/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/platform","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/errors","vs/base/common/arrays","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/base/common/resources","vs/base/node/pfs","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/common/extpath","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/base/common/glob","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","fs","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/editor/common/core/range","vs/platform/files/common/files","vs/workbench/api/common/extHostDebugService","vs/base/common/stopwatch","os","vs/editor/common/core/position","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/base/common/assert","vs/base/common/collections","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/node/processes","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/externalTerminal/node/externalTerminal","vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalProfiles","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],pe=function(K){for(var e=[],_=0,I=K.length;_<I;_++)e[_]=ge[K[_]];return e};define(ge[52],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function _(I,T){if(!I)throw new Error(T?`Assertion failed (${T})`:"Assertion Failed")}e.ok=_}),define(ge[53],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const _=Object.prototype.hasOwnProperty;function I(s){const C=[];for(let g in s)_.call(s,g)&&C.push(s[g]);return C}e.values=I;function T(s,C){for(let g in s)if(_.call(s,g)&&C({key:g,value:s[g]},function(){delete s[g]})===!1)return}e.forEach=T;function A(s,C){const g=Object.create(null);for(const m of s){const a=C(m);let u=g[a];u||(u=g[a]=[]),u.push(m)}return g}e.groupBy=A;function y(s){const C=Object.create(null);return s&&s.forEach((g,m)=>{C[m]=g}),C}e.fromMap=y;function k(s,C){const g=[],m=[];for(let a of s)C.has(a)||g.push(a);for(let a of C)s.has(a)||m.push(a);return{removed:g,added:m}}e.diffSets=k;function D(s,C){const g=[],m=[];for(let[a,u]of s)C.has(a)||g.push(u);for(let[a,u]of C)s.has(a)||m.push(u);return{removed:g,added:m}}e.diffMaps=D;class P{constructor(){this.map=new Map}add(C,g){let m=this.map.get(C);m||(m=new Set,this.map.set(C,m)),m.add(g)}delete(C,g){const m=this.map.get(C);!m||(m.delete(g),m.size===0&&this.map.delete(C))}forEach(C,g){const m=this.map.get(C);!m||m.forEach(g)}}e.SetMap=P}),define(ge[70],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function _(D){return(P,s,C)=>{let g=null,m=null;if(typeof C.value=="function"?(g="value",m=C.value):typeof C.get=="function"&&(g="get",m=C.get),!m)throw new Error("not supported");C[g]=D(m,s)}}e.createDecorator=_;let I=0;function T(){const D=`$memoize${I++}`;let P;const s=function(g,m,a){let u=null,E=null;if(typeof a.value=="function"?(u="value",E=a.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof a.get=="function"&&(u="get",E=a.get),!E)throw new Error("not supported");const w=`${D}:${m}`;a[u]=function(...S){return P=this,this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!0,enumerable:!1,writable:!0,value:E.apply(this,S)}),this[w]}};return s.clear=()=>{typeof P!="undefined"&&Object.getOwnPropertyNames(P).forEach(C=>{C.indexOf(D)===0&&delete P[C]})},s}e.createMemoizer=T;function A(D,P,s){return T()(D,P,s)}e.memoize=A;function y(D,P,s){return _((C,g)=>{const m=`$debounce$${g}`,a=`$debounce$result$${g}`;return function(...u){this[a]||(this[a]=s?s():void 0),clearTimeout(this[m]),P&&(this[a]=P(this[a],...u),u=[this[a]]),this[m]=setTimeout(()=>{C.apply(this,u),this[a]=s?s():void 0},D)}})}e.debounce=y;function k(D,P,s){return _((C,g)=>{const m=`$throttle$timer$${g}`,a=`$throttle$result$${g}`,u=`$throttle$lastRun$${g}`,E=`$throttle$pending$${g}`;return function(...w){if(this[a]||(this[a]=s?s():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),P&&(this[a]=P(this[a],...w)),!this[E]){const S=this[u]+D;S<=Date.now()?(this[u]=Date.now(),C.apply(this,[this[a]]),this[a]=s?s():void 0):(this[E]=!0,this[m]=setTimeout(()=>{this[E]=!1,this[u]=Date.now(),C.apply(this,[this[a]]),this[a]=s?s():void 0},S-Date.now()))}}})}e.throttle=k}),define(ge[18],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class _{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=_,e.errorHandler=new _;function I(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=I;function T(f){D(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=T;function A(f){D(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=A;function y(f){if(f instanceof Error){let{name:t,message:n}=f;const r=f.stacktrace||f.stack;return{$isError:!0,name:t,message:n,stack:r}}return f}e.transformErrorForSerialization=y;const k="Canceled";function D(f){return f instanceof Error&&f.name===k&&f.message===k}e.isPromiseCanceledError=D;class P extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=P;function s(){const f=new Error(k);return f.name=f.message,f}e.canceled=s;function C(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=C;function g(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=g;function m(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function a(f){const t=new Error(`${f} has been disposed`);return t.name="DISPOSED",t}e.disposed=a;function u(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=u;class E extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=E;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class S extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=S;function d(f){const t=f;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=d;function l(f,t=Object.create(null)){const n=new Error(f);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=l}),define(ge[19],pe([0,1,18]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function I(U,L=0){return U[U.length-(1+L)]}e.tail=I;function T(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=T;function A(U,L,F=(O,M)=>O===M){if(U===L)return!0;if(!U||!L||U.length!==L.length)return!1;for(let O=0,M=U.length;O<M;O++)if(!F(U[O],L[O]))return!1;return!0}e.equals=A;function y(U,L,F){let O=0,M=U.length-1;for(;O<=M;){const B=(O+M)/2|0,V=F(U[B],L);if(V<0)O=B+1;else if(V>0)M=B-1;else return B}return-(O+1)}e.binarySearch=y;function k(U,L){let F=0,O=U.length;if(O===0)return 0;for(;F<O;){const M=Math.floor((F+O)/2);L(U[M])?O=M:F=M+1}return F}e.findFirstInSorted=k;function D(U,L,F){if(U=U|0,U>=L.length)throw new TypeError("invalid index");let O=L[Math.floor(L.length*Math.random())],M=[],B=[],V=[];for(let Q of L){const de=F(Q,O);de<0?M.push(Q):de>0?B.push(Q):V.push(Q)}return U<M.length?D(U,M,F):U<M.length+V.length?V[0]:D(U-(M.length+V.length),B,F)}e.quickSelect=D;function P(U,L){const F=[];let O;for(const M of U.slice(0).sort(L))!O||L(O[0],M)!==0?(O=[M],F.push(O)):O.push(M);return F}e.groupBy=P;function s(U,L,F){const O=[];function M(Q,de,we){if(!(de===0&&we.length===0)){const Ie=O[O.length-1];Ie&&Ie.start+Ie.deleteCount===Q?(Ie.deleteCount+=de,Ie.toInsert.push(...we)):O.push({start:Q,deleteCount:de,toInsert:we})}}let B=0,V=0;for(;;){if(B===U.length){M(B,0,L.slice(V));break}if(V===L.length){M(B,U.length-B,[]);break}const Q=U[B],de=L[V],we=F(Q,de);we===0?(B+=1,V+=1):we<0?(M(B,1,[]),B+=1):we>0&&(M(B,0,[de]),V+=1)}return O}e.sortedDiff=s;function C(U,L,F){const O=s(U,L,F),M=[],B=[];for(const V of O)M.push(...U.slice(V.start,V.start+V.deleteCount)),B.push(...V.toInsert);return{removed:M,added:B}}e.delta=C;function g(U,L,F){if(F===0)return[];const O=U.slice(0,F).sort(L);return a(U,L,O,F,U.length),O}e.top=g;function m(U,L,F,O,M){return F===0?Promise.resolve([]):new Promise((B,V)=>{(async()=>{const Q=U.length,de=U.slice(0,F).sort(L);for(let we=F,Ie=Math.min(F+O,Q);we<Q;we=Ie,Ie=Math.min(Ie+O,Q)){if(we>F&&await new Promise(Ce=>setTimeout(Ce)),M&&M.isCancellationRequested)throw(0,_.canceled)();a(U,L,de,we,Ie)}return de})().then(B,V)})}e.topAsync=m;function a(U,L,F,O,M){for(const B=F.length;O<M;O++){const V=U[O];if(L(V,F[B-1])<0){F.pop();const Q=k(F,de=>L(V,de)<0);F.splice(Q,0,V)}}}function u(U){return U.filter(L=>!!L)}e.coalesce=u;function E(U){let L=0;for(let F=0;F<U.length;F++)U[F]&&(U[L]=U[F],L+=1);U.length=L}e.coalesceInPlace=E;function w(U,L,F){U.splice(F,0,U.splice(L,1)[0])}e.move=w;function S(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=S;function d(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=d;function l(U,L){if(!L)return U.filter((O,M)=>U.indexOf(O)===M);const F=Object.create(null);return U.filter(O=>{const M=L(O);return F[M]?!1:(F[M]=!0,!0)})}e.distinct=l;function f(U){const L=new Set;return U.filter(F=>L.has(F)?!1:(L.add(F),!0))}e.distinctES6=f;function t(U){const L=Object.create(null);return F=>{const O=U(F);return L[O]?!1:(L[O]=!0,!0)}}e.uniqueFilter=t;function n(U,L){for(let F=U.length-1;F>=0;F--){const O=U[F];if(L(O))return F}return-1}e.lastIndex=n;function r(U,L){return U.length>0?U[0]:L}e.firstOrDefault=r;function i(U,L,F=(O,M)=>O===M){let O=0;for(let M=0,B=Math.min(U.length,L.length);M<B&&F(U[M],L[M]);M++)O++;return O}e.commonPrefixLength=i;function o(U){return[].concat(...U)}e.flatten=o;function c(U,L){let F=typeof L=="number"?U:0;typeof L=="number"?F=U:(F=0,L=U);const O=[];if(F<=L)for(let M=F;M<L;M++)O.push(M);else for(let M=F;M>L;M--)O.push(M);return O}e.range=c;function v(U,L,F){return U.reduce((O,M)=>(O[L(M)]=F?F(M):M,O),Object.create(null))}e.index=v;function p(U,L){return U.push(L),()=>h(U,L)}e.insert=p;function h(U,L){const F=U.indexOf(L);if(F>-1)return U.splice(F,1),L}e.remove=h;function b(U,L,F){const O=U.slice(0,L),M=U.slice(L);return O.concat(F,M)}e.arrayInsert=b;function R(U,L){let F;if(typeof L=="number"){let O=L;F=()=>{const M=Math.sin(O++)*179426549;return M-Math.floor(M)}}else F=Math.random;for(let O=U.length-1;O>0;O-=1){const M=Math.floor(F()*(O+1)),B=U[O];U[O]=U[M],U[M]=B}}e.shuffle=R;function N(U,L){const F=U.indexOf(L);F>-1&&(U.splice(F,1),U.unshift(L))}e.pushToStart=N;function j(U,L){const F=U.indexOf(L);F>-1&&(U.splice(F,1),U.push(L))}e.pushToEnd=j;function oe(U,L){return Array.isArray(U)?U.map(L):L(U)}e.mapArrayOrNot=oe;function q(U){return Array.isArray(U)?U:[U]}e.asArray=q;function W(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=W;function H(U,L){for(const F of U){const O=L(F);if(O!==void 0)return O}}e.mapFind=H}),define(ge[71],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function _(I){const T=this;let A=!1,y;return function(){return A||(A=!0,y=I.apply(T,arguments)),y}}e.once=_}),define(ge[72],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class _{constructor(T){this._prefix=T,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=_,e.defaultGenerator=new _("id#")}),define(ge[54],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var _;(function(I){function T(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}I.is=T;const A=Object.freeze([]);function y(){return A}I.empty=y;function*k(f){yield f}I.single=k;function D(f){return f||A}I.from=D;function P(f){return!f||f[Symbol.iterator]().next().done===!0}I.isEmpty=P;function s(f){return f[Symbol.iterator]().next().value}I.first=s;function C(f,t){for(const n of f)if(t(n))return!0;return!1}I.some=C;function g(f,t){for(const n of f)if(t(n))return n}I.find=g;function*m(f,t){for(const n of f)t(n)&&(yield n)}I.filter=m;function*a(f,t){for(const n of f)yield t(n)}I.map=a;function*u(...f){for(const t of f)for(const n of t)yield n}I.concat=u;function*E(f){for(const t of f)for(const n of t)yield n}I.concatNested=E;function w(f,t,n){let r=n;for(const i of f)r=t(r,i);return r}I.reduce=w;function*S(f,t,n=f.length){for(t<0&&(t+=f.length),n<0?n+=f.length:n>f.length&&(n=f.length);t<n;t++)yield f[t]}I.slice=S;function d(f,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,f];const r=f[Symbol.iterator]();for(let i=0;i<t;i++){const o=r.next();if(o.done)return[n,I.empty()];n.push(o.value)}return[n,{[Symbol.iterator](){return r}}]}I.consume=d;function l(f,t,n=(r,i)=>r===i){const r=f[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const o=r.next(),c=i.next();if(o.done!==c.done)return!1;if(o.done)return!0;if(!n(o.value,c.value))return!1}}I.equals=l})(_=e.Iterable||(e.Iterable={}))}),define(ge[55],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var _;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(_=e.ScanError||(e.ScanError={}));var I;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function y(t,n=!1){let r=0,i=t.length,o="",c=0,v=16,p=0;function h(W){let H=0,U=0;for(;H<W;){const L=t.charCodeAt(r);if(L>=48&&L<=57)U=U*16+L-48;else if(L>=65&&L<=70)U=U*16+L-65+10;else if(L>=97&&L<=102)U=U*16+L-97+10;else break;r++,H++}return H<W&&(U=-1),U}function b(W){r=W,o="",c=0,v=16,p=0}function R(){const W=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&P(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&P(t.charCodeAt(r)))for(r++;r<t.length&&P(t.charCodeAt(r));)r++;else return p=3,t.substring(W,r);let H=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&P(t.charCodeAt(r))){for(r++;r<t.length&&P(t.charCodeAt(r));)r++;H=r}else p=3;return t.substring(W,H)}function N(){let W="",H=r;for(;;){if(r>=i){W+=t.substring(H,r),p=2;break}const U=t.charCodeAt(r);if(U===34){W+=t.substring(H,r),r++;break}if(U===92){if(W+=t.substring(H,r),r++,r>=i){p=2;break}switch(t.charCodeAt(r++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:const F=h(4);F>=0?W+=String.fromCharCode(F):p=4;break;default:p=5}H=r;continue}if(U>=0&&U<=31)if(D(U)){W+=t.substring(H,r),p=2;break}else p=6;r++}return W}function j(){if(o="",p=0,c=r,r>=i)return c=i,v=17;let W=t.charCodeAt(r);if(k(W)){do r++,o+=String.fromCharCode(W),W=t.charCodeAt(r);while(k(W));return v=15}if(D(W))return r++,o+=String.fromCharCode(W),W===13&&t.charCodeAt(r)===10&&(r++,o+=`
`),v=14;switch(W){case 123:return r++,v=1;case 125:return r++,v=2;case 91:return r++,v=3;case 93:return r++,v=4;case 58:return r++,v=6;case 44:return r++,v=5;case 34:return r++,o=N(),v=10;case 47:const H=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!D(t.charCodeAt(r));)r++;return o=t.substring(H,r),v=12}if(t.charCodeAt(r+1)===42){r+=2;const U=i-1;let L=!1;for(;r<U;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,L=!0;break}r++}return L||(r++,p=1),o=t.substring(H,r),v=13}return o+=String.fromCharCode(W),r++,v=16;case 45:if(o+=String.fromCharCode(W),r++,r===i||!P(t.charCodeAt(r)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=R(),v=11;default:for(;r<i&&oe(W);)r++,W=t.charCodeAt(r);if(c!==r){switch(o=t.substring(c,r),o){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return o+=String.fromCharCode(W),r++,v=16}}function oe(W){if(k(W)||D(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let W;do W=j();while(W>=12&&W<=15);return W}return{setPosition:b,getPosition:()=>r,scan:n?q:j,getToken:()=>v,getTokenValue:()=>o,getTokenOffset:()=>c,getTokenLength:()=>r-c,getTokenError:()=>p}}e.createScanner=y;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function P(t){return t>=48&&t<=57}var s;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(s||(s={}));function C(t,n){const r=[],i=new Object;let o;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function p(h,b,R,N){c.value=h,c.offset=b,c.length=R,c.type=N,c.colonOffset=void 0,o=c}try{d(t,{onObjectBegin:(h,b)=>{if(n<=h)throw i;o=void 0,v=n>h,r.push("")},onObjectProperty:(h,b,R)=>{if(n<b||(p(h,b,R,"property"),r[r.length-1]=h,n<=b+R))throw i},onObjectEnd:(h,b)=>{if(n<=h)throw i;o=void 0,r.pop()},onArrayBegin:(h,b)=>{if(n<=h)throw i;o=void 0,r.push(0)},onArrayEnd:(h,b)=>{if(n<=h)throw i;o=void 0,r.pop()},onLiteralValue:(h,b,R)=>{if(n<b||(p(h,b,R,f(h)),n<=b+R))throw i},onSeparator:(h,b,R)=>{if(n<=b)throw i;if(h===":"&&o&&o.type==="property")o.colonOffset=b,v=!1,o=void 0;else if(h===","){const N=r[r.length-1];typeof N=="number"?r[r.length-1]=N+1:(v=!0,r[r.length-1]=""),o=void 0}}})}catch(h){if(h!==i)throw h}return{path:r,previousNode:o,isAtPropertyKey:v,matches:h=>{let b=0;for(let R=0;b<h.length&&R<r.length;R++)if(h[b]===r[R]||h[b]==="*")b++;else if(h[b]!=="**")return!1;return b===h.length}}}e.getLocation=C;function g(t,n=[],r=A.DEFAULT){let i=null,o=[];const c=[];function v(h){Array.isArray(o)?o.push(h):i!==null&&(o[i]=h)}return d(t,{onObjectBegin:()=>{const h={};v(h),c.push(o),o=h,i=null},onObjectProperty:h=>{i=h},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const h=[];v(h),c.push(o),o=h,i=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:v,onError:(h,b,R)=>{n.push({error:h,offset:b,length:R})}},r),o[0]}e.parse=g;function m(t,n=[],r=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(h){i.type==="property"&&(i.length=h-i.offset,i=i.parent)}function c(h){return i.children.push(h),h}d(t,{onObjectBegin:h=>{i=c({type:"object",offset:h,length:-1,parent:i,children:[]})},onObjectProperty:(h,b,R)=>{i=c({type:"property",offset:b,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:h,offset:b,length:R,parent:i})},onObjectEnd:(h,b)=>{i.length=h+b-i.offset,i=i.parent,o(h+b)},onArrayBegin:(h,b)=>{i=c({type:"array",offset:h,length:-1,parent:i,children:[]})},onArrayEnd:(h,b)=>{i.length=h+b-i.offset,i=i.parent,o(h+b)},onLiteralValue:(h,b,R)=>{c({type:f(h),offset:b,length:R,parent:i,value:h}),o(b+R)},onSeparator:(h,b,R)=>{i.type==="property"&&(h===":"?i.colonOffset=b:h===","&&o(b))},onError:(h,b,R)=>{n.push({error:h,offset:b,length:R})}},r);const p=i.children[0];return p&&delete p.parent,p}e.parseTree=m;function a(t,n){if(!!t){let r=t;for(let i of n)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let o=!1;for(const c of r.children)if(Array.isArray(c.children)&&c.children[0].value===i){r=c.children[1],o=!0;break}if(!o)return}else{const o=i;if(r.type!=="array"||o<0||!Array.isArray(r.children)||o>=r.children.length)return;r=r.children[o]}return r}}e.findNodeAtLocation=a;function u(t){if(!t.parent||!t.parent.children)return[];const n=u(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;n.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&n.push(r)}return n}e.getNodePath=u;function E(t){switch(t.type){case"array":return t.children.map(E);case"object":const n=Object.create(null);for(let r of t.children){const i=r.children[1];i&&(n[r.children[0].value]=E(i))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=E;function w(t,n,r=!1){return n>=t.offset&&n<t.offset+t.length||r&&n===t.offset+t.length}e.contains=w;function S(t,n,r=!1){if(w(t,n,r)){const i=t.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=n;o++){const c=S(i[o],n,r);if(c)return c}return t}}e.findNodeAtOffset=S;function d(t,n,r=A.DEFAULT){const i=y(t,!1);function o(de){return de?()=>de(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(de){return de?we=>de(we,i.getTokenOffset(),i.getTokenLength()):()=>!0}const v=o(n.onObjectBegin),p=c(n.onObjectProperty),h=o(n.onObjectEnd),b=o(n.onArrayBegin),R=o(n.onArrayEnd),N=c(n.onLiteralValue),j=c(n.onSeparator),oe=o(n.onComment),q=c(n.onError),W=r&&r.disallowComments,H=r&&r.allowTrailingComma;function U(){for(;;){const de=i.scan();switch(i.getTokenError()){case 4:L(14);break;case 5:L(15);break;case 3:L(13);break;case 1:W||L(11);break;case 2:L(12);break;case 6:L(16);break}switch(de){case 12:case 13:W?L(10):oe();break;case 16:L(1);break;case 15:case 14:break;default:return de}}}function L(de,we=[],Ie=[]){if(q(de),we.length+Ie.length>0){let Ce=i.getToken();for(;Ce!==17;){if(we.indexOf(Ce)!==-1){U();break}else if(Ie.indexOf(Ce)!==-1)break;Ce=U()}}}function F(de){const we=i.getTokenValue();return de?N(we):p(we),U(),!0}function O(){switch(i.getToken()){case 11:let de=0;try{de=JSON.parse(i.getTokenValue()),typeof de!="number"&&(L(2),de=0)}catch(we){L(2)}N(de);break;case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return U(),!0}function M(){return i.getToken()!==10?(L(3,[],[2,5]),!1):(F(!1),i.getToken()===6?(j(":"),U(),Q()||L(4,[],[2,5])):L(5,[],[2,5]),!0)}function B(){v(),U();let de=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(de||L(4,[],[]),j(","),U(),i.getToken()===2&&H)break}else de&&L(6,[],[]);M()||L(4,[],[2,5]),de=!0}return h(),i.getToken()!==2?L(7,[2],[]):U(),!0}function V(){b(),U();let de=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(de||L(4,[],[]),j(","),U(),i.getToken()===4&&H)break}else de&&L(6,[],[]);Q()||L(4,[],[4,5]),de=!0}return R(),i.getToken()!==4?L(8,[4],[]):U(),!0}function Q(){switch(i.getToken()){case 3:return V();case 1:return B();case 10:return F(!0);default:return O()}}return U(),i.getToken()===17?r.allowEmptyContent?!0:(L(4,[],[]),!1):Q()?(i.getToken()!==17&&L(9,[],[]),!0):(L(4,[],[]),!1)}e.visit=d;function l(t,n){let r=y(t),i=[],o,c=0,v;do switch(v=r.getPosition(),o=r.scan(),o){case 12:case 13:case 17:c!==v&&i.push(t.substring(c,v)),n!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,n)),c=r.getPosition();break}while(o!==17);return i.join("")}e.stripComments=l;function f(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=f}),define(ge[132],pe([0,1,55]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function I(D,P,s){let C,g,m,a,u;if(P){for(a=P.offset,u=a+P.length,m=a;m>0&&!k(D,m-1);)m--;let c=u;for(;c<D.length&&!k(D,c);)c++;g=D.substring(m,c),C=A(g,s)}else g=D,C=0,m=0,a=0,u=D.length;const E=y(s,D);let w=!1,S=0,d;s.insertSpaces?d=T(" ",s.tabSize||4):d="	";const l=(0,_.createScanner)(g,!1);let f=!1;function t(){return E+T(d,C+S)}function n(){let c=l.scan();for(w=!1;c===15||c===14;)w=w||c===14,c=l.scan();return f=c===16||l.getTokenError()!==0,c}const r=[];function i(c,v,p){!f&&v<u&&p>a&&D.substring(v,p)!==c&&r.push({offset:v,length:p-v,content:c})}let o=n();if(o!==17){const c=l.getTokenOffset()+m,v=T(d,C);i(v,m,c)}for(;o!==17;){let c=l.getTokenOffset()+l.getTokenLength()+m,v=n(),p="";for(;!w&&(v===12||v===13);){const b=l.getTokenOffset()+m;i(" ",c,b),c=l.getTokenOffset()+l.getTokenLength()+m,p=v===12?t():"",v=n()}if(v===2)o!==1&&(S--,p=t());else if(v===4)o!==3&&(S--,p=t());else{switch(o){case 3:case 1:S++,p=t();break;case 5:case 12:p=t();break;case 13:w?p=t():p=" ";break;case 6:p=" ";break;case 10:if(v===6){p="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?p=" ":v!==5&&v!==17&&(f=!0);break;case 16:f=!0;break}w&&(v===12||v===13)&&(p=t())}const h=l.getTokenOffset()+m;i(p,c,h),o=v}return r}e.format=I;function T(D,P){let s="";for(let C=0;C<P;C++)s+=D;return s}function A(D,P){let s=0,C=0;const g=P.tabSize||4;for(;s<D.length;){const m=D.charAt(s);if(m===" ")C++;else if(m==="	")C+=g;else break;s++}return Math.floor(C/g)}function y(D,P){for(let s=0;s<P.length;s++){const C=P.charAt(s);if(C==="\r")return s+1<P.length&&P.charAt(s+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=y;function k(D,P){return`\r
`.indexOf(D.charAt(P))!==-1}e.isEOL=k}),define(ge[133],pe([0,1,55,132]),function(K,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(P,s,C){return A(P,s,void 0,C)}e.removeProperty=T;function A(P,s,C,g,m){const a=s.slice(),u=[],E=(0,_.parseTree)(P,u);let w,S;for(;a.length>0&&(S=a.pop(),w=(0,_.findNodeAtLocation)(E,a),w===void 0&&C!==void 0);)typeof S=="string"?C={[S]:C}:C=[C];if(w)if(w.type==="object"&&typeof S=="string"&&Array.isArray(w.children)){const d=(0,_.findNodeAtLocation)(w,[S]);if(d!==void 0)if(C===void 0){if(!d.parent)throw new Error("Malformed AST");const l=w.children.indexOf(d.parent);let f,t=d.parent.offset+d.parent.length;if(l>0){const n=w.children[l-1];f=n.offset+n.length}else f=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return y(P,{offset:f,length:t-f,content:""},g)}else return y(P,{offset:d.offset,length:d.length,content:JSON.stringify(C)},g);else{if(C===void 0)return[];const l=`${JSON.stringify(S)}: ${JSON.stringify(C)}`,f=m?m(w.children.map(n=>n.children[0].value)):w.children.length;let t;if(f>0){const n=w.children[f-1];t={offset:n.offset+n.length,length:0,content:","+l}}else w.children.length===0?t={offset:w.offset+1,length:0,content:l}:t={offset:w.offset+1,length:0,content:l+","};return y(P,t,g)}}else if(w.type==="array"&&typeof S=="number"&&Array.isArray(w.children))if(C!==void 0){const d=`${JSON.stringify(C)}`;let l;if(w.children.length===0||S===0)l={offset:w.offset+1,length:0,content:w.children.length===0?d:d+","};else{const f=S===-1||S>w.children.length?w.children.length:S,t=w.children[f-1];l={offset:t.offset+t.length,length:0,content:","+d}}return y(P,l,g)}else{const d=S,l=w.children[d];let f;if(w.children.length===1)f={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===d){const t=w.children[d-1],n=t.offset+t.length,r=w.offset+w.length;f={offset:n,length:r-2-n,content:""}}else f={offset:l.offset,length:w.children[d+1].offset-l.offset,content:""};return y(P,f,g)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${w.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return y(P,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(C)},g)}}e.setProperty=A;function y(P,s,C){let g=k(P,s),m=s.offset,a=s.offset+s.content.length;if(s.length===0||s.content.length===0){for(;m>0&&!(0,I.isEOL)(g,m-1);)m--;for(;a<g.length&&!(0,I.isEOL)(g,a);)a++}const u=(0,I.format)(g,{offset:m,length:a-m},C);for(let w=u.length-1;w>=0;w--){const S=u[w];g=k(g,S),m=Math.min(m,S.offset),a=Math.max(a,S.offset+S.length),a+=S.content.length-S.length}const E=P.length-(g.length-a)-m;return[{offset:m,length:E,content:g.substring(m,a)}]}e.withFormatting=y;function k(P,s){return P.substring(0,s.offset)+s.content+P.substring(s.offset+s.length)}e.applyEdit=k;function D(P,s){let C=s.slice(0).sort((m,a)=>{const u=m.offset-a.offset;return u===0?m.length-a.length:u}),g=P.length;for(let m=C.length-1;m>=0;m--){let a=C[m];if(a.offset+a.length<=g)P=k(P,a);else throw new Error("Overlapping edit");g=a.offset}return P}e.applyEdits=D}),define(ge[134],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class _{constructor(T){this.executor=T,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(T){return new _(()=>T(this.getValue()))}}e.Lazy=_}),define(ge[6],pe([0,1,71,54]),function(K,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const T=!1;let A=null;function y(d){A=d}if(e.setDisposableTracker=y,T){const d="__is_disposable_tracked__";A=new class{trackDisposable(l){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[d]||console.log(f)},3e3)}markTracked(l){if(l&&l!==u.None)try{l[d]=!0}catch(f){}}}}function k(d){!A||A.markTracked(d)}function D(d){return A&&A.trackDisposable(d),d}e.trackDisposable=D;class P extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=P;function s(d){return typeof d.dispose=="function"&&d.dispose.length===0}e.isDisposable=s;function C(d){if(I.Iterable.is(d)){let l=[];for(const f of d)if(f){k(f);try{f.dispose()}catch(t){l.push(t)}}if(l.length===1)throw l[0];if(l.length>1)throw new P(l);return Array.isArray(d)?[]:d}else if(d)return k(d),d.dispose(),d}e.dispose=C;function g(...d){return d.forEach(k),m(()=>C(d))}e.combinedDisposable=g;function m(d){const l=D({dispose:()=>{k(l),d()}});return l}e.toDisposable=m;class a{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(k(this),this._isDisposed=!0,this.clear())}clear(){try{C(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return k(l),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=a,a.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this._store=new a,D(this)}dispose(){k(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=u,u.None=Object.freeze({dispose(){}});class E{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var f;this._isDisposed||l===this._value||((f=this._value)===null||f===void 0||f.dispose(),l&&k(l),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,k(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}e.MutableDisposable=E;class w{constructor(){this.references=new Map}acquire(l,...f){let t=this.references.get(l);t||(t={counter:0,object:this.createReferencedObject(l,...f)},this.references.set(l,t));const{object:n}=t,r=(0,_.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(l,t.object),this.references.delete(l))});return t.counter++,{object:n,dispose:r}}}e.ReferenceCollection=w;class S{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=S}),define(ge[56],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class _{constructor(A){this.element=A,this.next=_.Undefined,this.prev=_.Undefined}}_.Undefined=new _(void 0);class I{constructor(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===_.Undefined}clear(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,y){const k=new _(A);if(this._first===_.Undefined)this._first=k,this._last=k;else if(y){const P=this._last;this._last=k,k.prev=P,P.next=k}else{const P=this._first;this._first=k,k.next=P,P.prev=k}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(k))}}shift(){if(this._first!==_.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==_.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==_.Undefined&&A.next!==_.Undefined){const y=A.prev;y.next=A.next,A.next.prev=y}else A.prev===_.Undefined&&A.next===_.Undefined?(this._first=_.Undefined,this._last=_.Undefined):A.next===_.Undefined?(this._last=this._last.prev,this._last.next=_.Undefined):A.prev===_.Undefined&&(this._first=this._first.next,this._first.prev=_.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==_.Undefined;)yield A.element,A=A.next}}e.LinkedList=I}),function(K,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(K=typeof globalThis!="undefined"?globalThis:K||self,K.marked=e())}(this,function(){"use strict";function K(G,re){for(var he=0;he<re.length;he++){var J=re[he];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(G,J.key,J)}}function e(G,re,he){return re&&K(G.prototype,re),he&&K(G,he),G}function _(G,re){if(!!G){if(typeof G=="string")return I(G,re);var he=Object.prototype.toString.call(G).slice(8,-1);if(he==="Object"&&G.constructor&&(he=G.constructor.name),he==="Map"||he==="Set")return Array.from(G);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return I(G,re)}}function I(G,re){(re==null||re>G.length)&&(re=G.length);for(var he=0,J=new Array(re);he<re;he++)J[he]=G[he];return J}function T(G,re){var he;if(typeof Symbol=="undefined"||G[Symbol.iterator]==null){if(Array.isArray(G)||(he=_(G))||re&&G&&typeof G.length=="number"){he&&(G=he);var J=0;return function(){return J>=G.length?{done:!0}:{done:!1,value:G[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return he=G[Symbol.iterator](),he.next.bind(he)}function A(G){var re={exports:{}};return G(re,re.exports),re.exports}var y=A(function(G){function re(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function he(J){G.exports.defaults=J}G.exports={defaults:re(),getDefaults:re,changeDefaults:he}}),k=/[&<>"']/,D=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,s=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},g=function(re){return C[re]};function m(G,re){if(re){if(k.test(G))return G.replace(D,g)}else if(P.test(G))return G.replace(s,g);return G}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(G){return G.replace(a,function(re,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var E=/(^|[^\[])\^/g;function w(G,re){G=G.source||G,re=re||"";var he={replace:function(ne,ce){return ce=ce.source||ce,ce=ce.replace(E,"$1"),G=G.replace(ne,ce),he},getRegex:function(){return new RegExp(G,re)}};return he}var S=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(G,re,he){if(G){var J;try{J=decodeURIComponent(u(he)).replace(S,"").toLowerCase()}catch(ne){return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}re&&!d.test(he)&&(he=i(re,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch(ne){return null}return he}var f={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(G,re){f[" "+G]||(t.test(G)?f[" "+G]=G+"/":f[" "+G]=p(G,"/",!0)),G=f[" "+G];var he=G.indexOf(":")===-1;return re.substring(0,2)==="//"?he?re:G.replace(n,"$1")+re:re.charAt(0)==="/"?he?re:G.replace(r,"$1")+re:G+re}var o={exec:function(){}};function c(G){for(var re=1,he,J;re<arguments.length;re++){he=arguments[re];for(J in he)Object.prototype.hasOwnProperty.call(he,J)&&(G[J]=he[J])}return G}function v(G,re){var he=G.replace(/\|/g,function(ce,ve,ye){for(var je=!1,He=ve;--He>=0&&ye[He]==="\\";)je=!je;return je?"|":" |"}),J=he.split(/ \|/),ne=0;if(J.length>re)J.splice(re);else for(;J.length<re;)J.push("");for(;ne<J.length;ne++)J[ne]=J[ne].trim().replace(/\\\|/g,"|");return J}function p(G,re,he){var J=G.length;if(J===0)return"";for(var ne=0;ne<J;){var ce=G.charAt(J-ne-1);if(ce===re&&!he)ne++;else if(ce!==re&&he)ne++;else break}return G.substr(0,J-ne)}function h(G,re){if(G.indexOf(re[1])===-1)return-1;for(var he=G.length,J=0,ne=0;ne<he;ne++)if(G[ne]==="\\")ne++;else if(G[ne]===re[0])J++;else if(G[ne]===re[1]&&(J--,J<0))return ne;return-1}function b(G){G&&G.sanitize&&!G.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(G,re){if(re<1)return"";for(var he="";re>1;)re&1&&(he+=G),re>>=1,G+=G;return he+G}var N={escape:m,unescape:u,edit:w,cleanUrl:l,resolveUrl:i,noopTest:o,merge:c,splitCells:v,rtrim:p,findClosingBracket:h,checkSanitizeDeprecation:b,repeatString:R},j=y.defaults,oe=N.rtrim,q=N.splitCells,W=N.escape,H=N.findClosingBracket;function U(G,re,he){var J=re.href,ne=re.title?W(re.title):null,ce=G[1].replace(/\\([\[\]])/g,"$1");return G[0].charAt(0)!=="!"?{type:"link",raw:he,href:J,title:ne,text:ce}:{type:"image",raw:he,href:J,title:ne,text:W(ce)}}function L(G,re){var he=G.match(/^(\s+)(?:```)/);if(he===null)return re;var J=he[1];return re.split(`
`).map(function(ne){var ce=ne.match(/^\s+/);if(ce===null)return ne;var ve=ce[0];return ve.length>=J.length?ne.slice(J.length):ne}).join(`
`)}var F=function(){function G(he){this.options=he||j}var re=G.prototype;return re.space=function(J){var ne=this.rules.block.newline.exec(J);if(ne)return ne[0].length>1?{type:"space",raw:ne[0]}:{raw:`
`}},re.code=function(J){var ne=this.rules.block.code.exec(J);if(ne){var ce=ne[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ne[0],codeBlockStyle:"indented",text:this.options.pedantic?ce:oe(ce,`
`)}}},re.fences=function(J){var ne=this.rules.block.fences.exec(J);if(ne){var ce=ne[0],ve=L(ce,ne[3]||"");return{type:"code",raw:ce,lang:ne[2]?ne[2].trim():ne[2],text:ve}}},re.heading=function(J){var ne=this.rules.block.heading.exec(J);if(ne){var ce=ne[2].trim();if(/#$/.test(ce)){var ve=oe(ce,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&(ce=ve.trim())}return{type:"heading",raw:ne[0],depth:ne[1].length,text:ce}}},re.nptable=function(J){var ne=this.rules.block.nptable.exec(J);if(ne){var ce={type:"table",header:q(ne[1].replace(/^ *| *\| *$/g,"")),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[],raw:ne[0]};if(ce.header.length===ce.align.length){var ve=ce.align.length,ye;for(ye=0;ye<ve;ye++)/^ *-+: *$/.test(ce.align[ye])?ce.align[ye]="right":/^ *:-+: *$/.test(ce.align[ye])?ce.align[ye]="center":/^ *:-+ *$/.test(ce.align[ye])?ce.align[ye]="left":ce.align[ye]=null;for(ve=ce.cells.length,ye=0;ye<ve;ye++)ce.cells[ye]=q(ce.cells[ye],ce.header.length);return ce}}},re.hr=function(J){var ne=this.rules.block.hr.exec(J);if(ne)return{type:"hr",raw:ne[0]}},re.blockquote=function(J){var ne=this.rules.block.blockquote.exec(J);if(ne){var ce=ne[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ne[0],text:ce}}},re.list=function(J){var ne=this.rules.block.list.exec(J);if(ne){var ce=ne[0],ve=ne[2],ye=ve.length>1,je={type:"list",raw:ce,ordered:ye,start:ye?+ve.slice(0,-1):"",loose:!1,items:[]},He=ne[0].match(this.rules.block.item),We=!1,Ke,nt,dt,it,Ye,mt,wt,Ee,fe=He.length;dt=this.rules.block.listItemStart.exec(He[0]);for(var ae=0;ae<fe;ae++){if(Ke=He[ae],ce=Ke,ae!==fe-1){if(it=this.rules.block.listItemStart.exec(He[ae+1]),this.options.pedantic?it[1].length>dt[1].length:it[1].length>dt[0].length||it[1].length>3){He.splice(ae,2,He[ae]+`
`+He[ae+1]),ae--,fe--;continue}else(!this.options.pedantic||this.options.smartLists?it[2][it[2].length-1]!==ve[ve.length-1]:ye===(it[2].length===1))&&(Ye=He.slice(ae+1).join(`
`),je.raw=je.raw.substring(0,je.raw.length-Ye.length),ae=fe-1);dt=it}nt=Ke.length,Ke=Ke.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ke.indexOf(`
 `)&&(nt-=Ke.length,Ke=this.options.pedantic?Ke.replace(/^ {1,4}/gm,""):Ke.replace(new RegExp("^ {1,"+nt+"}","gm"),"")),mt=We||/\n\n(?!\s*$)/.test(Ke),ae!==fe-1&&(We=Ke.charAt(Ke.length-1)===`
`,mt||(mt=We)),mt&&(je.loose=!0),this.options.gfm&&(wt=/^\[[ xX]\] /.test(Ke),Ee=void 0,wt&&(Ee=Ke[1]!==" ",Ke=Ke.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:ce,task:wt,checked:Ee,loose:mt,text:Ke})}return je}},re.html=function(J){var ne=this.rules.block.html.exec(J);if(ne)return{type:this.options.sanitize?"paragraph":"html",raw:ne[0],pre:!this.options.sanitizer&&(ne[1]==="pre"||ne[1]==="script"||ne[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):W(ne[0]):ne[0]}},re.def=function(J){var ne=this.rules.block.def.exec(J);if(ne){ne[3]&&(ne[3]=ne[3].substring(1,ne[3].length-1));var ce=ne[1].toLowerCase().replace(/\s+/g," ");return{tag:ce,raw:ne[0],href:ne[2],title:ne[3]}}},re.table=function(J){var ne=this.rules.block.table.exec(J);if(ne){var ce={type:"table",header:q(ne[1].replace(/^ *| *\| *$/g,"")),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[]};if(ce.header.length===ce.align.length){ce.raw=ne[0];var ve=ce.align.length,ye;for(ye=0;ye<ve;ye++)/^ *-+: *$/.test(ce.align[ye])?ce.align[ye]="right":/^ *:-+: *$/.test(ce.align[ye])?ce.align[ye]="center":/^ *:-+ *$/.test(ce.align[ye])?ce.align[ye]="left":ce.align[ye]=null;for(ve=ce.cells.length,ye=0;ye<ve;ye++)ce.cells[ye]=q(ce.cells[ye].replace(/^ *\| *| *\| *$/g,""),ce.header.length);return ce}}},re.lheading=function(J){var ne=this.rules.block.lheading.exec(J);if(ne)return{type:"heading",raw:ne[0],depth:ne[2].charAt(0)==="="?1:2,text:ne[1]}},re.paragraph=function(J){var ne=this.rules.block.paragraph.exec(J);if(ne)return{type:"paragraph",raw:ne[0],text:ne[1].charAt(ne[1].length-1)===`
`?ne[1].slice(0,-1):ne[1]}},re.text=function(J){var ne=this.rules.block.text.exec(J);if(ne)return{type:"text",raw:ne[0],text:ne[0]}},re.escape=function(J){var ne=this.rules.inline.escape.exec(J);if(ne)return{type:"escape",raw:ne[0],text:W(ne[1])}},re.tag=function(J,ne,ce){var ve=this.rules.inline.tag.exec(J);if(ve)return!ne&&/^<a /i.test(ve[0])?ne=!0:ne&&/^<\/a>/i.test(ve[0])&&(ne=!1),!ce&&/^<(pre|code|kbd|script)(\s|>)/i.test(ve[0])?ce=!0:ce&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ve[0])&&(ce=!1),{type:this.options.sanitize?"text":"html",raw:ve[0],inLink:ne,inRawBlock:ce,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ve[0]):W(ve[0]):ve[0]}},re.link=function(J){var ne=this.rules.inline.link.exec(J);if(ne){var ce=ne[2].trim();if(!this.options.pedantic&&/^</.test(ce)){if(!/>$/.test(ce))return;var ve=oe(ce.slice(0,-1),"\\");if((ce.length-ve.length)%2==0)return}else{var ye=H(ne[2],"()");if(ye>-1){var je=ne[0].indexOf("!")===0?5:4,He=je+ne[1].length+ye;ne[2]=ne[2].substring(0,ye),ne[0]=ne[0].substring(0,He).trim(),ne[3]=""}}var We=ne[2],Ke="";if(this.options.pedantic){var nt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(We);nt&&(We=nt[1],Ke=nt[3])}else Ke=ne[3]?ne[3].slice(1,-1):"";return We=We.trim(),/^</.test(We)&&(this.options.pedantic&&!/>$/.test(ce)?We=We.slice(1):We=We.slice(1,-1)),U(ne,{href:We&&We.replace(this.rules.inline._escapes,"$1"),title:Ke&&Ke.replace(this.rules.inline._escapes,"$1")},ne[0])}},re.reflink=function(J,ne){var ce;if((ce=this.rules.inline.reflink.exec(J))||(ce=this.rules.inline.nolink.exec(J))){var ve=(ce[2]||ce[1]).replace(/\s+/g," ");if(ve=ne[ve.toLowerCase()],!ve||!ve.href){var ye=ce[0].charAt(0);return{type:"text",raw:ye,text:ye}}return U(ce,ve,ce[0])}},re.emStrong=function(J,ne,ce){ce===void 0&&(ce="");var ve=this.rules.inline.emStrong.lDelim.exec(J);if(!!ve&&!(ve[3]&&ce.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ye=ve[1]||ve[2]||"";if(!ye||ye&&(ce===""||this.rules.inline.punctuation.exec(ce))){var je=ve[0].length-1,He,We,Ke=je,nt=0,dt=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(dt.lastIndex=0,ne=ne.slice(-1*J.length+je);(ve=dt.exec(ne))!=null;)if(He=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!He){if(We=He.length,ve[3]||ve[4]){Ke+=We;continue}else if((ve[5]||ve[6])&&je%3&&!((je+We)%3)){nt+=We;continue}if(Ke-=We,!(Ke>0)){if(Ke+nt-We<=0&&!ne.slice(dt.lastIndex).match(dt)&&(We=Math.min(We,We+Ke+nt)),Math.min(je,We)%2)return{type:"em",raw:J.slice(0,je+ve.index+We+1),text:J.slice(1,je+ve.index+We)};if(Math.min(je,We)%2==0)return{type:"strong",raw:J.slice(0,je+ve.index+We+1),text:J.slice(2,je+ve.index+We-1)}}}}}},re.codespan=function(J){var ne=this.rules.inline.code.exec(J);if(ne){var ce=ne[2].replace(/\n/g," "),ve=/[^ ]/.test(ce),ye=/^ /.test(ce)&&/ $/.test(ce);return ve&&ye&&(ce=ce.substring(1,ce.length-1)),ce=W(ce,!0),{type:"codespan",raw:ne[0],text:ce}}},re.br=function(J){var ne=this.rules.inline.br.exec(J);if(ne)return{type:"br",raw:ne[0]}},re.del=function(J){var ne=this.rules.inline.del.exec(J);if(ne)return{type:"del",raw:ne[0],text:ne[2]}},re.autolink=function(J,ne){var ce=this.rules.inline.autolink.exec(J);if(ce){var ve,ye;return ce[2]==="@"?(ve=W(this.options.mangle?ne(ce[1]):ce[1]),ye="mailto:"+ve):(ve=W(ce[1]),ye=ve),{type:"link",raw:ce[0],text:ve,href:ye,tokens:[{type:"text",raw:ve,text:ve}]}}},re.url=function(J,ne){var ce;if(ce=this.rules.inline.url.exec(J)){var ve,ye;if(ce[2]==="@")ve=W(this.options.mangle?ne(ce[0]):ce[0]),ye="mailto:"+ve;else{var je;do je=ce[0],ce[0]=this.rules.inline._backpedal.exec(ce[0])[0];while(je!==ce[0]);ve=W(ce[0]),ce[1]==="www."?ye="http://"+ve:ye=ve}return{type:"link",raw:ce[0],text:ve,href:ye,tokens:[{type:"text",raw:ve,text:ve}]}}},re.inlineText=function(J,ne,ce){var ve=this.rules.inline.text.exec(J);if(ve){var ye;return ne?ye=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ve[0]):W(ve[0]):ve[0]:ye=W(this.options.smartypants?ce(ve[0]):ve[0]),{type:"text",raw:ve[0],text:ye}}},G}(),O=N.noopTest,M=N.edit,B=N.merge,V={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:O,table:O,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};V._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,V._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,V.def=M(V.def).replace("label",V._label).replace("title",V._title).getRegex(),V.bullet=/(?:[*+-]|\d{1,9}[.)])/,V.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,V.item=M(V.item,"gm").replace(/bull/g,V.bullet).getRegex(),V.listItemStart=M(/^( *)(bull)/).replace("bull",V.bullet).getRegex(),V.list=M(V.list).replace(/bull/g,V.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+V.def.source+")").getRegex(),V._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",V._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,V.html=M(V.html,"i").replace("comment",V._comment).replace("tag",V._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),V.paragraph=M(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",V._tag).getRegex(),V.blockquote=M(V.blockquote).replace("paragraph",V.paragraph).getRegex(),V.normal=B({},V),V.gfm=B({},V.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),V.gfm.nptable=M(V.gfm.nptable).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",V._tag).getRegex(),V.gfm.table=M(V.gfm.table).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",V._tag).getRegex(),V.pedantic=B({},V.normal,{html:M(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",V._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:O,paragraph:M(V.normal._paragraph).replace("hr",V.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",V.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:O,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:O,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=M(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=M(V._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=M(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=M(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=M(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=M(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=M(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=M(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=M(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=M(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=B({},Q),Q.pedantic=B({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:M(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:M(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=B({},Q.normal,{escape:M(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),Q.gfm.url=M(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=B({},Q.gfm,{br:M(Q.br).replace("{2,}","*").getRegex(),text:M(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var de={block:V,inline:Q},we=y.defaults,Ie=de.block,Ce=de.inline,Le=N.repeatString;function z(G){return G.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Y(G){var re="",he,J,ne=G.length;for(he=0;he<ne;he++)J=G.charCodeAt(he),Math.random()>.5&&(J="x"+J.toString(16)),re+="&#"+J+";";return re}var ee=function(){function G(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||we,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var J={block:Ie.normal,inline:Ce.normal};this.options.pedantic?(J.block=Ie.pedantic,J.inline=Ce.pedantic):this.options.gfm&&(J.block=Ie.gfm,this.options.breaks?J.inline=Ce.breaks:J.inline=Ce.gfm),this.tokenizer.rules=J}G.lex=function(J,ne){var ce=new G(ne);return ce.lex(J)},G.lexInline=function(J,ne){var ce=new G(ne);return ce.inlineTokens(J)};var re=G.prototype;return re.lex=function(J){return J=J.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(J,this.tokens,!0),this.inline(this.tokens),this.tokens},re.blockTokens=function(J,ne,ce){ne===void 0&&(ne=[]),ce===void 0&&(ce=!0),this.options.pedantic&&(J=J.replace(/^ +$/gm,""));for(var ve,ye,je,He;J;){if(ve=this.tokenizer.space(J)){J=J.substring(ve.raw.length),ve.type&&ne.push(ve);continue}if(ve=this.tokenizer.code(J)){J=J.substring(ve.raw.length),He=ne[ne.length-1],He&&He.type==="paragraph"?(He.raw+=`
`+ve.raw,He.text+=`
`+ve.text):ne.push(ve);continue}if(ve=this.tokenizer.fences(J)){J=J.substring(ve.raw.length),ne.push(ve);continue}if(ve=this.tokenizer.heading(J)){J=J.substring(ve.raw.length),ne.push(ve);continue}if(ve=this.tokenizer.nptable(J)){J=J.substring(ve.raw.length),ne.push(ve);continue}if(ve=this.tokenizer.hr(J)){J=J.substring(ve.raw.length),ne.push(ve);continue}if(ve=this.tokenizer.blockquote(J)){J=J.substring(ve.raw.length),ve.tokens=this.blockTokens(ve.text,[],ce),ne.push(ve);continue}if(ve=this.tokenizer.list(J)){for(J=J.substring(ve.raw.length),je=ve.items.length,ye=0;ye<je;ye++)ve.items[ye].tokens=this.blockTokens(ve.items[ye].text,[],!1);ne.push(ve);continue}if(ve=this.tokenizer.html(J)){J=J.substring(ve.raw.length),ne.push(ve);continue}if(ce&&(ve=this.tokenizer.def(J))){J=J.substring(ve.raw.length),this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(J)){J=J.substring(ve.raw.length),ne.push(ve);continue}if(ve=this.tokenizer.lheading(J)){J=J.substring(ve.raw.length),ne.push(ve);continue}if(ce&&(ve=this.tokenizer.paragraph(J))){J=J.substring(ve.raw.length),ne.push(ve);continue}if(ve=this.tokenizer.text(J)){J=J.substring(ve.raw.length),He=ne[ne.length-1],He&&He.type==="text"?(He.raw+=`
`+ve.raw,He.text+=`
`+ve.text):ne.push(ve);continue}if(J){var We="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(We);break}else throw new Error(We)}}return ne},re.inline=function(J){var ne,ce,ve,ye,je,He,We=J.length;for(ne=0;ne<We;ne++)switch(He=J[ne],He.type){case"paragraph":case"text":case"heading":{He.tokens=[],this.inlineTokens(He.text,He.tokens);break}case"table":{for(He.tokens={header:[],cells:[]},ye=He.header.length,ce=0;ce<ye;ce++)He.tokens.header[ce]=[],this.inlineTokens(He.header[ce],He.tokens.header[ce]);for(ye=He.cells.length,ce=0;ce<ye;ce++)for(je=He.cells[ce],He.tokens.cells[ce]=[],ve=0;ve<je.length;ve++)He.tokens.cells[ce][ve]=[],this.inlineTokens(je[ve],He.tokens.cells[ce][ve]);break}case"blockquote":{this.inline(He.tokens);break}case"list":{for(ye=He.items.length,ce=0;ce<ye;ce++)this.inline(He.items[ce].tokens);break}}return J},re.inlineTokens=function(J,ne,ce,ve){ne===void 0&&(ne=[]),ce===void 0&&(ce=!1),ve===void 0&&(ve=!1);var ye,je,He=J,We,Ke,nt;if(this.tokens.links){var dt=Object.keys(this.tokens.links);if(dt.length>0)for(;(We=this.tokenizer.rules.inline.reflinkSearch.exec(He))!=null;)dt.includes(We[0].slice(We[0].lastIndexOf("[")+1,-1))&&(He=He.slice(0,We.index)+"["+Le("a",We[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(We=this.tokenizer.rules.inline.blockSkip.exec(He))!=null;)He=He.slice(0,We.index)+"["+Le("a",We[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(We=this.tokenizer.rules.inline.escapedEmSt.exec(He))!=null;)He=He.slice(0,We.index)+"++"+He.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;){if(Ke||(nt=""),Ke=!1,ye=this.tokenizer.escape(J)){J=J.substring(ye.raw.length),ne.push(ye);continue}if(ye=this.tokenizer.tag(J,ce,ve)){J=J.substring(ye.raw.length),ce=ye.inLink,ve=ye.inRawBlock;var it=ne[ne.length-1];it&&ye.type==="text"&&it.type==="text"?(it.raw+=ye.raw,it.text+=ye.text):ne.push(ye);continue}if(ye=this.tokenizer.link(J)){J=J.substring(ye.raw.length),ye.type==="link"&&(ye.tokens=this.inlineTokens(ye.text,[],!0,ve)),ne.push(ye);continue}if(ye=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(ye.raw.length);var Ye=ne[ne.length-1];ye.type==="link"?(ye.tokens=this.inlineTokens(ye.text,[],!0,ve),ne.push(ye)):Ye&&ye.type==="text"&&Ye.type==="text"?(Ye.raw+=ye.raw,Ye.text+=ye.text):ne.push(ye);continue}if(ye=this.tokenizer.emStrong(J,He,nt)){J=J.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],ce,ve),ne.push(ye);continue}if(ye=this.tokenizer.codespan(J)){J=J.substring(ye.raw.length),ne.push(ye);continue}if(ye=this.tokenizer.br(J)){J=J.substring(ye.raw.length),ne.push(ye);continue}if(ye=this.tokenizer.del(J)){J=J.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],ce,ve),ne.push(ye);continue}if(ye=this.tokenizer.autolink(J,Y)){J=J.substring(ye.raw.length),ne.push(ye);continue}if(!ce&&(ye=this.tokenizer.url(J,Y))){J=J.substring(ye.raw.length),ne.push(ye);continue}if(ye=this.tokenizer.inlineText(J,ve,z)){J=J.substring(ye.raw.length),ye.raw.slice(-1)!=="_"&&(nt=ye.raw.slice(-1)),Ke=!0,je=ne[ne.length-1],je&&je.type==="text"?(je.raw+=ye.raw,je.text+=ye.text):ne.push(ye);continue}if(J){var mt="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(mt);break}else throw new Error(mt)}}return ne},e(G,null,[{key:"rules",get:function(){return{block:Ie,inline:Ce}}}]),G}(),le=y.defaults,me=N.cleanUrl,De=N.escape,Oe=function(){function G(he){this.options=he||le}var re=G.prototype;return re.code=function(J,ne,ce){var ve=(ne||"").match(/\S*/)[0];if(this.options.highlight){var ye=this.options.highlight(J,ve);ye!=null&&ye!==J&&(ce=!0,J=ye)}return J=J.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+De(ve,!0)+'">'+(ce?J:De(J,!0))+`</code></pre>
`:"<pre><code>"+(ce?J:De(J,!0))+`</code></pre>
`},re.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},re.html=function(J){return J},re.heading=function(J,ne,ce,ve){return this.options.headerIds?"<h"+ne+' id="'+this.options.headerPrefix+ve.slug(ce)+'">'+J+"</h"+ne+`>
`:"<h"+ne+">"+J+"</h"+ne+`>
`},re.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},re.list=function(J,ne,ce){var ve=ne?"ol":"ul",ye=ne&&ce!==1?' start="'+ce+'"':"";return"<"+ve+ye+`>
`+J+"</"+ve+`>
`},re.listitem=function(J){return"<li>"+J+`</li>
`},re.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},re.paragraph=function(J){return"<p>"+J+`</p>
`},re.table=function(J,ne){return ne&&(ne="<tbody>"+ne+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+ne+`</table>
`},re.tablerow=function(J){return`<tr>
`+J+`</tr>
`},re.tablecell=function(J,ne){var ce=ne.header?"th":"td",ve=ne.align?"<"+ce+' align="'+ne.align+'">':"<"+ce+">";return ve+J+"</"+ce+`>
`},re.strong=function(J){return"<strong>"+J+"</strong>"},re.em=function(J){return"<em>"+J+"</em>"},re.codespan=function(J){return"<code>"+J+"</code>"},re.br=function(){return this.options.xhtml?"<br/>":"<br>"},re.del=function(J){return"<del>"+J+"</del>"},re.link=function(J,ne,ce){if(J=me(this.options.sanitize,this.options.baseUrl,J),J===null)return ce;var ve='<a href="'+De(J)+'"';return ne&&(ve+=' title="'+ne+'"'),ve+=">"+ce+"</a>",ve},re.image=function(J,ne,ce){if(J=me(this.options.sanitize,this.options.baseUrl,J),J===null)return ce;var ve='<img src="'+J+'" alt="'+ce+'"';return ne&&(ve+=' title="'+ne+'"'),ve+=this.options.xhtml?"/>":">",ve},re.text=function(J){return J},G}(),be=function(){function G(){}var re=G.prototype;return re.strong=function(J){return J},re.em=function(J){return J},re.codespan=function(J){return J},re.del=function(J){return J},re.html=function(J){return J},re.text=function(J){return J},re.link=function(J,ne,ce){return""+ce},re.image=function(J,ne,ce){return""+ce},re.br=function(){return""},G}(),Pe=function(){function G(){this.seen={}}var re=G.prototype;return re.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},re.getNextSafeSlug=function(J,ne){var ce=J,ve=0;if(this.seen.hasOwnProperty(ce)){ve=this.seen[J];do ve++,ce=J+"-"+ve;while(this.seen.hasOwnProperty(ce))}return ne||(this.seen[J]=ve,this.seen[ce]=0),ce},re.slug=function(J,ne){ne===void 0&&(ne={});var ce=this.serialize(J);return this.getNextSafeSlug(ce,ne.dryrun)},G}(),Re=y.defaults,Be=N.unescape,Se=function(){function G(he){this.options=he||Re,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new be,this.slugger=new Pe}G.parse=function(J,ne){var ce=new G(ne);return ce.parse(J)},G.parseInline=function(J,ne){var ce=new G(ne);return ce.parseInline(J)};var re=G.prototype;return re.parse=function(J,ne){ne===void 0&&(ne=!0);var ce="",ve,ye,je,He,We,Ke,nt,dt,it,Ye,mt,wt,Ee,fe,ae,Z,Fe,Te,Qe=J.length;for(ve=0;ve<Qe;ve++)switch(Ye=J[ve],Ye.type){case"space":continue;case"hr":{ce+=this.renderer.hr();continue}case"heading":{ce+=this.renderer.heading(this.parseInline(Ye.tokens),Ye.depth,Be(this.parseInline(Ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ce+=this.renderer.code(Ye.text,Ye.lang,Ye.escaped);continue}case"table":{for(dt="",nt="",He=Ye.header.length,ye=0;ye<He;ye++)nt+=this.renderer.tablecell(this.parseInline(Ye.tokens.header[ye]),{header:!0,align:Ye.align[ye]});for(dt+=this.renderer.tablerow(nt),it="",He=Ye.cells.length,ye=0;ye<He;ye++){for(Ke=Ye.tokens.cells[ye],nt="",We=Ke.length,je=0;je<We;je++)nt+=this.renderer.tablecell(this.parseInline(Ke[je]),{header:!1,align:Ye.align[je]});it+=this.renderer.tablerow(nt)}ce+=this.renderer.table(dt,it);continue}case"blockquote":{it=this.parse(Ye.tokens),ce+=this.renderer.blockquote(it);continue}case"list":{for(mt=Ye.ordered,wt=Ye.start,Ee=Ye.loose,He=Ye.items.length,it="",ye=0;ye<He;ye++)ae=Ye.items[ye],Z=ae.checked,Fe=ae.task,fe="",ae.task&&(Te=this.renderer.checkbox(Z),Ee?ae.tokens.length>0&&ae.tokens[0].type==="text"?(ae.tokens[0].text=Te+" "+ae.tokens[0].text,ae.tokens[0].tokens&&ae.tokens[0].tokens.length>0&&ae.tokens[0].tokens[0].type==="text"&&(ae.tokens[0].tokens[0].text=Te+" "+ae.tokens[0].tokens[0].text)):ae.tokens.unshift({type:"text",text:Te}):fe+=Te),fe+=this.parse(ae.tokens,Ee),it+=this.renderer.listitem(fe,Fe,Z);ce+=this.renderer.list(it,mt,wt);continue}case"html":{ce+=this.renderer.html(Ye.text);continue}case"paragraph":{ce+=this.renderer.paragraph(this.parseInline(Ye.tokens));continue}case"text":{for(it=Ye.tokens?this.parseInline(Ye.tokens):Ye.text;ve+1<Qe&&J[ve+1].type==="text";)Ye=J[++ve],it+=`
`+(Ye.tokens?this.parseInline(Ye.tokens):Ye.text);ce+=ne?this.renderer.paragraph(it):it;continue}default:{var Ze='Token with "'+Ye.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}return ce},re.parseInline=function(J,ne){ne=ne||this.renderer;var ce="",ve,ye,je=J.length;for(ve=0;ve<je;ve++)switch(ye=J[ve],ye.type){case"escape":{ce+=ne.text(ye.text);break}case"html":{ce+=ne.html(ye.text);break}case"link":{ce+=ne.link(ye.href,ye.title,this.parseInline(ye.tokens,ne));break}case"image":{ce+=ne.image(ye.href,ye.title,ye.text);break}case"strong":{ce+=ne.strong(this.parseInline(ye.tokens,ne));break}case"em":{ce+=ne.em(this.parseInline(ye.tokens,ne));break}case"codespan":{ce+=ne.codespan(ye.text);break}case"br":{ce+=ne.br();break}case"del":{ce+=ne.del(this.parseInline(ye.tokens,ne));break}case"text":{ce+=ne.text(ye.text);break}default:{var He='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(He);return}else throw new Error(He)}}return ce},G}(),qe=N.merge,X=N.checkSanitizeDeprecation,ie=N.escape,_e=y.getDefaults,Ne=y.changeDefaults,ze=y.defaults;function $e(G,re,he){if(typeof G=="undefined"||G===null)throw new Error("marked(): input parameter is undefined or null");if(typeof G!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(G)+", string expected");if(typeof re=="function"&&(he=re,re=null),re=qe({},$e.defaults,re||{}),X(re),he){var J=re.highlight,ne;try{ne=ee.lex(G,re)}catch(je){return he(je)}var ce=function(He){var We;if(!He)try{We=Se.parse(ne,re)}catch(Ke){He=Ke}return re.highlight=J,He?he(He):he(null,We)};if(!J||J.length<3||(delete re.highlight,!ne.length))return ce();var ve=0;$e.walkTokens(ne,function(je){je.type==="code"&&(ve++,setTimeout(function(){J(je.text,je.lang,function(He,We){if(He)return ce(He);We!=null&&We!==je.text&&(je.text=We,je.escaped=!0),ve--,ve===0&&ce()})},0))}),ve===0&&ce();return}try{var ye=ee.lex(G,re);return re.walkTokens&&$e.walkTokens(ye,re.walkTokens),Se.parse(ye,re)}catch(je){if(je.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+ie(je.message+"",!0)+"</pre>";throw je}}$e.options=$e.setOptions=function(G){return qe($e.defaults,G),Ne($e.defaults),$e},$e.getDefaults=_e,$e.defaults=ze,$e.use=function(G){var re=qe({},G);if(G.renderer&&function(){var J=$e.defaults.renderer||new Oe,ne=function(ye){var je=J[ye];J[ye]=function(){for(var He=arguments.length,We=new Array(He),Ke=0;Ke<He;Ke++)We[Ke]=arguments[Ke];var nt=G.renderer[ye].apply(J,We);return nt===!1&&(nt=je.apply(J,We)),nt}};for(var ce in G.renderer)ne(ce);re.renderer=J}(),G.tokenizer&&function(){var J=$e.defaults.tokenizer||new F,ne=function(ye){var je=J[ye];J[ye]=function(){for(var He=arguments.length,We=new Array(He),Ke=0;Ke<He;Ke++)We[Ke]=arguments[Ke];var nt=G.tokenizer[ye].apply(J,We);return nt===!1&&(nt=je.apply(J,We)),nt}};for(var ce in G.tokenizer)ne(ce);re.tokenizer=J}(),G.walkTokens){var he=$e.defaults.walkTokens;re.walkTokens=function(J){G.walkTokens(J),he&&he(J)}}$e.setOptions(re)},$e.walkTokens=function(G,re){for(var he=T(G),J;!(J=he()).done;){var ne=J.value;switch(re(ne),ne.type){case"table":{for(var ce=T(ne.tokens.header),ve;!(ve=ce()).done;){var ye=ve.value;$e.walkTokens(ye,re)}for(var je=T(ne.tokens.cells),He;!(He=je()).done;)for(var We=He.value,Ke=T(We),nt;!(nt=Ke()).done;){var dt=nt.value;$e.walkTokens(dt,re)}break}case"list":{$e.walkTokens(ne.items,re);break}default:ne.tokens&&$e.walkTokens(ne.tokens,re)}}},$e.parseInline=function(G,re){if(typeof G=="undefined"||G===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof G!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(G)+", string expected");re=qe({},$e.defaults,re||{}),X(re);try{var he=ee.lexInline(G,re);return re.walkTokens&&$e.walkTokens(he,re.walkTokens),Se.parseInline(he,re)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+ie(J.message+"",!0)+"</pre>";throw J}},$e.Parser=Se,$e.parser=Se.parse,$e.Renderer=Oe,$e.TextRenderer=be,$e.Lexer=ee,$e.lexer=ee.lex,$e.Tokenizer=F,$e.Slugger=Pe,$e.parse=$e;var Je=$e;return Je}),define(ge[73],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function _(y,k,D){return Math.min(Math.max(y,k),D)}e.clamp=_;function I(y,k){return(k+y%k)%k}e.rot=I;class T{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=T;class A{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A});"use strict";(function(){function K(T){const A=[];typeof T=="number"&&A.push("code/timeOrigin",T);function y(D){A.push(D,Date.now())}function k(){const D=[];for(let P=0;P<A.length;P+=2)D.push({name:A[P],startTime:A[P+1]});return D}return{mark:y,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const y of performance.getEntriesByType("mark"))A.push({name:y.name,startTime:Math.round(T+y.startTime)});return A}};if(typeof process=="object"){const T=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function _(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return _(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=_(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=_(I))})(),define(ge[10],pe([0,1]),function(K,e){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const I="en";let T=!1,A=!1,y=!1,k=!1,D=!1,P=!1,s=!1,C,g=I,m,a;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const E=typeof((_=u==null?void 0:u.versions)===null||_===void 0?void 0:_.electron)=="string"&&u.type==="renderer";if(e.isElectronSandboxed=E&&(u==null?void 0:u.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const i=u==null?void 0:u.env.VSCODE_BROWSER_CODE_LOADING;if(typeof i=="string")return i==="none"||i==="code"||i==="bypassHeatCheck"||i==="bypassHeatCheckAndEagerCompile"?i:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!E)a=navigator.userAgent,T=a.indexOf("Windows")>=0,A=a.indexOf("Macintosh")>=0,s=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=a.indexOf("Linux")>=0,P=!0,C=navigator.language,g=C;else if(typeof u=="object"){T=u.platform==="win32",A=u.platform==="darwin",y=u.platform==="linux",k=y&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,C=I,g=I;const i=u.env.VSCODE_NLS_CONFIG;if(i)try{const o=JSON.parse(i),c=o.availableLanguages["*"];C=o.locale,g=c||I,m=o._translationsConfigFile}catch(o){}D=!0}else console.error("Unable to resolve platform.");var w;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function S(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=S;let d=0;A?d=1:T?d=3:y&&(d=2),e.isWindows=T,e.isMacintosh=A,e.isLinux=y,e.isLinuxSnap=k,e.isNative=D,e.isWeb=P,e.isIOS=s,e.platform=d,e.userAgent=a,e.language=g;var l;(function(i){function o(){return e.language}i.value=o;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=c;function v(){return e.language==="en"}i.isDefault=v})(l=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",p=>{if(p.data&&p.data.vscodeSetImmediateId)for(let h=0,b=c.length;h<b;h++){const R=c[h];if(R.id===p.data.vscodeSetImmediateId){c.splice(h,1),R.callback();return}}});let v=0;return p=>{const h=++v;c.push({id:h,callback:p}),e.globals.postMessage({vscodeSetImmediateId:h},"*")}}if(typeof(u==null?void 0:u.nextTick)=="function")return u.nextTick.bind(u);const o=Promise.resolve();return c=>o.then(c)}();var f;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(f=e.OperatingSystem||(e.OperatingSystem={})),e.OS=A||s?2:T?1:3;let t=!0,n=!1;function r(){if(!n){n=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,t=new Uint16Array(i.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=r}),define(ge[36],pe([0,1,10]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let I;if(typeof _.globals.vscode!="undefined"){const T=_.globals.vscode.process;I={get platform(){return T.platform},get env(){return T.env},cwd(){return T.cwd()},nextTick(A){return(0,_.setImmediate)(A)}}}else typeof process!="undefined"?I={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(T){return process.nextTick(T)}}:I={get platform(){return _.isWindows?"win32":_.isMacintosh?"darwin":"linux"},nextTick(T){return(0,_.setImmediate)(T)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=I.cwd,e.env=I.env,e.platform=I.platform,e.nextTick=I.nextTick}),define(ge[8],pe([0,1,36]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const I=65,T=97,A=90,y=122,k=46,D=47,P=92,s=58,C=63;class g extends Error{constructor(l,f,t){let n;typeof f=="string"&&f.indexOf("not ")===0?(n="must not be",f=f.replace(/^not /,"")):n="must be";const r=l.indexOf(".")!==-1?"property":"argument";let i=`The "${l}" ${r} ${n} of type ${f}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function m(d,l){if(typeof d!="string")throw new g(l,"string",d)}function a(d){return d===D||d===P}function u(d){return d===D}function E(d){return d>=I&&d<=A||d>=T&&d<=y}function w(d,l,f,t){let n="",r=0,i=-1,o=0,c=0;for(let v=0;v<=d.length;++v){if(v<d.length)c=d.charCodeAt(v);else{if(t(c))break;c=D}if(t(c)){if(!(i===v-1||o===1))if(o===2){if(n.length<2||r!==2||n.charCodeAt(n.length-1)!==k||n.charCodeAt(n.length-2)!==k){if(n.length>2){const p=n.lastIndexOf(f);p===-1?(n="",r=0):(n=n.slice(0,p),r=n.length-1-n.lastIndexOf(f)),i=v,o=0;continue}else if(n.length!==0){n="",r=0,i=v,o=0;continue}}l&&(n+=n.length>0?`${f}..`:"..",r=2)}else n.length>0?n+=`${f}${d.slice(i+1,v)}`:n=d.slice(i+1,v),r=v-i-1;i=v,o=0}else c===k&&o!==-1?++o:o=-1}return n}function S(d,l){if(l===null||typeof l!="object")throw new g("pathObject","Object",l);const f=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return f?f===l.root?`${f}${t}`:`${f}${d}${t}`:t}e.win32={resolve(...d){let l="",f="",t=!1;for(let n=d.length-1;n>=-1;n--){let r;if(n>=0){if(r=d[n],m(r,"path"),r.length===0)continue}else l.length===0?r=_.cwd():(r=_.env[`=${l}`]||_.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==l.toLowerCase()&&r.charCodeAt(2)===P)&&(r=`${l}\\`));const i=r.length;let o=0,c="",v=!1;const p=r.charCodeAt(0);if(i===1)a(p)&&(o=1,v=!0);else if(a(p))if(v=!0,a(r.charCodeAt(1))){let h=2,b=h;for(;h<i&&!a(r.charCodeAt(h));)h++;if(h<i&&h!==b){const R=r.slice(b,h);for(b=h;h<i&&a(r.charCodeAt(h));)h++;if(h<i&&h!==b){for(b=h;h<i&&!a(r.charCodeAt(h));)h++;(h===i||h!==b)&&(c=`\\\\${R}\\${r.slice(b,h)}`,o=h)}}}else o=1;else E(p)&&r.charCodeAt(1)===s&&(c=r.slice(0,2),o=2,i>2&&a(r.charCodeAt(2))&&(v=!0,o=3));if(c.length>0)if(l.length>0){if(c.toLowerCase()!==l.toLowerCase())continue}else l=c;if(t){if(l.length>0)break}else if(f=`${r.slice(o)}\\${f}`,t=v,v&&l.length>0)break}return f=w(f,!t,"\\",a),t?`${l}\\${f}`:`${l}${f}`||"."},normalize(d){m(d,"path");const l=d.length;if(l===0)return".";let f=0,t,n=!1;const r=d.charCodeAt(0);if(l===1)return u(r)?"\\":d;if(a(r))if(n=!0,a(d.charCodeAt(1))){let o=2,c=o;for(;o<l&&!a(d.charCodeAt(o));)o++;if(o<l&&o!==c){const v=d.slice(c,o);for(c=o;o<l&&a(d.charCodeAt(o));)o++;if(o<l&&o!==c){for(c=o;o<l&&!a(d.charCodeAt(o));)o++;if(o===l)return`\\\\${v}\\${d.slice(c)}\\`;o!==c&&(t=`\\\\${v}\\${d.slice(c,o)}`,f=o)}}}else f=1;else E(r)&&d.charCodeAt(1)===s&&(t=d.slice(0,2),f=2,l>2&&a(d.charCodeAt(2))&&(n=!0,f=3));let i=f<l?w(d.slice(f),!n,"\\",a):"";return i.length===0&&!n&&(i="."),i.length>0&&a(d.charCodeAt(l-1))&&(i+="\\"),t===void 0?n?`\\${i}`:i:n?`${t}\\${i}`:`${t}${i}`},isAbsolute(d){m(d,"path");const l=d.length;if(l===0)return!1;const f=d.charCodeAt(0);return a(f)||l>2&&E(f)&&d.charCodeAt(1)===s&&a(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let l,f;for(let r=0;r<d.length;++r){const i=d[r];m(i,"path"),i.length>0&&(l===void 0?l=f=i:l+=`\\${i}`)}if(l===void 0)return".";let t=!0,n=0;if(typeof f=="string"&&a(f.charCodeAt(0))){++n;const r=f.length;r>1&&a(f.charCodeAt(1))&&(++n,r>2&&(a(f.charCodeAt(2))?++n:t=!1))}if(t){for(;n<l.length&&a(l.charCodeAt(n));)n++;n>=2&&(l=`\\${l.slice(n)}`)}return e.win32.normalize(l)},relative(d,l){if(m(d,"from"),m(l,"to"),d===l)return"";const f=e.win32.resolve(d),t=e.win32.resolve(l);if(f===t||(d=f.toLowerCase(),l=t.toLowerCase(),d===l))return"";let n=0;for(;n<d.length&&d.charCodeAt(n)===P;)n++;let r=d.length;for(;r-1>n&&d.charCodeAt(r-1)===P;)r--;const i=r-n;let o=0;for(;o<l.length&&l.charCodeAt(o)===P;)o++;let c=l.length;for(;c-1>o&&l.charCodeAt(c-1)===P;)c--;const v=c-o,p=i<v?i:v;let h=-1,b=0;for(;b<p;b++){const N=d.charCodeAt(n+b);if(N!==l.charCodeAt(o+b))break;N===P&&(h=b)}if(b!==p){if(h===-1)return t}else{if(v>p){if(l.charCodeAt(o+b)===P)return t.slice(o+b+1);if(b===2)return t.slice(o+b)}i>p&&(d.charCodeAt(n+b)===P?h=b:b===2&&(h=3)),h===-1&&(h=0)}let R="";for(b=n+h+1;b<=r;++b)(b===r||d.charCodeAt(b)===P)&&(R+=R.length===0?"..":"\\..");return o+=h,R.length>0?`${R}${t.slice(o,c)}`:(t.charCodeAt(o)===P&&++o,t.slice(o,c))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const l=e.win32.resolve(d);if(l.length<=2)return d;if(l.charCodeAt(0)===P){if(l.charCodeAt(1)===P){const f=l.charCodeAt(2);if(f!==C&&f!==k)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(E(l.charCodeAt(0))&&l.charCodeAt(1)===s&&l.charCodeAt(2)===P)return`\\\\?\\${l}`;return d},dirname(d){m(d,"path");const l=d.length;if(l===0)return".";let f=-1,t=0;const n=d.charCodeAt(0);if(l===1)return a(n)?d:".";if(a(n)){if(f=t=1,a(d.charCodeAt(1))){let o=2,c=o;for(;o<l&&!a(d.charCodeAt(o));)o++;if(o<l&&o!==c){for(c=o;o<l&&a(d.charCodeAt(o));)o++;if(o<l&&o!==c){for(c=o;o<l&&!a(d.charCodeAt(o));)o++;if(o===l)return d;o!==c&&(f=t=o+1)}}}}else E(n)&&d.charCodeAt(1)===s&&(f=l>2&&a(d.charCodeAt(2))?3:2,t=f);let r=-1,i=!0;for(let o=l-1;o>=t;--o)if(a(d.charCodeAt(o))){if(!i){r=o;break}}else i=!1;if(r===-1){if(f===-1)return".";r=f}return d.slice(0,r)},basename(d,l){l!==void 0&&m(l,"ext"),m(d,"path");let f=0,t=-1,n=!0,r;if(d.length>=2&&E(d.charCodeAt(0))&&d.charCodeAt(1)===s&&(f=2),l!==void 0&&l.length>0&&l.length<=d.length){if(l===d)return"";let i=l.length-1,o=-1;for(r=d.length-1;r>=f;--r){const c=d.charCodeAt(r);if(a(c)){if(!n){f=r+1;break}}else o===-1&&(n=!1,o=r+1),i>=0&&(c===l.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=o))}return f===t?t=o:t===-1&&(t=d.length),d.slice(f,t)}for(r=d.length-1;r>=f;--r)if(a(d.charCodeAt(r))){if(!n){f=r+1;break}}else t===-1&&(n=!1,t=r+1);return t===-1?"":d.slice(f,t)},extname(d){m(d,"path");let l=0,f=-1,t=0,n=-1,r=!0,i=0;d.length>=2&&d.charCodeAt(1)===s&&E(d.charCodeAt(0))&&(l=t=2);for(let o=d.length-1;o>=l;--o){const c=d.charCodeAt(o);if(a(c)){if(!r){t=o+1;break}continue}n===-1&&(r=!1,n=o+1),c===k?f===-1?f=o:i!==1&&(i=1):f!==-1&&(i=-1)}return f===-1||n===-1||i===0||i===1&&f===n-1&&f===t+1?"":d.slice(f,n)},format:S.bind(null,"\\"),parse(d){m(d,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return l;const f=d.length;let t=0,n=d.charCodeAt(0);if(f===1)return a(n)?(l.root=l.dir=d,l):(l.base=l.name=d,l);if(a(n)){if(t=1,a(d.charCodeAt(1))){let h=2,b=h;for(;h<f&&!a(d.charCodeAt(h));)h++;if(h<f&&h!==b){for(b=h;h<f&&a(d.charCodeAt(h));)h++;if(h<f&&h!==b){for(b=h;h<f&&!a(d.charCodeAt(h));)h++;h===f?t=h:h!==b&&(t=h+1)}}}}else if(E(n)&&d.charCodeAt(1)===s){if(f<=2)return l.root=l.dir=d,l;if(t=2,a(d.charCodeAt(2))){if(f===3)return l.root=l.dir=d,l;t=3}}t>0&&(l.root=d.slice(0,t));let r=-1,i=t,o=-1,c=!0,v=d.length-1,p=0;for(;v>=t;--v){if(n=d.charCodeAt(v),a(n)){if(!c){i=v+1;break}continue}o===-1&&(c=!1,o=v+1),n===k?r===-1?r=v:p!==1&&(p=1):r!==-1&&(p=-1)}return o!==-1&&(r===-1||p===0||p===1&&r===o-1&&r===i+1?l.base=l.name=d.slice(i,o):(l.name=d.slice(i,r),l.base=d.slice(i,o),l.ext=d.slice(r,o))),i>0&&i!==t?l.dir=d.slice(0,i-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let l="",f=!1;for(let t=d.length-1;t>=-1&&!f;t--){const n=t>=0?d[t]:_.cwd();m(n,"path"),n.length!==0&&(l=`${n}/${l}`,f=n.charCodeAt(0)===D)}return l=w(l,!f,"/",u),f?`/${l}`:l.length>0?l:"."},normalize(d){if(m(d,"path"),d.length===0)return".";const l=d.charCodeAt(0)===D,f=d.charCodeAt(d.length-1)===D;return d=w(d,!l,"/",u),d.length===0?l?"/":f?"./":".":(f&&(d+="/"),l?`/${d}`:d)},isAbsolute(d){return m(d,"path"),d.length>0&&d.charCodeAt(0)===D},join(...d){if(d.length===0)return".";let l;for(let f=0;f<d.length;++f){const t=d[f];m(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(d,l){if(m(d,"from"),m(l,"to"),d===l||(d=e.posix.resolve(d),l=e.posix.resolve(l),d===l))return"";const f=1,t=d.length,n=t-f,r=1,i=l.length-r,o=n<i?n:i;let c=-1,v=0;for(;v<o;v++){const h=d.charCodeAt(f+v);if(h!==l.charCodeAt(r+v))break;h===D&&(c=v)}if(v===o)if(i>o){if(l.charCodeAt(r+v)===D)return l.slice(r+v+1);if(v===0)return l.slice(r+v)}else n>o&&(d.charCodeAt(f+v)===D?c=v:v===0&&(c=0));let p="";for(v=f+c+1;v<=t;++v)(v===t||d.charCodeAt(v)===D)&&(p+=p.length===0?"..":"/..");return`${p}${l.slice(r+c)}`},toNamespacedPath(d){return d},dirname(d){if(m(d,"path"),d.length===0)return".";const l=d.charCodeAt(0)===D;let f=-1,t=!0;for(let n=d.length-1;n>=1;--n)if(d.charCodeAt(n)===D){if(!t){f=n;break}}else t=!1;return f===-1?l?"/":".":l&&f===1?"//":d.slice(0,f)},basename(d,l){l!==void 0&&m(l,"ext"),m(d,"path");let f=0,t=-1,n=!0,r;if(l!==void 0&&l.length>0&&l.length<=d.length){if(l===d)return"";let i=l.length-1,o=-1;for(r=d.length-1;r>=0;--r){const c=d.charCodeAt(r);if(c===D){if(!n){f=r+1;break}}else o===-1&&(n=!1,o=r+1),i>=0&&(c===l.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=o))}return f===t?t=o:t===-1&&(t=d.length),d.slice(f,t)}for(r=d.length-1;r>=0;--r)if(d.charCodeAt(r)===D){if(!n){f=r+1;break}}else t===-1&&(n=!1,t=r+1);return t===-1?"":d.slice(f,t)},extname(d){m(d,"path");let l=-1,f=0,t=-1,n=!0,r=0;for(let i=d.length-1;i>=0;--i){const o=d.charCodeAt(i);if(o===D){if(!n){f=i+1;break}continue}t===-1&&(n=!1,t=i+1),o===k?l===-1?l=i:r!==1&&(r=1):l!==-1&&(r=-1)}return l===-1||t===-1||r===0||r===1&&l===t-1&&l===f+1?"":d.slice(l,t)},format:S.bind(null,"/"),parse(d){m(d,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return l;const f=d.charCodeAt(0)===D;let t;f?(l.root="/",t=1):t=0;let n=-1,r=0,i=-1,o=!0,c=d.length-1,v=0;for(;c>=t;--c){const p=d.charCodeAt(c);if(p===D){if(!o){r=c+1;break}continue}i===-1&&(o=!1,i=c+1),p===k?n===-1?n=c:v!==1&&(v=1):n!==-1&&(v=-1)}if(i!==-1){const p=r===0&&f?1:r;n===-1||v===0||v===1&&n===i-1&&n===r+1?l.base=l.name=d.slice(p,i):(l.name=d.slice(p,n),l.base=d.slice(p,i),l.ext=d.slice(n,i))}return r>0?l.dir=d.slice(0,r-1):f&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=_.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=_.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=_.platform==="win32"?e.win32.join:e.posix.join,e.resolve=_.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=_.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=_.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=_.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=_.platform==="win32"?e.win32.extname:e.posix.extname,e.format=_.platform==="win32"?e.win32.format:e.posix.format,e.parse=_.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=_.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=_.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=_.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ge[135],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var _;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(_=e.Source||(e.Source={}));var I;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(I=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(A,...y){const k=y.reduce((s,C)=>(s[C]=!0,s),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(s=>!k[s]).forEach(s=>{for(let C=0;C<D.length;C++)if(s.search(D[C])!==-1){delete A[s];break}})}e.sanitizeProcessEnvironment=T}),define(ge[47],pe([0,1,10]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const I=_.globals.performance&&typeof _.globals.performance.now=="function";class T{constructor(y){this._highResolution=I&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new T(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?_.globals.performance.now():Date.now()}}e.StopWatch=T}),define(ge[3],pe([0,1,18,71,6,56,47]),function(K,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(w){w.None=()=>T.Disposable.None;function S(q){return(W,H=null,U)=>{let L=!1,F;return F=q(O=>{if(!L)return F?F.dispose():L=!0,W.call(H,O)},null,U),L&&F.dispose(),F}}w.once=S;function d(q,W){return i((H,U=null,L)=>q(F=>H.call(U,W(F)),null,L))}w.map=d;function l(q,W){return i((H,U=null,L)=>q(F=>{W(F),H.call(U,F)},null,L))}w.forEach=l;function f(q,W){return i((H,U=null,L)=>q(F=>W(F)&&H.call(U,F),null,L))}w.filter=f;function t(q){return q}w.signal=t;function n(...q){return(W,H=null,U)=>(0,T.combinedDisposable)(...q.map(L=>L(F=>W.call(H,F),null,U)))}w.any=n;function r(q,W,H){let U=H;return d(q,L=>(U=W(U,L),U))}w.reduce=r;function i(q){let W;const H=new g({onFirstListenerAdd(){W=q(H.fire,H)},onLastListenerRemove(){W.dispose()}});return H.event}w.snapshot=i;function o(q,W,H=100,U=!1,L){let F,O,M,B=0;const V=new g({leakWarningThreshold:L,onFirstListenerAdd(){F=q(Q=>{B++,O=W(O,Q),U&&!M&&(V.fire(O),O=void 0),clearTimeout(M),M=setTimeout(()=>{const de=O;O=void 0,M=void 0,(!U||B>1)&&V.fire(de),B=0},H)})},onLastListenerRemove(){F.dispose()}});return V.event}w.debounce=o;function c(q){const W=new Date().getTime();return d(S(q),H=>new Date().getTime()-W)}w.stopwatch=c;function v(q){let W=!0,H;return f(q,U=>{const L=W||U!==H;return W=!1,H=U,L})}w.latch=v;function p(q,W=!1,H=[]){let U=H.slice(),L=q(M=>{U?U.push(M):O.fire(M)});const F=()=>{U&&U.forEach(M=>O.fire(M)),U=null},O=new g({onFirstListenerAdd(){L||(L=q(M=>O.fire(M)))},onFirstListenerDidAdd(){U&&(W?setTimeout(F):F())},onLastListenerRemove(){L&&L.dispose(),L=null}});return O.event}w.buffer=p;class h{constructor(W){this.event=W}map(W){return new h(d(this.event,W))}forEach(W){return new h(l(this.event,W))}filter(W){return new h(f(this.event,W))}reduce(W,H){return new h(r(this.event,W,H))}latch(){return new h(v(this.event))}debounce(W,H=100,U=!1,L){return new h(o(this.event,W,H,U,L))}on(W,H,U){return this.event(W,H,U)}once(W,H,U){return S(this.event)(W,H,U)}}function b(q){return new h(q)}w.chain=b;function R(q,W,H=U=>U){const U=(...M)=>O.fire(H(...M)),L=()=>q.on(W,U),F=()=>q.removeListener(W,U),O=new g({onFirstListenerAdd:L,onLastListenerRemove:F});return O.event}w.fromNodeEventEmitter=R;function N(q,W,H=U=>U){const U=(...M)=>O.fire(H(...M)),L=()=>q.addEventListener(W,U),F=()=>q.removeEventListener(W,U),O=new g({onFirstListenerAdd:L,onLastListenerRemove:F});return O.event}w.fromDOMEventEmitter=N;function j(q){const W=new g;let H=!1;return q.then(void 0,()=>null).then(()=>{H?W.fire(void 0):setTimeout(()=>W.fire(void 0),0)}),H=!0,W.event}w.fromPromise=j;function oe(q){return new Promise(W=>S(q)(W))}w.toPromise=oe})(k=e.Event||(e.Event={}));class D{constructor(S){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${S}_${D._idPool++}`}start(S){this._stopWatch=new y.StopWatch(!0),this._listenerCount=S}stop(){if(this._stopWatch){const S=this._stopWatch.elapsed();this._elapsedOverall+=S,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${S.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let P=-1;function s(w){const S=P;return P=w,{dispose(){P=S}}}e.setGlobalLeakWarningThreshold=s;class C{constructor(S,d=Math.random().toString(18).slice(2,5)){this.customThreshold=S,this.name=d,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(S){let d=P;if(typeof this.customThreshold=="number"&&(d=this.customThreshold),!(d<=0||S<d)){this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),f=this._stacks.get(l)||0;if(this._stacks.set(l,f+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=d*.5;let t,n=0;for(const[r,i]of this._stacks)(!t||n<i)&&(t=r,n=i);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(l)||0;this._stacks.set(l,t-1)}}}}class g{constructor(S){var d;this._disposed=!1,this._options=S,this._leakageMon=P>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((d=this._options)===null||d===void 0?void 0:d._profName)?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(S,d,l)=>{var f;this._listeners||(this._listeners=new A.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(d?[S,d]:S);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,S,d);const r=(f=this._leakageMon)===null||f===void 0?void 0:f.check(this._listeners.size);let i;return i={dispose:()=>{r&&r(),i.dispose=g._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},l instanceof T.DisposableStore?l.add(i):Array.isArray(l)&&l.push(i),i}),this._event}fire(S){var d,l;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let f of this._listeners)this._deliveryQueue.push([f,S]);for((d=this._perfMon)===null||d===void 0||d.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[f,t]=this._deliveryQueue.shift();try{typeof f=="function"?f.call(void 0,t):f[0].call(f[1],t)}catch(n){(0,_.onUnexpectedError)(n)}}(l=this._perfMon)===null||l===void 0||l.stop()}}dispose(){var S,d,l;(S=this._listeners)===null||S===void 0||S.clear(),(d=this._deliveryQueue)===null||d===void 0||d.clear(),(l=this._leakageMon)===null||l===void 0||l.dispose(),this._disposed=!0}}e.Emitter=g,g._noop=function(){};class m extends g{constructor(S){super(S);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=S==null?void 0:S.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const S=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(S))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(S){this._listeners&&(this._isPaused!==0?this._eventQueue.push(S):super.fire(S))}}e.PauseableEmitter=m;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(S){const d={event:S,listener:null};this.events.push(d),this.hasListeners&&this.hook(d);const l=()=>{this.hasListeners&&this.unhook(d);const f=this.events.indexOf(d);this.events.splice(f,1)};return(0,T.toDisposable)((0,I.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(S=>this.hook(S))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(S=>this.unhook(S))}hook(S){S.listener=S.event(d=>this.emitter.fire(d))}unhook(S){S.listener&&S.listener.dispose(),S.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=a;class u{constructor(){this.buffers=[]}wrapEvent(S){return(d,l,f)=>S(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>d.call(l,t)):d.call(l,t)},void 0,f)}bufferEvents(S){const d=[];this.buffers.push(d);const l=S();return this.buffers.pop(),d.forEach(f=>f()),l}}e.EventBufferer=u;class E{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=T.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(S){this.inputEvent=S,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=S(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(ge[21],pe([0,1,3]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const I=Object.freeze(function(k,D){const P=setTimeout(k.bind(D),0);return{dispose(){clearTimeout(P)}}});var T;(function(k){function D(P){return P===k.None||P===k.Cancelled||P instanceof A?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}k.isCancellationToken=D,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:I})})(T=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?I:(this._emitter||(this._emitter=new _.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=T.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=y}),define(ge[43],pe([0,1,3]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class I{constructor(){this._icons=new Map,this._onDidRegister=new _.Emitter}add(C){const g=this._icons.get(C.id);g?C.description?g.description=C.description:console.error(`Duplicate registration of codicon ${C.id}`):(this._icons.set(C.id,C),this._onDidRegister.fire(C))}get(C){return this._icons.get(C)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const T=new I;e.iconRegistry=T;function A(s,C){return new k(s,C)}e.registerCodicon=A;function y(s){return s?s.replace(/\$\((.*?)\)/g,(C,g)=>` ${g} `).trim():""}e.getCodiconAriaLabel=y;class k{constructor(C,g,m){this.id=C,this.definition=g,this.description=m,T.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=k;function D(s,C){const g=["codicon","codicon-"+s];return C&&g.push("codicon-modifier-"+C),g}e.getClassNamesArray=D;var P;(function(s){s.iconNameSegment="[A-Za-z0-9]+",s.iconNameExpression="[A-Za-z0-9\\-]+",s.iconModifierExpression="~[A-Za-z]+";const C=new RegExp(`^(${s.iconNameExpression})(${s.iconModifierExpression})?$`);function g(u){if(u instanceof k)return["codicon","codicon-"+u.id];const E=C.exec(u.id);if(!E)return g(k.error);let[,w,S]=E;const d=["codicon","codicon-"+w];return S&&d.push("codicon-modifier-"+S.substr(1)),d}s.asClassNameArray=g;function m(u){return g(u).join(" ")}s.asClassName=m;function a(u){return"."+g(u).join(".")}s.asCSSSelector=a})(P=e.CSSIcon||(e.CSSIcon={})),function(s){s.add=new s("add",{fontCharacter:"\\ea60"}),s.plus=new s("plus",{fontCharacter:"\\ea60"}),s.gistNew=new s("gist-new",{fontCharacter:"\\ea60"}),s.repoCreate=new s("repo-create",{fontCharacter:"\\ea60"}),s.lightbulb=new s("lightbulb",{fontCharacter:"\\ea61"}),s.lightBulb=new s("light-bulb",{fontCharacter:"\\ea61"}),s.repo=new s("repo",{fontCharacter:"\\ea62"}),s.repoDelete=new s("repo-delete",{fontCharacter:"\\ea62"}),s.gistFork=new s("gist-fork",{fontCharacter:"\\ea63"}),s.repoForked=new s("repo-forked",{fontCharacter:"\\ea63"}),s.gitPullRequest=new s("git-pull-request",{fontCharacter:"\\ea64"}),s.gitPullRequestAbandoned=new s("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),s.recordKeys=new s("record-keys",{fontCharacter:"\\ea65"}),s.keyboard=new s("keyboard",{fontCharacter:"\\ea65"}),s.tag=new s("tag",{fontCharacter:"\\ea66"}),s.tagAdd=new s("tag-add",{fontCharacter:"\\ea66"}),s.tagRemove=new s("tag-remove",{fontCharacter:"\\ea66"}),s.person=new s("person",{fontCharacter:"\\ea67"}),s.personFollow=new s("person-follow",{fontCharacter:"\\ea67"}),s.personOutline=new s("person-outline",{fontCharacter:"\\ea67"}),s.personFilled=new s("person-filled",{fontCharacter:"\\ea67"}),s.gitBranch=new s("git-branch",{fontCharacter:"\\ea68"}),s.gitBranchCreate=new s("git-branch-create",{fontCharacter:"\\ea68"}),s.gitBranchDelete=new s("git-branch-delete",{fontCharacter:"\\ea68"}),s.sourceControl=new s("source-control",{fontCharacter:"\\ea68"}),s.mirror=new s("mirror",{fontCharacter:"\\ea69"}),s.mirrorPublic=new s("mirror-public",{fontCharacter:"\\ea69"}),s.star=new s("star",{fontCharacter:"\\ea6a"}),s.starAdd=new s("star-add",{fontCharacter:"\\ea6a"}),s.starDelete=new s("star-delete",{fontCharacter:"\\ea6a"}),s.starEmpty=new s("star-empty",{fontCharacter:"\\ea6a"}),s.comment=new s("comment",{fontCharacter:"\\ea6b"}),s.commentAdd=new s("comment-add",{fontCharacter:"\\ea6b"}),s.alert=new s("alert",{fontCharacter:"\\ea6c"}),s.warning=new s("warning",{fontCharacter:"\\ea6c"}),s.search=new s("search",{fontCharacter:"\\ea6d"}),s.searchSave=new s("search-save",{fontCharacter:"\\ea6d"}),s.logOut=new s("log-out",{fontCharacter:"\\ea6e"}),s.signOut=new s("sign-out",{fontCharacter:"\\ea6e"}),s.logIn=new s("log-in",{fontCharacter:"\\ea6f"}),s.signIn=new s("sign-in",{fontCharacter:"\\ea6f"}),s.eye=new s("eye",{fontCharacter:"\\ea70"}),s.eyeUnwatch=new s("eye-unwatch",{fontCharacter:"\\ea70"}),s.eyeWatch=new s("eye-watch",{fontCharacter:"\\ea70"}),s.circleFilled=new s("circle-filled",{fontCharacter:"\\ea71"}),s.primitiveDot=new s("primitive-dot",{fontCharacter:"\\ea71"}),s.closeDirty=new s("close-dirty",{fontCharacter:"\\ea71"}),s.debugBreakpoint=new s("debug-breakpoint",{fontCharacter:"\\ea71"}),s.debugBreakpointDisabled=new s("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),s.debugHint=new s("debug-hint",{fontCharacter:"\\ea71"}),s.primitiveSquare=new s("primitive-square",{fontCharacter:"\\ea72"}),s.edit=new s("edit",{fontCharacter:"\\ea73"}),s.pencil=new s("pencil",{fontCharacter:"\\ea73"}),s.info=new s("info",{fontCharacter:"\\ea74"}),s.issueOpened=new s("issue-opened",{fontCharacter:"\\ea74"}),s.gistPrivate=new s("gist-private",{fontCharacter:"\\ea75"}),s.gitForkPrivate=new s("git-fork-private",{fontCharacter:"\\ea75"}),s.lock=new s("lock",{fontCharacter:"\\ea75"}),s.mirrorPrivate=new s("mirror-private",{fontCharacter:"\\ea75"}),s.close=new s("close",{fontCharacter:"\\ea76"}),s.removeClose=new s("remove-close",{fontCharacter:"\\ea76"}),s.x=new s("x",{fontCharacter:"\\ea76"}),s.repoSync=new s("repo-sync",{fontCharacter:"\\ea77"}),s.sync=new s("sync",{fontCharacter:"\\ea77"}),s.clone=new s("clone",{fontCharacter:"\\ea78"}),s.desktopDownload=new s("desktop-download",{fontCharacter:"\\ea78"}),s.beaker=new s("beaker",{fontCharacter:"\\ea79"}),s.microscope=new s("microscope",{fontCharacter:"\\ea79"}),s.vm=new s("vm",{fontCharacter:"\\ea7a"}),s.deviceDesktop=new s("device-desktop",{fontCharacter:"\\ea7a"}),s.file=new s("file",{fontCharacter:"\\ea7b"}),s.fileText=new s("file-text",{fontCharacter:"\\ea7b"}),s.more=new s("more",{fontCharacter:"\\ea7c"}),s.ellipsis=new s("ellipsis",{fontCharacter:"\\ea7c"}),s.kebabHorizontal=new s("kebab-horizontal",{fontCharacter:"\\ea7c"}),s.mailReply=new s("mail-reply",{fontCharacter:"\\ea7d"}),s.reply=new s("reply",{fontCharacter:"\\ea7d"}),s.organization=new s("organization",{fontCharacter:"\\ea7e"}),s.organizationFilled=new s("organization-filled",{fontCharacter:"\\ea7e"}),s.organizationOutline=new s("organization-outline",{fontCharacter:"\\ea7e"}),s.newFile=new s("new-file",{fontCharacter:"\\ea7f"}),s.fileAdd=new s("file-add",{fontCharacter:"\\ea7f"}),s.newFolder=new s("new-folder",{fontCharacter:"\\ea80"}),s.fileDirectoryCreate=new s("file-directory-create",{fontCharacter:"\\ea80"}),s.trash=new s("trash",{fontCharacter:"\\ea81"}),s.trashcan=new s("trashcan",{fontCharacter:"\\ea81"}),s.history=new s("history",{fontCharacter:"\\ea82"}),s.clock=new s("clock",{fontCharacter:"\\ea82"}),s.folder=new s("folder",{fontCharacter:"\\ea83"}),s.fileDirectory=new s("file-directory",{fontCharacter:"\\ea83"}),s.symbolFolder=new s("symbol-folder",{fontCharacter:"\\ea83"}),s.logoGithub=new s("logo-github",{fontCharacter:"\\ea84"}),s.markGithub=new s("mark-github",{fontCharacter:"\\ea84"}),s.github=new s("github",{fontCharacter:"\\ea84"}),s.terminal=new s("terminal",{fontCharacter:"\\ea85"}),s.console=new s("console",{fontCharacter:"\\ea85"}),s.repl=new s("repl",{fontCharacter:"\\ea85"}),s.zap=new s("zap",{fontCharacter:"\\ea86"}),s.symbolEvent=new s("symbol-event",{fontCharacter:"\\ea86"}),s.error=new s("error",{fontCharacter:"\\ea87"}),s.stop=new s("stop",{fontCharacter:"\\ea87"}),s.variable=new s("variable",{fontCharacter:"\\ea88"}),s.symbolVariable=new s("symbol-variable",{fontCharacter:"\\ea88"}),s.array=new s("array",{fontCharacter:"\\ea8a"}),s.symbolArray=new s("symbol-array",{fontCharacter:"\\ea8a"}),s.symbolModule=new s("symbol-module",{fontCharacter:"\\ea8b"}),s.symbolPackage=new s("symbol-package",{fontCharacter:"\\ea8b"}),s.symbolNamespace=new s("symbol-namespace",{fontCharacter:"\\ea8b"}),s.symbolObject=new s("symbol-object",{fontCharacter:"\\ea8b"}),s.symbolMethod=new s("symbol-method",{fontCharacter:"\\ea8c"}),s.symbolFunction=new s("symbol-function",{fontCharacter:"\\ea8c"}),s.symbolConstructor=new s("symbol-constructor",{fontCharacter:"\\ea8c"}),s.symbolBoolean=new s("symbol-boolean",{fontCharacter:"\\ea8f"}),s.symbolNull=new s("symbol-null",{fontCharacter:"\\ea8f"}),s.symbolNumeric=new s("symbol-numeric",{fontCharacter:"\\ea90"}),s.symbolNumber=new s("symbol-number",{fontCharacter:"\\ea90"}),s.symbolStructure=new s("symbol-structure",{fontCharacter:"\\ea91"}),s.symbolStruct=new s("symbol-struct",{fontCharacter:"\\ea91"}),s.symbolParameter=new s("symbol-parameter",{fontCharacter:"\\ea92"}),s.symbolTypeParameter=new s("symbol-type-parameter",{fontCharacter:"\\ea92"}),s.symbolKey=new s("symbol-key",{fontCharacter:"\\ea93"}),s.symbolText=new s("symbol-text",{fontCharacter:"\\ea93"}),s.symbolReference=new s("symbol-reference",{fontCharacter:"\\ea94"}),s.goToFile=new s("go-to-file",{fontCharacter:"\\ea94"}),s.symbolEnum=new s("symbol-enum",{fontCharacter:"\\ea95"}),s.symbolValue=new s("symbol-value",{fontCharacter:"\\ea95"}),s.symbolRuler=new s("symbol-ruler",{fontCharacter:"\\ea96"}),s.symbolUnit=new s("symbol-unit",{fontCharacter:"\\ea96"}),s.activateBreakpoints=new s("activate-breakpoints",{fontCharacter:"\\ea97"}),s.archive=new s("archive",{fontCharacter:"\\ea98"}),s.arrowBoth=new s("arrow-both",{fontCharacter:"\\ea99"}),s.arrowDown=new s("arrow-down",{fontCharacter:"\\ea9a"}),s.arrowLeft=new s("arrow-left",{fontCharacter:"\\ea9b"}),s.arrowRight=new s("arrow-right",{fontCharacter:"\\ea9c"}),s.arrowSmallDown=new s("arrow-small-down",{fontCharacter:"\\ea9d"}),s.arrowSmallLeft=new s("arrow-small-left",{fontCharacter:"\\ea9e"}),s.arrowSmallRight=new s("arrow-small-right",{fontCharacter:"\\ea9f"}),s.arrowSmallUp=new s("arrow-small-up",{fontCharacter:"\\eaa0"}),s.arrowUp=new s("arrow-up",{fontCharacter:"\\eaa1"}),s.bell=new s("bell",{fontCharacter:"\\eaa2"}),s.bold=new s("bold",{fontCharacter:"\\eaa3"}),s.book=new s("book",{fontCharacter:"\\eaa4"}),s.bookmark=new s("bookmark",{fontCharacter:"\\eaa5"}),s.debugBreakpointConditionalUnverified=new s("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),s.debugBreakpointConditional=new s("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),s.debugBreakpointConditionalDisabled=new s("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),s.debugBreakpointDataUnverified=new s("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),s.debugBreakpointData=new s("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),s.debugBreakpointDataDisabled=new s("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),s.debugBreakpointLogUnverified=new s("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),s.debugBreakpointLog=new s("debug-breakpoint-log",{fontCharacter:"\\eaab"}),s.debugBreakpointLogDisabled=new s("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),s.briefcase=new s("briefcase",{fontCharacter:"\\eaac"}),s.broadcast=new s("broadcast",{fontCharacter:"\\eaad"}),s.browser=new s("browser",{fontCharacter:"\\eaae"}),s.bug=new s("bug",{fontCharacter:"\\eaaf"}),s.calendar=new s("calendar",{fontCharacter:"\\eab0"}),s.caseSensitive=new s("case-sensitive",{fontCharacter:"\\eab1"}),s.check=new s("check",{fontCharacter:"\\eab2"}),s.checklist=new s("checklist",{fontCharacter:"\\eab3"}),s.chevronDown=new s("chevron-down",{fontCharacter:"\\eab4"}),s.chevronLeft=new s("chevron-left",{fontCharacter:"\\eab5"}),s.chevronRight=new s("chevron-right",{fontCharacter:"\\eab6"}),s.chevronUp=new s("chevron-up",{fontCharacter:"\\eab7"}),s.chromeClose=new s("chrome-close",{fontCharacter:"\\eab8"}),s.chromeMaximize=new s("chrome-maximize",{fontCharacter:"\\eab9"}),s.chromeMinimize=new s("chrome-minimize",{fontCharacter:"\\eaba"}),s.chromeRestore=new s("chrome-restore",{fontCharacter:"\\eabb"}),s.circleOutline=new s("circle-outline",{fontCharacter:"\\eabc"}),s.debugBreakpointUnverified=new s("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),s.circleSlash=new s("circle-slash",{fontCharacter:"\\eabd"}),s.circuitBoard=new s("circuit-board",{fontCharacter:"\\eabe"}),s.clearAll=new s("clear-all",{fontCharacter:"\\eabf"}),s.clippy=new s("clippy",{fontCharacter:"\\eac0"}),s.closeAll=new s("close-all",{fontCharacter:"\\eac1"}),s.cloudDownload=new s("cloud-download",{fontCharacter:"\\eac2"}),s.cloudUpload=new s("cloud-upload",{fontCharacter:"\\eac3"}),s.code=new s("code",{fontCharacter:"\\eac4"}),s.collapseAll=new s("collapse-all",{fontCharacter:"\\eac5"}),s.colorMode=new s("color-mode",{fontCharacter:"\\eac6"}),s.commentDiscussion=new s("comment-discussion",{fontCharacter:"\\eac7"}),s.compareChanges=new s("compare-changes",{fontCharacter:"\\eafd"}),s.creditCard=new s("credit-card",{fontCharacter:"\\eac9"}),s.dash=new s("dash",{fontCharacter:"\\eacc"}),s.dashboard=new s("dashboard",{fontCharacter:"\\eacd"}),s.database=new s("database",{fontCharacter:"\\eace"}),s.debugContinue=new s("debug-continue",{fontCharacter:"\\eacf"}),s.debugDisconnect=new s("debug-disconnect",{fontCharacter:"\\ead0"}),s.debugPause=new s("debug-pause",{fontCharacter:"\\ead1"}),s.debugRestart=new s("debug-restart",{fontCharacter:"\\ead2"}),s.debugStart=new s("debug-start",{fontCharacter:"\\ead3"}),s.debugStepInto=new s("debug-step-into",{fontCharacter:"\\ead4"}),s.debugStepOut=new s("debug-step-out",{fontCharacter:"\\ead5"}),s.debugStepOver=new s("debug-step-over",{fontCharacter:"\\ead6"}),s.debugStop=new s("debug-stop",{fontCharacter:"\\ead7"}),s.debug=new s("debug",{fontCharacter:"\\ead8"}),s.deviceCameraVideo=new s("device-camera-video",{fontCharacter:"\\ead9"}),s.deviceCamera=new s("device-camera",{fontCharacter:"\\eada"}),s.deviceMobile=new s("device-mobile",{fontCharacter:"\\eadb"}),s.diffAdded=new s("diff-added",{fontCharacter:"\\eadc"}),s.diffIgnored=new s("diff-ignored",{fontCharacter:"\\eadd"}),s.diffModified=new s("diff-modified",{fontCharacter:"\\eade"}),s.diffRemoved=new s("diff-removed",{fontCharacter:"\\eadf"}),s.diffRenamed=new s("diff-renamed",{fontCharacter:"\\eae0"}),s.diff=new s("diff",{fontCharacter:"\\eae1"}),s.discard=new s("discard",{fontCharacter:"\\eae2"}),s.editorLayout=new s("editor-layout",{fontCharacter:"\\eae3"}),s.emptyWindow=new s("empty-window",{fontCharacter:"\\eae4"}),s.exclude=new s("exclude",{fontCharacter:"\\eae5"}),s.extensions=new s("extensions",{fontCharacter:"\\eae6"}),s.eyeClosed=new s("eye-closed",{fontCharacter:"\\eae7"}),s.fileBinary=new s("file-binary",{fontCharacter:"\\eae8"}),s.fileCode=new s("file-code",{fontCharacter:"\\eae9"}),s.fileMedia=new s("file-media",{fontCharacter:"\\eaea"}),s.filePdf=new s("file-pdf",{fontCharacter:"\\eaeb"}),s.fileSubmodule=new s("file-submodule",{fontCharacter:"\\eaec"}),s.fileSymlinkDirectory=new s("file-symlink-directory",{fontCharacter:"\\eaed"}),s.fileSymlinkFile=new s("file-symlink-file",{fontCharacter:"\\eaee"}),s.fileZip=new s("file-zip",{fontCharacter:"\\eaef"}),s.files=new s("files",{fontCharacter:"\\eaf0"}),s.filter=new s("filter",{fontCharacter:"\\eaf1"}),s.flame=new s("flame",{fontCharacter:"\\eaf2"}),s.foldDown=new s("fold-down",{fontCharacter:"\\eaf3"}),s.foldUp=new s("fold-up",{fontCharacter:"\\eaf4"}),s.fold=new s("fold",{fontCharacter:"\\eaf5"}),s.folderActive=new s("folder-active",{fontCharacter:"\\eaf6"}),s.folderOpened=new s("folder-opened",{fontCharacter:"\\eaf7"}),s.gear=new s("gear",{fontCharacter:"\\eaf8"}),s.gift=new s("gift",{fontCharacter:"\\eaf9"}),s.gistSecret=new s("gist-secret",{fontCharacter:"\\eafa"}),s.gist=new s("gist",{fontCharacter:"\\eafb"}),s.gitCommit=new s("git-commit",{fontCharacter:"\\eafc"}),s.gitCompare=new s("git-compare",{fontCharacter:"\\eafd"}),s.gitMerge=new s("git-merge",{fontCharacter:"\\eafe"}),s.githubAction=new s("github-action",{fontCharacter:"\\eaff"}),s.githubAlt=new s("github-alt",{fontCharacter:"\\eb00"}),s.globe=new s("globe",{fontCharacter:"\\eb01"}),s.grabber=new s("grabber",{fontCharacter:"\\eb02"}),s.graph=new s("graph",{fontCharacter:"\\eb03"}),s.gripper=new s("gripper",{fontCharacter:"\\eb04"}),s.heart=new s("heart",{fontCharacter:"\\eb05"}),s.home=new s("home",{fontCharacter:"\\eb06"}),s.horizontalRule=new s("horizontal-rule",{fontCharacter:"\\eb07"}),s.hubot=new s("hubot",{fontCharacter:"\\eb08"}),s.inbox=new s("inbox",{fontCharacter:"\\eb09"}),s.issueClosed=new s("issue-closed",{fontCharacter:"\\eb0a"}),s.issueReopened=new s("issue-reopened",{fontCharacter:"\\eb0b"}),s.issues=new s("issues",{fontCharacter:"\\eb0c"}),s.italic=new s("italic",{fontCharacter:"\\eb0d"}),s.jersey=new s("jersey",{fontCharacter:"\\eb0e"}),s.json=new s("json",{fontCharacter:"\\eb0f"}),s.kebabVertical=new s("kebab-vertical",{fontCharacter:"\\eb10"}),s.key=new s("key",{fontCharacter:"\\eb11"}),s.law=new s("law",{fontCharacter:"\\eb12"}),s.lightbulbAutofix=new s("lightbulb-autofix",{fontCharacter:"\\eb13"}),s.linkExternal=new s("link-external",{fontCharacter:"\\eb14"}),s.link=new s("link",{fontCharacter:"\\eb15"}),s.listOrdered=new s("list-ordered",{fontCharacter:"\\eb16"}),s.listUnordered=new s("list-unordered",{fontCharacter:"\\eb17"}),s.liveShare=new s("live-share",{fontCharacter:"\\eb18"}),s.loading=new s("loading",{fontCharacter:"\\eb19"}),s.location=new s("location",{fontCharacter:"\\eb1a"}),s.mailRead=new s("mail-read",{fontCharacter:"\\eb1b"}),s.mail=new s("mail",{fontCharacter:"\\eb1c"}),s.markdown=new s("markdown",{fontCharacter:"\\eb1d"}),s.megaphone=new s("megaphone",{fontCharacter:"\\eb1e"}),s.mention=new s("mention",{fontCharacter:"\\eb1f"}),s.milestone=new s("milestone",{fontCharacter:"\\eb20"}),s.mortarBoard=new s("mortar-board",{fontCharacter:"\\eb21"}),s.move=new s("move",{fontCharacter:"\\eb22"}),s.multipleWindows=new s("multiple-windows",{fontCharacter:"\\eb23"}),s.mute=new s("mute",{fontCharacter:"\\eb24"}),s.noNewline=new s("no-newline",{fontCharacter:"\\eb25"}),s.note=new s("note",{fontCharacter:"\\eb26"}),s.octoface=new s("octoface",{fontCharacter:"\\eb27"}),s.openPreview=new s("open-preview",{fontCharacter:"\\eb28"}),s.package_=new s("package",{fontCharacter:"\\eb29"}),s.paintcan=new s("paintcan",{fontCharacter:"\\eb2a"}),s.pin=new s("pin",{fontCharacter:"\\eb2b"}),s.play=new s("play",{fontCharacter:"\\eb2c"}),s.run=new s("run",{fontCharacter:"\\eb2c"}),s.plug=new s("plug",{fontCharacter:"\\eb2d"}),s.preserveCase=new s("preserve-case",{fontCharacter:"\\eb2e"}),s.preview=new s("preview",{fontCharacter:"\\eb2f"}),s.project=new s("project",{fontCharacter:"\\eb30"}),s.pulse=new s("pulse",{fontCharacter:"\\eb31"}),s.question=new s("question",{fontCharacter:"\\eb32"}),s.quote=new s("quote",{fontCharacter:"\\eb33"}),s.radioTower=new s("radio-tower",{fontCharacter:"\\eb34"}),s.reactions=new s("reactions",{fontCharacter:"\\eb35"}),s.references=new s("references",{fontCharacter:"\\eb36"}),s.refresh=new s("refresh",{fontCharacter:"\\eb37"}),s.regex=new s("regex",{fontCharacter:"\\eb38"}),s.remoteExplorer=new s("remote-explorer",{fontCharacter:"\\eb39"}),s.remote=new s("remote",{fontCharacter:"\\eb3a"}),s.remove=new s("remove",{fontCharacter:"\\eb3b"}),s.replaceAll=new s("replace-all",{fontCharacter:"\\eb3c"}),s.replace=new s("replace",{fontCharacter:"\\eb3d"}),s.repoClone=new s("repo-clone",{fontCharacter:"\\eb3e"}),s.repoForcePush=new s("repo-force-push",{fontCharacter:"\\eb3f"}),s.repoPull=new s("repo-pull",{fontCharacter:"\\eb40"}),s.repoPush=new s("repo-push",{fontCharacter:"\\eb41"}),s.report=new s("report",{fontCharacter:"\\eb42"}),s.requestChanges=new s("request-changes",{fontCharacter:"\\eb43"}),s.rocket=new s("rocket",{fontCharacter:"\\eb44"}),s.rootFolderOpened=new s("root-folder-opened",{fontCharacter:"\\eb45"}),s.rootFolder=new s("root-folder",{fontCharacter:"\\eb46"}),s.rss=new s("rss",{fontCharacter:"\\eb47"}),s.ruby=new s("ruby",{fontCharacter:"\\eb48"}),s.saveAll=new s("save-all",{fontCharacter:"\\eb49"}),s.saveAs=new s("save-as",{fontCharacter:"\\eb4a"}),s.save=new s("save",{fontCharacter:"\\eb4b"}),s.screenFull=new s("screen-full",{fontCharacter:"\\eb4c"}),s.screenNormal=new s("screen-normal",{fontCharacter:"\\eb4d"}),s.searchStop=new s("search-stop",{fontCharacter:"\\eb4e"}),s.server=new s("server",{fontCharacter:"\\eb50"}),s.settingsGear=new s("settings-gear",{fontCharacter:"\\eb51"}),s.settings=new s("settings",{fontCharacter:"\\eb52"}),s.shield=new s("shield",{fontCharacter:"\\eb53"}),s.smiley=new s("smiley",{fontCharacter:"\\eb54"}),s.sortPrecedence=new s("sort-precedence",{fontCharacter:"\\eb55"}),s.splitHorizontal=new s("split-horizontal",{fontCharacter:"\\eb56"}),s.splitVertical=new s("split-vertical",{fontCharacter:"\\eb57"}),s.squirrel=new s("squirrel",{fontCharacter:"\\eb58"}),s.starFull=new s("star-full",{fontCharacter:"\\eb59"}),s.starHalf=new s("star-half",{fontCharacter:"\\eb5a"}),s.symbolClass=new s("symbol-class",{fontCharacter:"\\eb5b"}),s.symbolColor=new s("symbol-color",{fontCharacter:"\\eb5c"}),s.symbolConstant=new s("symbol-constant",{fontCharacter:"\\eb5d"}),s.symbolEnumMember=new s("symbol-enum-member",{fontCharacter:"\\eb5e"}),s.symbolField=new s("symbol-field",{fontCharacter:"\\eb5f"}),s.symbolFile=new s("symbol-file",{fontCharacter:"\\eb60"}),s.symbolInterface=new s("symbol-interface",{fontCharacter:"\\eb61"}),s.symbolKeyword=new s("symbol-keyword",{fontCharacter:"\\eb62"}),s.symbolMisc=new s("symbol-misc",{fontCharacter:"\\eb63"}),s.symbolOperator=new s("symbol-operator",{fontCharacter:"\\eb64"}),s.symbolProperty=new s("symbol-property",{fontCharacter:"\\eb65"}),s.wrench=new s("wrench",{fontCharacter:"\\eb65"}),s.wrenchSubaction=new s("wrench-subaction",{fontCharacter:"\\eb65"}),s.symbolSnippet=new s("symbol-snippet",{fontCharacter:"\\eb66"}),s.tasklist=new s("tasklist",{fontCharacter:"\\eb67"}),s.telescope=new s("telescope",{fontCharacter:"\\eb68"}),s.textSize=new s("text-size",{fontCharacter:"\\eb69"}),s.threeBars=new s("three-bars",{fontCharacter:"\\eb6a"}),s.thumbsdown=new s("thumbsdown",{fontCharacter:"\\eb6b"}),s.thumbsup=new s("thumbsup",{fontCharacter:"\\eb6c"}),s.tools=new s("tools",{fontCharacter:"\\eb6d"}),s.triangleDown=new s("triangle-down",{fontCharacter:"\\eb6e"}),s.triangleLeft=new s("triangle-left",{fontCharacter:"\\eb6f"}),s.triangleRight=new s("triangle-right",{fontCharacter:"\\eb70"}),s.triangleUp=new s("triangle-up",{fontCharacter:"\\eb71"}),s.twitter=new s("twitter",{fontCharacter:"\\eb72"}),s.unfold=new s("unfold",{fontCharacter:"\\eb73"}),s.unlock=new s("unlock",{fontCharacter:"\\eb74"}),s.unmute=new s("unmute",{fontCharacter:"\\eb75"}),s.unverified=new s("unverified",{fontCharacter:"\\eb76"}),s.verified=new s("verified",{fontCharacter:"\\eb77"}),s.versions=new s("versions",{fontCharacter:"\\eb78"}),s.vmActive=new s("vm-active",{fontCharacter:"\\eb79"}),s.vmOutline=new s("vm-outline",{fontCharacter:"\\eb7a"}),s.vmRunning=new s("vm-running",{fontCharacter:"\\eb7b"}),s.watch=new s("watch",{fontCharacter:"\\eb7c"}),s.whitespace=new s("whitespace",{fontCharacter:"\\eb7d"}),s.wholeWord=new s("whole-word",{fontCharacter:"\\eb7e"}),s.window=new s("window",{fontCharacter:"\\eb7f"}),s.wordWrap=new s("word-wrap",{fontCharacter:"\\eb80"}),s.zoomIn=new s("zoom-in",{fontCharacter:"\\eb81"}),s.zoomOut=new s("zoom-out",{fontCharacter:"\\eb82"}),s.listFilter=new s("list-filter",{fontCharacter:"\\eb83"}),s.listFlat=new s("list-flat",{fontCharacter:"\\eb84"}),s.listSelection=new s("list-selection",{fontCharacter:"\\eb85"}),s.selection=new s("selection",{fontCharacter:"\\eb85"}),s.listTree=new s("list-tree",{fontCharacter:"\\eb86"}),s.debugBreakpointFunctionUnverified=new s("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),s.debugBreakpointFunction=new s("debug-breakpoint-function",{fontCharacter:"\\eb88"}),s.debugBreakpointFunctionDisabled=new s("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),s.debugStackframeActive=new s("debug-stackframe-active",{fontCharacter:"\\eb89"}),s.debugStackframeDot=new s("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),s.debugStackframe=new s("debug-stackframe",{fontCharacter:"\\eb8b"}),s.debugStackframeFocused=new s("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),s.debugBreakpointUnsupported=new s("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),s.symbolString=new s("symbol-string",{fontCharacter:"\\eb8d"}),s.debugReverseContinue=new s("debug-reverse-continue",{fontCharacter:"\\eb8e"}),s.debugStepBack=new s("debug-step-back",{fontCharacter:"\\eb8f"}),s.debugRestartFrame=new s("debug-restart-frame",{fontCharacter:"\\eb90"}),s.callIncoming=new s("call-incoming",{fontCharacter:"\\eb92"}),s.callOutgoing=new s("call-outgoing",{fontCharacter:"\\eb93"}),s.menu=new s("menu",{fontCharacter:"\\eb94"}),s.expandAll=new s("expand-all",{fontCharacter:"\\eb95"}),s.feedback=new s("feedback",{fontCharacter:"\\eb96"}),s.groupByRefType=new s("group-by-ref-type",{fontCharacter:"\\eb97"}),s.ungroupByRefType=new s("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),s.account=new s("account",{fontCharacter:"\\eb99"}),s.bellDot=new s("bell-dot",{fontCharacter:"\\eb9a"}),s.debugConsole=new s("debug-console",{fontCharacter:"\\eb9b"}),s.library=new s("library",{fontCharacter:"\\eb9c"}),s.output=new s("output",{fontCharacter:"\\eb9d"}),s.runAll=new s("run-all",{fontCharacter:"\\eb9e"}),s.syncIgnored=new s("sync-ignored",{fontCharacter:"\\eb9f"}),s.pinned=new s("pinned",{fontCharacter:"\\eba0"}),s.githubInverted=new s("github-inverted",{fontCharacter:"\\eba1"}),s.debugAlt=new s("debug-alt",{fontCharacter:"\\eb91"}),s.serverProcess=new s("server-process",{fontCharacter:"\\eba2"}),s.serverEnvironment=new s("server-environment",{fontCharacter:"\\eba3"}),s.pass=new s("pass",{fontCharacter:"\\eba4"}),s.stopCircle=new s("stop-circle",{fontCharacter:"\\eba5"}),s.playCircle=new s("play-circle",{fontCharacter:"\\eba6"}),s.record=new s("record",{fontCharacter:"\\eba7"}),s.debugAltSmall=new s("debug-alt-small",{fontCharacter:"\\eba8"}),s.vmConnect=new s("vm-connect",{fontCharacter:"\\eba9"}),s.cloud=new s("cloud",{fontCharacter:"\\ebaa"}),s.merge=new s("merge",{fontCharacter:"\\ebab"}),s.exportIcon=new s("export",{fontCharacter:"\\ebac"}),s.graphLeft=new s("graph-left",{fontCharacter:"\\ebad"}),s.magnet=new s("magnet",{fontCharacter:"\\ebae"}),s.notebook=new s("notebook",{fontCharacter:"\\ebaf"}),s.redo=new s("redo",{fontCharacter:"\\ebb0"}),s.checkAll=new s("check-all",{fontCharacter:"\\ebb1"}),s.pinnedDirty=new s("pinned-dirty",{fontCharacter:"\\ebb2"}),s.passFilled=new s("pass-filled",{fontCharacter:"\\ebb3"}),s.circleLargeFilled=new s("circle-large-filled",{fontCharacter:"\\ebb4"}),s.circleLargeOutline=new s("circle-large-outline",{fontCharacter:"\\ebb5"}),s.combine=new s("combine",{fontCharacter:"\\ebb6"}),s.gather=new s("gather",{fontCharacter:"\\ebb6"}),s.table=new s("table",{fontCharacter:"\\ebb7"}),s.variableGroup=new s("variable-group",{fontCharacter:"\\ebb8"}),s.typeHierarchy=new s("type-hierarchy",{fontCharacter:"\\ebb9"}),s.typeHierarchySub=new s("type-hierarchy-sub",{fontCharacter:"\\ebba"}),s.typeHierarchySuper=new s("type-hierarchy-super",{fontCharacter:"\\ebbb"}),s.gitPullRequestCreate=new s("git-pull-request-create",{fontCharacter:"\\ebbc"}),s.runAbove=new s("run-above",{fontCharacter:"\\ebbd"}),s.runBelow=new s("run-below",{fontCharacter:"\\ebbe"}),s.notebookTemplate=new s("notebook-template",{fontCharacter:"\\ebbf"}),s.debugRerun=new s("debug-rerun",{fontCharacter:"\\ebc0"}),s.workspaceTrusted=new s("workspace-trusted",{fontCharacter:"\\ebc1"}),s.workspaceUntrusted=new s("workspace-untrusted",{fontCharacter:"\\ebc2"}),s.workspaceUnspecified=new s("workspace-unspecified",{fontCharacter:"\\ebc3"}),s.terminalCmd=new s("terminal-cmd",{fontCharacter:"\\ebc4"}),s.terminalDebian=new s("terminal-debian",{fontCharacter:"\\ebc5"}),s.terminalLinux=new s("terminal-linux",{fontCharacter:"\\ebc6"}),s.terminalPowershell=new s("terminal-powershell",{fontCharacter:"\\ebc7"}),s.terminalTmux=new s("terminal-tmux",{fontCharacter:"\\ebc8"}),s.terminalUbuntu=new s("terminal-ubuntu",{fontCharacter:"\\ebc9"}),s.terminalBash=new s("terminal-bash",{fontCharacter:"\\ebca"}),s.arrowSwap=new s("arrow-swap",{fontCharacter:"\\ebcb"}),s.copy=new s("copy",{fontCharacter:"\\ebcc"}),s.personAdd=new s("person-add",{fontCharacter:"\\ebcd"}),s.filterFilled=new s("filter-filled",{fontCharacter:"\\ebce"}),s.wand=new s("wand",{fontCharacter:"\\ebcf"}),s.debugLineByLine=new s("debug-line-by-line",{fontCharacter:"\\ebd0"}),s.dropDownButton=new s("drop-down-button",s.chevronDown.definition)}(k=e.Codicon||(e.Codicon={}))}),define(ge[95],pe([0,1,18,6]),function(K,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function T(d){const l=d;return l?[l.on,l.pause,l.resume,l.destroy].every(f=>typeof f=="function"):!1}e.isReadableStream=T;function A(d){const l=d;return l?T(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=A;function y(d,l){return new k(d,l)}e.newWriteableStream=y;class k{constructor(l,f){this.reducer=l,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){var f;if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof((f=this.options)===null||f===void 0?void 0:f.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(f=>f(l))}emitError(l){this.listeners.error.length===0?(0,_.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(f=>f(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,f){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(l,f){if(!this.state.destroyed){let t;switch(l){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(f);n>=0&&t.splice(n,1)}}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(d,l){const f=[];let t;for(;(t=d.read())!==null;)f.push(t);return l(f)}e.consumeReadable=D;function P(d,l,f){const t=[];let n;for(;(n=d.read())!==null&&t.length<f;)t.push(n);return n===null&&t.length>0?l(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const r=n;return n=void 0,r}return d.read()}}}e.peekReadable=P;function s(d,l){return new Promise((f,t)=>{const n=[];C(d,{onData:r=>{l&&n.push(r)},onError:r=>{l?t(r):f(void 0)},onEnd:()=>{f(l?l(n):void 0)}})})}e.consumeStream=s;function C(d,l){d.on("error",f=>l.onError(f)),d.on("end",()=>l.onEnd()),d.on("data",f=>l.onData(f))}e.listenStream=C;function g(d,l){return new Promise((f,t)=>{const n=new I.DisposableStore,r=[],i=v=>{if(r.push(v),r.length>l)return n.dispose(),d.pause(),f({stream:d,buffer:r,ended:!1})},o=v=>t(v),c=()=>f({stream:d,buffer:r,ended:!0});n.add((0,I.toDisposable)(()=>d.removeListener("error",o))),d.on("error",o),n.add((0,I.toDisposable)(()=>d.removeListener("end",c))),d.on("end",c),n.add((0,I.toDisposable)(()=>d.removeListener("data",i))),d.on("data",i)})}e.peekStream=g;function m(d,l){const f=y(l);return f.end(d),f}e.toStream=m;function a(){const d=y(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=a;function u(d){let l=!1;return{read:()=>l?null:(l=!0,d)}}e.toReadable=u;function E(d,l,f){const t=y(f);return C(d,{onData:n=>t.write(l.data(n)),onError:n=>t.error(l.error?l.error(n):n),onEnd:()=>t.end()}),t}e.transform=E;function w(d,l,f){let t=!1;return{read:()=>{const n=l.read();return t?n:(t=!0,n!==null?f([d,n]):d)}}}e.prefixedReadable=w;function S(d,l,f){let t=!1;const n=y(f);return C(l,{onData:r=>t?n.write(r):(t=!0,n.write(f([d,r]))),onError:r=>n.error(r),onEnd:()=>{t||(t=!0,n.write(d)),n.end()}}),n}e.prefixedStream=S}),define(ge[9],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function _(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=_;const I=/{(\d+)}/g;function T(G,...re){return re.length===0?G:G.replace(I,function(he,J){const ne=parseInt(J,10);return isNaN(ne)||ne<0||ne>=re.length?he:re[ne]})}e.format=T;function A(G){return G.replace(/[<>&]/g,function(re){switch(re){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return re}})}e.escape=A;function y(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function k(G,re){let he=0;const J=re.charCodeAt(0);for(let ne=G.length-1;ne>=0;ne--)G.charCodeAt(ne)===J&&he++;return he}e.count=k;function D(G,re,he="\u2026"){return G.length<=re?G:`${G.substr(0,re)}${he}`}e.truncate=D;function P(G,re=" "){const he=s(G,re);return C(he,re)}e.trim=P;function s(G,re){if(!G||!re)return G;const he=re.length;if(he===0||G.length===0)return G;let J=0;for(;G.indexOf(re,J)===J;)J=J+he;return G.substring(J)}e.ltrim=s;function C(G,re){if(!G||!re)return G;const he=re.length,J=G.length;if(he===0||J===0)return G;let ne=J,ce=-1;for(;ce=G.lastIndexOf(re,ne-1),!(ce===-1||ce+he!==ne);){if(ce===0)return"";ne=ce}return G.substring(0,ne)}e.rtrim=C;function g(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function m(G){return G.replace(/\*/g,"")}e.stripWildcards=m;function a(G,re,he={}){if(!G)throw new Error("Cannot create regex from empty string");re||(G=y(G)),he.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let J="";return he.global&&(J+="g"),he.matchCase||(J+="i"),he.multiline&&(J+="m"),he.unicode&&(J+="u"),new RegExp(G,J)}e.createRegExp=a;function u(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=u;function E(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function w(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=w;function S(G){return G.split(/\r\n|\r|\n/)}e.splitLines=S;function d(G){for(let re=0,he=G.length;re<he;re++){const J=G.charCodeAt(re);if(J!==32&&J!==9)return re}return-1}e.firstNonWhitespaceIndex=d;function l(G,re=0,he=G.length){for(let J=re;J<he;J++){const ne=G.charCodeAt(J);if(ne!==32&&ne!==9)return G.substring(re,J)}return G.substring(re,he)}e.getLeadingWhitespace=l;function f(G,re=G.length-1){for(let he=re;he>=0;he--){const J=G.charCodeAt(he);if(J!==32&&J!==9)return he}return-1}e.lastNonWhitespaceIndex=f;function t(G,re){return G<re?-1:G>re?1:0}e.compare=t;function n(G,re,he=0,J=G.length,ne=0,ce=re.length){for(;he<J&&ne<ce;he++,ne++){let je=G.charCodeAt(he),He=re.charCodeAt(ne);if(je<He)return-1;if(je>He)return 1}const ve=J-he,ye=ce-ne;return ve<ye?-1:ve>ye?1:0}e.compareSubstring=n;function r(G,re){return i(G,re,0,G.length,0,re.length)}e.compareIgnoreCase=r;function i(G,re,he=0,J=G.length,ne=0,ce=re.length){for(;he<J&&ne<ce;he++,ne++){let je=G.charCodeAt(he),He=re.charCodeAt(ne);if(je!==He){const We=je-He;if(!(We===32&&c(He))&&!(We===-32&&c(je)))return o(je)&&o(He)?We:n(G.toLowerCase(),re.toLowerCase(),he,J,ne,ce)}}const ve=J-he,ye=ce-ne;return ve<ye?-1:ve>ye?1:0}e.compareSubstringIgnoreCase=i;function o(G){return G>=97&&G<=122}e.isLowerAsciiLetter=o;function c(G){return G>=65&&G<=90}e.isUpperAsciiLetter=c;function v(G){return o(G)||c(G)}function p(G,re){return G.length===re.length&&h(G,re)}e.equalsIgnoreCase=p;function h(G,re,he=G.length){for(let J=0;J<he;J++){const ne=G.charCodeAt(J),ce=re.charCodeAt(J);if(ne!==ce){if(v(ne)&&v(ce)){const ve=Math.abs(ne-ce);if(ve!==0&&ve!==32)return!1}else if(String.fromCharCode(ne).toLowerCase()!==String.fromCharCode(ce).toLowerCase())return!1}}return!0}function b(G,re){const he=re.length;return re.length>G.length?!1:h(G,re,he)}e.startsWithIgnoreCase=b;function R(G,re){let he,J=Math.min(G.length,re.length);for(he=0;he<J;he++)if(G.charCodeAt(he)!==re.charCodeAt(he))return he;return J}e.commonPrefixLength=R;function N(G,re){let he,J=Math.min(G.length,re.length);const ne=G.length-1,ce=re.length-1;for(he=0;he<J;he++)if(G.charCodeAt(ne-he)!==re.charCodeAt(ce-he))return he;return J}e.commonSuffixLength=N;function j(G){return 55296<=G&&G<=56319}e.isHighSurrogate=j;function oe(G){return 56320<=G&&G<=57343}e.isLowSurrogate=oe;function q(G,re){return(G-55296<<10)+(re-56320)+65536}e.computeCodePoint=q;function W(G,re,he){const J=G.charCodeAt(he);if(j(J)&&he+1<re){const ne=G.charCodeAt(he+1);if(oe(ne))return q(J,ne)}return J}e.getNextCodePoint=W;function H(G,re){const he=G.charCodeAt(re-1);if(oe(he)&&re>1){const J=G.charCodeAt(re-2);if(j(J))return q(J,he)}return he}function U(G,re){const he=$e.getInstance(),J=re,ne=G.length,ce=W(G,ne,re);re+=ce>=65536?2:1;let ve=he.getGraphemeBreakType(ce);for(;re<ne;){const ye=W(G,ne,re),je=he.getGraphemeBreakType(ye);if(Ne(ve,je))break;re+=ye>=65536?2:1,ve=je}return re-J}e.nextCharLength=U;function L(G,re){const he=$e.getInstance(),J=re,ne=H(G,re);re-=ne>=65536?2:1;let ce=he.getGraphemeBreakType(ne);for(;re>0;){const ve=H(G,re),ye=he.getGraphemeBreakType(ve);if(Ne(ye,ce))break;re-=ve>=65536?2:1,ce=ye}return J-re}e.prevCharLength=L;function F(G,re){const he=$e.getInstance(),J=G.length,ne=re,ce=W(G,J,re),ve=he.getGraphemeBreakType(ce);re+=ce>=65536?2:1;let ye=ve;for(;re<J;){const He=W(G,J,re),We=he.getGraphemeBreakType(He);if(Ne(ye,We))break;re+=He>=65536?2:1,ye=We}const je=re;for(re=ne,ye=ve;re>0;){const He=H(G,re),We=he.getGraphemeBreakType(He);if(Ne(We,ye))break;re-=He>=65536?2:1,ye=We}return[re,je]}function O(G,re){return re>0&&oe(G.charCodeAt(re))?F(G,re-1):F(G,re)}e.getCharContainingOffset=O;function M(G){const re=G.length;let he=0,J=0;for(;J<re;){const ve=W(G,re,J);J+=ve>=65536?2:1,ve<128?he+=1:ve<2048?he+=2:ve<65536?he+=3:he+=4}const ne=new Uint8Array(he);J=0;let ce=0;for(;J<re;){const ve=W(G,re,J);J+=ve>=65536?2:1,ve<128?ne[ce++]=ve:ve<2048?(ne[ce++]=192|(ve&1984)>>>6,ne[ce++]=128|(ve&63)>>>0):ve<65536?(ne[ce++]=224|(ve&61440)>>>12,ne[ce++]=128|(ve&4032)>>>6,ne[ce++]=128|(ve&63)>>>0):(ne[ce++]=240|(ve&1835008)>>>18,ne[ce++]=128|(ve&258048)>>>12,ne[ce++]=128|(ve&4032)>>>6,ne[ce++]=128|(ve&63)>>>0)}return ne}e.encodeUTF8=M;function B(G){const re=G.byteLength,he=[];let J=0;for(;J<re;){const ne=G[J];let ce;if(ne>=240&&J+3<re?ce=(G[J++]&7)<<18>>>0|(G[J++]&63)<<12>>>0|(G[J++]&63)<<6>>>0|(G[J++]&63)<<0>>>0:ne>=224&&J+2<re?ce=(G[J++]&15)<<12>>>0|(G[J++]&63)<<6>>>0|(G[J++]&63)<<0>>>0:ne>=192&&J+1<re?ce=(G[J++]&31)<<6>>>0|(G[J++]&63)<<0>>>0:ce=G[J++],ce>=0&&ce<=55295||ce>=57344&&ce<=65535)he.push(String.fromCharCode(ce));else if(ce>=65536&&ce<=1114111){const ve=ce-65536,ye=55296+((ve&1047552)>>>10),je=56320+((ve&1023)>>>0);he.push(String.fromCharCode(ye)),he.push(String.fromCharCode(je))}else he.push(String.fromCharCode(65533))}return he.join("")}e.decodeUTF8=B;const V=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(G){return V.test(G)}e.containsRTL=Q;const de=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function we(G){return de.test(G)}e.containsEmoji=we;const Ie=/^[\t\n\r\x20-\x7E]*$/;function Ce(G){return Ie.test(G)}e.isBasicASCII=Ce,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Le(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=Le;function z(G){for(let re=0,he=G.length;re<he;re++)if(Y(G.charCodeAt(re)))return!0;return!1}e.containsFullWidthCharacter=z;function Y(G){return G=+G,G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=Y;function ee(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129003||G>=129280&&G<=129535||G>=129648&&G<=129750}e.isEmojiImprecise=ee;function le(G,re){if(G.length<re)return G;const he=/\b/g;let J=0;for(;he.test(G)&&!(G.length-he.lastIndex<re);)J=he.lastIndex,he.lastIndex+=1;return G.substring(J).replace(/^\s/,"")}e.lcut=le;const me=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function be(G){return G&&(G=G.replace(me,""),G=G.replace(De,""),G=G.replace(Oe,"")),G}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Pe(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Pe;function Re(G){return Pe(G)?G.substr(1):G}e.stripUTF8BOM=Re;function Be(G,re){if(!G||!re||G.length<re.length)return!1;const he=re.length,J=G.toLowerCase();let ne=0,ce=-1;for(;ne<he;){const ve=J.indexOf(re[ne],ce+1);if(ve<0)return!1;ce=ve,ne++}return!0}e.fuzzyContains=Be;function Se(G,re=!1){return G?(re&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=Se;function qe(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=qe;function X(G,re=1){if(re===0)return"";let he=-1;do he=G.indexOf(`
`,he+1),re--;while(re>0&&he>=0);return he===-1?G:(G[he-1]==="\r"&&he--,G.substr(0,he))}e.getNLines=X;function ie(G){const re=90-65+1;return G=G%(2*re),G<re?String.fromCharCode(97+G):String.fromCharCode(65+G-re)}e.singleLetterHash=ie;function _e(G){return $e.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=_e;function Ne(G,re){return G===0?re!==5&&re!==7:G===2&&re===3?!1:G===4||G===2||G===3||re===4||re===2||re===3?!0:!(G===8&&(re===8||re===9||re===11||re===12)||(G===11||G===9)&&(re===9||re===10)||(G===12||G===10)&&re===10||re===5||re===13||re===7||G===1||G===13&&re===14||G===6&&re===6)}e.breakBetweenGraphemeBreakType=Ne;var ze;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(ze=e.GraphemeBreakType||(e.GraphemeBreakType={}));class $e{constructor(){this._data=Je()}static getInstance(){return $e._INSTANCE||($e._INSTANCE=new $e),$e._INSTANCE}getGraphemeBreakType(re){if(re<32)return re===10?3:re===13?2:4;if(re<127)return 0;const he=this._data,J=he.length/3;let ne=1;for(;ne<=J;)if(re<he[3*ne])ne=2*ne;else if(re>he[3*ne+1])ne=2*ne+1;else return he[3*ne+2];return 0}}$e._INSTANCE=null;function Je(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(ge[22],pe([0,1,9,95]),function(K,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer!="undefined",A=typeof TextEncoder!="undefined",y=typeof TextDecoder!="undefined";let k,D;class P{constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}static alloc(v){return T?new P(Buffer.allocUnsafe(v)):new P(new Uint8Array(v))}static wrap(v){return T&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new P(v)}static fromString(v,p){return!((p==null?void 0:p.dontUseNodeBuffer)||!1)&&T?new P(Buffer.from(v)):A?(k||(k=new TextEncoder),new P(k.encode(v))):new P(_.encodeUTF8(v))}static concat(v,p){if(typeof p=="undefined"){p=0;for(let R=0,N=v.length;R<N;R++)p+=v[R].byteLength}const h=P.alloc(p);let b=0;for(let R=0,N=v.length;R<N;R++){const j=v[R];h.set(j,b),b+=j.byteLength}return h}toString(){return T?this.buffer.toString():y?(D||(D=new TextDecoder),D.decode(this.buffer)):_.decodeUTF8(this.buffer)}slice(v,p){return new P(this.buffer.subarray(v,p))}set(v,p){v instanceof P?this.buffer.set(v.buffer,p):this.buffer.set(v,p)}readUInt32BE(v){return g(this.buffer,v)}writeUInt32BE(v,p){m(this.buffer,v,p)}readUInt32LE(v){return a(this.buffer,v)}writeUInt32LE(v,p){u(this.buffer,v,p)}readUInt8(v){return E(this.buffer,v)}writeUInt8(v,p){w(this.buffer,v,p)}}e.VSBuffer=P;function s(c,v){return c[v+0]<<0>>>0|c[v+1]<<8>>>0}e.readUInt16LE=s;function C(c,v,p){c[p+0]=v&255,v=v>>>8,c[p+1]=v&255}e.writeUInt16LE=C;function g(c,v){return c[v]*2**24+c[v+1]*2**16+c[v+2]*2**8+c[v+3]}e.readUInt32BE=g;function m(c,v,p){c[p+3]=v,v=v>>>8,c[p+2]=v,v=v>>>8,c[p+1]=v,v=v>>>8,c[p]=v}e.writeUInt32BE=m;function a(c,v){return c[v+0]<<0>>>0|c[v+1]<<8>>>0|c[v+2]<<16>>>0|c[v+3]<<24>>>0}e.readUInt32LE=a;function u(c,v,p){c[p+0]=v&255,v=v>>>8,c[p+1]=v&255,v=v>>>8,c[p+2]=v&255,v=v>>>8,c[p+3]=v&255}e.writeUInt32LE=u;function E(c,v){return c[v]}e.readUInt8=E;function w(c,v,p){c[p]=v}e.writeUInt8=w;function S(c){return I.consumeReadable(c,v=>P.concat(v))}e.readableToBuffer=S;function d(c){return I.toReadable(c)}e.bufferToReadable=d;function l(c){return I.consumeStream(c,v=>P.concat(v))}e.streamToBuffer=l;async function f(c){return c.ended?P.concat(c.buffer):P.concat([...c.buffer,await l(c.stream)])}e.bufferedStreamToBuffer=f;function t(c){return I.toStream(c,v=>P.concat(v))}e.bufferToStream=t;function n(c){return I.transform(c,{data:v=>typeof v=="string"?P.fromString(v):P.wrap(v)},v=>P.concat(v))}e.streamToBufferReadableStream=n;function r(c){return I.newWriteableStream(v=>P.concat(v),c)}e.newWriteableBufferStream=r;function i(c,v){return I.prefixedReadable(c,v,p=>P.concat(p))}e.prefixedBufferReadable=i;function o(c,v){return I.prefixedStream(c,v,p=>P.concat(p))}e.prefixedBufferStream=o}),define(ge[74],pe([0,1,9]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function I(w){return T(w,0)}e.hash=I;function T(w,S){switch(typeof w){case"object":return w===null?A(349,S):Array.isArray(w)?D(w,S):P(w,S);case"string":return k(w,S);case"boolean":return y(w,S);case"number":return A(w,S);case"undefined":return A(937,S);default:return A(617,S)}}e.doHash=T;function A(w,S){return(S<<5)-S+w|0}function y(w,S){return A(w?433:863,S)}function k(w,S){S=A(149417,S);for(let d=0,l=w.length;d<l;d++)S=A(w.charCodeAt(d),S);return S}e.stringHash=k;function D(w,S){return S=A(104579,S),w.reduce((d,l)=>T(l,d),S)}function P(w,S){return S=A(181387,S),Object.keys(w).sort().reduce((d,l)=>(d=k(l,d),T(w[l],d)),S)}class s{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=T(S,this._value),this._value}}e.Hasher=s;var C;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function g(w,S,d=32){const l=d-S,f=~((1<<l)-1);return(w<<S|(f&w)>>>l)>>>0}function m(w,S=0,d=w.byteLength,l=0){for(let f=0;f<d;f++)w[S+f]=l}function a(w,S,d="0"){for(;w.length<S;)w=d+w;return w}function u(w,S=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(d=>d.toString(16).padStart(2,"0")).join(""):a((w>>>0).toString(16),S/4)}e.toHexString=u;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const d=S.length;if(d!==0){const l=this._buff;let f=this._buffLen,t=this._leftoverHighSurrogate,n,r;for(t!==0?(n=t,r=-1,t=0):(n=S.charCodeAt(0),r=0);;){let i=n;if(_.isHighSurrogate(n))if(r+1<d){const o=S.charCodeAt(r+1);_.isLowSurrogate(o)?(r++,i=_.computeCodePoint(n,o)):i=65533}else{t=n;break}else _.isLowSurrogate(n)&&(i=65533);if(f=this._push(l,f,i),r++,r<d)n=S.charCodeAt(r);else break}this._buffLen=f,this._leftoverHighSurrogate=t}}_push(S,d,l){return l<128?S[d++]=l:l<2048?(S[d++]=192|(l&1984)>>>6,S[d++]=128|(l&63)>>>0):l<65536?(S[d++]=224|(l&61440)>>>12,S[d++]=128|(l&4032)>>>6,S[d++]=128|(l&63)>>>0):(S[d++]=240|(l&1835008)>>>18,S[d++]=128|(l&258048)>>>12,S[d++]=128|(l&4032)>>>6,S[d++]=128|(l&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),u(this._h0)+u(this._h1)+u(this._h2)+u(this._h3)+u(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=E._bigBlock32,d=this._buffDV;for(let v=0;v<64;v+=4)S.setUint32(v,d.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)S.setUint32(v,g(S.getUint32(v-12,!1)^S.getUint32(v-32,!1)^S.getUint32(v-56,!1)^S.getUint32(v-64,!1),1),!1);let l=this._h0,f=this._h1,t=this._h2,n=this._h3,r=this._h4,i,o,c;for(let v=0;v<80;v++)v<20?(i=f&t|~f&n,o=1518500249):v<40?(i=f^t^n,o=1859775393):v<60?(i=f&t|f&n|t&n,o=2400959708):(i=f^t^n,o=3395469782),c=g(l,5)+i+r+o+S.getUint32(v*4,!1)&4294967295,r=n,n=t,t=g(f,30),f=l,l=c;this._h0=this._h0+l&4294967295,this._h1=this._h1+f&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ge[57],pe([0,1,9]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(I||(I={})),function(T){const A="error",y="warning",k="warn",D="info",P="ignore";function s(g){return g?_.equalsIgnoreCase(A,g)?T.Error:_.equalsIgnoreCase(y,g)||_.equalsIgnoreCase(k,g)?T.Warning:_.equalsIgnoreCase(D,g)?T.Info:T.Ignore:T.Ignore}T.fromValue=s;function C(g){switch(g){case T.Error:return A;case T.Warning:return y;case T.Info:return D;default:return P}}T.toString=C}(I||(I={})),e.default=I}),define(ge[11],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function _(v){return Array.isArray(v)}e.isArray=_;function I(v){return typeof v=="string"}e.isString=I;function T(v){return Array.isArray(v)&&v.every(p=>I(p))}e.isStringArray=T;function A(v){return typeof v=="object"&&v!==null&&!Array.isArray(v)&&!(v instanceof RegExp)&&!(v instanceof Date)}e.isObject=A;function y(v){return typeof v=="number"&&!isNaN(v)}e.isNumber=y;function k(v){return!!v&&typeof v[Symbol.iterator]=="function"}e.isIterable=k;function D(v){return v===!0||v===!1}e.isBoolean=D;function P(v){return typeof v=="undefined"}e.isUndefined=P;function s(v){return!C(v)}e.isDefined=s;function C(v){return P(v)||v===null}e.isUndefinedOrNull=C;function g(v,p){if(!v)throw new Error(p?`Unexpected type, expected '${p}'`:"Unexpected type")}e.assertType=g;function m(v){if(C(v))throw new Error("Assertion Failed: argument is undefined or null");return v}e.assertIsDefined=m;function a(...v){const p=[];for(let h=0;h<v.length;h++){const b=v[h];if(C(b))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);p.push(b)}return p}e.assertAllDefined=a;const u=Object.prototype.hasOwnProperty;function E(v){if(!A(v))return!1;for(let p in v)if(u.call(v,p))return!1;return!0}e.isEmptyObject=E;function w(v){return typeof v=="function"}e.isFunction=w;function S(...v){return v.length>0&&v.every(w)}e.areFunctions=S;function d(v,p){const h=Math.min(v.length,p.length);for(let b=0;b<h;b++)l(v[b],p[b])}e.validateConstraints=d;function l(v,p){if(I(p)){if(typeof v!==p)throw new Error(`argument does not match constraint: typeof ${p}`)}else if(w(p)){try{if(v instanceof p)return}catch(h){}if(!C(v)&&v.constructor===p||p.length===1&&p.call(void 0,v)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function f(v){let p=[],h=Object.getPrototypeOf(v);for(;Object.prototype!==h;)p=p.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return p}e.getAllPropertyNames=f;function t(v){const p=[];for(const h of f(v))typeof v[h]=="function"&&p.push(h);return p}e.getAllMethodNames=t;function n(v,p){const h=R=>function(){const N=Array.prototype.slice.call(arguments,0);return p(R,N)};let b={};for(const R of v)b[R]=h(R);return b}e.createProxyObject=n;function r(v){return v===null?void 0:v}e.withNullAsUndefined=r;function i(v){return typeof v=="undefined"?null:v}e.withUndefinedAsNull=i;function o(v){return class{constructor(){return new Proxy({},{get(p,h){if(p[h])return p[h];throw new Error(`Not Implemented: ${v}->${String(h)}`)}})}}}e.NotImplementedProxy=o;function c(v){throw new Error("Unreachable")}e.assertNever=c}),define(ge[29],pe([0,1,10,9,8,11]),function(K,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function y(n){return n===47||n===92}e.isPathSeparator=y;function k(n){return n.replace(/[\\/]/g,T.posix.sep)}e.toSlashes=k;function D(n,r=T.posix.sep){if(!n)return"";const i=n.length,o=n.charCodeAt(0);if(y(o)){if(y(n.charCodeAt(1))&&!y(n.charCodeAt(2))){let v=3;const p=v;for(;v<i&&!y(n.charCodeAt(v));v++);if(p!==v&&!y(n.charCodeAt(v+1))){for(v+=1;v<i;v++)if(y(n.charCodeAt(v)))return n.slice(0,v+1).replace(/[\\/]/g,r)}}return r}else if(E(o)&&n.charCodeAt(1)===58)return y(n.charCodeAt(2))?n.slice(0,2)+r:n.slice(0,2);let c=n.indexOf("://");if(c!==-1){for(c+=3;c<i;c++)if(y(n.charCodeAt(c)))return n.slice(0,c+1)}return""}e.getRoot=D;function P(n){if(!_.isWindows||!n||n.length<5)return!1;let r=n.charCodeAt(0);if(r!==92||(r=n.charCodeAt(1),r!==92))return!1;let i=2;const o=i;for(;i<n.length&&(r=n.charCodeAt(i),r!==92);i++);return!(o===i||(r=n.charCodeAt(i+1),isNaN(r)||r===92))}e.isUNC=P;const s=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(n,r=_.isWindows){const i=r?s:C;return!(!n||n.length===0||/^\s+$/.test(n)||(i.lastIndex=0,i.test(n))||r&&g.test(n)||n==="."||n===".."||r&&n[n.length-1]==="."||r&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=m;function a(n,r,i){const o=n===r;return!i||o?o:!n||!r?!1:(0,I.equalsIgnoreCase)(n,r)}e.isEqual=a;function u(n,r,i,o=T.sep){if(n===r)return!0;if(!n||!r||r.length>n.length)return!1;if(i){if(!(0,I.startsWithIgnoreCase)(n,r))return!1;if(r.length===n.length)return!0;let v=r.length;return r.charAt(r.length-1)===o&&v--,n.charAt(v)===o}return r.charAt(r.length-1)!==o&&(r+=o),n.indexOf(r)===0}e.isEqualOrParent=u;function E(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=E;function w(n,r){return _.isWindows&&n.endsWith(":")&&(n+=T.sep),(0,T.isAbsolute)(n)||(n=(0,T.join)(r,n)),n=(0,T.normalize)(n),_.isWindows?(n=(0,I.rtrim)(n,T.sep),n.endsWith(":")&&(n+=T.sep)):(n=(0,I.rtrim)(n,T.sep),n||(n=T.sep)),n}e.sanitizeFilePath=w;function S(n){const r=(0,T.normalize)(n);return _.isWindows?n.length>3?!1:d(r)&&(n.length===2||r.charCodeAt(2)===92):r===T.posix.sep}e.isRootOrDriveLetter=S;function d(n){return _.isWindows?E(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function l(n){return d(n)?n[0]:void 0}e.getDriveLetter=l;function f(n,r,i){return r.length>n.length?-1:n===r?0:(i&&(n=n.toLowerCase(),r=r.toLowerCase()),n.indexOf(r))}e.indexOfPath=f;function t(n){const r=n.split(":");let i,o,c;if(r.forEach(v=>{const p=Number(v);(0,A.isNumber)(p)?o===void 0?o=p:c===void 0&&(c=p):i=i?[i,v].join(":"):v}),!i)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:i,line:o!==void 0?o:void 0,column:c!==void 0?c:o!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(ge[23],pe([0,1,11]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function I(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const u=Array.isArray(a)?[]:{};return Object.keys(a).forEach(E=>{a[E]&&typeof a[E]=="object"?u[E]=I(a[E]):u[E]=a[E]}),u}e.deepClone=I;function T(a){if(!a||typeof a!="object")return a;const u=[a];for(;u.length>0;){const E=u.shift();Object.freeze(E);for(const w in E)if(A.call(E,w)){const S=E[w];typeof S=="object"&&!Object.isFrozen(S)&&u.push(S)}}return a}e.deepFreeze=T;const A=Object.prototype.hasOwnProperty;function y(a,u){return k(a,u,new Set)}e.cloneAndChange=y;function k(a,u,E){if((0,_.isUndefinedOrNull)(a))return a;const w=u(a);if(typeof w!="undefined")return w;if((0,_.isArray)(a)){const S=[];for(const d of a)S.push(k(d,u,E));return S}if((0,_.isObject)(a)){if(E.has(a))throw new Error("Cannot clone recursive data-structure");E.add(a);const S={};for(let d in a)A.call(a,d)&&(S[d]=k(a[d],u,E));return E.delete(a),S}return a}function D(a,u,E=!0){return(0,_.isObject)(a)?((0,_.isObject)(u)&&Object.keys(u).forEach(w=>{w in a?E&&((0,_.isObject)(a[w])&&(0,_.isObject)(u[w])?D(a[w],u[w],E):a[w]=u[w]):a[w]=u[w]}),a):u}e.mixin=D;function P(a,u){if(a===u)return!0;if(a==null||u===null||u===void 0||typeof a!=typeof u||typeof a!="object"||Array.isArray(a)!==Array.isArray(u))return!1;let E,w;if(Array.isArray(a)){if(a.length!==u.length)return!1;for(E=0;E<a.length;E++)if(!P(a[E],u[E]))return!1}else{const S=[];for(w in a)S.push(w);S.sort();const d=[];for(w in u)d.push(w);if(d.sort(),!P(S,d))return!1;for(E=0;E<S.length;E++)if(!P(a[S[E]],u[S[E]]))return!1}return!0}e.equals=P;function s(a){const u=new Set;return JSON.stringify(a,(E,w)=>{if((0,_.isObject)(w)||Array.isArray(w)){if(u.has(w))return"[Circular]";u.add(w)}return w})}e.safeStringify=s;function C(a,u,E){const w=u(a);return typeof w=="undefined"?E:w}e.getOrDefault=C;function g(a,u){const E=Object.create(null);return!a||!u||Object.keys(u).forEach(S=>{const d=a[S],l=u[S];P(d,l)||(E[S]=l)}),E}e.distinct=g;function m(a,u){const E=u.toLowerCase(),w=Object.keys(a).find(S=>S.toLowerCase()===E);return w?a[w]:a[u]}e.getCaseInsensitive=m}),define(ge[96],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var _;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(_=e.Constants||(e.Constants={}));function I(A){return A<0?0:A>255?255:A|0}e.toUint8=I;function T(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=T}),define(ge[2],pe([0,1,10,8]),function(K,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,A=/^\//,y=/^\/\//;function k(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!T.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!A.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(r,i){return!r&&!i?"file":r}function P(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==C&&(i=C+i):i=C;break}return i}const s="",C="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(i,o,c,v,p,h=!1){typeof i=="object"?(this.scheme=i.scheme||s,this.authority=i.authority||s,this.path=i.path||s,this.query=i.query||s,this.fragment=i.fragment||s):(this.scheme=D(i,h),this.authority=o||s,this.path=P(this.scheme,c||s),this.query=v||s,this.fragment=p||s,k(this,h))}static isUri(i){return i instanceof m?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return d(this,!1)}with(i){if(!i)return this;let{scheme:o,authority:c,path:v,query:p,fragment:h}=i;return o===void 0?o=this.scheme:o===null&&(o=s),c===void 0?c=this.authority:c===null&&(c=s),v===void 0?v=this.path:v===null&&(v=s),p===void 0?p=this.query:p===null&&(p=s),h===void 0?h=this.fragment:h===null&&(h=s),o===this.scheme&&c===this.authority&&v===this.path&&p===this.query&&h===this.fragment?this:new u(o,c,v,p,h)}static parse(i,o=!1){const c=g.exec(i);return c?new u(c[2]||s,n(c[4]||s),n(c[5]||s),n(c[7]||s),n(c[9]||s),o):new u(s,s,s,s,s)}static file(i){let o=s;if(_.isWindows&&(i=i.replace(/\\/g,C)),i[0]===C&&i[1]===C){const c=i.indexOf(C,2);c===-1?(o=i.substring(2),i=C):(o=i.substring(2,c),i=i.substring(c)||C)}return new u("file",o,i,s,s)}static from(i){return new u(i.scheme,i.authority,i.path,i.query,i.fragment)}static joinPath(i,...o){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return _.isWindows&&i.scheme==="file"?c=m.file(I.win32.join(d(i,!0),...o)).path:c=I.posix.join(i.path,...o),i.with({path:c})}toString(i=!1){return l(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof m)return i;{const o=new u(i);return o._formatted=i.external,o._fsPath=i._sep===a?i.fsPath:null,o}}else return i}}e.URI=m;const a=_.isWindows?1:void 0;class u extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(i=!1){return i?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=a),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(r,i){let o,c=-1;for(let v=0;v<r.length;v++){const p=r.charCodeAt(v);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||i&&p===47)c!==-1&&(o+=encodeURIComponent(r.substring(c,v)),c=-1),o!==void 0&&(o+=r.charAt(v));else{o===void 0&&(o=r.substr(0,v));const h=E[p];h!==void 0?(c!==-1&&(o+=encodeURIComponent(r.substring(c,v)),c=-1),o+=h):c===-1&&(c=v)}}return c!==-1&&(o+=encodeURIComponent(r.substring(c))),o!==void 0?o:r}function S(r){let i;for(let o=0;o<r.length;o++){const c=r.charCodeAt(o);c===35||c===63?(i===void 0&&(i=r.substr(0,o)),i+=E[c]):i!==void 0&&(i+=r[o])}return i!==void 0?i:r}function d(r,i){let o;return r.authority&&r.path.length>1&&r.scheme==="file"?o=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?o=r.path.substr(1):o=r.path[1].toLowerCase()+r.path.substr(2):o=r.path,_.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=d;function l(r,i){const o=i?S:w;let c="",{scheme:v,authority:p,path:h,query:b,fragment:R}=r;if(v&&(c+=v,c+=":"),(p||v==="file")&&(c+=C,c+=C),p){let N=p.indexOf("@");if(N!==-1){const j=p.substr(0,N);p=p.substr(N+1),N=j.indexOf(":"),N===-1?c+=o(j,!1):(c+=o(j.substr(0,N),!1),c+=":",c+=o(j.substr(N+1),!1)),c+="@"}p=p.toLowerCase(),N=p.indexOf(":"),N===-1?c+=o(p,!1):(c+=o(p.substr(0,N),!1),c+=p.substr(N))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const N=h.charCodeAt(1);N>=65&&N<=90&&(h=`/${String.fromCharCode(N+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const N=h.charCodeAt(0);N>=65&&N<=90&&(h=`${String.fromCharCode(N+32)}:${h.substr(2)}`)}c+=o(h,!0)}return b&&(c+="?",c+=o(b,!1)),R&&(c+="#",c+=i?R:w(R,!1)),c}function f(r){try{return decodeURIComponent(r)}catch(i){return r.length>3?r.substr(0,3)+f(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(r){return r.match(t)?r.replace(t,i=>f(i)):r}});var tt=this&&this.__classPrivateFieldSet||function(K,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!T:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(K,_):T?T.value=_:e.set(K,_),_},Ue=this&&this.__classPrivateFieldGet||function(K,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!I:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(K):I?I.value:e.get(K)};define(ge[24],pe([0,1,2,9]),function(K,e,_,I){"use strict";var T,A,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(t,n,r){let i=t.get(n);return i===void 0&&(i=r,t.set(n,i)),i}e.getOrSet=k;function D(t){const n=[];return t.forEach((r,i)=>{n.push(`${i} => ${r}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=D;function P(t){const n=[];return t.forEach(r=>{n.push(r)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=P;class s{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const r=n.charCodeAt(0),i=this._value.charCodeAt(this._pos);return r-i}value(){return this._value[this._pos]}}e.StringIterator=s;class C{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,I.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class g{constructor(n=!0,r=!0){this._splitOnBackslash=n,this._caseSensitive=r}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,I.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=g;var m;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(m||(m={}));class a{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new g(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,I.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class u{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class E{constructor(n){this._iter=n}static forUris(n=()=>!1){return new E(new a(n))}static forPaths(){return new E(new g)}static forStrings(){return new E(new s)}static forConfigKeys(){return new E(new C)}clear(){this._root=void 0}set(n,r){const i=this._iter.reset(n);let o;for(this._root||(this._root=new u,this._root.segment=i.value()),o=this._root;;){const v=i.cmp(o.segment);if(v>0)o.left||(o.left=new u,o.left.segment=i.value()),o=o.left;else if(v<0)o.right||(o.right=new u,o.right.segment=i.value()),o=o.right;else if(i.hasNext())i.next(),o.mid||(o.mid=new u,o.mid.segment=i.value()),o=o.mid;else break}const c=o.value;return o.value=r,o.key=n,c}get(n){var r;return(r=this._getNode(n))===null||r===void 0?void 0:r.value}_getNode(n){const r=this._iter.reset(n);let i=this._root;for(;i;){const o=r.cmp(i.segment);if(o>0)i=i.left;else if(o<0)i=i.right;else if(r.hasNext())r.next(),i=i.mid;else break}return i}has(n){const r=this._getNode(n);return!((r==null?void 0:r.value)===void 0&&(r==null?void 0:r.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,r){const i=this._iter.reset(n),o=[];let c=this._root;for(;c;){const v=i.cmp(c.segment);if(v>0)o.push([1,c]),c=c.left;else if(v<0)o.push([-1,c]),c=c.right;else if(i.hasNext())i.next(),o.push([0,c]),c=c.mid;else{for(r?(c.left=void 0,c.mid=void 0,c.right=void 0):c.value=void 0;o.length>0&&c.isEmpty();){let[p,h]=o.pop();switch(p){case 1:h.left=void 0;break;case 0:h.mid=void 0;break;case-1:h.right=void 0;break}c=h}break}}}findSubstr(n){const r=this._iter.reset(n);let i=this._root,o;for(;i;){const c=r.cmp(i.segment);if(c>0)i=i.left;else if(c<0)i=i.right;else if(r.hasNext())r.next(),o=i.value||o,i=i.mid;else break}return i&&i.value||o}findSuperstr(n){const r=this._iter.reset(n);let i=this._root;for(;i;){const o=r.cmp(i.segment);if(o>0)i=i.left;else if(o<0)i=i.right;else if(r.hasNext())r.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(n){for(const[r,i]of this)n(i,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=E;class w{constructor(n,r){this[T]="ResourceMap",n instanceof w?(this.map=new Map(n.map),this.toKey=r!=null?r:w.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:w.defaultToKey)}set(n,r){return this.map.set(this.toKey(n),r),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,r){typeof r!="undefined"&&(n=n.bind(r));for(let[i,o]of this.map)n(o,_.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield _.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[_.URI.parse(n[0]),n[1]]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[_.URI.parse(n[0]),n[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var S;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class d{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,r=0){const i=this._map.get(n);if(!!i)return r!==0&&this.touch(i,r),i.value}set(n,r,i=0){let o=this._map.get(n);if(o)o.value=r,i!==0&&this.touch(o,i);else{switch(o={key:n,value:r,next:void 0,previous:void 0},i){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(n,o),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const r=this._map.get(n);if(!!r)return this._map.delete(n),this.removeItem(r),this._size--,r.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,r){const i=this._state;let o=this._head;for(;o;){if(r?n.bind(r)(o.value,o.key,this):n(o.value,o.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const n=this,r=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(i){const c={value:i.key,done:!1};return i=i.next,c}else return{value:void 0,done:!0}}};return o}values(){const n=this,r=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(i){const c={value:i.value,done:!1};return i=i.next,c}else return{value:void 0,done:!0}}};return o}entries(){const n=this,r=this._state;let i=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(i){const c={value:[i.key,i.value],done:!1};return i=i.next,c}else return{value:void 0,done:!0}}};return o}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let r=this._head,i=this.size;for(;r&&i>n;)this._map.delete(r.key),r=r.next,i--;this._head=r,this._size=i,r&&(r.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const r=n.next,i=n.previous;if(!r||!i)throw new Error("Invalid list");r.previous=i,i.next=r}n.next=void 0,n.previous=void 0,this._state++}touch(n,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(n===this._head)return;const i=n.next,o=n.previous;n===this._tail?(o.next=void 0,this._tail=o):(i.previous=o,o.next=i),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(r===2){if(n===this._tail)return;const i=n.next,o=n.previous;n===this._head?(i.previous=void 0,this._head=i):(i.previous=o,o.next=i),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((r,i)=>{n.push([i,r])}),n}fromJSON(n){this.clear();for(const[r,i]of n)this.set(r,i)}}e.LinkedMap=d;class l extends d{constructor(n,r=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,r=2){return super.get(n,r)}peek(n){return super.get(n,0)}set(n,r){return super.set(n,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class f{constructor(n){y.set(this,void 0),tt(this,y,n,"f")}get size(){return Ue(this,y,"f").size}forEach(n,r){Ue(this,y,"f").forEach(n,r)}get(n){return Ue(this,y,"f").get(n)}has(n){return Ue(this,y,"f").has(n)}entries(){return Ue(this,y,"f").entries()}keys(){return Ue(this,y,"f").keys()}values(){return Ue(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return Ue(this,y,"f").entries()}}e.ReadonlyMapView=f}),define(ge[97],pe([0,1,24,9]),function(K,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function T(...be){return function(Pe,Re){for(let Be=0,Se=be.length;Be<Se;Be++){const qe=be[Be](Pe,Re);if(qe)return qe}return null}}e.or=T,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(be,Pe,Re){if(!Re||Re.length<Pe.length)return null;let Be;return be?Be=I.startsWithIgnoreCase(Re,Pe):Be=Re.indexOf(Pe)===0,Be?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function y(be,Pe){const Re=Pe.toLowerCase().indexOf(be.toLowerCase());return Re===-1?null:[{start:Re,end:Re+be.length}]}e.matchesContiguousSubString=y;function k(be,Pe){return D(be.toLowerCase(),Pe.toLowerCase(),0,0)}e.matchesSubString=k;function D(be,Pe,Re,Be){if(Re===be.length)return[];if(Be===Pe.length)return null;if(be[Re]===Pe[Be]){let Se=null;return(Se=D(be,Pe,Re+1,Be+1))?w({start:Be,end:Be+1},Se):null}return D(be,Pe,Re,Be+1)}function P(be){return 97<=be&&be<=122}function s(be){return 65<=be&&be<=90}e.isUpper=s;function C(be){return 48<=be&&be<=57}function g(be){return be===32||be===9||be===10||be===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(be=>m.add(be.charCodeAt(0)));function a(be){return g(be)||m.has(be)}function u(be,Pe){return be===Pe||a(be)&&a(Pe)}function E(be){return P(be)||s(be)||C(be)}function w(be,Pe){return Pe.length===0?Pe=[be]:be.end===Pe[0].start?Pe[0].start=be.start:Pe.unshift(be),Pe}function S(be,Pe){for(let Re=Pe;Re<be.length;Re++){const Be=be.charCodeAt(Re);if(s(Be)||C(Be)||Re>0&&!E(be.charCodeAt(Re-1)))return Re}return be.length}function d(be,Pe,Re,Be){if(Re===be.length)return[];if(Be===Pe.length)return null;if(be[Re]!==Pe[Be].toLowerCase())return null;{let Se=null,qe=Be+1;for(Se=d(be,Pe,Re+1,Be+1);!Se&&(qe=S(Pe,qe))<Pe.length;)Se=d(be,Pe,Re+1,qe),qe++;return Se===null?null:w({start:Be,end:Be+1},Se)}}function l(be){let Pe=0,Re=0,Be=0,Se=0,qe=0;for(let ze=0;ze<be.length;ze++)qe=be.charCodeAt(ze),s(qe)&&Pe++,P(qe)&&Re++,E(qe)&&Be++,C(qe)&&Se++;const X=Pe/be.length,ie=Re/be.length,_e=Be/be.length,Ne=Se/be.length;return{upperPercent:X,lowerPercent:ie,alphaPercent:_e,numericPercent:Ne}}function f(be){const{upperPercent:Pe,lowerPercent:Re}=be;return Re===0&&Pe>.6}function t(be){const{upperPercent:Pe,lowerPercent:Re,alphaPercent:Be,numericPercent:Se}=be;return Re>.2&&Pe<.8&&Be>.6&&Se<.2}function n(be){let Pe=0,Re=0,Be=0,Se=0;for(let qe=0;qe<be.length;qe++)Be=be.charCodeAt(qe),s(Be)&&Pe++,P(Be)&&Re++,g(Be)&&Se++;return(Pe===0||Re===0)&&Se===0?be.length<=30:Pe<=5}function r(be,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!n(be)||Pe.length>60)return null;const Re=l(Pe);if(!t(Re)){if(!f(Re))return null;Pe=Pe.toLowerCase()}let Be=null,Se=0;for(be=be.toLowerCase();Se<Pe.length&&(Be=d(be,Pe,0,Se))===null;)Se=S(Pe,Se+1);return Be}e.matchesCamelCase=r;function i(be,Pe,Re=!1){if(!Pe||Pe.length===0)return null;let Be=null,Se=0;for(be=be.toLowerCase(),Pe=Pe.toLowerCase();Se<Pe.length&&(Be=o(be,Pe,0,Se,Re))===null;)Se=c(Pe,Se+1);return Be}e.matchesWords=i;function o(be,Pe,Re,Be,Se){if(Re===be.length)return[];if(Be===Pe.length)return null;if(u(be.charCodeAt(Re),Pe.charCodeAt(Be))){let qe=null,X=Be+1;if(qe=o(be,Pe,Re+1,Be+1,Se),!Se)for(;!qe&&(X=c(Pe,X))<Pe.length;)qe=o(be,Pe,Re+1,X,Se),X++;return qe===null?null:w({start:Be,end:Be+1},qe)}else return null}function c(be,Pe){for(let Re=Pe;Re<be.length;Re++)if(a(be.charCodeAt(Re))||Re>0&&a(be.charCodeAt(Re-1)))return Re;return be.length}const v=T(e.matchesPrefix,r,y),p=T(e.matchesPrefix,r,k),h=new _.LRUCache(1e4);function b(be,Pe,Re=!1){if(typeof be!="string"||typeof Pe!="string")return null;let Be=h.get(be);Be||(Be=new RegExp(I.convertSimple2RegExpPattern(be),"i"),h.set(be,Be));const Se=Be.exec(Pe);return Se?[{start:Se.index,end:Se.index+Se[0].length}]:Re?p(be,Pe):v(be,Pe)}e.matchesFuzzy=b;function R(be,Pe){const Re=z(be,be.toLowerCase(),0,Pe,Pe.toLowerCase(),0,!0);return Re?j(Re):null}e.matchesFuzzy2=R;function N(be,Pe,Re,Be,Se,qe){const X=Math.min(13,be.length);for(;Re<X;Re++){const ie=z(be,Pe,Re,Be,Se,qe,!1);if(ie)return ie}return[0,qe]}e.anyScore=N;function j(be){if(typeof be=="undefined")return[];const Pe=[],Re=be[1];for(let Be=be.length-1;Be>1;Be--){const Se=be[Be]+Re,qe=Pe[Pe.length-1];qe&&qe.end===Se?qe.end=Se+1:Pe.push({start:Se,end:Se+1})}return Pe}e.createMatches=j;const oe=128;function q(){const be=[],Pe=[];for(let Re=0;Re<=oe;Re++)Pe[Re]=0;for(let Re=0;Re<=oe;Re++)be.push(Pe.slice(0));return be}function W(be){const Pe=[];for(let Re=0;Re<=be;Re++)Pe[Re]=0;return Pe}const H=W(2*oe),U=W(2*oe),L=q(),F=q(),O=q(),M=!1;function B(be,Pe,Re,Be,Se){function qe(ie,_e,Ne=" "){for(;ie.length<_e;)ie=Ne+ie;return ie}let X=` |   |${Be.split("").map(ie=>qe(ie,3)).join("|")}
`;for(let ie=0;ie<=Re;ie++)ie===0?X+=" |":X+=`${Pe[ie-1]}|`,X+=be[ie].slice(0,Se+1).map(_e=>qe(_e.toString(),3)).join("|")+`
`;return X}function V(be,Pe,Re,Be){be=be.substr(Pe),Re=Re.substr(Be),console.log(B(F,be,be.length,Re,Re.length)),console.log(B(O,be,be.length,Re,Re.length)),console.log(B(L,be,be.length,Re,Re.length))}function Q(be,Pe){if(Pe<0||Pe>=be.length)return!1;const Re=be.codePointAt(Pe);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise(Re)}}function de(be,Pe){if(Pe<0||Pe>=be.length)return!1;switch(be.charCodeAt(Pe)){case 32:case 9:return!0;default:return!1}}function we(be,Pe,Re){return Pe[be]!==Re[be]}function Ie(be,Pe,Re,Be,Se,qe,X=!1){for(;Pe<Re&&Se<qe;)be[Pe]===Be[Se]&&(X&&(H[Pe]=Se),Pe+=1),Se+=1;return Pe===Re}e.isPatternInWord=Ie;var Ce;(function(be){be[be.Diag=1]="Diag",be[be.Left=2]="Left",be[be.LeftLeft=3]="LeftLeft"})(Ce||(Ce={}));var Le;(function(be){be.Default=[-100,0];function Pe(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}be.isDefault=Pe})(Le=e.FuzzyScore||(e.FuzzyScore={}));function z(be,Pe,Re,Be,Se,qe,X){const ie=be.length>oe?oe:be.length,_e=Be.length>oe?oe:Be.length;if(!(Re>=ie||qe>=_e||ie-Re>_e-qe)&&!!Ie(Pe,Re,ie,Se,qe,_e,!0)){Y(ie,_e,Re,qe,Pe,Se);let Ne=1,ze=1,$e=Re,Je=qe;const G=[!1];for(Ne=1,$e=Re;$e<ie;Ne++,$e++){const ce=H[$e],ve=U[$e],ye=$e+1<ie?U[$e+1]:_e;for(ze=ce-qe+1,Je=ce;Je<ye;ze++,Je++){let je=Number.MIN_SAFE_INTEGER,He=!1;Je<=ve&&(je=ee(be,Pe,$e,Re,Be,Se,Je,_e,qe,L[Ne-1][ze-1]===0,G));let We=0;je!==Number.MAX_SAFE_INTEGER&&(He=!0,We=je+F[Ne-1][ze-1]);const Ke=Je>ce,nt=Ke?F[Ne][ze-1]+(L[Ne][ze-1]>0?-5:0):0,dt=Je>ce+1&&L[Ne][ze-1]>0,it=dt?F[Ne][ze-2]+(L[Ne][ze-2]>0?-5:0):0;if(dt&&(!Ke||it>=nt)&&(!He||it>=We))F[Ne][ze]=it,O[Ne][ze]=3,L[Ne][ze]=0;else if(Ke&&(!He||nt>=We))F[Ne][ze]=nt,O[Ne][ze]=2,L[Ne][ze]=0;else if(He)F[Ne][ze]=We,O[Ne][ze]=1,L[Ne][ze]=L[Ne-1][ze-1]+1;else throw new Error("not possible")}}if(M&&V(be,Re,Be,qe),!(!G[0]&&!X)){Ne--,ze--;const re=[F[Ne][ze],qe];let he=0,J=0;for(;Ne>=1;){let ce=ze;do{const ve=O[Ne][ce];if(ve===3)ce=ce-2;else if(ve===2)ce=ce-1;else break}while(ce>=1);he>1&&Pe[Re+Ne-1]===Se[qe+ze-1]&&!we(ce+qe-1,Be,Se)&&he+1>L[Ne][ce]&&(ce=ze),ce===ze?he++:he=1,J||(J=ce),Ne--,ze=ce-1,re.push(ze)}_e===ie&&(re[0]+=2);const ne=J-ie;return re[0]-=ne,re}}}e.fuzzyScore=z;function Y(be,Pe,Re,Be,Se,qe){let X=be-1,ie=Pe-1;for(;X>=Re&&ie>=Be;)Se[X]===qe[ie]&&(U[X]=ie,X--),ie--}function ee(be,Pe,Re,Be,Se,qe,X,ie,_e,Ne,ze){if(Pe[Re]!==qe[X])return Number.MIN_SAFE_INTEGER;let $e=1,Je=!1;return X===Re-Be?$e=be[Re]===Se[X]?7:5:we(X,Se,qe)&&(X===0||!we(X-1,Se,qe))?($e=be[Re]===Se[X]?7:5,Je=!0):Q(qe,X)&&(X===0||!Q(qe,X-1))?$e=5:(Q(qe,X-1)||de(qe,X-1))&&($e=5,Je=!0),$e>1&&Re===Be&&(ze[0]=!0),Je||(Je=we(X,Se,qe)||Q(qe,X-1)||de(qe,X-1)),Re===Be?X>_e&&($e-=Je?3:5):Ne?$e+=Je?2:0:$e+=Je?0:1,X+1===ie&&($e-=Je?3:5),$e}function le(be,Pe,Re,Be,Se,qe,X){return De(be,Pe,Re,Be,Se,qe,!0,X)}e.fuzzyScoreGracefulAggressive=le;function me(be,Pe,Re,Be,Se,qe,X){return De(be,Pe,Re,Be,Se,qe,!1,X)}e.fuzzyScoreGraceful=me;function De(be,Pe,Re,Be,Se,qe,X,ie){let _e=z(be,Pe,Re,Be,Se,qe,ie);if(_e&&!X)return _e;if(be.length>=3){const Ne=Math.min(7,be.length-1);for(let ze=Re+1;ze<Ne;ze++){const $e=Oe(be,ze);if($e){const Je=z($e,$e.toLowerCase(),Re,Be,Se,qe,ie);Je&&(Je[0]-=3,(!_e||Je[0]>_e[0])&&(_e=Je))}}}return _e}function Oe(be,Pe){if(!(Pe+1>=be.length)){const Re=be[Pe],Be=be[Pe+1];if(Re!==Be)return be.slice(0,Pe)+Be+Re+be.slice(Pe+2)}}}),define(ge[136],pe([0,1,43,97,9]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${_.CSSIcon.iconNameExpression}(?:${_.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${A.source}`,"g");function k(u){return u.replace(y,(E,w)=>w?E:`\\${E}`)}e.escapeIcons=k;const D=new RegExp(`\\\\${A.source}`,"g");function P(u){return u.replace(D,E=>`\\${E}`)}e.markdownEscapeEscapedIcons=P;const s=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function C(u){return u.indexOf(e.iconStartMarker)===-1?u:u.replace(s,(E,w,S,d)=>S?E:w||d||"")}e.stripIcons=C;function g(u){const E=u.indexOf(e.iconStartMarker);return E===-1?{text:u}:m(u,E)}e.parseLabelWithIcons=g;function m(u,E){const w=[];let S="";function d(c){if(c){S+=c;for(const v of c)w.push(t)}}let l=-1,f="",t=0,n,r,i=E;const o=u.length;for(d(u.substr(0,E));i<o;)n=u[i],r=u[i+1],n===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(l=i,d(f),f=e.iconStartMarker,i++):n===")"&&l!==-1?(t+=i-l+1,l=-1,f=""):l!==-1?/^[a-z0-9\-]$/i.test(n)?f+=n:(d(f),l=-1,f=""):d(n),i++;return d(f),{text:S,iconOffsets:w}}function a(u,E,w=!1){const{text:S,iconOffsets:d}=E;if(!d||d.length===0)return(0,I.matchesFuzzy)(u,S,w);const l=(0,T.ltrim)(S," "),f=S.length-l.length,t=(0,I.matchesFuzzy)(u,l,w);if(t)for(const n of t){const r=d[n.start+f]+f;n.start+=r,n.end+=r}return t}e.matchesFuzzyIconAware=a}),define(ge[98],pe([0,1,19,136,18]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(u="",E=!1){var w,S;if(this.value=u,typeof this.value!="string")throw(0,T.illegalArgument)("value");typeof E=="boolean"?(this.isTrusted=E,this.supportThemeIcons=!1):(this.isTrusted=(w=E.isTrusted)!==null&&w!==void 0?w:void 0,this.supportThemeIcons=(S=E.supportThemeIcons)!==null&&S!==void 0?S:!1)}appendText(u,E=0){return this.value+=C(this.supportThemeIcons?(0,I.escapeIcons)(u):u).replace(/([ \t]+)/g,(w,S)=>"&nbsp;".repeat(S.length)).replace(/^>/gm,"\\>").replace(/\n/g,E===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,E){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=E,this.value+="\n```\n",this}}e.MarkdownString=y;function k(a){return D(a)?!a.value:Array.isArray(a)?a.every(k):!0}e.isEmptyMarkdownString=k;function D(a){return a instanceof y?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function P(a,u){return!a&&!u?!0:!a||!u?!1:Array.isArray(a)&&Array.isArray(u)?(0,_.equals)(a,u,s):D(a)&&D(u)?s(a,u):!1}e.markedStringsEquals=P;function s(a,u){return a===u?!0:!a||!u?!1:a.value===u.value&&a.isTrusted===u.isTrusted&&a.supportThemeIcons===u.supportThemeIcons}function C(a){return a.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function g(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=g;function m(a){const u=[],E=a.split("|").map(S=>S.trim());a=E[0];const w=E[1];if(w){const S=/height=(\d+)/.exec(w),d=/width=(\d+)/.exec(w),l=S?S[1]:"",f=d?d[1]:"",t=isFinite(parseInt(f)),n=isFinite(parseInt(l));t&&u.push(`width="${f}"`),n&&u.push(`height="${l}"`)}return{href:a,dimensions:u}}e.parseHrefAndDimensions=m}),define(ge[58],pe([0,1,22,9,2]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(P){return JSON.stringify(P,k)}e.stringify=A;function y(P){let s=JSON.parse(P);return s=D(s),s}e.parse=y;function k(P,s){return s instanceof RegExp?{$mid:2,source:s.source,flags:(0,I.regExpFlags)(s)}:s}function D(P,s=0){if(!P||s>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return T.URI.revive(P);case 2:return new RegExp(P.source,P.flags)}if(P instanceof _.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let C=0;C<P.length;++C)P[C]=D(P[C],s+1);else for(const C in P)Object.hasOwnProperty.call(P,C)&&(P[C]=D(P[C],s+1))}return P}e.revive=D}),define(ge[12],pe([0,1,2,10]),function(K,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var T;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file"})(T=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,P,s){this._hosts[D]=P,this._ports[D]=s}setConnectionToken(D,P){this._connectionTokens[D]=P}rewrite(D){if(this._delegate)return this._delegate(D);const P=D.authority;let s=this._hosts[P];s&&s.indexOf(":")!==-1&&(s=`[${s}]`);const C=this._ports[P],g=this._connectionTokens[P];let m=`path=${encodeURIComponent(D.path)}`;return typeof g=="string"&&(m+=`&tkn=${encodeURIComponent(g)}`),_.URI.from({scheme:I.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${s}:${C}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new A;class y{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,P,s){const C=this.toUri(D,P);return C.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(C):I.isNative&&(s||I.isPreferringBrowserCodeLoad)&&C.scheme===T.file?C.with({scheme:T.vscodeFileResource,authority:C.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(D,P){const s=this.toUri(D,P);return s.scheme===T.vscodeFileResource?s.with({scheme:T.file,authority:s.authority!==this.FALLBACK_AUTHORITY?s.authority:null,query:null,fragment:null}):s}toUri(D,P){return _.URI.isUri(D)?D:_.URI.parse(P.toUrl(D))}}e.FileAccess=new y}),define(ge[75],pe([0,1,24]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const I=new _.LRUCache(1e4);function T(P){return D(P,"NFC",I)}e.normalizeNFC=T;const A=new _.LRUCache(1e4);function y(P){return D(P,"NFD",A)}e.normalizeNFD=y;const k=/[^\u0000-\u0080]/;function D(P,s,C){if(!e.canNormalize||!P)return P;const g=C.get(P);if(g)return g;let m;return k.test(P)?m=P.normalize(s):m=P,C.set(P,m),m}e.removeAccents=function(){if(e.canNormalize){const P=/[\u0300-\u036f]/g;return function(s){return y(s).replace(P,"")}}else return function(P){return P}}()}),define(ge[25],pe([0,1,29,8,2,9,12,10]),function(K,e,_,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(m){return(0,T.uriToFsPath)(m,!0)}e.originalFSPath=D;class P{constructor(a){this._ignorePathCasing=a}compare(a,u,E=!1){return a===u?0:(0,A.compare)(this.getComparisonKey(a,E),this.getComparisonKey(u,E))}isEqual(a,u,E=!1){return a===u?!0:!a||!u?!1:this.getComparisonKey(a,E)===this.getComparisonKey(u,E)}getComparisonKey(a,u=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,u,E=!1){if(a.scheme===u.scheme){if(a.scheme===y.Schemas.file)return _.isEqualOrParent(D(a),D(u),this._ignorePathCasing(a))&&a.query===u.query&&(E||a.fragment===u.fragment);if((0,e.isEqualAuthority)(a.authority,u.authority))return _.isEqualOrParent(a.path,u.path,this._ignorePathCasing(a),"/")&&a.query===u.query&&(E||a.fragment===u.fragment)}return!1}joinPath(a,...u){return T.URI.joinPath(a,...u)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return I.posix.basename(a.path)}extname(a){return I.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let u;return a.scheme===y.Schemas.file?u=T.URI.file(I.dirname(D(a))).path:(u=I.posix.dirname(a.path),a.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),u="/")),a.with({path:u})}normalizePath(a){if(!a.path.length)return a;let u;return a.scheme===y.Schemas.file?u=T.URI.file(I.normalize(D(a))).path:u=I.posix.normalize(a.path),a.with({path:u})}relativePath(a,u){if(!(a.scheme!==u.scheme||!(0,e.isEqualAuthority)(a.authority,u.authority))){if(a.scheme===y.Schemas.file){const S=I.relative(D(a),D(u));return k.isWindows?_.toSlashes(S):S}let E=a.path||"/",w=u.path||"/";if(this._ignorePathCasing(a)){let S=0;for(const d=Math.min(E.length,w.length);S<d&&!(E.charCodeAt(S)!==w.charCodeAt(S)&&E.charAt(S).toLowerCase()!==w.charAt(S).toLowerCase());S++);E=w.substr(0,S)+E.substr(S)}return I.posix.relative(E,w)}}resolvePath(a,u){if(a.scheme===y.Schemas.file){const E=T.URI.file(I.resolve(D(a),u));return a.with({authority:E.authority,path:E.path})}return u.indexOf("/")===-1&&(u=_.toSlashes(u),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u)),a.with({path:I.posix.resolve(a.path,u)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,u){return a===u||(0,A.equalsIgnoreCase)(a,u)}hasTrailingPathSeparator(a,u=I.sep){if(a.scheme===y.Schemas.file){const E=D(a);return E.length>_.getRoot(E).length&&E[E.length-1]===u}else{const E=a.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,u=I.sep){return(0,e.hasTrailingPathSeparator)(a,u)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,u=I.sep){let E=!1;if(a.scheme===y.Schemas.file){const w=D(a);E=w!==void 0&&w.length===_.getRoot(w).length&&w[w.length-1]===u}else{u="/";const w=a.path;E=w.length===1&&w.charCodeAt(w.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(a,u)?a.with({path:a.path+"/"}):a}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(m=>m.scheme===y.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new P(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function s(m,a){const u=[];for(let E=0;E<m.length;E++){const w=a(m[E]);m.some((S,d)=>d===E?!1:(0,e.isEqualOrParent)(w,a(S)))||u.push(m[E])}return u}e.distinctParents=s;var C;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function a(u){const E=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(d=>{const[l,f]=d.split(":");l&&f&&E.set(l,f)});const S=u.path.substring(0,u.path.indexOf(";"));return S&&E.set(m.META_DATA_MIME,S),E}m.parseMetaData=a})(C=e.DataUri||(e.DataUri={}));function g(m,a,u){if(a){let E=m.path;return E&&E[0]!==I.posix.sep&&(E=I.posix.sep+E),m.with({scheme:u,authority:a,path:E})}return m.with({scheme:u})}e.toLocalResource=g}),define(ge[15],pe([0,1,21,18,3,6,56,25]),function(K,e,_,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(F){return!!F&&typeof F.then=="function"}e.isThenable=D;function P(F){const O=new _.CancellationTokenSource,M=F(O.token),B=new Promise((V,Q)=>{O.token.onCancellationRequested(()=>{Q((0,I.canceled)())}),Promise.resolve(M).then(de=>{O.dispose(),V(de)},de=>{O.dispose(),Q(de)})});return new class{cancel(){O.cancel()}then(V,Q){return B.then(V,Q)}catch(V){return this.then(void 0,V)}finally(V){return B.finally(V)}}}e.createCancelablePromise=P;function s(F,O,M){return Promise.race([F,new Promise(B=>O.onCancellationRequested(()=>B(M)))])}e.raceCancellation=s;async function C(F){let O=-1;const M=F.map((V,Q)=>V.then(de=>(O=Q,de))),B=await Promise.race(M);return F.forEach((V,Q)=>{Q!==O&&V.cancel()}),B}e.raceCancellablePromises=C;function g(F,O,M){let B;const V=setTimeout(()=>{B==null||B(void 0),M==null||M()},O);return Promise.race([F.finally(()=>clearTimeout(V)),new Promise(Q=>B=Q)])}e.raceTimeout=g;function m(F){return new Promise((O,M)=>{const B=F();D(B)?B.then(O,M):O(B)})}e.asPromise=m;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(O){if(this.activePromise){if(this.queuedPromiseFactory=O,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then(M,M).then(B)})}return new Promise((M,B)=>{this.queuedPromise.then(M,B)})}return this.activePromise=O(),new Promise((M,B)=>{this.activePromise.then(V=>{this.activePromise=null,M(V)},V=>{this.activePromise=null,B(V)})})}}e.Throttler=a;class u{constructor(){this.current=Promise.resolve(null)}queue(O){return this.current=this.current.then(()=>O(),()=>O())}}e.Sequencer=u;class E{constructor(){this.promiseMap=new Map}queue(O,M){var B;const Q=((B=this.promiseMap.get(O))!==null&&B!==void 0?B:Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(O)===Q&&this.promiseMap.delete(O)});return this.promiseMap.set(O,Q),Q}}e.SequencerByKey=E;class w{constructor(O){this.defaultDelay=O,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(O,M=this.defaultDelay){return this.task=O,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,V)=>{this.doResolve=B,this.doReject=V}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},M),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,I.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=w;class S{constructor(O){this.delayer=new w(O),this.throttler=new a}trigger(O,M){return this.delayer.trigger(()=>this.throttler.queue(O),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class d{constructor(){this._isOpen=!1,this._promise=new Promise((O,M)=>{this._completePromise=O})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=d;class l extends d{constructor(O){super();this._timeout=setTimeout(()=>this.open(),O)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function f(F,O){return O?new Promise((M,B)=>{const V=setTimeout(M,F);O.onCancellationRequested(()=>{clearTimeout(V),B((0,I.canceled)())})}):P(M=>f(F,M))}e.timeout=f;function t(F,O=0){const M=setTimeout(F,O);return(0,A.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=t;function n(F){return F.then(void 0,O=>{})}e.ignoreErrors=n;function r(F){const O=[];let M=0;const B=F.length;function V(){return M<B?F[M++]():null}function Q(de){de!=null&&O.push(de);const we=V();return we?we.then(Q):Promise.resolve(O)}return Promise.resolve(null).then(Q)}e.sequence=r;function i(F,O=B=>!!B,M=null){let B=0;const V=F.length,Q=()=>{if(B>=V)return Promise.resolve(M);const de=F[B++];return Promise.resolve(de()).then(Ie=>O(Ie)?Promise.resolve(Ie):Q())};return Q()}e.first=i;function o(F,O=B=>!!B,M=null){if(F.length===0)return Promise.resolve(M);let B=F.length;const V=()=>{var Q,de;B=-1;for(const we of F)(de=(Q=we).cancel)===null||de===void 0||de.call(Q)};return new Promise((Q,de)=>{for(const we of F)we.then(Ie=>{--B>=0&&O(Ie)?(V(),Q(Ie)):B===0&&Q(M)}).catch(Ie=>{--B>=0&&(V(),de(Ie))})})}e.firstParallel=o;class c{constructor(O){this._size=0,this.maxDegreeOfParalellism=O,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new T.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(O){return this._size++,new Promise((M,B)=>{this.outstandingPromises.push({factory:O,c:M,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const O=this.outstandingPromises.shift();this.runningPromises++;const M=O.factory();M.then(O.c,O.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=c;class v extends c{constructor(){super(1)}}e.Queue=v;class p{constructor(){this.queues=new Map}queueFor(O,M=k.extUri){const B=M.getComparisonKey(O);let V=this.queues.get(B);return V||(V=new v,T.Event.once(V.onFinished)(()=>{V==null||V.dispose(),this.queues.delete(B)}),this.queues.set(B,V)),V}dispose(){this.queues.forEach(O=>O.dispose()),this.queues.clear()}}e.ResourceQueue=p;class h{constructor(O,M){this._token=-1,typeof O=="function"&&typeof M=="number"&&this.setIfNotSet(O,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(O,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,O()},M)}setIfNotSet(O,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,O()},M))}}e.TimeoutTimer=h;class b{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(O,M){this.cancel(),this._token=setInterval(()=>{O()},M)}}e.IntervalTimer=b;class R{constructor(O,M){this.timeoutToken=-1,this.runner=O,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(O=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,O)}get delay(){return this.timeout}set delay(O){this.timeout=O}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class N extends R{constructor(O,M){super(O,M);this.units=[]}work(O){this.units.push(O),this.isScheduled()||this.schedule()}doRun(){const O=this.units;this.units=[],this.runner&&this.runner(O)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const F=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=O=>{const M=setTimeout(()=>O(F));let B=!1;return{dispose(){B||(B=!0,clearTimeout(M))}}}}else e.runWhenIdle=(F,O)=>{const M=requestIdleCallback(F,typeof O=="number"?{timeout:O}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(M))}}}}();class j{constructor(O){this._didRun=!1,this._executor=()=>{try{this._value=O()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=j;async function oe(F,O,M){let B;for(let V=0;V<M;V++)try{return await F()}catch(Q){B=Q,await f(O)}throw B}e.retry=oe;class q{hasPending(O){return this._pending?typeof O=="number"?this._pending.taskId===O:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var O;(O=this._pending)===null||O===void 0||O.cancel()}setPending(O,M,B){return this._pending={taskId:O,cancel:()=>B==null?void 0:B(),promise:M},M.then(()=>this.donePending(O),()=>this.donePending(O)),M}donePending(O){this._pending&&O===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const O=this._next;this._next=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}setNext(O){if(this._next)this._next.run=O;else{let M,B;const V=new Promise((Q,de)=>{M=Q,B=de});this._next={run:O,promise:V,promiseResolve:M,promiseReject:B}}return this._next.promise}}e.TaskSequentializer=q;class W{constructor(O){this.interval=O,this.lastIncrementTime=0,this.value=0}increment(){const O=Date.now();return O-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=O,this.value=0),this.value++,this.value}}e.IntervalCounter=W;class H{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((O,M)=>{this.completeCallback=O,this.errorCallback=M})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(O){return new Promise(M=>{this.completeCallback(O),this.resolved=!0,M()})}error(O){return new Promise(M=>{this.errorCallback(O),this.rejected=!0,M()})}cancel(){new Promise(O=>{this.errorCallback((0,I.canceled)()),this.rejected=!0,O()})}}e.DeferredPromise=H;class U extends T.Emitter{async fireAsync(O,M,B){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const V of this._listeners)this._asyncDeliveryQueue.push([V,O]);for(;this._asyncDeliveryQueue.size>0&&!M.isCancellationRequested;){const[V,Q]=this._asyncDeliveryQueue.shift(),de=[],we=Object.assign(Object.assign({},Q),{waitUntil:Ie=>{if(Object.isFrozen(de))throw new Error("waitUntil can NOT be called asynchronous");B&&(Ie=B(Ie,typeof V=="function"?V:V[0])),de.push(Ie)}});try{typeof V=="function"?V.call(void 0,we):V[0].call(V[1],we)}catch(Ie){(0,I.onUnexpectedError)(Ie);continue}Object.freeze(de),await L.settled(de).catch(Ie=>(0,I.onUnexpectedError)(Ie))}}}}e.AsyncEmitter=U;var L;(function(F){async function O(Q){return typeof Promise.allSettled=="function"?M(Q):B(Q)}F.allSettled=O;async function M(Q){return Promise.allSettled(Q)}async function B(Q){return Promise.all(Q.map(de=>de.then(we=>({status:"fulfilled",value:we}),we=>({status:"rejected",reason:we}))))}async function V(Q){let de;const we=await Promise.all(Q.map(Ie=>Ie.then(Ce=>Ce,Ce=>{de||(de=Ce)})));if(typeof de!="undefined")throw de;return we}F.settled=V})(L=e.Promises||(e.Promises={}))}),define(ge[99],pe([0,1,8,15]),function(K,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const T=new I.IdleValue(()=>{const l=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:l,collatorIsNumeric:l.resolvedOptions().numeric}}),A=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(l,f,t=!1){const n=l||"",r=f||"",i=T.value.collator.compare(n,r);return T.value.collatorIsNumeric&&i===0&&n!==r?n<r?-1:1:i}e.compareFileNames=k;function D(l,f){const t=A.value.collator;return l=l||"",f=f||"",u(t,l,f)}e.compareFileNamesDefault=D;function P(l,f,t=!1){t||(l=l&&l.toLowerCase(),f=f&&f.toLowerCase());const[n,r]=m(l),[i,o]=m(f);return n!==i?n<i?-1:1:r===o?0:r<o?-1:1}e.noIntlCompareFileNames=P;function s(l,f){const[t,n]=m(l),[r,i]=m(f);let o=T.value.collator.compare(n,i);if(o===0){if(T.value.collatorIsNumeric&&n!==i)return n<i?-1:1;if(o=T.value.collator.compare(t,r),T.value.collatorIsNumeric&&o===0&&t!==r)return t<r?-1:1}return o}e.compareFileExtensions=s;function C(l,f){l=l||"",f=f||"";const t=a(l),n=a(f),r=A.value.collator,i=y.value.collator;let o;return o=u(i,t,n),o!==0?o:u(r,l,f)}e.compareFileExtensionsDefault=C;const g=/^(.*?)(\.([^.]*))?$/;function m(l,f=!1){const t=l?g.exec(l):[];let n=[t&&t[1]||"",t&&t[3]||""];return f&&(!n[0]&&n[1]||n[0]&&n[0].charAt(0)===".")&&(n=[n[0]+"."+n[1],""]),n}function a(l){const f=l?g.exec(l):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function u(l,f,t){let n=l.compare(f,t);return n!==0?n:f.length!==t.length?f.length<t.length?-1:1:0}function E(l,f,t=!1){return t||(l=l&&l.toLowerCase(),f=f&&f.toLowerCase()),l===f?0:l<f?-1:1}function w(l,f,t=!1){const n=l.split(_.sep),r=f.split(_.sep),i=n.length-1,o=r.length-1;let c,v;for(let p=0;;p++){if(c=i===p,v=o===p,c&&v)return k(n[p],r[p],t);if(c)return-1;if(v)return 1;const h=E(n[p],r[p],t);if(h!==0)return h}}e.comparePaths=w;function S(l,f,t){const n=l.toLowerCase(),r=f.toLowerCase(),i=d(l,f,t);if(i)return i;const o=n.endsWith(t),c=r.endsWith(t);if(o!==c)return o?-1:1;const v=k(n,r);return v!==0?v:n.localeCompare(r)}e.compareAnything=S;function d(l,f,t){const n=l.toLowerCase(),r=f.toLowerCase(),i=n.startsWith(t),o=r.startsWith(t);if(i!==o)return i?-1:1;if(i&&o){if(n.length<r.length)return-1;if(n.length>r.length)return 1}return 0}e.compareByPrefix=d}),define(ge[100],pe([0,1,99,97,8,10,9]),function(K,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const k=0,D=[k,[]];function P(W,H,U,L){if(!W||!H)return D;const F=W.length,O=H.length;if(F<O)return D;const M=W.toLowerCase();return!L&&!M.includes(U)?D:s(H,U,O,W,M,F)}e.scoreFuzzy=P;function s(W,H,U,L,F,O){const M=[],B=[];for(let we=0;we<U;we++){const Ie=we*O,Ce=Ie-O,Le=we>0,z=W[we],Y=H[we];for(let ee=0;ee<O;ee++){const le=ee>0,me=Ie+ee,De=me-1,Oe=Ce+ee-1,be=le?M[De]:0,Pe=Le&&le?M[Oe]:0,Re=Le&&le?B[Oe]:0;let Be;!Pe&&Le?Be=0:Be=C(z,Y,L,F,ee,Re),Be&&Pe+Be>=be?(B[me]=Re+1,M[me]=Pe+Be):(B[me]=k,M[me]=be)}}const V=[];let Q=U-1,de=O-1;for(;Q>=0&&de>=0;){const we=Q*O+de;B[we]===k||(V.push(de),Q--),de--}return[M[U*O-1],V.reverse()]}function C(W,H,U,L,F,O){let M=0;if(!g(H,L[F]))return M;if(M+=1,O>0&&(M+=O*5),W===U[F]&&(M+=1),F===0)M+=8;else{const B=m(U.charCodeAt(F-1));B?M+=B:(0,I.isUpper)(U.charCodeAt(F))&&(M+=2)}return M}function g(W,H){return W===H?!0:W==="/"||W==="\\"?H==="/"||H==="\\":!1}function m(W){switch(W){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const a=[void 0,[]];function u(W,H,U=0,L=0){const F=H;return F.values&&F.values.length>1?E(W,F.values,U,L):w(W,H,U,L)}e.scoreFuzzy2=u;function E(W,H,U,L){let F=0;const O=[];for(const M of H){const[B,V]=w(W,M,U,L);if(typeof B!="number")return a;F+=B,O.push(...V)}return[F,c(O)]}function w(W,H,U,L){const F=(0,I.fuzzyScore)(H.original,H.originalLowercase,U,W,W.toLowerCase(),L,!0);return F?[F[0],(0,I.createMatches)(F)]:a}const S=Object.freeze({score:0}),d=1<<18,l=1<<17,f=1<<16;function t(W,H,U,L,F){if(!W||!H.normalized)return S;const O=L.getItemLabel(W);if(!O)return S;const M=L.getItemDescription(W);let B;M?B=`${O}${M}${H.normalized}${Array.isArray(H.values)?H.values.length:""}${U}`:B=`${O}${H.normalized}${Array.isArray(H.values)?H.values.length:""}${U}`;const V=F[B];if(V)return V;const Q=n(O,M,L.getItemPath(W),H,U);return F[B]=Q,Q}e.scoreItemFuzzy=t;function n(W,H,U,L,F){const O=!U||!L.containsPathSeparator;return U&&(A.isLinux?L.pathNormalized===U:(0,y.equalsIgnoreCase)(L.pathNormalized,U))?{score:d,labelMatch:[{start:0,end:W.length}],descriptionMatch:H?[{start:0,end:H.length}]:void 0}:L.values&&L.values.length>1?r(W,H,U,L.values,O,F):i(W,H,U,L,O,F)}function r(W,H,U,L,F,O){let M=0;const B=[],V=[];for(const Q of L){const{score:de,labelMatch:we,descriptionMatch:Ie}=i(W,H,U,Q,F,O);if(de===k)return S;M+=de,we&&B.push(...we),Ie&&V.push(...Ie)}return{score:M,labelMatch:c(B),descriptionMatch:c(V)}}function i(W,H,U,L,F,O){if(F||!H){const[M,B]=P(W,L.normalized,L.normalizedLowercase,O);if(M){const V=(0,I.matchesPrefix)(L.normalized,W);let Q;return V?(Q=l,Q+=Math.round(L.normalized.length/W.length*100)):Q=f,{score:Q+M,labelMatch:V||o(B)}}}if(H){let M=H;U&&(M=`${H}${T.sep}`);const B=M.length,V=`${M}${W}`,[Q,de]=P(V,L.normalized,L.normalizedLowercase,O);if(Q){const we=o(de),Ie=[],Ce=[];return we.forEach(Le=>{Le.start<B&&Le.end>B?(Ie.push({start:0,end:Le.end-B}),Ce.push({start:Le.start,end:B})):Le.start>=B?Ie.push({start:Le.start-B,end:Le.end-B}):Ce.push(Le)}),{score:Q,labelMatch:Ie,descriptionMatch:Ce}}}return S}function o(W){const H=[];if(!W)return H;let U;for(const L of W)U&&U.end===L?U.end+=1:(U={start:L,end:L+1},H.push(U));return H}function c(W){const H=W.sort((F,O)=>F.start-O.start),U=[];let L;for(const F of H)!L||!v(L,F)?(L=F,U.push(F)):(L.start=Math.min(L.start,F.start),L.end=Math.max(L.end,F.end));return U}function v(W,H){return!(W.end<H.start||H.end<W.start)}function p(W,H,U,L,F,O){const M=t(W,U,L,F,O),B=t(H,U,L,F,O),V=M.score,Q=B.score;if((V===d||Q===d)&&V!==Q)return V===d?-1:1;if(V>f||Q>f){if(V!==Q)return V>Q?-1:1;if(V<l&&Q<l){const Y=b(M.labelMatch,B.labelMatch);if(Y!==0)return Y}const Le=F.getItemLabel(W)||"",z=F.getItemLabel(H)||"";if(Le.length!==z.length)return Le.length-z.length}if(V!==Q)return V>Q?-1:1;const de=Array.isArray(M.labelMatch)&&M.labelMatch.length>0,we=Array.isArray(B.labelMatch)&&B.labelMatch.length>0;if(de&&!we)return-1;if(we&&!de)return 1;const Ie=h(W,M,F),Ce=h(H,B,F);return Ie&&Ce&&Ie!==Ce?Ce>Ie?-1:1:R(W,H,U,F)}e.compareItemsByFuzzyScore=p;function h(W,H,U){let L=-1,F=-1;if(H.descriptionMatch&&H.descriptionMatch.length?L=H.descriptionMatch[0].start:H.labelMatch&&H.labelMatch.length&&(L=H.labelMatch[0].start),H.labelMatch&&H.labelMatch.length){if(F=H.labelMatch[H.labelMatch.length-1].end,H.descriptionMatch&&H.descriptionMatch.length){const O=U.getItemDescription(W);O&&(F+=O.length)}}else H.descriptionMatch&&H.descriptionMatch.length&&(F=H.descriptionMatch[H.descriptionMatch.length-1].end);return F-L}function b(W,H){if(!W&&!H||(!W||!W.length)&&(!H||!H.length))return 0;if(!H||!H.length)return-1;if(!W||!W.length)return 1;const U=W[0].start,F=W[W.length-1].end-U,O=H[0].start,B=H[H.length-1].end-O;return F===B?0:B<F?1:-1}function R(W,H,U,L){const F=L.getItemLabel(W)||"",O=L.getItemLabel(H)||"",M=L.getItemDescription(W),B=L.getItemDescription(H),V=F.length+(M?M.length:0),Q=O.length+(B?B.length:0);if(V!==Q)return V-Q;const de=L.getItemPath(W),we=L.getItemPath(H);return de&&we&&de.length!==we.length?de.length-we.length:F!==O?(0,_.compareAnything)(F,O,U.normalized):M&&B&&M!==B?(0,_.compareAnything)(M,B,U.normalized):de&&we&&de!==we?(0,_.compareAnything)(de,we,U.normalized):0}const N=" ";function j(W){typeof W!="string"&&(W="");const H=W.toLowerCase(),{pathNormalized:U,normalized:L,normalizedLowercase:F}=oe(W),O=U.indexOf(T.sep)>=0;let M;const B=W.split(N);if(B.length>1)for(const V of B){const{pathNormalized:Q,normalized:de,normalizedLowercase:we}=oe(V);de&&(M||(M=[]),M.push({original:V,originalLowercase:V.toLowerCase(),pathNormalized:Q,normalized:de,normalizedLowercase:we}))}return{original:W,originalLowercase:H,pathNormalized:U,normalized:L,normalizedLowercase:F,values:M,containsPathSeparator:O}}e.prepareQuery=j;function oe(W){let H;A.isWindows?H=W.replace(/\//g,T.sep):H=W.replace(/\\/g,T.sep);const U=(0,y.stripWildcards)(H).replace(/\s/g,"");return{pathNormalized:H,normalized:U,normalizedLowercase:U.toLowerCase()}}function q(W){return Array.isArray(W)?j(W.map(H=>H.original).join(N)):j(W.original)}e.pieceToQuery=q}),define(ge[33],pe([0,1,9,29,8,24,15]),function(K,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const D="**",P="/",s="[/\\\\]",C="[^/\\\\]",g=/\//g;function m(M){switch(M){case 0:return"";case 1:return`${C}*?`;default:return`(?:${s}|${C}+${s}|${s}${C}+)*?`}}function a(M,B){if(!M)return[];const V=[];let Q=!1,de=!1,we="";for(const Ie of M){switch(Ie){case B:if(!Q&&!de){V.push(we),we="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":de=!0;break;case"]":de=!1;break}we+=Ie}return we&&V.push(we),V}e.splitGlobAware=a;function u(M){if(!M)return"";let B="";const V=a(M,P);if(V.every(Q=>Q===D))B=".*";else{let Q=!1;V.forEach((de,we)=>{if(de===D){Q||(B+=m(2),Q=!0);return}let Ie=!1,Ce="",Le=!1,z="";for(const Y of de){if(Y!=="}"&&Ie){Ce+=Y;continue}if(Le&&(Y!=="]"||!z)){let ee;Y==="-"?ee=Y:(Y==="^"||Y==="!")&&!z?ee="^":Y===P?ee="":ee=_.escapeRegExpCharacters(Y),z+=ee;continue}switch(Y){case"{":Ie=!0;continue;case"[":Le=!0;continue;case"}":B+=`(?:${a(Ce,",").map(me=>u(me)).join("|")})`,Ie=!1,Ce="";break;case"]":B+="["+z+"]",Le=!1,z="";break;case"?":B+=C;continue;case"*":B+=m(1);continue;default:B+=_.escapeRegExpCharacters(Y)}}we<V.length-1&&(V[we+1]!==D||we+2<V.length)&&(B+=s),Q=!1})}return B}const E=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),n=function(){return!1},r=function(){return null};function i(M,B){if(!M)return r;let V;typeof M!="string"?V=M.pattern:V=M,V=V.trim();const Q=`${V}_${!!B.trimForExclusions}`;let de=t.get(Q);if(de)return o(de,M);let we;if(E.test(V)){const Ie=V.substr(4);de=function(Ce,Le){return typeof Ce=="string"&&Ce.endsWith(Ie)?V:null}}else(we=w.exec(c(V,B)))?de=v(we[1],V):(B.trimForExclusions?d:S).test(V)?de=p(V,B):(we=l.exec(c(V,B)))?de=h(we[1].substr(1),V,!0):(we=f.exec(c(V,B)))?de=h(we[1],V,!1):de=b(V);return t.set(Q,de),o(de,M)}function o(M,B){return typeof B=="string"?M:function(V,Q){return I.isEqualOrParent(V,B.base)?M(T.relative(B.base,V),Q):null}}function c(M,B){return B.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function v(M,B){const V=`/${M}`,Q=`\\${M}`,de=function(Ie,Ce){return typeof Ie!="string"?null:Ce?Ce===M?B:null:Ie===M||Ie.endsWith(V)||Ie.endsWith(Q)?B:null},we=[M];return de.basenames=we,de.patterns=[B],de.allBasenames=we,de}function p(M,B){const V=O(M.slice(1,-1).split(",").map(Ce=>i(Ce,B)).filter(Ce=>Ce!==r),M),Q=V.length;if(!Q)return r;if(Q===1)return V[0];const de=function(Ce,Le){for(let z=0,Y=V.length;z<Y;z++)if(V[z](Ce,Le))return M;return null},we=V.find(Ce=>!!Ce.allBasenames);we&&(de.allBasenames=we.allBasenames);const Ie=V.reduce((Ce,Le)=>Le.allPaths?Ce.concat(Le.allPaths):Ce,[]);return Ie.length&&(de.allPaths=Ie),de}function h(M,B,V){const Q=T.sep===T.posix.sep,de=Q?M:M.replace(g,T.sep),we=T.sep+de,Ie=T.posix.sep+M,Ce=V?function(Le,z){return typeof Le=="string"&&(Le===de||Le.endsWith(we)||!Q&&(Le===M||Le.endsWith(Ie)))?B:null}:function(Le,z){return typeof Le=="string"&&(Le===de||!Q&&Le===M)?B:null};return Ce.allPaths=[(V?"*/":"./")+M],Ce}function b(M){try{const B=new RegExp(`^${u(M)}$`);return function(V){return B.lastIndex=0,typeof V=="string"&&B.test(V)?M:null}}catch(B){return r}}function R(M,B,V){return!M||typeof B!="string"?!1:N(M)(B,void 0,V)}e.match=R;function N(M,B={}){if(!M)return n;if(typeof M=="string"||W(M)){const V=i(M,B);if(V===r)return n;const Q=function(de,we){return!!V(de,we)};return V.allBasenames&&(Q.allBasenames=V.allBasenames),V.allPaths&&(Q.allPaths=V.allPaths),Q}return L(M,B)}e.parse=N;function j(M){if(!!M){let B;return V=>(B||(B=(M()||Promise.resolve([])).then(Q=>Q?q(Q):{})),B.then(Q=>!!Q[V]))}}e.hasSiblingPromiseFn=j;function oe(M){if(!!M){let B;return V=>{if(!B){const Q=M();B=Q?q(Q):{}}return!!B[V]}}}e.hasSiblingFn=oe;function q(M){const B={};for(const V of M)B[V]=!0;return B}function W(M){const B=M;return B&&typeof B.base=="string"&&typeof B.pattern=="string"}e.isRelativePattern=W;function H(M){return M.allBasenames||[]}e.getBasenameTerms=H;function U(M){return M.allPaths||[]}e.getPathTerms=U;function L(M,B){const V=O(Object.getOwnPropertyNames(M).map(Ce=>F(Ce,M[Ce],B)).filter(Ce=>Ce!==r)),Q=V.length;if(!Q)return r;if(!V.some(Ce=>!!Ce.requiresSiblings)){if(Q===1)return V[0];const Ce=function(Y,ee){for(let le=0,me=V.length;le<me;le++){const De=V[le](Y,ee);if(De)return De}return null},Le=V.find(Y=>!!Y.allBasenames);Le&&(Ce.allBasenames=Le.allBasenames);const z=V.reduce((Y,ee)=>ee.allPaths?Y.concat(ee.allPaths):Y,[]);return z.length&&(Ce.allPaths=z),Ce}const de=function(Ce,Le,z){let Y;for(let ee=0,le=V.length;ee<le;ee++){const me=V[ee];me.requiresSiblings&&z&&(Le||(Le=T.basename(Ce)),Y||(Y=Le.substr(0,Le.length-T.extname(Ce).length)));const De=me(Ce,Le,Y,z);if(De)return De}return null},we=V.find(Ce=>!!Ce.allBasenames);we&&(de.allBasenames=we.allBasenames);const Ie=V.reduce((Ce,Le)=>Le.allPaths?Ce.concat(Le.allPaths):Ce,[]);return Ie.length&&(de.allPaths=Ie),de}function F(M,B,V){if(B===!1)return r;const Q=i(M,V);if(Q===r)return r;if(typeof B=="boolean")return Q;if(B){const de=B.when;if(typeof de=="string"){const we=(Ie,Ce,Le,z)=>{if(!z||!Q(Ie,Ce))return null;const Y=de.replace("$(basename)",Le),ee=z(Y);return(0,y.isThenable)(ee)?ee.then(le=>le?M:null):ee?M:null};return we.requiresSiblings=!0,we}}return Q}function O(M,B){const V=M.filter(Ce=>!!Ce.basenames);if(V.length<2)return M;const Q=V.reduce((Ce,Le)=>{const z=Le.basenames;return z?Ce.concat(z):Ce},[]);let de;if(B){de=[];for(let Ce=0,Le=Q.length;Ce<Le;Ce++)de.push(B)}else de=V.reduce((Ce,Le)=>{const z=Le.patterns;return z?Ce.concat(z):Ce},[]);const we=function(Ce,Le){if(typeof Ce!="string")return null;if(!Le){let Y;for(Y=Ce.length;Y>0;Y--){const ee=Ce.charCodeAt(Y-1);if(ee===47||ee===92)break}Le=Ce.substr(Y)}const z=Q.indexOf(Le);return z!==-1?de[z]:null};we.basenames=Q,we.patterns=de,we.allBasenames=Q;const Ie=M.filter(Ce=>!Ce.basenames);return Ie.push(we),Ie}}),define(ge[76],pe([0,1,2,8,9,12,10,25,29]),function(K,e,_,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(i,o,c){if(typeof i=="string"&&(i=_.URI.file(i)),c){const p=c.getWorkspaceFolder(i);if(p){const h=c.getWorkspace().folders.length>1;let b;if((0,k.isEqual)(p.uri,i)?b="":b=(0,k.relativePath)(p.uri,i),h){const R=p.name?p.name:(0,k.basename)(p.uri);b=b?R+" \u2022 "+b:R}return b}}if(i.scheme!==A.Schemas.file&&i.scheme!==A.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(i.fsPath))return(0,I.normalize)(C(i.fsPath));let v=(0,I.normalize)(i.fsPath);return!y.isWindows&&(o==null?void 0:o.userHome)&&(v=m(v,o.userHome.fsPath)),v}e.getPathLabel=P;function s(i){if(!!i){typeof i=="string"&&(i=_.URI.file(i));const o=(0,k.basename)(i)||(i.scheme===A.Schemas.file?i.fsPath:i.path);return y.isWindows&&(0,D.isRootOrDriveLetter)(o)?C(o):o}}e.getBaseLabel=s;function C(i){return(0,D.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=C;let g=Object.create(null);function m(i,o){if(y.isWindows||!i||!o)return i;let c=g.original===o?g.normalized:void 0;return c||(c=`${(0,T.rtrim)(o,I.posix.sep)}${I.posix.sep}`,g={original:o,normalized:c}),(y.isLinux?i.startsWith(c):(0,T.startsWithIgnoreCase)(i,c))&&(i=`~/${i.substr(c.length)}`),i}e.tildify=m;function a(i,o){return i.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=a;const u="\u2026",E="\\\\",w="~";function S(i,o=I.sep){const c=new Array(i.length);let v=!1;for(let p=0;p<i.length;p++){let h=i[p];if(h===""){c[p]=`.${o}`;continue}if(!h){c[p]=h;continue}v=!0;let b="";h.indexOf(E)===0?(b=h.substr(0,h.indexOf(E)+E.length),h=h.substr(h.indexOf(E)+E.length)):h.indexOf(o)===0?(b=h.substr(0,h.indexOf(o)+o.length),h=h.substr(h.indexOf(o)+o.length)):h.indexOf(w)===0&&(b=h.substr(0,h.indexOf(w)+w.length),h=h.substr(h.indexOf(w)+w.length));const R=h.split(o);for(let N=1;v&&N<=R.length;N++)for(let j=R.length-N;v&&j>=0;j--){v=!1;let oe=R.slice(j,j+N).join(o);for(let q=0;!v&&q<i.length;q++)if(q!==p&&i[q]&&i[q].indexOf(oe)>-1){const W=j+N===R.length,H=j>0&&i[q].indexOf(o)>-1?o+oe:oe,U=i[q].endsWith(H);v=!W||U}if(!v){let q="";(R[0].endsWith(":")||b!=="")&&(j===1&&(j=0,N++,oe=R[0]+o+oe),j>0&&(q=R[0]+o),q=b+q),j>0&&(q=q+u+o),q=q+oe,j+N<R.length&&(q=q+o+u),c[p]=q}}v&&(c[p]=h)}return c}e.shorten=S;var d;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function l(i,o=Object.create(null)){const c=[];let v=!1,p="";for(const h of i)if(h==="$"||v&&h==="{")p&&c.push({value:p,type:d.TEXT}),p="",v=!0;else if(h==="}"&&v){const b=o[p];if(typeof b=="string")b.length&&c.push({value:b,type:d.VARIABLE});else if(b){const R=c[c.length-1];(!R||R.type!==d.SEPARATOR)&&c.push({value:b.label,type:d.SEPARATOR})}p="",v=!1}else p+=h;return p&&!v&&c.push({value:p,type:d.TEXT}),c.filter((h,b)=>{if(h.type===d.SEPARATOR){const R=c[b-1],N=c[b+1];return[R,N].every(j=>j&&(j.type===d.VARIABLE||j.type===d.TEXT)&&j.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=l;function f(i,o){return y.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):i.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=f;function t(i,o){return y.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,""):y.isWindows?i.replace(/&&|&/g,c=>c==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=n;function r(i){const o=i.indexOf("/")!==-1?I.posix:I.win32,c=o.basename(i),v=o.dirname(i);return c.length?{name:c,parentPath:v}:{name:v,parentPath:""}}e.splitName=r}),define(ge[101],pe([0,1,2]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(s){return s.toJSON()}class T{constructor(C){this._uriTransformer=C}transformIncoming(C){const g=this._uriTransformer.transformIncoming(C);return g===C?C:I(_.URI.from(g))}transformOutgoing(C){const g=this._uriTransformer.transformOutgoing(C);return g===C?C:I(_.URI.from(g))}transformOutgoingURI(C){const g=this._uriTransformer.transformOutgoing(C);return g===C?C:_.URI.from(g)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(s){return s}transformOutgoing(s){return s}transformOutgoingURI(s){return s}transformOutgoingScheme(s){return s}};function A(s,C,g){if(!s||g>200)return null;if(typeof s=="object"){if(s instanceof _.URI)return C.transformOutgoing(s);for(let m in s)if(Object.hasOwnProperty.call(s,m)){const a=A(s[m],C,g+1);a!==null&&(s[m]=a)}}return null}function y(s,C){const g=A(s,C,0);return g===null?s:g}e.transformOutgoingURIs=y;function k(s,C,g,m){if(!s||m>200)return null;if(typeof s=="object"){if(s.$mid===1)return g?_.URI.revive(C.transformIncoming(s)):C.transformIncoming(s);for(let a in s)if(Object.hasOwnProperty.call(s,a)){const u=k(s[a],C,g,m+1);u!==null&&(s[a]=u)}}return null}function D(s,C){const g=k(s,C,!1,0);return g===null?s:g}e.transformIncomingURIs=D;function P(s,C){const g=k(s,C,!0,0);return g===null?s:g}e.transformAndReviveIncomingURIs=P}),define(ge[30],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const _=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(D){return _.test(D)}e.isUUID=I;const T=new Uint8Array(16),A=[];for(let D=0;D<256;D++)A.push(D.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(D){for(let P=0;P<D.length;P++)D[P]=Math.floor(Math.random()*256);return D};function k(){y(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let D=0,P="";return P+=A[T[D++]],P+=A[T[D++]],P+=A[T[D++]],P+=A[T[D++]],P+="-",P+=A[T[D++]],P+=A[T[D++]],P+="-",P+=A[T[D++]],P+=A[T[D++]],P+="-",P+=A[T[D++]],P+=A[T[D++]],P+="-",P+=A[T[D++]],P+=A[T[D++]],P+=A[T[D++]],P+=A[T[D++]],P+=A[T[D++]],P+=A[T[D++]],P}e.generateUuid=k}),define(ge[137],pe([0,1,102]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class I{constructor(A="utf8"){this.stringDecoder=new _.StringDecoder(A),this.remaining=null}write(A){const y=[],k=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(k.length<1)return y;let D=0,P,s=D;for(;s<k.length;)if(P=k.charCodeAt(s),P===13||P===10){if(y.push(k.substring(D,s)),s++,s<k.length){const C=P;P=k.charCodeAt(s),(C===13&&P===10||C===10&&P===13)&&s++}D=s}else s++;return this.remaining=D<k.length?k.substr(D):null,y}end(){return this.remaining}}e.LineDecoder=I}),define(ge[26],pe([0,1,37,48,8,15,10,29,30,75,25,2]),function(K,e,_,I,T,A,y,k,D,P,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var g;(function(H){H[H.UNLINK=0]="UNLINK",H[H.MOVE=1]="MOVE"})(g=e.RimRafMode||(e.RimRafMode={}));async function m(H,U=g.UNLINK){if((0,k.isRootOrDriveLetter)(H))throw new Error("rimraf - will refuse to recursively delete root");return U===g.UNLINK?u(H):a(H)}e.rimraf=m;async function a(H){try{const U=(0,T.join)((0,I.tmpdir)(),(0,D.generateUuid)());try{await _.promises.rename(H,U)}catch(L){return u(H)}u(U).catch(L=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function u(H){return _.promises.rmdir(H,{recursive:!0,maxRetries:3})}function E(H){if((0,k.isRootOrDriveLetter)(H))throw new Error("rimraf - will refuse to recursively delete root");_.rmdirSync(H,{recursive:!0})}e.rimrafSync=E;async function w(H,U){return l(await(U?S(H):_.promises.readdir(H)))}e.readdir=w;async function S(H){try{return await _.promises.readdir(H,{withFileTypes:!0})}catch(F){console.warn("[node.js fs] readdir with filetypes failed with error: ",F)}const U=[],L=await w(H);for(const F of L){let O=!1,M=!1,B=!1;try{const V=await _.promises.lstat((0,T.join)(H,F));O=V.isFile(),M=V.isDirectory(),B=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}U.push({name:F,isFile:()=>O,isDirectory:()=>M,isSymbolicLink:()=>B})}return U}function d(H){return l(_.readdirSync(H))}e.readdirSync=d;function l(H){return H.map(U=>typeof U=="string"?y.isMacintosh?(0,P.normalizeNFC)(U):U:(U.name=y.isMacintosh?(0,P.normalizeNFC)(U.name):U.name,U))}async function f(H){const U=await w(H),L=[];for(const F of U)await n.existsDirectory((0,T.join)(H,F))&&L.push(F);return L}e.readDirsInDir=f;function t(H,U=1e3){return new Promise(L=>{let F=!1;const O=setInterval(()=>{F||(F=!0,_.access(H,M=>{F=!1,M&&(clearInterval(O),L(void 0))}))},U)})}e.whenDeleted=t;var n;(function(H){async function U(O){let M;try{if(M=await _.promises.lstat(O),!M.isSymbolicLink())return{stat:M}}catch(B){}try{return{stat:await _.promises.stat(O),symbolicLink:(M==null?void 0:M.isSymbolicLink())?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};if(y.isWindows&&B.code==="EACCES")try{return{stat:await _.promises.stat(await _.promises.readlink(O)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};throw V}throw B}}H.stat=U;async function L(O){try{const{stat:M,symbolicLink:B}=await H.stat(O);return M.isFile()&&(B==null?void 0:B.dangling)!==!0}catch(M){}return!1}H.existsFile=L;async function F(O){try{const{stat:M,symbolicLink:B}=await H.stat(O);return M.isDirectory()&&(B==null?void 0:B.dangling)!==!0}catch(M){}return!1}H.existsDirectory=F})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new A.ResourceQueue;function i(H,U,L){return r.queueFor(C.URI.file(H),s.extUriBiasedIgnorePathCase).queue(()=>{const F=p(L);return new Promise((O,M)=>c(H,U,F,B=>B?M(B):O()))})}e.writeFile=i;let o=!0;function c(H,U,L,F){if(!o)return _.writeFile(H,U,{mode:L.mode,flag:L.flag},F);_.open(H,L.flag,L.mode,(O,M)=>{if(O)return F(O);_.writeFile(M,U,B=>{if(B)return _.close(M,()=>F(B));_.fdatasync(M,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),o=!1),_.close(M,Q=>F(Q))))})})}function v(H,U,L){const F=p(L);if(!o)return _.writeFileSync(H,U,{mode:F.mode,flag:F.flag});const O=_.openSync(H,F.flag,F.mode);try{_.writeFileSync(O,U);try{_.fdatasyncSync(O)}catch(M){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",M),o=!1}}finally{_.closeSync(O)}}e.writeFileSync=v;function p(H){return H?{mode:typeof H.mode=="number"?H.mode:438,flag:typeof H.flag=="string"?H.flag:"w"}:{mode:438,flag:"w"}}async function h(H,U){if(H!==U){async function L(F){try{const O=await _.promises.lstat(F);if(O.isDirectory()||O.isSymbolicLink())return;const M=await _.promises.open(F,"a");try{await M.utimes(O.atime,new Date)}finally{await M.close()}}catch(O){}}try{await _.promises.rename(H,U),await L(U)}catch(F){if(H.toLowerCase()!==U.toLowerCase()&&F.code==="EXDEV"||H.endsWith("."))await b(H,U,{preserveSymlinks:!1}),await m(H,g.MOVE),await L(U);else throw F}}}e.move=h;async function b(H,U,L){return N(H,U,{root:{source:H,target:U},options:L,handledSourcePaths:new Set})}e.copy=b;const R=511;async function N(H,U,L){if(!L.handledSourcePaths.has(H)){L.handledSourcePaths.add(H);const{stat:F,symbolicLink:O}=await n.stat(H);if(O){if(L.options.preserveSymlinks)try{return await q(H,U,L)}catch(M){console.warn("[node.js fs] copy of symlink failed: ",M)}if(O.dangling)return}return F.isDirectory()?j(H,U,F.mode&R,L):oe(H,U,F.mode&R)}}async function j(H,U,L,F){await _.promises.mkdir(U,{recursive:!0,mode:L});const O=await w(H);for(const M of O)await N((0,T.join)(H,M),(0,T.join)(U,M),F)}async function oe(H,U,L){await _.promises.copyFile(H,U),await _.promises.chmod(U,L)}async function q(H,U,L){let F=await _.promises.readlink(H);(0,k.isEqualOrParent)(F,L.root.source,!y.isLinux)&&(F=(0,T.join)(L.root.target,F.substr(L.root.source.length+1))),await _.promises.symlink(F,U)}async function W(H){try{return await _.promises.access(H),!0}catch(U){return!1}}e.exists=W}),define(ge[103],pe([0,1,37,285,9,8,26]),function(K,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function k(C){const g=(0,A.dirname)(C);if(C===g)return C;const m=((0,A.basename)(C)||C).toLowerCase();try{const u=(0,y.readdirSync)(g).filter(E=>E.toLowerCase()===m);if(u.length===1){const E=k(g);if(E)return(0,A.join)(E,u[0])}else if(u.length>1){const E=u.indexOf(m);if(E>=0){const w=k(g);if(w)return(0,A.join)(w,u[E])}}}catch(a){}return null}e.realcaseSync=k;async function D(C){try{return await(0,I.promisify)(_.realpath)(C)}catch(g){const m=s(C);return await _.promises.access(m,_.constants.R_OK),m}}e.realpath=D;function P(C){try{return _.realpathSync(C)}catch(g){const m=s(C);return _.accessSync(m,_.constants.R_OK),m}}e.realpathSync=P;function s(C){return(0,T.rtrim)((0,A.normalize)(C),A.sep)}});var _t=this&&this.__await||function(K){return this instanceof _t?(this.v=K,this):new _t(K)},Ln=this&&this.__asyncGenerator||function(K,e,_){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var I=_.apply(K,e||[]),T,A=[];return T={},y("next"),y("throw"),y("return"),T[Symbol.asyncIterator]=function(){return this},T;function y(g){I[g]&&(T[g]=function(m){return new Promise(function(a,u){A.push([g,m,a,u])>1||k(g,m)})})}function k(g,m){try{D(I[g](m))}catch(a){C(A[0][3],a)}}function D(g){g.value instanceof _t?Promise.resolve(g.value.v).then(P,s):C(A[0][2],g)}function P(g){k("next",g)}function s(g){k("throw",g)}function C(g,m){g(m),A.shift(),A.length&&k(A[0][0],A[0][1])}},mn=this&&this.__asyncValues||function(K){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=K[Symbol.asyncIterator],_;return e?e.call(K):(K=typeof __values=="function"?__values(K):K[Symbol.iterator](),_={},I("next"),I("throw"),I("return"),_[Symbol.asyncIterator]=function(){return this},_);function I(A){_[A]=K[A]&&function(y){return new Promise(function(k,D){y=K[A](y),T(k,D,y.done,y.value)})}}function T(A,y,k,D){Promise.resolve(D).then(function(P){A({value:P,done:k})},y)}};define(ge[104],pe([0,1,26,48,8]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,y=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var D;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(D||(D={}));let P;switch(process.arch){case"ia32":case"x32":P=1;break;case"arm":case"arm64":P=2;break;default:P=0;break}let s;process.env.PROCESSOR_ARCHITEW6432?s=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?s=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?s=1:s=0;class C{constructor(f,t,n){this.exePath=f,this.displayName=t,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await _.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:l=!1}={}){return l?P===0?process.env["ProgramFiles(x86)"]||null:s===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:l=!1,findPreview:f=!1}={}){const t=g({useAlternateBitness:l});if(!t)return null;const n=T.join(t,"PowerShell");if(!await _.SymlinkSupport.existsDirectory(n))return null;let r=-1,i=null;for(const v of await _.readdir(n)){let p=-1;if(f){const b=v.indexOf("-");if(b<0)continue;const R=v.substring(0,b);if(!A.test(R)||v.substring(b+1)!=="preview")continue;p=parseInt(R,10)}else{if(!A.test(v))continue;p=parseInt(v,10)}if(!(p<=r)){const h=T.join(n,v,"pwsh.exe");!await _.SymlinkSupport.existsFile(h)||(i=h,r=p)}}if(!i)return null;const o=t.includes("x86")?" (x86)":"",c=f?" Preview":"";return new C(i,`PowerShell${c}${o}`,!0)}async function a({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const f=T.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await _.SymlinkSupport.existsDirectory(f))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=l?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:y,pwshMsixName:"PowerShell (Store)"};for(const r of await _.readdir(f))if(t.test(r)){const i=T.join(f,r,"pwsh.exe");return new C(i,n)}return null}function u(){const l=T.join(I.homedir(),".dotnet","tools","pwsh.exe");return new C(l,".NET Core PowerShell Global Tool")}function E(){const l=T.join(process.env.windir,P===1&&s!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(l,"Windows PowerShell",!0)}function w(){return Ln(this,arguments,function*(){let f=yield _t(m());f&&(yield yield _t(f)),f=yield _t(m({useAlternateBitness:!0})),f&&(yield yield _t(f)),f=yield _t(a()),f&&(yield yield _t(f)),f=u(),f&&(yield yield _t(f)),f=yield _t(m({findPreview:!0})),f&&(yield yield _t(f)),f=yield _t(a({findPreview:!0})),f&&(yield yield _t(f)),f=yield _t(m({useAlternateBitness:!0,findPreview:!0})),f&&(yield yield _t(f)),f=E(),f&&(yield yield _t(f))})}function S(){return Ln(this,arguments,function*(){var f,t;try{for(var n=mn(w()),r;r=yield _t(n.next()),!r.done;){const i=r.value;(yield _t(i.exists()))&&(yield yield _t(i))}}catch(i){f={error:i}}finally{try{r&&!r.done&&(t=n.return)&&(yield _t(t.call(n)))}finally{if(f)throw f.error}}})}e.enumeratePowerShellInstallations=S;async function d(){var l,f;try{for(var t=mn(S()),n;n=await t.next(),!n.done;)return n.value}catch(r){l={error:r}}finally{try{n&&!n.done&&(f=t.return)&&await f.call(t)}finally{if(l)throw l.error}}return null}e.getFirstAvailablePowerShellInstallation=d}),define(ge[105],pe([0,1,3,6,15,21,18,22,19,11,58,9]),function(K,e,_,I,T,A,y,k,D,P,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var g;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(g=e.RequestType||(e.RequestType={}));function m(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(a=e.ResponseType||(e.ResponseType={}));function u(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(E||(E={}));class w{constructor(O){this.buffer=O,this.pos=0}read(O){const M=this.buffer.slice(this.pos,this.pos+O);return this.pos+=M.byteLength,M}}class S{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var d;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(d||(d={}));function l(F){const O=k.VSBuffer.alloc(4);return O.writeUInt32BE(F,0),O}function f(F){return F.read(4).readUInt32BE(0)}function t(F){const O=k.VSBuffer.alloc(1);return O.writeUInt8(F,0),O}const n={Undefined:t(d.Undefined),String:t(d.String),Buffer:t(d.Buffer),VSBuffer:t(d.VSBuffer),Array:t(d.Array),Object:t(d.Object)},r=typeof Buffer!="undefined";function i(F,O){if(typeof O=="undefined")F.write(n.Undefined);else if(typeof O=="string"){const M=k.VSBuffer.fromString(O);F.write(n.String),F.write(l(M.byteLength)),F.write(M)}else if(r&&Buffer.isBuffer(O)){const M=k.VSBuffer.wrap(O);F.write(n.Buffer),F.write(l(M.byteLength)),F.write(M)}else if(O instanceof k.VSBuffer)F.write(n.VSBuffer),F.write(l(O.byteLength)),F.write(O);else if(Array.isArray(O)){F.write(n.Array),F.write(l(O.length));for(const M of O)i(F,M)}else{const M=k.VSBuffer.fromString(JSON.stringify(O));F.write(n.Object),F.write(l(M.byteLength)),F.write(M)}}function o(F){switch(F.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return F.read(f(F)).toString();case d.Buffer:return F.read(f(F)).buffer;case d.VSBuffer:return F.read(f(F));case d.Array:{const M=f(F),B=[];for(let V=0;V<M;V++)B.push(o(F));return B}case d.Object:return JSON.parse(F.read(f(F)).toString())}}class c{constructor(O,M,B=null,V=1e3){this.protocol=O,this.ctx=M,this.logger=B,this.timeoutDelay=V,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Q=>this.onRawMessage(Q)),this.sendResponse({type:200})}registerChannel(O,M){this.channels.set(O,M),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const M=this.send([O.type]);this.logger&&this.logger.logOutgoing(M,0,1,u(O.type));return}case 201:case 202:case 204:case 203:{const M=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(M,O.id,1,u(O.type),O.data);return}}}send(O,M=void 0){const B=new S;return i(B,O),i(B,M),this.sendBuffer(B.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(M){return 0}}onRawMessage(O){const M=new w(O),B=o(M),V=o(M),Q=B[0];switch(Q){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,B[1],1,`${m(Q)}: ${B[2]}.${B[3]}`,V),this.onPromise({type:Q,id:B[1],channelName:B[2],name:B[3],arg:V});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,B[1],1,`${m(Q)}: ${B[2]}.${B[3]}`,V),this.onEventListen({type:Q,id:B[1],channelName:B[2],name:B[3],arg:V});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,B[1],1,`${m(Q)}`),this.disposeActiveRequest({type:Q,id:B[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,B[1],1,`${m(Q)}`),this.disposeActiveRequest({type:Q,id:B[1]})}}onPromise(O){const M=this.channels.get(O.channelName);if(!M){this.collectPendingRequest(O);return}const B=new A.CancellationTokenSource;let V;try{V=M.call(this.ctx,O.name,O.arg,B.token)}catch(we){V=Promise.reject(we)}const Q=O.id;V.then(we=>{this.sendResponse({id:Q,data:we,type:201}),this.activeRequests.delete(O.id)},we=>{we instanceof Error?this.sendResponse({id:Q,data:{message:we.message,name:we.name,stack:we.stack?we.stack.split?we.stack.split(`
`):we.stack:void 0},type:202}):this.sendResponse({id:Q,data:we,type:203}),this.activeRequests.delete(O.id)});const de=(0,I.toDisposable)(()=>B.cancel());this.activeRequests.set(O.id,de)}onEventListen(O){const M=this.channels.get(O.channelName);if(!M){this.collectPendingRequest(O);return}const B=O.id,Q=M.listen(this.ctx,O.name,O.arg)(de=>this.sendResponse({id:B,data:de,type:204}));this.activeRequests.set(O.id,Q)}disposeActiveRequest(O){const M=this.activeRequests.get(O.id);M&&(M.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let M=this.pendingRequests.get(O.channelName);M||(M=[],this.pendingRequests.set(O.channelName,M));const B=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);M.push({request:O,timeoutTimer:B})}flushPendingRequests(O){const M=this.pendingRequests.get(O);if(M){for(const B of M)switch(clearTimeout(B.timeoutTimer),B.request.type){case 100:this.onPromise(B.request);break;case 102:this.onEventListen(B.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var v;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(v=e.RequestInitiator||(e.RequestInitiator={}));class p{constructor(O,M=null){this.protocol=O,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(B=>this.onBuffer(B)),this.logger=M}getChannel(O){const M=this;return{call(B,V,Q){return M.isDisposed?Promise.reject(y.canceled()):M.requestPromise(O,B,V,Q)},listen(B,V){return M.isDisposed?Promise.reject(y.canceled()):M.requestEvent(O,B,V)}}}requestPromise(O,M,B,V=A.CancellationToken.None){const Q=this.lastRequestId++,we={id:Q,type:100,channelName:O,name:M,arg:B};if(V.isCancellationRequested)return Promise.reject(y.canceled());let Ie;return new Promise((Le,z)=>{if(V.isCancellationRequested)return z(y.canceled());const Y=()=>{const De=Oe=>{switch(Oe.type){case 201:this.handlers.delete(Q),Le(Oe.data);break;case 202:this.handlers.delete(Q);const be=new Error(Oe.data.message);be.stack=Oe.data.stack,be.name=Oe.data.name,z(be);break;case 203:this.handlers.delete(Q),z(Oe.data);break}};this.handlers.set(Q,De),this.sendRequest(we)};let ee=null;this.state===E.Idle?Y():(ee=(0,T.createCancelablePromise)(De=>this.whenInitialized()),ee.then(()=>{ee=null,Y()}));const le=()=>{ee?(ee.cancel(),ee=null):this.sendRequest({id:Q,type:101}),z(y.canceled())},me=V.onCancellationRequested(le);Ie=(0,I.combinedDisposable)((0,I.toDisposable)(le),me),this.activeRequests.add(Ie)}).finally(()=>{this.activeRequests.delete(Ie)})}requestEvent(O,M,B){const V=this.lastRequestId++,de={id:V,type:102,channelName:O,name:M,arg:B};let we=null;const Ie=new _.Emitter({onFirstListenerAdd:()=>{we=(0,T.createCancelablePromise)(Le=>this.whenInitialized()),we.then(()=>{we=null,this.activeRequests.add(Ie),this.sendRequest(de)})},onLastListenerRemove:()=>{we?(we.cancel(),we=null):(this.activeRequests.delete(Ie),this.sendRequest({id:V,type:103}))}}),Ce=Le=>Ie.fire(Le.data);return this.handlers.set(V,Ce),Ie.event}sendRequest(O){switch(O.type){case 100:case 102:{const M=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(M,O.id,0,`${m(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const M=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(M,O.id,0,m(O.type));return}}}send(O,M=void 0){const B=new S;return i(B,O),i(B,M),this.sendBuffer(B.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(M){return 0}}onBuffer(O){const M=new w(O),B=o(M),V=o(M),Q=B[0];switch(Q){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,u(Q)),this.onResponse({type:B[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,B[1],0,u(Q),V),this.onResponse({type:B[0],id:B[1],data:V})}}onResponse(O){if(O.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}const M=this.handlers.get(O.id);M&&M(O)}whenInitialized(){return this.state===E.Idle?Promise.resolve():_.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelClient=p;class h{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:M,onDidClientDisconnect:B})=>{_.Event.once(M.onMessage)(Q=>{const de=new w(Q),we=o(de),Ie=new c(M,we),Ce=new p(M);this.channels.forEach((z,Y)=>Ie.registerChannel(Y,z));const Le={channelServer:Ie,channelClient:Ce,ctx:we};this._connections.add(Le),this._onDidAddConnection.fire(Le),B(()=>{Ie.dispose(),Ce.dispose(),this._connections.delete(Le),this._onDidRemoveConnection.fire(Le)})})})}get connections(){const O=[];return this._connections.forEach(M=>O.push(M)),O}getChannel(O,M){const B=this;return{call(V,Q,de){let we;if((0,P.isFunction)(M)){let Ce=(0,D.getRandomElement)(B.connections.filter(M));we=Ce?Promise.resolve(Ce):_.Event.toPromise(_.Event.filter(B.onDidAddConnection,M))}else we=M.routeCall(B,V,Q);const Ie=we.then(Ce=>Ce.channelClient.getChannel(O));return R(Ie).call(V,Q,de)},listen(V,Q){if((0,P.isFunction)(M))return B.getMulticastEvent(O,M,V,Q);const de=M.routeEvent(B,V,Q).then(we=>we.channelClient.getChannel(O));return R(de).listen(V,Q)}}}getMulticastEvent(O,M,B,V){const Q=this;let de=new I.DisposableStore;const we=new _.Emitter({onFirstListenerAdd:()=>{de=new I.DisposableStore;const Ie=new _.EventMultiplexer,Ce=new Map,Le=Y=>{const le=Y.channelClient.getChannel(O).listen(B,V),me=Ie.add(le);Ce.set(Y,me)},z=Y=>{const ee=Ce.get(Y);!ee||(ee.dispose(),Ce.delete(Y))};Q.connections.filter(M).forEach(Le),_.Event.filter(Q.onDidAddConnection,M)(Le,void 0,de),Q.onDidRemoveConnection(z,void 0,de),Ie.event(we.fire,we,de),de.add(Ie)},onLastListenerRemove:()=>{de.dispose()}});return we.event}registerChannel(O,M){this.channels.set(O,M),this._connections.forEach(B=>{B.channelServer.registerChannel(O,M)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=h;class b{constructor(O,M,B=null){const V=new S;i(V,M),O.send(V.buffer),this.channelClient=new p(O,B),this.channelServer=new c(O,M,B)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,M){this.channelServer.registerChannel(O,M)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=b;function R(F){return{call(O,M,B){return F.then(V=>V.call(O,M,B))},listen(O,M){const B=new _.Relay;return F.then(V=>B.input=V.listen(O,M)),B.event}}}e.getDelayedChannel=R;function N(F){let O=!1;return{call(M,B,V){return O?F.call(M,B,V):(0,T.timeout)(0).then(()=>O=!0).then(()=>F.call(M,B,V))},listen(M,B){if(O)return F.listen(M,B);const V=new _.Relay;return(0,T.timeout)(0).then(()=>O=!0).then(()=>V.input=F.listen(M,B)),V.event}}}e.getNextTickChannel=N;class j{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const M of O.connections)if(await Promise.resolve(this.fn(M.ctx)))return Promise.resolve(M);return await _.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=j;var oe;(function(F){function O(V,Q){const de=V,we=Q&&Q.disableMarshalling,Ie=new Map;for(const Ce in de)B(Ce)&&Ie.set(Ce,_.Event.buffer(de[Ce],!0));return new class{listen(Ce,Le){const z=Ie.get(Le);if(z)return z;throw new Error(`Event not found: ${Le}`)}call(Ce,Le,z){const Y=de[Le];if(typeof Y=="function"){if(!we&&Array.isArray(z))for(let ee=0;ee<z.length;ee++)z[ee]=(0,s.revive)(z[ee]);return Y.apply(de,z)}throw new Error(`Method not found: ${Le}`)}}}F.fromService=O;function M(V,Q){const de=Q&&Q.disableMarshalling;return new Proxy({},{get(we,Ie){var Ce;if(typeof Ie=="string")return((Ce=Q==null?void 0:Q.properties)===null||Ce===void 0?void 0:Ce.has(Ie))?Q.properties.get(Ie):B(Ie)?V.listen(Ie):async function(...Le){let z;Q&&!(0,P.isUndefinedOrNull)(Q.context)?z=[Q.context,...Le]:z=Le;const Y=await V.call(Ie,z);return de?Y:(0,s.revive)(Y)};throw new Error(`Property not found: ${String(Ie)}`)}})}F.toService=M;function B(V){return V[0]==="o"&&V[1]==="n"&&C.isUpperAsciiLetter(V.charCodeAt(2))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let O=F.toString();if(O!=="[object Object]")return O}return F}function H(F){return Array.isArray(F)?F.map(W):W(F)}function U(F,O,M,B,V,Q,de){de=H(de);const we=q[V],Ie=we[B%we.length];let Ce=[`%c[${F}]%c[${String(O).padStart(7," ")}]%c[len: ${String(M).padStart(5," ")}]%c${String(B).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${Ie}`];/\($/.test(Q)?(Ce=Ce.concat(de),Ce.push(")")):Ce.push(de),console.log.apply(console,Ce)}e.logWithColors=U;class L{constructor(O,M){this._outgoingPrefix=O,this._incomingPrefix=M,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,M,B,V,Q){this._totalOutgoing+=O,U(this._outgoingPrefix,this._totalOutgoing,O,M,B,V,Q)}logIncoming(O,M,B,V,Q){this._totalIncoming+=O,U(this._incomingPrefix,this._totalIncoming,O,M,B,V,Q)}}e.IPCLogger=L}),define(ge[106],pe([0,1,3,105,6,22,10,36]),function(K,e,_,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let D=null;function P(){return D||(D=A.VSBuffer.alloc(0)),D}class s{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,i){if(r===0)return P();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const p=this._chunks[0];return i&&(this._chunks.shift(),this._totalLength-=r),p}if(this._chunks[0].byteLength>r){const p=this._chunks[0].slice(0,r);return i&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),p}let o=A.VSBuffer.alloc(r),c=0,v=0;for(;r>0;){const p=this._chunks[v];if(p.byteLength>r){const h=p.slice(0,r);o.set(h,c),c+=r,i&&(this._chunks[v]=p.slice(r),this._totalLength-=r),r-=r}else o.set(p,c),c+=p.byteLength,i?(this._chunks.shift(),this._totalLength-=p.byteLength):v++,r-=p.byteLength}return o}}e.ChunkStream=s;var C;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(C||(C={}));var g;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(g=e.ProtocolConstants||(e.ProtocolConstants={}));class m{constructor(r,i,o,c){this.type=r,this.id=i,this.ack=o,this.data=c,this.writtenTime=0}get size(){return this.data.byteLength}}class a extends T.Disposable{constructor(r){super();this._onMessage=this._register(new _.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new s,this._register(this._socket.onData(i=>this.acceptChunk(i))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const i=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=i.readUInt32BE(9),this._state.messageType=i.readUInt8(0),this._state.id=i.readUInt32BE(1),this._state.ack=i.readUInt32BE(5);else{const o=this._state.messageType,c=this._state.id,v=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new m(o,c,v,i)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class u{constructor(r){this._isDisposed=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(r){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(r){if(!this._isDisposed){r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const i=A.VSBuffer.alloc(13);i.writeUInt8(r.type,0),i.writeUInt32BE(r.id,1),i.writeUInt32BE(r.ack,5),i.writeUInt32BE(r.data.byteLength,9),this._writeSoon(i,r.data)}}_bufferAdd(r,i){const o=this._totalLength===0;return this._data.push(r,i),this._totalLength+=r.byteLength+i.byteLength,o}_bufferTake(){const r=A.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,i){this._bufferAdd(r,i)&&y.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class E extends T.Disposable{constructor(r){super();this._onMessage=new _.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new u(this._socket)),this._socketReader=this._register(new a(this._socket)),this._register(this._socketReader.onMessage(i=>{i.type===1&&this._onMessage.fire(i.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new m(1,0,0,r))}}e.Protocol=E;class w extends I.IPCClient{constructor(r,i,o=null){super(r,i,o);this.protocol=r}static fromSocket(r,i){return new w(new E(r),i)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=w;class S{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new _.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,k.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=S;class d{constructor(r){this.data=r,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],i=0,o=this._first;for(;o;)r[i++]=o.data,o=o.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const i=new d(r);if(!this._first){this._first=i,this._last=i;return}this._last.next=i,this._last=i}}class f{constructor(){this.lastRuns=[];const r=Date.now();for(let i=0;i<f._HISTORY_LENGTH;i++)this.lastRuns[i]=r-1e3*i;setInterval(()=>{for(let i=f._HISTORY_LENGTH;i>=1;i--)this.lastRuns[i]=this.lastRuns[i-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return f._INSTANCE||(f._INSTANCE=new f),f._INSTANCE}load(){const r=Date.now(),i=(1+f._HISTORY_LENGTH)*1e3;let o=0;for(let c=0;c<f._HISTORY_LENGTH;c++)r-this.lastRuns[c]<=i&&o++;return 1-o/f._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}f._HISTORY_LENGTH=10,f._INSTANCE=null;class t{constructor(r,i=null){this._loadEstimator=f.getInstance(),this._onControlMessage=new S,this.onControlMessage=this._onControlMessage.event,this._onMessage=new S,this.onMessage=this._onMessage.event,this._onDidDispose=new S,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new S,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new S,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=r,this._socketWriter=new u(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),i&&this._socketReader.acceptChunk(i),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,T.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new m(5,0,0,P());this._socketWriter.write(r),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const r=Date.now()-this._socketWriter.lastWriteTime;if(r>=5e3){const i=new m(4,0,0,P());this._socketWriter.write(i),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-r+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const r=Date.now()-this._socketReader.lastReadTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-r,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,i){this._isReconnecting=!0,this._socketDisposables=(0,T.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=r,this._socketWriter=new u(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(i)}endAcceptReconnection(){this._isReconnecting=!1;const r=this._outgoingUnackMsg.toArray();for(let i=0,o=r.length;i<o;i++)this._socketWriter.write(r[i]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const i=this._outgoingUnackMsg.peek();if(i&&i.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(r.type===1){if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const i=Date.now();i-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=i,this._socketWriter.write(new m(6,0,0,P())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data)}else if(r.type===2)this._onControlMessage.fire(r.data);else if(r.type===5)this._onDidDispose.fire();else if(r.type===6){const i=this._outgoingUnackMsg.toArray();for(let o=0,c=i.length;o<c;o++)this._socketWriter.write(i[o]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const i=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new m(1,i,this._incomingAckId,r);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(r){const i=new m(2,0,0,r);this._socketWriter.write(i)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const r=this._outgoingUnackMsg.peek(),i=Date.now()-r.writtenTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-i,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const r=new m(3,0,this._incomingAckId,P());this._socketWriter.write(r)}}}e.PersistentProtocol=t}),define(ge[107],pe([0,1,96]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class I{constructor(k){let D=(0,_.toUint8)(k);this._defaultValue=D,this._asciiMap=I._createAsciiMap(D),this._map=new Map}static _createAsciiMap(k){let D=new Uint8Array(256);for(let P=0;P<256;P++)D[P]=k;return D}set(k,D){let P=(0,_.toUint8)(D);k>=0&&k<256?this._asciiMap[k]=P:this._map.set(k,P)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=I;var T;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(T||(T={}));class A{constructor(){this._actual=new I(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=A}),define(ge[138],pe([0,1,107]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var I;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(I=e.WordCharacterClass||(e.WordCharacterClass={}));class T extends _.CharacterClassifier{constructor(k){super(0);for(let D=0,P=k.length;D<P;D++)this.set(k.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=T;function A(y){let k={};return D=>(k.hasOwnProperty(D)||(k[D]=y(D)),k[D])}e.getMapForWordSeparators=A(y=>new T(y))}),define(ge[49],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class _{constructor(T,A){this.lineNumber=T,this.column=A}with(T=this.lineNumber,A=this.column){return T===this.lineNumber&&A===this.column?this:new _(T,A)}delta(T=0,A=0){return this.with(this.lineNumber+T,this.column+A)}equals(T){return _.equals(this,T)}static equals(T,A){return!T&&!A?!0:!!T&&!!A&&T.lineNumber===A.lineNumber&&T.column===A.column}isBefore(T){return _.isBefore(this,T)}static isBefore(T,A){return T.lineNumber<A.lineNumber?!0:A.lineNumber<T.lineNumber?!1:T.column<A.column}isBeforeOrEqual(T){return _.isBeforeOrEqual(this,T)}static isBeforeOrEqual(T,A){return T.lineNumber<A.lineNumber?!0:A.lineNumber<T.lineNumber?!1:T.column<=A.column}static compare(T,A){let y=T.lineNumber|0,k=A.lineNumber|0;if(y===k){let D=T.column|0,P=A.column|0;return D-P}return y-k}clone(){return new _(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(T){return new _(T.lineNumber,T.column)}static isIPosition(T){return T&&typeof T.lineNumber=="number"&&typeof T.column=="number"}}e.Position=_}),define(ge[44],pe([0,1,49]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class I{constructor(A,y,k,D){A>k||A===k&&y>D?(this.startLineNumber=k,this.startColumn=D,this.endLineNumber=A,this.endColumn=y):(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=k,this.endColumn=D)}isEmpty(){return I.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return I.containsPosition(this,A)}static containsPosition(A,y){return!(y.lineNumber<A.startLineNumber||y.lineNumber>A.endLineNumber||y.lineNumber===A.startLineNumber&&y.column<A.startColumn||y.lineNumber===A.endLineNumber&&y.column>A.endColumn)}containsRange(A){return I.containsRange(this,A)}static containsRange(A,y){return!(y.startLineNumber<A.startLineNumber||y.endLineNumber<A.startLineNumber||y.startLineNumber>A.endLineNumber||y.endLineNumber>A.endLineNumber||y.startLineNumber===A.startLineNumber&&y.startColumn<A.startColumn||y.endLineNumber===A.endLineNumber&&y.endColumn>A.endColumn)}strictContainsRange(A){return I.strictContainsRange(this,A)}static strictContainsRange(A,y){return!(y.startLineNumber<A.startLineNumber||y.endLineNumber<A.startLineNumber||y.startLineNumber>A.endLineNumber||y.endLineNumber>A.endLineNumber||y.startLineNumber===A.startLineNumber&&y.startColumn<=A.startColumn||y.endLineNumber===A.endLineNumber&&y.endColumn>=A.endColumn)}plusRange(A){return I.plusRange(this,A)}static plusRange(A,y){let k,D,P,s;return y.startLineNumber<A.startLineNumber?(k=y.startLineNumber,D=y.startColumn):y.startLineNumber===A.startLineNumber?(k=y.startLineNumber,D=Math.min(y.startColumn,A.startColumn)):(k=A.startLineNumber,D=A.startColumn),y.endLineNumber>A.endLineNumber?(P=y.endLineNumber,s=y.endColumn):y.endLineNumber===A.endLineNumber?(P=y.endLineNumber,s=Math.max(y.endColumn,A.endColumn)):(P=A.endLineNumber,s=A.endColumn),new I(k,D,P,s)}intersectRanges(A){return I.intersectRanges(this,A)}static intersectRanges(A,y){let k=A.startLineNumber,D=A.startColumn,P=A.endLineNumber,s=A.endColumn,C=y.startLineNumber,g=y.startColumn,m=y.endLineNumber,a=y.endColumn;return k<C?(k=C,D=g):k===C&&(D=Math.max(D,g)),P>m?(P=m,s=a):P===m&&(s=Math.min(s,a)),k>P||k===P&&D>s?null:new I(k,D,P,s)}equalsRange(A){return I.equalsRange(this,A)}static equalsRange(A,y){return!!A&&!!y&&A.startLineNumber===y.startLineNumber&&A.startColumn===y.startColumn&&A.endLineNumber===y.endLineNumber&&A.endColumn===y.endColumn}getEndPosition(){return I.getEndPosition(this)}static getEndPosition(A){return new _.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return I.getStartPosition(this)}static getStartPosition(A){return new _.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,y){return new I(this.startLineNumber,this.startColumn,A,y)}setStartPosition(A,y){return new I(A,y,this.endLineNumber,this.endColumn)}collapseToStart(){return I.collapseToStart(this)}static collapseToStart(A){return new I(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,y=A){return new I(A.lineNumber,A.column,y.lineNumber,y.column)}static lift(A){return A?new I(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,y){return!(A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<y.startColumn||y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<A.startColumn)}static areIntersecting(A,y){return!(A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<=y.startColumn||y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,y){if(A&&y){const P=A.startLineNumber|0,s=y.startLineNumber|0;if(P===s){const C=A.startColumn|0,g=y.startColumn|0;if(C===g){const m=A.endLineNumber|0,a=y.endLineNumber|0;if(m===a){const u=A.endColumn|0,E=y.endColumn|0;return u-E}return m-a}return C-g}return P-s}return(A?1:0)-(y?1:0)}static compareRangesUsingEnds(A,y){return A.endLineNumber===y.endLineNumber?A.endColumn===y.endColumn?A.startLineNumber===y.startLineNumber?A.startColumn-y.startColumn:A.startLineNumber-y.startLineNumber:A.endColumn-y.endColumn:A.endLineNumber-y.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}}e.Range=I}),define(ge[139],pe([0,1,49,44]),function(K,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var T;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(T=e.SelectionDirection||(e.SelectionDirection={}));class A extends I.Range{constructor(k,D,P,s){super(k,D,P,s);this.selectionStartLineNumber=k,this.selectionStartColumn=D,this.positionLineNumber=P,this.positionColumn=s}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return A.selectionsEqual(this,k)}static selectionsEqual(k,D){return k.selectionStartLineNumber===D.selectionStartLineNumber&&k.selectionStartColumn===D.selectionStartColumn&&k.positionLineNumber===D.positionLineNumber&&k.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,D){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,k,D):new A(k,D,this.startLineNumber,this.startColumn)}getPosition(){return new _.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(k,D){return this.getDirection()===0?new A(k,D,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,k,D)}static fromPositions(k,D=k){return new A(k.lineNumber,k.column,D.lineNumber,D.column)}static liftSelection(k){return new A(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,D){if(k&&!D||!k&&D)return!1;if(!k&&!D)return!0;if(k.length!==D.length)return!1;for(let P=0,s=k.length;P<s;P++)if(!this.selectionsEqual(k[P],D[P]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,D,P,s,C){return C===0?new A(k,D,P,s):new A(P,s,k,D)}}e.Selection=A}),define(ge[108],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var _;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(_=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class k{constructor(a){this.tabSize=Math.max(1,a.tabSize|0),this.indentSize=a.tabSize|0,this.insertSpaces=Boolean(a.insertSpaces),this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=Boolean(a.trimAutoWhitespace)}equals(a){return this.tabSize===a.tabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=k;class D{constructor(a,u){this.range=a,this.matches=u}}e.FindMatch=D;var P;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var s;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(s=e.ModelConstants||(e.ModelConstants={}));class C{constructor(a,u,E,w,S,d){this.identifier=a,this.range=u,this.text=E,this.forceMoveMarkers=w,this.isAutoWhitespaceEdit=S,this._isTracked=d}}e.ValidAnnotatedEditOperation=C;class g{constructor(a,u,E){this.reverseEdits=a,this.changes=u,this.trimAutoWhitespaceLineNumbers=E}}e.ApplyEditsResult=g}),define(ge[140],pe([0,1,9,138,49,44,108]),function(K,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class D{constructor(d,l,f,t){this.searchString=d,this.isRegex=l,this.matchCase=f,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let d;this.isRegex?d=P(this.searchString):d=this.searchString.indexOf(`
`)>=0;let l=null;try{l=_.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:d,global:!0,unicode:!0})}catch(t){return null}if(!l)return null;let f=!this.isRegex&&!d;return f&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(f=this.matchCase),new s(l,this.wordSeparators?(0,I.getMapForWordSeparators)(this.wordSeparators):null,f?this.searchString:null)}}e.SearchParams=D;function P(S){if(!S||S.length===0)return!1;for(let d=0,l=S.length;d<l;d++)if(S.charCodeAt(d)===92){if(d++,d>=l)break;const t=S.charCodeAt(d);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=P;class s{constructor(d,l,f){this.regex=d,this.wordSeparators=l,this.simpleSearch=f}}e.SearchData=s;function C(S,d,l){if(!l)return new y.FindMatch(S,null);let f=[];for(let t=0,n=d.length;t<n;t++)f[t]=d[t];return new y.FindMatch(S,f)}e.createFindMatch=C;class g{constructor(d){let l=[],f=0;for(let t=0,n=d.length;t<n;t++)d.charCodeAt(t)===10&&(l[f++]=t);this._lineFeedsOffsets=l}findLineFeedCountBeforeOffset(d){const l=this._lineFeedsOffsets;let f=0,t=l.length-1;if(t===-1||d<=l[0])return 0;for(;f<t;){const n=f+((t-f)/2>>0);l[n]>=d?t=n-1:l[n+1]>=d?(f=n,t=n):f=n+1}return f+1}}class m{static findMatches(d,l,f,t,n){const r=l.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(d,f,new w(r.wordSeparators,r.regex),t,n):this._doFindMatchesLineByLine(d,f,r,t,n):[]}static _getMultilineMatchRange(d,l,f,t,n,r){let i,o=0;t?(o=t.findLineFeedCountBeforeOffset(n),i=l+n+o):i=l+n;let c;if(t){let b=t.findLineFeedCountBeforeOffset(n+r.length)-o;c=i+r.length+b}else c=i+r.length;const v=d.getPositionAt(i),p=d.getPositionAt(c);return new A.Range(v.lineNumber,v.column,p.lineNumber,p.column)}static _doFindMatchesMultiline(d,l,f,t,n){const r=d.getOffsetAt(l.getStartPosition()),i=d.getValueInRange(l,1),o=d.getEOL()===`\r
`?new g(i):null,c=[];let v=0,p;for(f.reset(0);p=f.next(i);)if(c[v++]=C(this._getMultilineMatchRange(d,r,i,o,p.index,p[0]),p,t),v>=n)return c;return c}static _doFindMatchesLineByLine(d,l,f,t,n){const r=[];let i=0;if(l.startLineNumber===l.endLineNumber){const c=d.getLineContent(l.startLineNumber).substring(l.startColumn-1,l.endColumn-1);return i=this._findMatchesInLine(f,c,l.startLineNumber,l.startColumn-1,i,r,t,n),r}const o=d.getLineContent(l.startLineNumber).substring(l.startColumn-1);i=this._findMatchesInLine(f,o,l.startLineNumber,l.startColumn-1,i,r,t,n);for(let c=l.startLineNumber+1;c<l.endLineNumber&&i<n;c++)i=this._findMatchesInLine(f,d.getLineContent(c),c,0,i,r,t,n);if(i<n){const c=d.getLineContent(l.endLineNumber).substring(0,l.endColumn-1);i=this._findMatchesInLine(f,c,l.endLineNumber,0,i,r,t,n)}return r}static _findMatchesInLine(d,l,f,t,n,r,i,o){const c=d.wordSeparators;if(!i&&d.simpleSearch){const h=d.simpleSearch,b=h.length,R=l.length;let N=-b;for(;(N=l.indexOf(h,N+b))!==-1;)if((!c||E(c,l,R,N,b))&&(r[n++]=new y.FindMatch(new A.Range(f,N+1+t,f,N+1+b+t),null),n>=o))return n;return n}const v=new w(d.wordSeparators,d.regex);let p;v.reset(0);do if(p=v.next(l),p&&(r[n++]=C(new A.Range(f,p.index+1+t,f,p.index+1+p[0].length+t),p,i),n>=o))return n;while(p);return n}static findNextMatch(d,l,f,t){const n=l.parseSearchRequest();if(!n)return null;const r=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(d,f,r,t):this._doFindNextMatchLineByLine(d,f,r,t)}static _doFindNextMatchMultiline(d,l,f,t){const n=new T.Position(l.lineNumber,1),r=d.getOffsetAt(n),i=d.getLineCount(),o=d.getValueInRange(new A.Range(n.lineNumber,n.column,i,d.getLineMaxColumn(i)),1),c=d.getEOL()===`\r
`?new g(o):null;f.reset(l.column-1);let v=f.next(o);return v?C(this._getMultilineMatchRange(d,r,o,c,v.index,v[0]),v,t):l.lineNumber!==1||l.column!==1?this._doFindNextMatchMultiline(d,new T.Position(1,1),f,t):null}static _doFindNextMatchLineByLine(d,l,f,t){const n=d.getLineCount(),r=l.lineNumber,i=d.getLineContent(r),o=this._findFirstMatchInLine(f,i,r,l.column,t);if(o)return o;for(let c=1;c<=n;c++){const v=(r+c-1)%n,p=d.getLineContent(v+1),h=this._findFirstMatchInLine(f,p,v+1,1,t);if(h)return h}return null}static _findFirstMatchInLine(d,l,f,t,n){d.reset(t-1);const r=d.next(l);return r?C(new A.Range(f,r.index+1,f,r.index+1+r[0].length),r,n):null}static findPreviousMatch(d,l,f,t){const n=l.parseSearchRequest();if(!n)return null;const r=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(d,f,r,t):this._doFindPreviousMatchLineByLine(d,f,r,t)}static _doFindPreviousMatchMultiline(d,l,f,t){const n=this._doFindMatchesMultiline(d,new A.Range(1,1,l.lineNumber,l.column),f,t,10*k);if(n.length>0)return n[n.length-1];const r=d.getLineCount();return l.lineNumber!==r||l.column!==d.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(d,new T.Position(r,d.getLineMaxColumn(r)),f,t):null}static _doFindPreviousMatchLineByLine(d,l,f,t){const n=d.getLineCount(),r=l.lineNumber,i=d.getLineContent(r).substring(0,l.column-1),o=this._findLastMatchInLine(f,i,r,t);if(o)return o;for(let c=1;c<=n;c++){const v=(n+r-c-1)%n,p=d.getLineContent(v+1),h=this._findLastMatchInLine(f,p,v+1,t);if(h)return h}return null}static _findLastMatchInLine(d,l,f,t){let n=null,r;for(d.reset(0);r=d.next(l);)n=C(new A.Range(f,r.index+1,f,r.index+1+r[0].length),r,t);return n}}e.TextModelSearch=m;function a(S,d,l,f,t){if(f===0)return!0;const n=d.charCodeAt(f-1);if(S.get(n)!==0||n===13||n===10)return!0;if(t>0){const r=d.charCodeAt(f);if(S.get(r)!==0)return!0}return!1}function u(S,d,l,f,t){if(f+t===l)return!0;const n=d.charCodeAt(f+t);if(S.get(n)!==0||n===13||n===10)return!0;if(t>0){const r=d.charCodeAt(f+t-1);if(S.get(r)!==0)return!0}return!1}function E(S,d,l,f,t){return a(S,d,l,f,t)&&u(S,d,l,f,t)}e.isValidMatch=E;class w{constructor(d,l){this._wordSeparators=d,this._searchRegex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(d){this._searchRegex.lastIndex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(d){const l=d.length;let f;do{if(this._prevMatchStartIndex+this._prevMatchLength===l||(f=this._searchRegex.exec(d),!f))return null;const t=f.index,n=f[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){_.getNextCodePoint(d,l,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||E(this._wordSeparators,d,l,t,n))return f}while(f);return null}}e.Searcher=w}),define(ge[109],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function _(k=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)k.indexOf(P)>=0||(D+="\\"+P);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=_();function I(k){let D=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)D=k;else{let P="g";k.ignoreCase&&(P+="i"),k.multiline&&(P+="m"),k.unicode&&(P+="u"),D=new RegExp(k.source,P)}return D.lastIndex=0,D}e.ensureValidWordDefinition=I;const T={maxLen:1e3,windowSize:15,timeBudget:150};function A(k,D,P,s,C=T){if(P.length>C.maxLen){let E=k-C.maxLen/2;return E<0?E=0:s+=E,P=P.substring(E,k+C.maxLen/2),A(k,D,P,s,C)}const g=Date.now(),m=k-1-s;let a=-1,u=null;for(let E=1;!(Date.now()-g>=C.timeBudget);E++){const w=m-C.windowSize*E;D.lastIndex=Math.max(0,w);const S=y(D,P,m,a);if(!S&&u||(u=S,w<=0))break;a=w}if(u){let E={word:u[0],startColumn:s+1+u.index,endColumn:s+1+u.index+u[0].length};return D.lastIndex=0,E}return null}e.getWordAtText=A;function y(k,D,P,s){let C;for(;C=k.exec(D);){const g=C.index||0;if(g<=P&&k.lastIndex>=P)return C;if(s>0&&g>s)return null}return null}}),define(ge[141],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var _;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(_=e.IndentAction||(e.IndentAction={}));class I{constructor(k){if(this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let D=0,P=k.notIn.length;D<P;D++)switch(k.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}}e.StandardAutoClosingPairConditional=I;class T{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of k)A(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),A(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),A(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),A(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&A(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=T;function A(y,k,D){y.has(k)?y.get(k).push(D):y.set(k,[D])}}),define(ge[77],pe([0,1,33,8]),function(K,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function T(A,y,k,D){if(Array.isArray(A)){let P=0;for(const s of A){const C=T(s,y,k,D);if(C===10)return C;C>P&&(P=C)}return P}else{if(typeof A=="string")return D?A==="*"?5:A===k?10:0:0;if(A){const{language:P,pattern:s,scheme:C,hasAccessToAllModels:g}=A;if(!D&&!g)return 0;let m=0;if(C)if(C===y.scheme)m=10;else if(C==="*")m=5;else return 0;if(P)if(P===k)m=10;else if(P==="*")m=Math.max(m,5);else return 0;if(s){let a;if(typeof s=="string"?a=s:a=Object.assign(Object.assign({},s),{base:(0,I.normalize)(s.base)}),a===y.fsPath||(0,_.match)(a,y.fsPath))m=10;else return 0}return m}else return 0}}e.score=T}),define(ge[142],pe([0,1,107]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var I;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(I=e.State||(e.State={}));class T{constructor(a,u,E){const w=new Uint8Array(a*u);for(let S=0,d=a*u;S<d;S++)w[S]=E;this._data=w,this.rows=a,this.cols=u}get(a,u){return this._data[a*this.cols+u]}set(a,u,E){this._data[a*this.cols+u]=E}}e.Uint8Matrix=T;class A{constructor(a){let u=0,E=0;for(let S=0,d=a.length;S<d;S++){let[l,f,t]=a[S];f>u&&(u=f),l>E&&(E=l),t>E&&(E=t)}u++,E++;let w=new T(E,u,0);for(let S=0,d=a.length;S<d;S++){let[l,f,t]=a[S];w.set(l,f,t)}this._states=w,this._maxCharCode=u}nextState(a,u){return u<0||u>=this._maxCharCode?0:this._states.get(a,u)}}e.StateMachine=A;let y=null;function k(){return y===null&&(y=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var D;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let P=null;function s(){if(P===null){P=new _.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<m.length;u++)P.set(m.charCodeAt(u),1);const a=".,;";for(let u=0;u<a.length;u++)P.set(a.charCodeAt(u),2)}return P}class C{static _createLink(a,u,E,w,S){let d=S-1;do{const l=u.charCodeAt(d);if(a.get(l)!==2)break;d--}while(d>w);if(w>0){const l=u.charCodeAt(w-1),f=u.charCodeAt(d);(l===40&&f===41||l===91&&f===93||l===123&&f===125)&&d--}return{range:{startLineNumber:E,startColumn:w+1,endLineNumber:E,endColumn:d+2},url:u.substring(w,d+1)}}static computeLinks(a,u=k()){const E=s();let w=[];for(let S=1,d=a.getLineCount();S<=d;S++){const l=a.getLineContent(S),f=l.length;let t=0,n=0,r=0,i=1,o=!1,c=!1,v=!1,p=!1;for(;t<f;){let h=!1;const b=l.charCodeAt(t);if(i===13){let R;switch(b){case 40:o=!0,R=0;break;case 41:R=o?0:1;break;case 91:v=!0,c=!0,R=0;break;case 93:v=!1,R=c?0:1;break;case 123:p=!0,R=0;break;case 125:R=p?0:1;break;case 39:R=r===34||r===96?0:1;break;case 34:R=r===39||r===96?0:1;break;case 96:R=r===39||r===34?0:1;break;case 42:R=r===42?1:0;break;case 124:R=r===124?1:0;break;case 32:R=v?0:1;break;default:R=E.get(b)}R===1&&(w.push(C._createLink(E,l,S,n,t)),h=!0)}else if(i===12){let R;b===91?(c=!0,R=0):R=E.get(b),R===1?h=!0:i=13}else i=u.nextState(i,b),i===0&&(h=!0);h&&(i=1,o=!1,c=!1,p=!1,n=t+1,r=b),t++}i===13&&w.push(C._createLink(E,l,S,n,f))}return w}}e.LinkComputer=C;function g(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:C.computeLinks(m)}e.computeLinks=g}),define(ge[143],pe([0,1,3,6]),function(K,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class T{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new _.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,k){return this._map.set(y,k),this.fire([y]),(0,I.toDisposable)(()=>{this._map.get(y)===k&&(this._map.delete(y),this.fire([y]))})}registerPromise(y,k){let D=null,P=!1;return this._promises.set(y,k.then(s=>{this._promises.delete(y),!(P||!s)&&(D=this.register(y,s))})),(0,I.toDisposable)(()=>{P=!0,D&&D.dispose()})}getPromise(y){const k=this.get(y);if(k)return Promise.resolve(k);const D=this._promises.get(y);return D?D.then(P=>this.get(y)):null}get(y){return this._map.get(y)||null}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=T}),define(ge[110],pe([0,1,22,10]),function(K,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var T;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(T||(T={}));function A(C){for(let g=0,m=C.length;g<m;g+=4){const a=C[g+0],u=C[g+1],E=C[g+2],w=C[g+3];C[g+0]=w,C[g+1]=E,C[g+2]=u,C[g+3]=a}}function y(C){const g=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return I.isLittleEndian()||A(g),_.VSBuffer.wrap(g)}function k(C){const g=C.buffer;if(I.isLittleEndian()||A(g),g.byteOffset%4==0)return new Uint32Array(g.buffer,g.byteOffset,g.length/4);{const m=new Uint8Array(g.byteLength);return m.set(g),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function D(C){const g=new Uint32Array(P(C));let m=0;if(g[m++]=C.id,C.type==="full")g[m++]=1,g[m++]=C.data.length,g.set(C.data,m),m+=C.data.length;else{g[m++]=2,g[m++]=C.deltas.length;for(const a of C.deltas)g[m++]=a.start,g[m++]=a.deleteCount,a.data?(g[m++]=a.data.length,g.set(a.data,m),m+=a.data.length):g[m++]=0}return y(g)}e.encodeSemanticTokensDto=D;function P(C){let g=0;if(g+=1+1,C.type==="full")g+=1+C.data.length;else{g+=1,g+=(1+1+1)*C.deltas.length;for(const m of C.deltas)m.data&&(g+=m.data.length)}return g}function s(C){const g=k(C);let m=0;const a=g[m++];if(g[m++]===1){const S=g[m++],d=g.subarray(m,m+S);return m+=S,{id:a,type:"full",data:d}}const E=g[m++];let w=[];for(let S=0;S<E;S++){const d=g[m++],l=g[m++],f=g[m++];let t;f>0&&(t=g.subarray(m,m+f),m+=f),w[S]={start:d,deleteCount:l,data:t}}return{id:a,type:"delta",deltas:w}}e.decodeSemanticTokensDto=s}),define(ge[111],pe([0,1,96]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class I{constructor(y,k){this.index=y,this.remainder=k}}e.PrefixSumIndexOfResult=I;class T{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,k){y=(0,_.toUint32)(y);const D=this.values,P=this.prefixSum,s=k.length;return s===0?!1:(this.values=new Uint32Array(D.length+s),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y),y+s),this.values.set(k,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(y,k){return y=(0,_.toUint32)(y),k=(0,_.toUint32)(k),this.values[y]===k?!1:(this.values[y]=k,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,k){y=(0,_.toUint32)(y),k=(0,_.toUint32)(k);const D=this.values,P=this.prefixSum;if(y>=D.length)return!1;let s=D.length-y;return k>=s&&(k=s),k===0?!1:(this.values=new Uint32Array(D.length-k),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y+k),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(y){return y<0?0:(y=(0,_.toUint32)(y),this._getAccumulatedValue(y))}_getAccumulatedValue(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let k=this.prefixSumValidIndex[0]+1;k===0&&(this.prefixSum[0]=this.values[0],k++),y>=this.values.length&&(y=this.values.length-1);for(let D=k;D<=y;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalValue();let k=0,D=this.values.length-1,P=0,s=0,C=0;for(;k<=D;)if(P=k+(D-k)/2|0,s=this.prefixSum[P],C=s-this.values[P],y<C)D=P-1;else if(y>=s)k=P+1;else break;return new I(P,y-C)}}e.PrefixSumComputer=T}),define(ge[144],pe([0,1,9,49,111]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(k,D,P,s){this._uri=k,this._lines=D,this._eol=P,this._versionId=s,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const D=k.changes;for(const P of D)this._acceptDeleteRange(P.range),this._acceptInsertText(new I.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,D=this._lines.length,P=new Uint32Array(D);for(let s=0;s<D;s++)P[s]=this._lines[s].length+k;this._lineStarts=new T.PrefixSumComputer(P)}}_setLineText(k,D){this._lines[k]=D,this._lineStarts&&this._lineStarts.changeValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,D){if(D.length!==0){let P=(0,_.splitLines)(D);if(P.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+P[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}P[P.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+P[0]);let s=new Uint32Array(P.length-1);for(let C=1;C<P.length;C++)this._lines.splice(k.lineNumber+C-1,0,P[C]),s[C-1]=P[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,s)}}}e.MirrorTextModel=A}),define(ge[145],pe([16,17]),function(K,e){return K.create("vs/base/common/date",e)}),define(ge[146],pe([0,1,145]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const I=60,T=I*60,A=T*24,y=A*7,k=A*30,D=A*365;function P(C,g){typeof C!="number"&&(C=C.getTime());const m=Math.round((new Date().getTime()-C)/1e3);if(m<-30)return(0,_.localize)(0,null,P(new Date().getTime()+m*1e3,!1));if(m<30)return(0,_.localize)(1,null);let a;return m<I?(a=m,g?a===1?(0,_.localize)(2,null,a):(0,_.localize)(3,null,a):a===1?(0,_.localize)(4,null,a):(0,_.localize)(5,null,a)):m<T?(a=Math.floor(m/I),g?a===1?(0,_.localize)(6,null,a):(0,_.localize)(7,null,a):a===1?(0,_.localize)(8,null,a):(0,_.localize)(9,null,a)):m<A?(a=Math.floor(m/T),g?a===1?(0,_.localize)(10,null,a):(0,_.localize)(11,null,a):a===1?(0,_.localize)(12,null,a):(0,_.localize)(13,null,a)):m<y?(a=Math.floor(m/A),g?a===1?(0,_.localize)(14,null,a):(0,_.localize)(15,null,a):a===1?(0,_.localize)(16,null,a):(0,_.localize)(17,null,a)):m<k?(a=Math.floor(m/y),g?a===1?(0,_.localize)(18,null,a):(0,_.localize)(19,null,a):a===1?(0,_.localize)(20,null,a):(0,_.localize)(21,null,a)):m<D?(a=Math.floor(m/k),g?a===1?(0,_.localize)(22,null,a):(0,_.localize)(23,null,a):a===1?(0,_.localize)(24,null,a):(0,_.localize)(25,null,a)):(a=Math.floor(m/D),g?a===1?(0,_.localize)(26,null,a):(0,_.localize)(27,null,a):a===1?(0,_.localize)(28,null,a):(0,_.localize)(29,null,a))}e.fromNow=P;function s(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=s}),define(ge[147],pe([16,17]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(ge[59],pe([0,1,147,11,19]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(P,s){return s&&(P.stack||P.stacktrace)?_.localize(0,null,k(P),y(P.stack)||y(P.stacktrace)):k(P)}function y(P){return Array.isArray(P)?P.join(`
`):P}function k(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?_.localize(1,null,P.message):P.message||_.localize(2,null)}function D(P=null,s=!1){if(!P)return _.localize(3,null);if(Array.isArray(P)){const C=T.coalesce(P),g=D(C[0],s);return C.length>1?_.localize(4,null,g,C.length):g}if(I.isString(P))return P;if(P.detail){const C=P.detail;if(C.error)return A(C.error,s);if(C.exception)return A(C.exception,s)}return P.stack?A(P,s):P.message?P.message:_.localize(5,null)}e.toErrorMessage=D}),define(ge[148],pe([16,17]),function(K,e){return K.create("vs/base/node/processes",e)}),define(ge[78],pe([0,1,8,37,26,38,148,36,11,23,29,10,137,12]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function a(f){switch(f){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function u(f,t){if(C.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};t&&(n.cwd=t);const r=A.execFile("taskkill",["/T","/F","/PID",f.pid.toString()],n);return new Promise(i=>{r.once("error",o=>{i({success:!1,error:o})}),r.once("exit",(o,c)=>{i(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?a(n.status):1})}else if(C.isLinux||C.isMacintosh)try{const n=m.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(r=>{A.execFile(n,[f.pid.toString()],{encoding:"utf8",shell:!0},(i,o,c)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else f.kill("SIGKILL");return Promise.resolve({success:!0})}function E(f=k.env){return f.comspec||"cmd.exe"}e.getWindowsShell=E;class w{constructor(t,n,r,i){if(n!==void 0&&r!==void 0&&i!==void 0)this.cmd=t,this.args=n,this.shell=r,this.options=i;else{const o=t;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(k.env).forEach(c=>{o[c]=k.env[c]}),Object.keys(this.options.env).forEach(c=>{o[c]=this.options.env[c]}),this.options.env=o}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const n=t.lastIndexOf(_.sep);return n!==-1&&(t=t.substring(n+1)),w.WellKnowCommands[t]?t:"other"}start(t){return C.isWindows&&(this.options&&this.options.cwd&&s.isUNC(this.options.cwd)||!this.options&&s.isUNC(k.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(n=>{let r,i;const o=new Promise((c,v)=>{r=c,i=v});if(n){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=A.exec(c,this.options,(v,p,h)=>{this.childProcess=null;const b=v;b&&b.killed?i({killed:this.terminateRequested,stdout:p.toString(),stderr:h.toString()}):this.handleExec(r,t,v,p,h)})}else{let c=null;const v=p=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(p,r,t,i);const h={terminated:this.terminateRequested};D.isNumber(p)&&(h.cmdCode=p),r(h)};if(this.shell&&C.isWindows){const p=P.deepClone(this.options);p.windowsVerbatimArguments=!0,p.detached=!1;let h=!1,b=!1;const R=[];let N=this.ensureQuotes(this.cmd);R.push(N.value),h=N.quoted,this.args&&this.args.forEach(oe=>{N=this.ensureQuotes(oe),R.push(N.value),b=b&&N.quoted});const j=["/s","/c"];h?b?j.push('"'+R.join(" ")+'"'):R.length>1?j.push('"'+R[0]+'" '+R.slice(1).join(" ")):j.push('"'+R[0]+'"'):j.push(R.join(" ")),c=A.spawn(E(),j,p)}else this.cmd&&(c=A.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(D.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",p=>{this.childProcess=null,i({terminated:this.terminateRequested,error:p})}),c.pid&&(this.childProcess.on("close",v),this.handleSpawn(c,r,t,i,!0)))}return o})}handleClose(t,n,r,i){}ensureQuotes(t){return w.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,u(t,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!C.isWindows)return t(!1);const n=A.spawn(E(),["/s","/c"]);n.on("error",r=>t(!0)),n.on("exit",r=>t(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class S extends w{constructor(t,n,r,i){super(t,n,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,n,r,i,o){[i,o].forEach((c,v)=>{const p=new g.LineDecoder;p.write(c).forEach(R=>{n({line:R,source:v===0?0:1})});const b=p.end();b&&n({line:b,source:v===0?0:1})}),t({terminated:this.terminateRequested,error:r})}handleSpawn(t,n,r,i,o){const c=new g.LineDecoder,v=new g.LineDecoder;t.stdout.on("data",p=>{c.write(p).forEach(b=>r({line:b,source:0}))}),t.stderr.on("data",p=>{v.write(p).forEach(b=>r({line:b,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=v}handleClose(t,n,r,i){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&r({line:o,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&r({line:c,source:1})}}e.LineProcess=S;function d(f){let t=[],n=!1;const r=function(i){if(n){t.push(i);return}(!f.send(i,c=>{if(c&&console.error(c),n=!1,t.length>0){const v=t.slice(0);t=[],v.forEach(p=>r(p))}})||C.isWindows)&&(n=!0)};return{send:r}}e.createQueuedSender=d;var l;(function(f){async function t(n,r,i){if(_.isAbsolute(n))return n;if(r===void 0&&(r=k.cwd()),_.dirname(n)!=="."||(i===void 0&&D.isString(k.env.PATH)&&(i=k.env.PATH.split(_.delimiter)),i===void 0||i.length===0))return _.join(r,n);async function c(v){return await T.exists(v)?!(await I.promises.stat(v)).isDirectory():!1}for(let v of i){let p;if(_.isAbsolute(v)?p=_.join(v,n):p=_.join(r,v,n),await c(p))return p;let h=p+".com";if(await c(h)||(h=p+".exe",await c(h)))return h}return _.join(r,n)}f.findExecutable=t})(l=e.win32||(e.win32={}))}),define(ge[149],pe([0,1,48,10,104,78]),function(K,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function y(m,a){return m===1?I.isWindows?C():A.getWindowsShell(a):P(m,a)}e.getSystemShell=y;function k(m,a){return m===1?I.isWindows?g(a):A.getWindowsShell(a):P(m,a)}e.getSystemShellSync=k;let D=null;function P(m,a){if(I.isLinux&&m===2||I.isMacintosh&&m===3)return"/bin/bash";if(!D){let u;if(I.isWindows)u="/bin/bash";else{if(u=a.SHELL,!u)try{u=(0,_.userInfo)().shell}catch(E){}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}D=u}return D}let s=null;async function C(){return s||(s=(await(0,T.getFirstAvailablePowerShellInstallation)()).exePath),s}function g(m){if(s)return s;const a=I.isWindows&&parseFloat((0,_.release)())>=10,u=m.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${m.windir}\\${u?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return a?E:A.getWindowsShell(m)}}),define(ge[150],pe([16,17]),function(K,e){return K.create("vs/editor/common/config/editorOptions",e)}),define(ge[151],pe([0,1,150,10,109]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=y;class k{constructor(){this._values=[]}_read(ie){return this._values[ie]}get(ie){return this._values[ie]}_write(ie,_e){this._values[ie]=_e}}e.ValidatedEditorOptions=k;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class P{constructor(ie,_e,Ne,ze){this.id=ie,this.name=_e,this.defaultValue=Ne,this.schema=ze}compute(ie,_e,Ne){return Ne}}class s{constructor(ie,_e=null){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0,this.deps=_e}validate(ie){return this.defaultValue}}class C{constructor(ie,_e,Ne,ze){this.id=ie,this.name=_e,this.defaultValue=Ne,this.schema=ze}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,_e,Ne){return Ne}}function g(X,ie){return typeof X=="undefined"?ie:X==="false"?!1:Boolean(X)}e.boolean=g;class m extends C{constructor(ie,_e,Ne,ze=void 0){typeof ze!="undefined"&&(ze.type="boolean",ze.default=Ne),super(ie,_e,Ne,ze)}validate(ie){return g(ie,this.defaultValue)}}class a extends C{constructor(ie,_e,Ne,ze,$e,Je=void 0){typeof Je!="undefined"&&(Je.type="integer",Je.default=Ne,Je.minimum=ze,Je.maximum=$e),super(ie,_e,Ne,Je),this.minimum=ze,this.maximum=$e}static clampedInt(ie,_e,Ne,ze){if(typeof ie=="undefined")return _e;let $e=parseInt(ie,10);return isNaN($e)?_e:($e=Math.max(Ne,$e),$e=Math.min(ze,$e),$e|0)}validate(ie){return a.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class u extends C{constructor(ie,_e,Ne,ze,$e){typeof $e!="undefined"&&($e.type="number",$e.default=Ne),super(ie,_e,Ne,$e),this.validationFn=ze}static clamp(ie,_e,Ne){return ie<_e?_e:ie>Ne?Ne:ie}static float(ie,_e){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return _e;const Ne=parseFloat(ie);return isNaN(Ne)?_e:Ne}validate(ie){return this.validationFn(u.float(ie,this.defaultValue))}}class E extends C{static string(ie,_e){return typeof ie!="string"?_e:ie}constructor(ie,_e,Ne,ze=void 0){typeof ze!="undefined"&&(ze.type="string",ze.default=Ne),super(ie,_e,Ne,ze)}validate(ie){return E.string(ie,this.defaultValue)}}function w(X,ie,_e){return typeof X!="string"||_e.indexOf(X)===-1?ie:X}e.stringSet=w;class S extends C{constructor(ie,_e,Ne,ze,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.enum=ze,$e.default=Ne),super(ie,_e,Ne,$e),this._allowedValues=ze}validate(ie){return w(ie,this.defaultValue,this._allowedValues)}}class d extends P{constructor(ie,_e,Ne,ze,$e,Je,G=void 0){typeof G!="undefined"&&(G.type="string",G.enum=$e,G.default=ze),super(ie,_e,Ne,G),this._allowedValues=$e,this._convert=Je}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function l(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[_.localize(0,null),_.localize(1,null),_.localize(2,null)],default:"auto",description:_.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,_e,Ne){return Ne===0?ie.accessibilitySupport:Ne}}class t extends P{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:_.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:_.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{insertSpace:g(_e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(_e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var i;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(i=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function o(X){switch(X){case i.Line:return"line";case i.Block:return"block";case i.Underline:return"underline";case i.LineThin:return"line-thin";case i.BlockOutline:return"block-outline";case i.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=o;function c(X){switch(X){case"line":return i.Line;case"block":return i.Block;case"underline":return i.Underline;case"line-thin":return i.LineThin;case"block-outline":return i.BlockOutline;case"underline-thin":return i.UnderlineThin}}class v extends s{constructor(){super(123,[62,31])}compute(ie,_e,Ne){const ze=["monaco-editor"];return _e.get(31)&&ze.push(_e.get(31)),ie.extraEditorClassName&&ze.push(ie.extraEditorClassName),_e.get(62)==="default"?ze.push("mouse-default"):_e.get(62)==="copy"&&ze.push("mouse-copy"),_e.get(97)&&ze.push("showUnused"),_e.get(121)&&ze.push("showDeprecated"),ze.join(" ")}}class p extends m{constructor(){super(30,"emptySelectionClipboard",!0,{description:_.localize(6,null)})}compute(ie,_e,Ne){return Ne&&ie.emptySelectionClipboard}}class h extends P{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:_.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ie.seedSearchStringFromSelection,description:_.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[_.localize(9,null),_.localize(10,null),_.localize(11,null)],description:_.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:_.localize(13,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:_.localize(14,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:_.localize(15,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{cursorMoveOnType:g(_e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:g(_e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":w(_e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(_e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(_e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(_e.loop,this.defaultValue.loop)}}}class b extends P{constructor(){super(41,"fontLigatures",b.OFF,{anyOf:[{type:"boolean",description:_.localize(16,null)},{type:"string",description:_.localize(17,null)}],description:_.localize(18,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?b.OFF:ie==="true"?b.ON:ie:Boolean(ie)?b.ON:b.OFF}}e.EditorFontLigatures=b,b.OFF='"liga" off, "calt" off',b.ON='"liga" on, "calt" on';class R extends s{constructor(){super(40)}compute(ie,_e,Ne){return ie.fontInfo}}class N extends C{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:_.localize(19,null)})}validate(ie){let _e=u.float(ie,this.defaultValue);return _e===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(_e,6,100)}compute(ie,_e,Ne){return ie.fontInfo.fontSize}}class j extends P{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:j.MINIMUM_VALUE,maximum:j.MAXIMUM_VALUE,errorMessage:_.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:j.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:_.localize(21,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(a.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,j.MINIMUM_VALUE,j.MAXIMUM_VALUE))}}j.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],j.MINIMUM_VALUE=1,j.MAXIMUM_VALUE=1e3;class oe extends P{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},_e={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[_.localize(22,null),_.localize(23,null),_.localize(24,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:_.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:_.localize(26,null)},_e),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:_.localize(27,null)},_e),"editor.gotoLocation.multipleDeclarations":Object.assign({description:_.localize(28,null)},_e),"editor.gotoLocation.multipleImplementations":Object.assign({description:_.localize(29,null)},_e),"editor.gotoLocation.multipleReferences":Object.assign({description:_.localize(30,null)},_e),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,enum:Ne,description:_.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,enum:Ne,description:_.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,enum:Ne,description:_.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,enum:Ne,description:_.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,enum:Ne,description:_.localize(35,null)}})}validate(ie){var _e,Ne,ze,$e,Je;if(!ie||typeof ie!="object")return this.defaultValue;const G=ie;return{multiple:w(G.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(_e=G.multipleDefinitions)!==null&&_e!==void 0?_e:w(G.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ne=G.multipleTypeDefinitions)!==null&&Ne!==void 0?Ne:w(G.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(ze=G.multipleDeclarations)!==null&&ze!==void 0?ze:w(G.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:($e=G.multipleImplementations)!==null&&$e!==void 0?$e:w(G.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Je=G.multipleReferences)!==null&&Je!==void 0?Je:w(G.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:E.string(G.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:E.string(G.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:E.string(G.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:E.string(G.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:E.string(G.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class q extends P{constructor(){const ie={enabled:!0,delay:300,sticky:!0};super(50,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:_.localize(36,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:_.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:_.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:g(_e.enabled,this.defaultValue.enabled),delay:a.clampedInt(_e.delay,this.defaultValue.delay,0,1e4),sticky:g(_e.sticky,this.defaultValue.sticky)}}}var W;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(W=e.RenderMinimap||(e.RenderMinimap={}));class H extends s{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(ie,_e,Ne){return H.computeLayout(_e,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const _e=ie.height/ie.lineHeight,Ne=ie.scrollBeyondLastLine?_e-1:0,ze=(ie.viewLineCount+Ne)/(ie.pixelRatio*ie.height),$e=Math.floor(ie.viewLineCount/ze);return{typicalViewportLineCount:_e,extraLinesBeyondLastLine:Ne,desiredRatio:ze,minimapLineCount:$e}}static _computeMinimapLayout(ie,_e){const Ne=ie.outerWidth,ze=ie.outerHeight,$e=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor($e*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const Je=_e.stableMinimapLayoutInput,G=Je&&ie.outerHeight===Je.outerHeight&&ie.lineHeight===Je.lineHeight&&ie.typicalHalfwidthCharacterWidth===Je.typicalHalfwidthCharacterWidth&&ie.pixelRatio===Je.pixelRatio&&ie.scrollBeyondLastLine===Je.scrollBeyondLastLine&&ie.minimap.enabled===Je.minimap.enabled&&ie.minimap.side===Je.minimap.side&&ie.minimap.size===Je.minimap.size&&ie.minimap.showSlider===Je.minimap.showSlider&&ie.minimap.renderCharacters===Je.minimap.renderCharacters&&ie.minimap.maxColumn===Je.minimap.maxColumn&&ie.minimap.scale===Je.minimap.scale&&ie.verticalScrollbarWidth===Je.verticalScrollbarWidth&&ie.isViewportWrapping===Je.isViewportWrapping,re=ie.lineHeight,he=ie.typicalHalfwidthCharacterWidth,J=ie.scrollBeyondLastLine,ne=ie.minimap.renderCharacters;let ce=$e>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const ve=ie.minimap.maxColumn,ye=ie.minimap.size,je=ie.minimap.side,He=ie.verticalScrollbarWidth,We=ie.viewLineCount,Ke=ie.remainingWidth,nt=ie.isViewportWrapping,dt=ne?2:3;let it=Math.floor($e*ze);const Ye=it/$e;let mt=!1,wt=!1,Ee=dt*ce,fe=ce/$e,ae=1;if(ye==="fill"||ye==="fit"){const{typicalViewportLineCount:ht,extraLinesBeyondLastLine:Xe,desiredRatio:ot,minimapLineCount:ft}=H.computeContainedMinimapLineCount({viewLineCount:We,scrollBeyondLastLine:J,height:ze,lineHeight:re,pixelRatio:$e});if(We/ft>1)mt=!0,wt=!0,ce=1,Ee=1,fe=ce/$e;else{let Et=!1,vt=ce+1;if(ye==="fit"){const Ct=Math.ceil((We+Xe)*Ee);nt&&G&&Ke<=_e.stableFitRemainingWidth?(Et=!0,vt=_e.stableFitMaxMinimapScale):(Et=Ct>it,nt&&Et?(_e.stableMinimapLayoutInput=ie,_e.stableFitRemainingWidth=Ke):(_e.stableMinimapLayoutInput=null,_e.stableFitRemainingWidth=0))}if(ye==="fill"||Et){mt=!0;const Ct=ce;Ee=Math.min(re*$e,Math.max(1,Math.floor(1/ot))),ce=Math.min(vt,Math.max(1,Math.floor(Ee/dt))),ce>Ct&&(ae=Math.min(2,ce/Ct)),fe=ce/$e/ae,it=Math.ceil(Math.max(ht,We+Xe)*Ee),nt&&Et&&(_e.stableFitMaxMinimapScale=ce)}}}const Z=Math.floor(ve*fe),Fe=Math.min(Z,Math.max(0,Math.floor((Ke-He-2)*fe/(he+fe)))+e.MINIMAP_GUTTER_WIDTH);let Te=Math.floor($e*Fe);const Qe=Te/$e;Te=Math.floor(Te*ae);const Ze=ne?1:2,ct=je==="left"?0:Ne-Fe-He;return{renderMinimap:Ze,minimapLeft:ct,minimapWidth:Fe,minimapHeightIsEditorHeight:mt,minimapIsSampling:wt,minimapScale:ce,minimapLineHeight:Ee,minimapCanvasInnerWidth:Te,minimapCanvasInnerHeight:it,minimapCanvasOuterWidth:Qe,minimapCanvasOuterHeight:Ye}}static computeLayout(ie,_e){const Ne=_e.outerWidth|0,ze=_e.outerHeight|0,$e=_e.lineHeight|0,Je=_e.lineNumbersDigitCount|0,G=_e.typicalHalfwidthCharacterWidth,re=_e.maxDigitWidth,he=_e.pixelRatio,J=_e.viewLineCount,ne=ie.get(118),ce=ne==="inherit"?ie.get(117):ne,ve=ce==="inherit"?ie.get(113):ce,ye=ie.get(116),je=ie.get(2),He=_e.isDominatedByLongLines,We=ie.get(46),Ke=ie.get(56).renderType!==0,nt=ie.get(57),dt=ie.get(91),it=ie.get(61),Ye=ie.get(89),mt=Ye.verticalScrollbarSize,wt=Ye.verticalHasArrows,Ee=Ye.arrowSize,fe=Ye.horizontalScrollbarSize,ae=ie.get(54),Z=ie.get(35);let Fe;if(typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)){const bt=parseFloat(ae.substr(0,ae.length-2));Fe=a.clampedInt(bt*G,0,0,1e3)}else Fe=a.clampedInt(ae,0,0,1e3);Z&&(Fe+=16);let Te=0;if(Ke){const bt=Math.max(Je,nt);Te=Math.round(bt*re)}let Qe=0;We&&(Qe=$e);let Ze=0,ct=Ze+Qe,ht=ct+Te,Xe=ht+Fe;const ot=Ne-Qe-Te-Fe;let ft=!1,at=!1,Et=-1;je!==2&&(ce==="inherit"&&He?(ft=!0,at=!0):ve==="on"||ve==="bounded"?at=!0:ve==="wordWrapColumn"&&(Et=ye));const vt=H._computeMinimapLayout({outerWidth:Ne,outerHeight:ze,lineHeight:$e,typicalHalfwidthCharacterWidth:G,pixelRatio:he,scrollBeyondLastLine:dt,minimap:it,verticalScrollbarWidth:mt,viewLineCount:J,remainingWidth:ot,isViewportWrapping:at},_e.memory||new D);vt.renderMinimap!==0&&vt.minimapLeft===0&&(Ze+=vt.minimapWidth,ct+=vt.minimapWidth,ht+=vt.minimapWidth,Xe+=vt.minimapWidth);const Ct=ot-vt.minimapWidth,It=Math.max(1,Math.floor((Ct-mt-2)/G)),At=wt?Ee:0;return at&&(Et=Math.max(1,It),ve==="bounded"&&(Et=Math.min(Et,ye))),{width:Ne,height:ze,glyphMarginLeft:Ze,glyphMarginWidth:Qe,lineNumbersLeft:ct,lineNumbersWidth:Te,decorationsLeft:ht,decorationsWidth:Fe,contentLeft:Xe,contentWidth:Ct,minimap:vt,viewportColumn:It,isWordWrapMinified:ft,isViewportWrapping:at,wrappingColumn:Et,verticalScrollbarWidth:mt,horizontalScrollbarHeight:fe,overviewRuler:{top:At,width:mt,height:ze-2*At,right:0}}}}e.EditorLayoutInfoComputer=H;class U extends P{constructor(){const ie={enabled:!0};super(53,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:_.localize(39,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:g(ie.enabled,this.defaultValue.enabled)}}}class L extends P{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",ie,{"editor.inlineHints.enabled":{type:"boolean",default:ie.enabled,description:_.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:ie.fontSize,description:_.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:ie.fontFamily,description:_.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:g(_e.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(_e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:E.string(_e.fontFamily,this.defaultValue.fontFamily)}}}class F extends a{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:_.localize(43,null)})}compute(ie,_e,Ne){return ie.fontInfo.lineHeight}}class O extends P{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:_.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[_.localize(45,null),_.localize(46,null),_.localize(47,null)],default:ie.size,description:_.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:_.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:_.localize(50,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:_.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:_.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:_.localize(53,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:g(_e.enabled,this.defaultValue.enabled),size:w(_e.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(_e.side,this.defaultValue.side,["right","left"]),showSlider:w(_e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(_e.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(_e.scale,1,1,3),maxColumn:a.clampedInt(_e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function M(X){return X==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class B extends P{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:_.localize(55,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{top:a.clampedInt(_e.top,0,0,1e3),bottom:a.clampedInt(_e.bottom,0,0,1e3)}}}class V extends P{constructor(){const ie={enabled:!0,cycle:!1};super(72,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:_.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:_.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:g(_e.enabled,this.defaultValue.enabled),cycle:g(_e.cycle,this.defaultValue.cycle)}}}class Q extends s{constructor(){super(124)}compute(ie,_e,Ne){return ie.pixelRatio}}class de extends P{constructor(){const ie={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:_.localize(58,null)},comments:{type:"boolean",default:ie.comments,description:_.localize(59,null)},other:{type:"boolean",default:ie.other,description:_.localize(60,null)}}}],default:ie,description:_.localize(61,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const _e=ie,Ne={other:g(_e.other,this.defaultValue.other),comments:g(_e.comments,this.defaultValue.comments),strings:g(_e.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var we;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(we=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ie extends P{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[_.localize(62,null),_.localize(63,null),_.localize(64,null),_.localize(65,null)],default:"on",description:_.localize(66,null)})}validate(ie){let _e=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(_e=4,Ne=ie):ie==="interval"?_e=3:ie==="relative"?_e=2:ie==="on"?_e=1:_e=0),{renderType:_e,renderFn:Ne}}}function Ce(X){const ie=X.get(84);return ie==="editable"?X.get(77):ie!=="on"}e.filterValidationDecorations=Ce;class Le extends P{constructor(){const ie=[],_e={type:"number",description:_.localize(67,null)};super(88,"rulers",ie,{type:"array",items:{anyOf:[_e,{type:["object"],properties:{column:_e,color:{type:"string",description:_.localize(68,null),format:"color-hex"}}}]},default:ie,description:_.localize(69,null)})}validate(ie){if(Array.isArray(ie)){let _e=[];for(let Ne of ie)if(typeof Ne=="number")_e.push({column:a.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const ze=Ne;_e.push({column:a.clampedInt(ze.column,0,0,1e4),color:ze.color})}return _e.sort((Ne,ze)=>Ne.column-ze.column),_e}return this.defaultValue}}function z(X,ie){if(typeof X!="string")return ie;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class Y extends P{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie,Ne=a.clampedInt(_e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=a.clampedInt(_e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(_e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:z(_e.vertical,this.defaultValue.vertical),horizontal:z(_e.horizontal,this.defaultValue.horizontal),useShadows:g(_e.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(_e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(_e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(_e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(_e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:a.clampedInt(_e.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:a.clampedInt(_e.verticalSliderSize,ze,0,1e3),scrollByPage:g(_e.scrollByPage,this.defaultValue.scrollByPage)}}}class ee extends P{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[_.localize(70,null),_.localize(71,null)],default:ie.insertMode,description:_.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:_.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:_.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:_.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:_.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:_.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:_.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:_.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:_.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:_.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:_.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:_.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:_.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:_.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:_.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:_.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:_.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:_.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:_.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:_.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:_.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:_.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:_.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:_.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:_.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:_.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:_.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:_.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:_.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:_.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:_.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:_.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:_.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:_.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:_.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:_.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:_.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:_.localize(109,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{insertMode:w(_e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(_e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(_e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(_e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(_e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:g(_e.showIcons,this.defaultValue.showIcons),showStatusBar:g(_e.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:g(_e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(_e.showMethods,this.defaultValue.showMethods),showFunctions:g(_e.showFunctions,this.defaultValue.showFunctions),showConstructors:g(_e.showConstructors,this.defaultValue.showConstructors),showFields:g(_e.showFields,this.defaultValue.showFields),showVariables:g(_e.showVariables,this.defaultValue.showVariables),showClasses:g(_e.showClasses,this.defaultValue.showClasses),showStructs:g(_e.showStructs,this.defaultValue.showStructs),showInterfaces:g(_e.showInterfaces,this.defaultValue.showInterfaces),showModules:g(_e.showModules,this.defaultValue.showModules),showProperties:g(_e.showProperties,this.defaultValue.showProperties),showEvents:g(_e.showEvents,this.defaultValue.showEvents),showOperators:g(_e.showOperators,this.defaultValue.showOperators),showUnits:g(_e.showUnits,this.defaultValue.showUnits),showValues:g(_e.showValues,this.defaultValue.showValues),showConstants:g(_e.showConstants,this.defaultValue.showConstants),showEnums:g(_e.showEnums,this.defaultValue.showEnums),showEnumMembers:g(_e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(_e.showKeywords,this.defaultValue.showKeywords),showWords:g(_e.showWords,this.defaultValue.showWords),showColors:g(_e.showColors,this.defaultValue.showColors),showFiles:g(_e.showFiles,this.defaultValue.showFiles),showReferences:g(_e.showReferences,this.defaultValue.showReferences),showFolders:g(_e.showFolders,this.defaultValue.showFolders),showTypeParameters:g(_e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(_e.showSnippets,this.defaultValue.showSnippets),showUsers:g(_e.showUsers,this.defaultValue.showUsers),showIssues:g(_e.showIssues,this.defaultValue.showIssues)}}}class le extends P{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:_.localize(110,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class me extends s{constructor(){super(125,[77])}compute(ie,_e,Ne){return _e.get(77)?!0:ie.tabFocusMode}}var De;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(De=e.WrappingIndent||(e.WrappingIndent={}));function Oe(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class be extends s{constructor(){super(127,[126])}compute(ie,_e,Ne){const ze=_e.get(126);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}const Pe="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",Be="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?Re:I.isLinux?Be:Pe,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Se(X){return e.editorOptionsRegistry[X.id]=X,X}var qe;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.codeLens=12]="codeLens",X[X.codeLensFontFamily=13]="codeLensFontFamily",X[X.codeLensFontSize=14]="codeLensFontSize",X[X.colorDecorators=15]="colorDecorators",X[X.columnSelection=16]="columnSelection",X[X.comments=17]="comments",X[X.contextmenu=18]="contextmenu",X[X.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",X[X.cursorBlinking=20]="cursorBlinking",X[X.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",X[X.cursorStyle=22]="cursorStyle",X[X.cursorSurroundingLines=23]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",X[X.cursorWidth=25]="cursorWidth",X[X.disableLayerHinting=26]="disableLayerHinting",X[X.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",X[X.domReadOnly=28]="domReadOnly",X[X.dragAndDrop=29]="dragAndDrop",X[X.emptySelectionClipboard=30]="emptySelectionClipboard",X[X.extraEditorClassName=31]="extraEditorClassName",X[X.fastScrollSensitivity=32]="fastScrollSensitivity",X[X.find=33]="find",X[X.fixedOverflowWidgets=34]="fixedOverflowWidgets",X[X.folding=35]="folding",X[X.foldingStrategy=36]="foldingStrategy",X[X.foldingHighlight=37]="foldingHighlight",X[X.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=39]="fontFamily",X[X.fontInfo=40]="fontInfo",X[X.fontLigatures=41]="fontLigatures",X[X.fontSize=42]="fontSize",X[X.fontWeight=43]="fontWeight",X[X.formatOnPaste=44]="formatOnPaste",X[X.formatOnType=45]="formatOnType",X[X.glyphMargin=46]="glyphMargin",X[X.gotoLocation=47]="gotoLocation",X[X.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",X[X.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",X[X.hover=50]="hover",X[X.inDiffEditor=51]="inDiffEditor",X[X.letterSpacing=52]="letterSpacing",X[X.lightbulb=53]="lightbulb",X[X.lineDecorationsWidth=54]="lineDecorationsWidth",X[X.lineHeight=55]="lineHeight",X[X.lineNumbers=56]="lineNumbers",X[X.lineNumbersMinChars=57]="lineNumbersMinChars",X[X.linkedEditing=58]="linkedEditing",X[X.links=59]="links",X[X.matchBrackets=60]="matchBrackets",X[X.minimap=61]="minimap",X[X.mouseStyle=62]="mouseStyle",X[X.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=64]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",X[X.multiCursorModifier=66]="multiCursorModifier",X[X.multiCursorPaste=67]="multiCursorPaste",X[X.occurrencesHighlight=68]="occurrencesHighlight",X[X.overviewRulerBorder=69]="overviewRulerBorder",X[X.overviewRulerLanes=70]="overviewRulerLanes",X[X.padding=71]="padding",X[X.parameterHints=72]="parameterHints",X[X.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",X[X.quickSuggestions=75]="quickSuggestions",X[X.quickSuggestionsDelay=76]="quickSuggestionsDelay",X[X.readOnly=77]="readOnly",X[X.renameOnType=78]="renameOnType",X[X.renderControlCharacters=79]="renderControlCharacters",X[X.renderIndentGuides=80]="renderIndentGuides",X[X.renderFinalNewline=81]="renderFinalNewline",X[X.renderLineHighlight=82]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=84]="renderValidationDecorations",X[X.renderWhitespace=85]="renderWhitespace",X[X.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",X[X.roundedSelection=87]="roundedSelection",X[X.rulers=88]="rulers",X[X.scrollbar=89]="scrollbar",X[X.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=91]="scrollBeyondLastLine",X[X.scrollPredominantAxis=92]="scrollPredominantAxis",X[X.selectionClipboard=93]="selectionClipboard",X[X.selectionHighlight=94]="selectionHighlight",X[X.selectOnLineNumbers=95]="selectOnLineNumbers",X[X.showFoldingControls=96]="showFoldingControls",X[X.showUnused=97]="showUnused",X[X.snippetSuggestions=98]="snippetSuggestions",X[X.smartSelect=99]="smartSelect",X[X.smoothScrolling=100]="smoothScrolling",X[X.stickyTabStops=101]="stickyTabStops",X[X.stopRenderingLineAfter=102]="stopRenderingLineAfter",X[X.suggest=103]="suggest",X[X.suggestFontSize=104]="suggestFontSize",X[X.suggestLineHeight=105]="suggestLineHeight",X[X.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",X[X.suggestSelection=107]="suggestSelection",X[X.tabCompletion=108]="tabCompletion",X[X.tabIndex=109]="tabIndex",X[X.unusualLineTerminators=110]="unusualLineTerminators",X[X.useTabStops=111]="useTabStops",X[X.wordSeparators=112]="wordSeparators",X[X.wordWrap=113]="wordWrap",X[X.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=116]="wordWrapColumn",X[X.wordWrapOverride1=117]="wordWrapOverride1",X[X.wordWrapOverride2=118]="wordWrapOverride2",X[X.wrappingIndent=119]="wrappingIndent",X[X.wrappingStrategy=120]="wrappingStrategy",X[X.showDeprecated=121]="showDeprecated",X[X.inlineHints=122]="inlineHints",X[X.editorClassName=123]="editorClassName",X[X.pixelRatio=124]="pixelRatio",X[X.tabFocusMode=125]="tabFocusMode",X[X.layoutInfo=126]="layoutInfo",X[X.wrappingInfo=127]="wrappingInfo"})(qe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Se(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:_.localize(111,null)})),acceptSuggestionOnEnter:Se(new S(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",_.localize(112,null),""],markdownDescription:_.localize(113,null)})),accessibilitySupport:Se(new f),accessibilityPageSize:Se(new a(3,"accessibilityPageSize",10,1,1073741824,{description:_.localize(114,null)})),ariaLabel:Se(new E(4,"ariaLabel",_.localize(115,null))),autoClosingBrackets:Se(new S(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(116,null),_.localize(117,null),""],description:_.localize(118,null)})),autoClosingDelete:Se(new S(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",_.localize(119,null),""],description:_.localize(120,null)})),autoClosingOvertype:Se(new S(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",_.localize(121,null),""],description:_.localize(122,null)})),autoClosingQuotes:Se(new S(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",_.localize(123,null),_.localize(124,null),""],description:_.localize(125,null)})),autoIndent:Se(new d(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[_.localize(126,null),_.localize(127,null),_.localize(128,null),_.localize(129,null),_.localize(130,null)],description:_.localize(131,null)})),automaticLayout:Se(new m(10,"automaticLayout",!1)),autoSurround:Se(new S(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[_.localize(132,null),_.localize(133,null),_.localize(134,null),""],description:_.localize(135,null)})),stickyTabStops:Se(new m(101,"stickyTabStops",!1,{description:_.localize(136,null)})),codeLens:Se(new m(12,"codeLens",!0,{description:_.localize(137,null)})),codeLensFontFamily:Se(new E(13,"codeLensFontFamily","",{description:_.localize(138,null)})),codeLensFontSize:Se(new a(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:_.localize(139,null)})),colorDecorators:Se(new m(15,"colorDecorators",!0,{description:_.localize(140,null)})),columnSelection:Se(new m(16,"columnSelection",!1,{description:_.localize(141,null)})),comments:Se(new t),contextmenu:Se(new m(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Se(new m(19,"copyWithSyntaxHighlighting",!0,{description:_.localize(142,null)})),cursorBlinking:Se(new d(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:_.localize(143,null)})),cursorSmoothCaretAnimation:Se(new m(21,"cursorSmoothCaretAnimation",!1,{description:_.localize(144,null)})),cursorStyle:Se(new d(22,"cursorStyle",i.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],c,{description:_.localize(145,null)})),cursorSurroundingLines:Se(new a(23,"cursorSurroundingLines",0,0,1073741824,{description:_.localize(146,null)})),cursorSurroundingLinesStyle:Se(new S(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[_.localize(147,null),_.localize(148,null)],description:_.localize(149,null)})),cursorWidth:Se(new a(25,"cursorWidth",0,0,1073741824,{markdownDescription:_.localize(150,null)})),disableLayerHinting:Se(new m(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Se(new m(27,"disableMonospaceOptimizations",!1)),domReadOnly:Se(new m(28,"domReadOnly",!1)),dragAndDrop:Se(new m(29,"dragAndDrop",!0,{description:_.localize(151,null)})),emptySelectionClipboard:Se(new p),extraEditorClassName:Se(new E(31,"extraEditorClassName","")),fastScrollSensitivity:Se(new u(32,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:_.localize(152,null)})),find:Se(new h),fixedOverflowWidgets:Se(new m(34,"fixedOverflowWidgets",!1)),folding:Se(new m(35,"folding",!0,{description:_.localize(153,null)})),foldingStrategy:Se(new S(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[_.localize(154,null),_.localize(155,null)],description:_.localize(156,null)})),foldingHighlight:Se(new m(37,"foldingHighlight",!0,{description:_.localize(157,null)})),unfoldOnClickAfterEndOfLine:Se(new m(38,"unfoldOnClickAfterEndOfLine",!1,{description:_.localize(158,null)})),fontFamily:Se(new E(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:_.localize(159,null)})),fontInfo:Se(new R),fontLigatures2:Se(new b),fontSize:Se(new N),fontWeight:Se(new j),formatOnPaste:Se(new m(44,"formatOnPaste",!1,{description:_.localize(160,null)})),formatOnType:Se(new m(45,"formatOnType",!1,{description:_.localize(161,null)})),glyphMargin:Se(new m(46,"glyphMargin",!0,{description:_.localize(162,null)})),gotoLocation:Se(new oe),hideCursorInOverviewRuler:Se(new m(48,"hideCursorInOverviewRuler",!1,{description:_.localize(163,null)})),highlightActiveIndentGuide:Se(new m(49,"highlightActiveIndentGuide",!0,{description:_.localize(164,null)})),hover:Se(new q),inDiffEditor:Se(new m(51,"inDiffEditor",!1)),letterSpacing:Se(new u(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>u.clamp(X,-5,20),{description:_.localize(165,null)})),lightbulb:Se(new U),lineDecorationsWidth:Se(new C(54,"lineDecorationsWidth",10)),lineHeight:Se(new F),lineNumbers:Se(new Ie),lineNumbersMinChars:Se(new a(57,"lineNumbersMinChars",5,1,300)),linkedEditing:Se(new m(58,"linkedEditing",!1,{description:_.localize(166,null)})),links:Se(new m(59,"links",!0,{description:_.localize(167,null)})),matchBrackets:Se(new S(60,"matchBrackets","always",["always","near","never"],{description:_.localize(168,null)})),minimap:Se(new O),mouseStyle:Se(new S(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Se(new u(63,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:_.localize(169,null)})),mouseWheelZoom:Se(new m(64,"mouseWheelZoom",!1,{markdownDescription:_.localize(170,null)})),multiCursorMergeOverlapping:Se(new m(65,"multiCursorMergeOverlapping",!0,{description:_.localize(171,null)})),multiCursorModifier:Se(new d(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],M,{markdownEnumDescriptions:[_.localize(172,null),_.localize(173,null)],markdownDescription:_.localize(174,null)})),multiCursorPaste:Se(new S(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[_.localize(175,null),_.localize(176,null)],markdownDescription:_.localize(177,null)})),occurrencesHighlight:Se(new m(68,"occurrencesHighlight",!0,{description:_.localize(178,null)})),overviewRulerBorder:Se(new m(69,"overviewRulerBorder",!0,{description:_.localize(179,null)})),overviewRulerLanes:Se(new a(70,"overviewRulerLanes",3,0,3)),padding:Se(new B),parameterHints:Se(new V),peekWidgetDefaultFocus:Se(new S(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[_.localize(180,null),_.localize(181,null)],description:_.localize(182,null)})),definitionLinkOpensInPeek:Se(new m(74,"definitionLinkOpensInPeek",!1,{description:_.localize(183,null)})),quickSuggestions:Se(new de),quickSuggestionsDelay:Se(new a(76,"quickSuggestionsDelay",10,0,1073741824,{description:_.localize(184,null)})),readOnly:Se(new m(77,"readOnly",!1)),renameOnType:Se(new m(78,"renameOnType",!1,{description:_.localize(185,null),markdownDeprecationMessage:_.localize(186,null)})),renderControlCharacters:Se(new m(79,"renderControlCharacters",!1,{description:_.localize(187,null)})),renderIndentGuides:Se(new m(80,"renderIndentGuides",!0,{description:_.localize(188,null)})),renderFinalNewline:Se(new m(81,"renderFinalNewline",!0,{description:_.localize(189,null)})),renderLineHighlight:Se(new S(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",_.localize(190,null)],description:_.localize(191,null)})),renderLineHighlightOnlyWhenFocus:Se(new m(83,"renderLineHighlightOnlyWhenFocus",!1,{description:_.localize(192,null)})),renderValidationDecorations:Se(new S(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Se(new S(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",_.localize(193,null),_.localize(194,null),_.localize(195,null),""],description:_.localize(196,null)})),revealHorizontalRightPadding:Se(new a(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Se(new m(87,"roundedSelection",!0,{description:_.localize(197,null)})),rulers:Se(new Le),scrollbar:Se(new Y),scrollBeyondLastColumn:Se(new a(90,"scrollBeyondLastColumn",5,0,1073741824,{description:_.localize(198,null)})),scrollBeyondLastLine:Se(new m(91,"scrollBeyondLastLine",!0,{description:_.localize(199,null)})),scrollPredominantAxis:Se(new m(92,"scrollPredominantAxis",!0,{description:_.localize(200,null)})),selectionClipboard:Se(new m(93,"selectionClipboard",!0,{description:_.localize(201,null),included:I.isLinux})),selectionHighlight:Se(new m(94,"selectionHighlight",!0,{description:_.localize(202,null)})),selectOnLineNumbers:Se(new m(95,"selectOnLineNumbers",!0)),showFoldingControls:Se(new S(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[_.localize(203,null),_.localize(204,null)],description:_.localize(205,null)})),showUnused:Se(new m(97,"showUnused",!0,{description:_.localize(206,null)})),showDeprecated:Se(new m(121,"showDeprecated",!0,{description:_.localize(207,null)})),inlineHints:Se(new L),snippetSuggestions:Se(new S(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[_.localize(208,null),_.localize(209,null),_.localize(210,null),_.localize(211,null)],description:_.localize(212,null)})),smartSelect:Se(new le),smoothScrolling:Se(new m(100,"smoothScrolling",!1,{description:_.localize(213,null)})),stopRenderingLineAfter:Se(new a(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Se(new ee),suggestFontSize:Se(new a(104,"suggestFontSize",0,0,1e3,{markdownDescription:_.localize(214,null)})),suggestLineHeight:Se(new a(105,"suggestLineHeight",0,0,1e3,{markdownDescription:_.localize(215,null)})),suggestOnTriggerCharacters:Se(new m(106,"suggestOnTriggerCharacters",!0,{description:_.localize(216,null)})),suggestSelection:Se(new S(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[_.localize(217,null),_.localize(218,null),_.localize(219,null)],description:_.localize(220,null)})),tabCompletion:Se(new S(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[_.localize(221,null),_.localize(222,null),_.localize(223,null)],description:_.localize(224,null)})),tabIndex:Se(new a(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Se(new S(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[_.localize(225,null),_.localize(226,null),_.localize(227,null)],description:_.localize(228,null)})),useTabStops:Se(new m(111,"useTabStops",!0,{description:_.localize(229,null)})),wordSeparators:Se(new E(112,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:_.localize(230,null)})),wordWrap:Se(new S(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[_.localize(231,null),_.localize(232,null),_.localize(233,null),_.localize(234,null)],description:_.localize(235,null)})),wordWrapBreakAfterCharacters:Se(new E(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Se(new E(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Se(new a(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:_.localize(236,null)})),wordWrapOverride1:Se(new S(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Se(new S(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Se(new d(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Oe,{enumDescriptions:[_.localize(237,null),_.localize(238,null),_.localize(239,null),_.localize(240,null)],description:_.localize(241,null)})),wrappingStrategy:Se(new S(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[_.localize(242,null),_.localize(243,null)],description:_.localize(244,null)})),editorClassName:Se(new v),pixelRatio:Se(new Q),tabFocusMode:Se(new me),layoutInfo:Se(new H),wrappingInfo:Se(new be)}}),define(ge[152],pe([16,17]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ge[153],pe([16,17]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ge[154],pe([16,17]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(ge[155],pe([16,17]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(ge[156],pe([16,17]),function(K,e){return K.create("vs/platform/markers/common/markers",e)}),define(ge[157],pe([16,17]),function(K,e){return K.create("vs/platform/theme/common/iconRegistry",e)}),define(ge[158],pe([16,17]),function(K,e){return K.create("vs/platform/workspaces/common/workspaces",e)}),define(ge[159],pe([16,17]),function(K,e){return K.create("vs/workbench/api/common/extHost.api.impl",e)}),define(ge[160],pe([16,17]),function(K,e){return K.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ge[161],pe([16,17]),function(K,e){return K.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(ge[162],pe([16,17]),function(K,e){return K.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ge[163],pe([16,17]),function(K,e){return K.create("vs/workbench/api/common/extHostProgress",e)}),define(ge[164],pe([16,17]),function(K,e){return K.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ge[165],pe([16,17]),function(K,e){return K.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ge[166],pe([16,17]),function(K,e){return K.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ge[167],pe([16,17]),function(K,e){return K.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ge[168],pe([16,17]),function(K,e){return K.create("vs/workbench/api/node/extHostDebugService",e)}),define(ge[169],pe([16,17]),function(K,e){return K.create("vs/workbench/common/views",e)}),define(ge[170],pe([16,17]),function(K,e){return K.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ge[171],pe([16,17]),function(K,e){return K.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ge[172],pe([16,17]),function(K,e){return K.create("vs/workbench/contrib/externalTerminal/node/externalTerminalService",e)}),define(ge[173],pe([16,17]),function(K,e){return K.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ge[174],pe([16,17]),function(K,e){return K.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ge[175],pe([16,17]),function(K,e){return K.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ge[176],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var _;(function(y){y[y.ACTIVATE=0]="ACTIVATE",y[y.RESTORE=1]="RESTORE",y[y.PRESERVE=2]="PRESERVE"})(_=e.EditorActivation||(e.EditorActivation={}));var I;(function(y){y[y.PICK=1]="PICK",y[y.DISABLED=2]="DISABLED"})(I=e.EditorOverride||(e.EditorOverride={}));var T;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(T=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ge[177],pe([0,1,154]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function T(C){return C=C.trim(),C==="*"||I.test(C)}e.isValidVersionStr=T;function A(C){if(!T(C))return null;if(C=C.trim(),C==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=C.match(I);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=A;function y(C){if(!C)return null;let g=C.majorBase,m=C.majorMustEqual,a=C.minorBase,u=C.minorMustEqual,E=C.patchBase,w=C.patchMustEqual;return C.hasCaret&&(g===0||(u=!1),w=!1),{majorBase:g,majorMustEqual:m,minorBase:a,minorMustEqual:u,patchBase:E,patchMustEqual:w,isMinimum:C.hasGreaterEquals}}e.normalizeVersion=y;function k(C,g){let m;typeof C=="string"?m=y(A(C)):m=C;let a;if(typeof g=="string"?a=y(A(g)):a=g,!m||!a)return!1;let u=m.majorBase,E=m.minorBase,w=m.patchBase,S=a.majorBase,d=a.minorBase,l=a.patchBase,f=a.majorMustEqual,t=a.minorMustEqual,n=a.patchMustEqual;return a.isMinimum?u>S?!0:u<S?!1:E>d?!0:E<d?!1:w>=l:(u===1&&S===0&&(!f||!t||!n)&&(S=1,d=0,l=0,f=!0,t=!1,n=!1),u<S?!1:u>S?!f:E<d?!1:E>d?!t:w<l?!1:w>l?!n:!0)}e.isValidVersion=k;function D(C,g,m){return g.isBuiltin||typeof g.main=="undefined"?!0:s(C,g.engines.vscode,m)}e.isValidExtensionVersion=D;function P(C,g){return C==="*"||s(g,C)}e.isEngineValid=P;function s(C,g,m=[]){let a=y(A(g));if(!a)return m.push(_.localize(0,null,g)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return m.push(_.localize(1,null,g)),!1}else if(!a.majorMustEqual)return m.push(_.localize(2,null,g)),!1;return k(C,a)?!0:(m.push(_.localize(3,null,C,g)),!1)}e.isVersionValid=s}),define(ge[112],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class _{constructor(A,y=[],k=!1){this.ctor=A,this.staticArguments=y,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=_;const I=(T,...A)=>new _(T,A);e.createSyncDescriptor=I}),define(ge[79],pe([0,1,112]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const I=[];function T(y,k,D){k instanceof _.SyncDescriptor||(k=new _.SyncDescriptor(k,[],D)),I.push([y,k])}e.registerSingleton=T;function A(){return I}e.getSingletonServiceDescriptors=A}),define(ge[178],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class _{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=_;class I{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let y of this._nodes.values())y.outgoing.size===0&&A.push(y);return A}insertEdge(A,y){const k=this.lookupOrInsertNode(A),D=this.lookupOrInsertNode(y);k.outgoing.set(this._hashFn(y),D),D.incoming.set(this._hashFn(A),k)}removeNode(A){const y=this._hashFn(A);this._nodes.delete(y);for(let k of this._nodes.values())k.outgoing.delete(y),k.incoming.delete(y)}lookupOrInsertNode(A){const y=this._hashFn(A);let k=this._nodes.get(y);return k||(k=new _(A),this._nodes.set(y,k)),k}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[y,k]of this._nodes)A.push(`${y}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,y]of this._nodes){const k=new Set([A]),D=this._findCycle(y,k);if(D)return D}}_findCycle(A,y){for(let[k,D]of A.outgoing){if(y.has(k))return[...y,k].join(" -> ");y.add(k);const P=this._findCycle(D,y);if(P)return P;y.delete(k)}}}e.Graph=I}),define(ge[4],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var _;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function D(P){return P[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=D})(_=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function I(k,D,P,s){D[_.DI_TARGET]===D?D[_.DI_DEPENDENCIES].push({id:k,index:P,optional:s}):(D[_.DI_DEPENDENCIES]=[{id:k,index:P,optional:s}],D[_.DI_TARGET]=D)}function T(k){if(_.serviceIds.has(k))return _.serviceIds.get(k);const D=function(P,s,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(D,P,C,!1)};return D.toString=()=>k,_.serviceIds.set(k,D),D}e.createDecorator=T;function A(k){return k}e.refineServiceDecorator=A;function y(k){return function(D,P,s){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");I(k,D,s,!0)}}e.optional=y}),define(ge[179],pe([0,1,4]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,_.createDecorator)("modelService");function I(T){return!T.isTooLargeForSyncing()&&!T.isForSimpleWidget}e.shouldSynchronizeModel=I}),define(ge[180],pe([0,1,3,74,6,24,73,77,179]),function(K,e,_,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(g){return typeof g=="string"?!1:Array.isArray(g)?g.every(P):!!g.exclusive}class s{constructor(){this._clock=0,this._entries=[],this._onDidChange=new _.Emitter}get onDidChange(){return this._onDidChange.event}register(m,a){let u={selector:m,provider:a,_score:-1,_time:this._clock++};return this._entries.push(u),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,T.toDisposable)(()=>{if(u){let E=this._entries.indexOf(u);E>=0&&(this._entries.splice(E,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),u=void 0)}})}has(m){return this.all(m).length>0}all(m){if(!m)return[];this._updateScores(m);const a=[];for(let u of this._entries)u._score>0&&a.push(u.provider);return a}ordered(m){const a=[];return this._orderedForEach(m,u=>a.push(u.provider)),a}orderedGroups(m){const a=[];let u,E;return this._orderedForEach(m,w=>{u&&E===w._score?u.push(w.provider):(E=w._score,u=[w.provider],a.push(u))}),a}_orderedForEach(m,a){if(!!m){this._updateScores(m);for(const u of this._entries)u._score>0&&a(u)}}_updateScores(m){let a={uri:m.uri.toString(),language:m.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===a.language&&this._lastCandidate.uri===a.uri)){this._lastCandidate=a;for(let u of this._entries)if(u._score=(0,k.score)(u.selector,m.uri,m.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(m)),P(u.selector)&&u._score>0){for(let E of this._entries)E._score=0;u._score=1e3;break}this._entries.sort(s._compareByScoreAndTime)}}static _compareByScoreAndTime(m,a){return m._score<a._score?1:m._score>a._score?-1:m._time<a._time?1:m._time>a._time?-1:0}}e.LanguageFeatureRegistry=s;class C{constructor(m,a,u=Number.MAX_SAFE_INTEGER){this._registry=m,this.min=a,this.max=u,this._cache=new A.LRUCache(50,.7)}_key(m){return m.id+(0,I.hash)(this._registry.all(m))}_clamp(m){return m===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(m*1.3)))}get(m){const a=this._key(m),u=this._cache.get(a);return this._clamp(u==null?void 0:u.value)}update(m,a){const u=this._key(m);let E=this._cache.get(u);return E||(E=new y.MovingAverage,this._cache.set(u,E)),E.update(a),this.get(m)}}e.LanguageFeatureRequestDelays=C}),define(ge[80],pe([0,1,2,44,180,143,43]),function(K,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var k;(function(h){h[h.Null=0]="Null",h[h.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));class D{constructor(b,R){this.language=b,this.id=R}}e.LanguageIdentifier=D;var P;(function(h){h[h.NotSet=-1]="NotSet",h[h.None=0]="None",h[h.Italic=1]="Italic",h[h.Bold=2]="Bold",h[h.Underline=4]="Underline"})(P=e.FontStyle||(e.FontStyle={}));var s;(function(h){h[h.None=0]="None",h[h.DefaultForeground=1]="DefaultForeground",h[h.DefaultBackground=2]="DefaultBackground"})(s=e.ColorId||(e.ColorId={}));var C;(function(h){h[h.Other=0]="Other",h[h.Comment=1]="Comment",h[h.String=2]="String",h[h.RegEx=4]="RegEx"})(C=e.StandardTokenType||(e.StandardTokenType={}));var g;(function(h){h[h.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",h[h.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",h[h.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",h[h.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",h[h.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",h[h.ITALIC_MASK=2048]="ITALIC_MASK",h[h.BOLD_MASK=4096]="BOLD_MASK",h[h.UNDERLINE_MASK=8192]="UNDERLINE_MASK",h[h.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",h[h.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",h[h.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",h[h.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",h[h.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",h[h.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",h[h.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",h[h.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",h[h.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",h[h.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(g=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(b){return(b&255)>>>0}static getTokenType(b){return(b&1792)>>>8}static getFontStyle(b){return(b&14336)>>>11}static getForeground(b){return(b&8372224)>>>14}static getBackground(b){return(b&4286578688)>>>23}static getClassNameFromMetadata(b){let R=this.getForeground(b),N="mtk"+R,j=this.getFontStyle(b);return j&1&&(N+=" mtki"),j&2&&(N+=" mtkb"),j&4&&(N+=" mtku"),N}static getInlineStyleFromMetadata(b,R){const N=this.getForeground(b),j=this.getFontStyle(b);let oe=`color: ${R[N]};`;return j&1&&(oe+="font-style: italic;"),j&2&&(oe+="font-weight: bold;"),j&4&&(oe+="text-decoration: underline;"),oe}}e.TokenMetadata=m;var a;(function(h){h[h.Method=0]="Method",h[h.Function=1]="Function",h[h.Constructor=2]="Constructor",h[h.Field=3]="Field",h[h.Variable=4]="Variable",h[h.Class=5]="Class",h[h.Struct=6]="Struct",h[h.Interface=7]="Interface",h[h.Module=8]="Module",h[h.Property=9]="Property",h[h.Event=10]="Event",h[h.Operator=11]="Operator",h[h.Unit=12]="Unit",h[h.Value=13]="Value",h[h.Constant=14]="Constant",h[h.Enum=15]="Enum",h[h.EnumMember=16]="EnumMember",h[h.Keyword=17]="Keyword",h[h.Text=18]="Text",h[h.Color=19]="Color",h[h.File=20]="File",h[h.Reference=21]="Reference",h[h.Customcolor=22]="Customcolor",h[h.Folder=23]="Folder",h[h.TypeParameter=24]="TypeParameter",h[h.User=25]="User",h[h.Issue=26]="Issue",h[h.Snippet=27]="Snippet"})(a=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let h=Object.create(null);return h[0]="symbol-method",h[1]="symbol-function",h[2]="symbol-constructor",h[3]="symbol-field",h[4]="symbol-variable",h[5]="symbol-class",h[6]="symbol-struct",h[7]="symbol-interface",h[8]="symbol-module",h[9]="symbol-property",h[10]="symbol-event",h[11]="symbol-operator",h[12]="symbol-unit",h[13]="symbol-value",h[14]="symbol-constant",h[15]="symbol-enum",h[16]="symbol-enum-member",h[17]="symbol-keyword",h[27]="symbol-snippet",h[18]="symbol-text",h[19]="symbol-color",h[20]="symbol-file",h[21]="symbol-reference",h[22]="symbol-customcolor",h[23]="symbol-folder",h[24]="symbol-type-parameter",h[25]="account",h[26]="issues",function(b){const R=h[b];let N=R&&y.iconRegistry.get(R);return N||(console.info("No codicon found for CompletionItemKind "+b),N=y.Codicon.symbolProperty),N.classNames}}(),e.completionKindFromString=function(){let h=Object.create(null);return h.method=0,h.function=1,h.constructor=2,h.field=3,h.variable=4,h.class=5,h.struct=6,h.interface=7,h.module=8,h.property=9,h.event=10,h.operator=11,h.unit=12,h.value=13,h.constant=14,h.enum=15,h["enum-member"]=16,h.enumMember=16,h.keyword=17,h.snippet=27,h.text=18,h.color=19,h.file=20,h.reference=21,h.customcolor=22,h.folder=23,h["type-parameter"]=24,h.typeParameter=24,h.account=25,h.issue=26,function(b,R){let N=h[b];return typeof N=="undefined"&&!R&&(N=9),N}}();var u;(function(h){h[h.Deprecated=1]="Deprecated"})(u=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(h){h[h.KeepWhitespace=1]="KeepWhitespace",h[h.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(h){h[h.Invoke=0]="Invoke",h[h.TriggerCharacter=1]="TriggerCharacter",h[h.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(h){h[h.Invoke=1]="Invoke",h[h.Auto=2]="Auto"})(S=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(h){h[h.Invoke=1]="Invoke",h[h.TriggerCharacter=2]="TriggerCharacter",h[h.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var l;(function(h){h[h.Text=0]="Text",h[h.Read=1]="Read",h[h.Write=2]="Write"})(l=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function f(h){return h&&_.URI.isUri(h.uri)&&I.Range.isIRange(h.range)&&(I.Range.isIRange(h.originSelectionRange)||I.Range.isIRange(h.targetSelectionRange))}e.isLocationLink=f;var t;(function(h){h[h.File=0]="File",h[h.Module=1]="Module",h[h.Namespace=2]="Namespace",h[h.Package=3]="Package",h[h.Class=4]="Class",h[h.Method=5]="Method",h[h.Property=6]="Property",h[h.Field=7]="Field",h[h.Constructor=8]="Constructor",h[h.Enum=9]="Enum",h[h.Interface=10]="Interface",h[h.Function=11]="Function",h[h.Variable=12]="Variable",h[h.Constant=13]="Constant",h[h.String=14]="String",h[h.Number=15]="Number",h[h.Boolean=16]="Boolean",h[h.Array=17]="Array",h[h.Object=18]="Object",h[h.Key=19]="Key",h[h.Null=20]="Null",h[h.EnumMember=21]="EnumMember",h[h.Struct=22]="Struct",h[h.Event=23]="Event",h[h.Operator=24]="Operator",h[h.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(h){h[h.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var r;(function(h){const b=new Map;b.set("file",0),b.set("module",1),b.set("namespace",2),b.set("package",3),b.set("class",4),b.set("method",5),b.set("property",6),b.set("field",7),b.set("constructor",8),b.set("enum",9),b.set("interface",10),b.set("function",11),b.set("variable",12),b.set("constant",13),b.set("string",14),b.set("number",15),b.set("boolean",16),b.set("array",17),b.set("object",18),b.set("key",19),b.set("null",20),b.set("enum-member",21),b.set("struct",22),b.set("event",23),b.set("operator",24),b.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function N(q){return b.get(q)}h.fromString=N;function j(q){return R.get(q)}h.toString=j;function oe(q,W){const H=R.get(q);let U=H&&y.iconRegistry.get("symbol-"+H);return U||(console.info("No codicon found for SymbolKind "+q),U=y.Codicon.symbolProperty),`${W?"inline":"block"} ${U.classNames}`}h.toCssClassName=oe})(r=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(b){this.value=b}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var o;(function(h){h[h.Collapsed=0]="Collapsed",h[h.Expanded=1]="Expanded"})(o=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var c;(function(h){h[h.Editing=0]="Editing",h[h.Preview=1]="Preview"})(c=e.CommentMode||(e.CommentMode={}));var v;(function(h){h[h.Other=0]="Other",h[h.Type=1]="Type",h[h.Parameter=2]="Parameter"})(v=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new T.LanguageFeatureRegistry,e.RenameProviderRegistry=new T.LanguageFeatureRegistry,e.CompletionProviderRegistry=new T.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new T.LanguageFeatureRegistry,e.HoverProviderRegistry=new T.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new T.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new T.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new T.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new T.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new T.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new T.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.LinkProviderRegistry=new T.LanguageFeatureRegistry,e.ColorProviderRegistry=new T.LanguageFeatureRegistry,e.SelectionRangeRegistry=new T.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var p;(function(h){h[h.None=0]="None",h[h.Option=1]="Option",h[h.Default=2]="Default",h[h.Preferred=3]="Preferred"})(p=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ge[181],pe([0,1,6,11,4,3,56,54]),function(K,e,_,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,T.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new A.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(D,P){if(!D)throw new Error("invalid command");if(typeof D=="string"){if(!P)throw new Error("invalid command");return this.registerCommand({id:D,handler:P})}if(D.description){const a=[];for(let E of D.description.args)a.push(E.constraint);const u=D.handler;D.handler=function(E,...w){return(0,I.validateConstraints)(w,a),u(E,...w)}}const{id:s}=D;let C=this._commands.get(s);C||(C=new y.LinkedList,this._commands.set(s,C));let g=C.unshift(D),m=(0,_.toDisposable)(()=>{g();const a=this._commands.get(s);(a==null?void 0:a.isEmpty())&&this._commands.delete(s)});return this._onDidRegisterCommand.fire(s),m}registerCommandAlias(D,P){return e.CommandsRegistry.registerCommand(D,(s,...C)=>s.get(e.ICommandService).executeCommand(P,...C))}getCommand(D){const P=this._commands.get(D);if(!(!P||P.isEmpty()))return k.Iterable.first(P)}getCommands(){const D=new Map;for(const P of this._commands.keys()){const s=this.getCommand(P);s&&D.set(P,s)}return D}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>_.Disposable.None,onDidExecuteCommand:()=>_.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(ge[81],pe([0,1,9,4,10]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=T.userAgent||"";const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",T.isMacintosh),y.set("isLinux",T.isLinux),y.set("isWindows",T.isWindows),y.set("isWeb",T.isWeb),y.set("isMacNative",T.isMacintosh&&!T.isWeb),y.set("isEdge",A.indexOf("Edg/")>=0),y.set("isFirefox",A.indexOf("Firefox")>=0),y.set("isChrome",A.indexOf("Chrome")>=0),y.set("isSafari",A.indexOf("Safari")>=0),y.set("isIPad",A.indexOf("iPad")>=0);const k=Object.prototype.hasOwnProperty;var D;(function(h){h[h.False=0]="False",h[h.True=1]="True",h[h.Defined=2]="Defined",h[h.Not=3]="Not",h[h.Equals=4]="Equals",h[h.NotEquals=5]="NotEquals",h[h.And=6]="And",h[h.Regex=7]="Regex",h[h.NotRegex=8]="NotRegex",h[h.Or=9]="Or",h[h.In=10]="In",h[h.NotIn=11]="NotIn",h[h.Greater=12]="Greater",h[h.GreaterEquals=13]="GreaterEquals",h[h.Smaller=14]="Smaller",h[h.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return C.INSTANCE}static true(){return g.INSTANCE}static has(b){return m.create(b)}static equals(b,R){return a.create(b,R)}static notEquals(b,R){return w.create(b,R)}static regex(b,R){return n.create(b,R)}static in(b,R){return u.create(b,R)}static not(b){return S.create(b)}static and(...b){return i.create(b)}static or(...b){return o.create(b)}static greater(b,R){return d.create(b,R)}static less(b,R){return f.create(b,R)}static deserialize(b,R=!1){if(!!b)return this._deserializeOrExpression(b,R)}static _deserializeOrExpression(b,R){let N=b.split("||");return o.create(N.map(j=>this._deserializeAndExpression(j,R)))}static _deserializeAndExpression(b,R){let N=b.split("&&");return i.create(N.map(j=>this._deserializeOne(j,R)))}static _deserializeOne(b,R){if(b=b.trim(),b.indexOf("!=")>=0){let N=b.split("!=");return w.create(N[0].trim(),this._deserializeValue(N[1],R))}if(b.indexOf("==")>=0){let N=b.split("==");return a.create(N[0].trim(),this._deserializeValue(N[1],R))}if(b.indexOf("=~")>=0){let N=b.split("=~");return n.create(N[0].trim(),this._deserializeRegexValue(N[1],R))}if(b.indexOf(" in ")>=0){let N=b.split(" in ");return u.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(b)){const N=b.split(">=");return l.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(b)){const N=b.split(">");return d.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(b)){const N=b.split("<=");return t.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(b)){const N=b.split("<");return f.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(b)?S.create(b.substr(1).trim()):m.create(b)}static _deserializeValue(b,R){if(b=b.trim(),b==="true")return!0;if(b==="false")return!1;let N=/^'([^']*)'$/.exec(b);return N?N[1].trim():b}static _deserializeRegexValue(b,R){if((0,_.isFalsyOrWhitespace)(b)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=b.indexOf("/"),j=b.lastIndexOf("/");if(N===j||N<0){if(R)throw new Error(`bad regexp-value '${b}', missing /-enclosure`);return console.warn(`bad regexp-value '${b}', missing /-enclosure`),null}let oe=b.slice(N+1,j),q=b[j+1]==="i"?"i":"";try{return new RegExp(oe,q)}catch(W){if(R)throw new Error(`bad regexp-value '${b}', parse error: ${W}`);return console.warn(`bad regexp-value '${b}', parse error: ${W}`),null}}}e.ContextKeyExpr=P;function s(h,b){return h.cmp(b)}class C{constructor(){this.type=0}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}evaluate(b){return!1}serialize(){return"false"}keys(){return[]}map(b){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class g{constructor(){this.type=1}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}evaluate(b){return!0}serialize(){return"true"}keys(){return[]}map(b){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=g,g.INSTANCE=new g;class m{constructor(b){this.key=b,this.type=2}static create(b){const R=y.get(b);return typeof R=="boolean"?R?g.INSTANCE:C.INSTANCE:new m(b)}cmp(b){return b.type!==this.type?this.type-b.type:v(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}evaluate(b){return!!b.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(b){return b.mapDefined(this.key)}negate(){return S.create(this.key)}}e.ContextKeyDefinedExpr=m;class a{constructor(b,R){this.key=b,this.value=R,this.type=4}static create(b,R){if(typeof R=="boolean")return R?m.create(b):S.create(b);const N=y.get(b);return typeof N=="boolean"?R===(N?"true":"false")?g.INSTANCE:C.INSTANCE:new a(b,R)}cmp(b){return b.type!==this.type?this.type-b.type:p(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return b.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(b){return b.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class u{constructor(b,R){this.key=b,this.valueKey=R,this.type=10}static create(b,R){return new u(b,R)}cmp(b){return b.type!==this.type?this.type-b.type:p(this.key,this.valueKey,b.key,b.valueKey)}equals(b){return b.type===this.type?this.key===b.key&&this.valueKey===b.valueKey:!1}evaluate(b){const R=b.getValue(this.valueKey),N=b.getValue(this.key);return Array.isArray(R)?R.indexOf(N)>=0:typeof N=="string"&&typeof R=="object"&&R!==null?k.call(R,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(b){return b.mapIn(this.key,this.valueKey)}negate(){return E.create(this)}}e.ContextKeyInExpr=u;class E{constructor(b){this._actual=b,this.type=11}static create(b){return new E(b)}cmp(b){return b.type!==this.type?this.type-b.type:this._actual.cmp(b._actual)}equals(b){return b.type===this.type?this._actual.equals(b._actual):!1}evaluate(b){return!this._actual.evaluate(b)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(b){return new E(this._actual.map(b))}negate(){return this._actual}}e.ContextKeyNotInExpr=E;class w{constructor(b,R){this.key=b,this.value=R,this.type=5}static create(b,R){if(typeof R=="boolean")return R?S.create(b):m.create(b);const N=y.get(b);return typeof N=="boolean"?R===(N?"true":"false")?C.INSTANCE:g.INSTANCE:new w(b,R)}cmp(b){return b.type!==this.type?this.type-b.type:p(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return b.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(b){return b.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class S{constructor(b){this.key=b,this.type=3}static create(b){const R=y.get(b);return typeof R=="boolean"?R?C.INSTANCE:g.INSTANCE:new S(b)}cmp(b){return b.type!==this.type?this.type-b.type:v(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}evaluate(b){return!b.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(b){return b.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=S;class d{constructor(b,R){this.key=b,this.value=R,this.type=12}static create(b,R){return new d(b,R)}cmp(b){return b.type!==this.type?this.type-b.type:p(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(b){return b.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=d;class l{constructor(b,R){this.key=b,this.value=R,this.type=13}static create(b,R){return new l(b,R)}cmp(b){return b.type!==this.type?this.type-b.type:p(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(b){return b.mapGreaterEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=l;class f{constructor(b,R){this.key=b,this.value=R,this.type=14}static create(b,R){return new f(b,R)}cmp(b){return b.type!==this.type?this.type-b.type:p(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(b){return b.mapSmaller(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerExpr=f;class t{constructor(b,R){this.key=b,this.value=R,this.type=15}static create(b,R){return new t(b,R)}cmp(b){return b.type!==this.type?this.type-b.type:p(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(b){return b.mapSmallerEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(b,R){this.key=b,this.regexp=R,this.type=7}static create(b,R){return new n(b,R)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.key<b.key)return-1;if(this.key>b.key)return 1;const R=this.regexp?this.regexp.source:"",N=b.regexp?b.regexp.source:"";return R<N?-1:R>N?1:0}equals(b){if(b.type===this.type){const R=this.regexp?this.regexp.source:"",N=b.regexp?b.regexp.source:"";return this.key===b.key&&R===N}return!1}evaluate(b){let R=b.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const b=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${b}`}keys(){return[this.key]}map(b){return b.mapRegex(this.key,this.regexp)}negate(){return r.create(this)}}e.ContextKeyRegexExpr=n;class r{constructor(b){this._actual=b,this.type=8}static create(b){return new r(b)}cmp(b){return b.type!==this.type?this.type-b.type:this._actual.cmp(b._actual)}equals(b){return b.type===this.type?this._actual.equals(b._actual):!1}evaluate(b){return!this._actual.evaluate(b)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(b){return new r(this._actual.map(b))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class i{constructor(b){this.expr=b,this.type=6}static create(b){return i._normalizeArr(b)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let R=0,N=this.expr.length;R<N;R++){const j=s(this.expr[R],b.expr[R]);if(j!==0)return j}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let R=0,N=this.expr.length;R<N;R++)if(!this.expr[R].equals(b.expr[R]))return!1;return!0}return!1}evaluate(b){for(let R=0,N=this.expr.length;R<N;R++)if(!this.expr[R].evaluate(b))return!1;return!0}static _normalizeArr(b){const R=[];let N=!1;for(const j of b)if(!!j){if(j.type===1){N=!0;continue}if(j.type===0)return C.INSTANCE;if(j.type===6){R.push(...j.expr);continue}R.push(j)}if(R.length===0&&N)return g.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(s);R.length>1;){const j=R[R.length-1];if(j.type!==9)break;R.pop();const oe=R.pop(),q=o.create(j.expr.map(W=>i.create([W,oe])));q&&(R.push(q),R.sort(s))}return R.length===1?R[0]:new i(R)}}serialize(){return this.expr.map(b=>b.serialize()).join(" && ")}keys(){const b=[];for(let R of this.expr)b.push(...R.keys());return b}map(b){return new i(this.expr.map(R=>R.map(b)))}negate(){let b=[];for(let R of this.expr)b.push(R.negate());return o.create(b)}}e.ContextKeyAndExpr=i;class o{constructor(b){this.expr=b,this.type=9}static create(b){const R=o._normalizeArr(b);if(R.length!==0)return R.length===1?R[0]:new o(R)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let R=0,N=this.expr.length;R<N;R++){const j=s(this.expr[R],b.expr[R]);if(j!==0)return j}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let R=0,N=this.expr.length;R<N;R++)if(!this.expr[R].equals(b.expr[R]))return!1;return!0}return!1}evaluate(b){for(let R=0,N=this.expr.length;R<N;R++)if(this.expr[R].evaluate(b))return!0;return!1}static _normalizeArr(b){let R=[],N=!1;if(b){for(let j=0,oe=b.length;j<oe;j++){const q=b[j];if(!!q){if(q.type===0){N=!0;continue}if(q.type===1)return[g.INSTANCE];if(q.type===9){R=R.concat(q.expr);continue}R.push(q)}}if(R.length===0&&N)return[C.INSTANCE];R.sort(s)}return R}serialize(){return this.expr.map(b=>b.serialize()).join(" || ")}keys(){const b=[];for(let R of this.expr)b.push(...R.keys());return b}map(b){return new o(this.expr.map(R=>R.map(b)))}negate(){let b=[];for(let N of this.expr)b.push(N.negate());const R=N=>N.type===9?N.expr:[N];for(;b.length>1;){const N=b.shift(),j=b.shift(),oe=[];for(const q of R(N))for(const W of R(j))oe.push(P.and(q,W));b.unshift(P.or(...oe))}return b[0]}}e.ContextKeyOrExpr=o;class c extends m{constructor(b,R,N){super(b);this._defaultValue=R,typeof N=="object"?c._info.push(Object.assign(Object.assign({},N),{key:b})):N!==!0&&c._info.push({key:b,description:N,type:R!=null?typeof R:void 0})}static all(){return c._info.values()}bindTo(b){return b.createKey(this.key,this._defaultValue)}getValue(b){return b.getContextKeyValue(this.key)}toNegated(){return P.not(this.key)}isEqualTo(b){return P.equals(this.key,b)}notEqualsTo(b){return P.notEquals(this.key,b)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(h,b){return h<b?-1:h>b?1:0}function p(h,b,R,N){return h<R?-1:h>R?1:b<N?-1:b>N?1:0}}),define(ge[182],pe([0,1,4]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,_.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,_.refineServiceDecorator)(e.IEnvironmentService)}),define(ge[183],pe([0,1,153,4,12]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function A(C){return C&&typeof C=="object"&&typeof C.id=="string"&&(!C.uuid||typeof C.uuid=="string")}e.isIExtensionIdentifier=A;var y;(function(C){C[C.NoneOrRelevance=0]="NoneOrRelevance",C[C.LastUpdatedDate=1]="LastUpdatedDate",C[C.Title=2]="Title",C[C.PublisherName=3]="PublisherName",C[C.InstallCount=4]="InstallCount",C[C.PublishedDate=5]="PublishedDate",C[C.AverageRating=6]="AverageRating",C[C.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var k;(function(C){C[C.Default=0]="Default",C[C.Ascending=1]="Ascending",C[C.Descending=2]="Descending"})(k=e.SortOrder||(e.SortOrder={}));var D;(function(C){C.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var P;(function(C){C[C.None=0]="None",C[C.Install=1]="Install",C[C.Update=2]="Update"})(P=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class s extends Error{constructor(g,m){super(g);this.code=m}}e.ExtensionManagementError=s,e.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,_.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,_.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(ge[28],pe([0,1,9,4]),function(K,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function T(P){return P&&typeof P=="object"&&typeof P.id=="string"&&(!P.uuid||typeof P.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(P){P[P.System=0]="System",P[P.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class y{constructor(s){this.value=s,this._lower=s.toLowerCase()}static equals(s,C){if(typeof s=="undefined"||s===null)return typeof C=="undefined"||C===null;if(typeof C=="undefined"||C===null)return!1;if(typeof s=="string"||typeof C=="string"){let g=typeof s=="string"?s:s.value,m=typeof C=="string"?C:C.value;return _.equalsIgnoreCase(g,m)}return s._lower===C._lower}static toKey(s){return typeof s=="string"?s.toLowerCase():s._lower}}e.ExtensionIdentifier=y;function k(P){return P.contributes&&P.contributes.localizations?P.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function D(P){return P.contributes&&P.contributes.authentication?P.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=D,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(ge[184],pe([0,1,9,28]),function(K,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function T(m,a){return m.uuid&&a.uuid?m.uuid===a.uuid:m.id===a.id?!0:(0,_.compareIgnoreCase)(m.id,a.id)===0}e.areSameExtensions=T;class A{constructor(a,u){this.version=u,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof A?T(this,a)&&this.version===a.version:!1}}e.ExtensionIdentifierWithVersion=A;function y(m,a){return`${m}.${a}`}e.getExtensionId=y;function k(m){return m.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function D(m,a){return k(y(m,a))}e.getGalleryExtensionId=D;function P(m,a){const u=[],E=w=>{for(const S of u)if(S.some(d=>T(a(d),a(w))))return S;return null};for(const w of m){const S=E(w);S?S.push(w):u.push([w])}return u}e.groupByExtension=P;function s(m){return{id:m.identifier.id,name:m.manifest.name,galleryId:null,publisherId:m.publisherId,publisherName:m.manifest.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:m.manifest.extensionDependencies&&m.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=s;function C(m){return Object.assign({id:m.identifier.id,name:m.name,galleryId:m.identifier.uuid,publisherId:m.publisherId,publisherName:m.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:!!(m.properties.dependencies&&m.properties.dependencies.length>0)},m.telemetryData)}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function g(m){const a=new Set;for(const u of m)u.malicious&&a.add(u.id.id);return a}e.getMaliciousExtensionsSet=g}),define(ge[45],pe([0,1,155,8,2,4,9,11,24]),function(K,e,_,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,A.createDecorator)("fileService");function P(q){return q.create===!0}e.isFileOpenForWriteOptions=P;var s;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(s=e.FileType||(e.FileType={}));var C;(function(q){q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(q){return!!(q.capabilities&2)}e.hasReadWriteCapability=g;function m(q){return!!(q.capabilities&8)}e.hasFileFolderCopyCapability=m;function a(q){return!!(q.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function u(q){return!!(q.capabilities&16)}e.hasFileReadStreamCapability=u;var E;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(W,H){super(W);this.code=H}}e.FileSystemProviderError=w;function S(q,W){const H=new w(q.toString(),W);return l(H,W),H}e.createFileSystemProviderError=S;function d(q){return q||S((0,_.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=d;function l(q,W){return q.name=W?`${W} (FileSystemError)`:"FileSystemError",q}e.markAsFileSystemProviderError=l;function f(q){if(!q)return E.Unknown;if(q instanceof w)return q.code;const W=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!W)return E.Unknown;switch(W[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=f;function t(q){if(q instanceof v)return q.fileOperationResult;switch(f(q)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var n;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class r{constructor(W,H,U){this.resource=W,this.operation=H,this.target=U}isOperation(W){return this.operation===W}}e.FileOperationEvent=r;var i;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(i=e.FileChangeType||(e.FileChangeType={}));class o{constructor(W,H){this.ignorePathCasing=H,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=W;for(const U of W)switch(U.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(U.resource,U);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(U.resource,U);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(U.resource,U);break}}contains(W,...H){return this.doContains(W,{includeChildren:!1},...H)}affects(W,...H){return this.doContains(W,{includeChildren:!0},...H)}doContains(W,H,...U){var L,F,O,M,B,V;if(!W)return!1;const Q=U.length>0;return!!((!Q||U.includes(1))&&(((L=this.added)===null||L===void 0?void 0:L.get(W))||H.includeChildren&&((F=this.added)===null||F===void 0?void 0:F.findSuperstr(W)))||(!Q||U.includes(0))&&(((O=this.updated)===null||O===void 0?void 0:O.get(W))||H.includeChildren&&((M=this.updated)===null||M===void 0?void 0:M.findSuperstr(W)))||(!Q||U.includes(2))&&(((B=this.deleted)===null||B===void 0?void 0:B.findSubstr(W))||H.includeChildren&&((V=this.deleted)===null||V===void 0?void 0:V.findSuperstr(W))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(W){const H=[],U=W===1?this.added:W===0?this.updated:this.deleted;if(U)for(const[,L]of U)H.push(L);return H}filter(W){return new o(this.changes.filter(H=>W(H)),this.ignorePathCasing)}}e.FileChangesEvent=o;function c(q,W,H){return!q||!W||q===W||W.length>q.length?!1:(W.charAt(W.length-1)!==I.sep&&(W+=I.sep),H?(0,y.startsWithIgnoreCase)(q,W):q.indexOf(W)===0)}e.isParent=c;class v extends Error{constructor(W,H,U){super(W);this.fileOperationResult=H,this.options=U}static isFileOperationError(W){return W instanceof Error&&!(0,k.isUndefinedOrNull)(W.fileOperationResult)}}e.FileOperationError=v;var p;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",q[q.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(p=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var h;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(h=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function b(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.etag=b;async function R(q,W){if(!W.canHandleResource(T.URI.from({scheme:q.scheme})))return new Promise(H=>{const U=W.onDidChangeFileSystemProviderRegistrations(L=>{L.scheme===q.scheme&&L.added&&(U.dispose(),H())})})}e.whenProviderRegistered=R,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(W){return(0,k.isNumber)(W)||(W=0),W<N.KB?(0,_.localize)(1,null,W.toFixed(0)):W<N.MB?(0,_.localize)(2,null,(W/N.KB).toFixed(2)):W<N.GB?(0,_.localize)(3,null,(W/N.MB).toFixed(2)):W<N.TB?(0,_.localize)(4,null,(W/N.GB).toFixed(2)):(0,_.localize)(5,null,(W/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var j;(function(q){q[q.IA32=0]="IA32",q[q.OTHER=1]="OTHER"})(j=e.Arch||(e.Arch={}));function oe(q){return{maxFileSize:q===0?300*N.MB:16*N.GB,maxHeapSize:q===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=oe}),define(ge[82],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class _{constructor(...T){this._entries=new Map;for(let[A,y]of T)this.set(A,y)}set(T,A){const y=this._entries.get(T);return this._entries.set(T,A),y}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=_}),define(ge[185],pe([0,1,18,178,112,4,82,15]),function(K,e,_,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class P extends Error{constructor(a){var u;super("cyclic dependency between services");this.message=(u=a.findCycleSlow())!==null&&u!==void 0?u:`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class s{constructor(a=new y.ServiceCollection,u=!1,E){this._activeInstantiations=new Set,this._services=a,this._strict=u,this._parent=E,this._services.set(A.IInstantiationService,this)}createChild(a){return new s(a,this._strict,this)}invokeFunction(a,...u){let E=g.traceInvocation(a),w=!1;try{return a({get:(d,l)=>{if(w)throw(0,_.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(d,E);if(!f&&l!==A.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return f}},...u)}finally{w=!0,E.stop()}}createInstance(a,...u){let E,w;return a instanceof T.SyncDescriptor?(E=g.traceCreation(a.ctor),w=this._createInstance(a.ctor,a.staticArguments.concat(u),E)):(E=g.traceCreation(a),w=this._createInstance(a,u,E)),E.stop(),w}_createInstance(a,u=[],E){let w=A._util.getServiceDependencies(a).sort((l,f)=>l.index-f.index),S=[];for(const l of w){let f=this._getOrCreateServiceInstance(l.id,E);if(!f&&this._strict&&!l.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${l.id}.`);S.push(f)}let d=w.length>0?w[0].index:u.length;if(u.length!==d){console.warn(`[createInstance] First service dependency of ${a.name} at position ${d+1} conflicts with ${u.length} static arguments`);let l=d-u.length;l>0?u=u.concat(new Array(l)):u=u.slice(0,d)}return new a(...[...u,...S])}_setServiceInstance(a,u){if(this._services.get(a)instanceof T.SyncDescriptor)this._services.set(a,u);else if(this._parent)this._parent._setServiceInstance(a,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let u=this._services.get(a);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):u}_getOrCreateServiceInstance(a,u){let E=this._getServiceInstanceOrDescriptor(a);return E instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,E,u.branch(a,!0)):(u.branch(a,!1),E)}_safeCreateAndCacheServiceInstance(a,u,E){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,u,E)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,u,E){const w=new I.Graph(l=>l.id.toString());let S=0;const d=[{id:a,desc:u,_trace:E}];for(;d.length;){const l=d.pop();if(w.lookupOrInsertNode(l),S++>1e3)throw new P(w);for(let f of A._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(f.id);if(!t&&!f.optional&&console.warn(`[createInstance] ${a} depends on ${f.id} which is NOT registered.`),t instanceof T.SyncDescriptor){const n={id:f.id,desc:t,_trace:l._trace.branch(f.id,!0)};w.insertEdge(l,n),d.push(n)}}}for(;;){const l=w.roots();if(l.length===0){if(!w.isEmpty())throw new P(w);break}for(const{data:f}of l){if(this._getServiceInstanceOrDescriptor(f.id)instanceof T.SyncDescriptor){const n=this._createServiceInstanceWithOwner(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this._setServiceInstance(f.id,n)}w.removeNode(f)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,u,E=[],w,S){if(this._services.get(a)instanceof T.SyncDescriptor)return this._createServiceInstance(u,E,w,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,u,E,w,S);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(a,u=[],E,w){if(E){const S=new k.IdleValue(()=>this._createInstance(a,u,w));return new Proxy(Object.create(null),{get(d,l){if(l in d)return d[l];let f=S.value,t=f[l];return typeof t!="function"||(t=t.bind(f),d[l]=t),t},set(d,l,f){return S.value[l]=f,!0}})}else return this._createInstance(a,u,w)}}e.InstantiationService=s;var C;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(C||(C={}));class g{constructor(a,u){this.type=a,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return D?new g(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(a){return D?new g(0,a.name):g._None}branch(a,u){let E=new g(2,a.toString());return this._dep.push([a,u,E]),E}stop(){let a=Date.now()-this._start;g._totals+=a;let u=!1;function E(S,d){let l=[],f=new Array(S+1).join("	");for(const[t,n,r]of d._dep)if(n&&r){u=!0,l.push(`${f}CREATES -> ${t}`);let i=E(S+1,r);i&&l.push(i)}else l.push(`${f}uses -> ${t}`);return l.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(a>2||u)&&console.log(w.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(ge[13],pe([0,1,4,6,10,3,59]),function(K,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function k(){return new Date().toISOString()}var D;(function(f){f[f.Trace=0]="Trace",f[f.Debug=1]="Debug",f[f.Info=2]="Info",f[f.Warning=3]="Warning",f[f.Error=4]="Error",f[f.Critical=5]="Critical",f[f.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class P extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class s extends P{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(D.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(D.Error,this.format(r))}else this.log(D.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let r=0;r<t.length;r++){let i=t[r];if(typeof i=="object")try{i=JSON.stringify(i)}catch(o){}n+=(r>0?" ":"")+i}return n}}e.AbstractMessageLogger=s;class C extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!T.isWindows}trace(t,...n){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...n):console.log(`[main ${k()}]`,t,...n))}debug(t,...n){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...n):console.log(`[main ${k()}]`,t,...n))}info(t,...n){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...n):console.log(`[main ${k()}]`,t,...n))}warn(t,...n){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,t,...n):console.warn(`[main ${k()}]`,t,...n))}error(t,...n){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,t,...n):console.error(`[main ${k()}]`,t,...n))}critical(t,...n){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,t,...n):console.error(`[main ${k()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class g extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=g;class m extends P{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,y.toErrorMessage)(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class a extends P{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const r of this.logServices)r.trace(t,...n)}debug(t,...n){for(const r of this.logServices)r.debug(t,...n)}info(t,...n){for(const r of this.logServices)r.info(t,...n)}warn(t,...n){for(const r of this.logServices)r.warn(t,...n)}error(t,...n){for(const r of this.logServices)r.error(t,...n)}critical(t,...n){for(const r of this.logServices)r.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=a;class u extends I.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=u;class E extends I.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(r))}))}createLogger(t,n){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,(n==null?void 0:n.always)?D.Trace:this.logLevel,n),this.loggers.set(t.toString(),r),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=E;class w{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=w;function S(f){if(f.verbose)return D.Trace;if(typeof f.logLevel=="string"){const t=d(f.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=S;function d(f){switch(f){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=d;function l(f){switch(f){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=l}),define(ge[113],pe([0,1,13,45]),function(K,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function T(D,P,s,C){try{const g=await new Promise((m,a)=>{K(["spdlog"],m,a)});return g.setAsyncMode(8192,500),g.createRotatingLoggerAsync(D,P,s,C)}catch(g){console.error(g)}return null}function A(D,P,s,C){return K.__$__nodeRequire("spdlog").createRotatingLogger(D,P,s,C)}e.createRotatingLogger=A;function y(D,P,s){switch(P){case _.LogLevel.Trace:D.trace(s);break;case _.LogLevel.Debug:D.debug(s);break;case _.LogLevel.Info:D.info(s);break;case _.LogLevel.Warning:D.warn(s);break;case _.LogLevel.Error:D.error(s);break;case _.LogLevel.Critical:D.critical(s);break;default:throw new Error("Invalid log level")}}class k extends _.AbstractMessageLogger{constructor(P,s,C,g){super();this.name=P,this.filepath=s,this.rotating=C,this.buffer=[],this.setLevel(g),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}_createSpdLogLogger(){const P=this.rotating?6:1,s=30/P*I.ByteSize.MB;return T(this.name,this.filepath,s,P).then(C=>{if(C){this._logger=C,this._logger.setLevel(this.getLevel());for(const{level:g,message:m}of this.buffer)y(this._logger,g,m);this.buffer=[]}})}log(P,s){this._logger?y(this._logger,P,s):this.getLevel()<=P&&this.buffer.push({level:P,message:s})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(ge[114],pe([0,1,4,156,57]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var y;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function P(a,u){return u-a}D.compare=P;const s=Object.create(null);s[D.Error]=(0,I.localize)(0,null),s[D.Warning]=(0,I.localize)(1,null),s[D.Info]=(0,I.localize)(2,null);function C(a){return s[a]||""}D.toString=C;function g(a){switch(a){case T.default.Error:return D.Error;case T.default.Warning:return D.Warning;case T.default.Info:return D.Info;case T.default.Ignore:return D.Hint}}D.fromSeverity=g;function m(a){switch(a){case D.Error:return T.default.Error;case D.Warning:return T.default.Warning;case D.Info:return T.default.Info;case D.Hint:return T.default.Ignore}}D.toSeverity=m}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(D){const P="";function s(g){return C(g,!0)}D.makeKey=s;function C(g,m){let a=[P];return g.source?a.push(g.source.replace("\xA6","\\\xA6")):a.push(P),g.code?typeof g.code=="string"?a.push(g.code.replace("\xA6","\\\xA6")):a.push(g.code.value.replace("\xA6","\\\xA6")):a.push(P),g.severity!==void 0&&g.severity!==null?a.push(y.toString(g.severity)):a.push(P),g.message&&m?a.push(g.message.replace("\xA6","\\\xA6")):a.push(P),g.startLineNumber!==void 0&&g.startLineNumber!==null?a.push(g.startLineNumber.toString()):a.push(P),g.startColumn!==void 0&&g.startColumn!==null?a.push(g.startColumn.toString()):a.push(P),g.endLineNumber!==void 0&&g.endLineNumber!==null?a.push(g.endLineNumber.toString()):a.push(P),g.endColumn!==void 0&&g.endColumn!==null?a.push(g.endColumn.toString()):a.push(P),a.push(P),a.join("\xA6")}D.makeKeyOptionalMessage=C})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(ge[186],pe([0,1,57,4,3]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=_.default,e.INotificationService=(0,I.createDecorator)("notificationService");var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new D,this.onDidClose=T.Event.None,this.onDidChangeVisibility=T.Event.None}updateSeverity(s){}updateMessage(s){}updateActions(s){}close(){}}e.NoOpNotification=k;class D{infinite(){}done(){}total(s){}worked(s){}}e.NoOpProgress=D}),define(ge[187],pe([0,1,12,10,36,25]),function(K,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof I.globals.vscode!="undefined"){const k=I.globals.vscode.context.configuration();if(k)y=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(K==null?void 0:K.__$__nodeRequire)=="function"){const k=(0,A.dirname)(_.FileAccess.asFileUri("",K));y=K.__$__nodeRequire((0,A.joinPath)(k,"product.json").fsPath);const D=K.__$__nodeRequire((0,A.joinPath)(k,"package.json").fsPath);T.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`}),Object.assign(y,{version:D.version})}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.56.0-dev",nameShort:I.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:I.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=y});var Ve=this&&this.__decorate||function(K,e,_,I){var T=arguments.length,A=T<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,_):I,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(K,e,_,I);else for(var k=K.length-1;k>=0;k--)(y=K[k])&&(A=(T<3?y(A):T>3?y(e,_,A):y(e,_))||A);return T>3&&A&&Object.defineProperty(e,_,A),A},xe=this&&this.__param||function(K,e){return function(_,I){e(_,I,K)}};define(ge[115],pe([0,1,4,21,6,15]),function(K,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,_.createDecorator)("progressService");var y;(function(s){s[s.Explorer=1]="Explorer",s[s.Scm=3]="Scm",s[s.Extensions=5]="Extensions",s[s.Window=10]="Window",s[s.Notification=15]="Notification",s[s.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let D=class extends T.Disposable{constructor(C,g){super();this.deferred=new A.DeferredPromise,g.withProgress(C,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,T.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};D=Ve([xe(1,e.IProgressService)],D),e.UnmanagedProgress=D;class P extends T.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new T.DisposableStore)}start(C){this.stop();const g=++this.currentOperationId,m=new I.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{g===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,T.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,T.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,T.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:g,token:m.token,stop:()=>this.doStop(g),isCurrent:()=>this.currentOperationId===g}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,_.createDecorator)("editorProgressService")}),define(ge[40],pe([0,1,11,52]),function(K,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(y,k){I.ok(_.isString(y)),I.ok(_.isObject(k)),I.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,k)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new T}),define(ge[116],pe([0,1,40,3]),function(K,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class A{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,P){this.schemasById[T(D)]=P,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new A;_.Registry.add(e.Extensions.JSONContribution,y)}),define(ge[83],pe([0,1,152,3,40,11,116]),function(K,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const D=T.Registry.as(y.Extensions.JSONContribution);class P{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,S=!0){this.registerConfigurations([w],S)}registerConfigurations(w,S=!0){const d=[];w.forEach(l=>{d.push(...this.validateAndRegisterProperties(l,S,l.extensionInfo)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterConfigurations(w){const S=[],d=l=>{if(l.properties)for(const f in l.properties)S.push(f),delete this.configurationProperties[f],this.removeFromSchema(f,l.properties[f]);l.allOf&&l.allOf.forEach(f=>d(f))};for(const l of w){d(l);const f=this.configurationContributors.indexOf(l);f!==-1&&this.configurationContributors.splice(f,1)}D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}registerDefaultConfigurations(w){const S=[],d=[];for(const l of w)for(const f in l)if(S.push(f),e.OVERRIDE_PROPERTY_PATTERN.test(f)){this.defaultValues[f]=Object.assign(Object.assign({},this.defaultValues[f]||{}),l[f]);const t={type:"object",default:this.defaultValues[f],description:_.localize(1,null,f),$ref:e.resourceLanguageSettingsSchemaId};d.push(C(f)),this.configurationProperties[f]=t,this.defaultLanguageConfigurationOverridesNode.properties[f]=t}else{this.defaultValues[f]=l[f];const t=this.configurationProperties[f];t&&(this.updatePropertyDefaultValue(f,t),this.updateSchema(f,t))}this.registerOverrideIdentifiers(d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}deregisterDefaultConfigurations(w){const S=[];for(const d of w)for(const l in d)if(S.push(l),delete this.defaultValues[l],e.OVERRIDE_PROPERTY_PATTERN.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const f=this.configurationProperties[l];f&&(this.updatePropertyDefaultValue(l,f),this.updateSchema(l,f))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const S of w)this.overrideIdentifiers.add(S);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,S=!0,d,l=3){var f;l=A.isUndefinedOrNull(w.scope)?l:w.scope;let t=[],n=w.properties;if(n)for(let i in n){if(S&&a(i)){delete n[i];continue}const o=n[i];if(this.updatePropertyDefaultValue(i,o),e.OVERRIDE_PROPERTY_PATTERN.test(i)?o.scope=void 0:(o.scope=A.isUndefinedOrNull(o.scope)?l:o.scope,o.requireTrust=A.isUndefinedOrNull(o.requireTrust)?!!((f=d==null?void 0:d.requireTrustForConfigurations)===null||f===void 0?void 0:f.includes(i)):o.requireTrust),n[i].hasOwnProperty("included")&&!n[i].included){this.excludedConfigurationProperties[i]=n[i],delete n[i];continue}else this.configurationProperties[i]=n[i];!n[i].deprecationMessage&&n[i].markdownDeprecationMessage&&(n[i].deprecationMessage=n[i].markdownDeprecationMessage),t.push(i)}let r=w.allOf;if(r)for(let i of r)t.push(...this.validateAndRegisterProperties(i,S,d,l));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const S=d=>{let l=d.properties;if(l)for(const t in l)this.updateSchema(t,l[t]);let f=d.allOf;f&&f.forEach(S)};S(w)}updateSchema(w,S){switch(e.allSettings.properties[w]=S,S.scope){case 1:e.applicationSettings.properties[w]=S;break;case 2:e.machineSettings.properties[w]=S;break;case 6:e.machineOverridableSettings.properties[w]=S;break;case 3:e.windowSettings.properties[w]=S;break;case 4:e.resourceSettings.properties[w]=S;break;case 5:e.resourceSettings.properties[w]=S,this.resourceLanguageSettingsSchema.properties[w]=S;break}}removeFromSchema(w,S){switch(delete e.allSettings.properties[w],S.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const S=`[${w}]`,d={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(S,d),e.allSettings.properties[S]=d,e.applicationSettings.properties[S]=d,e.machineSettings.properties[S]=d,e.machineOverridableSettings.properties[S]=d,e.windowSettings.properties[S]=d,e.resourceSettings.properties[S]=d}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,S){let d=this.defaultValues[w];A.isUndefined(d)&&(d=S.default),A.isUndefined(d)&&(d=g(S.type)),S.default=d}}const s="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(s);function C(E){return E.substring(1,E.length-1)}e.overrideIdentifierFromKey=C;function g(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const m=new P;T.Registry.add(e.Extensions.Configuration,m);function a(E){return E.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(E)?_.localize(5,null,E):m.getConfigurationProperties()[E]!==void 0?_.localize(6,null,E):null:_.localize(4,null)}e.validateProperty=a;function u(){const E=[],w=m.getConfigurationProperties();for(const S of Object.keys(w))E.push([S,w[S].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=u}),define(ge[84],pe([0,1,23,11,2,40,4,83]),function(K,e,_,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function D(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof T.URI)}e.isConfigurationOverrides=D;var P;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function s(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=s;function C(n,r){const i=r?n?r.keys.filter(R=>n.keys.indexOf(R)===-1):[...r.keys]:[],o=n?r?n.keys.filter(R=>r.keys.indexOf(R)===-1):[...n.keys]:[],c=[];if(r&&n){for(const R of n.keys)if(r.keys.indexOf(R)!==-1){const N=w(n.contents,R),j=w(r.contents,R);_.equals(N,j)||c.push(R)}}const v=[],p=R=>{const N={};for(const j of R)for(const oe of j.identifiers)N[f(oe)]=j;return N},h=r?p(r.overrides):{},b=n?p(n.overrides):{};if(Object.keys(h).length)for(const R of i){const N=h[R];N&&v.push([(0,k.overrideIdentifierFromKey)(R),N.keys])}if(Object.keys(b).length)for(const R of o){const N=b[R];N&&v.push([(0,k.overrideIdentifierFromKey)(R),N.keys])}if(Object.keys(h).length&&Object.keys(b).length)for(const R of c){const N=b[R],j=h[R];if(N&&j){const oe=C({contents:N.contents,keys:N.keys,overrides:[]},{contents:j.contents,keys:j.keys,overrides:[]});v.push([(0,k.overrideIdentifierFromKey)(R),[...oe.added,...oe.removed,...oe.updated]])}}return{added:i,removed:o,updated:c,overrides:v}}e.compare=C;function g(n,r){const i=[];for(const o of Object.keys(n))if(k.OVERRIDE_PROPERTY_PATTERN.test(o)){const c={};for(const v in n[o])c[v]=n[o][v];i.push({identifiers:[(0,k.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(c),contents:m(c,r)})}return i}e.toOverrides=g;function m(n,r){const i=Object.create(null);for(let o in n)a(i,o,n[o],r);return i}e.toValuesTree=m;function a(n,r,i,o){const c=r.split("."),v=c.pop();let p=n;for(let h=0;h<c.length;h++){let b=c[h],R=p[b];switch(typeof R){case"undefined":R=p[b]=Object.create(null);break;case"object":break;default:o(`Ignoring ${r} as ${c.slice(0,h+1).join(".")} is ${JSON.stringify(R)}`);return}p=R}if(typeof p=="object"&&p!==null)try{p[v]=i}catch(h){o(`Ignoring ${r} as ${c.join(".")} is ${JSON.stringify(p)}`)}else o(`Ignoring ${r} as ${c.join(".")} is ${JSON.stringify(p)}`)}e.addToValueTree=a;function u(n,r){const i=r.split(".");E(n,i)}e.removeFromValueTree=u;function E(n,r){const i=r.shift();if(r.length===0){delete n[i];return}if(Object.keys(n).indexOf(i)!==-1){const o=n[i];typeof o=="object"&&!Array.isArray(o)&&(E(o,r),Object.keys(o).length===0&&delete n[i])}}function w(n,r,i){function o(p,h){let b=p;for(const R of h){if(typeof b!="object"||b===null)return;b=b[R]}return b}const c=r.split("."),v=o(n,c);return typeof v=="undefined"?i:v}e.getConfigurationValue=w;function S(n,r,i){Object.keys(r).forEach(o=>{o!=="__proto__"&&(o in n?I.isObject(n[o])&&I.isObject(r[o])?S(n[o],r[o],i):i&&(n[o]=r[o]):n[o]=r[o])})}e.merge=S;function d(){const n=A.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=d;function l(){const n=Object.create(null),r=A.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let i in r){let o=r[i].default;a(n,i,o,c=>console.error(`Conflict in default settings: ${c}`))}return n}e.getDefaultValues=l;function f(n){return`[${n}]`}e.keyFromOverrideIdentifier=f;function t(n,r,i){const o=n.inspect(r),c=n.inspect(i);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:o.defaultValue}e.getMigratedSettingValue=t}),define(ge[188],pe([0,1,55,24,19,11,23,2,83,84,40,6,3]),function(K,e,_,I,T,A,y,k,D,P,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},n=[],r=[]){this._contents=t,this._keys=n,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,P.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const r=this.getContentsForOverrideIdentifer(n);return r?t?(0,P.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let r={};for(const i of T.distinct([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[i],c=n[i];c&&(typeof o=="object"&&typeof c=="object"?(o=y.deepClone(o),this.mergeContents(o,c)):o=c),r[i]=o}return new m(r,this.keys,this.overrides)}merge(...t){const n=y.deepClone(this.contents),r=y.deepClone(this.overrides),i=[...this.keys];for(const o of t){this.mergeContents(n,o.contents);for(const c of o.overrides){const[v]=r.filter(p=>T.equals(p.identifiers,c.identifiers));v?this.mergeContents(v.contents,c.contents):r.push(y.deepClone(c))}for(const c of o.keys)i.indexOf(c)===-1&&i.push(c)}return new m(n,i,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const r of Object.keys(n)){if(r in t&&A.isObject(t[r])&&A.isObject(n[r])){this.mergeContents(t[r],n[r]);continue}t[r]=y.deepClone(n[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,P.addToValueTree)(this.contents,t,n,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,P.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let r=0;r<n;r++)t.indexOf(this.keys[r])===0&&(n=r);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=m;class a extends m{constructor(){const t=(0,P.getDefaultValues)(),n=(0,P.getConfigurationKeys)(),r=[];for(const i of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(i)&&r.push({identifiers:[(0,D.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,P.toValuesTree)(t[i],o=>console.error(`Conflict in default settings file: ${o}`))});super(t,n,r)}}e.DefaultConfigurationModel=a;class u{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!A.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:r,keys:i,overrides:o,untrusted:c}=this.doParseRaw(t,n);this._configurationModel=new m(r,i,o),this._untrustedConfigurations=c||[]}doParseContent(t){let n={},r=null,i=[],o=[],c=[];function v(h){Array.isArray(i)?i.push(h):r&&(i[r]=h)}let p={onObjectBegin:()=>{let h={};v(h),o.push(i),i=h,r=null},onObjectProperty:h=>{r=h},onObjectEnd:()=>{i=o.pop()},onArrayBegin:()=>{let h=[];v(h),o.push(i),i=h,r=null},onArrayEnd:()=>{i=o.pop()},onLiteralValue:v,onError:(h,b,R)=>{c.push({error:h,offset:b,length:R})}};if(t)try{_.visit(t,p),n=i[0]||{}}catch(h){console.error(`Error while parsing settings file ${this._name}: ${h}`),this._parseErrors=[h]}return n}doParseRaw(t,n){const r=s.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,r,!0,n);t=i.raw;const o=(0,P.toValuesTree)(t,p=>console.error(`Conflict in settings file ${this._name}: ${p}`)),c=Object.keys(t),v=(0,P.toOverrides)(t,p=>console.error(`Conflict in settings file ${this._name}: ${p}`));return{contents:o,keys:c,overrides:v,untrusted:i.untrusted}}filter(t,n,r,i){if(!(i==null?void 0:i.scopes)&&!(i==null?void 0:i.isUntrusted))return{raw:t,untrusted:[]};const o={},c=[];for(let v in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(v)&&r){const p=this.filter(t[v],n,!1,i);o[v]=p.raw,c.push(...p.untrusted)}else{const p=n[v],h=p?typeof p.scope!="undefined"?p.scope:3:void 0;(h===void 0||i.scopes===void 0||i.scopes.includes(h))&&(i.isUntrusted&&(p==null?void 0:p.requireTrust)?c.push(v):o[v]=t[v])}return{raw:o,untrusted:c}}}e.ConfigurationModelParser=u;class E extends C.Disposable{constructor(t,n,r,i){super();this.userSettingsResource=t,this.scopes=n,this.fileService=i,this._onDidChange=this._register(new g.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(g.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=E;class w{constructor(t,n,r=new m,i=new m,o=new I.ResourceMap,c=new m,v=new I.ResourceMap,p=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=r,this._workspaceConfiguration=i,this._folderConfigurations=o,this._memoryConfiguration=c,this._memoryConfigurationByResource=v,this._freeze=p,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(t,n,r){return this.getConsolidateConfigurationModel(n,r).getValue(t)}updateValue(t,n,r={}){let i;r.resource?(i=this._memoryConfigurationByResource.get(r.resource),i||(i=new m,this._memoryConfigurationByResource.set(r.resource,i))):i=this._memoryConfiguration,n===void 0?i.removeValue(t):i.setValue(t,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,r){const i=this.getConsolidateConfigurationModel(n,r),o=this.getFolderConfigurationModelForResource(n.resource,r),c=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,v=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),p=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),h=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),b=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=r?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,N=o?n.overrideIdentifier?o.freeze().override(n.overrideIdentifier).getValue(t):o.freeze().getValue(t):void 0,j=n.overrideIdentifier?c.override(n.overrideIdentifier).getValue(t):c.getValue(t),oe=i.getValue(t),q=T.distinct(T.flatten(i.overrides.map(W=>W.identifiers))).filter(W=>i.getOverrideValue(t,W)!==void 0);return{defaultValue:v,userValue:p,userLocalValue:h,userRemoteValue:b,workspaceValue:R,workspaceFolderValue:N,memoryValue:j,value:oe,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:p!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:h!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:b!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:o==null?void 0:o.freeze().getValue(t),override:n.overrideIdentifier?o==null?void 0:o.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:j!==void 0?{value:c.getValue(t),override:n.overrideIdentifier?c.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const r=n.filter(i=>D.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const o=(0,D.overrideIdentifierFromKey)(i),c=this._defaultConfiguration.getKeysForOverrideIdentifier(o),v=t.getKeysForOverrideIdentifier(o),p=[...v.filter(h=>c.indexOf(h)===-1),...c.filter(h=>v.indexOf(h)===-1),...c.filter(h=>!y.equals(this._defaultConfiguration.override(o).getValue(h),t.override(o).getValue(h)))];return[o,p]});return this.updateDefaultConfiguration(t),{keys:n,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:r,removed:i,overrides:o}=(0,P.compare)(this.localUserConfiguration,t),c=[...n,...r,...i];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:r,removed:i,overrides:o}=(0,P.compare)(this.remoteUserConfiguration,t);let c=[...n,...r,...i];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:r,removed:i,overrides:o}=(0,P.compare)(this.workspaceConfiguration,t);let c=[...n,...r,...i];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:o}}compareAndUpdateFolderConfiguration(t,n){const r=this.folderConfigurations.get(t),{added:i,updated:o,removed:c,overrides:v}=(0,P.compare)(r,n);let p=[...i,...o,...c];return(p.length||!r)&&this.updateFolderConfiguration(t,n),{keys:p,overrides:v}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:i,removed:o,overrides:c}=(0,P.compare)(n,void 0);return{keys:[...r,...i,...o],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let r=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const i=n.getFolder(t);i&&(r=this.getFolderConsolidatedConfiguration(i.uri)||r);const o=this._memoryConfigurationByResource.get(t);o&&(r=r.merge(o))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(n=r.merge(i),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=r}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const r=n.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:r,overrides:i,keys:o}=this._folderConfigurations.get(n);return t.push([n,{contents:r,overrides:i,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(i=>n.add(i))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((c,v)=>(c.set(k.URI.revive(v[0]),this.parseConfigurationModel(v[1])),c),new I.ResourceMap);return new w(n,r,new m,i,o,new m,new I.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function S(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const t=new Set,n=new Map;for(const i of f)i.keys.forEach(o=>t.add(o)),i.overrides.forEach(([o,c])=>{const v=(0,I.getOrSet)(n,o,new Set);c.forEach(p=>v.add(p))});const r=[];return n.forEach((i,o)=>r.push([o,[...i.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=S;class d{constructor(t,n,r,i){this.change=t,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=i,this._previousConfiguration=void 0;const o=new Set;t.keys.forEach(v=>o.add(v)),t.overrides.forEach(([,v])=>v.forEach(p=>o.add(p))),this.affectedKeys=[...o.values()];const c=new m;this.affectedKeys.forEach(v=>c.setValue(v,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var r;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(r=this.previous)===null||r===void 0?void 0:r.workspace):void 0,o=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!y.equals(i,o)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let r=(0,P.toValuesTree)({[n]:!0},()=>{}),i;for(;typeof r=="object"&&(i=Object.keys(r)[0]);){if(t=t[i],!t)return!1;r=r[i]}return!0}}e.ConfigurationChangeEvent=d;class l extends d{constructor(t,n,r,i){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=r,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=l}),define(ge[85],pe([0,1,4]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,_.createDecorator)("remoteAuthorityResolverService");var I;(function(y){y[y.Unknown=0]="Unknown",y[y.DisableTrust=1]="DisableTrust",y[y.MachineTrusted=2]="MachineTrusted"})(I=e.RemoteTrustOption||(e.RemoteTrustOption={}));var T;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends Error{constructor(k,D=T.Unknown,P){super(k);this._message=k,this._code=D,this._detail=P,this.isHandled=D===T.NotAvailable&&P===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}static isTemporarilyNotAvailable(k){return k instanceof A&&k._code===T.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof A&&k._code===T.NoResolverFound}static isHandled(k){return k instanceof A&&k.isHandled}}e.RemoteAuthorityResolverError=A}),define(ge[117],pe([0,1,12]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function I(D){return D.scheme===_.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=I;function T(D){if(!!D){const P=D.indexOf("+");return P<0?D:D.substr(0,P)}}e.getRemoteName=T;function A(D){return D.scheme!==_.Schemas.file&&D.scheme!==_.Schemas.vscodeRemote}function y(D){if(D.folders.length)return D.folders.every(P=>A(P.uri))?D.folders[0].uri:void 0;if(D.configuration&&A(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=y;function k(D){var P;return(P=y(D))===null||P===void 0?void 0:P.scheme}e.getVirtualWorkspaceScheme=k}),define(ge[189],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class _{vsda(){return new Promise((T,A)=>K(["vsda"],T,A))}async sign(T){try{const A=await this.vsda(),y=new A.signer;if(y)return y.sign(T)}catch(A){}return T}}e.SignService=_}),define(ge[190],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class _{constructor(T){this._callback=T,this._terminalBufferMap=new Map}dispose(){for(const T of this._terminalBufferMap.values())T.dispose()}startBuffering(T,A,y=5){let k;return k=A(D=>{const P=typeof D=="string"?D:D.data;let s=this._terminalBufferMap.get(T);if(s){s.data.push(P);return}const C=setTimeout(()=>this.flushBuffer(T),y);s={data:[P],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(T),k.dispose()}},this._terminalBufferMap.set(T,s)}),k}stopBuffering(T){const A=this._terminalBufferMap.get(T);A&&A.dispose()}flushBuffer(T){const A=this._terminalBufferMap.get(T);A&&(this._terminalBufferMap.delete(T),this._callback(T,A.data.join("")))}}e.TerminalDataBufferer=_}),define(ge[191],pe([0,1,48,8,36,26,11,23,10]),function(K,e,_,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function P(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(_.release());let g=0;return C&&C.length===4&&(g=parseInt(C[3])),g}e.getWindowsBuildNumber=P;async function s(C,g,m,a=T.env,u=A.exists){if(I.isAbsolute(C))return await u(C)?C:void 0;if(g===void 0&&(g=T.cwd()),I.dirname(C)!=="."){const d=I.join(g,C);return await u(d)?d:void 0}const w=(0,k.getCaseInsensitive)(a,"PATH");if(m===void 0&&(0,y.isString)(w)&&(m=w.split(I.delimiter)),m===void 0||m.length===0){const d=I.join(g,C);return await u(d)?d:void 0}for(let d of m){let l;if(I.isAbsolute(d)?l=I.join(d,C):l=I.join(g,d,C),await u(l))return l;if(D.isWindows){let f=l+".com";if(await u(f)||(f=l+".exe",await u(f)))return f}}const S=I.join(g,C);return await u(S)?S:void 0}e.findExecutable=s}),define(ge[192],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var _;(function(I){I.DARK="dark",I.LIGHT="light",I.HIGH_CONTRAST="hc"})(_=e.ColorScheme||(e.ColorScheme={}))}),define(ge[193],pe([0,1,4,6,40,3,192,43]),function(K,e,_,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,_.createDecorator)("themeService");var D;(function(E){function w(S){return S&&typeof S=="object"&&typeof S.id=="string"}E.isThemeColor=w})(D=e.ThemeColor||(e.ThemeColor={}));function P(E){return{id:E}}e.themeColorFromId=P;var s;(function(E){function w(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||D.isThemeColor(t.color))}E.isThemeIcon=w;const S=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function d(t){const n=S.exec(t);if(!!n){let[,r]=n;return{id:r}}}E.fromString=d;function l(t,n){let r=t.id;const i=r.lastIndexOf("~");return i!==-1&&(r=r.substring(0,i)),n&&(r=`${r}~${n}`),{id:r}}E.modify=l;function f(t,n){var r,i;return t.id===n.id&&((r=t.color)===null||r===void 0?void 0:r.id)===((i=n.color)===null||i===void 0?void 0:i.id)}E.isEqual=f,E.asClassNameArray=k.CSSIcon.asClassNameArray,E.asClassName=k.CSSIcon.asClassName,E.asCSSSelector=k.CSSIcon.asCSSSelector})(s=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function C(E){switch(E){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new A.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,I.toDisposable)(()=>{const S=this.themingParticipants.indexOf(w);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new g;T.Registry.add(e.Extensions.ThemingContribution,m);function a(E){return m.onColorThemeChange(E)}e.registerThemingParticipant=a;class u extends I.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,S){let d=this.theme.getColor(w);return d&&S&&(d=S(d,this.theme)),d?d.toString():null}}e.Themable=u}),define(ge[194],pe([0,1,40,193,3,157,116,15,43]),function(K,e,_,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class P{constructor(){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${D.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(w,S,d,l){const f=this.iconsById[w];if(f){if(d&&!f.description){f.description=d,this.iconSchema.properties[w].markdownDescription=`${d} $(${w})`;const r=this.iconReferenceSchema.enum.indexOf(w);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=d),this._onDidChange.fire()}return f}let t={id:w,description:d,defaults:S,deprecationMessage:l};this.iconsById[w]=t;let n={$ref:"#/definitions/icons"};return l&&(n.deprecationMessage=l),d&&(n.markdownDescription=`${d}: $(${w})`),this.iconSchema.properties[w]=n,this.iconReferenceSchema.enum.push(w),this.iconReferenceSchema.enumDescriptions.push(d||""),this._onDidChange.fire(),{id:w}}deregisterIcon(w){delete this.iconsById[w],delete this.iconSchema.properties[w];const S=this.iconReferenceSchema.enum.indexOf(w);S!==-1&&(this.iconReferenceSchema.enum.splice(S,1),this.iconReferenceSchema.enumDescriptions.splice(S,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(w=>this.iconsById[w])}getIcon(w){return this.iconsById[w]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(w,S){const d=this.iconFontsById[w];if(d)return d;let l={id:w,definition:S};return this.iconFontsById[w]=l,this._onDidChange.fire(),l}deregisterIconFont(w){delete this.iconFontsById[w]}getIconFonts(){return Object.keys(this.iconFontsById).map(w=>this.iconFontsById[w])}getIconFont(w){return this.iconFontsById[w]}toString(){const w=(f,t)=>f.id.localeCompare(t.id),S=f=>{for(;I.ThemeIcon.isThemeIcon(f.defaults);)f=this.iconsById[f.defaults.id];return`codicon codicon-${f?f.id:""}`};let d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.iconsById).map(f=>this.iconsById[f]);for(const f of l.filter(t=>!!t.description).sort(w))d.push(`|<i class="${S(f)}"></i>|${f.id}|${I.ThemeIcon.isThemeIcon(f.defaults)?f.defaults.id:f.id}|${f.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const f of l.filter(t=>!I.ThemeIcon.isThemeIcon(t.defaults)).sort(w))d.push(`|<i class="${S(f)}"></i>|${f.id}|`);return d.join(`
`)}}const s=new P;_.Registry.add(e.Extensions.IconContribution,s);function C(E,w,S,d){return s.registerIcon(E,w,S,d)}e.registerIcon=C;function g(){return s}e.getIconRegistry=g;function m(){for(const E of D.iconRegistry.all)s.registerIcon(E.id,E.definition,E.description);D.iconRegistry.onDidRegister(E=>s.registerIcon(E.id,E.definition,E.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let a=_.Registry.as(y.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,s.getIconSchema());const u=new k.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);s.onDidChange(()=>{u.isScheduled()||u.schedule()}),e.widgetClose=C("widget-close",D.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=C("goto-previous-location",D.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=C("goto-next-location",D.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=I.ThemeIcon.modify(D.Codicon.sync,"spin")}),define(ge[60],pe([0,1,2,25,4,24]),function(K,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var y;(function(g){g[g.EMPTY=1]="EMPTY",g[g.FOLDER=2]="FOLDER",g[g.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function k(g){const m=g;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=k;function D(g){const m=g;return!!(m&&typeof m=="object"&&_.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=D;class P{constructor(m,a,u,E){this._id=m,this._configuration=u,this._ignorePathCasing=E,this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(m){this._id=m.id,this._configuration=m.configuration,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=P;class s{constructor(m,a){this.raw=a,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,I.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=s;function C(g){return new s({uri:g,index:0,name:(0,I.basenameOrAuthority)(g)},{uri:g.toString()})}e.toWorkspaceFolder=C}),define(ge[118],pe([0,1,4,158,60,2,10,8,25,133,55,12,76,29,117]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const u=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(H){return(typeof H=="string"?(0,k.extname)(H):(0,D.extname)(H))===u}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,_.createDecorator)("workspacesService");function w(H){return H.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function S(H){return H.hasOwnProperty("folderUri")}e.isRecentFolder=S;function d(H){return H.hasOwnProperty("fileUri")}e.isRecentFile=d;function l(H){const U=H;return typeof(U==null?void 0:U.id)=="string"&&A.URI.isUri(U.uri)}e.isSingleFolderWorkspaceIdentifier=l;function f(H){if(H.configuration)return{id:H.id,configPath:H.configuration};if(H.folders.length===1)return{id:H.id,uri:H.folders[0].uri}}e.toWorkspaceIdentifier=f;function t(H){const U=H;return typeof(U==null?void 0:U.id)=="string"&&A.URI.isUri(U.configPath)}e.isWorkspaceIdentifier=t;function n(H){const U=H;if(U==null?void 0:U.uri)return{id:U.id,uri:A.URI.revive(U.uri)};const L=H;if(L==null?void 0:L.configPath)return{id:L.id,configPath:A.URI.revive(L.configPath)};if(H==null?void 0:H.id)return{id:H.id}}e.reviveIdentifier=n;function r(H,U){return D.extUriBiasedIgnorePathCase.isEqualOrParent(H,U.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function i(H){return o(H)||c(H)}e.isStoredWorkspaceFolder=i;function o(H){const U=H;return typeof(U==null?void 0:U.path)=="string"&&(!U.name||typeof U.name=="string")}e.isRawFileWorkspaceFolder=o;function c(H){const U=H;return typeof(U==null?void 0:U.uri)=="string"&&(!U.name||typeof U.name=="string")}e.isRawUriWorkspaceFolder=c;function v(H,U,L,F,O=!y.isWindows,M){if(H.scheme!==F.scheme)return{name:L,uri:H.toString(!0)};let B=U?void 0:M.relativePath(F,H);if(B!==void 0)B.length===0?B=".":y.isWindows&&H.scheme===C.Schemas.file&&!O&&(B=B.replace(/\//g,"\\"));else if(H.scheme===C.Schemas.file)B=H.fsPath,y.isWindows&&(B=(0,g.normalizeDriveLetter)(B),O&&(B=(0,m.toSlashes)(B)));else{if(!M.isEqualAuthority(H.authority,F.authority))return{name:L,uri:H.toString(!0)};B=H.path}return{name:L,path:B}}e.getStoredWorkspaceFolder=v;function p(H,U,L){let F=[],O=new Set;const M=L.dirname(U);for(let B of H){let V=null;if(o(B))B.path&&(V=L.resolvePath(M,B.path));else if(c(B))try{V=A.URI.parse(B.uri),V.path[0]!=="/"&&(V=V.with({path:"/"+V.path}))}catch(Q){console.warn(Q)}if(V){let Q=L.getComparisonKey(V);if(!O.has(Q)){O.add(Q);const de=B.name||L.basenameOrAuthority(V);F.push(new T.WorkspaceFolder({uri:V,name:de,index:F.length},B))}}}return F}e.toWorkspaceFolders=p;function h(H,U,L,F,O){let M=b(U,H);const B=O.dirname(U),V=O.dirname(F),Q=[],de=R(M.folders);for(const Le of M.folders){const z=o(Le)?O.resolvePath(B,Le.path):A.URI.parse(Le.uri);let Y;L?Y=!1:Y=!o(Le)||(0,k.isAbsolute)(Le.path),Q.push(v(z,Y,Le.name,V,de,O))}const we={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},Ie=P.setProperty(H,["folders"],Q,we);let Ce=P.applyEdits(H,Ie);return M.remoteAuthority===(0,a.getRemoteAuthority)(F)&&(Ce=P.applyEdits(Ce,P.removeProperty(Ce,["remoteAuthority"],we))),Ce}e.rewriteWorkspaceFileForNewLocation=h;function b(H,U){let L=s.parse(U);if(L&&Array.isArray(L.folders))L.folders=L.folders.filter(F=>i(F));else throw new Error(`${H} looks like an invalid workspace file.`);return L}function R(H){return y.isWindows?H.some(U=>o(U)&&U.path.indexOf("/")>=0):!0}e.useSlashForPath=R;function N(H){return H.workspace&&typeof H.workspace=="object"&&typeof H.workspace.id=="string"&&typeof H.workspace.configPath=="string"}function j(H){return typeof H.folderUri=="string"}function oe(H){return typeof H.fileUri=="string"}function q(H,U){const L={workspaces:[],files:[]};if(H){const F=function(M,B){for(let V=0;V<M.length;V++)try{B(M[V],V)}catch(Q){U.warn(`Error restoring recent entry ${JSON.stringify(M[V])}: ${Q.toString()}. Skip entry.`)}},O=H;if(Array.isArray(O.entries))F(O.entries,M=>{const B=M.label,V=M.remoteAuthority;N(M)?L.workspaces.push({label:B,remoteAuthority:V,workspace:{id:M.workspace.id,configPath:A.URI.parse(M.workspace.configPath)}}):j(M)?L.workspaces.push({label:B,remoteAuthority:V,folderUri:A.URI.parse(M.folderUri)}):oe(M)&&L.files.push({label:B,remoteAuthority:V,fileUri:A.URI.parse(M.fileUri)})});else{const M=H;Array.isArray(M.workspaces3)&&F(M.workspaces3,(B,V)=>{const Q=Array.isArray(M.workspaceLabels)&&M.workspaceLabels[V]||void 0;typeof B=="object"&&typeof B.id=="string"&&typeof B.configURIPath=="string"?L.workspaces.push({label:Q,workspace:{id:B.id,configPath:A.URI.parse(B.configURIPath)}}):typeof B=="string"&&L.workspaces.push({label:Q,folderUri:A.URI.parse(B)})}),Array.isArray(M.files2)&&F(M.files2,(B,V)=>{const Q=Array.isArray(M.fileLabels)&&M.fileLabels[V]||void 0;typeof B=="string"&&L.files.push({label:Q,fileUri:A.URI.parse(B)})})}}return L}e.restoreRecentlyOpened=q;function W(H){const U={entries:[]};for(const L of H.workspaces)S(L)?U.entries.push({folderUri:L.folderUri.toString(),label:L.label,remoteAuthority:L.remoteAuthority}):U.entries.push({workspace:{id:L.workspace.id,configPath:L.workspace.configPath.toString()},label:L.label,remoteAuthority:L.remoteAuthority});for(const L of H.files)U.entries.push({fileUri:L.fileUri.toString(),label:L.label,remoteAuthority:L.remoteAuthority});return U}e.toStoreData=W}),define(ge[86],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class _{constructor(T){this.id=T,this._data=new Map,this._idPool=1}add(T){const A=this._idPool++;return this._data.set(A,T),this.logDebugInfo(),A}get(T,A){return this._data.has(T)?this._data.get(T)[A]:void 0}delete(T){this._data.delete(T),this.logDebugInfo()}logDebugInfo(){!_.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=_,_.enableDebugLogging=!1}),define(ge[195],pe([0,1,2,3]),function(K,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class T{constructor(){this._onDidChangeTabs=new I.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(y){this._tabs=y.map(k=>({name:k.name,group:k.group,resource:_.URI.revive(k.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(ge[61],pe([0,1,12,4]),function(K,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(_.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(y,k){k===null?this._providerInfo.delete(y):this._providerInfo.set(y,k)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(ge[27],pe([0,1,4]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,_.createDecorator)("IExtHostInitDataService")}),define(ge[196],pe([0,1,15]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class I{constructor(y,k,D){this._deferredPromises=new Map,this._id=y,this._shared=k,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new _.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const s of P.values())s.complete()}catch(s){for(const C of P.values())C.error(s)}})()},0)}get whenReady(){return this._init}get(y,k){let D=this._value[y];return typeof D=="undefined"&&(D=k),D}update(y,k){this._value[y]=k;let D=this._deferredPromises.get(y);if(D!==void 0)return D.p;const P=new _.DeferredPromise;return this._deferredPromises.set(y,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=I;class T extends I{constructor(y,k){super(y.identifier.value,!0,k);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=T}),define(ge[14],pe([0,1,4]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,_.createDecorator)("IExtHostRpcService");class I{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=I});var tt=this&&this.__classPrivateFieldSet||function(K,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!T:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(K,_):T?T.value=_:e.set(K,_),_},Ue=this&&this.__classPrivateFieldGet||function(K,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!I:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(K):I?I.value:e.get(K)};define(ge[197],pe([0,1,28,3]),function(K,e,_,I){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(k,D){T.set(this,void 0),this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._id=_.ExtensionIdentifier.toKey(k.identifier),tt(this,T,D,"f"),Ue(this,T,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(k){return Ue(this,T,"f").get(this._id,k)}store(k,D){return Ue(this,T,"f").store(this._id,k,D)}delete(k){return Ue(this,T,"f").delete(this._id,k)}}e.ExtensionSecrets=A,T=new WeakMap}),define(ge[119],pe([0,1,4,3]),function(K,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class T{constructor(){this._onDidChangeTelemetryEnabled=new I.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(y){this._enabled=y}$onDidChangeTelemetryEnabled(y){this._enabled=y,this._onDidChangeTelemetryEnabled.fire(y)}}e.ExtHostTelemetry=T,e.IExtHostTelemetry=(0,_.createDecorator)("IExtHostTelemetry")}),define(ge[87],pe([0,1,3]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var I;(function(y){y[y.NewChild=0]="NewChild",y[y.Disposed=1]="Disposed",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp"})(I=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const T=new WeakMap,A=y=>{let k=T.get(y);return k||(k={children:new Map,bus:new _.Emitter},T.set(y,k)),k};e.getPrivateApiFor=A}),define(ge[50],pe([0,1,4,3,14]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(k){function D(s){return{remoteAddress:s.remoteAddress,localAddress:s.localAddress,public:!!s.public}}k.fromApiTunnel=D;function P(s){return{remoteAddress:{host:s.tunnelRemoteHost,port:s.tunnelRemotePort},localAddress:s.localAddress,public:s.public}}k.fromServiceTunnel=P})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,_.createDecorator)("IExtHostTunnelService");let y=class{constructor(D){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,P){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,P){return{dispose:()=>{}}}async $providePortAttributes(D,P,s,C,g){return[]}async $forwardPort(D,P){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=Ve([xe(0,T.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var tt=this&&this.__classPrivateFieldSet||function(K,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!T:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(K,_):T?T.value=_:e.set(K,_),_},Ue=this&&this.__classPrivateFieldGet||function(K,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!I:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(K):I?I.value:e.get(K)},jt=this&&this.__rest||function(K,e){var _={};for(var I in K)Object.prototype.hasOwnProperty.call(K,I)&&e.indexOf(I)<0&&(_[I]=K[I]);if(K!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,I=Object.getOwnPropertySymbols(K);T<I.length;T++)e.indexOf(I[T])<0&&Object.prototype.propertyIsEnumerable.call(K,I[T])&&(_[I[T]]=K[I[T]]);return _};define(ge[7],pe([0,1,19,18,98,24,9,11,2,30,45,85,87]),function(K,e,_,I,T,A,y,k,D,P,s,C,g){"use strict";var m,a,u,E,w,S,d,l,f,t,n,r,i,o,c,v;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function p($){function x(){return Reflect.construct($,arguments,this.constructor)}return Object.defineProperty(x,"name",Object.getOwnPropertyDescriptor($,"name")),Object.setPrototypeOf(x,$),Object.setPrototypeOf(x.prototype,$.prototype),x}let h=u=class{constructor(x){m.set(this,void 0),tt(this,m,x,"f")}static from(...x){let se=x;return new u(function(){if(se){for(const ke of se)ke&&typeof ke.dispose=="function"&&ke.dispose();se=void 0}})}dispose(){typeof Ue(this,m,"f")=="function"&&(Ue(this,m,"f").call(this),tt(this,m,void 0,"f"))}};m=new WeakMap,h=u=Ve([p],h),e.Disposable=h;let b=E=class{constructor(x,se){if(x<0)throw(0,I.illegalArgument)("line must be non-negative");if(se<0)throw(0,I.illegalArgument)("character must be non-negative");this._line=x,this._character=se}static Min(...x){if(x.length===0)throw new TypeError;let se=x[0];for(let ke=1;ke<x.length;ke++){const Ge=x[ke];Ge.isBefore(se)&&(se=Ge)}return se}static Max(...x){if(x.length===0)throw new TypeError;let se=x[0];for(let ke=1;ke<x.length;ke++){const Ge=x[ke];Ge.isAfter(se)&&(se=Ge)}return se}static isPosition(x){if(!x)return!1;if(x instanceof E)return!0;let{line:se,character:ke}=x;return typeof se=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<x._character}isBeforeOrEqual(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<=x._character}isAfter(x){return!this.isBeforeOrEqual(x)}isAfterOrEqual(x){return!this.isBefore(x)}isEqual(x){return this._line===x._line&&this._character===x._character}compareTo(x){return this._line<x._line?-1:this._line>x.line?1:this._character<x._character?-1:this._character>x._character?1:0}translate(x,se=0){if(x===null||se===null)throw(0,I.illegalArgument)();let ke;return typeof x=="undefined"?ke=0:typeof x=="number"?ke=x:(ke=typeof x.lineDelta=="number"?x.lineDelta:0,se=typeof x.characterDelta=="number"?x.characterDelta:0),ke===0&&se===0?this:new E(this.line+ke,this.character+se)}with(x,se=this.character){if(x===null||se===null)throw(0,I.illegalArgument)();let ke;return typeof x=="undefined"?ke=this.line:typeof x=="number"?ke=x:(ke=typeof x.line=="number"?x.line:this.line,se=typeof x.character=="number"?x.character:this.character),ke===this.line&&se===this.character?this:new E(ke,se)}toJSON(){return{line:this.line,character:this.character}}};b=E=Ve([p],b),e.Position=b;let R=w=class{constructor(x,se,ke,Ge){let et,st;if(typeof x=="number"&&typeof se=="number"&&typeof ke=="number"&&typeof Ge=="number"?(et=new b(x,se),st=new b(ke,Ge)):x instanceof b&&se instanceof b&&(et=x,st=se),!et||!st)throw new Error("Invalid arguments");et.isBefore(st)?(this._start=et,this._end=st):(this._start=st,this._end=et)}static isRange(x){return x instanceof w?!0:x?b.isPosition(x.start)&&b.isPosition(x.end):!1}get start(){return this._start}get end(){return this._end}contains(x){return x instanceof w?this.contains(x._start)&&this.contains(x._end):x instanceof b?!(x.isBefore(this._start)||this._end.isBefore(x)):!1}isEqual(x){return this._start.isEqual(x._start)&&this._end.isEqual(x._end)}intersection(x){const se=b.Max(x.start,this._start),ke=b.Min(x.end,this._end);if(!se.isAfter(ke))return new w(se,ke)}union(x){if(this.contains(x))return this;if(x.contains(this))return x;const se=b.Min(x.start,this._start),ke=b.Max(x.end,this.end);return new w(se,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(x,se=this.end){if(x===null||se===null)throw(0,I.illegalArgument)();let ke;return x?b.isPosition(x)?ke=x:(ke=x.start||this.start,se=x.end||this.end):ke=this.start,ke.isEqual(this._start)&&se.isEqual(this.end)?this:new w(ke,se)}toJSON(){return[this.start,this.end]}};R=w=Ve([p],R),e.Range=R;let N=S=class extends R{constructor(x,se,ke,Ge){let et,st;if(typeof x=="number"&&typeof se=="number"&&typeof ke=="number"&&typeof Ge=="number"?(et=new b(x,se),st=new b(ke,Ge)):x instanceof b&&se instanceof b&&(et=x,st=se),!et||!st)throw new Error("Invalid arguments");super(et,st);this._anchor=et,this._active=st}static isSelection(x){return x instanceof S?!0:x?R.isRange(x)&&b.isPosition(x.anchor)&&b.isPosition(x.active)&&typeof x.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};N=S=Ve([p],N),e.Selection=N;class j{constructor(x,se,ke){if(typeof x!="string"||x.length===0)throw(0,I.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,I.illegalArgument)("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw(0,I.illegalArgument)("connectionToken");this.host=x,this.port=Math.round(se),this.connectionToken=ke}}e.ResolvedAuthority=j;class oe extends Error{constructor(x,se=C.RemoteAuthorityResolverErrorCode.Unknown,ke){super(x);this._message=x,this._code=se,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,oe.prototype)}static NotAvailable(x,se){return new oe(x,C.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(x){return new oe(x,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=oe;var q;(function($){$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(q=e.EndOfLine||(e.EndOfLine={}));var W;(function($){$[$.Replace=1]="Replace",$[$.Append=2]="Append",$[$.Prepend=3]="Prepend"})(W=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let H=d=class{constructor(x,se){this._range=x,this._newText=se}static isTextEdit(x){return x instanceof d?!0:x?R.isRange(x)&&typeof x.newText=="string":!1}static replace(x,se){return new d(x,se)}static insert(x,se){return d.replace(new R(x,x),se)}static delete(x){return d.replace(x,"")}static setEndOfLine(x){const se=new d(new R(new b(0,0),new b(0,0)),"");return se.newEol=x,se}get range(){return this._range}set range(x){if(x&&!R.isRange(x))throw(0,I.illegalArgument)("range");this._range=x}get newText(){return this._newText||""}set newText(x){if(x&&typeof x!="string")throw(0,I.illegalArgument)("newText");this._newText=x}get newEol(){return this._newEol}set newEol(x){if(x&&typeof x!="number")throw(0,I.illegalArgument)("newEol");this._newEol=x}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};H=d=Ve([p],H),e.TextEdit=H;var U;(function($){$[$.File=1]="File",$[$.Text=2]="Text",$[$.Cell=3]="Cell",$[$.CellOutput=4]="CellOutput",$[$.CellReplace=5]="CellReplace",$[$.CellOutputItem=6]="CellOutputItem"})(U=e.FileEditType||(e.FileEditType={}));let L=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(x,se,ke,Ge){this._edits.push({_type:1,from:x,to:se,options:ke,metadata:Ge})}createFile(x,se,ke){this._edits.push({_type:1,from:void 0,to:x,options:se,metadata:ke})}deleteFile(x,se,ke){this._edits.push({_type:1,from:x,to:void 0,options:se,metadata:ke})}replaceNotebookMetadata(x,se,ke){this._edits.push({_type:3,metadata:ke,uri:x,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(x,se,ke,Ge,et){let st,ut,St=[],Dt;if(Bt.isNotebookRange(se)&&Lt.isNotebookCellDataArray(ke)&&!Lt.isNotebookCellDataArray(Ge)?(st=se.start,ut=se.end,St=ke,Dt=Ge):typeof se=="number"&&typeof ke=="number"&&Lt.isNotebookCellDataArray(Ge)&&(st=se,ut=ke,St=Ge,Dt=et),st===void 0||ut===void 0)throw new Error("Invalid arguments");(st!==ut||St.length>0)&&this._edits.push({_type:5,uri:x,index:st,count:ut-st,cells:St,metadata:Dt})}replaceNotebookCellMetadata(x,se,ke,Ge){this._edits.push({_type:3,metadata:Ge,uri:x,edit:{editType:11,index:se,metadata:ke}})}replace(x,se,ke,Ge){this._edits.push({_type:2,uri:x,edit:new H(se,ke),metadata:Ge})}insert(x,se,ke,Ge){this.replace(x,new R(se,se),ke,Ge)}delete(x,se,ke){this.replace(x,se,"",ke)}has(x){return this._edits.some(se=>se._type===2&&se.uri.toString()===x.toString())}set(x,se){if(se)for(const ke of se)ke&&this._edits.push({_type:2,uri:x,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Ge=this._edits[ke];Ge._type===2&&Ge.uri.toString()===x.toString()&&(this._edits[ke]=void 0)}(0,_.coalesceInPlace)(this._edits)}}get(x){const se=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===x.toString()&&se.push(ke.edit);return se}entries(){const x=new A.ResourceMap;for(let se of this._edits)if(se._type===2){let ke=x.get(se.uri);ke||(ke=[se.uri,[]],x.set(se.uri,ke)),ke[1].push(se.edit)}return[...x.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};L=Ve([p],L),e.WorkspaceEdit=L;let F=l=class{constructor(x){this._tabstop=1,this.value=x||""}static isSnippetString(x){return x instanceof l?!0:x?typeof x.value=="string":!1}static _escape(x){return x.replace(/\$|}|\\/g,"\\$&")}appendText(x){return this.value+=l._escape(x),this}appendTabstop(x=this._tabstop++){return this.value+="$",this.value+=x,this}appendPlaceholder(x,se=this._tabstop++){if(typeof x=="function"){const ke=new l;ke._tabstop=this._tabstop,x(ke),this._tabstop=ke._tabstop,x=ke.value}else x=l._escape(x);return this.value+="${",this.value+=se,this.value+=":",this.value+=x,this.value+="}",this}appendChoice(x,se=this._tabstop++){const ke=x.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(x,se){if(typeof se=="function"){const ke=new l;ke._tabstop=this._tabstop,se(ke),this._tabstop=ke._tabstop,se=ke.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=x,se&&(this.value+=":",this.value+=se),this.value+="}",this}};F=l=Ve([p],F),e.SnippetString=F;var O;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(O=e.DiagnosticTag||(e.DiagnosticTag={}));var M;(function($){$[$.Hint=3]="Hint",$[$.Information=2]="Information",$[$.Warning=1]="Warning",$[$.Error=0]="Error"})(M=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let B=f=class{constructor(x,se){if(this.uri=x,se)if(se instanceof R)this.range=se;else if(se instanceof b)this.range=new R(se,se);else throw new Error("Illegal argument")}static isLocation(x){return x instanceof f?!0:x?R.isRange(x.range)&&D.URI.isUri(x.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};B=f=Ve([p],B),e.Location=B;let V=class{constructor(x,se){this.location=x,this.message=se}static is(x){return x?typeof x.message=="string"&&x.location&&R.isRange(x.location.range)&&D.URI.isUri(x.location.uri):!1}static isEqual(x,se){return x===se?!0:!x||!se?!1:x.message===se.message&&x.location.range.isEqual(se.location.range)&&x.location.uri.toString()===se.location.uri.toString()}};V=Ve([p],V),e.DiagnosticRelatedInformation=V;let Q=class{constructor(x,se,ke=M.Error){if(!R.isRange(x))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=x,this.message=se,this.severity=ke}toJSON(){return{severity:M[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(x,se){return x===se?!0:!x||!se?!1:x.message===se.message&&x.severity===se.severity&&x.code===se.code&&x.severity===se.severity&&x.source===se.source&&x.range.isEqual(se.range)&&(0,_.equals)(x.tags,se.tags)&&(0,_.equals)(x.relatedInformation,se.relatedInformation,V.isEqual)}};Q=Ve([p],Q),e.Diagnostic=Q;let de=class{constructor(x,se){if(!x)throw new Error("Illegal argument, contents must be defined");Array.isArray(x)?this.contents=x:(0,T.isMarkdownString)(x)?this.contents=[x]:this.contents=[x],this.range=se}};de=Ve([p],de),e.Hover=de;var we;(function($){$[$.Text=0]="Text",$[$.Read=1]="Read",$[$.Write=2]="Write"})(we=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ie=class{constructor(x,se=we.Text){this.range=x,this.kind=se}toJSON(){return{range:this.range,kind:we[this.kind]}}};Ie=Ve([p],Ie),e.DocumentHighlight=Ie;var Ce;(function($){$[$.File=0]="File",$[$.Module=1]="Module",$[$.Namespace=2]="Namespace",$[$.Package=3]="Package",$[$.Class=4]="Class",$[$.Method=5]="Method",$[$.Property=6]="Property",$[$.Field=7]="Field",$[$.Constructor=8]="Constructor",$[$.Enum=9]="Enum",$[$.Interface=10]="Interface",$[$.Function=11]="Function",$[$.Variable=12]="Variable",$[$.Constant=13]="Constant",$[$.String=14]="String",$[$.Number=15]="Number",$[$.Boolean=16]="Boolean",$[$.Array=17]="Array",$[$.Object=18]="Object",$[$.Key=19]="Key",$[$.Null=20]="Null",$[$.EnumMember=21]="EnumMember",$[$.Struct=22]="Struct",$[$.Event=23]="Event",$[$.Operator=24]="Operator",$[$.TypeParameter=25]="TypeParameter"})(Ce=e.SymbolKind||(e.SymbolKind={}));var Le;(function($){$[$.Deprecated=1]="Deprecated"})(Le=e.SymbolTag||(e.SymbolTag={}));let z=t=class{constructor(x,se,ke,Ge,et){this.name=x,this.kind=se,this.containerName=et,typeof ke=="string"&&(this.containerName=ke),Ge instanceof B?this.location=Ge:ke instanceof R&&(this.location=new B(Ge,ke)),t.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ce[this.kind],location:this.location,containerName:this.containerName}}};z=t=Ve([p],z),e.SymbolInformation=z;let Y=n=class{constructor(x,se,ke,Ge,et){this.name=x,this.detail=se,this.kind=ke,this.range=Ge,this.selectionRange=et,this.children=[],n.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy");if(!x.range.contains(x.selectionRange))throw new Error("selectionRange must be contained in fullRange");x.children&&x.children.forEach(n.validate)}};Y=n=Ve([p],Y),e.DocumentSymbol=Y;var ee;(function($){$[$.Invoke=1]="Invoke",$[$.Automatic=2]="Automatic"})(ee=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor(x,se){this.title=x,this.kind=se}};le=Ve([p],le),e.CodeAction=le;let me=r=class{constructor(x){this.value=x}append(x){return new r(this.value?this.value+r.sep+x:x)}intersects(x){return this.contains(x)||x.contains(this)}contains(x){return this.value===x.value||x.value.startsWith(this.value+r.sep)}};me.sep=".",me=r=Ve([p],me),e.CodeActionKind=me,me.Empty=new me(""),me.QuickFix=me.Empty.append("quickfix"),me.Refactor=me.Empty.append("refactor"),me.RefactorExtract=me.Refactor.append("extract"),me.RefactorInline=me.Refactor.append("inline"),me.RefactorRewrite=me.Refactor.append("rewrite"),me.Source=me.Empty.append("source"),me.SourceOrganizeImports=me.Source.append("organizeImports"),me.SourceFixAll=me.Source.append("fixAll");let De=class{constructor(x,se){if(this.range=x,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};De=Ve([p],De),e.SelectionRange=De;class Oe{constructor(x,se,ke,Ge,et,st){this.kind=x,this.name=se,this.detail=ke,this.uri=Ge,this.range=et,this.selectionRange=st}}e.CallHierarchyItem=Oe;class be{constructor(x,se){this.fromRanges=se,this.from=x}}e.CallHierarchyIncomingCall=be;class Pe{constructor(x,se){this.fromRanges=se,this.to=x}}e.CallHierarchyOutgoingCall=Pe;let Re=class{constructor(x,se){this.range=x,this.command=se}get isResolved(){return!!this.command}};Re=Ve([p],Re),e.CodeLens=Re;let Be=i=class{constructor(x,se=!1){a.set(this,void 0),tt(this,a,new T.MarkdownString(x,{supportThemeIcons:se}),"f")}static isMarkdownString(x){return x instanceof i?!0:x&&x.appendCodeblock&&x.appendMarkdown&&x.appendText&&x.value!==void 0}get value(){return Ue(this,a,"f").value}set value(x){Ue(this,a,"f").value=x}get isTrusted(){return Ue(this,a,"f").isTrusted}set isTrusted(x){Ue(this,a,"f").isTrusted=x}get supportThemeIcons(){return Ue(this,a,"f").supportThemeIcons}appendText(x){return Ue(this,a,"f").appendText(x),this}appendMarkdown(x){return Ue(this,a,"f").appendMarkdown(x),this}appendCodeblock(x,se){return Ue(this,a,"f").appendCodeblock(se!=null?se:"",x),this}};a=new WeakMap,Be=i=Ve([p],Be),e.MarkdownString=Be;let Se=class{constructor(x,se){this.label=x,this.documentation=se}};Se=Ve([p],Se),e.ParameterInformation=Se;let qe=class{constructor(x,se){this.label=x,this.documentation=se,this.parameters=[]}};qe=Ve([p],qe),e.SignatureInformation=qe;let X=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};X=Ve([p],X),e.SignatureHelp=X;var ie;(function($){$[$.Invoke=1]="Invoke",$[$.TriggerCharacter=2]="TriggerCharacter",$[$.ContentChange=3]="ContentChange"})(ie=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var _e;(function($){$[$.Other=0]="Other",$[$.Type=1]="Type",$[$.Parameter=2]="Parameter"})(_e=e.InlineHintKind||(e.InlineHintKind={}));let Ne=class{constructor(x,se,ke){this.text=x,this.range=se,this.kind=ke}};Ne=Ve([p],Ne),e.InlineHint=Ne;var ze;(function($){$[$.Invoke=0]="Invoke",$[$.TriggerCharacter=1]="TriggerCharacter",$[$.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $e;(function($){$[$.Text=0]="Text",$[$.Method=1]="Method",$[$.Function=2]="Function",$[$.Constructor=3]="Constructor",$[$.Field=4]="Field",$[$.Variable=5]="Variable",$[$.Class=6]="Class",$[$.Interface=7]="Interface",$[$.Module=8]="Module",$[$.Property=9]="Property",$[$.Unit=10]="Unit",$[$.Value=11]="Value",$[$.Enum=12]="Enum",$[$.Keyword=13]="Keyword",$[$.Snippet=14]="Snippet",$[$.Color=15]="Color",$[$.File=16]="File",$[$.Reference=17]="Reference",$[$.Folder=18]="Folder",$[$.EnumMember=19]="EnumMember",$[$.Constant=20]="Constant",$[$.Struct=21]="Struct",$[$.Event=22]="Event",$[$.Operator=23]="Operator",$[$.TypeParameter=24]="TypeParameter",$[$.User=25]="User",$[$.Issue=26]="Issue"})($e=e.CompletionItemKind||(e.CompletionItemKind={}));var Je;(function($){$[$.Deprecated=1]="Deprecated"})(Je=e.CompletionItemTag||(e.CompletionItemTag={}));let G=class{constructor(x,se){this.label=x,this.kind=se}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&$e[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};G=Ve([p],G),e.CompletionItem=G;let re=class{constructor(x=[],se=!1){this.items=x,this.isIncomplete=se}};re=Ve([p],re),e.CompletionList=re;var he;(function($){$[$.Active=-1]="Active",$[$.Beside=-2]="Beside",$[$.One=1]="One",$[$.Two=2]="Two",$[$.Three=3]="Three",$[$.Four=4]="Four",$[$.Five=5]="Five",$[$.Six=6]="Six",$[$.Seven=7]="Seven",$[$.Eight=8]="Eight",$[$.Nine=9]="Nine"})(he=e.ViewColumn||(e.ViewColumn={}));var J;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(J=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ne;(function($){$[$.Off=0]="Off",$[$.On=1]="On",$[$.Relative=2]="Relative"})(ne=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ce;(function($){$[$.Manual=1]="Manual",$[$.AfterDelay=2]="AfterDelay",$[$.FocusOut=3]="FocusOut"})(ce=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ve;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(ve=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ye;(function($){$[$.Keyboard=1]="Keyboard",$[$.Mouse=2]="Mouse",$[$.Command=3]="Command"})(ye=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var je;(function($){$[$.OpenOpen=0]="OpenOpen",$[$.ClosedClosed=1]="ClosedClosed",$[$.OpenClosed=2]="OpenClosed",$[$.ClosedOpen=3]="ClosedOpen"})(je=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function($){function x(se){switch(se){case"keyboard":return $.Keyboard;case"mouse":return $.Mouse;case"api":return $.Command}}$.fromValue=x}(ye=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let He=class{constructor(x,se){if(se&&!D.URI.isUri(se))throw(0,I.illegalArgument)("target");if(!R.isRange(x)||x.isEmpty)throw(0,I.illegalArgument)("range");this.range=x,this.target=se}};He=Ve([p],He),e.DocumentLink=He;let We=class{constructor(x,se,ke,Ge){this.red=x,this.green=se,this.blue=ke,this.alpha=Ge}};We=Ve([p],We),e.Color=We;let Ke=class{constructor(x,se){if(se&&!(se instanceof We))throw(0,I.illegalArgument)("color");if(!R.isRange(x)||x.isEmpty)throw(0,I.illegalArgument)("range");this.range=x,this.color=se}};Ke=Ve([p],Ke),e.ColorInformation=Ke;let nt=class{constructor(x){if(!x||typeof x!="string")throw(0,I.illegalArgument)("label");this.label=x}};nt=Ve([p],nt),e.ColorPresentation=nt;var dt;(function($){$[$.RGB=0]="RGB",$[$.HEX=1]="HEX",$[$.HSL=2]="HSL"})(dt=e.ColorFormat||(e.ColorFormat={}));var it;(function($){$[$.Error=0]="Error",$[$.Warning=1]="Warning",$[$.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Ye;(function($){$[$.Always=1]="Always",$[$.Silent=2]="Silent",$[$.Never=3]="Never"})(Ye=e.TaskRevealKind||(e.TaskRevealKind={}));var mt;(function($){$[$.Shared=1]="Shared",$[$.Dedicated=2]="Dedicated",$[$.New=3]="New"})(mt=e.TaskPanelKind||(e.TaskPanelKind={}));let wt=o=class{constructor(x,se){if(typeof x!="string"||typeof se!="string")throw(0,I.illegalArgument)("name");this._id=x}static from(x){switch(x){case"clean":return o.Clean;case"build":return o.Build;case"rebuild":return o.Rebuild;case"test":return o.Test;default:return}}get id(){return this._id}};wt.Clean=new o("clean","Clean"),wt.Build=new o("build","Build"),wt.Rebuild=new o("rebuild","Rebuild"),wt.Test=new o("test","Test"),wt=o=Ve([p],wt),e.TaskGroup=wt;function Ee($){let x="";for(let se=0;se<$.length;se++)x+=$[se].replace(/,/g,",,")+",";return x}let fe=class{constructor(x,se,ke){if(typeof x!="string")throw(0,I.illegalArgument)("process");this._args=[],this._process=x,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=ke):this._options=se)}get process(){return this._process}set process(x){if(typeof x!="string")throw(0,I.illegalArgument)("process");this._process=x}get args(){return this._args}set args(x){Array.isArray(x)||(x=[]),this._args=x}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("process"),this._process!==void 0&&x.push(this._process),this._args&&this._args.length>0)for(let se of this._args)x.push(se);return Ee(x)}};fe=Ve([p],fe),e.ProcessExecution=fe;let ae=class{constructor(x,se,ke){if(this._args=[],Array.isArray(se)){if(!x)throw(0,I.illegalArgument)("command can't be undefined or null");if(typeof x!="string"&&typeof x.value!="string")throw(0,I.illegalArgument)("command");this._command=x,this._args=se,this._options=ke}else{if(typeof x!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=x,this._options=se}}get commandLine(){return this._commandLine}set commandLine(x){if(typeof x!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=x}get command(){return this._command?this._command:""}set command(x){if(typeof x!="string"&&typeof x.value!="string")throw(0,I.illegalArgument)("command");this._command=x}get args(){return this._args}set args(x){this._args=x||[]}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("shell"),this._commandLine!==void 0&&x.push(this._commandLine),this._command!==void 0&&x.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)x.push(typeof se=="string"?se:se.value);return Ee(x)}};ae=Ve([p],ae),e.ShellExecution=ae;var Z;(function($){$[$.Escape=1]="Escape",$[$.Strong=2]="Strong",$[$.Weak=3]="Weak"})(Z=e.ShellQuoting||(e.ShellQuoting={}));var Fe;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace"})(Fe=e.TaskScope||(e.TaskScope={}));class Te{constructor(x){this._callback=x}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(x){this._callback=x}get callback(){return this._callback}}e.CustomExecution=Te;let Qe=c=class{constructor(x,se,ke,Ge,et,st){this.__deprecated=!1,this._definition=this.definition=x;let ut;typeof se=="string"?(this._name=this.name=se,this._source=this.source=ke,this.execution=Ge,ut=et,this.__deprecated=!0):se===Fe.Global||se===Fe.Workspace?(this.target=se,this._name=this.name=ke,this._source=this.source=Ge,this.execution=et,ut=st):(this.target=se,this._name=this.name=ke,this._source=this.source=Ge,this.execution=et,ut=st),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(x){this.__id=x}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof fe?this._definition={type:c.ProcessType,id:this._execution.computeId()}:this._execution instanceof ae?this._definition={type:c.ShellType,id:this._execution.computeId()}:this._execution instanceof Te?this._definition={type:c.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:c.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(x){if(x==null)throw(0,I.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=x}get scope(){return this._scope}set target(x){this.clear(),this._scope=x}get name(){return this._name}set name(x){if(typeof x!="string")throw(0,I.illegalArgument)("name");this.clear(),this._name=x}get execution(){return this._execution}set execution(x){x===null&&(x=void 0),this.clear(),this._execution=x;const se=this._definition.type;(c.EmptyType===se||c.ProcessType===se||c.ShellType===se||c.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(x){if(Array.isArray(x))this.clear(),this._problemMatchers=x,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(x){x!==!0&&x!==!1&&(x=!1),this.clear(),this._isBackground=x}get source(){return this._source}set source(x){if(typeof x!="string"||x.length===0)throw(0,I.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=x}get group(){return this._group}set group(x){x===null&&(x=void 0),this.clear(),this._group=x}get detail(){return this._detail}set detail(x){x===null&&(x=void 0),this._detail=x}get presentationOptions(){return this._presentationOptions}set presentationOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._presentationOptions=x}get runOptions(){return this._runOptions}set runOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._runOptions=x}};Qe.ExtensionCallbackType="customExecution",Qe.ProcessType="process",Qe.ShellType="shell",Qe.EmptyType="$empty",Qe=c=Ve([p],Qe),e.Task=Qe;var Ze;(function($){$[$.SourceControl=1]="SourceControl",$[$.Window=10]="Window",$[$.Notification=15]="Notification"})(Ze=e.ProgressLocation||(e.ProgressLocation={}));let ct=class{constructor(x,se=ht.None){this.collapsibleState=se,D.URI.isUri(x)?this.resourceUri=x:this.label=x}};ct=Ve([p],ct),e.TreeItem=ct;var ht;(function($){$[$.None=0]="None",$[$.Collapsed=1]="Collapsed",$[$.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Xe=class{constructor(x,se){this.id=x,this.color=se}};Xe=Ve([p],Xe),e.ThemeIcon=Xe,Xe.File=new Xe("file"),Xe.Folder=new Xe("folder");let ot=class{constructor(x){this.id=x}};ot=Ve([p],ot),e.ThemeColor=ot;var ft;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace",$[$.WorkspaceFolder=3]="WorkspaceFolder"})(ft=e.ConfigurationTarget||(e.ConfigurationTarget={}));let at=class{constructor(x,se){if(typeof x!="string"&&(!x||!D.URI.isUri(x)&&!D.URI.isUri(x.uri)))throw(0,I.illegalArgument)("base");if(typeof se!="string")throw(0,I.illegalArgument)("pattern");typeof x=="string"?(this.baseFolder=D.URI.file(x),this.base=x):D.URI.isUri(x)?(this.baseFolder=x,this.base=x.fsPath):(this.baseFolder=x.uri,this.base=x.uri.fsPath),this.pattern=se}};at=Ve([p],at),e.RelativePattern=at;let Et=class{constructor(x,se,ke,Ge){this.enabled=typeof x=="boolean"?x:!0,typeof se=="string"&&(this.condition=se),typeof ke=="string"&&(this.hitCondition=ke),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,P.generateUuid)()),this._id}};Et=Ve([p],Et),e.Breakpoint=Et;let vt=class extends Et{constructor(x,se,ke,Ge,et){super(se,ke,Ge,et);if(x===null)throw(0,I.illegalArgument)("location");this.location=x}};vt=Ve([p],vt),e.SourceBreakpoint=vt;let Ct=class extends Et{constructor(x,se,ke,Ge,et){super(se,ke,Ge,et);this.functionName=x}};Ct=Ve([p],Ct),e.FunctionBreakpoint=Ct;let It=class extends Et{constructor(x,se,ke,Ge,et,st,ut){super(Ge,et,st,ut);if(!se)throw(0,I.illegalArgument)("dataId");this.label=x,this.dataId=se,this.canPersist=ke}};It=Ve([p],It),e.DataBreakpoint=It;let At=class{constructor(x,se,ke){this.command=x,this.args=se||[],this.options=ke}};At=Ve([p],At),e.DebugAdapterExecutable=At;let bt=class{constructor(x,se){this.port=x,this.host=se}};bt=Ve([p],bt),e.DebugAdapterServer=bt;let Yt=class{constructor(x){this.path=x}};Yt=Ve([p],Yt),e.DebugAdapterNamedPipeServer=Yt;let Jt=class{constructor(x){this.implementation=x}};Jt=Ve([p],Jt),e.DebugAdapterInlineImplementation=Jt;let gt=class{constructor(x,se){this.range=x,this.expression=se}};gt=Ve([p],gt),e.EvaluatableExpression=gt;let Zt=class{constructor(x,se){this.range=x,this.text=se}};Zt=Ve([p],Zt),e.InlineValueText=Zt;let yt=class{constructor(x,se,ke=!0){this.range=x,this.variableName=se,this.caseSensitiveLookup=ke}};yt=Ve([p],yt),e.InlineValueVariableLookup=yt;let qt=class{constructor(x,se){this.range=x,this.expression=se}};qt=Ve([p],qt),e.InlineValueEvaluatableExpression=qt;let en=class{constructor(x,se){this.frameId=x,this.stoppedLocation=se}};en=Ve([p],en),e.InlineValueContext=en;var Gt;(function($){$[$.Changed=1]="Changed",$[$.Created=2]="Created",$[$.Deleted=3]="Deleted"})(Gt=e.FileChangeType||(e.FileChangeType={}));let lt=v=class extends Error{constructor(x,se=s.FileSystemProviderErrorCode.Unknown,ke){var Ge;super(D.URI.isUri(x)?x.toString(!0):x);this.code=(Ge=ke==null?void 0:ke.name)!==null&&Ge!==void 0?Ge:"Unknown",(0,s.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists(x){return new v(x,s.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(x){return new v(x,s.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(x){return new v(x,s.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(x){return new v(x,s.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(x){return new v(x,s.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(x){return new v(x,s.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}};lt=v=Ve([p],lt),e.FileSystemError=lt;let tn=class{constructor(x,se,ke){this.start=x,this.end=se,this.kind=ke}};tn=Ve([p],tn),e.FoldingRange=tn;var Tt;(function($){$[$.Comment=1]="Comment",$[$.Imports=2]="Imports",$[$.Region=3]="Region"})(Tt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var xt;(function($){$[$.Collapsed=0]="Collapsed",$[$.Expanded=1]="Expanded"})(xt=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var gn;(function($){$[$.Editing=0]="Editing",$[$.Preview=1]="Preview"})(gn=e.CommentMode||(e.CommentMode={}));class En{constructor(x,se=[]){this.tokenTypes=x,this.tokenModifiers=se}}e.SemanticTokensLegend=En;function pn($){return typeof $=="undefined"||(0,k.isStringArray)($)}class nn{constructor(x){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,x){this._hasLegend=!0;for(let se=0,ke=x.tokenTypes.length;se<ke;se++)this._tokenTypeStrToInt.set(x.tokenTypes[se],se);for(let se=0,ke=x.tokenModifiers.length;se<ke;se++)this._tokenModifierStrToInt.set(x.tokenModifiers[se],se)}}push(x,se,ke,Ge,et){if(typeof x=="number"&&typeof se=="number"&&typeof ke=="number"&&typeof Ge=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(x,se,ke,Ge,et);if(R.isRange(x)&&typeof se=="string"&&pn(ke))return this._push(x,se,ke);throw(0,I.illegalArgument)()}_push(x,se,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(x.start.line!==x.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const Ge=x.start.line,et=x.start.character,st=x.end.character-x.start.character,ut=this._tokenTypeStrToInt.get(se);let St=0;if(ke)for(const Dt of ke){if(!this._tokenModifierStrToInt.has(Dt))throw new Error("`tokenModifier` is not in the provided legend");const kt=this._tokenModifierStrToInt.get(Dt);St|=1<<kt>>>0}this._pushEncoded(Ge,et,st,ut,St)}_pushEncoded(x,se,ke,Ge,et){if(this._dataIsSortedAndDeltaEncoded&&(x<this._prevLine||x===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let Dt=0,kt=0;for(let Pt=0;Pt<St;Pt++){let Ft=this._data[5*Pt],hn=this._data[5*Pt+1];Ft===0?(Ft=Dt,hn+=kt):Ft+=Dt,this._data[5*Pt]=Ft,this._data[5*Pt+1]=hn,Dt=Ft,kt=hn}}let st=x,ut=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=et,this._prevLine=x,this._prevChar=se}static _sortAndDeltaEncode(x){let se=[];const ke=x.length/5|0;for(let ut=0;ut<ke;ut++)se[ut]=ut;se.sort((ut,St)=>{const Dt=x[5*ut],kt=x[5*St];if(Dt===kt){const Pt=x[5*ut+1],Ft=x[5*St+1];return Pt-Ft}return Dt-kt});const Ge=new Uint32Array(x.length);let et=0,st=0;for(let ut=0;ut<ke;ut++){const St=5*se[ut],Dt=x[St+0],kt=x[St+1],Pt=x[St+2],Ft=x[St+3],hn=x[St+4],Fn=Dt-et,xn=Fn===0?kt-st:kt,fn=5*ut;Ge[fn+0]=Fn,Ge[fn+1]=xn,Ge[fn+2]=Pt,Ge[fn+3]=Ft,Ge[fn+4]=hn,et=Dt,st=kt}return Ge}build(x){return this._dataIsSortedAndDeltaEncoded?new Kt(new Uint32Array(this._data),x):new Kt(nn._sortAndDeltaEncode(this._data),x)}}e.SemanticTokensBuilder=nn;class Kt{constructor(x,se){this.resultId=se,this.data=x}}e.SemanticTokens=Kt;class Ot{constructor(x,se,ke){this.start=x,this.deleteCount=se,this.data=ke}}e.SemanticTokensEdit=Ot;class Sn{constructor(x,se){this.resultId=se,this.edits=x}}e.SemanticTokensEdits=Sn;var rn;(function($){$[$.Separate=0]="Separate",$[$.MergeWithParent=1]="MergeWithParent"})(rn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var sn;(function($){$[$.Initial=1]="Initial",$[$.Dynamic=2]="Dynamic"})(sn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Qt=class{constructor(){}};Qt.Back={iconPath:new Xe("arrow-left")},Qt=Ve([p],Qt),e.QuickInputButtons=Qt;var yn;(function($){$[$.UI=1]="UI",$[$.Workspace=2]="Workspace"})(yn=e.ExtensionKind||(e.ExtensionKind={}));class Rt{constructor(x,se,ke){this.badge=x,this.tooltip=se,this.color=ke}static validate(x){if(x.badge&&x.badge.length!==1&&x.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!x.color&&!x.badge&&!x.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Rt;let on=class{constructor(x){this.kind=x}};on=Ve([p],on),e.ColorTheme=on;var Dn;(function($){$[$.Light=1]="Light",$[$.Dark=2]="Dark",$[$.HighContrast=3]="HighContrast"})(Dn=e.ColorThemeKind||(e.ColorThemeKind={}));class Bt{constructor(x,se){if(x<0)throw(0,I.illegalArgument)("start must be positive");if(se<0)throw(0,I.illegalArgument)("end must be positive");x<=se?(this._start=x,this._end=se):(this._start=se,this._end=x)}static isNotebookRange(x){return x instanceof Bt?!0:x?typeof x.start=="number"&&typeof x.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(x){let se=this._start,ke=this._end;return x.start!==void 0&&(se=x.start),x.end!==void 0&&(ke=x.end),se===this._start&&ke===this._end?this:new Bt(se,ke)}}e.NotebookRange=Bt;class an{constructor(x,se){typeof x=="object"?Object.assign(this,x):(this.inputCollapsed=x,this.outputCollapsed=se)}with(x){let{inputCollapsed:se,outputCollapsed:ke}=x,Ge=jt(x,["inputCollapsed","outputCollapsed"]);return se===void 0?se=this.inputCollapsed:se===null&&(se=void 0),ke===void 0?ke=this.outputCollapsed:ke===null&&(ke=void 0),se===this.inputCollapsed&&ke===this.outputCollapsed&&Object.keys(Ge).length===0?this:new an(Object.assign({inputCollapsed:se,outputCollapsed:ke},Ge))}}e.NotebookCellMetadata=an;class Nt{constructor(x=!0){var se;typeof x=="object"?(Object.assign(this,x),this.trusted=(se=x.trusted)!==null&&se!==void 0?se:!0):this.trusted=x}with(x){let{trusted:se}=x,ke=jt(x,["trusted"]);return se===void 0?se=this.trusted:se===null&&(se=void 0),se===this.trusted&&Object.keys(ke).length===0?this:new Nt(Object.assign({trusted:se},ke))}}e.NotebookDocumentMetadata=Nt;class Lt{constructor(x,se,ke,Ge,et,st){this.kind=x,this.source=se,this.language=ke,this.outputs=Ge!=null?Ge:[],this.metadata=et,this.latestExecutionSummary=st}static isNotebookCellDataArray(x){return Array.isArray(x)&&x.every(se=>Lt.isNotebookCellData(se))}static isNotebookCellData(x){return!0}}e.NotebookCellData=Lt;class vn{constructor(x,se){this.cells=x,this.metadata=se!=null?se:new Nt}}e.NotebookData=vn;class Wt{constructor(x,se,ke){if(this.mime=x,this.value=se,this.metadata=ke,(0,y.isFalsyOrWhitespace)(this.mime))throw new Error("INVALID mime type, must not be empty or falsy")}static isNotebookCellOutputItem(x){return x instanceof Wt}}e.NotebookCellOutputItem=Wt;class Me{constructor(x,se,ke){this.outputs=x,typeof se=="string"?(this.id=se,this.metadata=ke):(this.id=(0,P.generateUuid)(),this.metadata=se!=null?se:ke)}}e.NotebookCellOutput=Me;var ln;(function($){$[$.Markdown=1]="Markdown",$[$.Code=2]="Code"})(ln=e.NotebookCellKind||(e.NotebookCellKind={}));var cn;(function($){$[$.Idle=1]="Idle",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(cn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pt;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(pt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Cn;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(Cn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class kn{constructor(x,se,ke,Ge,et,st){this.text=x,this.alignment=se,this.command=ke,this.tooltip=Ge,this.priority=et,this.accessibilityInformation=st}}e.NotebookCellStatusBarItem=kn;let Xt=class{constructor(x,se){this.label=x,this.timestamp=se}};Xt=Ve([p],Xt),e.TimelineItem=Xt;var wn;(function($){$[$.Production=1]="Production",$[$.Development=2]="Development",$[$.Test=3]="Test"})(wn=e.ExtensionMode||(e.ExtensionMode={}));var Pn;(function($){$[$.Node=1]="Node",$[$.Webworker=2]="Webworker"})(Pn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var In;(function($){$[$.Other=0]="Other",$[$.Comment=1]="Comment",$[$.String=2]="String",$[$.RegEx=4]="RegEx"})(In=e.StandardTokenType||(e.StandardTokenType={}));class An{constructor(x,se){this.ranges=x,this.wordPattern=se}}e.LinkedEditingRanges=An;var Tn;(function($){$[$.Unset=0]="Unset",$[$.Queued=1]="Queued",$[$.Running=2]="Running",$[$.Passed=3]="Passed",$[$.Failed=4]="Failed",$[$.Skipped=5]="Skipped",$[$.Errored=6]="Errored"})(Tn=e.TestResultState||(e.TestResultState={}));var un;(function($){$[$.Error=0]="Error",$[$.Warning=1]="Warning",$[$.Information=2]="Information",$[$.Hint=3]="Hint"})(un=e.TestMessageSeverity||(e.TestMessageSeverity={}));var bn;(function($){$[$.Pending=0]="Pending",$[$.Resolved=1]="Resolved"})(bn=e.TestItemStatus||(e.TestItemStatus={}));const Ut=($,x,se,ke)=>{let Ge=se;return{enumerable:!0,configurable:!1,get(){return Ge},set(et){ke(Ge,et)||(Ge=et,$.bus.fire([3,x,et]))}}},$t=($,x)=>$===x,Rn=($,x)=>$===x?!0:!$||!x?!1:$.isEqual(x);class dn{constructor(x,se,ke,Ge){this.label=se,this.data=Ge;const et=(0,g.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:x,enumerable:!0,writable:!1},uri:{value:ke,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>et.parent},children:{value:new A.ReadonlyMapView(et.children),enumerable:!0,writable:!1},range:Ut(et,"range",void 0,Rn),description:Ut(et,"description",void 0,$t),runnable:Ut(et,"runnable",!0,$t),debuggable:Ut(et,"debuggable",!0,$t),status:Ut(et,"status",bn.Resolved,$t),error:Ut(et,"error",void 0,$t)})}invalidate(){(0,g.getPrivateApiFor)(this).bus.fire([2])}dispose(){const x=(0,g.getPrivateApiFor)(this);x.parent&&(0,g.getPrivateApiFor)(x.parent).children.delete(this.id),x.bus.fire([1])}addChild(x){if(!(x instanceof dn))throw new Error("Test child must be created through vscode.test.createTestItem()");const se=(0,g.getPrivateApiFor)(this);if(se.children.has(x.id))throw new Error(`Attempted to insert a duplicate test item ID ${x.id}`);se.children.set(x.id,x),se.bus.fire([0,x])}}e.TestItemImpl=dn;class te{constructor(x){this.message=x,this.severity=un.Error}static diff(x,se,ke){const Ge=new te(x);return Ge.expectedOutput=se,Ge.actualOutput=ke,Ge}}e.TestMessage=te;var ue;(function($){$[$.None=0]="None",$[$.Option=1]="Option",$[$.Default=2]="Default",$[$.Preferred=3]="Preferred"})(ue=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Ae;(function($){$[$.Untrusted=0]="Untrusted",$[$.Trusted=1]="Trusted",$[$.Unspecified=2]="Unspecified"})(Ae=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var rt;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore"})(rt=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ge[120],pe([0,1,52,12,9,144,109,7,19]),function(K,e,_,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function s(a,u){u?P.set(a,u):P.delete(a)}e.setWordDefinitionFor=s;function C(a){return P.get(a)}e.getWordDefinitionFor=C;class g extends A.MirrorTextModel{constructor(u,E,w,S,d,l,f,t){super(E,w,S,d);this._proxy=u,this._languageId=l,this._isDirty=f,this._notebook=t,this._isDisposed=!1}dispose(){(0,_.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return(0,D.equals)(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===I.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},get notebook(){return u._notebook},save(){return u._save()},getText(E){return E?u._getTextInRange(E):u.getText()},get eol(){return u._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(E){return u._lineAt(E)},offsetAt(E){return u._offsetAt(E)},positionAt(E){return u._positionAt(E)},validateRange(E){return u._validateRange(E)},validatePosition(E){return u._validatePosition(E)},getWordRangeAtPosition(E,w){return u._getWordRangeAtPosition(E,w)}}}return Object.freeze(this._document)}_acceptLanguageId(u){(0,_.ok)(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){(0,_.ok)(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const E=this._validateRange(u);if(E.isEmpty)return"";if(E.isSingleLine)return this._lines[E.start.line].substring(E.start.character,E.end.character);const w=this._eol,S=E.start.line,d=E.end.line,l=[];l.push(this._lines[S].substring(E.start.character));for(let f=S+1;f<d;f++)l.push(this._lines[f]);return l.push(this._lines[d].substring(0,E.end.character)),l.join(w)}_lineAt(u){let E;if(u instanceof k.Position?E=u.line:typeof u=="number"&&(E=u),typeof E!="number"||E<0||E>=this._lines.length||Math.floor(E)!==E)throw new Error("Illegal value for `line`");return new m(E,this._lines[E],E===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const E=this._lineStarts.getIndexOf(u),w=this._lines[E.index].length;return new k.Position(E.index,Math.min(E.remainder,w))}_validateRange(u){if(!(u instanceof k.Range))throw new Error("Invalid argument");const E=this._validatePosition(u.start),w=this._validatePosition(u.end);return E===u.start&&w===u.end?u:new k.Range(E.line,E.character,w.line,w.character)}_validatePosition(u){if(!(u instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:E,character:w}=u,S=!1;if(E<0)E=0,w=0,S=!0;else if(E>=this._lines.length)E=this._lines.length-1,w=this._lines[E].length,S=!0;else{const d=this._lines[E].length;w<0?(w=0,S=!0):w>d&&(w=d,S=!0)}return S?new k.Position(E,w):u}_getWordRangeAtPosition(u,E){const w=this._validatePosition(u);if(!E)E=C(this._languageId);else if((0,T.regExpLeadsToEndlessLoop)(E))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${E.source}' because it matches the empty string.`);const S=(0,y.getWordAtText)(w.character+1,(0,y.ensureValidWordDefinition)(E),this._lines[w.line],0);if(S)return new k.Range(w.line,S.startColumn-1,w.line,S.endColumn-1)}}e.ExtHostDocumentData=g;class m{constructor(u,E,w){this._line=u,this._text=E,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(ge[198],pe([0,1,7,3,111,6,77,24,2,30]),function(K,e,_,I,T,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class s{constructor(g,m,a,u){this._notebook=a,this._selector=u,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(w=>{const S=this._cellUris.get(w.document.uri);S!==void 0&&(this._cellLengths.changeValue(S,this._cells[S].document.getText().length+1),this._cellLines.changeValue(S,this._cells[S].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const E=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(g.onDidChangeNotebookCells(w=>E(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const g=[],m=[];for(const a of this._notebook.getCells())a.kind===_.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),g.push(a.document.getText().length+1),m.push(a.document.lineCount));this._cellLengths=new T.PrefixSumComputer(new Uint32Array(g)),this._cellLines=new T.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(g){var m,a;if(!g){let d="";for(const l of this._cells)d+=l.document.getText()+`
`;return d=d.slice(0,-1),d}if(g.isEmpty)return"";const u=this.locationAt(g.start),E=this.locationAt(g.end),w=this._cells[(m=this._cellUris.get(u.uri))!==null&&m!==void 0?m:-1],S=this._cells[(a=this._cellUris.get(E.uri))!==null&&a!==void 0?a:-1];if(!w||!S)return"";if(w===S)return w.document.getText(new _.Range(u.range.start,E.range.end));{const d=w.document.getText(new _.Range(u.range.start,new _.Position(w.document.lineCount,0))),l=S.document.getText(new _.Range(new _.Position(0,0),E.range.end));return d+`
`+l}}offsetAt(g){const m=this._cellLines.getIndexOf(g.line),a=this._cellLengths.getAccumulatedValue(m.index-1),u=this._cells[m.index].document.offsetAt(g.with(m.remainder));return a+u}positionAt(g){if(typeof g=="number"){const a=this._cellLengths.getIndexOf(g),u=this._cellLines.getAccumulatedValue(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(u)}const m=this._cellUris.get(g.uri);if(m!==void 0){const a=this._cellLines.getAccumulatedValue(m-1);return new _.Position(a+g.range.start.line,g.range.start.character)}return new _.Position(0,0)}locationAt(g){_.Range.isRange(g)||(g=new _.Range(g,g));const m=this._cellLines.getIndexOf(g.start.line);let a=m;g.isEmpty||(a=this._cellLines.getIndexOf(g.end.line));const u=new _.Position(m.remainder,g.start.character),E=new _.Position(a.remainder,g.end.character),w=new _.Range(u,E),S=this._cells[m.index];return new _.Location(S.document.uri,S.document.validateRange(w))}contains(g){return this._cellUris.has(g)}validateRange(g){const m=this.validatePosition(g.start),a=this.validatePosition(g.end);return g.with(m,a)}validatePosition(g){const m=this._cellLines.getIndexOf(g.line),a=new _.Position(m.remainder,g.character),u=this._cells[m.index].document.validatePosition(a),E=this._cellLines.getAccumulatedValue(m.index-1);return new _.Position(E+u.line,u.character)}}e.ExtHostNotebookConcatDocument=s}),define(ge[199],pe([0,1,7,14,3]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(k){this._actual=new _.ColorTheme(_.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new T.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let D=k==="light"?_.ColorThemeKind.Light:k==="dark"?_.ColorThemeKind.Dark:_.ColorThemeKind.HighContrast;this._actual=new _.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=Ve([xe(0,I.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(ge[62],pe([0,1,4]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,_.createDecorator)("IURITransformerService");class I{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=I}),define(ge[200],pe([0,1,22]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class I{constructor(){this.buffers=[]}add(D){let P=this.buffers.indexOf(D);return P<0&&(P=this.buffers.length,this.buffers.push(D)),P}}function T(k,D){if(D){const P=new I,s=(m,a)=>{if(a instanceof ArrayBuffer){const u=P.add(a);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(a)){const u=A(a);if(u){const E=P.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:E,view:{type:u,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},C=JSON.stringify(k,s),g=P.buffers.map(m=>{const a=new Uint8Array(m);return _.VSBuffer.wrap(a)});return{message:C,buffers:g}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=T;function A(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(k,D){const P=D.map(g=>{const m=new ArrayBuffer(g.byteLength);return new Uint8Array(m).set(g.buffer),m}),s=D.length?(g,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const a=m,{index:u}=a,E=P[u];if(a.view)switch(a.view.type){case 1:return new Int8Array(E,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(E,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(E,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(E,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(E,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(E,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(E,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(E,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(E,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(E,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(E,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return E}return m}:void 0;return{message:JSON.parse(k,s),arrayBuffers:P}}e.deserializeWebviewMessage=y}),define(ge[88],pe([0,1,2]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function I(A,y,k){const D=A.webviewResourceRoot.replace("{{resource}}",k.scheme+T(k)).replace("{{uuid}}",y);return _.URI.parse(D)}e.asWebviewUri=I;function T(A){return A.toString().replace(/^\S+?:/,"")}}),define(ge[201],pe([0,1,3,6,88,30]),function(K,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(D,P,s){this._proxy=D,this._editors=P,this._initData=s,this._handlePool=0,this._disposables=new I.DisposableStore,this._insets=new Map,this._disposables.add(P.onDidChangeVisibleTextEditors(()=>{const C=P.getVisibleTextEditors();for(const g of this._insets.values())C.indexOf(g.editor)<0&&g.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,P,s,C,g){let m;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===D){m=l;break}if(!m)throw new Error("not a visible editor");const a=this,u=this._handlePool++,E=new _.Emitter,w=new _.Emitter,S=new class{constructor(){this._uuid=(0,A.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,T.asWebviewUri)(a._initData,this._uuid,l)}get cspSource(){return a._initData.webviewCspSource}set options(l){this._options=l,a._proxy.$setOptions(u,l)}get options(){return this._options}set html(l){this._html=l,a._proxy.$setHtml(u,l)}get html(){return this._html}get onDidReceiveMessage(){return E.event}postMessage(l){return a._proxy.$postMessage(u,l)}},d=new class{constructor(){this.editor=D,this.line=P,this.height=s,this.webview=S,this.onDidDispose=w.event}dispose(){a._insets.has(u)&&(a._insets.delete(u),a._proxy.$disposeEditorInset(u),w.fire(),w.dispose(),E.dispose())}};return this._proxy.$createEditorInset(u,m.id,m.value.document.uri,P+1,s,C||{},g.identifier,g.extensionLocation),this._insets.set(u,{editor:D,inset:d,onDidReceiveMessage:E}),d}$onDidDispose(D){const P=this._insets.get(D);P&&P.inset.dispose()}$onDidReceiveMessage(D,P){const s=this._insets.get(D);s&&s.onDidReceiveMessage.fire(P)}}e.ExtHostEditorInsets=y}),define(ge[202],pe([0,1,3,81,169,4,6,24,40,19,53,23,43,194]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",g.Codicon.window,(0,T.localize)(0,null));var a;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(a=e.Extensions||(e.Extensions={}));var u;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel"})(u=e.ViewContainerLocation||(e.ViewContainerLocation={}));function E(o){switch(o){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=E;function w(o){return`viewContainer.${o}.enabled`}e.getEnabledViewContainerContextKey=w;class S extends y.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new _.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new _.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,P.flatten)([...this.viewContainers.values()])}registerViewContainer(c,v,p){var h;const b=this.get(c.id);if(b)return b;const R=c;return R.openCommandActionDescriptor=(p==null?void 0:p.donotRegisterOpenCommand)?void 0:(h=R.openCommandActionDescriptor)!==null&&h!==void 0?h:{id:R.id},(0,k.getOrSet)(this.viewContainers,v,[]).push(R),(p==null?void 0:p.isDefault)&&this.defaultViewContainers.push(R),this._onDidRegister.fire({viewContainer:R,viewContainerLocation:v}),R}deregisterViewContainer(c){for(const v of this.viewContainers.keys()){const p=this.viewContainers.get(v),h=p==null?void 0:p.indexOf(c);if(h!==-1){p==null||p.splice(h,1),p.length===0&&this.viewContainers.delete(v),this._onDidDeregister.fire({viewContainer:c,viewContainerLocation:v});return}}}get(c){return this.all.filter(v=>v.id===c)[0]}getViewContainers(c){return[...this.viewContainers.get(c)||[]]}getViewContainerLocation(c){return[...this.viewContainers.keys()].filter(v=>this.getViewContainers(v).filter(p=>(p==null?void 0:p.id)===c.id).length>0)[0]}getDefaultViewContainer(c){return this.defaultViewContainers.find(v=>this.getViewContainerLocation(v)===c)}}D.Registry.add(a.ViewContainersRegistry,new S);var d;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(d=e.ViewContentGroups||(e.ViewContentGroups={}));function l(o,c){var v,p,h,b;const R=(v=o.group)!==null&&v!==void 0?v:d.More,N=(p=c.group)!==null&&p!==void 0?p:d.More;return R!==N?R.localeCompare(N):((h=o.order)!==null&&h!==void 0?h:5)-((b=c.order)!==null&&b!==void 0?b:5)}class f extends y.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new _.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new _.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new _.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new _.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new s.SetMap}registerViews(c,v){this.registerViews2([{views:c,viewContainer:v}])}registerViews2(c){c.forEach(({views:v,viewContainer:p})=>this.addViews(v,p)),this._onViewsRegistered.fire(c)}deregisterViews(c,v){const p=this.removeViews(c,v);p.length&&this._onViewsDeregistered.fire({views:p,viewContainer:v})}moveViews(c,v){for(const p of this._views.keys())if(p!==v){const h=this.removeViews(c,p);h.length&&(this.addViews(h,v),this._onDidChangeContainer.fire({views:h,from:p,to:v}))}}getViews(c){return this._views.get(c)||[]}getView(c){for(const v of this._viewContainers){const p=(this._views.get(v)||[]).filter(h=>h.id===c)[0];if(p)return p}return null}getViewContainer(c){for(const v of this._viewContainers)if((this._views.get(v)||[]).filter(h=>h.id===c)[0])return v;return null}registerViewWelcomeContent(c,v){return this._viewWelcomeContents.add(c,v),this._onDidChangeViewWelcomeContent.fire(c),(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(c,v),this._onDidChangeViewWelcomeContent.fire(c)})}registerViewWelcomeContent2(c,v){const p=new Map;for(const[h,b]of v)this._viewWelcomeContents.add(c,b),p.set(h,(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(c,b),this._onDidChangeViewWelcomeContent.fire(c)}));return this._onDidChangeViewWelcomeContent.fire(c),p}getViewWelcomeContent(c){const v=[];return this._viewWelcomeContents.forEach(c,p=>v.push(p)),v.sort(l)}addViews(c,v){let p=this._views.get(v);p||(p=[],this._views.set(v,p),this._viewContainers.push(v));for(const h of c){if(this.getView(h.id)!==null)throw new Error((0,T.localize)(1,null,h.id));p.push(h)}}removeViews(c,v){const p=this._views.get(v);if(!p)return[];const h=[],b=[];for(const R of p)c.includes(R)?h.push(R):b.push(R);return h.length&&(b.length?this._views.set(v,b):(this._views.delete(v),this._viewContainers.splice(this._viewContainers.indexOf(v),1))),h}}D.Registry.add(a.ViewsRegistry,new f),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new I.RawContextKey("focusedView","",(0,T.localize)(2,null));function t(o){return`view.${o}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var n;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(c,v){this.resolved=!1,this._hasResolve=!1,(0,C.mixin)(this,c),this._hasResolve=!!v,this.resolve=async p=>{var h,b;if(v&&!this.resolved){const R=await v(p);R&&(this.tooltip=(h=this.tooltip)!==null&&h!==void 0?h:R.tooltip,this.command=(b=this.command)!==null&&b!==void 0?b:R.command)}p.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i}),define(ge[203],pe([0,1,2,181,118,13,182,202]),function(K,e,_,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function D(u){return(E,...w)=>u(E.get(I.ICommandService),...w)}class P{static execute(E,w){const S={forceReuseWindow:w&&w.reuseWindow,remoteAuthority:w&&w.remoteAuthority};return E.executeCommand("_files.newWindow",S)}}e.NewWindowAPICommand=P,P.ID="vscode.newWindow",I.CommandsRegistry.registerCommand({id:P.ID,handler:D(P.execute),description:{description:"Opens an new window",args:[]}}),I.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(u,E){return u.get(T.IWorkspacesService).removeRecentlyOpened([E])});class s{static execute(E,w){return typeof w=="string"?w=w.match(/^[^:/?#]+:\/\//)?_.URI.parse(w):_.URI.file(w):w=_.URI.revive(w),E.executeCommand("_workbench.removeFromRecentlyOpened",w)}}e.RemoveFromRecentlyOpenedAPICommand=s,s.ID="vscode.removeFromRecentlyOpened",I.CommandsRegistry.registerCommand(s.ID,D(s.execute));class C{static execute(E,w){const S=typeof w=="string"?{extensionId:w}:w;return E.executeCommand("workbench.action.openIssueReporter",S)}}e.OpenIssueReporter=C,C.ID="vscode.openIssueReporter",I.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(u,E){const w=u.get(T.IWorkspacesService);let S;const d=E.uri,l=E.label,f=E.remoteAuthority;return E.type==="workspace"?S={workspace:await w.getWorkspaceIdentifier(d),label:l,remoteAuthority:f}:E.type==="folder"?S={folderUri:d,label:l,remoteAuthority:f}:S={fileUri:d,label:l,remoteAuthority:f},w.addRecentlyOpened([S])}),I.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(u){return u.get(T.IWorkspacesService).getRecentlyOpened()}),I.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(u,E){const w=u.get(A.ILogService),S=u.get(y.IEnvironmentService);S.isExtensionDevelopment&&!!S.extensionTestsLocationURI&&w.setLevel(E)}),I.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(u){return u.get(A.ILogService).getLevel()}),I.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(u,E){const w=u.get(k.IViewDescriptorService),S=w.getViewContainerById(E.destinationId);if(!!S){for(const d of E.viewIds){const l=w.getViewDescriptorById(d);(l==null?void 0:l.canMoveView)&&w.moveViewsToContainer([l],S,k.ViewVisibilityState.Default)}await u.get(k.IViewsService).openViewContainer(S.id,!0)}});class g{static execute(E,w){return!Array.isArray(w==null?void 0:w.viewIds)||typeof(w==null?void 0:w.destinationId)!="string"?Promise.reject("Invalid arguments"):E.executeCommand("_workbench.action.moveViews",w)}}e.MoveViewsAPICommand=g,g.ID="vscode.moveViews",I.CommandsRegistry.registerCommand({id:g.ID,handler:D(g.execute),description:{description:"Move Views",args:[]}});class m{static execute(E,w){return E.executeCommand("_workbench.open",w)}}m.ID="vscode.open",I.CommandsRegistry.registerCommand(m.ID,D(m.execute));class a{static execute(E,w,S,d,l){return E.executeCommand("_workbench.diff",[w,S,d])}}a.ID="vscode.diff",I.CommandsRegistry.registerCommand(a.ID,D(a.execute))}),define(ge[121],pe([0,1,3,15,170]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new _.Emitter,this._onExit=new _.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,D,P,s){const C={command:k};if(D&&Object.keys(D).length>0&&(C.arguments=D),this.internalSend("request",C),typeof s=="number"){const g=setTimeout(()=>{clearTimeout(g);const m=this.pendingRequests.get(C.seq);if(m){this.pendingRequests.delete(C.seq);const a={type:"response",seq:0,request_seq:C.seq,success:!1,command:k,message:(0,T.localize)(0,null,s,k)};m(a)}},s)}return P&&this.pendingRequests.set(C.seq,P),C.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,D){return k.type!=="event"||D.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,I.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const D=k,P=this.pendingRequests.get(D.request_seq);P&&(this.pendingRequests.delete(D.request_seq),P(D));break}}}internalSend(k,D){D.type=k,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((D,P)=>k.set(P,D)),await(0,I.timeout)(500),k.forEach((D,P)=>{D({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(ge[204],pe([0,1,9,2,8,23,12]),function(K,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function D(n,r,i){return n.replace(k,function(o,c){return r&&c.length>0&&c[0]!=="_"?o:i&&i.hasOwnProperty(c)?i[c]:o})}e.formatPII=D;function P(n){const r={};for(const i of Object.keys(n))i.startsWith("!")||(r[i]=n[i]);return r}e.filterExceptionsFromTelemetry=P;function s(n){return n.configuration.request==="attach"&&!C(n)}e.isSessionAttach=s;function C(n){let r=n.configuration.type;if(!!r)return r==="vslsShare"&&(r=n.configuration.adapterProxy.configuration.type),(0,_.equalsIgnoreCase)(r,"extensionhost")||(0,_.equalsIgnoreCase)(r,"pwa-extensionhost")?n:n.parentSession?C(n.parentSession):void 0}e.getExtensionHostDebugSession=C;function g(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=g;function m(n,r,i){let o,c=0,v=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,p=null;for(;p=v.exec(n);){let h=p.index+1,b=h+p[0].length;if(h<=r&&b>=i){o=p[0],c=h;break}}if(o){let h=/\w+/g,b=null;for(;(b=h.exec(o))&&!(b.index+1+c+b[0].length>=i););b&&(o=o.substring(0,h.lastIndex))}return o?{start:c,end:c+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(n){return!!(n&&n.match(a))}e.isUri=u;function E(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(u(n.path))return I.URI.parse(n.path);if((0,T.isAbsolute)(n.path))return I.URI.file(n.path)}return n.path}function w(n){if(typeof n.path=="object"){const r=I.URI.revive(n.path);if(r)return r.scheme===y.Schemas.file?r.fsPath:r.toString()}return n.path}function S(n,r){const i=r?E:w,o=(0,A.deepClone)(n);return l(o,(c,v)=>{c&&v&&(v.path=i(v))}),o}e.convertToDAPaths=S;function d(n,r){const i=r?E:w,o=(0,A.deepClone)(n);return l(o,(c,v)=>{!c&&v&&(v.path=i(v))}),o}e.convertToVSCPaths=d;function l(n,r){switch(n.type){case"event":const i=n;switch(i.event){case"output":r(!1,i.body.source);break;case"loadedSource":r(!1,i.body.source);break;case"breakpoint":r(!1,i.body.breakpoint.source);break;default:break}break;case"request":const o=n;switch(o.command){case"setBreakpoints":r(!0,o.arguments.source);break;case"breakpointLocations":r(!0,o.arguments.source);break;case"source":r(!0,o.arguments.source);break;case"gotoTargets":r(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(v=>r(!1,v));break;default:break}break;case"response":const c=n;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(v=>r(!1,v.source));break;case"loadedSources":c.body.sources.forEach(v=>r(!1,v));break;case"scopes":c.body.scopes.forEach(v=>r(!1,v.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(v=>r(!1,v.source));break;case"setBreakpoints":c.body.breakpoints.forEach(v=>r(!1,v.source));break;default:break}break}}function f(n){return n.filter(r=>{var i;return!((i=r.presentation)===null||i===void 0?void 0:i.hidden)}).sort((r,i)=>r.presentation?i.presentation?r.presentation.group?i.presentation.group?r.presentation.group!==i.presentation.group?r.presentation.group.localeCompare(i.presentation.group):t(r.presentation.order,i.presentation.order):-1:i.presentation.group?1:t(r.presentation.order,i.presentation.order):-1:i.presentation?1:0)}e.getVisibleAndSorted=f;function t(n,r){return typeof n!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:n-r}}),define(ge[205],pe([0,1,26,38,171,122,8,9,23,10,183,121]),function(K,e,_,I,T,A,y,k,D,P,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class g extends C.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(S,d){this.outputStream=d,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,S.on("data",l=>this.handleData(l))}sendMessage(S){if(this.outputStream){const d=JSON.stringify(S);this.outputStream.write(`Content-Length: ${Buffer.byteLength(d,"utf8")}${g.TWO_CRLF}${d}`,"utf8")}}handleData(S){for(this.rawData=Buffer.concat([this.rawData,S]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const d=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,d.length>0)try{this.acceptMessage(JSON.parse(d))}catch(l){this._onError.fire(new Error((l.message||l)+`
`+d))}continue}}else{const d=this.rawData.indexOf(g.TWO_CRLF);if(d!==-1){const f=this.rawData.toString("utf8",0,d).split(g.HEADER_LINESEPARATOR);for(const t of f){const n=t.split(g.HEADER_FIELDSEPARATOR);n[0]==="Content-Length"&&(this.contentLength=Number(n[1]))}this.rawData=this.rawData.slice(d+g.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=g,g.TWO_CRLF=`\r
\r
`,g.HEADER_LINESEPARATOR=/\r?\n/,g.HEADER_FIELDSEPARATOR=/: */;class m extends g{startSession(){return new Promise((S,d)=>{let l=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),S(),l=!0}),this.socket.on("close",()=>{l?this._onError.fire(new Error("connection closed")):d(new Error("connection closed"))}),this.socket.on("error",f=>{l?this._onError.fire(f):d(f)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=m;class a extends m{constructor(S){super();this.adapterServer=S}createConnection(S){return A.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",S)}}e.SocketDebugAdapter=a;class u extends m{constructor(S){super();this.adapterServer=S}createConnection(S){return A.createConnection(this.adapterServer.path,S)}}e.NamedPipeDebugAdapter=u;class E extends g{constructor(S,d,l){super();this.adapterExecutable=S,this.debugType=d,this.outputService=l}async startSession(){const S=this.adapterExecutable.command,d=this.adapterExecutable.args,l=this.adapterExecutable.options||{};try{if(S)if(y.isAbsolute(S)){if(!await(0,_.exists)(S))throw new Error(T.localize(0,null,S))}else S.indexOf("/")<0&&S.indexOf("\\")<0;else throw new Error(T.localize(1,null,this.debugType));let f=process.env;if(l.env&&Object.keys(l.env).length>0&&(f=D.mixin(D.deepClone(process.env),l.env)),S==="node")if(Array.isArray(d)&&d.length>0){const n=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:f,execArgv:n?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};l.cwd&&(r.cwd=l.cwd);const i=I.fork(d[0],d.slice(1),r);if(!i.pid)throw new Error(T.localize(2,null,d[0]));this.serverProcess=i}else throw new Error(T.localize(3,null));else{const n={env:f};l.cwd&&(n.cwd=l.cwd),this.serverProcess=I.spawn(S,d,n)}this.serverProcess.on("error",n=>{this._onError.fire(n)}),this.serverProcess.on("exit",(n,r)=>{this._onExit.fire(n)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",n=>{this._onError.fire(n)}),this.serverProcess.stdin.on("error",n=>{this._onError.fire(n)});const t=this.outputService;if(t){const n=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const i=t.getChannel(s.ExtensionsChannelId);i&&i.append(n(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(f){this._onError.fire(f)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((S,d)=>{const l=I.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(f,t,n){if(f)return d(f)});l.on("exit",S),l.on("error",d)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(S,d){if(!!S){const l=Object.create(null);S.runtime&&(S.runtime.indexOf("./")===0?l.runtime=y.join(d,S.runtime):l.runtime=S.runtime),S.runtimeArgs&&(l.runtimeArgs=S.runtimeArgs),S.program&&(y.isAbsolute(S.program)?l.program=S.program:l.program=y.join(d,S.program)),S.args&&(l.args=S.args);const f=S;return f.win&&(l.win=E.extract(f.win,d)),f.winx86&&(l.winx86=E.extract(f.winx86,d)),f.windows&&(l.windows=E.extract(f.windows,d)),f.osx&&(l.osx=E.extract(f.osx,d)),f.linux&&(l.linux=E.extract(f.linux,d)),l}}static platformAdapterExecutable(S,d){let l=Object.create(null);d=d.toLowerCase();for(const o of S)if(o.contributes){const c=o.contributes.debuggers;c&&c.length>0&&c.filter(v=>typeof v.type=="string"&&k.equalsIgnoreCase(v.type,d)).forEach(v=>{const p=E.extract(v,o.extensionLocation.fsPath);l=D.mixin(l,p,o.isBuiltin)})}let f;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?f=l.winx86||l.win||l.windows:P.isWindows?f=l.win||l.windows:P.isMacintosh?f=l.osx:P.isLinux&&(f=l.linux),f=f||l;let t=f.program||l.program;const n=f.args||l.args;let r=f.runtime||l.runtime;const i=f.runtimeArgs||l.runtimeArgs;if(r)return{type:"executable",command:r,args:(i||[]).concat(typeof t=="string"?[t]:[]).concat(n||[])};if(t)return{type:"executable",command:t,args:n||[]}}}e.ExecutableDebugAdapter=E}),define(ge[206],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DEFAULT_TERMINAL_OSX=void 0,e.DEFAULT_TERMINAL_OSX="Terminal.app"}),define(ge[207],pe([0,1,38,8,78,172,26,10,84,4,206,12]),function(K,e,_,I,T,A,y,k,D,P,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const g=A.localize(0,null);let m=class Ht{constructor(d){this._configurationService=d}openTerminal(d){if(this._configurationService){const l=this._configurationService.getValue();this.spawnTerminal(_,l,T.getWindowsShell(),d)}}runInTerminal(d,l,f,t,n){const r=n.windowsExec||Ht.getDefaultTerminalWindows();return new Promise((i,o)=>{const c=`"${l} - ${g}"`,v=`""${f.join('" "')}" & pause"`,p=["/c","start",c,"/wait",r,"/c",v],h=Object.assign({},process.env,t);Object.keys(h).filter(N=>h[N]===null).forEach(N=>delete h[N]);const b={cwd:l,env:h,windowsVerbatimArguments:!0};_.spawn(Ht.CMD,p,b).on("error",N=>{o(E(N))}),i(void 0)})}spawnTerminal(d,l,f,t){const r=l.terminal.external.windowsExec||Ht.getDefaultTerminalWindows();t&&t[1]===":"&&(t=t[0].toUpperCase()+t.substr(1));const i=I.basename(r).toLowerCase();if(i==="cmder"||i==="cmder.exe")return d.spawn(r,t?[t]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return r.indexOf(" ")>=0&&o.push('""'),o.push(r),(i==="wt"||i==="wt.exe")&&o.push("-d ."),new Promise((c,v)=>{const p=t?{cwd:t}:void 0,h=d.spawn(f,o,p);h.on("error",v),h.on("exit",()=>c())})}static getDefaultTerminalWindows(){if(!Ht._DEFAULT_TERMINAL_WINDOWS){const d=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");Ht._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${d?"Sysnative":"System32"}\\cmd.exe`}return Ht._DEFAULT_TERMINAL_WINDOWS}};m.CMD="cmd.exe",m=Ve([xe(0,(0,P.optional)(D.IConfigurationService))],m),e.WindowsExternalTerminalService=m;let a=class Mn{constructor(d){this._configurationService=d}openTerminal(d){if(this._configurationService){const l=this._configurationService.getValue();this.spawnTerminal(_,l,d)}}runInTerminal(d,l,f,t,n){const r=n.osxExec||s.DEFAULT_TERMINAL_OSX;return new Promise((i,o)=>{if(r===s.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const c=r===s.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",p=[C.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,K).fsPath,"-t",d||g,"-w",l];for(let R of f)p.push("-a"),p.push(R);if(t)for(let R in t){const N=t[R];N===null?(p.push("-u"),p.push(R)):(p.push("-e"),p.push(`${R}=${N}`))}let h="";const b=_.spawn(Mn.OSASCRIPT,p);b.on("error",R=>{o(E(R))}),b.stderr.on("data",R=>{h+=R.toString()}),b.on("exit",R=>{if(R===0)i(void 0);else if(h){const N=h.split(`
`,1);o(new Error(N[0]))}else o(new Error(A.localize(1,null,c,R)))})}else o(new Error(A.localize(2,null,r)))})}spawnTerminal(d,l,f){const n=l.terminal.external.osxExec||s.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{const o=["-a",n];f&&o.push(f);const c=d.spawn("/usr/bin/open",o);c.on("error",i),c.on("exit",()=>r())})}};a.OSASCRIPT="/usr/bin/osascript",a=Ve([xe(0,(0,P.optional)(D.IConfigurationService))],a),e.MacExternalTerminalService=a;let u=class zt{constructor(d){this._configurationService=d}openTerminal(d){if(this._configurationService){const l=this._configurationService.getValue();this.spawnTerminal(_,l,d)}}runInTerminal(d,l,f,t,n){const r=n.linuxExec?Promise.resolve(n.linuxExec):zt.getDefaultTerminalLinuxReady();return new Promise((i,o)=>{let c=[];r.then(v=>{v.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const p=`${w(f)}; echo; read -p "${zt.WAIT_MESSAGE}" -n1;`;c.push(`''${p}''`);const h=Object.assign({},process.env,t);Object.keys(h).filter(j=>h[j]===null).forEach(j=>delete h[j]);const b={cwd:l,env:h};let R="";const N=_.spawn(v,c,b);N.on("error",j=>{o(E(j))}),N.stderr.on("data",j=>{R+=j.toString()}),N.on("exit",j=>{if(j===0)i(void 0);else if(R){const oe=R.split(`
`,1);o(new Error(oe[0]))}else o(new Error(A.localize(4,null,v,j)))})})})}spawnTerminal(d,l,f){const t=l.terminal.external,n=t.linuxExec?Promise.resolve(t.linuxExec):zt.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{n.then(o=>{const c=f?{cwd:f}:void 0,v=d.spawn(o,[],c);v.on("error",i),v.on("exit",()=>r())})})}static async getDefaultTerminalLinuxReady(){return zt._DEFAULT_TERMINAL_LINUX_READY||(zt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async d=>{k.isLinux?await y.exists("/etc/debian_version")?d("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?d("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?d("konsole"):process.env.COLORTERM?d(process.env.COLORTERM):process.env.TERM?d(process.env.TERM):d("xterm"):d("xterm")})),zt._DEFAULT_TERMINAL_LINUX_READY}};u.WAIT_MESSAGE=A.localize(3,null),u=Ve([xe(0,(0,P.optional)(D.IConfigurationService))],u),e.LinuxExternalTerminalService=u;function E(S){return"errno"in S&&S.errno==="ENOENT"&&"path"in S&&typeof S.path=="string"?new Error(A.localize(5,null,S.path)):S}function w(S){let d="";for(let l of S)l.indexOf(" ")>=0?d+='"'+l+'"':d+=l,d+=" ";return d}}),define(ge[208],pe([0,1,38,10,207,29]),function(K,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;let y;function k(g,m){if(!y)if(I.isWindows)y=new T.WindowsExternalTerminalService(void 0);else if(I.isMacintosh)y=new T.MacExternalTerminalService(void 0);else if(I.isLinux)y=new T.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const a=m.getConfiguration("terminal");return y.runInTerminal(g.title,g.cwd,g.args,g.env||{},a.external||{})}e.runInExternalTerminal=k;function D(g,m){return new Promise((a,u)=>{let E="";const w=_.spawn(g,m);w.pid&&w.stdout.on("data",S=>{E+=S.toString()}),w.on("error",S=>{u(S)}),w.on("close",S=>{a(E)})})}function P(g){return g?I.isWindows?D("wmic",["process","get","ParentProcessId"]).then(m=>m.split(`\r
`).some(u=>parseInt(u)===g),m=>!0):D("/usr/bin/pgrep",["-lP",String(g)]).then(m=>{const a=m.trim();return!(a.length===0||a.indexOf(" tmux")>=0)},m=>!0):Promise.resolve(!0)}e.hasChildProcesses=P;var s;(function(g){g[g.cmd=0]="cmd",g[g.powershell=1]="powershell",g[g.bash=2]="bash"})(s||(s={}));function C(g,m,a,u){g=g.trim().toLowerCase();let E;g.indexOf("powershell")>=0||g.indexOf("pwsh")>=0?E=1:g.indexOf("cmd.exe")>=0?E=0:g.indexOf("bash")>=0?E=2:I.isWindows?E=0:E=2;let w,S=" ";switch(E){case 1:if(w=l=>(l=l.replace(/\'/g,"''"),l.length>0&&l.charAt(l.length-1)==="\\"?`'${l}\\'`:`'${l}'`),a){const l=(0,A.getDriveLetter)(a);l&&(S+=`${l}:; `),S+=`cd ${w(a)}; `}if(u)for(let l in u){const f=u[l];f===null?S+=`Remove-Item env:${l}; `:S+=`\${env:${l}}='${f}'; `}if(m.length>0){const l=w(m.shift());S+=l[0]==="'"?`& ${l} `:`${l} `;for(let f of m)S+=`${w(f)} `}break;case 0:if(w=l=>(l=l.replace(/\"/g,'""'),l.indexOf(" ")>=0||l.indexOf('"')>=0||l.length===0?`"${l}"`:l),a){const l=(0,A.getDriveLetter)(a);l&&(S+=`${l}: && `),S+=`cd ${w(a)} && `}if(u){S+='cmd /C "';for(let l in u){let f=u[l];f===null?S+=`set "${l}=" && `:(f=f.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),S+=`set "${l}=${f}" && `)}}for(let l of m)S+=`${w(l)} `;u&&(S+='"');break;case 2:w=l=>(l=l.replace(/(["'\\\$])/g,"\\$1"),l.indexOf(" ")>=0||l.indexOf(";")>=0||l.length===0?`"${l}"`:l);const d=l=>/[^\w@%\/+=,.:^-]/.test(l)?`'${l.replace(/'/g,"'\\''")}'`:l;if(a&&(S+=`cd ${w(a)} ; `),u){S+="/usr/bin/env";for(let l in u){const f=u[l];f===null?S+=` -u ${d(l)}`:S+=` ${d(`${l}=${f}`)}`}S+=" "}for(let l of m)S+=`${w(l)} `;break}return S}e.prepareCommand=C}),define(ge[89],pe([0,1,33,12,8,10,81]),function(K,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var k;(function(p){p[p.Markdown=1]="Markdown",p[p.Code=2]="Code"})(k=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(p){p[p.Running=1]="Running",p[p.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{},trusted:!0};var P;(function(p){p[p.Idle=1]="Idle",p[p.Pending=2]="Pending",p[p.Executing=3]="Executing"})(P=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var s;(function(p){p[p.WithHardKernelDependency=0]="WithHardKernelDependency",p[p.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",p[p.Pure=2]="Pure",p[p.Never=3]="Never"})(s=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var C;(function(p){p[p.ModelChange=1]="ModelChange",p[p.Move=2]="Move",p[p.CellClearOutput=3]="CellClearOutput",p[p.CellsClearOutput=4]="CellsClearOutput",p[p.ChangeLanguage=5]="ChangeLanguage",p[p.Initialize=6]="Initialize",p[p.ChangeCellMetadata=7]="ChangeCellMetadata",p[p.Output=8]="Output",p[p.OutputItem=9]="OutputItem",p[p.ChangeCellContent=10]="ChangeCellContent",p[p.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",p[p.Unknown=12]="Unknown"})(C=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var g;(function(p){p[p.Handle=0]="Handle",p[p.Index=1]="Index"})(g=e.SelectionStateType||(e.SelectionStateType={}));var m;(function(p){p[p.Replace=1]="Replace",p[p.Output=2]="Output",p[p.Metadata=3]="Metadata",p[p.CellLanguage=4]="CellLanguage",p[p.DocumentMetadata=5]="DocumentMetadata",p[p.OutputsSplice=6]="OutputsSplice",p[p.Move=7]="Move",p[p.Unknown=8]="Unknown",p[p.CellContent=9]="CellContent",p[p.OutputItems=10]="OutputItems",p[p.PartialMetadata=11]="PartialMetadata"})(m=e.CellEditType||(e.CellEditType={}));function a(p){const h=u.parse(p);return h?h.notebook.toString():p.toString()}e.getCellUndoRedoComparisonKey=a;var u;(function(p){p.scheme=I.Schemas.vscodeNotebookCell;const h=/^ch(\d{7,})/;function b(oe,q){return oe.with({scheme:p.scheme,fragment:`ch${q.toString().padStart(7,"0")}${oe.scheme!==I.Schemas.file?oe.scheme:""}`})}p.generate=b;function R(oe){if(oe.scheme===p.scheme){const q=h.exec(oe.fragment);if(!!q)return{handle:Number(q[1]),notebook:oe.with({scheme:oe.fragment.substr(q[0].length)||I.Schemas.file,fragment:null})}}}p.parse=R;function N(oe,q){return oe.with({scheme:I.Schemas.vscodeNotebookCellMetadata,fragment:`ch${q.toString().padStart(7,"0")}${oe.scheme!==I.Schemas.file?oe.scheme:""}`})}p.generateCellMetadataUri=N;function j(oe){if(oe.scheme===I.Schemas.vscodeNotebookCellMetadata){const q=h.exec(oe.fragment);if(!!q)return{handle:Number(q[1]),notebook:oe.with({scheme:oe.fragment.substr(q[0].length)||I.Schemas.file,fragment:null})}}}p.parseCellMetadataUri=j})(u=e.CellUri||(e.CellUri={}));const E=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function w(p){var h,b;return(b=(h=E.get(p))===null||h===void 0?void 0:h.alwaysSecure)!==null&&b!==void 0?b:!1}e.mimeTypeIsAlwaysSecure=w;function S(p){var h,b;return(b=(h=E.get(p))===null||h===void 0?void 0:h.supportedByCore)!==null&&b!==void 0?b:!1}e.mimeTypeSupportedByCore=S;function d(p){var h,b;return(b=(h=E.get(p))===null||h===void 0?void 0:h.mergeable)!==null&&b!==void 0?b:!1}e.mimeTypeIsMergeable=d;function l(p,h){return A.isWindows&&(p=p.replace(/\//g,"\\"),h=h.replace(/\//g,"\\")),_.match(p,h)}function f(p,h,b){let R=0;for(let N=0;N<h.length;N++){if(l(h[N],p))return R;R++}for(let N=0;N<b.length;N++){if(l(b[N],p))return R;R++}return R}function t(p,h,b){return p.sort((R,N)=>f(R,h,b)-f(N,h,b))}e.sortMimeTypes=t;function n(p,h,b,R=(N,j)=>N===j){const N=[];function j(W,H,U){if(!(H===0&&U.length===0)){const L=N[N.length-1];L&&L.start+L.deleteCount===W?(L.deleteCount+=H,L.toInsert.push(...U)):N.push({start:W,deleteCount:H,toInsert:U})}}let oe=0,q=0;for(;;){if(oe===p.length){j(oe,0,h.slice(q));break}if(q===h.length){j(oe,p.length-oe,[]);break}const W=p[oe],H=h[q];if(R(W,H)){oe+=1,q+=1;continue}b(H)?(j(oe,1,[]),oe+=1):(j(oe,0,[H]),q+=1)}return N}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(p){p.default="default",p.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function i(p){const h=p;return!!((typeof h.include=="string"||_.isRelativePattern(h.include))&&(typeof h.exclude=="string"||_.isRelativePattern(h.exclude)))}e.isDocumentExcludePattern=i;function o(p,h,b){if(Array.isArray(p.viewType)&&p.viewType.indexOf(h)>=0||p.viewType===h)return!0;if(p.filenamePattern){let R=i(p.filenamePattern)?p.filenamePattern.include:p.filenamePattern,N=i(p.filenamePattern)?p.filenamePattern.exclude:void 0;if(_.match(R,(0,T.basename)(b.fsPath).toLowerCase()))return!(N&&_.match(N,(0,T.basename)(b.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class c{constructor(h){this.textModel=h}getElements(){const h=new Int32Array(this.textModel.cells.length);for(let b=0;b<this.textModel.cells.length;b++)h[b]=this.textModel.cells[b].getHashValue();return h}}e.CellSequence=c,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var v;(function(p){p[p.Left=1]="Left",p[p.Right=2]="Right"})(v=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}))}),define(ge[209],pe([0,1,174,4,81]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new T.RawContextKey("customExecutionSupported",!0,_.localize(0,null)),e.ShellExecutionSupportedContext=new T.RawContextKey("shellExecutionSupported",!1,_.localize(1,null)),e.ProcessExecutionSupportedContext=new T.RawContextKey("processExecutionSupported",!1,_.localize(2,null)),e.ITaskService=(0,I.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ge[210],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function _(T){return[...T.entries()]}e.serializeEnvironmentVariableCollection=_;function I(T){return new Map(T)}e.deserializeEnvironmentVariableCollection=I}),define(ge[211],pe([0,1,8,135,10]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.escapeNonWindowsPath=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function A(f,t){if(!!t)if(T.isWindows)for(const n in t){let r=n;for(const o in f)if(n.toLowerCase()===o.toLowerCase()){r=o;break}const i=t[n];i!==void 0&&y(f,r,i)}else Object.keys(t).forEach(n=>{const r=t[n];r!==void 0&&y(f,n,r)})}e.mergeEnvironments=A;function y(f,t,n){typeof n=="string"?f[t]=n:delete f[t]}function k(f,t,n,r){f.TERM_PROGRAM="vscode",t&&(f.TERM_PROGRAM_VERSION=t),s(f,r)&&(f.LANG=C(n)),f.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=k;function D(f,t){if(!!t)for(const n of Object.keys(t)){const r=t[n];r&&(f[n]=r)}}function P(f,t){return Object.keys(t).forEach(n=>{const r=t[n];if(typeof r=="string")try{t[n]=f(r)}catch(i){t[n]=r}}),t}function s(f,t){if(t==="on")return!0;if(t==="auto"){const n=f.LANG;return!n||n.search(/\.UTF\-8$/)===-1&&n.search(/\.utf8$/)===-1&&n.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=s;function C(f){const t=f?f.split("-"):[],n=t.length;if(n===0)return"en_US.UTF-8";if(n===1){const r={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in r&&t.push(r[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.getLangEnvVariable=C;function g(f,t,n,r,i,o){if(f.cwd){const v=typeof f.cwd=="object"?f.cwd.fsPath:f.cwd,p=m(v,n);return a(p||v)}let c;return!f.ignoreConfigurationCwd&&i&&(n&&(i=m(i,n,o)),i&&(_.isAbsolute(i)?c=i:r&&(c=_.join(r.fsPath,i)))),c||(c=r?r.fsPath:t||""),a(c)}e.getCwd=g;function m(f,t,n){if(t)try{return t(f)}catch(r){n==null||n.error("Could not resolve terminal cwd",r);return}return f}function a(f){return T.OS===1&&f&&f[1]===":"?f[0].toUpperCase()+f.substr(1):f}function u(f){let t=f;t.indexOf("\\")!==0&&(t=t.replace(/\\/g,"\\\\"));const n=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return t=t.replace(n,""),`'${t}'`}e.escapeNonWindowsPath=u;function E(f,t){if(!!t)return n=>t.resolve(f,n)}e.createVariableResolver=E;function w(f,t,n,r,i,o,c,v=T.platform){let p;c&&(p=d(f,"automationShell",v)),p||(p=d(f,"shell",v));let h=p||t;if(v===3&&!n&&r){const b=_.join(r,"Sysnative").replace(/\//g,"\\").toLowerCase();h&&h.toLowerCase().indexOf(b)===0&&(h=_.join(r,"System32",h.substr(b.length+1)))}if(h&&v===3&&(h=h.replace(/\//g,"\\")),i)try{h=i(h)}catch(b){o.error("Could not resolve shell",b)}return h}e.getDefaultShell=w;function S(f,t,n,r,i=T.platform){if(t&&d(f,"automationShell",i))return[];const o=i===3?"windows":i===1?"osx":"linux";let c=f(`terminal.integrated.shellArgs.${o}`);if(!c)return[];if(typeof c=="string"&&i===3)return n?n(c):c;if(n){const v=[];for(const p of c)try{v.push(n(p))}catch(h){r.error(`Could not resolve terminal.integrated.shellArgs.${o}`,h),v.push(p)}c=v}return c}e.getDefaultShellArgs=S;function d(f,t,n=T.platform){return f(`terminal.integrated.${t}.${n===3?"windows":n===1?"osx":"linux"}`)}function l(f,t,n,r,i,o){let c={};if(f.strictEnv)D(c,f.env);else{D(c,o);const v=Object.assign({},t);n&&(v&&P(n,v),f.env&&P(n,f.env)),(0,I.sanitizeProcessEnvironment)(c,"VSCODE_IPC_HOOK_CLI"),A(c,v),A(c,f.env),k(c,r,T.locale,i)}return c}e.createTerminalEnvironment=l});var mn=this&&this.__asyncValues||function(K){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=K[Symbol.asyncIterator],_;return e?e.call(K):(K=typeof __values=="function"?__values(K):K[Symbol.iterator](),_={},I("next"),I("throw"),I("return"),_[Symbol.asyncIterator]=function(){return this},_);function I(A){_[A]=K[A]&&function(y){return new Promise(function(k,D){y=K[A](y),T(k,D,y.done,y.value)})}}function T(A,y,k,D){Promise.resolve(D).then(function(P){A({value:P,done:k})},y)}};define(ge[212],pe([0,1,37,8,104,191,38,26,43,10]),function(K,e,_,I,T,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let s;function C(l,f,t,n,r,i,o){return f=f||{existsFile:k.SymlinkSupport.existsFile,readFile:_.promises.readFile},P.isWindows?g(l,f,t,n==null?void 0:n.useWslProfiles,n==null?void 0:n.profiles.windows,r,i):w(f,t,l,P.isMacintosh?n==null?void 0:n.profiles.osx:n==null?void 0:n.profiles.linux,o,r,i)}e.detectAvailableProfiles=C;async function g(l,f,t,n,r,i,o){const c=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${process.env.windir}\\${c?"Sysnative":"System32"}`;let p=!1;(0,A.getWindowsBuildNumber)()>=16299&&(p=!0),await a();const h=new Map;l||(h.set("PowerShell",{source:"PowerShell",icon:D.Codicon.terminalPowershell.id,isAutoDetected:!0}),h.set("Windows PowerShell",{path:`${v}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:D.Codicon.terminalPowershell.id,isAutoDetected:!0}),h.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),h.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),h.set("Command Prompt",{path:`${v}\\cmd.exe`,icon:D.Codicon.terminalCmd.id,isAutoDetected:!0})),S(r,h);const b=await m(h.entries(),f,t,i,o);if(!l||l&&n)try{const R=await E(`${v}\\${p?"wsl.exe":"bash.exe"}`,n);R&&b.push(...R)}catch(R){t==null||t.info("WSL is not installed, so could not detect WSL profiles")}return b}async function m(l,f,t,n,r){const i=[];for(const[o,c]of l)if(c!==null){let v,p,h;if("source"in c){const N=s==null?void 0:s.get(c.source);if(!N)continue;v=N.paths,p=c.args||N.args,h=c.icon||N.icon}else v=Array.isArray(c.path)?c.path:[c.path],p=P.isWindows||Array.isArray(c.args)?c.args:void 0,h=c.icon;const b=v.slice();for(let N=0;N<b.length;N++)b[N]=await(n==null?void 0:n.resolveAsync(r,b[N]))||b[N];const R=await d(o,b,f,p,c.env,c.overrideName,c.isAutoDetected,t);R?(R.isAutoDetected=c.isAutoDetected,R.icon=h,i.push(R)):t==null||t.trace("profile not validated",o,v)}return i}async function a(){s||(s=new Map,s.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`],args:["--login"]}),s.set("PowerShell",{profileName:"PowerShell",paths:await u(),icon:"terminal-powershell"}))}async function u(){var l,f;const t=[];try{for(var n=mn((0,T.enumeratePowerShellInstallations)()),r;r=await n.next(),!r.done;){const i=r.value;t.push(i.exePath)}}catch(i){l={error:i}}finally{try{r&&!r.done&&(f=n.return)&&await f.call(n)}finally{if(l)throw l.error}}return t}async function E(l,f){const t=[];if(f){const n=await new Promise((r,i)=>{y.exec("wsl.exe -l -q",{encoding:"utf16le"},(o,c)=>{if(o)return i("Problem occurred when getting wsl distros");r(c)})});if(n){const r=new RegExp(/[\r?\n]/),i=n.split(r).filter(o=>o.trim().length>0&&o!=="");for(let o of i)if(o!==""&&!o.startsWith("docker-desktop")){const c={profileName:`${o} (WSL)`,path:l,args:["-d",`${o}`]};o.includes("Ubuntu")?c.icon="terminal-ubuntu":o.includes("Debian")?c.icon="terminal-debian":c.icon="terminal-linux",t.push(c)}return t}}return[]}async function w(l,f,t,n,r,i,o){const c=new Map;if(!t){const v=await l.readFile("/etc/shells","utf8"),p=r||v.split(`
`).filter(b=>b.trim().indexOf("#")!==0&&b.trim().length>0),h=new Map;for(const b of p){let R=(0,I.basename)(b),N=h.get(R)||0;N++,N>1&&(R=`${R} (${N})`),h.set(R,N),c.set(R,{path:b,isAutoDetected:!0})}}return S(n,c),await m(c.entries(),l,f,i,o)}function S(l,f){if(!!l)for(const[t,n]of Object.entries(l))n===null||!("path"in n)&&!("source"in n)?f.delete(t):f.set(t,n)}async function d(l,f,t,n,r,i,o,c){if(f.length===0)return Promise.resolve(void 0);const v=f.shift();if(v==="")return d(l,f,t,n,r,i,o);const p={profileName:l,path:v,args:n,env:r,overrideName:i,isAutoDetected:o};if((0,I.basename)(v)===v){const b=process.env.PATH?process.env.PATH.split(I.delimiter):void 0;return await(0,A.findExecutable)(v,void 0,b,void 0,t.existsFile)?p:d(l,f,t,n)}return await t.existsFile((0,I.normalize)(v))?p:d(l,f,t,n,r,i,o)}}),define(ge[123],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var _;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(_=e.TestItemExpandState||(e.TestItemExpandState={}));const I=(D,P)=>{P.expand!==void 0&&(D.expand=P.expand),P.item!==void 0&&Object.assign(D.item,P.item)};e.applyTestItemUpdate=I;var T;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.DeltaRootsComplete=3]="DeltaRootsComplete",D[D.Retire=4]="Retire"})(T=e.TestDiffOpType||(e.TestDiffOpType={}));const A=(D,P)=>`${D}:${P.toString()}`;e.getTestSubscriptionKey=A;class y{add(P){}update(P){}remove(P,s){}complete(){}}e.IncrementalChangeCollector=y;class k{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(P){const s=this.createChangeCollector();for(const C of P)switch(C[0]){case 0:{const g=C[1];if(g.parent){if(this.items.has(g.parent)){const m=this.items.get(g.parent);m.children.add(g.item.extId);const a=this.createItem(g,m);this.items.set(g.item.extId,a),s.add(a)}}else{this.roots.add(g.item.extId);const m=this.createItem(g);this.items.set(g.item.extId,m),s.add(m)}g.expand===2&&this.updateBusyControllers(1);break}case 1:{const g=C[1],m=this.items.get(g.extId);if(!m)break;(0,e.applyTestItemUpdate)(m,g),s.update(m),g.expand!==void 0&&m.expand===2&&g.expand!==2&&this.updateBusyControllers(-1);break}case 2:{const g=this.items.get(C[1]);if(!g)break;g.parent?this.items.get(g.parent).children.delete(g.item.extId):this.roots.delete(g.item.extId);const m=[[C[1]]];for(;m.length;)for(const a of m.pop()){const u=this.items.get(a);u&&(m.push(u.children),this.items.delete(a),s.remove(u,u!==g),u.expand===2&&this.updateBusyControllers(-1))}break}case 4:this.retireTest(C[1]);break;case 3:this.updatePendingRoots(C[1]);break}s.complete()}retireTest(P){}updateBusyControllers(P){this.busyControllerCount+=P}updatePendingRoots(P){this.pendingRootCount+=P}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=k}),define(ge[213],pe([0,1,8,36,11,23,10,76,175]),function(K,e,_,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(C,g,m,a){if(this._contributedVariables=new Map,this._context=C,this._labelService=g,m)if(y.isWindows){const u=Object.create(null);this._envVariables=u,Object.keys(m).forEach(E=>{u[E.toLowerCase()]=m[E]})}else this._envVariables=m}resolveWithEnvironment(C,g,m){return this.recursiveResolve(C,g?g.uri:void 0,m)}async resolveAsync(C,g){return this.recursiveResolve(this._envVariables,C?C.uri:void 0,g)}resolve(C,g){return this.recursiveResolve(this._envVariables,C?C.uri:void 0,g)}resolveAnyBase(C,g,m,a){const u=A.deepClone(g);return y.isWindows&&u.windows?Object.keys(u.windows).forEach(E=>u[E]=u.windows[E]):y.isMacintosh&&u.osx?Object.keys(u.osx).forEach(E=>u[E]=u.osx[E]):y.isLinux&&u.linux&&Object.keys(u.linux).forEach(E=>u[E]=u.linux[E]),delete u.windows,delete u.osx,delete u.linux,this.recursiveResolve(this._envVariables,C?C.uri:void 0,u,m,a)}resolveAny(C,g,m){return this.resolveAnyBase(C,g,m)}async resolveAnyAsync(C,g,m){return this.resolveAnyBase(C,g,m)}resolveAnyMap(C,g,m){const a=new Map;return{newConfig:this.resolveAnyBase(C,g,m,a),resolvedVariables:a}}resolveWithInteractionReplace(C,g,m,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,g,m,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,g){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,g)}recursiveResolve(C,g,m,a,u){if(T.isString(m))return this.resolveString(C,g,m,a,u);if(T.isArray(m))return m.map(E=>this.recursiveResolve(C,g,E,a,u));if(T.isObject(m)){let E=Object.create(null);return Object.keys(m).forEach(w=>{const S=this.resolveString(C,g,w,a,u);E[S]=this.recursiveResolve(C,g,m[w],a,u)}),E}return m}resolveString(C,g,m,a,u){return m.replace(P.VARIABLE_REGEXP,(w,S)=>{if(S.includes(P.VARIABLE_LHS))return w;let d=this.evaluateSingleVariable(C,w,S,g,a);return u&&u.set(S,d),d})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,g,m,a,u){let E;const w=m.split(":");w.length>1&&(m=w[0],E=w[1]);const S=()=>{const f=this._context.getFilePath();if(f)return f;throw new Error((0,D.localize)(0,null,g))},d=()=>{const f=S();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,D.localize)(1,null,g,_.basename(f)))},l=()=>{if(E){const f=this._context.getFolderUri(E);if(f)return f;throw new Error((0,D.localize)(2,null,g,E))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,g)):new Error((0,D.localize)(4,null,g))};switch(m){case"env":if(E){if(C){const f=C[y.isWindows?E.toLowerCase():E];if(T.isString(f))return f}return""}throw new Error((0,D.localize)(5,null,g));case"config":if(E){const f=this._context.getConfigurationValue(a,E);if(T.isUndefinedOrNull(f))throw new Error((0,D.localize)(6,null,g,E));if(T.isObject(f))throw new Error((0,D.localize)(7,null,g,E));return f}throw new Error((0,D.localize)(8,null,g));case"command":return this.resolveFromMap(g,E,u,"command");case"input":return this.resolveFromMap(g,E,u,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(l()));case"cwd":return a||E?(0,k.normalizeDriveLetter)(this.fsPath(l())):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return _.basename(this.fsPath(l()));case"lineNumber":const f=this._context.getLineNumber();if(f)return f;throw new Error((0,D.localize)(9,null,g));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,D.localize)(10,null,g));case"file":return S();case"fileWorkspaceFolder":return d();case"relativeFile":return a||E?_.relative(this.fsPath(l()),S()):S();case"relativeFileDirname":const n=_.dirname(S());if(a||E){const c=_.relative(this.fsPath(l()),n);return c.length===0?".":c}return n;case"fileDirname":return _.dirname(S());case"fileExtname":return _.extname(S());case"fileBasename":return _.basename(S());case"fileBasenameNoExtension":const r=_.basename(S());return r.slice(0,r.length-_.extname(r).length);case"fileDirnameBasename":return _.basename(_.dirname(S()));case"execPath":const i=this._context.getExecPath();return i||g;case"execInstallFolder":const o=this._context.getAppRoot();return o||g;case"pathSeparator":return _.sep;default:try{const c=E?`${m}:${E}`:m;return this.resolveFromMap(g,c,u,void 0)}catch(c){return g}}}}resolveFromMap(C,g,m,a){if(g&&m){const u=a===void 0?m[g]:m[a+":"+g];if(typeof u=="string")return u;throw new Error((0,D.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ge[214],pe([0,1,4]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,_.createDecorator)("editorGroupsService");var I;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var T;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var y;(function(g){g[g.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var k;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(k=e.MergeGroupMode||(e.MergeGroupMode={}));var D;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(g){g[g.GROUP_ACTIVE=0]="GROUP_ACTIVE",g[g.GROUP_INDEX=1]="GROUP_INDEX",g[g.EDITOR_OPEN=2]="EDITOR_OPEN",g[g.EDITOR_CLOSE=3]="EDITOR_CLOSE",g[g.EDITOR_MOVE=4]="EDITOR_MOVE",g[g.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",g[g.EDITOR_LABEL=6]="EDITOR_LABEL",g[g.EDITOR_PIN=7]="EDITOR_PIN",g[g.EDITOR_STICKY=8]="EDITOR_STICKY",g[g.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(P=e.GroupChangeKind||(e.GroupChangeKind={}));var s;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(s=e.OpenEditorContext||(e.OpenEditorContext={}));function C(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(ge[215],pe([0,1,4]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,_.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ge[20],pe([0,1,19,98,286,58,23,11,2,44,80,176,114,89,215,7]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var E;(function(Ee){function fe(Z){const{selectionStartLineNumber:Fe,selectionStartColumn:Te,positionLineNumber:Qe,positionColumn:Ze}=Z,ct=new u.Position(Fe-1,Te-1),ht=new u.Position(Qe-1,Ze-1);return new u.Selection(ct,ht)}Ee.to=fe;function ae(Z){const{anchor:Fe,active:Te}=Z;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}Ee.from=ae})(E=e.Selection||(e.Selection={}));var w;(function(Ee){function fe(Z){if(!!Z){const{start:Fe,end:Te}=Z;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}}Ee.from=fe;function ae(Z){if(!!Z){const{startLineNumber:Fe,startColumn:Te,endLineNumber:Qe,endColumn:Ze}=Z;return new u.Range(Fe-1,Te-1,Qe-1,Ze-1)}}Ee.to=ae})(w=e.Range||(e.Range={}));var S;(function(Ee){function fe(ae){switch(ae){case 1:return u.StandardTokenType.Comment;case 0:return u.StandardTokenType.Other;case 4:return u.StandardTokenType.RegEx;case 2:return u.StandardTokenType.String}}Ee.to=fe})(S=e.TokenType||(e.TokenType={}));var d;(function(Ee){function fe(Z){return new u.Position(Z.lineNumber-1,Z.column-1)}Ee.to=fe;function ae(Z){return{lineNumber:Z.line+1,column:Z.character+1}}Ee.from=ae})(d=e.Position||(e.Position={}));var l;(function(Ee){function fe(Z){switch(Z){case u.DiagnosticTag.Unnecessary:return 1;case u.DiagnosticTag.Deprecated:return 2}}Ee.from=fe;function ae(Z){switch(Z){case 1:return u.DiagnosticTag.Unnecessary;case 2:return u.DiagnosticTag.Deprecated;default:return}}Ee.to=ae})(l=e.DiagnosticTag||(e.DiagnosticTag={}));var f;(function(Ee){function fe(Z){let Fe;return Z.code&&((0,k.isString)(Z.code)||(0,k.isNumber)(Z.code)?Fe=String(Z.code):Fe={value:String(Z.code.value),target:Z.code.target}),Object.assign(Object.assign({},w.from(Z.range)),{message:Z.message,source:Z.source,code:Fe,severity:n.from(Z.severity),relatedInformation:Z.relatedInformation&&Z.relatedInformation.map(t.from),tags:Array.isArray(Z.tags)?(0,_.coalesce)(Z.tags.map(l.from)):void 0})}Ee.from=fe;function ae(Z){var Fe;const Te=new u.Diagnostic(w.to(Z),Z.message,n.to(Z.severity));return Te.source=Z.source,Te.code=(0,k.isString)(Z.code)?Z.code:(Fe=Z.code)===null||Fe===void 0?void 0:Fe.value,Te.relatedInformation=Z.relatedInformation&&Z.relatedInformation.map(t.to),Te.tags=Z.tags&&(0,_.coalesce)(Z.tags.map(l.to)),Te}Ee.to=ae})(f=e.Diagnostic||(e.Diagnostic={}));var t;(function(Ee){function fe(Z){return Object.assign(Object.assign({},w.from(Z.location.range)),{message:Z.message,resource:Z.location.uri})}Ee.from=fe;function ae(Z){return new u.DiagnosticRelatedInformation(new u.Location(Z.resource,w.to(Z)),Z.message)}Ee.to=ae})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(Ee){function fe(Z){switch(Z){case u.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case u.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case u.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case u.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}Ee.from=fe;function ae(Z){switch(Z){case g.MarkerSeverity.Info:return u.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return u.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return u.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return u.DiagnosticSeverity.Hint;default:return u.DiagnosticSeverity.Error}}Ee.to=ae})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var r;(function(Ee){function fe(Z){return typeof Z=="number"&&Z>=u.ViewColumn.One?Z-1:Z===u.ViewColumn.Beside?a.SIDE_GROUP:a.ACTIVE_GROUP}Ee.from=fe;function ae(Z){if(typeof Z=="number"&&Z>=0)return Z+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=ae})(r=e.ViewColumn||(e.ViewColumn={}));function i(Ee){return typeof Ee.range!="undefined"}function o(Ee){return Ee.length===0?!0:!!i(Ee[0])}e.isDecorationOptionsArr=o;var c;(function(Ee){function fe(Ze){return Ze.map(Ee.from)}Ee.fromMany=fe;function ae(Ze){return Ze&&typeof Ze=="object"&&typeof Ze.language=="string"&&typeof Ze.value=="string"}function Z(Ze){let ct;if(ae(Ze)){const{language:ft,value:at}=Ze;ct={value:"```"+ft+`
`+at+"\n```\n"}}else u.MarkdownString.isMarkdownString(Ze)?ct={value:Ze.value,isTrusted:Ze.isTrusted,supportThemeIcons:Ze.supportThemeIcons}:typeof Ze=="string"?ct={value:Ze}:ct={value:""};const ht=Object.create(null);ct.uris=ht;const Xe=ft=>{try{let at=D.URI.parse(ft,!0);at=at.with({query:Fe(at.query,ht)}),ht[ft]=at}catch(at){}return""},ot=new T.Renderer;return ot.link=Xe,ot.image=ft=>Xe(I.parseHrefAndDimensions(ft).href),T(ct.value,{renderer:ot}),ct}Ee.from=Z;function Fe(Ze,ct){if(!Ze)return Ze;let ht;try{ht=(0,A.parse)(Ze)}catch(ot){}if(!ht)return Ze;let Xe=!1;return ht=(0,y.cloneAndChange)(ht,ot=>{if(D.URI.isUri(ot)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[ft]=ot,Xe=!0,ft}else return}),Xe?JSON.stringify(ht):Ze}function Te(Ze){const ct=new u.MarkdownString(Ze.value,Ze.supportThemeIcons);return ct.isTrusted=Ze.isTrusted,ct}Ee.to=Te;function Qe(Ze){if(!!Ze)return typeof Ze=="string"?Ze:Ee.from(Ze)}Ee.fromStrict=Qe})(c=e.MarkdownString||(e.MarkdownString={}));function v(Ee){return o(Ee)?Ee.map(fe=>({range:w.from(fe.range),hoverMessage:Array.isArray(fe.hoverMessage)?c.fromMany(fe.hoverMessage):fe.hoverMessage?c.from(fe.hoverMessage):void 0,renderOptions:fe.renderOptions})):Ee.map(fe=>({range:w.from(fe)}))}e.fromRangeOrRangeWithMessage=v;function p(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?D.URI.file(Ee):Ee}e.pathOrURIToURI=p;var h;(function(Ee){function fe(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?p(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}Ee.from=fe})(h=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var b;(function(Ee){function fe(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?p(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?h.from(ae.before):void 0,after:ae.after?h.from(ae.after):void 0}}Ee.from=fe})(b=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(Ee){function fe(ae){if(typeof ae=="undefined")return ae;switch(ae){case u.DecorationRangeBehavior.OpenOpen:return 0;case u.DecorationRangeBehavior.ClosedClosed:return 1;case u.DecorationRangeBehavior.OpenClosed:return 2;case u.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=fe})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var N;(function(Ee){function fe(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?R.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?b.from(ae.light):void 0,dark:ae.dark?b.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?p(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?h.from(ae.before):void 0,after:ae.after?h.from(ae.after):void 0}}Ee.from=fe})(N=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var j;(function(Ee){function fe(Z){return{text:Z.newText,eol:Z.newEol&&ie.from(Z.newEol),range:w.from(Z.range)}}Ee.from=fe;function ae(Z){const Fe=new u.TextEdit(w.to(Z.range),Z.text);return Fe.newEol=typeof Z.eol=="undefined"?void 0:ie.to(Z.eol),Fe}Ee.to=ae})(j=e.TextEdit||(e.TextEdit={}));var oe;(function(Ee){function fe(Z,Fe,Te){var Qe,Ze,ct;const ht={edits:[]};if(Z instanceof u.WorkspaceEdit)for(let Xe of Z._allEntries())if(Xe._type===1)ht.edits.push({_type:1,oldUri:Xe.from,newUri:Xe.to,options:Xe.options,metadata:Xe.metadata});else if(Xe._type===2){const ot=Fe==null?void 0:Fe.getDocument(Xe.uri);ht.edits.push({_type:2,resource:Xe.uri,edit:j.from(Xe.edit),modelVersionId:ot==null?void 0:ot.version,metadata:Xe.metadata})}else Xe._type===3?ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:(Qe=Te==null?void 0:Te.lookupNotebookDocument(Xe.uri))===null||Qe===void 0?void 0:Qe.apiNotebook.version}):Xe._type===4?(Xe.newOutputs&&ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:2,index:Xe.index,append:Xe.append,outputs:Xe.newOutputs.map(je.from)}}),Xe.newMetadata&&ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:11,index:Xe.index,metadata:Xe.newMetadata}})):Xe._type===5?ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:(Ze=Te==null?void 0:Te.lookupNotebookDocument(Xe.uri))===null||Ze===void 0?void 0:Ze.apiNotebook.version,edit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(ve.from)}}):Xe._type===6&&ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:10,outputId:Xe.outputId,items:((ct=Xe.newOutputItems)===null||ct===void 0?void 0:ct.map(ye.from))||[],append:Xe.append}});return ht}Ee.from=fe;function ae(Z){const Fe=new u.WorkspaceEdit;for(const Te of Z.edits)Te.edit?Fe.replace(D.URI.revive(Te.resource),w.to(Te.edit.range),Te.edit.text):Fe.renameFile(D.URI.revive(Te.oldUri),D.URI.revive(Te.newUri),Te.options);return Fe}Ee.to=ae})(oe=e.WorkspaceEdit||(e.WorkspaceEdit={}));var q;(function(Ee){const fe=Object.create(null);fe[u.SymbolKind.File]=0,fe[u.SymbolKind.Module]=1,fe[u.SymbolKind.Namespace]=2,fe[u.SymbolKind.Package]=3,fe[u.SymbolKind.Class]=4,fe[u.SymbolKind.Method]=5,fe[u.SymbolKind.Property]=6,fe[u.SymbolKind.Field]=7,fe[u.SymbolKind.Constructor]=8,fe[u.SymbolKind.Enum]=9,fe[u.SymbolKind.Interface]=10,fe[u.SymbolKind.Function]=11,fe[u.SymbolKind.Variable]=12,fe[u.SymbolKind.Constant]=13,fe[u.SymbolKind.String]=14,fe[u.SymbolKind.Number]=15,fe[u.SymbolKind.Boolean]=16,fe[u.SymbolKind.Array]=17,fe[u.SymbolKind.Object]=18,fe[u.SymbolKind.Key]=19,fe[u.SymbolKind.Null]=20,fe[u.SymbolKind.EnumMember]=21,fe[u.SymbolKind.Struct]=22,fe[u.SymbolKind.Event]=23,fe[u.SymbolKind.Operator]=24,fe[u.SymbolKind.TypeParameter]=25;function ae(Fe){return typeof fe[Fe]=="number"?fe[Fe]:6}Ee.from=ae;function Z(Fe){for(const Te in fe)if(fe[Te]===Fe)return Number(Te);return u.SymbolKind.Property}Ee.to=Z})(q=e.SymbolKind||(e.SymbolKind={}));var W;(function(Ee){function fe(Z){switch(Z){case u.SymbolTag.Deprecated:return 1}}Ee.from=fe;function ae(Z){switch(Z){case 1:return u.SymbolTag.Deprecated}}Ee.to=ae})(W=e.SymbolTag||(e.SymbolTag={}));var H;(function(Ee){function fe(Z){return{name:Z.name,kind:q.from(Z.kind),tags:Z.tags&&Z.tags.map(W.from),containerName:Z.containerName,location:M.from(Z.location)}}Ee.from=fe;function ae(Z){const Fe=new u.SymbolInformation(Z.name,q.to(Z.kind),Z.containerName,M.to(Z.location));return Fe.tags=Z.tags&&Z.tags.map(W.to),Fe}Ee.to=ae})(H=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var U;(function(Ee){function fe(Z){var Fe,Te;const Qe={name:Z.name||"!!MISSING: name!!",detail:Z.detail,range:w.from(Z.range),selectionRange:w.from(Z.selectionRange),kind:q.from(Z.kind),tags:(Te=(Fe=Z.tags)===null||Fe===void 0?void 0:Fe.map(W.from))!==null&&Te!==void 0?Te:[]};return Z.children&&(Qe.children=Z.children.map(fe)),Qe}Ee.from=fe;function ae(Z){const Fe=new u.DocumentSymbol(Z.name,Z.detail,q.to(Z.kind),w.to(Z.range),w.to(Z.selectionRange));return(0,_.isNonEmptyArray)(Z.tags)&&(Fe.tags=Z.tags.map(W.to)),Z.children&&(Fe.children=Z.children.map(ae)),Fe}Ee.to=ae})(U=e.DocumentSymbol||(e.DocumentSymbol={}));var L;(function(Ee){function fe(ae){const Z=new u.CallHierarchyItem(q.to(ae.kind),ae.name,ae.detail||"",D.URI.revive(ae.uri),w.to(ae.range),w.to(ae.selectionRange));return Z._sessionId=ae._sessionId,Z._itemId=ae._itemId,Z}Ee.to=fe})(L=e.CallHierarchyItem||(e.CallHierarchyItem={}));var F;(function(Ee){function fe(ae){return new u.CallHierarchyIncomingCall(L.to(ae.from),ae.fromRanges.map(Z=>w.to(Z)))}Ee.to=fe})(F=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var O;(function(Ee){function fe(ae){return new u.CallHierarchyOutgoingCall(L.to(ae.to),ae.fromRanges.map(Z=>w.to(Z)))}Ee.to=fe})(O=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var M;(function(Ee){function fe(Z){return{range:Z.range&&w.from(Z.range),uri:Z.uri}}Ee.from=fe;function ae(Z){return new u.Location(D.URI.revive(Z.uri),w.to(Z.range))}Ee.to=ae})(M=e.location||(e.location={}));var B;(function(Ee){function fe(Z){const Fe=Z,Te=Z;return{originSelectionRange:Fe.originSelectionRange?w.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Te.uri,range:w.from(Fe.targetRange?Fe.targetRange:Te.range),targetSelectionRange:Fe.targetSelectionRange?w.from(Fe.targetSelectionRange):void 0}}Ee.from=fe;function ae(Z){return{targetUri:D.URI.revive(Z.uri),targetRange:w.to(Z.range),targetSelectionRange:Z.targetSelectionRange?w.to(Z.targetSelectionRange):void 0,originSelectionRange:Z.originSelectionRange?w.to(Z.originSelectionRange):void 0}}Ee.to=ae})(B=e.DefinitionLink||(e.DefinitionLink={}));var V;(function(Ee){function fe(Z){return{range:w.from(Z.range),contents:c.fromMany(Z.contents)}}Ee.from=fe;function ae(Z){return new u.Hover(Z.contents.map(c.to),w.to(Z.range))}Ee.to=ae})(V=e.Hover||(e.Hover={}));var Q;(function(Ee){function fe(Z){return{range:w.from(Z.range),expression:Z.expression}}Ee.from=fe;function ae(Z){return new u.EvaluatableExpression(w.to(Z.range),Z.expression)}Ee.to=ae})(Q=e.EvaluatableExpression||(e.EvaluatableExpression={}));var de;(function(Ee){function fe(Z){if(Z instanceof u.InlineValueText)return{type:"text",range:w.from(Z.range),text:Z.text};if(Z instanceof u.InlineValueVariableLookup)return{type:"variable",range:w.from(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};if(Z instanceof u.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(Z.range),expression:Z.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=fe;function ae(Z){switch(Z.type){case"text":return{range:w.to(Z.range),text:Z.text};case"variable":return{range:w.to(Z.range),variableName:Z.variableName,caseSensitiveLookup:Z.caseSensitiveLookup};case"expression":return{range:w.to(Z.range),expression:Z.expression}}}Ee.to=ae})(de=e.InlineValue||(e.InlineValue={}));var we;(function(Ee){function fe(Z){return{frameId:Z.frameId,stoppedLocation:w.from(Z.stoppedLocation)}}Ee.from=fe;function ae(Z){return new u.InlineValueContext(Z.frameId,w.to(Z.stoppedLocation))}Ee.to=ae})(we=e.InlineValueContext||(e.InlineValueContext={}));var Ie;(function(Ee){function fe(Z){return{range:w.from(Z.range),kind:Z.kind}}Ee.from=fe;function ae(Z){return new u.DocumentHighlight(w.to(Z.range),Z.kind)}Ee.to=ae})(Ie=e.DocumentHighlight||(e.DocumentHighlight={}));var Ce;(function(Ee){function fe(ae){switch(ae){case 1:return u.CompletionTriggerKind.TriggerCharacter;case 2:return u.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return u.CompletionTriggerKind.Invoke}}Ee.to=fe})(Ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Le;(function(Ee){function fe(ae){return{triggerKind:Ce.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}Ee.to=fe})(Le=e.CompletionContext||(e.CompletionContext={}));var z;(function(Ee){function fe(Z){switch(Z){case u.CompletionItemTag.Deprecated:return 1}}Ee.from=fe;function ae(Z){switch(Z){case 1:return u.CompletionItemTag.Deprecated}}Ee.to=ae})(z=e.CompletionItemTag||(e.CompletionItemTag={}));var Y;(function(Ee){const fe=new Map([[u.CompletionItemKind.Method,0],[u.CompletionItemKind.Function,1],[u.CompletionItemKind.Constructor,2],[u.CompletionItemKind.Field,3],[u.CompletionItemKind.Variable,4],[u.CompletionItemKind.Class,5],[u.CompletionItemKind.Interface,7],[u.CompletionItemKind.Struct,6],[u.CompletionItemKind.Module,8],[u.CompletionItemKind.Property,9],[u.CompletionItemKind.Unit,12],[u.CompletionItemKind.Value,13],[u.CompletionItemKind.Constant,14],[u.CompletionItemKind.Enum,15],[u.CompletionItemKind.EnumMember,16],[u.CompletionItemKind.Keyword,17],[u.CompletionItemKind.Snippet,27],[u.CompletionItemKind.Text,18],[u.CompletionItemKind.Color,19],[u.CompletionItemKind.File,20],[u.CompletionItemKind.Reference,21],[u.CompletionItemKind.Folder,23],[u.CompletionItemKind.Event,10],[u.CompletionItemKind.Operator,11],[u.CompletionItemKind.TypeParameter,24],[u.CompletionItemKind.Issue,26],[u.CompletionItemKind.User,25]]);function ae(Te){var Qe;return(Qe=fe.get(Te))!==null&&Qe!==void 0?Qe:9}Ee.from=ae;const Z=new Map([[0,u.CompletionItemKind.Method],[1,u.CompletionItemKind.Function],[2,u.CompletionItemKind.Constructor],[3,u.CompletionItemKind.Field],[4,u.CompletionItemKind.Variable],[5,u.CompletionItemKind.Class],[7,u.CompletionItemKind.Interface],[6,u.CompletionItemKind.Struct],[8,u.CompletionItemKind.Module],[9,u.CompletionItemKind.Property],[12,u.CompletionItemKind.Unit],[13,u.CompletionItemKind.Value],[14,u.CompletionItemKind.Constant],[15,u.CompletionItemKind.Enum],[16,u.CompletionItemKind.EnumMember],[17,u.CompletionItemKind.Keyword],[27,u.CompletionItemKind.Snippet],[18,u.CompletionItemKind.Text],[19,u.CompletionItemKind.Color],[20,u.CompletionItemKind.File],[21,u.CompletionItemKind.Reference],[23,u.CompletionItemKind.Folder],[10,u.CompletionItemKind.Event],[11,u.CompletionItemKind.Operator],[24,u.CompletionItemKind.TypeParameter],[25,u.CompletionItemKind.User],[26,u.CompletionItemKind.Issue]]);function Fe(Te){var Qe;return(Qe=Z.get(Te))!==null&&Qe!==void 0?Qe:u.CompletionItemKind.Property}Ee.to=Fe})(Y=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(Ee){function fe(ae,Z){var Fe;const Te=new u.CompletionItem(typeof ae.label=="string"?ae.label:ae.label.name);return typeof ae.label!="string"&&(Te.label2=ae.label),Te.insertText=ae.insertText,Te.kind=Y.to(ae.kind),Te.tags=(Fe=ae.tags)===null||Fe===void 0?void 0:Fe.map(z.to),Te.detail=ae.detail,Te.documentation=I.isMarkdownString(ae.documentation)?c.to(ae.documentation):ae.documentation,Te.sortText=ae.sortText,Te.filterText=ae.filterText,Te.preselect=ae.preselect,Te.commitCharacters=ae.commitCharacters,P.Range.isIRange(ae.range)?Te.range=w.to(ae.range):typeof ae.range=="object"&&(Te.range={inserting:w.to(ae.range.insert),replacing:w.to(ae.range.replace)}),Te.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?Te.insertText=new u.SnippetString(ae.insertText):(Te.insertText=ae.insertText,Te.textEdit=Te.range instanceof u.Range?new u.TextEdit(Te.range,Te.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Te.additionalTextEdits=ae.additionalTextEdits.map(Qe=>j.to(Qe))),Te.command=Z&&ae.command?Z.fromInternal(ae.command):void 0,Te}Ee.to=fe})(ee=e.CompletionItem||(e.CompletionItem={}));var le;(function(Ee){function fe(Z){return{label:Z.label,documentation:Z.documentation?c.fromStrict(Z.documentation):void 0}}Ee.from=fe;function ae(Z){return{label:Z.label,documentation:I.isMarkdownString(Z.documentation)?c.to(Z.documentation):Z.documentation}}Ee.to=ae})(le=e.ParameterInformation||(e.ParameterInformation={}));var me;(function(Ee){function fe(Z){return{label:Z.label,documentation:Z.documentation?c.fromStrict(Z.documentation):void 0,parameters:Array.isArray(Z.parameters)?Z.parameters.map(le.from):[],activeParameter:Z.activeParameter}}Ee.from=fe;function ae(Z){return{label:Z.label,documentation:I.isMarkdownString(Z.documentation)?c.to(Z.documentation):Z.documentation,parameters:Array.isArray(Z.parameters)?Z.parameters.map(le.to):[],activeParameter:Z.activeParameter}}Ee.to=ae})(me=e.SignatureInformation||(e.SignatureInformation={}));var De;(function(Ee){function fe(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(me.from):[]}}Ee.from=fe;function ae(Z){return{activeSignature:Z.activeSignature,activeParameter:Z.activeParameter,signatures:Array.isArray(Z.signatures)?Z.signatures.map(me.to):[]}}Ee.to=ae})(De=e.SignatureHelp||(e.SignatureHelp={}));var Oe;(function(Ee){function fe(Z){var Fe;return{text:Z.text,range:w.from(Z.range),kind:be.from((Fe=Z.kind)!==null&&Fe!==void 0?Fe:u.InlineHintKind.Other),description:Z.description&&c.fromStrict(Z.description),whitespaceBefore:Z.whitespaceBefore,whitespaceAfter:Z.whitespaceAfter}}Ee.from=fe;function ae(Z){const Fe=new u.InlineHint(Z.text,w.to(Z.range),be.to(Z.kind));return Fe.whitespaceAfter=Z.whitespaceAfter,Fe.whitespaceBefore=Z.whitespaceBefore,Fe.description=I.isMarkdownString(Z.description)?c.to(Z.description):Z.description,Fe}Ee.to=ae})(Oe=e.InlineHint||(e.InlineHint={}));var be;(function(Ee){function fe(Z){return Z}Ee.from=fe;function ae(Z){return Z}Ee.to=ae})(be=e.InlineHintKind||(e.InlineHintKind={}));var Pe;(function(Ee){function fe(Z){return{range:w.from(Z.range),url:Z.target,tooltip:Z.tooltip}}Ee.from=fe;function ae(Z){let Fe;if(Z.url)try{Fe=typeof Z.url=="string"?D.URI.parse(Z.url,!0):D.URI.revive(Z.url)}catch(Te){}return new u.DocumentLink(w.to(Z.range),Fe)}Ee.to=ae})(Pe=e.DocumentLink||(e.DocumentLink={}));var Re;(function(Ee){function fe(Z){const Fe=new u.ColorPresentation(Z.label);return Z.textEdit&&(Fe.textEdit=j.to(Z.textEdit)),Z.additionalTextEdits&&(Fe.additionalTextEdits=Z.additionalTextEdits.map(Te=>j.to(Te))),Fe}Ee.to=fe;function ae(Z){return{label:Z.label,textEdit:Z.textEdit?j.from(Z.textEdit):void 0,additionalTextEdits:Z.additionalTextEdits?Z.additionalTextEdits.map(Fe=>j.from(Fe)):void 0}}Ee.from=ae})(Re=e.ColorPresentation||(e.ColorPresentation={}));var Be;(function(Ee){function fe(Z){return new u.Color(Z[0],Z[1],Z[2],Z[3])}Ee.to=fe;function ae(Z){return[Z.red,Z.green,Z.blue,Z.alpha]}Ee.from=ae})(Be=e.Color||(e.Color={}));var Se;(function(Ee){function fe(Z){return{range:w.from(Z.range)}}Ee.from=fe;function ae(Z){return new u.SelectionRange(w.to(Z.range))}Ee.to=ae})(Se=e.SelectionRange||(e.SelectionRange={}));var qe;(function(Ee){function fe(ae){switch(ae){case 2:return u.TextDocumentSaveReason.AfterDelay;case 1:return u.TextDocumentSaveReason.Manual;case 3:case 4:return u.TextDocumentSaveReason.FocusOut}}Ee.to=fe})(qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var X;(function(Ee){function fe(Z){switch(Z){case u.TextEditorLineNumbersStyle.Off:return 0;case u.TextEditorLineNumbersStyle.Relative:return 2;case u.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=fe;function ae(Z){switch(Z){case 0:return u.TextEditorLineNumbersStyle.Off;case 2:return u.TextEditorLineNumbersStyle.Relative;case 1:default:return u.TextEditorLineNumbersStyle.On}}Ee.to=ae})(X=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ie;(function(Ee){function fe(Z){if(Z===u.EndOfLine.CRLF)return 1;if(Z===u.EndOfLine.LF)return 0}Ee.from=fe;function ae(Z){if(Z===1)return u.EndOfLine.CRLF;if(Z===0)return u.EndOfLine.LF}Ee.to=ae})(ie=e.EndOfLine||(e.EndOfLine={}));var _e;(function(Ee){function fe(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case u.ProgressLocation.SourceControl:return 3;case u.ProgressLocation.Window:return 10;case u.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=fe})(_e=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(Ee){function fe(ae){const Z={start:ae.start+1,end:ae.end+1};return ae.kind&&(Z.kind=ze.from(ae.kind)),Z}Ee.from=fe})(Ne=e.FoldingRange||(e.FoldingRange={}));var ze;(function(Ee){function fe(ae){if(ae)switch(ae){case u.FoldingRangeKind.Comment:return s.FoldingRangeKind.Comment;case u.FoldingRangeKind.Imports:return s.FoldingRangeKind.Imports;case u.FoldingRangeKind.Region:return s.FoldingRangeKind.Region}}Ee.from=fe})(ze=e.FoldingRangeKind||(e.FoldingRangeKind={}));var $e;(function(Ee){function fe(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?w.from(ae.selection):void 0,override:typeof ae.override=="boolean"?C.EditorOverride.DISABLED:void 0}}Ee.from=fe})($e=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Je;(function(Ee){function fe(Z){return Z instanceof u.RelativePattern||typeof Z=="string"?Z:ae(Z)?new u.RelativePattern(Z.base,Z.pattern):Z}Ee.from=fe;function ae(Z){const Fe=Z;return Fe&&typeof Fe.base=="string"&&typeof Fe.pattern=="string"}})(Je=e.GlobPattern||(e.GlobPattern={}));var G;(function(Ee){function fe(ae){if(ae){if(Array.isArray(ae))return ae.map(fe);if(typeof ae=="string")return ae;{const Z=ae;return{language:Z.language,scheme:Z.scheme,pattern:typeof Z.pattern=="undefined"?void 0:Je.from(Z.pattern),exclusive:Z.exclusive}}}else return}Ee.from=fe})(G=e.LanguageSelector||(e.LanguageSelector={}));var re;(function(Ee){function fe(Z){return{start:Z.start,end:Z.end}}Ee.from=fe;function ae(Z){return new u.NotebookRange(Z.start,Z.end)}Ee.to=ae})(re=e.NotebookRange||(e.NotebookRange={}));var he;(function(Ee){function fe(ae){return new u.NotebookCellMetadata().with(Object.assign(Object.assign({},ae),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}Ee.to=fe})(he=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var J;(function(Ee){function fe(Z){return Z}Ee.from=fe;function ae(Z){return new u.NotebookDocumentMetadata().with(Z)}Ee.to=ae})(J=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ne;(function(Ee){function fe(Z){return{startTime:Z.runStartTime,endTime:Z.runEndTime,executionOrder:Z.executionOrder,success:Z.lastRunSuccess}}Ee.to=fe;function ae(Z){return{lastRunSuccess:Z.success,runStartTime:Z.startTime,runEndTime:Z.endTime,executionOrder:Z.executionOrder}}Ee.from=ae})(ne=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var ce;(function(Ee){function fe(Z){switch(Z){case u.NotebookCellKind.Markdown:return m.CellKind.Markdown;case u.NotebookCellKind.Code:default:return m.CellKind.Code}}Ee.from=fe;function ae(Z){switch(Z){case m.CellKind.Markdown:return u.NotebookCellKind.Markdown;case m.CellKind.Code:default:return u.NotebookCellKind.Code}}Ee.to=ae})(ce=e.NotebookCellKind||(e.NotebookCellKind={}));var ve;(function(Ee){function fe(Z){var Fe;return{cellKind:ce.from(Z.kind),language:Z.language,source:Z.source,metadata:Object.assign(Object.assign({},Z.metadata),ne.from((Fe=Z.latestExecutionSummary)!==null&&Fe!==void 0?Fe:{})),outputs:Z.outputs?Z.outputs.map(je.from):[]}}Ee.from=fe;function ae(Z){return new u.NotebookCellData(ce.to(Z.cellKind),Z.source,Z.language,Z.outputs?Z.outputs.map(je.to):void 0,Z.metadata?he.to(Z.metadata):void 0)}Ee.to=ae})(ve=e.NotebookCellData||(e.NotebookCellData={}));var ye;(function(Ee){function fe(Z){return{mime:Z.mime,value:Z.value,metadata:Z.metadata}}Ee.from=fe;function ae(Z){return new u.NotebookCellOutputItem(Z.mime,Z.value,Z.metadata)}Ee.to=ae})(ye=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var je;(function(Ee){function fe(Z){return{outputId:Z.id,outputs:Z.outputs.map(ye.from),metadata:Z.metadata}}Ee.from=fe;function ae(Z){const Fe=Z.outputs.map(ye.to);return new u.NotebookCellOutput(Fe,Z.outputId,Z.metadata)}Ee.to=ae})(je=e.NotebookCellOutput||(e.NotebookCellOutput={}));var He;(function(Ee){function fe(Te){if(Te!=null){if(Te instanceof u.RelativePattern||typeof Te=="string")return Te;if(Fe(Te))return new u.RelativePattern(Te.base,Te.pattern);if(Z(Te))return{include:Je.from(Te.include)||void 0,exclude:Je.from(Te.exclude)||void 0}}}Ee.from=fe;function ae(Te){return typeof Te=="string"?Te:Fe(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}Ee.to=ae;function Z(Te){const Qe=Te,Ze=Je.from(Qe.include);if(!(Ze&&Ze instanceof u.RelativePattern||typeof Ze=="string"))return!1;const ct=Je.from(Qe.exclude);return!!(ct&&ct instanceof u.RelativePattern||typeof ct=="string")}function Fe(Te){const Qe=Te;return Qe&&typeof Qe.base=="string"&&typeof Qe.pattern=="string"}})(He=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var We;(function(Ee){function fe(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?h.from(ae.top):void 0}}Ee.from=fe})(We=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ke;(function(Ee){function fe(ae,Z,Fe){const Te=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===u.NotebookCellStatusBarAlignment.Left?1:2,command:Z.toInternal(Te,Fe),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}Ee.from=fe})(Ke=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var nt;(function(Ee){function fe(ae){var Z,Fe;return{transientOutputs:(Z=ae==null?void 0:ae.transientOutputs)!==null&&Z!==void 0?Z:!1,transientCellMetadata:Object.assign(Object.assign({},ae==null?void 0:ae.transientCellMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0}),transientDocumentMetadata:(Fe=ae==null?void 0:ae.transientDocumentMetadata)!==null&&Fe!==void 0?Fe:{}}}Ee.from=fe})(nt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var dt;(function(Ee){function fe(Z){var Fe;return{uri:Z.uri,provides:typeof Z.provides=="string"?[Z.provides]:(Fe=Z.provides)!==null&&Fe!==void 0?Fe:[]}}Ee.from=fe;function ae(Z){return{uri:D.URI.revive(Z.uri),provides:Z.provides}}Ee.to=ae})(dt=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var it;(function(Ee){function fe(Z){return{message:c.fromStrict(Z.message)||"",severity:Z.severity,expectedOutput:Z.expectedOutput,actualOutput:Z.actualOutput,location:Z.location?M.from(Z.location):void 0}}Ee.from=fe;function ae(Z){const Fe=new u.TestMessage(typeof Z.message=="string"?Z.message:c.to(Z.message));return Fe.severity=Z.severity,Fe.actualOutput=Z.actualOutput,Fe.expectedOutput=Z.expectedOutput,Fe}Ee.to=ae})(it=e.TestMessage||(e.TestMessage={}));var Ye;(function(Ee){function fe(Te){var Qe,Ze;return{extId:Te.id,label:Te.label,uri:Te.uri,range:w.from(Te.range),debuggable:(Qe=Te.debuggable)!==null&&Qe!==void 0?Qe:!1,description:Te.description,runnable:(Ze=Te.runnable)!==null&&Ze!==void 0?Ze:!0,error:Te.error?c.fromStrict(Te.error):void 0}}Ee.from=fe;function ae(Te){return{extId:Te.id,label:Te.label,uri:Te.uri,range:w.from(Te.range),debuggable:!1,description:Te.description,error:void 0,runnable:!0}}Ee.fromResultSnapshot=ae;function Z(Te){return{id:Te.extId,label:Te.label,uri:D.URI.revive(Te.uri),range:w.to(Te.range),addChild:()=>{},dispose:()=>{},status:u.TestItemStatus.Pending,data:void 0,debuggable:Te.debuggable,description:Te.description,runnable:Te.runnable}}Ee.toPlain=Z;function Fe(Te){const Qe=new u.TestItemImpl(Te.extId,Te.label,D.URI.revive(Te.uri),void 0);return Qe.range=w.to(Te.range),Qe.debuggable=Te.debuggable,Qe.description=Te.description,Qe.runnable=Te.runnable,Qe}Ee.to=Fe})(Ye=e.TestItem||(e.TestItem={}));var mt;(function(Ee){const fe=(Z,Fe)=>Object.assign(Object.assign({},Ye.toPlain(Z.item)),{taskStates:Z.tasks.map(Te=>({state:Te.state,duration:Te.duration,messages:Te.messages.map(it.to)})),children:Z.children.map(Te=>Fe.get(Te)).filter(k.isDefined).map(Te=>fe(Te,Fe))});function ae(Z){const Fe=[],Te=new Map;for(const Qe of Z.items)Te.set(Qe.item.extId,Qe),Qe.direct&&Fe.push(Qe);return{completedAt:Z.completedAt,results:Fe.map(Qe=>fe(Qe,Te))}}Ee.to=ae})(mt=e.TestResults||(e.TestResults={}));var wt;(function(Ee){function fe(ae){switch(ae){case 1:return u.CodeActionTriggerKind.Invoke;case 2:return u.CodeActionTriggerKind.Automatic}}Ee.to=fe})(wt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ge[216],pe([0,1,2,18,7,20,56]),function(K,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(P,s,C,g={timeout:1500,errors:3}){this._logService=P,this._documents=s,this._mainThreadBulkEdits=C,this._thresholds=g,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(s,C,g)=>{const a={dispose:this._callbacks.push([s,C,P])};return Array.isArray(g)&&g.push(a),a}}async $participateInSave(P,s){const C=_.URI.revive(P);let g=!1;const m=setTimeout(()=>g=!0,this._thresholds.timeout),a=[];try{for(let u of[...this._callbacks]){if(g)break;const E=this._documents.getDocument(C),w=await this._deliverEventAsyncAndBlameBadListeners(u,{document:E,reason:A.TextDocumentSaveReason.to(s)});a.push(w)}}finally{clearTimeout(m)}return a}_deliverEventAsyncAndBlameBadListeners([P,s,C],g){const m=this._badListeners.get(P);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,P,s,g).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const u=this._badListeners.get(P);this._badListeners.set(P,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,s,C,g){const m=[],a=Date.now(),{document:u,reason:E}=g,{version:w}=u,S=Object.freeze({document:u,reason:E,waitUntil(d){if(Object.isFrozen(m))throw(0,I.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(d))}});try{s.apply(C,[S])}catch(d){return Promise.reject(d)}return Object.freeze(m),new Promise((d,l)=>{const f=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(f),d(t)}).catch(t=>{clearTimeout(f),l(t)})}).then(d=>{const l={edits:[]};for(const f of d)if(Array.isArray(f)&&f.every(t=>t instanceof T.TextEdit))for(const{newText:t,newEol:n,range:r}of f)l.edits.push({_type:2,resource:u.uri,edit:{range:r&&A.Range.from(r),text:t,eol:n&&A.EndOfLine.from(n)}});if(l.edits.length!==0)return w===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(ge[217],pe([0,1,3,15,33,2,20,7]),function(K,e,_,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(C,g,m,a,u){this._onDidCreate=new _.Emitter,this._onDidChange=new _.Emitter,this._onDidDelete=new _.Emitter,this._config=0,m&&(this._config+=1),a&&(this._config+=2),u&&(this._config+=4);const E=(0,T.parse)(g),w=C(S=>{if(!m)for(let d of S.created){const l=A.URI.revive(d);E(l.fsPath)&&this._onDidCreate.fire(l)}if(!a)for(let d of S.changed){const l=A.URI.revive(d);E(l.fsPath)&&this._onDidChange.fire(l)}if(!u)for(let d of S.deleted){const l=A.URI.revive(d);E(l.fsPath)&&this._onDidDelete.fire(l)}});this._disposable=k.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(C,g,m){this._logService=g,this._extHostDocumentsAndEditors=m,this._onFileSystemEvent=new _.Emitter,this._onDidRenameFile=new _.Emitter,this._onDidCreateFile=new _.Emitter,this._onDidDeleteFile=new _.Emitter,this._onWillRenameFile=new I.AsyncEmitter,this._onWillCreateFile=new I.AsyncEmitter,this._onWillDeleteFile=new I.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,g,m,a){return new D(this._onFileSystemEvent.event,C,g,m,a)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,g){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:g.map(m=>({oldUri:A.URI.revive(m.source),newUri:A.URI.revive(m.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:g.map(m=>A.URI.revive(m.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:g.map(m=>A.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,g){return(m,a,u)=>{const E=function(S){m.call(a,S)};return E.extension=C,g.event(E,void 0,u)}}async $onWillRunFileOperation(C,g,m,a){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:g.map(u=>({oldUri:A.URI.revive(u.source),newUri:A.URI.revive(u.target)}))},m,a);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:g.map(u=>A.URI.revive(u.target))},m,a);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:g.map(u=>A.URI.revive(u.target))},m,a)}}async _fireWillEvent(C,g,m,a){const u=new Set,E=[];if(await C.fireAsync(g,a,async(S,d)=>{var l;const f=Date.now(),t=await Promise.resolve(S);t instanceof k.WorkspaceEdit&&(E.push(t),u.add((l=d.extension.displayName)!==null&&l!==void 0?l:d.extension.identifier.value)),Date.now()-f>m&&this._logService.warn("SLOW file-participant",d.extension.identifier)}),!a.isCancellationRequested&&E.length!==0){const w={edits:[]};for(let S of E){let{edits:d}=y.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(d)}return{edit:w,extensionNames:Array.from(u)}}}}e.ExtHostFileSystemEventService=P}),define(ge[218],pe([0,1,12,23,2,20,7,89]),function(K,e,_,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(g,m,a,u){this.start=g,this.deletedCount=m,this.deletedItems=a,this.items=u}static asApiEvents(g){return g.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(a=>a.apiCell)}))}}class P{constructor(g,m,a){var u;this._notebook=g,this._extHostDocument=m,this._cellData=a,this.handle=a.handle,this.uri=T.URI.revive(a.uri),this.cellKind=a.cellKind,this._outputs=a.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=(u=a.metadata)!==null&&u!==void 0?u:{},this._metadata=A.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=A.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(g,m){return{EOL:m.eol,lines:m.source,modeId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:g}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._cell){const g=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return g._notebook.getCellIndex(g)},notebook:g._notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get outputs(){return g._outputs.slice(0)},get metadata(){return g._metadata},get latestExecutionSummary(){return g._previousResult}})}return this._cell}setOutputs(g){this._outputs=g.map(A.NotebookCellOutput.to)}setOutputItems(g,m,a){const u=a.map(A.NotebookCellOutputItem.to),E=this._outputs.find(w=>w.id===g);E&&(m||(E.outputs.length=0),E.outputs.push(...u))}setMetadata(g){this._internalMetadata=g,this._metadata=A.NotebookCellMetadata.to(g),this._previousResult=A.NotebookCellPreviousExecutionResult.to(g)}}e.ExtHostCell=P;class s{constructor(g,m,a,u,E,w,S){this._proxy=g,this._textDocumentsAndEditors=m,this._textDocuments=a,this._emitter=u,this._viewType=E,this._metadata=w,this.uri=S,this.handle=s._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const g=this;this._notebook={get uri(){return g.uri},get version(){return g._versionId},get viewType(){return g._viewType},get isDirty(){return g._isDirty},get isUntitled(){return g.uri.scheme===_.Schemas.untitled},get isClosed(){return g._disposed},get metadata(){return g._metadata},get cellCount(){return g._cells.length},cellAt(m){return m=g._validateIndex(m),g._cells[m].apiCell},getCells(m){return(m?g._getCells(m):g._cells).map(u=>u.apiCell)},save(){return g._save()}}}return this._notebook}updateBackup(g){var m;(m=this._backup)===null||m===void 0||m.delete(),this._backup=g}disposeBackup(){var g;(g=this._backup)===null||g===void 0||g.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(g){g.metadata&&(this._metadata=this._metadata.with(g.metadata))}acceptModelChanged(g,m){this._versionId=g.versionId,this._isDirty=m;for(const a of g.rawEvents)a.kind===k.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(a.changes,!0),a.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1):a.kind===k.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx):a.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(a.index,a.outputs):a.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems):a.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(a.index,a.language):a.kind===k.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(a.index,a.metadata)}_validateIndex(g){return g<0?0:g>=this._cells.length?this._cells.length-1:g}_validateRange(g){return g.start<0&&(g=g.with({start:0})),g.end>this._cells.length&&(g=g.with({end:this._cells.length})),g}_getCells(g){g=this._validateRange(g);const m=[];for(let a=g.start;a<g.end;a++)m.push(this._cells[a]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(g,m){if(!this._disposed){const a=[],u=[],E=[];g.reverse().forEach(w=>{const d=w[2].map(t=>{const n=new P(this,this._textDocumentsAndEditors,t);return m||u.push(P.asModelAddData(this.apiNotebook,t)),n}),l=new D(w[0],w[1],[],d),f=this._cells.splice(w[0],w[1],...d);for(let t of f)E.push(t.uri),l.deletedItems.push(t.apiCell);a.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:E}),m||this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(a)}))}}_moveCell(g,m){const a=this._cells.splice(g,1);this._cells.splice(m,0,...a);const u=[new D(g,1,a.map(E=>E.apiCell),[]),new D(m,0,[],a)];this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(u)}))}_setCellOutputs(g,m){const a=this._cells[g];a.setOutputs(m),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[a.apiCell]}))}_setCellOutputItems(g,m,a,u){const E=this._cells[g];E.setOutputItems(m,a,u),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[E.apiCell]}))}_changeCellLanguage(g,m){const a=this._cells[g];a.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(a.uri,m)}_changeCellMetadata(g,m){var a;const u=this._cells[g],E=u.internalMetadata,w=u.apiCell.metadata;u.setMetadata(m);const S=u.apiCell.metadata;if((0,I.equals)(w,S)||this._emitter.emitCellMetadataChange((0,I.deepFreeze)({document:this.apiNotebook,cell:u.apiCell})),E.runState!==m.runState){const d=(a=m.runState)!==null&&a!==void 0?a:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,I.deepFreeze)({document:this.apiNotebook,cell:u.apiCell,executionState:d}))}}getCellFromIndex(g){return this._cells[g]}getCell(g){return this._cells.find(m=>m.handle===g)}getCellIndex(g){return this._cells.indexOf(g)}}e.ExtHostNotebookDocument=s,s._handlePool=0}),define(ge[219],pe([0,1,7,20]),function(K,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(k){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=k}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(k){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:k})}replaceCellMetadata(k,D){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:k,metadata:D})}replaceCells(k,D,P){this._throwIfFinalized(),!(k===D&&P.length===0)&&this._collectedEdits.push({editType:1,index:k,count:D-k,cells:P.map(I.NotebookCellData.from)})}}class A{constructor(k,D,P,s,C,g){this.id=k,this._proxy=D,this.notebookData=P,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=C,this._visibleRanges=s,this._viewColumn=g}get apiEditor(){if(!this._editor){const k=this;this._editor={get document(){return k.notebookData.apiNotebook},get selections(){return k._selections},get visibleRanges(){return k._visibleRanges},revealRange(D,P){k._proxy.$tryRevealRange(k.id,I.NotebookRange.from(D),P!=null?P:_.NotebookEditorRevealType.Default)},get viewColumn(){return k._viewColumn},edit(D){const P=new T(this.document.version);return D(P),k._applyEdit(P.finalize())},setDecorations(D,P){return k.setDecorations(D,P)}}}return this._editor}get visible(){return this._visible}_acceptVisibility(k){this._visible=k}_acceptVisibleRanges(k){this._visibleRanges=k}_acceptSelections(k){this._selections=k}_acceptViewColumn(k){this._viewColumn=k}_applyEdit(k){if(k.cellEdits.length===0)return Promise.resolve(!0);const D=[];let P=-1;for(let s=0;s<k.cellEdits.length;s++){if(P<0){D.push(k.cellEdits[s]),P++;continue}const g=D[P],m=k.cellEdits[s];if(g.editType===1&&m.editType===1&&g.index===m.index){g.cells.push(...k.cellEdits[s].cells),g.count+=k.cellEdits[s].count;continue}D.push(k.cellEdits[s]),P++}return this._proxy.$tryApplyEdits(this.id,k.documentVersionId,D)}setDecorations(k,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(k.key)))return D.isEmpty?this._hasDecorationsForKey.delete(k.key):this._hasDecorationsForKey.add(k.key),this._proxy.$trySetDecorations(this.id,I.NotebookRange.from(D),k.key)}}e.ExtHostNotebookEditor=A}),define(ge[220],pe([0,1,20,115,163,21,70]),function(K,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class k{constructor(C){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=C}withProgress(C,g,m){const a=this._handles++,{title:u,location:E,cancellable:w}=g,S={label:(0,T.localize)(0,null,C.displayName||C.name),id:C.identifier.value};return this._proxy.$startProgress(a,{location:_.ProgressLocation.from(E),title:u,source:S,cancellable:w},C),this._withProgress(a,m,!!w)}_withProgress(C,g,m){let a;m&&(a=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(C,a));const u=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),a&&a.dispose()};let E;try{E=g(new P(this._proxy,C),m&&a?a.token:A.CancellationToken.None)}catch(w){throw u(C),w}return E.then(w=>u(C),w=>u(C)),E}$acceptProgressCanceled(C){const g=this._mapHandleToCancellationSource.get(C);g&&(g.cancel(),this._mapHandleToCancellationSource.delete(C))}}e.ExtHostProgress=k;function D(s,C){return s.message=C.message,typeof C.increment=="number"&&(typeof s.increment=="number"?s.increment+=C.increment:s.increment=C.increment),s}class P extends I.Progress{constructor(C,g){super(m=>this.throttledReport(m));this._proxy=C,this._handle=g}throttledReport(C){this._proxy.$progressReport(this._handle,C)}}Ve([(0,y.throttle)(100,(s,C)=>D(s,C),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(ge[124],pe([0,1,52,18,72,20,7]),function(K,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(g,m){const a=k._Keys.nextId();g.$registerTextEditorDecorationType(a,A.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:a,dispose(){g.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=k,k._Keys=new T.IdGenerator("TextEditorDecorationType");class D{constructor(g,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=g,this._documentVersionId=g.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(g,m){this._throwIfFinalized();let a=null;if(g instanceof y.Position)a=new y.Range(g,g);else if(g instanceof y.Range)a=g;else throw new Error("Unrecognized location");this._pushEdit(a,m,!1)}insert(g,m){this._throwIfFinalized(),this._pushEdit(new y.Range(g,g),m,!0)}delete(g){this._throwIfFinalized();let m=null;if(g instanceof y.Range)m=g;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(g,m,a){const u=this._document.validateRange(g);this._collectedEdits.push({range:u,text:m,forceMoveMarkers:a})}setEndOfLine(g){if(this._throwIfFinalized(),g!==y.EndOfLine.LF&&g!==y.EndOfLine.CRLF)throw(0,I.illegalArgument)("endOfLine");this._setEndOfLine=g}}e.TextEditorEdit=D;class P{constructor(g,m,a,u){this._proxy=g,this._id=m,this._accept(a),this._logService=u;const E=this;this.value={get tabSize(){return E._tabSize},set tabSize(w){E._setTabSize(w)},get insertSpaces(){return E._insertSpaces},set insertSpaces(w){E._setInsertSpaces(w)},get cursorStyle(){return E._cursorStyle},set cursorStyle(w){E._setCursorStyle(w)},get lineNumbers(){return E._lineNumbers},set lineNumbers(w){E._setLineNumbers(w)}}}_accept(g){this._tabSize=g.tabSize,this._insertSpaces=g.insertSpaces,this._cursorStyle=g.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(g.lineNumbers)}_validateTabSize(g){if(g==="auto")return"auto";if(typeof g=="number"){const m=Math.floor(g);return m>0?m:null}if(typeof g=="string"){const m=parseInt(g,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(g){const m=this._validateTabSize(g);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(g){return g==="auto"?"auto":g==="false"?!1:Boolean(g)}_setInsertSpaces(g){const m=this._validateInsertSpaces(g);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(g){this._cursorStyle!==g&&(this._cursorStyle=g,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:g})))}_setLineNumbers(g){this._lineNumbers!==g&&(this._lineNumbers=g,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(g)})))}assign(g){const m={};let a=!1;if(typeof g.tabSize!="undefined"){const u=this._validateTabSize(g.tabSize);u==="auto"?(a=!0,m.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,a=!0,m.tabSize=u)}if(typeof g.insertSpaces!="undefined"){const u=this._validateInsertSpaces(g.insertSpaces);u==="auto"?(a=!0,m.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,a=!0,m.insertSpaces=u)}typeof g.cursorStyle!="undefined"&&this._cursorStyle!==g.cursorStyle&&(this._cursorStyle=g.cursorStyle,a=!0,m.cursorStyle=g.cursorStyle),typeof g.lineNumbers!="undefined"&&this._lineNumbers!==g.lineNumbers&&(this._lineNumbers=g.lineNumbers,a=!0,m.lineNumbers=A.TextEditorLineNumbersStyle.from(g.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(g){g.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=P;class s{constructor(g,m,a,u,E,w,S,d){this.id=g,this._proxy=m,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=E,this._options=new P(this._proxy,this.id,w,a),this._visibleRanges=S,this._viewColumn=d;const l=this;this.value=Object.freeze({get document(){return u.getValue()},set document(f){throw(0,I.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(f){if(!(f instanceof y.Selection))throw(0,I.illegalArgument)("selection");l._selections=[f],l._trySetSelection()},get selections(){return l._selections},set selections(f){if(!Array.isArray(f)||f.some(t=>!(t instanceof y.Selection)))throw(0,I.illegalArgument)("selections");l._selections=f,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(f){throw(0,I.readonly)("visibleRanges")},get options(){return l._options.value},set options(f){l._disposed||l._options.assign(f)},get viewColumn(){return l._viewColumn},set viewColumn(f){throw(0,I.readonly)("viewColumn")},edit(f,t={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new D(u.getValue(),t);return f(n),l._applyEdit(n)},insertSnippet(f,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=l._selections.map(i=>A.Range.from(i));else if(t instanceof y.Position){const{lineNumber:i,column:o}=A.Position.from(t);r=[{startLineNumber:i,startColumn:o,endLineNumber:i,endColumn:o}]}else if(t instanceof y.Range)r=[A.Range.from(t)];else{r=[];for(const i of t)if(i instanceof y.Range)r.push(A.Range.from(i));else{const{lineNumber:o,column:c}=A.Position.from(i);r.push({startLineNumber:o,startColumn:c,endLineNumber:o,endColumn:c})}}return m.$tryInsertSnippet(g,f.value,r,n)},setDecorations(f,t){const n=t.length===0;n&&!l._hasDecorationsForKey.has(f.key)||(n?l._hasDecorationsForKey.delete(f.key):l._hasDecorationsForKey.add(f.key),l._runOnProxy(()=>{if(A.isDecorationOptionsArr(t))return m.$trySetDecorations(g,f.key,A.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let i=0,o=t.length;i<o;i++){const c=t[i];r[4*i]=c.start.line+1,r[4*i+1]=c.start.character+1,r[4*i+2]=c.end.line+1,r[4*i+3]=c.end.character+1}return m.$trySetDecorationsFast(g,f.key,r)}}))},revealRange(f,t){l._runOnProxy(()=>m.$tryRevealRange(g,A.Range.from(f),t||y.TextEditorRevealType.Default))},show(f){m.$tryShowEditor(g,A.ViewColumn.from(f))},hide(){m.$tryHideEditor(g)}})}dispose(){(0,_.ok)(!this._disposed),this._disposed=!0}_acceptOptions(g){(0,_.ok)(!this._disposed),this._options._accept(g)}_acceptVisibleRanges(g){(0,_.ok)(!this._disposed),this._visibleRanges=g}_acceptViewColumn(g){(0,_.ok)(!this._disposed),this._viewColumn=g}_acceptSelections(g){(0,_.ok)(!this._disposed),this._selections=g}async _trySetSelection(){const g=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,g)),this.value}_applyEdit(g){const m=g.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const a=m.edits.map(E=>E.range);a.sort((E,w)=>E.end.line===w.end.line?E.end.character===w.end.character?E.start.line===w.start.line?E.start.character-w.start.character:E.start.line-w.start.line:E.end.character-w.end.character:E.end.line-w.end.line);for(let E=0,w=a.length-1;E<w;E++){const S=a[E].end;if(a[E+1].start.isBefore(S))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=m.edits.map(E=>({range:A.Range.from(E.range),text:E.text,forceMoveMarkers:E.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,u,{setEndOfLine:typeof m.setEndOfLine=="number"?A.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(g){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):g().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=s}),define(ge[221],pe([0,1,166,25,2,3,6,15,7,11,19,20,21]),function(K,e,_,I,T,A,y,k,D,P,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function m(E,w){if((0,P.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let S;return Array.isArray(E.highlights)&&(S=E.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),S=S.length?S:void 0),{label:E.label,highlights:S}}}class a{constructor(w,S,d){this._proxy=w,this.commands=S,this.logService=d,this.treeViews=new Map;function l(f){return f&&f.$treeViewId&&f.$treeItemHandle}S.registerArgumentProcessor({processArgument:f=>l(f)?this.convertArgument(f):Array.isArray(f)&&f.length>0?f.map(t=>l(t)?this.convertArgument(t):t):f})}registerTreeDataProvider(w,S,d){const l=this.createTreeView(w,{treeDataProvider:S},d);return{dispose:()=>l.dispose()}}createTreeView(w,S,d){if(!S||!S.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const l=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!S.showCollapseAll,canSelectMany:!!S.canSelectMany}),f=this.createExtHostTreeView(w,S,d);return{get onDidCollapseElement(){return f.onDidCollapseElement},get onDidExpandElement(){return f.onDidExpandElement},get selection(){return f.selectedElements},get onDidChangeSelection(){return f.onDidChangeSelection},get visible(){return f.visible},get onDidChangeVisibility(){return f.onDidChangeVisibility},get message(){return f.message},set message(t){f.message=t},get title(){return f.title},set title(t){f.title=t},get description(){return f.description},set description(t){f.description=t},reveal:(t,n)=>f.reveal(t,n),dispose:async()=>{await l,this.treeViews.delete(w),f.dispose()}}}$getChildren(w,S){const d=this.treeViews.get(w);return d?d.getChildren(S):Promise.reject(new Error((0,_.localize)(0,null,w)))}async $hasResolve(w){const S=this.treeViews.get(w);if(!S)throw new Error((0,_.localize)(1,null,w));return S.hasResolve}$resolve(w,S,d){const l=this.treeViews.get(w);if(!l)throw new Error((0,_.localize)(2,null,w));return l.resolveTreeItem(S,d)}$setExpanded(w,S,d){const l=this.treeViews.get(w);if(!l)throw new Error((0,_.localize)(3,null,w));l.setExpanded(S,d)}$setSelection(w,S){const d=this.treeViews.get(w);if(!d)throw new Error((0,_.localize)(4,null,w));d.setSelection(S)}$setVisible(w,S){const d=this.treeViews.get(w);if(!d)throw new Error((0,_.localize)(5,null,w));d.setVisible(S)}createExtHostTreeView(w,S,d){const l=new u(w,S,this._proxy,this.commands.converter,this.logService,d);return this.treeViews.set(w,l),l}convertArgument(w){const S=this.treeViews.get(w.$treeViewId);return S?S.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=a;class u extends y.Disposable{constructor(w,S,d,l,f,t){super();if(this.viewId=w,this.proxy=d,this.commands=l,this.logService=f,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new g.CancellationTokenSource,t.contributes&&t.contributes.views)for(const i in t.contributes.views)for(const o of t.contributes.views[i])o.id===w&&(this._title=o.name);this.dataProvider=S.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(i=>this._onDidChangeData.fire({message:!1,element:i})));let n,r;this._register(A.Event.debounce(this._onDidChangeData.event,(i,o)=>(i||(i={message:!1,elements:[]}),o.element!==!1&&(n||(n=new Promise(c=>r=c),this.refreshPromise=this.refreshPromise.then(()=>n)),i.elements.push(o.element)),o.message&&(i.message=!0),i),200,!0)(({message:i,elements:o})=>{o.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const c=r;return n=null,this.refresh(o).then(()=>c())})),i&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!(0,P.isUndefinedOrNull)(w))}getChildren(w){const S=w?this.getExtensionElement(w):void 0;if(w&&!S)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);const d=this.getChildrenNodes(w);return(d?Promise.resolve(d):this.fetchChildrenNodes(S)).then(l=>l.map(f=>f.item))}getExtensionElement(w){return this.elements.get(w)}reveal(w,S){S=S||{select:!0,focus:!1};const d=(0,P.isUndefinedOrNull)(S.select)?!0:S.select,l=(0,P.isUndefinedOrNull)(S.focus)?!1:S.focus,f=(0,P.isUndefinedOrNull)(S.expand)?!1:S.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(t=>this.resolveTreeNode(w,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(r=>r.item)},{select:d,focus:l,expand:f})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:d,focus:l,expand:f})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,S){const d=this.getExtensionElement(w);d&&(S?this._onDidExpandElement.fire(Object.freeze({element:d})):this._onDidCollapseElement.fire(Object.freeze({element:d})))}setSelection(w){(0,s.equals)(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,S){var d;if(!!this.dataProvider.resolveTreeItem){const l=this.elements.get(w);if(l){const f=this.nodes.get(l);if(f){const t=(d=await this.dataProvider.resolveTreeItem(f.extensionItem,l,S))!==null&&d!==void 0?d:f.extensionItem;return f.item.tooltip=this.getTooltip(t.tooltip),f.item.command=this.getCommand(f.disposableStore,t.command),f.item}}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(S=>S?this.resolveUnknownParentChain(S).then(d=>this.resolveTreeNode(S,d[d.length-1]).then(l=>(d.push(l),d))):Promise.resolve([]))}resolveParent(w){const S=this.nodes.get(w);return S?Promise.resolve(S.parent?this.elements.get(S.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,S){const d=this.nodes.get(w);return d?Promise.resolve(d):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(l=>this.createHandle(w,l,S,!0)).then(l=>this.getChildren(S?S.item.handle:void 0).then(()=>{const f=this.getExtensionElement(l);if(f){const t=this.nodes.get(f);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${l}`)}))}getChildrenNodes(w){if(w){let S;if(typeof w=="string"){const d=this.getExtensionElement(w);S=d?this.nodes.get(d):void 0}else S=w;return S&&S.children||null}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const S=new g.CancellationTokenSource(this._refreshCancellationSource.token);try{const d=w?this.nodes.get(w):void 0,l=await this.dataProvider.getChildren(w);if(S.token.isCancellationRequested)return[];const f=await Promise.all((0,s.coalesce)(l||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!S.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,d):null}));return S.token.isCancellationRequested?[]:(0,s.coalesce)(f)}finally{S.dispose()}}refresh(w){if(w.some(d=>!d))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new g.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const d=this.getHandlesToRefresh(w);if(d.length)return this.refreshHandles(d)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const S=new Set,d=w.map(f=>this.nodes.get(f));for(const f of d)if(f&&!S.has(f.item.handle)){let t=f;for(;t&&t.parent&&d.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&S.add(f.item.handle)}const l=[];return S.forEach(f=>{const t=this.elements.get(f);if(t){const n=this.nodes.get(t);n&&(!n.parent||!S.has(n.parent.item.handle))&&l.push(f)}}),l}refreshHandles(w){const S={};return Promise.all(w.map(d=>this.refreshNode(d).then(l=>{l&&(S[d]=l.item)}))).then(()=>Object.keys(S).length?this.proxy.$refresh(this.viewId,S):void 0)}refreshNode(w){const S=this.getExtensionElement(w);if(S){const d=this.nodes.get(S);if(d)return this.clearChildren(S),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(S)).then(l=>{if(l){const f=this.createTreeNode(S,l,d.parent);return this.updateNodeCache(S,f,d,d.parent),d.dispose(),f}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,S,d){const l=this.createTreeNode(w,S,d);if(S.id&&this.elements.has(l.item.handle))throw new Error((0,_.localize)(6,null,S.id));return this.addNodeToCache(w,l),this.addNodeToParentCache(l,d),l}getTooltip(w){return D.MarkdownString.isMarkdownString(w)?C.MarkdownString.from(w):w}getCommand(w,S){return S?this.commands.toInternal(S,w):void 0}createTreeNode(w,S,d){const l=new y.DisposableStore,f=this.createHandle(w,S,d),t=this.getLightIconPath(S);return{item:{handle:f,parentHandle:d?d.item.handle:void 0,label:m(S.label,this.extension),description:S.description,resourceUri:S.resourceUri,tooltip:this.getTooltip(S.tooltip),command:this.getCommand(l,S.command),contextValue:S.contextValue,icon:t,iconDark:this.getDarkIconPath(S)||t,themeIcon:this.getThemeIcon(S),collapsibleState:(0,P.isUndefinedOrNull)(S.collapsibleState)?D.TreeItemCollapsibleState.None:S.collapsibleState,accessibilityInformation:S.accessibilityInformation},extensionItem:S,parent:d,children:void 0,disposableStore:l,dispose(){l.dispose()}}}getThemeIcon(w){return w.iconPath instanceof D.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:S,label:d,resourceUri:l},f,t){if(S)return`${u.ID_HANDLE_PREFIX}/${S}`;const n=m(d,this.extension),r=f?f.item.handle:u.LABEL_HANDLE_PREFIX;let i=n?n.label:l?(0,I.basename)(l):"";i=i.indexOf("/")!==-1?i.replace("/","//"):i;const o=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,c=this.getChildrenNodes(f)||[];let v,p=0;do{if(v=`${r}/${p}:${i}`,t||!this.elements.has(v)||o===v)break;p++}while(p<=c.length);return v}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon))return typeof w.iconPath=="string"||T.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return T.URI.isUri(w)?w:T.URI.file(w)}addNodeToCache(w,S){this.elements.set(S.item.handle,w),this.nodes.set(w,S)}updateNodeCache(w,S,d,l){this.elements.delete(S.item.handle),this.nodes.delete(w),S.item.handle!==d.item.handle&&this.elements.delete(d.item.handle),this.addNodeToCache(w,S);const f=this.getChildrenNodes(l)||[],t=f.filter(n=>n.item.handle===d.item.handle)[0];t&&f.splice(f.indexOf(t),1,S)}addNodeToParentCache(w,S){S?(S.children||(S.children=[]),S.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const S=this.nodes.get(w);if(S){if(S.children)for(const d of S.children){const l=this.elements.get(d.item.handle);l&&this.clear(l)}S.children=void 0}}else this.clearAll()}clear(w){const S=this.nodes.get(w);if(S){if(S.children)for(const d of S.children){const l=this.elements.get(d.item.handle);l&&this.clear(l)}this.nodes.delete(w),this.elements.delete(S.item.handle),S.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}u.LABEL_HANDLE_PREFIX="0",u.ID_HANDLE_PREFIX="1"}),define(ge[222],pe([0,1,19,15,21,11,87,20,7,123]),function(K,e,_,I,T,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class s{constructor(){this.testIdsToInternal=new Map}getTestById(E,w){if(w!==void 0){const S=this.testIdsToInternal.get(w),d=S==null?void 0:S.get(E);if(d)return[S,d]}return(0,_.mapFind)(this.testIdsToInternal.values(),S=>{const d=S.get(E);return d&&[S,d]})}createForHierarchy(E=()=>{}){return new a(this.createIdMap(g++),E)}createIdMap(E){const w=new m(E);return this.testIdsToInternal.set(w.id,w),{object:w,dispose:()=>this.testIdsToInternal.delete(w.id)}}}e.OwnedTestCollection=s;var C;(function(u){u[u.Disconnected=0]="Disconnected",u[u.IsChild=1]="IsChild",u[u.IsParent=2]="IsParent",u[u.IsSame=3]="IsSame"})(C=e.TestPosition||(e.TestPosition={}));let g=0;class m{constructor(E){this.id=E,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(E){if(this.map.has(E.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${E.item.extId}`);this.map.set(E.item.extId,E),E.parent||this._roots.add(E)}has(E){return this.map.has(E)}delete(E){const w=this.map.get(E);return w?(this.map.delete(E),this._roots.delete(w),!0):!1}get(E){return this.map.get(E)}comparePositions(E,w){const S=typeof E=="string"?this.map.get(E):E,d=typeof w=="string"?this.map.get(w):w;if(!S||!d)return 0;if(S===d)return 3;for(let l=this.map.get(d.parent);l;l=this.map.get(l.parent))if(l===S)return 1;for(let l=this.map.get(S.parent);l;l=this.map.get(l.parent))if(l===d)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=m;class a{constructor(E,w){this.testIdToInternal=E,this.publishDiff=w,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new I.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(E,w){this.addItem(E,w,null)}getTestByReference(E){return this.testItemToInternal.get(E)}collectDiff(){const E=this.diff;return this.diff=[],E}pushDiff(E){const w=this.diff[this.diff.length-1];if(w&&E[0]===1){if(w[0]===1&&w[1].extId===E[1].extId){(0,P.applyTestItemUpdate)(w[1],E[1]);return}if(w[0]===0&&w[1].item.extId===E[1].extId){(0,P.applyTestItemUpdate)(w[1],E[1]);return}}this.diff.push(E),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(E,w){var S;const d=this.testIdToInternal.object.get(E);if(!!d){if((d.expandLevels===void 0||w>d.expandLevels)&&(d.expandLevels=w),d.expand===1){const l=this.refreshChildren(d);return l.isSettled?this.expandChildren(d,w-1):l.p.then(()=>this.expandChildren(d,w-1))}else if(d.expand===3)return((S=d.initialExpand)===null||S===void 0?void 0:S.isSettled)===!1?d.initialExpand.p.then(()=>this.expandChildren(d,w-1)):this.expandChildren(d,w-1)}}dispose(){var E;for(const w of this.testItemToInternal.values())(E=w.discoverCts)===null||E===void 0||E.dispose(!0),(0,y.getPrivateApiFor)(w.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(E,w){const S=E==null?void 0:E.actual.id;switch(w[0]){case 2:this.pushDiff([4,S]);break;case 1:this.removeItem(E);break;case 0:this.addItem(w[1],E.src.controller,E);break;case 3:const[d,l,f]=w;switch(l){case"status":this.updateExpandability(E);break;case"range":this.pushDiff([1,{extId:S,item:{range:k.Range.from(f)}}]);break;default:this.pushDiff([1,{extId:S,item:{[l]:f}}]);break}break;default:(0,A.assertNever)(w[0])}}addItem(E,w,S){if(!(E instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${E.id} did not`);if(this.testItemToInternal.has(E))throw new Error(`Attempted to add a single TestItem ${E.id} multiple times to the tree`);if(this.testIdToInternal.object.has(E.id))throw new Error(`Attempted to insert a duplicate test item ID ${E.id}`);const d=S?S.item.extId:null,l=E.resolveHandler?1:0,f=S==null?void 0:S.expandLevels,t={controller:w,tree:this.testIdToInternal.object.id},n={actual:E,parent:d,item:k.TestItem.from(E),expandLevels:f?f-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(E,n),this.pushDiff([0,{parent:d,src:t,expand:l,item:n.item}]);const r=(0,y.getPrivateApiFor)(E);r.parent=S==null?void 0:S.actual,r.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const i of r.children.values())this.testItemToInternal.has(i)||this.addItem(i,w,n)}updateExpandability(E){var w;let S;E.actual.resolveHandler?E.actual.status===D.TestItemStatus.Pending?S=E.discoverCts?2:1:((w=E.initialExpand)===null||w===void 0||w.complete(),S=3):S=0,S!==E.expand&&(E.expand=S,this.pushDiff([1,{extId:E.actual.id,expand:S}]),S===1&&E.expandLevels!==void 0&&this.refreshChildren(E))}expandChildren(E,w){if(!(w<0)){const S=[...E.actual.children.values()].map(d=>this.expand(d.id,w)).filter(I.isThenable);if(S.length)return Promise.all(S).then(()=>{})}}refreshChildren(E){if(E.discoverCts&&E.discoverCts.dispose(!0),!E.actual.resolveHandler){const w=new I.DeferredPromise;return w.complete(),w}return E.expand=2,E.discoverCts=new T.CancellationTokenSource,this.pushExpandStateUpdate(E),E.initialExpand=new I.DeferredPromise,E.actual.resolveHandler(E.discoverCts.token),E.initialExpand}pushExpandStateUpdate(E){this.pushDiff([1,{extId:E.actual.id,expand:E.expand}])}removeItem(E){var w;this.pushDiff([2,E.actual.id]);const S=[E];for(;S.length;){const d=S.pop();if(!!d){(w=d.discoverCts)===null||w===void 0||w.dispose(!0),this.testIdToInternal.object.delete(d.item.extId),this.testItemToInternal.delete(d.actual);for(const l of d.actual.children.values())S.push(this.testIdToInternal.object.get(l.id))}}}flushDiff(){const E=this.collectDiff();E.length&&this.publishDiff(E)}}e.SingleUseTestCollection=a}),define(ge[223],pe([0,1,28,3,8]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(s){this.removedDueToLooping=s}}e.DeltaExtensionsResult=A;class y{constructor(s){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=s,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const s of this._extensionDescriptions){if(this._extensionsMap.has(_.ExtensionIdentifier.toKey(s.identifier))){console.error("Extension `"+s.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(_.ExtensionIdentifier.toKey(s.identifier),s),this._extensionsArr.push(s),Array.isArray(s.activationEvents))for(let C of s.activationEvents)C==="onUri"&&(C=`onUri:${_.ExtensionIdentifier.toKey(s.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(s)}}keepOnly(s){const C=new Set;s.forEach(g=>C.add(_.ExtensionIdentifier.toKey(g))),this._extensionDescriptions=this._extensionDescriptions.filter(g=>C.has(_.ExtensionIdentifier.toKey(g.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(s,C){s.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(s));const g=y._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(g.map(m=>m.identifier)),C.length>0){const m=new Set;C.forEach(a=>m.add(_.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!m.has(_.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(g)}static _findLoopingExtensions(s){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(E){this._nodesSet.has(E)||(this._nodesSet.add(E),this._nodesArr.push(E))}addArc(E,w){this.addNode(E),this.addNode(w),this._arcs.has(E)?this._arcs.get(E).push(w):this._arcs.set(E,[w])}getArcs(E){return this._arcs.has(E)?this._arcs.get(E):[]}hasOnlyGoodArcs(E,w){const S=C.getArcs(E);for(let d=0;d<S.length;d++)if(!w.has(S[d]))return!1;return!0}getNodes(){return this._nodesArr}};let g=new Map;for(let E of s){const w=_.ExtensionIdentifier.toKey(E.identifier);if(g.set(w,E),E.extensionDependencies)for(let S of E.extensionDependencies){const d=_.ExtensionIdentifier.toKey(S);C.addArc(w,d)}}let m=new Set;C.getNodes().filter(E=>C.getArcs(E).length===0).forEach(E=>m.add(E));let a=C.getNodes().filter(E=>!m.has(E)),u;do{u=!1;for(let E=0;E<a.length;E++){const w=a[E];C.hasOnlyGoodArcs(w,m)&&(a.splice(E,1),E--,m.add(w),u=!0)}}while(u);return a.map(E=>g.get(E))}containsActivationEvent(s){return this._activationMap.has(s)}containsExtension(s){return this._extensionsMap.has(_.ExtensionIdentifier.toKey(s))}getExtensionDescriptionsForActivationEvent(s){const C=this._activationMap.get(s);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(s){const C=this._extensionsMap.get(_.ExtensionIdentifier.toKey(s));return C||void 0}}e.ExtensionDescriptionRegistry=y;var k;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(k||(k={}));function D(P,s){const C=P.isBuiltin?0:P.isUnderDevelopment?2:1,g=s.isBuiltin?0:s.isUnderDevelopment?2:1;if(C!==g)return C-g;const m=T.posix.basename(P.extensionLocation.path),a=T.posix.basename(s.extensionLocation.path);return m<a?-1:m>a?1:0}}),define(ge[224],pe([0,1,22]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var I;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var T;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(T=e.MessageType||(e.MessageType={}));function A(k){const D=_.VSBuffer.alloc(1);switch(k){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=A;function y(k,D){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=y}),define(ge[41],pe([0,1,3,2,4,28,184]),function(K,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,T.createDecorator)("extensionService");class k{constructor(S){this.dependency=S}}e.MissingDependencyError=k;var D;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class P{constructor(S,d,l,f){this.codeLoadingTime=S,this.activateCallTime=d,this.activateResolvedTime=l,this.activationReason=f}}e.ActivationTimes=P;class s{constructor(S,d){this.description=S,this.value=d}}e.ExtensionPointContribution=s,e.ExtensionHostLogFileName="exthost";var C;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(C=e.ActivationKind||(e.ActivationKind={}));function g(w){w.enableProposedApi||m(w)}e.checkProposedApiEnabled=g;function m(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=m;function a(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=a;function u(w){return Object.assign(Object.assign({identifier:new A.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!1,extensionLocation:w.location},w.manifest),{uuid:w.identifier.uuid})}e.toExtensionDescription=u;class E{constructor(){this.onDidRegisterExtensions=_.Event.None,this.onDidChangeExtensionsStatus=_.Event.None,this.onDidChangeExtensions=_.Event.None,this.onWillActivateByEvent=_.Event.None,this.onDidChangeResponsiveChange=_.Event.None}activateByEvent(S){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(S){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(S){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(S){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(S,d){}_activateById(S,d){return Promise.resolve()}_onWillActivateExtension(S){}_onDidActivateExtension(S,d,l,f,t){}_onExtensionRuntimeError(S,d){}_onExtensionHostExit(S){}}e.NullExtensionService=E}),define(ge[225],pe([0,1,161,28,41,13]),function(K,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class k{constructor(u,E,w,S){this.startup=u,this.codeLoadingTime=E,this.activateCallTime=w,this.activateResolvedTime=S}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class D{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,E){return u===-1||E===-1?-1:E-u}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class P{constructor(u,E,w,S,d,l){this.activationFailed=u,this.activationFailedError=E,this.activationTimes=w,this.module=S,this.exports=d,this.subscriptions=l}}e.ActivatedExtension=P;class s extends P{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=s;class C extends P{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=C;class g extends P{constructor(u){super(!0,u,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=g;let m=class{constructor(u,E,w,S,d){this._logService=d,this._registry=u,this._resolvedExtensionsSet=new Set,E.forEach(l=>this._resolvedExtensionsSet.add(I.ExtensionIdentifier.toKey(l))),this._hostExtensionsMap=new Map,w.forEach(l=>this._hostExtensionsMap.set(I.ExtensionIdentifier.toKey(l),l)),this._host=S,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(u){const E=I.ExtensionIdentifier.toKey(u);return this._activatedExtensions.has(E)}getActivatedExtension(u){const E=I.ExtensionIdentifier.toKey(u),w=this._activatedExtensions.get(E);if(!w)throw new Error("Extension `"+u.value+"` is not known or not activated");return w}activateByEvent(u,E){if(this._alreadyActivatedEvents[u])return y;const w=this._registry.getExtensionDescriptionsForActivationEvent(u);return this._activateExtensions(w.map(S=>({id:S.identifier,reason:{startup:E,extensionId:S.identifier,activationEvent:u}}))).then(()=>{this._alreadyActivatedEvents[u]=!0})}activateById(u,E){const w=this._registry.getExtensionDescription(u);if(!w)throw new Error("Extension `"+u+"` is not known");return this._activateExtensions([{id:w.identifier,reason:E}])}_handleActivateRequest(u,E,w){if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(u.id))){E[I.ExtensionIdentifier.toKey(u.id)]=u;return}const S=this._registry.getExtensionDescription(u.id);if(!S){this._host.onExtensionActivationError(u.id,new T.MissingDependencyError(u.id.value));const f=new Error(`Unknown dependency '${u.id.value}'`);this._activatedExtensions.set(I.ExtensionIdentifier.toKey(u.id),new g(f));return}const d=typeof S.extensionDependencies=="undefined"?[]:S.extensionDependencies;let l=!0;for(let f=0,t=d.length;f<t;f++){const n=d[f];if(!this._resolvedExtensionsSet.has(I.ExtensionIdentifier.toKey(n))){const r=this._activatedExtensions.get(I.ExtensionIdentifier.toKey(n));if(!(r&&!r.activationFailed)){if(r&&r.activationFailed){this._host.onExtensionActivationError(S.identifier,_.localize(0,null,S.displayName||S.identifier.value,n));const c=new Error(`Dependency ${n} failed to activate`);c.detail=r.activationFailedError,this._activatedExtensions.set(I.ExtensionIdentifier.toKey(S.identifier),new g(c));return}if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(n))){l=!1,E[I.ExtensionIdentifier.toKey(n)]={id:this._hostExtensionsMap.get(I.ExtensionIdentifier.toKey(n)),reason:u.reason};continue}const i=this._registry.getExtensionDescription(n);if(i){l=!1,E[I.ExtensionIdentifier.toKey(n)]={id:i.identifier,reason:u.reason};continue}this._host.onExtensionActivationError(S.identifier,new T.MissingDependencyError(n));const o=new Error(`Unknown dependency '${n}'`);this._activatedExtensions.set(I.ExtensionIdentifier.toKey(S.identifier),new g(o));return}}}l?E[I.ExtensionIdentifier.toKey(S.identifier)]=u:w.push(u)}_activateExtensions(u){if(u.length===0||(u=u.filter(d=>!this._activatedExtensions.has(I.ExtensionIdentifier.toKey(d.id))),u.length===0))return Promise.resolve(void 0);const E=Object.create(null),w=[];for(let d=0,l=u.length;d<l;d++)this._handleActivateRequest(u[d],E,w);for(let d=0,l=w.length;d<l;d++){const f=I.ExtensionIdentifier.toKey(w[d].id);E[f]&&delete E[f]}const S=Object.keys(E).map(d=>E[d]);return w.length===0?Promise.all(S.map(d=>this._activateExtension(d.id,d.reason))).then(d=>{}):this._activateExtensions(S).then(d=>this._activateExtensions(w))}_activateExtension(u,E){const w=I.ExtensionIdentifier.toKey(u);if(this._activatedExtensions.has(w))return Promise.resolve(void 0);const S=this._activatingExtensions.get(w);if(S)return S;const d=this._host.actualActivateExtension(u,E).then(void 0,l=>(this._host.onExtensionActivationError(u,_.localize(1,null,u.value,l.message)),this._logService.error(`Activating extension ${u.value} failed due to an error:`),this._logService.error(l),new g(l))).then(l=>{this._activatedExtensions.set(w,l),this._activatingExtensions.delete(w)});return this._activatingExtensions.set(w,d),d}};m=Ve([xe(4,A.ILogService)],m),e.ExtensionsActivator=m}),define(ge[226],pe([0,1,13,41,27,12,113]),function(K,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let k=class extends _.LogService{constructor(P){if(P.logFile.scheme!==A.Schemas.file)throw new Error("Only file-logging supported");super(new y.SpdLogLogger(I.ExtensionHostLogFileName,P.logFile.fsPath,!0,P.logLevel))}$setLevel(P){this.setLevel(P)}};k=Ve([xe(0,T.IExtHostInitDataService)],k),e.ExtHostLogService=k}),define(ge[227],pe([0,1,18]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class I{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,y)=>{this._actualOk=A,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,_.onUnexpectedError)(A))}then(A,y){return this._ensureActual().then(A,y)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=I}),define(ge[125],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class _{constructor(D,P){this.isMain=D,this.sid=P,this.nid=++_.count}}e.ProxyIdentifier=_,_.count=0;const I=[];function T(k){const D=new _(!0,k);return I[D.nid]=D,D}e.createMainContextProxyIdentifier=T;function A(k){const D=new _(!1,k);return I[D.nid]=D,D}e.createExtHostContextProxyIdentifier=A;function y(k){return I[k].sid}e.getStringIdentifierForProxy=y}),define(ge[5],pe([0,1,2,125,58]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var y;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(l){l[l.Markdown=1]="Markdown",l[l.Code=2]="Code"})(P=e.CellKind||(e.CellKind={}));var s;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(s=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var g;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(g=e.CandidatePortSource||(e.CandidatePortSource={}));var m;(function(l){l.name="$ident";function f(n,r){return Object.defineProperty(n,l.name,{value:r,enumerable:!0}),n}l.mixin=f;function t(n){return n[l.name]}l.of=t})(m=e.ObjectIdentifier||(e.ObjectIdentifier={}));class a{static mixin(f){return f._id=a._n++,f}}e.IdObject=a,a._n=0;var u;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n",l.label2="o"})(u=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var E;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(E=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function S(l){if(l&&l.edits)for(const f of l.edits)typeof f.resource=="object"?f.resource=_.URI.revive(f.resource):(f.newUri=_.URI.revive(f.newUri),f.oldUri=_.URI.revive(f.oldUri)),f.metadata&&f.metadata.iconPath&&(f.metadata=(0,T.revive)(f.metadata));return l}e.reviveWorkspaceEditDto=S;var d;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(d=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,I.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,I.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,I.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,I.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,I.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,I.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ge[90],pe([0,1,5,3,4]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(k){this._onDidChangePassword=new I.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(_.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,D){return this._proxy.$getPassword(k,D)}store(k,D,P){return this._proxy.$setPassword(k,D,P)}delete(k,D){return this._proxy.$deletePassword(k,D)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,T.createDecorator)("IExtHostSecretState")}),define(ge[63],pe([0,1,4,13,5,14]),function(K,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,_.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(D,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(T.MainContext.MainThreadTelemetry)}report(D,P,s){const C=this.getUsageKey(D,P);this._reportedUsages.has(C)||(this._reportedUsages.add(C),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${s}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:D}))}getUsageKey(D,P){return`${D}-${P.identifier.value}`}};y=Ve([xe(0,A.IExtHostRpcService),xe(1,I.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(k,D,P){}})}),define(ge[228],pe([0,1,3,5,7,28]),function(K,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new _.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new _.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(I.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(D,P,s,C={}){const g=A.ExtensionIdentifier.toKey(D.identifier),m=this._inFlightRequests.get(g)||[],a=s.sort().join(" ");let u=m.find(E=>E.scopes===a);if(u)return u.result;{const E=this._getSession(D,g,P,s,C);u={scopes:a,result:E},m.push(u),this._inFlightRequests.set(g,m);try{await E}finally{const w=m.findIndex(S=>S.scopes===a);w>-1&&(m.splice(w),this._inFlightRequests.set(g,m))}return E}}async _getSession(D,P,s,C,g={}){await this._proxy.$ensureProvider(s);const m=D.displayName||D.name;return this._proxy.$getSession(s,C,P,m,g)}async removeSession(D,P){const s=this._authenticationProviders.get(D);return s?s.provider.removeSession(P):this._proxy.$removeSession(D,P)}registerAuthenticationProvider(D,P,s,C){var g;if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:P,provider:s,options:C!=null?C:{supportsMultipleAccounts:!1}}),this._providers.find(a=>a.id===D)||this._providers.push({id:D,label:P});const m=s.onDidChangeSessions(a=>{var u,E,w;this._proxy.$sendDidChangeSessions(D,{added:(u=a.added)!==null&&u!==void 0?u:[],changed:(E=a.changed)!==null&&E!==void 0?E:[],removed:(w=a.removed)!==null&&w!==void 0?w:[]})});return this._proxy.$registerAuthenticationProvider(D,P,(g=C==null?void 0:C.supportsMultipleAccounts)!==null&&g!==void 0?g:!1),new T.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(D);const a=this._providers.findIndex(u=>u.id===D);a>-1&&this._providers.splice(a),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,P){const s=this._authenticationProviders.get(D);if(s)return Promise.resolve(s.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,P){const s=this._authenticationProviders.get(D);if(s)return Promise.resolve(s.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,P){const s=this._authenticationProviders.get(D);if(s)return Promise.resolve(s.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,P){return this._onDidChangeSessions.fire({provider:{id:D,label:P}}),Promise.resolve()}$onDidChangeAuthenticationProviders(D,P){return D.forEach(s=>{this._providers.some(C=>C.id===s.id)||this._providers.push(s)}),P.forEach(s=>{const C=this._providers.findIndex(g=>g.id===s.id);C>-1&&this._providers.splice(C)}),this._onDidChangeAuthenticationProviders.fire({added:D,removed:P}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(ge[229],pe([0,1,5,14,20]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(k,D){this._extHostDocumentsAndEditors=D,this._proxy=k.getProxy(_.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const D=T.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};A=Ve([xe(0,I.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(ge[230],pe([0,1,5]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class I{constructor(A){const y=A.getProxy(_.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(k){return y.$writeText(k)}})}}e.ExtHostClipboard=I}),define(ge[51],pe([0,1,11,7,20,23,5,19,13,58,44,49,2,6,4,14]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let E=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadCommands),this._logService=n,this.converter=new w(this,r=>{const i=this._apiCommands.get(r);return(i==null?void 0:i.result)===d.Void?i:void 0},n),this._argumentProcessors=[{processArgument(r){return(0,P.revive)(r)}},{processArgument(r){return(0,A.cloneAndChange)(r,function(i){if(s.Range.isIRange(i))return T.Range.to(i);if(C.Position.isIPosition(i))return T.Position.to(i);if(s.Range.isIRange(i.range)&&g.URI.isUri(i.uri))return T.location.to(i);if(!Array.isArray(i))return i})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...r)=>{const i=t.args.map((c,v)=>{if(!c.validate(r[v]))throw new Error(`Invalid argument '${c.name}' when running '${t.id}', received: ${r[v]}`);return c.convert(r[v])}),o=await this.executeCommand(t.internalId,...i);return t.result.convert(o,r,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new I.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,r,i,o){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:r,thisArg:i,description:o}),t&&this._proxy.$registerCommand(n),new I.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,r){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const i=(0,A.cloneAndChange)(n,function(o){if(o instanceof I.Position)return T.Position.from(o);if(o instanceof I.Range)return T.Range.from(o);if(o instanceof I.Location)return T.location.from(o);if(!Array.isArray(o))return o});try{const o=await this._proxy.$executeCommand(t,i,r);return(0,P.revive)(o)}catch(o){if(o instanceof Error&&o.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw o}}}async _executeContributedCommand(t,n){const r=this._commands.get(t);if(!r)throw new Error("Unknown command");let{callback:i,thisArg:o,description:c}=r;if(c)for(let v=0;v<c.args.length;v++)try{(0,_.validateConstraint)(n[v],c.args[v].constraint)}catch(p){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${c.args[v].name}' - ${c.args[v].description}`)}try{return await i.apply(o,n)}catch(v){if(t===this.converter.delegatingCommandId){const p=this.converter.getActualCommand(...n);p&&(t=p.command)}throw this._logService.error(v,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(r=>this._argumentProcessors.reduce((i,o)=>o.processArgument(i),r)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(r=>r[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,r]of this._commands){let{description:i}=r;i&&(t[n]=i)}return Promise.resolve(t)}};E=Ve([xe(0,u.IExtHostRpcService),xe(1,D.ILogService)],E),e.ExtHostCommands=E,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class w{constructor(t,n,r){this._commands=t,this._lookupApiCommand=n,this._logService=r,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const r={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return r;const i=this._lookupApiCommand(t.command);if(i)r.id=i.internalId,r.arguments=i.args.map((o,c)=>o.convert(t.arguments&&t.arguments[c]));else if((0,k.isNonEmptyArray)(t.arguments)){const o=++this._cachIdPool;this._cache.set(o,t),n.add((0,m.toDisposable)(()=>{this._cache.delete(o),this._logService.trace("CommandsConverter#DISPOSE",o)})),r.$ident=o,r.id=this.delegatingCommandId,r.arguments=[o],this._logService.trace("CommandsConverter#CREATE",t.command,o)}return r}}fromInternal(t){const n=y.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class S{constructor(t,n,r,i){this.name=t,this.description=n,this.validate=r,this.convert=i}optional(){return new S(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new S(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=S,S.Uri=new S("uri","Uri of a text document",f=>g.URI.isUri(f),f=>f),S.Position=new S("position","A position in a text document",f=>I.Position.isPosition(f),T.Position.from),S.Range=new S("range","A range in a text document",f=>I.Range.isRange(f),T.Range.from),S.Selection=new S("selection","A selection in a text document",f=>I.Selection.isSelection(f),T.Selection.from),S.Number=new S("number","",f=>typeof f=="number",f=>f),S.String=new S("string","",f=>typeof f=="string",f=>f),S.CallHierarchyItem=new S("item","A call hierarchy item",f=>f instanceof I.CallHierarchyItem,T.CallHierarchyItem.to);class d{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=d,d.Void=new d("no result",f=>f);class l{constructor(t,n,r,i,o){this.id=t,this.internalId=n,this.description=r,this.args=i,this.result=o}}e.ApiCommand=l}),define(ge[231],pe([0,1,6,20,7,80,51,203,19,110]),function(K,e,_,I,T,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const s=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",g(I.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,u)=>{if(!(0,D.isFalsyOrEmpty)(a)){class E extends T.SymbolInformation{static to(S){const d=new E(S.name,I.SymbolKind.to(S.kind),S.containerName||"",new T.Location(u[0],I.Range.to(S.range)));return d.detail=S.detail,d.range=d.location.range,d.selectionRange=I.Range.to(S.selectionRange),d.children=S.children?S.children.map(E.to):[],d}}return a.map(E.to)}})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(I.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",g(I.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",g(I.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(u=>T.Position.isPosition(u)),a=>a.map(I.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(u=>{let E;for(const w of u.reverse())E=new T.SelectionRange(I.Range.to(w),E);return E}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>{const u=[];if(Array.isArray(a))for(let E of a)u.push(...E[1].map(I.WorkspaceSymbol.to));return u})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(I.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(I.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(I.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return I.WorkspaceEdit.to(a)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(I.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new T.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!!a){const u=(0,P.decodeSemanticTokensDto)(a);if(u.type==="full")return new T.SemanticTokens(u.data,void 0)}})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new T.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!!a){const u=(0,P.decodeSemanticTokensDto)(a);if(u.type==="full")return new T.SemanticTokens(u.data,void 0)}})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,u,E)=>{if(!a)return new T.CompletionList([]);const w=a.suggestions.map(S=>I.CompletionItem.to(S,E));return new T.CompletionList(w,a.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return I.SignatureHelp.to(a)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,u,E)=>g(w=>new T.CodeLens(I.Range.to(w.range),w.command&&E.fromInternal(w.command)))(a))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>T.Range.isRange(a),a=>T.Selection.isSelection(a)?I.Selection.from(a):I.Range.from(a)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,u,E)=>g(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return E.fromInternal(w.command)}else{const S=new T.CodeAction(w.title,w.kind?new T.CodeActionKind(w.kind):void 0);return w.edit&&(S.edit=I.WorkspaceEdit.to(w.edit)),w.command&&(S.command=E.fromInternal(w.command)),S.isPreferred=w.isPreferred,S}})(a))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(u=>new T.ColorInformation(I.Range.to(u.range),I.Color.to(u.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",a=>a instanceof T.Color,I.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:I.Range.from(a.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(I.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineHint objects",a=>a.map(I.InlineHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",g(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(u=>I.NotebookExclusiveDocumentPattern.to(u))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(I.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[I.ViewColumn.from(a.viewColumn),I.TextEditorOpenOptions.from(a)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[I.ViewColumn.from(a.viewColumn),I.TextEditorOpenOptions.from(a)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[I.ViewColumn.from(a.viewColumn),I.TextEditorOpenOptions.from(a)]).optional()],y.ApiCommandResult.Void)];class C{constructor(u){this._disposables=new _.DisposableStore,this._commands=u}static register(u){return s.forEach(u.registerApiCommand,u),new C(u).registerCommands()}registerCommands(){const u=E=>(...w)=>E(this._commands,...w);this._register(k.RemoveFromRecentlyOpenedAPICommand.ID,u(k.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:E=>typeof E=="string"}]}),this._register(k.OpenIssueReporter.ID,u(k.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:E=>typeof E=="string"||typeof E=="object"&&typeof E.extensionId=="string"}]})}_register(u,E,w){const S=this._commands.registerCommand(!1,u,E,this,w);this._disposables.add(S)}}e.ExtHostApiCommands=C;function g(a){return u=>{if(Array.isArray(u))return u.map(a)}}function m(a){if(!!Array.isArray(a)){const u=[];for(const E of a)A.isLocationLink(E)?u.push(I.DefinitionLink.to(E)):u.push(I.location.to(E));return u}}}),define(ge[232],pe([0,1,15,70,3,6,2,80,28,20,7,5]),function(K,e,_,I,T,A,y,k,D,P,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class g{constructor(l,f,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=l.getProxy(C.MainContext.MainThreadComments),f.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const r=this._commentControllers.get(n.handle);return r||n}else if(n&&n.$mid===7){const r=this._commentControllers.get(n.commentControlHandle);if(!r)return n;const i=r.getCommentThread(n.commentThreadHandle);return i||n}else if(n&&n.$mid===8){const r=this._commentControllers.get(n.thread.commentControlHandle);if(!r)return n;const i=r.getCommentThread(n.thread.commentThreadHandle);return i?{thread:i,text:n.text}:n}else if(n&&n.$mid===9){const r=this._commentControllers.get(n.thread.commentControlHandle);if(!r)return n;const i=r.getCommentThread(n.thread.commentThreadHandle);if(!i)return n;let o=n.commentUniqueId,c=i.getCommentByUniqueId(o);return c||n}else if(n&&n.$mid===10){const r=this._commentControllers.get(n.thread.commentControlHandle);if(!r)return n;const i=r.getCommentThread(n.thread.commentThreadHandle);if(!i)return n;let o=n.text,c=n.commentUniqueId,v=i.getCommentByUniqueId(c);return v?(v.body=o,v):n}return n}})}createCommentController(l,f,t){const n=g.handlePool++,r=new a(l,n,this._proxy,f,t);this._commentControllers.set(r.handle,r);const i=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(l.identifier))||[];return i.push(r),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(l.identifier),i),r}$createCommentThreadTemplate(l,f,t){const n=this._commentControllers.get(l);!n||n.$createCommentThreadTemplate(f,t)}async $updateCommentThreadTemplate(l,f,t){const n=this._commentControllers.get(l);!n||n.$updateCommentThreadTemplate(f,t)}$deleteCommentThread(l,f){const t=this._commentControllers.get(l);t&&t.$deleteCommentThread(f)}$provideCommentingRanges(l,f,t){const n=this._commentControllers.get(l);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const r=this._documents.getDocument(y.URI.revive(f));return(0,_.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(r,t)).then(i=>i?i.map(o=>P.Range.from(o)):void 0)}$toggleReaction(l,f,t,n,r){const i=this._commentControllers.get(l);return!i||!i.reactionHandler?Promise.resolve(void 0):(0,_.asPromise)(()=>{const o=i.getCommentThread(f);if(o){const c=o.getCommentByUniqueId(n.uniqueIdInThread);if(i!==void 0&&c&&i.reactionHandler)return i.reactionHandler(c,w(r))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=g,g.handlePool=0;class m{constructor(l,f,t,n,r,i,o){this._proxy=l,this._commentController=f,this._id=t,this._uri=n,this._range=r,this._comments=i,this.handle=m._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new T.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${f.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,P.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=i}set threadId(l){this._id=l}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(l){l.isEqual(this._range)||(this._range=l,this.modifications.range=l,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(l){this._canReply!==l&&(this._canReply=l,this.modifications.canReply=l,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(l){this._label=l,this.modifications.label=l,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(l){this._contextValue=l,this.modifications.contextValue=l,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(l){this._comments=l,this.modifications.comments=l,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(l){this._collapseState=l,this.modifications.collapsibleState=l,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const l=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),f={};l("range")&&(f.range=P.Range.from(this._range)),l("label")&&(f.label=this.label),l("contextValue")&&(f.contextValue=this.contextValue),l("comments")&&(f.comments=this._comments.map(t=>u(this,this._commentController,t,this._commentsMap))),l("collapsibleState")&&(f.collapseState=S(this._collapseState)),l("canReply")&&(f.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,f)}}getCommentByUniqueId(l){for(let f of this._commentsMap){let t=f[0],n=f[1];if(l===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(l=>l.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}m._handlePool=0,Ve([(0,I.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=m;class a{constructor(l,f,t,n,r){this._extension=l,this._handle=f,this._proxy=t,this._id=n,this._label=r,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,r)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(l){this._reactionHandler=l,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this._options}set options(l){this._options=l,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(l,f,t,n){if(typeof l=="string"){const r=new m(this._proxy,this,l,f,t,n,this._extension.identifier);return this._threads.set(r.handle,r),r}else{const r=new m(this._proxy,this,void 0,l,f,t,this._extension.identifier);return this._threads.set(r.handle,r),r}}$createCommentThreadTemplate(l,f){const t=new m(this._proxy,this,void 0,y.URI.revive(l),P.Range.to(f),[],this._extension.identifier);return t.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(l,f){let t=this._threads.get(l);t&&(t.range=P.Range.to(f))}$deleteCommentThread(l){let f=this._threads.get(l);f&&f.dispose(),this._threads.delete(l)}getCommentThread(l){return this._threads.get(l)}dispose(){this._threads.forEach(l=>{l.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function u(d,l,f,t){let n=t.get(f);n||(n=++d.commentHandle,t.set(f,n));const r=f.author&&f.author.iconPath?f.author.iconPath.toString():void 0;return{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:n,body:P.MarkdownString.from(f.body),userName:f.author.name,userIconPath:r,label:f.label,commentReactions:f.reactions?f.reactions.map(i=>E(i)):void 0}}function E(d){return{label:d.label,iconPath:d.iconPath?P.pathOrURIToURI(d.iconPath):void 0,count:d.count,hasReacted:d.authorHasReacted}}function w(d){return{label:d.label||"",count:d.count||0,iconPath:d.iconPath?y.URI.revive(d.iconPath):"",authorHasReacted:d.hasReacted||!1}}function S(d){if(d!==void 0)switch(d){case s.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case s.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}}),define(ge[126],pe([0,1,2,5,7,4,14,13,19,9,8]),function(K,e,_,I,T,A,y,k,D,P,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class _n{constructor(m,a){this._logService=a,this._provider=new Map,this._proxy=m.getProxy(I.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,a){const u=_n._handlePool++;this._provider.set(u,{provider:m,extensionId:a}),this._proxy.$registerDecorationProvider(u,a.value);const E=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(u,null);return}let S=(0,D.asArray)(w);if(S.length<=_n._maxEventSize){this._proxy.$onDidChange(u,S);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,S.length);const d=S.map(t=>({uri:t,rank:(0,P.count)(t.path,"/")})),l=(0,D.groupBy)(d,(t,n)=>t.rank-n.rank||(0,P.compare)(t.uri.path,n.uri.path));let f=[];e:for(let t of l){let n;for(let r of t){let i=(0,s.dirname)(r.uri.path);if(n!==i&&(n=i,f.push(r.uri)>=_n._maxEventSize))break e}}this._proxy.$onDidChange(u,f)});return new T.Disposable(()=>{E==null||E.dispose(),this._proxy.$unregisterDecorationProvider(u),this._provider.delete(u)})}async $provideDecorations(m,a,u){if(!this._provider.has(m))return Object.create(null);const E=Object.create(null),{provider:w,extensionId:S}=this._provider.get(m);return await Promise.all(a.map(async d=>{try{const{uri:l,id:f}=d,t=await Promise.resolve(w.provideFileDecoration(_.URI.revive(l),u));if(!t)return;try{T.FileDecoration.validate(t),E[f]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${S.value}': ${n}`)}}catch(l){this._logService.error(l)}})),E}};C._handlePool=0,C._maxEventSize=250,C=Ve([xe(0,y.IExtHostRpcService),xe(1,k.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(ge[233],pe([0,1,160,114,2,5,7,20,3,13,24]),function(K,e,_,I,T,A,y,k,D,P,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class C{constructor(a,u,E,w,S){this._name=a,this._owner=u,this._maxDiagnosticsPerFile=E,this._proxy=w,this._onDidChangeDiagnostics=S,this._isDisposed=!1,this._data=new s.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,u){if(!a){this.clear();return}this._checkDisposed();let E=[];if(T.URI.isUri(a)){if(!u){this.delete(a);return}this._data.set(a,u.slice()),E=[a]}else if(Array.isArray(a)){E=[];let S;a=[...a].sort(C._compareIndexedTuplesByUri);for(const d of a){const[l,f]=d;if((!S||l.toString()!==S.toString())&&(S&&this._data.get(S).length===0&&this._data.delete(S),S=l,E.push(l),this._data.set(l,[])),f){const t=this._data.get(l);t&&t.push(...f)}else{const t=this._data.get(l);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(E),!!this._proxy){const w=[];for(let S of E){let d=[];const l=this._data.get(S);if(l)if(l.length>this._maxDiagnosticsPerFile){d=[];const f=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of l)if(n.severity===f[t]&&d.push(k.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;d.push({severity:I.MarkerSeverity.Info,message:(0,_.localize)(0,null,l.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=l.map(f=>k.Diagnostic.from(f));w.push([S,d])}this._proxy.$changeMany(this._owner,w)}}delete(a){this._checkDisposed(),this._onDidChangeDiagnostics.fire([a]),this._data.delete(a),this._proxy&&this._proxy.$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(a,u){this._checkDisposed();for(let E of this._data.keys())a.apply(u,[E,this.get(E),this])}get(a){this._checkDisposed();const u=this._data.get(a);return Array.isArray(u)?Object.freeze(u.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(this._data.get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,u){return a[0].toString()<u[0].toString()?-1:a[0].toString()>u[0].toString()?1:0}}e.DiagnosticCollection=C;let g=class Vt{constructor(a,u){this._logService=u,this._collections=new Map,this._onDidChangeDiagnostics=new D.Emitter,this.onDidChangeDiagnostics=D.Event.map(D.Event.debounce(this._onDidChangeDiagnostics.event,Vt._debouncer,50),Vt._mapper),this._proxy=a.getProxy(A.MainContext.MainThreadDiagnostics)}static _debouncer(a,u){return a?a.concat(u):u}static _mapper(a){const u=[],E=new Set;for(const w of a)typeof w=="string"?E.has(w)||(E.add(w),u.push(T.URI.parse(w))):E.has(w.toString())||(E.add(w.toString()),u.push(w));return Object.freeze(u),{uris:u}}createDiagnosticCollection(a,u){const{_collections:E,_proxy:w,_onDidChangeDiagnostics:S,_logService:d}=this,l=new class{$changeMany(n,r){w.$changeMany(n,r),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,n,r.length===0?"CLEARING":r)}$clear(n){w.$clear(n),d.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,n)}dispose(){w.dispose()}};let f;if(!u)u="_generated_diagnostic_collection_name_#"+Vt._idPool++,f=u;else if(!E.has(u))f=u;else{this._logService.warn(`DiagnosticCollection with name '${u}' does already exist.`);do f=u+Vt._idPool++;while(E.has(f))}return new class extends C{constructor(){super(u,f,Vt._maxDiagnosticsPerFile,l,S);E.set(f,this)}dispose(){super.dispose(),E.delete(f)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const u=new Map,E=[];for(const w of this._collections.values())w.forEach((S,d)=>{let l=u.get(S.toString());typeof l=="undefined"&&(l=E.length,u.set(S.toString(),l),E.push([S,[]])),E[l][1]=E[l][1].concat(...d)});return E}}_getDiagnostics(a){let u=[];for(let E of this._collections.values())E.has(a)&&(u=u.concat(E.get(a)));return u}$acceptMarkersChange(a){if(!this._mirrorCollection){const u="_generated_mirror",E=new C(u,u,Vt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(u,E),this._mirrorCollection=E}for(const[u,E]of a)this._mirrorCollection.set(T.URI.revive(u),E.map(k.Diagnostic.to))}};g._idPool=0,g._maxDiagnosticsPerFile=1e3,g=Ve([xe(1,P.ILogService)],g),e.ExtHostDiagnostics=g}),define(ge[234],pe([0,1,2,5]),function(K,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class T{constructor(y){this._proxy=y.getProxy(I.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(k=>k?k.map(D=>_.URI.revive(D)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(k=>k?_.URI.revive(k):void 0)}}e.ExtHostDialogs=T}),define(ge[235],pe([0,1,18,2,7,5,12,21,9]),function(K,e,_,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(C,g,m){this._documentsAndEditors=g,this._logService=m,this._documentContentProviders=new Map,this._proxy=C.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,g){if(Object.keys(y.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const m=P._handlePool++;this._documentContentProviders.set(m,g),this._proxy.$registerTextContentProvider(m,C);let a;return typeof g.onDidChange=="function"&&(a=g.onDidChange(u=>{if(u.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(m,u).then(E=>{if(!(!E&&typeof E!="string")){const w=this._documentsAndEditors.getDocument(u);if(!!w){const S=(0,D.splitLines)(E);if(!w.equalLines(S))return this._proxy.$onVirtualDocumentChange(u,E)}}},_.onUnexpectedError)})),new T.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(C,g){const m=this._documentContentProviders.get(C);return m?Promise.resolve(m.provideTextDocumentContent(I.URI.revive(g),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${g.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(ge[236],pe([0,1,3,6,2,5,120,20,11,23]),function(K,e,_,I,T,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class s{constructor(g,m){this._onDidAddDocument=new _.Emitter,this._onDidRemoveDocument=new _.Emitter,this._onDidChangeDocument=new _.Emitter,this._onDidSaveDocument=new _.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new I.DisposableStore,this._documentLoader=new Map,this._proxy=g.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=m,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const u of a)this._onDidRemoveDocument.fire(u.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const u of a)this._onDidAddDocument.fire(u.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(g){if(!!g){const m=this._documentsAndEditors.getDocument(g);if(m)return m}}getDocument(g){const m=this.getDocumentData(g);if(!(m==null?void 0:m.document))throw new Error(`Unable to retrieve document from URI '${g}'`);return m.document}ensureDocumentData(g){const m=this._documentsAndEditors.getDocument(g);if(m)return Promise.resolve(m);let a=this._documentLoader.get(g.toString());return a||(a=this._proxy.$tryOpenDocument(g).then(u=>{this._documentLoader.delete(g.toString());const E=T.URI.revive(u);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(E))},u=>(this._documentLoader.delete(g.toString()),Promise.reject(u))),this._documentLoader.set(g.toString(),a)),a}createDocumentData(g){return this._proxy.$tryCreateDocument(g).then(m=>T.URI.revive(m))}$acceptModelModeChanged(g,m){const a=T.URI.revive(g),u=this._documentsAndEditors.getDocument(a);if(!u)throw new Error("unknown document");this._onDidRemoveDocument.fire(u.document),u._acceptLanguageId(m),this._onDidAddDocument.fire(u.document)}$acceptModelSaved(g){const m=T.URI.revive(g),a=this._documentsAndEditors.getDocument(m);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(g,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(g,m){const a=T.URI.revive(g),u=this._documentsAndEditors.getDocument(a);if(!u)throw new Error("unknown document");u._acceptIsDirty(m),this._onDidChangeDocument.fire({document:u.document,contentChanges:[]})}$acceptModelChanged(g,m,a){const u=T.URI.revive(g),E=this._documentsAndEditors.getDocument(u);if(!E)throw new Error("unknown document");E._acceptIsDirty(a),E.onEvents(m),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:E.document,contentChanges:m.changes.map(w=>({range:k.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text}))}))}setWordDefinitionFor(g,m){(0,y.setWordDefinitionFor)(g,m)}}e.ExtHostDocuments=s}),define(ge[39],pe([0,1,52,3,6,2,4,5,120,14,124,20,13,24,12,54,134]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let S=class{constructor(l,f){this._extHostRpc=l,this._logService=f,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new I.Emitter,this._onDidRemoveDocuments=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const f=[],t=[],n=[];if(l.removedDocuments)for(const r of l.removedDocuments){const i=A.URI.revive(r),o=this._documents.get(i);(o==null?void 0:o.unref())&&(this._documents.delete(i),f.push(o.value))}if(l.addedDocuments)for(const r of l.addedDocuments){const i=A.URI.revive(r.uri);let o=this._documents.get(i);if(o&&i.scheme!==a.Schemas.vscodeNotebookCell)throw new Error(`document '${i} already exists!'`);o||(o=new w(new D.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(i,o),t.push(o.value)),o.ref()}if(l.removedEditors)for(const r of l.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&n.push(i)}if(l.addedEditors)for(const r of l.addedEditors){const i=A.URI.revive(r.documentUri);_.ok(this._documents.has(i),`document '${i}' does not exist`),_.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const o=this._documents.get(i).value,c=new s.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new E.Lazy(()=>o.document),r.selections.map(C.Selection.to),r.options,r.visibleRanges.map(v=>C.Range.to(v)),typeof r.editorPosition=="number"?C.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,c)}l.newActiveEditor!==void 0&&(_.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,T.dispose)(f),(0,T.dispose)(n),l.removedDocuments&&this._onDidRemoveDocuments.fire(f),l.addedDocuments&&this._onDidAddDocuments.fire(t),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){var f;return(f=this._documents.get(l))===null||f===void 0?void 0:f.value}allDocuments(){return u.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!!this._activeEditorId){const f=this._editors.get(this._activeEditorId);return l?f:f==null?void 0:f.value}}allEditors(){return[...this._editors.values()]}};S=Ve([xe(0,P.IExtHostRpcService),xe(1,g.ILogService)],S),e.ExtHostDocumentsAndEditors=S,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(ge[237],pe([0,1,2,5,6,7,20,142,9,22]),function(K,e,_,I,T,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class s{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const a=this._schemes.indexOf(m);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),a=[];let u,E,w=14,S=14;for(const d of m){let l=u?(0,D.commonPrefixLength)(u,d):0;for(l===0?E=1:E=S;l<d.length;l++)l+1===d.length?(w=S,S=9):S+=1,a.push([E,d.toUpperCase().charCodeAt(l),S]),a.push([E,d.toLowerCase().charCodeAt(l),S]),E=S;u=d,S=w}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new k.StateMachine(a)}}provideDocumentLinks(m){this._initStateMachine();const a=[],u=k.LinkComputer.computeLinks({getLineContent(E){return m.lineAt(E-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const E of u){const w=y.DocumentLink.to(E);w.target&&a.push(w)}return a}}class C{constructor(m,a){this._extHostLanguageFeatures=a,this._linkProvider=new s,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=m.getProxy(I.MainContext.MainThreadFileSystem)}dispose(){var m;(m=this._linkProviderRegistration)===null||m===void 0||m.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,a,u,E={}){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const w=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(w,u);let S=2;E.isCaseSensitive&&(S+=1024),E.isReadonly&&(S+=2048),typeof u.copy=="function"&&(S+=8),typeof u.open=="function"&&typeof u.close=="function"&&typeof u.read=="function"&&typeof u.write=="function"&&(S+=4),this._proxy.$registerFileSystemProvider(w,a,S).catch(l=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${a}`),console.error(l)});const d=u.onDidChangeFile(l=>{const f=[];for(const t of l){let{uri:n,type:r}=t;if(n.scheme===a){let i;switch(r){case A.FileChangeType.Changed:i=0;break;case A.FileChangeType.Created:i=1;break;case A.FileChangeType.Deleted:i=2;break;default:throw new Error("Unknown FileChangeType")}f.push({resource:n,type:i})}}this._proxy.$onFileSystemChange(w,f)});return(0,T.toDisposable)(()=>{d.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(w),this._proxy.$unregisterProvider(w)})}static _asIStat(m){const{type:a,ctime:u,mtime:E,size:w}=m;return{type:a,ctime:u,mtime:E,size:w}}$stat(m,a){return Promise.resolve(this._getFsProvider(m).stat(_.URI.revive(a))).then(C._asIStat)}$readdir(m,a){return Promise.resolve(this._getFsProvider(m).readDirectory(_.URI.revive(a)))}$readFile(m,a){return Promise.resolve(this._getFsProvider(m).readFile(_.URI.revive(a))).then(u=>P.VSBuffer.wrap(u))}$writeFile(m,a,u,E){return Promise.resolve(this._getFsProvider(m).writeFile(_.URI.revive(a),u.buffer,E))}$delete(m,a,u){return Promise.resolve(this._getFsProvider(m).delete(_.URI.revive(a),u))}$rename(m,a,u,E){return Promise.resolve(this._getFsProvider(m).rename(_.URI.revive(a),_.URI.revive(u),E))}$copy(m,a,u,E){const w=this._getFsProvider(m);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(_.URI.revive(a),_.URI.revive(u),E))}$mkdir(m,a){return Promise.resolve(this._getFsProvider(m).createDirectory(_.URI.revive(a)))}$watch(m,a,u,E){const w=this._getFsProvider(m).watch(_.URI.revive(u),E);this._watches.set(a,w)}$unwatch(m,a){const u=this._watches.get(a);u&&(u.dispose(),this._watches.delete(a))}$open(m,a,u){const E=this._getFsProvider(m);if(!E.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(E.open(_.URI.revive(a),u))}$close(m,a){const u=this._getFsProvider(m);if(!u.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(u.close(a))}$read(m,a,u,E){const w=this._getFsProvider(m);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const S=P.VSBuffer.alloc(E);return Promise.resolve(w.read(a,u,S.buffer,0,E)).then(d=>S.slice(0,d))}$write(m,a,u,E){const w=this._getFsProvider(m);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(a,u,E.buffer,0,E.byteLength))}_getFsProvider(m){const a=this._fsProvider.get(m);if(!a){const u=new Error;throw u.name="ENOPRO",u.message="no provider",u}return a}}e.ExtHostFileSystem=C}),define(ge[91],pe([0,1,5,45,7,22,4,14,61]),function(K,e,_,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class Mt{constructor(C,g){const m=C.getProxy(_.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(a){return m.$stat(a).catch(Mt._handleError)},readDirectory(a){return m.$readdir(a).catch(Mt._handleError)},createDirectory(a){return m.$mkdir(a).catch(Mt._handleError)},async readFile(a){return m.$readFile(a).then(u=>u.buffer).catch(Mt._handleError)},writeFile(a,u){return m.$writeFile(a,A.VSBuffer.wrap(u)).catch(Mt._handleError)},delete(a,u){return m.$delete(a,Object.assign({recursive:!1,useTrash:!1},u)).catch(Mt._handleError)},rename(a,u,E){return m.$rename(a,u,Object.assign({overwrite:!1},E)).catch(Mt._handleError)},copy(a,u,E){return m.$copy(a,u,Object.assign({overwrite:!1},E)).catch(Mt._handleError)},isWritableFileSystem(a){const u=g.getCapabilities(a);if(typeof u=="number")return!(u&2048)}})}static _handleError(C){if(!(C instanceof Error))throw new T.FileSystemError(String(C));if(C.name==="ENOPRO")throw T.FileSystemError.Unavailable(C.message);switch(C.name){case I.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(C.message);case I.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(C.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(C.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(C.message);case I.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(C.message);case I.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(C.message);default:throw new T.FileSystemError(C.message,C.name)}}};P=Ve([xe(0,k.IExtHostRpcService),xe(1,D.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(ge[238],pe([0,1,6,5]),function(K,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class T{constructor(y){this._handlePool=0,this._proxy=y.getProxy(I.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,y),(0,_.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=T}),define(ge[239],pe([0,1,2,23,20,7,15,5,9,44,19,11,139,6,110,72,86,47,18]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a,u,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class d{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentSymbols(z,Y){const ee=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentSymbols(ee,Y)).then(le=>{if(!(0,s.isFalsyOrEmpty)(le))return le[0]instanceof A.DocumentSymbol?le.map(T.DocumentSymbol.from):d._asDocumentSymbolTree(le)})}static _asDocumentSymbolTree(z){var Y;z=z.slice(0).sort((me,De)=>{let Oe=me.location.range.start.compareTo(De.location.range.start);return Oe===0&&(Oe=De.location.range.end.compareTo(me.location.range.end)),Oe});const ee=[],le=[];for(const me of z){const De={name:me.name||"!!MISSING: name!!",kind:T.SymbolKind.from(me.kind),tags:((Y=me.tags)===null||Y===void 0?void 0:Y.map(T.SymbolTag.from))||[],detail:"",containerName:me.containerName,range:T.Range.from(me.location.range),selectionRange:T.Range.from(me.location.range),children:[]};for(;;){if(le.length===0){le.push(De),ee.push(De);break}const Oe=le[le.length-1];if(P.Range.containsRange(Oe.range,De.range)&&!P.Range.equalsRange(Oe.range,De.range)){Oe.children&&Oe.children.push(De),le.push(De);break}le.pop()}}return ee}}class l{constructor(z,Y,ee){this._documents=z,this._commands=Y,this._provider=ee,this._cache=new E.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,Y){const ee=this._documents.getDocument(z),le=await this._provider.provideCodeLenses(ee,Y);if(!(!le||Y.isCancellationRequested)){const me=this._cache.add(le),De=new m.DisposableStore;this._disposables.set(me,De);const Oe={cacheId:me,lenses:[]};for(let be=0;be<le.length;be++)Oe.lenses.push({cacheId:[me,be],range:T.Range.from(le[be].range),command:this._commands.toInternal(le[be].command,De)});return Oe}}async resolveCodeLens(z,Y){var ee;const le=z.cacheId&&this._cache.get(...z.cacheId);if(!!le){let me;if(typeof this._provider.resolveCodeLens!="function"||le.isResolved?me=le:me=await this._provider.resolveCodeLens(le,Y),me||(me=le),!Y.isCancellationRequested){const De=z.cacheId&&this._disposables.get(z.cacheId[0]);if(!!De)return z.command=this._commands.toInternal((ee=me.command)!==null&&ee!==void 0?ee:l._badCmd,De),z}}}releaseCodeLenses(z){var Y;(Y=this._disposables.get(z))===null||Y===void 0||Y.dispose(),this._disposables.delete(z),this._cache.delete(z)}}l._badCmd={command:"missing",title:"!!MISSING: command!!"};function f(Le){return Array.isArray(Le)?Le.map(T.DefinitionLink.from):Le?[T.DefinitionLink.from(Le)]:[]}class t{constructor(z,Y){this._documents=z,this._provider=Y}provideDefinition(z,Y,ee){const le=this._documents.getDocument(z),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideDefinition(le,me,ee)).then(f)}}class n{constructor(z,Y){this._documents=z,this._provider=Y}provideDeclaration(z,Y,ee){const le=this._documents.getDocument(z),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideDeclaration(le,me,ee)).then(f)}}class r{constructor(z,Y){this._documents=z,this._provider=Y}provideImplementation(z,Y,ee){const le=this._documents.getDocument(z),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideImplementation(le,me,ee)).then(f)}}class i{constructor(z,Y){this._documents=z,this._provider=Y}provideTypeDefinition(z,Y,ee){const le=this._documents.getDocument(z),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideTypeDefinition(le,me,ee)).then(f)}}class o{constructor(z,Y){this._documents=z,this._provider=Y}provideHover(z,Y,ee){const le=this._documents.getDocument(z),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideHover(le,me,ee)).then(De=>{if(!(!De||(0,s.isFalsyOrEmpty)(De.contents)))return De.range||(De.range=le.getWordRangeAtPosition(me)),De.range||(De.range=new A.Range(me,me)),T.Hover.from(De)})}}class c{constructor(z,Y){this._documents=z,this._provider=Y}provideEvaluatableExpression(z,Y,ee){const le=this._documents.getDocument(z),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideEvaluatableExpression(le,me,ee)).then(De=>{if(De)return T.EvaluatableExpression.from(De)})}}class v{constructor(z,Y){this._documents=z,this._provider=Y}provideInlineValues(z,Y,ee,le){const me=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideInlineValues(me,T.Range.to(Y),T.InlineValueContext.to(ee),le)).then(De=>{if(Array.isArray(De))return De.map(Oe=>T.InlineValue.from(Oe))})}}class p{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentHighlights(z,Y,ee){const le=this._documents.getDocument(z),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideDocumentHighlights(le,me,ee)).then(De=>{if(Array.isArray(De))return De.map(T.DocumentHighlight.from)})}}class h{constructor(z,Y){this._documents=z,this._provider=Y}provideLinkedEditingRanges(z,Y,ee){const le=this._documents.getDocument(z),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideLinkedEditingRanges(le,me,ee)).then(De=>{if(De&&Array.isArray(De.ranges))return{ranges:(0,s.coalesce)(De.ranges.map(T.Range.from)),wordPattern:De.wordPattern}})}}class b{constructor(z,Y){this._documents=z,this._provider=Y}provideReferences(z,Y,ee,le){const me=this._documents.getDocument(z),De=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideReferences(me,De,ee,le)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(T.location.from)})}}class R{constructor(z,Y,ee,le,me,De,Oe){this._documents=z,this._commands=Y,this._diagnostics=ee,this._provider=le,this._logService=me,this._extension=De,this._apiDeprecation=Oe,this._cache=new E.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(z,Y,ee,le){const me=this._documents.getDocument(z),De=g.Selection.isISelection(Y)?T.Selection.to(Y):T.Range.to(Y),Oe=[];for(const Pe of this._diagnostics.getDiagnostics(z))if(De.intersection(Pe.range)&&Oe.push(Pe)>R._maxCodeActionsPerFile)break;const be={diagnostics:Oe,only:ee.only?new A.CodeActionKind(ee.only):void 0,triggerKind:T.CodeActionTriggerKind.to(ee.trigger)};return(0,y.asPromise)(()=>this._provider.provideCodeActions(me,De,be,le)).then(Pe=>{var Re;if(!(!(0,s.isNonEmptyArray)(Pe)||le.isCancellationRequested)){const Be=this._cache.add(Pe),Se=new m.DisposableStore;this._disposables.set(Be,Se);const qe=[];for(let X=0;X<Pe.length;X++){const ie=Pe[X];!ie||(R._isCommand(ie)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:ie.title,command:this._commands.toInternal(ie,Se)})):(be.only&&(ie.kind?be.only.contains(ie.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action is of kind '${ie.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[Be,X],title:ie.title,command:ie.command&&this._commands.toInternal(ie.command,Se),diagnostics:ie.diagnostics&&ie.diagnostics.map(T.Diagnostic.from),edit:ie.edit&&T.WorkspaceEdit.from(ie.edit),kind:ie.kind&&ie.kind.value,isPreferred:ie.isPreferred,disabled:(Re=ie.disabled)===null||Re===void 0?void 0:Re.reason})))}return{cacheId:Be,actions:qe}}})}async resolveCodeAction(z,Y){var ee;const[le,me]=z,De=this._cache.get(le,me);if(!(!De||R._isCommand(De))&&!!this._provider.resolveCodeAction){const Oe=(ee=await this._provider.resolveCodeAction(De,Y))!==null&&ee!==void 0?ee:De;return(Oe==null?void 0:Oe.edit)?T.WorkspaceEdit.from(Oe.edit):void 0}}releaseCodeActions(z){var Y;(Y=this._disposables.get(z))===null||Y===void 0||Y.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}R._maxCodeActionsPerFile=1e3;class N{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentFormattingEdits(z,Y,ee){const le=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentFormattingEdits(le,Y,ee)).then(me=>{if(Array.isArray(me))return me.map(T.TextEdit.from)})}}class j{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentRangeFormattingEdits(z,Y,ee,le){const me=this._documents.getDocument(z),De=T.Range.to(Y);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(me,De,ee,le)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(T.TextEdit.from)})}}class oe{constructor(z,Y){this._documents=z,this._provider=Y,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(z,Y,ee,le,me){const De=this._documents.getDocument(z),Oe=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(De,Oe,ee,le,me)).then(be=>{if(Array.isArray(be))return be.map(T.TextEdit.from)})}}class q{constructor(z,Y){this._provider=z,this._logService=Y,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(z,Y){const ee=k.IdObject.mixin({symbols:[]});return(0,y.asPromise)(()=>this._provider.provideWorkspaceSymbols(z,Y)).then(le=>{if((0,s.isNonEmptyArray)(le)){for(const me of le)if(!!me){if(!me.name){this._logService.warn("INVALID SymbolInformation, lacks name",me);continue}const De=k.IdObject.mixin(T.WorkspaceSymbol.from(me));this._symbolCache.set(De._id,me),ee.symbols.push(De)}}}).then(()=>(ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee))}async resolveWorkspaceSymbol(z,Y){if(typeof this._provider.resolveWorkspaceSymbol!="function")return z;const ee=this._symbolCache.get(z._id);if(ee){const le=await(0,y.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ee,Y));return le&&(0,I.mixin)(z,T.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(z){const Y=this._resultCache.get(z);if(Y){for(let[ee,le]=Y;ee<=le;ee++)this._symbolCache.delete(ee);this._resultCache.delete(z)}}}class W{constructor(z,Y,ee){this._documents=z,this._provider=Y,this._logService=ee}static supportsResolving(z){return typeof z.prepareRename=="function"}provideRenameEdits(z,Y,ee,le){const me=this._documents.getDocument(z),De=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideRenameEdits(me,De,ee,le)).then(Oe=>{if(!!Oe)return T.WorkspaceEdit.from(Oe)},Oe=>{const be=W._asMessage(Oe);return be?{rejectReason:be,edits:void 0}:Promise.reject(Oe)})}resolveRenameLocation(z,Y,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(z),me=T.Position.to(Y);return(0,y.asPromise)(()=>this._provider.prepareRename(le,me,ee)).then(De=>{let Oe,be;if(A.Range.isRange(De)?(Oe=De,be=le.getText(De)):(0,C.isObject)(De)&&(Oe=De.range,be=De.placeholder),!!Oe){if(Oe.start.line>me.line||Oe.end.line<me.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:T.Range.from(Oe),text:be}}},De=>{const Oe=W._asMessage(De);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(De)})}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class H{constructor(z,Y){this.resultId=z,this.tokens=Y}}class U{constructor(z,Y){this._documents=z,this._provider=Y,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(z,Y,ee){const le=this._documents.getDocument(z),me=Y!==0?this._previousResults.get(Y):null;return(0,y.asPromise)(()=>me&&typeof me.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(le,me.resultId,ee):this._provider.provideDocumentSemanticTokens(le,ee)).then(De=>(me&&this._previousResults.delete(Y),De?(De=U._fixProvidedSemanticTokens(De),this._send(U._convertToEdits(me,De),De)):null))}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return U._isSemanticTokens(z)?U._isCorrectSemanticTokens(z)?z:new A.SemanticTokens(new Uint32Array(z.data),z.resultId):U._isSemanticTokensEdits(z)?U._isCorrectSemanticTokensEdits(z)?z:new A.SemanticTokensEdits(z.edits.map(Y=>new A.SemanticTokensEdit(Y.start,Y.deleteCount,Y.data?new Uint32Array(Y.data):Y.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const Y of z.edits)if(!(Y.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,Y){if(!U._isSemanticTokens(Y)||!z||!z.tokens)return Y;const ee=z.tokens,le=ee.length,me=Y.data,De=me.length;let Oe=0;const be=Math.min(le,De);for(;Oe<be&&ee[Oe]===me[Oe];)Oe++;if(Oe===le&&Oe===De)return new A.SemanticTokensEdits([],Y.resultId);let Pe=0;const Re=be-Oe;for(;Pe<Re&&ee[le-Pe-1]===me[De-Pe-1];)Pe++;return new A.SemanticTokensEdits([{start:Oe,deleteCount:le-Oe-Pe,data:me.subarray(Oe,De-Pe)}],Y.resultId)}_send(z,Y){if(U._isSemanticTokens(z)){const ee=this._nextResultId++;return this._previousResults.set(ee,new H(z.resultId,z.data)),(0,a.encodeSemanticTokensDto)({id:ee,type:"full",data:z.data})}if(U._isSemanticTokensEdits(z)){const ee=this._nextResultId++;return U._isSemanticTokens(Y)?this._previousResults.set(ee,new H(Y.resultId,Y.data)):this._previousResults.set(ee,new H(z.resultId)),(0,a.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(z.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=U;class L{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentRangeSemanticTokens(z,Y,ee){const le=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(le,T.Range.to(Y),ee)).then(me=>me?this._send(me):null)}_send(z){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}e.DocumentRangeSemanticTokensAdapter=L;class F{constructor(z,Y,ee,le,me){this._documents=z,this._commands=Y,this._provider=ee,this._apiDeprecation=le,this._extension=me,this._cache=new E.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}async provideCompletionItems(z,Y,ee,le){const me=this._documents.getDocument(z),De=T.Position.to(Y),Oe=me.getWordRangeAtPosition(De)||new A.Range(De,De),be=Oe.with({end:De}),Pe=new w.StopWatch(!0),Re=await(0,y.asPromise)(()=>this._provider.provideCompletionItems(me,De,le,T.CompletionContext.to(ee)));if(!!Re&&!le.isCancellationRequested){const Be=Array.isArray(Re)?new A.CompletionList(Re):Re,Se=F.supportsResolving(this._provider)?this._cache.add(Be.items):this._cache.add([]),qe=new m.DisposableStore;this._disposables.set(Se,qe);const X=[],ie={x:Se,b:X,a:{replace:T.Range.from(Oe),insert:T.Range.from(be)},c:Be.isIncomplete||void 0,d:Pe.elapsed()};for(let _e=0;_e<Be.items.length;_e++){const Ne=Be.items[_e],ze=this._convertCompletionItem(Ne,[Se,_e],be,Oe);X.push(ze)}return ie}}async resolveCompletionItem(z,Y){if(typeof this._provider.resolveCompletionItem=="function"){const ee=this._cache.get(...z);if(!!ee){const le=await(0,y.asPromise)(()=>this._provider.resolveCompletionItem(ee,Y));if(!!le)return this._convertCompletionItem(le,z)}}}releaseCompletionItems(z){var Y;(Y=this._disposables.get(z))===null||Y===void 0||Y.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,Y,ee,le){var me;const De=this._disposables.get(Y[0]);if(!De)throw Error("DisposableStore is missing...");const Oe={x:Y,a:(me=z.label)!==null&&me!==void 0?me:"",o:z.label2,b:z.kind!==void 0?T.CompletionItemKind.from(z.kind):void 0,n:z.tags&&z.tags.map(T.CompletionItemTag.from),c:z.detail,d:typeof z.documentation=="undefined"?void 0:T.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters,l:z.additionalTextEdits&&z.additionalTextEdits.map(T.TextEdit.from),m:this._commands.toInternal(z.command,De)};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=z.textEdit.newText):typeof z.insertText=="string"?Oe.h=z.insertText:z.insertText instanceof A.SnippetString&&(Oe.h=z.insertText.value,Oe.i|=4);let be;return z.textEdit?be=z.textEdit.range:z.range&&(be=z.range),A.Range.isRange(be)?Oe.j=T.Range.from(be):be&&(!(ee==null?void 0:ee.isEqual(be.inserting))||!(le==null?void 0:le.isEqual(be.replacing)))&&(Oe.j={insert:T.Range.from(be.inserting),replace:T.Range.from(be.replacing)}),Oe}}class O{constructor(z,Y){this._documents=z,this._provider=Y,this._cache=new E.Cache("SignatureHelp")}provideSignatureHelp(z,Y,ee,le){const me=this._documents.getDocument(z),De=T.Position.to(Y),Oe=this.reviveContext(ee);return(0,y.asPromise)(()=>this._provider.provideSignatureHelp(me,De,le,Oe)).then(be=>{if(be){const Pe=this._cache.add([be]);return Object.assign(Object.assign({},T.SignatureHelp.from(be)),{id:Pe})}})}reviveContext(z){let Y;if(z.activeSignatureHelp){const ee=T.SignatureHelp.to(z.activeSignatureHelp),le=this._cache.get(z.activeSignatureHelp.id,0);le?(Y=le,Y.activeSignature=ee.activeSignature,Y.activeParameter=ee.activeParameter):Y=ee}return Object.assign(Object.assign({},z),{activeSignatureHelp:Y})}releaseSignatureHelp(z){this._cache.delete(z)}}class M{constructor(z,Y){this._documents=z,this._provider=Y}provideInlineHints(z,Y,ee){const le=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideInlineHints(le,T.Range.to(Y),ee)).then(me=>me?{hints:me.map(T.InlineHint.from)}:void 0)}}class B{constructor(z,Y){this._documents=z,this._provider=Y,this._cache=new E.Cache("DocumentLink")}provideLinks(z,Y){const ee=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentLinks(ee,Y)).then(le=>{if(!(!Array.isArray(le)||le.length===0)&&!Y.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.map(T.DocumentLink.from)};{const me=this._cache.add(le),De={links:[],id:me};for(let Oe=0;Oe<le.length;Oe++){const be=T.DocumentLink.from(le[Oe]);be.cacheId=[me,Oe],De.links.push(be)}return De}}})}resolveLink(z,Y){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ee=this._cache.get(...z);return ee?(0,y.asPromise)(()=>this._provider.resolveDocumentLink(ee,Y)).then(le=>le&&T.DocumentLink.from(le)||void 0):Promise.resolve(void 0)}releaseLinks(z){this._cache.delete(z)}}class V{constructor(z,Y){this._documents=z,this._provider=Y}provideColors(z,Y){const ee=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentColors(ee,Y)).then(le=>Array.isArray(le)?le.map(De=>({color:T.Color.from(De.color),range:T.Range.from(De.range)})):[])}provideColorPresentations(z,Y,ee){const le=this._documents.getDocument(z),me=T.Range.to(Y.range),De=T.Color.to(Y.color);return(0,y.asPromise)(()=>this._provider.provideColorPresentations(De,{document:le,range:me},ee)).then(Oe=>{if(!!Array.isArray(Oe))return Oe.map(T.ColorPresentation.from)})}}class Q{constructor(z,Y){this._documents=z,this._provider=Y}provideFoldingRanges(z,Y,ee){const le=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideFoldingRanges(le,Y,ee)).then(me=>{if(!!Array.isArray(me))return me.map(T.FoldingRange.from)})}}class de{constructor(z,Y,ee){this._documents=z,this._provider=Y,this._logService=ee}provideSelectionRanges(z,Y,ee){const le=this._documents.getDocument(z),me=Y.map(T.Position.to);return(0,y.asPromise)(()=>this._provider.provideSelectionRanges(le,me,ee)).then(De=>{if(!(0,s.isNonEmptyArray)(De))return[];if(De.length!==me.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let be=0;be<me.length;be++){const Pe=[];Oe.push(Pe);let Re=me[be],Be=De[be];for(;;){if(!Be.range.contains(Re))throw new Error("INVALID selection range, must contain the previous range");if(Pe.push(T.SelectionRange.from(Be)),!Be.parent)break;Re=Be.range,Be=Be.parent}}return Oe})}}class we{constructor(z,Y){this._documents=z,this._provider=Y,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(z,Y,ee){const le=this._documents.getDocument(z),me=T.Position.to(Y),De=await this._provider.prepareCallHierarchy(le,me,ee);if(!!De){const Oe=this._idPool.nextId();return this._cache.set(Oe,new Map),Array.isArray(De)?De.map(be=>this._cacheAndConvertItem(Oe,be)):[this._cacheAndConvertItem(Oe,De)]}}async provideCallsTo(z,Y,ee){const le=this._itemFromCache(z,Y);if(!le)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyIncomingCalls(le,ee);if(!!me)return me.map(De=>({from:this._cacheAndConvertItem(z,De.from),fromRanges:De.fromRanges.map(Oe=>T.Range.from(Oe))}))}async provideCallsFrom(z,Y,ee){const le=this._itemFromCache(z,Y);if(!le)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyOutgoingCalls(le,ee);if(!!me)return me.map(De=>({to:this._cacheAndConvertItem(z,De.to),fromRanges:De.fromRanges.map(Oe=>T.Range.from(Oe))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,Y){var ee;const le=this._cache.get(z),me={_sessionId:z,_itemId:le.size.toString(36),name:Y.name,detail:Y.detail,kind:T.SymbolKind.from(Y.kind),uri:Y.uri,range:T.Range.from(Y.range),selectionRange:T.Range.from(Y.selectionRange),tags:(ee=Y.tags)===null||ee===void 0?void 0:ee.map(T.SymbolTag.from)};return le.set(me._itemId,Y),me}_itemFromCache(z,Y){const ee=this._cache.get(z);return ee==null?void 0:ee.get(Y)}}class Ie{constructor(z,Y){this.adapter=z,this.extension=Y}}class Ce{constructor(z,Y,ee,le,me,De,Oe){this._adapter=new Map,this._uriTransformer=Y,this._proxy=z.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=le,this._diagnostics=me,this._logService=De,this._apiDeprecation=Oe}_transformDocumentSelector(z){return(0,s.coalesce)((0,s.asArray)(z).map(Y=>this._doTransformDocumentSelector(Y)))}_doTransformDocumentSelector(z){if(typeof z=="string")return{$serialized:!0,language:z};if(z)return{$serialized:!0,language:z.language,scheme:this._transformScheme(z.scheme),pattern:typeof z.pattern=="undefined"?void 0:T.GlobPattern.from(z.pattern),exclusive:z.exclusive}}_transformScheme(z){return this._uriTransformer&&typeof z=="string"?this._uriTransformer.transformOutgoingScheme(z):z}_createDisposable(z){return new A.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return Ce._handlePool++}_withAdapter(z,Y,ee,le,me=!1){const De=this._adapter.get(z);if(!De)return Promise.resolve(le);if(De.adapter instanceof Y){let Oe;De.extension&&(Oe=Date.now(),this._logService.trace(`[${De.extension.identifier.value}] INVOKE provider '${Y.name}'`));const be=ee(De.adapter,De.extension),Pe=De.extension;return Pe&&Promise.resolve(be).then(()=>this._logService.trace(`[${Pe.identifier.value}] provider DONE after ${Date.now()-Oe}ms`),Re=>{me&&Re instanceof S.CancellationError||(this._logService.error(`[${Pe.identifier.value}] provider FAILED`),this._logService.error(Re))}),be}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(z,Y){const ee=this._nextHandle();return this._adapter.set(ee,new Ie(z,Y)),ee}static _extLabel(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,Y,ee,le){const me=this._addNewAdapter(new d(this._documents,ee),z),De=le&&le.label||Ce._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(me,this._transformDocumentSelector(Y),De),this._createDisposable(me)}$provideDocumentSymbols(z,Y,ee){return this._withAdapter(z,d,le=>le.provideDocumentSymbols(_.URI.revive(Y),ee),void 0)}registerCodeLensProvider(z,Y,ee){const le=this._nextHandle(),me=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new Ie(new l(this._documents,this._commands.converter,ee),z)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(Y),me);let De=this._createDisposable(le);if(me!==void 0){const Oe=ee.onDidChangeCodeLenses(be=>this._proxy.$emitCodeLensEvent(me));De=A.Disposable.from(De,Oe)}return De}$provideCodeLenses(z,Y,ee){return this._withAdapter(z,l,le=>le.provideCodeLenses(_.URI.revive(Y),ee),void 0)}$resolveCodeLens(z,Y,ee){return this._withAdapter(z,l,le=>le.resolveCodeLens(Y,ee),void 0)}$releaseCodeLenses(z,Y){this._withAdapter(z,l,ee=>Promise.resolve(ee.releaseCodeLenses(Y)),void 0)}registerDefinitionProvider(z,Y,ee){const le=this._addNewAdapter(new t(this._documents,ee),z);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(Y)),this._createDisposable(le)}$provideDefinition(z,Y,ee,le){return this._withAdapter(z,t,me=>me.provideDefinition(_.URI.revive(Y),ee,le),[])}registerDeclarationProvider(z,Y,ee){const le=this._addNewAdapter(new n(this._documents,ee),z);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(Y)),this._createDisposable(le)}$provideDeclaration(z,Y,ee,le){return this._withAdapter(z,n,me=>me.provideDeclaration(_.URI.revive(Y),ee,le),[])}registerImplementationProvider(z,Y,ee){const le=this._addNewAdapter(new r(this._documents,ee),z);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(Y)),this._createDisposable(le)}$provideImplementation(z,Y,ee,le){return this._withAdapter(z,r,me=>me.provideImplementation(_.URI.revive(Y),ee,le),[])}registerTypeDefinitionProvider(z,Y,ee){const le=this._addNewAdapter(new i(this._documents,ee),z);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(Y)),this._createDisposable(le)}$provideTypeDefinition(z,Y,ee,le){return this._withAdapter(z,i,me=>me.provideTypeDefinition(_.URI.revive(Y),ee,le),[])}registerHoverProvider(z,Y,ee,le){const me=this._addNewAdapter(new o(this._documents,ee),z);return this._proxy.$registerHoverProvider(me,this._transformDocumentSelector(Y)),this._createDisposable(me)}$provideHover(z,Y,ee,le){return this._withAdapter(z,o,me=>me.provideHover(_.URI.revive(Y),ee,le),void 0)}registerEvaluatableExpressionProvider(z,Y,ee,le){const me=this._addNewAdapter(new c(this._documents,ee),z);return this._proxy.$registerEvaluatableExpressionProvider(me,this._transformDocumentSelector(Y)),this._createDisposable(me)}$provideEvaluatableExpression(z,Y,ee,le){return this._withAdapter(z,c,me=>me.provideEvaluatableExpression(_.URI.revive(Y),ee,le),void 0)}registerInlineValuesProvider(z,Y,ee,le){const me=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,De=this._addNewAdapter(new v(this._documents,ee),z);this._proxy.$registerInlineValuesProvider(De,this._transformDocumentSelector(Y),me);let Oe=this._createDisposable(De);if(me!==void 0){const be=ee.onDidChangeInlineValues(Pe=>this._proxy.$emitInlineValuesEvent(me));Oe=A.Disposable.from(Oe,be)}return Oe}$provideInlineValues(z,Y,ee,le,me){return this._withAdapter(z,v,De=>De.provideInlineValues(_.URI.revive(Y),ee,le,me),void 0)}registerDocumentHighlightProvider(z,Y,ee){const le=this._addNewAdapter(new p(this._documents,ee),z);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(Y)),this._createDisposable(le)}$provideDocumentHighlights(z,Y,ee,le){return this._withAdapter(z,p,me=>me.provideDocumentHighlights(_.URI.revive(Y),ee,le),void 0)}registerLinkedEditingRangeProvider(z,Y,ee){const le=this._addNewAdapter(new h(this._documents,ee),z);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(Y)),this._createDisposable(le)}$provideLinkedEditingRanges(z,Y,ee,le){return this._withAdapter(z,h,async me=>{const De=await me.provideLinkedEditingRanges(_.URI.revive(Y),ee,le);if(De)return{ranges:De.ranges,wordPattern:De.wordPattern?Ce._serializeRegExp(De.wordPattern):void 0}},void 0)}registerReferenceProvider(z,Y,ee){const le=this._addNewAdapter(new b(this._documents,ee),z);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(Y)),this._createDisposable(le)}$provideReferences(z,Y,ee,le,me){return this._withAdapter(z,b,De=>De.provideReferences(_.URI.revive(Y),ee,le,me),void 0)}registerCodeActionProvider(z,Y,ee,le){var me,De;const Oe=new m.DisposableStore,be=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerQuickFixSupport(be,this._transformDocumentSelector(Y),{providedKinds:(me=le==null?void 0:le.providedCodeActionKinds)===null||me===void 0?void 0:me.map(Pe=>Pe.value),documentation:(De=le==null?void 0:le.documentation)===null||De===void 0?void 0:De.map(Pe=>({kind:Pe.kind.value,command:this._commands.converter.toInternal(Pe.command,Oe)}))},Ce._extLabel(z),Boolean(ee.resolveCodeAction)),Oe.add(this._createDisposable(be)),Oe}$provideCodeActions(z,Y,ee,le,me){return this._withAdapter(z,R,De=>De.provideCodeActions(_.URI.revive(Y),ee,le,me),void 0)}$resolveCodeAction(z,Y,ee){return this._withAdapter(z,R,le=>le.resolveCodeAction(Y,ee),void 0)}$releaseCodeActions(z,Y){this._withAdapter(z,R,ee=>Promise.resolve(ee.releaseCodeActions(Y)),void 0)}registerDocumentFormattingEditProvider(z,Y,ee){const le=this._addNewAdapter(new N(this._documents,ee),z);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(Y),z.identifier,z.displayName||z.name),this._createDisposable(le)}$provideDocumentFormattingEdits(z,Y,ee,le){return this._withAdapter(z,N,me=>me.provideDocumentFormattingEdits(_.URI.revive(Y),ee,le),void 0)}registerDocumentRangeFormattingEditProvider(z,Y,ee){const le=this._addNewAdapter(new j(this._documents,ee),z);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(Y),z.identifier,z.displayName||z.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(z,Y,ee,le,me){return this._withAdapter(z,j,De=>De.provideDocumentRangeFormattingEdits(_.URI.revive(Y),ee,le,me),void 0)}registerOnTypeFormattingEditProvider(z,Y,ee,le){const me=this._addNewAdapter(new oe(this._documents,ee),z);return this._proxy.$registerOnTypeFormattingSupport(me,this._transformDocumentSelector(Y),le,z.identifier),this._createDisposable(me)}$provideOnTypeFormattingEdits(z,Y,ee,le,me,De){return this._withAdapter(z,oe,Oe=>Oe.provideOnTypeFormattingEdits(_.URI.revive(Y),ee,le,me,De),void 0)}registerWorkspaceSymbolProvider(z,Y){const ee=this._addNewAdapter(new q(Y,this._logService),z);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(z,Y,ee){return this._withAdapter(z,q,le=>le.provideWorkspaceSymbols(Y,ee),{symbols:[]})}$resolveWorkspaceSymbol(z,Y,ee){return this._withAdapter(z,q,le=>le.resolveWorkspaceSymbol(Y,ee),void 0)}$releaseWorkspaceSymbols(z,Y){this._withAdapter(z,q,ee=>ee.releaseWorkspaceSymbols(Y),void 0)}registerRenameProvider(z,Y,ee){const le=this._addNewAdapter(new W(this._documents,ee,this._logService),z);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(Y),W.supportsResolving(ee)),this._createDisposable(le)}$provideRenameEdits(z,Y,ee,le,me){return this._withAdapter(z,W,De=>De.provideRenameEdits(_.URI.revive(Y),ee,le,me),void 0)}$resolveRenameLocation(z,Y,ee,le){return this._withAdapter(z,W,me=>me.resolveRenameLocation(_.URI.revive(Y),ee,le),void 0)}registerDocumentSemanticTokensProvider(z,Y,ee,le){const me=this._nextHandle(),De=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(me,new Ie(new U(this._documents,ee),z)),this._proxy.$registerDocumentSemanticTokensProvider(me,this._transformDocumentSelector(Y),le,De);let Oe=this._createDisposable(me);if(De){const be=ee.onDidChangeSemanticTokens(Pe=>this._proxy.$emitDocumentSemanticTokensEvent(De));Oe=A.Disposable.from(Oe,be)}return Oe}$provideDocumentSemanticTokens(z,Y,ee,le){return this._withAdapter(z,U,me=>me.provideDocumentSemanticTokens(_.URI.revive(Y),ee,le),null,!0)}$releaseDocumentSemanticTokens(z,Y){this._withAdapter(z,U,ee=>ee.releaseDocumentSemanticColoring(Y),void 0)}registerDocumentRangeSemanticTokensProvider(z,Y,ee,le){const me=this._addNewAdapter(new L(this._documents,ee),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(me,this._transformDocumentSelector(Y),le),this._createDisposable(me)}$provideDocumentRangeSemanticTokens(z,Y,ee,le){return this._withAdapter(z,L,me=>me.provideDocumentRangeSemanticTokens(_.URI.revive(Y),ee,le),null,!0)}registerCompletionItemProvider(z,Y,ee,le){const me=this._addNewAdapter(new F(this._documents,this._commands.converter,ee,this._apiDeprecation,z),z);return this._proxy.$registerSuggestSupport(me,this._transformDocumentSelector(Y),le,F.supportsResolving(ee),`${z.identifier.value}(${le.join("")})`),this._createDisposable(me)}$provideCompletionItems(z,Y,ee,le,me){return this._withAdapter(z,F,De=>De.provideCompletionItems(_.URI.revive(Y),ee,le,me),void 0)}$resolveCompletionItem(z,Y,ee){return this._withAdapter(z,F,le=>le.resolveCompletionItem(Y,ee),void 0)}$releaseCompletionItems(z,Y){this._withAdapter(z,F,ee=>ee.releaseCompletionItems(Y),void 0)}registerSignatureHelpProvider(z,Y,ee,le){const me=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,De=this._addNewAdapter(new O(this._documents,ee),z);return this._proxy.$registerSignatureHelpProvider(De,this._transformDocumentSelector(Y),me),this._createDisposable(De)}$provideSignatureHelp(z,Y,ee,le,me){return this._withAdapter(z,O,De=>De.provideSignatureHelp(_.URI.revive(Y),ee,le,me),void 0)}$releaseSignatureHelp(z,Y){this._withAdapter(z,O,ee=>ee.releaseSignatureHelp(Y),void 0)}registerInlineHintsProvider(z,Y,ee){const le=typeof ee.onDidChangeInlineHints=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new M(this._documents,ee),z);this._proxy.$registerInlineHintsProvider(me,this._transformDocumentSelector(Y),le);let De=this._createDisposable(me);if(le!==void 0){const Oe=ee.onDidChangeInlineHints(be=>this._proxy.$emitInlineHintsEvent(le));De=A.Disposable.from(De,Oe)}return De}$provideInlineHints(z,Y,ee,le){return this._withAdapter(z,M,me=>me.provideInlineHints(_.URI.revive(Y),ee,le),void 0)}registerDocumentLinkProvider(z,Y,ee){const le=this._addNewAdapter(new B(this._documents,ee),z);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(Y),typeof ee.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(z,Y,ee){return this._withAdapter(z,B,le=>le.provideLinks(_.URI.revive(Y),ee),void 0)}$resolveDocumentLink(z,Y,ee){return this._withAdapter(z,B,le=>le.resolveLink(Y,ee),void 0)}$releaseDocumentLinks(z,Y){this._withAdapter(z,B,ee=>ee.releaseLinks(Y),void 0)}registerColorProvider(z,Y,ee){const le=this._addNewAdapter(new V(this._documents,ee),z);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(Y)),this._createDisposable(le)}$provideDocumentColors(z,Y,ee){return this._withAdapter(z,V,le=>le.provideColors(_.URI.revive(Y),ee),[])}$provideColorPresentations(z,Y,ee,le){return this._withAdapter(z,V,me=>me.provideColorPresentations(_.URI.revive(Y),ee,le),void 0)}registerFoldingRangeProvider(z,Y,ee){const le=this._nextHandle(),me=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new Ie(new Q(this._documents,ee),z)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(Y),me);let De=this._createDisposable(le);if(me!==void 0){const Oe=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(me));De=A.Disposable.from(De,Oe)}return De}$provideFoldingRanges(z,Y,ee,le){return this._withAdapter(z,Q,me=>me.provideFoldingRanges(_.URI.revive(Y),ee,le),void 0)}registerSelectionRangeProvider(z,Y,ee){const le=this._addNewAdapter(new de(this._documents,ee,this._logService),z);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(Y)),this._createDisposable(le)}$provideSelectionRanges(z,Y,ee,le){return this._withAdapter(z,de,me=>me.provideSelectionRanges(_.URI.revive(Y),ee,le),[])}registerCallHierarchyProvider(z,Y,ee){const le=this._addNewAdapter(new we(this._documents,ee),z);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(Y)),this._createDisposable(le)}$prepareCallHierarchy(z,Y,ee,le){return this._withAdapter(z,we,me=>Promise.resolve(me.prepareSession(_.URI.revive(Y),ee,le)),void 0)}$provideCallHierarchyIncomingCalls(z,Y,ee,le){return this._withAdapter(z,we,me=>me.provideCallsTo(Y,ee,le),void 0)}$provideCallHierarchyOutgoingCalls(z,Y,ee,le){return this._withAdapter(z,we,me=>me.provideCallsFrom(Y,ee,le),void 0)}$releaseCallHierarchy(z,Y){this._withAdapter(z,we,ee=>Promise.resolve(ee.releaseSession(Y)),void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:(0,D.regExpFlags)(z)}}static _serializeIndentationRule(z){return{decreaseIndentPattern:Ce._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:Ce._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Ce._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Ce._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:Ce._serializeRegExp(z.beforeText),afterText:z.afterText?Ce._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?Ce._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(Ce._serializeOnEnterRule)}setLanguageConfiguration(z,Y,ee){let{wordPattern:le}=ee;if(le&&(0,D.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(Y,le):this._documents.setWordDefinitionFor(Y,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const me=this._nextHandle(),De={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?Ce._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?Ce._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?Ce._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(me,Y,De),this._createDisposable(me)}$setWordDefinitions(z){for(const Y of z)this._documents.setWordDefinitionFor(Y.languageId,new RegExp(Y.regexSource,Y.regexFlags))}}e.ExtHostLanguageFeatures=Ce,Ce._handlePool=0}),define(ge[240],pe([0,1,5,20,7]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class A{constructor(k,D){this._proxy=k.getProxy(_.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(k,D){await this._proxy.$changeLanguage(k,D);const P=this._documents.getDocumentData(k);if(!P)throw new Error(`document '${k.toString}' NOT found`);return P.document}async tokenAtPosition(k,D){var P;const s=k.version,C=I.Position.from(D),g=await this._proxy.$tokensAtPosition(k.uri,C),m={type:T.StandardTokenType.Other,range:(P=k.getWordRangeAtPosition(D))!==null&&P!==void 0?P:new T.Range(D.line,D.character,D.line,D.character)};if(!g)return m;const a={range:I.Range.to(g.range),type:I.TokenType.to(g.type)};return!a.range.contains(D)||s!==k.version?m:a}}e.ExtHostLanguages=A}),define(ge[241],pe([0,1,5,13,41]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(k){return k&&k.title}let y=class{constructor(D,P){this._logService=P,this._proxy=D.getProxy(_.MainContext.MainThreadMessageService)}showMessage(D,P,s,C,g){const m={extension:D};let a;typeof C=="string"||A(C)?a=[C,...g]:(m.modal=C&&C.modal,m.useCustom=C&&C.useCustom,a=g),m.useCustom&&(0,T.checkProposedApiEnabled)(D);const u=[];for(let E=0;E<a.length;E++){const w=a[E];if(typeof w=="string")u.push({title:w,handle:E,isCloseAffordance:!1});else if(typeof w=="object"){let{title:S,isCloseAffordance:d}=w;u.push({title:S,isCloseAffordance:!!d,handle:E})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(P,s,m,u).then(E=>{if(typeof E=="number")return a[E]})}};y=Ve([xe(1,I.ILogService)],y),e.ExtHostMessageService=y}),define(ge[242],pe([0,1,21,3,6,2,5,20,7,89,24,218,219,72,11,22,74,86,9]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a,u,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class d{constructor(r,i){const o=d._Keys.nextId();r.$registerNotebookEditorDecorationType(o,k.NotebookDecorationRenderOptions.from(i)),this.value={key:o,dispose(){r.$removeNotebookEditorDecorationType(o)}}}}e.NotebookEditorDecorationType=d,d._Keys=new m.IdGenerator("NotebookEditorDecorationType");class l{constructor(r,i,o,c,v,p){this._textDocumentsAndEditors=o,this._textDocuments=c,this.logService=v,this._extensionStoragePaths=p,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new s.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new I.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new I.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new I.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new I.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new I.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new I.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new I.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new I.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new I.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new I.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new I.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new I.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new s.ResourceMap,this._statusBarCache=new w.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=r.getProxy(y.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=r.getProxy(y.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=r.getProxy(y.MainContext.MainThreadNotebookEditors),this._commandsConverter=i.converter,i.registerArgumentProcessor({processArgument:h=>{var b;if(h&&h.$mid===12){const R=(b=h.notebookEditor)===null||b===void 0?void 0:b.notebookUri,N=h.cell.handle,j=this._documents.get(R),oe=j==null?void 0:j.getCell(N);if(oe)return oe.apiCell}return h}})}get activeNotebookEditor(){var r;return(r=this._activeNotebookEditor)===null||r===void 0?void 0:r.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(r=>r.apiEditor)}getEditorById(r){return this._editors.get(r)}getIdByEditor(r){for(const[i,o]of this._editors)if(o.apiEditor===r)return i}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(r){return this._documents.get(r)}_getNotebookDocument(r){const i=this._documents.get(r);if(!i)throw new Error(`NO notebook document for '${r}'`);return i}_getProviderData(r){const i=this._notebookContentProviders.get(r);if(!i)throw new Error(`NO provider for '${r}'`);return i}registerNotebookContentProvider(r,i,o,c){var v,p,h;if((0,S.isFalsyOrWhitespace)(i))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(i))throw new Error(`Notebook provider for '${i}' already registered`);this._notebookContentProviders.set(i,{extension:r,provider:o});let b;o.onDidChangeNotebookContentOptions&&(b=o.onDidChangeNotebookContentOptions(()=>{const j=k.NotebookDocumentContentOptions.from(o.options);this._notebookProxy.$updateNotebookProviderOptions(i,j)}));const R=(v=c==null?void 0:c.viewOptions)===null||v===void 0?void 0:v.filenamePattern.map(j=>k.NotebookExclusiveDocumentPattern.from(j)).filter(j=>j!==void 0);((p=c==null?void 0:c.viewOptions)===null||p===void 0?void 0:p.filenamePattern)&&!R&&console.warn(`Notebook content provider view options file name pattern is invalid ${(h=c==null?void 0:c.viewOptions)===null||h===void 0?void 0:h.filenamePattern}`);const N=k.NotebookDocumentContentOptions.from(c);return this._notebookProxy.$registerNotebookProvider({id:r.identifier,location:r.extensionLocation,description:r.description},i,{transientOutputs:N.transientOutputs,transientCellMetadata:N.transientCellMetadata,transientDocumentMetadata:N.transientDocumentMetadata,viewOptions:(c==null?void 0:c.viewOptions)&&R?{displayName:c.viewOptions.displayName,filenamePattern:R,exclusive:c.viewOptions.exclusive||!1}:void 0}),new D.Disposable(()=>{b==null||b.dispose(),this._notebookContentProviders.delete(i),this._notebookProxy.$unregisterNotebookProvider(i)})}registerNotebookCellStatusBarItemProvider(r,i,o){const c=l._notebookStatusBarItemProviderHandlePool++,v=typeof o.onDidChangeCellStatusBarItems=="function"?l._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(c,o),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(c,v,i);let p;return v!==void 0&&(p=o.onDidChangeCellStatusBarItems(h=>this._notebookProxy.$emitCellStatusBarEvent(v))),new D.Disposable(()=>{this._notebookStatusBarItemProviders.delete(c),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(c,v),p&&p.dispose()})}createNotebookEditorDecorationType(r){return new d(this._notebookEditorsProxy,r).value}async openNotebookDocument(r){const i=this._documents.get(r);if(i)return i.apiNotebook;const o=await this._notebookDocumentsProxy.$tryOpenDocument(r),c=this._documents.get(A.URI.revive(o));return(0,a.assertIsDefined)(c==null?void 0:c.apiNotebook)}async showNotebookDocument(r,i){var o;A.URI.isUri(r)&&(r=await this.openNotebookDocument(r));let c;typeof i=="object"?c={position:k.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus,selections:i.selections&&i.selections.map(k.NotebookRange.from),pinned:typeof i.preview=="boolean"?!i.preview:void 0}:c={preserveFocus:!1};const v=await this._notebookEditorsProxy.$tryShowNotebookDocument(r.uri,r.viewType,c),p=v&&((o=this._editors.get(v))===null||o===void 0?void 0:o.apiEditor);if(p)return p;throw v?new Error(`Could NOT open editor for "${r.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${r.toString()}".`)}async $provideNotebookCellStatusBarItems(r,i,o,c){var v;const p=this._notebookStatusBarItemProviders.get(r),h=A.URI.revive(i),b=this._documents.get(h);if(!(!b||!p)){const R=b.getCellFromIndex(o);if(!!R){const N=await p.provideCellStatusBarItems(R.apiCell,c);if(!!N){const j=new T.DisposableStore,oe=this._statusBarCache.add([j]),q=(v=N&&N.map(W=>k.NotebookStatusBarItem.from(W,this._commandsConverter,j)))!==null&&v!==void 0?v:void 0;return{cacheId:oe,items:q}}}}}$releaseNotebookCellStatusBarItems(r){this._statusBarCache.delete(r)}registerNotebookSerializer(r,i,o,c){if((0,S.isFalsyOrWhitespace)(i))throw new Error("viewType cannot be empty or just whitespace");const v=this._handlePool++;this._notebookSerializer.set(v,o);const p=k.NotebookDocumentContentOptions.from(c);return this._notebookProxy.$registerNotebookSerializer(v,{id:r.identifier,location:r.extensionLocation,description:r.description},i,p),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(v)})}async $dataToNotebook(r,i,o){const c=this._notebookSerializer.get(r);if(!c)throw new Error("NO serializer found");const v=await c.deserializeNotebook(i.buffer,o);return{metadata:k.NotebookDocumentMetadata.from(v.metadata),cells:v.cells.map(k.NotebookCellData.from)}}async $notebookToData(r,i,o){const c=this._notebookSerializer.get(r);if(!c)throw new Error("NO serializer found");const v=await c.serializeNotebook({metadata:k.NotebookDocumentMetadata.to(i.metadata),cells:i.cells.map(k.NotebookCellData.to)},o);return u.VSBuffer.wrap(v)}cancelOneNotebookCellExecution(r){const i=this._activeExecutions.get(r.uri);i==null||i.cancel()}async $openNotebook(r,i,o,c,v){const{provider:p}=this._getProviderData(r),h=await p.openNotebook(A.URI.revive(i),{backupId:o,untitledDocumentData:c==null?void 0:c.buffer},v);return{metadata:k.NotebookDocumentMetadata.from(h.metadata),cells:h.cells.map(k.NotebookCellData.from)}}async $saveNotebook(r,i,o){const c=this._getNotebookDocument(A.URI.revive(i)),{provider:v}=this._getProviderData(r);return await v.saveNotebook(c.apiNotebook,o),!0}async $saveNotebookAs(r,i,o,c){const v=this._getNotebookDocument(A.URI.revive(i)),{provider:p}=this._getProviderData(r);return await p.saveNotebookAs(A.URI.revive(o),v.apiNotebook,c),!0}async $backupNotebook(r,i,o){var c;const v=this._getNotebookDocument(A.URI.revive(i)),p=this._getProviderData(r),h=(c=this._extensionStoragePaths.workspaceValue(p.extension))!==null&&c!==void 0?c:this._extensionStoragePaths.globalValue(p.extension),b=String((0,E.hash)([v.uri.toString(),this._backupIdPool++])),R=A.URI.joinPath(h,b),N=await p.provider.backupNotebook(v.apiNotebook,{destination:R},o);return v.updateBackup(N),N.id}$acceptModelChanged(r,i,o){this._getNotebookDocument(A.URI.revive(r)).acceptModelChanged(i,o)}$acceptDirtyStateChanged(r,i){const o=this._getNotebookDocument(A.URI.revive(r));o.acceptModelChanged({rawEvents:[],versionId:o.apiNotebook.version},i)}$acceptModelSaved(r){const i=this._getNotebookDocument(A.URI.revive(r));this._onDidSaveNotebookDocument.fire(i.apiNotebook)}$acceptEditorPropertiesChanged(r,i){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",r,i);const o=this._editors.get(r);if(!o)throw new Error(`unknown text editor: ${r}. known editors: ${[...this._editors.keys()]} `);i.visibleRanges&&o._acceptVisibleRanges(i.visibleRanges.ranges.map(k.NotebookRange.to)),i.selections&&o._acceptSelections(i.selections.selections.map(k.NotebookRange.to)),i.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:o.apiEditor,visibleRanges:o.apiEditor.visibleRanges}),i.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:o.apiEditor,selections:o.apiEditor.selections}))}$acceptEditorViewColumns(r){for(const i in r){const o=this._editors.get(i);if(!o)throw new Error(`unknown text editor: ${i}. known editors: ${[...this._editors.keys()]} `);o._acceptViewColumn(k.ViewColumn.to(r[i]))}}$acceptDocumentPropertiesChanged(r,i){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",r.path,i);const o=this._getNotebookDocument(A.URI.revive(r));o.acceptDocumentPropertiesChanged(i),i.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:o.apiNotebook})}_createExtHostEditor(r,i,o){if(this._editors.has(i))throw new Error(`editor with id ALREADY EXSIST: ${i}`);const c=new g.ExtHostNotebookEditor(i,this._notebookEditorsProxy,r,o.visibleRanges.map(k.NotebookRange.to),o.selections.map(k.NotebookRange.to),typeof o.viewColumn=="number"?k.ViewColumn.to(o.viewColumn):void 0);this._editors.set(i,c)}$acceptDocumentAndEditorsDelta(r){var i,o,c;if(r.removedDocuments)for(const p of r.removedDocuments){const h=A.URI.revive(p),b=this._documents.get(h);b&&(b.dispose(),this._documents.delete(h),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(R=>R.document.uri)}),this._onDidCloseNotebookDocument.fire(b.apiNotebook));for(const R of this._editors.values())R.notebookData.uri.toString()===h.toString()&&this._editors.delete(R.id)}if(r.addedDocuments){const p=[];for(const h of r.addedDocuments){const b=A.URI.revive(h.uri),R=h.viewType;if(this._documents.has(b))throw new Error(`adding EXISTING notebook ${b} `);const N=this,j=new C.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(oe){N._onDidChangeNotebookCells.fire(oe)},emitCellOutputsChange(oe){N._onDidChangeCellOutputs.fire(oe)},emitCellMetadataChange(oe){N._onDidChangeCellMetadata.fire(oe)},emitCellExecutionStateChange(oe){N._onDidChangeCellExecutionState.fire(oe)}},R,h.metadata?k.NotebookDocumentMetadata.to(h.metadata):new D.NotebookDocumentMetadata,b);j.acceptModelChanged({versionId:h.versionId,rawEvents:[{kind:P.NotebookCellsChangeType.Initialize,changes:[[0,0,h.cells]]}]},!1),p.push(...h.cells.map(oe=>C.ExtHostCell.asModelAddData(j.apiNotebook,oe))),(i=this._documents.get(b))===null||i===void 0||i.dispose(),this._documents.set(b,j),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this._onDidOpenNotebookDocument.fire(j.apiNotebook)}}if(r.addedEditors)for(const p of r.addedEditors){if(this._editors.has(p.id))return;const h=A.URI.revive(p.documentUri),b=this._documents.get(h);b&&this._createExtHostEditor(b,p.id,p)}const v=[];if(r.removedEditors)for(const p of r.removedEditors){const h=this._editors.get(p);h&&(this._editors.delete(p),((o=this._activeNotebookEditor)===null||o===void 0?void 0:o.id)===h.id&&(this._activeNotebookEditor=void 0),v.push(h))}if(r.visibleEditors){this._visibleNotebookEditors=r.visibleEditors.map(h=>this._editors.get(h)).filter(h=>!!h);const p=new Set;this._visibleNotebookEditors.forEach(h=>p.add(h.id));for(const h of this._editors.values()){const b=p.has(h.id);h._acceptVisibility(b)}this._visibleNotebookEditors=[...this._editors.values()].map(h=>h).filter(h=>h.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}r.newActiveEditor===null?this._activeNotebookEditor=void 0:r.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(r.newActiveEditor)),r.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((c=this._activeNotebookEditor)===null||c===void 0?void 0:c.apiEditor)}createNotebookCellExecution(r,i,o){const c=this.lookupNotebookDocument(r);if(!c)throw new Error(`Invalid uri: ${r} `);const v=c.getCellFromIndex(i);if(!v)throw new Error(`Invalid cell index: ${r}, ${i} `);if(this._activeExecutions.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const p=new t(r,c,v,this._notebookDocumentsProxy);this._activeExecutions.set(v.uri,p);const h=p.onDidChangeState(()=>{p.state===f.Resolved&&(p.dispose(),h.dispose(),this._activeExecutions.delete(v.uri))});return p.asApiObject()}}e.ExtHostNotebookController=l,l._notebookStatusBarItemProviderHandlePool=0;var f;(function(n){n[n.Init=0]="Init",n[n.Started=1]="Started",n[n.Resolved=2]="Resolved"})(f||(f={}));class t extends T.Disposable{constructor(r,i,o,c){super();this._uri=r,this._document=i,this._cell=o,this._proxy=c,this._onDidChangeState=new I.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=f.Init,this._tokenSource=this._register(new _.CancellationTokenSource),this._executionOrder=o.internalMetadata.executionOrder,this.mixinMetadata({runState:D.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEdits(r){return this._proxy.$applyEdits(this._uri,r,!1)}verifyStateForOutput(){if(this._state===f.Init)throw new Error("Must call start before modifying cell output");if(this._state===f.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(r){const i=[{editType:11,handle:this._cell.handle,metadata:r}];this.applyEdits(i)}cellIndexToHandle(r){const i=typeof r=="number"?this._document.getCellFromIndex(r):this._cell;if(!!i)return i.handle}asApiObject(){const r=this;return Object.freeze({get document(){return r._document.apiNotebook},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(i){r._executionOrder=i,r.mixinMetadata({executionOrder:i})},start(i){var o;if(r._state===f.Resolved||r._state===f.Started)throw new Error("Cannot call start again");r._state=f.Started,r._onDidChangeState.fire(),r.mixinMetadata({runState:D.NotebookCellExecutionState.Executing,runStartTime:(o=i==null?void 0:i.startTime)!==null&&o!==void 0?o:null})},end(i){var o,c;if(r._state===f.Resolved)throw new Error("Cannot call resolve twice");r._state=f.Resolved,r._onDidChangeState.fire(),r.mixinMetadata({runState:D.NotebookCellExecutionState.Idle,lastRunSuccess:(o=i==null?void 0:i.success)!==null&&o!==void 0?o:null,runEndTime:(c=i==null?void 0:i.endTime)!==null&&c!==void 0?c:null})},clearOutput(i){return r.verifyStateForOutput(),this.replaceOutput([],i)},async appendOutput(i,o){r.verifyStateForOutput();const c=r.cellIndexToHandle(o);if(typeof c=="number")return i=Array.isArray(i)?i:[i],r.applyEdits([{editType:2,handle:c,append:!0,outputs:i.map(k.NotebookCellOutput.from)}])},async replaceOutput(i,o){r.verifyStateForOutput();const c=r.cellIndexToHandle(o);if(typeof c=="number")return i=Array.isArray(i)?i:[i],r.applyEdits([{editType:2,handle:c,outputs:i.map(k.NotebookCellOutput.from)}])},async appendOutputItems(i,o){return r.verifyStateForOutput(),i=Array.isArray(i)?i:[i],r.applyEdits([{editType:10,append:!0,items:i.map(k.NotebookCellOutputItem.from),outputId:o}])},async replaceOutputItems(i,o){return r.verifyStateForOutput(),i=Array.isArray(i)?i:[i],r.applyEdits([{editType:10,items:i.map(k.NotebookCellOutputItem.from),outputId:o}])},token:r._tokenSource.token})}}}),define(ge[243],pe([0,1,3,6,5,2,20,88]),function(K,e,_,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class D{constructor(s,C,g){this._initData=C,this._extHostNotebook=g,this._kernelData=new Map,this._handlePool=0,this._proxy=s.getProxy(T.MainContext.MainThreadNotebookKernels)}createNotebookController(s,C,g,m,a,u){for(let p of this._kernelData.values())if(p.controller.id===C)throw new Error(`notebook controller with id '${C}' ALREADY exist`);const E=this._handlePool++,w=this,S=()=>console.warn(`NO execute handler from notebook controller '${n.id}' of extension: '${s.identifier}'`);let d=!1;const l=new I.DisposableStore,f=new _.Emitter,t=new _.Emitter,n={id:C,selector:g,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:m||s.identifier.value,preloads:u?u.map(y.NotebookKernelPreload.from):[]};let r=a!=null?a:S,i;this._proxy.$addKernel(E,n).catch(p=>{console.log(p),d=!0});let o=0;const c=()=>{if(!d){const p=++o;Promise.resolve().then(()=>{p===o&&this._proxy.$updateKernel(E,n)})}},v={get id(){return n.id},get selector(){return n.selector},onDidChangeNotebookAssociation:f.event,get label(){return n.label},set label(p){var h;n.label=(h=p!=null?p:s.displayName)!==null&&h!==void 0?h:s.name,c()},get detail(){var p;return(p=n.detail)!==null&&p!==void 0?p:""},set detail(p){n.detail=p,c()},get description(){var p;return(p=n.description)!==null&&p!==void 0?p:""},set description(p){n.description=p,c()},get isPreferred(){var p;return(p=n.isPreferred)!==null&&p!==void 0?p:!1},set isPreferred(p){n.isPreferred=p,c()},get supportedLanguages(){var p;return(p=n.supportedLanguages)!==null&&p!==void 0?p:[]},set supportedLanguages(p){n.supportedLanguages=p,c()},get hasExecutionOrder(){var p;return(p=n.hasExecutionOrder)!==null&&p!==void 0?p:!1},set hasExecutionOrder(p){n.hasExecutionOrder=p,c()},get preloads(){return n.preloads?n.preloads.map(y.NotebookKernelPreload.to):[]},get executeHandler(){return r},set executeHandler(p){r=p!=null?p:S},get interruptHandler(){return i},set interruptHandler(p){i=p,n.supportsInterrupt=Boolean(p),c()},createNotebookCellExecutionTask(p){if(d)throw new Error("notebook controller is DISPOSED");return w._extHostNotebook.createNotebookCellExecution(p.notebook.uri,p.index,n.id)},dispose:()=>{d||(d=!0,this._kernelData.delete(E),l.dispose(),f.dispose(),t.dispose(),this._proxy.$removeKernel(E))},onDidReceiveMessage:t.event,postMessage(p,h){return w._proxy.$postMessage(E,h&&w._extHostNotebook.getIdByEditor(h),p)},asWebviewUri(p){return(0,k.asWebviewUri)(w._initData.environment,String(E),p)}};return this._kernelData.set(E,{extensionId:s.identifier,controller:v,onDidChangeSelection:f,onDidReceiveMessage:t}),v}$acceptSelection(s,C,g){const m=this._kernelData.get(s);m&&m.onDidChangeSelection.fire({selected:g,notebook:this._extHostNotebook.lookupNotebookDocument(A.URI.revive(C)).apiNotebook})}async $executeCells(s,C,g){const m=this._kernelData.get(s);if(!!m){const a=this._extHostNotebook.lookupNotebookDocument(A.URI.revive(C));if(!a)throw new Error("MISSING notebook");const u=[];for(let E of g){const w=a.getCell(E);w&&u.push(w.apiCell)}try{await m.controller.executeHandler.call(m.controller,u,m.controller)}catch(E){console.error(E)}}}async $cancelCells(s,C,g){const m=this._kernelData.get(s);if(!!m){const a=this._extHostNotebook.lookupNotebookDocument(A.URI.revive(C));if(!a)throw new Error("MISSING notebook");m.controller.interruptHandler&&await m.controller.interruptHandler.call(m.controller);for(let u of g){const E=a.getCell(u);E&&this._extHostNotebook.cancelOneNotebookCellExecution(E)}}}$acceptRendererMessage(s,C,g){const m=this._kernelData.get(s);if(!!m){const a=this._extHostNotebook.getEditorById(C);if(!a)throw new Error(`send message for UNKNOWN editor: ${C}`);m.onDidReceiveMessage.fire(Object.freeze({editor:a.apiEditor,message:g}))}}}e.ExtHostNotebookKernels=D}),define(ge[64],pe([0,1,5,3,6,22,4,14]),function(K,e,_,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends T.Disposable{constructor(a,u,E,w){super();this._onDidAppend=this._register(new I.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=a,this._proxy=w,this._id=w.$register(this.name,u,E),this._disposed=!1,this._offset=0}get name(){return this._name}append(a){this.validate(),this._offset+=a?A.VSBuffer.fromString(a).byteLength:0}update(){this._id.then(a=>this._proxy.$update(a))}appendLine(a){this.validate(),this.append(a+`
`)}clear(){this.validate();const a=this._offset;this._id.then(u=>this._proxy.$clear(u,a))}show(a,u){this.validate(),this._id.then(E=>this._proxy.$reveal(E,!!(typeof a=="boolean"?a:u)))}hide(){this.validate(),this._id.then(a=>this._proxy.$close(a))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(a=>this._proxy.$dispose(a)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class P extends D{constructor(a,u){super(a,!1,void 0,u)}append(a){super.append(a),this._id.then(u=>this._proxy.$append(u,a)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class s extends D{constructor(a,u,E){super(a,!0,u,E)}append(a){throw new Error("Not supported")}}class C{constructor(a,u){this.name=a,this._channel=u}append(a){this._channel.then(u=>u.append(a))}appendLine(a){this._channel.then(u=>u.appendLine(a))}clear(){this._channel.then(a=>a.clear())}show(a,u){this._channel.then(E=>E.show(a,u))}hide(){this._channel.then(a=>a.hide())}dispose(){this._channel.then(a=>a.dispose())}}e.LazyOutputChannel=C;let g=class{constructor(a){this._proxy=a.getProxy(_.MainContext.MainThreadOutputService)}$setVisibleChannel(a){}createOutputChannel(a){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");return new P(a,this._proxy)}createOutputChannelFromLogFile(a,u){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");if(!u)throw new Error("illegal argument `file`. must not be falsy");return new s(a,u,this._proxy)}};g=Ve([xe(0,k.IExtHostRpcService)],g),e.ExtHostOutputService=g,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(ge[244],pe([0,1,15,21,3,6,5,2,7,18,19,57]),function(K,e,_,I,T,A,y,k,D,P,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(m,a,u){const E=m.getProxy(y.MainContext.MainThreadQuickOpen);class w{constructor(i,o){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=o}showQuickPick(i,o,c,v=I.CancellationToken.None){this._onDidSelectItem=void 0;const p=Promise.resolve(i),h=++this._instances,b=E.$show(h,{title:c==null?void 0:c.title,placeHolder:c==null?void 0:c.placeHolder,matchOnDescription:c==null?void 0:c.matchOnDescription,matchOnDetail:c==null?void 0:c.matchOnDetail,ignoreFocusLost:c==null?void 0:c.ignoreFocusOut,canPickMany:c==null?void 0:c.canPickMany},v),R={},N=b.then(()=>R);return Promise.race([N,p]).then(j=>{if(j!==R)return p.then(oe=>{const q=[];for(let W=0;W<oe.length;W++){const H=oe[W];let U,L,F,O,M;typeof H=="string"?U=H:(U=H.label,L=H.description,F=H.detail,O=H.picked,M=H.alwaysShow),q.push({label:U,description:L,handle:W,detail:F,picked:O,alwaysShow:M})}return c&&typeof c.onDidSelectItem=="function"&&(this._onDidSelectItem=W=>{c.onDidSelectItem(oe[W])}),E.$setItems(h,q),b.then(W=>{if(typeof W=="number")return oe[W];if(Array.isArray(W))return W.map(H=>oe[H])})})}).then(void 0,j=>{if(!(0,P.isPromiseCanceledError)(j))return E.$setError(h,j),Promise.reject(j)})}$onItemSelected(i){this._onDidSelectItem&&this._onDidSelectItem(i)}showInput(i,o=I.CancellationToken.None){return this._validateInput=i?i.validateInput:void 0,E.$input(i,typeof this._validateInput=="function",o).then(void 0,c=>{if(!(0,P.isPromiseCanceledError)(c))return Promise.reject(c)})}$validateInput(i){return this._validateInput?(0,_.asPromise)(()=>this._validateInput(i)):Promise.resolve(void 0)}async showWorkspaceFolderPick(i,o=I.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!!c){const v=await this._workspace.getWorkspaceFolders2();if(!!v)return v.find(p=>p.uri.toString()===c.uri.toString())}}createQuickPick(i,o){const c=new t(i,o,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}createInputBox(i){const o=new n(i,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}$onDidChangeValue(i,o){const c=this._sessions.get(i);c&&c._fireDidChangeValue(o)}$onDidAccept(i){const o=this._sessions.get(i);o&&o._fireDidAccept()}$onDidChangeActive(i,o){const c=this._sessions.get(i);c instanceof t&&c._fireDidChangeActive(o)}$onDidChangeSelection(i,o){const c=this._sessions.get(i);c instanceof t&&c._fireDidChangeSelection(o)}$onDidTriggerButton(i,o){const c=this._sessions.get(i);c&&c._fireDidTriggerButton(o)}$onDidHide(i){const o=this._sessions.get(i);o&&o._fireDidHide()}}class S{constructor(i,o){this._extensionId=i,this._onDidDispose=o,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new T.Emitter,this._onDidChangeValueEmitter=new T.Emitter,this._onDidTriggerButtonEmitter=new T.Emitter,this._onDidHideEmitter=new T.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((o,c)=>{const v=o===D.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(v,o)}),this.update({buttons:i.map((o,c)=>({iconPath:d(o.iconPath),tooltip:o.tooltip,handle:o===D.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const o=this._handlesToButtons.get(i);o&&this._onDidTriggerButtonEmitter.fire(o)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),E.$dispose(this._id))}update(i){if(!this._disposed){for(const o of Object.keys(i)){const c=i[o];this._pendingUpdate[o]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){E.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}S._nextId=1;function d(r){if(r instanceof D.ThemeIcon)return{id:r.id};const i=f(r),o=l(r);return{dark:typeof i=="string"?k.URI.file(i):i,light:typeof o=="string"?k.URI.file(o):o}}function l(r){return typeof r=="object"&&"light"in r?r.light:r}function f(r){return typeof r=="object"&&"dark"in r?r.dark:r}class t extends S{constructor(i,o,c){super(i,c);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new T.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new T.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((o,c)=>{this._handlesToItems.set(c,o),this._itemsToHandles.set(o,c)}),this.update({items:i.map((o,c)=>({label:o.label,description:o.description,handle:c,detail:o.detail,picked:o.picked,alwaysShow:o.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(o=>this._itemsToHandles.has(o)),this.update({activeItems:this._activeItems.map(o=>this._itemsToHandles.get(o))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(o=>this._itemsToHandles.has(o)),this.update({selectedItems:this._selectedItems.map(o=>this._itemsToHandles.get(o))})}_fireDidChangeActive(i){const o=(0,s.coalesce)(i.map(c=>this._handlesToItems.get(c)));this._activeItems=o,this._onDidChangeActiveEmitter.fire(o)}_fireDidChangeSelection(i){const o=(0,s.coalesce)(i.map(c=>this._handlesToItems.get(c)));this._selectedItems=o,this._onDidChangeSelectionEmitter.fire(o)}}class n extends S{constructor(i,o){super(i,o);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,this.update({validationMessage:i,severity:i?C.default.Error:C.default.Ignore})}}return new w(a,u)}e.createExtHostQuickOpen=g}),define(ge[245],pe([0,1,2,3,70,6,15,5,19,99,13,28,41]),function(K,e,_,I,T,A,y,k,D,P,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function m(i){if(i)return typeof i.iconPath=="string"?_.URI.file(i.iconPath):i.iconPath}function a(i,o){if(!i.iconPath&&!o.iconPath)return 0;if(i.iconPath){if(!o.iconPath)return 1}else return-1;const c=typeof i.iconPath=="string"?i.iconPath:i.iconPath.fsPath,v=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath;return(0,P.comparePaths)(c,v)}function u(i,o){let c=0;if(i.strikeThrough!==o.strikeThrough)return i.strikeThrough?1:-1;if(i.faded!==o.faded)return i.faded?1:-1;if(i.tooltip!==o.tooltip)return(i.tooltip||"").localeCompare(o.tooltip||"");if(c=a(i,o),c!==0)return c;if(i.light&&o.light)c=a(i.light,o.light);else{if(i.light)return 1;if(o.light)return-1}if(c!==0)return c;if(i.dark&&o.dark)c=a(i.dark,o.dark);else{if(i.dark)return 1;if(o.dark)return-1}return c}function E(i,o){if(i.command!==o.command)return i.command<o.command?-1:1;if(i.title!==o.title)return i.title<o.title?-1:1;if(i.tooltip!==o.tooltip){if(i.tooltip!==void 0&&o.tooltip!==void 0)return i.tooltip<o.tooltip?-1:1;if(i.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(i.arguments===o.arguments)return 0;if(i.arguments)if(o.arguments){if(i.arguments.length!==o.arguments.length)return i.arguments.length-o.arguments.length}else return 1;else return-1;for(let c=0;c<i.arguments.length;c++){const v=i.arguments[c],p=o.arguments[c];if(v!==p)return v<p?-1:1}return 0}function w(i,o){let c=(0,P.comparePaths)(i.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(c!==0)return c;if(i.command&&o.command)c=E(i.command,o.command);else{if(i.command)return 1;if(o.command)return-1}if(c!==0)return c;if(i.decorations&&o.decorations)c=u(i.decorations,o.decorations);else{if(i.decorations)return 1;if(o.decorations)return-1}return c}function S(i,o){for(let c=0;c<i.length;c++)if(i[c]!==o[c])return!1;return!0}function d(i,o){return i.command===o.command&&i.title===o.title&&i.tooltip===o.tooltip&&(i.arguments&&o.arguments?S(i.arguments,o.arguments):i.arguments===o.arguments)}function l(i,o){return(0,D.equals)(i,o,d)}class f{constructor(o,c,v){this._extension=o,this._proxy=c,this._sourceControlHandle=v,this._value="",this._onDidChange=new I.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(o){this._proxy.$setInputBoxValue(this._sourceControlHandle,o),this.updateValue(o)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(o){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,o),this._placeholder=o}get validateInput(){return(0,g.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(o){if((0,g.checkProposedApiEnabled)(this._extension),o&&typeof o!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=o,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!o)}get visible(){return this._visible}set visible(o){o=!!o,this._visible!==o&&(this._visible=o,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,o))}focus(){(0,g.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(o,c){(0,g.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,o,c)}$onInputBoxValueChange(o){this.updateValue(o)}updateValue(o){this._value=o,this._onDidChange.fire(o)}}e.ExtHostSCMInputBox=f;class t{constructor(o,c,v,p,h){this._proxy=o,this._commands=c,this._sourceControlHandle=v,this._id=p,this._label=h,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new I.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new I.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(o){this._label=o,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,o)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(o){this._hideWhenEmpty=o,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(o){this._resourceStates=[...o],this._onDidUpdateResourceStates.fire()}getResourceState(o){return this._resourceStatesMap.get(o)}$executeResourceCommand(o,c){const v=this._resourceStatesCommandsMap.get(o);return v?(0,y.asPromise)(()=>this._commands.executeCommand(v.command,...v.arguments||[],c)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var o;const c=[...this._resourceStates].sort(w),p=(0,D.sortedDiff)(this._resourceSnapshot,c,w).map(R=>{const N=R.toInsert.map(j=>{const oe=this._resourceHandlePool++;this._resourceStatesMap.set(oe,j);const q=j.resourceUri,W=m(j.decorations),H=j.decorations&&m(j.decorations.light)||W,U=j.decorations&&m(j.decorations.dark)||W,L=[];let F;if(j.command)if(j.command.command==="vscode.open"||j.command.command==="vscode.diff"){const de=new A.DisposableStore;F=this._commands.converter.toInternal(j.command,de),this._resourceStatesDisposablesMap.set(oe,de)}else this._resourceStatesCommandsMap.set(oe,j.command);H&&L.push(H),U&&U.toString()!==(H==null?void 0:H.toString())&&L.push(U);const O=j.decorations&&j.decorations.tooltip||"",M=j.decorations&&!!j.decorations.strikeThrough,B=j.decorations&&!!j.decorations.faded,V=j.contextValue||"";return{rawResource:[oe,q,L,O,M,B,V,F],handle:oe}});return{start:R.start,deleteCount:R.deleteCount,toInsert:N}}),h=p.map(({start:R,deleteCount:N,toInsert:j})=>[R,N,j.map(oe=>oe.rawResource)]),b=p.reverse();for(const{start:R,deleteCount:N,toInsert:j}of b){const oe=j.map(W=>W.handle),q=this._handlesSnapshot.splice(R,N,...oe);for(const W of q)this._resourceStatesMap.delete(W),this._resourceStatesCommandsMap.delete(W),(o=this._resourceStatesDisposablesMap.get(W))===null||o===void 0||o.dispose(),this._resourceStatesDisposablesMap.delete(W)}return this._resourceSnapshot=c,h}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(o,c,v,p,h,b){this._proxy=c,this._commands=v,this._id=p,this._label=h,this._rootUri=b,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new I.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new f(o,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,p,h,b)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(o){this._count!==o&&(this._count=o,this._proxy.$updateSourceControl(this.handle,{count:o}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(o){this._quickDiffProvider=o,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!o})}get commitTemplate(){return this._commitTemplate}set commitTemplate(o){o!==this._commitTemplate&&(this._commitTemplate=o,this._proxy.$updateSourceControl(this.handle,{commitTemplate:o}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(o){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=o;const c=this._commands.converter.toInternal(o,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:c})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(o){if(!(this._statusBarCommands&&o&&l(this._statusBarCommands,o))){this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=o;const c=(o||[]).map(v=>this._commands.converter.toInternal(v,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:c})}}get selected(){return this._selected}createResourceGroup(o,c){const v=new t(this._proxy,this._commands,this.handle,o,c),p=I.Event.once(v.onDidDispose)(()=>this.createdResourceGroups.delete(v));return this.createdResourceGroups.set(v,p),this.eventuallyAddResourceGroups(),v}eventuallyAddResourceGroups(){const o=[],c=[];for(const[v,p]of this.createdResourceGroups){p.dispose();const h=v.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(v),this.eventuallyUpdateResourceStates()});I.Event.once(v.onDidDispose)(()=>{this.updatedResourceGroups.delete(v),h.dispose(),this._groups.delete(v.handle),this._proxy.$unregisterGroup(this.handle,v.handle)}),o.push([v.handle,v.id,v.label,v.features]);const b=v._takeResourceStateSnapshot();b.length>0&&c.push([v.handle,b]),this._groups.set(v.handle,v)}this._proxy.$registerGroups(this.handle,o,c),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const o=[];this.updatedResourceGroups.forEach(c=>{const v=c._takeResourceStateSnapshot();v.length!==0&&o.push([c.handle,v])}),o.length>0&&this._proxy.$spliceResourceStates(this.handle,o),this.updatedResourceGroups.clear()}getResourceGroup(o){return this._groups.get(o)}setSelectionState(o){this._selected=o,this._onDidChangeSelection.fire(o)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(o=>o.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,Ve([(0,T.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),Ve([(0,T.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let r=class On{constructor(o,c,v){this._commands=c,this.logService=v,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new I.Emitter,this._proxy=o.getProxy(k.MainContext.MainThreadSCM),this._telemetry=o.getProxy(k.MainContext.MainThreadTelemetry),c.registerArgumentProcessor({processArgument:p=>{if(p&&p.$mid===3){const h=this._sourceControls.get(p.sourceControlHandle);if(!h)return p;const b=h.getResourceGroup(p.groupHandle);return b?b.getResourceState(p.handle):p}else if(p&&p.$mid===4){const h=this._sourceControls.get(p.sourceControlHandle);return h?h.getResourceGroup(p.groupHandle):p}else if(p&&p.$mid===5){const h=this._sourceControls.get(p.handle);return h||p}return p}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(o,c,v,p){this.logService.trace("ExtHostSCM#createSourceControl",o.identifier.value,c,v,p),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const h=On._handlePool++,b=new n(o,this._proxy,this._commands,c,v,p);this._sourceControls.set(h,b);const R=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(o.identifier))||[];return R.push(b),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(o.identifier),R),b}getLastInputBox(o){this.logService.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const c=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(o.identifier)),v=c&&c[c.length-1];return v&&v.inputBox}$provideOriginalResource(o,c,v){const p=_.URI.revive(c);this.logService.trace("ExtHostSCM#$provideOriginalResource",o,p.toString());const h=this._sourceControls.get(o);return!h||!h.quickDiffProvider||!h.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>h.quickDiffProvider.provideOriginalResource(p,v)).then(b=>b||null)}$onInputBoxValueChange(o,c){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",o);const v=this._sourceControls.get(o);return v&&v.inputBox.$onInputBoxValueChange(c),Promise.resolve(void 0)}$executeResourceCommand(o,c,v,p){this.logService.trace("ExtHostSCM#$executeResourceCommand",o,c,v);const h=this._sourceControls.get(o);if(!h)return Promise.resolve(void 0);const b=h.getResourceGroup(c);return b?b.$executeResourceCommand(v,p):Promise.resolve(void 0)}$validateInput(o,c,v){this.logService.trace("ExtHostSCM#$validateInput",o);const p=this._sourceControls.get(o);return!p||!p.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>p.inputBox.validateInput(c,v)).then(h=>h?Promise.resolve([h.message,h.type]):Promise.resolve(void 0))}$setSelectedSourceControl(o){var c,v;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&((c=this._sourceControls.get(o))===null||c===void 0||c.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((v=this._sourceControls.get(this._selectedSourceControlHandle))===null||v===void 0||v.setSelectionState(!1)),this._selectedSourceControlHandle=o,Promise.resolve(void 0)}};r._handlePool=0,r=Ve([xe(2,s.ILogService)],r),e.ExtHostSCM=r});var tt=this&&this.__classPrivateFieldSet||function(K,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!T:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(K,_):T?T.value=_:e.set(K,_),_},Ue=this&&this.__classPrivateFieldGet||function(K,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!I:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(K):I?I.value:e.get(K)};define(ge[246],pe([0,1,7,5,164,6]),function(K,e,_,I,T,A){"use strict";var y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class D{constructor(g,m,a,u,E=_.StatusBarAlignment.Left,w,S){y.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,tt(this,y,g,"f"),tt(this,k,m,"f"),this._id=D.ID_GEN++,this._statusId=a,this._statusName=u,this._alignment=E,this._priority=w,this._accessibilityInformation=S}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var g;return(g=this._command)===null||g===void 0?void 0:g.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(g){this._text=g,this.update()}set tooltip(g){this._tooltip=g,this.update()}set color(g){this._color=g,this.update()}set backgroundColor(g){g&&!D.ALLOWED_BACKGROUND_COLORS.has(g.id)&&(g=void 0),this._backgroundColor=g,this.update()}set command(g){var m;((m=this._command)===null||m===void 0?void 0:m.fromApi)!==g&&(this._internalCommandRegistration.clear(),typeof g=="string"?this._command={fromApi:g,internal:Ue(this,k,"f").toInternal({title:"",command:g},this._internalCommandRegistration)}:g?this._command={fromApi:g,internal:Ue(this,k,"f").toInternal(g,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(g){this._accessibilityInformation=g,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,y,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var g;this._timeoutHandle=void 0;let m=this._color;this._backgroundColor&&(m=D.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Ue(this,y,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(g=this._command)===null||g===void 0?void 0:g.internal,m,this._backgroundColor,this._alignment===_.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=D,y=new WeakMap,k=new WeakMap,D.ID_GEN=0,D.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new _.ThemeColor("statusBarItem.errorForeground")]]);class P{constructor(g){this._messages=[],this._item=g.createStatusBarEntry("status.extensionMessage",(0,T.localize)(0,null),_.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(g){const m={message:g};return this._messages.unshift(m),this._update(),new _.Disposable(()=>{const a=this._messages.indexOf(m);a>=0&&(this._messages.splice(a,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class s{constructor(g,m){this._proxy=g.getProxy(I.MainContext.MainThreadStatusBar),this._commands=m,this._statusMessage=new P(this)}createStatusBarEntry(g,m,a,u,E){return new D(this._proxy,this._commands,g,m,a,u,E)}setStatusBarMessage(g,m){const a=this._statusMessage.setMessage(g);let u;return typeof m=="number"?u=setTimeout(()=>a.dispose(),m):typeof m!="undefined"&&m.then(()=>a.dispose(),()=>a.dispose()),new _.Disposable(()=>{a.dispose(),clearTimeout(u)})}}e.ExtHostStatusBar=s}),define(ge[92],pe([0,1,5,3,4]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(k){this._onDidChangeStorage=new I.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(_.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,D){this._proxy.$registerExtensionStorageKeysToSync(k,D)}getValue(k,D,P){return this._proxy.$getValue(k,D).then(s=>s||P)}setValue(k,D,P){return this._proxy.$setValue(k,D,P)}$acceptValue(k,D,P){this._onDidChangeStorage.fire({shared:k,key:D,value:P})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,T.createDecorator)("IExtHostStorage")}),define(ge[93],pe([0,1,4,27,13,91,2]),function(K,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,_.createDecorator)("IExtensionStoragePaths");let k=class{constructor(P,s,C){var g;this._logService=s,this._extHostFileSystem=C,this._workspace=(g=P.workspace)!==null&&g!==void 0?g:void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getOrCreateWorkspaceStoragePath(){var P;if(!this._workspace)return Promise.resolve(void 0);const s=this._workspace.id,C=y.URI.joinPath(this._environment.workspaceStorageHome,s);try{return await this._extHostFileSystem.value.stat(C),this._logService.trace("[ExtHostStorage] storage dir already exists",C),C}catch(g){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",C),await this._extHostFileSystem.value.createDirectory(C),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(P=y.URI.revive(this._workspace.configuration))===null||P===void 0?void 0:P.toString(),name:this._workspace.name},void 0,2))),C}catch(g){this._logService.error("[ExtHostStorage]",g);return}}workspaceValue(P){if(this._value)return y.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return y.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}};k=Ve([xe(0,I.IExtHostInitDataService),xe(1,T.ILogService),xe(2,A.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(ge[34],pe([0,1,3,5,4,2,14,6,7,165,18,210,21,30,190]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,T.createDecorator)("IExtHostTerminalService");class u{constructor(t,n,r,i){this._proxy=t,this._id=n,this._creationOptions=r,this._name=i,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(c=>this._pidPromiseComplete=c);const o=this;this.value={get name(){return o._name||""},get processId(){return o._pidPromise},get creationOptions(){return o._creationOptions},get exitStatus(){return o._exitStatus},sendText(c,v=!0){o._checkDisposed(),o._proxy.$sendText(o._id,c,v)},show(c){o._checkDisposed(),o._proxy.$show(o._id,c)},hide(){o._checkDisposed(),o._proxy.$hide(o._id)},dispose(){o._disposed||(o._disposed=!0,o._proxy.$dispose(o._id))},get dimensions(){if(!(o._cols===void 0||o._rows===void 0))return{columns:o._cols,rows:o._rows}}}}async create(t,n,r,i,o,c,v,p,h,b,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:r,env:i,icon:o,initialText:c,waitOnExit:v,strictEnv:p,hideFromUser:h,isFeatureTerminal:b,isExtensionOwnedTerminal:R})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=u;class E{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new _.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new _.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new _.Emitter,this._onProcessTitleChanged=new _.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new _.Emitter,this._onProcessShellTypeChanged=new _.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=E;let w=1,S=class extends k.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new _.Emitter,this._onDidOpenTerminal=new _.Emitter,this._onDidChangeActiveTerminal=new _.Emitter,this._onDidChangeTerminalDimensions=new _.Emitter,this._proxy=n.getProxy(I.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new _.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[r,i]of this._terminalProcesses)i.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const n=new u(this._proxy,(0,m.generateUuid)(),t,t.name),r=new E(t.pty);return n.createExtensionTerminal().then(i=>{const o=this._setupExtHostProcessListeners(i,r);this._terminalProcessDisposables[i]=o}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const i=new E(n),o=this._setupExtHostProcessListeners(t,i);this._terminalProcessDisposables[t]=o}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const r=this._getTerminalById(t);r&&(this._activeTerminal=r,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const r=this._getTerminalById(t);r&&this._onDidWriteTerminalData.fire({terminal:r.value,data:n})}async $acceptTerminalDimensions(t,n,r){const i=this._getTerminalById(t);i&&i.setDimensions(n,r)&&this._onDidChangeTerminalDimensions.fire({terminal:i.value,dimensions:i.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,r){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.resize(n,r)}async $acceptTerminalTitleChange(t,n){const r=this._getTerminalById(t);r&&(r.name=n)}async $acceptTerminalClosed(t,n){const r=this._getTerminalObjectIndexById(this._terminals,t);if(r!==null){const i=this._terminals.splice(r,1)[0];i.setExitCode(n),this._onDidCloseTerminal.fire(i.value)}}$acceptTerminalOpened(t,n,r,i){if(n){const v=this._getTerminalObjectIndexById(this._terminals,n);if(v!==null){this._terminals[v]._id=t,this._onDidOpenTerminal.fire(this.terminals[v]),this._terminals[v].isOpen=!0;return}}const o={name:i.name,shellPath:i.executable,shellArgs:i.args,cwd:typeof i.cwd=="string"?i.cwd:A.URI.revive(i.cwd),env:i.env,hideFromUser:i.hideFromUser},c=new u(this._proxy,t,o,r);this._terminals.push(c),this._onDidOpenTerminal.fire(c.value),c.isOpen=!0}async $acceptTerminalProcessId(t,n){const r=this._getTerminalById(t);r&&r._setProcessId(n)}async $startExtensionTerminal(t,n){const r=this._getTerminalById(t);if(!r)return{message:(0,P.localize)(0,null,t)};r.isOpen||await new Promise(o=>{const c=this.onDidOpenTerminal(async v=>{v===r.value&&(c.dispose(),o())})});const i=this._terminalProcesses.get(t);i?i.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const r=new k.DisposableStore;r.add(n.onProcessReady(o=>this._proxy.$sendProcessReady(t,o.pid,o.cwd))),r.add(n.onProcessTitleChanged(o=>this._proxy.$sendProcessTitle(t,o))),this._bufferer.startBuffering(t,n.onProcessData),r.add(n.onProcessExit(o=>this._onProcessExit(t,o))),n.onProcessOverrideDimensions&&r.add(n.onProcessOverrideDimensions(o=>this._proxy.$sendOverrideDimensions(t,o))),this._terminalProcesses.set(t,n);const i=this._extensionTerminalAwaitingStart[t];return i&&n instanceof E&&(n.startSendingEvents(i.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),r}$acceptProcessAckDataEvent(t,n){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.input(n)}$acceptProcessResize(t,n,r){var i;try{(i=this._terminalProcesses.get(t))===null||i===void 0||i.resize(n,r)}catch(o){if(o.code!=="EPIPE"&&o.code!=="ERR_IPC_CHANNEL_CLOSED")throw o}}$acceptProcessShutdown(t,n){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(r=>this._proxy.$sendProcessInitialCwd(t,r))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(r=>this._proxy.$sendProcessCwd(t,r))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const r=this._getTerminalById(t);if(!r)return[];this._terminalLinkCache.delete(t);const i=this._terminalLinkCancellationSource.get(t);i&&i.dispose(!0);const o=new g.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,o);const c=[],v={terminal:r.value,line:n},p=[];for(const R of this._linkProviders)p.push(new Promise(async N=>{o.token.onCancellationRequested(()=>N({provider:R,links:[]}));const j=await R.provideTerminalLinks(v,o.token)||[];o.token.isCancellationRequested||N({provider:R,links:j})}));const h=await Promise.all(p);if(o.token.isCancellationRequested)return[];const b=new Map;for(const R of h)R&&R.links.length>0&&c.push(...R.links.map(N=>{const j={id:w++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return b.set(j.id,{provider:R.provider,link:N}),j}));return this._terminalLinkCache.set(t,b),c}$activateLink(t,n){var r;const i=(r=this._terminalLinkCache.get(t))===null||r===void 0?void 0:r.get(n);!i||i.provider.handleTerminalLink(i.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const r=this._terminalProcessDisposables[t];r&&(r.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const r=this._getTerminalObjectIndexById(t,n);return r!==null?t[r]:null}_getTerminalObjectIndexById(t,n){let r=null;return t.some((i,o)=>i._id===n?(r=o,!0):!1),r}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new d,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const r=(0,C.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,r.length===0?void 0:r)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const r=n[0],i=new d(n[1]);this._setEnvironmentVariableCollection(r,i)})}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};S=Ve([xe(1,y.IExtHostRpcService)],S),e.BaseExtHostTerminalService=S;class d{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new _.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const r=this.map.get(t);(!r||r.value!==n.value||r.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((r,i)=>t.call(n,i,r,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=d;let l=class extends S{constructor(t){super(!1,t)}createTerminal(t,n,r){throw new s.NotSupportedError}createTerminalFromOptions(t){throw new s.NotSupportedError}getDefaultShell(t,n){throw new s.NotSupportedError}getDefaultShellArgs(t,n){throw new s.NotSupportedError}$getAvailableProfiles(t){throw new s.NotSupportedError}async $getDefaultShellAndArgs(t){throw new s.NotSupportedError}};l=Ve([xe(0,y.IExtHostRpcService)],l),e.WorkerExtHostTerminalService=l}),define(ge[247],pe([0,1,3,19,5,124,20,7]),function(K,e,_,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(s,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new _.Emitter,this._onDidChangeTextEditorOptions=new _.Emitter,this._onDidChangeTextEditorVisibleRanges=new _.Emitter,this._onDidChangeTextEditorViewColumn=new _.Emitter,this._onDidChangeActiveTextEditor=new _.Emitter,this._onDidChangeVisibleTextEditors=new _.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=s.getProxy(T.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(g=>this._onDidChangeVisibleTextEditors.fire(g)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(g=>this._onDidChangeActiveTextEditor.fire(g))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(s){const C=this._extHostDocumentsAndEditors.allEditors();return s?C:C.map(g=>g.value)}async showTextDocument(s,C,g){let m;typeof C=="number"?m={position:y.ViewColumn.from(C),preserveFocus:g}:typeof C=="object"?m={position:y.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?y.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:m={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(s.uri,m),u=a&&this._extHostDocumentsAndEditors.getEditor(a);if(u)return u.value;throw a?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}createTextEditorDecorationType(s){return new A.TextEditorDecorationType(this._proxy,s).value}$acceptEditorPropertiesChanged(s,C){const g=this._extHostDocumentsAndEditors.getEditor(s);if(!g)throw new Error("unknown text editor");if(C.options&&g._acceptOptions(C.options),C.selections){const m=C.selections.selections.map(y.Selection.to);g._acceptSelections(m)}if(C.visibleRanges){const m=I.coalesce(C.visibleRanges.map(y.Range.to));g._acceptVisibleRanges(m)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:g.value,options:Object.assign(Object.assign({},C.options),{lineNumbers:y.TextEditorLineNumbersStyle.to(C.options.lineNumbers)})}),C.selections){const m=k.TextEditorSelectionChangeKind.fromValue(C.selections.source),a=C.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:g.value,selections:a,kind:m})}if(C.visibleRanges){const m=I.coalesce(C.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:g.value,visibleRanges:m})}}$acceptEditorPositionData(s){for(const C in s){const g=this._extHostDocumentsAndEditors.getEditor(C);if(!g)throw new Error("Unknown text editor");const m=y.ViewColumn.to(s[C]);g.value.viewColumn!==m&&(g._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:g.value,viewColumn:m}))}}getDiffInformation(s){return Promise.resolve(this._proxy.$getDiffInformation(s))}}e.ExtHostEditors=D});var jt=this&&this.__rest||function(K,e){var _={};for(var I in K)Object.prototype.hasOwnProperty.call(K,I)&&e.indexOf(I)<0&&(_[I]=K[I]);if(K!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,I=Object.getOwnPropertySymbols(K);T<I.length;T++)e.indexOf(I[T])<0&&Object.prototype.propertyIsEnumerable.call(K,I[T])&&(_[I[T]]=K[I[T]]);return _};define(ge[248],pe([0,1,2,4,5,6,7]),function(K,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,I.createDecorator)("IExtHostTimeline");class k{constructor(s,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=s.getProxy(T.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:g=>{var m,a;if(g&&g.$mid===11){const u=g.uri===void 0?void 0:_.URI.revive(g.uri);return(a=(m=this._itemsBySourceAndUriMap.get(g.source))===null||m===void 0?void 0:m.get(D(u)))===null||a===void 0?void 0:a.get(g.handle)}return g}})}async $getTimeline(s,C,g,m,a){const u=this._providers.get(s);return u==null?void 0:u.provideTimeline(_.URI.revive(C),g,m,a)}registerTimelineProvider(s,C,g,m){const a=new A.DisposableStore,u=this.convertTimelineItem(C.id,m,a).bind(this);let E;C.onDidChange&&(E=C.onDidChange(S=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},S),{id:C.id})),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},C),{scheme:s,onDidChange:void 0,async provideTimeline(S,d,l,f){var t;(f==null?void 0:f.resetCache)&&(a.clear(),(t=w.get(C.id))===null||t===void 0||t.clear());const n=await C.provideTimeline(S,d,l);if(n!=null){const r=u(S,f);return Object.assign(Object.assign({},n),{source:C.id,items:n.items.map(r)})}},dispose(){var S;for(const d of w.values())(S=d.get(C.id))===null||S===void 0||S.clear();E==null||E.dispose(),a.dispose()}}))}convertTimelineItem(s,C,g){return(m,a)=>{let u;if(a==null?void 0:a.cacheResults){let E=this._itemsBySourceAndUriMap.get(s);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(s,E));const w=D(m);u=E.get(w),u===void 0&&(u=new Map,E.set(w,u))}return E=>{var w,S;const{iconPath:d}=E,l=jt(E,["iconPath"]),f=`${s}|${(w=E.id)!==null&&w!==void 0?w:E.timestamp}`;u==null||u.set(f,E);let t,n,r;return E.iconPath&&(d instanceof y.ThemeIcon?r={id:d.id}:_.URI.isUri(d)?(t=d,n=d):{light:t,dark:n}=d),Object.assign(Object.assign({},l),{id:(S=l.id)!==null&&S!==void 0?S:void 0,handle:f,source:s,command:E.command?C.toInternal(E.command,g):void 0,icon:t,iconDark:n,themeIcon:r,accessibilityInformation:E.accessibilityInformation})}}}registerTimelineProviderCore(s){if(this._providers.get(s.id))throw new Error(`Timeline Provider ${s.id} already exists.`);return this._proxy.$registerTimelineProvider({id:s.id,label:s.label,scheme:s.scheme}),this._providers.set(s.id,s),(0,A.toDisposable)(()=>{var g;for(const m of this._itemsBySourceAndUriMap.values())(g=m.get(s.id))===null||g===void 0||g.clear();this._providers.delete(s.id),this._proxy.$unregisterTimelineProvider(s.id),s.dispose()})}}e.ExtHostTimeline=k;function D(P){return P==null?void 0:P.toString()}}),define(ge[249],pe([0,1,6,12,2,5]),function(K,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(D){this._openers=new Map,this._proxy=D.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,P,s,C){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const g=C.schemes.find(m=>!y.supportedSchemes.has(m));if(g)throw new Error(`Scheme '${g}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,s),this._proxy.$registerUriOpener(P,C.schemes,D,C.label),(0,_.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(D,P,s){const C=this._openers.get(D);if(!C)throw new Error(`Unknown opener with id: ${D}`);const g=T.URI.revive(P);return C.canOpenExternalUri(g,s)}async $openUri(D,P,s){const C=this._openers.get(D);if(!C)throw new Error(`Unknown opener id: '${D}'`);return C.openExternalUri(T.URI.revive(P.resolvedUri),{sourceUri:T.URI.revive(P.sourceUri)},s)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([I.Schemas.http,I.Schemas.https])}),define(ge[250],pe([0,1,5,2,6,18,28]),function(K,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(_.MainContext.MainThreadUrls)}registerUriHandler(P,s){if(this.handles.has(y.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const C=k.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(P)),this.handlers.set(C,s),this._proxy.$registerUriHandler(C,P),(0,T.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(P)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(P,s){const C=this.handlers.get(P);if(!C)return Promise.resolve(void 0);try{C.handleUri(I.URI.revive(s))}catch(g){(0,A.onUnexpectedError)(g)}return Promise.resolve(void 0)}async createAppUri(P){return I.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=k,k.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(K,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!T:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(K,_):T?T.value=_:e.set(K,_),_},Ue=this&&this.__classPrivateFieldGet||function(K,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!I:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(K):I?I.value:e.get(K)};define(ge[65],pe([0,1,22,3,2,177,200,88,5]),function(K,e,_,I,T,A,y,k,D){"use strict";var P,s,C,g,m,a,u,E,w,S,d,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.serializeMessage=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class f{constructor(h,b,R,N,j,oe,q){P.set(this,void 0),s.set(this,void 0),C.set(this,void 0),g.set(this,void 0),m.set(this,void 0),a.set(this,void 0),u.set(this,""),E.set(this,void 0),w.set(this,!1),S.set(this,!1),d.set(this,!1),this._onMessageEmitter=new I.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new I.Emitter),this._onDidDispose=Ue(this,l,"f").event,tt(this,P,h,"f"),tt(this,s,b,"f"),tt(this,E,R,"f"),tt(this,g,N,"f"),tt(this,m,j,"f"),tt(this,a,oe,"f"),tt(this,d,t(oe),"f"),tt(this,C,q,"f")}dispose(){tt(this,w,!0,"f"),Ue(this,l,"f").fire(),Ue(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(h){return tt(this,S,!0,"f"),(0,k.asWebviewUri)(Ue(this,g,"f"),Ue(this,P,"f"),h)}get cspSource(){return Ue(this,g,"f").webviewCspSource.replace("{{uuid}}",Ue(this,P,"f"))}get html(){return this.assertNotDisposed(),Ue(this,u,"f")}set html(h){this.assertNotDisposed(),Ue(this,u,"f")!==h&&(tt(this,u,h,"f"),!Ue(this,S,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(h)&&(tt(this,S,!0,"f"),Ue(this,C,"f").report("Webview vscode-resource: uris",Ue(this,a,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,s,"f").$setHtml(Ue(this,P,"f"),h))}get options(){return this.assertNotDisposed(),Ue(this,E,"f")}set options(h){this.assertNotDisposed(),Ue(this,s,"f").$setOptions(Ue(this,P,"f"),o(Ue(this,a,"f"),Ue(this,m,"f"),h)),tt(this,E,h,"f")}async postMessage(h){if(Ue(this,w,"f"))return!1;const b=n(h,{serializeBuffersForPostMessage:Ue(this,d,"f")});return Ue(this,s,"f").$postMessage(Ue(this,P,"f"),b.message,...b.buffers)}assertNotDisposed(){if(Ue(this,w,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=f,P=new WeakMap,s=new WeakMap,C=new WeakMap,g=new WeakMap,m=new WeakMap,a=new WeakMap,u=new WeakMap,E=new WeakMap,w=new WeakMap,S=new WeakMap,d=new WeakMap,l=new WeakMap;function t(p){if(!p.enableProposedApi)return!1;try{const h=(0,A.normalizeVersion)((0,A.parseVersion)(p.engines.vscode));return!!h&&h.majorBase>=1&&h.minorBase>=56}catch(h){return!1}}e.shouldSerializeBuffersForPostMessage=t;function n(p,h){if(h.serializeBuffersForPostMessage){const b=[],R=(j,oe)=>{if(oe&&oe instanceof ArrayBuffer){let q=b.findIndex(W=>W.original===oe);if(q===-1){const W=new Uint8Array(oe),H=_.VSBuffer.wrap(W);q=b.length,b.push({original:oe,vsBuffer:H})}return{$$vscode_array_buffer_reference$$:!0,index:q}}return oe};return{message:JSON.stringify(p,R),buffers:b.map(j=>j.vsBuffer)}}else return{message:JSON.stringify(p),buffers:[]}}e.serializeMessage=n;class r{constructor(h,b,R,N,j){this.initData=b,this.workspace=R,this._logService=N,this._deprecationService=j,this._webviews=new Map,this._webviewProxy=h.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(h,b,...R){const N=this.getWebview(h);if(N){const{message:j}=(0,y.deserializeWebviewMessage)(b,R);N._onMessageEmitter.fire(j)}}$onMissingCsp(h,b){this._logService.warn(`${b} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(h,b,R){const N=new f(h,this._webviewProxy,c(b),this.initData,this.workspace,R,this._deprecationService);return this._webviews.set(h,N),N._onDidDispose(()=>{this._webviews.delete(h)}),N}deleteWebview(h){this._webviews.delete(h)}getWebview(h){return this._webviews.get(h)}}e.ExtHostWebviews=r;function i(p){return{id:p.identifier,location:p.extensionLocation}}e.toExtensionData=i;function o(p,h,b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots||v(p,h)}}e.serializeWebviewOptions=o;function c(p){var h;return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,portMapping:p.portMapping,localResourceRoots:(h=p.localResourceRoots)===null||h===void 0?void 0:h.map(b=>T.URI.from(b))}}e.reviveOptions=c;function v(p,h){return[...((h==null?void 0:h.getWorkspaceFolders())||[]).map(b=>b.uri),p.extensionLocation]}}),define(ge[251],pe([0,1,21,74,6,12,25,2,20,65,86,5,7]),function(K,e,_,I,T,A,y,k,D,P,s,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new s.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=l(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class a{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,r){const i=this.key(t,n.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const o=new m(n,r);return this._documents.set(i,o),o}delete(t,n){const r=this.key(t,n.uri);this._documents.delete(r)}key(t,n){return`${t}@@@${n}`}}var u;(function(f){f[f.Text=0]="Text",f[f.Custom=1]="Custom"})(u||(u={}));class E{constructor(){this._providers=new Map}addTextProvider(t,n,r){return this.add(0,t,n,r)}addCustomProvider(t,n,r){return this.add(1,t,n,r)}get(t){return this._providers.get(t)}add(t,n,r,i){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:r,provider:i}),new g.Disposable(()=>this._providers.delete(n))}}class w{constructor(t,n,r,i,o){this._extHostDocuments=n,this._extensionStoragePaths=r,this._extHostWebview=i,this._extHostWebviewPanels=o,this._editorProviders=new E,this._documents=new a,this._proxy=t.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,r,i){const o=new T.DisposableStore;return S(r)?(o.add(this._editorProviders.addTextProvider(n,t,r)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(t),n,i.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(t))):(o.add(this._editorProviders.addCustomProvider(n,t,r)),this.supportEditing(r)&&o.add(r.onDidChangeCustomDocument(c=>{const v=this.getCustomDocumentEntry(n,c.document.uri);if(d(c)){const p=v.addEdit(c);this._proxy.$onDidEdit(c.document.uri,n,p,c.label)}else this._proxy.$onContentChange(c.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(t),n,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(t))),g.Disposable.from(o,new g.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,r,i,o){var c;const v=this._editorProviders.get(n);if(!v)throw new Error(`No provider found for '${n}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${n}'`);const p=k.URI.revive(t),h=await v.provider.openCustomDocument(p,{backupId:r,untitledDocumentData:i==null?void 0:i.buffer},o);let b;return this.supportEditing(v.provider)&&this._extensionStoragePaths&&(b=(c=this._extensionStoragePaths.workspaceValue(v.extension))!==null&&c!==void 0?c:this._extensionStoragePaths.globalValue(v.extension)),this._documents.add(n,h,b),{editable:this.supportEditing(v.provider)}}async $disposeCustomDocument(t,n){const r=this._editorProviders.get(n);if(!r)throw new Error(`No provider found for '${n}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${n}'`);const i=k.URI.revive(t),{document:o}=this.getCustomDocumentEntry(n,i);this._documents.delete(n,o),o.dispose()}async $resolveWebviewEditor(t,n,r,i,o,c){const v=this._editorProviders.get(r);if(!v)throw new Error(`No provider found for '${r}'`);const p=D.ViewColumn.to(o),h=this._extHostWebview.createNewWebview(n,i.webviewOptions,v.extension),b=this._extHostWebviewPanels.createNewWebviewPanel(n,r,i.title,p,i.panelOptions,h),R=k.URI.revive(t);switch(v.type){case 1:{const{document:N}=this.getCustomDocumentEntry(r,R);return v.provider.resolveCustomEditor(N,b,c)}case 0:{const N=this._extHostDocuments.getDocument(R);return v.provider.resolveCustomTextEditor(N,b,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,r){this.getCustomDocumentEntry(n,t).disposeEdits(r)}async $onMoveCustomEditor(t,n,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const o=this._extHostWebviewPanels.getWebviewPanel(t);if(!o)throw new Error("No webview found");const c=k.URI.revive(n),v=this._extHostDocuments.getDocument(c);await i.provider.moveCustomTextEditor(v,o,_.CancellationToken.None)}async $undo(t,n,r,i){return this.getCustomDocumentEntry(n,t).undo(r,i)}async $redo(t,n,r,i){return this.getCustomDocumentEntry(n,t).redo(r,i)}async $revert(t,n,r){const i=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(i.document,r),i.disposeBackup()}async $onSave(t,n,r){const i=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(i.document,r),i.disposeBackup()}async $onSaveAs(t,n,r,i){const o=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(o.document,k.URI.revive(r),i)}async $backup(t,n,r){const i=this.getCustomDocumentEntry(n,t),c=await this.getCustomEditorProvider(n).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},r);return i.updateBackup(c),c.id}getCustomDocumentEntry(t,n){const r=this._documents.get(t,k.URI.revive(n));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(t){const n=this._editorProviders.get(t),r=n==null?void 0:n.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function S(f){return typeof f.resolveCustomTextEditor=="function"}function d(f){return typeof f.undo=="function"&&typeof f.redo=="function"}function l(f){const t=f.scheme===A.Schemas.file||f.scheme===A.Schemas.untitled?f.fsPath:f.toString();return(0,I.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(K,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!T:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(K,_):T?T.value=_:e.set(K,_),_},Ue=this&&this.__classPrivateFieldGet||function(K,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!I:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(K):I?I.value:e.get(K)};define(ge[252],pe([0,1,3,6,2,30,20,65,5,7]),function(K,e,_,I,T,A,y,k,D,P){"use strict";var s,C,g,m,a,u,E,w,S,d,l,f,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends I.Disposable{constructor(c,v,p,h,b,R,N){super();s.set(this,void 0),C.set(this,void 0),g.set(this,void 0),m.set(this,void 0),a.set(this,void 0),u.set(this,void 0),E.set(this,void 0),w.set(this,void 0),S.set(this,!0),d.set(this,!0),l.set(this,!1),f.set(this,this._register(new _.Emitter)),this.onDidDispose=Ue(this,f,"f").event,t.set(this,this._register(new _.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,tt(this,s,c,"f"),tt(this,C,v,"f"),tt(this,g,p,"f"),tt(this,a,R,"f"),tt(this,w,b,"f"),tt(this,u,h,"f"),tt(this,m,N,"f")}dispose(){Ue(this,l,"f")||(tt(this,l,!0,"f"),Ue(this,f,"f").fire(),Ue(this,C,"f").$disposeWebview(Ue(this,s,"f")),Ue(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,m,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,g,"f")}get title(){return this.assertNotDisposed(),Ue(this,u,"f")}set title(c){this.assertNotDisposed(),Ue(this,u,"f")!==c&&(tt(this,u,c,"f"),Ue(this,C,"f").$setTitle(Ue(this,s,"f"),c))}get iconPath(){return this.assertNotDisposed(),Ue(this,E,"f")}set iconPath(c){this.assertNotDisposed(),Ue(this,E,"f")!==c&&(tt(this,E,c,"f"),Ue(this,C,"f").$setIconPath(Ue(this,s,"f"),T.URI.isUri(c)?{light:c,dark:c}:c))}get options(){return Ue(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,w,"f")=="number"&&Ue(this,w,"f")<0))return Ue(this,w,"f")}get active(){return this.assertNotDisposed(),Ue(this,d,"f")}get visible(){return this.assertNotDisposed(),Ue(this,S,"f")}_updateViewState(c){Ue(this,l,"f")||(this.active!==c.active||this.visible!==c.visible||this.viewColumn!==c.viewColumn)&&(tt(this,d,c.active,"f"),tt(this,S,c.visible,"f"),tt(this,w,c.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(c,v){this.assertNotDisposed(),Ue(this,C,"f").$reveal(Ue(this,s,"f"),{viewColumn:c?y.ViewColumn.from(c):void 0,preserveFocus:!!v})}assertNotDisposed(){if(Ue(this,l,"f"))throw new Error("Webview is disposed")}}s=new WeakMap,C=new WeakMap,g=new WeakMap,m=new WeakMap,a=new WeakMap,u=new WeakMap,E=new WeakMap,w=new WeakMap,S=new WeakMap,d=new WeakMap,l=new WeakMap,f=new WeakMap,t=new WeakMap;class r{constructor(c,v,p){this.webviews=v,this.workspace=p,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=c.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(c,v,p,h,b={}){const R=typeof h=="object"?h.viewColumn:h,N={viewColumn:y.ViewColumn.from(R),preserveFocus:typeof h=="object"&&!!h.preserveFocus},j=(0,k.shouldSerializeBuffersForPostMessage)(c),oe=r.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(c),oe,v,{title:p,panelOptions:i(b),webviewOptions:(0,k.serializeWebviewOptions)(c,this.workspace,b),serializeBuffersForPostMessage:j},N);const q=this.webviews.createNewWebview(oe,b,c);return this.createNewWebviewPanel(oe,v,p,R,b,q)}$onDidChangeWebviewPanelViewStates(c){const v=Object.keys(c);v.sort((p,h)=>{const b=c[p],R=c[h];return b.active?1:R.active?-1:+b.visible-+R.visible});for(const p of v){const h=this.getWebviewPanel(p);if(!!h){const b=c[p];h._updateViewState({active:b.active,visible:b.visible,viewColumn:y.ViewColumn.to(b.position)})}}}async $onDidDisposeWebviewPanel(c){const v=this.getWebviewPanel(c);v==null||v.dispose(),this._webviewPanels.delete(c),this.webviews.deleteWebview(c)}registerWebviewPanelSerializer(c,v,p){if(this._serializers.has(v))throw new Error(`Serializer for '${v}' already registered`);return this._serializers.set(v,{serializer:p,extension:c}),this._proxy.$registerSerializer(v,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(c)}),new P.Disposable(()=>{this._serializers.delete(v),this._proxy.$unregisterSerializer(v)})}async $deserializeWebviewPanel(c,v,p,h){const b=this._serializers.get(v);if(!b)throw new Error(`No serializer found for '${v}'`);const{serializer:R,extension:N}=b,j=this.webviews.createNewWebview(c,p.webviewOptions,N),oe=this.createNewWebviewPanel(c,v,p.title,h,p.panelOptions,j);await R.deserializeWebviewPanel(oe,p.state)}createNewWebviewPanel(c,v,p,h,b,R){const N=new n(c,this._proxy,v,p,h,b,R);return this._webviewPanels.set(c,N),N}getWebviewPanel(c){return this._webviewPanels.get(c)}}e.ExtHostWebviewPanels=r;function i(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(K,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!T:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(K,_):T?T.value=_:e.set(K,_),_},Ue=this&&this.__classPrivateFieldGet||function(K,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!I:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(K):I?I.value:e.get(K)};define(ge[253],pe([0,1,3,6,65,5,7]),function(K,e,_,I,T,A,y){"use strict";var k,D,P,s,C,g,m,a,u,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends I.Disposable{constructor(l,f,t,n,r,i){super();k.set(this,void 0),D.set(this,void 0),P.set(this,void 0),s.set(this,void 0),C.set(this,!1),g.set(this,void 0),m.set(this,void 0),a.set(this,void 0),u.set(this,this._register(new _.Emitter)),this.onDidChangeVisibility=Ue(this,u,"f").event,E.set(this,this._register(new _.Emitter)),this.onDidDispose=Ue(this,E,"f").event,tt(this,P,t,"f"),tt(this,m,n,"f"),tt(this,k,l,"f"),tt(this,D,f,"f"),tt(this,s,r,"f"),tt(this,g,i,"f")}dispose(){Ue(this,C,"f")||(tt(this,C,!0,"f"),Ue(this,E,"f").fire(),Ue(this,s,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,m,"f")}set title(l){this.assertNotDisposed(),Ue(this,m,"f")!==l&&(tt(this,m,l,"f"),Ue(this,D,"f").$setWebviewViewTitle(Ue(this,k,"f"),l))}get description(){return this.assertNotDisposed(),Ue(this,a,"f")}set description(l){this.assertNotDisposed(),Ue(this,a,"f")!==l&&(tt(this,a,l,"f"),Ue(this,D,"f").$setWebviewViewDescription(Ue(this,k,"f"),l))}get visible(){return Ue(this,g,"f")}get webview(){return Ue(this,s,"f")}get viewType(){return Ue(this,P,"f")}_setVisible(l){l===Ue(this,g,"f")||Ue(this,C,"f")||(tt(this,g,l,"f"),Ue(this,u,"f").fire())}show(l){this.assertNotDisposed(),Ue(this,D,"f").$show(Ue(this,k,"f"),!!l)}assertNotDisposed(){if(Ue(this,C,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,D=new WeakMap,P=new WeakMap,s=new WeakMap,C=new WeakMap,g=new WeakMap,m=new WeakMap,a=new WeakMap,u=new WeakMap,E=new WeakMap;class S{constructor(l,f){this._extHostWebview=f,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=l.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(l,f,t,n){if(this._viewProviders.has(f))throw new Error(`View provider for '${f}' already registered`);return this._viewProviders.set(f,{provider:t,extension:l}),this._proxy.$registerWebviewViewProvider((0,T.toExtensionData)(l),f,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(f),this._proxy.$unregisterWebviewViewProvider(f)})}async $resolveWebviewView(l,f,t,n,r){const i=this._viewProviders.get(f);if(!i)throw new Error(`No view provider found for '${f}'`);const{provider:o,extension:c}=i,v=this._extHostWebview.createNewWebview(l,{},c),p=new w(l,this._proxy,f,t,v,!0);this._webviewViews.set(l,p),await o.resolveWebviewView(p,{state:n},r)}async $onDidChangeWebviewViewVisibility(l,f){this.getWebviewView(l)._setVisible(f)}async $disposeWebviewView(l){const f=this.getWebviewView(l);this._webviewViews.delete(l),f.dispose(),this._extHostWebview.deleteWebview(l)}getWebviewView(l){const f=this._webviewViews.get(l);if(!f)throw new Error("No webview found");return f}}e.ExtHostWebviewViews=S}),define(ge[127],pe([0,1,3,5,2,12,9,4,14]),function(K,e,_,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Nn{constructor(C){this._onDidChangeWindowState=new _.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Nn.InitialState,this._proxy=C.getProxy(I.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(g=>this.$onDidChangeWindowFocus(g))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:C}),this._onDidChangeWindowState.fire(this._state))}openUri(C,g){let m;if(typeof C=="string"){m=C;try{C=T.URI.parse(C)}catch(a){return Promise.reject(`Invalid uri - '${C}'`)}}return(0,y.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,m,g)}async asExternalUri(C,g){if((0,y.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([A.Schemas.http,A.Schemas.https]).has(C.scheme))return Promise.reject(`Invalid scheme '${C.scheme}'`);const m=await this._proxy.$asExternalUri(C,g);return T.URI.from(m)}};P.InitialState={focused:!0},P=Ve([xe(0,D.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(ge[254],pe([0,1,8,48,30,51,6,5,2,14]),function(K,e,_,I,T,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let s=class extends y.Disposable{constructor(g,m){super();const a=g.getProxy(k.MainContext.MainThreadDownloadService);m.registerCommand(!1,"_workbench.downloadResource",async u=>{const E=D.URI.file((0,_.join)((0,I.tmpdir)(),(0,T.generateUuid)()));return await a.$download(u,E),E})}};s=Ve([xe(0,P.IExtHostRpcService),xe(1,A.IExtHostCommands)],s),e.ExtHostDownloadService=s}),define(ge[255],pe([0,1,2,8,146,26,37,64,27,14,6,13,113,45]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=e.ExtHostOutputChannelBackedByFile=void 0;class a{constructor(S,d){this.file=d,this.appender=(0,g.createRotatingLogger)(S,d,30*m.ByteSize.MB,1),this.appender.clearFormatters()}append(S){this.appender.critical(S)}flush(){this.appender.flush()}}class u extends k.AbstractExtHostOutputChannel{constructor(S,d,l){super(S,!1,_.URI.file(d.file),l);this._appender=d}append(S){super.append(S),this._appender.append(S),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(S,d){this._appender.flush(),super.show(S,d)}clear(){this._appender.flush(),super.clear()}}e.ExtHostOutputChannelBackedByFile=u;let E=class extends k.ExtHostOutputService{constructor(S,d,l){super(S);this.logService=d,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new s.MutableDisposable,this._logsLocation=l.logsLocation}$setVisibleChannel(S){if(S){const d=this._channels.get(S);d&&(this._visibleChannelDisposable.value=d.onDidAppend(()=>d.update()))}}createOutputChannel(S){if(S=S.trim(),!S)throw new Error("illegal argument `name`. must not be falsy");const d=this._doCreateOutChannel(S);return d.then(l=>l._id.then(f=>this._channels.set(f,l))),new k.LazyOutputChannel(S,d)}async _doCreateOutChannel(S){try{const d=(0,I.join)(this._logsLocation.fsPath,`output_logging_${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await A.SymlinkSupport.existsDirectory(d)||await y.promises.mkdir(d,{recursive:!0});const f=`${this._namePool++}-${S.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=_.URI.file((0,I.join)(d,`${f}.log`)),n=new a(f,t.fsPath);return new u(S,n,this._proxy)}catch(d){return this.logService.error(d),new k.ExtHostPushOutputChannel(S,this._proxy)}}};E=Ve([xe(0,P.IExtHostRpcService),xe(1,C.ILogService),xe(2,D.IExtHostInitDataService)],E),e.ExtHostOutputService2=E}),define(ge[256],pe([0,1,5,14,6,27,2,38,25,37,26,7,10,50,3,73,13]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class w{constructor(v,p,h){this.remoteAddress=v,this.localAddress=p,this._dispose=h,this._onDispose=new a.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function S(c){const v=c.trim().split(`
`),p=[];return v.forEach(b=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(b);R&&R.length>=3&&p.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),p.reduce((b,R)=>(b[R.socket]=R,b),{})}e.getSockets=S;function d(...c){const v=[].concat(...c.map(f));return[...new Map(v.filter(p=>p.st==="0A").map(p=>{const h=p.local_address.split(":");return{socket:parseInt(p.inode,10),ip:l(h[0]),port:parseInt(h[1],16)}}).map(p=>[p.ip+":"+p.port,p])).values()]}e.loadListeningPorts=d;function l(c){let v="";if(c.length===8)for(let p=c.length-2;p>=0;p-=2)v+=parseInt(c.substr(p,2),16),p!==0&&(v+=".");else for(let p=c.length-4;p>=0;p-=4)v+=parseInt(c.substr(p,4),16).toString(16),p!==0&&(v+=":");return v}e.parseIpAddress=l;function f(c){const v=c.trim().split(`
`),p=v.shift().trim().split(/\s+/).filter(b=>b!=="rx_queue"&&b!=="tm->when");return v.map(b=>b.trim().split(/\s+/).reduce((R,N,j)=>(R[p[j]||j]=N,R),{}))}e.loadConnectionTable=f;function t(c){return!!c.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||c.indexOf("out/vs/server/main.js")!==-1||c.indexOf("_productName=VSCode")!==-1}function n(c){const v=c.trim().split(`
`),p=[];return v.forEach(h=>{const b=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(h);b&&b.length>=4&&p.push({pid:parseInt(b[1],10),ppid:parseInt(b[2]),cmd:b[3]})}),p}e.getRootProcesses=n;async function r(c,v,p){const h=p.reduce((R,N)=>(R[N.pid]=N,R),{}),b=[];return c.forEach(({socket:R,ip:N,port:j})=>{var oe;const q=v[R]?v[R].pid:void 0,W=q?(oe=h[q])===null||oe===void 0?void 0:oe.cmd:void 0;q&&W&&!t(W)&&b.push({host:N,port:j,detail:W,pid:q})}),b}e.findPorts=r;function i(c,v,p){const h=new Map,b=n(v);for(const R of c){const N=p.get(R.port);if(N){h.set(R.port,N);continue}const j=b.find(oe=>oe.cmd.includes(`${R.port}`));if(j){let oe=j,q;do q=b.find(W=>W.ppid===oe.pid),q&&(oe=q);while(q);h.set(R.port,{host:R.ip,port:R.port,pid:oe.pid,detail:oe.cmd,ppid:oe.ppid})}else h.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return h}e.tryFindRootPorts=i;let o=class extends T.Disposable{constructor(v,p,h){super();this.logService=h,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new a.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=v.getProxy(_.MainContext.MainThreadTunnelService),g.isLinux&&p.remote.isRemote&&p.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(v,p){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${v.identifier.value} called openTunnel API for ${p.remoteAddress.port}.`);const h=await this._proxy.$openTunnel(p,v.displayName);if(h){const b=new w(h.remoteAddress,h.localAddress,()=>this._proxy.$closeTunnel(h.remoteAddress));return this._register(b),b}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(v){return Math.max(v*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(v,p){const h=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(h,{selector:v,provider:p}),this._proxy.$registerPortsAttributesProvider(v,h),new C.Disposable(()=>{this._portAttributesProviders.delete(h),this._proxy.$unregisterPortsAttributesProvider(h)})}async $providePortAttributes(v,p,h,b,R){const N=[];for(const oe of v){const q=this._portAttributesProviders.get(oe);if(!q)return[];N.push(...await Promise.all(p.map(async W=>q.provider.providePortAttributes(W,h,b,R))))}const j=N.filter(oe=>!!oe);return j.length>0?j.map(oe=>({autoForwardAction:oe.autoForwardAction,port:oe.port})):[]}async $registerCandidateFinder(v){if(!(v&&this._candidateFindingEnabled)){this._candidateFindingEnabled=v;let p=new u.MovingAverage,h;for(;this._candidateFindingEnabled;){const b=new Date().getTime(),R=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${R.map(j=>j.port).join(", ")}`);const N=new Date().getTime()-b;p.update(N),(!h||JSON.stringify(h)!==JSON.stringify(R))&&(h=R,await this._proxy.$onFoundNewCandidates(h)),await new Promise(j=>setTimeout(()=>j(),this.calculateDelay(p.value)))}}}async setTunnelExtensionFunctions(v){var p;return v?(v.candidatePortSource!==void 0&&await this._proxy.$setCandidatePortSource(v.candidatePortSource),v.showCandidatePort&&(this._showCandidatePort=v.showCandidatePort,await this._proxy.$setCandidateFilter()),v.tunnelFactory&&(this._forwardPortProvider=v.tunnelFactory,await this._proxy.$setTunnelProvider((p=v.tunnelFeatures)!==null&&p!==void 0?p:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,T.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(v,p){if(this._extensionTunnels.has(v.host)){const h=this._extensionTunnels.get(v.host);h.has(v.port)&&(p&&h.get(v.port).disposeListener.dispose(),await h.get(v.port).tunnel.dispose(),h.delete(v.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(v,p){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const h=this._forwardPortProvider(v,p);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),h!==void 0){const b=await h;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(v.remoteAddress.host)||this._extensionTunnels.set(v.remoteAddress.host,new Map);const R=this._register(b.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(b.remoteAddress))));return this._extensionTunnels.get(v.remoteAddress.host).set(v.remoteAddress.port,{tunnel:b,disposeListener:R}),m.TunnelDto.fromApiTunnel(b)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(h){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(v){const p=await Promise.all(v.map(b=>{var R;return this._showCandidatePort(b.host,b.port,(R=b.detail)!==null&&R!==void 0?R:"")})),h=v.filter((b,R)=>p[R]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${v.map(b=>b.port).join(", ")} to ${h.map(b=>b.port).join(", ")}`),h}async findCandidatePorts(){let v="",p="";try{v=await P.promises.readFile("/proc/net/tcp","utf8"),p=await P.promises.readFile("/proc/net/tcp6","utf8")}catch(U){}const h=d(v,p),b=await new Promise(U=>{(0,k.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(L,F,O)=>{U(F)})}),R=S(b),N=await s.readdir("/proc"),j=[];for(let U of N)try{const L=Number(U),F=D.joinPath(y.URI.file("/proc"),U);if((await P.promises.stat(F.fsPath)).isDirectory()&&!isNaN(L)){const M=await P.promises.readlink(D.joinPath(F,"cwd").fsPath),B=await P.promises.readFile(D.joinPath(F,"cmdline").fsPath,"utf8");j.push({pid:L,cwd:M,cmd:B})}}catch(L){}const oe=[],q=h.filter(U=>{const L=R[U.socket];return L||oe.push(U),L}),W=r(q,R,j);let H;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${oe.length}`),oe.length>0){const U=await new Promise(L=>{(0,k.exec)("ps -F -A -l | grep root",(F,O,M)=>{L(O)})});this._foundRootPorts=i(oe,U,this._foundRootPorts),H=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${H.join(", ")}`)}return W.then(U=>H?U.concat(H):U)}};o=Ve([xe(0,I.IExtHostRpcService),xe(1,A.IExtHostInitDataService),xe(2,E.ILogService)],o),e.ExtHostTunnelService=o}),define(ge[257],pe([0,1,15,21,18,3,6,101,227,125,22]),function(K,e,_,I,T,A,y,k,D,P,s){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function g(i,o){try{return JSON.stringify(i,o)}catch(c){return"null"}}function m(i,o){return JSON.stringify(i,o)}function a(i){return i?(o,c)=>c&&c.$mid===1?i.transformOutgoing(c):c:null}var u;(function(i){i[i.LocalSide=0]="LocalSide",i[i.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));var E;(function(i){i[i.Responsive=0]="Responsive",i[i.Unresponsive=1]="Unresponsive"})(E=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},S=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class l extends y.Disposable{constructor(o,c=null,v=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=o,this._logger=c,this._uriTransformer=v,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let p=0,h=P.ProxyIdentifier.count;p<h;p++)this._locals[p]=null,this._proxies[p]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new _.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(p=>this._receiveOneMessage(p))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(o=>{this._pendingRPCReplies[o].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(o){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(o){this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(o){this._responsiveState!==o&&(this._responsiveState=o,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(o){return this._uriTransformer?(0,k.transformIncomingURIs)(o,this._uriTransformer):o}getProxy(o){const{nid:c,sid:v}=o;return this._proxies[c]||(this._proxies[c]=this._createProxy(c,v)),this._proxies[c]}_createProxy(o,c){let v={get:(p,h)=>(typeof h=="string"&&!p[h]&&h.charCodeAt(0)===36&&(p[h]=(...b)=>this._remoteCall(o,h,b)),h===d?c:p[h])};return new Proxy(Object.create(null),v)}set(o,c){return this._locals[o.nid]=c,c}assertRegistered(o){for(let c=0,v=o.length;c<v;c++){const p=o[c];if(!this._locals[p.nid])throw new Error(`Missing actor ${p.sid} (isMain: ${p.isMain})`)}}_receiveOneMessage(o){if(!this._isDisposed){const c=o.byteLength,v=f.read(o,0),p=v.readUInt8(),h=v.readUInt32();switch(p){case 1:case 2:{let{rpcId:b,method:R,args:N}=t.deserializeRequestJSONArgs(v);this._uriTransformer&&(N=(0,k.transformIncomingURIs)(N,this._uriTransformer)),this._receiveRequest(c,h,b,R,N,p===2);break}case 3:case 4:{let{rpcId:b,method:R,args:N}=t.deserializeRequestMixedArgs(v);this._uriTransformer&&(N=(0,k.transformIncomingURIs)(N,this._uriTransformer)),this._receiveRequest(c,h,b,R,N,p===4);break}case 5:{this._logger&&this._logger.logIncoming(c,h,0,"ack"),this._onDidReceiveAcknowledge(h);break}case 6:{this._receiveCancel(c,h);break}case 7:{this._receiveReply(c,h,void 0);break}case 9:{let b=t.deserializeReplyOKJSON(v);this._uriTransformer&&(b=(0,k.transformIncomingURIs)(b,this._uriTransformer)),this._receiveReply(c,h,b);break}case 8:{let b=t.deserializeReplyOKVSBuffer(v);this._receiveReply(c,h,b);break}case 10:{let b=t.deserializeReplyErrError(v);this._uriTransformer&&(b=(0,k.transformIncomingURIs)(b,this._uriTransformer)),this._receiveReplyErr(c,h,b);break}case 11:{this._receiveReplyErr(c,h,void 0);break}default:console.error("received unexpected message"),console.error(o)}}}_receiveRequest(o,c,v,p,h,b){this._logger&&this._logger.logIncoming(o,c,1,`receiveRequest ${(0,P.getStringIdentifierForProxy)(v)}.${p}(`,h);const R=String(c);let N,j;if(b){const q=new I.CancellationTokenSource;h.push(q.token),N=this._invokeHandler(v,p,h),j=()=>q.cancel()}else N=this._invokeHandler(v,p,h),j=w;this._cancelInvokedHandlers[R]=j;const oe=t.serializeAcknowledged(c);this._logger&&this._logger.logOutgoing(oe.byteLength,c,1,"ack"),this._protocol.send(oe),N.then(q=>{delete this._cancelInvokedHandlers[R];const W=t.serializeReplyOK(c,q,this._uriReplacer);this._logger&&this._logger.logOutgoing(W.byteLength,c,1,"reply:",q),this._protocol.send(W)},q=>{delete this._cancelInvokedHandlers[R];const W=t.serializeReplyErr(c,q);this._logger&&this._logger.logOutgoing(W.byteLength,c,1,"replyErr:",q),this._protocol.send(W)})}_receiveCancel(o,c){this._logger&&this._logger.logIncoming(o,c,1,"receiveCancel");const v=String(c);this._cancelInvokedHandlers[v]&&this._cancelInvokedHandlers[v]()}_receiveReply(o,c,v){this._logger&&this._logger.logIncoming(o,c,0,"receiveReply:",v);const p=String(c);if(!!this._pendingRPCReplies.hasOwnProperty(p)){const h=this._pendingRPCReplies[p];delete this._pendingRPCReplies[p],h.resolveOk(v)}}_receiveReplyErr(o,c,v){this._logger&&this._logger.logIncoming(o,c,0,"receiveReplyErr:",v);const p=String(c);if(!!this._pendingRPCReplies.hasOwnProperty(p)){const h=this._pendingRPCReplies[p];delete this._pendingRPCReplies[p];let b;v&&(v.$isError?(b=new Error,b.name=v.name,b.message=v.message,b.stack=v.stack):b=v),h.resolveErr(b)}}_invokeHandler(o,c,v){try{return Promise.resolve(this._doInvokeHandler(o,c,v))}catch(p){return Promise.reject(p)}}_doInvokeHandler(o,c,v){const p=this._locals[o];if(!p)throw new Error("Unknown actor "+(0,P.getStringIdentifierForProxy)(o));let h=p[c];if(typeof h!="function")throw new Error("Unknown method "+c+" on actor "+(0,P.getStringIdentifierForProxy)(o));return h.apply(p,v)}_remoteCall(o,c,v){if(this._isDisposed)return Promise.reject(T.canceled());let p=null;if(v.length>0&&I.CancellationToken.isCancellationToken(v[v.length-1])&&(p=v.pop()),p&&p.isCancellationRequested)return Promise.reject(T.canceled());const h=t.serializeRequestArguments(v,this._uriReplacer),b=++this._lastMessageId,R=String(b),N=new D.LazyPromise;p&&p.onCancellationRequested(()=>{const oe=t.serializeCancel(b);this._logger&&this._logger.logOutgoing(oe.byteLength,b,0,"cancel"),this._protocol.send(t.serializeCancel(b))}),this._pendingRPCReplies[R]=N,this._onWillSendRequest(b);const j=t.serializeRequest(b,o,c,h,!!p);return this._logger&&this._logger.logOutgoing(j.byteLength,b,0,`request: ${(0,P.getStringIdentifierForProxy)(o)}.${c}(`,v),this._protocol.send(j),N}}e.RPCProtocol=l,C=S,l.UNRESPONSIVE_TIME=3*1e3;class f{constructor(o,c){this._buff=o,this._offset=c}static alloc(o,c,v){let p=new f(s.VSBuffer.alloc(v+1+4),0);return p.writeUInt8(o),p.writeUInt32(c),p}static read(o,c){return new f(o,c)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(o){this._buff.writeUInt8(o,this._offset),this._offset+=1}readUInt8(){const o=this._buff.readUInt8(this._offset);return this._offset+=1,o}writeUInt32(o){this._buff.writeUInt32BE(o,this._offset),this._offset+=4}readUInt32(){const o=this._buff.readUInt32BE(this._offset);return this._offset+=4,o}static sizeShortString(o){return 1+o.byteLength}writeShortString(o){this._buff.writeUInt8(o.byteLength,this._offset),this._offset+=1,this._buff.set(o,this._offset),this._offset+=o.byteLength}readShortString(){const o=this._buff.readUInt8(this._offset);this._offset+=1;const v=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,v}static sizeLongString(o){return 4+o.byteLength}writeLongString(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readLongString(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const v=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,v}writeBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}static sizeVSBuffer(o){return 4+o.byteLength}writeVSBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readVSBuffer(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const c=this._buff.slice(this._offset,this._offset+o);return this._offset+=o,c}static sizeMixedArray(o,c){let v=0;v+=1;for(let p=0,h=o.length;p<h;p++){const b=o[p],R=c[p];switch(v+=1,R){case 1:v+=this.sizeLongString(b);break;case 2:v+=this.sizeVSBuffer(b);break;case 3:break}}return v}writeMixedArray(o,c){this._buff.writeUInt8(o.length,this._offset),this._offset+=1;for(let v=0,p=o.length;v<p;v++){const h=o[v];switch(c[v]){case 1:this.writeUInt8(1),this.writeLongString(h);break;case 2:this.writeUInt8(2),this.writeVSBuffer(h);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const o=this._buff.readUInt8(this._offset);this._offset+=1;let c=new Array(o);for(let v=0;v<o;v++)switch(this.readUInt8()){case 1:c[v]=this.readLongString();break;case 2:c[v]=this.readVSBuffer();break;case 3:c[v]=void 0;break}return c}}class t{static _arrayContainsBufferOrUndefined(o){for(let c=0,v=o.length;c<v;c++)if(o[c]instanceof s.VSBuffer||typeof o[c]=="undefined")return!0;return!1}static serializeRequestArguments(o,c){if(this._arrayContainsBufferOrUndefined(o)){let v=[],p=[];for(let h=0,b=o.length;h<b;h++){const R=o[h];R instanceof s.VSBuffer?(v[h]=R,p[h]=2):typeof R=="undefined"?(v[h]=s.VSBuffer.alloc(0),p[h]=3):(v[h]=s.VSBuffer.fromString(m(R,c)),p[h]=1)}return{type:"mixed",args:v,argsType:p}}return{type:"simple",args:m(o,c)}}static serializeRequest(o,c,v,p,h){return p.type==="mixed"?this._requestMixedArgs(o,c,v,p.args,p.argsType,h):this._requestJSONArgs(o,c,v,p.args,h)}static _requestJSONArgs(o,c,v,p,h){const b=s.VSBuffer.fromString(v),R=s.VSBuffer.fromString(p);let N=0;N+=f.sizeUInt8(),N+=f.sizeShortString(b),N+=f.sizeLongString(R);let j=f.alloc(h?2:1,o,N);return j.writeUInt8(c),j.writeShortString(b),j.writeLongString(R),j.buffer}static deserializeRequestJSONArgs(o){const c=o.readUInt8(),v=o.readShortString(),p=o.readLongString();return{rpcId:c,method:v,args:JSON.parse(p)}}static _requestMixedArgs(o,c,v,p,h,b){const R=s.VSBuffer.fromString(v);let N=0;N+=f.sizeUInt8(),N+=f.sizeShortString(R),N+=f.sizeMixedArray(p,h);let j=f.alloc(b?4:3,o,N);return j.writeUInt8(c),j.writeShortString(R),j.writeMixedArray(p,h),j.buffer}static deserializeRequestMixedArgs(o){const c=o.readUInt8(),v=o.readShortString(),p=o.readMixedArray(),h=new Array(p.length);for(let b=0,R=p.length;b<R;b++){const N=p[b];typeof N=="string"?h[b]=JSON.parse(N):h[b]=N}return{rpcId:c,method:v,args:h}}static serializeAcknowledged(o){return f.alloc(5,o,0).buffer}static serializeCancel(o){return f.alloc(6,o,0).buffer}static serializeReplyOK(o,c,v){return typeof c=="undefined"?this._serializeReplyOKEmpty(o):c instanceof s.VSBuffer?this._serializeReplyOKVSBuffer(o,c):this._serializeReplyOKJSON(o,g(c,v))}static _serializeReplyOKEmpty(o){return f.alloc(7,o,0).buffer}static _serializeReplyOKVSBuffer(o,c){let v=0;v+=f.sizeVSBuffer(c);let p=f.alloc(8,o,v);return p.writeVSBuffer(c),p.buffer}static deserializeReplyOKVSBuffer(o){return o.readVSBuffer()}static _serializeReplyOKJSON(o,c){const v=s.VSBuffer.fromString(c);let p=0;p+=f.sizeLongString(v);let h=f.alloc(9,o,p);return h.writeLongString(v),h.buffer}static deserializeReplyOKJSON(o){const c=o.readLongString();return JSON.parse(c)}static serializeReplyErr(o,c){return c?this._serializeReplyErrEror(o,c):this._serializeReplyErrEmpty(o)}static _serializeReplyErrEror(o,c){const v=s.VSBuffer.fromString(g(T.transformErrorForSerialization(c),null));let p=0;p+=f.sizeLongString(v);let h=f.alloc(10,o,p);return h.writeLongString(v),h.buffer}static deserializeReplyErrError(o){const c=o.readLongString();return JSON.parse(c)}static _serializeReplyErrEmpty(o){return f.alloc(11,o,0).buffer}}var n;(function(i){i[i.RequestJSONArgs=1]="RequestJSONArgs",i[i.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",i[i.RequestMixedArgs=3]="RequestMixedArgs",i[i.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",i[i.Acknowledged=5]="Acknowledged",i[i.Cancel=6]="Cancel",i[i.ReplyOKEmpty=7]="ReplyOKEmpty",i[i.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",i[i.ReplyOKJSON=9]="ReplyOKJSON",i[i.ReplyErrError=10]="ReplyErrError",i[i.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var r;(function(i){i[i.String=1]="String",i[i.VSBuffer=2]="VSBuffer",i[i.Undefined=3]="Undefined"})(r||(r={}))}),define(ge[258],pe([0,1,4]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,_.createDecorator)("remoteAgentService")}),define(ge[259],pe([0,1,12,8,10,2,4,258]),function(K,e,_,I,T,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let D=class{constructor(s,C){this.localUserHome=s,this.remoteAgentService=C,this.resolveOS=(async()=>{const g=await this.remoteAgentService.getEnvironment();return(g==null?void 0:g.os)||T.OS})(),this.resolveUserHome=(async()=>{const g=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(g==null?void 0:g.userHome)||s})()}async userHome(s){return(s==null?void 0:s.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(s=>s===1?I.win32:I.posix)}async fileURI(s){let C="";if(await this.resolveOS===1&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const m=s.indexOf("/",2);m===-1?(C=s.substring(2),s="/"):(C=s.substring(2,m),s=s.substring(m)||"/")}return A.URI.from({scheme:_.Schemas.file,authority:C,path:s,query:"",fragment:""})}};D=Ve([xe(1,k.IRemoteAgentService)],D),e.AbstractPathService=D}),define(ge[66],pe([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class _{constructor(y,k){this.line=y,this.character=k}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,k){return new _(0,0)}with(y){return new _(0,0)}}e.Position=_;class I{constructor(y,k,D,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new _(y,k),this.end=new _(D,P)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new I(0,0,0,0)}with(y){return new I(0,0,0,0)}}e.Range=I;var T;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(T=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ge[31],pe([0,1,19,33,23,29,9,4,8,18,66]),function(K,e,_,I,T,A,y,k,D,P,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return s.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const C="\u27EA ",g=" characters skipped \u27EB",m=(C.length+g.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var a;(function(L){L[L.file=0]="file",L[L.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var u;(function(L){L[L.File=1]="File",L[L.Text=2]="Text"})(u=e.QueryType||(e.QueryType={}));function E(L){return!!L.preview}e.resultIsMatch=E;function w(L){return!!L.resource}e.isFileMatch=w;function S(L){return!!L.message}e.isProgressMessage=S;var d;(function(L){L[L.Normal=0]="Normal",L[L.NewSearchStarted=1]="NewSearchStarted"})(d=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class l{constructor(F){this.resource=F,this.results=[]}}e.FileMatch=l;class f{constructor(F,O,M){this.ranges=O;const B=Array.isArray(O)?O:[O];if(M&&M.matchLines===1&&t(B)){F=(0,y.getNLines)(F,M.matchLines);let V="",Q=0,de=0;const we=Math.floor(M.charsPerLine/5),Ie=[];for(const Ce of B){const Le=Math.max(Ce.startColumn-we,0),z=Ce.startColumn+M.charsPerLine;if(Le>de+we+m){const Y=C+(Le-de)+g;V+=Y+F.slice(Le,z),Q+=Le-(de+Y.length)}else V+=F.slice(de,z);Ie.push(new r(0,Ce.startColumn-Q,Ce.endColumn-Q)),de=z}this.preview={text:V,matches:Array.isArray(this.ranges)?Ie:Ie[0]}}else{const V=Array.isArray(O)?O[0].startLineNumber:O.startLineNumber;this.preview={text:F,matches:(0,_.mapArrayOrNot)(O,Q=>new n(Q.startLineNumber-V,Q.startColumn,Q.endLineNumber-V,Q.endColumn))}}}}e.TextSearchMatch=f;function t(L){const F=L[0].startLineNumber;for(const O of L)if(O.startLineNumber!==F||O.endLineNumber!==F)return!1;return!0}class n{constructor(F,O,M,B){this.startLineNumber=F,this.startColumn=O,this.endLineNumber=M,this.endColumn=B}}e.SearchRange=n;class r extends n{constructor(F,O,M){super(F,O,F,M)}}e.OneLineRange=r;var i;(function(L){L.Default="default",L.FileNames="fileNames",L.Type="type",L.Modified="modified",L.CountDescending="countDescending",L.CountAscending="countAscending"})(i=e.SearchSortOrder||(e.SearchSortOrder={}));function o(L,F=!0){const O=L&&L.files&&L.files.exclude,M=F&&L&&L.search&&L.search.exclude;if(!(!O&&!M)){if(!O||!M)return O||M;let B=Object.create(null);return B=T.mixin(B,T.deepClone(O)),B=T.mixin(B,T.deepClone(M),!0),B}}e.getExcludes=o;function c(L,F){return L.excludePattern&&I.match(L.excludePattern,F)?!1:L.includePattern||L.usingSearchPaths?L.includePattern&&I.match(L.includePattern,F)?!0:L.usingSearchPaths?!!L.folderQueries&&L.folderQueries.some(O=>{const M=O.folder.fsPath;if(A.isEqualOrParent(F,M)){const B=D.relative(M,F);return!O.includePattern||!!I.match(O.includePattern,B)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var v;(function(L){L[L.unknownEncoding=1]="unknownEncoding",L[L.regexParseError=2]="regexParseError",L[L.globParseError=3]="globParseError",L[L.invalidLiteral=4]="invalidLiteral",L[L.rgProcessError=5]="rgProcessError",L[L.other=6]="other",L[L.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class p extends Error{constructor(F,O){super(F);this.code=O}}e.SearchError=p;function h(L){const F=L.message;if((0,P.isPromiseCanceledError)(L))return new p(F,v.canceled);try{const O=JSON.parse(F);return new p(O.message,O.code)}catch(O){return new p(F,v.other)}}e.deserializeSearchError=h;function b(L){const F={message:L.message,code:L.code};return new Error(JSON.stringify(F))}e.serializeSearchError=b;function R(L){return L.type==="error"?!0:L.type==="success"}e.isSerializedSearchComplete=R;function N(L){return L.type==="success"}e.isSerializedSearchSuccess=N;function j(L){return!!L.path}e.isSerializedFileMatch=j;function oe(L,F){const O=L.searchPath?L.searchPath:L.relativePath;return(0,y.fuzzyContains)(O,F)}e.isFilePatternMatch=oe;class q{constructor(F){this.path=F,this.results=[]}addMatch(F){this.results.push(F)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=q;function W(L,F){const O=Object.assign(Object.assign({},L||{}),F||{});return Object.keys(O).filter(M=>{const B=O[M];return typeof B=="boolean"&&B})}e.resolvePatternsForProvider=W;class H{constructor(F,O){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},F.excludePattern||{}),O.excludePattern||{}),this._parsedExcludeExpression=I.parse(this._excludeExpression);let M=F.includePattern;O.includePattern&&(M?M=Object.assign(Object.assign({},M),O.includePattern):M=O.includePattern),M&&(this._parsedIncludeExpression=I.parse(M))}includedInQuerySync(F,O,M){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(F,O,M)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(F,O,M))}includedInQuery(F,O,M){return Promise.resolve(this._parsedExcludeExpression(F,O,M)).then(V=>!!V).then(V=>V?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(F,O,M)).then(Q=>!!Q):Promise.resolve(!0)).then(V=>V)}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=H;function U(L){for(const F in L)if(typeof L[F]!="boolean")return!0;return!1}}),define(ge[32],pe([0,1,19,15,21,3,24,12,73,25,9,11,2,167,4,13,186,60,61,27,14,7,31,5]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a,u,E,w,S,d,l,f,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(R,N,j){return new P.ExtUri(oe=>v(oe,j)).isEqual(R,N)}function i(R,N,j){return r(R.uri,N.uri,j)?0:(0,s.compare)(R.uri.toString(),N.uri.toString())}function o(R,N,j){return R.index!==N.index?R.index<N.index?-1:1:r(R.uri,N.uri,j)?(0,s.compare)(R.name,N.name):(0,s.compare)(R.uri.toString(),N.uri.toString())}function c(R,N,j,oe){const q=R.slice(0).sort((H,U)=>j(H,U,oe)),W=N.slice(0).sort((H,U)=>j(H,U,oe));return(0,_.delta)(q,W,(H,U)=>j(H,U,oe))}function v(R,N){const j=N.getCapabilities(R.scheme);return!(j&&j&1024)}class p extends w.Workspace{constructor(N,j,oe,q,W,H){super(N,oe.map(U=>new w.WorkspaceFolder(U)),q,H);this._name=j,this._isUntitled=W,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris(H),oe.forEach(U=>{this._workspaceFolders.push(U),this._structure.set(U.uri,U)})}static toExtHostWorkspace(N,j,oe,q){if(!N)return{workspace:null,added:[],removed:[]};const{id:W,name:H,folders:U,configuration:L,isUntitled:F}=N,O=[],M=j;j?U.forEach((de,we)=>{const Ie=g.URI.revive(de.uri),Ce=p._findFolder(oe||j,Ie,q);Ce?(Ce.name=de.name,Ce.index=de.index,O.push(Ce)):O.push({uri:Ie,name:de.name,index:we})}):O.push(...U.map(({uri:de,name:we,index:Ie})=>({uri:g.URI.revive(de),name:we,index:Ie}))),O.sort((de,we)=>de.index<we.index?-1:1);const B=new p(W,H,O,L?g.URI.revive(L):null,!!F,de=>v(de,q)),{added:V,removed:Q}=c(M?M.workspaceFolders:[],B.workspaceFolders,i,q);return{workspace:B,added:V,removed:Q}}static _findFolder(N,j,oe){for(let q=0;q<N.folders.length;q++){const W=N.workspaceFolders[q];if(r(W.uri,j,oe))return W}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(N,j){return j&&this._structure.get(N)&&(N=(0,P.dirname)(N)),this._structure.findSubstr(N)}resolveWorkspaceFolder(N){return this._structure.get(N)}}let h=class{constructor(N,j,oe,q){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=q,this._extHostFileSystemInfo=oe,this._requestIdProvider=new D.Counter,this._barrier=new I.Barrier,this._proxy=N.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=N.getProxy(n.MainContext.MainThreadMessageService);const W=j.workspace;this._confirmedWorkspace=W?new p(W.id,W.name,[],W.configuration?g.URI.revive(W.configuration):null,!!W.isUntitled,H=>v(H,oe)):void 0}$initializeWorkspace(N,j){this._trusted=j,this.$acceptWorkspaceData(N),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?g.URI.from({scheme:k.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(N,j,oe,...q){const W=[];if(Array.isArray(q)&&q.forEach(O=>{g.URI.isUri(O.uri)&&!W.some(M=>r(M.uri,O.uri,this._extHostFileSystemInfo))&&W.push({uri:O.uri,name:O.name||(0,P.basenameOrAuthority)(O.uri)})}),this._unconfirmedWorkspace||[j,oe].some(O=>typeof O!="number"||O<0)||oe===0&&W.length===0)return!1;const H=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(j+oe>H.length)return!1;const U=H.slice(0);U.splice(j,oe,...W.map(O=>({uri:O.uri,name:O.name||(0,P.basenameOrAuthority)(O.uri),index:void 0})));for(let O=0;O<U.length;O++){const M=U[O];if(U.some((B,V)=>V!==O&&r(M.uri,B.uri,this._extHostFileSystemInfo)))return!1}U.forEach((O,M)=>O.index=M);const{added:L,removed:F}=c(H,U,o,this._extHostFileSystemInfo);if(L.length===0&&F.length===0)return!1;if(this._proxy){const O=N.displayName||N.name;this._proxy.$updateWorkspaceFolders(O,j,oe,W).then(void 0,M=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(E.Severity.Error,(0,m.localize)(0,null,O,M.toString()),{extension:N},[])})}return this.trySetWorkspaceFolders(U),!0}getWorkspaceFolder(N,j){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,j)}async getWorkspaceFolder2(N,j){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,j)}async resolveWorkspaceFolder(N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(N)}getPath(){if(!!this._actualWorkspace){const{folders:N}=this._actualWorkspace;if(N.length!==0)return N[0].uri.fsPath}}getRelativePath(N,j){let oe,q="";if(typeof N=="string"?(oe=g.URI.file(N),q=N):typeof N!="undefined"&&(oe=N,q=N.fsPath),!oe)return q;const W=this.getWorkspaceFolder(oe,!0);if(!W)return q;typeof j=="undefined"&&this._actualWorkspace&&(j=this._actualWorkspace.folders.length>1);let H=(0,P.relativePath)(W.uri,oe);return j&&W.name&&(H=`${W.name}/${H}`),H}trySetWorkspaceFolders(N){this._actualWorkspace&&(this._unconfirmedWorkspace=p.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:N,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:j,added:oe,removed:q}=p.toExtHostWorkspace(N,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=j||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:oe,removed:q}))}findFiles(N,j,oe,q,W=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${q.value}, entryPoint: findFiles`);let H;if(j===null?H=!1:j&&(typeof j=="string"?H=j:H=j.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:U,folder:L}=b(N);return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(U),(0,C.withUndefinedAsNull)(L),(0,C.withUndefinedAsNull)(H),(0,C.withUndefinedAsNull)(oe),W).then(F=>Array.isArray(F)?F.map(O=>g.URI.revive(O)):[])}async findTextInFiles(N,j,oe,q,W=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${q.value}, entryPoint: findTextInFiles`);const H=this._requestIdProvider.getNext(),U=typeof j.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:L,folder:F}=b(j.include),O=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,M={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:U,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:L,excludePattern:O},B=!1;if(this._activeSearchCallbacks[H]=V=>{if(!B){const Q=g.URI.revive(V.resource);V.results.forEach(de=>{(0,t.resultIsMatch)(de)?oe({uri:Q,preview:{text:de.preview.text,matches:(0,_.mapArrayOrNot)(de.preview.matches,we=>new f.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:(0,_.mapArrayOrNot)(de.ranges,we=>new f.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):oe({uri:Q,text:de.text,lineNumber:de.lineNumber})})}},W.isCancellationRequested)return{};try{const V=await this._proxy.$startTextSearch(N,(0,C.withUndefinedAsNull)(F),M,H,W);return delete this._activeSearchCallbacks[H],V||{}}catch(V){throw delete this._activeSearchCallbacks[H],V}}$handleTextSearchResult(N,j){this._activeSearchCallbacks[j]&&this._activeSearchCallbacks[j](N)}saveAll(N){return this._proxy.$saveAll(N)}resolveProxy(N){return this._proxy.$resolveProxy(N)}get trusted(){return this._trusted}requestWorkspaceTrust(N){const j=this._proxy.$requestWorkspaceTrust(N);return(N==null?void 0:N.modal)?j:Promise.resolve(this._trusted)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};h=Ve([xe(0,l.IExtHostRpcService),xe(1,d.IExtHostInitDataService),xe(2,S.IExtHostFileSystemInfo),xe(3,u.ILogService)],h),e.ExtHostWorkspace=h,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function b(R){let N,j;return R&&(typeof R=="string"?N=R:(N=R.pattern,j=R.baseFolder||g.URI.file(R.base))),{includePattern:N,folder:j}}}),define(ge[35],pe([0,1,23,3,32,5,7,188,83,11,15,4,14,13,2]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(n,r){if(r){const i=r.split(".");let o=n;for(let c=0;o&&c<i.length;c++)o=o[i[c]];return o}}function E(n){return n instanceof a.URI}function w(n){return n&&n.uri instanceof a.URI&&n.languageId&&typeof n.languageId=="string"}function S(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function d(n){return n&&n.uri instanceof a.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function l(n){if(E(n))return{resource:n};if(w(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(S(n))return{overrideIdentifier:n.languageId};if(d(n))return{resource:n.uri};if(n===null)return{resource:null}}let f=class{constructor(r,i,o){this._proxy=r.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=o,this._barrier=new s.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(r,i))}};f=Ve([xe(0,g.IExtHostRpcService),xe(1,T.IExtHostWorkspace),xe(2,m.ILogService)],f),e.ExtHostConfiguration=f;class t{constructor(r,i,o,c){this._onDidChangeConfiguration=new I.Emitter,this._proxy=r,this._logService=c,this._extHostWorkspace=i,this._configuration=k.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,o))}getConfiguration(r,i,o){const c=l(i)||{},v=this._toReadonlyValue(r?u(this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,c,o==null?void 0:o.identifier);function p(b){if(b==null)return null;if(typeof b=="boolean")return b?1:4;switch(b){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const h={has(b){return typeof u(v,b)!="undefined"},get:(b,R)=>{this._validateConfigurationAccess(r?`${r}.${b}`:b,c,o==null?void 0:o.identifier);let N=u(v,b);if(typeof N=="undefined")N=R;else{let j;const oe=(q,W)=>{let H;const U=()=>{j=j||(0,_.deepClone)(v),H=H||u(j,W)};return(0,P.isObject)(q)?new Proxy(q,{get:(L,F)=>{if(typeof F=="string"&&F.toLowerCase()==="tojson")return U(),()=>H;if(j)return H=H||u(j,W),H[F];const O=L[F];return typeof F=="string"?oe(O,`${W}.${F}`):O},set:(L,F,O)=>(U(),H&&(H[F]=O),!0),deleteProperty:(L,F)=>(U(),H&&delete H[F],!0),defineProperty:(L,F,O)=>(U(),H&&Object.defineProperty(H,F,O),!0)}):q};N=oe(N,b)}return N},update:(b,R,N,j)=>{b=r?`${r}.${b}`:b;const oe=p(N);return R!==void 0?this._proxy.$updateConfigurationOption(oe,b,R,c,j):this._proxy.$removeConfigurationOption(oe,b,c,j)},inspect:b=>{var R,N,j,oe,q,W,H,U;b=r?`${r}.${b}`:b;const L=(0,_.deepClone)(this._configuration.inspect(b,c,this._extHostWorkspace.workspace));if(L)return{key:b,defaultValue:(R=L.default)===null||R===void 0?void 0:R.value,globalValue:(N=L.user)===null||N===void 0?void 0:N.value,workspaceValue:(j=L.workspace)===null||j===void 0?void 0:j.value,workspaceFolderValue:(oe=L.workspaceFolder)===null||oe===void 0?void 0:oe.value,defaultLanguageValue:(q=L.default)===null||q===void 0?void 0:q.override,globalLanguageValue:(W=L.user)===null||W===void 0?void 0:W.override,workspaceLanguageValue:(H=L.workspace)===null||H===void 0?void 0:H.override,workspaceFolderLanguageValue:(U=L.workspaceFolder)===null||U===void 0?void 0:U.override,languageIds:L.overrideIdentifiers}}};return typeof v=="object"&&(0,_.mixin)(h,v,!1),Object.freeze(h)}_toReadonlyValue(r){const i=o=>(0,P.isObject)(o)?new Proxy(o,{get:(c,v)=>i(c[v]),set:(c,v,p)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(c,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(c,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:c=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return i(r)}_validateConfigurationAccess(r,i,o){const c=D.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),v=o?`[${o.value}] `:"";if(c===4){typeof(i==null?void 0:i.resource)=="undefined"&&this._logService.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(c===3){(i==null?void 0:i.resource)&&this._logService.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const o=new k.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(c,v)=>o.affectsConfiguration(c,l(v))})}_toMap(r){return r.reduce((i,o)=>(i.set(o[0],o[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(K,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!T:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(K,_):T?T.value=_:e.set(K,_),_},Ue=this&&this.__classPrivateFieldGet||function(K,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!I:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(K):I?I.value:e.get(K)};define(ge[67],pe([0,1,2,15,3,5,7,32,39,35,21,34,14,27,4,12,10,13,63,209,18]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a,u,E,w,S,d,l){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(q){function W(U){if(U!=null)return U}q.from=W;function H(U){if(U!=null)return U}q.to=H})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(q){function W(U){if(U!=null)return U}q.from=W;function H(U){if(U!=null)return U}q.to=H})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(q){function W(U){if(U!=null)return U}q.from=W;function H(U){if(U!=null)return U}q.to=H})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(q){function W(L){if(L){const F=L;return F&&!!F.process}else return!1}q.is=W;function H(L){if(L!=null){const F={process:L.process,args:L.args};return L.options&&(F.options=r.from(L.options)),F}}q.from=H;function U(L){if(L!=null)return new y.ProcessExecution(L.process,L.args,L.options)}q.to=U})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(q){function W(U){if(U!=null)return U}q.from=W;function H(U){if(U!=null)return U}q.to=H})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var c;(function(q){function W(L){if(L){const F=L;return F&&(!!F.commandLine||!!F.command)}else return!1}q.is=W;function H(L){if(L!=null){const F={};return L.commandLine!==void 0?F.commandLine=L.commandLine:(F.command=L.command,F.args=L.args),L.options&&(F.options=o.from(L.options)),F}}q.from=H;function U(L){if(!(L==null||L.command===void 0&&L.commandLine===void 0))return L.commandLine?new y.ShellExecution(L.commandLine,L.options):new y.ShellExecution(L.command,L.args?L.args:[],L.options)}q.to=U})(c=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var v;(function(q){function W(L){if(L){let F=L;return F&&F.customExecution==="customExecution"}else return!1}q.is=W;function H(L){return{customExecution:"customExecution"}}q.from=H;function U(L,F){return F.get(L)}q.to=U})(v=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var p;(function(q){function W(H,U){let L;return H.scope!==void 0&&typeof H.scope!="number"?L=H.scope.uri:H.scope!==void 0&&typeof H.scope=="number"&&(H.scope===y.TaskScope.Workspace&&U&&U.workspaceFile?L=U.workspaceFile:L=d.USER_TASKS_GROUP_KEY),{id:H._id,workspaceFolder:L}}q.from=W})(p=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(q){function W(L,F){if(L==null)return[];const O=[];for(let M of L){const B=H(M,F);B&&O.push(B)}return O}q.fromMany=W;function H(L,F){if(L!=null){let O;L.execution instanceof y.ProcessExecution?O=i.from(L.execution):L.execution instanceof y.ShellExecution?O=c.from(L.execution):L.execution&&L.execution instanceof y.CustomExecution&&(O=v.from(L.execution));const M=t.from(L.definition);let B;if(L.scope?typeof L.scope=="number"?B=L.scope:B=L.scope.uri:B=y.TaskScope.Workspace,!(!M||!B)){const V=L.group?L.group.id:void 0;return{_id:L._id,definition:M,name:L.name,source:{extensionId:F.identifier.value,label:L.source,scope:B},execution:O,isBackground:L.isBackground,group:V,presentationOptions:n.from(L.presentationOptions),problemMatchers:L.problemMatchers,hasDefinedMatchers:L.hasDefinedMatchers,runOptions:L.runOptions?L.runOptions:{reevaluateOnRerun:!0},detail:L.detail}}}}q.from=H;async function U(L,F,O){if(L!=null){let M;i.is(L.execution)?M=i.to(L.execution):c.is(L.execution)?M=c.to(L.execution):v.is(L.execution)&&(M=v.to(L._id,O));const B=t.to(L.definition);let V;if(L.source&&(L.source.scope!==void 0?typeof L.source.scope=="number"?V=L.source.scope:V=await F.resolveWorkspaceFolder(_.URI.revive(L.source.scope)):V=y.TaskScope.Workspace),!(!B||!V)){const Q=new y.Task(B,V,L.name,L.source.label,M,L.problemMatchers);return L.isBackground!==void 0&&(Q.isBackground=L.isBackground),L.group!==void 0&&(Q.group=y.TaskGroup.from(L.group)),L.presentationOptions&&(Q.presentationOptions=n.to(L.presentationOptions)),L._id&&(Q._id=L._id),L.detail&&(Q.detail=L.detail),Q}}}q.to=U})(h=e.TaskDTO||(e.TaskDTO={}));var b;(function(q){function W(U){return U}q.from=W;function H(U){if(!!U)return Object.assign(Object.create(null),U)}q.to=H})(b=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(W,H,U){this._id=H,this._task=U,f.set(this,void 0),tt(this,f,W,"f")}get task(){return this._task}terminate(){Ue(this,f,"f").terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}f=new WeakMap;var N;(function(q){function W(H){return{id:H._id,task:void 0}}q.from=W})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let j=class{constructor(W,H,U,L,F,O,M,B){this._onDidExecuteTask=new T.Emitter,this._onDidTerminateTask=new T.Emitter,this._onDidTaskProcessStarted=new T.Emitter,this._onDidTaskProcessEnded=new T.Emitter,this._proxy=W.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=L,this._configurationService=F,this._terminalService=O,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=M,this._deprecationService=B,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(W,H,U){if(!U)return new y.Disposable(()=>{});const L=this.nextHandle();return this._handlers.set(L,{type:H,provider:U,extension:W}),this._proxy.$registerTaskProvider(L,H),new y.Disposable(()=>{this._handlers.delete(L),this._proxy.$unregisterTaskProvider(L)})}registerTaskSystem(W,H){this._proxy.$registerTaskSystem(W,H)}fetchTasks(W){return this._proxy.$fetchTasks(b.from(W)).then(async H=>{const U=[];for(let L of H){const F=await h.to(L,this._workspaceProvider,this._providedCustomExecutions2);F&&U.push(F)}return U})}get taskExecutions(){const W=[];return this._taskExecutions.forEach(H=>W.push(H)),W}terminateTask(W){if(!(W instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(W._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(W,H,U){const L=this._providedCustomExecutions2.get(W.id);if(L){if(this._activeCustomExecutions2.get(W.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(W.id,L),this._terminalService.attachPtyToTerminal(H,await L.callback(U))}this._lastStartedTask=W.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(W)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(W){const H=await this.getTaskExecution(W);this._taskExecutionPromises.delete(W.id),this._taskExecutions.delete(W.id),this.customExecutionComplete(W),this._onDidTerminateTask.fire({execution:H})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(W){const H=await this.getTaskExecution(W.id);this._onDidTaskProcessStarted.fire({execution:H,processId:W.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(W){const H=await this.getTaskExecution(W.id);this._onDidTaskProcessEnded.fire({execution:H,exitCode:W.exitCode})}$provideTasks(W,H){const U=this._handlers.get(W);if(!U)return Promise.reject(new Error("no handler found"));const L=[],F=(0,I.asPromise)(()=>U.provider.provideTasks(s.CancellationToken.None)).then(O=>this.provideTasksInternal(H,L,U,O));return new Promise(O=>{F.then(M=>{Promise.all(L).then(()=>{O(M)})})})}async $resolveTask(W,H){const U=this._handlers.get(W);if(!U)return Promise.reject(new Error("no handler found"));if(H.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${H.definition.type}] cannot be resolved by provider of type [${U.type}].`);const L=await h.to(H,this._workspaceProvider,this._providedCustomExecutions2);if(!L)throw new Error("Unexpected: Task cannot be resolved.");const F=await U.provider.resolveTask(L,s.CancellationToken.None);if(!!F){this.checkDeprecation(F,U);const O=h.from(F,U.extension);if(!O)throw new Error("Unexpected: Task cannot be resolved.");if(F.definition!==L.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return v.is(O.execution)&&await this.addCustomExecution(O,F,!0),await this.resolveTaskInternal(O)}}nextHandle(){return this._handleCounter++}async addCustomExecution(W,H,U){const L=await this._proxy.$createTaskId(W);!U&&!this._providedCustomExecutions2.has(L)&&this._notProvidedCustomExecutions.add(L),this._providedCustomExecutions2.set(L,H.execution)}async getTaskExecution(W,H){if(typeof W=="string"){const F=this._taskExecutionPromises.get(W);if(!F)throw new Error("Unexpected: The specified task is missing an execution");return F}let U=this._taskExecutionPromises.get(W.id);if(U)return U;const L=new Promise(async(F,O)=>{const M=H||await h.to(W.task,this._workspaceProvider,this._providedCustomExecutions2);M?F(new R(this,W.id,M)):O("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(W.id,L),L.then(F=>(this._taskExecutions.set(W.id,F),F),F=>Promise.reject(F))}checkDeprecation(W,H){W._deprecated&&this._deprecationService.report("Task.constructor",H.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(W){this._activeCustomExecutions2.get(W.id)&&this._activeCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.has(W.id)&&this._lastStartedTask!==W.id&&(this._providedCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.delete(W.id));let U=this._notProvidedCustomExecutions.values(),L=U.next();for(;!L.done;)!this._activeCustomExecutions2.has(L.value)&&this._lastStartedTask!==L.value&&(this._providedCustomExecutions2.delete(L.value),this._notProvidedCustomExecutions.delete(L.value)),L=U.next()}};j=Ve([xe(0,g.IExtHostRpcService),xe(1,m.IExtHostInitDataService),xe(2,k.IExtHostWorkspace),xe(3,D.IExtHostDocumentsAndEditors),xe(4,P.IExtHostConfiguration),xe(5,C.IExtHostTerminalService),xe(6,w.ILogService),xe(7,S.IExtHostApiDeprecationService)],j),e.ExtHostTaskBase=j;let oe=class extends j{constructor(W,H,U,L,F,O,M,B){super(W,H,U,L,F,O,M,B);this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:E.PlatformToString(0)})}async executeTask(W,H){if(!H.execution)throw new Error("Tasks to execute must include an execution");const U=h.from(H,W);if(U===void 0)throw new Error("Task is not valid");if(v.is(U.execution))await this.addCustomExecution(U,H,!1);else throw new l.NotSupportedError;const L=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),H);return this._proxy.$executeTask(U).catch(F=>{throw new Error(F)}),L}provideTasksInternal(W,H,U,L){const F=[];if(L)for(let O of L){this.checkDeprecation(O,U),(!O.definition||!W[O.definition.type])&&this._logService.warn(`The task [${O.source}, ${O.name}] uses an undefined task type. The task will be ignored in the future.`);const M=h.from(O,U.extension);M&&v.is(M.execution)?(F.push(M),H.push(this.addCustomExecution(M,O,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:F,extension:U.extension}}async resolveTaskInternal(W){if(v.is(W.execution))return W;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(W,H){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(W,H,U){}};oe=Ve([xe(0,g.IExtHostRpcService),xe(1,m.IExtHostInitDataService),xe(2,k.IExtHostWorkspace),xe(3,D.IExtHostDocumentsAndEditors),xe(4,P.IExtHostConfiguration),xe(5,C.IExtHostTerminalService),xe(6,w.ILogService),xe(7,S.IExtHostApiDeprecationService)],oe),e.WorkerExtHostTask=oe,e.IExtHostTask=(0,a.createDecorator)("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(K,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!T:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(K,_):T?T.value=_:e.set(K,_),_},Ue=this&&this.__classPrivateFieldGet||function(K,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!I:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(K):I?I.value:e.get(K)},jt=this&&this.__rest||function(K,e){var _={};for(var I in K)Object.prototype.hasOwnProperty.call(K,I)&&e.indexOf(I)<0&&(_[I]=K[I]);if(K!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,I=Object.getOwnPropertySymbols(K);T<I.length;T++)e.indexOf(I[T])<0&&Object.prototype.propertyIsEnumerable.call(K,I[T])&&(_[I[T]]=K[I[T]]);return _};define(ge[260],pe([0,1,19,15,22,21,3,71,54,6,23,11,2,30,5,39,14,87,20,7,32,222,123]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a,u,E,w,S,d,l,f,t){"use strict";var n,r,i,o;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const c=(U,L)=>`${U}:${L.toString()}`;let v=class{constructor(L,F,O){this.documents=F,this.workspace=O,this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.ownedTests=new f.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(a.MainContext.MainThreadTesting),this.runQueue=new p(this.proxy),this.workspaceObservers=new W(this.proxy),this.textDocumentObservers=new H(this.proxy,F)}registerTestController(L,F){const O=(0,m.generateUuid)();this.controllers.set(O,{instance:F,extensionId:L}),this.proxy.$registerTestController(O);const M=[...this.testControllers.keys()];return setTimeout(()=>{var B;for(const V of M)(B=this.testControllers.get(V))===null||B===void 0||B.subscribeFn(O,F)},0),new d.Disposable(()=>{this.controllers.delete(O),this.proxy.$unregisterTestController(O)})}createTextDocumentTestObserver(L){return this.textDocumentObservers.checkout(L.uri)}createWorkspaceTestObserver(L){return this.workspaceObservers.checkout(L.uri)}async runTests(L,F=A.CancellationToken.None){const O=M=>M.map(this.getInternalTestForReference,this).filter(C.isDefined).map(B=>({src:B.src,testId:B.item.extId}));await this.proxy.$runTests({exclude:L.exclude?O(L.exclude).map(M=>M.testId):void 0,tests:O(L.tests),debug:L.debug},F)}createTestRunTask(L,F,O,M=!0){return this.runQueue.createTestRunTask(L,F,O,M)}$publishTestResults(L){this.results=Object.freeze(L.map(F=>(0,s.deepFreeze)(S.TestResults.to(F))).concat(this.results).sort((F,O)=>O.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(L,F){const O=g.URI.revive(F),M=c(L,O);if(!this.testControllers.has(M)){const B=new A.CancellationTokenSource;let V;if(L===1){let Ie=this.documents.getDocument(O);if(!Ie){const Ce=new P.DisposableStore;Ie=await new Promise(Le=>{Ce.add((0,I.disposableTimeout)(()=>Le(void 0),5e3)),Ce.add(this.documents.onDidAddDocuments(z=>{const Y=z.find(ee=>ee.document.uri.toString()===O.toString());Y&&Le(Y)}))}).finally(()=>Ce.dispose())}if(Ie){const Ce=await this.workspace.getWorkspaceFolder2(O,!1);V=Le=>Le.createDocumentTestRoot?Le.createDocumentTestRoot(Ie.document,B.token):(0,e.createDefaultDocumentTestRoot)(Le,Ie.document,Ce,B.token)}}else{const Ie=await this.workspace.getWorkspaceFolder2(O,!1);Ie&&(V=Ce=>Ce.createWorkspaceTestRoot(Ie,B.token))}if(!!V){const Q=async(Ie,Ce)=>{try{const Le=await V(Ce);Le&&we.addRoot(Le,Ie)}catch(Le){console.error(Le)}},de=new P.DisposableStore,we=de.add(this.ownedTests.createForHierarchy(Ie=>this.proxy.$publishDiff(L,F,Ie)));de.add((0,P.toDisposable)(()=>B.dispose(!0)));for(const[Ie,Ce]of this.controllers)Q(Ie,Ce.instance);we.pushDiff([3,-1]),this.testControllers.set(M,{store:de,collection:we,subscribeFn:Q})}}}async $expandTest(L,F){const O=(0,_.mapFind)(this.testControllers.values(),M=>M.collection.treeId===L.src.tree?M:void 0);await(O==null?void 0:O.collection.expand(L.testId,F<0?Infinity:F)),this.flushCollectionDiffs()}$unsubscribeFromTests(L,F){var O;const M=g.URI.revive(F),B=c(L,M);(O=this.testControllers.get(B))===null||O===void 0||O.store.dispose(),this.testControllers.delete(B)}$acceptDiff(L,F,O){L===1?this.textDocumentObservers.acceptDiff(g.URI.revive(F),O):this.workspaceObservers.acceptDiff(g.URI.revive(F),O)}async $runTestsForProvider(L,F){const O=this.controllers.get(L.tests[0].src.controller);if(!!O){const M=L.tests.map(({testId:Q,src:de})=>this.ownedTests.getTestById(Q,de==null?void 0:de.tree)).filter(C.isDefined).map(([Q,de])=>de),B=L.excludeExtIds.map(Q=>this.ownedTests.getTestById(Q)).filter(C.isDefined).filter(([Q,de])=>M.some(we=>Q.comparePositions(we,de)===1));if(!!M.length){const V={tests:M.map(Q=>N.unwrap(Q.actual)),exclude:B.map(([,Q])=>N.unwrap(Q.actual)),debug:L.debug};await this.runQueue.enqueueRun({dto:h.fromInternal(L),token:F,extensionId:O.extensionId,req:V,doRun:()=>O.instance.runTests(V,F)})}}}$lookupTest(L){const F=this.ownedTests.getTestById(L.testId);if(!F)return Promise.resolve(void 0);const O=F[1],{actual:M,discoverCts:B,expandLevels:V}=O,Q=jt(O,["actual","discoverCts","expandLevels"]);return Promise.resolve(Q)}flushCollectionDiffs(){for(const{collection:L}of this.testControllers.values())L.flushDiff()}getInternalTestForReference(L){var F,O;return(O=(F=this.workspaceObservers.getMirroredTestDataByReference(L))!==null&&F!==void 0?F:(0,_.mapFind)(this.testControllers.values(),M=>M.collection.getTestByReference(L)))!==null&&O!==void 0?O:this.textDocumentObservers.getMirroredTestDataByReference(L)}};v=Ve([xe(0,E.IExtHostRpcService),xe(1,u.IExtHostDocumentsAndEditors),xe(2,l.IExtHostWorkspace)],v),e.ExtHostTesting=v;class p{constructor(L){this.proxy=L,this.state=new Map}enqueueRun(L){let F=this.state.get(L.extensionId);F||(F={queue:[],current:void 0},this.state.set(L.extensionId,F));const O=new I.DeferredPromise,M=()=>{const B=[],V=new Set;F.current={publicReq:L.req,factory:Q=>{const de=new b(Q,L.dto,V,this.proxy);return B.push(de),L.token.onCancellationRequested(()=>de.end()),de}},this.invokeRunner(L.extensionId,L.dto.id,L.doRun,B).finally(()=>O.complete())};return F.queue.push(M),F.queue.length===1&&M(),O.p}createTestRunTask(L,F,O,M){var B,V;const Q=this.state.get(L);if((Q==null?void 0:Q.current.publicReq)===F)return Q.current.factory(O);const de=h.fromPublic(F),we=new b(O,de,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:F.debug,exclude:(V=(B=F.exclude)===null||B===void 0?void 0:B.map(Ie=>Ie.id))!==null&&V!==void 0?V:[],id:de.id,tests:F.tests.map(Ie=>Ie.id),persist:M}),we.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(de.id)),we}invokeRunner(L,F,O,M){try{const B=O();return(0,I.isThenable)(B)?B.then(()=>this.handleInvokeResult(L,F,M,void 0)).catch(V=>this.handleInvokeResult(L,F,M,V)):this.handleInvokeResult(L,F,M,void 0)}catch(B){return this.handleInvokeResult(L,F,M,B)}}async handleInvokeResult(L,F,O,M){const B=this.state.get(L);!B||(B.queue.shift(),B.queue.length>0?B.queue[0]():this.state.delete(L),await Promise.all(O.map(V=>V.onEnd.wait())))}}class h{constructor(L,F,O){this.id=L,this.include=F,this.exclude=O}static fromPublic(L){var F,O;return new h((0,m.generateUuid)(),new Set(L.tests.map(M=>M.id)),new Set((O=(F=L.exclude)===null||F===void 0?void 0:F.map(M=>M.id))!==null&&O!==void 0?O:D.Iterable.empty()))}static fromInternal(L){return new h(L.runId,new Set(L.tests.map(F=>F.testId)),new Set(L.excludeExtIds))}isIncluded(L){for(let F=L;F;F=F.parent){if(this.include.has(F.id))return!0;if(this.exclude.has(F.id))return!1}return!0}}class b{constructor(L,F,O,M){this.name=L,n.set(this,void 0),r.set(this,void 0),i.set(this,(0,m.generateUuid)()),o.set(this,void 0),this.onEnd=new I.Barrier,tt(this,n,M,"f"),tt(this,r,F,"f"),tt(this,o,O,"f"),M.$startedTestRunTask(F.id,{id:Ue(this,i,"f"),name:L,running:!0})}setState(L,F,O){Ue(this,r,"f").isIncluded(L)&&(this.ensureTestIsKnown(L),Ue(this,n,"f").$updateTestStateInRun(Ue(this,r,"f").id,Ue(this,i,"f"),L.id,F,O))}appendMessage(L,F){Ue(this,r,"f").isIncluded(L)&&(this.ensureTestIsKnown(L),Ue(this,n,"f").$appendTestMessageInRun(Ue(this,r,"f").id,Ue(this,i,"f"),L.id,S.TestMessage.from(F)))}appendOutput(L){Ue(this,n,"f").$appendOutputToRun(Ue(this,r,"f").id,Ue(this,i,"f"),T.VSBuffer.fromString(L))}end(){Ue(this,n,"f").$finishedTestRunTask(Ue(this,r,"f").id,Ue(this,i,"f")),this.onEnd.open()}ensureTestIsKnown(L){const F=Ue(this,o,"f");if(!F.has(L.id)){const O=[];for(;O.unshift(S.TestItem.from(L)),!(F.has(L.id)||(F.add(L.id),!L.parent));)L=L.parent;Ue(this,n,"f").$addTestsToRun(Ue(this,r,"f").id,O)}}}n=new WeakMap,r=new WeakMap,i=new WeakMap,o=new WeakMap;const R=async(U,L,F,O)=>{if(!!F){const M=await U.createWorkspaceTestRoot(F,O);if(!!M){O.onCancellationRequested(()=>{N.removeFilter(L)});const B=N.getWrapperForTestItem(M,L);return B.refreshMatch(),B}}};e.createDefaultDocumentTestRoot=R;class N extends d.TestItemImpl{constructor(L,F,O){super(L.id,L.label,L.uri,void 0);if(this.actual=L,this.filterDocument=F,this.actualParent=O,!(L instanceof d.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${L.id} did not`);this.debuggable=L.debuggable,this.runnable=L.runnable,this.description=L.description,this.error=L.error,this.status=L.status,this.range=L.range,this.resolveHandler=L.resolveHandler;const M=(0,w.getPrivateApiFor)(this);(0,w.getPrivateApiFor)(L).bus.event(V=>{switch(V[0]){case 3:this[V[1]]=V[2];break;case 0:const Q=N.getWrapperForTestItem(V[1],this.filterDocument,this);(0,w.getPrivateApiFor)(Q).parent=L,Q.refreshMatch();break;default:M.bus.fire(V)}})}static removeFilter(L){this.wrapperMap.delete(L)}static getWrapperForTestItem(L,F,O){let M=this.wrapperMap.get(F);if(M==null?void 0:M.has(L))return M.get(L);M||(M=new WeakMap,this.wrapperMap.set(F,M));const B=new N(L,F,O);return M.set(L,B),B}static unwrap(L){return L instanceof N?L.actual:L}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var L;const F=this._cachedMatchesFilter;for(const M of this.actual.children.values()){const B=N.getWrapperForTestItem(M,this.filterDocument,this);B.hasNodeMatchingFilter?this.children.has(B.id)||this.addChild(B):B.dispose()}const O=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=O,O!==F&&((L=this.actualParent)===null||L===void 0||L.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,w.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,w.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=N,N.wrapperMap=new WeakMap;class j extends t.IncrementalChangeCollector{constructor(L){super();this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(L){this.added.add(L)}update(L){Object.assign(L.revived,S.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}if(this.updated.delete(L),L.parent&&this.alreadyRemoved.has(L.parent)){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:F,removed:O}=this;return{get added(){return[...L].map(M=>M.revived)},get updated(){return[...F].map(M=>M.revived)},get removed(){return[...O].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class oe extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(L){let F=[];for(const O of L){const M=this.items.get(O);M&&F.push(M.revived)}return F}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,F){return Object.assign(Object.assign({},L),{revived:S.TestItem.toPlain(L.item),depth:F?F.depth+1:0,children:new Set})}createChangeCollector(){return new j(this.changeEmitter)}}e.MirroredTestCollection=oe;class q{constructor(){this.resources=new Map}checkout(L){var F,O;const M=L.toString(),B=(F=this.resources.get(M))!==null&&F!==void 0?F:this.createObserverData(L);return(O=B.pendingDeletion)===null||O===void 0||O.dispose(),B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,onDidDiscoverInitialTests:new y.Emitter().event,get tests(){return B.tests.rootTestItems},dispose:(0,k.once)(()=>{--B.observers||(B.pendingDeletion=this.eventuallyDispose(L))})}}getMirroredTestDataByReference(L){for(const{tests:F}of this.resources.values()){const O=F.getMirroredTestDataByReference(L);if(O)return O}}eventuallyDispose(L){return(0,I.disposableTimeout)(()=>this.unlisten(L),10*1e3)}createObserverData(L){const F=new oe,O=this.listen(L,B=>F.apply(B)),M={observers:0,tests:F,listener:O};return this.resources.set(L.toString(),M),M}unlisten(L){var F;const O=L.toString(),M=this.resources.get(O);M&&(M.observers=-1,(F=M.pendingDeletion)===null||F===void 0||F.dispose(),M.listener.dispose(),this.resources.delete(O))}}class W extends q{constructor(L){super();this.proxy=L,this.diffListeners=new Map}acceptDiff(L,F){var O;(O=this.diffListeners.get(L.toString()))===null||O===void 0||O(F)}listen(L,F){this.proxy.$subscribeToDiffs(0,L);const O=L.toString();return this.diffListeners.set(O,F),new d.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,L),this.diffListeners.delete(O)})}}class H extends q{constructor(L,F){super();this.proxy=L,this.documents=F,this.diffListeners=new Map}acceptDiff(L,F){var O;(O=this.diffListeners.get(L.toString()))===null||O===void 0||O(F)}listen(L,F){if(!this.documents.getDocument(L))return new d.Disposable(()=>{});const M=L.toString();return this.diffListeners.set(M,F),this.proxy.$subscribeToDiffs(1,L),new d.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,L),this.diffListeners.delete(M)})}}}),define(ge[261],pe([0,1,19,53,33,76,24,12,8,25,9,11,2,140,173,84,60,214,259,31]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a,u,E,w,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let l=class{constructor(p,h,b,R){this.configurationService=p,this.workspaceContextService=h,this.editorGroupsService=b,this.pathService=R}text(p,h,b={}){p=this.getContentPattern(p,b);const R=this.configurationService.getValue(),N=h&&h.some(oe=>!this.configurationService.getValue({resource:oe}).search.useRipgrep),j=this.commonQuery(h==null?void 0:h.map(E.toWorkspaceFolder),b);return Object.assign(Object.assign({},j),{type:2,contentPattern:p,previewOptions:b.previewOptions,maxFileSize:b.maxFileSize,usePCRE2:R.search.usePCRE2||N||!1,beforeContext:b.beforeContext,afterContext:b.afterContext,userDisabledExcludesAndIgnoreFiles:b.disregardExcludeSettings&&b.disregardIgnoreFiles})}getContentPattern(p,h){const b=this.configurationService.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},p),{wordSeparators:b.editor.wordSeparators});return this.isCaseSensitive(p,h)&&(R.isCaseSensitive=!0),this.isMultiline(p)&&(R.isMultiline=!0),R}file(p,h={}){const b=this.commonQuery(p,h);return Object.assign(Object.assign({},b),{type:1,filePattern:h.filePattern?h.filePattern.trim():h.filePattern,exists:h.exists,sortByScore:h.sortByScore,cacheKey:h.cacheKey})}handleIncludeExclude(p,h){return p?(p=Array.isArray(p)?p.map(i):i(p),h?this.parseSearchPaths(p):{pattern:t(...Array.isArray(p)?p:[p])}):{}}commonQuery(p=[],h={}){const b=this.handleIncludeExclude(h.includePattern,h.expandPatterns),R=this.handleIncludeExclude(h.excludePattern,h.expandPatterns),N=p.length>1,j=(b.searchPaths&&b.searchPaths.length?b.searchPaths.map(W=>this.getFolderQueryForSearchPath(W,h,R)):p.map(W=>this.getFolderQueryForRoot(W,h,R,N))).filter(W=>!!W),oe={_reason:h._reason,folderQueries:j,usingSearchPaths:!!(b.searchPaths&&b.searchPaths.length),extraFileResources:h.extraFileResources,excludePattern:R.pattern,includePattern:b.pattern,onlyOpenEditors:h.onlyOpenEditors,maxResults:h.maxResults};if(h.onlyOpenEditors){const H=_.coalesce(_.flatten(this.editorGroupsService.groups.map(L=>L.editors.map(F=>F.resource)))).filter(L=>(0,d.pathIncludedInQuery)(oe,L.fsPath)),U=this.commonQueryFromFileList(H);return Object.assign(Object.assign({},oe),U)}const q=h.extraFileResources&&h.extraFileResources.filter(W=>(0,d.pathIncludedInQuery)(oe,W.fsPath));return oe.extraFileResources=q&&q.length?q:void 0,oe}commonQueryFromFileList(p){const h=[],b=new y.ResourceMap,R={};let N=!1;return p.forEach(j=>{var oe,q;if(j.scheme!==k.Schemas.walkThrough)if((0,P.isAbsolutePath)(j)){const H=(q=(oe=this.workspaceContextService.getWorkspaceFolder(j))===null||oe===void 0?void 0:oe.uri)!==null&&q!==void 0?q:j.with({path:D.dirname(j.fsPath)});let U=b.get(H);U||(N=!0,U={folder:H,includePattern:{}},h.push(U),b.set(H,U));const L=D.relative(H.fsPath,j.fsPath);(0,C.assertIsDefined)(U.includePattern)[L.replace(/\\/g,"/")]=!0}else j.fsPath&&(N=!0,R[j.fsPath]=!0)}),{folderQueries:h,includePattern:R,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}isCaseSensitive(p,h){if(h.isSmartCase){if(p.isRegExp){if(s.containsUppercaseCharacter(p.pattern,!0))return!0}else if(s.containsUppercaseCharacter(p.pattern))return!0}return!!p.isCaseSensitive}isMultiline(p){return p.isMultiline||p.isRegExp&&(0,m.isMultilineRegexSource)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const h=U=>D.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),R=(Array.isArray(p)?p:n(p)).map(U=>{const L=this.pathService.resolvedUserHome;return L?(0,A.untildify)(U,L.scheme===k.Schemas.file?L.fsPath:L.path):U}),N=I.groupBy(R,U=>h(U)?"searchPaths":"exprSegments"),j=(N.exprSegments||[]).map(U=>s.rtrim(U,"/")).map(U=>s.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),r(U))),oe={},q=this.expandSearchPathPatterns(N.searchPaths||[]);q&&q.length&&(oe.searchPaths=q);const W=_.flatten(j),H=t(...W);return H&&(oe.pattern=H),oe}getExcludesForFolder(p,h){return h.disregardExcludeSettings?void 0:(0,d.getExcludes)(p,!h.disregardSearchExcludeSettings)}expandSearchPathPatterns(p){if(!p||!p.length)return[];const h=_.flatten(p.map(R=>{let{pathPortion:N,globPortion:j}=f(R);j&&(j=o(j));const oe=this.expandOneSearchPath(N);return _.flatten(oe.map(q=>this.resolveOneSearchPathPattern(q,j)))})),b=new Map;return h.forEach(R=>{const N=R.searchPath.toString(),j=b.get(N);j?R.pattern&&(j.pattern=j.pattern||{},j.pattern[R.pattern]=!0):b.set(N,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(b.values())}expandOneSearchPath(p){if(D.isAbsolute(p)){const h=this.workspaceContextService.getWorkspace().folders;return h[0]&&h[0].uri.scheme!==k.Schemas.file?[{searchPath:h[0].uri.with({path:p})}]:[{searchPath:g.URI.file(D.normalize(p))}]}if(this.workspaceContextService.getWorkbenchState()===2){const h=this.workspaceContextService.getWorkspace().folders[0].uri;if(p=i(p),p.startsWith("../")||p===".."){const R=D.posix.resolve(h.path,p);return[{searchPath:h.with({path:R})}]}const b=o(p);return[{searchPath:h,pattern:b}]}else{if(p==="./"||p===".\\")return[];{const h=p.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(h){const b=h[1],R=this.workspaceContextService.getWorkspace().folders.filter(N=>N.name===b);if(R.length)return R.map(N=>{const j=h[2];return{searchPath:N.uri,pattern:j&&o(j)}});{const N=a.localize(0,null,b);throw new Error(N)}}}}return[]}resolveOneSearchPathPattern(p,h){const b=p.pattern&&h?`${p.pattern}/${h}`:p.pattern||h,R=[{searchPath:p.searchPath,pattern:b}];return b&&!b.endsWith("**")&&R.push({searchPath:p.searchPath,pattern:b+"/**"}),R}getFolderQueryForSearchPath(p,h,b){const R=this.getFolderQueryForRoot((0,E.toWorkspaceFolder)(p.searchPath),h,b,!1);return R?Object.assign(Object.assign({},R),{includePattern:p.pattern}):null}getFolderQueryForRoot(p,h,b,R){let N;const j=g.URI.isUri(p)?p:p.uri;if(b.searchPaths){const U=b.searchPaths.filter(L=>(0,P.isEqual)(L.searchPath,j))[0];if(U&&!U.pattern)return null;U&&(N=U.pattern)}const oe=this.configurationService.getValue({resource:j}),q=this.getExcludesForFolder(oe,h),W=Object.assign(Object.assign({},q||{}),N||{}),H=g.URI.isUri(p)?(0,P.basename)(p):p.name;return{folder:j,folderName:R?H:void 0,excludePattern:Object.keys(W).length>0?W:void 0,fileEncoding:oe.files&&oe.files.encoding,disregardIgnoreFiles:typeof h.disregardIgnoreFiles=="boolean"?h.disregardIgnoreFiles:!oe.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof h.disregardGlobalIgnoreFiles=="boolean"?h.disregardGlobalIgnoreFiles:!oe.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof h.ignoreSymlinks=="boolean"?h.ignoreSymlinks:!oe.search.followSymlinks}}};l=Ve([xe(0,u.IConfigurationService),xe(1,E.IWorkspaceContextService),xe(2,w.IEditorGroupsService),xe(3,S.IPathService)],l),e.QueryBuilder=l;function f(v){const p=v.match(/[\*\{\}\(\)\[\]\?]/);if(p){const h=p.index,b=v.substr(0,h).match(/[/|\\][^/\\]*$/);if(b){let R=v.substr(0,b.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:v.substr((b.index||0)+1)}}}return{pathPortion:v}}function t(...v){return v.length?v.reduce((p,h)=>(p[h]=!0,p),Object.create(null)):void 0}function n(v){return T.splitGlobAware(v,",").map(p=>p.trim()).filter(p=>!!p.length)}function r(v){return[`**/${v}/**`,`**/${v}`].map(h=>h.replace(/\*\*\/\*\*/g,"**"))}function i(v){return v.replace(/\\/g,"/")}function o(v){return i(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(v,p){v=_.distinct(v,R=>R.toString());const h=[],b=p.getWorkspace();return v&&v.forEach(R=>{let N;if(p.getWorkbenchState()===2)N=(0,P.relativePath)(b.folders[0].uri,R),N&&N!=="."&&(N="./"+N);else{const j=p.getWorkspaceFolder(R);if(j){const oe=j.name;if(b.folders.filter(W=>W.name===oe).length===1){const W=(0,P.relativePath)(j.uri,R);W===""?N=`./${j.name}`:N=`./${j.name}/${W}`}else N=R.fsPath}}N&&h.push(N)}),h}e.resolveResourcesForSearchIncludes=c}),define(ge[262],pe([0,1,25,2,21,18,4,261,31,60]),function(K,e,_,I,T,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const s=7e3;function C(u,E){const w=E.activationEvents;if(!w)return Promise.resolve(void 0);const S=[],d=[];for(const i of w)if(/^workspaceContains:/.test(i)){const o=i.substr("workspaceContains:".length);o.indexOf("*")>=0||o.indexOf("?")>=0||u.forceUsingSearch?d.push(o):S.push(o)}if(S.length===0&&d.length===0)return Promise.resolve(void 0);let l;const f=new Promise((i,o)=>{l=i}),t=i=>l({activationEvent:i}),n=Promise.all(S.map(i=>g(u,i,t))).then(()=>{}),r=m(u,E.identifier,d,t);return Promise.all([n,r]).then(()=>{l(void 0)}),f}e.checkActivateWorkspaceContainsExtension=C;async function g(u,E,w){for(const S of u.folders)if(await u.exists(_.joinPath(I.URI.revive(S),E))){w(`workspaceContains:${E}`);return}}async function m(u,E,w,S){if(w.length===0)return Promise.resolve(void 0);const d=new T.CancellationTokenSource,l=u.checkExists(u.folders,w,d.token),f=setTimeout(async()=>{d.cancel(),S(`workspaceContainsTimeout:${w.join(",")}`)},s);let t=!1;try{t=await l}catch(n){A.isPromiseCanceledError(n)||A.onUnexpectedError(n)}d.dispose(),clearTimeout(f),t&&S(`workspaceContains:${w.join(",")}`)}function a(u,E,w,S){const d=u.get(y.IInstantiationService),l=u.get(D.ISearchService),t=d.createInstance(k.QueryBuilder).file(E.map(n=>(0,P.toWorkspaceFolder)(I.URI.revive(n))),{_reason:"checkExists",includePattern:w,exists:!0});return l.fileSearch(t,S).then(n=>!!n.limitHit,n=>A.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=a});var tt=this&&this.__classPrivateFieldSet||function(K,e,_,I,T){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!T:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?T.call(K,_):T?T.value=_:e.set(K,_),_},Ue=this&&this.__classPrivateFieldGet||function(K,e,_,I){if(_==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!I:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return _==="m"?I:_==="a"?I.call(K):I?I.value:e.get(K)};define(ge[42],pe([0,1,162,8,68,25,15,6,24,2,13,5,35,225,92,32,41,223,18,28,12,22,196,7,85,4,27,93,14,82,50,34,3,262,90,197]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a,u,E,w,S,d,l,f,t,n,r,i,o,c,v,p,h,b,R,N,j,oe){"use strict";var q,W,H;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,i.createDecorator)("IHostUtils");let U=class Un extends k.Disposable{constructor(M,B,V,Q,de,we,Ie,Ce,Le,z){super();this._onDidChangeRemoteConnectionData=this._register(new R.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=B,this._extHostContext=V,this._initData=Ie,this._extHostWorkspace=Q,this._extHostConfiguration=de,this._logService=we,this._extHostTunnelService=Le,this._extHostTerminalService=z,this._disposables=new k.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new j.ExtHostSecretState(this._extHostContext),this._storagePath=Ce,this._instaService=M.createChild(new p.ServiceCollection([a.IExtHostStorage,this._storage],[j.IExtHostSecretState,this._secretState]));const Y=new Set;this._initData.hostExtensions.forEach(ee=>Y.add(d.ExtensionIdentifier.toKey(ee))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ee,le)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ee,le)},actualActivateExtension:async(ee,le)=>{if(Y.has(d.ExtensionIdentifier.toKey(ee)))return await this._mainThreadExtensionsProxy.$activateExtension(ee,le),new m.HostExtension;const me=this._registry.getExtensionDescription(ee);return this._activateExtension(me,le)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),T.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){S.onUnexpectedError(M)}}async deactivateAll(){let M=[];try{M=this._registry.getAllExtensionDescriptions().map(de=>de.identifier).filter(de=>this.isActivated(de)).map(de=>this._deactivate(de))}catch(B){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,B){return this._activator.activateByEvent(M,B)}_activateById(M,B){return this._activator.activateById(M,B)}activateByIdWithErrors(M,B){return this._activateById(M,B).then(()=>{const V=this._activator.getActivatedExtension(M);if(V.activationFailed)return Promise.reject(V.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=D.TernarySearchTree.forPaths(),B=this._registry.getAllExtensionDescriptions().map(V=>{if(!!this._getEntryPoint(V))return this._hostUtils.realpath(V.extensionLocation.fsPath).then(Q=>M.set(P.URI.file(Q).fsPath,V))});this._extensionPathIndex=Promise.all(B).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let B=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return B;const V=this._activator.getActivatedExtension(M);if(!V)return B;try{typeof V.module.deactivate=="function"&&(B=Promise.resolve(V.module.deactivate()).then(void 0,Q=>Promise.resolve(void 0)))}catch(Q){}try{(0,k.dispose)(V.subscriptions)}catch(Q){}return B}async _activateExtension(M,B){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,B).then(V=>{const Q=V.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,Q.codeLoadingTime,Q.activateCallTime,Q.activateResolvedTime,B),this._logExtensionActivationTimes(M,B,"success",Q),V},V=>{throw this._logExtensionActivationTimes(M,B,"failure"),V})}_logExtensionActivationTimes(M,B,V,Q){const de=L(M,B);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},de),Q||{}),{outcome:V}))}_doActivateExtension(M,B){const V=L(M,B);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",V);const Q=this._getEntryPoint(M);if(!Q)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify(B)}`),this._logService.flush();const de=new m.ExtensionActivationTimesBuilder(B.startup);return Promise.all([this._loadCommonJSModule(M.identifier,(0,A.joinPath)(M.extensionLocation,Q),de),this._loadExtensionContext(M)]).then(we=>(T.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),Un._callActivate(this._logService,M.identifier,we[0],we[1],de))).then(we=>(T.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),we))}_loadExtensionContext(M){const B=new t.ExtensionGlobalMemento(M,this._storage),V=new t.ExtensionMemento(M.identifier.value,!1,this._storage),Q=new oe.ExtensionSecrets(M,this._secretState),de=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,we=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([B.whenReady,V.whenReady,this._storagePath.whenReady]).then(()=>{const Ie=this;let Ce;return Object.freeze({globalState:B,workspaceState:V,secrets:Q,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(Le){return I.join(M.extensionLocation.fsPath,Le)},get storagePath(){var Le;return(Le=Ie._storagePath.workspaceValue(M))===null||Le===void 0?void 0:Le.fsPath},get globalStoragePath(){return Ie._storagePath.globalValue(M).fsPath},get logPath(){return I.join(Ie._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return P.URI.joinPath(Ie._initData.logsLocation,M.identifier.value)},get storageUri(){return Ie._storagePath.workspaceValue(M)},get globalStorageUri(){return Ie._storagePath.globalValue(M)},get extensionMode(){return de},get extension(){return Ce===void 0&&(Ce=new F(Ie,M.identifier,M,we)),Ce},get extensionRuntime(){return(0,E.checkProposedApiEnabled)(M),Ie.extensionRuntime},get environmentVariableCollection(){return Ie._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,B,V,Q,de){return V=V||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,B,V,Q,de).then(we=>new m.ActivatedExtension(!1,null,de.build(),V,we,Q.subscriptions))}static _callActivateOptional(M,B,V,Q,de){if(typeof V.activate=="function")try{de.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${B.value}`);const we=typeof global=="object"?global:self,Ie=V.activate.apply(we,[Q]);return de.activateCallStop(),de.activateResolveStart(),Promise.resolve(Ie).then(Ce=>(de.activateResolveStop(),Ce))}catch(we){return Promise.reject(we)}else return Promise.resolve(V)}_activateOneStartupFinished(M,B){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:B}).then(void 0,V=>{this._logService.error(V)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(T.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const B of M.activationEvents)B==="onStartupFinished"&&this._activateOneStartupFinished(M,B)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,de=>{this._logService.error(de)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(de=>this._handleWorkspaceContainsEagerExtensions(de.added)));const B=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],V=this._handleWorkspaceContainsEagerExtensions(B),Q=Promise.all([M,V]).then(()=>{});return Promise.race([Q,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Q}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(B=>this._handleWorkspaceContainsEagerExtension(M,B))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,B){if(!this.isActivated(B.identifier)){const V=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Q={folders:M.map(we=>we.uri),forceUsingSearch:V,exists:we=>this._hostUtils.exists(we.fsPath),checkExists:(we,Ie,Ce)=>this._mainThreadWorkspaceProxy.$checkExists(we,Ie,Ce)},de=await(0,N.checkActivateWorkspaceContainsExtension)(Q,B);if(!!de)return this._activateById(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:de.activationEvent}).then(void 0,we=>this._logService.error(we))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:B}=this._initData.environment;if(!M||!B||B.scheme!==l.Schemas.file)throw new Error(_.localize(0,null));const V=(0,A.originalFSPath)(B),Q=await this._loadCommonJSModule(null,B,new m.ExtensionActivationTimesBuilder(!1));if(!Q||typeof Q.run!="function")throw new Error(_.localize(1,null,V));return new Promise((de,we)=>{const Ie=(Le,z)=>{Le?we(Le):de(typeof z=="number"&&z>0?1:0)},Ce=Q.run(V,Ie);Ce&&Ce.then&&Ce.then(()=>{de(0)}).catch(Le=>{we(Le.toString())})})}async $extensionTestsExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,B){return this._resolvers[M]=B,(0,k.toDisposable)(()=>{delete this._resolvers[M]})}async $resolveAuthority(M,B){const V=M.indexOf("+");if(V===-1)throw new Error("Not an authority that can be resolved!");const Q=M.substr(0,V);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Q}`,!1);const de=this._resolvers[Q];if(!de)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Q}.`,detail:void 0}};try{T.mark(`code/extHost/willResolveAuthority/${Q}`);const we=await de.resolve(M,{resolveAttempt:B});T.mark(`code/extHost/didResolveAuthorityOK/${Q}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(de));const Ie={authority:M,host:we.host,port:we.port,connectionToken:we.connectionToken},Ce={extensionHostEnv:we.extensionHostEnv,trust:we.trust};return{type:"ok",value:{authority:Ie,options:Ce,tunnelInformation:{environmentTunnels:we.environmentTunnels}}}}catch(we){if(T.mark(`code/extHost/didResolveAuthorityError/${Q}`),we instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:we._code,message:we._message,detail:we._detail}};throw we}}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,B){return B===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(V=>this._activateByEvent(M,!1))}async $activate(M,B){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,B),!0):!1}async $deltaExtensions(M,B){M.forEach(Q=>Q.extensionLocation=P.URI.revive(Q.extensionLocation));const V=await this.getExtensionPathIndex();return await Promise.all(B.map(async Q=>{const de=this._registry.getExtensionDescription(Q);if(!!de){const we=await this._hostUtils.realpath(de.extensionLocation.fsPath);V.delete(P.URI.file(we).fsPath)}})),await Promise.all(M.map(async Q=>{const de=await this._hostUtils.realpath(Q.extensionLocation.fsPath);V.set(P.URI.file(de).fsPath,Q)})),this._registry.deltaExtensions(M,B),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let B=f.VSBuffer.alloc(M),V=Math.random()%256;for(let Q=0;Q<M;Q++)B.writeUInt8(V,Q);return B}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};U=Ve([xe(0,i.IInstantiationService),xe(1,e.IHostUtils),xe(2,v.IExtHostRpcService),xe(3,u.IExtHostWorkspace),xe(4,g.IExtHostConfiguration),xe(5,s.ILogService),xe(6,o.IExtHostInitDataService),xe(7,c.IExtensionStoragePaths),xe(8,h.IExtHostTunnelService),xe(9,b.IExtHostTerminalService)],U),e.AbstractExtHostExtensionService=U;function L(O,M){return{id:O.identifier.value,name:O.name,extensionVersion:O.version,publisherDisplayName:O.publisher,activationEvents:O.activationEvents?O.activationEvents.join(","):null,isBuiltin:O.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=(0,i.createDecorator)("IExtHostExtensionService");class F{constructor(M,B,V,Q){q.set(this,void 0),W.set(this,void 0),H.set(this,void 0),tt(this,q,M,"f"),tt(this,W,B,"f"),tt(this,H,V.identifier,"f"),this.id=V.identifier.value,this.extensionUri=V.extensionLocation,this.extensionPath=I.normalize((0,A.originalFSPath)(V.extensionLocation)),this.packageJSON=V,this.extensionKind=Q}get isActive(){return Ue(this,q,"f").isActivated(Ue(this,H,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ue(this,q,"f").getExtensionExports(Ue(this,H,"f"))}activate(){return Ue(this,q,"f").activateByIdWithErrors(Ue(this,H,"f"),{startup:!1,extensionId:Ue(this,W,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=F,q=new WeakMap,W=new WeakMap,H=new WeakMap}),define(ge[46],pe([0,1,8,2,3,15,5,7,121,32,42,39,213,35,204,14,4,11,36]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a,u,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,E.createDecorator)("IExtHostDebugService");let d=class{constructor(c,v,p,h,b){this._workspaceService=v,this._extensionService=p,this._editorsService=h,this._configurationService=b,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new T.Emitter,this._onDidTerminateDebugSession=new T.Emitter,this._onDidChangeActiveDebugSession=new T.Emitter,this._onDidReceiveDebugSessionCustomEvent=new T.Emitter,this._debugServiceProxy=c.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new T.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new f(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(R=>{R.onDidChange(N=>{this.registerAllDebugTypes(R)}),this.registerAllDebugTypes(R)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,v){const p=c;if(typeof p.sourceReference=="number"&&p.sourceReference>0){let h=`debug:${encodeURIComponent(p.path||"")}`,b="?";return v&&(h+=`${b}session=${encodeURIComponent(v.id)}`,b="&"),h+=`${b}ref=${p.sourceReference}`,I.URI.parse(h)}else{if(p.path)return I.URI.file(p.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const v=[];for(const p of c.getAllExtensionDescriptions())if(p.contributes){const h=p.contributes.debuggers;if(h&&h.length>0)for(const b of h)(0,a.isDebuggerMainContribution)(b)&&v.push(b.type)}this._debugServiceProxy.$registerDebugTypes(v)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(v=>c.push(v)),c}addBreakpoints(c){this.startBreakpoints();const v=c.filter(b=>{const R=b.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,b),!0)});this.fireBreakpointChanges(v,[],[]);const p=[],h=new Map;for(const b of v)if(b instanceof k.SourceBreakpoint){let R=h.get(b.location.uri.toString());R||(R={type:"sourceMulti",uri:b.location.uri,lines:[]},h.set(b.location.uri.toString(),R),p.push(R)),R.lines.push({id:b.id,enabled:b.enabled,condition:b.condition,hitCondition:b.hitCondition,logMessage:b.logMessage,line:b.location.range.start.line,character:b.location.range.start.character})}else b instanceof k.FunctionBreakpoint&&p.push({type:"function",id:b.id,enabled:b.enabled,hitCondition:b.hitCondition,logMessage:b.logMessage,condition:b.condition,functionName:b.functionName});return this._debugServiceProxy.$registerBreakpoints(p)}removeBreakpoints(c){this.startBreakpoints();const v=c.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],v,[]);const p=v.filter(R=>R instanceof k.SourceBreakpoint).map(R=>R.id),h=v.filter(R=>R instanceof k.FunctionBreakpoint).map(R=>R.id),b=v.filter(R=>R instanceof k.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(p,h,b)}startDebugging(c,v,p){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,v,{parentSessionID:p.parentSession?p.parentSession.id:void 0,repl:p.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:p.noDebug,compact:p.compact})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,v,p){if(!v)return new k.Disposable(()=>{});const h=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:h,provider:v}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,p,!!v.provideDebugConfigurations,!!v.resolveDebugConfiguration,!!v.resolveDebugConfigurationWithSubstitutedVariables,h),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(b=>b.provider!==v),this._debugServiceProxy.$unregisterDebugConfigurationProvider(h)})}registerDebugAdapterDescriptorFactory(c,v,p){if(!p)return new k.Disposable(()=>{});if(!this.definesDebugType(c,v))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${v}' debugger.`);if(this.getAdapterDescriptorFactoryByType(v))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const h=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:v,handle:h,factory:p}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(v,h),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(b=>b.factory!==p),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(h)})}registerDebugAdapterTrackerFactory(c,v){if(!v)return new k.Disposable(()=>{});const p=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:p,factory:v}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(h=>h.factory!==v)})}async $runInTerminal(c,v){return Promise.resolve(void 0)}async $substituteVariables(c,v){if(!this._variableResolver){const[b,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(b||[],this._editorsService,R)}let p;const h=await this.getFolder(c);return h&&(p={uri:h.uri,name:h.name,index:h.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(p,v)}createDebugAdapter(c,v){if(c.type==="implementation")return new r(c.implementation)}createSignService(){}async $startDASession(c,v){const p=this,h=await this.getSession(v);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(h.type),h).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${h.type}' (extension might have failed to activate)`);const R=this.convertToDto(b),N=this.createDebugAdapter(R,h);if(!N)throw new Error(`Couldn't create a debug adapter for type '${h.type}'.`);const j=N;return this._debugAdapters.set(c,j),this.getDebugAdapterTrackers(h).then(oe=>(oe&&this._debugAdaptersTrackers.set(c,oe),j.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const W=q,H={type:"response",seq:0,command:W.command,request_seq:W.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(W.arguments.value);H.body={signature:U},j.sendResponse(H)}else throw new Error("no signer")}catch(U){H.success=!1,H.message=U.message,j.sendResponse(H)}}else oe&&oe.onDidSendMessage&&oe.onDidSendMessage(q),q=(0,a.convertToVSCPaths)(q,!0),p._debugServiceProxy.$acceptDAMessage(c,q)}),j.onError(q=>{oe&&oe.onError&&oe.onError(q),this._debugServiceProxy.$acceptDAError(c,q.name,q.message,q.stack)}),j.onExit(q=>{oe&&oe.onExit&&oe.onExit((0,w.withNullAsUndefined)(q),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,w.withNullAsUndefined)(q),void 0)}),oe&&oe.onWillStartSession&&oe.onWillStartSession(),j.startSession()))})}$sendDAMessage(c,v){v=(0,a.convertToDAPaths)(v,!1);const p=this._debugAdaptersTrackers.get(c);p&&p.onWillReceiveMessage&&p.onWillReceiveMessage(v);const h=this._debugAdapters.get(c);h&&h.sendMessage(v)}$stopDASession(c){const v=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),v&&v.onWillStopSession&&v.onWillStopSession();const p=this._debugAdapters.get(c);return this._debugAdapters.delete(c),p?p.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const v=[],p=[],h=[];if(c.added)for(const b of c.added){const R=b.id;if(R&&!this._breakpoints.has(R)){let N;if(b.type==="function")N=new k.FunctionBreakpoint(b.functionName,b.enabled,b.condition,b.hitCondition,b.logMessage);else if(b.type==="data")N=new k.DataBreakpoint(b.label,b.dataId,b.canPersist,b.enabled,b.hitCondition,b.condition,b.logMessage);else{const j=I.URI.revive(b.uri);N=new k.SourceBreakpoint(new k.Location(j,new k.Position(b.line,b.character)),b.enabled,b.condition,b.hitCondition,b.logMessage)}N._id=R,this._breakpoints.set(R,N),v.push(N)}}if(c.removed)for(const b of c.removed){const R=this._breakpoints.get(b);R&&(this._breakpoints.delete(b),p.push(R))}if(c.changed){for(const b of c.changed)if(b.id){const R=this._breakpoints.get(b.id);if(R){if(R instanceof k.FunctionBreakpoint&&b.type==="function"){const N=R;N.enabled=b.enabled,N.condition=b.condition,N.hitCondition=b.hitCondition,N.logMessage=b.logMessage,N.functionName=b.functionName}else if(R instanceof k.SourceBreakpoint&&b.type==="source"){const N=R;N.enabled=b.enabled,N.condition=b.condition,N.hitCondition=b.hitCondition,N.logMessage=b.logMessage,N.location=new k.Location(I.URI.revive(b.uri),new k.Position(b.line,b.character))}h.push(R)}}}this.fireBreakpointChanges(v,p,h)}$provideDebugConfigurations(c,v,p){return(0,A.asPromise)(async()=>{const h=this.getConfigProviderByHandle(c);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const b=await this.getFolder(v);return h.provideDebugConfigurations(b,p)}).then(h=>{if(!h)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return h})}$resolveDebugConfiguration(c,v,p,h){return(0,A.asPromise)(async()=>{const b=this.getConfigProviderByHandle(c);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(v);return b.resolveDebugConfiguration(R,p,h)})}$resolveDebugConfigurationWithSubstitutedVariables(c,v,p,h){return(0,A.asPromise)(async()=>{const b=this.getConfigProviderByHandle(c);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(v);return b.resolveDebugConfigurationWithSubstitutedVariables(R,p,h)})}async $provideDebugAdapter(c,v){const p=this.getAdapterDescriptorFactoryByHandle(c);if(!p)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const h=await this.getSession(v);return this.getAdapterDescriptor(p,h).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${h.type}'`);return this.convertToDto(b)})}async $acceptDebugSessionStarted(c){const v=await this.getSession(c);this._onDidStartDebugSession.fire(v)}async $acceptDebugSessionTerminated(c){const v=await this.getSession(c);v&&(this._onDidTerminateDebugSession.fire(v),this._debugSessions.delete(v.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,v){const p=await this.getSession(c);p&&p._acceptNameChanged(v)}async $acceptDebugSessionCustomEvent(c,v){const h={session:await this.getSession(c),event:v.event,body:v.body};this._onDidReceiveDebugSessionCustomEvent.fire(h)}convertToDto(c){if(c instanceof k.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof k.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const v=this._adapterFactories.filter(p=>p.type===c);if(v.length>0)return v[0].factory}getAdapterDescriptorFactoryByHandle(c){const v=this._adapterFactories.filter(p=>p.handle===c);if(v.length>0)return v[0].factory}getConfigProviderByHandle(c){const v=this._configProviders.filter(p=>p.handle===c);if(v.length>0)return v[0].provider}definesDebugType(c,v){if(c.contributes){const p=c.contributes.debuggers;if(p&&p.length>0){for(const h of p)if(h.label&&h.type&&h.type===v)return!0}}return!1}getDebugAdapterTrackers(c){const p=c.configuration.type,h=this._trackerFactories.filter(b=>b.type===p||b.type==="*").map(b=>(0,A.asPromise)(()=>b.factory.createDebugAdapterTracker(c)).then(R=>R,R=>null));return Promise.race([Promise.all(h).then(b=>{const R=b.filter(N=>!!N);if(R.length>0)return new n(R)}),new Promise((b,R)=>{const N=setTimeout(()=>{clearTimeout(N),R(new Error("timeout"))},1e3)})]).catch(b=>{})}async getAdapterDescriptor(c,v){const p=v.configuration.debugServer;if(typeof p=="number")return Promise.resolve(new k.DebugAdapterServer(p));if(c){const b=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>c.createDebugAdapterDescriptor(v,this.daExecutableFromPackage(v,b))).then(R=>{if(R)return R})}const h=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(v,h))}daExecutableFromPackage(c,v){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,v,p){(c.length>0||v.length>0||p.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:v,changed:p}))}async getSession(c){if(c)if(typeof c=="string"){const v=this._debugSessions.get(c);if(v)return v}else{let v=this._debugSessions.get(c.id);if(!v){const p=await this.getFolder(c.folderUri);v=new l(this._debugServiceProxy,c.id,c.type,c.name,p,c.configuration),this._debugSessions.set(v.id,v),this._debugServiceProxy.$sessionCached(v.id)}return v}throw new Error("cannot find session")}getFolder(c){if(c){const v=I.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(v)}return Promise.resolve(void 0)}};d=Ve([xe(0,u.IExtHostRpcService),xe(1,P.IExtHostWorkspace),xe(2,s.IExtHostExtensionService),xe(3,C.IExtHostDocumentsAndEditors),xe(4,m.IExtHostConfiguration)],d),e.ExtHostDebugServiceBase=d;class l{constructor(c,v,p,h,b,R){this._debugServiceProxy=c,this._id=v,this._type=p,this._name=h,this._workspaceFolder=b,this._configuration=R}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,v){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,v)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=l;class f{constructor(c){this.value=Object.freeze({append(v){c.$appendDebugConsole(v)},appendLine(v){this.append(v+`
`)}})}}e.ExtHostDebugConsole=f;class t extends g.AbstractVariableResolverService{constructor(c,v,p,h){super({getFolderUri:b=>{const R=c.filter(N=>N.name===b);if(R&&R.length>0)return R[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(b,R)=>p.getConfiguration(void 0,b).get(R),getAppRoot:()=>S.cwd(),getExecPath:()=>S.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(v){const b=v.activeEditor();if(b)return _.normalize(b.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(v&&h){const b=v.activeEditor();if(b){const R=h.getWorkspaceFolder(b.document.uri);if(R)return _.normalize(R.uri.fsPath)}}},getSelectedText:()=>{if(v){const b=v.activeEditor();if(b&&!b.selection.isEmpty)return b.document.getText(b.selection)}},getLineNumber:()=>{if(v){const b=v.activeEditor();if(b)return String(b.selection.end.line+1)}}},void 0,S.env)}}e.ExtHostVariableResolverService=t;class n{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(v=>v.onWillReceiveMessage?v.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(v=>v.onDidSendMessage?v.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(v=>v.onError?v.onError(c):void 0)}onExit(c,v){this.trackers.forEach(p=>p.onExit?p.onExit(c,v):void 0)}}class r extends D.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(v=>{this.acceptMessage(v)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let i=class extends d{constructor(c,v,p,h,b){super(c,v,p,h,b)}createVariableResolver(c,v,p){return new t(c,v,p)}};i=Ve([xe(0,u.IExtHostRpcService),xe(1,P.IExtHostWorkspace),xe(2,s.IExtHostExtensionService),xe(3,C.IExtHostDocumentsAndEditors),xe(4,m.IExtHostConfiguration)],i),e.WorkerExtHostDebugService=i}),define(ge[263],pe([0,1,68,2,5,35,41,28,14,27,4,42,36,13]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(d,l,f,t,n,r,i){this._apiFactory=d,this._extensionRegistry=l,this._instaService=f,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=r,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),_.mark("code/extHost/willWaitForConfig");const d=await this._extHostConfiguration.getConfigProvider();_.mark("code/extHost/didWaitForConfig");const l=await this._extHostExtensionService.getExtensionPathIndex();this.register(new u(this._apiFactory,l,this._extensionRegistry,d,this._logService)),this.register(this._instaService.createInstance(E)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,l,this._initData.environment.appUriScheme))}register(d){if(Array.isArray(d.nodeModuleName))for(let l of d.nodeModuleName)this._factories.set(l,d);else this._factories.set(d.nodeModuleName,d);typeof d.alternativeModuleName=="function"&&this._alternatives.push(l=>d.alternativeModuleName(l))}};a=Ve([xe(2,s.IInstantiationService),xe(3,A.IExtHostConfiguration),xe(4,C.IExtHostExtensionService),xe(5,P.IExtHostInitDataService),xe(6,m.ILogService)],a),e.RequireInterceptor=a;class u{constructor(d,l,f,t,n){this._apiFactory=d,this._extensionPaths=l,this._extensionRegistry=f,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(d,l){const f=this._extensionPaths.findSubstr(l.fsPath);if(f){let t=this._extApiImpl.get(k.ExtensionIdentifier.toKey(f.identifier));return t||(t=this._apiFactory(f,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(f.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,r)=>t+=`	${r} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${l.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let E=class{constructor(d,l){this.nodeModuleName="keytar";const{environment:f}=l,t=d.getProxy(T.MainContext.MainThreadKeytar);if(f.appRoot){let n=f.appRoot.fsPath;g.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,r)=>t.$getPassword(n,r),setPassword:(n,r,i)=>t.$setPassword(n,r,i),deletePassword:(n,r)=>t.$deletePassword(n,r),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(d,l){return this._impl}alternativeModuleName(d){const l=d.length;if(!(l<=7||!this.alternativeNames)){const f=l-7;if((d.charAt(f)==="/"||d.charAt(f)==="\\")&&d.endsWith("keytar")&&(d=d.replace(/\\/g,"/"),this.alternativeNames.has(d)))return"keytar"}}};E=Ve([xe(0,D.IExtHostRpcService),xe(1,P.IExtHostInitDataService)],E);let w=class{constructor(d,l,f){this._extensionPaths=d,this._appUriScheme=l,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=f.getProxy(T.MainContext.MainThreadTelemetry);const t=f.getProxy(T.MainContext.MainThreadWindow);this._impl=(n,r)=>{const i=I.URI.parse(n);return r?this.callOriginal(n,r):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,n,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,n,{}):this.callOriginal(n,r)}}load(d,l,f){const t=this._extensionPaths.findSubstr(l.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=f(d),this._impl}callOriginal(d,l){return this.sendNoForwardTelemetry(),this._original(d,l)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=Ve([xe(2,D.IExtHostRpcService)],w)}),define(ge[264],pe([0,1,168,10,7,205,32,42,39,35,34,14,46,189,208,15]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let E=class extends g.ExtHostDebugServiceBase{constructor(d,l,f,t,n,r){super(d,l,f,t,n);this._terminalService=r,this._integratedTerminalInstances=new w}createDebugAdapter(d,l){switch(d.type){case"server":return new A.SocketDebugAdapter(d);case"pipeServer":return new A.NamedPipeDebugAdapter(d);case"executable":return new A.ExecutableDebugAdapter(d,l.type)}return super.createDebugAdapter(d,l)}daExecutableFromPackage(d,l){const f=A.ExecutableDebugAdapter.platformAdapterExecutable(l.getAllExtensionDescriptions(),d.type);if(f)return new T.DebugAdapterExecutable(f.command,f.args,f.options)}createSignService(){return new m.SignService}async $runInTerminal(d,l){if(d.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(b=>{this._integratedTerminalInstances.onTerminalClosed(b)}));const f=await this._configurationService.getConfigProvider(),t=this._terminalService.getDefaultShell(!0,f),n=this._terminalService.getDefaultShellArgs(!0,f),r=JSON.stringify({shell:t,shellArgs:n});let i=await this._integratedTerminalInstances.checkout(r),o,c=!1;if(i)o=d.cwd;else{const b={shellPath:t,shellArgs:n,cwd:d.cwd,name:d.title||_.localize(0,null)};c=!0,i=this._terminalService.createTerminalFromOptions(b,!0),this._integratedTerminalInstances.insert(i,r)}i.show(!0);const v=await i.processId;c?await new Promise(b=>setTimeout(b,1e3)):f.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(t.indexOf("powershell")>=0||t.indexOf("pwsh")>=0||t.indexOf("cmd.exe")>=0?i.sendText("cls"):t.indexOf("bash")>=0?i.sendText("clear"):I.isWindows?i.sendText("cls"):i.sendText("clear"));const p=(0,a.prepareCommand)(t,d.args,o,d.env);i.sendText(p);const h=this.onDidTerminateDebugSession(b=>{b.id===l&&(this._integratedTerminalInstances.free(i),h.dispose())});return v}else if(d.kind==="external")return(0,a.runInExternalTerminal)(d,await this._configurationService.getConfigProvider());return super.$runInTerminal(d,l)}createVariableResolver(d,l,f){return new g.ExtHostVariableResolverService(d,l,f,this._workspaceService)}};E=Ve([xe(0,C.IExtHostRpcService),xe(1,y.IExtHostWorkspace),xe(2,k.IExtHostExtensionService),xe(3,D.IExtHostDocumentsAndEditors),xe(4,P.IExtHostConfiguration),xe(5,s.IExtHostTerminalService)],E),e.ExtHostDebugService=E;class w{constructor(){this._terminalInstances=new Map}async checkout(d){const f=[...this._terminalInstances.entries()].map(([t,n])=>(0,u.createCancelablePromise)(async r=>{if(n.lastUsedAt!==-1&&await(0,a.hasChildProcesses)(await t.processId))return null;const i=Date.now();return n.lastUsedAt+w.minUseDelay>i||r.isCancellationRequested||n.config!==d?null:(n.lastUsedAt=i,t)}));return await(0,u.firstParallel)(f,t=>!!t)}insert(d,l){this._terminalInstances.set(d,{lastUsedAt:Date.now(),config:l})}free(d){const l=this._terminalInstances.get(d);l&&(l.lastUsedAt=-1)}onTerminalClosed(d){this._terminalInstances.delete(d)}}w.minUseDelay=1e3}),define(ge[265],pe([0,1,8,2,78,32,46,39,35,34,14,27,67,12,13,63]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let E=class extends g.ExtHostTaskBase{constructor(S,d,l,f,t,n,r,i){super(S,d,l,f,t,n,r,i);this.workspaceService=l,d.remote.isRemote&&d.remote.authority?this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:d.remote.authority,platform:process.platform}):this.registerTaskSystem(m.Schemas.file,{scheme:m.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(S,d){const l=d;if(!d.execution&&l._id===void 0)throw new Error("Tasks to execute must include an execution");if(l._id!==void 0){const f=g.TaskHandleDTO.from(l,this.workspaceService),t=await this._proxy.$getTaskExecution(f);if(t.task===void 0)throw new Error("Task from execution DTO is undefined");const n=await this.getTaskExecution(t,d);return this._proxy.$executeTask(f).catch(()=>{}),n}else{const f=g.TaskDTO.from(d,S);if(f===void 0)return Promise.reject(new Error("Task is not valid"));g.CustomExecutionDTO.is(f.execution)&&await this.addCustomExecution(f,d,!1);const t=await this.getTaskExecution(await this._proxy.$getTaskExecution(f),d);return this._proxy.$executeTask(f).catch(()=>{}),t}}provideTasksInternal(S,d,l,f){const t=[];if(f)for(let n of f){this.checkDeprecation(n,l),(!n.definition||!S[n.definition.type])&&this._logService.warn(`The task [${n.source}, ${n.name}] uses an undefined task type. The task will be ignored in the future.`);const r=g.TaskDTO.from(n,l.extension);r&&(t.push(r),g.CustomExecutionDTO.is(r.execution)&&d.push(this.addCustomExecution(r,n,!0)))}return{tasks:t,extension:l.extension}}async resolveTaskInternal(S){return S}async getVariableResolver(S){if(this._variableResolver===void 0){const d=await this._configurationService.getConfigProvider();this._variableResolver=new y.ExtHostVariableResolverService(S,this._editorService,d,this.workspaceService)}return this._variableResolver}async $resolveVariables(S,d){const l=I.URI.revive(S),f={process:void 0,variables:Object.create(null)},t=await this._workspaceProvider.resolveWorkspaceFolder(l),n=await this._workspaceProvider.getWorkspaceFolders2();if(!n||!t)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const r=await this.getVariableResolver(n),i={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}};for(let o of d.variables)f.variables[o]=await r.resolveAsync(i,o);if(d.process!==void 0){let o;if(d.process.path!==void 0){o=d.process.path.split(_.delimiter);for(let c=0;c<o.length;c++)o[c]=await r.resolveAsync(i,o[c])}f.process=await T.win32.findExecutable(await r.resolveAsync(i,d.process.name),d.process.cwd!==void 0?await r.resolveAsync(i,d.process.cwd):void 0,o)}return f}$getDefaultShellAndArgs(){return this._terminalService.$getDefaultShellAndArgs(!0)}async $jsonTasksSupported(){return!0}async $findExecutable(S,d,l){return T.win32.findExecutable(S,d,l)}};E=Ve([xe(0,s.IExtHostRpcService),xe(1,C.IExtHostInitDataService),xe(2,A.IExtHostWorkspace),xe(3,k.IExtHostDocumentsAndEditors),xe(4,D.IExtHostConfiguration),xe(5,P.IExtHostTerminalService),xe(6,a.ILogService),xe(7,u.IExtHostApiDeprecationService)],E),e.ExtHostTask=E}),define(ge[266],pe([0,1,10,11,30,149,13,35,46,39,14,34,32,211,212]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let u=class extends C.BaseExtHostTerminalService{constructor(w,S,d,l,f){super(!0,w);this._extHostConfiguration=S,this._extHostWorkspace=d,this._extHostDocumentsAndEditors=l,this._logService=f,(0,A.getSystemShell)(_.OS,process.env).then(t=>this._defaultShell=t),this._updateLastActiveWorkspace(),this._variableResolverPromise=this._updateVariableResolver(),this._registerListeners()}createTerminal(w,S,d){const l=new C.ExtHostTerminal(this._proxy,(0,T.generateUuid)(),{name:w,shellPath:S,shellArgs:d},w);return this._terminals.push(l),l.create(S,d),l.value}createTerminalFromOptions(w,S){const d=new C.ExtHostTerminal(this._proxy,(0,T.generateUuid)(),w,w.name);return this._terminals.push(d),d.create((0,I.withNullAsUndefined)(w.shellPath),(0,I.withNullAsUndefined)(w.shellArgs),(0,I.withNullAsUndefined)(w.cwd),(0,I.withNullAsUndefined)(w.env),(0,I.withNullAsUndefined)(w.icon),(0,I.withNullAsUndefined)(w.message),void 0,(0,I.withNullAsUndefined)(w.strictEnv),(0,I.withNullAsUndefined)(w.hideFromUser),(0,I.withNullAsUndefined)(S),!0),d.value}getDefaultShell(w,S){var d;const l=f=>S.getConfiguration(f.substr(0,f.lastIndexOf("."))).get(f.substr(f.lastIndexOf(".")+1));return m.getDefaultShell(l,(d=this._defaultShell)!==null&&d!==void 0?d:(0,A.getSystemShellSync)(_.OS,process.env),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,m.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService,w)}getDefaultShellArgs(w,S){const d=l=>S.getConfiguration(l.substr(0,l.lastIndexOf("."))).get(l.substr(l.lastIndexOf(".")+1));return m.getDefaultShellArgs(d,w,m.createVariableResolver(this._lastActiveWorkspace,this._variableResolver),this._logService)}_registerListeners(){this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(()=>this._updateLastActiveWorkspace()),this._extHostWorkspace.onDidChangeWorkspace(()=>{this._variableResolverPromise=this._updateVariableResolver()})}_updateLastActiveWorkspace(){const w=this._extHostDocumentsAndEditors.activeEditor();w&&(this._lastActiveWorkspace=this._extHostWorkspace.getWorkspaceFolder(w.document.uri))}async _updateVariableResolver(){const w=await this._extHostConfiguration.getConfigProvider(),S=await this._extHostWorkspace.getWorkspaceFolders2();return this._variableResolver=new D.ExtHostVariableResolverService(S||[],this._extHostDocumentsAndEditors,w),this._variableResolver}async $getAvailableProfiles(w){const S=await(await this._extHostConfiguration.getConfigProvider()).getConfiguration().get("terminal.integrated");return(0,a.detectAvailableProfiles)(w,void 0,this._logService,S,await this._variableResolverPromise,this._lastActiveWorkspace)}async $getDefaultShellAndArgs(w){const S=await this._extHostConfiguration.getConfigProvider();return{shell:this.getDefaultShell(w,S),args:this.getDefaultShellArgs(w,S)}}};u=Ve([xe(0,s.IExtHostRpcService),xe(1,k.IExtHostConfiguration),xe(2,g.IExtHostWorkspace),xe(3,P.IExtHostDocumentsAndEditors),xe(4,y.ILogService)],u),e.ExtHostTerminalService=u}),define(ge[267],pe([0,1,15,18,68,6,2,5,257,13,79,82,27,185,14,62,42,34]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a,u,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class S{constructor(l,f,t,n){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const r=new D.RPCProtocol(l,null,n);f=S._transform(f,r);const i=new C.ServiceCollection(...(0,s.getSingletonServiceDescriptors)());i.set(g.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},f)),i.set(a.IExtHostRpcService,new a.ExtHostRpcService(r)),i.set(u.IURITransformerService,new u.URITransformerService(n)),i.set(E.IHostUtils,t);const o=new m.InstantiationService(i,!0),c=o.invokeFunction(b=>b.get(w.IExtHostTerminalService));this._disposables.add(c),this._logService=o.invokeFunction(b=>b.get(P.ILogService)),T.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",f),this._extensionService=o.invokeFunction(b=>b.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const v=new WeakMap;this._extensionService.getExtensionPathIndex().then(b=>{Error.prepareStackTrace=(R,N)=>{let j="",oe,q;for(const W of N)j+=`
	at ${W.toString()}`,q=W.getFileName(),!oe&&q&&(oe=b.findSubstr(q));return v.set(R,oe),`${R.name||"Error"}: ${R.message||""}${j}`}});const p=r.getProxy(k.MainContext.MainThreadExtensionService),h=r.getProxy(k.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(b=>{const R=I.transformErrorForSerialization(b),N=v.get(b);N?p.$onExtensionRuntimeError(N.identifier,R):h.$onUnexpectedError(R)})}terminate(l){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${l}`),this._logService.flush(),this._disposables.dispose(),I.setUnexpectedErrorHandler(t=>{});const f=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,_.timeout)(4e3),f]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(l,f){l.extensions.forEach(n=>n.extensionLocation=y.URI.revive(f.transformIncomingURIs(n.extensionLocation))),l.environment.appRoot=y.URI.revive(f.transformIncomingURIs(l.environment.appRoot));const t=l.environment.extensionDevelopmentLocationURI;return t&&(l.environment.extensionDevelopmentLocationURI=t.map(n=>y.URI.revive(f.transformIncomingURIs(n)))),l.environment.extensionTestsLocationURI=y.URI.revive(f.transformIncomingURIs(l.environment.extensionTestsLocationURI)),l.environment.globalStorageHome=y.URI.revive(f.transformIncomingURIs(l.environment.globalStorageHome)),l.environment.workspaceStorageHome=y.URI.revive(f.transformIncomingURIs(l.environment.workspaceStorageHome)),l.logsLocation=y.URI.revive(f.transformIncomingURIs(l.logsLocation)),l.logFile=y.URI.revive(f.transformIncomingURIs(l.logFile)),l.workspace=f.transformIncomingURIs(l.workspace),l}}e.ExtensionHostMain=S}),define(ge[268],pe([0,1,8,21,59,33,25,47,31]),function(K,e,_,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(g,m,a){this.config=g,this.provider=m,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=g.filePattern,this.includePattern=g.includePattern&&A.parse(g.includePattern),this.maxResults=g.maxResults||void 0,this.exists=g.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=g.excludePattern&&A.parse(g.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(g=>g.cancel()),this.activeCancellationTokens=new Set}search(g){const m=this.config.folderQueries||[];return new Promise((a,u)=>{const E=w=>{this.resultCount++,g(w)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const S=w.toString(),d=_.basename(S);this.globalExcludePattern&&this.globalExcludePattern(S,d)||this.matchFile(E,{base:w,basename:d})}),Promise.all(m.map(w=>this.searchInFolder(w,E))).then(w=>{a({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{u(new Error((0,T.toErrorMessage)(w)))})})}async searchInFolder(g,m){const a=new I.CancellationTokenSource,u=this.getSearchOptionsForFolder(g),E=this.initDirectoryTree(),w=new D.QueryGlobTester(this.config,g),S=!w.hasSiblingExcludeClauses();let d;try{this.activeCancellationTokens.add(a),d=k.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,a.token),f=d.elapsed(),t=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(n=>{const r=_.posix.relative(g.folder.path,n.path);if(S){const i=_.basename(n.path);this.matchFile(m,{base:g.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(E,g.folder,r,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(E,w,m),{providerTime:f,postProcessTime:t.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(g){const m=(0,D.resolvePatternsForProvider)(this.config.includePattern,g.includePattern),a=(0,D.resolvePatternsForProvider)(this.config.excludePattern,g.excludePattern);return{folder:g.folder,excludes:a,includes:m,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,followSymlinks:!g.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const g={rootEntries:[],pathToEntries:Object.create(null)};return g.pathToEntries["."]=g.rootEntries,g}addDirectoryEntries({pathToEntries:g},m,a,u){if(a===this.filePattern){const w=_.basename(this.filePattern);this.matchFile(u,{base:m,relativePath:this.filePattern,basename:w})}function E(w){const S=_.basename(w),d=_.dirname(w);let l=g[d];l||(l=g[d]=[],E(d)),l.push({base:m,relativePath:w,basename:S})}E(a)}matchDirectoryTree({rootEntries:g,pathToEntries:m},a,u){const E=this,w=this.filePattern;function S(d){const l=A.hasSiblingFn(()=>d.map(f=>f.basename));for(let f=0,t=d.length;f<t;f++){const n=d[f],{relativePath:r,basename:i}=n;if(!!a.includedInQuerySync(r,i,w!==i?l:void 0)){const o=m[r];if(o)S(o);else{if(r===w)continue;E.matchFile(u,n)}if(E.isLimitHit)break}}}S(g)}matchFile(g,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||g(m))}}class s{constructor(){this.sessions=new Map}fileSearch(g,m,a,u){const E=this.getSessionTokenSource(g.cacheKey),w=new P(g,m,E&&E.token);let S=0;const d=l=>{S+=l.length,a(l.map(f=>this.rawMatchToSearchItem(f)))};return this.doSearch(w,s.BATCH_SIZE,d,u).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:S,detailStats:l.stats}}))}clearCache(g){const m=this.getSessionTokenSource(g);m&&m.cancel()}getSessionTokenSource(g){if(!!g)return this.sessions.has(g)||this.sessions.set(g,new I.CancellationTokenSource),this.sessions.get(g)}rawMatchToSearchItem(g){return g.relativePath?{resource:y.joinPath(g.base,g.relativePath)}:{resource:g.base}}doSearch(g,m,a,u){u.onCancellationRequested(()=>{g.cancel()});const E=S=>{S&&(w.push(S),m>0&&w.length>=m&&(a(w),w=[]))};let w=[];return g.search(E).then(S=>(w.length&&a(w),S),S=>(w.length&&a(w),Promise.reject(S)))}}e.FileSearchManager=s,s.BATCH_SIZE=512}),define(ge[128],pe([0,1,8,19,21,59,25,33,2,31,12,11]),function(K,e,_,I,T,A,y,k,D,P,s,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class g{constructor(d,l,f){this.query=d,this.provider=l,this.fileUtils=f,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(d,l){const f=this.query.folderQueries||[],t=new T.CancellationTokenSource;return l.onCancellationRequested(()=>t.cancel()),new Promise((n,r)=>{this.collector=new a(d);let i=!1;const o=(c,v)=>{if(!i&&!this.isLimitHit){const p=this.resultSize(c);E(c)&&typeof this.query.maxResults=="number"&&this.resultCount+p>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),c=this.trimResultToSize(c,this.query.maxResults-this.resultCount));const h=this.resultSize(c);this.resultCount+=h,(h>0||!E(c))&&this.collector.add(c,v)}};Promise.all(f.map((c,v)=>this.searchInFolder(c,p=>o(p,v),t.token))).then(c=>{t.dispose(),this.collector.flush();const v=c.some(p=>!!p&&!!p.limitHit);n({limitHit:this.isLimitHit||v,messages:(0,I.flatten)(c.map(p=>(p==null?void 0:p.message)?(0,C.isArray)(p.message)?p.message:[p.message]:[])),stats:{type:"textSearchProvider"}})},c=>{t.dispose();const v=(0,A.toErrorMessage)(c);r(new Error(v))})})}resultSize(d){return E(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}trimResultToSize(d,l){const f=Array.isArray(d.ranges)?d.ranges:[d.ranges],t=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:f.slice(0,l),preview:{matches:t.slice(0,l),text:d.preview.text},uri:d.uri}}async searchInFolder(d,l,f){const t=new P.QueryGlobTester(this.query,d),n=[],r={report:c=>{if(!!this.validateProviderResult(c)){const v=d.folder.scheme===s.Schemas.file?k.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(c.uri))):void 0,p=y.relativePath(d.folder,c.uri);p&&n.push(t.includedInQuery(p,_.basename(p),v).then(h=>{h&&l(c)}))}}},i=this.getSearchOptionsForFolder(d),o=await this.provider.provideTextSearchResults(m(this.query.contentPattern),i,r,f);return await Promise.all(n),o}validateProviderResult(d){if(E(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(d){const l=(0,P.resolvePatternsForProvider)(this.query.includePattern,d.includePattern),f=(0,P.resolvePatternsForProvider)(this.query.excludePattern,d.excludePattern),t={folder:D.URI.from(d.folder),excludes:f,includes:l,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.fileUtils.toCanonicalName(d.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=g;function m(S){return{isCaseSensitive:S.isCaseSensitive||!1,isRegExp:S.isRegExp||!1,isWordMatch:S.isWordMatch||!1,isMultiline:S.isMultiline||!1,pattern:S.pattern}}class a{constructor(d){this._onResult=d,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,l=>this.sendItems(l))}add(d,l){this._currentFileMatch&&(this._currentFolderIdx!==l||!y.isEqual(this._currentUri,d.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=l,this._currentFileMatch={resource:d.uri,results:[]}),this._currentFileMatch.results.push(u(d))}pushToCollector(){const d=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,d)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(d){this._onResult(d)}}e.TextSearchResultsCollector=a;function u(S){return E(S)?{preview:{matches:(0,I.mapArrayOrNot)(S.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:S.preview.text},ranges:(0,I.mapArrayOrNot)(S.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:S.text,lineNumber:S.lineNumber}}function E(S){return!!S.preview}e.extensionResultIsMatch=E;class w{constructor(d,l){this.maxBatchSize=d,this.cb=l,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(d,l){!d||this.addItemToBatch(d,l)}addItems(d,l){!d||this.addItemsToBatch(d,l)}addItemToBatch(d,l){this.batch.push(d),this.batchSize+=l,this.onUpdate()}addItemsToBatch(d,l){this.batch=this.batch.concat(d),this.batchSize+=l,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(ge[69],pe([0,1,6,5,4,268,14,62,13,2,128]),function(K,e,_,I,T,A,y,k,D,P,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,T.createDecorator)("IExtHostSearch");let C=class{constructor(u,E,w){this.extHostRpc=u,this._uriTransformer=E,this._logService=w,this._proxy=this.extHostRpc.getProxy(I.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,E){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const w=this._handlePool++;return this._textSearchProvider.set(w,E),this._proxy.$registerTextSearchProvider(w,this._transformScheme(u)),(0,_.toDisposable)(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(u,E){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const w=this._handlePool++;return this._fileSearchProvider.set(w,E),this._proxy.$registerFileSearchProvider(w,this._transformScheme(u)),(0,_.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(u,E,w,S){const d=g(w),l=this._fileSearchProvider.get(u);if(l)return this._fileSearchManager.fileSearch(d,l,f=>{this._proxy.$handleFileMatch(u,E,f.map(t=>t.resource))},S);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,E,w,S){const d=this._textSearchProvider.get(u);if(!d||!d.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const l=g(w);return this.createTextSearchManager(l,d).search(t=>this._proxy.$handleTextMatch(u,E,t),S)}createTextSearchManager(u,E){return new s.TextSearchManager(u,E,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};C=Ve([xe(0,y.IExtHostRpcService),xe(1,k.IURITransformerService),xe(2,D.ILogService)],C),e.ExtHostSearch=C;function g(a){return Object.assign(Object.assign({},a),{folderQueries:a.folderQueries&&a.folderQueries.map(m),extraFileResources:a.extraFileResources&&a.extraFileResources.map(u=>P.URI.revive(u))})}e.reviveQuery=g;function m(a){return Object.assign(Object.assign({},a),{folder:P.URI.revive(a.folder)})}}),define(ge[269],pe([0,1,159,21,18,3,57,2,151,108,141,77,45,5,231,230,51,232,35,233,234,235,216,236,39,42,237,217,239,240,241,64,220,244,245,246,92,34,247,221,20,7,250,65,127,32,41,53,201,238,117,126,67,46,69,13,62,14,27,242,199,50,63,228,248,198,93,91,253,251,252,229,61,260,249,90,195,119,243,85,66]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a,u,E,w,S,d,l,f,t,n,r,i,o,c,v,p,h,b,R,N,j,oe,q,W,H,U,L,F,O,M,B,V,Q,de,we,Ie,Ce,Le,z,Y,ee,le,me,De,Oe,be,Pe,Re,Be,Se,qe,X,ie,_e,Ne,ze,$e,Je,G,re,he,J,ne,ce,ve,ye,je){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function He(We){const Ke=We.get(Oe.IExtHostInitDataService),nt=We.get(G.IExtHostFileSystemInfo),dt=We.get(_e.IExtHostConsumerFileSystem),it=We.get(i.IExtHostExtensionService),Ye=We.get(V.IExtHostWorkspace),mt=We.get(ce.IExtHostTelemetry),wt=We.get(S.IExtHostConfiguration),Ee=We.get(me.IURITransformerService),fe=We.get(De.IExtHostRpcService),ae=We.get(q.IExtHostStorage),Z=We.get(ie.IExtensionStoragePaths),Fe=We.get(le.ILogService),Te=We.get(Re.IExtHostTunnelService),Qe=We.get(Be.IExtHostApiDeprecationService),Ze=We.get(B.IExtHostWindow),ct=We.get(J.IExtHostSecretState);fe.set(m.ExtHostContext.ExtHostFileSystemInfo,nt),fe.set(m.ExtHostContext.ExtHostLogService,Fe),fe.set(m.ExtHostContext.ExtHostWorkspace,Ye),fe.set(m.ExtHostContext.ExtHostConfiguration,wt),fe.set(m.ExtHostContext.ExtHostExtensionService,it),fe.set(m.ExtHostContext.ExtHostStorage,ae),fe.set(m.ExtHostContext.ExtHostTunnelService,Te),fe.set(m.ExtHostContext.ExtHostWindow,Ze),fe.set(m.ExtHostContext.ExtHostSecretState,ct),fe.set(m.ExtHostContext.ExtHostTelemetry,mt);const ht=fe.set(m.ExtHostContext.ExtHostDecorations,We.get(Le.IExtHostDecorations)),Xe=fe.set(m.ExtHostContext.ExtHostDocumentsAndEditors,We.get(r.IExtHostDocumentsAndEditors)),ot=fe.set(m.ExtHostContext.ExtHostCommands,We.get(E.IExtHostCommands)),ft=fe.set(m.ExtHostContext.ExtHostTerminalService,We.get(W.IExtHostTerminalService)),at=fe.set(m.ExtHostContext.ExtHostDebugService,We.get(Y.IExtHostDebugService)),Et=fe.set(m.ExtHostContext.ExtHostSearch,We.get(ee.IExtHostSearch)),vt=fe.set(m.ExtHostContext.ExtHostTask,We.get(z.IExtHostTask)),Ct=fe.set(m.ExtHostContext.ExtHostOutputService,We.get(b.IExtHostOutputService)),It=fe.set(m.ExtHostContext.ExtHostEditorTabs,new ne.ExtHostEditorTabs),At=fe.set(m.ExtHostContext.ExtHostUrls,new O.ExtHostUrls(fe)),bt=fe.set(m.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(fe,Xe)),Yt=fe.set(m.ExtHostContext.ExtHostDocumentContentProviders,new f.ExtHostDocumentContentProvider(fe,Xe,Fe)),Jt=fe.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Fe,bt,fe.getProxy(m.MainContext.MainThreadBulkEdits))),gt=fe.set(m.ExtHostContext.ExtHostNotebook,new be.ExtHostNotebookController(fe,ot,Xe,bt,Fe,Z)),Zt=fe.set(m.ExtHostContext.ExtHostNotebookKernels,new ve.ExtHostNotebookKernels(fe,Ke,gt)),yt=fe.set(m.ExtHostContext.ExtHostEditors,new H.ExtHostEditors(fe,Xe)),qt=fe.set(m.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(fe.getProxy(m.MainContext.MainThreadTreeViews),ot,Fe)),en=fe.set(m.ExtHostContext.ExtHostEditorInsets,new we.ExtHostEditorInsets(fe.getProxy(m.MainContext.MainThreadEditorInsets),yt,Ke.environment)),Gt=fe.set(m.ExtHostContext.ExtHostDiagnostics,new d.ExtHostDiagnostics(fe,Fe)),lt=fe.set(m.ExtHostContext.ExtHostLanguageFeatures,new v.ExtHostLanguageFeatures(fe,Ee,bt,ot,Gt,Fe,Qe)),tn=fe.set(m.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(fe,lt)),Tt=fe.set(m.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(fe,Fe,Xe)),xt=fe.set(m.ExtHostContext.ExtHostQuickOpen,(0,N.createExtHostQuickOpen)(fe,Ye,ot)),gn=fe.set(m.ExtHostContext.ExtHostSCM,new j.ExtHostSCM(fe,ot,Fe)),En=fe.set(m.ExtHostContext.ExtHostComments,new w.ExtHostComments(fe,ot,bt)),pn=fe.set(m.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(fe.getProxy(m.MainContext.MainThreadProgress))),nn=fe.set(m.ExtHostContext.ExtHosLabelService,new Ie.ExtHostLabelService(fe)),Kt=fe.set(m.ExtHostContext.ExtHostTheming,new Pe.ExtHostTheming(fe)),Ot=fe.set(m.ExtHostContext.ExtHostAuthentication,new Se.ExtHostAuthentication(fe)),Sn=fe.set(m.ExtHostContext.ExtHostTimeline,new qe.ExtHostTimeline(fe,ot)),rn=fe.set(m.ExtHostContext.ExtHostWebviews,new M.ExtHostWebviews(fe,Ke.environment,Ye,Fe,Qe)),sn=fe.set(m.ExtHostContext.ExtHostWebviewPanels,new $e.ExtHostWebviewPanels(fe,rn,Ye)),Qt=fe.set(m.ExtHostContext.ExtHostCustomEditors,new ze.ExtHostCustomEditors(fe,bt,Z,rn,sn)),yn=fe.set(m.ExtHostContext.ExtHostWebviewViews,new Ne.ExtHostWebviewViews(fe,rn)),Rt=fe.set(m.ExtHostContext.ExtHostTesting,new re.ExtHostTesting(fe,Xe,Ye)),on=fe.set(m.ExtHostContext.ExtHostUriOpeners,new he.ExtHostUriOpeners(fe)),Dn=(0,de.values)(m.ExtHostContext);fe.assertRegistered(Dn);const Bt=new Je.ExtHostBulkEdits(fe,Xe),an=new u.ExtHostClipboard(fe),Nt=new h.ExtHostMessageService(fe,Fe),Lt=new l.ExtHostDialogs(fe),vn=new oe.ExtHostStatusBar(fe,ot.converter),Wt=new p.ExtHostLanguages(fe,bt);return a.ExtHostApiCommands.register(ot),function(Me,ln,cn){const pt=function(){let te=!Me.isUnderDevelopment;function ue(Ae){te||(Fe.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Ae(rt){if(Array.isArray(rt))rt.forEach(Ae);else if(typeof rt=="string")ue(rt);else{const $=rt;typeof $.scheme=="undefined"&&ue(rt),!Me.enableProposedApi&&typeof $.exclusive=="boolean"&&(0,Q.throwProposedApiError)(Me)}return rt}}(),Cn={getSession(te,ue,Ae){return Ot.getSession(Me,te,ue,Ae)},get onDidChangeSessions(){return Ot.onDidChangeSessions},registerAuthenticationProvider(te,ue,Ae,rt){return Ot.registerAuthenticationProvider(te,ue,Ae,rt)},get onDidChangeAuthenticationProviders(){return(0,Q.checkProposedApiEnabled)(Me),Ot.onDidChangeAuthenticationProviders},get providers(){return(0,Q.checkProposedApiEnabled)(Me),Ot.providers},logout(te,ue){return(0,Q.checkProposedApiEnabled)(Me),Ot.removeSession(te,ue)}},kn={registerCommand(te,ue,Ae){return ot.registerCommand(!0,te,ue,Ae)},registerTextEditorCommand(te,ue,Ae){return ot.registerCommand(!0,te,(...rt)=>{const $=yt.getActiveTextEditor();if(!$){Fe.warn("Cannot execute "+te+" because there is no active text editor.");return}return $.edit(x=>{ue.apply(Ae,[$,x,...rt])}).then(x=>{x||Fe.warn("Edits from command "+te+" were not applied.")},x=>{Fe.warn("An error occurred while running command "+te,x)})})},registerDiffInformationCommand:(te,ue,Ae)=>((0,Q.checkProposedApiEnabled)(Me),ot.registerCommand(!0,te,async(...rt)=>{const $=Xe.activeEditor(!0);if(!$){Fe.warn("Cannot execute "+te+" because there is no active text editor.");return}const x=await yt.getDiffInformation($.id);ue.apply(Ae,[x,...rt])})),executeCommand(te,...ue){return ot.executeCommand(te,...ue)},getCommands(te=!1){return ot.getCommands(te)}},Xt={get machineId(){return Ke.telemetryInfo.machineId},get sessionId(){return Ke.telemetryInfo.sessionId},get language(){return Ke.environment.appLanguage},get appName(){return Ke.environment.appName},get appRoot(){var te,ue;return(ue=(te=Ke.environment.appRoot)===null||te===void 0?void 0:te.fsPath)!==null&&ue!==void 0?ue:""},get uriScheme(){return Ke.environment.appUriScheme},get clipboard(){return an.value},get shell(){return ft.getDefaultShell(!1,cn)},get isTelemetryEnabled(){return mt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return mt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const te=Date.now()-new Date(Ke.telemetryInfo.firstSessionDate).getTime();return isNaN(te)?!1:te<1e3*60*60*24},openExternal(te,ue){return Ze.openUri(te,{allowTunneling:!!Ke.remote.authority,allowContributedOpeners:ue==null?void 0:ue.allowContributedOpeners})},asExternalUri(te){return te.scheme===Ke.environment.appUriScheme?At.createAppUri(te):Ze.asExternalUri(te,{allowTunneling:!!Ke.remote.authority})},get remoteName(){return(0,Ce.getRemoteName)(Ke.remote.authority)},get uiKind(){return Ke.uiKind}};Ke.environment.extensionTestsLocationURI||Object.freeze(Xt);const wn=Ke.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,Pn={registerTestController(te){return(0,Q.checkProposedApiEnabled)(Me),Rt.registerTestController(Me.identifier.value,te)},createDocumentTestObserver(te){return(0,Q.checkProposedApiEnabled)(Me),Rt.createTextDocumentTestObserver(te)},createWorkspaceTestObserver(te){return(0,Q.checkProposedApiEnabled)(Me),Rt.createWorkspaceTestObserver(te)},runTests(te){return(0,Q.checkProposedApiEnabled)(Me),Rt.runTests(te)},createTestItem(te,ue){return new F.TestItemImpl(te.id,te.label,te.uri,ue)},createTestRunTask(te,ue,Ae){return(0,Q.checkProposedApiEnabled)(Me),Rt.createTestRunTask(Me.identifier.value,te,ue,Ae)},get onDidChangeTestResults(){return(0,Q.checkProposedApiEnabled)(Me),Rt.onResultsChanged},get testResults(){return(0,Q.checkProposedApiEnabled)(Me),Rt.results}},In={getExtension(te){const ue=ln.getExtensionDescription(te);if(ue)return new i.Extension(it,Me.identifier,ue,wn)},get all(){return ln.getAllExtensionDescriptions().map(te=>new i.Extension(it,Me.identifier,te,wn))},get onDidChange(){return ln.onDidChange}},An={createDiagnosticCollection(te){return Gt.createDiagnosticCollection(Me.identifier,te)},get onDidChangeDiagnostics(){return Gt.onDidChangeDiagnostics},getDiagnostics:te=>Gt.getDiagnostics(te),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(te,ue){return Wt.changeLanguage(te.uri,ue)},match(te,ue){return(0,C.score)(L.LanguageSelector.from(te),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(te,ue,Ae){return lt.registerCodeActionProvider(Me,pt(te),ue,Ae)},registerCodeLensProvider(te,ue){return lt.registerCodeLensProvider(Me,pt(te),ue)},registerDefinitionProvider(te,ue){return lt.registerDefinitionProvider(Me,pt(te),ue)},registerDeclarationProvider(te,ue){return lt.registerDeclarationProvider(Me,pt(te),ue)},registerImplementationProvider(te,ue){return lt.registerImplementationProvider(Me,pt(te),ue)},registerTypeDefinitionProvider(te,ue){return lt.registerTypeDefinitionProvider(Me,pt(te),ue)},registerHoverProvider(te,ue){return lt.registerHoverProvider(Me,pt(te),ue,Me.identifier)},registerEvaluatableExpressionProvider(te,ue){return lt.registerEvaluatableExpressionProvider(Me,pt(te),ue,Me.identifier)},registerInlineValuesProvider(te,ue){return lt.registerInlineValuesProvider(Me,pt(te),ue,Me.identifier)},registerDocumentHighlightProvider(te,ue){return lt.registerDocumentHighlightProvider(Me,pt(te),ue)},registerLinkedEditingRangeProvider(te,ue){return lt.registerLinkedEditingRangeProvider(Me,pt(te),ue)},registerReferenceProvider(te,ue){return lt.registerReferenceProvider(Me,pt(te),ue)},registerRenameProvider(te,ue){return lt.registerRenameProvider(Me,pt(te),ue)},registerDocumentSymbolProvider(te,ue,Ae){return lt.registerDocumentSymbolProvider(Me,pt(te),ue,Ae)},registerWorkspaceSymbolProvider(te){return lt.registerWorkspaceSymbolProvider(Me,te)},registerDocumentFormattingEditProvider(te,ue){return lt.registerDocumentFormattingEditProvider(Me,pt(te),ue)},registerDocumentRangeFormattingEditProvider(te,ue){return lt.registerDocumentRangeFormattingEditProvider(Me,pt(te),ue)},registerOnTypeFormattingEditProvider(te,ue,Ae,...rt){return lt.registerOnTypeFormattingEditProvider(Me,pt(te),ue,[Ae].concat(rt))},registerDocumentSemanticTokensProvider(te,ue,Ae){return lt.registerDocumentSemanticTokensProvider(Me,pt(te),ue,Ae)},registerDocumentRangeSemanticTokensProvider(te,ue,Ae){return lt.registerDocumentRangeSemanticTokensProvider(Me,pt(te),ue,Ae)},registerSignatureHelpProvider(te,ue,Ae,...rt){return typeof Ae=="object"?lt.registerSignatureHelpProvider(Me,pt(te),ue,Ae):lt.registerSignatureHelpProvider(Me,pt(te),ue,typeof Ae=="undefined"?[]:[Ae,...rt])},registerCompletionItemProvider(te,ue,...Ae){return lt.registerCompletionItemProvider(Me,pt(te),ue,Ae)},registerDocumentLinkProvider(te,ue){return lt.registerDocumentLinkProvider(Me,pt(te),ue)},registerColorProvider(te,ue){return lt.registerColorProvider(Me,pt(te),ue)},registerFoldingRangeProvider(te,ue){return lt.registerFoldingRangeProvider(Me,pt(te),ue)},registerSelectionRangeProvider(te,ue){return lt.registerSelectionRangeProvider(Me,te,ue)},registerCallHierarchyProvider(te,ue){return lt.registerCallHierarchyProvider(Me,te,ue)},setLanguageConfiguration:(te,ue)=>lt.setLanguageConfiguration(Me,te,ue),getTokenInformationAtPosition(te,ue){return(0,Q.checkProposedApiEnabled)(Me),Wt.tokenAtPosition(te,ue)},registerInlineHintsProvider(te,ue){return(0,Q.checkProposedApiEnabled)(Me),lt.registerInlineHintsProvider(Me,te,ue)}},Tn={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(te,ue,Ae){const rt=await(k.URI.isUri(te)?Promise.resolve(un.openTextDocument(te)):Promise.resolve(te));return yt.showTextDocument(rt,ue,Ae)},createTextEditorDecorationType(te){return yt.createTextEditorDecorationType(te)},onDidChangeActiveTextEditor(te,ue,Ae){return yt.onDidChangeActiveTextEditor(te,ue,Ae)},onDidChangeVisibleTextEditors(te,ue,Ae){return yt.onDidChangeVisibleTextEditors(te,ue,Ae)},onDidChangeTextEditorSelection(te,ue,Ae){return yt.onDidChangeTextEditorSelection(te,ue,Ae)},onDidChangeTextEditorOptions(te,ue,Ae){return yt.onDidChangeTextEditorOptions(te,ue,Ae)},onDidChangeTextEditorVisibleRanges(te,ue,Ae){return yt.onDidChangeTextEditorVisibleRanges(te,ue,Ae)},onDidChangeTextEditorViewColumn(te,ue,Ae){return yt.onDidChangeTextEditorViewColumn(te,ue,Ae)},onDidCloseTerminal(te,ue,Ae){return ft.onDidCloseTerminal(te,ue,Ae)},onDidOpenTerminal(te,ue,Ae){return ft.onDidOpenTerminal(te,ue,Ae)},onDidChangeActiveTerminal(te,ue,Ae){return ft.onDidChangeActiveTerminal(te,ue,Ae)},onDidChangeTerminalDimensions(te,ue,Ae){return(0,Q.checkProposedApiEnabled)(Me),ft.onDidChangeTerminalDimensions(te,ue,Ae)},onDidWriteTerminalData(te,ue,Ae){return(0,Q.checkProposedApiEnabled)(Me),ft.onDidWriteTerminalData(te,ue,Ae)},get state(){return Ze.state},onDidChangeWindowState(te,ue,Ae){return Ze.onDidChangeWindowState(te,ue,Ae)},showInformationMessage(te,...ue){return Nt.showMessage(Me,y.default.Info,te,ue[0],ue.slice(1))},showWarningMessage(te,...ue){return Nt.showMessage(Me,y.default.Warning,te,ue[0],ue.slice(1))},showErrorMessage(te,...ue){return Nt.showMessage(Me,y.default.Error,te,ue[0],ue.slice(1))},showQuickPick(te,ue,Ae){return xt.showQuickPick(te,!!Me.enableProposedApi,ue,Ae)},showWorkspaceFolderPick(te){return xt.showWorkspaceFolderPick(te)},showInputBox(te,ue){return xt.showInput(te,ue)},showOpenDialog(te){return Lt.showOpenDialog(te)},showSaveDialog(te){return Lt.showSaveDialog(te)},createStatusBarItem(te,ue){let Ae,rt,$,x;return te&&typeof te!="number"?(Ae=te.id,rt=te.name,$=te.alignment,ue=te.priority,x=te.accessibilityInformation):(Ae=Me.identifier.value,rt=_.localize(0,null,Me.displayName||Me.name),$=te),vn.createStatusBarEntry(Ae,rt,$,ue,x)},setStatusBarMessage(te,ue){return vn.setStatusBarMessage(te,ue)},withScmProgress(te){return Qe.report("window.withScmProgress",Me,"Use 'withProgress' instead."),pn.withProgress(Me,{location:F.ProgressLocation.SourceControl},(ue,Ae)=>te({report(rt){}}))},withProgress(te,ue){return pn.withProgress(Me,te,ue)},createOutputChannel(te){return Ct.createOutputChannel(te)},createWebviewPanel(te,ue,Ae,rt){return sn.createWebviewPanel(Me,te,ue,Ae,rt)},createWebviewTextEditorInset(te,ue,Ae,rt){return(0,Q.checkProposedApiEnabled)(Me),en.createWebviewEditorInset(te,ue,Ae,rt,Me)},createTerminal(te,ue,Ae){return typeof te=="object"?"pty"in te?ft.createExtensionTerminal(te):(te.message&&(0,Q.checkProposedApiEnabled)(Me),te.icon&&(0,Q.checkProposedApiEnabled)(Me),ft.createTerminalFromOptions(te)):ft.createTerminal(te,ue,Ae)},registerTerminalLinkProvider(te){return ft.registerLinkProvider(te)},registerTreeDataProvider(te,ue){return qt.registerTreeDataProvider(te,ue,Me)},createTreeView(te,ue){return qt.createTreeView(te,ue,Me)},registerWebviewPanelSerializer:(te,ue)=>sn.registerWebviewPanelSerializer(Me,te,ue),registerCustomEditorProvider:(te,ue,Ae={})=>Qt.registerCustomEditorProvider(Me,te,ue,Ae),registerFileDecorationProvider(te){return ht.registerFileDecorationProvider(te,Me.identifier)},registerUriHandler(te){return At.registerUriHandler(Me.identifier,te)},createQuickPick(){return xt.createQuickPick(Me.identifier,!!Me.enableProposedApi)},createInputBox(){return xt.createInputBox(Me.identifier)},get activeColorTheme(){return Kt.activeColorTheme},onDidChangeActiveColorTheme(te,ue,Ae){return Kt.onDidChangeActiveColorTheme(te,ue,Ae)},registerWebviewViewProvider(te,ue,Ae){return yn.registerWebviewViewProvider(Me,te,ue,Ae==null?void 0:Ae.webviewOptions)},get activeNotebookEditor(){return(0,Q.checkProposedApiEnabled)(Me),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,ue,Ae){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeActiveNotebookEditor(te,ue,Ae)},get visibleNotebookEditors(){return(0,Q.checkProposedApiEnabled)(Me),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,ue,Ae){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookEditorSelection(te,ue,Ae)},onDidChangeNotebookEditorVisibleRanges(te,ue,Ae){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookEditorVisibleRanges(te,ue,Ae)},showNotebookDocument(te,ue){return(0,Q.checkProposedApiEnabled)(Me),gt.showNotebookDocument(te,ue)},registerExternalUriOpener(te,ue,Ae){return(0,Q.checkProposedApiEnabled)(Me),on.registerExternalUriOpener(Me.identifier,te,ue,Ae)},get openEditors(){return(0,Q.checkProposedApiEnabled)(Me),It.tabs},get onDidChangeOpenEditors(){return(0,Q.checkProposedApiEnabled)(Me),It.onDidChangeTabs}},un={get rootPath(){return Qe.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ye.getPath()},set rootPath(te){throw T.readonly()},getWorkspaceFolder(te){return Ye.getWorkspaceFolder(te)},get workspaceFolders(){return Ye.getWorkspaceFolders()},get name(){return Ye.name},set name(te){throw T.readonly()},get workspaceFile(){return Ye.workspaceFile},set workspaceFile(te){throw T.readonly()},updateWorkspaceFolders:(te,ue,...Ae)=>Ye.updateWorkspaceFolders(Me,te,ue||0,...Ae),onDidChangeWorkspaceFolders:function(te,ue,Ae){return Ye.onDidChangeWorkspace(te,ue,Ae)},asRelativePath:(te,ue)=>Ye.getRelativePath(te,ue),findFiles:(te,ue,Ae,rt)=>Ye.findFiles(L.GlobPattern.from(te),L.GlobPattern.from(ue),Ae,Me.identifier,rt),findTextInFiles:(te,ue,Ae,rt)=>{let $,x;return typeof ue=="object"?($=ue,x=Ae):($={},x=ue,rt=Ae),Ye.findTextInFiles(te,$||{},x,Me.identifier,rt)},saveAll:te=>Ye.saveAll(te),applyEdit(te){return Bt.applyWorkspaceEdit(te)},createFileSystemWatcher:(te,ue,Ae,rt)=>Tt.createFileSystemWatcher(L.GlobPattern.from(te),ue,Ae,rt),get textDocuments(){return bt.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw T.readonly()},openTextDocument(te){let ue;const Ae=te;if(typeof te=="string")ue=Promise.resolve(k.URI.file(te));else if(k.URI.isUri(te))ue=Promise.resolve(te);else if(!Ae||typeof Ae=="object")ue=bt.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(rt=>bt.ensureDocumentData(rt).then($=>$.document))},onDidOpenTextDocument:(te,ue,Ae)=>bt.onDidAddDocument(te,ue,Ae),onDidCloseTextDocument:(te,ue,Ae)=>bt.onDidRemoveDocument(te,ue,Ae),onDidChangeTextDocument:(te,ue,Ae)=>bt.onDidChangeDocument(te,ue,Ae),onDidSaveTextDocument:(te,ue,Ae)=>bt.onDidSaveDocument(te,ue,Ae),onWillSaveTextDocument:(te,ue,Ae)=>Jt.getOnWillSaveTextDocumentEvent(Me)(te,ue,Ae),onDidChangeConfiguration:(te,ue,Ae)=>cn.onDidChangeConfiguration(te,ue,Ae),getConfiguration(te,ue){return ue=arguments.length===1?void 0:ue,cn.getConfiguration(te,ue,Me)},registerTextDocumentContentProvider(te,ue){return Yt.registerTextDocumentContentProvider(te,ue)},registerTaskProvider:(te,ue)=>(Qe.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Me,te,ue)),registerFileSystemProvider(te,ue,Ae){return tn.registerFileSystemProvider(Me.identifier,te,ue,Ae)},get fs(){return dt.value},registerFileSearchProvider:(te,ue)=>((0,Q.checkProposedApiEnabled)(Me),Et.registerFileSearchProvider(te,ue)),registerTextSearchProvider:(te,ue)=>((0,Q.checkProposedApiEnabled)(Me),Et.registerTextSearchProvider(te,ue)),registerRemoteAuthorityResolver:(te,ue)=>((0,Q.checkProposedApiEnabled)(Me),it.registerRemoteAuthorityResolver(te,ue)),registerResourceLabelFormatter:te=>((0,Q.checkProposedApiEnabled)(Me),nn.$registerResourceLabelFormatter(te)),onDidCreateFiles:(te,ue,Ae)=>Tt.onDidCreateFile(te,ue,Ae),onDidDeleteFiles:(te,ue,Ae)=>Tt.onDidDeleteFile(te,ue,Ae),onDidRenameFiles:(te,ue,Ae)=>Tt.onDidRenameFile(te,ue,Ae),onWillCreateFiles:(te,ue,Ae)=>Tt.getOnWillCreateFileEvent(Me)(te,ue,Ae),onWillDeleteFiles:(te,ue,Ae)=>Tt.getOnWillDeleteFileEvent(Me)(te,ue,Ae),onWillRenameFiles:(te,ue,Ae)=>Tt.getOnWillRenameFileEvent(Me)(te,ue,Ae),openTunnel:te=>((0,Q.checkProposedApiEnabled)(Me),Te.openTunnel(Me,te).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,Q.checkProposedApiEnabled)(Me),Te.getTunnels()},onDidChangeTunnels:(te,ue,Ae)=>((0,Q.checkProposedApiEnabled)(Me),Te.onDidChangeTunnels(te,ue,Ae)),registerPortAttributesProvider:(te,ue)=>((0,Q.checkProposedApiEnabled)(Me),Te.registerPortsAttributesProvider(te,ue)),registerTimelineProvider:(te,ue)=>((0,Q.checkProposedApiEnabled)(Me),Sn.registerTimelineProvider(te,ue,Me.identifier,ot.converter)),get isTrusted(){return Ye.trusted},requestWorkspaceTrust:te=>((0,Q.checkProposedApiEnabled)(Me),Ye.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,ue,Ae)=>Ye.onDidGrantWorkspaceTrust(te,ue,Ae)},bn={get inputBox(){return Qe.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),gn.getLastInputBox(Me)},createSourceControl(te,ue,Ae){return gn.createSourceControl(Me,te,ue,Ae)}},Ut={createCommentController(te,ue){return En.createCommentController(Me,te,ue)}},$t={get activeDebugSession(){return at.activeDebugSession},get activeDebugConsole(){return at.activeDebugConsole},get breakpoints(){return at.breakpoints},onDidStartDebugSession(te,ue,Ae){return at.onDidStartDebugSession(te,ue,Ae)},onDidTerminateDebugSession(te,ue,Ae){return at.onDidTerminateDebugSession(te,ue,Ae)},onDidChangeActiveDebugSession(te,ue,Ae){return at.onDidChangeActiveDebugSession(te,ue,Ae)},onDidReceiveDebugSessionCustomEvent(te,ue,Ae){return at.onDidReceiveDebugSessionCustomEvent(te,ue,Ae)},onDidChangeBreakpoints(te,ue,Ae){return at.onDidChangeBreakpoints(te,ue,Ae)},registerDebugConfigurationProvider(te,ue,Ae){return at.registerDebugConfigurationProvider(te,ue,Ae||F.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,ue){return at.registerDebugAdapterDescriptorFactory(Me,te,ue)},registerDebugAdapterTrackerFactory(te,ue){return at.registerDebugAdapterTrackerFactory(te,ue)},startDebugging(te,ue,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?at.startDebugging(te,ue,{parentSession:Ae}):at.startDebugging(te,ue,Ae||{})},stopDebugging(te){return at.stopDebugging(te)},addBreakpoints(te){return at.addBreakpoints(te)},removeBreakpoints(te){return at.removeBreakpoints(te)},asDebugSourceUri(te,ue){return at.asDebugSourceUri(te,ue)}},Rn={registerTaskProvider:(te,ue)=>vt.registerTaskProvider(Me,te,ue),fetchTasks:te=>vt.fetchTasks(te),executeTask:te=>vt.executeTask(Me,te),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(te,ue,Ae)=>vt.onDidStartTask(te,ue,Ae),onDidEndTask:(te,ue,Ae)=>vt.onDidEndTask(te,ue,Ae),onDidStartTaskProcess:(te,ue,Ae)=>vt.onDidStartTaskProcess(te,ue,Ae),onDidEndTaskProcess:(te,ue,Ae)=>vt.onDidEndTaskProcess(te,ue,Ae)},dn={openNotebookDocument:te=>((0,Q.checkProposedApiEnabled)(Me),gt.openNotebookDocument(te)),get onDidOpenNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,Q.checkProposedApiEnabled)(Me),gt.notebookDocuments.map(te=>te.apiNotebook)},registerNotebookSerializer(te,ue,Ae){return(0,Q.checkProposedApiEnabled)(Me),gt.registerNotebookSerializer(Me,te,ue,Ae)},registerNotebookContentProvider:(te,ue,Ae)=>((0,Q.checkProposedApiEnabled)(Me),gt.registerNotebookContentProvider(Me,te,ue,Ae)),registerNotebookCellStatusBarItemProvider:(te,ue)=>((0,Q.checkProposedApiEnabled)(Me),gt.registerNotebookCellStatusBarItemProvider(Me,te,ue)),createNotebookEditorDecorationType(te){return(0,Q.checkProposedApiEnabled)(Me),gt.createNotebookEditorDecorationType(te)},onDidChangeNotebookDocumentMetadata(te,ue,Ae){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookDocumentMetadata(te,ue,Ae)},onDidChangeNotebookCells(te,ue,Ae){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookCells(te,ue,Ae)},onDidChangeCellExecutionState(te,ue,Ae){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookCellExecutionState(te,ue,Ae)},onDidChangeCellOutputs(te,ue,Ae){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeCellOutputs(te,ue,Ae)},onDidChangeCellMetadata(te,ue,Ae){return(0,Q.checkProposedApiEnabled)(Me),gt.onDidChangeCellMetadata(te,ue,Ae)},createConcatTextDocument(te,ue){return(0,Q.checkProposedApiEnabled)(Me),new X.ExtHostNotebookConcatDocument(gt,bt,te,ue)},createNotebookCellExecutionTask(te,ue,Ae){return(0,Q.checkProposedApiEnabled)(Me),gt.createNotebookCellExecution(te,ue,Ae)},createNotebookController(te,ue,Ae,rt,$){return(0,Q.checkProposedApiEnabled)(Me),Zt.createNotebookController(Me,te,ue,Ae,rt,$)}};return{version:Ke.version,authentication:Cn,commands:kn,comments:Ut,debug:$t,env:Xt,extensions:In,languages:An,notebook:dn,scm:bn,tasks:Rn,test:Pn,window:Tn,workspace:un,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:I.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTriggerKind:F.CodeActionTriggerKind,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:F.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,InlineValueText:F.InlineValueText,InlineValueVariableLookup:F.InlineValueVariableLookup,InlineValueEvaluatableExpression:F.InlineValueEvaluatableExpression,EventEmitter:A.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:g.FileType,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,Hover:F.Hover,IndentAction:s.IndentAction,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:P.OverviewRulerLane,ParameterInformation:F.ParameterInformation,PortAutoForwardAction:F.PortAutoForwardAction,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,TaskGroup:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItemCollapsibleState:F.TreeItemCollapsibleState,UIKind:m.UIKind,Uri:k.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,InlineHint:F.InlineHint,InlineHintKind:F.InlineHintKind,RemoteAuthorityResolverError:F.RemoteAuthorityResolverError,RemoteTrustOption:ye.RemoteTrustOption,ResolvedAuthority:F.ResolvedAuthority,SourceControlInputBoxValidationType:F.SourceControlInputBoxValidationType,ExtensionRuntime:F.ExtensionRuntime,TimelineItem:F.TimelineItem,NotebookRange:F.NotebookRange,NotebookCellKind:F.NotebookCellKind,NotebookCellExecutionState:F.NotebookCellExecutionState,NotebookDocumentMetadata:F.NotebookDocumentMetadata,NotebookCellMetadata:F.NotebookCellMetadata,NotebookCellData:F.NotebookCellData,NotebookData:F.NotebookData,NotebookCellStatusBarAlignment:F.NotebookCellStatusBarAlignment,NotebookEditorRevealType:F.NotebookEditorRevealType,NotebookCellOutput:F.NotebookCellOutput,NotebookCellOutputItem:F.NotebookCellOutputItem,NotebookCellStatusBarItem:F.NotebookCellStatusBarItem,LinkedEditingRanges:F.LinkedEditingRanges,TestItemStatus:F.TestItemStatus,TestResultState:F.TestResultState,TestMessage:F.TestMessage,TextSearchCompleteMessageType:je.TextSearchCompleteMessageType,TestMessageSeverity:F.TestMessageSeverity,WorkspaceTrustState:F.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=He}),define(ge[270],pe([0,1,79,64,32,126,35,51,39,34,67,46,69,93,92,50,63,127,91,61,90,119]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a,u,E,w,S,d,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(m.IExtensionStoragePaths,m.ExtensionStoragePaths),(0,_.registerSingleton)(E.IExtHostApiDeprecationService,E.ExtHostApiDeprecationService),(0,_.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,_.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,_.registerSingleton)(S.IExtHostConsumerFileSystem,S.ExtHostConsumerFileSystem),(0,_.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,_.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,_.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,_.registerSingleton)(d.IExtHostFileSystemInfo,d.ExtHostFileSystemInfo),(0,_.registerSingleton)(I.IExtHostOutputService,I.ExtHostOutputService),(0,_.registerSingleton)(g.IExtHostSearch,g.ExtHostSearch),(0,_.registerSingleton)(a.IExtHostStorage,a.ExtHostStorage),(0,_.registerSingleton)(s.IExtHostTask,s.WorkerExtHostTask),(0,_.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,_.registerSingleton)(u.IExtHostTunnelService,u.ExtHostTunnelService),(0,_.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,_.registerSingleton)(T.IExtHostWorkspace,T.ExtHostWorkspace),(0,_.registerSingleton)(l.IExtHostSecretState,l.ExtHostSecretState),(0,_.registerSingleton)(f.IExtHostTelemetry,f.ExtHostTelemetry)}),define(ge[94],pe([0,1,19,13,31,66]),function(K,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function y(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.anchorGlob=y;function k(C,g,m,a){const u=(0,_.mapArrayOrNot)(m,D),E=new T.TextSearchMatch(g,u,a),w=E.preview.matches;return{ranges:(0,_.mapArrayOrNot)(u,P),uri:C,preview:{text:E.preview.text,matches:(0,_.mapArrayOrNot)(w,P)}}}e.createTextSearchResult=k;function D(C){return new T.SearchRange(C.start.line,C.start.character,C.end.line,C.end.character)}function P(C){return new A.Range(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let s=class{constructor(g,m){this.prefix=g,this.logService=m}appendLine(g){this.logService.debug(`${this.prefix}#search`,g)}};s=Ve([xe(1,I.ILogService)],s),e.OutputChannel=s}),define(ge[271],pe([0,1,95,22]),function(K,e,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function T(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(n=>n===t)}e.isUTFEncoding=T,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,y=512,k=512*8,D=512*128;class P{constructor(n){this.iconvLiteDecoder=n}static async create(n){let r;if(n!==e.UTF8)r=(await new Promise((o,c)=>{K(["iconv-lite-umd"],o,c)})).getDecoder(m(n));else{const i=new TextDecoder;r={write(o){return i.decode(o,{stream:!0})},end(){return i.decode()}}}return new P(r)}write(n){return this.iconvLiteDecoder.write(n)}end(){return this.iconvLiteDecoder.end()}}function s(t,n){var r;const i=((r=n.minBytesRequiredForDetection)!==null&&r!==void 0?r:n.guessEncoding)?k:y;return new Promise((o,c)=>{const v=(0,_.newWriteableStream)(N=>N.join("")),p=[];let h=0,b;const R=async()=>{try{const N=await f({buffer:I.VSBuffer.concat(p),bytesRead:h},n.guessEncoding);N.encoding=await n.overwriteEncoding(N.encoding),b=await P.create(N.encoding);const j=b.write(I.VSBuffer.concat(p).buffer);v.write(j),p.length=0,h=0,o({stream:v,detected:N})}catch(N){c(N)}};(0,_.listenStream)(t,{onData:async N=>{b?v.write(b.write(N.buffer)):(p.push(N),h+=N.byteLength,h>=i&&(t.pause(),await R(),setTimeout(()=>t.resume())))},onError:N=>v.error(N),onEnd:async()=>{b||await R(),v.end(b==null?void 0:b.end())}})})}e.toDecodeStream=s;async function C(t,n,r){const o=(await new Promise((p,h)=>{K(["iconv-lite-umd"],p,h)})).getEncoder(m(n),r);let c=!1,v=!1;return{read(){if(v)return null;const p=t.read();if(typeof p!="string"){if(v=!0,!c&&(r==null?void 0:r.addBOM))switch(n){case e.UTF8:case e.UTF8_with_bom:return I.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return I.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return I.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const h=o.end();return h&&h.length>0?(c=!0,I.VSBuffer.wrap(h)):null}return c=!0,I.VSBuffer.wrap(o.write(p))}}}e.toEncodeReadable=C;async function g(t){return(await new Promise((r,i)=>{K(["iconv-lite-umd"],r,i)})).encodingExists(m(t))}e.encodingExists=g;function m(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=m;function a(t,n){if(!t||n<e.UTF16be_BOM.length)return null;const r=t.readUInt8(0),i=t.readUInt8(1);if(r===e.UTF16be_BOM[0]&&i===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&i===e.UTF16le_BOM[1])return e.UTF16le;if(n<e.UTF8_BOM.length)return null;const o=t.readUInt8(2);return r===e.UTF8_BOM[0]&&i===e.UTF8_BOM[1]&&o===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=a;const u=["ascii","utf-16","utf-32"];async function E(t){const n=await new Promise((v,p)=>{K(["jschardet"],v,p)}),r=t.slice(0,D),i=d(r.buffer),o=n.detect(i);if(!o||!o.encoding)return null;const c=o.encoding.toLowerCase();return 0<=u.indexOf(c)?null:S(o.encoding)}const w={ibm866:"cp866",big5:"cp950"};function S(t){const n=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return w[n]||n}function d(t){let n="";for(let r=0;r<t.length;r++)n+=String.fromCharCode(t[r]);return n}function l(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const n=t.match(/windows(\d+)/);return n?"windows-"+n[1]:t}}e.toCanonicalName=l;function f({buffer:t,bytesRead:n},r){let i=a(t,n),o=!1;if(i!==e.UTF16be&&i!==e.UTF16le&&t){let c=!0,v=!0,p=!1;for(let h=0;h<n&&h<A;h++){const b=h%2==1,R=t.readUInt8(h)===0;if(R&&(p=!0),c&&(b&&!R||!b&&R)&&(c=!1),v&&(b&&R||!b&&!R)&&(v=!1),R&&!c&&!v)break}p&&(c?i=e.UTF16le:v?i=e.UTF16be:o=!0)}return r&&!o&&!i&&t?E(t.slice(0,n)).then(c=>({seemsBinary:!1,encoding:c})):{seemsBinary:o,encoding:i}}e.detectEncodingFromBuffer=f,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ge[129],pe([0,1,271,26,128]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends T.TextSearchManager{constructor(k,D,P=I){super(k,D,{readdir:s=>P.readdir(s.fsPath),toCanonicalName:s=>(0,_.toCanonicalName)(s)})}}e.NativeTextSearchManager=A}),define(ge[272],pe([0,1,273,287,288,2,289]),function(K,e,_,I,T,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(C,g,m,a,u,E){const w=E.environment.useHostProxy,S=typeof w=="boolean"?w:!E.remote.isRemote,d=(0,y.createProxyResolver)({resolveProxy:f=>C.resolveProxy(f),getHttpProxySetting:()=>g.getConfiguration("http").get("proxy"),log:(f,t,...n)=>{switch(f){case y.LogLevel.Trace:a.trace(t,...n);break;case y.LogLevel.Debug:a.debug(t,...n);break;case y.LogLevel.Info:a.info(t,...n);break;case y.LogLevel.Warning:a.warn(t,...n);break;case y.LogLevel.Error:a.error(t,...n);break;case y.LogLevel.Critical:a.critical(t,...n);break;case y.LogLevel.Off:break;default:r(f,t,n);break}function r(i,o,...c){a.error("Unknown log level",i),a.error(o,...c)}},getLogLevel:()=>a.getLevel(),proxyResolveTelemetry:f=>{u.$publicLog2("resolveProxy",f)},useHostProxy:S,env:process.env}),l=D(g,d);return s(m,l)}e.connectProxyResolver=k;function D(C,g){const m={config:C.getConfiguration("http").get("proxySupport")||"off"};C.onDidChangeConfiguration(u=>{m.config=C.getConfiguration("http").get("proxySupport")||"off"});const a={config:!!C.getConfiguration("http").get("systemCertificates")};return C.onDidChangeConfiguration(u=>{a.config=!!C.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},_,(0,y.createHttpPatch)(_,g,{config:"off"},a,!0)),on:Object.assign({},_,(0,y.createHttpPatch)(_,g,{config:"on"},a,!0)),override:Object.assign({},_,(0,y.createHttpPatch)(_,g,{config:"override"},a,!0)),onRequest:Object.assign({},_,(0,y.createHttpPatch)(_,g,m,a,!0)),default:Object.assign(_,(0,y.createHttpPatch)(_,g,m,a,!1))},https:{off:Object.assign({},I,(0,y.createHttpPatch)(I,g,{config:"off"},a,!0)),on:Object.assign({},I,(0,y.createHttpPatch)(I,g,{config:"on"},a,!0)),override:Object.assign({},I,(0,y.createHttpPatch)(I,g,{config:"override"},a,!0)),onRequest:Object.assign({},I,(0,y.createHttpPatch)(I,g,m,a,!0)),default:Object.assign(I,(0,y.createHttpPatch)(I,g,m,a,!1))},tls:Object.assign(T,(0,y.createTlsPatch)(T))}}const P=new Map;function s(C,g){return C.getExtensionPathIndex().then(m=>{const a=K.__$__nodeRequire("module"),u=a._load;a._load=function(w,S,d){if(w==="tls")return g.tls;if(w!=="http"&&w!=="https")return u.apply(this,arguments);const l=g[w],f=m.findSubstr(A.URI.file(S.filename).fsPath);let t=P.get(f);if(t||P.set(f,t={}),!t[w]){let n=l.default;f&&f.enableProposedApi&&(n=l[f.proxySupport]||l.onRequest),t[w]=Object.assign({},n)}return t[w]}})}}),define(ge[274],pe([0,1,38,8,75,29,10,9,94,275]),function(K,e,_,I,T,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const s=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(d,l,f,t){const n=g(d,l,f,t),r=l.folder.fsPath;return{cmd:_.spawn(s,n.args,{cwd:r}),rgDiskPath:s,siblingClauses:n.siblingClauses,rgArgs:n,cwd:r}}e.spawnRipgrepCmd=C;function g(d,l,f,t){const n=["--files","--hidden","--case-sensitive"];a([l],f,!1).forEach(i=>{const o=(0,D.anchorGlob)(i);if(n.push("-g",o),y.isMacintosh){const c=(0,T.normalizeNFD)(o);c!==o&&n.push("-g",c)}});const r=m([l],t,void 0,!1);return r.globArgs.forEach(i=>{const o=`!${(0,D.anchorGlob)(i)}`;if(n.push("-g",o),y.isMacintosh){const c=(0,T.normalizeNFD)(o);c!==o&&n.push("-g",c)}}),l.disregardIgnoreFiles!==!1?n.push("--no-ignore"):n.push("--no-ignore-parent"),l.ignoreSymlinks||n.push("--follow"),d.exists&&n.push("--quiet"),n.push("--no-config"),l.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:r.siblingClauses}}function m(d,l,f,t=!0){const n=[];let r={};return d.forEach(i=>{const o=Object.assign({},i.excludePattern||{},l||{}),c=u(o,t?i.folder.fsPath:void 0,f);n.push(...c.globArgs),c.siblingClauses&&(r=Object.assign(r,c.siblingClauses))}),{globArgs:n,siblingClauses:r}}e.foldersToRgExcludeGlobs=m;function a(d,l,f=!0){const t=[];return d.forEach(n=>{const r=Object.assign({},l||{},n.includePattern||{}),i=u(r,f?n.folder.fsPath:void 0);t.push(...i.globArgs)}),t}e.foldersToIncludeGlobs=a;function u(d,l,f){const t=[],n={};return Object.keys(d).forEach(r=>{if(!(f&&f.has(r))&&!!r){const i=d[r];r=w(l?E(l,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof i=="boolean"&&i?(r.startsWith("\\\\")&&(r+="**"),t.push(S(r))):i&&i.when&&(n[r]=i)}}),{globArgs:t,siblingClauses:n}}function E(d,l){return I.isAbsolute(l)?l:I.join(d,l)}e.getAbsoluteGlob=E;function w(d){return d=k.rtrim(d,"\\"),k.rtrim(d,"/")}function S(d){return A.getRoot(d).toLowerCase()==="c:/"?d.replace(/^c:[/\\]/i,"/"):d}e.fixDriveC=S}),define(ge[276],pe([0,1,38,37,8,102,19,59,33,75,29,10,47,9,11,26,31,274,100]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a,u,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const d=new Set;process.on("exit",()=>{d.forEach(r=>r())});class l{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&D.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,S.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&D.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(o=>{const c=Object.assign({},o.excludePattern||{},this.config.excludePattern||{}),v=o.folder.fsPath;i.folderQueries.map(p=>p.folder.fsPath).filter(p=>p!==v).forEach(p=>{(0,s.isEqualOrParent)(p,v)&&(c[T.relative(v,p)]=!0)}),this.folderExcludePatterns.set(v,new t(c,v))})}cancel(){this.isCanceled=!0}walk(i,o,c,v,p){if(this.fileWalkSW=g.StopWatch.create(!1),this.isCanceled)return p(null,this.isLimitHit);o.forEach(h=>{const b=T.basename(h.fsPath);this.globalExcludePattern&&this.globalExcludePattern(h.fsPath,b)||this.matchFile(c,{relativePath:h.fsPath,searchPath:void 0})}),this.cmdSW=g.StopWatch.create(!1),this.parallel(i,(h,b)=>{this.call(this.cmdTraversal,this,h,c,v,R=>{if(R){const N=(0,k.toErrorMessage)(R);console.error(N),this.errors.push(N),b(R,void 0)}else b(null,void 0)})},(h,b)=>{this.fileWalkSW.stop();const R=h?y.coalesce(h)[0]:null;p(R,this.isLimitHit)})}parallel(i,o,c){const v=new Array(i.length),p=new Array(i.length);let h=!1,b=0;if(i.length===0)return c(null,[]);i.forEach((R,N)=>{o(R,(j,oe)=>{if(j?(h=!0,v[N]=null,p[N]=j):(v[N]=oe,p[N]=null),++b===i.length)return c(h?p:null,v)})})}call(i,o,...c){try{i.apply(o,c)}catch(v){c[c.length-1](v)}}cmdTraversal(i,o,c,v){const p=i.folder.fsPath,h=C.isMacintosh;let b;const R=()=>b&&b.kill();d.add(R);let N=L=>{d.delete(R),N=()=>{},v(L)},j="";const oe=this.initDirectoryTree();let q;const W=(0,w.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);b=W.cmd,q=!Object.keys(W.siblingClauses).length;const H=W.rgArgs.args.map(L=>L.match(/^-/)?L:`'${L}'`).join(" ");let U=`${W.rgDiskPath} ${H}
 - cwd: ${W.cwd}`;W.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(W.rgArgs.siblingClauses)}`),c({message:U}),this.cmdResultCount=0,this.collectStdout(b,"utf8",c,(L,F,O)=>{if(L){N(L);return}if(this.isLimitHit){N();return}const B=(j+(h?P.normalizeNFC(F||""):F)).split(`
`);if(O){const V=B.length;B[V-1]=B[V-1].trim(),B[V-1]||B.pop()}else j=B.pop()||"";if(B.length&&B[0].indexOf(`
`)!==-1){N(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=B.length,q){for(const V of B)if(this.matchFile(o,{base:p,relativePath:V,searchPath:this.getSearchPath(i,V)}),this.isLimitHit){R();break}(O||this.isLimitHit)&&N();return}this.addDirectoryEntries(i,oe,p,B,o),O&&(this.matchDirectoryTree(oe,p,o),N())})}spawnFindCmd(i){const o=this.folderExcludePatterns.get(i.folder.fsPath),c=o.getBasenameTerms(),v=o.getPathTerms(),p=["-L","."];if(c.length||v.length){p.push("-not","(","(");for(const h of c)p.push("-name",h),p.push("-o");for(const h of v)p.push("-path",h),p.push("-o");p.pop(),p.push(")","-prune",")")}return p.push("-type","f"),_.spawn("find",p,{cwd:i.folder.fsPath})}readStdout(i,o,c){let v="";this.collectStdout(i,o,()=>{},(p,h,b)=>{if(p){c(p);return}v+=h,b&&c(null,v)})}collectStdout(i,o,c,v){let p=(R,N,j)=>{(R||j)&&(p=()=>{},this.cmdSW&&this.cmdSW.stop()),v(R,N,j)},h=!1;i.stdout?(this.forwardData(i.stdout,o,p),i.stdout.once("data",()=>h=!0)):c({message:"stdout is null"});let b;i.stderr?b=this.collectData(i.stderr):c({message:"stderr is null"}),i.on("error",R=>{p(R)}),i.on("close",R=>{let N;!h&&(N=this.decodeData(b,o))&&n(N)?p(new Error(`command failed with error code ${R}: ${this.decodeData(b,o)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),p(null,"",!0))})}forwardData(i,o,c){const v=new A.StringDecoder(o);return i.on("data",p=>{c(null,v.write(p))}),v}collectData(i){const o=[];return i.on("data",c=>{o.push(c)}),o}decodeData(i,o){const c=new A.StringDecoder(o);return i.map(v=>c.write(v)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:o},c,v,p){v.indexOf(this.filePattern)!==-1&&this.matchFile(p,{base:c,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const h=b=>{const R=T.basename(b),N=T.dirname(b);let j=o[N];j||(j=o[N]=[],h(N)),j.push({base:c,relativePath:b,basename:R,searchPath:this.getSearchPath(i,b)})};v.forEach(h)}matchDirectoryTree({rootEntries:i,pathToEntries:o},c,v){const p=this,h=this.folderExcludePatterns.get(c),b=this.filePattern;function R(N){p.directoriesWalked++;const j=D.hasSiblingFn(()=>N.map(oe=>oe.basename));for(let oe=0,q=N.length;oe<q;oe++){const W=N[oe],{relativePath:H,basename:U}=W;if(!h.test(H,U,b!==U?j:void 0)){const L=o[H];if(L)R(L);else{if(p.filesWalked++,H===b)continue;p.matchFile(v,W)}if(p.isLimitHit)break}}}R(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,o,c,v,p){const h=i.folder,b=D.hasSiblingFn(()=>c);this.parallel(c,(R,N)=>{if(this.isCanceled||this.isLimitHit)return N(null);const j=o?[o,R].join(T.sep):R;if(this.folderExcludePatterns.get(i.folder.fsPath).test(j,R,this.config.filePattern!==R?b:void 0))return N(null);const oe=[h.fsPath,j].join(T.sep);I.lstat(oe,(q,W)=>{if(q||this.isCanceled||this.isLimitHit)return N(null);this.statLinkIfNeeded(oe,W,(H,U)=>H||this.isCanceled||this.isLimitHit?N(null):U.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(oe,W,(L,F)=>L||this.isCanceled||this.isLimitHit||(F=F||"",this.walkedPaths[F])?N(null):(this.walkedPaths[F]=!0,(0,u.readdir)(oe).then(O=>{if(this.isCanceled||this.isLimitHit)return N(null);this.doWalk(i,j,O,v,M=>N(M||null))},O=>{N(null)})))):(this.filesWalked++,j===this.filePattern||this.maxFilesize&&a.isNumber(U.size)&&U.size>this.maxFilesize||this.matchFile(v,{base:h.fsPath,relativePath:j,searchPath:this.getSearchPath(i,j)}),N(null,void 0)))})},R=>{const N=R&&y.coalesce(R);return p(N&&N.length>0?N[0]:void 0)})}matchFile(i,o){this.isFileMatch(o)&&(!this.includePattern||this.includePattern(o.relativePath,T.basename(o.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(o))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,E.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,o,c){return o.isSymbolicLink()?I.stat(i,c):c(null,o)}realPathIfNeeded(i,o,c){return o.isSymbolicLink()?I.realpath(i,(v,p)=>v?c(v):c(null,p)):c(null,i)}getSearchPath(i,o){return i.folderName?T.join(i.folderName,o):o}}e.FileWalker=l;class f{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new l(i)}search(i,o,c){this.walker.walk(this.folderQueries,this.extraFiles,i,o,(v,p)=>{c(v,{limitHit:p,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=f;class t{constructor(i,o){this.expression=i,this.root=o,this.init(i)}init(i){let o,c;Object.keys(i).filter(v=>i[v]).forEach(v=>{T.isAbsolute(v)?(o=o||D.getEmptyExpression(),o[v]=i[v]):(c=c||D.getEmptyExpression(),c[v]=i[v])}),this.absoluteParsedExpr=o&&D.parse(o,{trimForExclusions:!0}),this.relativeParsedExpr=c&&D.parse(c,{trimForExclusions:!0})}test(i,o,c){return this.relativeParsedExpr&&this.relativeParsedExpr(i,o,c)||this.absoluteParsedExpr&&this.absoluteParsedExpr(T.join(this.root,i),o,c)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getPathTerms(this.relativeParsedExpr)),i}}function n(r){const i=r.trim().split(`
`),o=i[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return m.uppercaseFirstLetter(i[i.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}e.rgErrorMsgForDisplay=n}),define(ge[130],pe([0,1,38,290,102,19,53,33,8,9,2,31,66,291,275,94]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const E=a.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class w{constructor(h){this.outputChannel=h}provideTextSearchResults(h,b,R,N){return this.outputChannel.appendLine(`provideTextSearchResults ${h.pattern}, ${JSON.stringify(Object.assign(Object.assign({},b),{folder:b.folder.toString()}))}`),new Promise((j,oe)=>{N.onCancellationRequested(()=>M());const q=n(h,b),W=b.folder.fsPath,H=q.map(we=>we.match(/^-/)?we:`'${we}'`).join(" ");this.outputChannel.appendLine(`${E} ${H}
 - cwd: ${W}`);let U=_.spawn(E,q,{cwd:W});U.on("error",we=>{console.error(we),this.outputChannel.appendLine("Error: "+(we&&we.message)),oe((0,C.serializeSearchError)(new C.SearchError(we&&we.message,C.SearchErrorCode.rgProcessError)))});let L=!1;const F=new l(b.maxResults,W,b.previewOptions);F.on("result",we=>{L=!0,V="",R.report(we)});let O=!1;const M=()=>{O=!0,U&&U.kill(),F&&F.cancel()};let B=!1;F.on("hitLimit",()=>{B=!0,M()});let V="";U.stdout.on("data",we=>{F.handleData(we),L||(V+=we)});let Q=!1;U.stdout.once("data",()=>Q=!0);let de="";U.stderr.on("data",we=>{const Ie=we.toString();this.outputChannel.appendLine(Ie),de+=Ie}),U.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(L?"Got result from parser":"No result from parser"),V&&this.outputChannel.appendLine(`Got data without result: ${V}`),this.outputChannel.appendLine(""),O)j({limitHit:B});else{F.flush(),U=null;let we;de&&!Q&&(we=S(de))?oe((0,C.serializeSearchError)(new C.SearchError(we.message,we.code))):j({limitHit:B})}})})}}e.RipgrepTextSearchEngine=w;function S(p){const h=p.split(`
`),b=h[0].trim();if(h.some(N=>N.startsWith("regex parse error")))return new C.SearchError(d(h),C.SearchErrorCode.regexParseError);const R=b.match(/grep config error: unknown encoding: (.*)/);if(R)return new C.SearchError(`Unknown encoding: ${R[1]}`,C.SearchErrorCode.unknownEncoding);if(b.startsWith("error parsing glob"))return new C.SearchError(b.charAt(0).toUpperCase()+b.substr(1),C.SearchErrorCode.globParseError);if(b.startsWith("the literal"))return new C.SearchError(b.charAt(0).toUpperCase()+b.substr(1),C.SearchErrorCode.invalidLiteral);if(b.startsWith("PCRE2: error compiling pattern"))return new C.SearchError(b,C.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=S;function d(p){const h=["Regex parse error"],b=p.filter(R=>R.startsWith("PCRE2:"));if(b.length>=1){const R=b[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const N=R.split(":")[1];h.push(":"+N)}}return h.join("")}e.buildRegexParseError=d;class l extends I.EventEmitter{constructor(h,b,R){super();this.maxResults=h,this.rootFolder=b,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new T.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(h,b){return super.on(h,b),this}handleData(h){if(!this.isDone){const b=typeof h=="string"?h:this.stringDecoder.write(h);this.handleDecodedData(b)}}handleDecodedData(h){let b=h.indexOf(`
`);const R=this.remainder+h;if(b>=0)b+=this.remainder.length;else{this.remainder=R;return}let N=0;for(;b>=0;)this.handleLine(R.substring(N,b).trim()),N=b+1,b=R.indexOf(`
`,N);this.remainder=R.substring(N)}handleLine(h){if(!(this.isDone||!h)){let b;try{b=JSON.parse(h)}catch(R){throw new Error(`malformed line from rg: ${h}`)}if(b.type==="match"){const R=f(b.data.path),N=s.URI.file(D.join(this.rootFolder,R)),j=this.createTextSearchMatch(b.data,N);this.onResult(j),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(b.type==="context"){const R=f(b.data.path),N=s.URI.file(D.join(this.rootFolder,R));this.createTextSearchContext(b.data,N).forEach(oe=>this.onResult(oe))}}}createTextSearchMatch(h,b){const R=h.line_number-1;let N=!1,j=f(h.lines);R===0&&(0,P.startsWithUTF8BOM)(j)&&(N=!0,j=(0,P.stripUTF8BOM)(j));const oe=Buffer.from(j);let q=0,W=0,H=R;h.submatches.length===0&&h.submatches.push(j.length?{start:0,end:1,match:{text:j[0]}}:{start:0,end:0,match:{text:""}});const U=(0,A.coalesce)(h.submatches.map((L,F)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let O=f(L.match);R===0&&F===0&&N&&(O=(0,P.stripUTF8BOM)(O),L.start=L.start<=3?0:L.start-3,L.end=L.end<=3?0:L.end-3);const M=oe.slice(q,L.start).toString().length,B=W+M,V=t(O),Q=H,de=V.numLines+Q,we=V.numLines>0?V.lastLineLength:V.lastLineLength+B;return q=L.end,W=we,H=de,new g.Range(Q,B,de,we)}));return(0,u.createTextSearchResult)(b,j,U,this.previewOptions)}createTextSearchContext(h,b){const R=f(h.lines),N=h.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((j,oe)=>({text:j,uri:b,lineNumber:N+oe}))}onResult(h){this.emit("result",h)}}e.RipgrepParser=l;function f(p){return p.bytes?Buffer.from(p.bytes,"base64").toString():p.text}function t(p){const h=/\n/g;let b=0,R=-1,N;for(;N=h.exec(p);)b++,R=N.index;const j=R>=0?p.length-R-1:p.length;return{numLines:b,lastLineLength:j}}function n(p,h){const b=["--hidden"];b.push(p.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:N}=(0,y.groupBy)(h.includes,oe=>oe.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const oe=new Set;N.forEach(q=>{oe.add(q)}),b.push("-g","!*"),oe.forEach(q=>{r(q).map(u.anchorGlob).forEach(W=>{b.push("-g",W)})})}R&&R.length&&R.forEach(oe=>{b.push("-g",oe)}),h.excludes.map(u.anchorGlob).forEach(oe=>b.push("-g",`!${oe}`)),h.maxFileSize&&b.push("--max-filesize",h.maxFileSize+""),h.useIgnoreFiles?b.push("--no-ignore-parent"):b.push("--no-ignore"),h.followSymlinks&&b.push("--follow"),h.encoding&&h.encoding!=="utf8"&&b.push("--encoding",h.encoding),p.pattern==="--"&&(p.isRegExp=!0,p.pattern="\\-\\-"),p.isMultiline&&!p.isRegExp&&(p.pattern=(0,P.escapeRegExpCharacters)(p.pattern),p.isRegExp=!0),h.usePCRE2&&b.push("--pcre2"),b.push("--crlf"),p.isRegExp&&(p.pattern=i(p.pattern),b.push("--auto-hybrid-regex"));let j;if(p.isWordMatch){const q=(0,P.createRegExp)(p.pattern,!!p.isRegExp,{wholeWord:p.isWordMatch}).source.replace(/\\\//g,"/");b.push("--regexp",q)}else if(p.isRegExp){let oe=c(p.pattern);oe=v(oe),b.push("--regexp",oe)}else j=p.pattern,b.push("--fixed-strings");return b.push("--no-config"),h.useGlobalIgnoreFiles||b.push("--no-ignore-global"),b.push("--json"),p.isMultiline&&b.push("--multiline"),h.beforeContext&&b.push("--before-context",h.beforeContext+""),h.afterContext&&b.push("--after-context",h.afterContext+""),b.push("--"),j&&b.push(j),b.push("."),b}function r(p){const h=(0,k.splitGlobAware)(p,"/");return h.map((b,R)=>h.slice(0,R+1).join("/"))}e.spreadGlobComponents=r;function i(p){const h=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;p.match(h);)p=p.replace(h,"$1\\x{$2}");const b=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;p.match(b);)p=p.replace(b,"$1\\x{$2}");return p}e.unicodeEscapesToPCRE2=i;const o=p=>p.type==="Assertion"&&p.kind==="lookbehind";function c(p){let h;try{h=new m.RegExpParser().parsePattern(p)}catch(q){return p}let b="",R=0;const N=(q,W,H)=>{b+=p.slice(R,q)+H,R=W},j=[];return new m.RegExpVisitor({onCharacterEnter(q){if(q.raw==="\\n"){const W=j[0];if(!W)N(q.start,q.end,"\\r?\\n");else if(!j.some(o))if(W.type==="CharacterClass"){const H=p.slice(W.start+1,q.start)+p.slice(q.end,W.end-1);N(W.start,W.end,H===""?"\\r?\\n":`(?:[${H}]|\\r?\\n)`)}else W.type==="Quantifier"&&N(q.start,q.end,"(?:\\r?\\n)")}},onQuantifierEnter(q){j.unshift(q)},onQuantifierLeave(){j.shift()},onCharacterClassRangeEnter(q){j.unshift(q)},onCharacterClassRangeLeave(){j.shift()},onCharacterClassEnter(q){j.unshift(q)},onCharacterClassLeave(){j.shift()},onAssertionEnter(q){o(q)&&j.push(q)},onAssertionLeave(q){j[0]===q&&j.shift()}}).visit(h),b+=p.slice(R),b}e.fixRegexNewline=c;function v(p){return p.replace(/\n/g,"\\r?\\n")}e.fixNewline=v}),define(ge[277],pe([0,1,21,130,115,12]),function(K,e,_,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class y{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,s,C,g){const m=new I.RipgrepTextSearchEngine(this.outputChannel);if(s.folder.scheme===A.Schemas.userData){const a=Object.assign(Object.assign({},s),{folder:s.folder.with({scheme:A.Schemas.file})}),u=new T.Progress(E=>C.report(Object.assign(Object.assign({},E),{uri:E.uri.with({scheme:s.folder.scheme})})));return this.withToken(g,E=>m.provideTextSearchResults(P,a,u,E))}else return this.withToken(g,a=>m.provideTextSearchResults(P,s,C,a))}async withToken(P,s){const C=k(P);this.inProgress.add(C);const g=await s(C.token);return this.inProgress.delete(C),g}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=y;function k(D){const P=new _.CancellationTokenSource;return D.onCancellationRequested(()=>P.cancel()),P}}),define(ge[278],pe([0,1,26,130,129]),function(K,e,_,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(D){this.query=D}search(D,P,s){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(m){s({message:m})}},g=new T.NativeTextSearchManager(this.query,new I.RipgrepTextSearchEngine(C),_);return new Promise((m,a)=>g.search(u=>{P(u.map(y))},D).then(u=>m({limitHit:u.limitHit,type:"success"}),a))}}e.TextSearchEngineAdapter=A;function y(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((D,P)=>{if(P.ranges){const s=P;return D+(Array.isArray(s.ranges)?s.ranges.length:1)}else return D+1},0)}}}),define(ge[279],pe([0,1,37,292,19,15,18,3,100,8,47,2,45,31,276,278]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,I.gracefulify(_);class E{constructor(){this.caches=Object.create(null)}fileSearch(t){let n;const r=d(t),i=new k.Emitter({onFirstListenerDidAdd:()=>{n=(0,A.createCancelablePromise)(o=>this.doFileSearchWithEngine(a.Engine,r,c=>i.fire(c),o)),n.then(o=>i.fire(o),o=>i.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return i.event}textSearch(t){let n;const r=d(t),i=new k.Emitter({onFirstListenerDidAdd:()=>{n=(0,A.createCancelablePromise)(o=>this.ripgrepTextSearch(r,c=>i.fire(c),o)),n.then(o=>i.fire(o),o=>i.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return i.event}ripgrepTextSearch(t,n,r){return t.maxFileSize=(0,g.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new u.TextSearchEngineAdapter(t).search(r,n,n)}doFileSearch(t,n,r){return this.doFileSearchWithEngine(a.Engine,t,n,r)}doFileSearchWithEngine(t,n,r,i,o=E.BATCH_SIZE){let c=0;const v=h=>{Array.isArray(h)?(c+=h.length,r(h.map(b=>this.rawMatchToSearchItem(b)))):h.relativePath?(c++,r(this.rawMatchToSearchItem(h))):r(h)};if(n.sortByScore){let h=this.trySortedSearchFromCache(n,v,i);if(!h){const b=n.maxResults?Object.assign({},n,{maxResults:null}):n,R=new t(b);h=this.doSortedSearch(R,n,r,v,i)}return new Promise((b,R)=>{h.then(([N,j])=>{const oe=j.map(q=>this.rawMatchToSearchItem(q));this.sendProgress(oe,r,o),b(N)},R)})}const p=new t(n);return this.doSearch(p,v,o,i).then(h=>({limitHit:h.limitHit,type:"success",stats:{detailStats:h.stats,type:"searchProcess",fromCache:!1,resultCount:c,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,P.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,n,r,i,o){const c=new k.Emitter;let v=(0,A.createCancelablePromise)(h=>{let b=[];const R=N=>{Array.isArray(N)?b=N:(i(N),c.fire(N))};return this.doSearch(t,R,-1,h).then(N=>[N,b])}),p;if(n.cacheKey){p=this.getOrCreateCache(n.cacheKey);const h={promise:v,event:c.event,resolved:!1};p.resultsToSearchCache[n.filePattern||""]=h,v.then(()=>{h.resolved=!0},b=>{delete p.resultsToSearchCache[n.filePattern||""]}),v=this.preventCancellation(v)}return v.then(([h,b])=>{const R=p?p.scorerCache:Object.create(null),N=(typeof n.maxResults!="number"||n.maxResults>0)&&s.StopWatch.create(!1);return this.sortResults(n,b,R,o).then(j=>{const oe=N?N.elapsed():-1;return[{type:"success",stats:{detailStats:h.stats,sortingTime:oe,fromCache:!1,type:"searchProcess",workspaceFolderCount:n.folderQueries.length,resultCount:j.length},messages:h.messages,limitHit:h.limitHit||typeof n.maxResults=="number"&&b.length>n.maxResults},j]})})}getOrCreateCache(t){const n=this.caches[t];return n||(this.caches[t]=new w)}trySortedSearchFromCache(t,n,r){const i=t.cacheKey&&this.caches[t.cacheKey];if(!!i){const o=this.getResultsFromCache(i,t.filePattern||"",n,r);if(o)return o.then(([c,v,p])=>{const h=s.StopWatch.create(!1);return this.sortResults(t,v,i.scorerCache,r).then(b=>{const R=h.elapsed(),N={fromCache:!0,detailStats:p,type:"searchProcess",resultCount:v.length,sortingTime:R};return[{type:"success",limitHit:c.limitHit||typeof t.maxResults=="number"&&v.length>t.maxResults,stats:N},b]})})}}sortResults(t,n,r,i){const o=(0,D.prepareQuery)(t.filePattern||""),c=(p,h)=>(0,D.compareItemsByFuzzyScore)(p,h,o,!0,S,r),v=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return T.topAsync(n,c,v,1e4,i)}sendProgress(t,n,r){if(r&&r>0)for(let i=0;i<t.length;i+=r)n(t.slice(i,i+r));else n(t)}getResultsFromCache(t,n,r,i){const o=s.StopWatch.create(!1),c=n.indexOf(P.sep)>=0;let v;for(const R in t.resultsToSearchCache)if(n.startsWith(R)){if(c&&R.indexOf(P.sep)<0&&R!=="")continue;const N=t.resultsToSearchCache[R];v={promise:this.preventCancellation(N.promise),event:N.event,resolved:N.resolved};break}if(!v)return null;const p=o.elapsed(),h=s.StopWatch.create(!1),b=v.event(r);return i&&i.onCancellationRequested(()=>{b.dispose()}),v.promise.then(([R,N])=>{if(i&&i.isCancellationRequested)throw(0,y.canceled)();const j=[],oe=(0,D.prepareQuery)(n).normalizedLowercase;for(const q of N)!(0,m.isFilePatternMatch)(q,oe)||j.push(q);return[R,j,{cacheWasResolved:v.resolved,cacheLookupTime:p,cacheFilterTime:h.elapsed(),cacheEntryCount:N.length}]})}doSearch(t,n,r,i){return new Promise((o,c)=>{let v=[];i&&i.onCancellationRequested(()=>t.cancel()),t.search(p=>{p&&(r?(v.push(p),r>0&&v.length>=r&&(n(v),v=[])):n(p))},p=>{n(p)},(p,h)=>{v.length&&n(v),p?c(p):o(h)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(n,r){return t.then(n,r)}catch(n){return this.then(void 0,n)}finally(n){return t.finally(n)}}}}e.SearchService=E,E.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const S=new class{getItemLabel(f){return(0,P.basename)(f.relativePath)}getItemDescription(f){return(0,P.dirname)(f.relativePath)}getItemPath(f){return f.relativePath}};function d(f){return Object.assign(Object.assign({},f),{folderQueries:f.folderQueries&&f.folderQueries.map(l),extraFileResources:f.extraFileResources&&f.extraFileResources.map(t=>C.URI.revive(t))})}function l(f){return Object.assign(Object.assign({},f),{folder:C.URI.revive(f.folder)})}}),define(ge[280],pe([0,1,6,2,26,13,31,279,277,94,14,62,27,69,12,129]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let E=class extends m.ExtHostSearch{constructor(S,d,l,f){super(S,l,f);this._pfs=T,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new P.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(a.Schemas.userData,new D.RipgrepSearchProvider(t)),d.remote.isRemote&&d.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const S=new P.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(a.Schemas.file,new D.RipgrepSearchProvider(S)),this.registerInternalFileSearchProvider(a.Schemas.file,new k.SearchService)}registerInternalFileSearchProvider(S,d){const l=this._handlePool++;return this._internalFileSearchProvider=d,this._internalFileSearchHandle=l,this._proxy.$registerFileSearchProvider(l,this._transformScheme(S)),(0,_.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(l)})}$provideFileSearchResults(S,d,l,f){const t=(0,m.reviveQuery)(l);return S===this._internalFileSearchHandle?this.doInternalFileSearch(S,d,t,f):super.$provideFileSearchResults(S,d,l,f)}doInternalFileSearch(S,d,l,f){const t=n=>{if((0,y.isSerializedFileMatch)(n)&&(n=[n]),Array.isArray(n)){this._proxy.$handleFileMatch(S,d,n.map(r=>I.URI.file(r.path)));return}n.message&&this._logService.debug("ExtHostSearch",n.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(l,t,f)}$clearCache(S){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(S),super.$clearCache(S)}createTextSearchManager(S,d){return new u.NativeTextSearchManager(S,d)}};E=Ve([xe(0,s.IExtHostRpcService),xe(1,g.IExtHostInitDataService),xe(2,C.IURITransformerService),xe(3,A.ILogService)],E),e.NativeExtHostSearch=E}),define(ge[131],pe([0,1,293,122,294,3,105,8,48,30,6,22,106,18,10]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class u{constructor(v){this.socket=v,this._errorListener=p=>{if(p){if(p.code==="EPIPE")return;(0,m.onUnexpectedError)(p)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(v){const p=h=>v(C.VSBuffer.wrap(h));return this.socket.on("data",p),{dispose:()=>this.socket.off("data",p)}}onClose(v){return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(v){return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(v){if(!this.socket.destroyed)try{this.socket.write(v.buffer,p=>{if(p){if(p.code==="EPIPE")return;(0,m.onUnexpectedError)(p)}})}catch(p){if(p.code==="EPIPE")return;(0,m.onUnexpectedError)(p)}}end(){this.socket.end()}drain(){return new Promise((v,p)=>{if(this.socket.bufferSize===0){v();return}const h=()=>{this.socket.off("close",h),this.socket.off("end",h),this.socket.off("error",h),this.socket.off("timeout",h),this.socket.off("drain",h),v()};this.socket.on("close",h),this.socket.on("end",h),this.socket.on("error",h),this.socket.on("timeout",h),this.socket.on("drain",h)})}}e.NodeSocket=u;var E;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var w;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(w||(w={}));class S extends s.Disposable{constructor(v,p,h,b){super();this._onDidZlibFlush=this._register(new A.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new A.Emitter),this._onClose=this._register(new A.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=v,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=p,this._recordInflateBytes=b,p?(this._zlibInflate=T.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",R=>{console.error(R),(0,m.onUnexpectedError)(R),this._onClose.fire()}),this._zlibInflate.on("data",R=>{this._pendingInflateData.push(R)}),h&&(this._zlibInflate.write(h.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=T.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",R=>{console.error(R),(0,m.onUnexpectedError)(R),this._onClose.fire()}),this._zlibDeflate.on("data",R=>{this._pendingDeflateData.push(R)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new g.ChunkStream,this._register(this.socket.onData(R=>this._acceptChunk(R))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this._onData.event(v)}onClose(v){return this._onClose.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){this._totalOutgoingDataBytes+=v.byteLength,this._zlibDeflate?(this._zlibDeflate.write(v.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let p=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,p=p.slice(0,p.length-4),this._isEnded||this._write(C.VSBuffer.wrap(p),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(v,!1)}_write(v,p){let h=2;v.byteLength<126?h+=0:v.byteLength<2**16?h+=2:h+=8;const b=C.VSBuffer.alloc(h);if(p?b.writeUInt8(194,0):b.writeUInt8(130,0),v.byteLength<126)b.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){b.writeUInt8(126,1);let R=1;b.writeUInt8(v.byteLength>>>8&255,++R),b.writeUInt8(v.byteLength>>>0&255,++R)}else{b.writeUInt8(127,1);let R=1;b.writeUInt8(0,++R),b.writeUInt8(0,++R),b.writeUInt8(0,++R),b.writeUInt8(0,++R),b.writeUInt8(v.byteLength>>>24&255,++R),b.writeUInt8(v.byteLength>>>16&255,++R),b.writeUInt8(v.byteLength>>>8&255,++R),b.writeUInt8(v.byteLength>>>0&255,++R)}this._totalOutgoingWireBytes+=b.byteLength+v.byteLength,this.socket.write(C.VSBuffer.concat([b,v]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(v){if(v.byteLength!==0){for(this._totalIncomingWireBytes+=v.byteLength,this._incomingData.acceptChunk(v);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const p=this._incomingData.peek(this._state.readLen),b=(p.readUInt8(0)&128)>>>7,R=p.readUInt8(1),N=(R&128)>>>7,j=R&127;this._state.state=2,this._state.readLen=2+(N?4:0)+(j===126?2:0)+(j===127?8:0),this._state.fin=b,this._state.mask=0}else if(this._state.state===2){const p=this._incomingData.read(this._state.readLen),h=p.readUInt8(1),b=(h&128)>>>7;let R=h&127,N=1;R===126?R=p.readUInt8(++N)*2**8+p.readUInt8(++N):R===127&&(R=p.readUInt8(++N)*0+p.readUInt8(++N)*0+p.readUInt8(++N)*0+p.readUInt8(++N)*0+p.readUInt8(++N)*2**24+p.readUInt8(++N)*2**16+p.readUInt8(++N)*2**8+p.readUInt8(++N));let j=0;b&&(j=p.readUInt8(++N)*2**24+p.readUInt8(++N)*2**16+p.readUInt8(++N)*2**8+p.readUInt8(++N)),this._state.state=3,this._state.readLen=R,this._state.mask=j}else if(this._state.state===3){const p=this._incomingData.read(this._state.readLen);d(p,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(p.buffer)),this._zlibInflate.write(p.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const h=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=h.length,this._onData.fire(C.VSBuffer.wrap(h))})):(this._totalIncomingDataBytes+=p.byteLength,this._onData.fire(p))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await A.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=S;function d(c,v){if(v!==0){let p=c.byteLength>>>2;for(let oe=0;oe<p;oe++){const q=c.readUInt32BE(oe*4);c.writeUInt32BE(q^v,oe*4)}let h=p*4,b=c.byteLength-h;const R=v>>>24&255,N=v>>>16&255,j=v>>>8&255;b>=1&&c.writeUInt8(c.readUInt8(h)^R,h),b>=2&&c.writeUInt8(c.readUInt8(h+1)^N,h+1),b>=3&&c.writeUInt8(c.readUInt8(h+2)^j,h+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function f(){const c=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let v;return e.XDG_RUNTIME_DIR?v=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):v=(0,k.join)((0,D.tmpdir)(),`vscode-ipc-${c}.sock`),n(v),v}e.createRandomIPCHandle=f;function t(c,v,p){const h=(0,_.createHash)("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${h}-${p}-${v}-sock`;let b;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?b=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-${h.substr(0,8)}-${p}-${v}.sock`):b=(0,k.join)(c,`${p}-${v}.sock`),n(b),b}e.createStaticIPCHandle=t;function n(c){const v=l[a.platform];typeof v=="number"&&c.length>=v&&console.warn(`WARNING: IPC handle "${c}" is longer than ${v} chars, try a shorter --user-data-dir`)}class r extends y.IPCServer{constructor(v){super(r.toClientConnectionEvent(v));this.server=v}static toClientConnectionEvent(v){const p=A.Event.fromNodeEventEmitter(v,"connection");return A.Event.map(p,h=>({protocol:new g.Protocol(new u(h)),onDidClientDisconnect:A.Event.once(A.Event.fromNodeEventEmitter(h,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function i(c){return new Promise((v,p)=>{const h=(0,I.createServer)();h.on("error",p),h.listen(c,()=>{h.removeListener("error",p),v(new r(h))})})}e.serve=i;function o(c,v){return new Promise((p,h)=>{const b=(0,I.createConnection)(c,()=>{b.removeListener("error",h),p(g.Client.fromSocket(new u(b),v))});b.once("error",h)})}e.connect=o}),define(ge[281],pe([0,1,131,273,37,51,2,118,13]),function(K,e,_,I,T,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(g,m,a){this._commands=g,this.logService=m,this._ipcHandlePath=a,this._server=I.createServer((u,E)=>this.onRequest(u,E)),this.setup().catch(u=>(m.error(u),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",g=>this.logService.error(g))}catch(g){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(g,m){const a=[];g.setEncoding("utf8"),g.on("data",u=>a.push(u)),g.on("end",()=>{const u=JSON.parse(a.join(""));switch(u.type){case"open":this.open(u,m);break;case"openExternal":this.openExternal(u,m);break;case"status":this.getStatus(u,m);break;case"extensionManagement":this.manageExtensions(u,m).catch(this.logService.error);break;default:m.writeHead(404),m.write(`Unknown message type: ${u.type}`,E=>{E&&this.logService.error(E)}),m.end();break}})}open(g,m){let{fileURIs:a,folderURIs:u,forceNewWindow:E,diffMode:w,addMode:S,forceReuseWindow:d,gotoLineMode:l,waitMarkerFilePath:f}=g;const t=[];if(Array.isArray(u))for(const n of u)try{t.push({folderUri:y.URI.parse(n)})}catch(r){}if(Array.isArray(a))for(const n of a)try{(0,k.hasWorkspaceFileExtension)(n)?t.push({workspaceUri:y.URI.parse(n)}):t.push({fileUri:y.URI.parse(n)})}catch(r){}if(t.length){const n=f?y.URI.file(f):void 0,i={forceNewWindow:E,diffMode:w,addMode:S,gotoLineMode:l,forceReuseWindow:d,preferNewWindow:!d&&!n&&!S,waitMarkerFileURI:n};this._commands.executeCommand("_remoteCLI.windowOpen",t,i)}m.writeHead(200),m.end()}async openExternal(g,m){for(const a of g.uris){const u=y.URI.parse(a),E=u.scheme==="file"?u:a;await this._commands.executeCommand("_remoteCLI.openExternal",E)}m.writeHead(200),m.end()}async manageExtensions(g,m){try{const a=w=>w==null?void 0:w.map(S=>/\.vsix$/i.test(S)?y.URI.parse(S):S),u={list:g.list,install:a(g.install),uninstall:a(g.uninstall),force:g.force},E=await this._commands.executeCommand("_remoteCLI.manageExtensions",u);m.writeHead(200),m.write(E)}catch(a){m.writeHead(500),m.write(String(a),u=>{u&&this.logService.error(u)})}m.end()}async getStatus(g,m){try{const a=await this._commands.executeCommand("_remoteCLI.getSystemStatus");m.writeHead(200),m.write(a),m.end()}catch(a){m.writeHead(500),m.write(String(a),u=>{u&&this.logService.error(u)}),m.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&T.existsSync(this._ipcHandlePath)&&T.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let s=class extends P{constructor(g,m){super(g,m,(0,_.createRandomIPCHandle)())}};s=Ve([xe(0,A.IExtHostCommands),xe(1,D.ILogService)],s),e.CLIServer=s}),define(ge[282],pe([0,1,68,269,263,5,272,42,254,2,12,7,281,103]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class a extends T.RequireInterceptor{_installInterceptor(){const w=this,S=K.__$__nodeRequire("module"),d=S._load;S._load=function(f,t,n){for(let r of w._alternatives){let i=r(f);if(i){f=i;break}}return w._factories.has(f)?w._factories.get(f).load(f,P.URI.file((0,m.realpathSync)(t.filename)),r=>d.apply(this,[r,t,n])):d.apply(this,arguments)}}}class u extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=C.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const w=this._instaService.invokeFunction(I.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(g.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(a,w,this._registry).install(),_.mark("code/extHost/didInitAPI");const d=await this._extHostConfiguration.getConfigProvider();await(0,y.connectProxyResolver)(this._extHostWorkspace,d,this,this._logService,this._mainThreadTelemetryProxy,this._initData),_.mark("code/extHost/didInitProxyResolver");const l=process.send,f=this._extHostContext.getProxy(A.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?l.apply(process,t):(f.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(w){return w.main}_loadCommonJSModule(w,S,d){if(S.scheme!==s.Schemas.file)throw new Error(`Cannot load URI: '${S}', must be of file-scheme`);let l=null;d.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${S.toString(!0)}`),this._logService.flush();try{w&&_.mark(`code/extHost/willLoadExtensionCode/${w.value}`),l=K.__$__nodeRequire(S.fsPath)}catch(f){return Promise.reject(f)}finally{w&&_.mark(`code/extHost/didLoadExtensionCode/${w.value}`),d.codeLoadingStop()}return Promise.resolve(l)}async $setRemoteEnvironment(w){if(!!this._initData.remote.isRemote)for(const S in w){const d=w[S];d===null?delete process.env[S]:process.env[S]=d}}}e.ExtHostExtensionService=u}),define(ge[283],pe([0,1,79,255,266,265,264,280,282,226,256,46,42,64,69,67,34,50,13]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a,u,E,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.registerSingleton)(g.IExtHostExtensionService,D.ExtHostExtensionService),(0,_.registerSingleton)(S.ILogService,P.ExtHostLogService),(0,_.registerSingleton)(C.IExtHostDebugService,y.ExtHostDebugService),(0,_.registerSingleton)(m.IExtHostOutputService,I.ExtHostOutputService2),(0,_.registerSingleton)(a.IExtHostSearch,k.NativeExtHostSearch),(0,_.registerSingleton)(u.IExtHostTask,A.ExtHostTask),(0,_.registerSingleton)(E.IExtHostTerminalService,T.ExtHostTerminalService),(0,_.registerSingleton)(w.IExtHostTunnelService,s.ExtHostTunnelService)}),define(ge[284],pe([0,1,122,295,68,18,106,131,187,224,267,22,101,26,103,15,270,283]),function(K,e,_,I,T,A,y,k,D,P,s,C,g,m,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let i=0;i<process.execArgv.length;i++)process.execArgv[i]==="--inspect-port=0"&&(process.execArgv.splice(i,1),i--)}();const E=I(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const r=K.__$__nodeRequire("module"),i=r._load;r._load=function(o){if(o==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return i.apply(this,arguments)}})();const w=process.exit.bind(process);function S(r){process.exit=function(i){if(r)w(i);else{const o=new Error("An extension called process.exit() and this was prevented.");console.warn(o.stack)}},process.crash=function(){const i=new Error("An extension called process.crash() and this was prevented.");console.warn(i.stack)}}let d=function(r){w()};function l(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((r,i)=>{let o=null,c=setTimeout(()=>{i(new Error("VSCODE_EXTHOST_IPC_SOCKET timeout"))},6e4);const v=108e5,p=3e5,h=new u.RunOnceScheduler(()=>d("renderer disconnected for too long (1)"),v),b=new u.RunOnceScheduler(()=>d("renderer disconnected for too long (2)"),p);process.on("message",(N,j)=>{if(N&&N.type==="VSCODE_EXTHOST_IPC_SOCKET"){const oe=C.VSBuffer.wrap(Buffer.from(N.initialDataChunk,"base64"));let q;if(N.skipWebSocketFrames)q=new k.NodeSocket(j);else{const W=C.VSBuffer.wrap(Buffer.from(N.inflateBytes,"base64"));q=new k.WebSocketNodeSocket(new k.NodeSocket(j),N.permessageDeflate,W,!1)}o?(h.cancel(),b.cancel(),o.beginAcceptReconnection(q,oe),o.endAcceptReconnection()):(clearTimeout(c),o=new y.PersistentProtocol(q,oe),o.onDidDispose(()=>d("renderer disconnected")),r(o),o.onSocketClose(()=>{h.schedule()}))}if(N&&N.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(b.isScheduled())return;h.isScheduled()&&b.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const r=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((i,o)=>{const c=_.createConnection(r,()=>{c.removeListener("error",o),i(new y.PersistentProtocol(new k.NodeSocket(c)))});c.once("error",o)})}}async function f(){const r=await l();return new class{constructor(){this._onMessage=new y.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,r.onMessage(i=>{(0,P.isMessageOfType)(i,2)?(this._terminating=!0,d("received terminate message from renderer")):this._onMessage.fire(i)})}send(i){this._terminating||r.send(i)}drain(){return r.drain()}}}function t(r){return new Promise(i=>{const o=r.onMessage(c=>{o.dispose();const v=JSON.parse(c.toString()),p=v.commit,h=D.default.commit;p&&h&&p!==h&&w(55);const b=[];process.on("unhandledRejection",(j,oe)=>{b.push(oe),setTimeout(()=>{const q=b.indexOf(oe);q>=0&&oe.catch(W=>{b.splice(q,1),console.warn(`rejected promise not handled within 1 second: ${W}`),W&&W.stack&&console.warn(`stack trace: ${W.stack}`),(0,A.onUnexpectedError)(j)})},1e3)}),process.on("rejectionHandled",j=>{const oe=b.indexOf(j);oe>=0&&b.splice(oe,1)}),process.on("uncaughtException",function(j){(0,A.onUnexpectedError)(j)});let R=0;setInterval(function(){try{process.kill(v.parentPid,0),R=0}catch(j){j&&j.code==="EPERM"?(R++,R>=3&&d(`parent process ${v.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):d(`parent process ${v.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let N;try{N=K.__$__nodeRequire("native-watchdog"),N.start(v.parentPid)}catch(j){(0,A.onUnexpectedError)(j)}r.send((0,P.createMessageOfType)(0)),i({protocol:r,initData:v})});r.send((0,P.createMessageOfType)(1))})}async function n(){T.mark("code/extHost/willConnectToRenderer");const r=await f();T.mark("code/extHost/didConnectToRenderer");const i=await t(r);T.mark("code/extHost/didWaitForInitData");const{initData:o}=i;S(!!o.environment.extensionTestsLocationURI),o.environment.useHostProxy=E.useHostProxy!==void 0?E.useHostProxy!=="false":void 0;const c=new class{exit(b){w(b)}exists(b){return(0,m.exists)(b)}realpath(b){return(0,a.realpath)(b)}};let v=null;if(o.remote.authority&&E.uriTransformerPath)try{const b=K.__$__nodeRequire(E.uriTransformerPath)(o.remote.authority);v=new g.URITransformer(b)}catch(h){console.error(h)}const p=new s.ExtensionHostMain(i.protocol,o,c,v);d=h=>p.terminate(h)}e.startExtensionHostProcess=n}),define(ge[296],pe([0,1,284]),function(K,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,_.startExtensionHostProcess)().catch(I=>console.log(I))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7ce1499d9541ba2acf66cd30a9054bd7818a8f80/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
