/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/async","vs/base/common/errors","vs/base/common/path","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/network","vs/platform/log/common/log","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/base/common/uuid","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/process","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(Q){for(var e=[],w=0,I=Q.length;w<I;w++)e[w]=be[Q[w]];return e};define(be[42],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function w(I,A){if(!I)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=w}),define(be[51],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const w=Object.prototype.hasOwnProperty;function I(i){const P=[];for(let c in i)w.call(i,c)&&P.push(i[c]);return P}e.values=I;function A(i,P){for(let c in i)if(w.call(i,c)&&P({key:c,value:i[c]},function(){delete i[c]})===!1)return}e.forEach=A;function T(i,P){const c=Object.create(null);for(const d of i){const o=P(d);let l=c[o];l||(l=c[o]=[]),l.push(d)}return c}e.groupBy=T;function y(i){const P=Object.create(null);return i&&i.forEach((c,d)=>{P[d]=c}),P}e.fromMap=y;function C(i,P){const c=[],d=[];for(let o of i)P.has(o)||c.push(o);for(let o of P)i.has(o)||d.push(o);return{removed:c,added:d}}e.diffSets=C;function S(i,P){const c=[],d=[];for(let[o,l]of i)P.has(o)||c.push(l);for(let[o,l]of P)i.has(o)||d.push(l);return{removed:c,added:d}}e.diffMaps=S;class k{constructor(){this.map=new Map}add(P,c){let d=this.map.get(P);d||(d=new Set,this.map.set(P,d)),d.add(c)}delete(P,c){const d=this.map.get(P);!d||(d.delete(c),d.size===0&&this.map.delete(P))}forEach(P,c){const d=this.map.get(P);!d||d.forEach(c)}}e.SetMap=k}),define(be[52],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function w(S){return(k,i,P)=>{let c=null,d=null;if(typeof P.value=="function"?(c="value",d=P.value):typeof P.get=="function"&&(c="get",d=P.get),!d)throw new Error("not supported");P[c]=S(d,i)}}e.createDecorator=w;let I=0;function A(){const S=`$memoize${I++}`;let k;const i=function(c,d,o){let l=null,g=null;if(typeof o.value=="function"?(l="value",g=o.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof o.get=="function"&&(l="get",g=o.get),!g)throw new Error("not supported");const m=`${S}:${d}`;o[l]=function(...D){return k=this,this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!0,enumerable:!1,writable:!0,value:g.apply(this,D)}),this[m]}};return i.clear=()=>{typeof k!="undefined"&&Object.getOwnPropertyNames(k).forEach(P=>{P.indexOf(S)===0&&delete k[P]})},i}e.createMemoizer=A;function T(S,k,i){return A()(S,k,i)}e.memoize=T;function y(S,k,i){return w((P,c)=>{const d=`$debounce$${c}`,o=`$debounce$result$${c}`;return function(...l){this[o]||(this[o]=i?i():void 0),clearTimeout(this[d]),k&&(this[o]=k(this[o],...l),l=[this[o]]),this[d]=setTimeout(()=>{P.apply(this,l),this[o]=i?i():void 0},S)}})}e.debounce=y;function C(S,k,i){return w((P,c)=>{const d=`$throttle$timer$${c}`,o=`$throttle$result$${c}`,l=`$throttle$lastRun$${c}`,g=`$throttle$pending$${c}`;return function(...m){if(this[o]||(this[o]=i?i():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),k&&(this[o]=k(this[o],...m)),!this[g]){const D=this[l]+S;D<=Date.now()?(this[l]=Date.now(),P.apply(this,[this[o]]),this[o]=i?i():void 0):(this[g]=!0,this[d]=setTimeout(()=>{this[g]=!1,this[l]=Date.now(),P.apply(this,[this[o]]),this[o]=i?i():void 0},D-Date.now()))}}})}e.throttle=C}),define(be[12],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=w,e.errorHandler=new w;function I(p){e.errorHandler.setUnexpectedErrorHandler(p)}e.setUnexpectedErrorHandler=I;function A(p){S(p)||e.errorHandler.onUnexpectedError(p)}e.onUnexpectedError=A;function T(p){S(p)||e.errorHandler.onUnexpectedExternalError(p)}e.onUnexpectedExternalError=T;function y(p){if(p instanceof Error){let{name:t,message:n}=p;const s=p.stacktrace||p.stack;return{$isError:!0,name:t,message:n,stack:s}}return p}e.transformErrorForSerialization=y;const C="Canceled";function S(p){return p instanceof Error&&p.name===C&&p.message===C}e.isPromiseCanceledError=S;class k extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=k;function i(){const p=new Error(C);return p.name=p.message,p}e.canceled=i;function P(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}e.illegalArgument=P;function c(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}e.illegalState=c;function d(p){return p?new Error(`readonly property '${p} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=d;function o(p){const t=new Error(`${p} has been disposed`);return t.name="DISPOSED",t}e.disposed=o;function l(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}e.getErrorMessage=l;class g extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=g;class m extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=m;class D extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=D;function f(p){const t=p;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=f;function u(p,t=Object.create(null)){const n=new Error(p);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=u}),define(be[15],_e([0,1,12]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function I($,R=0){return $[$.length-(1+R)]}e.tail=I;function A($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=A;function T($,R,M=(x,O)=>x===O){if($===R)return!0;if(!$||!R||$.length!==R.length)return!1;for(let x=0,O=$.length;x<O;x++)if(!M($[x],R[x]))return!1;return!0}e.equals=T;function y($,R,M){let x=0,O=$.length-1;for(;x<=O;){const G=(x+O)/2|0,Y=M($[G],R);if(Y<0)x=G+1;else if(Y>0)O=G-1;else return G}return-(x+1)}e.binarySearch=y;function C($,R){let M=0,x=$.length;if(x===0)return 0;for(;M<x;){const O=Math.floor((M+x)/2);R($[O])?x=O:M=O+1}return M}e.findFirstInSorted=C;function S($,R,M){if($=$|0,$>=R.length)throw new TypeError("invalid index");let x=R[Math.floor(R.length*Math.random())],O=[],G=[],Y=[];for(let ne of R){const pe=M(ne,x);pe<0?O.push(ne):pe>0?G.push(ne):Y.push(ne)}return $<O.length?S($,O,M):$<O.length+Y.length?Y[0]:S($-(O.length+Y.length),G,M)}e.quickSelect=S;function k($,R){const M=[];let x;for(const O of $.slice(0).sort(R))!x||R(x[0],O)!==0?(x=[O],M.push(x)):x.push(O);return M}e.groupBy=k;function i($,R,M){const x=[];function O(ne,pe,Ie){if(!(pe===0&&Ie.length===0)){const Oe=x[x.length-1];Oe&&Oe.start+Oe.deleteCount===ne?(Oe.deleteCount+=pe,Oe.toInsert.push(...Ie)):x.push({start:ne,deleteCount:pe,toInsert:Ie})}}let G=0,Y=0;for(;;){if(G===$.length){O(G,0,R.slice(Y));break}if(Y===R.length){O(G,$.length-G,[]);break}const ne=$[G],pe=R[Y],Ie=M(ne,pe);Ie===0?(G+=1,Y+=1):Ie<0?(O(G,1,[]),G+=1):Ie>0&&(O(G,0,[pe]),Y+=1)}return x}e.sortedDiff=i;function P($,R,M){const x=i($,R,M),O=[],G=[];for(const Y of x)O.push(...$.slice(Y.start,Y.start+Y.deleteCount)),G.push(...Y.toInsert);return{removed:O,added:G}}e.delta=P;function c($,R,M){if(M===0)return[];const x=$.slice(0,M).sort(R);return o($,R,x,M,$.length),x}e.top=c;function d($,R,M,x,O){return M===0?Promise.resolve([]):new Promise((G,Y)=>{(async()=>{const ne=$.length,pe=$.slice(0,M).sort(R);for(let Ie=M,Oe=Math.min(M+x,ne);Ie<ne;Ie=Oe,Oe=Math.min(Oe+x,ne)){if(Ie>M&&await new Promise(Te=>setTimeout(Te)),O&&O.isCancellationRequested)throw(0,w.canceled)();o($,R,pe,Ie,Oe)}return pe})().then(G,Y)})}e.topAsync=d;function o($,R,M,x,O){for(const G=M.length;x<O;x++){const Y=$[x];if(R(Y,M[G-1])<0){M.pop();const ne=C(M,pe=>R(Y,pe)<0);M.splice(ne,0,Y)}}}function l($){return $.filter(R=>!!R)}e.coalesce=l;function g($){let R=0;for(let M=0;M<$.length;M++)$[M]&&($[R]=$[M],R+=1);$.length=R}e.coalesceInPlace=g;function m($,R,M){$.splice(M,0,$.splice(R,1)[0])}e.move=m;function D($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=D;function f($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=f;function u($,R){if(!R)return $.filter((x,O)=>$.indexOf(x)===O);const M=Object.create(null);return $.filter(x=>{const O=R(x);return M[O]?!1:(M[O]=!0,!0)})}e.distinct=u;function p($){const R=new Set;return $.filter(M=>R.has(M)?!1:(R.add(M),!0))}e.distinctES6=p;function t($){const R=Object.create(null);return M=>{const x=$(M);return R[x]?!1:(R[x]=!0,!0)}}e.uniqueFilter=t;function n($,R){for(let M=$.length-1;M>=0;M--){const x=$[M];if(R(x))return M}return-1}e.lastIndex=n;function s($,R){return $.length>0?$[0]:R}e.firstOrDefault=s;function r($,R,M=(x,O)=>x===O){let x=0;for(let O=0,G=Math.min($.length,R.length);O<G&&M($[O],R[O]);O++)x++;return x}e.commonPrefixLength=r;function a($){return[].concat(...$)}e.flatten=a;function h($,R){let M=typeof R=="number"?$:0;typeof R=="number"?M=$:(M=0,R=$);const x=[];if(M<=R)for(let O=M;O<R;O++)x.push(O);else for(let O=M;O>R;O--)x.push(O);return x}e.range=h;function b($,R,M){return $.reduce((x,O)=>(x[R(O)]=M?M(O):O,x),Object.create(null))}e.index=b;function _($,R){return $.push(R),()=>v($,R)}e.insert=_;function v($,R){const M=$.indexOf(R);if(M>-1)return $.splice(M,1),R}e.remove=v;function E($,R,M){const x=$.slice(0,R),O=$.slice(R);return x.concat(M,O)}e.arrayInsert=E;function F($,R){let M;if(typeof R=="number"){let x=R;M=()=>{const O=Math.sin(x++)*179426549;return O-Math.floor(O)}}else M=Math.random;for(let x=$.length-1;x>0;x-=1){const O=Math.floor(M()*(x+1)),G=$[x];$[x]=$[O],$[O]=G}}e.shuffle=F;function U($,R){const M=$.indexOf(R);M>-1&&($.splice(M,1),$.unshift(R))}e.pushToStart=U;function J($,R){const M=$.indexOf(R);M>-1&&($.splice(M,1),$.push(R))}e.pushToEnd=J;function me($,R){return Array.isArray($)?$.map(R):R($)}e.mapArrayOrNot=me;function q($){return Array.isArray($)?$:[$]}e.asArray=q;function z($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=z;function ee($,R){for(const M of $){const x=R(M);if(x!==void 0)return x}}e.mapFind=ee}),define(be[53],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(I){const A=this;let T=!1,y;return function(){return T||(T=!0,y=I.apply(A,arguments)),y}}e.once=w}),define(be[54],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class w{constructor(A){this._prefix=A,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=w,e.defaultGenerator=new w("id#")}),define(be[43],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(I){function A(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}I.is=A;const T=Object.freeze([]);function y(){return T}I.empty=y;function*C(p){yield p}I.single=C;function S(p){return p||T}I.from=S;function k(p){return!p||p[Symbol.iterator]().next().done===!0}I.isEmpty=k;function i(p){return p[Symbol.iterator]().next().value}I.first=i;function P(p,t){for(const n of p)if(t(n))return!0;return!1}I.some=P;function c(p,t){for(const n of p)if(t(n))return n}I.find=c;function*d(p,t){for(const n of p)t(n)&&(yield n)}I.filter=d;function*o(p,t){for(const n of p)yield t(n)}I.map=o;function*l(...p){for(const t of p)for(const n of t)yield n}I.concat=l;function*g(p){for(const t of p)for(const n of t)yield n}I.concatNested=g;function m(p,t,n){let s=n;for(const r of p)s=t(s,r);return s}I.reduce=m;function*D(p,t,n=p.length){for(t<0&&(t+=p.length),n<0?n+=p.length:n>p.length&&(n=p.length);t<n;t++)yield p[t]}I.slice=D;function f(p,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,p];const s=p[Symbol.iterator]();for(let r=0;r<t;r++){const a=s.next();if(a.done)return[n,I.empty()];n.push(a.value)}return[n,{[Symbol.iterator](){return s}}]}I.consume=f;function u(p,t,n=(s,r)=>s===r){const s=p[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const a=s.next(),h=r.next();if(a.done!==h.done)return!1;if(a.done)return!0;if(!n(a.value,h.value))return!1}}I.equals=u})(w=e.Iterable||(e.Iterable={}))}),define(be[44],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var I;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function y(t,n=!1){let s=0,r=t.length,a="",h=0,b=16,_=0;function v(z){let ee=0,$=0;for(;ee<z;){const R=t.charCodeAt(s);if(R>=48&&R<=57)$=$*16+R-48;else if(R>=65&&R<=70)$=$*16+R-65+10;else if(R>=97&&R<=102)$=$*16+R-97+10;else break;s++,ee++}return ee<z&&($=-1),$}function E(z){s=z,a="",h=0,b=16,_=0}function F(){const z=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&k(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&k(t.charCodeAt(s)))for(s++;s<t.length&&k(t.charCodeAt(s));)s++;else return _=3,t.substring(z,s);let ee=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&k(t.charCodeAt(s))){for(s++;s<t.length&&k(t.charCodeAt(s));)s++;ee=s}else _=3;return t.substring(z,ee)}function U(){let z="",ee=s;for(;;){if(s>=r){z+=t.substring(ee,s),_=2;break}const $=t.charCodeAt(s);if($===34){z+=t.substring(ee,s),s++;break}if($===92){if(z+=t.substring(ee,s),s++,s>=r){_=2;break}switch(t.charCodeAt(s++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:const M=v(4);M>=0?z+=String.fromCharCode(M):_=4;break;default:_=5}ee=s;continue}if($>=0&&$<=31)if(S($)){z+=t.substring(ee,s),_=2;break}else _=6;s++}return z}function J(){if(a="",_=0,h=s,s>=r)return h=r,b=17;let z=t.charCodeAt(s);if(C(z)){do s++,a+=String.fromCharCode(z),z=t.charCodeAt(s);while(C(z));return b=15}if(S(z))return s++,a+=String.fromCharCode(z),z===13&&t.charCodeAt(s)===10&&(s++,a+=`
`),b=14;switch(z){case 123:return s++,b=1;case 125:return s++,b=2;case 91:return s++,b=3;case 93:return s++,b=4;case 58:return s++,b=6;case 44:return s++,b=5;case 34:return s++,a=U(),b=10;case 47:const ee=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<r&&!S(t.charCodeAt(s));)s++;return a=t.substring(ee,s),b=12}if(t.charCodeAt(s+1)===42){s+=2;const $=r-1;let R=!1;for(;s<$;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,R=!0;break}s++}return R||(s++,_=1),a=t.substring(ee,s),b=13}return a+=String.fromCharCode(z),s++,b=16;case 45:if(a+=String.fromCharCode(z),s++,s===r||!k(t.charCodeAt(s)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=F(),b=11;default:for(;s<r&&me(z);)s++,z=t.charCodeAt(s);if(h!==s){switch(a=t.substring(h,s),a){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return a+=String.fromCharCode(z),s++,b=16}}function me(z){if(C(z)||S(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let z;do z=J();while(z>=12&&z<=15);return z}return{setPosition:E,getPosition:()=>s,scan:n?q:J,getToken:()=>b,getTokenValue:()=>a,getTokenOffset:()=>h,getTokenLength:()=>s-h,getTokenError:()=>_}}e.createScanner=y;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function P(t,n){const s=[],r=new Object;let a;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function _(v,E,F,U){h.value=v,h.offset=E,h.length=F,h.type=U,h.colonOffset=void 0,a=h}try{f(t,{onObjectBegin:(v,E)=>{if(n<=v)throw r;a=void 0,b=n>v,s.push("")},onObjectProperty:(v,E,F)=>{if(n<E||(_(v,E,F,"property"),s[s.length-1]=v,n<=E+F))throw r},onObjectEnd:(v,E)=>{if(n<=v)throw r;a=void 0,s.pop()},onArrayBegin:(v,E)=>{if(n<=v)throw r;a=void 0,s.push(0)},onArrayEnd:(v,E)=>{if(n<=v)throw r;a=void 0,s.pop()},onLiteralValue:(v,E,F)=>{if(n<E||(_(v,E,F,p(v)),n<=E+F))throw r},onSeparator:(v,E,F)=>{if(n<=E)throw r;if(v===":"&&a&&a.type==="property")a.colonOffset=E,b=!1,a=void 0;else if(v===","){const U=s[s.length-1];typeof U=="number"?s[s.length-1]=U+1:(b=!0,s[s.length-1]=""),a=void 0}}})}catch(v){if(v!==r)throw v}return{path:s,previousNode:a,isAtPropertyKey:b,matches:v=>{let E=0;for(let F=0;E<v.length&&F<s.length;F++)if(v[E]===s[F]||v[E]==="*")E++;else if(v[E]!=="**")return!1;return E===v.length}}}e.getLocation=P;function c(t,n=[],s=T.DEFAULT){let r=null,a=[];const h=[];function b(v){Array.isArray(a)?a.push(v):r!==null&&(a[r]=v)}return f(t,{onObjectBegin:()=>{const v={};b(v),h.push(a),a=v,r=null},onObjectProperty:v=>{r=v},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{const v=[];b(v),h.push(a),a=v,r=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:b,onError:(v,E,F)=>{n.push({error:v,offset:E,length:F})}},s),a[0]}e.parse=c;function d(t,n=[],s=T.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(v){r.type==="property"&&(r.length=v-r.offset,r=r.parent)}function h(v){return r.children.push(v),v}f(t,{onObjectBegin:v=>{r=h({type:"object",offset:v,length:-1,parent:r,children:[]})},onObjectProperty:(v,E,F)=>{r=h({type:"property",offset:E,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:v,offset:E,length:F,parent:r})},onObjectEnd:(v,E)=>{r.length=v+E-r.offset,r=r.parent,a(v+E)},onArrayBegin:(v,E)=>{r=h({type:"array",offset:v,length:-1,parent:r,children:[]})},onArrayEnd:(v,E)=>{r.length=v+E-r.offset,r=r.parent,a(v+E)},onLiteralValue:(v,E,F)=>{h({type:p(v),offset:E,length:F,parent:r,value:v}),a(E+F)},onSeparator:(v,E,F)=>{r.type==="property"&&(v===":"?r.colonOffset=E:v===","&&a(E))},onError:(v,E,F)=>{n.push({error:v,offset:E,length:F})}},s);const _=r.children[0];return _&&delete _.parent,_}e.parseTree=d;function o(t,n){if(!!t){let s=t;for(let r of n)if(typeof r=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let a=!1;for(const h of s.children)if(Array.isArray(h.children)&&h.children[0].value===r){s=h.children[1],a=!0;break}if(!a)return}else{const a=r;if(s.type!=="array"||a<0||!Array.isArray(s.children)||a>=s.children.length)return;s=s.children[a]}return s}}e.findNodeAtLocation=o;function l(t){if(!t.parent||!t.parent.children)return[];const n=l(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;n.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&n.push(s)}return n}e.getNodePath=l;function g(t){switch(t.type){case"array":return t.children.map(g);case"object":const n=Object.create(null);for(let s of t.children){const r=s.children[1];r&&(n[s.children[0].value]=g(r))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=g;function m(t,n,s=!1){return n>=t.offset&&n<t.offset+t.length||s&&n===t.offset+t.length}e.contains=m;function D(t,n,s=!1){if(m(t,n,s)){const r=t.children;if(Array.isArray(r))for(let a=0;a<r.length&&r[a].offset<=n;a++){const h=D(r[a],n,s);if(h)return h}return t}}e.findNodeAtOffset=D;function f(t,n,s=T.DEFAULT){const r=y(t,!1);function a(pe){return pe?()=>pe(r.getTokenOffset(),r.getTokenLength()):()=>!0}function h(pe){return pe?Ie=>pe(Ie,r.getTokenOffset(),r.getTokenLength()):()=>!0}const b=a(n.onObjectBegin),_=h(n.onObjectProperty),v=a(n.onObjectEnd),E=a(n.onArrayBegin),F=a(n.onArrayEnd),U=h(n.onLiteralValue),J=h(n.onSeparator),me=a(n.onComment),q=h(n.onError),z=s&&s.disallowComments,ee=s&&s.allowTrailingComma;function $(){for(;;){const pe=r.scan();switch(r.getTokenError()){case 4:R(14);break;case 5:R(15);break;case 3:R(13);break;case 1:z||R(11);break;case 2:R(12);break;case 6:R(16);break}switch(pe){case 12:case 13:z?R(10):me();break;case 16:R(1);break;case 15:case 14:break;default:return pe}}}function R(pe,Ie=[],Oe=[]){if(q(pe),Ie.length+Oe.length>0){let Te=r.getToken();for(;Te!==17;){if(Ie.indexOf(Te)!==-1){$();break}else if(Oe.indexOf(Te)!==-1)break;Te=$()}}}function M(pe){const Ie=r.getTokenValue();return pe?U(Ie):_(Ie),$(),!0}function x(){switch(r.getToken()){case 11:let pe=0;try{pe=JSON.parse(r.getTokenValue()),typeof pe!="number"&&(R(2),pe=0)}catch(Ie){R(2)}U(pe);break;case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return $(),!0}function O(){return r.getToken()!==10?(R(3,[],[2,5]),!1):(M(!1),r.getToken()===6?(J(":"),$(),ne()||R(4,[],[2,5])):R(5,[],[2,5]),!0)}function G(){b(),$();let pe=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(pe||R(4,[],[]),J(","),$(),r.getToken()===2&&ee)break}else pe&&R(6,[],[]);O()||R(4,[],[2,5]),pe=!0}return v(),r.getToken()!==2?R(7,[2],[]):$(),!0}function Y(){E(),$();let pe=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(pe||R(4,[],[]),J(","),$(),r.getToken()===4&&ee)break}else pe&&R(6,[],[]);ne()||R(4,[],[4,5]),pe=!0}return F(),r.getToken()!==4?R(8,[4],[]):$(),!0}function ne(){switch(r.getToken()){case 3:return Y();case 1:return G();case 10:return M(!0);default:return x()}}return $(),r.getToken()===17?s.allowEmptyContent?!0:(R(4,[],[]),!1):ne()?(r.getToken()!==17&&R(9,[],[]),!0):(R(4,[],[]),!1)}e.visit=f;function u(t,n){let s=y(t),r=[],a,h=0,b;do switch(b=s.getPosition(),a=s.scan(),a){case 12:case 13:case 17:h!==b&&r.push(t.substring(h,b)),n!==void 0&&r.push(s.getTokenValue().replace(/[^\r\n]/g,n)),h=s.getPosition();break}while(a!==17);return r.join("")}e.stripComments=u;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(be[106],_e([0,1,44]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function I(S,k,i){let P,c,d,o,l;if(k){for(o=k.offset,l=o+k.length,d=o;d>0&&!C(S,d-1);)d--;let h=l;for(;h<S.length&&!C(S,h);)h++;c=S.substring(d,h),P=T(c,i)}else c=S,P=0,d=0,o=0,l=S.length;const g=y(i,S);let m=!1,D=0,f;i.insertSpaces?f=A(" ",i.tabSize||4):f="	";const u=(0,w.createScanner)(c,!1);let p=!1;function t(){return g+A(f,P+D)}function n(){let h=u.scan();for(m=!1;h===15||h===14;)m=m||h===14,h=u.scan();return p=h===16||u.getTokenError()!==0,h}const s=[];function r(h,b,_){!p&&b<l&&_>o&&S.substring(b,_)!==h&&s.push({offset:b,length:_-b,content:h})}let a=n();if(a!==17){const h=u.getTokenOffset()+d,b=A(f,P);r(b,d,h)}for(;a!==17;){let h=u.getTokenOffset()+u.getTokenLength()+d,b=n(),_="";for(;!m&&(b===12||b===13);){const E=u.getTokenOffset()+d;r(" ",h,E),h=u.getTokenOffset()+u.getTokenLength()+d,_=b===12?t():"",b=n()}if(b===2)a!==1&&(D--,_=t());else if(b===4)a!==3&&(D--,_=t());else{switch(a){case 3:case 1:D++,_=t();break;case 5:case 12:_=t();break;case 13:m?_=t():_=" ";break;case 6:_=" ";break;case 10:if(b===6){_="";break}case 7:case 8:case 9:case 11:case 2:case 4:b===12||b===13?_=" ":b!==5&&b!==17&&(p=!0);break;case 16:p=!0;break}m&&(b===12||b===13)&&(_=t())}const v=u.getTokenOffset()+d;r(_,h,v),a=b}return s}e.format=I;function A(S,k){let i="";for(let P=0;P<k;P++)i+=S;return i}function T(S,k){let i=0,P=0;const c=k.tabSize||4;for(;i<S.length;){const d=S.charAt(i);if(d===" ")P++;else if(d==="	")P+=c;else break;i++}return Math.floor(P/c)}function y(S,k){for(let i=0;i<k.length;i++){const P=k.charAt(i);if(P==="\r")return i+1<k.length&&k.charAt(i+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=y;function C(S,k){return`\r
`.indexOf(S.charAt(k))!==-1}e.isEOL=C}),define(be[107],_e([0,1,44,106]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(k,i,P){return T(k,i,void 0,P)}e.removeProperty=A;function T(k,i,P,c,d){const o=i.slice(),l=[],g=(0,w.parseTree)(k,l);let m,D;for(;o.length>0&&(D=o.pop(),m=(0,w.findNodeAtLocation)(g,o),m===void 0&&P!==void 0);)typeof D=="string"?P={[D]:P}:P=[P];if(m)if(m.type==="object"&&typeof D=="string"&&Array.isArray(m.children)){const f=(0,w.findNodeAtLocation)(m,[D]);if(f!==void 0)if(P===void 0){if(!f.parent)throw new Error("Malformed AST");const u=m.children.indexOf(f.parent);let p,t=f.parent.offset+f.parent.length;if(u>0){const n=m.children[u-1];p=n.offset+n.length}else p=m.offset+1,m.children.length>1&&(t=m.children[1].offset);return y(k,{offset:p,length:t-p,content:""},c)}else return y(k,{offset:f.offset,length:f.length,content:JSON.stringify(P)},c);else{if(P===void 0)return[];const u=`${JSON.stringify(D)}: ${JSON.stringify(P)}`,p=d?d(m.children.map(n=>n.children[0].value)):m.children.length;let t;if(p>0){const n=m.children[p-1];t={offset:n.offset+n.length,length:0,content:","+u}}else m.children.length===0?t={offset:m.offset+1,length:0,content:u}:t={offset:m.offset+1,length:0,content:u+","};return y(k,t,c)}}else if(m.type==="array"&&typeof D=="number"&&Array.isArray(m.children))if(P!==void 0){const f=`${JSON.stringify(P)}`;let u;if(m.children.length===0||D===0)u={offset:m.offset+1,length:0,content:m.children.length===0?f:f+","};else{const p=D===-1||D>m.children.length?m.children.length:D,t=m.children[p-1];u={offset:t.offset+t.length,length:0,content:","+f}}return y(k,u,c)}else{const f=D,u=m.children[f];let p;if(m.children.length===1)p={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===f){const t=m.children[f-1],n=t.offset+t.length,s=m.offset+m.length;p={offset:n,length:s-2-n,content:""}}else p={offset:u.offset,length:m.children[f+1].offset-u.offset,content:""};return y(k,p,c)}else throw new Error(`Can not add ${typeof D!="number"?"index":"property"} to parent of type ${m.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return y(k,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(P)},c)}}e.setProperty=T;function y(k,i,P){let c=C(k,i),d=i.offset,o=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;d>0&&!(0,I.isEOL)(c,d-1);)d--;for(;o<c.length&&!(0,I.isEOL)(c,o);)o++}const l=(0,I.format)(c,{offset:d,length:o-d},P);for(let m=l.length-1;m>=0;m--){const D=l[m];c=C(c,D),d=Math.min(d,D.offset),o=Math.max(o,D.offset+D.length),o+=D.content.length-D.length}const g=k.length-(c.length-o)-d;return[{offset:d,length:g,content:c.substring(d,o)}]}e.withFormatting=y;function C(k,i){return k.substring(0,i.offset)+i.content+k.substring(i.offset+i.length)}e.applyEdit=C;function S(k,i){let P=i.slice(0).sort((d,o)=>{const l=d.offset-o.offset;return l===0?d.length-o.length:l}),c=k.length;for(let d=P.length-1;d>=0;d--){let o=P[d];if(o.offset+o.length<=c)k=C(k,o);else throw new Error("Overlapping edit");c=o.offset}return k}e.applyEdits=S}),define(be[108],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class w{constructor(A){this.executor=A,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(A){return new w(()=>A(this.getValue()))}}e.Lazy=w}),define(be[6],_e([0,1,53,43]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let T=null;function y(f){T=f}if(e.setDisposableTracker=y,A){const f="__is_disposable_tracked__";T=new class{trackDisposable(u){const p=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[f]||console.log(p)},3e3)}markTracked(u){if(u&&u!==l.None)try{u[f]=!0}catch(p){}}}}function C(f){!T||T.markTracked(f)}function S(f){return T&&T.trackDisposable(f),f}e.trackDisposable=S;class k extends Error{constructor(u){super(`Encountered errors while disposing of store. Errors: [${u.join(", ")}]`);this.errors=u}}e.MultiDisposeError=k;function i(f){return typeof f.dispose=="function"&&f.dispose.length===0}e.isDisposable=i;function P(f){if(I.Iterable.is(f)){let u=[];for(const p of f)if(p){C(p);try{p.dispose()}catch(t){u.push(t)}}if(u.length===1)throw u[0];if(u.length>1)throw new k(u);return Array.isArray(f)?[]:f}else if(f)return C(f),f.dispose(),f}e.dispose=P;function c(...f){return f.forEach(C),d(()=>P(f))}e.combinedDisposable=c;function d(f){const u=S({dispose:()=>{C(u),f()}});return u}e.toDisposable=d;class o{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}clear(){try{P(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return C(u),this._isDisposed?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=o,o.DISABLE_DISPOSED_WARNING=!1;class l{constructor(){this._store=new o,S(this)}dispose(){C(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=l,l.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){var p;this._isDisposed||u===this._value||((p=this._value)===null||p===void 0||p.dispose(),u&&C(u),this._value=u)}clear(){this.value=void 0}dispose(){var u;this._isDisposed=!0,C(this),(u=this._value)===null||u===void 0||u.dispose(),this._value=void 0}}e.MutableDisposable=g;class m{constructor(){this.references=new Map}acquire(u,...p){let t=this.references.get(u);t||(t={counter:0,object:this.createReferencedObject(u,...p)},this.references.set(u,t));const{object:n}=t,s=(0,w.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(u,t.object),this.references.delete(u))});return t.counter++,{object:n,dispose:s}}}e.ReferenceCollection=m;class D{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=D}),define(be[45],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(T){this.element=T,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class I{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,y){const C=new w(T);if(this._first===w.Undefined)this._first=C,this._last=C;else if(y){const k=this._last;this._last=C,C.prev=k,k.next=C}else{const k=this._first;this._first=C,C.next=k,k.prev=C}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(C))}}shift(){if(this._first!==w.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==w.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==w.Undefined&&T.next!==w.Undefined){const y=T.prev;y.next=T.next,T.next.prev=y}else T.prev===w.Undefined&&T.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):T.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):T.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==w.Undefined;)yield T.element,T=T.next}}e.LinkedList=I}),function(Q,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Q=typeof globalThis!="undefined"?globalThis:Q||self,Q.marked=e())}(this,function(){"use strict";function Q(W,re){for(var ce=0;ce<re.length;ce++){var V=re[ce];V.enumerable=V.enumerable||!1,V.configurable=!0,"value"in V&&(V.writable=!0),Object.defineProperty(W,V.key,V)}}function e(W,re,ce){return re&&Q(W.prototype,re),ce&&Q(W,ce),W}function w(W,re){if(!!W){if(typeof W=="string")return I(W,re);var ce=Object.prototype.toString.call(W).slice(8,-1);if(ce==="Object"&&W.constructor&&(ce=W.constructor.name),ce==="Map"||ce==="Set")return Array.from(W);if(ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ce))return I(W,re)}}function I(W,re){(re==null||re>W.length)&&(re=W.length);for(var ce=0,V=new Array(re);ce<re;ce++)V[ce]=W[ce];return V}function A(W,re){var ce;if(typeof Symbol=="undefined"||W[Symbol.iterator]==null){if(Array.isArray(W)||(ce=w(W))||re&&W&&typeof W.length=="number"){ce&&(W=ce);var V=0;return function(){return V>=W.length?{done:!0}:{done:!1,value:W[V++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return ce=W[Symbol.iterator](),ce.next.bind(ce)}function T(W){var re={exports:{}};return W(re,re.exports),re.exports}var y=T(function(W){function re(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function ce(V){W.exports.defaults=V}W.exports={defaults:re(),getDefaults:re,changeDefaults:ce}}),C=/[&<>"']/,S=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,P={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},c=function(re){return P[re]};function d(W,re){if(re){if(C.test(W))return W.replace(S,c)}else if(k.test(W))return W.replace(i,c);return W}var o=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function l(W){return W.replace(o,function(re,ce){return ce=ce.toLowerCase(),ce==="colon"?":":ce.charAt(0)==="#"?ce.charAt(1)==="x"?String.fromCharCode(parseInt(ce.substring(2),16)):String.fromCharCode(+ce.substring(1)):""})}var g=/(^|[^\[])\^/g;function m(W,re){W=W.source||W,re=re||"";var ce={replace:function(Z,ae){return ae=ae.source||ae,ae=ae.replace(g,"$1"),W=W.replace(Z,ae),ce},getRegex:function(){return new RegExp(W,re)}};return ce}var D=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(W,re,ce){if(W){var V;try{V=decodeURIComponent(l(ce)).replace(D,"").toLowerCase()}catch(Z){return null}if(V.indexOf("javascript:")===0||V.indexOf("vbscript:")===0||V.indexOf("data:")===0)return null}re&&!f.test(ce)&&(ce=r(re,ce));try{ce=encodeURI(ce).replace(/%25/g,"%")}catch(Z){return null}return ce}var p={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(W,re){p[" "+W]||(t.test(W)?p[" "+W]=W+"/":p[" "+W]=_(W,"/",!0)),W=p[" "+W];var ce=W.indexOf(":")===-1;return re.substring(0,2)==="//"?ce?re:W.replace(n,"$1")+re:re.charAt(0)==="/"?ce?re:W.replace(s,"$1")+re:W+re}var a={exec:function(){}};function h(W){for(var re=1,ce,V;re<arguments.length;re++){ce=arguments[re];for(V in ce)Object.prototype.hasOwnProperty.call(ce,V)&&(W[V]=ce[V])}return W}function b(W,re){var ce=W.replace(/\|/g,function(ae,he,ye){for(var ze=!1,$e=he;--$e>=0&&ye[$e]==="\\";)ze=!ze;return ze?"|":" |"}),V=ce.split(/ \|/),Z=0;if(V.length>re)V.splice(re);else for(;V.length<re;)V.push("");for(;Z<V.length;Z++)V[Z]=V[Z].trim().replace(/\\\|/g,"|");return V}function _(W,re,ce){var V=W.length;if(V===0)return"";for(var Z=0;Z<V;){var ae=W.charAt(V-Z-1);if(ae===re&&!ce)Z++;else if(ae!==re&&ce)Z++;else break}return W.substr(0,V-Z)}function v(W,re){if(W.indexOf(re[1])===-1)return-1;for(var ce=W.length,V=0,Z=0;Z<ce;Z++)if(W[Z]==="\\")Z++;else if(W[Z]===re[0])V++;else if(W[Z]===re[1]&&(V--,V<0))return Z;return-1}function E(W){W&&W.sanitize&&!W.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(W,re){if(re<1)return"";for(var ce="";re>1;)re&1&&(ce+=W),re>>=1,W+=W;return ce+W}var U={escape:d,unescape:l,edit:m,cleanUrl:u,resolveUrl:r,noopTest:a,merge:h,splitCells:b,rtrim:_,findClosingBracket:v,checkSanitizeDeprecation:E,repeatString:F},J=y.defaults,me=U.rtrim,q=U.splitCells,z=U.escape,ee=U.findClosingBracket;function $(W,re,ce){var V=re.href,Z=re.title?z(re.title):null,ae=W[1].replace(/\\([\[\]])/g,"$1");return W[0].charAt(0)!=="!"?{type:"link",raw:ce,href:V,title:Z,text:ae}:{type:"image",raw:ce,href:V,title:Z,text:z(ae)}}function R(W,re){var ce=W.match(/^(\s+)(?:```)/);if(ce===null)return re;var V=ce[1];return re.split(`
`).map(function(Z){var ae=Z.match(/^\s+/);if(ae===null)return Z;var he=ae[0];return he.length>=V.length?Z.slice(V.length):Z}).join(`
`)}var M=function(){function W(ce){this.options=ce||J}var re=W.prototype;return re.space=function(V){var Z=this.rules.block.newline.exec(V);if(Z)return Z[0].length>1?{type:"space",raw:Z[0]}:{raw:`
`}},re.code=function(V){var Z=this.rules.block.code.exec(V);if(Z){var ae=Z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Z[0],codeBlockStyle:"indented",text:this.options.pedantic?ae:me(ae,`
`)}}},re.fences=function(V){var Z=this.rules.block.fences.exec(V);if(Z){var ae=Z[0],he=R(ae,Z[3]||"");return{type:"code",raw:ae,lang:Z[2]?Z[2].trim():Z[2],text:he}}},re.heading=function(V){var Z=this.rules.block.heading.exec(V);if(Z){var ae=Z[2].trim();if(/#$/.test(ae)){var he=me(ae,"#");(this.options.pedantic||!he||/ $/.test(he))&&(ae=he.trim())}return{type:"heading",raw:Z[0],depth:Z[1].length,text:ae}}},re.nptable=function(V){var Z=this.rules.block.nptable.exec(V);if(Z){var ae={type:"table",header:q(Z[1].replace(/^ *| *\| *$/g,"")),align:Z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:Z[3]?Z[3].replace(/\n$/,"").split(`
`):[],raw:Z[0]};if(ae.header.length===ae.align.length){var he=ae.align.length,ye;for(ye=0;ye<he;ye++)/^ *-+: *$/.test(ae.align[ye])?ae.align[ye]="right":/^ *:-+: *$/.test(ae.align[ye])?ae.align[ye]="center":/^ *:-+ *$/.test(ae.align[ye])?ae.align[ye]="left":ae.align[ye]=null;for(he=ae.cells.length,ye=0;ye<he;ye++)ae.cells[ye]=q(ae.cells[ye],ae.header.length);return ae}}},re.hr=function(V){var Z=this.rules.block.hr.exec(V);if(Z)return{type:"hr",raw:Z[0]}},re.blockquote=function(V){var Z=this.rules.block.blockquote.exec(V);if(Z){var ae=Z[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:Z[0],text:ae}}},re.list=function(V){var Z=this.rules.block.list.exec(V);if(Z){var ae=Z[0],he=Z[2],ye=he.length>1,ze={type:"list",raw:ae,ordered:ye,start:ye?+he.slice(0,-1):"",loose:!1,items:[]},$e=Z[0].match(this.rules.block.item),Be=!1,Ge,nt,dt,it,Ye,mt,wt,we,de=$e.length;dt=this.rules.block.listItemStart.exec($e[0]);for(var oe=0;oe<de;oe++){if(Ge=$e[oe],ae=Ge,oe!==de-1){if(it=this.rules.block.listItemStart.exec($e[oe+1]),this.options.pedantic?it[1].length>dt[1].length:it[1].length>dt[0].length||it[1].length>3){$e.splice(oe,2,$e[oe]+`
`+$e[oe+1]),oe--,de--;continue}else(!this.options.pedantic||this.options.smartLists?it[2][it[2].length-1]!==he[he.length-1]:ye===(it[2].length===1))&&(Ye=$e.slice(oe+1).join(`
`),ze.raw=ze.raw.substring(0,ze.raw.length-Ye.length),oe=de-1);dt=it}nt=Ge.length,Ge=Ge.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ge.indexOf(`
 `)&&(nt-=Ge.length,Ge=this.options.pedantic?Ge.replace(/^ {1,4}/gm,""):Ge.replace(new RegExp("^ {1,"+nt+"}","gm"),"")),mt=Be||/\n\n(?!\s*$)/.test(Ge),oe!==de-1&&(Be=Ge.charAt(Ge.length-1)===`
`,mt||(mt=Be)),mt&&(ze.loose=!0),this.options.gfm&&(wt=/^\[[ xX]\] /.test(Ge),we=void 0,wt&&(we=Ge[1]!==" ",Ge=Ge.replace(/^\[[ xX]\] +/,""))),ze.items.push({type:"list_item",raw:ae,task:wt,checked:we,loose:mt,text:Ge})}return ze}},re.html=function(V){var Z=this.rules.block.html.exec(V);if(Z)return{type:this.options.sanitize?"paragraph":"html",raw:Z[0],pre:!this.options.sanitizer&&(Z[1]==="pre"||Z[1]==="script"||Z[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):z(Z[0]):Z[0]}},re.def=function(V){var Z=this.rules.block.def.exec(V);if(Z){Z[3]&&(Z[3]=Z[3].substring(1,Z[3].length-1));var ae=Z[1].toLowerCase().replace(/\s+/g," ");return{tag:ae,raw:Z[0],href:Z[2],title:Z[3]}}},re.table=function(V){var Z=this.rules.block.table.exec(V);if(Z){var ae={type:"table",header:q(Z[1].replace(/^ *| *\| *$/g,"")),align:Z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:Z[3]?Z[3].replace(/\n$/,"").split(`
`):[]};if(ae.header.length===ae.align.length){ae.raw=Z[0];var he=ae.align.length,ye;for(ye=0;ye<he;ye++)/^ *-+: *$/.test(ae.align[ye])?ae.align[ye]="right":/^ *:-+: *$/.test(ae.align[ye])?ae.align[ye]="center":/^ *:-+ *$/.test(ae.align[ye])?ae.align[ye]="left":ae.align[ye]=null;for(he=ae.cells.length,ye=0;ye<he;ye++)ae.cells[ye]=q(ae.cells[ye].replace(/^ *\| *| *\| *$/g,""),ae.header.length);return ae}}},re.lheading=function(V){var Z=this.rules.block.lheading.exec(V);if(Z)return{type:"heading",raw:Z[0],depth:Z[2].charAt(0)==="="?1:2,text:Z[1]}},re.paragraph=function(V){var Z=this.rules.block.paragraph.exec(V);if(Z)return{type:"paragraph",raw:Z[0],text:Z[1].charAt(Z[1].length-1)===`
`?Z[1].slice(0,-1):Z[1]}},re.text=function(V){var Z=this.rules.block.text.exec(V);if(Z)return{type:"text",raw:Z[0],text:Z[0]}},re.escape=function(V){var Z=this.rules.inline.escape.exec(V);if(Z)return{type:"escape",raw:Z[0],text:z(Z[1])}},re.tag=function(V,Z,ae){var he=this.rules.inline.tag.exec(V);if(he)return!Z&&/^<a /i.test(he[0])?Z=!0:Z&&/^<\/a>/i.test(he[0])&&(Z=!1),!ae&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?ae=!0:ae&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(ae=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:Z,inRawBlock:ae,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):z(he[0]):he[0]}},re.link=function(V){var Z=this.rules.inline.link.exec(V);if(Z){var ae=Z[2].trim();if(!this.options.pedantic&&/^</.test(ae)){if(!/>$/.test(ae))return;var he=me(ae.slice(0,-1),"\\");if((ae.length-he.length)%2==0)return}else{var ye=ee(Z[2],"()");if(ye>-1){var ze=Z[0].indexOf("!")===0?5:4,$e=ze+Z[1].length+ye;Z[2]=Z[2].substring(0,ye),Z[0]=Z[0].substring(0,$e).trim(),Z[3]=""}}var Be=Z[2],Ge="";if(this.options.pedantic){var nt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Be);nt&&(Be=nt[1],Ge=nt[3])}else Ge=Z[3]?Z[3].slice(1,-1):"";return Be=Be.trim(),/^</.test(Be)&&(this.options.pedantic&&!/>$/.test(ae)?Be=Be.slice(1):Be=Be.slice(1,-1)),$(Z,{href:Be&&Be.replace(this.rules.inline._escapes,"$1"),title:Ge&&Ge.replace(this.rules.inline._escapes,"$1")},Z[0])}},re.reflink=function(V,Z){var ae;if((ae=this.rules.inline.reflink.exec(V))||(ae=this.rules.inline.nolink.exec(V))){var he=(ae[2]||ae[1]).replace(/\s+/g," ");if(he=Z[he.toLowerCase()],!he||!he.href){var ye=ae[0].charAt(0);return{type:"text",raw:ye,text:ye}}return $(ae,he,ae[0])}},re.emStrong=function(V,Z,ae){ae===void 0&&(ae="");var he=this.rules.inline.emStrong.lDelim.exec(V);if(!!he&&!(he[3]&&ae.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ye=he[1]||he[2]||"";if(!ye||ye&&(ae===""||this.rules.inline.punctuation.exec(ae))){var ze=he[0].length-1,$e,Be,Ge=ze,nt=0,dt=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(dt.lastIndex=0,Z=Z.slice(-1*V.length+ze);(he=dt.exec(Z))!=null;)if($e=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!$e){if(Be=$e.length,he[3]||he[4]){Ge+=Be;continue}else if((he[5]||he[6])&&ze%3&&!((ze+Be)%3)){nt+=Be;continue}if(Ge-=Be,!(Ge>0)){if(Ge+nt-Be<=0&&!Z.slice(dt.lastIndex).match(dt)&&(Be=Math.min(Be,Be+Ge+nt)),Math.min(ze,Be)%2)return{type:"em",raw:V.slice(0,ze+he.index+Be+1),text:V.slice(1,ze+he.index+Be)};if(Math.min(ze,Be)%2==0)return{type:"strong",raw:V.slice(0,ze+he.index+Be+1),text:V.slice(2,ze+he.index+Be-1)}}}}}},re.codespan=function(V){var Z=this.rules.inline.code.exec(V);if(Z){var ae=Z[2].replace(/\n/g," "),he=/[^ ]/.test(ae),ye=/^ /.test(ae)&&/ $/.test(ae);return he&&ye&&(ae=ae.substring(1,ae.length-1)),ae=z(ae,!0),{type:"codespan",raw:Z[0],text:ae}}},re.br=function(V){var Z=this.rules.inline.br.exec(V);if(Z)return{type:"br",raw:Z[0]}},re.del=function(V){var Z=this.rules.inline.del.exec(V);if(Z)return{type:"del",raw:Z[0],text:Z[2]}},re.autolink=function(V,Z){var ae=this.rules.inline.autolink.exec(V);if(ae){var he,ye;return ae[2]==="@"?(he=z(this.options.mangle?Z(ae[1]):ae[1]),ye="mailto:"+he):(he=z(ae[1]),ye=he),{type:"link",raw:ae[0],text:he,href:ye,tokens:[{type:"text",raw:he,text:he}]}}},re.url=function(V,Z){var ae;if(ae=this.rules.inline.url.exec(V)){var he,ye;if(ae[2]==="@")he=z(this.options.mangle?Z(ae[0]):ae[0]),ye="mailto:"+he;else{var ze;do ze=ae[0],ae[0]=this.rules.inline._backpedal.exec(ae[0])[0];while(ze!==ae[0]);he=z(ae[0]),ae[1]==="www."?ye="http://"+he:ye=he}return{type:"link",raw:ae[0],text:he,href:ye,tokens:[{type:"text",raw:he,text:he}]}}},re.inlineText=function(V,Z,ae){var he=this.rules.inline.text.exec(V);if(he){var ye;return Z?ye=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):z(he[0]):he[0]:ye=z(this.options.smartypants?ae(he[0]):he[0]),{type:"text",raw:he[0],text:ye}}},W}(),x=U.noopTest,O=U.edit,G=U.merge,Y={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:x,table:x,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};Y._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,Y._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Y.def=O(Y.def).replace("label",Y._label).replace("title",Y._title).getRegex(),Y.bullet=/(?:[*+-]|\d{1,9}[.)])/,Y.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,Y.item=O(Y.item,"gm").replace(/bull/g,Y.bullet).getRegex(),Y.listItemStart=O(/^( *)(bull)/).replace("bull",Y.bullet).getRegex(),Y.list=O(Y.list).replace(/bull/g,Y.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Y.def.source+")").getRegex(),Y._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Y._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Y.html=O(Y.html,"i").replace("comment",Y._comment).replace("tag",Y._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Y.paragraph=O(Y._paragraph).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",Y._tag).getRegex(),Y.blockquote=O(Y.blockquote).replace("paragraph",Y.paragraph).getRegex(),Y.normal=G({},Y),Y.gfm=G({},Y.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Y.gfm.nptable=O(Y.gfm.nptable).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",Y._tag).getRegex(),Y.gfm.table=O(Y.gfm.table).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",Y._tag).getRegex(),Y.pedantic=G({},Y.normal,{html:O(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Y._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:x,paragraph:O(Y.normal._paragraph).replace("hr",Y.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Y.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ne={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:x,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:x,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ne._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ne.punctuation=O(ne.punctuation).replace(/punctuation/g,ne._punctuation).getRegex(),ne.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ne.escapedEmSt=/\\\*|\\_/g,ne._comment=O(Y._comment).replace("(?:-->|$)","-->").getRegex(),ne.emStrong.lDelim=O(ne.emStrong.lDelim).replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimAst=O(ne.emStrong.rDelimAst,"g").replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimUnd=O(ne.emStrong.rDelimUnd,"g").replace(/punct/g,ne._punctuation).getRegex(),ne._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ne._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ne._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ne.autolink=O(ne.autolink).replace("scheme",ne._scheme).replace("email",ne._email).getRegex(),ne._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ne.tag=O(ne.tag).replace("comment",ne._comment).replace("attribute",ne._attribute).getRegex(),ne._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ne._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ne._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ne.link=O(ne.link).replace("label",ne._label).replace("href",ne._href).replace("title",ne._title).getRegex(),ne.reflink=O(ne.reflink).replace("label",ne._label).getRegex(),ne.reflinkSearch=O(ne.reflinkSearch,"g").replace("reflink",ne.reflink).replace("nolink",ne.nolink).getRegex(),ne.normal=G({},ne),ne.pedantic=G({},ne.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:O(/^!?\[(label)\]\((.*?)\)/).replace("label",ne._label).getRegex(),reflink:O(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ne._label).getRegex()}),ne.gfm=G({},ne.normal,{escape:O(ne.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),ne.gfm.url=O(ne.gfm.url,"i").replace("email",ne.gfm._extended_email).getRegex(),ne.breaks=G({},ne.gfm,{br:O(ne.br).replace("{2,}","*").getRegex(),text:O(ne.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var pe={block:Y,inline:ne},Ie=y.defaults,Oe=pe.block,Te=pe.inline,Ue=U.repeatString;function B(W){return W.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(W){var re="",ce,V,Z=W.length;for(ce=0;ce<Z;ce++)V=W.charCodeAt(ce),Math.random()>.5&&(V="x"+V.toString(16)),re+="&#"+V+";";return re}var ie=function(){function W(ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=ce||Ie,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var V={block:Oe.normal,inline:Te.normal};this.options.pedantic?(V.block=Oe.pedantic,V.inline=Te.pedantic):this.options.gfm&&(V.block=Oe.gfm,this.options.breaks?V.inline=Te.breaks:V.inline=Te.gfm),this.tokenizer.rules=V}W.lex=function(V,Z){var ae=new W(Z);return ae.lex(V)},W.lexInline=function(V,Z){var ae=new W(Z);return ae.inlineTokens(V)};var re=W.prototype;return re.lex=function(V){return V=V.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(V,this.tokens,!0),this.inline(this.tokens),this.tokens},re.blockTokens=function(V,Z,ae){Z===void 0&&(Z=[]),ae===void 0&&(ae=!0),this.options.pedantic&&(V=V.replace(/^ +$/gm,""));for(var he,ye,ze,$e;V;){if(he=this.tokenizer.space(V)){V=V.substring(he.raw.length),he.type&&Z.push(he);continue}if(he=this.tokenizer.code(V)){V=V.substring(he.raw.length),$e=Z[Z.length-1],$e&&$e.type==="paragraph"?($e.raw+=`
`+he.raw,$e.text+=`
`+he.text):Z.push(he);continue}if(he=this.tokenizer.fences(V)){V=V.substring(he.raw.length),Z.push(he);continue}if(he=this.tokenizer.heading(V)){V=V.substring(he.raw.length),Z.push(he);continue}if(he=this.tokenizer.nptable(V)){V=V.substring(he.raw.length),Z.push(he);continue}if(he=this.tokenizer.hr(V)){V=V.substring(he.raw.length),Z.push(he);continue}if(he=this.tokenizer.blockquote(V)){V=V.substring(he.raw.length),he.tokens=this.blockTokens(he.text,[],ae),Z.push(he);continue}if(he=this.tokenizer.list(V)){for(V=V.substring(he.raw.length),ze=he.items.length,ye=0;ye<ze;ye++)he.items[ye].tokens=this.blockTokens(he.items[ye].text,[],!1);Z.push(he);continue}if(he=this.tokenizer.html(V)){V=V.substring(he.raw.length),Z.push(he);continue}if(ae&&(he=this.tokenizer.def(V))){V=V.substring(he.raw.length),this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(V)){V=V.substring(he.raw.length),Z.push(he);continue}if(he=this.tokenizer.lheading(V)){V=V.substring(he.raw.length),Z.push(he);continue}if(ae&&(he=this.tokenizer.paragraph(V))){V=V.substring(he.raw.length),Z.push(he);continue}if(he=this.tokenizer.text(V)){V=V.substring(he.raw.length),$e=Z[Z.length-1],$e&&$e.type==="text"?($e.raw+=`
`+he.raw,$e.text+=`
`+he.text):Z.push(he);continue}if(V){var Be="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(Be);break}else throw new Error(Be)}}return Z},re.inline=function(V){var Z,ae,he,ye,ze,$e,Be=V.length;for(Z=0;Z<Be;Z++)switch($e=V[Z],$e.type){case"paragraph":case"text":case"heading":{$e.tokens=[],this.inlineTokens($e.text,$e.tokens);break}case"table":{for($e.tokens={header:[],cells:[]},ye=$e.header.length,ae=0;ae<ye;ae++)$e.tokens.header[ae]=[],this.inlineTokens($e.header[ae],$e.tokens.header[ae]);for(ye=$e.cells.length,ae=0;ae<ye;ae++)for(ze=$e.cells[ae],$e.tokens.cells[ae]=[],he=0;he<ze.length;he++)$e.tokens.cells[ae][he]=[],this.inlineTokens(ze[he],$e.tokens.cells[ae][he]);break}case"blockquote":{this.inline($e.tokens);break}case"list":{for(ye=$e.items.length,ae=0;ae<ye;ae++)this.inline($e.items[ae].tokens);break}}return V},re.inlineTokens=function(V,Z,ae,he){Z===void 0&&(Z=[]),ae===void 0&&(ae=!1),he===void 0&&(he=!1);var ye,ze,$e=V,Be,Ge,nt;if(this.tokens.links){var dt=Object.keys(this.tokens.links);if(dt.length>0)for(;(Be=this.tokenizer.rules.inline.reflinkSearch.exec($e))!=null;)dt.includes(Be[0].slice(Be[0].lastIndexOf("[")+1,-1))&&($e=$e.slice(0,Be.index)+"["+Ue("a",Be[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Be=this.tokenizer.rules.inline.blockSkip.exec($e))!=null;)$e=$e.slice(0,Be.index)+"["+Ue("a",Be[0].length-2)+"]"+$e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Be=this.tokenizer.rules.inline.escapedEmSt.exec($e))!=null;)$e=$e.slice(0,Be.index)+"++"+$e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;V;){if(Ge||(nt=""),Ge=!1,ye=this.tokenizer.escape(V)){V=V.substring(ye.raw.length),Z.push(ye);continue}if(ye=this.tokenizer.tag(V,ae,he)){V=V.substring(ye.raw.length),ae=ye.inLink,he=ye.inRawBlock;var it=Z[Z.length-1];it&&ye.type==="text"&&it.type==="text"?(it.raw+=ye.raw,it.text+=ye.text):Z.push(ye);continue}if(ye=this.tokenizer.link(V)){V=V.substring(ye.raw.length),ye.type==="link"&&(ye.tokens=this.inlineTokens(ye.text,[],!0,he)),Z.push(ye);continue}if(ye=this.tokenizer.reflink(V,this.tokens.links)){V=V.substring(ye.raw.length);var Ye=Z[Z.length-1];ye.type==="link"?(ye.tokens=this.inlineTokens(ye.text,[],!0,he),Z.push(ye)):Ye&&ye.type==="text"&&Ye.type==="text"?(Ye.raw+=ye.raw,Ye.text+=ye.text):Z.push(ye);continue}if(ye=this.tokenizer.emStrong(V,$e,nt)){V=V.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],ae,he),Z.push(ye);continue}if(ye=this.tokenizer.codespan(V)){V=V.substring(ye.raw.length),Z.push(ye);continue}if(ye=this.tokenizer.br(V)){V=V.substring(ye.raw.length),Z.push(ye);continue}if(ye=this.tokenizer.del(V)){V=V.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],ae,he),Z.push(ye);continue}if(ye=this.tokenizer.autolink(V,K)){V=V.substring(ye.raw.length),Z.push(ye);continue}if(!ae&&(ye=this.tokenizer.url(V,K))){V=V.substring(ye.raw.length),Z.push(ye);continue}if(ye=this.tokenizer.inlineText(V,he,B)){V=V.substring(ye.raw.length),ye.raw.slice(-1)!=="_"&&(nt=ye.raw.slice(-1)),Ge=!0,ze=Z[Z.length-1],ze&&ze.type==="text"?(ze.raw+=ye.raw,ze.text+=ye.text):Z.push(ye);continue}if(V){var mt="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(mt);break}else throw new Error(mt)}}return Z},e(W,null,[{key:"rules",get:function(){return{block:Oe,inline:Te}}}]),W}(),le=y.defaults,fe=U.cleanUrl,Se=U.escape,Ne=function(){function W(ce){this.options=ce||le}var re=W.prototype;return re.code=function(V,Z,ae){var he=(Z||"").match(/\S*/)[0];if(this.options.highlight){var ye=this.options.highlight(V,he);ye!=null&&ye!==V&&(ae=!0,V=ye)}return V=V.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+Se(he,!0)+'">'+(ae?V:Se(V,!0))+`</code></pre>
`:"<pre><code>"+(ae?V:Se(V,!0))+`</code></pre>
`},re.blockquote=function(V){return`<blockquote>
`+V+`</blockquote>
`},re.html=function(V){return V},re.heading=function(V,Z,ae,he){return this.options.headerIds?"<h"+Z+' id="'+this.options.headerPrefix+he.slug(ae)+'">'+V+"</h"+Z+`>
`:"<h"+Z+">"+V+"</h"+Z+`>
`},re.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},re.list=function(V,Z,ae){var he=Z?"ol":"ul",ye=Z&&ae!==1?' start="'+ae+'"':"";return"<"+he+ye+`>
`+V+"</"+he+`>
`},re.listitem=function(V){return"<li>"+V+`</li>
`},re.checkbox=function(V){return"<input "+(V?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},re.paragraph=function(V){return"<p>"+V+`</p>
`},re.table=function(V,Z){return Z&&(Z="<tbody>"+Z+"</tbody>"),`<table>
<thead>
`+V+`</thead>
`+Z+`</table>
`},re.tablerow=function(V){return`<tr>
`+V+`</tr>
`},re.tablecell=function(V,Z){var ae=Z.header?"th":"td",he=Z.align?"<"+ae+' align="'+Z.align+'">':"<"+ae+">";return he+V+"</"+ae+`>
`},re.strong=function(V){return"<strong>"+V+"</strong>"},re.em=function(V){return"<em>"+V+"</em>"},re.codespan=function(V){return"<code>"+V+"</code>"},re.br=function(){return this.options.xhtml?"<br/>":"<br>"},re.del=function(V){return"<del>"+V+"</del>"},re.link=function(V,Z,ae){if(V=fe(this.options.sanitize,this.options.baseUrl,V),V===null)return ae;var he='<a href="'+Se(V)+'"';return Z&&(he+=' title="'+Z+'"'),he+=">"+ae+"</a>",he},re.image=function(V,Z,ae){if(V=fe(this.options.sanitize,this.options.baseUrl,V),V===null)return ae;var he='<img src="'+V+'" alt="'+ae+'"';return Z&&(he+=' title="'+Z+'"'),he+=this.options.xhtml?"/>":">",he},re.text=function(V){return V},W}(),ge=function(){function W(){}var re=W.prototype;return re.strong=function(V){return V},re.em=function(V){return V},re.codespan=function(V){return V},re.del=function(V){return V},re.html=function(V){return V},re.text=function(V){return V},re.link=function(V,Z,ae){return""+ae},re.image=function(V,Z,ae){return""+ae},re.br=function(){return""},W}(),Ce=function(){function W(){this.seen={}}var re=W.prototype;return re.serialize=function(V){return V.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},re.getNextSafeSlug=function(V,Z){var ae=V,he=0;if(this.seen.hasOwnProperty(ae)){he=this.seen[V];do he++,ae=V+"-"+he;while(this.seen.hasOwnProperty(ae))}return Z||(this.seen[V]=he,this.seen[ae]=0),ae},re.slug=function(V,Z){Z===void 0&&(Z={});var ae=this.serialize(V);return this.getNextSafeSlug(ae,Z.dryrun)},W}(),Ae=y.defaults,We=U.unescape,Ee=function(){function W(ce){this.options=ce||Ae,this.options.renderer=this.options.renderer||new Ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ge,this.slugger=new Ce}W.parse=function(V,Z){var ae=new W(Z);return ae.parse(V)},W.parseInline=function(V,Z){var ae=new W(Z);return ae.parseInline(V)};var re=W.prototype;return re.parse=function(V,Z){Z===void 0&&(Z=!0);var ae="",he,ye,ze,$e,Be,Ge,nt,dt,it,Ye,mt,wt,we,de,oe,j,Re,Pe,Qe=V.length;for(he=0;he<Qe;he++)switch(Ye=V[he],Ye.type){case"space":continue;case"hr":{ae+=this.renderer.hr();continue}case"heading":{ae+=this.renderer.heading(this.parseInline(Ye.tokens),Ye.depth,We(this.parseInline(Ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ae+=this.renderer.code(Ye.text,Ye.lang,Ye.escaped);continue}case"table":{for(dt="",nt="",$e=Ye.header.length,ye=0;ye<$e;ye++)nt+=this.renderer.tablecell(this.parseInline(Ye.tokens.header[ye]),{header:!0,align:Ye.align[ye]});for(dt+=this.renderer.tablerow(nt),it="",$e=Ye.cells.length,ye=0;ye<$e;ye++){for(Ge=Ye.tokens.cells[ye],nt="",Be=Ge.length,ze=0;ze<Be;ze++)nt+=this.renderer.tablecell(this.parseInline(Ge[ze]),{header:!1,align:Ye.align[ze]});it+=this.renderer.tablerow(nt)}ae+=this.renderer.table(dt,it);continue}case"blockquote":{it=this.parse(Ye.tokens),ae+=this.renderer.blockquote(it);continue}case"list":{for(mt=Ye.ordered,wt=Ye.start,we=Ye.loose,$e=Ye.items.length,it="",ye=0;ye<$e;ye++)oe=Ye.items[ye],j=oe.checked,Re=oe.task,de="",oe.task&&(Pe=this.renderer.checkbox(j),we?oe.tokens.length>0&&oe.tokens[0].type==="text"?(oe.tokens[0].text=Pe+" "+oe.tokens[0].text,oe.tokens[0].tokens&&oe.tokens[0].tokens.length>0&&oe.tokens[0].tokens[0].type==="text"&&(oe.tokens[0].tokens[0].text=Pe+" "+oe.tokens[0].tokens[0].text)):oe.tokens.unshift({type:"text",text:Pe}):de+=Pe),de+=this.parse(oe.tokens,we),it+=this.renderer.listitem(de,Re,j);ae+=this.renderer.list(it,mt,wt);continue}case"html":{ae+=this.renderer.html(Ye.text);continue}case"paragraph":{ae+=this.renderer.paragraph(this.parseInline(Ye.tokens));continue}case"text":{for(it=Ye.tokens?this.parseInline(Ye.tokens):Ye.text;he+1<Qe&&V[he+1].type==="text";)Ye=V[++he],it+=`
`+(Ye.tokens?this.parseInline(Ye.tokens):Ye.text);ae+=Z?this.renderer.paragraph(it):it;continue}default:{var Ze='Token with "'+Ye.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}return ae},re.parseInline=function(V,Z){Z=Z||this.renderer;var ae="",he,ye,ze=V.length;for(he=0;he<ze;he++)switch(ye=V[he],ye.type){case"escape":{ae+=Z.text(ye.text);break}case"html":{ae+=Z.html(ye.text);break}case"link":{ae+=Z.link(ye.href,ye.title,this.parseInline(ye.tokens,Z));break}case"image":{ae+=Z.image(ye.href,ye.title,ye.text);break}case"strong":{ae+=Z.strong(this.parseInline(ye.tokens,Z));break}case"em":{ae+=Z.em(this.parseInline(ye.tokens,Z));break}case"codespan":{ae+=Z.codespan(ye.text);break}case"br":{ae+=Z.br();break}case"del":{ae+=Z.del(this.parseInline(ye.tokens,Z));break}case"text":{ae+=Z.text(ye.text);break}default:{var $e='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error($e);return}else throw new Error($e)}}return ae},W}(),je=U.merge,H=U.checkSanitizeDeprecation,te=U.escape,ve=y.getDefaults,Le=y.changeDefaults,He=y.defaults;function xe(W,re,ce){if(typeof W=="undefined"||W===null)throw new Error("marked(): input parameter is undefined or null");if(typeof W!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(W)+", string expected");if(typeof re=="function"&&(ce=re,re=null),re=je({},xe.defaults,re||{}),H(re),ce){var V=re.highlight,Z;try{Z=ie.lex(W,re)}catch(ze){return ce(ze)}var ae=function($e){var Be;if(!$e)try{Be=Ee.parse(Z,re)}catch(Ge){$e=Ge}return re.highlight=V,$e?ce($e):ce(null,Be)};if(!V||V.length<3||(delete re.highlight,!Z.length))return ae();var he=0;xe.walkTokens(Z,function(ze){ze.type==="code"&&(he++,setTimeout(function(){V(ze.text,ze.lang,function($e,Be){if($e)return ae($e);Be!=null&&Be!==ze.text&&(ze.text=Be,ze.escaped=!0),he--,he===0&&ae()})},0))}),he===0&&ae();return}try{var ye=ie.lex(W,re);return re.walkTokens&&xe.walkTokens(ye,re.walkTokens),Ee.parse(ye,re)}catch(ze){if(ze.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+te(ze.message+"",!0)+"</pre>";throw ze}}xe.options=xe.setOptions=function(W){return je(xe.defaults,W),Le(xe.defaults),xe},xe.getDefaults=ve,xe.defaults=He,xe.use=function(W){var re=je({},W);if(W.renderer&&function(){var V=xe.defaults.renderer||new Ne,Z=function(ye){var ze=V[ye];V[ye]=function(){for(var $e=arguments.length,Be=new Array($e),Ge=0;Ge<$e;Ge++)Be[Ge]=arguments[Ge];var nt=W.renderer[ye].apply(V,Be);return nt===!1&&(nt=ze.apply(V,Be)),nt}};for(var ae in W.renderer)Z(ae);re.renderer=V}(),W.tokenizer&&function(){var V=xe.defaults.tokenizer||new M,Z=function(ye){var ze=V[ye];V[ye]=function(){for(var $e=arguments.length,Be=new Array($e),Ge=0;Ge<$e;Ge++)Be[Ge]=arguments[Ge];var nt=W.tokenizer[ye].apply(V,Be);return nt===!1&&(nt=ze.apply(V,Be)),nt}};for(var ae in W.tokenizer)Z(ae);re.tokenizer=V}(),W.walkTokens){var ce=xe.defaults.walkTokens;re.walkTokens=function(V){W.walkTokens(V),ce&&ce(V)}}xe.setOptions(re)},xe.walkTokens=function(W,re){for(var ce=A(W),V;!(V=ce()).done;){var Z=V.value;switch(re(Z),Z.type){case"table":{for(var ae=A(Z.tokens.header),he;!(he=ae()).done;){var ye=he.value;xe.walkTokens(ye,re)}for(var ze=A(Z.tokens.cells),$e;!($e=ze()).done;)for(var Be=$e.value,Ge=A(Be),nt;!(nt=Ge()).done;){var dt=nt.value;xe.walkTokens(dt,re)}break}case"list":{xe.walkTokens(Z.items,re);break}default:Z.tokens&&xe.walkTokens(Z.tokens,re)}}},xe.parseInline=function(W,re){if(typeof W=="undefined"||W===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof W!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(W)+", string expected");re=je({},xe.defaults,re||{}),H(re);try{var ce=ie.lexInline(W,re);return re.walkTokens&&xe.walkTokens(ce,re.walkTokens),Ee.parseInline(ce,re)}catch(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+te(V.message+"",!0)+"</pre>";throw V}},xe.Parser=Ee,xe.parser=Ee.parse,xe.Renderer=Ne,xe.TextRenderer=ge,xe.Lexer=ie,xe.lexer=ie.lex,xe.Tokenizer=M,xe.Slugger=Ce,xe.parse=xe;var Xe=xe;return Xe}),define(be[81],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function w(y,C,S){return Math.min(Math.max(y,C),S)}e.clamp=w;function I(y,C){return(C+y%C)%C}e.rot=I;class A{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=A;class T{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T});"use strict";(function(){function Q(A){const T=[];typeof A=="number"&&T.push("code/timeOrigin",A);function y(S){T.push(S,Date.now())}function C(){const S=[];for(let k=0;k<T.length;k+=2)S.push({name:T[k],startTime:T[k+1]});return S}return{mark:y,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const y of performance.getEntriesByType("mark"))T.push({name:y.name,startTime:Math.round(A+y.startTime)});return T}};if(typeof process=="object"){const A=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function w(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=w(I))})(),define(be[21],_e([0,1]),function(Q,e){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const I="en";let A=!1,T=!1,y=!1,C=!1,S=!1,k=!1,i=!1,P,c=I,d,o;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode!="undefined"?l=e.globals.vscode.process:typeof process!="undefined"&&(l=process);const g=typeof((w=l==null?void 0:l.versions)===null||w===void 0?void 0:w.electron)=="string"&&l.type==="renderer";if(e.isElectronSandboxed=g&&(l==null?void 0:l.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=l==null?void 0:l.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!g)o=navigator.userAgent,A=o.indexOf("Windows")>=0,T=o.indexOf("Macintosh")>=0,i=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=o.indexOf("Linux")>=0,k=!0,P=navigator.language,c=P;else if(typeof l=="object"){A=l.platform==="win32",T=l.platform==="darwin",y=l.platform==="linux",C=y&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,P=I,c=I;const r=l.env.VSCODE_NLS_CONFIG;if(r)try{const a=JSON.parse(r),h=a.availableLanguages["*"];P=a.locale,c=h||I,d=a._translationsConfigFile}catch(a){}S=!0}else console.error("Unable to resolve platform.");var m;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(m=e.Platform||(e.Platform={}));function D(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=D;let f=0;T?f=1:A?f=3:y&&(f=2),e.isWindows=A,e.isMacintosh=T,e.isLinux=y,e.isLinuxSnap=C,e.isNative=S,e.isWeb=k,e.isIOS=i,e.platform=f,e.userAgent=o,e.language=c;var u;(function(r){function a(){return e.language}r.value=a;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=h;function b(){return e.language==="en"}r.isDefault=b})(u=e.Language||(e.Language={})),e.locale=P,e.translationsConfigFile=d,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let h=[];e.globals.addEventListener("message",_=>{if(_.data&&_.data.vscodeSetImmediateId)for(let v=0,E=h.length;v<E;v++){const F=h[v];if(F.id===_.data.vscodeSetImmediateId){h.splice(v,1),F.callback();return}}});let b=0;return _=>{const v=++b;h.push({id:v,callback:_}),e.globals.postMessage({vscodeSetImmediateId:v},"*")}}if(typeof(l==null?void 0:l.nextTick)=="function")return l.nextTick.bind(l);const a=Promise.resolve();return h=>a.then(h)}();var p;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(p=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||i?2:A?1:3;let t=!0,n=!1;function s(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(be[46],_e([0,1,21]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let I;if(typeof w.globals.vscode!="undefined"){const A=w.globals.vscode.process;I={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(T){return(0,w.setImmediate)(T)}}}else typeof process!="undefined"?I={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}}:I={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},nextTick(A){return(0,w.setImmediate)(A)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=I.cwd,e.env=I.env,e.platform=I.platform,e.nextTick=I.nextTick}),define(be[13],_e([0,1,46]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const I=65,A=97,T=90,y=122,C=46,S=47,k=92,i=58,P=63;class c extends Error{constructor(u,p,t){let n;typeof p=="string"&&p.indexOf("not ")===0?(n="must not be",p=p.replace(/^not /,"")):n="must be";const s=u.indexOf(".")!==-1?"property":"argument";let r=`The "${u}" ${s} ${n} of type ${p}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function d(f,u){if(typeof f!="string")throw new c(u,"string",f)}function o(f){return f===S||f===k}function l(f){return f===S}function g(f){return f>=I&&f<=T||f>=A&&f<=y}function m(f,u,p,t){let n="",s=0,r=-1,a=0,h=0;for(let b=0;b<=f.length;++b){if(b<f.length)h=f.charCodeAt(b);else{if(t(h))break;h=S}if(t(h)){if(!(r===b-1||a===1))if(a===2){if(n.length<2||s!==2||n.charCodeAt(n.length-1)!==C||n.charCodeAt(n.length-2)!==C){if(n.length>2){const _=n.lastIndexOf(p);_===-1?(n="",s=0):(n=n.slice(0,_),s=n.length-1-n.lastIndexOf(p)),r=b,a=0;continue}else if(n.length!==0){n="",s=0,r=b,a=0;continue}}u&&(n+=n.length>0?`${p}..`:"..",s=2)}else n.length>0?n+=`${p}${f.slice(r+1,b)}`:n=f.slice(r+1,b),s=b-r-1;r=b,a=0}else h===C&&a!==-1?++a:a=-1}return n}function D(f,u){if(u===null||typeof u!="object")throw new c("pathObject","Object",u);const p=u.dir||u.root,t=u.base||`${u.name||""}${u.ext||""}`;return p?p===u.root?`${p}${t}`:`${p}${f}${t}`:t}e.win32={resolve(...f){let u="",p="",t=!1;for(let n=f.length-1;n>=-1;n--){let s;if(n>=0){if(s=f[n],d(s,"path"),s.length===0)continue}else u.length===0?s=w.cwd():(s=w.env[`=${u}`]||w.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==u.toLowerCase()&&s.charCodeAt(2)===k)&&(s=`${u}\\`));const r=s.length;let a=0,h="",b=!1;const _=s.charCodeAt(0);if(r===1)o(_)&&(a=1,b=!0);else if(o(_))if(b=!0,o(s.charCodeAt(1))){let v=2,E=v;for(;v<r&&!o(s.charCodeAt(v));)v++;if(v<r&&v!==E){const F=s.slice(E,v);for(E=v;v<r&&o(s.charCodeAt(v));)v++;if(v<r&&v!==E){for(E=v;v<r&&!o(s.charCodeAt(v));)v++;(v===r||v!==E)&&(h=`\\\\${F}\\${s.slice(E,v)}`,a=v)}}}else a=1;else g(_)&&s.charCodeAt(1)===i&&(h=s.slice(0,2),a=2,r>2&&o(s.charCodeAt(2))&&(b=!0,a=3));if(h.length>0)if(u.length>0){if(h.toLowerCase()!==u.toLowerCase())continue}else u=h;if(t){if(u.length>0)break}else if(p=`${s.slice(a)}\\${p}`,t=b,b&&u.length>0)break}return p=m(p,!t,"\\",o),t?`${u}\\${p}`:`${u}${p}`||"."},normalize(f){d(f,"path");const u=f.length;if(u===0)return".";let p=0,t,n=!1;const s=f.charCodeAt(0);if(u===1)return l(s)?"\\":f;if(o(s))if(n=!0,o(f.charCodeAt(1))){let a=2,h=a;for(;a<u&&!o(f.charCodeAt(a));)a++;if(a<u&&a!==h){const b=f.slice(h,a);for(h=a;a<u&&o(f.charCodeAt(a));)a++;if(a<u&&a!==h){for(h=a;a<u&&!o(f.charCodeAt(a));)a++;if(a===u)return`\\\\${b}\\${f.slice(h)}\\`;a!==h&&(t=`\\\\${b}\\${f.slice(h,a)}`,p=a)}}}else p=1;else g(s)&&f.charCodeAt(1)===i&&(t=f.slice(0,2),p=2,u>2&&o(f.charCodeAt(2))&&(n=!0,p=3));let r=p<u?m(f.slice(p),!n,"\\",o):"";return r.length===0&&!n&&(r="."),r.length>0&&o(f.charCodeAt(u-1))&&(r+="\\"),t===void 0?n?`\\${r}`:r:n?`${t}\\${r}`:`${t}${r}`},isAbsolute(f){d(f,"path");const u=f.length;if(u===0)return!1;const p=f.charCodeAt(0);return o(p)||u>2&&g(p)&&f.charCodeAt(1)===i&&o(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let u,p;for(let s=0;s<f.length;++s){const r=f[s];d(r,"path"),r.length>0&&(u===void 0?u=p=r:u+=`\\${r}`)}if(u===void 0)return".";let t=!0,n=0;if(typeof p=="string"&&o(p.charCodeAt(0))){++n;const s=p.length;s>1&&o(p.charCodeAt(1))&&(++n,s>2&&(o(p.charCodeAt(2))?++n:t=!1))}if(t){for(;n<u.length&&o(u.charCodeAt(n));)n++;n>=2&&(u=`\\${u.slice(n)}`)}return e.win32.normalize(u)},relative(f,u){if(d(f,"from"),d(u,"to"),f===u)return"";const p=e.win32.resolve(f),t=e.win32.resolve(u);if(p===t||(f=p.toLowerCase(),u=t.toLowerCase(),f===u))return"";let n=0;for(;n<f.length&&f.charCodeAt(n)===k;)n++;let s=f.length;for(;s-1>n&&f.charCodeAt(s-1)===k;)s--;const r=s-n;let a=0;for(;a<u.length&&u.charCodeAt(a)===k;)a++;let h=u.length;for(;h-1>a&&u.charCodeAt(h-1)===k;)h--;const b=h-a,_=r<b?r:b;let v=-1,E=0;for(;E<_;E++){const U=f.charCodeAt(n+E);if(U!==u.charCodeAt(a+E))break;U===k&&(v=E)}if(E!==_){if(v===-1)return t}else{if(b>_){if(u.charCodeAt(a+E)===k)return t.slice(a+E+1);if(E===2)return t.slice(a+E)}r>_&&(f.charCodeAt(n+E)===k?v=E:E===2&&(v=3)),v===-1&&(v=0)}let F="";for(E=n+v+1;E<=s;++E)(E===s||f.charCodeAt(E)===k)&&(F+=F.length===0?"..":"\\..");return a+=v,F.length>0?`${F}${t.slice(a,h)}`:(t.charCodeAt(a)===k&&++a,t.slice(a,h))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const u=e.win32.resolve(f);if(u.length<=2)return f;if(u.charCodeAt(0)===k){if(u.charCodeAt(1)===k){const p=u.charCodeAt(2);if(p!==P&&p!==C)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(g(u.charCodeAt(0))&&u.charCodeAt(1)===i&&u.charCodeAt(2)===k)return`\\\\?\\${u}`;return f},dirname(f){d(f,"path");const u=f.length;if(u===0)return".";let p=-1,t=0;const n=f.charCodeAt(0);if(u===1)return o(n)?f:".";if(o(n)){if(p=t=1,o(f.charCodeAt(1))){let a=2,h=a;for(;a<u&&!o(f.charCodeAt(a));)a++;if(a<u&&a!==h){for(h=a;a<u&&o(f.charCodeAt(a));)a++;if(a<u&&a!==h){for(h=a;a<u&&!o(f.charCodeAt(a));)a++;if(a===u)return f;a!==h&&(p=t=a+1)}}}}else g(n)&&f.charCodeAt(1)===i&&(p=u>2&&o(f.charCodeAt(2))?3:2,t=p);let s=-1,r=!0;for(let a=u-1;a>=t;--a)if(o(f.charCodeAt(a))){if(!r){s=a;break}}else r=!1;if(s===-1){if(p===-1)return".";s=p}return f.slice(0,s)},basename(f,u){u!==void 0&&d(u,"ext"),d(f,"path");let p=0,t=-1,n=!0,s;if(f.length>=2&&g(f.charCodeAt(0))&&f.charCodeAt(1)===i&&(p=2),u!==void 0&&u.length>0&&u.length<=f.length){if(u===f)return"";let r=u.length-1,a=-1;for(s=f.length-1;s>=p;--s){const h=f.charCodeAt(s);if(o(h)){if(!n){p=s+1;break}}else a===-1&&(n=!1,a=s+1),r>=0&&(h===u.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=a))}return p===t?t=a:t===-1&&(t=f.length),f.slice(p,t)}for(s=f.length-1;s>=p;--s)if(o(f.charCodeAt(s))){if(!n){p=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":f.slice(p,t)},extname(f){d(f,"path");let u=0,p=-1,t=0,n=-1,s=!0,r=0;f.length>=2&&f.charCodeAt(1)===i&&g(f.charCodeAt(0))&&(u=t=2);for(let a=f.length-1;a>=u;--a){const h=f.charCodeAt(a);if(o(h)){if(!s){t=a+1;break}continue}n===-1&&(s=!1,n=a+1),h===C?p===-1?p=a:r!==1&&(r=1):p!==-1&&(r=-1)}return p===-1||n===-1||r===0||r===1&&p===n-1&&p===t+1?"":f.slice(p,n)},format:D.bind(null,"\\"),parse(f){d(f,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return u;const p=f.length;let t=0,n=f.charCodeAt(0);if(p===1)return o(n)?(u.root=u.dir=f,u):(u.base=u.name=f,u);if(o(n)){if(t=1,o(f.charCodeAt(1))){let v=2,E=v;for(;v<p&&!o(f.charCodeAt(v));)v++;if(v<p&&v!==E){for(E=v;v<p&&o(f.charCodeAt(v));)v++;if(v<p&&v!==E){for(E=v;v<p&&!o(f.charCodeAt(v));)v++;v===p?t=v:v!==E&&(t=v+1)}}}}else if(g(n)&&f.charCodeAt(1)===i){if(p<=2)return u.root=u.dir=f,u;if(t=2,o(f.charCodeAt(2))){if(p===3)return u.root=u.dir=f,u;t=3}}t>0&&(u.root=f.slice(0,t));let s=-1,r=t,a=-1,h=!0,b=f.length-1,_=0;for(;b>=t;--b){if(n=f.charCodeAt(b),o(n)){if(!h){r=b+1;break}continue}a===-1&&(h=!1,a=b+1),n===C?s===-1?s=b:_!==1&&(_=1):s!==-1&&(_=-1)}return a!==-1&&(s===-1||_===0||_===1&&s===a-1&&s===r+1?u.base=u.name=f.slice(r,a):(u.name=f.slice(r,s),u.base=f.slice(r,a),u.ext=f.slice(s,a))),r>0&&r!==t?u.dir=f.slice(0,r-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let u="",p=!1;for(let t=f.length-1;t>=-1&&!p;t--){const n=t>=0?f[t]:w.cwd();d(n,"path"),n.length!==0&&(u=`${n}/${u}`,p=n.charCodeAt(0)===S)}return u=m(u,!p,"/",l),p?`/${u}`:u.length>0?u:"."},normalize(f){if(d(f,"path"),f.length===0)return".";const u=f.charCodeAt(0)===S,p=f.charCodeAt(f.length-1)===S;return f=m(f,!u,"/",l),f.length===0?u?"/":p?"./":".":(p&&(f+="/"),u?`/${f}`:f)},isAbsolute(f){return d(f,"path"),f.length>0&&f.charCodeAt(0)===S},join(...f){if(f.length===0)return".";let u;for(let p=0;p<f.length;++p){const t=f[p];d(t,"path"),t.length>0&&(u===void 0?u=t:u+=`/${t}`)}return u===void 0?".":e.posix.normalize(u)},relative(f,u){if(d(f,"from"),d(u,"to"),f===u||(f=e.posix.resolve(f),u=e.posix.resolve(u),f===u))return"";const p=1,t=f.length,n=t-p,s=1,r=u.length-s,a=n<r?n:r;let h=-1,b=0;for(;b<a;b++){const v=f.charCodeAt(p+b);if(v!==u.charCodeAt(s+b))break;v===S&&(h=b)}if(b===a)if(r>a){if(u.charCodeAt(s+b)===S)return u.slice(s+b+1);if(b===0)return u.slice(s+b)}else n>a&&(f.charCodeAt(p+b)===S?h=b:b===0&&(h=0));let _="";for(b=p+h+1;b<=t;++b)(b===t||f.charCodeAt(b)===S)&&(_+=_.length===0?"..":"/..");return`${_}${u.slice(s+h)}`},toNamespacedPath(f){return f},dirname(f){if(d(f,"path"),f.length===0)return".";const u=f.charCodeAt(0)===S;let p=-1,t=!0;for(let n=f.length-1;n>=1;--n)if(f.charCodeAt(n)===S){if(!t){p=n;break}}else t=!1;return p===-1?u?"/":".":u&&p===1?"//":f.slice(0,p)},basename(f,u){u!==void 0&&d(u,"ext"),d(f,"path");let p=0,t=-1,n=!0,s;if(u!==void 0&&u.length>0&&u.length<=f.length){if(u===f)return"";let r=u.length-1,a=-1;for(s=f.length-1;s>=0;--s){const h=f.charCodeAt(s);if(h===S){if(!n){p=s+1;break}}else a===-1&&(n=!1,a=s+1),r>=0&&(h===u.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=a))}return p===t?t=a:t===-1&&(t=f.length),f.slice(p,t)}for(s=f.length-1;s>=0;--s)if(f.charCodeAt(s)===S){if(!n){p=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":f.slice(p,t)},extname(f){d(f,"path");let u=-1,p=0,t=-1,n=!0,s=0;for(let r=f.length-1;r>=0;--r){const a=f.charCodeAt(r);if(a===S){if(!n){p=r+1;break}continue}t===-1&&(n=!1,t=r+1),a===C?u===-1?u=r:s!==1&&(s=1):u!==-1&&(s=-1)}return u===-1||t===-1||s===0||s===1&&u===t-1&&u===p+1?"":f.slice(u,t)},format:D.bind(null,"/"),parse(f){d(f,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return u;const p=f.charCodeAt(0)===S;let t;p?(u.root="/",t=1):t=0;let n=-1,s=0,r=-1,a=!0,h=f.length-1,b=0;for(;h>=t;--h){const _=f.charCodeAt(h);if(_===S){if(!a){s=h+1;break}continue}r===-1&&(a=!1,r=h+1),_===C?n===-1?n=h:b!==1&&(b=1):n!==-1&&(b=-1)}if(r!==-1){const _=s===0&&p?1:s;n===-1||b===0||b===1&&n===r-1&&n===s+1?u.base=u.name=f.slice(_,r):(u.name=f.slice(_,n),u.base=f.slice(_,r),u.ext=f.slice(n,r))}return s>0?u.dir=f.slice(0,s-1):p&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(be[55],_e([0,1,21]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const I=w.globals.performance&&typeof w.globals.performance.now=="function";class A{constructor(y){this._highResolution=I&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new A(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=A}),define(be[3],_e([0,1,12,53,6,45,55]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(m){m.None=()=>A.Disposable.None;function D(q){return(z,ee=null,$)=>{let R=!1,M;return M=q(x=>{if(!R)return M?M.dispose():R=!0,z.call(ee,x)},null,$),R&&M.dispose(),M}}m.once=D;function f(q,z){return r((ee,$=null,R)=>q(M=>ee.call($,z(M)),null,R))}m.map=f;function u(q,z){return r((ee,$=null,R)=>q(M=>{z(M),ee.call($,M)},null,R))}m.forEach=u;function p(q,z){return r((ee,$=null,R)=>q(M=>z(M)&&ee.call($,M),null,R))}m.filter=p;function t(q){return q}m.signal=t;function n(...q){return(z,ee=null,$)=>(0,A.combinedDisposable)(...q.map(R=>R(M=>z.call(ee,M),null,$)))}m.any=n;function s(q,z,ee){let $=ee;return f(q,R=>($=z($,R),$))}m.reduce=s;function r(q){let z;const ee=new c({onFirstListenerAdd(){z=q(ee.fire,ee)},onLastListenerRemove(){z.dispose()}});return ee.event}m.snapshot=r;function a(q,z,ee=100,$=!1,R){let M,x,O,G=0;const Y=new c({leakWarningThreshold:R,onFirstListenerAdd(){M=q(ne=>{G++,x=z(x,ne),$&&!O&&(Y.fire(x),x=void 0),clearTimeout(O),O=setTimeout(()=>{const pe=x;x=void 0,O=void 0,(!$||G>1)&&Y.fire(pe),G=0},ee)})},onLastListenerRemove(){M.dispose()}});return Y.event}m.debounce=a;function h(q){const z=new Date().getTime();return f(D(q),ee=>new Date().getTime()-z)}m.stopwatch=h;function b(q){let z=!0,ee;return p(q,$=>{const R=z||$!==ee;return z=!1,ee=$,R})}m.latch=b;function _(q,z=!1,ee=[]){let $=ee.slice(),R=q(O=>{$?$.push(O):x.fire(O)});const M=()=>{$&&$.forEach(O=>x.fire(O)),$=null},x=new c({onFirstListenerAdd(){R||(R=q(O=>x.fire(O)))},onFirstListenerDidAdd(){$&&(z?setTimeout(M):M())},onLastListenerRemove(){R&&R.dispose(),R=null}});return x.event}m.buffer=_;class v{constructor(z){this.event=z}map(z){return new v(f(this.event,z))}forEach(z){return new v(u(this.event,z))}filter(z){return new v(p(this.event,z))}reduce(z,ee){return new v(s(this.event,z,ee))}latch(){return new v(b(this.event))}debounce(z,ee=100,$=!1,R){return new v(a(this.event,z,ee,$,R))}on(z,ee,$){return this.event(z,ee,$)}once(z,ee,$){return D(this.event)(z,ee,$)}}function E(q){return new v(q)}m.chain=E;function F(q,z,ee=$=>$){const $=(...O)=>x.fire(ee(...O)),R=()=>q.on(z,$),M=()=>q.removeListener(z,$),x=new c({onFirstListenerAdd:R,onLastListenerRemove:M});return x.event}m.fromNodeEventEmitter=F;function U(q,z,ee=$=>$){const $=(...O)=>x.fire(ee(...O)),R=()=>q.addEventListener(z,$),M=()=>q.removeEventListener(z,$),x=new c({onFirstListenerAdd:R,onLastListenerRemove:M});return x.event}m.fromDOMEventEmitter=U;function J(q){const z=new c;let ee=!1;return q.then(void 0,()=>null).then(()=>{ee?z.fire(void 0):setTimeout(()=>z.fire(void 0),0)}),ee=!0,z.event}m.fromPromise=J;function me(q){return new Promise(z=>D(q)(z))}m.toPromise=me})(C=e.Event||(e.Event={}));class S{constructor(D){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${D}_${S._idPool++}`}start(D){this._stopWatch=new y.StopWatch(!0),this._listenerCount=D}stop(){if(this._stopWatch){const D=this._stopWatch.elapsed();this._elapsedOverall+=D,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${D.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let k=-1;function i(m){const D=k;return k=m,{dispose(){k=D}}}e.setGlobalLeakWarningThreshold=i;class P{constructor(D,f=Math.random().toString(18).slice(2,5)){this.customThreshold=D,this.name=f,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(D){let f=k;if(typeof this.customThreshold=="number"&&(f=this.customThreshold),!(f<=0||D<f)){this._stacks||(this._stacks=new Map);const u=new Error().stack.split(`
`).slice(3).join(`
`),p=this._stacks.get(u)||0;if(this._stacks.set(u,p+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=f*.5;let t,n=0;for(const[s,r]of this._stacks)(!t||n<r)&&(t=s,n=r);console.warn(`[${this.name}] potential listener LEAK detected, having ${D} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(u)||0;this._stacks.set(u,t-1)}}}}class c{constructor(D){var f;this._disposed=!1,this._options=D,this._leakageMon=k>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((f=this._options)===null||f===void 0?void 0:f._profName)?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(D,f,u)=>{var p;this._listeners||(this._listeners=new T.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(f?[D,f]:D);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,D,f);const s=(p=this._leakageMon)===null||p===void 0?void 0:p.check(this._listeners.size);let r;return r={dispose:()=>{s&&s(),r.dispose=c._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},u instanceof A.DisposableStore?u.add(r):Array.isArray(u)&&u.push(r),r}),this._event}fire(D){var f,u;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let p of this._listeners)this._deliveryQueue.push([p,D]);for((f=this._perfMon)===null||f===void 0||f.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[p,t]=this._deliveryQueue.shift();try{typeof p=="function"?p.call(void 0,t):p[0].call(p[1],t)}catch(n){(0,w.onUnexpectedError)(n)}}(u=this._perfMon)===null||u===void 0||u.stop()}}dispose(){var D,f,u;(D=this._listeners)===null||D===void 0||D.clear(),(f=this._deliveryQueue)===null||f===void 0||f.clear(),(u=this._leakageMon)===null||u===void 0||u.dispose(),this._disposed=!0}}e.Emitter=c,c._noop=function(){};class d extends c{constructor(D){super(D);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=D==null?void 0:D.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const D=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(D))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(D){this._listeners&&(this._isPaused!==0?this._eventQueue.push(D):super.fire(D))}}e.PauseableEmitter=d;class o{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(D){const f={event:D,listener:null};this.events.push(f),this.hasListeners&&this.hook(f);const u=()=>{this.hasListeners&&this.unhook(f);const p=this.events.indexOf(f);this.events.splice(p,1)};return(0,A.toDisposable)((0,I.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(D=>this.hook(D))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(D=>this.unhook(D))}hook(D){D.listener=D.event(f=>this.emitter.fire(f))}unhook(D){D.listener&&D.listener.dispose(),D.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=o;class l{constructor(){this.buffers=[]}wrapEvent(D){return(f,u,p)=>D(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>f.call(u,t)):f.call(u,t)},void 0,p)}bufferEvents(D){const f=[];this.buffers.push(f);const u=D();return this.buffers.pop(),f.forEach(p=>p()),u}}e.EventBufferer=l;class g{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=A.Disposable.None,this.emitter=new c({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(D){this.inputEvent=D,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=D(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=g}),define(be[20],_e([0,1,3]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const I=Object.freeze(function(C,S){const k=setTimeout(C.bind(S),0);return{dispose(){clearTimeout(k)}}});var A;(function(C){function S(k){return k===C.None||k===C.Cancelled||k instanceof T?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}C.isCancellationToken=S,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:I})})(A=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?I:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=A.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=y}),define(be[36],_e([0,1,3]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class I{constructor(){this._icons=new Map,this._onDidRegister=new w.Emitter}add(P){const c=this._icons.get(P.id);c?P.description?c.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const A=new I;e.iconRegistry=A;function T(i,P){return new C(i,P)}e.registerCodicon=T;function y(i){return i?i.replace(/\$\((.*?)\)/g,(P,c)=>` ${c} `).trim():""}e.getCodiconAriaLabel=y;class C{constructor(P,c,d){this.id=P,this.definition=c,this.description=d,A.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function S(i,P){const c=["codicon","codicon-"+i];return P&&c.push("codicon-modifier-"+P),c}e.getClassNamesArray=S;var k;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function c(l){if(l instanceof C)return["codicon","codicon-"+l.id];const g=P.exec(l.id);if(!g)return c(C.error);let[,m,D]=g;const f=["codicon","codicon-"+m];return D&&f.push("codicon-modifier-"+D.substr(1)),f}i.asClassNameArray=c;function d(l){return c(l).join(" ")}i.asClassName=d;function o(l){return"."+c(l).join(".")}i.asCSSSelector=o})(k=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(be[109],_e([0,1,12,6]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(f){const u=f;return u?[u.on,u.pause,u.resume,u.destroy].every(p=>typeof p=="function"):!1}e.isReadableStream=A;function T(f){const u=f;return u?A(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=T;function y(f,u){return new C(f,u)}e.newWriteableStream=y;class C{constructor(u,p){this.reducer=u,this.options=p,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){var p;if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof((p=this.options)===null||p===void 0?void 0:p.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u!="undefined"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(p=>p(u))}emitError(u){this.listeners.error.length===0?(0,w.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(p=>p(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,p){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(p),this.resume();break;case"end":this.listeners.end.push(p),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(p),this.state.flowing&&this.flowErrors();break}}removeListener(u,p){if(!this.state.destroyed){let t;switch(u){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(p);n>=0&&t.splice(n,1)}}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const p=[...this.pendingWritePromises];this.pendingWritePromises.length=0,p.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(f,u){const p=[];let t;for(;(t=f.read())!==null;)p.push(t);return u(p)}e.consumeReadable=S;function k(f,u,p){const t=[];let n;for(;(n=f.read())!==null&&t.length<p;)t.push(n);return n===null&&t.length>0?u(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const s=n;return n=void 0,s}return f.read()}}}e.peekReadable=k;function i(f,u){return new Promise((p,t)=>{const n=[];P(f,{onData:s=>{u&&n.push(s)},onError:s=>{u?t(s):p(void 0)},onEnd:()=>{p(u?u(n):void 0)}})})}e.consumeStream=i;function P(f,u){f.on("error",p=>u.onError(p)),f.on("end",()=>u.onEnd()),f.on("data",p=>u.onData(p))}e.listenStream=P;function c(f,u){return new Promise((p,t)=>{const n=new I.DisposableStore,s=[],r=b=>{if(s.push(b),s.length>u)return n.dispose(),f.pause(),p({stream:f,buffer:s,ended:!1})},a=b=>t(b),h=()=>p({stream:f,buffer:s,ended:!0});n.add((0,I.toDisposable)(()=>f.removeListener("error",a))),f.on("error",a),n.add((0,I.toDisposable)(()=>f.removeListener("end",h))),f.on("end",h),n.add((0,I.toDisposable)(()=>f.removeListener("data",r))),f.on("data",r)})}e.peekStream=c;function d(f,u){const p=y(u);return p.end(f),p}e.toStream=d;function o(){const f=y(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=o;function l(f){let u=!1;return{read:()=>u?null:(u=!0,f)}}e.toReadable=l;function g(f,u,p){const t=y(p);return P(f,{onData:n=>t.write(u.data(n)),onError:n=>t.error(u.error?u.error(n):n),onEnd:()=>t.end()}),t}e.transform=g;function m(f,u,p){let t=!1;return{read:()=>{const n=u.read();return t?n:(t=!0,n!==null?p([f,n]):f)}}}e.prefixedReadable=m;function D(f,u,p){let t=!1;const n=y(p);return P(u,{onData:s=>t?n.write(s):(t=!0,n.write(p([f,s]))),onError:s=>n.error(s),onEnd:()=>{t||(t=!0,n.write(f)),n.end()}}),n}e.prefixedStream=D}),define(be[8],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function w(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=w;const I=/{(\d+)}/g;function A(W,...re){return re.length===0?W:W.replace(I,function(ce,V){const Z=parseInt(V,10);return isNaN(Z)||Z<0||Z>=re.length?ce:re[Z]})}e.format=A;function T(W){return W.replace(/[<>&]/g,function(re){switch(re){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return re}})}e.escape=T;function y(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function C(W,re){let ce=0;const V=re.charCodeAt(0);for(let Z=W.length-1;Z>=0;Z--)W.charCodeAt(Z)===V&&ce++;return ce}e.count=C;function S(W,re,ce="\u2026"){return W.length<=re?W:`${W.substr(0,re)}${ce}`}e.truncate=S;function k(W,re=" "){const ce=i(W,re);return P(ce,re)}e.trim=k;function i(W,re){if(!W||!re)return W;const ce=re.length;if(ce===0||W.length===0)return W;let V=0;for(;W.indexOf(re,V)===V;)V=V+ce;return W.substring(V)}e.ltrim=i;function P(W,re){if(!W||!re)return W;const ce=re.length,V=W.length;if(ce===0||V===0)return W;let Z=V,ae=-1;for(;ae=W.lastIndexOf(re,Z-1),!(ae===-1||ae+ce!==Z);){if(ae===0)return"";Z=ae}return W.substring(0,Z)}e.rtrim=P;function c(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=c;function d(W){return W.replace(/\*/g,"")}e.stripWildcards=d;function o(W,re,ce={}){if(!W)throw new Error("Cannot create regex from empty string");re||(W=y(W)),ce.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let V="";return ce.global&&(V+="g"),ce.matchCase||(V+="i"),ce.multiline&&(V+="m"),ce.unicode&&(V+="u"),new RegExp(W,V)}e.createRegExp=o;function l(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=l;function g(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=g;function m(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=m;function D(W){return W.split(/\r\n|\r|\n/)}e.splitLines=D;function f(W){for(let re=0,ce=W.length;re<ce;re++){const V=W.charCodeAt(re);if(V!==32&&V!==9)return re}return-1}e.firstNonWhitespaceIndex=f;function u(W,re=0,ce=W.length){for(let V=re;V<ce;V++){const Z=W.charCodeAt(V);if(Z!==32&&Z!==9)return W.substring(re,V)}return W.substring(re,ce)}e.getLeadingWhitespace=u;function p(W,re=W.length-1){for(let ce=re;ce>=0;ce--){const V=W.charCodeAt(ce);if(V!==32&&V!==9)return ce}return-1}e.lastNonWhitespaceIndex=p;function t(W,re){return W<re?-1:W>re?1:0}e.compare=t;function n(W,re,ce=0,V=W.length,Z=0,ae=re.length){for(;ce<V&&Z<ae;ce++,Z++){let ze=W.charCodeAt(ce),$e=re.charCodeAt(Z);if(ze<$e)return-1;if(ze>$e)return 1}const he=V-ce,ye=ae-Z;return he<ye?-1:he>ye?1:0}e.compareSubstring=n;function s(W,re){return r(W,re,0,W.length,0,re.length)}e.compareIgnoreCase=s;function r(W,re,ce=0,V=W.length,Z=0,ae=re.length){for(;ce<V&&Z<ae;ce++,Z++){let ze=W.charCodeAt(ce),$e=re.charCodeAt(Z);if(ze!==$e){const Be=ze-$e;if(!(Be===32&&h($e))&&!(Be===-32&&h(ze)))return a(ze)&&a($e)?Be:n(W.toLowerCase(),re.toLowerCase(),ce,V,Z,ae)}}const he=V-ce,ye=ae-Z;return he<ye?-1:he>ye?1:0}e.compareSubstringIgnoreCase=r;function a(W){return W>=97&&W<=122}e.isLowerAsciiLetter=a;function h(W){return W>=65&&W<=90}e.isUpperAsciiLetter=h;function b(W){return a(W)||h(W)}function _(W,re){return W.length===re.length&&v(W,re)}e.equalsIgnoreCase=_;function v(W,re,ce=W.length){for(let V=0;V<ce;V++){const Z=W.charCodeAt(V),ae=re.charCodeAt(V);if(Z!==ae){if(b(Z)&&b(ae)){const he=Math.abs(Z-ae);if(he!==0&&he!==32)return!1}else if(String.fromCharCode(Z).toLowerCase()!==String.fromCharCode(ae).toLowerCase())return!1}}return!0}function E(W,re){const ce=re.length;return re.length>W.length?!1:v(W,re,ce)}e.startsWithIgnoreCase=E;function F(W,re){let ce,V=Math.min(W.length,re.length);for(ce=0;ce<V;ce++)if(W.charCodeAt(ce)!==re.charCodeAt(ce))return ce;return V}e.commonPrefixLength=F;function U(W,re){let ce,V=Math.min(W.length,re.length);const Z=W.length-1,ae=re.length-1;for(ce=0;ce<V;ce++)if(W.charCodeAt(Z-ce)!==re.charCodeAt(ae-ce))return ce;return V}e.commonSuffixLength=U;function J(W){return 55296<=W&&W<=56319}e.isHighSurrogate=J;function me(W){return 56320<=W&&W<=57343}e.isLowSurrogate=me;function q(W,re){return(W-55296<<10)+(re-56320)+65536}e.computeCodePoint=q;function z(W,re,ce){const V=W.charCodeAt(ce);if(J(V)&&ce+1<re){const Z=W.charCodeAt(ce+1);if(me(Z))return q(V,Z)}return V}e.getNextCodePoint=z;function ee(W,re){const ce=W.charCodeAt(re-1);if(me(ce)&&re>1){const V=W.charCodeAt(re-2);if(J(V))return q(V,ce)}return ce}function $(W,re){const ce=xe.getInstance(),V=re,Z=W.length,ae=z(W,Z,re);re+=ae>=65536?2:1;let he=ce.getGraphemeBreakType(ae);for(;re<Z;){const ye=z(W,Z,re),ze=ce.getGraphemeBreakType(ye);if(Le(he,ze))break;re+=ye>=65536?2:1,he=ze}return re-V}e.nextCharLength=$;function R(W,re){const ce=xe.getInstance(),V=re,Z=ee(W,re);re-=Z>=65536?2:1;let ae=ce.getGraphemeBreakType(Z);for(;re>0;){const he=ee(W,re),ye=ce.getGraphemeBreakType(he);if(Le(ye,ae))break;re-=he>=65536?2:1,ae=ye}return V-re}e.prevCharLength=R;function M(W,re){const ce=xe.getInstance(),V=W.length,Z=re,ae=z(W,V,re),he=ce.getGraphemeBreakType(ae);re+=ae>=65536?2:1;let ye=he;for(;re<V;){const $e=z(W,V,re),Be=ce.getGraphemeBreakType($e);if(Le(ye,Be))break;re+=$e>=65536?2:1,ye=Be}const ze=re;for(re=Z,ye=he;re>0;){const $e=ee(W,re),Be=ce.getGraphemeBreakType($e);if(Le(Be,ye))break;re-=$e>=65536?2:1,ye=Be}return[re,ze]}function x(W,re){return re>0&&me(W.charCodeAt(re))?M(W,re-1):M(W,re)}e.getCharContainingOffset=x;function O(W){const re=W.length;let ce=0,V=0;for(;V<re;){const he=z(W,re,V);V+=he>=65536?2:1,he<128?ce+=1:he<2048?ce+=2:he<65536?ce+=3:ce+=4}const Z=new Uint8Array(ce);V=0;let ae=0;for(;V<re;){const he=z(W,re,V);V+=he>=65536?2:1,he<128?Z[ae++]=he:he<2048?(Z[ae++]=192|(he&1984)>>>6,Z[ae++]=128|(he&63)>>>0):he<65536?(Z[ae++]=224|(he&61440)>>>12,Z[ae++]=128|(he&4032)>>>6,Z[ae++]=128|(he&63)>>>0):(Z[ae++]=240|(he&1835008)>>>18,Z[ae++]=128|(he&258048)>>>12,Z[ae++]=128|(he&4032)>>>6,Z[ae++]=128|(he&63)>>>0)}return Z}e.encodeUTF8=O;function G(W){const re=W.byteLength,ce=[];let V=0;for(;V<re;){const Z=W[V];let ae;if(Z>=240&&V+3<re?ae=(W[V++]&7)<<18>>>0|(W[V++]&63)<<12>>>0|(W[V++]&63)<<6>>>0|(W[V++]&63)<<0>>>0:Z>=224&&V+2<re?ae=(W[V++]&15)<<12>>>0|(W[V++]&63)<<6>>>0|(W[V++]&63)<<0>>>0:Z>=192&&V+1<re?ae=(W[V++]&31)<<6>>>0|(W[V++]&63)<<0>>>0:ae=W[V++],ae>=0&&ae<=55295||ae>=57344&&ae<=65535)ce.push(String.fromCharCode(ae));else if(ae>=65536&&ae<=1114111){const he=ae-65536,ye=55296+((he&1047552)>>>10),ze=56320+((he&1023)>>>0);ce.push(String.fromCharCode(ye)),ce.push(String.fromCharCode(ze))}else ce.push(String.fromCharCode(65533))}return ce.join("")}e.decodeUTF8=G;const Y=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ne(W){return Y.test(W)}e.containsRTL=ne;const pe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Ie(W){return pe.test(W)}e.containsEmoji=Ie;const Oe=/^[\t\n\r\x20-\x7E]*$/;function Te(W){return Oe.test(W)}e.isBasicASCII=Te,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ue(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=Ue;function B(W){for(let re=0,ce=W.length;re<ce;re++)if(K(W.charCodeAt(re)))return!0;return!1}e.containsFullWidthCharacter=B;function K(W){return W=+W,W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=K;function ie(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129003||W>=129280&&W<=129535||W>=129648&&W<=129750}e.isEmojiImprecise=ie;function le(W,re){if(W.length<re)return W;const ce=/\b/g;let V=0;for(;ce.test(W)&&!(W.length-ce.lastIndex<re);)V=ce.lastIndex,ce.lastIndex+=1;return W.substring(V).replace(/^\s/,"")}e.lcut=le;const fe=/\x1B\x5B[12]?K/g,Se=/\x1b\[\d+m/g,Ne=/\x1b\[0?m/g;function ge(W){return W&&(W=W.replace(fe,""),W=W.replace(Se,""),W=W.replace(Ne,"")),W}e.removeAnsiEscapeCodes=ge,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Ae(W){return Ce(W)?W.substr(1):W}e.stripUTF8BOM=Ae;function We(W,re){if(!W||!re||W.length<re.length)return!1;const ce=re.length,V=W.toLowerCase();let Z=0,ae=-1;for(;Z<ce;){const he=V.indexOf(re[Z],ae+1);if(he<0)return!1;ae=he,Z++}return!0}e.fuzzyContains=We;function Ee(W,re=!1){return W?(re&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=Ee;function je(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=je;function H(W,re=1){if(re===0)return"";let ce=-1;do ce=W.indexOf(`
`,ce+1),re--;while(re>0&&ce>=0);return ce===-1?W:(W[ce-1]==="\r"&&ce--,W.substr(0,ce))}e.getNLines=H;function te(W){const re=90-65+1;return W=W%(2*re),W<re?String.fromCharCode(97+W):String.fromCharCode(65+W-re)}e.singleLetterHash=te;function ve(W){return xe.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=ve;function Le(W,re){return W===0?re!==5&&re!==7:W===2&&re===3?!1:W===4||W===2||W===3||re===4||re===2||re===3?!0:!(W===8&&(re===8||re===9||re===11||re===12)||(W===11||W===9)&&(re===9||re===10)||(W===12||W===10)&&re===10||re===5||re===13||re===7||W===1||W===13&&re===14||W===6&&re===6)}e.breakBetweenGraphemeBreakType=Le;var He;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})(He=e.GraphemeBreakType||(e.GraphemeBreakType={}));class xe{constructor(){this._data=Xe()}static getInstance(){return xe._INSTANCE||(xe._INSTANCE=new xe),xe._INSTANCE}getGraphemeBreakType(re){if(re<32)return re===10?3:re===13?2:4;if(re<127)return 0;const ce=this._data,V=ce.length/3;let Z=1;for(;Z<=V;)if(re<ce[3*Z])Z=2*Z;else if(re>ce[3*Z+1])Z=2*Z+1;else return ce[3*Z+2];return 0}}xe._INSTANCE=null;function Xe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(be[23],_e([0,1,8,109]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",y=typeof TextDecoder!="undefined";let C,S;class k{constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}static alloc(b){return A?new k(Buffer.allocUnsafe(b)):new k(new Uint8Array(b))}static wrap(b){return A&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new k(b)}static fromString(b,_){return!((_==null?void 0:_.dontUseNodeBuffer)||!1)&&A?new k(Buffer.from(b)):T?(C||(C=new TextEncoder),new k(C.encode(b))):new k(w.encodeUTF8(b))}static concat(b,_){if(typeof _=="undefined"){_=0;for(let F=0,U=b.length;F<U;F++)_+=b[F].byteLength}const v=k.alloc(_);let E=0;for(let F=0,U=b.length;F<U;F++){const J=b[F];v.set(J,E),E+=J.byteLength}return v}toString(){return A?this.buffer.toString():y?(S||(S=new TextDecoder),S.decode(this.buffer)):w.decodeUTF8(this.buffer)}slice(b,_){return new k(this.buffer.subarray(b,_))}set(b,_){b instanceof k?this.buffer.set(b.buffer,_):this.buffer.set(b,_)}readUInt32BE(b){return c(this.buffer,b)}writeUInt32BE(b,_){d(this.buffer,b,_)}readUInt32LE(b){return o(this.buffer,b)}writeUInt32LE(b,_){l(this.buffer,b,_)}readUInt8(b){return g(this.buffer,b)}writeUInt8(b,_){m(this.buffer,b,_)}}e.VSBuffer=k;function i(h,b){return h[b+0]<<0>>>0|h[b+1]<<8>>>0}e.readUInt16LE=i;function P(h,b,_){h[_+0]=b&255,b=b>>>8,h[_+1]=b&255}e.writeUInt16LE=P;function c(h,b){return h[b]*2**24+h[b+1]*2**16+h[b+2]*2**8+h[b+3]}e.readUInt32BE=c;function d(h,b,_){h[_+3]=b,b=b>>>8,h[_+2]=b,b=b>>>8,h[_+1]=b,b=b>>>8,h[_]=b}e.writeUInt32BE=d;function o(h,b){return h[b+0]<<0>>>0|h[b+1]<<8>>>0|h[b+2]<<16>>>0|h[b+3]<<24>>>0}e.readUInt32LE=o;function l(h,b,_){h[_+0]=b&255,b=b>>>8,h[_+1]=b&255,b=b>>>8,h[_+2]=b&255,b=b>>>8,h[_+3]=b&255}e.writeUInt32LE=l;function g(h,b){return h[b]}e.readUInt8=g;function m(h,b,_){h[_]=b}e.writeUInt8=m;function D(h){return I.consumeReadable(h,b=>k.concat(b))}e.readableToBuffer=D;function f(h){return I.toReadable(h)}e.bufferToReadable=f;function u(h){return I.consumeStream(h,b=>k.concat(b))}e.streamToBuffer=u;async function p(h){return h.ended?k.concat(h.buffer):k.concat([...h.buffer,await u(h.stream)])}e.bufferedStreamToBuffer=p;function t(h){return I.toStream(h,b=>k.concat(b))}e.bufferToStream=t;function n(h){return I.transform(h,{data:b=>typeof b=="string"?k.fromString(b):k.wrap(b)},b=>k.concat(b))}e.streamToBufferReadableStream=n;function s(h){return I.newWriteableStream(b=>k.concat(b),h)}e.newWriteableBufferStream=s;function r(h,b){return I.prefixedReadable(h,b,_=>k.concat(_))}e.prefixedBufferReadable=r;function a(h,b){return I.prefixedStream(h,b,_=>k.concat(_))}e.prefixedBufferStream=a}),define(be[56],_e([0,1,8]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function I(m){return A(m,0)}e.hash=I;function A(m,D){switch(typeof m){case"object":return m===null?T(349,D):Array.isArray(m)?S(m,D):k(m,D);case"string":return C(m,D);case"boolean":return y(m,D);case"number":return T(m,D);case"undefined":return T(937,D);default:return T(617,D)}}e.doHash=A;function T(m,D){return(D<<5)-D+m|0}function y(m,D){return T(m?433:863,D)}function C(m,D){D=T(149417,D);for(let f=0,u=m.length;f<u;f++)D=T(m.charCodeAt(f),D);return D}e.stringHash=C;function S(m,D){return D=T(104579,D),m.reduce((f,u)=>A(u,f),D)}function k(m,D){return D=T(181387,D),Object.keys(m).sort().reduce((f,u)=>(f=C(u,f),A(m[u],f)),D)}class i{constructor(){this._value=0}get value(){return this._value}hash(D){return this._value=A(D,this._value),this._value}}e.Hasher=i;var P;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function c(m,D,f=32){const u=f-D,p=~((1<<u)-1);return(m<<D|(p&m)>>>u)>>>0}function d(m,D=0,f=m.byteLength,u=0){for(let p=0;p<f;p++)m[D+p]=u}function o(m,D,f="0"){for(;m.length<D;)m=f+m;return m}function l(m,D=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(f=>f.toString(16).padStart(2,"0")).join(""):o((m>>>0).toString(16),D/4)}e.toHexString=l;class g{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(D){const f=D.length;if(f!==0){const u=this._buff;let p=this._buffLen,t=this._leftoverHighSurrogate,n,s;for(t!==0?(n=t,s=-1,t=0):(n=D.charCodeAt(0),s=0);;){let r=n;if(w.isHighSurrogate(n))if(s+1<f){const a=D.charCodeAt(s+1);w.isLowSurrogate(a)?(s++,r=w.computeCodePoint(n,a)):r=65533}else{t=n;break}else w.isLowSurrogate(n)&&(r=65533);if(p=this._push(u,p,r),s++,s<f)n=D.charCodeAt(s);else break}this._buffLen=p,this._leftoverHighSurrogate=t}}_push(D,f,u){return u<128?D[f++]=u:u<2048?(D[f++]=192|(u&1984)>>>6,D[f++]=128|(u&63)>>>0):u<65536?(D[f++]=224|(u&61440)>>>12,D[f++]=128|(u&4032)>>>6,D[f++]=128|(u&63)>>>0):(D[f++]=240|(u&1835008)>>>18,D[f++]=128|(u&258048)>>>12,D[f++]=128|(u&4032)>>>6,D[f++]=128|(u&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,D[0]=D[64+0],D[1]=D[64+1],D[2]=D[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),l(this._h0)+l(this._h1)+l(this._h2)+l(this._h3)+l(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const D=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(D/4294967296),!1),this._buffDV.setUint32(60,D%4294967296,!1),this._step()}_step(){const D=g._bigBlock32,f=this._buffDV;for(let b=0;b<64;b+=4)D.setUint32(b,f.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)D.setUint32(b,c(D.getUint32(b-12,!1)^D.getUint32(b-32,!1)^D.getUint32(b-56,!1)^D.getUint32(b-64,!1),1),!1);let u=this._h0,p=this._h1,t=this._h2,n=this._h3,s=this._h4,r,a,h;for(let b=0;b<80;b++)b<20?(r=p&t|~p&n,a=1518500249):b<40?(r=p^t^n,a=1859775393):b<60?(r=p&t|p&n|t&n,a=2400959708):(r=p^t^n,a=3395469782),h=c(u,5)+r+s+a+D.getUint32(b*4,!1)&4294967295,s=n,n=t,t=c(p,30),p=u,u=h;this._h0=this._h0+u&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=g,g._bigBlock32=new DataView(new ArrayBuffer(320))}),define(be[47],_e([0,1,8]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(I||(I={})),function(A){const T="error",y="warning",C="warn",S="info",k="ignore";function i(c){return c?w.equalsIgnoreCase(T,c)?A.Error:w.equalsIgnoreCase(y,c)||w.equalsIgnoreCase(C,c)?A.Warning:w.equalsIgnoreCase(S,c)?A.Info:A.Ignore:A.Ignore}A.fromValue=i;function P(c){switch(c){case A.Error:return T;case A.Warning:return y;case A.Info:return S;default:return k}}A.toString=P}(I||(I={})),e.default=I}),define(be[10],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function w(b){return Array.isArray(b)}e.isArray=w;function I(b){return typeof b=="string"}e.isString=I;function A(b){return Array.isArray(b)&&b.every(_=>I(_))}e.isStringArray=A;function T(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}e.isObject=T;function y(b){return typeof b=="number"&&!isNaN(b)}e.isNumber=y;function C(b){return!!b&&typeof b[Symbol.iterator]=="function"}e.isIterable=C;function S(b){return b===!0||b===!1}e.isBoolean=S;function k(b){return typeof b=="undefined"}e.isUndefined=k;function i(b){return!P(b)}e.isDefined=i;function P(b){return k(b)||b===null}e.isUndefinedOrNull=P;function c(b,_){if(!b)throw new Error(_?`Unexpected type, expected '${_}'`:"Unexpected type")}e.assertType=c;function d(b){if(P(b))throw new Error("Assertion Failed: argument is undefined or null");return b}e.assertIsDefined=d;function o(...b){const _=[];for(let v=0;v<b.length;v++){const E=b[v];if(P(E))throw new Error(`Assertion Failed: argument at index ${v} is undefined or null`);_.push(E)}return _}e.assertAllDefined=o;const l=Object.prototype.hasOwnProperty;function g(b){if(!T(b))return!1;for(let _ in b)if(l.call(b,_))return!1;return!0}e.isEmptyObject=g;function m(b){return typeof b=="function"}e.isFunction=m;function D(...b){return b.length>0&&b.every(m)}e.areFunctions=D;function f(b,_){const v=Math.min(b.length,_.length);for(let E=0;E<v;E++)u(b[E],_[E])}e.validateConstraints=f;function u(b,_){if(I(_)){if(typeof b!==_)throw new Error(`argument does not match constraint: typeof ${_}`)}else if(m(_)){try{if(b instanceof _)return}catch(v){}if(!P(b)&&b.constructor===_||_.length===1&&_.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function p(b){let _=[],v=Object.getPrototypeOf(b);for(;Object.prototype!==v;)_=_.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return _}e.getAllPropertyNames=p;function t(b){const _=[];for(const v of p(b))typeof b[v]=="function"&&_.push(v);return _}e.getAllMethodNames=t;function n(b,_){const v=F=>function(){const U=Array.prototype.slice.call(arguments,0);return _(F,U)};let E={};for(const F of b)E[F]=v(F);return E}e.createProxyObject=n;function s(b){return b===null?void 0:b}e.withNullAsUndefined=s;function r(b){return typeof b=="undefined"?null:b}e.withUndefinedAsNull=r;function a(b){return class{constructor(){return new Proxy({},{get(_,v){if(_[v])return _[v];throw new Error(`Not Implemented: ${b}->${String(v)}`)}})}}}e.NotImplementedProxy=a;function h(b){throw new Error("Unreachable")}e.assertNever=h}),define(be[37],_e([0,1,21,8,13,10]),function(Q,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function y(n){return n===47||n===92}e.isPathSeparator=y;function C(n){return n.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=C;function S(n,s=A.posix.sep){if(!n)return"";const r=n.length,a=n.charCodeAt(0);if(y(a)){if(y(n.charCodeAt(1))&&!y(n.charCodeAt(2))){let b=3;const _=b;for(;b<r&&!y(n.charCodeAt(b));b++);if(_!==b&&!y(n.charCodeAt(b+1))){for(b+=1;b<r;b++)if(y(n.charCodeAt(b)))return n.slice(0,b+1).replace(/[\\/]/g,s)}}return s}else if(g(a)&&n.charCodeAt(1)===58)return y(n.charCodeAt(2))?n.slice(0,2)+s:n.slice(0,2);let h=n.indexOf("://");if(h!==-1){for(h+=3;h<r;h++)if(y(n.charCodeAt(h)))return n.slice(0,h+1)}return""}e.getRoot=S;function k(n){if(!w.isWindows||!n||n.length<5)return!1;let s=n.charCodeAt(0);if(s!==92||(s=n.charCodeAt(1),s!==92))return!1;let r=2;const a=r;for(;r<n.length&&(s=n.charCodeAt(r),s!==92);r++);return!(a===r||(s=n.charCodeAt(r+1),isNaN(s)||s===92))}e.isUNC=k;const i=/[\\/:\*\?"<>\|]/g,P=/[\\/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(n,s=w.isWindows){const r=s?i:P;return!(!n||n.length===0||/^\s+$/.test(n)||(r.lastIndex=0,r.test(n))||s&&c.test(n)||n==="."||n===".."||s&&n[n.length-1]==="."||s&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=d;function o(n,s,r){const a=n===s;return!r||a?a:!n||!s?!1:(0,I.equalsIgnoreCase)(n,s)}e.isEqual=o;function l(n,s,r,a=A.sep){if(n===s)return!0;if(!n||!s||s.length>n.length)return!1;if(r){if(!(0,I.startsWithIgnoreCase)(n,s))return!1;if(s.length===n.length)return!0;let b=s.length;return s.charAt(s.length-1)===a&&b--,n.charAt(b)===a}return s.charAt(s.length-1)!==a&&(s+=a),n.indexOf(s)===0}e.isEqualOrParent=l;function g(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=g;function m(n,s){return w.isWindows&&n.endsWith(":")&&(n+=A.sep),(0,A.isAbsolute)(n)||(n=(0,A.join)(s,n)),n=(0,A.normalize)(n),w.isWindows?(n=(0,I.rtrim)(n,A.sep),n.endsWith(":")&&(n+=A.sep)):(n=(0,I.rtrim)(n,A.sep),n||(n=A.sep)),n}e.sanitizeFilePath=m;function D(n){const s=(0,A.normalize)(n);return w.isWindows?n.length>3?!1:f(s)&&(n.length===2||s.charCodeAt(2)===92):s===A.posix.sep}e.isRootOrDriveLetter=D;function f(n){return w.isWindows?g(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function u(n){return f(n)?n[0]:void 0}e.getDriveLetter=u;function p(n,s,r){return s.length>n.length?-1:n===s?0:(r&&(n=n.toLowerCase(),s=s.toLowerCase()),n.indexOf(s))}e.indexOfPath=p;function t(n){const s=n.split(":");let r,a,h;if(s.forEach(b=>{const _=Number(b);(0,T.isNumber)(_)?a===void 0?a=_:h===void 0&&(h=_):r=r?[r,b].join(":"):b}),!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:a!==void 0?a:void 0,column:h!==void 0?h:a!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(be[24],_e([0,1,10]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function I(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const l=Array.isArray(o)?[]:{};return Object.keys(o).forEach(g=>{o[g]&&typeof o[g]=="object"?l[g]=I(o[g]):l[g]=o[g]}),l}e.deepClone=I;function A(o){if(!o||typeof o!="object")return o;const l=[o];for(;l.length>0;){const g=l.shift();Object.freeze(g);for(const m in g)if(T.call(g,m)){const D=g[m];typeof D=="object"&&!Object.isFrozen(D)&&l.push(D)}}return o}e.deepFreeze=A;const T=Object.prototype.hasOwnProperty;function y(o,l){return C(o,l,new Set)}e.cloneAndChange=y;function C(o,l,g){if((0,w.isUndefinedOrNull)(o))return o;const m=l(o);if(typeof m!="undefined")return m;if((0,w.isArray)(o)){const D=[];for(const f of o)D.push(C(f,l,g));return D}if((0,w.isObject)(o)){if(g.has(o))throw new Error("Cannot clone recursive data-structure");g.add(o);const D={};for(let f in o)T.call(o,f)&&(D[f]=C(o[f],l,g));return g.delete(o),D}return o}function S(o,l,g=!0){return(0,w.isObject)(o)?((0,w.isObject)(l)&&Object.keys(l).forEach(m=>{m in o?g&&((0,w.isObject)(o[m])&&(0,w.isObject)(l[m])?S(o[m],l[m],g):o[m]=l[m]):o[m]=l[m]}),o):l}e.mixin=S;function k(o,l){if(o===l)return!0;if(o==null||l===null||l===void 0||typeof o!=typeof l||typeof o!="object"||Array.isArray(o)!==Array.isArray(l))return!1;let g,m;if(Array.isArray(o)){if(o.length!==l.length)return!1;for(g=0;g<o.length;g++)if(!k(o[g],l[g]))return!1}else{const D=[];for(m in o)D.push(m);D.sort();const f=[];for(m in l)f.push(m);if(f.sort(),!k(D,f))return!1;for(g=0;g<D.length;g++)if(!k(o[D[g]],l[D[g]]))return!1}return!0}e.equals=k;function i(o){const l=new Set;return JSON.stringify(o,(g,m)=>{if((0,w.isObject)(m)||Array.isArray(m)){if(l.has(m))return"[Circular]";l.add(m)}return m})}e.safeStringify=i;function P(o,l,g){const m=l(o);return typeof m=="undefined"?g:m}e.getOrDefault=P;function c(o,l){const g=Object.create(null);return!o||!l||Object.keys(l).forEach(D=>{const f=o[D],u=l[D];k(f,u)||(g[D]=u)}),g}e.distinct=c;function d(o,l){const g=l.toLowerCase(),m=Object.keys(o).find(D=>D.toLowerCase()===g);return m?o[m]:o[l]}e.getCaseInsensitive=d}),define(be[82],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var w;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(w=e.Constants||(e.Constants={}));function I(T){return T<0?0:T>255?255:T|0}e.toUint8=I;function A(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=A}),define(be[2],_e([0,1,21,13]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,T=/^\//,y=/^\/\//;function C(s,r){if(!s.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!A.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!T.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(s,r){return!s&&!r?"file":s}function k(s,r){switch(s){case"https":case"http":case"file":r?r[0]!==P&&(r=P+r):r=P;break}return r}const i="",P="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{constructor(r,a,h,b,_,v=!1){typeof r=="object"?(this.scheme=r.scheme||i,this.authority=r.authority||i,this.path=r.path||i,this.query=r.query||i,this.fragment=r.fragment||i):(this.scheme=S(r,v),this.authority=a||i,this.path=k(this.scheme,h||i),this.query=b||i,this.fragment=_||i,C(this,v))}static isUri(r){return r instanceof d?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return f(this,!1)}with(r){if(!r)return this;let{scheme:a,authority:h,path:b,query:_,fragment:v}=r;return a===void 0?a=this.scheme:a===null&&(a=i),h===void 0?h=this.authority:h===null&&(h=i),b===void 0?b=this.path:b===null&&(b=i),_===void 0?_=this.query:_===null&&(_=i),v===void 0?v=this.fragment:v===null&&(v=i),a===this.scheme&&h===this.authority&&b===this.path&&_===this.query&&v===this.fragment?this:new l(a,h,b,_,v)}static parse(r,a=!1){const h=c.exec(r);return h?new l(h[2]||i,n(h[4]||i),n(h[5]||i),n(h[7]||i),n(h[9]||i),a):new l(i,i,i,i,i)}static file(r){let a=i;if(w.isWindows&&(r=r.replace(/\\/g,P)),r[0]===P&&r[1]===P){const h=r.indexOf(P,2);h===-1?(a=r.substring(2),r=P):(a=r.substring(2,h),r=r.substring(h)||P)}return new l("file",a,r,i,i)}static from(r){return new l(r.scheme,r.authority,r.path,r.query,r.fragment)}static joinPath(r,...a){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return w.isWindows&&r.scheme==="file"?h=d.file(I.win32.join(f(r,!0),...a)).path:h=I.posix.join(r.path,...a),r.with({path:h})}toString(r=!1){return u(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof d)return r;{const a=new l(r);return a._formatted=r.external,a._fsPath=r._sep===o?r.fsPath:null,a}}else return r}}e.URI=d;const o=w.isWindows?1:void 0;class l extends d{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(r=!1){return r?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=o),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(s,r){let a,h=-1;for(let b=0;b<s.length;b++){const _=s.charCodeAt(b);if(_>=97&&_<=122||_>=65&&_<=90||_>=48&&_<=57||_===45||_===46||_===95||_===126||r&&_===47)h!==-1&&(a+=encodeURIComponent(s.substring(h,b)),h=-1),a!==void 0&&(a+=s.charAt(b));else{a===void 0&&(a=s.substr(0,b));const v=g[_];v!==void 0?(h!==-1&&(a+=encodeURIComponent(s.substring(h,b)),h=-1),a+=v):h===-1&&(h=b)}}return h!==-1&&(a+=encodeURIComponent(s.substring(h))),a!==void 0?a:s}function D(s){let r;for(let a=0;a<s.length;a++){const h=s.charCodeAt(a);h===35||h===63?(r===void 0&&(r=s.substr(0,a)),r+=g[h]):r!==void 0&&(r+=s[a])}return r!==void 0?r:s}function f(s,r){let a;return s.authority&&s.path.length>1&&s.scheme==="file"?a=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?r?a=s.path.substr(1):a=s.path[1].toLowerCase()+s.path.substr(2):a=s.path,w.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=f;function u(s,r){const a=r?D:m;let h="",{scheme:b,authority:_,path:v,query:E,fragment:F}=s;if(b&&(h+=b,h+=":"),(_||b==="file")&&(h+=P,h+=P),_){let U=_.indexOf("@");if(U!==-1){const J=_.substr(0,U);_=_.substr(U+1),U=J.indexOf(":"),U===-1?h+=a(J,!1):(h+=a(J.substr(0,U),!1),h+=":",h+=a(J.substr(U+1),!1)),h+="@"}_=_.toLowerCase(),U=_.indexOf(":"),U===-1?h+=a(_,!1):(h+=a(_.substr(0,U),!1),h+=_.substr(U))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const U=v.charCodeAt(1);U>=65&&U<=90&&(v=`/${String.fromCharCode(U+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const U=v.charCodeAt(0);U>=65&&U<=90&&(v=`${String.fromCharCode(U+32)}:${v.substr(2)}`)}h+=a(v,!0)}return E&&(h+="?",h+=a(E,!1)),F&&(h+="#",h+=r?F:m(F,!1)),h}function p(s){try{return decodeURIComponent(s)}catch(r){return s.length>3?s.substr(0,3)+p(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(t)?s.replace(t,r=>p(r)):s}});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Q):I?I.value:e.get(Q)};define(be[22],_e([0,1,2,8]),function(Q,e,w,I){"use strict";var A,T,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(t,n,s){let r=t.get(n);return r===void 0&&(r=s,t.set(n,r)),r}e.getOrSet=C;function S(t){const n=[];return t.forEach((s,r)=>{n.push(`${r} => ${s}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=S;function k(t){const n=[];return t.forEach(s=>{n.push(s)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=k;class i{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),r=this._value.charCodeAt(this._pos);return s-r}value(){return this._value[this._pos]}}e.StringIterator=i;class P{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,I.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class c{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,I.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=c;var d;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(d||(d={}));class o{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new c(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,I.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=o;class l{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class g{constructor(n){this._iter=n}static forUris(n=()=>!1){return new g(new o(n))}static forPaths(){return new g(new c)}static forStrings(){return new g(new i)}static forConfigKeys(){return new g(new P)}clear(){this._root=void 0}set(n,s){const r=this._iter.reset(n);let a;for(this._root||(this._root=new l,this._root.segment=r.value()),a=this._root;;){const b=r.cmp(a.segment);if(b>0)a.left||(a.left=new l,a.left.segment=r.value()),a=a.left;else if(b<0)a.right||(a.right=new l,a.right.segment=r.value()),a=a.right;else if(r.hasNext())r.next(),a.mid||(a.mid=new l,a.mid.segment=r.value()),a=a.mid;else break}const h=a.value;return a.value=s,a.key=n,h}get(n){var s;return(s=this._getNode(n))===null||s===void 0?void 0:s.value}_getNode(n){const s=this._iter.reset(n);let r=this._root;for(;r;){const a=s.cmp(r.segment);if(a>0)r=r.left;else if(a<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else break}return r}has(n){const s=this._getNode(n);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const r=this._iter.reset(n),a=[];let h=this._root;for(;h;){const b=r.cmp(h.segment);if(b>0)a.push([1,h]),h=h.left;else if(b<0)a.push([-1,h]),h=h.right;else if(r.hasNext())r.next(),a.push([0,h]),h=h.mid;else{for(s?(h.left=void 0,h.mid=void 0,h.right=void 0):h.value=void 0;a.length>0&&h.isEmpty();){let[_,v]=a.pop();switch(_){case 1:v.left=void 0;break;case 0:v.mid=void 0;break;case-1:v.right=void 0;break}h=v}break}}}findSubstr(n){const s=this._iter.reset(n);let r=this._root,a;for(;r;){const h=s.cmp(r.segment);if(h>0)r=r.left;else if(h<0)r=r.right;else if(s.hasNext())s.next(),a=r.value||a,r=r.mid;else break}return r&&r.value||a}findSuperstr(n){const s=this._iter.reset(n);let r=this._root;for(;r;){const a=s.cmp(r.segment);if(a>0)r=r.left;else if(a<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(n){for(const[s,r]of this)n(r,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=g;class m{constructor(n,s){this[A]="ResourceMap",n instanceof m?(this.map=new Map(n.map),this.toKey=s!=null?s:m.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:m.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),s),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s!="undefined"&&(n=n.bind(s));for(let[r,a]of this.map)n(a,w.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield w.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[w.URI.parse(n[0]),n[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[w.URI.parse(n[0]),n[1]]}}e.ResourceMap=m,m.defaultToKey=t=>t.toString();var D;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(D=e.Touch||(e.Touch={}));class f{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,s=0){const r=this._map.get(n);if(!!r)return s!==0&&this.touch(r,s),r.value}set(n,s,r=0){let a=this._map.get(n);if(a)a.value=s,r!==0&&this.touch(a,r);else{switch(a={key:n,value:s,next:void 0,previous:void 0},r){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(n,a),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,s){const r=this._state;let a=this._head;for(;a;){if(s?n.bind(s)(a.value,a.key,this):n(a.value,a.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const n=this,s=this._state;let r=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const h={value:r.key,done:!1};return r=r.next,h}else return{value:void 0,done:!0}}};return a}values(){const n=this,s=this._state;let r=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const h={value:r.value,done:!1};return r=r.next,h}else return{value:void 0,done:!0}}};return a}entries(){const n=this,s=this._state;let r=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const h={value:[r.key,r.value],done:!1};return r=r.next,h}else return{value:void 0,done:!0}}};return a}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let s=this._head,r=this.size;for(;s&&r>n;)this._map.delete(s.key),s=s.next,r--;this._head=s,this._size=r,s&&(s.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,r=n.previous;if(!s||!r)throw new Error("Invalid list");s.previous=r,r.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const r=n.next,a=n.previous;n===this._tail?(a.next=void 0,this._tail=a):(r.previous=a,a.next=r),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const r=n.next,a=n.previous;n===this._head?(r.previous=void 0,this._head=r):(r.previous=a,a.next=r),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,r)=>{n.push([r,s])}),n}fromJSON(n){this.clear();for(const[s,r]of n)this.set(s,r)}}e.LinkedMap=f;class u extends f{constructor(n,s=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u;class p{constructor(n){y.set(this,void 0),tt(this,y,n,"f")}get size(){return Me(this,y,"f").size}forEach(n,s){Me(this,y,"f").forEach(n,s)}get(n){return Me(this,y,"f").get(n)}has(n){return Me(this,y,"f").has(n)}entries(){return Me(this,y,"f").entries()}keys(){return Me(this,y,"f").keys()}values(){return Me(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return Me(this,y,"f").entries()}}e.ReadonlyMapView=p}),define(be[110],_e([0,1,22,8]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function A(...ge){return function(Ce,Ae){for(let We=0,Ee=ge.length;We<Ee;We++){const je=ge[We](Ce,Ae);if(je)return je}return null}}e.or=A,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(ge,Ce,Ae){if(!Ae||Ae.length<Ce.length)return null;let We;return ge?We=I.startsWithIgnoreCase(Ae,Ce):We=Ae.indexOf(Ce)===0,We?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function y(ge,Ce){const Ae=Ce.toLowerCase().indexOf(ge.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+ge.length}]}e.matchesContiguousSubString=y;function C(ge,Ce){return S(ge.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=C;function S(ge,Ce,Ae,We){if(Ae===ge.length)return[];if(We===Ce.length)return null;if(ge[Ae]===Ce[We]){let Ee=null;return(Ee=S(ge,Ce,Ae+1,We+1))?m({start:We,end:We+1},Ee):null}return S(ge,Ce,Ae,We+1)}function k(ge){return 97<=ge&&ge<=122}function i(ge){return 65<=ge&&ge<=90}e.isUpper=i;function P(ge){return 48<=ge&&ge<=57}function c(ge){return ge===32||ge===9||ge===10||ge===13}const d=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(ge=>d.add(ge.charCodeAt(0)));function o(ge){return c(ge)||d.has(ge)}function l(ge,Ce){return ge===Ce||o(ge)&&o(Ce)}function g(ge){return k(ge)||i(ge)||P(ge)}function m(ge,Ce){return Ce.length===0?Ce=[ge]:ge.end===Ce[0].start?Ce[0].start=ge.start:Ce.unshift(ge),Ce}function D(ge,Ce){for(let Ae=Ce;Ae<ge.length;Ae++){const We=ge.charCodeAt(Ae);if(i(We)||P(We)||Ae>0&&!g(ge.charCodeAt(Ae-1)))return Ae}return ge.length}function f(ge,Ce,Ae,We){if(Ae===ge.length)return[];if(We===Ce.length)return null;if(ge[Ae]!==Ce[We].toLowerCase())return null;{let Ee=null,je=We+1;for(Ee=f(ge,Ce,Ae+1,We+1);!Ee&&(je=D(Ce,je))<Ce.length;)Ee=f(ge,Ce,Ae+1,je),je++;return Ee===null?null:m({start:We,end:We+1},Ee)}}function u(ge){let Ce=0,Ae=0,We=0,Ee=0,je=0;for(let He=0;He<ge.length;He++)je=ge.charCodeAt(He),i(je)&&Ce++,k(je)&&Ae++,g(je)&&We++,P(je)&&Ee++;const H=Ce/ge.length,te=Ae/ge.length,ve=We/ge.length,Le=Ee/ge.length;return{upperPercent:H,lowerPercent:te,alphaPercent:ve,numericPercent:Le}}function p(ge){const{upperPercent:Ce,lowerPercent:Ae}=ge;return Ae===0&&Ce>.6}function t(ge){const{upperPercent:Ce,lowerPercent:Ae,alphaPercent:We,numericPercent:Ee}=ge;return Ae>.2&&Ce<.8&&We>.6&&Ee<.2}function n(ge){let Ce=0,Ae=0,We=0,Ee=0;for(let je=0;je<ge.length;je++)We=ge.charCodeAt(je),i(We)&&Ce++,k(We)&&Ae++,c(We)&&Ee++;return(Ce===0||Ae===0)&&Ee===0?ge.length<=30:Ce<=5}function s(ge,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!n(ge)||Ce.length>60)return null;const Ae=u(Ce);if(!t(Ae)){if(!p(Ae))return null;Ce=Ce.toLowerCase()}let We=null,Ee=0;for(ge=ge.toLowerCase();Ee<Ce.length&&(We=f(ge,Ce,0,Ee))===null;)Ee=D(Ce,Ee+1);return We}e.matchesCamelCase=s;function r(ge,Ce,Ae=!1){if(!Ce||Ce.length===0)return null;let We=null,Ee=0;for(ge=ge.toLowerCase(),Ce=Ce.toLowerCase();Ee<Ce.length&&(We=a(ge,Ce,0,Ee,Ae))===null;)Ee=h(Ce,Ee+1);return We}e.matchesWords=r;function a(ge,Ce,Ae,We,Ee){if(Ae===ge.length)return[];if(We===Ce.length)return null;if(l(ge.charCodeAt(Ae),Ce.charCodeAt(We))){let je=null,H=We+1;if(je=a(ge,Ce,Ae+1,We+1,Ee),!Ee)for(;!je&&(H=h(Ce,H))<Ce.length;)je=a(ge,Ce,Ae+1,H,Ee),H++;return je===null?null:m({start:We,end:We+1},je)}else return null}function h(ge,Ce){for(let Ae=Ce;Ae<ge.length;Ae++)if(o(ge.charCodeAt(Ae))||Ae>0&&o(ge.charCodeAt(Ae-1)))return Ae;return ge.length}const b=A(e.matchesPrefix,s,y),_=A(e.matchesPrefix,s,C),v=new w.LRUCache(1e4);function E(ge,Ce,Ae=!1){if(typeof ge!="string"||typeof Ce!="string")return null;let We=v.get(ge);We||(We=new RegExp(I.convertSimple2RegExpPattern(ge),"i"),v.set(ge,We));const Ee=We.exec(Ce);return Ee?[{start:Ee.index,end:Ee.index+Ee[0].length}]:Ae?_(ge,Ce):b(ge,Ce)}e.matchesFuzzy=E;function F(ge,Ce){const Ae=B(ge,ge.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return Ae?J(Ae):null}e.matchesFuzzy2=F;function U(ge,Ce,Ae,We,Ee,je){const H=Math.min(13,ge.length);for(;Ae<H;Ae++){const te=B(ge,Ce,Ae,We,Ee,je,!1);if(te)return te}return[0,je]}e.anyScore=U;function J(ge){if(typeof ge=="undefined")return[];const Ce=[],Ae=ge[1];for(let We=ge.length-1;We>1;We--){const Ee=ge[We]+Ae,je=Ce[Ce.length-1];je&&je.end===Ee?je.end=Ee+1:Ce.push({start:Ee,end:Ee+1})}return Ce}e.createMatches=J;const me=128;function q(){const ge=[],Ce=[];for(let Ae=0;Ae<=me;Ae++)Ce[Ae]=0;for(let Ae=0;Ae<=me;Ae++)ge.push(Ce.slice(0));return ge}function z(ge){const Ce=[];for(let Ae=0;Ae<=ge;Ae++)Ce[Ae]=0;return Ce}const ee=z(2*me),$=z(2*me),R=q(),M=q(),x=q(),O=!1;function G(ge,Ce,Ae,We,Ee){function je(te,ve,Le=" "){for(;te.length<ve;)te=Le+te;return te}let H=` |   |${We.split("").map(te=>je(te,3)).join("|")}
`;for(let te=0;te<=Ae;te++)te===0?H+=" |":H+=`${Ce[te-1]}|`,H+=ge[te].slice(0,Ee+1).map(ve=>je(ve.toString(),3)).join("|")+`
`;return H}function Y(ge,Ce,Ae,We){ge=ge.substr(Ce),Ae=Ae.substr(We),console.log(G(M,ge,ge.length,Ae,Ae.length)),console.log(G(x,ge,ge.length,Ae,Ae.length)),console.log(G(R,ge,ge.length,Ae,Ae.length))}function ne(ge,Ce){if(Ce<0||Ce>=ge.length)return!1;const Ae=ge.codePointAt(Ce);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise(Ae)}}function pe(ge,Ce){if(Ce<0||Ce>=ge.length)return!1;switch(ge.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function Ie(ge,Ce,Ae){return Ce[ge]!==Ae[ge]}function Oe(ge,Ce,Ae,We,Ee,je,H=!1){for(;Ce<Ae&&Ee<je;)ge[Ce]===We[Ee]&&(H&&(ee[Ce]=Ee),Ce+=1),Ee+=1;return Ce===Ae}e.isPatternInWord=Oe;var Te;(function(ge){ge[ge.Diag=1]="Diag",ge[ge.Left=2]="Left",ge[ge.LeftLeft=3]="LeftLeft"})(Te||(Te={}));var Ue;(function(ge){ge.Default=[-100,0];function Ce(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}ge.isDefault=Ce})(Ue=e.FuzzyScore||(e.FuzzyScore={}));function B(ge,Ce,Ae,We,Ee,je,H){const te=ge.length>me?me:ge.length,ve=We.length>me?me:We.length;if(!(Ae>=te||je>=ve||te-Ae>ve-je)&&!!Oe(Ce,Ae,te,Ee,je,ve,!0)){K(te,ve,Ae,je,Ce,Ee);let Le=1,He=1,xe=Ae,Xe=je;const W=[!1];for(Le=1,xe=Ae;xe<te;Le++,xe++){const ae=ee[xe],he=$[xe],ye=xe+1<te?$[xe+1]:ve;for(He=ae-je+1,Xe=ae;Xe<ye;He++,Xe++){let ze=Number.MIN_SAFE_INTEGER,$e=!1;Xe<=he&&(ze=ie(ge,Ce,xe,Ae,We,Ee,Xe,ve,je,R[Le-1][He-1]===0,W));let Be=0;ze!==Number.MAX_SAFE_INTEGER&&($e=!0,Be=ze+M[Le-1][He-1]);const Ge=Xe>ae,nt=Ge?M[Le][He-1]+(R[Le][He-1]>0?-5:0):0,dt=Xe>ae+1&&R[Le][He-1]>0,it=dt?M[Le][He-2]+(R[Le][He-2]>0?-5:0):0;if(dt&&(!Ge||it>=nt)&&(!$e||it>=Be))M[Le][He]=it,x[Le][He]=3,R[Le][He]=0;else if(Ge&&(!$e||nt>=Be))M[Le][He]=nt,x[Le][He]=2,R[Le][He]=0;else if($e)M[Le][He]=Be,x[Le][He]=1,R[Le][He]=R[Le-1][He-1]+1;else throw new Error("not possible")}}if(O&&Y(ge,Ae,We,je),!(!W[0]&&!H)){Le--,He--;const re=[M[Le][He],je];let ce=0,V=0;for(;Le>=1;){let ae=He;do{const he=x[Le][ae];if(he===3)ae=ae-2;else if(he===2)ae=ae-1;else break}while(ae>=1);ce>1&&Ce[Ae+Le-1]===Ee[je+He-1]&&!Ie(ae+je-1,We,Ee)&&ce+1>R[Le][ae]&&(ae=He),ae===He?ce++:ce=1,V||(V=ae),Le--,He=ae-1,re.push(He)}ve===te&&(re[0]+=2);const Z=V-te;return re[0]-=Z,re}}}e.fuzzyScore=B;function K(ge,Ce,Ae,We,Ee,je){let H=ge-1,te=Ce-1;for(;H>=Ae&&te>=We;)Ee[H]===je[te]&&($[H]=te,H--),te--}function ie(ge,Ce,Ae,We,Ee,je,H,te,ve,Le,He){if(Ce[Ae]!==je[H])return Number.MIN_SAFE_INTEGER;let xe=1,Xe=!1;return H===Ae-We?xe=ge[Ae]===Ee[H]?7:5:Ie(H,Ee,je)&&(H===0||!Ie(H-1,Ee,je))?(xe=ge[Ae]===Ee[H]?7:5,Xe=!0):ne(je,H)&&(H===0||!ne(je,H-1))?xe=5:(ne(je,H-1)||pe(je,H-1))&&(xe=5,Xe=!0),xe>1&&Ae===We&&(He[0]=!0),Xe||(Xe=Ie(H,Ee,je)||ne(je,H-1)||pe(je,H-1)),Ae===We?H>ve&&(xe-=Xe?3:5):Le?xe+=Xe?2:0:xe+=Xe?0:1,H+1===te&&(xe-=Xe?3:5),xe}function le(ge,Ce,Ae,We,Ee,je,H){return Se(ge,Ce,Ae,We,Ee,je,!0,H)}e.fuzzyScoreGracefulAggressive=le;function fe(ge,Ce,Ae,We,Ee,je,H){return Se(ge,Ce,Ae,We,Ee,je,!1,H)}e.fuzzyScoreGraceful=fe;function Se(ge,Ce,Ae,We,Ee,je,H,te){let ve=B(ge,Ce,Ae,We,Ee,je,te);if(ve&&!H)return ve;if(ge.length>=3){const Le=Math.min(7,ge.length-1);for(let He=Ae+1;He<Le;He++){const xe=Ne(ge,He);if(xe){const Xe=B(xe,xe.toLowerCase(),Ae,We,Ee,je,te);Xe&&(Xe[0]-=3,(!ve||Xe[0]>ve[0])&&(ve=Xe))}}}return ve}function Ne(ge,Ce){if(!(Ce+1>=ge.length)){const Ae=ge[Ce],We=ge[Ce+1];if(Ae!==We)return ge.slice(0,Ce)+We+Ae+ge.slice(Ce+2)}}}),define(be[111],_e([0,1,36,110,8]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${T.source}`,"g");function C(l){return l.replace(y,(g,m)=>m?g:`\\${g}`)}e.escapeIcons=C;const S=new RegExp(`\\\\${T.source}`,"g");function k(l){return l.replace(S,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=k;const i=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function P(l){return l.indexOf(e.iconStartMarker)===-1?l:l.replace(i,(g,m,D,f)=>D?g:m||f||"")}e.stripIcons=P;function c(l){const g=l.indexOf(e.iconStartMarker);return g===-1?{text:l}:d(l,g)}e.parseLabelWithIcons=c;function d(l,g){const m=[];let D="";function f(h){if(h){D+=h;for(const b of h)m.push(t)}}let u=-1,p="",t=0,n,s,r=g;const a=l.length;for(f(l.substr(0,g));r<a;)n=l[r],s=l[r+1],n===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(u=r,f(p),p=e.iconStartMarker,r++):n===")"&&u!==-1?(t+=r-u+1,u=-1,p=""):u!==-1?/^[a-z0-9\-]$/i.test(n)?p+=n:(f(p),u=-1,p=""):f(n),r++;return f(p),{text:D,iconOffsets:m}}function o(l,g,m=!1){const{text:D,iconOffsets:f}=g;if(!f||f.length===0)return(0,I.matchesFuzzy)(l,D,m);const u=(0,A.ltrim)(D," "),p=D.length-u.length,t=(0,I.matchesFuzzy)(l,u,m);if(t)for(const n of t){const s=f[n.start+p]+p;n.start+=s,n.end+=s}return t}e.matchesFuzzyIconAware=o}),define(be[83],_e([0,1,15,111,12]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(l="",g=!1){var m,D;if(this.value=l,typeof this.value!="string")throw(0,A.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1):(this.isTrusted=(m=g.isTrusted)!==null&&m!==void 0?m:void 0,this.supportThemeIcons=(D=g.supportThemeIcons)!==null&&D!==void 0?D:!1)}appendText(l,g=0){return this.value+=P(this.supportThemeIcons?(0,I.escapeIcons)(l):l).replace(/([ \t]+)/g,(m,D)=>"&nbsp;".repeat(D.length)).replace(/^>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,g){return this.value+="\n```",this.value+=l,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}}e.MarkdownString=y;function C(o){return S(o)?!o.value:Array.isArray(o)?o.every(C):!0}e.isEmptyMarkdownString=C;function S(o){return o instanceof y?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=S;function k(o,l){return!o&&!l?!0:!o||!l?!1:Array.isArray(o)&&Array.isArray(l)?(0,w.equals)(o,l,i):S(o)&&S(l)?i(o,l):!1}e.markedStringsEquals=k;function i(o,l){return o===l?!0:!o||!l?!1:o.value===l.value&&o.isTrusted===l.isTrusted&&o.supportThemeIcons===l.supportThemeIcons}function P(o){return o.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function c(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=c;function d(o){const l=[],g=o.split("|").map(D=>D.trim());o=g[0];const m=g[1];if(m){const D=/height=(\d+)/.exec(m),f=/width=(\d+)/.exec(m),u=D?D[1]:"",p=f?f[1]:"",t=isFinite(parseInt(p)),n=isFinite(parseInt(u));t&&l.push(`width="${p}"`),n&&l.push(`height="${u}"`)}return{href:o,dimensions:l}}e.parseHrefAndDimensions=d}),define(be[57],_e([0,1,23,8,2]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(k){return JSON.stringify(k,C)}e.stringify=T;function y(k){let i=JSON.parse(k);return i=S(i),i}e.parse=y;function C(k,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:(0,I.regExpFlags)(i)}:i}function S(k,i=0){if(!k||i>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return A.URI.revive(k);case 2:return new RegExp(k.source,k.flags)}if(k instanceof w.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let P=0;P<k.length;++P)k[P]=S(k[P],i+1);else for(const P in k)Object.hasOwnProperty.call(k,P)&&(k[P]=S(k[P],i+1))}return k}e.revive=S}),define(be[18],_e([0,1,2,21]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file"})(A=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,k,i){this._hosts[S]=k,this._ports[S]=i}setConnectionToken(S,k){this._connectionTokens[S]=k}rewrite(S){if(this._delegate)return this._delegate(S);const k=S.authority;let i=this._hosts[k];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const P=this._ports[k],c=this._connectionTokens[k];let d=`path=${encodeURIComponent(S.path)}`;return typeof c=="string"&&(d+=`&tkn=${encodeURIComponent(c)}`),w.URI.from({scheme:I.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${i}:${P}`,path:"/vscode-remote-resource",query:d})}}e.RemoteAuthorities=new T;class y{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(S,k,i){const P=this.toUri(S,k);return P.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(P):I.isNative&&(i||I.isPreferringBrowserCodeLoad)&&P.scheme===A.file?P.with({scheme:A.vscodeFileResource,authority:P.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(S,k){const i=this.toUri(S,k);return i.scheme===A.vscodeFileResource?i.with({scheme:A.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(S,k){return w.URI.isUri(S)?S:w.URI.parse(k.toUrl(S))}}e.FileAccess=new y}),define(be[25],_e([0,1,37,13,2,8,18,21]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(d){return(0,A.uriToFsPath)(d,!0)}e.originalFSPath=S;class k{constructor(o){this._ignorePathCasing=o}compare(o,l,g=!1){return o===l?0:(0,T.compare)(this.getComparisonKey(o,g),this.getComparisonKey(l,g))}isEqual(o,l,g=!1){return o===l?!0:!o||!l?!1:this.getComparisonKey(o,g)===this.getComparisonKey(l,g)}getComparisonKey(o,l=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,l,g=!1){if(o.scheme===l.scheme){if(o.scheme===y.Schemas.file)return w.isEqualOrParent(S(o),S(l),this._ignorePathCasing(o))&&o.query===l.query&&(g||o.fragment===l.fragment);if((0,e.isEqualAuthority)(o.authority,l.authority))return w.isEqualOrParent(o.path,l.path,this._ignorePathCasing(o),"/")&&o.query===l.query&&(g||o.fragment===l.fragment)}return!1}joinPath(o,...l){return A.URI.joinPath(o,...l)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return I.posix.basename(o.path)}extname(o){return I.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let l;return o.scheme===y.Schemas.file?l=A.URI.file(I.dirname(S(o))).path:(l=I.posix.dirname(o.path),o.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),l="/")),o.with({path:l})}normalizePath(o){if(!o.path.length)return o;let l;return o.scheme===y.Schemas.file?l=A.URI.file(I.normalize(S(o))).path:l=I.posix.normalize(o.path),o.with({path:l})}relativePath(o,l){if(!(o.scheme!==l.scheme||!(0,e.isEqualAuthority)(o.authority,l.authority))){if(o.scheme===y.Schemas.file){const D=I.relative(S(o),S(l));return C.isWindows?w.toSlashes(D):D}let g=o.path||"/",m=l.path||"/";if(this._ignorePathCasing(o)){let D=0;for(const f=Math.min(g.length,m.length);D<f&&!(g.charCodeAt(D)!==m.charCodeAt(D)&&g.charAt(D).toLowerCase()!==m.charAt(D).toLowerCase());D++);g=m.substr(0,D)+g.substr(D)}return I.posix.relative(g,m)}}resolvePath(o,l){if(o.scheme===y.Schemas.file){const g=A.URI.file(I.resolve(S(o),l));return o.with({authority:g.authority,path:g.path})}return l.indexOf("/")===-1&&(l=w.toSlashes(l),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l)),o.with({path:I.posix.resolve(o.path,l)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,l){return o===l||(0,T.equalsIgnoreCase)(o,l)}hasTrailingPathSeparator(o,l=I.sep){if(o.scheme===y.Schemas.file){const g=S(o);return g.length>w.getRoot(g).length&&g[g.length-1]===l}else{const g=o.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,l=I.sep){return(0,e.hasTrailingPathSeparator)(o,l)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,l=I.sep){let g=!1;if(o.scheme===y.Schemas.file){const m=S(o);g=m!==void 0&&m.length===w.getRoot(m).length&&m[m.length-1]===l}else{l="/";const m=o.path;g=m.length===1&&m.charCodeAt(m.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(o,l)?o.with({path:o.path+"/"}):o}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(d=>d.scheme===y.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new k(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(d,o){const l=[];for(let g=0;g<d.length;g++){const m=o(d[g]);d.some((D,f)=>f===g?!1:(0,e.isEqualOrParent)(m,o(D)))||l.push(d[g])}return l}e.distinctParents=i;var P;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function o(l){const g=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(f=>{const[u,p]=f.split(":");u&&p&&g.set(u,p)});const D=l.path.substring(0,l.path.indexOf(";"));return D&&g.set(d.META_DATA_MIME,D),g}d.parseMetaData=o})(P=e.DataUri||(e.DataUri={}));function c(d,o,l){if(o){let g=d.path;return g&&g[0]!==I.posix.sep&&(g=I.posix.sep+g),d.with({scheme:l,authority:o,path:g})}return d.with({scheme:l})}e.toLocalResource=c}),define(be[11],_e([0,1,20,12,3,6,45,25]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(M){return!!M&&typeof M.then=="function"}e.isThenable=S;function k(M){const x=new w.CancellationTokenSource,O=M(x.token),G=new Promise((Y,ne)=>{x.token.onCancellationRequested(()=>{ne((0,I.canceled)())}),Promise.resolve(O).then(pe=>{x.dispose(),Y(pe)},pe=>{x.dispose(),ne(pe)})});return new class{cancel(){x.cancel()}then(Y,ne){return G.then(Y,ne)}catch(Y){return this.then(void 0,Y)}finally(Y){return G.finally(Y)}}}e.createCancelablePromise=k;function i(M,x,O){return Promise.race([M,new Promise(G=>x.onCancellationRequested(()=>G(O)))])}e.raceCancellation=i;async function P(M){let x=-1;const O=M.map((Y,ne)=>Y.then(pe=>(x=ne,pe))),G=await Promise.race(O);return M.forEach((Y,ne)=>{ne!==x&&Y.cancel()}),G}e.raceCancellablePromises=P;function c(M,x,O){let G;const Y=setTimeout(()=>{G==null||G(void 0),O==null||O()},x);return Promise.race([M.finally(()=>clearTimeout(Y)),new Promise(ne=>G=ne)])}e.raceTimeout=c;function d(M){return new Promise((x,O)=>{const G=M();S(G)?G.then(x,O):x(G)})}e.asPromise=d;class o{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(x){if(this.activePromise){if(this.queuedPromiseFactory=x,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const G=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,G};this.queuedPromise=new Promise(G=>{this.activePromise.then(O,O).then(G)})}return new Promise((O,G)=>{this.queuedPromise.then(O,G)})}return this.activePromise=x(),new Promise((O,G)=>{this.activePromise.then(Y=>{this.activePromise=null,O(Y)},Y=>{this.activePromise=null,G(Y)})})}}e.Throttler=o;class l{constructor(){this.current=Promise.resolve(null)}queue(x){return this.current=this.current.then(()=>x(),()=>x())}}e.Sequencer=l;class g{constructor(){this.promiseMap=new Map}queue(x,O){var G;const ne=((G=this.promiseMap.get(x))!==null&&G!==void 0?G:Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(x)===ne&&this.promiseMap.delete(x)});return this.promiseMap.set(x,ne),ne}}e.SequencerByKey=g;class m{constructor(x){this.defaultDelay=x,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(x,O=this.defaultDelay){return this.task=x,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((G,Y)=>{this.doResolve=G,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const G=this.task;return this.task=null,G()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},O),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,I.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=m;class D{constructor(x){this.delayer=new m(x),this.throttler=new o}trigger(x,O){return this.delayer.trigger(()=>this.throttler.queue(x),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=D;class f{constructor(){this._isOpen=!1,this._promise=new Promise((x,O)=>{this._completePromise=x})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=f;class u extends f{constructor(x){super();this._timeout=setTimeout(()=>this.open(),x)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function p(M,x){return x?new Promise((O,G)=>{const Y=setTimeout(O,M);x.onCancellationRequested(()=>{clearTimeout(Y),G((0,I.canceled)())})}):k(O=>p(M,O))}e.timeout=p;function t(M,x=0){const O=setTimeout(M,x);return(0,T.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=t;function n(M){return M.then(void 0,x=>{})}e.ignoreErrors=n;function s(M){const x=[];let O=0;const G=M.length;function Y(){return O<G?M[O++]():null}function ne(pe){pe!=null&&x.push(pe);const Ie=Y();return Ie?Ie.then(ne):Promise.resolve(x)}return Promise.resolve(null).then(ne)}e.sequence=s;function r(M,x=G=>!!G,O=null){let G=0;const Y=M.length,ne=()=>{if(G>=Y)return Promise.resolve(O);const pe=M[G++];return Promise.resolve(pe()).then(Oe=>x(Oe)?Promise.resolve(Oe):ne())};return ne()}e.first=r;function a(M,x=G=>!!G,O=null){if(M.length===0)return Promise.resolve(O);let G=M.length;const Y=()=>{var ne,pe;G=-1;for(const Ie of M)(pe=(ne=Ie).cancel)===null||pe===void 0||pe.call(ne)};return new Promise((ne,pe)=>{for(const Ie of M)Ie.then(Oe=>{--G>=0&&x(Oe)?(Y(),ne(Oe)):G===0&&ne(O)}).catch(Oe=>{--G>=0&&(Y(),pe(Oe))})})}e.firstParallel=a;class h{constructor(x){this._size=0,this.maxDegreeOfParalellism=x,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(x){return this._size++,new Promise((O,G)=>{this.outstandingPromises.push({factory:x,c:O,e:G}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const x=this.outstandingPromises.shift();this.runningPromises++;const O=x.factory();O.then(x.c,x.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=h;class b extends h{constructor(){super(1)}}e.Queue=b;class _{constructor(){this.queues=new Map}queueFor(x,O=C.extUri){const G=O.getComparisonKey(x);let Y=this.queues.get(G);return Y||(Y=new b,A.Event.once(Y.onFinished)(()=>{Y==null||Y.dispose(),this.queues.delete(G)}),this.queues.set(G,Y)),Y}dispose(){this.queues.forEach(x=>x.dispose()),this.queues.clear()}}e.ResourceQueue=_;class v{constructor(x,O){this._token=-1,typeof x=="function"&&typeof O=="number"&&this.setIfNotSet(x,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(x,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,x()},O)}setIfNotSet(x,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,x()},O))}}e.TimeoutTimer=v;class E{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(x,O){this.cancel(),this._token=setInterval(()=>{x()},O)}}e.IntervalTimer=E;class F{constructor(x,O){this.timeoutToken=-1,this.runner=x,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(x=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,x)}get delay(){return this.timeout}set delay(x){this.timeout=x}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=F;class U extends F{constructor(x,O){super(x,O);this.units=[]}work(x){this.units.push(x),this.isScheduled()||this.schedule()}doRun(){const x=this.units;this.units=[],this.runner&&this.runner(x)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const M=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=x=>{const O=setTimeout(()=>x(M));let G=!1;return{dispose(){G||(G=!0,clearTimeout(O))}}}}else e.runWhenIdle=(M,x)=>{const O=requestIdleCallback(M,typeof x=="number"?{timeout:x}:void 0);let G=!1;return{dispose(){G||(G=!0,cancelIdleCallback(O))}}}}();class J{constructor(x){this._didRun=!1,this._executor=()=>{try{this._value=x()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=J;async function me(M,x,O){let G;for(let Y=0;Y<O;Y++)try{return await M()}catch(ne){G=ne,await p(x)}throw G}e.retry=me;class q{hasPending(x){return this._pending?typeof x=="number"?this._pending.taskId===x:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var x;(x=this._pending)===null||x===void 0||x.cancel()}setPending(x,O,G){return this._pending={taskId:x,cancel:()=>G==null?void 0:G(),promise:O},O.then(()=>this.donePending(x),()=>this.donePending(x)),O}donePending(x){this._pending&&x===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const x=this._next;this._next=void 0,x.run().then(x.promiseResolve,x.promiseReject)}}setNext(x){if(this._next)this._next.run=x;else{let O,G;const Y=new Promise((ne,pe)=>{O=ne,G=pe});this._next={run:x,promise:Y,promiseResolve:O,promiseReject:G}}return this._next.promise}}e.TaskSequentializer=q;class z{constructor(x){this.interval=x,this.lastIncrementTime=0,this.value=0}increment(){const x=Date.now();return x-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=x,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class ee{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((x,O)=>{this.completeCallback=x,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(x){return new Promise(O=>{this.completeCallback(x),this.resolved=!0,O()})}error(x){return new Promise(O=>{this.errorCallback(x),this.rejected=!0,O()})}cancel(){new Promise(x=>{this.errorCallback((0,I.canceled)()),this.rejected=!0,x()})}}e.DeferredPromise=ee;class $ extends A.Emitter{async fireAsync(x,O,G){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const Y of this._listeners)this._asyncDeliveryQueue.push([Y,x]);for(;this._asyncDeliveryQueue.size>0&&!O.isCancellationRequested;){const[Y,ne]=this._asyncDeliveryQueue.shift(),pe=[],Ie=Object.assign(Object.assign({},ne),{waitUntil:Oe=>{if(Object.isFrozen(pe))throw new Error("waitUntil can NOT be called asynchronous");G&&(Oe=G(Oe,typeof Y=="function"?Y:Y[0])),pe.push(Oe)}});try{typeof Y=="function"?Y.call(void 0,Ie):Y[0].call(Y[1],Ie)}catch(Oe){(0,I.onUnexpectedError)(Oe);continue}Object.freeze(pe),await R.settled(pe).catch(Oe=>(0,I.onUnexpectedError)(Oe))}}}}e.AsyncEmitter=$;var R;(function(M){async function x(ne){return typeof Promise.allSettled=="function"?O(ne):G(ne)}M.allSettled=x;async function O(ne){return Promise.allSettled(ne)}async function G(ne){return Promise.all(ne.map(pe=>pe.then(Ie=>({status:"fulfilled",value:Ie}),Ie=>({status:"rejected",reason:Ie}))))}async function Y(ne){let pe;const Ie=await Promise.all(ne.map(Oe=>Oe.then(Te=>Te,Te=>{pe||(pe=Te)})));if(typeof pe!="undefined")throw pe;return Ie}M.settled=Y})(R=e.Promises||(e.Promises={}))}),define(be[112],_e([0,1,13,11]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const A=new I.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),T=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(u,p,t=!1){const n=u||"",s=p||"",r=A.value.collator.compare(n,s);return A.value.collatorIsNumeric&&r===0&&n!==s?n<s?-1:1:r}e.compareFileNames=C;function S(u,p){const t=T.value.collator;return u=u||"",p=p||"",l(t,u,p)}e.compareFileNamesDefault=S;function k(u,p,t=!1){t||(u=u&&u.toLowerCase(),p=p&&p.toLowerCase());const[n,s]=d(u),[r,a]=d(p);return n!==r?n<r?-1:1:s===a?0:s<a?-1:1}e.noIntlCompareFileNames=k;function i(u,p){const[t,n]=d(u),[s,r]=d(p);let a=A.value.collator.compare(n,r);if(a===0){if(A.value.collatorIsNumeric&&n!==r)return n<r?-1:1;if(a=A.value.collator.compare(t,s),A.value.collatorIsNumeric&&a===0&&t!==s)return t<s?-1:1}return a}e.compareFileExtensions=i;function P(u,p){u=u||"",p=p||"";const t=o(u),n=o(p),s=T.value.collator,r=y.value.collator;let a;return a=l(r,t,n),a!==0?a:l(s,u,p)}e.compareFileExtensionsDefault=P;const c=/^(.*?)(\.([^.]*))?$/;function d(u,p=!1){const t=u?c.exec(u):[];let n=[t&&t[1]||"",t&&t[3]||""];return p&&(!n[0]&&n[1]||n[0]&&n[0].charAt(0)===".")&&(n=[n[0]+"."+n[1],""]),n}function o(u){const p=u?c.exec(u):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function l(u,p,t){let n=u.compare(p,t);return n!==0?n:p.length!==t.length?p.length<t.length?-1:1:0}function g(u,p,t=!1){return t||(u=u&&u.toLowerCase(),p=p&&p.toLowerCase()),u===p?0:u<p?-1:1}function m(u,p,t=!1){const n=u.split(w.sep),s=p.split(w.sep),r=n.length-1,a=s.length-1;let h,b;for(let _=0;;_++){if(h=r===_,b=a===_,h&&b)return C(n[_],s[_],t);if(h)return-1;if(b)return 1;const v=g(n[_],s[_],t);if(v!==0)return v}}e.comparePaths=m;function D(u,p,t){const n=u.toLowerCase(),s=p.toLowerCase(),r=f(u,p,t);if(r)return r;const a=n.endsWith(t),h=s.endsWith(t);if(a!==h)return a?-1:1;const b=C(n,s);return b!==0?b:n.localeCompare(s)}e.compareAnything=D;function f(u,p,t){const n=u.toLowerCase(),s=p.toLowerCase(),r=n.startsWith(t),a=s.startsWith(t);if(r!==a)return r?-1:1;if(r&&a){if(n.length<s.length)return-1;if(n.length>s.length)return 1}return 0}e.compareByPrefix=f}),define(be[28],_e([0,1,8,37,13,22,11]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const S="**",k="/",i="[/\\\\]",P="[^/\\\\]",c=/\//g;function d(O){switch(O){case 0:return"";case 1:return`${P}*?`;default:return`(?:${i}|${P}+${i}|${i}${P}+)*?`}}function o(O,G){if(!O)return[];const Y=[];let ne=!1,pe=!1,Ie="";for(const Oe of O){switch(Oe){case G:if(!ne&&!pe){Y.push(Ie),Ie="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}Ie+=Oe}return Ie&&Y.push(Ie),Y}e.splitGlobAware=o;function l(O){if(!O)return"";let G="";const Y=o(O,k);if(Y.every(ne=>ne===S))G=".*";else{let ne=!1;Y.forEach((pe,Ie)=>{if(pe===S){ne||(G+=d(2),ne=!0);return}let Oe=!1,Te="",Ue=!1,B="";for(const K of pe){if(K!=="}"&&Oe){Te+=K;continue}if(Ue&&(K!=="]"||!B)){let ie;K==="-"?ie=K:(K==="^"||K==="!")&&!B?ie="^":K===k?ie="":ie=w.escapeRegExpCharacters(K),B+=ie;continue}switch(K){case"{":Oe=!0;continue;case"[":Ue=!0;continue;case"}":G+=`(?:${o(Te,",").map(fe=>l(fe)).join("|")})`,Oe=!1,Te="";break;case"]":G+="["+B+"]",Ue=!1,B="";break;case"?":G+=P;continue;case"*":G+=d(1);continue;default:G+=w.escapeRegExpCharacters(K)}}Ie<Y.length-1&&(Y[Ie+1]!==S||Ie+2<Y.length)&&(G+=i),ne=!1})}return G}const g=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,D=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),n=function(){return!1},s=function(){return null};function r(O,G){if(!O)return s;let Y;typeof O!="string"?Y=O.pattern:Y=O,Y=Y.trim();const ne=`${Y}_${!!G.trimForExclusions}`;let pe=t.get(ne);if(pe)return a(pe,O);let Ie;if(g.test(Y)){const Oe=Y.substr(4);pe=function(Te,Ue){return typeof Te=="string"&&Te.endsWith(Oe)?Y:null}}else(Ie=m.exec(h(Y,G)))?pe=b(Ie[1],Y):(G.trimForExclusions?f:D).test(Y)?pe=_(Y,G):(Ie=u.exec(h(Y,G)))?pe=v(Ie[1].substr(1),Y,!0):(Ie=p.exec(h(Y,G)))?pe=v(Ie[1],Y,!1):pe=E(Y);return t.set(ne,pe),a(pe,O)}function a(O,G){return typeof G=="string"?O:function(Y,ne){return I.isEqualOrParent(Y,G.base)?O(A.relative(G.base,Y),ne):null}}function h(O,G){return G.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function b(O,G){const Y=`/${O}`,ne=`\\${O}`,pe=function(Oe,Te){return typeof Oe!="string"?null:Te?Te===O?G:null:Oe===O||Oe.endsWith(Y)||Oe.endsWith(ne)?G:null},Ie=[O];return pe.basenames=Ie,pe.patterns=[G],pe.allBasenames=Ie,pe}function _(O,G){const Y=x(O.slice(1,-1).split(",").map(Te=>r(Te,G)).filter(Te=>Te!==s),O),ne=Y.length;if(!ne)return s;if(ne===1)return Y[0];const pe=function(Te,Ue){for(let B=0,K=Y.length;B<K;B++)if(Y[B](Te,Ue))return O;return null},Ie=Y.find(Te=>!!Te.allBasenames);Ie&&(pe.allBasenames=Ie.allBasenames);const Oe=Y.reduce((Te,Ue)=>Ue.allPaths?Te.concat(Ue.allPaths):Te,[]);return Oe.length&&(pe.allPaths=Oe),pe}function v(O,G,Y){const ne=A.sep===A.posix.sep,pe=ne?O:O.replace(c,A.sep),Ie=A.sep+pe,Oe=A.posix.sep+O,Te=Y?function(Ue,B){return typeof Ue=="string"&&(Ue===pe||Ue.endsWith(Ie)||!ne&&(Ue===O||Ue.endsWith(Oe)))?G:null}:function(Ue,B){return typeof Ue=="string"&&(Ue===pe||!ne&&Ue===O)?G:null};return Te.allPaths=[(Y?"*/":"./")+O],Te}function E(O){try{const G=new RegExp(`^${l(O)}$`);return function(Y){return G.lastIndex=0,typeof Y=="string"&&G.test(Y)?O:null}}catch(G){return s}}function F(O,G,Y){return!O||typeof G!="string"?!1:U(O)(G,void 0,Y)}e.match=F;function U(O,G={}){if(!O)return n;if(typeof O=="string"||z(O)){const Y=r(O,G);if(Y===s)return n;const ne=function(pe,Ie){return!!Y(pe,Ie)};return Y.allBasenames&&(ne.allBasenames=Y.allBasenames),Y.allPaths&&(ne.allPaths=Y.allPaths),ne}return R(O,G)}e.parse=U;function J(O){if(!!O){let G;return Y=>(G||(G=(O()||Promise.resolve([])).then(ne=>ne?q(ne):{})),G.then(ne=>!!ne[Y]))}}e.hasSiblingPromiseFn=J;function me(O){if(!!O){let G;return Y=>{if(!G){const ne=O();G=ne?q(ne):{}}return!!G[Y]}}}e.hasSiblingFn=me;function q(O){const G={};for(const Y of O)G[Y]=!0;return G}function z(O){const G=O;return G&&typeof G.base=="string"&&typeof G.pattern=="string"}e.isRelativePattern=z;function ee(O){return O.allBasenames||[]}e.getBasenameTerms=ee;function $(O){return O.allPaths||[]}e.getPathTerms=$;function R(O,G){const Y=x(Object.getOwnPropertyNames(O).map(Te=>M(Te,O[Te],G)).filter(Te=>Te!==s)),ne=Y.length;if(!ne)return s;if(!Y.some(Te=>!!Te.requiresSiblings)){if(ne===1)return Y[0];const Te=function(K,ie){for(let le=0,fe=Y.length;le<fe;le++){const Se=Y[le](K,ie);if(Se)return Se}return null},Ue=Y.find(K=>!!K.allBasenames);Ue&&(Te.allBasenames=Ue.allBasenames);const B=Y.reduce((K,ie)=>ie.allPaths?K.concat(ie.allPaths):K,[]);return B.length&&(Te.allPaths=B),Te}const pe=function(Te,Ue,B){let K;for(let ie=0,le=Y.length;ie<le;ie++){const fe=Y[ie];fe.requiresSiblings&&B&&(Ue||(Ue=A.basename(Te)),K||(K=Ue.substr(0,Ue.length-A.extname(Te).length)));const Se=fe(Te,Ue,K,B);if(Se)return Se}return null},Ie=Y.find(Te=>!!Te.allBasenames);Ie&&(pe.allBasenames=Ie.allBasenames);const Oe=Y.reduce((Te,Ue)=>Ue.allPaths?Te.concat(Ue.allPaths):Te,[]);return Oe.length&&(pe.allPaths=Oe),pe}function M(O,G,Y){if(G===!1)return s;const ne=r(O,Y);if(ne===s)return s;if(typeof G=="boolean")return ne;if(G){const pe=G.when;if(typeof pe=="string"){const Ie=(Oe,Te,Ue,B)=>{if(!B||!ne(Oe,Te))return null;const K=pe.replace("$(basename)",Ue),ie=B(K);return(0,y.isThenable)(ie)?ie.then(le=>le?O:null):ie?O:null};return Ie.requiresSiblings=!0,Ie}}return ne}function x(O,G){const Y=O.filter(Te=>!!Te.basenames);if(Y.length<2)return O;const ne=Y.reduce((Te,Ue)=>{const B=Ue.basenames;return B?Te.concat(B):Te},[]);let pe;if(G){pe=[];for(let Te=0,Ue=ne.length;Te<Ue;Te++)pe.push(G)}else pe=Y.reduce((Te,Ue)=>{const B=Ue.patterns;return B?Te.concat(B):Te},[]);const Ie=function(Te,Ue){if(typeof Te!="string")return null;if(!Ue){let K;for(K=Te.length;K>0;K--){const ie=Te.charCodeAt(K-1);if(ie===47||ie===92)break}Ue=Te.substr(K)}const B=ne.indexOf(Ue);return B!==-1?pe[B]:null};Ie.basenames=ne,Ie.patterns=pe,Ie.allBasenames=ne;const Oe=O.filter(Te=>!Te.basenames);return Oe.push(Ie),Oe}}),define(be[58],_e([0,1,2,13,8,18,21,25,37]),function(Q,e,w,I,A,T,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(r,a,h){if(typeof r=="string"&&(r=w.URI.file(r)),h){const _=h.getWorkspaceFolder(r);if(_){const v=h.getWorkspace().folders.length>1;let E;if((0,C.isEqual)(_.uri,r)?E="":E=(0,C.relativePath)(_.uri,r),v){const F=_.name?_.name:(0,C.basename)(_.uri);E=E?F+" \u2022 "+E:F}return E}}if(r.scheme!==T.Schemas.file&&r.scheme!==T.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,S.hasDriveLetter)(r.fsPath))return(0,I.normalize)(P(r.fsPath));let b=(0,I.normalize)(r.fsPath);return!y.isWindows&&(a==null?void 0:a.userHome)&&(b=d(b,a.userHome.fsPath)),b}e.getPathLabel=k;function i(r){if(!!r){typeof r=="string"&&(r=w.URI.file(r));const a=(0,C.basename)(r)||(r.scheme===T.Schemas.file?r.fsPath:r.path);return y.isWindows&&(0,S.isRootOrDriveLetter)(a)?P(a):a}}e.getBaseLabel=i;function P(r){return(0,S.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=P;let c=Object.create(null);function d(r,a){if(y.isWindows||!r||!a)return r;let h=c.original===a?c.normalized:void 0;return h||(h=`${(0,A.rtrim)(a,I.posix.sep)}${I.posix.sep}`,c={original:a,normalized:h}),(y.isLinux?r.startsWith(h):(0,A.startsWithIgnoreCase)(r,h))&&(r=`~/${r.substr(h.length)}`),r}e.tildify=d;function o(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=o;const l="\u2026",g="\\\\",m="~";function D(r,a=I.sep){const h=new Array(r.length);let b=!1;for(let _=0;_<r.length;_++){let v=r[_];if(v===""){h[_]=`.${a}`;continue}if(!v){h[_]=v;continue}b=!0;let E="";v.indexOf(g)===0?(E=v.substr(0,v.indexOf(g)+g.length),v=v.substr(v.indexOf(g)+g.length)):v.indexOf(a)===0?(E=v.substr(0,v.indexOf(a)+a.length),v=v.substr(v.indexOf(a)+a.length)):v.indexOf(m)===0&&(E=v.substr(0,v.indexOf(m)+m.length),v=v.substr(v.indexOf(m)+m.length));const F=v.split(a);for(let U=1;b&&U<=F.length;U++)for(let J=F.length-U;b&&J>=0;J--){b=!1;let me=F.slice(J,J+U).join(a);for(let q=0;!b&&q<r.length;q++)if(q!==_&&r[q]&&r[q].indexOf(me)>-1){const z=J+U===F.length,ee=J>0&&r[q].indexOf(a)>-1?a+me:me,$=r[q].endsWith(ee);b=!z||$}if(!b){let q="";(F[0].endsWith(":")||E!=="")&&(J===1&&(J=0,U++,me=F[0]+a+me),J>0&&(q=F[0]+a),q=E+q),J>0&&(q=q+l+a),q=q+me,J+U<F.length&&(q=q+a+l),h[_]=q}}b&&(h[_]=v)}return h}e.shorten=D;var f;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function u(r,a=Object.create(null)){const h=[];let b=!1,_="";for(const v of r)if(v==="$"||b&&v==="{")_&&h.push({value:_,type:f.TEXT}),_="",b=!0;else if(v==="}"&&b){const E=a[_];if(typeof E=="string")E.length&&h.push({value:E,type:f.VARIABLE});else if(E){const F=h[h.length-1];(!F||F.type!==f.SEPARATOR)&&h.push({value:E.label,type:f.SEPARATOR})}_="",b=!1}else _+=v;return _&&!b&&h.push({value:_,type:f.TEXT}),h.filter((v,E)=>{if(v.type===f.SEPARATOR){const F=h[E-1],U=h[E+1];return[F,U].every(J=>J&&(J.type===f.VARIABLE||J.type===f.TEXT)&&J.value.length>0)}return!0}).map(v=>v.value).join("")}e.template=u;function p(r,a){return y.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):r.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function t(r,a){return y.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,""):y.isWindows?r.replace(/&&|&/g,h=>h==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=n;function s(r){const a=r.indexOf("/")!==-1?I.posix:I.win32,h=a.basename(r),b=a.dirname(r);return h.length?{name:h,parentPath:b}:{name:b,parentPath:""}}e.splitName=s}),define(be[113],_e([0,1,2]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(i){return i.toJSON()}class A{constructor(P){this._uriTransformer=P}transformIncoming(P){const c=this._uriTransformer.transformIncoming(P);return c===P?P:I(w.URI.from(c))}transformOutgoing(P){const c=this._uriTransformer.transformOutgoing(P);return c===P?P:I(w.URI.from(c))}transformOutgoingURI(P){const c=this._uriTransformer.transformOutgoing(P);return c===P?P:w.URI.from(c)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function T(i,P,c){if(!i||c>200)return null;if(typeof i=="object"){if(i instanceof w.URI)return P.transformOutgoing(i);for(let d in i)if(Object.hasOwnProperty.call(i,d)){const o=T(i[d],P,c+1);o!==null&&(i[d]=o)}}return null}function y(i,P){const c=T(i,P,0);return c===null?i:c}e.transformOutgoingURIs=y;function C(i,P,c,d){if(!i||d>200)return null;if(typeof i=="object"){if(i.$mid===1)return c?w.URI.revive(P.transformIncoming(i)):P.transformIncoming(i);for(let o in i)if(Object.hasOwnProperty.call(i,o)){const l=C(i[o],P,c,d+1);l!==null&&(i[o]=l)}}return null}function S(i,P){const c=C(i,P,!1,0);return c===null?i:c}e.transformIncomingURIs=S;function k(i,P){const c=C(i,P,!0,0);return c===null?i:c}e.transformAndReviveIncomingURIs=k}),define(be[31],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(S){return w.test(S)}e.isUUID=I;const A=new Uint8Array(16),T=[];for(let S=0;S<256;S++)T.push(S.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(S){for(let k=0;k<S.length;k++)S[k]=Math.floor(Math.random()*256);return S};function C(){y(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let S=0,k="";return k+=T[A[S++]],k+=T[A[S++]],k+=T[A[S++]],k+=T[A[S++]],k+="-",k+=T[A[S++]],k+=T[A[S++]],k+="-",k+=T[A[S++]],k+=T[A[S++]],k+="-",k+=T[A[S++]],k+=T[A[S++]],k+="-",k+=T[A[S++]],k+=T[A[S++]],k+=T[A[S++]],k+=T[A[S++]],k+=T[A[S++]],k+=T[A[S++]],k}e.generateUuid=C}),define(be[84],_e([0,1,82]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class I{constructor(C){let S=(0,w.toUint8)(C);this._defaultValue=S,this._asciiMap=I._createAsciiMap(S),this._map=new Map}static _createAsciiMap(C){let S=new Uint8Array(256);for(let k=0;k<256;k++)S[k]=C;return S}set(C,S){let k=(0,w.toUint8)(S);C>=0&&C<256?this._asciiMap[C]=k:this._map.set(C,k)}get(C){return C>=0&&C<256?this._asciiMap[C]:this._map.get(C)||this._defaultValue}}e.CharacterClassifier=I;var A;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(A||(A={}));class T{constructor(){this._actual=new I(0)}add(C){this._actual.set(C,1)}has(C){return this._actual.get(C)===1}}e.CharacterSet=T}),define(be[114],_e([0,1,84]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var I;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(I=e.WordCharacterClass||(e.WordCharacterClass={}));class A extends w.CharacterClassifier{constructor(C){super(0);for(let S=0,k=C.length;S<k;S++)this.set(C.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=A;function T(y){let C={};return S=>(C.hasOwnProperty(S)||(C[S]=y(S)),C[S])}e.getMapForWordSeparators=T(y=>new A(y))}),define(be[38],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class w{constructor(A,T){this.lineNumber=A,this.column=T}with(A=this.lineNumber,T=this.column){return A===this.lineNumber&&T===this.column?this:new w(A,T)}delta(A=0,T=0){return this.with(this.lineNumber+A,this.column+T)}equals(A){return w.equals(this,A)}static equals(A,T){return!A&&!T?!0:!!A&&!!T&&A.lineNumber===T.lineNumber&&A.column===T.column}isBefore(A){return w.isBefore(this,A)}static isBefore(A,T){return A.lineNumber<T.lineNumber?!0:T.lineNumber<A.lineNumber?!1:A.column<T.column}isBeforeOrEqual(A){return w.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,T){return A.lineNumber<T.lineNumber?!0:T.lineNumber<A.lineNumber?!1:A.column<=T.column}static compare(A,T){let y=A.lineNumber|0,C=T.lineNumber|0;if(y===C){let S=A.column|0,k=T.column|0;return S-k}return y-C}clone(){return new w(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new w(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}}e.Position=w}),define(be[32],_e([0,1,38]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class I{constructor(T,y,C,S){T>C||T===C&&y>S?(this.startLineNumber=C,this.startColumn=S,this.endLineNumber=T,this.endColumn=y):(this.startLineNumber=T,this.startColumn=y,this.endLineNumber=C,this.endColumn=S)}isEmpty(){return I.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return I.containsPosition(this,T)}static containsPosition(T,y){return!(y.lineNumber<T.startLineNumber||y.lineNumber>T.endLineNumber||y.lineNumber===T.startLineNumber&&y.column<T.startColumn||y.lineNumber===T.endLineNumber&&y.column>T.endColumn)}containsRange(T){return I.containsRange(this,T)}static containsRange(T,y){return!(y.startLineNumber<T.startLineNumber||y.endLineNumber<T.startLineNumber||y.startLineNumber>T.endLineNumber||y.endLineNumber>T.endLineNumber||y.startLineNumber===T.startLineNumber&&y.startColumn<T.startColumn||y.endLineNumber===T.endLineNumber&&y.endColumn>T.endColumn)}strictContainsRange(T){return I.strictContainsRange(this,T)}static strictContainsRange(T,y){return!(y.startLineNumber<T.startLineNumber||y.endLineNumber<T.startLineNumber||y.startLineNumber>T.endLineNumber||y.endLineNumber>T.endLineNumber||y.startLineNumber===T.startLineNumber&&y.startColumn<=T.startColumn||y.endLineNumber===T.endLineNumber&&y.endColumn>=T.endColumn)}plusRange(T){return I.plusRange(this,T)}static plusRange(T,y){let C,S,k,i;return y.startLineNumber<T.startLineNumber?(C=y.startLineNumber,S=y.startColumn):y.startLineNumber===T.startLineNumber?(C=y.startLineNumber,S=Math.min(y.startColumn,T.startColumn)):(C=T.startLineNumber,S=T.startColumn),y.endLineNumber>T.endLineNumber?(k=y.endLineNumber,i=y.endColumn):y.endLineNumber===T.endLineNumber?(k=y.endLineNumber,i=Math.max(y.endColumn,T.endColumn)):(k=T.endLineNumber,i=T.endColumn),new I(C,S,k,i)}intersectRanges(T){return I.intersectRanges(this,T)}static intersectRanges(T,y){let C=T.startLineNumber,S=T.startColumn,k=T.endLineNumber,i=T.endColumn,P=y.startLineNumber,c=y.startColumn,d=y.endLineNumber,o=y.endColumn;return C<P?(C=P,S=c):C===P&&(S=Math.max(S,c)),k>d?(k=d,i=o):k===d&&(i=Math.min(i,o)),C>k||C===k&&S>i?null:new I(C,S,k,i)}equalsRange(T){return I.equalsRange(this,T)}static equalsRange(T,y){return!!T&&!!y&&T.startLineNumber===y.startLineNumber&&T.startColumn===y.startColumn&&T.endLineNumber===y.endLineNumber&&T.endColumn===y.endColumn}getEndPosition(){return I.getEndPosition(this)}static getEndPosition(T){return new w.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return I.getStartPosition(this)}static getStartPosition(T){return new w.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,y){return new I(this.startLineNumber,this.startColumn,T,y)}setStartPosition(T,y){return new I(T,y,this.endLineNumber,this.endColumn)}collapseToStart(){return I.collapseToStart(this)}static collapseToStart(T){return new I(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,y=T){return new I(T.lineNumber,T.column,y.lineNumber,y.column)}static lift(T){return T?new I(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,y){return!(T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<y.startColumn||y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<T.startColumn)}static areIntersecting(T,y){return!(T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<=y.startColumn||y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,y){if(T&&y){const k=T.startLineNumber|0,i=y.startLineNumber|0;if(k===i){const P=T.startColumn|0,c=y.startColumn|0;if(P===c){const d=T.endLineNumber|0,o=y.endLineNumber|0;if(d===o){const l=T.endColumn|0,g=y.endColumn|0;return l-g}return d-o}return P-c}return k-i}return(T?1:0)-(y?1:0)}static compareRangesUsingEnds(T,y){return T.endLineNumber===y.endLineNumber?T.endColumn===y.endColumn?T.startLineNumber===y.startLineNumber?T.startColumn-y.startColumn:T.startLineNumber-y.startLineNumber:T.endColumn-y.endColumn:T.endLineNumber-y.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}}e.Range=I}),define(be[115],_e([0,1,38,32]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var A;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(A=e.SelectionDirection||(e.SelectionDirection={}));class T extends I.Range{constructor(C,S,k,i){super(C,S,k,i);this.selectionStartLineNumber=C,this.selectionStartColumn=S,this.positionLineNumber=k,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(C){return T.selectionsEqual(this,C)}static selectionsEqual(C,S){return C.selectionStartLineNumber===S.selectionStartLineNumber&&C.selectionStartColumn===S.selectionStartColumn&&C.positionLineNumber===S.positionLineNumber&&C.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(C,S){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,C,S):new T(C,S,this.startLineNumber,this.startColumn)}getPosition(){return new w.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(C,S){return this.getDirection()===0?new T(C,S,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,C,S)}static fromPositions(C,S=C){return new T(C.lineNumber,C.column,S.lineNumber,S.column)}static liftSelection(C){return new T(C.selectionStartLineNumber,C.selectionStartColumn,C.positionLineNumber,C.positionColumn)}static selectionsArrEqual(C,S){if(C&&!S||!C&&S)return!1;if(!C&&!S)return!0;if(C.length!==S.length)return!1;for(let k=0,i=C.length;k<i;k++)if(!this.selectionsEqual(C[k],S[k]))return!1;return!0}static isISelection(C){return C&&typeof C.selectionStartLineNumber=="number"&&typeof C.selectionStartColumn=="number"&&typeof C.positionLineNumber=="number"&&typeof C.positionColumn=="number"}static createWithDirection(C,S,k,i,P){return P===0?new T(C,S,k,i):new T(k,i,C,S)}}e.Selection=T}),define(be[85],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var w;(function(d){d[d.Left=1]="Left",d[d.Center=2]="Center",d[d.Right=4]="Right",d[d.Full=7]="Full"})(w=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(d){d[d.Inline=1]="Inline",d[d.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(d){d[d.TextDefined=0]="TextDefined",d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(d){d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(d){d[d.LF=0]="LF",d[d.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(o){this.tabSize=Math.max(1,o.tabSize|0),this.indentSize=o.tabSize|0,this.insertSpaces=Boolean(o.insertSpaces),this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=Boolean(o.trimAutoWhitespace)}equals(o){return this.tabSize===o.tabSize&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class S{constructor(o,l){this.range=o,this.matches=l}}e.FindMatch=S;var k;(function(d){d[d.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",d[d.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",d[d.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",d[d.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(d){d[d.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(i=e.ModelConstants||(e.ModelConstants={}));class P{constructor(o,l,g,m,D,f){this.identifier=o,this.range=l,this.text=g,this.forceMoveMarkers=m,this.isAutoWhitespaceEdit=D,this._isTracked=f}}e.ValidAnnotatedEditOperation=P;class c{constructor(o,l,g){this.reverseEdits=o,this.changes=l,this.trimAutoWhitespaceLineNumbers=g}}e.ApplyEditsResult=c}),define(be[116],_e([0,1,8,114,38,32,85]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class S{constructor(f,u,p,t){this.searchString=f,this.isRegex=u,this.matchCase=p,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let f;this.isRegex?f=k(this.searchString):f=this.searchString.indexOf(`
`)>=0;let u=null;try{u=w.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:f,global:!0,unicode:!0})}catch(t){return null}if(!u)return null;let p=!this.isRegex&&!f;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new i(u,this.wordSeparators?(0,I.getMapForWordSeparators)(this.wordSeparators):null,p?this.searchString:null)}}e.SearchParams=S;function k(D){if(!D||D.length===0)return!1;for(let f=0,u=D.length;f<u;f++)if(D.charCodeAt(f)===92){if(f++,f>=u)break;const t=D.charCodeAt(f);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=k;class i{constructor(f,u,p){this.regex=f,this.wordSeparators=u,this.simpleSearch=p}}e.SearchData=i;function P(D,f,u){if(!u)return new y.FindMatch(D,null);let p=[];for(let t=0,n=f.length;t<n;t++)p[t]=f[t];return new y.FindMatch(D,p)}e.createFindMatch=P;class c{constructor(f){let u=[],p=0;for(let t=0,n=f.length;t<n;t++)f.charCodeAt(t)===10&&(u[p++]=t);this._lineFeedsOffsets=u}findLineFeedCountBeforeOffset(f){const u=this._lineFeedsOffsets;let p=0,t=u.length-1;if(t===-1||f<=u[0])return 0;for(;p<t;){const n=p+((t-p)/2>>0);u[n]>=f?t=n-1:u[n+1]>=f?(p=n,t=n):p=n+1}return p+1}}class d{static findMatches(f,u,p,t,n){const s=u.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(f,p,new m(s.wordSeparators,s.regex),t,n):this._doFindMatchesLineByLine(f,p,s,t,n):[]}static _getMultilineMatchRange(f,u,p,t,n,s){let r,a=0;t?(a=t.findLineFeedCountBeforeOffset(n),r=u+n+a):r=u+n;let h;if(t){let E=t.findLineFeedCountBeforeOffset(n+s.length)-a;h=r+s.length+E}else h=r+s.length;const b=f.getPositionAt(r),_=f.getPositionAt(h);return new T.Range(b.lineNumber,b.column,_.lineNumber,_.column)}static _doFindMatchesMultiline(f,u,p,t,n){const s=f.getOffsetAt(u.getStartPosition()),r=f.getValueInRange(u,1),a=f.getEOL()===`\r
`?new c(r):null,h=[];let b=0,_;for(p.reset(0);_=p.next(r);)if(h[b++]=P(this._getMultilineMatchRange(f,s,r,a,_.index,_[0]),_,t),b>=n)return h;return h}static _doFindMatchesLineByLine(f,u,p,t,n){const s=[];let r=0;if(u.startLineNumber===u.endLineNumber){const h=f.getLineContent(u.startLineNumber).substring(u.startColumn-1,u.endColumn-1);return r=this._findMatchesInLine(p,h,u.startLineNumber,u.startColumn-1,r,s,t,n),s}const a=f.getLineContent(u.startLineNumber).substring(u.startColumn-1);r=this._findMatchesInLine(p,a,u.startLineNumber,u.startColumn-1,r,s,t,n);for(let h=u.startLineNumber+1;h<u.endLineNumber&&r<n;h++)r=this._findMatchesInLine(p,f.getLineContent(h),h,0,r,s,t,n);if(r<n){const h=f.getLineContent(u.endLineNumber).substring(0,u.endColumn-1);r=this._findMatchesInLine(p,h,u.endLineNumber,0,r,s,t,n)}return s}static _findMatchesInLine(f,u,p,t,n,s,r,a){const h=f.wordSeparators;if(!r&&f.simpleSearch){const v=f.simpleSearch,E=v.length,F=u.length;let U=-E;for(;(U=u.indexOf(v,U+E))!==-1;)if((!h||g(h,u,F,U,E))&&(s[n++]=new y.FindMatch(new T.Range(p,U+1+t,p,U+1+E+t),null),n>=a))return n;return n}const b=new m(f.wordSeparators,f.regex);let _;b.reset(0);do if(_=b.next(u),_&&(s[n++]=P(new T.Range(p,_.index+1+t,p,_.index+1+_[0].length+t),_,r),n>=a))return n;while(_);return n}static findNextMatch(f,u,p,t){const n=u.parseSearchRequest();if(!n)return null;const s=new m(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(f,p,s,t):this._doFindNextMatchLineByLine(f,p,s,t)}static _doFindNextMatchMultiline(f,u,p,t){const n=new A.Position(u.lineNumber,1),s=f.getOffsetAt(n),r=f.getLineCount(),a=f.getValueInRange(new T.Range(n.lineNumber,n.column,r,f.getLineMaxColumn(r)),1),h=f.getEOL()===`\r
`?new c(a):null;p.reset(u.column-1);let b=p.next(a);return b?P(this._getMultilineMatchRange(f,s,a,h,b.index,b[0]),b,t):u.lineNumber!==1||u.column!==1?this._doFindNextMatchMultiline(f,new A.Position(1,1),p,t):null}static _doFindNextMatchLineByLine(f,u,p,t){const n=f.getLineCount(),s=u.lineNumber,r=f.getLineContent(s),a=this._findFirstMatchInLine(p,r,s,u.column,t);if(a)return a;for(let h=1;h<=n;h++){const b=(s+h-1)%n,_=f.getLineContent(b+1),v=this._findFirstMatchInLine(p,_,b+1,1,t);if(v)return v}return null}static _findFirstMatchInLine(f,u,p,t,n){f.reset(t-1);const s=f.next(u);return s?P(new T.Range(p,s.index+1,p,s.index+1+s[0].length),s,n):null}static findPreviousMatch(f,u,p,t){const n=u.parseSearchRequest();if(!n)return null;const s=new m(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(f,p,s,t):this._doFindPreviousMatchLineByLine(f,p,s,t)}static _doFindPreviousMatchMultiline(f,u,p,t){const n=this._doFindMatchesMultiline(f,new T.Range(1,1,u.lineNumber,u.column),p,t,10*C);if(n.length>0)return n[n.length-1];const s=f.getLineCount();return u.lineNumber!==s||u.column!==f.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(f,new A.Position(s,f.getLineMaxColumn(s)),p,t):null}static _doFindPreviousMatchLineByLine(f,u,p,t){const n=f.getLineCount(),s=u.lineNumber,r=f.getLineContent(s).substring(0,u.column-1),a=this._findLastMatchInLine(p,r,s,t);if(a)return a;for(let h=1;h<=n;h++){const b=(n+s-h-1)%n,_=f.getLineContent(b+1),v=this._findLastMatchInLine(p,_,b+1,t);if(v)return v}return null}static _findLastMatchInLine(f,u,p,t){let n=null,s;for(f.reset(0);s=f.next(u);)n=P(new T.Range(p,s.index+1,p,s.index+1+s[0].length),s,t);return n}}e.TextModelSearch=d;function o(D,f,u,p,t){if(p===0)return!0;const n=f.charCodeAt(p-1);if(D.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=f.charCodeAt(p);if(D.get(s)!==0)return!0}return!1}function l(D,f,u,p,t){if(p+t===u)return!0;const n=f.charCodeAt(p+t);if(D.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=f.charCodeAt(p+t-1);if(D.get(s)!==0)return!0}return!1}function g(D,f,u,p,t){return o(D,f,u,p,t)&&l(D,f,u,p,t)}e.isValidMatch=g;class m{constructor(f,u){this._wordSeparators=f,this._searchRegex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(f){this._searchRegex.lastIndex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(f){const u=f.length;let p;do{if(this._prevMatchStartIndex+this._prevMatchLength===u||(p=this._searchRegex.exec(f),!p))return null;const t=p.index,n=p[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){w.getNextCodePoint(f,u,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||g(this._wordSeparators,f,u,t,n))return p}while(p);return null}}e.Searcher=m}),define(be[86],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function w(C=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)C.indexOf(k)>=0||(S+="\\"+k);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=w();function I(C){let S=e.DEFAULT_WORD_REGEXP;if(C&&C instanceof RegExp)if(C.global)S=C;else{let k="g";C.ignoreCase&&(k+="i"),C.multiline&&(k+="m"),C.unicode&&(k+="u"),S=new RegExp(C.source,k)}return S.lastIndex=0,S}e.ensureValidWordDefinition=I;const A={maxLen:1e3,windowSize:15,timeBudget:150};function T(C,S,k,i,P=A){if(k.length>P.maxLen){let g=C-P.maxLen/2;return g<0?g=0:i+=g,k=k.substring(g,C+P.maxLen/2),T(C,S,k,i,P)}const c=Date.now(),d=C-1-i;let o=-1,l=null;for(let g=1;!(Date.now()-c>=P.timeBudget);g++){const m=d-P.windowSize*g;S.lastIndex=Math.max(0,m);const D=y(S,k,d,o);if(!D&&l||(l=D,m<=0))break;o=m}if(l){let g={word:l[0],startColumn:i+1+l.index,endColumn:i+1+l.index+l[0].length};return S.lastIndex=0,g}return null}e.getWordAtText=T;function y(C,S,k,i){let P;for(;P=C.exec(S);){const c=P.index||0;if(c<=k&&C.lastIndex>=k)return P;if(i>0&&c>i)return null}return null}}),define(be[117],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var w;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(w=e.IndentAction||(e.IndentAction={}));class I{constructor(C){if(this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let S=0,k=C.notIn.length;S<k;S++)switch(C.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=I;class A{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of C)T(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),T(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),T(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),T(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&T(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=A;function T(y,C,S){y.has(C)?y.get(C).push(S):y.set(C,[S])}}),define(be[59],_e([0,1,28,13]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function A(T,y,C,S){if(Array.isArray(T)){let k=0;for(const i of T){const P=A(i,y,C,S);if(P===10)return P;P>k&&(k=P)}return k}else{if(typeof T=="string")return S?T==="*"?5:T===C?10:0:0;if(T){const{language:k,pattern:i,scheme:P,hasAccessToAllModels:c}=T;if(!S&&!c)return 0;let d=0;if(P)if(P===y.scheme)d=10;else if(P==="*")d=5;else return 0;if(k)if(k===C)d=10;else if(k==="*")d=Math.max(d,5);else return 0;if(i){let o;if(typeof i=="string"?o=i:o=Object.assign(Object.assign({},i),{base:(0,I.normalize)(i.base)}),o===y.fsPath||(0,w.match)(o,y.fsPath))d=10;else return 0}return d}else return 0}}e.score=A}),define(be[118],_e([0,1,84]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var I;(function(d){d[d.Invalid=0]="Invalid",d[d.Start=1]="Start",d[d.H=2]="H",d[d.HT=3]="HT",d[d.HTT=4]="HTT",d[d.HTTP=5]="HTTP",d[d.F=6]="F",d[d.FI=7]="FI",d[d.FIL=8]="FIL",d[d.BeforeColon=9]="BeforeColon",d[d.AfterColon=10]="AfterColon",d[d.AlmostThere=11]="AlmostThere",d[d.End=12]="End",d[d.Accept=13]="Accept",d[d.LastKnownState=14]="LastKnownState"})(I=e.State||(e.State={}));class A{constructor(o,l,g){const m=new Uint8Array(o*l);for(let D=0,f=o*l;D<f;D++)m[D]=g;this._data=m,this.rows=o,this.cols=l}get(o,l){return this._data[o*this.cols+l]}set(o,l,g){this._data[o*this.cols+l]=g}}e.Uint8Matrix=A;class T{constructor(o){let l=0,g=0;for(let D=0,f=o.length;D<f;D++){let[u,p,t]=o[D];p>l&&(l=p),u>g&&(g=u),t>g&&(g=t)}l++,g++;let m=new A(g,l,0);for(let D=0,f=o.length;D<f;D++){let[u,p,t]=o[D];m.set(u,p,t)}this._states=m,this._maxCharCode=l}nextState(o,l){return l<0||l>=this._maxCharCode?0:this._states.get(o,l)}}e.StateMachine=T;let y=null;function C(){return y===null&&(y=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var S;(function(d){d[d.None=0]="None",d[d.ForceTermination=1]="ForceTermination",d[d.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let k=null;function i(){if(k===null){k=new w.CharacterClassifier(0);const d=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let l=0;l<d.length;l++)k.set(d.charCodeAt(l),1);const o=".,;";for(let l=0;l<o.length;l++)k.set(o.charCodeAt(l),2)}return k}class P{static _createLink(o,l,g,m,D){let f=D-1;do{const u=l.charCodeAt(f);if(o.get(u)!==2)break;f--}while(f>m);if(m>0){const u=l.charCodeAt(m-1),p=l.charCodeAt(f);(u===40&&p===41||u===91&&p===93||u===123&&p===125)&&f--}return{range:{startLineNumber:g,startColumn:m+1,endLineNumber:g,endColumn:f+2},url:l.substring(m,f+1)}}static computeLinks(o,l=C()){const g=i();let m=[];for(let D=1,f=o.getLineCount();D<=f;D++){const u=o.getLineContent(D),p=u.length;let t=0,n=0,s=0,r=1,a=!1,h=!1,b=!1,_=!1;for(;t<p;){let v=!1;const E=u.charCodeAt(t);if(r===13){let F;switch(E){case 40:a=!0,F=0;break;case 41:F=a?0:1;break;case 91:b=!0,h=!0,F=0;break;case 93:b=!1,F=h?0:1;break;case 123:_=!0,F=0;break;case 125:F=_?0:1;break;case 39:F=s===34||s===96?0:1;break;case 34:F=s===39||s===96?0:1;break;case 96:F=s===39||s===34?0:1;break;case 42:F=s===42?1:0;break;case 124:F=s===124?1:0;break;case 32:F=b?0:1;break;default:F=g.get(E)}F===1&&(m.push(P._createLink(g,u,D,n,t)),v=!0)}else if(r===12){let F;E===91?(h=!0,F=0):F=g.get(E),F===1?v=!0:r=13}else r=l.nextState(r,E),r===0&&(v=!0);v&&(r=1,a=!1,h=!1,_=!1,n=t+1,s=E),t++}r===13&&m.push(P._createLink(g,u,D,n,p))}return m}}e.LinkComputer=P;function c(d){return!d||typeof d.getLineCount!="function"||typeof d.getLineContent!="function"?[]:P.computeLinks(d)}e.computeLinks=c}),define(be[119],_e([0,1,3,6]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class A{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new w.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,C){return this._map.set(y,C),this.fire([y]),(0,I.toDisposable)(()=>{this._map.get(y)===C&&(this._map.delete(y),this.fire([y]))})}registerPromise(y,C){let S=null,k=!1;return this._promises.set(y,C.then(i=>{this._promises.delete(y),!(k||!i)&&(S=this.register(y,i))})),(0,I.toDisposable)(()=>{k=!0,S&&S.dispose()})}getPromise(y){const C=this.get(y);if(C)return Promise.resolve(C);const S=this._promises.get(y);return S?S.then(k=>this.get(y)):null}get(y){return this._map.get(y)||null}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=A}),define(be[87],_e([0,1,23,21]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var A;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(A||(A={}));function T(P){for(let c=0,d=P.length;c<d;c+=4){const o=P[c+0],l=P[c+1],g=P[c+2],m=P[c+3];P[c+0]=m,P[c+1]=g,P[c+2]=l,P[c+3]=o}}function y(P){const c=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return I.isLittleEndian()||T(c),w.VSBuffer.wrap(c)}function C(P){const c=P.buffer;if(I.isLittleEndian()||T(c),c.byteOffset%4==0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const d=new Uint8Array(c.byteLength);return d.set(c),new Uint32Array(d.buffer,d.byteOffset,d.length/4)}}function S(P){const c=new Uint32Array(k(P));let d=0;if(c[d++]=P.id,P.type==="full")c[d++]=1,c[d++]=P.data.length,c.set(P.data,d),d+=P.data.length;else{c[d++]=2,c[d++]=P.deltas.length;for(const o of P.deltas)c[d++]=o.start,c[d++]=o.deleteCount,o.data?(c[d++]=o.data.length,c.set(o.data,d),d+=o.data.length):c[d++]=0}return y(c)}e.encodeSemanticTokensDto=S;function k(P){let c=0;if(c+=1+1,P.type==="full")c+=1+P.data.length;else{c+=1,c+=(1+1+1)*P.deltas.length;for(const d of P.deltas)d.data&&(c+=d.data.length)}return c}function i(P){const c=C(P);let d=0;const o=c[d++];if(c[d++]===1){const D=c[d++],f=c.subarray(d,d+D);return d+=D,{id:o,type:"full",data:f}}const g=c[d++];let m=[];for(let D=0;D<g;D++){const f=c[d++],u=c[d++],p=c[d++];let t;p>0&&(t=c.subarray(d,d+p),d+=p),m[D]={start:f,deleteCount:u,data:t}}return{id:o,type:"delta",deltas:m}}e.decodeSemanticTokensDto=i}),define(be[88],_e([0,1,82]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class I{constructor(y,C){this.index=y,this.remainder=C}}e.PrefixSumIndexOfResult=I;class A{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,C){y=(0,w.toUint32)(y);const S=this.values,k=this.prefixSum,i=C.length;return i===0?!1:(this.values=new Uint32Array(S.length+i),this.values.set(S.subarray(0,y),0),this.values.set(S.subarray(y),y+i),this.values.set(C,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(y,C){return y=(0,w.toUint32)(y),C=(0,w.toUint32)(C),this.values[y]===C?!1:(this.values[y]=C,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,C){y=(0,w.toUint32)(y),C=(0,w.toUint32)(C);const S=this.values,k=this.prefixSum;if(y>=S.length)return!1;let i=S.length-y;return C>=i&&(C=i),C===0?!1:(this.values=new Uint32Array(S.length-C),this.values.set(S.subarray(0,y),0),this.values.set(S.subarray(y+C),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(y){return y<0?0:(y=(0,w.toUint32)(y),this._getAccumulatedValue(y))}_getAccumulatedValue(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),y>=this.values.length&&(y=this.values.length-1);for(let S=C;S<=y;S++)this.prefixSum[S]=this.prefixSum[S-1]+this.values[S];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalValue();let C=0,S=this.values.length-1,k=0,i=0,P=0;for(;C<=S;)if(k=C+(S-C)/2|0,i=this.prefixSum[k],P=i-this.values[k],y<P)S=k-1;else if(y>=i)C=k+1;else break;return new I(k,y-P)}}e.PrefixSumComputer=A}),define(be[120],_e([0,1,8,38,88]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(C,S,k,i){this._uri=C,this._lines=S,this._eol=k,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const S=C.changes;for(const k of S)this._acceptDeleteRange(k.range),this._acceptInsertText(new I.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,S=this._lines.length,k=new Uint32Array(S);for(let i=0;i<S;i++)k[i]=this._lines[i].length+C;this._lineStarts=new A.PrefixSumComputer(k)}}_setLineText(C,S){this._lines[C]=S,this._lineStarts&&this._lineStarts.changeValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,S){if(S.length!==0){let k=(0,w.splitLines)(S);if(k.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+k[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}k[k.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+k[0]);let i=new Uint32Array(k.length-1);for(let P=1;P<k.length;P++)this._lines.splice(C.lineNumber+P-1,0,k[P]),i[P-1]=k[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,i)}}}e.MirrorTextModel=T}),define(be[121],_e([16,17]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(be[60],_e([0,1,121,10,15]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(k,i){return i&&(k.stack||k.stacktrace)?w.localize(0,null,C(k),y(k.stack)||y(k.stacktrace)):C(k)}function y(k){return Array.isArray(k)?k.join(`
`):k}function C(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?w.localize(1,null,k.message):k.message||w.localize(2,null)}function S(k=null,i=!1){if(!k)return w.localize(3,null);if(Array.isArray(k)){const P=A.coalesce(k),c=S(P[0],i);return P.length>1?w.localize(4,null,c,P.length):c}if(I.isString(k))return k;if(k.detail){const P=k.detail;if(P.error)return T(P.error,i);if(P.exception)return T(P.exception,i)}return k.stack?T(k,i):k.message?k.message:w.localize(5,null)}e.toErrorMessage=S}),define(be[122],_e([16,17]),function(Q,e){return Q.create("vs/editor/common/config/editorOptions",e)}),define(be[123],_e([0,1,122,21,86]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(H){H[H.None=0]="None",H[H.Keep=1]="Keep",H[H.Brackets=2]="Brackets",H[H.Advanced=3]="Advanced",H[H.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=y;class C{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,ve){this._values[te]=ve}}e.ValidatedEditorOptions=C;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class k{constructor(te,ve,Le,He){this.id=te,this.name=ve,this.defaultValue=Le,this.schema=He}compute(te,ve,Le){return Le}}class i{constructor(te,ve=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=ve}validate(te){return this.defaultValue}}class P{constructor(te,ve,Le,He){this.id=te,this.name=ve,this.defaultValue=Le,this.schema=He}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,ve,Le){return Le}}function c(H,te){return typeof H=="undefined"?te:H==="false"?!1:Boolean(H)}e.boolean=c;class d extends P{constructor(te,ve,Le,He=void 0){typeof He!="undefined"&&(He.type="boolean",He.default=Le),super(te,ve,Le,He)}validate(te){return c(te,this.defaultValue)}}class o extends P{constructor(te,ve,Le,He,xe,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="integer",Xe.default=Le,Xe.minimum=He,Xe.maximum=xe),super(te,ve,Le,Xe),this.minimum=He,this.maximum=xe}static clampedInt(te,ve,Le,He){if(typeof te=="undefined")return ve;let xe=parseInt(te,10);return isNaN(xe)?ve:(xe=Math.max(Le,xe),xe=Math.min(He,xe),xe|0)}validate(te){return o.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class l extends P{constructor(te,ve,Le,He,xe){typeof xe!="undefined"&&(xe.type="number",xe.default=Le),super(te,ve,Le,xe),this.validationFn=He}static clamp(te,ve,Le){return te<ve?ve:te>Le?Le:te}static float(te,ve){if(typeof te=="number")return te;if(typeof te=="undefined")return ve;const Le=parseFloat(te);return isNaN(Le)?ve:Le}validate(te){return this.validationFn(l.float(te,this.defaultValue))}}class g extends P{static string(te,ve){return typeof te!="string"?ve:te}constructor(te,ve,Le,He=void 0){typeof He!="undefined"&&(He.type="string",He.default=Le),super(te,ve,Le,He)}validate(te){return g.string(te,this.defaultValue)}}function m(H,te,ve){return typeof H!="string"||ve.indexOf(H)===-1?te:H}e.stringSet=m;class D extends P{constructor(te,ve,Le,He,xe=void 0){typeof xe!="undefined"&&(xe.type="string",xe.enum=He,xe.default=Le),super(te,ve,Le,xe),this._allowedValues=He}validate(te){return m(te,this.defaultValue,this._allowedValues)}}class f extends k{constructor(te,ve,Le,He,xe,Xe,W=void 0){typeof W!="undefined"&&(W.type="string",W.enum=xe,W.default=He),super(te,ve,Le,W),this._allowedValues=xe,this._convert=Xe}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function u(H){switch(H){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[w.localize(0,null),w.localize(1,null),w.localize(2,null)],default:"auto",description:w.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,ve,Le){return Le===0?te.accessibilitySupport:Le}}class t extends k{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:w.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:w.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{insertSpace:c(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(H){H[H.Hidden=0]="Hidden",H[H.Blink=1]="Blink",H[H.Smooth=2]="Smooth",H[H.Phase=3]="Phase",H[H.Expand=4]="Expand",H[H.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(H){switch(H){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(H){H[H.Line=1]="Line",H[H.Block=2]="Block",H[H.Underline=3]="Underline",H[H.LineThin=4]="LineThin",H[H.BlockOutline=5]="BlockOutline",H[H.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function a(H){switch(H){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=a;function h(H){switch(H){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class b extends i{constructor(){super(123,[62,31])}compute(te,ve,Le){const He=["monaco-editor"];return ve.get(31)&&He.push(ve.get(31)),te.extraEditorClassName&&He.push(te.extraEditorClassName),ve.get(62)==="default"?He.push("mouse-default"):ve.get(62)==="copy"&&He.push("mouse-copy"),ve.get(97)&&He.push("showUnused"),ve.get(121)&&He.push("showDeprecated"),He.join(" ")}}class _ extends d{constructor(){super(30,"emptySelectionClipboard",!0,{description:w.localize(6,null)})}compute(te,ve,Le){return Le&&te.emptySelectionClipboard}}class v extends k{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:w.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:te.seedSearchStringFromSelection,description:w.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[w.localize(9,null),w.localize(10,null),w.localize(11,null)],description:w.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:w.localize(13,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:w.localize(14,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:w.localize(15,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{cursorMoveOnType:c(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:c(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":m(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(ve.loop,this.defaultValue.loop)}}}class E extends k{constructor(){super(41,"fontLigatures",E.OFF,{anyOf:[{type:"boolean",description:w.localize(16,null)},{type:"string",description:w.localize(17,null)}],description:w.localize(18,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?E.OFF:te==="true"?E.ON:te:Boolean(te)?E.ON:E.OFF}}e.EditorFontLigatures=E,E.OFF='"liga" off, "calt" off',E.ON='"liga" on, "calt" on';class F extends i{constructor(){super(40)}compute(te,ve,Le){return te.fontInfo}}class U extends P{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:w.localize(19,null)})}validate(te){let ve=l.float(te,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(ve,6,100)}compute(te,ve,Le){return te.fontInfo.fontSize}}class J extends k{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:J.MINIMUM_VALUE,maximum:J.MAXIMUM_VALUE,errorMessage:w.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:J.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:w.localize(21,null)})}validate(te){return te==="normal"||te==="bold"?te:String(o.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,J.MINIMUM_VALUE,J.MAXIMUM_VALUE))}}J.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],J.MINIMUM_VALUE=1,J.MAXIMUM_VALUE=1e3;class me extends k{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[w.localize(22,null),w.localize(23,null),w.localize(24,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:w.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:w.localize(26,null)},ve),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:w.localize(27,null)},ve),"editor.gotoLocation.multipleDeclarations":Object.assign({description:w.localize(28,null)},ve),"editor.gotoLocation.multipleImplementations":Object.assign({description:w.localize(29,null)},ve),"editor.gotoLocation.multipleReferences":Object.assign({description:w.localize(30,null)},ve),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,enum:Le,description:w.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,enum:Le,description:w.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,enum:Le,description:w.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,enum:Le,description:w.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,enum:Le,description:w.localize(35,null)}})}validate(te){var ve,Le,He,xe,Xe;if(!te||typeof te!="object")return this.defaultValue;const W=te;return{multiple:m(W.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ve=W.multipleDefinitions)!==null&&ve!==void 0?ve:m(W.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Le=W.multipleTypeDefinitions)!==null&&Le!==void 0?Le:m(W.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(He=W.multipleDeclarations)!==null&&He!==void 0?He:m(W.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(xe=W.multipleImplementations)!==null&&xe!==void 0?xe:m(W.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Xe=W.multipleReferences)!==null&&Xe!==void 0?Xe:m(W.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(W.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(W.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(W.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(W.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(W.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class q extends k{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(50,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:w.localize(36,null)},"editor.hover.delay":{type:"number",default:te.delay,description:w.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:w.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:c(ve.enabled,this.defaultValue.enabled),delay:o.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:c(ve.sticky,this.defaultValue.sticky)}}}var z;(function(H){H[H.None=0]="None",H[H.Text=1]="Text",H[H.Blocks=2]="Blocks"})(z=e.RenderMinimap||(e.RenderMinimap={}));class ee extends i{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(te,ve,Le){return ee.computeLayout(ve,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const ve=te.height/te.lineHeight,Le=te.scrollBeyondLastLine?ve-1:0,He=(te.viewLineCount+Le)/(te.pixelRatio*te.height),xe=Math.floor(te.viewLineCount/He);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:Le,desiredRatio:He,minimapLineCount:xe}}static _computeMinimapLayout(te,ve){const Le=te.outerWidth,He=te.outerHeight,xe=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(xe*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const Xe=ve.stableMinimapLayoutInput,W=Xe&&te.outerHeight===Xe.outerHeight&&te.lineHeight===Xe.lineHeight&&te.typicalHalfwidthCharacterWidth===Xe.typicalHalfwidthCharacterWidth&&te.pixelRatio===Xe.pixelRatio&&te.scrollBeyondLastLine===Xe.scrollBeyondLastLine&&te.minimap.enabled===Xe.minimap.enabled&&te.minimap.side===Xe.minimap.side&&te.minimap.size===Xe.minimap.size&&te.minimap.showSlider===Xe.minimap.showSlider&&te.minimap.renderCharacters===Xe.minimap.renderCharacters&&te.minimap.maxColumn===Xe.minimap.maxColumn&&te.minimap.scale===Xe.minimap.scale&&te.verticalScrollbarWidth===Xe.verticalScrollbarWidth&&te.isViewportWrapping===Xe.isViewportWrapping,re=te.lineHeight,ce=te.typicalHalfwidthCharacterWidth,V=te.scrollBeyondLastLine,Z=te.minimap.renderCharacters;let ae=xe>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const he=te.minimap.maxColumn,ye=te.minimap.size,ze=te.minimap.side,$e=te.verticalScrollbarWidth,Be=te.viewLineCount,Ge=te.remainingWidth,nt=te.isViewportWrapping,dt=Z?2:3;let it=Math.floor(xe*He);const Ye=it/xe;let mt=!1,wt=!1,we=dt*ae,de=ae/xe,oe=1;if(ye==="fill"||ye==="fit"){const{typicalViewportLineCount:ht,extraLinesBeyondLastLine:Je,desiredRatio:ot,minimapLineCount:ft}=ee.computeContainedMinimapLineCount({viewLineCount:Be,scrollBeyondLastLine:V,height:He,lineHeight:re,pixelRatio:xe});if(Be/ft>1)mt=!0,wt=!0,ae=1,we=1,de=ae/xe;else{let _t=!1,vt=ae+1;if(ye==="fit"){const Dt=Math.ceil((Be+Je)*we);nt&&W&&Ge<=ve.stableFitRemainingWidth?(_t=!0,vt=ve.stableFitMaxMinimapScale):(_t=Dt>it,nt&&_t?(ve.stableMinimapLayoutInput=te,ve.stableFitRemainingWidth=Ge):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0))}if(ye==="fill"||_t){mt=!0;const Dt=ae;we=Math.min(re*xe,Math.max(1,Math.floor(1/ot))),ae=Math.min(vt,Math.max(1,Math.floor(we/dt))),ae>Dt&&(oe=Math.min(2,ae/Dt)),de=ae/xe/oe,it=Math.ceil(Math.max(ht,Be+Je)*we),nt&&_t&&(ve.stableFitMaxMinimapScale=ae)}}}const j=Math.floor(he*de),Re=Math.min(j,Math.max(0,Math.floor((Ge-$e-2)*de/(ce+de)))+e.MINIMAP_GUTTER_WIDTH);let Pe=Math.floor(xe*Re);const Qe=Pe/xe;Pe=Math.floor(Pe*oe);const Ze=Z?1:2,ut=ze==="left"?0:Le-Re-$e;return{renderMinimap:Ze,minimapLeft:ut,minimapWidth:Re,minimapHeightIsEditorHeight:mt,minimapIsSampling:wt,minimapScale:ae,minimapLineHeight:we,minimapCanvasInnerWidth:Pe,minimapCanvasInnerHeight:it,minimapCanvasOuterWidth:Qe,minimapCanvasOuterHeight:Ye}}static computeLayout(te,ve){const Le=ve.outerWidth|0,He=ve.outerHeight|0,xe=ve.lineHeight|0,Xe=ve.lineNumbersDigitCount|0,W=ve.typicalHalfwidthCharacterWidth,re=ve.maxDigitWidth,ce=ve.pixelRatio,V=ve.viewLineCount,Z=te.get(118),ae=Z==="inherit"?te.get(117):Z,he=ae==="inherit"?te.get(113):ae,ye=te.get(116),ze=te.get(2),$e=ve.isDominatedByLongLines,Be=te.get(46),Ge=te.get(56).renderType!==0,nt=te.get(57),dt=te.get(91),it=te.get(61),Ye=te.get(89),mt=Ye.verticalScrollbarSize,wt=Ye.verticalHasArrows,we=Ye.arrowSize,de=Ye.horizontalScrollbarSize,oe=te.get(54),j=te.get(35);let Re;if(typeof oe=="string"&&/^\d+(\.\d+)?ch$/.test(oe)){const bt=parseFloat(oe.substr(0,oe.length-2));Re=o.clampedInt(bt*W,0,0,1e3)}else Re=o.clampedInt(oe,0,0,1e3);j&&(Re+=16);let Pe=0;if(Ge){const bt=Math.max(Xe,nt);Pe=Math.round(bt*re)}let Qe=0;Be&&(Qe=xe);let Ze=0,ut=Ze+Qe,ht=ut+Pe,Je=ht+Re;const ot=Le-Qe-Pe-Re;let ft=!1,at=!1,_t=-1;ze!==2&&(ae==="inherit"&&$e?(ft=!0,at=!0):he==="on"||he==="bounded"?at=!0:he==="wordWrapColumn"&&(_t=ye));const vt=ee._computeMinimapLayout({outerWidth:Le,outerHeight:He,lineHeight:xe,typicalHalfwidthCharacterWidth:W,pixelRatio:ce,scrollBeyondLastLine:dt,minimap:it,verticalScrollbarWidth:mt,viewLineCount:V,remainingWidth:ot,isViewportWrapping:at},ve.memory||new S);vt.renderMinimap!==0&&vt.minimapLeft===0&&(Ze+=vt.minimapWidth,ut+=vt.minimapWidth,ht+=vt.minimapWidth,Je+=vt.minimapWidth);const Dt=ot-vt.minimapWidth,It=Math.max(1,Math.floor((Dt-mt-2)/W)),Pt=wt?we:0;return at&&(_t=Math.max(1,It),he==="bounded"&&(_t=Math.min(_t,ye))),{width:Le,height:He,glyphMarginLeft:Ze,glyphMarginWidth:Qe,lineNumbersLeft:ut,lineNumbersWidth:Pe,decorationsLeft:ht,decorationsWidth:Re,contentLeft:Je,contentWidth:Dt,minimap:vt,viewportColumn:It,isWordWrapMinified:ft,isViewportWrapping:at,wrappingColumn:_t,verticalScrollbarWidth:mt,horizontalScrollbarHeight:de,overviewRuler:{top:Pt,width:mt,height:He-2*Pt,right:0}}}}e.EditorLayoutInfoComputer=ee;class $ extends k{constructor(){const te={enabled:!0};super(53,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:w.localize(39,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:c(te.enabled,this.defaultValue.enabled)}}}class R extends k{constructor(){const te={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",te,{"editor.inlineHints.enabled":{type:"boolean",default:te.enabled,description:w.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:te.fontSize,description:w.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:te.fontFamily,description:w.localize(42,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:c(ve.enabled,this.defaultValue.enabled),fontSize:o.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class M extends o{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:w.localize(43,null)})}compute(te,ve,Le){return te.fontInfo.lineHeight}}class x extends k{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:w.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[w.localize(45,null),w.localize(46,null),w.localize(47,null)],default:te.size,description:w.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:w.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:w.localize(50,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:w.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:w.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:w.localize(53,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:c(ve.enabled,this.defaultValue.enabled),size:m(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:m(ve.side,this.defaultValue.side,["right","left"]),showSlider:m(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(ve.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(ve.scale,1,1,3),maxColumn:o.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function O(H){return H==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class G extends k{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(55,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{top:o.clampedInt(ve.top,0,0,1e3),bottom:o.clampedInt(ve.bottom,0,0,1e3)}}}class Y extends k{constructor(){const te={enabled:!0,cycle:!1};super(72,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:w.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:w.localize(57,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:c(ve.enabled,this.defaultValue.enabled),cycle:c(ve.cycle,this.defaultValue.cycle)}}}class ne extends i{constructor(){super(124)}compute(te,ve,Le){return te.pixelRatio}}class pe extends k{constructor(){const te={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:w.localize(58,null)},comments:{type:"boolean",default:te.comments,description:w.localize(59,null)},other:{type:"boolean",default:te.other,description:w.localize(60,null)}}}],default:te,description:w.localize(61,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const ve=te,Le={other:c(ve.other,this.defaultValue.other),comments:c(ve.comments,this.defaultValue.comments),strings:c(ve.strings,this.defaultValue.strings)};return Le.other&&Le.comments&&Le.strings?!0:!Le.other&&!Le.comments&&!Le.strings?!1:Le}return this.defaultValue}}var Ie;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval",H[H.Custom=4]="Custom"})(Ie=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Oe extends k{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[w.localize(62,null),w.localize(63,null),w.localize(64,null),w.localize(65,null)],default:"on",description:w.localize(66,null)})}validate(te){let ve=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(ve=4,Le=te):te==="interval"?ve=3:te==="relative"?ve=2:te==="on"?ve=1:ve=0),{renderType:ve,renderFn:Le}}}function Te(H){const te=H.get(84);return te==="editable"?H.get(77):te!=="on"}e.filterValidationDecorations=Te;class Ue extends k{constructor(){const te=[],ve={type:"number",description:w.localize(67,null)};super(88,"rulers",te,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:w.localize(68,null),format:"color-hex"}}}]},default:te,description:w.localize(69,null)})}validate(te){if(Array.isArray(te)){let ve=[];for(let Le of te)if(typeof Le=="number")ve.push({column:o.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const He=Le;ve.push({column:o.clampedInt(He.column,0,0,1e4),color:He.color})}return ve.sort((Le,He)=>Le.column-He.column),ve}return this.defaultValue}}function B(H,te){if(typeof H!="string")return te;switch(H){case"hidden":return 2;case"visible":return 3;default:return 1}}class K extends k{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te,Le=o.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=o.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:B(ve.vertical,this.defaultValue.vertical),horizontal:B(ve.horizontal,this.defaultValue.horizontal),useShadows:c(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:o.clampedInt(ve.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:He,verticalSliderSize:o.clampedInt(ve.verticalSliderSize,He,0,1e3),scrollByPage:c(ve.scrollByPage,this.defaultValue.scrollByPage)}}}class ie extends k{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[w.localize(70,null),w.localize(71,null)],default:te.insertMode,description:w.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:w.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:w.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:w.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:w.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:w.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:w.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:w.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:w.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:w.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:w.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:w.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:w.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:w.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:w.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:w.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:w.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:w.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:w.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:w.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:w.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:w.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:w.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:w.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:w.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:w.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:w.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:w.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:w.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:w.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:w.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:w.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:w.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:w.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:w.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:w.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:w.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:w.localize(109,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{insertMode:m(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:c(ve.showIcons,this.defaultValue.showIcons),showStatusBar:c(ve.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:c(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(ve.showMethods,this.defaultValue.showMethods),showFunctions:c(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:c(ve.showConstructors,this.defaultValue.showConstructors),showFields:c(ve.showFields,this.defaultValue.showFields),showVariables:c(ve.showVariables,this.defaultValue.showVariables),showClasses:c(ve.showClasses,this.defaultValue.showClasses),showStructs:c(ve.showStructs,this.defaultValue.showStructs),showInterfaces:c(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:c(ve.showModules,this.defaultValue.showModules),showProperties:c(ve.showProperties,this.defaultValue.showProperties),showEvents:c(ve.showEvents,this.defaultValue.showEvents),showOperators:c(ve.showOperators,this.defaultValue.showOperators),showUnits:c(ve.showUnits,this.defaultValue.showUnits),showValues:c(ve.showValues,this.defaultValue.showValues),showConstants:c(ve.showConstants,this.defaultValue.showConstants),showEnums:c(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:c(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(ve.showKeywords,this.defaultValue.showKeywords),showWords:c(ve.showWords,this.defaultValue.showWords),showColors:c(ve.showColors,this.defaultValue.showColors),showFiles:c(ve.showFiles,this.defaultValue.showFiles),showReferences:c(ve.showReferences,this.defaultValue.showReferences),showFolders:c(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:c(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(ve.showSnippets,this.defaultValue.showSnippets),showUsers:c(ve.showUsers,this.defaultValue.showUsers),showIssues:c(ve.showIssues,this.defaultValue.showIssues)}}}class le extends k{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:w.localize(110,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class fe extends i{constructor(){super(125,[77])}compute(te,ve,Le){return ve.get(77)?!0:te.tabFocusMode}}var Se;(function(H){H[H.None=0]="None",H[H.Same=1]="Same",H[H.Indent=2]="Indent",H[H.DeepIndent=3]="DeepIndent"})(Se=e.WrappingIndent||(e.WrappingIndent={}));function Ne(H){switch(H){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ge extends i{constructor(){super(127,[126])}compute(te,ve,Le){const He=ve.get(126);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",Ae="Menlo, Monaco, 'Courier New', monospace",We="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?Ae:I.isLinux?We:Ce,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Ee(H){return e.editorOptionsRegistry[H.id]=H,H}var je;(function(H){H[H.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",H[H.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",H[H.accessibilitySupport=2]="accessibilitySupport",H[H.accessibilityPageSize=3]="accessibilityPageSize",H[H.ariaLabel=4]="ariaLabel",H[H.autoClosingBrackets=5]="autoClosingBrackets",H[H.autoClosingDelete=6]="autoClosingDelete",H[H.autoClosingOvertype=7]="autoClosingOvertype",H[H.autoClosingQuotes=8]="autoClosingQuotes",H[H.autoIndent=9]="autoIndent",H[H.automaticLayout=10]="automaticLayout",H[H.autoSurround=11]="autoSurround",H[H.codeLens=12]="codeLens",H[H.codeLensFontFamily=13]="codeLensFontFamily",H[H.codeLensFontSize=14]="codeLensFontSize",H[H.colorDecorators=15]="colorDecorators",H[H.columnSelection=16]="columnSelection",H[H.comments=17]="comments",H[H.contextmenu=18]="contextmenu",H[H.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",H[H.cursorBlinking=20]="cursorBlinking",H[H.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",H[H.cursorStyle=22]="cursorStyle",H[H.cursorSurroundingLines=23]="cursorSurroundingLines",H[H.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",H[H.cursorWidth=25]="cursorWidth",H[H.disableLayerHinting=26]="disableLayerHinting",H[H.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",H[H.domReadOnly=28]="domReadOnly",H[H.dragAndDrop=29]="dragAndDrop",H[H.emptySelectionClipboard=30]="emptySelectionClipboard",H[H.extraEditorClassName=31]="extraEditorClassName",H[H.fastScrollSensitivity=32]="fastScrollSensitivity",H[H.find=33]="find",H[H.fixedOverflowWidgets=34]="fixedOverflowWidgets",H[H.folding=35]="folding",H[H.foldingStrategy=36]="foldingStrategy",H[H.foldingHighlight=37]="foldingHighlight",H[H.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",H[H.fontFamily=39]="fontFamily",H[H.fontInfo=40]="fontInfo",H[H.fontLigatures=41]="fontLigatures",H[H.fontSize=42]="fontSize",H[H.fontWeight=43]="fontWeight",H[H.formatOnPaste=44]="formatOnPaste",H[H.formatOnType=45]="formatOnType",H[H.glyphMargin=46]="glyphMargin",H[H.gotoLocation=47]="gotoLocation",H[H.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",H[H.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",H[H.hover=50]="hover",H[H.inDiffEditor=51]="inDiffEditor",H[H.letterSpacing=52]="letterSpacing",H[H.lightbulb=53]="lightbulb",H[H.lineDecorationsWidth=54]="lineDecorationsWidth",H[H.lineHeight=55]="lineHeight",H[H.lineNumbers=56]="lineNumbers",H[H.lineNumbersMinChars=57]="lineNumbersMinChars",H[H.linkedEditing=58]="linkedEditing",H[H.links=59]="links",H[H.matchBrackets=60]="matchBrackets",H[H.minimap=61]="minimap",H[H.mouseStyle=62]="mouseStyle",H[H.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",H[H.mouseWheelZoom=64]="mouseWheelZoom",H[H.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",H[H.multiCursorModifier=66]="multiCursorModifier",H[H.multiCursorPaste=67]="multiCursorPaste",H[H.occurrencesHighlight=68]="occurrencesHighlight",H[H.overviewRulerBorder=69]="overviewRulerBorder",H[H.overviewRulerLanes=70]="overviewRulerLanes",H[H.padding=71]="padding",H[H.parameterHints=72]="parameterHints",H[H.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",H[H.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",H[H.quickSuggestions=75]="quickSuggestions",H[H.quickSuggestionsDelay=76]="quickSuggestionsDelay",H[H.readOnly=77]="readOnly",H[H.renameOnType=78]="renameOnType",H[H.renderControlCharacters=79]="renderControlCharacters",H[H.renderIndentGuides=80]="renderIndentGuides",H[H.renderFinalNewline=81]="renderFinalNewline",H[H.renderLineHighlight=82]="renderLineHighlight",H[H.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",H[H.renderValidationDecorations=84]="renderValidationDecorations",H[H.renderWhitespace=85]="renderWhitespace",H[H.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",H[H.roundedSelection=87]="roundedSelection",H[H.rulers=88]="rulers",H[H.scrollbar=89]="scrollbar",H[H.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",H[H.scrollBeyondLastLine=91]="scrollBeyondLastLine",H[H.scrollPredominantAxis=92]="scrollPredominantAxis",H[H.selectionClipboard=93]="selectionClipboard",H[H.selectionHighlight=94]="selectionHighlight",H[H.selectOnLineNumbers=95]="selectOnLineNumbers",H[H.showFoldingControls=96]="showFoldingControls",H[H.showUnused=97]="showUnused",H[H.snippetSuggestions=98]="snippetSuggestions",H[H.smartSelect=99]="smartSelect",H[H.smoothScrolling=100]="smoothScrolling",H[H.stickyTabStops=101]="stickyTabStops",H[H.stopRenderingLineAfter=102]="stopRenderingLineAfter",H[H.suggest=103]="suggest",H[H.suggestFontSize=104]="suggestFontSize",H[H.suggestLineHeight=105]="suggestLineHeight",H[H.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",H[H.suggestSelection=107]="suggestSelection",H[H.tabCompletion=108]="tabCompletion",H[H.tabIndex=109]="tabIndex",H[H.unusualLineTerminators=110]="unusualLineTerminators",H[H.useTabStops=111]="useTabStops",H[H.wordSeparators=112]="wordSeparators",H[H.wordWrap=113]="wordWrap",H[H.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",H[H.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",H[H.wordWrapColumn=116]="wordWrapColumn",H[H.wordWrapOverride1=117]="wordWrapOverride1",H[H.wordWrapOverride2=118]="wordWrapOverride2",H[H.wrappingIndent=119]="wrappingIndent",H[H.wrappingStrategy=120]="wrappingStrategy",H[H.showDeprecated=121]="showDeprecated",H[H.inlineHints=122]="inlineHints",H[H.editorClassName=123]="editorClassName",H[H.pixelRatio=124]="pixelRatio",H[H.tabFocusMode=125]="tabFocusMode",H[H.layoutInfo=126]="layoutInfo",H[H.wrappingInfo=127]="wrappingInfo"})(je=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ee(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:w.localize(111,null)})),acceptSuggestionOnEnter:Ee(new D(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",w.localize(112,null),""],markdownDescription:w.localize(113,null)})),accessibilitySupport:Ee(new p),accessibilityPageSize:Ee(new o(3,"accessibilityPageSize",10,1,1073741824,{description:w.localize(114,null)})),ariaLabel:Ee(new g(4,"ariaLabel",w.localize(115,null))),autoClosingBrackets:Ee(new D(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(116,null),w.localize(117,null),""],description:w.localize(118,null)})),autoClosingDelete:Ee(new D(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",w.localize(119,null),""],description:w.localize(120,null)})),autoClosingOvertype:Ee(new D(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",w.localize(121,null),""],description:w.localize(122,null)})),autoClosingQuotes:Ee(new D(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(123,null),w.localize(124,null),""],description:w.localize(125,null)})),autoIndent:Ee(new f(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[w.localize(126,null),w.localize(127,null),w.localize(128,null),w.localize(129,null),w.localize(130,null)],description:w.localize(131,null)})),automaticLayout:Ee(new d(10,"automaticLayout",!1)),autoSurround:Ee(new D(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[w.localize(132,null),w.localize(133,null),w.localize(134,null),""],description:w.localize(135,null)})),stickyTabStops:Ee(new d(101,"stickyTabStops",!1,{description:w.localize(136,null)})),codeLens:Ee(new d(12,"codeLens",!0,{description:w.localize(137,null)})),codeLensFontFamily:Ee(new g(13,"codeLensFontFamily","",{description:w.localize(138,null)})),codeLensFontSize:Ee(new o(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:w.localize(139,null)})),colorDecorators:Ee(new d(15,"colorDecorators",!0,{description:w.localize(140,null)})),columnSelection:Ee(new d(16,"columnSelection",!1,{description:w.localize(141,null)})),comments:Ee(new t),contextmenu:Ee(new d(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Ee(new d(19,"copyWithSyntaxHighlighting",!0,{description:w.localize(142,null)})),cursorBlinking:Ee(new f(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:w.localize(143,null)})),cursorSmoothCaretAnimation:Ee(new d(21,"cursorSmoothCaretAnimation",!1,{description:w.localize(144,null)})),cursorStyle:Ee(new f(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],h,{description:w.localize(145,null)})),cursorSurroundingLines:Ee(new o(23,"cursorSurroundingLines",0,0,1073741824,{description:w.localize(146,null)})),cursorSurroundingLinesStyle:Ee(new D(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[w.localize(147,null),w.localize(148,null)],description:w.localize(149,null)})),cursorWidth:Ee(new o(25,"cursorWidth",0,0,1073741824,{markdownDescription:w.localize(150,null)})),disableLayerHinting:Ee(new d(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ee(new d(27,"disableMonospaceOptimizations",!1)),domReadOnly:Ee(new d(28,"domReadOnly",!1)),dragAndDrop:Ee(new d(29,"dragAndDrop",!0,{description:w.localize(151,null)})),emptySelectionClipboard:Ee(new _),extraEditorClassName:Ee(new g(31,"extraEditorClassName","")),fastScrollSensitivity:Ee(new l(32,"fastScrollSensitivity",5,H=>H<=0?5:H,{markdownDescription:w.localize(152,null)})),find:Ee(new v),fixedOverflowWidgets:Ee(new d(34,"fixedOverflowWidgets",!1)),folding:Ee(new d(35,"folding",!0,{description:w.localize(153,null)})),foldingStrategy:Ee(new D(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[w.localize(154,null),w.localize(155,null)],description:w.localize(156,null)})),foldingHighlight:Ee(new d(37,"foldingHighlight",!0,{description:w.localize(157,null)})),unfoldOnClickAfterEndOfLine:Ee(new d(38,"unfoldOnClickAfterEndOfLine",!1,{description:w.localize(158,null)})),fontFamily:Ee(new g(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:w.localize(159,null)})),fontInfo:Ee(new F),fontLigatures2:Ee(new E),fontSize:Ee(new U),fontWeight:Ee(new J),formatOnPaste:Ee(new d(44,"formatOnPaste",!1,{description:w.localize(160,null)})),formatOnType:Ee(new d(45,"formatOnType",!1,{description:w.localize(161,null)})),glyphMargin:Ee(new d(46,"glyphMargin",!0,{description:w.localize(162,null)})),gotoLocation:Ee(new me),hideCursorInOverviewRuler:Ee(new d(48,"hideCursorInOverviewRuler",!1,{description:w.localize(163,null)})),highlightActiveIndentGuide:Ee(new d(49,"highlightActiveIndentGuide",!0,{description:w.localize(164,null)})),hover:Ee(new q),inDiffEditor:Ee(new d(51,"inDiffEditor",!1)),letterSpacing:Ee(new l(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,H=>l.clamp(H,-5,20),{description:w.localize(165,null)})),lightbulb:Ee(new $),lineDecorationsWidth:Ee(new P(54,"lineDecorationsWidth",10)),lineHeight:Ee(new M),lineNumbers:Ee(new Oe),lineNumbersMinChars:Ee(new o(57,"lineNumbersMinChars",5,1,300)),linkedEditing:Ee(new d(58,"linkedEditing",!1,{description:w.localize(166,null)})),links:Ee(new d(59,"links",!0,{description:w.localize(167,null)})),matchBrackets:Ee(new D(60,"matchBrackets","always",["always","near","never"],{description:w.localize(168,null)})),minimap:Ee(new x),mouseStyle:Ee(new D(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ee(new l(63,"mouseWheelScrollSensitivity",1,H=>H===0?1:H,{markdownDescription:w.localize(169,null)})),mouseWheelZoom:Ee(new d(64,"mouseWheelZoom",!1,{markdownDescription:w.localize(170,null)})),multiCursorMergeOverlapping:Ee(new d(65,"multiCursorMergeOverlapping",!0,{description:w.localize(171,null)})),multiCursorModifier:Ee(new f(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],O,{markdownEnumDescriptions:[w.localize(172,null),w.localize(173,null)],markdownDescription:w.localize(174,null)})),multiCursorPaste:Ee(new D(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[w.localize(175,null),w.localize(176,null)],markdownDescription:w.localize(177,null)})),occurrencesHighlight:Ee(new d(68,"occurrencesHighlight",!0,{description:w.localize(178,null)})),overviewRulerBorder:Ee(new d(69,"overviewRulerBorder",!0,{description:w.localize(179,null)})),overviewRulerLanes:Ee(new o(70,"overviewRulerLanes",3,0,3)),padding:Ee(new G),parameterHints:Ee(new Y),peekWidgetDefaultFocus:Ee(new D(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[w.localize(180,null),w.localize(181,null)],description:w.localize(182,null)})),definitionLinkOpensInPeek:Ee(new d(74,"definitionLinkOpensInPeek",!1,{description:w.localize(183,null)})),quickSuggestions:Ee(new pe),quickSuggestionsDelay:Ee(new o(76,"quickSuggestionsDelay",10,0,1073741824,{description:w.localize(184,null)})),readOnly:Ee(new d(77,"readOnly",!1)),renameOnType:Ee(new d(78,"renameOnType",!1,{description:w.localize(185,null),markdownDeprecationMessage:w.localize(186,null)})),renderControlCharacters:Ee(new d(79,"renderControlCharacters",!1,{description:w.localize(187,null)})),renderIndentGuides:Ee(new d(80,"renderIndentGuides",!0,{description:w.localize(188,null)})),renderFinalNewline:Ee(new d(81,"renderFinalNewline",!0,{description:w.localize(189,null)})),renderLineHighlight:Ee(new D(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",w.localize(190,null)],description:w.localize(191,null)})),renderLineHighlightOnlyWhenFocus:Ee(new d(83,"renderLineHighlightOnlyWhenFocus",!1,{description:w.localize(192,null)})),renderValidationDecorations:Ee(new D(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ee(new D(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",w.localize(193,null),w.localize(194,null),w.localize(195,null),""],description:w.localize(196,null)})),revealHorizontalRightPadding:Ee(new o(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ee(new d(87,"roundedSelection",!0,{description:w.localize(197,null)})),rulers:Ee(new Ue),scrollbar:Ee(new K),scrollBeyondLastColumn:Ee(new o(90,"scrollBeyondLastColumn",5,0,1073741824,{description:w.localize(198,null)})),scrollBeyondLastLine:Ee(new d(91,"scrollBeyondLastLine",!0,{description:w.localize(199,null)})),scrollPredominantAxis:Ee(new d(92,"scrollPredominantAxis",!0,{description:w.localize(200,null)})),selectionClipboard:Ee(new d(93,"selectionClipboard",!0,{description:w.localize(201,null),included:I.isLinux})),selectionHighlight:Ee(new d(94,"selectionHighlight",!0,{description:w.localize(202,null)})),selectOnLineNumbers:Ee(new d(95,"selectOnLineNumbers",!0)),showFoldingControls:Ee(new D(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[w.localize(203,null),w.localize(204,null)],description:w.localize(205,null)})),showUnused:Ee(new d(97,"showUnused",!0,{description:w.localize(206,null)})),showDeprecated:Ee(new d(121,"showDeprecated",!0,{description:w.localize(207,null)})),inlineHints:Ee(new R),snippetSuggestions:Ee(new D(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[w.localize(208,null),w.localize(209,null),w.localize(210,null),w.localize(211,null)],description:w.localize(212,null)})),smartSelect:Ee(new le),smoothScrolling:Ee(new d(100,"smoothScrolling",!1,{description:w.localize(213,null)})),stopRenderingLineAfter:Ee(new o(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ee(new ie),suggestFontSize:Ee(new o(104,"suggestFontSize",0,0,1e3,{markdownDescription:w.localize(214,null)})),suggestLineHeight:Ee(new o(105,"suggestLineHeight",0,0,1e3,{markdownDescription:w.localize(215,null)})),suggestOnTriggerCharacters:Ee(new d(106,"suggestOnTriggerCharacters",!0,{description:w.localize(216,null)})),suggestSelection:Ee(new D(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[w.localize(217,null),w.localize(218,null),w.localize(219,null)],description:w.localize(220,null)})),tabCompletion:Ee(new D(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[w.localize(221,null),w.localize(222,null),w.localize(223,null)],description:w.localize(224,null)})),tabIndex:Ee(new o(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Ee(new D(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[w.localize(225,null),w.localize(226,null),w.localize(227,null)],description:w.localize(228,null)})),useTabStops:Ee(new d(111,"useTabStops",!0,{description:w.localize(229,null)})),wordSeparators:Ee(new g(112,"wordSeparators",A.USUAL_WORD_SEPARATORS,{description:w.localize(230,null)})),wordWrap:Ee(new D(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[w.localize(231,null),w.localize(232,null),w.localize(233,null),w.localize(234,null)],description:w.localize(235,null)})),wordWrapBreakAfterCharacters:Ee(new g(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ee(new g(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ee(new o(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:w.localize(236,null)})),wordWrapOverride1:Ee(new D(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ee(new D(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ee(new f(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ne,{enumDescriptions:[w.localize(237,null),w.localize(238,null),w.localize(239,null),w.localize(240,null)],description:w.localize(241,null)})),wrappingStrategy:Ee(new D(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[w.localize(242,null),w.localize(243,null)],description:w.localize(244,null)})),editorClassName:Ee(new b),pixelRatio:Ee(new ne),tabFocusMode:Ee(new fe),layoutInfo:Ee(new ee),wrappingInfo:Ee(new ge)}}),define(be[124],_e([16,17]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[125],_e([16,17]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[126],_e([16,17]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(be[127],_e([16,17]),function(Q,e){return Q.create("vs/platform/markers/common/markers",e)}),define(be[128],_e([16,17]),function(Q,e){return Q.create("vs/platform/theme/common/iconRegistry",e)}),define(be[129],_e([16,17]),function(Q,e){return Q.create("vs/platform/workspaces/common/workspaces",e)}),define(be[130],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHost.api.impl",e)}),define(be[131],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[132],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(be[133],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[134],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostProgress",e)}),define(be[135],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[136],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[137],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[138],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[139],_e([16,17]),function(Q,e){return Q.create("vs/workbench/common/views",e)}),define(be[140],_e([16,17]),function(Q,e){return Q.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[141],_e([16,17]),function(Q,e){return Q.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[142],_e([16,17]),function(Q,e){return Q.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[143],_e([16,17]),function(Q,e){return Q.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[144],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var w;(function(y){y[y.ACTIVATE=0]="ACTIVATE",y[y.RESTORE=1]="RESTORE",y[y.PRESERVE=2]="PRESERVE"})(w=e.EditorActivation||(e.EditorActivation={}));var I;(function(y){y[y.PICK=1]="PICK",y[y.DISABLED=2]="DISABLED"})(I=e.EditorOverride||(e.EditorOverride={}));var A;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(A=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[145],_e([0,1,125]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function A(P){return P=P.trim(),P==="*"||I.test(P)}e.isValidVersionStr=A;function T(P){if(!A(P))return null;if(P=P.trim(),P==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let c=P.match(I);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.parseVersion=T;function y(P){if(!P)return null;let c=P.majorBase,d=P.majorMustEqual,o=P.minorBase,l=P.minorMustEqual,g=P.patchBase,m=P.patchMustEqual;return P.hasCaret&&(c===0||(l=!1),m=!1),{majorBase:c,majorMustEqual:d,minorBase:o,minorMustEqual:l,patchBase:g,patchMustEqual:m,isMinimum:P.hasGreaterEquals}}e.normalizeVersion=y;function C(P,c){let d;typeof P=="string"?d=y(T(P)):d=P;let o;if(typeof c=="string"?o=y(T(c)):o=c,!d||!o)return!1;let l=d.majorBase,g=d.minorBase,m=d.patchBase,D=o.majorBase,f=o.minorBase,u=o.patchBase,p=o.majorMustEqual,t=o.minorMustEqual,n=o.patchMustEqual;return o.isMinimum?l>D?!0:l<D?!1:g>f?!0:g<f?!1:m>=u:(l===1&&D===0&&(!p||!t||!n)&&(D=1,f=0,u=0,p=!0,t=!1,n=!1),l<D?!1:l>D?!p:g<f?!1:g>f?!t:m<u?!1:m>u?!n:!0)}e.isValidVersion=C;function S(P,c,d){return c.isBuiltin||typeof c.main=="undefined"?!0:i(P,c.engines.vscode,d)}e.isValidExtensionVersion=S;function k(P,c){return P==="*"||i(c,P)}e.isEngineValid=k;function i(P,c,d=[]){let o=y(T(c));if(!o)return d.push(w.localize(0,null,c)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return d.push(w.localize(1,null,c)),!1}else if(!o.majorMustEqual)return d.push(w.localize(2,null,c)),!1;return C(P,o)?!0:(d.push(w.localize(3,null,P,c)),!1)}e.isVersionValid=i}),define(be[89],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class w{constructor(T,y=[],C=!1){this.ctor=T,this.staticArguments=y,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=w;const I=(A,...T)=>new w(A,T);e.createSyncDescriptor=I}),define(be[61],_e([0,1,89]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const I=[];function A(y,C,S){C instanceof w.SyncDescriptor||(C=new w.SyncDescriptor(C,[],S)),I.push([y,C])}e.registerSingleton=A;function T(){return I}e.getSingletonServiceDescriptors=T}),define(be[146],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=w;class I{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let y of this._nodes.values())y.outgoing.size===0&&T.push(y);return T}insertEdge(T,y){const C=this.lookupOrInsertNode(T),S=this.lookupOrInsertNode(y);C.outgoing.set(this._hashFn(y),S),S.incoming.set(this._hashFn(T),C)}removeNode(T){const y=this._hashFn(T);this._nodes.delete(y);for(let C of this._nodes.values())C.outgoing.delete(y),C.incoming.delete(y)}lookupOrInsertNode(T){const y=this._hashFn(T);let C=this._nodes.get(y);return C||(C=new w(T),this._nodes.set(y,C)),C}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[y,C]of this._nodes)T.push(`${y}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,y]of this._nodes){const C=new Set([T]),S=this._findCycle(y,C);if(S)return S}}_findCycle(T,y){for(let[C,S]of T.outgoing){if(y.has(C))return[...y,C].join(" -> ");y.add(C);const k=this._findCycle(S,y);if(k)return k;y.delete(C)}}}e.Graph=I}),define(be[4],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function S(k){return k[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=S})(w=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function I(C,S,k,i){S[w.DI_TARGET]===S?S[w.DI_DEPENDENCIES].push({id:C,index:k,optional:i}):(S[w.DI_DEPENDENCIES]=[{id:C,index:k,optional:i}],S[w.DI_TARGET]=S)}function A(C){if(w.serviceIds.has(C))return w.serviceIds.get(C);const S=function(k,i,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(S,k,P,!1)};return S.toString=()=>C,w.serviceIds.set(C,S),S}e.createDecorator=A;function T(C){return C}e.refineServiceDecorator=T;function y(C){return function(S,k,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");I(C,S,i,!0)}}e.optional=y}),define(be[147],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,w.createDecorator)("modelService");function I(A){return!A.isTooLargeForSyncing()&&!A.isForSimpleWidget}e.shouldSynchronizeModel=I}),define(be[148],_e([0,1,3,56,6,22,81,59,147]),function(Q,e,w,I,A,T,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(c){return typeof c=="string"?!1:Array.isArray(c)?c.every(k):!!c.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new w.Emitter}get onDidChange(){return this._onDidChange.event}register(d,o){let l={selector:d,provider:o,_score:-1,_time:this._clock++};return this._entries.push(l),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,A.toDisposable)(()=>{if(l){let g=this._entries.indexOf(l);g>=0&&(this._entries.splice(g,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),l=void 0)}})}has(d){return this.all(d).length>0}all(d){if(!d)return[];this._updateScores(d);const o=[];for(let l of this._entries)l._score>0&&o.push(l.provider);return o}ordered(d){const o=[];return this._orderedForEach(d,l=>o.push(l.provider)),o}orderedGroups(d){const o=[];let l,g;return this._orderedForEach(d,m=>{l&&g===m._score?l.push(m.provider):(g=m._score,l=[m.provider],o.push(l))}),o}_orderedForEach(d,o){if(!!d){this._updateScores(d);for(const l of this._entries)l._score>0&&o(l)}}_updateScores(d){let o={uri:d.uri.toString(),language:d.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===o.language&&this._lastCandidate.uri===o.uri)){this._lastCandidate=o;for(let l of this._entries)if(l._score=(0,C.score)(l.selector,d.uri,d.getLanguageIdentifier().language,(0,S.shouldSynchronizeModel)(d)),k(l.selector)&&l._score>0){for(let g of this._entries)g._score=0;l._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(d,o){return d._score<o._score?1:d._score>o._score?-1:d._time<o._time?1:d._time>o._time?-1:0}}e.LanguageFeatureRegistry=i;class P{constructor(d,o,l=Number.MAX_SAFE_INTEGER){this._registry=d,this.min=o,this.max=l,this._cache=new T.LRUCache(50,.7)}_key(d){return d.id+(0,I.hash)(this._registry.all(d))}_clamp(d){return d===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(d*1.3)))}get(d){const o=this._key(d),l=this._cache.get(o);return this._clamp(l==null?void 0:l.value)}update(d,o){const l=this._key(d);let g=this._cache.get(l);return g||(g=new y.MovingAverage,this._cache.set(l,g)),g.update(o),this.get(d)}}e.LanguageFeatureRequestDelays=P}),define(be[62],_e([0,1,2,32,148,119,36]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(v){v[v.Null=0]="Null",v[v.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class S{constructor(E,F){this.language=E,this.id=F}}e.LanguageIdentifier=S;var k;(function(v){v[v.NotSet=-1]="NotSet",v[v.None=0]="None",v[v.Italic=1]="Italic",v[v.Bold=2]="Bold",v[v.Underline=4]="Underline"})(k=e.FontStyle||(e.FontStyle={}));var i;(function(v){v[v.None=0]="None",v[v.DefaultForeground=1]="DefaultForeground",v[v.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var P;(function(v){v[v.Other=0]="Other",v[v.Comment=1]="Comment",v[v.String=2]="String",v[v.RegEx=4]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var c;(function(v){v[v.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",v[v.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",v[v.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",v[v.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",v[v.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",v[v.ITALIC_MASK=2048]="ITALIC_MASK",v[v.BOLD_MASK=4096]="BOLD_MASK",v[v.UNDERLINE_MASK=8192]="UNDERLINE_MASK",v[v.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",v[v.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",v[v.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",v[v.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",v[v.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",v[v.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",v[v.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",v[v.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",v[v.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",v[v.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(c=e.MetadataConsts||(e.MetadataConsts={}));class d{static getLanguageId(E){return(E&255)>>>0}static getTokenType(E){return(E&1792)>>>8}static getFontStyle(E){return(E&14336)>>>11}static getForeground(E){return(E&8372224)>>>14}static getBackground(E){return(E&4286578688)>>>23}static getClassNameFromMetadata(E){let F=this.getForeground(E),U="mtk"+F,J=this.getFontStyle(E);return J&1&&(U+=" mtki"),J&2&&(U+=" mtkb"),J&4&&(U+=" mtku"),U}static getInlineStyleFromMetadata(E,F){const U=this.getForeground(E),J=this.getFontStyle(E);let me=`color: ${F[U]};`;return J&1&&(me+="font-style: italic;"),J&2&&(me+="font-weight: bold;"),J&4&&(me+="text-decoration: underline;"),me}}e.TokenMetadata=d;var o;(function(v){v[v.Method=0]="Method",v[v.Function=1]="Function",v[v.Constructor=2]="Constructor",v[v.Field=3]="Field",v[v.Variable=4]="Variable",v[v.Class=5]="Class",v[v.Struct=6]="Struct",v[v.Interface=7]="Interface",v[v.Module=8]="Module",v[v.Property=9]="Property",v[v.Event=10]="Event",v[v.Operator=11]="Operator",v[v.Unit=12]="Unit",v[v.Value=13]="Value",v[v.Constant=14]="Constant",v[v.Enum=15]="Enum",v[v.EnumMember=16]="EnumMember",v[v.Keyword=17]="Keyword",v[v.Text=18]="Text",v[v.Color=19]="Color",v[v.File=20]="File",v[v.Reference=21]="Reference",v[v.Customcolor=22]="Customcolor",v[v.Folder=23]="Folder",v[v.TypeParameter=24]="TypeParameter",v[v.User=25]="User",v[v.Issue=26]="Issue",v[v.Snippet=27]="Snippet"})(o=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let v=Object.create(null);return v[0]="symbol-method",v[1]="symbol-function",v[2]="symbol-constructor",v[3]="symbol-field",v[4]="symbol-variable",v[5]="symbol-class",v[6]="symbol-struct",v[7]="symbol-interface",v[8]="symbol-module",v[9]="symbol-property",v[10]="symbol-event",v[11]="symbol-operator",v[12]="symbol-unit",v[13]="symbol-value",v[14]="symbol-constant",v[15]="symbol-enum",v[16]="symbol-enum-member",v[17]="symbol-keyword",v[27]="symbol-snippet",v[18]="symbol-text",v[19]="symbol-color",v[20]="symbol-file",v[21]="symbol-reference",v[22]="symbol-customcolor",v[23]="symbol-folder",v[24]="symbol-type-parameter",v[25]="account",v[26]="issues",function(E){const F=v[E];let U=F&&y.iconRegistry.get(F);return U||(console.info("No codicon found for CompletionItemKind "+E),U=y.Codicon.symbolProperty),U.classNames}}(),e.completionKindFromString=function(){let v=Object.create(null);return v.method=0,v.function=1,v.constructor=2,v.field=3,v.variable=4,v.class=5,v.struct=6,v.interface=7,v.module=8,v.property=9,v.event=10,v.operator=11,v.unit=12,v.value=13,v.constant=14,v.enum=15,v["enum-member"]=16,v.enumMember=16,v.keyword=17,v.snippet=27,v.text=18,v.color=19,v.file=20,v.reference=21,v.customcolor=22,v.folder=23,v["type-parameter"]=24,v.typeParameter=24,v.account=25,v.issue=26,function(E,F){let U=v[E];return typeof U=="undefined"&&!F&&(U=9),U}}();var l;(function(v){v[v.Deprecated=1]="Deprecated"})(l=e.CompletionItemTag||(e.CompletionItemTag={}));var g;(function(v){v[v.KeepWhitespace=1]="KeepWhitespace",v[v.InsertAsSnippet=4]="InsertAsSnippet"})(g=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var m;(function(v){v[v.Invoke=0]="Invoke",v[v.TriggerCharacter=1]="TriggerCharacter",v[v.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var D;(function(v){v[v.Invoke=1]="Invoke",v[v.Auto=2]="Auto"})(D=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var f;(function(v){v[v.Invoke=1]="Invoke",v[v.TriggerCharacter=2]="TriggerCharacter",v[v.ContentChange=3]="ContentChange"})(f=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var u;(function(v){v[v.Text=0]="Text",v[v.Read=1]="Read",v[v.Write=2]="Write"})(u=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function p(v){return v&&w.URI.isUri(v.uri)&&I.Range.isIRange(v.range)&&(I.Range.isIRange(v.originSelectionRange)||I.Range.isIRange(v.targetSelectionRange))}e.isLocationLink=p;var t;(function(v){v[v.File=0]="File",v[v.Module=1]="Module",v[v.Namespace=2]="Namespace",v[v.Package=3]="Package",v[v.Class=4]="Class",v[v.Method=5]="Method",v[v.Property=6]="Property",v[v.Field=7]="Field",v[v.Constructor=8]="Constructor",v[v.Enum=9]="Enum",v[v.Interface=10]="Interface",v[v.Function=11]="Function",v[v.Variable=12]="Variable",v[v.Constant=13]="Constant",v[v.String=14]="String",v[v.Number=15]="Number",v[v.Boolean=16]="Boolean",v[v.Array=17]="Array",v[v.Object=18]="Object",v[v.Key=19]="Key",v[v.Null=20]="Null",v[v.EnumMember=21]="EnumMember",v[v.Struct=22]="Struct",v[v.Event=23]="Event",v[v.Operator=24]="Operator",v[v.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(v){v[v.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var s;(function(v){const E=new Map;E.set("file",0),E.set("module",1),E.set("namespace",2),E.set("package",3),E.set("class",4),E.set("method",5),E.set("property",6),E.set("field",7),E.set("constructor",8),E.set("enum",9),E.set("interface",10),E.set("function",11),E.set("variable",12),E.set("constant",13),E.set("string",14),E.set("number",15),E.set("boolean",16),E.set("array",17),E.set("object",18),E.set("key",19),E.set("null",20),E.set("enum-member",21),E.set("struct",22),E.set("event",23),E.set("operator",24),E.set("type-parameter",25);const F=new Map;F.set(0,"file"),F.set(1,"module"),F.set(2,"namespace"),F.set(3,"package"),F.set(4,"class"),F.set(5,"method"),F.set(6,"property"),F.set(7,"field"),F.set(8,"constructor"),F.set(9,"enum"),F.set(10,"interface"),F.set(11,"function"),F.set(12,"variable"),F.set(13,"constant"),F.set(14,"string"),F.set(15,"number"),F.set(16,"boolean"),F.set(17,"array"),F.set(18,"object"),F.set(19,"key"),F.set(20,"null"),F.set(21,"enum-member"),F.set(22,"struct"),F.set(23,"event"),F.set(24,"operator"),F.set(25,"type-parameter");function U(q){return E.get(q)}v.fromString=U;function J(q){return F.get(q)}v.toString=J;function me(q,z){const ee=F.get(q);let $=ee&&y.iconRegistry.get("symbol-"+ee);return $||(console.info("No codicon found for SymbolKind "+q),$=y.Codicon.symbolProperty),`${z?"inline":"block"} ${$.classNames}`}v.toCssClassName=me})(s=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(E){this.value=E}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var a;(function(v){v[v.Collapsed=0]="Collapsed",v[v.Expanded=1]="Expanded"})(a=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var h;(function(v){v[v.Editing=0]="Editing",v[v.Preview=1]="Preview"})(h=e.CommentMode||(e.CommentMode={}));var b;(function(v){v[v.Other=0]="Other",v[v.Type=1]="Type",v[v.Parameter=2]="Parameter"})(b=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new A.LanguageFeatureRegistry,e.RenameProviderRegistry=new A.LanguageFeatureRegistry,e.CompletionProviderRegistry=new A.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new A.LanguageFeatureRegistry,e.HoverProviderRegistry=new A.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new A.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new A.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new A.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new A.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new A.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new A.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.LinkProviderRegistry=new A.LanguageFeatureRegistry,e.ColorProviderRegistry=new A.LanguageFeatureRegistry,e.SelectionRangeRegistry=new A.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var _;(function(v){v[v.None=0]="None",v[v.Option=1]="Option",v[v.Default=2]="Default",v[v.Preferred=3]="Preferred"})(_=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[149],_e([0,1,6,10,4,3,45,43]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,A.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new T.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(S,k){if(!S)throw new Error("invalid command");if(typeof S=="string"){if(!k)throw new Error("invalid command");return this.registerCommand({id:S,handler:k})}if(S.description){const o=[];for(let g of S.description.args)o.push(g.constraint);const l=S.handler;S.handler=function(g,...m){return(0,I.validateConstraints)(m,o),l(g,...m)}}const{id:i}=S;let P=this._commands.get(i);P||(P=new y.LinkedList,this._commands.set(i,P));let c=P.unshift(S),d=(0,w.toDisposable)(()=>{c();const o=this._commands.get(i);(o==null?void 0:o.isEmpty())&&this._commands.delete(i)});return this._onDidRegisterCommand.fire(i),d}registerCommandAlias(S,k){return e.CommandsRegistry.registerCommand(S,(i,...P)=>i.get(e.ICommandService).executeCommand(k,...P))}getCommand(S){const k=this._commands.get(S);if(!(!k||k.isEmpty()))return C.Iterable.first(k)}getCommands(){const S=new Map;for(const k of this._commands.keys()){const i=this.getCommand(k);i&&S.set(k,i)}return S}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>w.Disposable.None,onDidExecuteCommand:()=>w.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(be[63],_e([0,1,8,4,21]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=A.userAgent||"";const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",A.isMacintosh),y.set("isLinux",A.isLinux),y.set("isWindows",A.isWindows),y.set("isWeb",A.isWeb),y.set("isMacNative",A.isMacintosh&&!A.isWeb),y.set("isEdge",T.indexOf("Edg/")>=0),y.set("isFirefox",T.indexOf("Firefox")>=0),y.set("isChrome",T.indexOf("Chrome")>=0),y.set("isSafari",T.indexOf("Safari")>=0),y.set("isIPad",T.indexOf("iPad")>=0);const C=Object.prototype.hasOwnProperty;var S;(function(v){v[v.False=0]="False",v[v.True=1]="True",v[v.Defined=2]="Defined",v[v.Not=3]="Not",v[v.Equals=4]="Equals",v[v.NotEquals=5]="NotEquals",v[v.And=6]="And",v[v.Regex=7]="Regex",v[v.NotRegex=8]="NotRegex",v[v.Or=9]="Or",v[v.In=10]="In",v[v.NotIn=11]="NotIn",v[v.Greater=12]="Greater",v[v.GreaterEquals=13]="GreaterEquals",v[v.Smaller=14]="Smaller",v[v.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return P.INSTANCE}static true(){return c.INSTANCE}static has(E){return d.create(E)}static equals(E,F){return o.create(E,F)}static notEquals(E,F){return m.create(E,F)}static regex(E,F){return n.create(E,F)}static in(E,F){return l.create(E,F)}static not(E){return D.create(E)}static and(...E){return r.create(E)}static or(...E){return a.create(E)}static greater(E,F){return f.create(E,F)}static less(E,F){return p.create(E,F)}static deserialize(E,F=!1){if(!!E)return this._deserializeOrExpression(E,F)}static _deserializeOrExpression(E,F){let U=E.split("||");return a.create(U.map(J=>this._deserializeAndExpression(J,F)))}static _deserializeAndExpression(E,F){let U=E.split("&&");return r.create(U.map(J=>this._deserializeOne(J,F)))}static _deserializeOne(E,F){if(E=E.trim(),E.indexOf("!=")>=0){let U=E.split("!=");return m.create(U[0].trim(),this._deserializeValue(U[1],F))}if(E.indexOf("==")>=0){let U=E.split("==");return o.create(U[0].trim(),this._deserializeValue(U[1],F))}if(E.indexOf("=~")>=0){let U=E.split("=~");return n.create(U[0].trim(),this._deserializeRegexValue(U[1],F))}if(E.indexOf(" in ")>=0){let U=E.split(" in ");return l.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(E)){const U=E.split(">=");return u.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(E)){const U=E.split(">");return f.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(E)){const U=E.split("<=");return t.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(E)){const U=E.split("<");return p.create(U[0].trim(),U[1].trim())}return/^\!\s*/.test(E)?D.create(E.substr(1).trim()):d.create(E)}static _deserializeValue(E,F){if(E=E.trim(),E==="true")return!0;if(E==="false")return!1;let U=/^'([^']*)'$/.exec(E);return U?U[1].trim():E}static _deserializeRegexValue(E,F){if((0,w.isFalsyOrWhitespace)(E)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let U=E.indexOf("/"),J=E.lastIndexOf("/");if(U===J||U<0){if(F)throw new Error(`bad regexp-value '${E}', missing /-enclosure`);return console.warn(`bad regexp-value '${E}', missing /-enclosure`),null}let me=E.slice(U+1,J),q=E[J+1]==="i"?"i":"";try{return new RegExp(me,q)}catch(z){if(F)throw new Error(`bad regexp-value '${E}', parse error: ${z}`);return console.warn(`bad regexp-value '${E}', parse error: ${z}`),null}}}e.ContextKeyExpr=k;function i(v,E){return v.cmp(E)}class P{constructor(){this.type=0}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return c.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class c{constructor(){this.type=1}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=c,c.INSTANCE=new c;class d{constructor(E){this.key=E,this.type=2}static create(E){const F=y.get(E);return typeof F=="boolean"?F?c.INSTANCE:P.INSTANCE:new d(E)}cmp(E){return E.type!==this.type?this.type-E.type:b(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return D.create(this.key)}}e.ContextKeyDefinedExpr=d;class o{constructor(E,F){this.key=E,this.value=F,this.type=4}static create(E,F){if(typeof F=="boolean")return F?d.create(E):D.create(E);const U=y.get(E);return typeof U=="boolean"?F===(U?"true":"false")?c.INSTANCE:P.INSTANCE:new o(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return E.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(E){return E.mapEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeyEqualsExpr=o;class l{constructor(E,F){this.key=E,this.valueKey=F,this.type=10}static create(E,F){return new l(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.valueKey,E.key,E.valueKey)}equals(E){return E.type===this.type?this.key===E.key&&this.valueKey===E.valueKey:!1}evaluate(E){const F=E.getValue(this.valueKey),U=E.getValue(this.key);return Array.isArray(F)?F.indexOf(U)>=0:typeof U=="string"&&typeof F=="object"&&F!==null?C.call(F,U):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(E){return E.mapIn(this.key,this.valueKey)}negate(){return g.create(this)}}e.ContextKeyInExpr=l;class g{constructor(E){this._actual=E,this.type=11}static create(E){return new g(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new g(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotInExpr=g;class m{constructor(E,F){this.key=E,this.value=F,this.type=5}static create(E,F){if(typeof F=="boolean")return F?D.create(E):d.create(E);const U=y.get(E);return typeof U=="boolean"?F===(U?"true":"false")?P.INSTANCE:c.INSTANCE:new m(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return E.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(E){return E.mapNotEquals(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=m;class D{constructor(E){this.key=E,this.type=3}static create(E){const F=y.get(E);return typeof F=="boolean"?F?P.INSTANCE:c.INSTANCE:new D(E)}cmp(E){return E.type!==this.type?this.type-E.type:b(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}evaluate(E){return!E.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(E){return E.mapNot(this.key)}negate(){return d.create(this.key)}}e.ContextKeyNotExpr=D;class f{constructor(E,F){this.key=E,this.value=F,this.type=12}static create(E,F){return new f(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return parseFloat(E.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=f;class u{constructor(E,F){this.key=E,this.value=F,this.type=13}static create(E,F){return new u(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return parseFloat(E.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreaterEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=u;class p{constructor(E,F){this.key=E,this.value=F,this.type=14}static create(E,F){return new p(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return parseFloat(E.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmaller(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerExpr=p;class t{constructor(E,F){this.key=E,this.value=F,this.type=15}static create(E,F){return new t(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return parseFloat(E.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmallerEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(E,F){this.key=E,this.regexp=F,this.type=7}static create(E,F){return new n(E,F)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.key<E.key)return-1;if(this.key>E.key)return 1;const F=this.regexp?this.regexp.source:"",U=E.regexp?E.regexp.source:"";return F<U?-1:F>U?1:0}equals(E){if(E.type===this.type){const F=this.regexp?this.regexp.source:"",U=E.regexp?E.regexp.source:"";return this.key===E.key&&F===U}return!1}evaluate(E){let F=E.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const E=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${E}`}keys(){return[this.key]}map(E){return E.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=n;class s{constructor(E){this._actual=E,this.type=8}static create(E){return new s(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new s(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class r{constructor(E){this.expr=E,this.type=6}static create(E){return r._normalizeArr(E)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let F=0,U=this.expr.length;F<U;F++){const J=i(this.expr[F],E.expr[F]);if(J!==0)return J}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].equals(E.expr[F]))return!1;return!0}return!1}evaluate(E){for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].evaluate(E))return!1;return!0}static _normalizeArr(E){const F=[];let U=!1;for(const J of E)if(!!J){if(J.type===1){U=!0;continue}if(J.type===0)return P.INSTANCE;if(J.type===6){F.push(...J.expr);continue}F.push(J)}if(F.length===0&&U)return c.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];for(F.sort(i);F.length>1;){const J=F[F.length-1];if(J.type!==9)break;F.pop();const me=F.pop(),q=a.create(J.expr.map(z=>r.create([z,me])));q&&(F.push(q),F.sort(i))}return F.length===1?F[0]:new r(F)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(let F of this.expr)E.push(...F.keys());return E}map(E){return new r(this.expr.map(F=>F.map(E)))}negate(){let E=[];for(let F of this.expr)E.push(F.negate());return a.create(E)}}e.ContextKeyAndExpr=r;class a{constructor(E){this.expr=E,this.type=9}static create(E){const F=a._normalizeArr(E);if(F.length!==0)return F.length===1?F[0]:new a(F)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let F=0,U=this.expr.length;F<U;F++){const J=i(this.expr[F],E.expr[F]);if(J!==0)return J}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].equals(E.expr[F]))return!1;return!0}return!1}evaluate(E){for(let F=0,U=this.expr.length;F<U;F++)if(this.expr[F].evaluate(E))return!0;return!1}static _normalizeArr(E){let F=[],U=!1;if(E){for(let J=0,me=E.length;J<me;J++){const q=E[J];if(!!q){if(q.type===0){U=!0;continue}if(q.type===1)return[c.INSTANCE];if(q.type===9){F=F.concat(q.expr);continue}F.push(q)}}if(F.length===0&&U)return[P.INSTANCE];F.sort(i)}return F}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(let F of this.expr)E.push(...F.keys());return E}map(E){return new a(this.expr.map(F=>F.map(E)))}negate(){let E=[];for(let U of this.expr)E.push(U.negate());const F=U=>U.type===9?U.expr:[U];for(;E.length>1;){const U=E.shift(),J=E.shift(),me=[];for(const q of F(U))for(const z of F(J))me.push(k.and(q,z));E.unshift(k.or(...me))}return E[0]}}e.ContextKeyOrExpr=a;class h extends d{constructor(E,F,U){super(E);this._defaultValue=F,typeof U=="object"?h._info.push(Object.assign(Object.assign({},U),{key:E})):U!==!0&&h._info.push({key:E,description:U,type:F!=null?typeof F:void 0})}static all(){return h._info.values()}bindTo(E){return E.createKey(this.key,this._defaultValue)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return k.not(this.key)}isEqualTo(E){return k.equals(this.key,E)}notEqualsTo(E){return k.notEquals(this.key,E)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function b(v,E){return v<E?-1:v>E?1:0}function _(v,E,F,U){return v<F?-1:v>F?1:E<U?-1:E>U?1:0}}),define(be[150],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(be[26],_e([0,1,8,4]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(k){return k&&typeof k=="object"&&typeof k.id=="string"&&(!k.uuid||typeof k.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(k){k[k.System=0]="System",k[k.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class y{constructor(i){this.value=i,this._lower=i.toLowerCase()}static equals(i,P){if(typeof i=="undefined"||i===null)return typeof P=="undefined"||P===null;if(typeof P=="undefined"||P===null)return!1;if(typeof i=="string"||typeof P=="string"){let c=typeof i=="string"?i:i.value,d=typeof P=="string"?P:P.value;return w.equalsIgnoreCase(c,d)}return i._lower===P._lower}static toKey(i){return typeof i=="string"?i.toLowerCase():i._lower}}e.ExtensionIdentifier=y;function C(k){return k.contributes&&k.contributes.localizations?k.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function S(k){return k.contributes&&k.contributes.authentication?k.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=S,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[151],_e([0,1,8,26]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(d,o){return d.uuid&&o.uuid?d.uuid===o.uuid:d.id===o.id?!0:(0,w.compareIgnoreCase)(d.id,o.id)===0}e.areSameExtensions=A;class T{constructor(o,l){this.version=l,this.id=o.id,this.uuid=o.uuid}key(){return`${this.id}-${this.version}`}equals(o){return o instanceof T?A(this,o)&&this.version===o.version:!1}}e.ExtensionIdentifierWithVersion=T;function y(d,o){return`${d}.${o}`}e.getExtensionId=y;function C(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function S(d,o){return C(y(d,o))}e.getGalleryExtensionId=S;function k(d,o){const l=[],g=m=>{for(const D of l)if(D.some(f=>A(o(f),o(m))))return D;return null};for(const m of d){const D=g(m);D?D.push(m):l.push([m])}return l}e.groupByExtension=k;function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function P(d){return Object.assign({id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0)},d.telemetryData)}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function c(d){const o=new Set;for(const l of d)l.malicious&&o.add(l.id.id);return o}e.getMaliciousExtensionsSet=c}),define(be[64],_e([0,1,126,13,2,4,8,10,22]),function(Q,e,w,I,A,T,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,T.createDecorator)("fileService");function k(q){return q.create===!0}e.isFileOpenForWriteOptions=k;var i;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var P;(function(q){q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock"})(P=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function c(q){return!!(q.capabilities&2)}e.hasReadWriteCapability=c;function d(q){return!!(q.capabilities&8)}e.hasFileFolderCopyCapability=d;function o(q){return!!(q.capabilities&4)}e.hasOpenReadWriteCloseCapability=o;function l(q){return!!(q.capabilities&16)}e.hasFileReadStreamCapability=l;var g;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class m extends Error{constructor(z,ee){super(z);this.code=ee}}e.FileSystemProviderError=m;function D(q,z){const ee=new m(q.toString(),z);return u(ee,z),ee}e.createFileSystemProviderError=D;function f(q){return q||D((0,w.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=f;function u(q,z){return q.name=z?`${z} (FileSystemError)`:"FileSystemError",q}e.markAsFileSystemProviderError=u;function p(q){if(!q)return g.Unknown;if(q instanceof m)return q.code;const z=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!z)return g.Unknown;switch(z[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=p;function t(q){if(q instanceof b)return q.fileOperationResult;switch(p(q)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var n;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class s{constructor(z,ee,$){this.resource=z,this.operation=ee,this.target=$}isOperation(z){return this.operation===z}}e.FileOperationEvent=s;var r;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(r=e.FileChangeType||(e.FileChangeType={}));class a{constructor(z,ee){this.ignorePathCasing=ee,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=z;for(const $ of z)switch($.type){case 1:this.added||(this.added=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set($.resource,$);break;case 0:this.updated||(this.updated=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set($.resource,$);break;case 2:this.deleted||(this.deleted=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set($.resource,$);break}}contains(z,...ee){return this.doContains(z,{includeChildren:!1},...ee)}affects(z,...ee){return this.doContains(z,{includeChildren:!0},...ee)}doContains(z,ee,...$){var R,M,x,O,G,Y;if(!z)return!1;const ne=$.length>0;return!!((!ne||$.includes(1))&&(((R=this.added)===null||R===void 0?void 0:R.get(z))||ee.includeChildren&&((M=this.added)===null||M===void 0?void 0:M.findSuperstr(z)))||(!ne||$.includes(0))&&(((x=this.updated)===null||x===void 0?void 0:x.get(z))||ee.includeChildren&&((O=this.updated)===null||O===void 0?void 0:O.findSuperstr(z)))||(!ne||$.includes(2))&&(((G=this.deleted)===null||G===void 0?void 0:G.findSubstr(z))||ee.includeChildren&&((Y=this.deleted)===null||Y===void 0?void 0:Y.findSuperstr(z))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(z){const ee=[],$=z===1?this.added:z===0?this.updated:this.deleted;if($)for(const[,R]of $)ee.push(R);return ee}filter(z){return new a(this.changes.filter(ee=>z(ee)),this.ignorePathCasing)}}e.FileChangesEvent=a;function h(q,z,ee){return!q||!z||q===z||z.length>q.length?!1:(z.charAt(z.length-1)!==I.sep&&(z+=I.sep),ee?(0,y.startsWithIgnoreCase)(q,z):q.indexOf(z)===0)}e.isParent=h;class b extends Error{constructor(z,ee,$){super(z);this.fileOperationResult=ee,this.options=$}static isFileOperationError(z){return z instanceof Error&&!(0,C.isUndefinedOrNull)(z.fileOperationResult)}}e.FileOperationError=b;var _;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",q[q.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var v;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(v=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function E(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.etag=E;async function F(q,z){if(!z.canHandleResource(A.URI.from({scheme:q.scheme})))return new Promise(ee=>{const $=z.onDidChangeFileSystemProviderRegistrations(R=>{R.scheme===q.scheme&&R.added&&($.dispose(),ee())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(z){return(0,C.isNumber)(z)||(z=0),z<U.KB?(0,w.localize)(1,null,z.toFixed(0)):z<U.MB?(0,w.localize)(2,null,(z/U.KB).toFixed(2)):z<U.GB?(0,w.localize)(3,null,(z/U.MB).toFixed(2)):z<U.TB?(0,w.localize)(4,null,(z/U.GB).toFixed(2)):(0,w.localize)(5,null,(z/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var J;(function(q){q[q.IA32=0]="IA32",q[q.OTHER=1]="OTHER"})(J=e.Arch||(e.Arch={}));function me(q){return{maxFileSize:q===0?300*U.MB:16*U.GB,maxHeapSize:q===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=me}),define(be[65],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...A){this._entries=new Map;for(let[T,y]of A)this.set(T,y)}set(A,T){const y=this._entries.get(A);return this._entries.set(A,T),y}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=w}),define(be[152],_e([0,1,12,146,89,4,65,11]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class k extends Error{constructor(o){var l;super("cyclic dependency between services");this.message=(l=o.findCycleSlow())!==null&&l!==void 0?l:`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class i{constructor(o=new y.ServiceCollection,l=!1,g){this._activeInstantiations=new Set,this._services=o,this._strict=l,this._parent=g,this._services.set(T.IInstantiationService,this)}createChild(o){return new i(o,this._strict,this)}invokeFunction(o,...l){let g=c.traceInvocation(o),m=!1;try{return o({get:(f,u)=>{if(m)throw(0,w.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(f,g);if(!p&&u!==T.optional)throw new Error(`[invokeFunction] unknown service '${f}'`);return p}},...l)}finally{m=!0,g.stop()}}createInstance(o,...l){let g,m;return o instanceof A.SyncDescriptor?(g=c.traceCreation(o.ctor),m=this._createInstance(o.ctor,o.staticArguments.concat(l),g)):(g=c.traceCreation(o),m=this._createInstance(o,l,g)),g.stop(),m}_createInstance(o,l=[],g){let m=T._util.getServiceDependencies(o).sort((u,p)=>u.index-p.index),D=[];for(const u of m){let p=this._getOrCreateServiceInstance(u.id,g);if(!p&&this._strict&&!u.optional)throw new Error(`[createInstance] ${o.name} depends on UNKNOWN service ${u.id}.`);D.push(p)}let f=m.length>0?m[0].index:l.length;if(l.length!==f){console.warn(`[createInstance] First service dependency of ${o.name} at position ${f+1} conflicts with ${l.length} static arguments`);let u=f-l.length;u>0?l=l.concat(new Array(u)):l=l.slice(0,f)}return new o(...[...l,...D])}_setServiceInstance(o,l){if(this._services.get(o)instanceof A.SyncDescriptor)this._services.set(o,l);else if(this._parent)this._parent._setServiceInstance(o,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let l=this._services.get(o);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):l}_getOrCreateServiceInstance(o,l){let g=this._getServiceInstanceOrDescriptor(o);return g instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,g,l.branch(o,!0)):(l.branch(o,!1),g)}_safeCreateAndCacheServiceInstance(o,l,g){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,l,g)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,l,g){const m=new I.Graph(u=>u.id.toString());let D=0;const f=[{id:o,desc:l,_trace:g}];for(;f.length;){const u=f.pop();if(m.lookupOrInsertNode(u),D++>1e3)throw new k(m);for(let p of T._util.getServiceDependencies(u.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(p.id);if(!t&&!p.optional&&console.warn(`[createInstance] ${o} depends on ${p.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const n={id:p.id,desc:t,_trace:u._trace.branch(p.id,!0)};m.insertEdge(u,n),f.push(n)}}}for(;;){const u=m.roots();if(u.length===0){if(!m.isEmpty())throw new k(m);break}for(const{data:p}of u){if(this._getServiceInstanceOrDescriptor(p.id)instanceof A.SyncDescriptor){const n=this._createServiceInstanceWithOwner(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this._setServiceInstance(p.id,n)}m.removeNode(p)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,l,g=[],m,D){if(this._services.get(o)instanceof A.SyncDescriptor)return this._createServiceInstance(l,g,m,D);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,l,g,m,D);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(o,l=[],g,m){if(g){const D=new C.IdleValue(()=>this._createInstance(o,l,m));return new Proxy(Object.create(null),{get(f,u){if(u in f)return f[u];let p=D.value,t=p[u];return typeof t!="function"||(t=t.bind(p),f[u]=t),t},set(f,u,p){return D.value[u]=p,!0}})}else return this._createInstance(o,l,m)}}e.InstantiationService=i;var P;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(P||(P={}));class c{constructor(o,l){this.type=o,this.name=l,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return S?new c(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(o){return S?new c(0,o.name):c._None}branch(o,l){let g=new c(2,o.toString());return this._dep.push([o,l,g]),g}stop(){let o=Date.now()-this._start;c._totals+=o;let l=!1;function g(D,f){let u=[],p=new Array(D+1).join("	");for(const[t,n,s]of f._dep)if(n&&s){l=!0,u.push(`${p}CREATES -> ${t}`);let r=g(D+1,s);r&&u.push(r)}else u.push(`${p}uses -> ${t}`);return u.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(o>2||l)&&console.log(m.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(be[19],_e([0,1,4,6,21,3,60]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function C(){return new Date().toISOString()}var S;(function(p){p[p.Trace=0]="Trace",p[p.Debug=1]="Debug",p[p.Info=2]="Info",p[p.Warning=3]="Warning",p[p.Error=4]="Error",p[p.Critical=5]="Critical",p[p.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class k extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class i extends k{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(S.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(S.Error,this.format(s))}else this.log(S.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let s=0;s<t.length;s++){let r=t[s];if(typeof r=="object")try{r=JSON.stringify(r)}catch(a){}n+=(s>0?" ":"")+r}return n}}e.AbstractMessageLogger=i;class P extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!A.isWindows}trace(t,...n){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...n):console.log(`[main ${C()}]`,t,...n))}debug(t,...n){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...n):console.log(`[main ${C()}]`,t,...n))}info(t,...n){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...n):console.log(`[main ${C()}]`,t,...n))}warn(t,...n){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,t,...n):console.warn(`[main ${C()}]`,t,...n))}error(t,...n){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,t,...n):console.error(`[main ${C()}]`,t,...n))}critical(t,...n){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,t,...n):console.error(`[main ${C()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class c extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=c;class d extends k{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,y.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class o extends k{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const s of this.logServices)s.trace(t,...n)}debug(t,...n){for(const s of this.logServices)s.debug(t,...n)}info(t,...n){for(const s of this.logServices)s.info(t,...n)}warn(t,...n){for(const s of this.logServices)s.warn(t,...n)}error(t,...n){for(const s of this.logServices)s.error(t,...n)}critical(t,...n){for(const s of this.logServices)s.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=o;class l extends I.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=l;class g extends I.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(s))}))}createLogger(t,n){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(n==null?void 0:n.always)?S.Trace:this.logLevel,n),this.loggers.set(t.toString(),s),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class m{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=m;function D(p){if(p.verbose)return S.Trace;if(typeof p.logLevel=="string"){const t=f(p.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=D;function f(p){switch(p){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=f;function u(p){switch(p){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=u}),define(be[90],_e([0,1,4,127,47]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var y;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function k(o,l){return l-o}S.compare=k;const i=Object.create(null);i[S.Error]=(0,I.localize)(0,null),i[S.Warning]=(0,I.localize)(1,null),i[S.Info]=(0,I.localize)(2,null);function P(o){return i[o]||""}S.toString=P;function c(o){switch(o){case A.default.Error:return S.Error;case A.default.Warning:return S.Warning;case A.default.Info:return S.Info;case A.default.Ignore:return S.Hint}}S.fromSeverity=c;function d(o){switch(o){case S.Error:return A.default.Error;case S.Warning:return A.default.Warning;case S.Info:return A.default.Info;case S.Hint:return A.default.Ignore}}S.toSeverity=d}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(S){const k="";function i(c){return P(c,!0)}S.makeKey=i;function P(c,d){let o=[k];return c.source?o.push(c.source.replace("\xA6","\\\xA6")):o.push(k),c.code?typeof c.code=="string"?o.push(c.code.replace("\xA6","\\\xA6")):o.push(c.code.value.replace("\xA6","\\\xA6")):o.push(k),c.severity!==void 0&&c.severity!==null?o.push(y.toString(c.severity)):o.push(k),c.message&&d?o.push(c.message.replace("\xA6","\\\xA6")):o.push(k),c.startLineNumber!==void 0&&c.startLineNumber!==null?o.push(c.startLineNumber.toString()):o.push(k),c.startColumn!==void 0&&c.startColumn!==null?o.push(c.startColumn.toString()):o.push(k),c.endLineNumber!==void 0&&c.endLineNumber!==null?o.push(c.endLineNumber.toString()):o.push(k),c.endColumn!==void 0&&c.endColumn!==null?o.push(c.endColumn.toString()):o.push(k),o.push(k),o.join("\xA6")}S.makeKeyOptionalMessage=P})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(be[153],_e([0,1,47,4,3]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=w.default,e.INotificationService=(0,I.createDecorator)("notificationService");var T;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new S,this.onDidClose=A.Event.None,this.onDidChangeVisibility=A.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=C;class S{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=S});var Ve=this&&this.__decorate||function(Q,e,w,I){var A=arguments.length,T=A<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,w):I,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(Q,e,w,I);else for(var C=Q.length-1;C>=0;C--)(y=Q[C])&&(T=(A<3?y(T):A>3?y(e,w,T):y(e,w))||T);return A>3&&T&&Object.defineProperty(e,w,T),T},qe=this&&this.__param||function(Q,e){return function(w,I){e(w,I,Q)}};define(be[154],_e([0,1,4,20,6,11]),function(Q,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,w.createDecorator)("progressService");var y;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(P){this.callback=P}get value(){return this._value}report(P){this._value=P,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let S=class extends A.Disposable{constructor(P,c){super();this.deferred=new T.DeferredPromise,c.withProgress(P,d=>(this.reporter=d,this.lastStep&&d.report(this.lastStep),this.deferred.p)),this._register((0,A.toDisposable)(()=>this.deferred.complete()))}report(P){this.reporter?this.reporter.report(P):this.lastStep=P}};S=Ve([qe(1,e.IProgressService)],S),e.UnmanagedProgress=S;class k extends A.Disposable{constructor(P){super();this.progressIndicator=P,this.currentOperationId=0,this.currentOperationDisposables=this._register(new A.DisposableStore)}start(P){this.stop();const c=++this.currentOperationId,d=new I.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},P),this.currentOperationDisposables.add((0,A.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,A.toDisposable)(()=>d.cancel())),this.currentOperationDisposables.add((0,A.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:d.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(P){this.currentOperationId===P&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,w.createDecorator)("editorProgressService")}),define(be[29],_e([0,1,10,42]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(y,C){I.ok(w.isString(y)),I.ok(w.isObject(C)),I.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,C)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new A}),define(be[91],_e([0,1,29,3]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class T{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,k){this.schemasById[A(S)]=k,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new T;w.Registry.add(e.Extensions.JSONContribution,y)}),define(be[66],_e([0,1,124,3,29,10,91]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const S=A.Registry.as(y.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:w.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(m,D=!0){this.registerConfigurations([m],D)}registerConfigurations(m,D=!0){const f=[];m.forEach(u=>{f.push(...this.validateAndRegisterProperties(u,D,u.extensionInfo)),this.configurationContributors.push(u),this.registerJSONConfiguration(u)}),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterConfigurations(m){const D=[],f=u=>{if(u.properties)for(const p in u.properties)D.push(p),delete this.configurationProperties[p],this.removeFromSchema(p,u.properties[p]);u.allOf&&u.allOf.forEach(p=>f(p))};for(const u of m){f(u);const p=this.configurationContributors.indexOf(u);p!==-1&&this.configurationContributors.splice(p,1)}S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}registerDefaultConfigurations(m){const D=[],f=[];for(const u of m)for(const p in u)if(D.push(p),e.OVERRIDE_PROPERTY_PATTERN.test(p)){this.defaultValues[p]=Object.assign(Object.assign({},this.defaultValues[p]||{}),u[p]);const t={type:"object",default:this.defaultValues[p],description:w.localize(1,null,p),$ref:e.resourceLanguageSettingsSchemaId};f.push(P(p)),this.configurationProperties[p]=t,this.defaultLanguageConfigurationOverridesNode.properties[p]=t}else{this.defaultValues[p]=u[p];const t=this.configurationProperties[p];t&&(this.updatePropertyDefaultValue(p,t),this.updateSchema(p,t))}this.registerOverrideIdentifiers(f),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}deregisterDefaultConfigurations(m){const D=[];for(const f of m)for(const u in f)if(D.push(u),delete this.defaultValues[u],e.OVERRIDE_PROPERTY_PATTERN.test(u))delete this.configurationProperties[u],delete this.defaultLanguageConfigurationOverridesNode.properties[u];else{const p=this.configurationProperties[u];p&&(this.updatePropertyDefaultValue(u,p),this.updateSchema(u,p))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}notifyConfigurationSchemaUpdated(...m){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(m){for(const D of m)this.overrideIdentifiers.add(D);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(m,D=!0,f,u=3){var p;u=T.isUndefinedOrNull(m.scope)?u:m.scope;let t=[],n=m.properties;if(n)for(let r in n){if(D&&o(r)){delete n[r];continue}const a=n[r];if(this.updatePropertyDefaultValue(r,a),e.OVERRIDE_PROPERTY_PATTERN.test(r)?a.scope=void 0:(a.scope=T.isUndefinedOrNull(a.scope)?u:a.scope,a.requireTrust=T.isUndefinedOrNull(a.requireTrust)?!!((p=f==null?void 0:f.requireTrustForConfigurations)===null||p===void 0?void 0:p.includes(r)):a.requireTrust),n[r].hasOwnProperty("included")&&!n[r].included){this.excludedConfigurationProperties[r]=n[r],delete n[r];continue}else this.configurationProperties[r]=n[r];!n[r].deprecationMessage&&n[r].markdownDeprecationMessage&&(n[r].deprecationMessage=n[r].markdownDeprecationMessage),t.push(r)}let s=m.allOf;if(s)for(let r of s)t.push(...this.validateAndRegisterProperties(r,D,f,u));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(m){const D=f=>{let u=f.properties;if(u)for(const t in u)this.updateSchema(t,u[t]);let p=f.allOf;p&&p.forEach(D)};D(m)}updateSchema(m,D){switch(e.allSettings.properties[m]=D,D.scope){case 1:e.applicationSettings.properties[m]=D;break;case 2:e.machineSettings.properties[m]=D;break;case 6:e.machineOverridableSettings.properties[m]=D;break;case 3:e.windowSettings.properties[m]=D;break;case 4:e.resourceSettings.properties[m]=D;break;case 5:e.resourceSettings.properties[m]=D,this.resourceLanguageSettingsSchema.properties[m]=D;break}}removeFromSchema(m,D){switch(delete e.allSettings.properties[m],D.scope){case 1:delete e.applicationSettings.properties[m];break;case 2:delete e.machineSettings.properties[m];break;case 6:delete e.machineOverridableSettings.properties[m];break;case 3:delete e.windowSettings.properties[m];break;case 4:case 5:delete e.resourceSettings.properties[m];break}}updateOverridePropertyPatternKey(){for(const m of this.overrideIdentifiers.values()){const D=`[${m}]`,f={type:"object",description:w.localize(2,null),errorMessage:w.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(D,f),e.allSettings.properties[D]=f,e.applicationSettings.properties[D]=f,e.machineSettings.properties[D]=f,e.machineOverridableSettings.properties[D]=f,e.windowSettings.properties[D]=f,e.resourceSettings.properties[D]=f}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(m,D){let f=this.defaultValues[m];T.isUndefined(f)&&(f=D.default),T.isUndefined(f)&&(f=c(D.type)),D.default=f}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function P(g){return g.substring(1,g.length-1)}e.overrideIdentifierFromKey=P;function c(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=c;const d=new k;A.Registry.add(e.Extensions.Configuration,d);function o(g){return g.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(g)?w.localize(5,null,g):d.getConfigurationProperties()[g]!==void 0?w.localize(6,null,g):null:w.localize(4,null)}e.validateProperty=o;function l(){const g=[],m=d.getConfigurationProperties();for(const D of Object.keys(m))g.push([D,m[D].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=l}),define(be[92],_e([0,1,24,10,2,29,4,66]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function S(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof A.URI)}e.isConfigurationOverrides=S;var k;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function P(n,s){const r=s?n?s.keys.filter(F=>n.keys.indexOf(F)===-1):[...s.keys]:[],a=n?s?n.keys.filter(F=>s.keys.indexOf(F)===-1):[...n.keys]:[],h=[];if(s&&n){for(const F of n.keys)if(s.keys.indexOf(F)!==-1){const U=m(n.contents,F),J=m(s.contents,F);w.equals(U,J)||h.push(F)}}const b=[],_=F=>{const U={};for(const J of F)for(const me of J.identifiers)U[p(me)]=J;return U},v=s?_(s.overrides):{},E=n?_(n.overrides):{};if(Object.keys(v).length)for(const F of r){const U=v[F];U&&b.push([(0,C.overrideIdentifierFromKey)(F),U.keys])}if(Object.keys(E).length)for(const F of a){const U=E[F];U&&b.push([(0,C.overrideIdentifierFromKey)(F),U.keys])}if(Object.keys(v).length&&Object.keys(E).length)for(const F of h){const U=E[F],J=v[F];if(U&&J){const me=P({contents:U.contents,keys:U.keys,overrides:[]},{contents:J.contents,keys:J.keys,overrides:[]});b.push([(0,C.overrideIdentifierFromKey)(F),[...me.added,...me.removed,...me.updated]])}}return{added:r,removed:a,updated:h,overrides:b}}e.compare=P;function c(n,s){const r=[];for(const a of Object.keys(n))if(C.OVERRIDE_PROPERTY_PATTERN.test(a)){const h={};for(const b in n[a])h[b]=n[a][b];r.push({identifiers:[(0,C.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(h),contents:d(h,s)})}return r}e.toOverrides=c;function d(n,s){const r=Object.create(null);for(let a in n)o(r,a,n[a],s);return r}e.toValuesTree=d;function o(n,s,r,a){const h=s.split("."),b=h.pop();let _=n;for(let v=0;v<h.length;v++){let E=h[v],F=_[E];switch(typeof F){case"undefined":F=_[E]=Object.create(null);break;case"object":break;default:a(`Ignoring ${s} as ${h.slice(0,v+1).join(".")} is ${JSON.stringify(F)}`);return}_=F}if(typeof _=="object"&&_!==null)try{_[b]=r}catch(v){a(`Ignoring ${s} as ${h.join(".")} is ${JSON.stringify(_)}`)}else a(`Ignoring ${s} as ${h.join(".")} is ${JSON.stringify(_)}`)}e.addToValueTree=o;function l(n,s){const r=s.split(".");g(n,r)}e.removeFromValueTree=l;function g(n,s){const r=s.shift();if(s.length===0){delete n[r];return}if(Object.keys(n).indexOf(r)!==-1){const a=n[r];typeof a=="object"&&!Array.isArray(a)&&(g(a,s),Object.keys(a).length===0&&delete n[r])}}function m(n,s,r){function a(_,v){let E=_;for(const F of v){if(typeof E!="object"||E===null)return;E=E[F]}return E}const h=s.split("."),b=a(n,h);return typeof b=="undefined"?r:b}e.getConfigurationValue=m;function D(n,s,r){Object.keys(s).forEach(a=>{a!=="__proto__"&&(a in n?I.isObject(n[a])&&I.isObject(s[a])?D(n[a],s[a],r):r&&(n[a]=s[a]):n[a]=s[a])})}e.merge=D;function f(){const n=T.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=f;function u(){const n=Object.create(null),s=T.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let r in s){let a=s[r].default;o(n,r,a,h=>console.error(`Conflict in default settings: ${h}`))}return n}e.getDefaultValues=u;function p(n){return`[${n}]`}e.keyFromOverrideIdentifier=p;function t(n,s,r){const a=n.inspect(s),h=n.inspect(r);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:a.defaultValue}e.getMigratedSettingValue=t}),define(be[155],_e([0,1,44,22,15,10,24,2,66,92,29,6,3]),function(Q,e,w,I,A,T,y,C,S,k,i,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class d{constructor(t={},n=[],s=[]){this._contents=t,this._keys=n,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,k.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const s=this.getContentsForOverrideIdentifer(n);return s?t?(0,k.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const r of A.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[r],h=n[r];h&&(typeof a=="object"&&typeof h=="object"?(a=y.deepClone(a),this.mergeContents(a,h)):a=h),s[r]=a}return new d(s,this.keys,this.overrides)}merge(...t){const n=y.deepClone(this.contents),s=y.deepClone(this.overrides),r=[...this.keys];for(const a of t){this.mergeContents(n,a.contents);for(const h of a.overrides){const[b]=s.filter(_=>A.equals(_.identifiers,h.identifiers));b?this.mergeContents(b.contents,h.contents):s.push(y.deepClone(h))}for(const h of a.keys)r.indexOf(h)===-1&&r.push(h)}return new d(n,r,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const s of Object.keys(n)){if(s in t&&T.isObject(t[s])&&T.isObject(n[s])){this.mergeContents(t[s],n[s]);continue}t[s]=y.deepClone(n[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,k.addToValueTree)(this.contents,t,n,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,k.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let s=0;s<n;s++)t.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=d;class o extends d{constructor(){const t=(0,k.getDefaultValues)(),n=(0,k.getConfigurationKeys)(),s=[];for(const r of Object.keys(t))S.OVERRIDE_PROPERTY_PATTERN.test(r)&&s.push({identifiers:[(0,S.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,k.toValuesTree)(t[r],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,n,s)}}e.DefaultConfigurationModel=o;class l{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!T.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:s,keys:r,overrides:a,untrusted:h}=this.doParseRaw(t,n);this._configurationModel=new d(s,r,a),this._untrustedConfigurations=h||[]}doParseContent(t){let n={},s=null,r=[],a=[],h=[];function b(v){Array.isArray(r)?r.push(v):s&&(r[s]=v)}let _={onObjectBegin:()=>{let v={};b(v),a.push(r),r=v,s=null},onObjectProperty:v=>{s=v},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{let v=[];b(v),a.push(r),r=v,s=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:b,onError:(v,E,F)=>{h.push({error:v,offset:E,length:F})}};if(t)try{w.visit(t,_),n=r[0]||{}}catch(v){console.error(`Error while parsing settings file ${this._name}: ${v}`),this._parseErrors=[v]}return n}doParseRaw(t,n){const s=i.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,s,!0,n);t=r.raw;const a=(0,k.toValuesTree)(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),h=Object.keys(t),b=(0,k.toOverrides)(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:a,keys:h,overrides:b,untrusted:r.untrusted}}filter(t,n,s,r){if(!(r==null?void 0:r.scopes)&&!(r==null?void 0:r.isUntrusted))return{raw:t,untrusted:[]};const a={},h=[];for(let b in t)if(S.OVERRIDE_PROPERTY_PATTERN.test(b)&&s){const _=this.filter(t[b],n,!1,r);a[b]=_.raw,h.push(..._.untrusted)}else{const _=n[b],v=_?typeof _.scope!="undefined"?_.scope:3:void 0;(v===void 0||r.scopes===void 0||r.scopes.includes(v))&&(r.isUntrusted&&(_==null?void 0:_.requireTrust)?h.push(b):a[b]=t[b])}return{raw:a,untrusted:h}}}e.ConfigurationModelParser=l;class g extends P.Disposable{constructor(t,n,s,r){super();this.userSettingsResource=t,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new c.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new l(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(c.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new d}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=g;class m{constructor(t,n,s=new d,r=new d,a=new I.ResourceMap,h=new d,b=new I.ResourceMap,_=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=r,this._folderConfigurations=a,this._memoryConfiguration=h,this._memoryConfigurationByResource=b,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(t,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(t)}updateValue(t,n,s={}){let r;s.resource?(r=this._memoryConfigurationByResource.get(s.resource),r||(r=new d,this._memoryConfigurationByResource.set(s.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(t):r.setValue(t,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,s){const r=this.getConsolidateConfigurationModel(n,s),a=this.getFolderConfigurationModelForResource(n.resource,s),h=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,b=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),_=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),v=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),E=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),F=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,U=a?n.overrideIdentifier?a.freeze().override(n.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,J=n.overrideIdentifier?h.override(n.overrideIdentifier).getValue(t):h.getValue(t),me=r.getValue(t),q=A.distinct(A.flatten(r.overrides.map(z=>z.identifiers))).filter(z=>r.getOverrideValue(t,z)!==void 0);return{defaultValue:b,userValue:_,userLocalValue:v,userRemoteValue:E,workspaceValue:F,workspaceFolderValue:U,memoryValue:J,value:me,default:b!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:_!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:v!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:E!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:U!==void 0?{value:a==null?void 0:a.freeze().getValue(t),override:n.overrideIdentifier?a==null?void 0:a.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:J!==void 0?{value:h.getValue(t),override:n.overrideIdentifier?h.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=n.filter(r=>S.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const a=(0,S.overrideIdentifierFromKey)(r),h=this._defaultConfiguration.getKeysForOverrideIdentifier(a),b=t.getKeysForOverrideIdentifier(a),_=[...b.filter(v=>h.indexOf(v)===-1),...h.filter(v=>b.indexOf(v)===-1),...h.filter(v=>!y.equals(this._defaultConfiguration.override(a).getValue(v),t.override(a).getValue(v)))];return[a,_]});return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:r,overrides:a}=(0,k.compare)(this.localUserConfiguration,t),h=[...n,...s,...r];return h.length&&this.updateLocalUserConfiguration(t),{keys:h,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:r,overrides:a}=(0,k.compare)(this.remoteUserConfiguration,t);let h=[...n,...s,...r];return h.length&&this.updateRemoteUserConfiguration(t),{keys:h,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:r,overrides:a}=(0,k.compare)(this.workspaceConfiguration,t);let h=[...n,...s,...r];return h.length&&this.updateWorkspaceConfiguration(t),{keys:h,overrides:a}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:r,updated:a,removed:h,overrides:b}=(0,k.compare)(s,n);let _=[...r,...a,...h];return(_.length||!s)&&this.updateFolderConfiguration(t,n),{keys:_,overrides:b}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:r,removed:a,overrides:h}=(0,k.compare)(n,void 0);return{keys:[...s,...r,...a],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let s=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const r=n.getFolder(t);r&&(s=this.getFolderConsolidatedConfiguration(r.uri)||s);const a=this._memoryConfigurationByResource.get(t);a&&(s=s.merge(a))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(n=s.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=s}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:s,overrides:r,keys:a}=this._folderConfigurations.get(n);return t.push([n,{contents:s,overrides:r,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((h,b)=>(h.set(C.URI.revive(b[0]),this.parseConfigurationModel(b[1])),h),new I.ResourceMap);return new m(n,s,new d,r,a,new d,new I.ResourceMap,!1)}static parseConfigurationModel(t){return new d(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=m;function D(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const t=new Set,n=new Map;for(const r of p)r.keys.forEach(a=>t.add(a)),r.overrides.forEach(([a,h])=>{const b=(0,I.getOrSet)(n,a,new Set);h.forEach(_=>b.add(_))});const s=[];return n.forEach((r,a)=>s.push([a,[...r.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=D;class f{constructor(t,n,s,r){this.change=t,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=r,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(b=>a.add(b)),t.overrides.forEach(([,b])=>b.forEach(_=>a.add(_))),this.affectedKeys=[...a.values()];const h=new d;this.affectedKeys.forEach(b=>h.setValue(b,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,a=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!y.equals(r,a)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let s=(0,k.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof s=="object"&&(r=Object.keys(s)[0]);){if(t=t[r],!t)return!1;s=s[r]}return!0}}e.ConfigurationChangeEvent=f;class u extends f{constructor(t,n,s,r){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=s,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=u}),define(be[67],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,w.createDecorator)("remoteAuthorityResolverService");var I;(function(y){y[y.Unknown=0]="Unknown",y[y.DisableTrust=1]="DisableTrust",y[y.MachineTrusted=2]="MachineTrusted"})(I=e.RemoteTrustOption||(e.RemoteTrustOption={}));var A;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(A=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends Error{constructor(C,S=A.Unknown,k){super(C);this._message=C,this._code=S,this._detail=k,this.isHandled=S===A.NotAvailable&&k===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(C){return C instanceof T&&C._code===A.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof T&&C._code===A.NoResolverFound}static isHandled(C){return C instanceof T&&C.isHandled}}e.RemoteAuthorityResolverError=T}),define(be[93],_e([0,1,18]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function I(S){return S.scheme===w.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=I;function A(S){if(!!S){const k=S.indexOf("+");return k<0?S:S.substr(0,k)}}e.getRemoteName=A;function T(S){return S.scheme!==w.Schemas.file&&S.scheme!==w.Schemas.vscodeRemote}function y(S){if(S.folders.length)return S.folders.every(k=>T(k.uri))?S.folders[0].uri:void 0;if(S.configuration&&T(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=y;function C(S){var k;return(k=y(S))===null||k===void 0?void 0:k.scheme}e.getVirtualWorkspaceScheme=C}),define(be[156],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class w{constructor(A){this._callback=A,this._terminalBufferMap=new Map}dispose(){for(const A of this._terminalBufferMap.values())A.dispose()}startBuffering(A,T,y=5){let C;return C=T(S=>{const k=typeof S=="string"?S:S.data;let i=this._terminalBufferMap.get(A);if(i){i.data.push(k);return}const P=setTimeout(()=>this.flushBuffer(A),y);i={data:[k],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(A),C.dispose()}},this._terminalBufferMap.set(A,i)}),C}stopBuffering(A){const T=this._terminalBufferMap.get(A);T&&T.dispose()}flushBuffer(A){const T=this._terminalBufferMap.get(A);T&&(this._terminalBufferMap.delete(A),this._callback(A,T.data.join("")))}}e.TerminalDataBufferer=w}),define(be[157],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var w;(function(I){I.DARK="dark",I.LIGHT="light",I.HIGH_CONTRAST="hc"})(w=e.ColorScheme||(e.ColorScheme={}))}),define(be[158],_e([0,1,4,6,29,3,157,36]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,w.createDecorator)("themeService");var S;(function(g){function m(D){return D&&typeof D=="object"&&typeof D.id=="string"}g.isThemeColor=m})(S=e.ThemeColor||(e.ThemeColor={}));function k(g){return{id:g}}e.themeColorFromId=k;var i;(function(g){function m(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||S.isThemeColor(t.color))}g.isThemeIcon=m;const D=new RegExp(`^\\$\\((${C.CSSIcon.iconNameExpression}(?:${C.CSSIcon.iconModifierExpression})?)\\)$`);function f(t){const n=D.exec(t);if(!!n){let[,s]=n;return{id:s}}}g.fromString=f;function u(t,n){let s=t.id;const r=s.lastIndexOf("~");return r!==-1&&(s=s.substring(0,r)),n&&(s=`${s}~${n}`),{id:s}}g.modify=u;function p(t,n){var s,r;return t.id===n.id&&((s=t.color)===null||s===void 0?void 0:s.id)===((r=n.color)===null||r===void 0?void 0:r.id)}g.isEqual=p,g.asClassNameArray=C.CSSIcon.asClassNameArray,g.asClassName=C.CSSIcon.asClassName,g.asCSSSelector=C.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=C.Codicon.file,e.FolderThemeIcon=C.Codicon.folder;function P(g){switch(g){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class c{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,I.toDisposable)(()=>{const D=this.themingParticipants.indexOf(m);this.themingParticipants.splice(D,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let d=new c;A.Registry.add(e.Extensions.ThemingContribution,d);function o(g){return d.onColorThemeChange(g)}e.registerThemingParticipant=o;class l extends I.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(D=>this.onThemeChange(D)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,D){let f=this.theme.getColor(m);return f&&D&&(f=D(f,this.theme)),f?f.toString():null}}e.Themable=l}),define(be[159],_e([0,1,29,158,3,128,91,11,36]),function(Q,e,w,I,A,T,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${S.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(m,D,f,u){const p=this.iconsById[m];if(p){if(f&&!p.description){p.description=f,this.iconSchema.properties[m].markdownDescription=`${f} $(${m})`;const s=this.iconReferenceSchema.enum.indexOf(m);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=f),this._onDidChange.fire()}return p}let t={id:m,description:f,defaults:D,deprecationMessage:u};this.iconsById[m]=t;let n={$ref:"#/definitions/icons"};return u&&(n.deprecationMessage=u),f&&(n.markdownDescription=`${f}: $(${m})`),this.iconSchema.properties[m]=n,this.iconReferenceSchema.enum.push(m),this.iconReferenceSchema.enumDescriptions.push(f||""),this._onDidChange.fire(),{id:m}}deregisterIcon(m){delete this.iconsById[m],delete this.iconSchema.properties[m];const D=this.iconReferenceSchema.enum.indexOf(m);D!==-1&&(this.iconReferenceSchema.enum.splice(D,1),this.iconReferenceSchema.enumDescriptions.splice(D,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(m=>this.iconsById[m])}getIcon(m){return this.iconsById[m]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(m,D){const f=this.iconFontsById[m];if(f)return f;let u={id:m,definition:D};return this.iconFontsById[m]=u,this._onDidChange.fire(),u}deregisterIconFont(m){delete this.iconFontsById[m]}getIconFonts(){return Object.keys(this.iconFontsById).map(m=>this.iconFontsById[m])}getIconFont(m){return this.iconFontsById[m]}toString(){const m=(p,t)=>p.id.localeCompare(t.id),D=p=>{for(;I.ThemeIcon.isThemeIcon(p.defaults);)p=this.iconsById[p.defaults.id];return`codicon codicon-${p?p.id:""}`};let f=[];f.push("| preview     | identifier                        | default codicon ID                | description"),f.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.iconsById).map(p=>this.iconsById[p]);for(const p of u.filter(t=>!!t.description).sort(m))f.push(`|<i class="${D(p)}"></i>|${p.id}|${I.ThemeIcon.isThemeIcon(p.defaults)?p.defaults.id:p.id}|${p.description||""}|`);f.push("| preview     | identifier                        "),f.push("| ----------- | --------------------------------- |");for(const p of u.filter(t=>!I.ThemeIcon.isThemeIcon(t.defaults)).sort(m))f.push(`|<i class="${D(p)}"></i>|${p.id}|`);return f.join(`
`)}}const i=new k;w.Registry.add(e.Extensions.IconContribution,i);function P(g,m,D,f){return i.registerIcon(g,m,D,f)}e.registerIcon=P;function c(){return i}e.getIconRegistry=c;function d(){for(const g of S.iconRegistry.all)i.registerIcon(g.id,g.definition,g.description);S.iconRegistry.onDidRegister(g=>i.registerIcon(g.id,g.definition,g.description))}d(),e.iconsSchemaId="vscode://schemas/icons";let o=w.Registry.as(y.Extensions.JSONContribution);o.registerSchema(e.iconsSchemaId,i.getIconSchema());const l=new C.RunOnceScheduler(()=>o.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{l.isScheduled()||l.schedule()}),e.widgetClose=P("widget-close",S.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=P("goto-previous-location",S.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=P("goto-next-location",S.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=I.ThemeIcon.modify(S.Codicon.sync,"spin")}),define(be[48],_e([0,1,2,25,4,22]),function(Q,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var y;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function C(c){const d=c;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}e.isWorkspace=C;function S(c){const d=c;return!!(d&&typeof d=="object"&&w.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}e.isWorkspaceFolder=S;class k{constructor(d,o,l,g){this._id=d,this._configuration=l,this._ignorePathCasing=g,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=o}update(d){this._id=d.id,this._configuration=d.configuration,this._ignorePathCasing=d._ignorePathCasing,this.folders=d.folders}get folders(){return this._folders}set folders(d){this._folders=d,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(d){this._configuration=d}getFolder(d){return d&&this._foldersMap.findSubstr(d.with({scheme:d.scheme,authority:d.authority,path:d.path}))||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing);for(const d of this.folders)this._foldersMap.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=k;class i{constructor(d,o){this.raw=o,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,I.joinPath)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function P(c){return new i({uri:c,index:0,name:(0,I.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=P}),define(be[160],_e([0,1,4,129,48,2,21,13,25,107,44,18,58,37,93]),function(Q,e,w,I,A,T,y,C,S,k,i,P,c,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const l=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function g(ee){return(typeof ee=="string"?(0,C.extname)(ee):(0,S.extname)(ee))===l}e.hasWorkspaceFileExtension=g,e.IWorkspacesService=(0,w.createDecorator)("workspacesService");function m(ee){return ee.hasOwnProperty("workspace")}e.isRecentWorkspace=m;function D(ee){return ee.hasOwnProperty("folderUri")}e.isRecentFolder=D;function f(ee){return ee.hasOwnProperty("fileUri")}e.isRecentFile=f;function u(ee){const $=ee;return typeof($==null?void 0:$.id)=="string"&&T.URI.isUri($.uri)}e.isSingleFolderWorkspaceIdentifier=u;function p(ee){if(ee.configuration)return{id:ee.id,configPath:ee.configuration};if(ee.folders.length===1)return{id:ee.id,uri:ee.folders[0].uri}}e.toWorkspaceIdentifier=p;function t(ee){const $=ee;return typeof($==null?void 0:$.id)=="string"&&T.URI.isUri($.configPath)}e.isWorkspaceIdentifier=t;function n(ee){const $=ee;if($==null?void 0:$.uri)return{id:$.id,uri:T.URI.revive($.uri)};const R=ee;if(R==null?void 0:R.configPath)return{id:R.id,configPath:T.URI.revive(R.configPath)};if(ee==null?void 0:ee.id)return{id:ee.id}}e.reviveIdentifier=n;function s(ee,$){return S.extUriBiasedIgnorePathCase.isEqualOrParent(ee,$.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function r(ee){return a(ee)||h(ee)}e.isStoredWorkspaceFolder=r;function a(ee){const $=ee;return typeof($==null?void 0:$.path)=="string"&&(!$.name||typeof $.name=="string")}e.isRawFileWorkspaceFolder=a;function h(ee){const $=ee;return typeof($==null?void 0:$.uri)=="string"&&(!$.name||typeof $.name=="string")}e.isRawUriWorkspaceFolder=h;function b(ee,$,R,M,x=!y.isWindows,O){if(ee.scheme!==M.scheme)return{name:R,uri:ee.toString(!0)};let G=$?void 0:O.relativePath(M,ee);if(G!==void 0)G.length===0?G=".":y.isWindows&&ee.scheme===P.Schemas.file&&!x&&(G=G.replace(/\//g,"\\"));else if(ee.scheme===P.Schemas.file)G=ee.fsPath,y.isWindows&&(G=(0,c.normalizeDriveLetter)(G),x&&(G=(0,d.toSlashes)(G)));else{if(!O.isEqualAuthority(ee.authority,M.authority))return{name:R,uri:ee.toString(!0)};G=ee.path}return{name:R,path:G}}e.getStoredWorkspaceFolder=b;function _(ee,$,R){let M=[],x=new Set;const O=R.dirname($);for(let G of ee){let Y=null;if(a(G))G.path&&(Y=R.resolvePath(O,G.path));else if(h(G))try{Y=T.URI.parse(G.uri),Y.path[0]!=="/"&&(Y=Y.with({path:"/"+Y.path}))}catch(ne){console.warn(ne)}if(Y){let ne=R.getComparisonKey(Y);if(!x.has(ne)){x.add(ne);const pe=G.name||R.basenameOrAuthority(Y);M.push(new A.WorkspaceFolder({uri:Y,name:pe,index:M.length},G))}}}return M}e.toWorkspaceFolders=_;function v(ee,$,R,M,x){let O=E($,ee);const G=x.dirname($),Y=x.dirname(M),ne=[],pe=F(O.folders);for(const Ue of O.folders){const B=a(Ue)?x.resolvePath(G,Ue.path):T.URI.parse(Ue.uri);let K;R?K=!1:K=!a(Ue)||(0,C.isAbsolute)(Ue.path),ne.push(b(B,K,Ue.name,Y,pe,x))}const Ie={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},Oe=k.setProperty(ee,["folders"],ne,Ie);let Te=k.applyEdits(ee,Oe);return O.remoteAuthority===(0,o.getRemoteAuthority)(M)&&(Te=k.applyEdits(Te,k.removeProperty(Te,["remoteAuthority"],Ie))),Te}e.rewriteWorkspaceFileForNewLocation=v;function E(ee,$){let R=i.parse($);if(R&&Array.isArray(R.folders))R.folders=R.folders.filter(M=>r(M));else throw new Error(`${ee} looks like an invalid workspace file.`);return R}function F(ee){return y.isWindows?ee.some($=>a($)&&$.path.indexOf("/")>=0):!0}e.useSlashForPath=F;function U(ee){return ee.workspace&&typeof ee.workspace=="object"&&typeof ee.workspace.id=="string"&&typeof ee.workspace.configPath=="string"}function J(ee){return typeof ee.folderUri=="string"}function me(ee){return typeof ee.fileUri=="string"}function q(ee,$){const R={workspaces:[],files:[]};if(ee){const M=function(O,G){for(let Y=0;Y<O.length;Y++)try{G(O[Y],Y)}catch(ne){$.warn(`Error restoring recent entry ${JSON.stringify(O[Y])}: ${ne.toString()}. Skip entry.`)}},x=ee;if(Array.isArray(x.entries))M(x.entries,O=>{const G=O.label,Y=O.remoteAuthority;U(O)?R.workspaces.push({label:G,remoteAuthority:Y,workspace:{id:O.workspace.id,configPath:T.URI.parse(O.workspace.configPath)}}):J(O)?R.workspaces.push({label:G,remoteAuthority:Y,folderUri:T.URI.parse(O.folderUri)}):me(O)&&R.files.push({label:G,remoteAuthority:Y,fileUri:T.URI.parse(O.fileUri)})});else{const O=ee;Array.isArray(O.workspaces3)&&M(O.workspaces3,(G,Y)=>{const ne=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[Y]||void 0;typeof G=="object"&&typeof G.id=="string"&&typeof G.configURIPath=="string"?R.workspaces.push({label:ne,workspace:{id:G.id,configPath:T.URI.parse(G.configURIPath)}}):typeof G=="string"&&R.workspaces.push({label:ne,folderUri:T.URI.parse(G)})}),Array.isArray(O.files2)&&M(O.files2,(G,Y)=>{const ne=Array.isArray(O.fileLabels)&&O.fileLabels[Y]||void 0;typeof G=="string"&&R.files.push({label:ne,fileUri:T.URI.parse(G)})})}}return R}e.restoreRecentlyOpened=q;function z(ee){const $={entries:[]};for(const R of ee.workspaces)D(R)?$.entries.push({folderUri:R.folderUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority}):$.entries.push({workspace:{id:R.workspace.id,configPath:R.workspace.configPath.toString()},label:R.label,remoteAuthority:R.remoteAuthority});for(const R of ee.files)$.entries.push({fileUri:R.fileUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority});return $}e.toStoreData=z}),define(be[68],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class w{constructor(A){this.id=A,this._data=new Map,this._idPool=1}add(A){const T=this._idPool++;return this._data.set(T,A),this.logDebugInfo(),T}get(A,T){return this._data.has(A)?this._data.get(A)[T]:void 0}delete(A){this._data.delete(A),this.logDebugInfo()}logDebugInfo(){!w.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=w,w.enableDebugLogging=!1}),define(be[161],_e([0,1,2,3]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class A{constructor(){this._onDidChangeTabs=new I.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(y){this._tabs=y.map(C=>({name:C.name,group:C.group,resource:w.URI.revive(C.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=A}),define(be[49],_e([0,1,18,4]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(w.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(y,C){C===null?this._providerInfo.delete(y):this._providerInfo.set(y,C)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(be[27],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,w.createDecorator)("IExtHostInitDataService")}),define(be[162],_e([0,1,11]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class I{constructor(y,C,S){this._deferredPromises=new Map,this._id=y,this._shared=C,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new w.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of k.values())i.complete()}catch(i){for(const P of k.values())P.error(i)}})()},0)}get whenReady(){return this._init}get(y,C){let S=this._value[y];return typeof S=="undefined"&&(S=C),S}update(y,C){this._value[y]=C;let S=this._deferredPromises.get(y);if(S!==void 0)return S.p;const k=new w.DeferredPromise;return this._deferredPromises.set(y,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=I;class A extends I{constructor(y,C){super(y.identifier.value,!0,C);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=A}),define(be[14],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,w.createDecorator)("IExtHostRpcService");class I{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=I});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Q):I?I.value:e.get(Q)};define(be[163],_e([0,1,26,3]),function(Q,e,w,I){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(C,S){A.set(this,void 0),this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._id=w.ExtensionIdentifier.toKey(C.identifier),tt(this,A,S,"f"),Me(this,A,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(C){return Me(this,A,"f").get(this._id,C)}store(C,S){return Me(this,A,"f").store(this._id,C,S)}delete(C){return Me(this,A,"f").delete(this._id,C)}}e.ExtensionSecrets=T,A=new WeakMap}),define(be[94],_e([0,1,4,3]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class A{constructor(){this._onDidChangeTelemetryEnabled=new I.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(y){this._enabled=y}$onDidChangeTelemetryEnabled(y){this._enabled=y,this._onDidChangeTelemetryEnabled.fire(y)}}e.ExtHostTelemetry=A,e.IExtHostTelemetry=(0,w.createDecorator)("IExtHostTelemetry")}),define(be[69],_e([0,1,3]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var I;(function(y){y[y.NewChild=0]="NewChild",y[y.Disposed=1]="Disposed",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp"})(I=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const A=new WeakMap,T=y=>{let C=A.get(y);return C||(C={children:new Map,bus:new w.Emitter},A.set(y,C)),C};e.getPrivateApiFor=T}),define(be[70],_e([0,1,4,3,14]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(C){function S(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public}}C.fromApiTunnel=S;function k(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public}}C.fromServiceTunnel=k})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,w.createDecorator)("IExtHostTunnelService");let y=class{constructor(S){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(S){return S}async openTunnel(S,k){}async getTunnels(){return[]}async setTunnelExtensionFunctions(S){return{dispose:()=>{}}}registerPortsAttributesProvider(S,k){return{dispose:()=>{}}}async $providePortAttributes(S,k,i,P,c){return[]}async $forwardPort(S,k){}async $closeTunnel(S){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=Ve([qe(0,A.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Q):I?I.value:e.get(Q)},Ht=this&&this.__rest||function(Q,e){var w={};for(var I in Q)Object.prototype.hasOwnProperty.call(Q,I)&&e.indexOf(I)<0&&(w[I]=Q[I]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,I=Object.getOwnPropertySymbols(Q);A<I.length;A++)e.indexOf(I[A])<0&&Object.prototype.propertyIsEnumerable.call(Q,I[A])&&(w[I[A]]=Q[I[A]]);return w};define(be[7],_e([0,1,15,12,83,22,8,10,2,31,64,67,69]),function(Q,e,w,I,A,T,y,C,S,k,i,P,c){"use strict";var d,o,l,g,m,D,f,u,p,t,n,s,r,a,h,b;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function _(N){function L(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(L,N),Object.setPrototypeOf(L.prototype,N.prototype),L}let v=l=class{constructor(L){d.set(this,void 0),tt(this,d,L,"f")}static from(...L){let se=L;return new l(function(){if(se){for(const De of se)De&&typeof De.dispose=="function"&&De.dispose();se=void 0}})}dispose(){typeof Me(this,d,"f")=="function"&&(Me(this,d,"f").call(this),tt(this,d,void 0,"f"))}};d=new WeakMap,v=l=Ve([_],v),e.Disposable=v;let E=g=class{constructor(L,se){if(L<0)throw(0,I.illegalArgument)("line must be non-negative");if(se<0)throw(0,I.illegalArgument)("character must be non-negative");this._line=L,this._character=se}static Min(...L){if(L.length===0)throw new TypeError;let se=L[0];for(let De=1;De<L.length;De++){const Ke=L[De];Ke.isBefore(se)&&(se=Ke)}return se}static Max(...L){if(L.length===0)throw new TypeError;let se=L[0];for(let De=1;De<L.length;De++){const Ke=L[De];Ke.isAfter(se)&&(se=Ke)}return se}static isPosition(L){if(!L)return!1;if(L instanceof g)return!0;let{line:se,character:De}=L;return typeof se=="number"&&typeof De=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,se=0){if(L===null||se===null)throw(0,I.illegalArgument)();let De;return typeof L=="undefined"?De=0:typeof L=="number"?De=L:(De=typeof L.lineDelta=="number"?L.lineDelta:0,se=typeof L.characterDelta=="number"?L.characterDelta:0),De===0&&se===0?this:new g(this.line+De,this.character+se)}with(L,se=this.character){if(L===null||se===null)throw(0,I.illegalArgument)();let De;return typeof L=="undefined"?De=this.line:typeof L=="number"?De=L:(De=typeof L.line=="number"?L.line:this.line,se=typeof L.character=="number"?L.character:this.character),De===this.line&&se===this.character?this:new g(De,se)}toJSON(){return{line:this.line,character:this.character}}};E=g=Ve([_],E),e.Position=E;let F=m=class{constructor(L,se,De,Ke){let et,st;if(typeof L=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Ke=="number"?(et=new E(L,se),st=new E(De,Ke)):L instanceof E&&se instanceof E&&(et=L,st=se),!et||!st)throw new Error("Invalid arguments");et.isBefore(st)?(this._start=et,this._end=st):(this._start=st,this._end=et)}static isRange(L){return L instanceof m?!0:L?E.isPosition(L.start)&&E.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof m?this.contains(L._start)&&this.contains(L._end):L instanceof E?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const se=E.Max(L.start,this._start),De=E.Min(L.end,this._end);if(!se.isAfter(De))return new m(se,De)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const se=E.Min(L.start,this._start),De=E.Max(L.end,this.end);return new m(se,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,se=this.end){if(L===null||se===null)throw(0,I.illegalArgument)();let De;return L?E.isPosition(L)?De=L:(De=L.start||this.start,se=L.end||this.end):De=this.start,De.isEqual(this._start)&&se.isEqual(this.end)?this:new m(De,se)}toJSON(){return[this.start,this.end]}};F=m=Ve([_],F),e.Range=F;let U=D=class extends F{constructor(L,se,De,Ke){let et,st;if(typeof L=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Ke=="number"?(et=new E(L,se),st=new E(De,Ke)):L instanceof E&&se instanceof E&&(et=L,st=se),!et||!st)throw new Error("Invalid arguments");super(et,st);this._anchor=et,this._active=st}static isSelection(L){return L instanceof D?!0:L?F.isRange(L)&&E.isPosition(L.anchor)&&E.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};U=D=Ve([_],U),e.Selection=U;class J{constructor(L,se,De){if(typeof L!="string"||L.length===0)throw(0,I.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,I.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,I.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(se),this.connectionToken=De}}e.ResolvedAuthority=J;class me extends Error{constructor(L,se=P.RemoteAuthorityResolverErrorCode.Unknown,De){super(L);this._message=L,this._code=se,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,me.prototype)}static NotAvailable(L,se){return new me(L,P.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(L){return new me(L,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=me;var q;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(q=e.EndOfLine||(e.EndOfLine={}));var z;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(z=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ee=f=class{constructor(L,se){this._range=L,this._newText=se}static isTextEdit(L){return L instanceof f?!0:L?F.isRange(L)&&typeof L.newText=="string":!1}static replace(L,se){return new f(L,se)}static insert(L,se){return f.replace(new F(L,L),se)}static delete(L){return f.replace(L,"")}static setEndOfLine(L){const se=new f(new F(new E(0,0),new E(0,0)),"");return se.newEol=L,se}get range(){return this._range}set range(L){if(L&&!F.isRange(L))throw(0,I.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,I.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,I.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ee=f=Ve([_],ee),e.TextEdit=ee;var $;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellOutput=4]="CellOutput",N[N.CellReplace=5]="CellReplace",N[N.CellOutputItem=6]="CellOutputItem"})($=e.FileEditType||(e.FileEditType={}));let R=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,se,De,Ke){this._edits.push({_type:1,from:L,to:se,options:De,metadata:Ke})}createFile(L,se,De){this._edits.push({_type:1,from:void 0,to:L,options:se,metadata:De})}deleteFile(L,se,De){this._edits.push({_type:1,from:L,to:void 0,options:se,metadata:De})}replaceNotebookMetadata(L,se,De){this._edits.push({_type:3,metadata:De,uri:L,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(L,se,De,Ke,et){let st,ct,Et=[],St;if(Bt.isNotebookRange(se)&&Rt.isNotebookCellDataArray(De)&&!Rt.isNotebookCellDataArray(Ke)?(st=se.start,ct=se.end,Et=De,St=Ke):typeof se=="number"&&typeof De=="number"&&Rt.isNotebookCellDataArray(Ke)&&(st=se,ct=De,Et=Ke,St=et),st===void 0||ct===void 0)throw new Error("Invalid arguments");(st!==ct||Et.length>0)&&this._edits.push({_type:5,uri:L,index:st,count:ct-st,cells:Et,metadata:St})}replaceNotebookCellMetadata(L,se,De,Ke){this._edits.push({_type:3,metadata:Ke,uri:L,edit:{editType:11,index:se,metadata:De}})}replace(L,se,De,Ke){this._edits.push({_type:2,uri:L,edit:new ee(se,De),metadata:Ke})}insert(L,se,De,Ke){this.replace(L,new F(se,se),De,Ke)}delete(L,se,De){this.replace(L,se,"",De)}has(L){return this._edits.some(se=>se._type===2&&se.uri.toString()===L.toString())}set(L,se){if(se)for(const De of se)De&&this._edits.push({_type:2,uri:L,edit:De});else{for(let De=0;De<this._edits.length;De++){const Ke=this._edits[De];Ke._type===2&&Ke.uri.toString()===L.toString()&&(this._edits[De]=void 0)}(0,w.coalesceInPlace)(this._edits)}}get(L){const se=[];for(let De of this._edits)De._type===2&&De.uri.toString()===L.toString()&&se.push(De.edit);return se}entries(){const L=new T.ResourceMap;for(let se of this._edits)if(se._type===2){let De=L.get(se.uri);De||(De=[se.uri,[]],L.set(se.uri,De)),De[1].push(se.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};R=Ve([_],R),e.WorkspaceEdit=R;let M=u=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof u?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=u._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,se=this._tabstop++){if(typeof L=="function"){const De=new u;De._tabstop=this._tabstop,L(De),this._tabstop=De._tabstop,L=De.value}else L=u._escape(L);return this.value+="${",this.value+=se,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,se=this._tabstop++){const De=L.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(L,se){if(typeof se=="function"){const De=new u;De._tabstop=this._tabstop,se(De),this._tabstop=De._tabstop,se=De.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,se&&(this.value+=":",this.value+=se),this.value+="}",this}};M=u=Ve([_],M),e.SnippetString=M;var x;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(x=e.DiagnosticTag||(e.DiagnosticTag={}));var O;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(O=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let G=p=class{constructor(L,se){if(this.uri=L,se)if(se instanceof F)this.range=se;else if(se instanceof E)this.range=new F(se,se);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof p?!0:L?F.isRange(L.range)&&S.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};G=p=Ve([_],G),e.Location=G;let Y=class{constructor(L,se){this.location=L,this.message=se}static is(L){return L?typeof L.message=="string"&&L.location&&F.isRange(L.location.range)&&S.URI.isUri(L.location.uri):!1}static isEqual(L,se){return L===se?!0:!L||!se?!1:L.message===se.message&&L.location.range.isEqual(se.location.range)&&L.location.uri.toString()===se.location.uri.toString()}};Y=Ve([_],Y),e.DiagnosticRelatedInformation=Y;let ne=class{constructor(L,se,De=O.Error){if(!F.isRange(L))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=L,this.message=se,this.severity=De}toJSON(){return{severity:O[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,se){return L===se?!0:!L||!se?!1:L.message===se.message&&L.severity===se.severity&&L.code===se.code&&L.severity===se.severity&&L.source===se.source&&L.range.isEqual(se.range)&&(0,w.equals)(L.tags,se.tags)&&(0,w.equals)(L.relatedInformation,se.relatedInformation,Y.isEqual)}};ne=Ve([_],ne),e.Diagnostic=ne;let pe=class{constructor(L,se){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:(0,A.isMarkdownString)(L)?this.contents=[L]:this.contents=[L],this.range=se}};pe=Ve([_],pe),e.Hover=pe;var Ie;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(Ie=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Oe=class{constructor(L,se=Ie.Text){this.range=L,this.kind=se}toJSON(){return{range:this.range,kind:Ie[this.kind]}}};Oe=Ve([_],Oe),e.DocumentHighlight=Oe;var Te;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(Te=e.SymbolKind||(e.SymbolKind={}));var Ue;(function(N){N[N.Deprecated=1]="Deprecated"})(Ue=e.SymbolTag||(e.SymbolTag={}));let B=t=class{constructor(L,se,De,Ke,et){this.name=L,this.kind=se,this.containerName=et,typeof De=="string"&&(this.containerName=De),Ke instanceof G?this.location=Ke:De instanceof F&&(this.location=new G(Ke,De)),t.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Te[this.kind],location:this.location,containerName:this.containerName}}};B=t=Ve([_],B),e.SymbolInformation=B;let K=n=class{constructor(L,se,De,Ke,et){this.name=L,this.detail=se,this.kind=De,this.range=Ke,this.selectionRange=et,this.children=[],n.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(n.validate)}};K=n=Ve([_],K),e.DocumentSymbol=K;var ie;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(ie=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor(L,se){this.title=L,this.kind=se}};le=Ve([_],le),e.CodeAction=le;let fe=s=class{constructor(L){this.value=L}append(L){return new s(this.value?this.value+s.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+s.sep)}};fe.sep=".",fe=s=Ve([_],fe),e.CodeActionKind=fe,fe.Empty=new fe(""),fe.QuickFix=fe.Empty.append("quickfix"),fe.Refactor=fe.Empty.append("refactor"),fe.RefactorExtract=fe.Refactor.append("extract"),fe.RefactorInline=fe.Refactor.append("inline"),fe.RefactorRewrite=fe.Refactor.append("rewrite"),fe.Source=fe.Empty.append("source"),fe.SourceOrganizeImports=fe.Source.append("organizeImports"),fe.SourceFixAll=fe.Source.append("fixAll");let Se=class{constructor(L,se){if(this.range=L,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Se=Ve([_],Se),e.SelectionRange=Se;class Ne{constructor(L,se,De,Ke,et,st){this.kind=L,this.name=se,this.detail=De,this.uri=Ke,this.range=et,this.selectionRange=st}}e.CallHierarchyItem=Ne;class ge{constructor(L,se){this.fromRanges=se,this.from=L}}e.CallHierarchyIncomingCall=ge;class Ce{constructor(L,se){this.fromRanges=se,this.to=L}}e.CallHierarchyOutgoingCall=Ce;let Ae=class{constructor(L,se){this.range=L,this.command=se}get isResolved(){return!!this.command}};Ae=Ve([_],Ae),e.CodeLens=Ae;let We=r=class{constructor(L,se=!1){o.set(this,void 0),tt(this,o,new A.MarkdownString(L,{supportThemeIcons:se}),"f")}static isMarkdownString(L){return L instanceof r?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Me(this,o,"f").value}set value(L){Me(this,o,"f").value=L}get isTrusted(){return Me(this,o,"f").isTrusted}set isTrusted(L){Me(this,o,"f").isTrusted=L}get supportThemeIcons(){return Me(this,o,"f").supportThemeIcons}appendText(L){return Me(this,o,"f").appendText(L),this}appendMarkdown(L){return Me(this,o,"f").appendMarkdown(L),this}appendCodeblock(L,se){return Me(this,o,"f").appendCodeblock(se!=null?se:"",L),this}};o=new WeakMap,We=r=Ve([_],We),e.MarkdownString=We;let Ee=class{constructor(L,se){this.label=L,this.documentation=se}};Ee=Ve([_],Ee),e.ParameterInformation=Ee;let je=class{constructor(L,se){this.label=L,this.documentation=se,this.parameters=[]}};je=Ve([_],je),e.SignatureInformation=je;let H=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};H=Ve([_],H),e.SignatureHelp=H;var te;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(te=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ve;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(ve=e.InlineHintKind||(e.InlineHintKind={}));let Le=class{constructor(L,se,De){this.text=L,this.range=se,this.kind=De}};Le=Ve([_],Le),e.InlineHint=Le;var He;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var xe;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(xe=e.CompletionItemKind||(e.CompletionItemKind={}));var Xe;(function(N){N[N.Deprecated=1]="Deprecated"})(Xe=e.CompletionItemTag||(e.CompletionItemTag={}));let W=class{constructor(L,se){this.label=L,this.kind=se}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&xe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};W=Ve([_],W),e.CompletionItem=W;let re=class{constructor(L=[],se=!1){this.items=L,this.isIncomplete=se}};re=Ve([_],re),e.CompletionList=re;var ce;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(ce=e.ViewColumn||(e.ViewColumn={}));var V;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(V=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Z;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(Z=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ae;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(ae=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var he;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(he=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ye;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(ye=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ze;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(ze=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function L(se){switch(se){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=L}(ye=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let $e=class{constructor(L,se){if(se&&!S.URI.isUri(se))throw(0,I.illegalArgument)("target");if(!F.isRange(L)||L.isEmpty)throw(0,I.illegalArgument)("range");this.range=L,this.target=se}};$e=Ve([_],$e),e.DocumentLink=$e;let Be=class{constructor(L,se,De,Ke){this.red=L,this.green=se,this.blue=De,this.alpha=Ke}};Be=Ve([_],Be),e.Color=Be;let Ge=class{constructor(L,se){if(se&&!(se instanceof Be))throw(0,I.illegalArgument)("color");if(!F.isRange(L)||L.isEmpty)throw(0,I.illegalArgument)("range");this.range=L,this.color=se}};Ge=Ve([_],Ge),e.ColorInformation=Ge;let nt=class{constructor(L){if(!L||typeof L!="string")throw(0,I.illegalArgument)("label");this.label=L}};nt=Ve([_],nt),e.ColorPresentation=nt;var dt;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(dt=e.ColorFormat||(e.ColorFormat={}));var it;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Ye;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(Ye=e.TaskRevealKind||(e.TaskRevealKind={}));var mt;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(mt=e.TaskPanelKind||(e.TaskPanelKind={}));let wt=a=class{constructor(L,se){if(typeof L!="string"||typeof se!="string")throw(0,I.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}get id(){return this._id}};wt.Clean=new a("clean","Clean"),wt.Build=new a("build","Build"),wt.Rebuild=new a("rebuild","Rebuild"),wt.Test=new a("test","Test"),wt=a=Ve([_],wt),e.TaskGroup=wt;function we(N){let L="";for(let se=0;se<N.length;se++)L+=N[se].replace(/,/g,",,")+",";return L}let de=class{constructor(L,se,De){if(typeof L!="string")throw(0,I.illegalArgument)("process");this._args=[],this._process=L,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=De):this._options=se)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,I.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let se of this._args)L.push(se);return we(L)}};de=Ve([_],de),e.ProcessExecution=de;let oe=class{constructor(L,se,De){if(this._args=[],Array.isArray(se)){if(!L)throw(0,I.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,I.illegalArgument)("command");this._command=L,this._args=se,this._options=De}else{if(typeof L!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=L,this._options=se}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,I.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)L.push(typeof se=="string"?se:se.value);return we(L)}};oe=Ve([_],oe),e.ShellExecution=oe;var j;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(j=e.ShellQuoting||(e.ShellQuoting={}));var Re;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(Re=e.TaskScope||(e.TaskScope={}));class Pe{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,k.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=Pe;let Qe=h=class{constructor(L,se,De,Ke,et,st){this.__deprecated=!1,this._definition=this.definition=L;let ct;typeof se=="string"?(this._name=this.name=se,this._source=this.source=De,this.execution=Ke,ct=et,this.__deprecated=!0):se===Re.Global||se===Re.Workspace?(this.target=se,this._name=this.name=De,this._source=this.source=Ke,this.execution=et,ct=st):(this.target=se,this._name=this.name=De,this._source=this.source=Ke,this.execution=et,ct=st),typeof ct=="string"?(this._problemMatchers=[ct],this._hasDefinedMatchers=!0):Array.isArray(ct)?(this._problemMatchers=ct,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof de?this._definition={type:h.ProcessType,id:this._execution.computeId()}:this._execution instanceof oe?this._definition={type:h.ShellType,id:this._execution.computeId()}:this._execution instanceof Pe?this._definition={type:h.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:h.EmptyType,id:(0,k.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,I.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,I.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const se=this._definition.type;(h.EmptyType===se||h.ProcessType===se||h.ShellType===se||h.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,I.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};Qe.ExtensionCallbackType="customExecution",Qe.ProcessType="process",Qe.ShellType="shell",Qe.EmptyType="$empty",Qe=h=Ve([_],Qe),e.Task=Qe;var Ze;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(Ze=e.ProgressLocation||(e.ProgressLocation={}));let ut=class{constructor(L,se=ht.None){this.collapsibleState=se,S.URI.isUri(L)?this.resourceUri=L:this.label=L}};ut=Ve([_],ut),e.TreeItem=ut;var ht;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Je=class{constructor(L,se){this.id=L,this.color=se}};Je=Ve([_],Je),e.ThemeIcon=Je,Je.File=new Je("file"),Je.Folder=new Je("folder");let ot=class{constructor(L){this.id=L}};ot=Ve([_],ot),e.ThemeColor=ot;var ft;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(ft=e.ConfigurationTarget||(e.ConfigurationTarget={}));let at=class{constructor(L,se){if(typeof L!="string"&&(!L||!S.URI.isUri(L)&&!S.URI.isUri(L.uri)))throw(0,I.illegalArgument)("base");if(typeof se!="string")throw(0,I.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=S.URI.file(L),this.base=L):S.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=se}};at=Ve([_],at),e.RelativePattern=at;let _t=class{constructor(L,se,De,Ke){this.enabled=typeof L=="boolean"?L:!0,typeof se=="string"&&(this.condition=se),typeof De=="string"&&(this.hitCondition=De),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,k.generateUuid)()),this._id}};_t=Ve([_],_t),e.Breakpoint=_t;let vt=class extends _t{constructor(L,se,De,Ke,et){super(se,De,Ke,et);if(L===null)throw(0,I.illegalArgument)("location");this.location=L}};vt=Ve([_],vt),e.SourceBreakpoint=vt;let Dt=class extends _t{constructor(L,se,De,Ke,et){super(se,De,Ke,et);this.functionName=L}};Dt=Ve([_],Dt),e.FunctionBreakpoint=Dt;let It=class extends _t{constructor(L,se,De,Ke,et,st,ct){super(Ke,et,st,ct);if(!se)throw(0,I.illegalArgument)("dataId");this.label=L,this.dataId=se,this.canPersist=De}};It=Ve([_],It),e.DataBreakpoint=It;let Pt=class{constructor(L,se,De){this.command=L,this.args=se||[],this.options=De}};Pt=Ve([_],Pt),e.DebugAdapterExecutable=Pt;let bt=class{constructor(L,se){this.port=L,this.host=se}};bt=Ve([_],bt),e.DebugAdapterServer=bt;let Gt=class{constructor(L){this.path=L}};Gt=Ve([_],Gt),e.DebugAdapterNamedPipeServer=Gt;let Qt=class{constructor(L){this.implementation=L}};Qt=Ve([_],Qt),e.DebugAdapterInlineImplementation=Qt;let gt=class{constructor(L,se){this.range=L,this.expression=se}};gt=Ve([_],gt),e.EvaluatableExpression=gt;let Jt=class{constructor(L,se){this.range=L,this.text=se}};Jt=Ve([_],Jt),e.InlineValueText=Jt;let yt=class{constructor(L,se,De=!0){this.range=L,this.variableName=se,this.caseSensitiveLookup=De}};yt=Ve([_],yt),e.InlineValueVariableLookup=yt;let zt=class{constructor(L,se){this.range=L,this.expression=se}};zt=Ve([_],zt),e.InlineValueEvaluatableExpression=zt;let Yt=class{constructor(L,se){this.frameId=L,this.stoppedLocation=se}};Yt=Ve([_],Yt),e.InlineValueContext=Yt;var Vt;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Vt=e.FileChangeType||(e.FileChangeType={}));let lt=b=class extends Error{constructor(L,se=i.FileSystemProviderErrorCode.Unknown,De){var Ke;super(S.URI.isUri(L)?L.toString(!0):L);this.code=(Ke=De==null?void 0:De.name)!==null&&Ke!==void 0?Ke:"Unknown",(0,i.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(L){return new b(L,i.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(L){return new b(L,i.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(L){return new b(L,i.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(L){return new b(L,i.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(L){return new b(L,i.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(L){return new b(L,i.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}};lt=b=Ve([_],lt),e.FileSystemError=lt;let Xt=class{constructor(L,se,De){this.start=L,this.end=se,this.kind=De}};Xt=Ve([_],Xt),e.FoldingRange=Xt;var At;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(At=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ut;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(Ut=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var dn;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(dn=e.CommentMode||(e.CommentMode={}));class vn{constructor(L,se=[]){this.tokenTypes=L,this.tokenModifiers=se}}e.SemanticTokensLegend=vn;function hn(N){return typeof N=="undefined"||(0,C.isStringArray)(N)}class Zt{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let se=0,De=L.tokenTypes.length;se<De;se++)this._tokenTypeStrToInt.set(L.tokenTypes[se],se);for(let se=0,De=L.tokenModifiers.length;se<De;se++)this._tokenModifierStrToInt.set(L.tokenModifiers[se],se)}}push(L,se,De,Ke,et){if(typeof L=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Ke=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(L,se,De,Ke,et);if(F.isRange(L)&&typeof se=="string"&&hn(De))return this._push(L,se,De);throw(0,I.illegalArgument)()}_push(L,se,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const Ke=L.start.line,et=L.start.character,st=L.end.character-L.start.character,ct=this._tokenTypeStrToInt.get(se);let Et=0;if(De)for(const St of De){if(!this._tokenModifierStrToInt.has(St))throw new Error("`tokenModifier` is not in the provided legend");const Ct=this._tokenModifierStrToInt.get(St);Et|=1<<Ct>>>0}this._pushEncoded(Ke,et,st,ct,Et)}_pushEncoded(L,se,De,Ke,et){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Et=this._data.length/5|0;let St=0,Ct=0;for(let kt=0;kt<Et;kt++){let Ft=this._data[5*kt],un=this._data[5*kt+1];Ft===0?(Ft=St,un+=Ct):Ft+=St,this._data[5*kt]=Ft,this._data[5*kt+1]=un,St=Ft,Ct=un}}let st=L,ct=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(ct-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=ct,this._data[this._dataLen++]=De,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=et,this._prevLine=L,this._prevChar=se}static _sortAndDeltaEncode(L){let se=[];const De=L.length/5|0;for(let ct=0;ct<De;ct++)se[ct]=ct;se.sort((ct,Et)=>{const St=L[5*ct],Ct=L[5*Et];if(St===Ct){const kt=L[5*ct+1],Ft=L[5*Et+1];return kt-Ft}return St-Ct});const Ke=new Uint32Array(L.length);let et=0,st=0;for(let ct=0;ct<De;ct++){const Et=5*se[ct],St=L[Et+0],Ct=L[Et+1],kt=L[Et+2],Ft=L[Et+3],un=L[Et+4],Pn=St-et,Fn=Pn===0?Ct-st:Ct,cn=5*ct;Ke[cn+0]=Pn,Ke[cn+1]=Fn,Ke[cn+2]=kt,Ke[cn+3]=Ft,Ke[cn+4]=un,et=St,st=Ct}return Ke}build(L){return this._dataIsSortedAndDeltaEncoded?new jt(new Uint32Array(this._data),L):new jt(Zt._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=Zt;class jt{constructor(L,se){this.resultId=se,this.data=L}}e.SemanticTokens=jt;class Mt{constructor(L,se,De){this.start=L,this.deleteCount=se,this.data=De}}e.SemanticTokensEdit=Mt;class wn{constructor(L,se){this.resultId=se,this.edits=L}}e.SemanticTokensEdits=wn;var en;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(en=e.DebugConsoleMode||(e.DebugConsoleMode={}));var tn;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(tn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let qt=class{constructor(){}};qt.Back={iconPath:new Je("arrow-left")},qt=Ve([_],qt),e.QuickInputButtons=qt;var bn;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(bn=e.ExtensionKind||(e.ExtensionKind={}));class Tt{constructor(L,se,De){this.badge=L,this.tooltip=se,this.color=De}static validate(L){if(L.badge&&L.badge.length!==1&&L.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Tt;let nn=class{constructor(L){this.kind=L}};nn=Ve([_],nn),e.ColorTheme=nn;var _n;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(_n=e.ColorThemeKind||(e.ColorThemeKind={}));class Bt{constructor(L,se){if(L<0)throw(0,I.illegalArgument)("start must be positive");if(se<0)throw(0,I.illegalArgument)("end must be positive");L<=se?(this._start=L,this._end=se):(this._start=se,this._end=L)}static isNotebookRange(L){return L instanceof Bt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let se=this._start,De=this._end;return L.start!==void 0&&(se=L.start),L.end!==void 0&&(De=L.end),se===this._start&&De===this._end?this:new Bt(se,De)}}e.NotebookRange=Bt;class rn{constructor(L,se){typeof L=="object"?Object.assign(this,L):(this.inputCollapsed=L,this.outputCollapsed=se)}with(L){let{inputCollapsed:se,outputCollapsed:De}=L,Ke=Ht(L,["inputCollapsed","outputCollapsed"]);return se===void 0?se=this.inputCollapsed:se===null&&(se=void 0),De===void 0?De=this.outputCollapsed:De===null&&(De=void 0),se===this.inputCollapsed&&De===this.outputCollapsed&&Object.keys(Ke).length===0?this:new rn(Object.assign({inputCollapsed:se,outputCollapsed:De},Ke))}}e.NotebookCellMetadata=rn;class Ot{constructor(L=!0){var se;typeof L=="object"?(Object.assign(this,L),this.trusted=(se=L.trusted)!==null&&se!==void 0?se:!0):this.trusted=L}with(L){let{trusted:se}=L,De=Ht(L,["trusted"]);return se===void 0?se=this.trusted:se===null&&(se=void 0),se===this.trusted&&Object.keys(De).length===0?this:new Ot(Object.assign({trusted:se},De))}}e.NotebookDocumentMetadata=Ot;class Rt{constructor(L,se,De,Ke,et,st){this.kind=L,this.source=se,this.language=De,this.outputs=Ke!=null?Ke:[],this.metadata=et,this.latestExecutionSummary=st}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(se=>Rt.isNotebookCellData(se))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Rt;class fn{constructor(L,se){this.cells=L,this.metadata=se!=null?se:new Ot}}e.NotebookData=fn;class xt{constructor(L,se,De){if(this.mime=L,this.value=se,this.metadata=De,(0,y.isFalsyOrWhitespace)(this.mime))throw new Error("INVALID mime type, must not be empty or falsy")}static isNotebookCellOutputItem(L){return L instanceof xt}}e.NotebookCellOutputItem=xt;class Fe{constructor(L,se,De){this.outputs=L,typeof se=="string"?(this.id=se,this.metadata=De):(this.id=(0,k.generateUuid)(),this.metadata=se!=null?se:De)}}e.NotebookCellOutput=Fe;var sn;(function(N){N[N.Markdown=1]="Markdown",N[N.Code=2]="Code"})(sn=e.NotebookCellKind||(e.NotebookCellKind={}));var on;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(on=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pt;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(pt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var En;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(En=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class yn{constructor(L,se,De,Ke,et,st){this.text=L,this.alignment=se,this.command=De,this.tooltip=Ke,this.priority=et,this.accessibilityInformation=st}}e.NotebookCellStatusBarItem=yn;let Kt=class{constructor(L,se){this.label=L,this.timestamp=se}};Kt=Ve([_],Kt),e.TimelineItem=Kt;var mn;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(mn=e.ExtensionMode||(e.ExtensionMode={}));var Sn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(Sn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Dn;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(Dn=e.StandardTokenType||(e.StandardTokenType={}));class Cn{constructor(L,se){this.ranges=L,this.wordPattern=se}}e.LinkedEditingRanges=Cn;var kn;(function(N){N[N.Unset=0]="Unset",N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(kn=e.TestResultState||(e.TestResultState={}));var an;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information",N[N.Hint=3]="Hint"})(an=e.TestMessageSeverity||(e.TestMessageSeverity={}));var gn;(function(N){N[N.Pending=0]="Pending",N[N.Resolved=1]="Resolved"})(gn=e.TestItemStatus||(e.TestItemStatus={}));const Nt=(N,L,se,De)=>{let Ke=se;return{enumerable:!0,configurable:!1,get(){return Ke},set(et){De(Ke,et)||(Ke=et,N.bus.fire([3,L,et]))}}},$t=(N,L)=>N===L,In=(N,L)=>N===L?!0:!N||!L?!1:N.isEqual(L);class ln{constructor(L,se,De,Ke){this.label=se,this.data=Ke;const et=(0,c.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:L,enumerable:!0,writable:!1},uri:{value:De,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>et.parent},children:{value:new T.ReadonlyMapView(et.children),enumerable:!0,writable:!1},range:Nt(et,"range",void 0,In),description:Nt(et,"description",void 0,$t),runnable:Nt(et,"runnable",!0,$t),debuggable:Nt(et,"debuggable",!0,$t),status:Nt(et,"status",gn.Resolved,$t),error:Nt(et,"error",void 0,$t)})}invalidate(){(0,c.getPrivateApiFor)(this).bus.fire([2])}dispose(){const L=(0,c.getPrivateApiFor)(this);L.parent&&(0,c.getPrivateApiFor)(L.parent).children.delete(this.id),L.bus.fire([1])}addChild(L){if(!(L instanceof ln))throw new Error("Test child must be created through vscode.test.createTestItem()");const se=(0,c.getPrivateApiFor)(this);if(se.children.has(L.id))throw new Error(`Attempted to insert a duplicate test item ID ${L.id}`);se.children.set(L.id,L),se.bus.fire([0,L])}}e.TestItemImpl=ln;class X{constructor(L){this.message=L,this.severity=an.Error}static diff(L,se,De){const Ke=new X(L);return Ke.expectedOutput=se,Ke.actualOutput=De,Ke}}e.TestMessage=X;var ue;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(ue=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var ke;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(ke=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var rt;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore"})(rt=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(be[95],_e([0,1,42,18,8,120,86,7,15]),function(Q,e,w,I,A,T,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function i(o,l){l?k.set(o,l):k.delete(o)}e.setWordDefinitionFor=i;function P(o){return k.get(o)}e.getWordDefinitionFor=P;class c extends T.MirrorTextModel{constructor(l,g,m,D,f,u,p,t){super(g,m,D,f);this._proxy=l,this._languageId=u,this._isDirty=p,this._notebook=t,this._isDisposed=!1}dispose(){(0,w.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(l){return(0,S.equals)(this._lines,l)}get document(){if(!this._document){const l=this;this._document={get uri(){return l._uri},get fileName(){return l._uri.fsPath},get isUntitled(){return l._uri.scheme===I.Schemas.untitled},get languageId(){return l._languageId},get version(){return l._versionId},get isClosed(){return l._isDisposed},get isDirty(){return l._isDirty},get notebook(){return l._notebook},save(){return l._save()},getText(g){return g?l._getTextInRange(g):l.getText()},get eol(){return l._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return l._lines.length},lineAt(g){return l._lineAt(g)},offsetAt(g){return l._offsetAt(g)},positionAt(g){return l._positionAt(g)},validateRange(g){return l._validateRange(g)},validatePosition(g){return l._validatePosition(g)},getWordRangeAtPosition(g,m){return l._getWordRangeAtPosition(g,m)}}}return Object.freeze(this._document)}_acceptLanguageId(l){(0,w.ok)(!this._isDisposed),this._languageId=l}_acceptIsDirty(l){(0,w.ok)(!this._isDisposed),this._isDirty=l}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(l){const g=this._validateRange(l);if(g.isEmpty)return"";if(g.isSingleLine)return this._lines[g.start.line].substring(g.start.character,g.end.character);const m=this._eol,D=g.start.line,f=g.end.line,u=[];u.push(this._lines[D].substring(g.start.character));for(let p=D+1;p<f;p++)u.push(this._lines[p]);return u.push(this._lines[f].substring(0,g.end.character)),u.join(m)}_lineAt(l){let g;if(l instanceof C.Position?g=l.line:typeof l=="number"&&(g=l),typeof g!="number"||g<0||g>=this._lines.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new d(g,this._lines[g],g===this._lines.length-1)}_offsetAt(l){return l=this._validatePosition(l),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(l.line-1)+l.character}_positionAt(l){l=Math.floor(l),l=Math.max(0,l),this._ensureLineStarts();const g=this._lineStarts.getIndexOf(l),m=this._lines[g.index].length;return new C.Position(g.index,Math.min(g.remainder,m))}_validateRange(l){if(!(l instanceof C.Range))throw new Error("Invalid argument");const g=this._validatePosition(l.start),m=this._validatePosition(l.end);return g===l.start&&m===l.end?l:new C.Range(g.line,g.character,m.line,m.character)}_validatePosition(l){if(!(l instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return l.with(0,0);let{line:g,character:m}=l,D=!1;if(g<0)g=0,m=0,D=!0;else if(g>=this._lines.length)g=this._lines.length-1,m=this._lines[g].length,D=!0;else{const f=this._lines[g].length;m<0?(m=0,D=!0):m>f&&(m=f,D=!0)}return D?new C.Position(g,m):l}_getWordRangeAtPosition(l,g){const m=this._validatePosition(l);if(!g)g=P(this._languageId);else if((0,A.regExpLeadsToEndlessLoop)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const D=(0,y.getWordAtText)(m.character+1,(0,y.ensureValidWordDefinition)(g),this._lines[m.line],0);if(D)return new C.Range(m.line,D.startColumn-1,m.line,D.endColumn-1)}}e.ExtHostDocumentData=c;class d{constructor(l,g,m){this._line=l,this._text=g,this._isLastLine=m}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=d}),define(be[164],_e([0,1,7,3,88,6,59,22,2,31]),function(Q,e,w,I,A,T,y,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(c,d,o,l){this._notebook=o,this._selector=l,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(d.onDidChangeDocument(m=>{const D=this._cellUris.get(m.document.uri);D!==void 0&&(this._cellLengths.changeValue(D,this._cells[D].document.getText().length+1),this._cellLines.changeValue(D,this._cells[D].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const g=m=>{m===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(c.onDidChangeNotebookCells(m=>g(m.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const c=[],d=[];for(const o of this._notebook.getCells())o.kind===w.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,o.document.uri,o.document.languageId,!0))&&(this._cellUris.set(o.document.uri,this._cells.length),this._cells.push(o),c.push(o.document.getText().length+1),d.push(o.document.lineCount));this._cellLengths=new A.PrefixSumComputer(new Uint32Array(c)),this._cellLines=new A.PrefixSumComputer(new Uint32Array(d))}get version(){return this._versionId}getText(c){var d,o;if(!c){let f="";for(const u of this._cells)f+=u.document.getText()+`
`;return f=f.slice(0,-1),f}if(c.isEmpty)return"";const l=this.locationAt(c.start),g=this.locationAt(c.end),m=this._cells[(d=this._cellUris.get(l.uri))!==null&&d!==void 0?d:-1],D=this._cells[(o=this._cellUris.get(g.uri))!==null&&o!==void 0?o:-1];if(!m||!D)return"";if(m===D)return m.document.getText(new w.Range(l.range.start,g.range.end));{const f=m.document.getText(new w.Range(l.range.start,new w.Position(m.document.lineCount,0))),u=D.document.getText(new w.Range(new w.Position(0,0),g.range.end));return f+`
`+u}}offsetAt(c){const d=this._cellLines.getIndexOf(c.line),o=this._cellLengths.getAccumulatedValue(d.index-1),l=this._cells[d.index].document.offsetAt(c.with(d.remainder));return o+l}positionAt(c){if(typeof c=="number"){const o=this._cellLengths.getIndexOf(c),l=this._cellLines.getAccumulatedValue(o.index-1);return this._cells[o.index].document.positionAt(o.remainder).translate(l)}const d=this._cellUris.get(c.uri);if(d!==void 0){const o=this._cellLines.getAccumulatedValue(d-1);return new w.Position(o+c.range.start.line,c.range.start.character)}return new w.Position(0,0)}locationAt(c){w.Range.isRange(c)||(c=new w.Range(c,c));const d=this._cellLines.getIndexOf(c.start.line);let o=d;c.isEmpty||(o=this._cellLines.getIndexOf(c.end.line));const l=new w.Position(d.remainder,c.start.character),g=new w.Position(o.remainder,c.end.character),m=new w.Range(l,g),D=this._cells[d.index];return new w.Location(D.document.uri,D.document.validateRange(m))}contains(c){return this._cellUris.has(c)}validateRange(c){const d=this.validatePosition(c.start),o=this.validatePosition(c.end);return c.with(d,o)}validatePosition(c){const d=this._cellLines.getIndexOf(c.line),o=new w.Position(d.remainder,c.character),l=this._cells[d.index].document.validatePosition(o),g=this._cellLines.getAccumulatedValue(d.index-1);return new w.Position(g+l.line,l.character)}}e.ExtHostNotebookConcatDocument=i}),define(be[165],_e([0,1,7,14,3]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(C){this._actual=new w.ColorTheme(w.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new A.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let S=C==="light"?w.ColorThemeKind.Light:C==="dark"?w.ColorThemeKind.Dark:w.ColorThemeKind.HighContrast;this._actual=new w.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=Ve([qe(0,I.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(be[71],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,w.createDecorator)("IURITransformerService");class I{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=I}),define(be[166],_e([0,1,23]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class I{constructor(){this.buffers=[]}add(S){let k=this.buffers.indexOf(S);return k<0&&(k=this.buffers.length,this.buffers.push(S)),k}}function A(C,S){if(S){const k=new I,i=(d,o)=>{if(o instanceof ArrayBuffer){const l=k.add(o);return{$$vscode_array_buffer_reference$$:!0,index:l}}else if(ArrayBuffer.isView(o)){const l=T(o);if(l){const g=k.add(o.buffer);return{$$vscode_array_buffer_reference$$:!0,index:g,view:{type:l,byteLength:o.byteLength,byteOffset:o.byteOffset}}}}return o},P=JSON.stringify(C,i),c=k.buffers.map(d=>{const o=new Uint8Array(d);return w.VSBuffer.wrap(o)});return{message:P,buffers:c}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=A;function T(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(C,S){const k=S.map(c=>{const d=new ArrayBuffer(c.byteLength);return new Uint8Array(d).set(c.buffer),d}),i=S.length?(c,d)=>{if(typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const o=d,{index:l}=o,g=k[l];if(o.view)switch(o.view.type){case 1:return new Int8Array(g,o.view.byteOffset,o.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,o.view.byteOffset,o.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,o.view.byteOffset,o.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,o.view.byteOffset,o.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,o.view.byteOffset,o.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,o.view.byteOffset,o.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,o.view.byteOffset,o.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,o.view.byteOffset,o.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,o.view.byteOffset,o.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,o.view.byteOffset,o.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,o.view.byteOffset,o.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return d}:void 0;return{message:JSON.parse(C,i),arrayBuffers:k}}e.deserializeWebviewMessage=y}),define(be[72],_e([0,1,2]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function I(T,y,C){const S=T.webviewResourceRoot.replace("{{resource}}",C.scheme+A(C)).replace("{{uuid}}",y);return w.URI.parse(S)}e.asWebviewUri=I;function A(T){return T.toString().replace(/^\S+?:/,"")}}),define(be[167],_e([0,1,3,6,72,31]),function(Q,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(S,k,i){this._proxy=S,this._editors=k,this._initData=i,this._handlePool=0,this._disposables=new I.DisposableStore,this._insets=new Map,this._disposables.add(k.onDidChangeVisibleTextEditors(()=>{const P=k.getVisibleTextEditors();for(const c of this._insets.values())P.indexOf(c.editor)<0&&c.inset.dispose()}))}dispose(){this._insets.forEach(S=>S.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(S,k,i,P,c){let d;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===S){d=u;break}if(!d)throw new Error("not a visible editor");const o=this,l=this._handlePool++,g=new w.Emitter,m=new w.Emitter,D=new class{constructor(){this._uuid=(0,T.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,A.asWebviewUri)(o._initData,this._uuid,u)}get cspSource(){return o._initData.webviewCspSource}set options(u){this._options=u,o._proxy.$setOptions(l,u)}get options(){return this._options}set html(u){this._html=u,o._proxy.$setHtml(l,u)}get html(){return this._html}get onDidReceiveMessage(){return g.event}postMessage(u){return o._proxy.$postMessage(l,u)}},f=new class{constructor(){this.editor=S,this.line=k,this.height=i,this.webview=D,this.onDidDispose=m.event}dispose(){o._insets.has(l)&&(o._insets.delete(l),o._proxy.$disposeEditorInset(l),m.fire(),m.dispose(),g.dispose())}};return this._proxy.$createEditorInset(l,d.id,d.value.document.uri,k+1,i,P||{},c.identifier,c.extensionLocation),this._insets.set(l,{editor:S,inset:f,onDidReceiveMessage:g}),f}$onDidDispose(S){const k=this._insets.get(S);k&&k.inset.dispose()}$onDidReceiveMessage(S,k){const i=this._insets.get(S);i&&i.onDidReceiveMessage.fire(k)}}e.ExtHostEditorInsets=y}),define(be[168],_e([0,1,3,63,139,4,6,22,29,15,51,24,36,159]),function(Q,e,w,I,A,T,y,C,S,k,i,P,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,d.registerIcon)("default-view-icon",c.Codicon.window,(0,A.localize)(0,null));var o;(function(a){a.ViewContainersRegistry="workbench.registry.view.containers",a.ViewsRegistry="workbench.registry.view"})(o=e.Extensions||(e.Extensions={}));var l;(function(a){a[a.Sidebar=0]="Sidebar",a[a.Panel=1]="Panel"})(l=e.ViewContainerLocation||(e.ViewContainerLocation={}));function g(a){switch(a){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=g;function m(a){return`viewContainer.${a}.enabled`}e.getEnabledViewContainerContextKey=m;class D extends y.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new w.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new w.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(h,b,_){var v;const E=this.get(h.id);if(E)return E;const F=h;return F.openCommandActionDescriptor=(_==null?void 0:_.donotRegisterOpenCommand)?void 0:(v=F.openCommandActionDescriptor)!==null&&v!==void 0?v:{id:F.id},(0,C.getOrSet)(this.viewContainers,b,[]).push(F),(_==null?void 0:_.isDefault)&&this.defaultViewContainers.push(F),this._onDidRegister.fire({viewContainer:F,viewContainerLocation:b}),F}deregisterViewContainer(h){for(const b of this.viewContainers.keys()){const _=this.viewContainers.get(b),v=_==null?void 0:_.indexOf(h);if(v!==-1){_==null||_.splice(v,1),_.length===0&&this.viewContainers.delete(b),this._onDidDeregister.fire({viewContainer:h,viewContainerLocation:b});return}}}get(h){return this.all.filter(b=>b.id===h)[0]}getViewContainers(h){return[...this.viewContainers.get(h)||[]]}getViewContainerLocation(h){return[...this.viewContainers.keys()].filter(b=>this.getViewContainers(b).filter(_=>(_==null?void 0:_.id)===h.id).length>0)[0]}getDefaultViewContainer(h){return this.defaultViewContainers.find(b=>this.getViewContainerLocation(b)===h)}}S.Registry.add(o.ViewContainersRegistry,new D);var f;(function(a){a.Open="2_open",a.Debug="4_debug",a.SCM="5_scm",a.More="9_more"})(f=e.ViewContentGroups||(e.ViewContentGroups={}));function u(a,h){var b,_,v,E;const F=(b=a.group)!==null&&b!==void 0?b:f.More,U=(_=h.group)!==null&&_!==void 0?_:f.More;return F!==U?F.localeCompare(U):((v=a.order)!==null&&v!==void 0?v:5)-((E=h.order)!==null&&E!==void 0?E:5)}class p extends y.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new w.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new w.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new w.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new w.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(h,b){this.registerViews2([{views:h,viewContainer:b}])}registerViews2(h){h.forEach(({views:b,viewContainer:_})=>this.addViews(b,_)),this._onViewsRegistered.fire(h)}deregisterViews(h,b){const _=this.removeViews(h,b);_.length&&this._onViewsDeregistered.fire({views:_,viewContainer:b})}moveViews(h,b){for(const _ of this._views.keys())if(_!==b){const v=this.removeViews(h,_);v.length&&(this.addViews(v,b),this._onDidChangeContainer.fire({views:v,from:_,to:b}))}}getViews(h){return this._views.get(h)||[]}getView(h){for(const b of this._viewContainers){const _=(this._views.get(b)||[]).filter(v=>v.id===h)[0];if(_)return _}return null}getViewContainer(h){for(const b of this._viewContainers)if((this._views.get(b)||[]).filter(v=>v.id===h)[0])return b;return null}registerViewWelcomeContent(h,b){return this._viewWelcomeContents.add(h,b),this._onDidChangeViewWelcomeContent.fire(h),(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(h,b),this._onDidChangeViewWelcomeContent.fire(h)})}registerViewWelcomeContent2(h,b){const _=new Map;for(const[v,E]of b)this._viewWelcomeContents.add(h,E),_.set(v,(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(h,E),this._onDidChangeViewWelcomeContent.fire(h)}));return this._onDidChangeViewWelcomeContent.fire(h),_}getViewWelcomeContent(h){const b=[];return this._viewWelcomeContents.forEach(h,_=>b.push(_)),b.sort(u)}addViews(h,b){let _=this._views.get(b);_||(_=[],this._views.set(b,_),this._viewContainers.push(b));for(const v of h){if(this.getView(v.id)!==null)throw new Error((0,A.localize)(1,null,v.id));_.push(v)}}removeViews(h,b){const _=this._views.get(b);if(!_)return[];const v=[],E=[];for(const F of _)h.includes(F)?v.push(F):E.push(F);return v.length&&(E.length?this._views.set(b,E):(this._views.delete(b),this._viewContainers.splice(this._viewContainers.indexOf(b),1))),v}}S.Registry.add(o.ViewsRegistry,new p),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new I.RawContextKey("focusedView","",(0,A.localize)(2,null));function t(a){return`view.${a}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var n;(function(a){a[a.Default=0]="Default",a[a.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(a){a[a.None=0]="None",a[a.Collapsed=1]="Collapsed",a[a.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(h,b){this.resolved=!1,this._hasResolve=!1,(0,P.mixin)(this,h),this._hasResolve=!!b,this.resolve=async _=>{var v,E;if(b&&!this.resolved){const F=await b(_);F&&(this.tooltip=(v=this.tooltip)!==null&&v!==void 0?v:F.tooltip,this.command=(E=this.command)!==null&&E!==void 0?E:F.command)}_.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r}),define(be[169],_e([0,1,2,149,160,19,150,168]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function S(l){return(g,...m)=>l(g.get(I.ICommandService),...m)}class k{static execute(g,m){const D={forceReuseWindow:m&&m.reuseWindow,remoteAuthority:m&&m.remoteAuthority};return g.executeCommand("_files.newWindow",D)}}e.NewWindowAPICommand=k,k.ID="vscode.newWindow",I.CommandsRegistry.registerCommand({id:k.ID,handler:S(k.execute),description:{description:"Opens an new window",args:[]}}),I.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(l,g){return l.get(A.IWorkspacesService).removeRecentlyOpened([g])});class i{static execute(g,m){return typeof m=="string"?m=m.match(/^[^:/?#]+:\/\//)?w.URI.parse(m):w.URI.file(m):m=w.URI.revive(m),g.executeCommand("_workbench.removeFromRecentlyOpened",m)}}e.RemoveFromRecentlyOpenedAPICommand=i,i.ID="vscode.removeFromRecentlyOpened",I.CommandsRegistry.registerCommand(i.ID,S(i.execute));class P{static execute(g,m){const D=typeof m=="string"?{extensionId:m}:m;return g.executeCommand("workbench.action.openIssueReporter",D)}}e.OpenIssueReporter=P,P.ID="vscode.openIssueReporter",I.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(l,g){const m=l.get(A.IWorkspacesService);let D;const f=g.uri,u=g.label,p=g.remoteAuthority;return g.type==="workspace"?D={workspace:await m.getWorkspaceIdentifier(f),label:u,remoteAuthority:p}:g.type==="folder"?D={folderUri:f,label:u,remoteAuthority:p}:D={fileUri:f,label:u,remoteAuthority:p},m.addRecentlyOpened([D])}),I.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(l){return l.get(A.IWorkspacesService).getRecentlyOpened()}),I.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(l,g){const m=l.get(T.ILogService),D=l.get(y.IEnvironmentService);D.isExtensionDevelopment&&!!D.extensionTestsLocationURI&&m.setLevel(g)}),I.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(l){return l.get(T.ILogService).getLevel()}),I.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(l,g){const m=l.get(C.IViewDescriptorService),D=m.getViewContainerById(g.destinationId);if(!!D){for(const f of g.viewIds){const u=m.getViewDescriptorById(f);(u==null?void 0:u.canMoveView)&&m.moveViewsToContainer([u],D,C.ViewVisibilityState.Default)}await l.get(C.IViewsService).openViewContainer(D.id,!0)}});class c{static execute(g,m){return!Array.isArray(m==null?void 0:m.viewIds)||typeof(m==null?void 0:m.destinationId)!="string"?Promise.reject("Invalid arguments"):g.executeCommand("_workbench.action.moveViews",m)}}e.MoveViewsAPICommand=c,c.ID="vscode.moveViews",I.CommandsRegistry.registerCommand({id:c.ID,handler:S(c.execute),description:{description:"Move Views",args:[]}});class d{static execute(g,m){return g.executeCommand("_workbench.open",m)}}d.ID="vscode.open",I.CommandsRegistry.registerCommand(d.ID,S(d.execute));class o{static execute(g,m,D,f,u){return g.executeCommand("_workbench.diff",[m,D,f])}}o.ID="vscode.diff",I.CommandsRegistry.registerCommand(o.ID,S(o.execute))}),define(be[170],_e([0,1,3,11,140]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new w.Emitter,this._onExit=new w.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,S,k,i){const P={command:C};if(S&&Object.keys(S).length>0&&(P.arguments=S),this.internalSend("request",P),typeof i=="number"){const c=setTimeout(()=>{clearTimeout(c);const d=this.pendingRequests.get(P.seq);if(d){this.pendingRequests.delete(P.seq);const o={type:"response",seq:0,request_seq:P.seq,success:!1,command:C,message:(0,A.localize)(0,null,i,C)};d(o)}},i)}return k&&this.pendingRequests.set(P.seq,k),P.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,S){return C.type!=="event"||S.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,I.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const S=C,k=this.pendingRequests.get(S.request_seq);k&&(this.pendingRequests.delete(S.request_seq),k(S));break}}}internalSend(C,S){S.type=C,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((S,k)=>C.set(k,S)),await(0,I.timeout)(500),C.forEach((S,k)=>{S({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(be[171],_e([0,1,8,2,13,24,18]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function S(n,s,r){return n.replace(C,function(a,h){return s&&h.length>0&&h[0]!=="_"?a:r&&r.hasOwnProperty(h)?r[h]:a})}e.formatPII=S;function k(n){const s={};for(const r of Object.keys(n))r.startsWith("!")||(s[r]=n[r]);return s}e.filterExceptionsFromTelemetry=k;function i(n){return n.configuration.request==="attach"&&!P(n)}e.isSessionAttach=i;function P(n){let s=n.configuration.type;if(!!s)return s==="vslsShare"&&(s=n.configuration.adapterProxy.configuration.type),(0,w.equalsIgnoreCase)(s,"extensionhost")||(0,w.equalsIgnoreCase)(s,"pwa-extensionhost")?n:n.parentSession?P(n.parentSession):void 0}e.getExtensionHostDebugSession=P;function c(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=c;function d(n,s,r){let a,h=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,_=null;for(;_=b.exec(n);){let v=_.index+1,E=v+_[0].length;if(v<=s&&E>=r){a=_[0],h=v;break}}if(a){let v=/\w+/g,E=null;for(;(E=v.exec(a))&&!(E.index+1+h+E[0].length>=r););E&&(a=a.substring(0,v.lastIndex))}return a?{start:h,end:h+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=d;const o=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function l(n){return!!(n&&n.match(o))}e.isUri=l;function g(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(l(n.path))return I.URI.parse(n.path);if((0,A.isAbsolute)(n.path))return I.URI.file(n.path)}return n.path}function m(n){if(typeof n.path=="object"){const s=I.URI.revive(n.path);if(s)return s.scheme===y.Schemas.file?s.fsPath:s.toString()}return n.path}function D(n,s){const r=s?g:m,a=(0,T.deepClone)(n);return u(a,(h,b)=>{h&&b&&(b.path=r(b))}),a}e.convertToDAPaths=D;function f(n,s){const r=s?g:m,a=(0,T.deepClone)(n);return u(a,(h,b)=>{!h&&b&&(b.path=r(b))}),a}e.convertToVSCPaths=f;function u(n,s){switch(n.type){case"event":const r=n;switch(r.event){case"output":s(!1,r.body.source);break;case"loadedSource":s(!1,r.body.source);break;case"breakpoint":s(!1,r.body.breakpoint.source);break;default:break}break;case"request":const a=n;switch(a.command){case"setBreakpoints":s(!0,a.arguments.source);break;case"breakpointLocations":s(!0,a.arguments.source);break;case"source":s(!0,a.arguments.source);break;case"gotoTargets":s(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(b=>s(!1,b));break;default:break}break;case"response":const h=n;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(b=>s(!1,b.source));break;case"loadedSources":h.body.sources.forEach(b=>s(!1,b));break;case"scopes":h.body.scopes.forEach(b=>s(!1,b.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(b=>s(!1,b.source));break;case"setBreakpoints":h.body.breakpoints.forEach(b=>s(!1,b.source));break;default:break}break}}function p(n){return n.filter(s=>{var r;return!((r=s.presentation)===null||r===void 0?void 0:r.hidden)}).sort((s,r)=>s.presentation?r.presentation?s.presentation.group?r.presentation.group?s.presentation.group!==r.presentation.group?s.presentation.group.localeCompare(r.presentation.group):t(s.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(s.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=p;function t(n,s){return typeof n!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:n-s}}),define(be[73],_e([0,1,28,18,13,21,63]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var C;(function(_){_[_.Markdown=1]="Markdown",_[_.Code=2]="Code"})(C=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var S;(function(_){_[_.Running=1]="Running",_[_.Idle=2]="Idle"})(S=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{},trusted:!0};var k;(function(_){_[_.Idle=1]="Idle",_[_.Pending=2]="Pending",_[_.Executing=3]="Executing"})(k=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var i;(function(_){_[_.WithHardKernelDependency=0]="WithHardKernelDependency",_[_.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",_[_.Pure=2]="Pure",_[_.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var P;(function(_){_[_.ModelChange=1]="ModelChange",_[_.Move=2]="Move",_[_.CellClearOutput=3]="CellClearOutput",_[_.CellsClearOutput=4]="CellsClearOutput",_[_.ChangeLanguage=5]="ChangeLanguage",_[_.Initialize=6]="Initialize",_[_.ChangeCellMetadata=7]="ChangeCellMetadata",_[_.Output=8]="Output",_[_.OutputItem=9]="OutputItem",_[_.ChangeCellContent=10]="ChangeCellContent",_[_.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",_[_.Unknown=12]="Unknown"})(P=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(_){_[_.Handle=0]="Handle",_[_.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(_){_[_.Replace=1]="Replace",_[_.Output=2]="Output",_[_.Metadata=3]="Metadata",_[_.CellLanguage=4]="CellLanguage",_[_.DocumentMetadata=5]="DocumentMetadata",_[_.OutputsSplice=6]="OutputsSplice",_[_.Move=7]="Move",_[_.Unknown=8]="Unknown",_[_.CellContent=9]="CellContent",_[_.OutputItems=10]="OutputItems",_[_.PartialMetadata=11]="PartialMetadata"})(d=e.CellEditType||(e.CellEditType={}));function o(_){const v=l.parse(_);return v?v.notebook.toString():_.toString()}e.getCellUndoRedoComparisonKey=o;var l;(function(_){_.scheme=I.Schemas.vscodeNotebookCell;const v=/^ch(\d{7,})/;function E(me,q){return me.with({scheme:_.scheme,fragment:`ch${q.toString().padStart(7,"0")}${me.scheme!==I.Schemas.file?me.scheme:""}`})}_.generate=E;function F(me){if(me.scheme===_.scheme){const q=v.exec(me.fragment);if(!!q)return{handle:Number(q[1]),notebook:me.with({scheme:me.fragment.substr(q[0].length)||I.Schemas.file,fragment:null})}}}_.parse=F;function U(me,q){return me.with({scheme:I.Schemas.vscodeNotebookCellMetadata,fragment:`ch${q.toString().padStart(7,"0")}${me.scheme!==I.Schemas.file?me.scheme:""}`})}_.generateCellMetadataUri=U;function J(me){if(me.scheme===I.Schemas.vscodeNotebookCellMetadata){const q=v.exec(me.fragment);if(!!q)return{handle:Number(q[1]),notebook:me.with({scheme:me.fragment.substr(q[0].length)||I.Schemas.file,fragment:null})}}}_.parseCellMetadataUri=J})(l=e.CellUri||(e.CellUri={}));const g=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function m(_){var v,E;return(E=(v=g.get(_))===null||v===void 0?void 0:v.alwaysSecure)!==null&&E!==void 0?E:!1}e.mimeTypeIsAlwaysSecure=m;function D(_){var v,E;return(E=(v=g.get(_))===null||v===void 0?void 0:v.supportedByCore)!==null&&E!==void 0?E:!1}e.mimeTypeSupportedByCore=D;function f(_){var v,E;return(E=(v=g.get(_))===null||v===void 0?void 0:v.mergeable)!==null&&E!==void 0?E:!1}e.mimeTypeIsMergeable=f;function u(_,v){return T.isWindows&&(_=_.replace(/\//g,"\\"),v=v.replace(/\//g,"\\")),w.match(_,v)}function p(_,v,E){let F=0;for(let U=0;U<v.length;U++){if(u(v[U],_))return F;F++}for(let U=0;U<E.length;U++){if(u(E[U],_))return F;F++}return F}function t(_,v,E){return _.sort((F,U)=>p(F,v,E)-p(U,v,E))}e.sortMimeTypes=t;function n(_,v,E,F=(U,J)=>U===J){const U=[];function J(z,ee,$){if(!(ee===0&&$.length===0)){const R=U[U.length-1];R&&R.start+R.deleteCount===z?(R.deleteCount+=ee,R.toInsert.push(...$)):U.push({start:z,deleteCount:ee,toInsert:$})}}let me=0,q=0;for(;;){if(me===_.length){J(me,0,v.slice(q));break}if(q===v.length){J(me,_.length-me,[]);break}const z=_[me],ee=v[q];if(F(z,ee)){me+=1,q+=1;continue}E(ee)?(J(me,1,[]),me+=1):(J(me,0,[ee]),q+=1)}return U}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(_){_.default="default",_.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(_){const v=_;return!!((typeof v.include=="string"||w.isRelativePattern(v.include))&&(typeof v.exclude=="string"||w.isRelativePattern(v.exclude)))}e.isDocumentExcludePattern=r;function a(_,v,E){if(Array.isArray(_.viewType)&&_.viewType.indexOf(v)>=0||_.viewType===v)return!0;if(_.filenamePattern){let F=r(_.filenamePattern)?_.filenamePattern.include:_.filenamePattern,U=r(_.filenamePattern)?_.filenamePattern.exclude:void 0;if(w.match(F,(0,A.basename)(E.fsPath).toLowerCase()))return!(U&&w.match(U,(0,A.basename)(E.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a;class h{constructor(v){this.textModel=v}getElements(){const v=new Int32Array(this.textModel.cells.length);for(let E=0;E<this.textModel.cells.length;E++)v[E]=this.textModel.cells[E].getHashValue();return v}}e.CellSequence=h,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var b;(function(_){_[_.Left=1]="Left",_[_.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}))}),define(be[172],_e([0,1,142,4,63]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new A.RawContextKey("customExecutionSupported",!0,w.localize(0,null)),e.ShellExecutionSupportedContext=new A.RawContextKey("shellExecutionSupported",!1,w.localize(1,null)),e.ProcessExecutionSupportedContext=new A.RawContextKey("processExecutionSupported",!1,w.localize(2,null)),e.ITaskService=(0,I.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[173],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function w(A){return[...A.entries()]}e.serializeEnvironmentVariableCollection=w;function I(A){return new Map(A)}e.deserializeEnvironmentVariableCollection=I}),define(be[96],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var w;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(w=e.TestItemExpandState||(e.TestItemExpandState={}));const I=(S,k)=>{k.expand!==void 0&&(S.expand=k.expand),k.item!==void 0&&Object.assign(S.item,k.item)};e.applyTestItemUpdate=I;var A;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.Remove=2]="Remove",S[S.DeltaRootsComplete=3]="DeltaRootsComplete",S[S.Retire=4]="Retire"})(A=e.TestDiffOpType||(e.TestDiffOpType={}));const T=(S,k)=>`${S}:${k.toString()}`;e.getTestSubscriptionKey=T;class y{add(k){}update(k){}remove(k,i){}complete(){}}e.IncrementalChangeCollector=y;class C{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(k){const i=this.createChangeCollector();for(const P of k)switch(P[0]){case 0:{const c=P[1];if(c.parent){if(this.items.has(c.parent)){const d=this.items.get(c.parent);d.children.add(c.item.extId);const o=this.createItem(c,d);this.items.set(c.item.extId,o),i.add(o)}}else{this.roots.add(c.item.extId);const d=this.createItem(c);this.items.set(c.item.extId,d),i.add(d)}c.expand===2&&this.updateBusyControllers(1);break}case 1:{const c=P[1],d=this.items.get(c.extId);if(!d)break;(0,e.applyTestItemUpdate)(d,c),i.update(d),c.expand!==void 0&&d.expand===2&&c.expand!==2&&this.updateBusyControllers(-1);break}case 2:{const c=this.items.get(P[1]);if(!c)break;c.parent?this.items.get(c.parent).children.delete(c.item.extId):this.roots.delete(c.item.extId);const d=[[P[1]]];for(;d.length;)for(const o of d.pop()){const l=this.items.get(o);l&&(d.push(l.children),this.items.delete(o),i.remove(l,l!==c),l.expand===2&&this.updateBusyControllers(-1))}break}case 4:this.retireTest(P[1]);break;case 3:this.updatePendingRoots(P[1]);break}i.complete()}retireTest(k){}updateBusyControllers(k){this.busyControllerCount+=k}updatePendingRoots(k){this.pendingRootCount+=k}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=C}),define(be[174],_e([0,1,13,46,10,24,21,58,143]),function(Q,e,w,I,A,T,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(P,c,d,o){if(this._contributedVariables=new Map,this._context=P,this._labelService=c,d)if(y.isWindows){const l=Object.create(null);this._envVariables=l,Object.keys(d).forEach(g=>{l[g.toLowerCase()]=d[g]})}else this._envVariables=d}resolveWithEnvironment(P,c,d){return this.recursiveResolve(P,c?c.uri:void 0,d)}async resolveAsync(P,c){return this.recursiveResolve(this._envVariables,P?P.uri:void 0,c)}resolve(P,c){return this.recursiveResolve(this._envVariables,P?P.uri:void 0,c)}resolveAnyBase(P,c,d,o){const l=T.deepClone(c);return y.isWindows&&l.windows?Object.keys(l.windows).forEach(g=>l[g]=l.windows[g]):y.isMacintosh&&l.osx?Object.keys(l.osx).forEach(g=>l[g]=l.osx[g]):y.isLinux&&l.linux&&Object.keys(l.linux).forEach(g=>l[g]=l.linux[g]),delete l.windows,delete l.osx,delete l.linux,this.recursiveResolve(this._envVariables,P?P.uri:void 0,l,d,o)}resolveAny(P,c,d){return this.resolveAnyBase(P,c,d)}async resolveAnyAsync(P,c,d){return this.resolveAnyBase(P,c,d)}resolveAnyMap(P,c,d){const o=new Map;return{newConfig:this.resolveAnyBase(P,c,d,o),resolvedVariables:o}}resolveWithInteractionReplace(P,c,d,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,c,d,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,c){if(this._contributedVariables.has(P))throw new Error("Variable "+P+" is contributed twice.");this._contributedVariables.set(P,c)}recursiveResolve(P,c,d,o,l){if(A.isString(d))return this.resolveString(P,c,d,o,l);if(A.isArray(d))return d.map(g=>this.recursiveResolve(P,c,g,o,l));if(A.isObject(d)){let g=Object.create(null);return Object.keys(d).forEach(m=>{const D=this.resolveString(P,c,m,o,l);g[D]=this.recursiveResolve(P,c,d[m],o,l)}),g}return d}resolveString(P,c,d,o,l){return d.replace(k.VARIABLE_REGEXP,(m,D)=>{if(D.includes(k.VARIABLE_LHS))return m;let f=this.evaluateSingleVariable(P,m,D,c,o);return l&&l.set(D,f),f})}fsPath(P){return this._labelService?this._labelService.getUriLabel(P,{noPrefix:!0}):P.fsPath}evaluateSingleVariable(P,c,d,o,l){let g;const m=d.split(":");m.length>1&&(d=m[0],g=m[1]);const D=()=>{const p=this._context.getFilePath();if(p)return p;throw new Error((0,S.localize)(0,null,c))},f=()=>{const p=D();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,S.localize)(1,null,c,w.basename(p)))},u=()=>{if(g){const p=this._context.getFolderUri(g);if(p)return p;throw new Error((0,S.localize)(2,null,c,g))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,c)):new Error((0,S.localize)(4,null,c))};switch(d){case"env":if(g){if(P){const p=P[y.isWindows?g.toLowerCase():g];if(A.isString(p))return p}return""}throw new Error((0,S.localize)(5,null,c));case"config":if(g){const p=this._context.getConfigurationValue(o,g);if(A.isUndefinedOrNull(p))throw new Error((0,S.localize)(6,null,c,g));if(A.isObject(p))throw new Error((0,S.localize)(7,null,c,g));return p}throw new Error((0,S.localize)(8,null,c));case"command":return this.resolveFromMap(c,g,l,"command");case"input":return this.resolveFromMap(c,g,l,"input");default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(u()));case"cwd":return o||g?(0,C.normalizeDriveLetter)(this.fsPath(u())):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return w.basename(this.fsPath(u()));case"lineNumber":const p=this._context.getLineNumber();if(p)return p;throw new Error((0,S.localize)(9,null,c));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,S.localize)(10,null,c));case"file":return D();case"fileWorkspaceFolder":return f();case"relativeFile":return o||g?w.relative(this.fsPath(u()),D()):D();case"relativeFileDirname":const n=w.dirname(D());if(o||g){const h=w.relative(this.fsPath(u()),n);return h.length===0?".":h}return n;case"fileDirname":return w.dirname(D());case"fileExtname":return w.extname(D());case"fileBasename":return w.basename(D());case"fileBasenameNoExtension":const s=w.basename(D());return s.slice(0,s.length-w.extname(s).length);case"fileDirnameBasename":return w.basename(w.dirname(D()));case"execPath":const r=this._context.getExecPath();return r||c;case"execInstallFolder":const a=this._context.getAppRoot();return a||c;case"pathSeparator":return w.sep;default:try{const h=g?`${d}:${g}`:d;return this.resolveFromMap(c,h,l,void 0)}catch(h){return c}}}}resolveFromMap(P,c,d,o){if(c&&d){const l=o===void 0?d[c]:d[o+":"+c];if(typeof l=="string")return l;throw new Error((0,S.localize)(11,null,P))}return P}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[175],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,w.createDecorator)("editorGroupsService");var I;(function(c){c[c.UP=0]="UP",c[c.DOWN=1]="DOWN",c[c.LEFT=2]="LEFT",c[c.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var A;(function(c){c[c.HORIZONTAL=0]="HORIZONTAL",c[c.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(c){c[c.FIRST=0]="FIRST",c[c.LAST=1]="LAST",c[c.NEXT=2]="NEXT",c[c.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var y;(function(c){c[c.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",c[c.EVEN=1]="EVEN",c[c.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(c){c[c.COPY_EDITORS=0]="COPY_EDITORS",c[c.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));var S;(function(c){c[c.CREATION_TIME=0]="CREATION_TIME",c[c.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",c[c.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(S=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(c){c[c.GROUP_ACTIVE=0]="GROUP_ACTIVE",c[c.GROUP_INDEX=1]="GROUP_INDEX",c[c.EDITOR_OPEN=2]="EDITOR_OPEN",c[c.EDITOR_CLOSE=3]="EDITOR_CLOSE",c[c.EDITOR_MOVE=4]="EDITOR_MOVE",c[c.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",c[c.EDITOR_LABEL=6]="EDITOR_LABEL",c[c.EDITOR_PIN=7]="EDITOR_PIN",c[c.EDITOR_STICKY=8]="EDITOR_STICKY",c[c.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var i;(function(c){c[c.NEW_EDITOR=1]="NEW_EDITOR",c[c.MOVE_EDITOR=2]="MOVE_EDITOR",c[c.COPY_EDITOR=3]="COPY_EDITOR"})(i=e.OpenEditorContext||(e.OpenEditorContext={}));function P(c){return c.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=P}),define(be[176],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,w.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(be[9],_e([0,1,15,83,230,57,24,10,2,32,62,144,90,73,176,7]),function(Q,e,w,I,A,T,y,C,S,k,i,P,c,d,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var g;(function(we){function de(j){const{selectionStartLineNumber:Re,selectionStartColumn:Pe,positionLineNumber:Qe,positionColumn:Ze}=j,ut=new l.Position(Re-1,Pe-1),ht=new l.Position(Qe-1,Ze-1);return new l.Selection(ut,ht)}we.to=de;function oe(j){const{anchor:Re,active:Pe}=j;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Pe.line+1,positionColumn:Pe.character+1}}we.from=oe})(g=e.Selection||(e.Selection={}));var m;(function(we){function de(j){if(!!j){const{start:Re,end:Pe}=j;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Pe.line+1,endColumn:Pe.character+1}}}we.from=de;function oe(j){if(!!j){const{startLineNumber:Re,startColumn:Pe,endLineNumber:Qe,endColumn:Ze}=j;return new l.Range(Re-1,Pe-1,Qe-1,Ze-1)}}we.to=oe})(m=e.Range||(e.Range={}));var D;(function(we){function de(oe){switch(oe){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 4:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}we.to=de})(D=e.TokenType||(e.TokenType={}));var f;(function(we){function de(j){return new l.Position(j.lineNumber-1,j.column-1)}we.to=de;function oe(j){return{lineNumber:j.line+1,column:j.character+1}}we.from=oe})(f=e.Position||(e.Position={}));var u;(function(we){function de(j){switch(j){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}we.from=de;function oe(j){switch(j){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}we.to=oe})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var p;(function(we){function de(j){let Re;return j.code&&((0,C.isString)(j.code)||(0,C.isNumber)(j.code)?Re=String(j.code):Re={value:String(j.code.value),target:j.code.target}),Object.assign(Object.assign({},m.from(j.range)),{message:j.message,source:j.source,code:Re,severity:n.from(j.severity),relatedInformation:j.relatedInformation&&j.relatedInformation.map(t.from),tags:Array.isArray(j.tags)?(0,w.coalesce)(j.tags.map(u.from)):void 0})}we.from=de;function oe(j){var Re;const Pe=new l.Diagnostic(m.to(j),j.message,n.to(j.severity));return Pe.source=j.source,Pe.code=(0,C.isString)(j.code)?j.code:(Re=j.code)===null||Re===void 0?void 0:Re.value,Pe.relatedInformation=j.relatedInformation&&j.relatedInformation.map(t.to),Pe.tags=j.tags&&(0,w.coalesce)(j.tags.map(u.to)),Pe}we.to=oe})(p=e.Diagnostic||(e.Diagnostic={}));var t;(function(we){function de(j){return Object.assign(Object.assign({},m.from(j.location.range)),{message:j.message,resource:j.location.uri})}we.from=de;function oe(j){return new l.DiagnosticRelatedInformation(new l.Location(j.resource,m.to(j)),j.message)}we.to=oe})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(we){function de(j){switch(j){case l.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}we.from=de;function oe(j){switch(j){case c.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}we.to=oe})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(we){function de(j){return typeof j=="number"&&j>=l.ViewColumn.One?j-1:j===l.ViewColumn.Beside?o.SIDE_GROUP:o.ACTIVE_GROUP}we.from=de;function oe(j){if(typeof j=="number"&&j>=0)return j+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=oe})(s=e.ViewColumn||(e.ViewColumn={}));function r(we){return typeof we.range!="undefined"}function a(we){return we.length===0?!0:!!r(we[0])}e.isDecorationOptionsArr=a;var h;(function(we){function de(Ze){return Ze.map(we.from)}we.fromMany=de;function oe(Ze){return Ze&&typeof Ze=="object"&&typeof Ze.language=="string"&&typeof Ze.value=="string"}function j(Ze){let ut;if(oe(Ze)){const{language:ft,value:at}=Ze;ut={value:"```"+ft+`
`+at+"\n```\n"}}else l.MarkdownString.isMarkdownString(Ze)?ut={value:Ze.value,isTrusted:Ze.isTrusted,supportThemeIcons:Ze.supportThemeIcons}:typeof Ze=="string"?ut={value:Ze}:ut={value:""};const ht=Object.create(null);ut.uris=ht;const Je=ft=>{try{let at=S.URI.parse(ft,!0);at=at.with({query:Re(at.query,ht)}),ht[ft]=at}catch(at){}return""},ot=new A.Renderer;return ot.link=Je,ot.image=ft=>Je(I.parseHrefAndDimensions(ft).href),A(ut.value,{renderer:ot}),ut}we.from=j;function Re(Ze,ut){if(!Ze)return Ze;let ht;try{ht=(0,T.parse)(Ze)}catch(ot){}if(!ht)return Ze;let Je=!1;return ht=(0,y.cloneAndChange)(ht,ot=>{if(S.URI.isUri(ot)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ft]=ot,Je=!0,ft}else return}),Je?JSON.stringify(ht):Ze}function Pe(Ze){const ut=new l.MarkdownString(Ze.value,Ze.supportThemeIcons);return ut.isTrusted=Ze.isTrusted,ut}we.to=Pe;function Qe(Ze){if(!!Ze)return typeof Ze=="string"?Ze:we.from(Ze)}we.fromStrict=Qe})(h=e.MarkdownString||(e.MarkdownString={}));function b(we){return a(we)?we.map(de=>({range:m.from(de.range),hoverMessage:Array.isArray(de.hoverMessage)?h.fromMany(de.hoverMessage):de.hoverMessage?h.from(de.hoverMessage):void 0,renderOptions:de.renderOptions})):we.map(de=>({range:m.from(de)}))}e.fromRangeOrRangeWithMessage=b;function _(we){return typeof we=="undefined"?we:typeof we=="string"?S.URI.file(we):we}e.pathOrURIToURI=_;var v;(function(we){function de(oe){return typeof oe=="undefined"?oe:{contentText:oe.contentText,contentIconPath:oe.contentIconPath?_(oe.contentIconPath):void 0,border:oe.border,borderColor:oe.borderColor,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,color:oe.color,backgroundColor:oe.backgroundColor,margin:oe.margin,width:oe.width,height:oe.height}}we.from=de})(v=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var E;(function(we){function de(oe){return typeof oe=="undefined"?oe:{backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?_(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?v.from(oe.before):void 0,after:oe.after?v.from(oe.after):void 0}}we.from=de})(E=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(we){function de(oe){if(typeof oe=="undefined")return oe;switch(oe){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=de})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var U;(function(we){function de(oe){return{isWholeLine:oe.isWholeLine,rangeBehavior:oe.rangeBehavior?F.from(oe.rangeBehavior):void 0,overviewRulerLane:oe.overviewRulerLane,light:oe.light?E.from(oe.light):void 0,dark:oe.dark?E.from(oe.dark):void 0,backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?_(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?v.from(oe.before):void 0,after:oe.after?v.from(oe.after):void 0}}we.from=de})(U=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var J;(function(we){function de(j){return{text:j.newText,eol:j.newEol&&te.from(j.newEol),range:m.from(j.range)}}we.from=de;function oe(j){const Re=new l.TextEdit(m.to(j.range),j.text);return Re.newEol=typeof j.eol=="undefined"?void 0:te.to(j.eol),Re}we.to=oe})(J=e.TextEdit||(e.TextEdit={}));var me;(function(we){function de(j,Re,Pe){var Qe,Ze,ut;const ht={edits:[]};if(j instanceof l.WorkspaceEdit)for(let Je of j._allEntries())if(Je._type===1)ht.edits.push({_type:1,oldUri:Je.from,newUri:Je.to,options:Je.options,metadata:Je.metadata});else if(Je._type===2){const ot=Re==null?void 0:Re.getDocument(Je.uri);ht.edits.push({_type:2,resource:Je.uri,edit:J.from(Je.edit),modelVersionId:ot==null?void 0:ot.version,metadata:Je.metadata})}else Je._type===3?ht.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:(Qe=Pe==null?void 0:Pe.lookupNotebookDocument(Je.uri))===null||Qe===void 0?void 0:Qe.apiNotebook.version}):Je._type===4?(Je.newOutputs&&ht.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:{editType:2,index:Je.index,append:Je.append,outputs:Je.newOutputs.map(ze.from)}}),Je.newMetadata&&ht.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:{editType:11,index:Je.index,metadata:Je.newMetadata}})):Je._type===5?ht.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,notebookVersionId:(Ze=Pe==null?void 0:Pe.lookupNotebookDocument(Je.uri))===null||Ze===void 0?void 0:Ze.apiNotebook.version,edit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(he.from)}}):Je._type===6&&ht.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:{editType:10,outputId:Je.outputId,items:((ut=Je.newOutputItems)===null||ut===void 0?void 0:ut.map(ye.from))||[],append:Je.append}});return ht}we.from=de;function oe(j){const Re=new l.WorkspaceEdit;for(const Pe of j.edits)Pe.edit?Re.replace(S.URI.revive(Pe.resource),m.to(Pe.edit.range),Pe.edit.text):Re.renameFile(S.URI.revive(Pe.oldUri),S.URI.revive(Pe.newUri),Pe.options);return Re}we.to=oe})(me=e.WorkspaceEdit||(e.WorkspaceEdit={}));var q;(function(we){const de=Object.create(null);de[l.SymbolKind.File]=0,de[l.SymbolKind.Module]=1,de[l.SymbolKind.Namespace]=2,de[l.SymbolKind.Package]=3,de[l.SymbolKind.Class]=4,de[l.SymbolKind.Method]=5,de[l.SymbolKind.Property]=6,de[l.SymbolKind.Field]=7,de[l.SymbolKind.Constructor]=8,de[l.SymbolKind.Enum]=9,de[l.SymbolKind.Interface]=10,de[l.SymbolKind.Function]=11,de[l.SymbolKind.Variable]=12,de[l.SymbolKind.Constant]=13,de[l.SymbolKind.String]=14,de[l.SymbolKind.Number]=15,de[l.SymbolKind.Boolean]=16,de[l.SymbolKind.Array]=17,de[l.SymbolKind.Object]=18,de[l.SymbolKind.Key]=19,de[l.SymbolKind.Null]=20,de[l.SymbolKind.EnumMember]=21,de[l.SymbolKind.Struct]=22,de[l.SymbolKind.Event]=23,de[l.SymbolKind.Operator]=24,de[l.SymbolKind.TypeParameter]=25;function oe(Re){return typeof de[Re]=="number"?de[Re]:6}we.from=oe;function j(Re){for(const Pe in de)if(de[Pe]===Re)return Number(Pe);return l.SymbolKind.Property}we.to=j})(q=e.SymbolKind||(e.SymbolKind={}));var z;(function(we){function de(j){switch(j){case l.SymbolTag.Deprecated:return 1}}we.from=de;function oe(j){switch(j){case 1:return l.SymbolTag.Deprecated}}we.to=oe})(z=e.SymbolTag||(e.SymbolTag={}));var ee;(function(we){function de(j){return{name:j.name,kind:q.from(j.kind),tags:j.tags&&j.tags.map(z.from),containerName:j.containerName,location:O.from(j.location)}}we.from=de;function oe(j){const Re=new l.SymbolInformation(j.name,q.to(j.kind),j.containerName,O.to(j.location));return Re.tags=j.tags&&j.tags.map(z.to),Re}we.to=oe})(ee=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var $;(function(we){function de(j){var Re,Pe;const Qe={name:j.name||"!!MISSING: name!!",detail:j.detail,range:m.from(j.range),selectionRange:m.from(j.selectionRange),kind:q.from(j.kind),tags:(Pe=(Re=j.tags)===null||Re===void 0?void 0:Re.map(z.from))!==null&&Pe!==void 0?Pe:[]};return j.children&&(Qe.children=j.children.map(de)),Qe}we.from=de;function oe(j){const Re=new l.DocumentSymbol(j.name,j.detail,q.to(j.kind),m.to(j.range),m.to(j.selectionRange));return(0,w.isNonEmptyArray)(j.tags)&&(Re.tags=j.tags.map(z.to)),j.children&&(Re.children=j.children.map(oe)),Re}we.to=oe})($=e.DocumentSymbol||(e.DocumentSymbol={}));var R;(function(we){function de(oe){const j=new l.CallHierarchyItem(q.to(oe.kind),oe.name,oe.detail||"",S.URI.revive(oe.uri),m.to(oe.range),m.to(oe.selectionRange));return j._sessionId=oe._sessionId,j._itemId=oe._itemId,j}we.to=de})(R=e.CallHierarchyItem||(e.CallHierarchyItem={}));var M;(function(we){function de(oe){return new l.CallHierarchyIncomingCall(R.to(oe.from),oe.fromRanges.map(j=>m.to(j)))}we.to=de})(M=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var x;(function(we){function de(oe){return new l.CallHierarchyOutgoingCall(R.to(oe.to),oe.fromRanges.map(j=>m.to(j)))}we.to=de})(x=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var O;(function(we){function de(j){return{range:j.range&&m.from(j.range),uri:j.uri}}we.from=de;function oe(j){return new l.Location(S.URI.revive(j.uri),m.to(j.range))}we.to=oe})(O=e.location||(e.location={}));var G;(function(we){function de(j){const Re=j,Pe=j;return{originSelectionRange:Re.originSelectionRange?m.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Pe.uri,range:m.from(Re.targetRange?Re.targetRange:Pe.range),targetSelectionRange:Re.targetSelectionRange?m.from(Re.targetSelectionRange):void 0}}we.from=de;function oe(j){return{targetUri:S.URI.revive(j.uri),targetRange:m.to(j.range),targetSelectionRange:j.targetSelectionRange?m.to(j.targetSelectionRange):void 0,originSelectionRange:j.originSelectionRange?m.to(j.originSelectionRange):void 0}}we.to=oe})(G=e.DefinitionLink||(e.DefinitionLink={}));var Y;(function(we){function de(j){return{range:m.from(j.range),contents:h.fromMany(j.contents)}}we.from=de;function oe(j){return new l.Hover(j.contents.map(h.to),m.to(j.range))}we.to=oe})(Y=e.Hover||(e.Hover={}));var ne;(function(we){function de(j){return{range:m.from(j.range),expression:j.expression}}we.from=de;function oe(j){return new l.EvaluatableExpression(m.to(j.range),j.expression)}we.to=oe})(ne=e.EvaluatableExpression||(e.EvaluatableExpression={}));var pe;(function(we){function de(j){if(j instanceof l.InlineValueText)return{type:"text",range:m.from(j.range),text:j.text};if(j instanceof l.InlineValueVariableLookup)return{type:"variable",range:m.from(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};if(j instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:m.from(j.range),expression:j.expression};throw new Error("Unknown 'InlineValue' type")}we.from=de;function oe(j){switch(j.type){case"text":return{range:m.to(j.range),text:j.text};case"variable":return{range:m.to(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};case"expression":return{range:m.to(j.range),expression:j.expression}}}we.to=oe})(pe=e.InlineValue||(e.InlineValue={}));var Ie;(function(we){function de(j){return{frameId:j.frameId,stoppedLocation:m.from(j.stoppedLocation)}}we.from=de;function oe(j){return new l.InlineValueContext(j.frameId,m.to(j.stoppedLocation))}we.to=oe})(Ie=e.InlineValueContext||(e.InlineValueContext={}));var Oe;(function(we){function de(j){return{range:m.from(j.range),kind:j.kind}}we.from=de;function oe(j){return new l.DocumentHighlight(m.to(j.range),j.kind)}we.to=oe})(Oe=e.DocumentHighlight||(e.DocumentHighlight={}));var Te;(function(we){function de(oe){switch(oe){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}we.to=de})(Te=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ue;(function(we){function de(oe){return{triggerKind:Te.to(oe.triggerKind),triggerCharacter:oe.triggerCharacter}}we.to=de})(Ue=e.CompletionContext||(e.CompletionContext={}));var B;(function(we){function de(j){switch(j){case l.CompletionItemTag.Deprecated:return 1}}we.from=de;function oe(j){switch(j){case 1:return l.CompletionItemTag.Deprecated}}we.to=oe})(B=e.CompletionItemTag||(e.CompletionItemTag={}));var K;(function(we){const de=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function oe(Pe){var Qe;return(Qe=de.get(Pe))!==null&&Qe!==void 0?Qe:9}we.from=oe;const j=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Re(Pe){var Qe;return(Qe=j.get(Pe))!==null&&Qe!==void 0?Qe:l.CompletionItemKind.Property}we.to=Re})(K=e.CompletionItemKind||(e.CompletionItemKind={}));var ie;(function(we){function de(oe,j){var Re;const Pe=new l.CompletionItem(typeof oe.label=="string"?oe.label:oe.label.name);return typeof oe.label!="string"&&(Pe.label2=oe.label),Pe.insertText=oe.insertText,Pe.kind=K.to(oe.kind),Pe.tags=(Re=oe.tags)===null||Re===void 0?void 0:Re.map(B.to),Pe.detail=oe.detail,Pe.documentation=I.isMarkdownString(oe.documentation)?h.to(oe.documentation):oe.documentation,Pe.sortText=oe.sortText,Pe.filterText=oe.filterText,Pe.preselect=oe.preselect,Pe.commitCharacters=oe.commitCharacters,k.Range.isIRange(oe.range)?Pe.range=m.to(oe.range):typeof oe.range=="object"&&(Pe.range={inserting:m.to(oe.range.insert),replacing:m.to(oe.range.replace)}),Pe.keepWhitespace=typeof oe.insertTextRules=="undefined"?!1:Boolean(oe.insertTextRules&1),typeof oe.insertTextRules!="undefined"&&oe.insertTextRules&4?Pe.insertText=new l.SnippetString(oe.insertText):(Pe.insertText=oe.insertText,Pe.textEdit=Pe.range instanceof l.Range?new l.TextEdit(Pe.range,Pe.insertText):void 0),oe.additionalTextEdits&&oe.additionalTextEdits.length>0&&(Pe.additionalTextEdits=oe.additionalTextEdits.map(Qe=>J.to(Qe))),Pe.command=j&&oe.command?j.fromInternal(oe.command):void 0,Pe}we.to=de})(ie=e.CompletionItem||(e.CompletionItem={}));var le;(function(we){function de(j){return{label:j.label,documentation:j.documentation?h.fromStrict(j.documentation):void 0}}we.from=de;function oe(j){return{label:j.label,documentation:I.isMarkdownString(j.documentation)?h.to(j.documentation):j.documentation}}we.to=oe})(le=e.ParameterInformation||(e.ParameterInformation={}));var fe;(function(we){function de(j){return{label:j.label,documentation:j.documentation?h.fromStrict(j.documentation):void 0,parameters:Array.isArray(j.parameters)?j.parameters.map(le.from):[],activeParameter:j.activeParameter}}we.from=de;function oe(j){return{label:j.label,documentation:I.isMarkdownString(j.documentation)?h.to(j.documentation):j.documentation,parameters:Array.isArray(j.parameters)?j.parameters.map(le.to):[],activeParameter:j.activeParameter}}we.to=oe})(fe=e.SignatureInformation||(e.SignatureInformation={}));var Se;(function(we){function de(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(fe.from):[]}}we.from=de;function oe(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(fe.to):[]}}we.to=oe})(Se=e.SignatureHelp||(e.SignatureHelp={}));var Ne;(function(we){function de(j){var Re;return{text:j.text,range:m.from(j.range),kind:ge.from((Re=j.kind)!==null&&Re!==void 0?Re:l.InlineHintKind.Other),description:j.description&&h.fromStrict(j.description),whitespaceBefore:j.whitespaceBefore,whitespaceAfter:j.whitespaceAfter}}we.from=de;function oe(j){const Re=new l.InlineHint(j.text,m.to(j.range),ge.to(j.kind));return Re.whitespaceAfter=j.whitespaceAfter,Re.whitespaceBefore=j.whitespaceBefore,Re.description=I.isMarkdownString(j.description)?h.to(j.description):j.description,Re}we.to=oe})(Ne=e.InlineHint||(e.InlineHint={}));var ge;(function(we){function de(j){return j}we.from=de;function oe(j){return j}we.to=oe})(ge=e.InlineHintKind||(e.InlineHintKind={}));var Ce;(function(we){function de(j){return{range:m.from(j.range),url:j.target,tooltip:j.tooltip}}we.from=de;function oe(j){let Re;if(j.url)try{Re=typeof j.url=="string"?S.URI.parse(j.url,!0):S.URI.revive(j.url)}catch(Pe){}return new l.DocumentLink(m.to(j.range),Re)}we.to=oe})(Ce=e.DocumentLink||(e.DocumentLink={}));var Ae;(function(we){function de(j){const Re=new l.ColorPresentation(j.label);return j.textEdit&&(Re.textEdit=J.to(j.textEdit)),j.additionalTextEdits&&(Re.additionalTextEdits=j.additionalTextEdits.map(Pe=>J.to(Pe))),Re}we.to=de;function oe(j){return{label:j.label,textEdit:j.textEdit?J.from(j.textEdit):void 0,additionalTextEdits:j.additionalTextEdits?j.additionalTextEdits.map(Re=>J.from(Re)):void 0}}we.from=oe})(Ae=e.ColorPresentation||(e.ColorPresentation={}));var We;(function(we){function de(j){return new l.Color(j[0],j[1],j[2],j[3])}we.to=de;function oe(j){return[j.red,j.green,j.blue,j.alpha]}we.from=oe})(We=e.Color||(e.Color={}));var Ee;(function(we){function de(j){return{range:m.from(j.range)}}we.from=de;function oe(j){return new l.SelectionRange(m.to(j.range))}we.to=oe})(Ee=e.SelectionRange||(e.SelectionRange={}));var je;(function(we){function de(oe){switch(oe){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}we.to=de})(je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var H;(function(we){function de(j){switch(j){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}we.from=de;function oe(j){switch(j){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}we.to=oe})(H=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var te;(function(we){function de(j){if(j===l.EndOfLine.CRLF)return 1;if(j===l.EndOfLine.LF)return 0}we.from=de;function oe(j){if(j===1)return l.EndOfLine.CRLF;if(j===0)return l.EndOfLine.LF}we.to=oe})(te=e.EndOfLine||(e.EndOfLine={}));var ve;(function(we){function de(oe){if(typeof oe=="object")return oe.viewId;switch(oe){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=de})(ve=e.ProgressLocation||(e.ProgressLocation={}));var Le;(function(we){function de(oe){const j={start:oe.start+1,end:oe.end+1};return oe.kind&&(j.kind=He.from(oe.kind)),j}we.from=de})(Le=e.FoldingRange||(e.FoldingRange={}));var He;(function(we){function de(oe){if(oe)switch(oe){case l.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}we.from=de})(He=e.FoldingRangeKind||(e.FoldingRangeKind={}));var xe;(function(we){function de(oe){if(oe)return{pinned:typeof oe.preview=="boolean"?!oe.preview:void 0,inactive:oe.background,preserveFocus:oe.preserveFocus,selection:typeof oe.selection=="object"?m.from(oe.selection):void 0,override:typeof oe.override=="boolean"?P.EditorOverride.DISABLED:void 0}}we.from=de})(xe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Xe;(function(we){function de(j){return j instanceof l.RelativePattern||typeof j=="string"?j:oe(j)?new l.RelativePattern(j.base,j.pattern):j}we.from=de;function oe(j){const Re=j;return Re&&typeof Re.base=="string"&&typeof Re.pattern=="string"}})(Xe=e.GlobPattern||(e.GlobPattern={}));var W;(function(we){function de(oe){if(oe){if(Array.isArray(oe))return oe.map(de);if(typeof oe=="string")return oe;{const j=oe;return{language:j.language,scheme:j.scheme,pattern:typeof j.pattern=="undefined"?void 0:Xe.from(j.pattern),exclusive:j.exclusive}}}else return}we.from=de})(W=e.LanguageSelector||(e.LanguageSelector={}));var re;(function(we){function de(j){return{start:j.start,end:j.end}}we.from=de;function oe(j){return new l.NotebookRange(j.start,j.end)}we.to=oe})(re=e.NotebookRange||(e.NotebookRange={}));var ce;(function(we){function de(oe){return new l.NotebookCellMetadata().with(Object.assign(Object.assign({},oe),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}we.to=de})(ce=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var V;(function(we){function de(j){return j}we.from=de;function oe(j){return new l.NotebookDocumentMetadata().with(j)}we.to=oe})(V=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var Z;(function(we){function de(j){return{startTime:j.runStartTime,endTime:j.runEndTime,executionOrder:j.executionOrder,success:j.lastRunSuccess}}we.to=de;function oe(j){return{lastRunSuccess:j.success,runStartTime:j.startTime,runEndTime:j.endTime,executionOrder:j.executionOrder}}we.from=oe})(Z=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var ae;(function(we){function de(j){switch(j){case l.NotebookCellKind.Markdown:return d.CellKind.Markdown;case l.NotebookCellKind.Code:default:return d.CellKind.Code}}we.from=de;function oe(j){switch(j){case d.CellKind.Markdown:return l.NotebookCellKind.Markdown;case d.CellKind.Code:default:return l.NotebookCellKind.Code}}we.to=oe})(ae=e.NotebookCellKind||(e.NotebookCellKind={}));var he;(function(we){function de(j){var Re;return{cellKind:ae.from(j.kind),language:j.language,source:j.source,metadata:Object.assign(Object.assign({},j.metadata),Z.from((Re=j.latestExecutionSummary)!==null&&Re!==void 0?Re:{})),outputs:j.outputs?j.outputs.map(ze.from):[]}}we.from=de;function oe(j){return new l.NotebookCellData(ae.to(j.cellKind),j.source,j.language,j.outputs?j.outputs.map(ze.to):void 0,j.metadata?ce.to(j.metadata):void 0)}we.to=oe})(he=e.NotebookCellData||(e.NotebookCellData={}));var ye;(function(we){function de(j){return{mime:j.mime,value:j.value,metadata:j.metadata}}we.from=de;function oe(j){return new l.NotebookCellOutputItem(j.mime,j.value,j.metadata)}we.to=oe})(ye=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ze;(function(we){function de(j){return{outputId:j.id,outputs:j.outputs.map(ye.from),metadata:j.metadata}}we.from=de;function oe(j){const Re=j.outputs.map(ye.to);return new l.NotebookCellOutput(Re,j.outputId,j.metadata)}we.to=oe})(ze=e.NotebookCellOutput||(e.NotebookCellOutput={}));var $e;(function(we){function de(Pe){if(Pe!=null){if(Pe instanceof l.RelativePattern||typeof Pe=="string")return Pe;if(Re(Pe))return new l.RelativePattern(Pe.base,Pe.pattern);if(j(Pe))return{include:Xe.from(Pe.include)||void 0,exclude:Xe.from(Pe.exclude)||void 0}}}we.from=de;function oe(Pe){return typeof Pe=="string"?Pe:Re(Pe)?{base:Pe.base,pattern:Pe.pattern}:{include:Pe.include,exclude:Pe.exclude}}we.to=oe;function j(Pe){const Qe=Pe,Ze=Xe.from(Qe.include);if(!(Ze&&Ze instanceof l.RelativePattern||typeof Ze=="string"))return!1;const ut=Xe.from(Qe.exclude);return!!(ut&&ut instanceof l.RelativePattern||typeof ut=="string")}function Re(Pe){const Qe=Pe;return Qe&&typeof Qe.base=="string"&&typeof Qe.pattern=="string"}})($e=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Be;(function(we){function de(oe){return{backgroundColor:oe.backgroundColor,borderColor:oe.borderColor,top:oe.top?v.from(oe.top):void 0}}we.from=de})(Be=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ge;(function(we){function de(oe,j,Re){const Pe=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{alignment:oe.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:j.toInternal(Pe,Re),text:oe.text,tooltip:oe.tooltip,accessibilityInformation:oe.accessibilityInformation,priority:oe.priority}}we.from=de})(Ge=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var nt;(function(we){function de(oe){var j,Re;return{transientOutputs:(j=oe==null?void 0:oe.transientOutputs)!==null&&j!==void 0?j:!1,transientCellMetadata:Object.assign(Object.assign({},oe==null?void 0:oe.transientCellMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0}),transientDocumentMetadata:(Re=oe==null?void 0:oe.transientDocumentMetadata)!==null&&Re!==void 0?Re:{}}}we.from=de})(nt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var dt;(function(we){function de(j){var Re;return{uri:j.uri,provides:typeof j.provides=="string"?[j.provides]:(Re=j.provides)!==null&&Re!==void 0?Re:[]}}we.from=de;function oe(j){return{uri:S.URI.revive(j.uri),provides:j.provides}}we.to=oe})(dt=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var it;(function(we){function de(j){return{message:h.fromStrict(j.message)||"",severity:j.severity,expectedOutput:j.expectedOutput,actualOutput:j.actualOutput,location:j.location?O.from(j.location):void 0}}we.from=de;function oe(j){const Re=new l.TestMessage(typeof j.message=="string"?j.message:h.to(j.message));return Re.severity=j.severity,Re.actualOutput=j.actualOutput,Re.expectedOutput=j.expectedOutput,Re}we.to=oe})(it=e.TestMessage||(e.TestMessage={}));var Ye;(function(we){function de(Pe){var Qe,Ze;return{extId:Pe.id,label:Pe.label,uri:Pe.uri,range:m.from(Pe.range),debuggable:(Qe=Pe.debuggable)!==null&&Qe!==void 0?Qe:!1,description:Pe.description,runnable:(Ze=Pe.runnable)!==null&&Ze!==void 0?Ze:!0,error:Pe.error?h.fromStrict(Pe.error):void 0}}we.from=de;function oe(Pe){return{extId:Pe.id,label:Pe.label,uri:Pe.uri,range:m.from(Pe.range),debuggable:!1,description:Pe.description,error:void 0,runnable:!0}}we.fromResultSnapshot=oe;function j(Pe){return{id:Pe.extId,label:Pe.label,uri:S.URI.revive(Pe.uri),range:m.to(Pe.range),addChild:()=>{},dispose:()=>{},status:l.TestItemStatus.Pending,data:void 0,debuggable:Pe.debuggable,description:Pe.description,runnable:Pe.runnable}}we.toPlain=j;function Re(Pe){const Qe=new l.TestItemImpl(Pe.extId,Pe.label,S.URI.revive(Pe.uri),void 0);return Qe.range=m.to(Pe.range),Qe.debuggable=Pe.debuggable,Qe.description=Pe.description,Qe.runnable=Pe.runnable,Qe}we.to=Re})(Ye=e.TestItem||(e.TestItem={}));var mt;(function(we){const de=(j,Re)=>Object.assign(Object.assign({},Ye.toPlain(j.item)),{taskStates:j.tasks.map(Pe=>({state:Pe.state,duration:Pe.duration,messages:Pe.messages.map(it.to)})),children:j.children.map(Pe=>Re.get(Pe)).filter(C.isDefined).map(Pe=>de(Pe,Re))});function oe(j){const Re=[],Pe=new Map;for(const Qe of j.items)Pe.set(Qe.item.extId,Qe),Qe.direct&&Re.push(Qe);return{completedAt:j.completedAt,results:Re.map(Qe=>de(Qe,Pe))}}we.to=oe})(mt=e.TestResults||(e.TestResults={}));var wt;(function(we){function de(oe){switch(oe){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}we.to=de})(wt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(be[177],_e([0,1,2,12,7,9,45]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(k,i,P,c={timeout:1500,errors:3}){this._logService=k,this._documents=i,this._mainThreadBulkEdits=P,this._thresholds=c,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(i,P,c)=>{const o={dispose:this._callbacks.push([i,P,k])};return Array.isArray(c)&&c.push(o),o}}async $participateInSave(k,i){const P=w.URI.revive(k);let c=!1;const d=setTimeout(()=>c=!0,this._thresholds.timeout),o=[];try{for(let l of[...this._callbacks]){if(c)break;const g=this._documents.getDocument(P),m=await this._deliverEventAsyncAndBlameBadListeners(l,{document:g,reason:T.TextDocumentSaveReason.to(i)});o.push(m)}}finally{clearTimeout(d)}return o}_deliverEventAsyncAndBlameBadListeners([k,i,P],c){const d=this._badListeners.get(k);return typeof d=="number"&&d>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,k,i,c).then(()=>!0,o=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(o),!(o instanceof Error)||o.message!=="concurrent_edits"){const l=this._badListeners.get(k);this._badListeners.set(k,l?l+1:1),typeof l=="number"&&l>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,i,P,c){const d=[],o=Date.now(),{document:l,reason:g}=c,{version:m}=l,D=Object.freeze({document:l,reason:g,waitUntil(f){if(Object.isFrozen(d))throw(0,I.illegalState)("waitUntil can not be called async");d.push(Promise.resolve(f))}});try{i.apply(P,[D])}catch(f){return Promise.reject(f)}return Object.freeze(d),new Promise((f,u)=>{const p=setTimeout(()=>u(new Error("timeout")),this._thresholds.timeout);return Promise.all(d).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-o}ms`),clearTimeout(p),f(t)}).catch(t=>{clearTimeout(p),u(t)})}).then(f=>{const u={edits:[]};for(const p of f)if(Array.isArray(p)&&p.every(t=>t instanceof A.TextEdit))for(const{newText:t,newEol:n,range:s}of p)u.edits.push({_type:2,resource:l.uri,edit:{range:s&&T.Range.from(s),text:t,eol:n&&T.EndOfLine.from(n)}});if(u.edits.length!==0)return m===l.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(be[178],_e([0,1,3,11,28,2,9,7]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{constructor(P,c,d,o,l){this._onDidCreate=new w.Emitter,this._onDidChange=new w.Emitter,this._onDidDelete=new w.Emitter,this._config=0,d&&(this._config+=1),o&&(this._config+=2),l&&(this._config+=4);const g=(0,A.parse)(c),m=P(D=>{if(!d)for(let f of D.created){const u=T.URI.revive(f);g(u.fsPath)&&this._onDidCreate.fire(u)}if(!o)for(let f of D.changed){const u=T.URI.revive(f);g(u.fsPath)&&this._onDidChange.fire(u)}if(!l)for(let f of D.deleted){const u=T.URI.revive(f);g(u.fsPath)&&this._onDidDelete.fire(u)}});this._disposable=C.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,m)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(P,c,d){this._logService=c,this._extHostDocumentsAndEditors=d,this._onFileSystemEvent=new w.Emitter,this._onDidRenameFile=new w.Emitter,this._onDidCreateFile=new w.Emitter,this._onDidDeleteFile=new w.Emitter,this._onWillRenameFile=new I.AsyncEmitter,this._onWillCreateFile=new I.AsyncEmitter,this._onWillDeleteFile=new I.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(P,c,d,o){return new S(this._onFileSystemEvent.event,P,c,d,o)}$onFileEvent(P){this._onFileSystemEvent.fire(P)}$onDidRunFileOperation(P,c){switch(P){case 2:this._onDidRenameFile.fire(Object.freeze({files:c.map(d=>({oldUri:T.URI.revive(d.source),newUri:T.URI.revive(d.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:c.map(d=>T.URI.revive(d.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:c.map(d=>T.URI.revive(d.target))}));break;default:}}getOnWillRenameFileEvent(P){return this._createWillExecuteEvent(P,this._onWillRenameFile)}getOnWillCreateFileEvent(P){return this._createWillExecuteEvent(P,this._onWillCreateFile)}getOnWillDeleteFileEvent(P){return this._createWillExecuteEvent(P,this._onWillDeleteFile)}_createWillExecuteEvent(P,c){return(d,o,l)=>{const g=function(D){d.call(o,D)};return g.extension=P,c.event(g,void 0,l)}}async $onWillRunFileOperation(P,c,d,o){switch(P){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:c.map(l=>({oldUri:T.URI.revive(l.source),newUri:T.URI.revive(l.target)}))},d,o);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:c.map(l=>T.URI.revive(l.target))},d,o);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:c.map(l=>T.URI.revive(l.target))},d,o)}}async _fireWillEvent(P,c,d,o){const l=new Set,g=[];if(await P.fireAsync(c,o,async(D,f)=>{var u;const p=Date.now(),t=await Promise.resolve(D);t instanceof C.WorkspaceEdit&&(g.push(t),l.add((u=f.extension.displayName)!==null&&u!==void 0?u:f.extension.identifier.value)),Date.now()-p>d&&this._logService.warn("SLOW file-participant",f.extension.identifier)}),!o.isCancellationRequested&&g.length!==0){const m={edits:[]};for(let D of g){let{edits:f}=y.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);m.edits=m.edits.concat(f)}return{edit:m,extensionNames:Array.from(l)}}}}e.ExtHostFileSystemEventService=k}),define(be[179],_e([0,1,18,24,2,9,7,73]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(c,d,o,l){this.start=c,this.deletedCount=d,this.deletedItems=o,this.items=l}static asApiEvents(c){return c.map(d=>({start:d.start,deletedCount:d.deletedCount,deletedItems:d.deletedItems,items:d.items.map(o=>o.apiCell)}))}}class k{constructor(c,d,o){var l;this._notebook=c,this._extHostDocument=d,this._cellData=o,this.handle=o.handle,this.uri=A.URI.revive(o.uri),this.cellKind=o.cellKind,this._outputs=o.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=(l=o.metadata)!==null&&l!==void 0?l:{},this._metadata=T.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=T.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(c,d){return{EOL:d.eol,lines:d.source,modeId:d.language,uri:d.uri,isDirty:!1,versionId:1,notebook:c}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._cell){const c=this,d=this._extHostDocument.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return c._notebook.getCellIndex(c)},notebook:c._notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:d.document,get outputs(){return c._outputs.slice(0)},get metadata(){return c._metadata},get latestExecutionSummary(){return c._previousResult}})}return this._cell}setOutputs(c){this._outputs=c.map(T.NotebookCellOutput.to)}setOutputItems(c,d,o){const l=o.map(T.NotebookCellOutputItem.to),g=this._outputs.find(m=>m.id===c);g&&(d||(g.outputs.length=0),g.outputs.push(...l))}setMetadata(c){this._internalMetadata=c,this._metadata=T.NotebookCellMetadata.to(c),this._previousResult=T.NotebookCellPreviousExecutionResult.to(c)}}e.ExtHostCell=k;class i{constructor(c,d,o,l,g,m,D){this._proxy=c,this._textDocumentsAndEditors=d,this._textDocuments=o,this._emitter=l,this._viewType=g,this._metadata=m,this.uri=D,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const c=this;this._notebook={get uri(){return c.uri},get version(){return c._versionId},get viewType(){return c._viewType},get isDirty(){return c._isDirty},get isUntitled(){return c.uri.scheme===w.Schemas.untitled},get isClosed(){return c._disposed},get metadata(){return c._metadata},get cellCount(){return c._cells.length},cellAt(d){return d=c._validateIndex(d),c._cells[d].apiCell},getCells(d){return(d?c._getCells(d):c._cells).map(l=>l.apiCell)},save(){return c._save()}}}return this._notebook}updateBackup(c){var d;(d=this._backup)===null||d===void 0||d.delete(),this._backup=c}disposeBackup(){var c;(c=this._backup)===null||c===void 0||c.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(c){c.metadata&&(this._metadata=this._metadata.with(c.metadata))}acceptModelChanged(c,d){this._versionId=c.versionId,this._isDirty=d;for(const o of c.rawEvents)o.kind===C.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(o.changes,!0),o.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1):o.kind===C.NotebookCellsChangeType.Move?this._moveCell(o.index,o.newIdx):o.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(o.index,o.outputs):o.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems):o.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(o.index,o.language):o.kind===C.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(o.index,o.metadata)}_validateIndex(c){return c<0?0:c>=this._cells.length?this._cells.length-1:c}_validateRange(c){return c.start<0&&(c=c.with({start:0})),c.end>this._cells.length&&(c=c.with({end:this._cells.length})),c}_getCells(c){c=this._validateRange(c);const d=[];for(let o=c.start;o<c.end;o++)d.push(this._cells[o]);return d}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(c,d){if(!this._disposed){const o=[],l=[],g=[];c.reverse().forEach(m=>{const f=m[2].map(t=>{const n=new k(this,this._textDocumentsAndEditors,t);return d||l.push(k.asModelAddData(this.apiNotebook,t)),n}),u=new S(m[0],m[1],[],f),p=this._cells.splice(m[0],m[1],...f);for(let t of p)g.push(t.uri),u.deletedItems.push(t.apiCell);o.push(u)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:g}),d||this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(o)}))}}_moveCell(c,d){const o=this._cells.splice(c,1);this._cells.splice(d,0,...o);const l=[new S(c,1,o.map(g=>g.apiCell),[]),new S(d,0,[],o)];this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(l)}))}_setCellOutputs(c,d){const o=this._cells[c];o.setOutputs(d),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[o.apiCell]}))}_setCellOutputItems(c,d,o,l){const g=this._cells[c];g.setOutputItems(d,o,l),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[g.apiCell]}))}_changeCellLanguage(c,d){const o=this._cells[c];o.apiCell.document.languageId!==d&&this._textDocuments.$acceptModelModeChanged(o.uri,d)}_changeCellMetadata(c,d){var o;const l=this._cells[c],g=l.internalMetadata,m=l.apiCell.metadata;l.setMetadata(d);const D=l.apiCell.metadata;if((0,I.equals)(m,D)||this._emitter.emitCellMetadataChange((0,I.deepFreeze)({document:this.apiNotebook,cell:l.apiCell})),g.runState!==d.runState){const f=(o=d.runState)!==null&&o!==void 0?o:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,I.deepFreeze)({document:this.apiNotebook,cell:l.apiCell,executionState:f}))}}getCellFromIndex(c){return this._cells[c]}getCell(c){return this._cells.find(d=>d.handle===c)}getCellIndex(c){return this._cells.indexOf(c)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(be[180],_e([0,1,7,9]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,S){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:C,metadata:S})}replaceCells(C,S,k){this._throwIfFinalized(),!(C===S&&k.length===0)&&this._collectedEdits.push({editType:1,index:C,count:S-C,cells:k.map(I.NotebookCellData.from)})}}class T{constructor(C,S,k,i,P,c){this.id=C,this._proxy=S,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=P,this._visibleRanges=i,this._viewColumn=c}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},get visibleRanges(){return C._visibleRanges},revealRange(S,k){C._proxy.$tryRevealRange(C.id,I.NotebookRange.from(S),k!=null?k:w.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(S){const k=new A(this.document.version);return S(k),C._applyEdit(k.finalize())},setDecorations(S,k){return C.setDecorations(S,k)}}}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const S=[];let k=-1;for(let i=0;i<C.cellEdits.length;i++){if(k<0){S.push(C.cellEdits[i]),k++;continue}const c=S[k],d=C.cellEdits[i];if(c.editType===1&&d.editType===1&&c.index===d.index){c.cells.push(...C.cellEdits[i].cells),c.count+=C.cellEdits[i].count;continue}S.push(C.cellEdits[i]),k++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,S)}setDecorations(C,S){if(!(S.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return S.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,I.NotebookRange.from(S),C.key)}}e.ExtHostNotebookEditor=T}),define(be[181],_e([0,1,9,154,134,20,52]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(P){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=P}withProgress(P,c,d){const o=this._handles++,{title:l,location:g,cancellable:m}=c,D={label:(0,A.localize)(0,null,P.displayName||P.name),id:P.identifier.value};return this._proxy.$startProgress(o,{location:w.ProgressLocation.from(g),title:l,source:D,cancellable:m},P),this._withProgress(o,d,!!m)}_withProgress(P,c,d){let o;d&&(o=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(P,o));const l=m=>{this._proxy.$progressEnd(m),this._mapHandleToCancellationSource.delete(m),o&&o.dispose()};let g;try{g=c(new k(this._proxy,P),d&&o?o.token:T.CancellationToken.None)}catch(m){throw l(P),m}return g.then(m=>l(P),m=>l(P)),g}$acceptProgressCanceled(P){const c=this._mapHandleToCancellationSource.get(P);c&&(c.cancel(),this._mapHandleToCancellationSource.delete(P))}}e.ExtHostProgress=C;function S(i,P){return i.message=P.message,typeof P.increment=="number"&&(typeof i.increment=="number"?i.increment+=P.increment:i.increment=P.increment),i}class k extends I.Progress{constructor(P,c){super(d=>this.throttledReport(d));this._proxy=P,this._handle=c}throttledReport(P){this._proxy.$progressReport(this._handle,P)}}Ve([(0,y.throttle)(100,(i,P)=>S(i,P),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(be[97],_e([0,1,42,12,54,9,7]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(c,d){const o=C._Keys.nextId();c.$registerTextEditorDecorationType(o,T.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:o,dispose(){c.$removeTextEditorDecorationType(o)}})}}e.TextEditorDecorationType=C,C._Keys=new A.IdGenerator("TextEditorDecorationType");class S{constructor(c,d){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=d.undoStopBefore,this._undoStopAfter=d.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,d){this._throwIfFinalized();let o=null;if(c instanceof y.Position)o=new y.Range(c,c);else if(c instanceof y.Range)o=c;else throw new Error("Unrecognized location");this._pushEdit(o,d,!1)}insert(c,d){this._throwIfFinalized(),this._pushEdit(new y.Range(c,c),d,!0)}delete(c){this._throwIfFinalized();let d=null;if(c instanceof y.Range)d=c;else throw new Error("Unrecognized location");this._pushEdit(d,null,!0)}_pushEdit(c,d,o){const l=this._document.validateRange(c);this._collectedEdits.push({range:l,text:d,forceMoveMarkers:o})}setEndOfLine(c){if(this._throwIfFinalized(),c!==y.EndOfLine.LF&&c!==y.EndOfLine.CRLF)throw(0,I.illegalArgument)("endOfLine");this._setEndOfLine=c}}e.TextEditorEdit=S;class k{constructor(c,d,o,l){this._proxy=c,this._id=d,this._accept(o),this._logService=l;const g=this;this.value={get tabSize(){return g._tabSize},set tabSize(m){g._setTabSize(m)},get insertSpaces(){return g._insertSpaces},set insertSpaces(m){g._setInsertSpaces(m)},get cursorStyle(){return g._cursorStyle},set cursorStyle(m){g._setCursorStyle(m)},get lineNumbers(){return g._lineNumbers},set lineNumbers(m){g._setLineNumbers(m)}}}_accept(c){this._tabSize=c.tabSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const d=Math.floor(c);return d>0?d:null}if(typeof c=="string"){const d=parseInt(c,10);return isNaN(d)?null:d>0?d:null}return null}_setTabSize(c){const d=this._validateTabSize(c);if(d!==null){if(typeof d=="number"){if(this._tabSize===d)return;this._tabSize=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:d}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:Boolean(c)}_setInsertSpaces(c){const d=this._validateInsertSpaces(c);if(typeof d=="boolean"){if(this._insertSpaces===d)return;this._insertSpaces=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:d}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(c)})))}assign(c){const d={};let o=!1;if(typeof c.tabSize!="undefined"){const l=this._validateTabSize(c.tabSize);l==="auto"?(o=!0,d.tabSize=l):typeof l=="number"&&this._tabSize!==l&&(this._tabSize=l,o=!0,d.tabSize=l)}if(typeof c.insertSpaces!="undefined"){const l=this._validateInsertSpaces(c.insertSpaces);l==="auto"?(o=!0,d.insertSpaces=l):this._insertSpaces!==l&&(this._insertSpaces=l,o=!0,d.insertSpaces=l)}typeof c.cursorStyle!="undefined"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,o=!0,d.cursorStyle=c.cursorStyle),typeof c.lineNumbers!="undefined"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,o=!0,d.lineNumbers=T.TextEditorLineNumbersStyle.from(c.lineNumbers)),o&&this._warnOnError(this._proxy.$trySetOptions(this._id,d))}_warnOnError(c){c.catch(d=>this._logService.warn(d))}}e.ExtHostTextEditorOptions=k;class i{constructor(c,d,o,l,g,m,D,f){this.id=c,this._proxy=d,this._logService=o,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=g,this._options=new k(this._proxy,this.id,m,o),this._visibleRanges=D,this._viewColumn=f;const u=this;this.value=Object.freeze({get document(){return l.getValue()},set document(p){throw(0,I.readonly)("document")},get selection(){return u._selections&&u._selections[0]},set selection(p){if(!(p instanceof y.Selection))throw(0,I.illegalArgument)("selection");u._selections=[p],u._trySetSelection()},get selections(){return u._selections},set selections(p){if(!Array.isArray(p)||p.some(t=>!(t instanceof y.Selection)))throw(0,I.illegalArgument)("selections");u._selections=p,u._trySetSelection()},get visibleRanges(){return u._visibleRanges},set visibleRanges(p){throw(0,I.readonly)("visibleRanges")},get options(){return u._options.value},set options(p){u._disposed||u._options.assign(p)},get viewColumn(){return u._viewColumn},set viewColumn(p){throw(0,I.readonly)("viewColumn")},edit(p,t={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new S(l.getValue(),t);return p(n),u._applyEdit(n)},insertSnippet(p,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=u._selections.map(r=>T.Range.from(r));else if(t instanceof y.Position){const{lineNumber:r,column:a}=T.Position.from(t);s=[{startLineNumber:r,startColumn:a,endLineNumber:r,endColumn:a}]}else if(t instanceof y.Range)s=[T.Range.from(t)];else{s=[];for(const r of t)if(r instanceof y.Range)s.push(T.Range.from(r));else{const{lineNumber:a,column:h}=T.Position.from(r);s.push({startLineNumber:a,startColumn:h,endLineNumber:a,endColumn:h})}}return d.$tryInsertSnippet(c,p.value,s,n)},setDecorations(p,t){const n=t.length===0;n&&!u._hasDecorationsForKey.has(p.key)||(n?u._hasDecorationsForKey.delete(p.key):u._hasDecorationsForKey.add(p.key),u._runOnProxy(()=>{if(T.isDecorationOptionsArr(t))return d.$trySetDecorations(c,p.key,T.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let r=0,a=t.length;r<a;r++){const h=t[r];s[4*r]=h.start.line+1,s[4*r+1]=h.start.character+1,s[4*r+2]=h.end.line+1,s[4*r+3]=h.end.character+1}return d.$trySetDecorationsFast(c,p.key,s)}}))},revealRange(p,t){u._runOnProxy(()=>d.$tryRevealRange(c,T.Range.from(p),t||y.TextEditorRevealType.Default))},show(p){d.$tryShowEditor(c,T.ViewColumn.from(p))},hide(){d.$tryHideEditor(c)}})}dispose(){(0,w.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,w.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,w.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,w.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,w.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const d=c.finalize();if(d.edits.length===0&&!d.setEndOfLine)return Promise.resolve(!0);const o=d.edits.map(g=>g.range);o.sort((g,m)=>g.end.line===m.end.line?g.end.character===m.end.character?g.start.line===m.start.line?g.start.character-m.start.character:g.start.line-m.start.line:g.end.character-m.end.character:g.end.line-m.end.line);for(let g=0,m=o.length-1;g<m;g++){const D=o[g].end;if(o[g+1].start.isBefore(D))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=d.edits.map(g=>({range:T.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,d.documentVersionId,l,{setEndOfLine:typeof d.setEndOfLine=="number"?T.EndOfLine.from(d.setEndOfLine):void 0,undoStopBefore:d.undoStopBefore,undoStopAfter:d.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,d=>(d instanceof Error&&d.name==="DISPOSED"||this._logService.warn(d),null))}}e.ExtHostTextEditor=i}),define(be[182],_e([0,1,137,25,2,3,6,11,7,10,15,9,20]),function(Q,e,w,I,A,T,y,C,S,k,i,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(g,m){if((0,k.isString)(g))return{label:g};if(g&&typeof g=="object"&&typeof g.label=="string"){let D;return Array.isArray(g.highlights)&&(D=g.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),D=D.length?D:void 0),{label:g.label,highlights:D}}}class o{constructor(m,D,f){this._proxy=m,this.commands=D,this.logService=f,this.treeViews=new Map;function u(p){return p&&p.$treeViewId&&p.$treeItemHandle}D.registerArgumentProcessor({processArgument:p=>u(p)?this.convertArgument(p):Array.isArray(p)&&p.length>0?p.map(t=>u(t)?this.convertArgument(t):t):p})}registerTreeDataProvider(m,D,f){const u=this.createTreeView(m,{treeDataProvider:D},f);return{dispose:()=>u.dispose()}}createTreeView(m,D,f){if(!D||!D.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=this._proxy.$registerTreeViewDataProvider(m,{showCollapseAll:!!D.showCollapseAll,canSelectMany:!!D.canSelectMany}),p=this.createExtHostTreeView(m,D,f);return{get onDidCollapseElement(){return p.onDidCollapseElement},get onDidExpandElement(){return p.onDidExpandElement},get selection(){return p.selectedElements},get onDidChangeSelection(){return p.onDidChangeSelection},get visible(){return p.visible},get onDidChangeVisibility(){return p.onDidChangeVisibility},get message(){return p.message},set message(t){p.message=t},get title(){return p.title},set title(t){p.title=t},get description(){return p.description},set description(t){p.description=t},reveal:(t,n)=>p.reveal(t,n),dispose:async()=>{await u,this.treeViews.delete(m),p.dispose()}}}$getChildren(m,D){const f=this.treeViews.get(m);return f?f.getChildren(D):Promise.reject(new Error((0,w.localize)(0,null,m)))}async $hasResolve(m){const D=this.treeViews.get(m);if(!D)throw new Error((0,w.localize)(1,null,m));return D.hasResolve}$resolve(m,D,f){const u=this.treeViews.get(m);if(!u)throw new Error((0,w.localize)(2,null,m));return u.resolveTreeItem(D,f)}$setExpanded(m,D,f){const u=this.treeViews.get(m);if(!u)throw new Error((0,w.localize)(3,null,m));u.setExpanded(D,f)}$setSelection(m,D){const f=this.treeViews.get(m);if(!f)throw new Error((0,w.localize)(4,null,m));f.setSelection(D)}$setVisible(m,D){const f=this.treeViews.get(m);if(!f)throw new Error((0,w.localize)(5,null,m));f.setVisible(D)}createExtHostTreeView(m,D,f){const u=new l(m,D,this._proxy,this.commands.converter,this.logService,f);return this.treeViews.set(m,u),u}convertArgument(m){const D=this.treeViews.get(m.$treeViewId);return D?D.getExtensionElement(m.$treeItemHandle):null}}e.ExtHostTreeViews=o;class l extends y.Disposable{constructor(m,D,f,u,p,t){super();if(this.viewId=m,this.proxy=f,this.commands=u,this.logService=p,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new c.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const a of t.contributes.views[r])a.id===m&&(this._title=a.name);this.dataProvider=D.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let n,s;this._register(T.Event.debounce(this._onDidChangeData.event,(r,a)=>(r||(r={message:!1,elements:[]}),a.element!==!1&&(n||(n=new Promise(h=>s=h),this.refreshPromise=this.refreshPromise.then(()=>n)),r.elements.push(a.element)),a.message&&(r.message=!0),r),200,!0)(({message:r,elements:a})=>{a.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=s;return n=null,this.refresh(a).then(()=>h())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(m=>this.getExtensionElement(m)).filter(m=>!(0,k.isUndefinedOrNull)(m))}getChildren(m){const D=m?this.getExtensionElement(m):void 0;if(m&&!D)return this.logService.error(`No tree item with id '${m}' found.`),Promise.resolve([]);const f=this.getChildrenNodes(m);return(f?Promise.resolve(f):this.fetchChildrenNodes(D)).then(u=>u.map(p=>p.item))}getExtensionElement(m){return this.elements.get(m)}reveal(m,D){D=D||{select:!0,focus:!1};const f=(0,k.isUndefinedOrNull)(D.select)?!0:D.select,u=(0,k.isUndefinedOrNull)(D.focus)?!1:D.focus,p=(0,k.isUndefinedOrNull)(D.expand)?!1:D.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):m?this.refreshPromise.then(()=>this.resolveUnknownParentChain(m)).then(t=>this.resolveTreeNode(m,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(s=>s.item)},{select:f,focus:u,expand:p})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:f,focus:u,expand:p})}get message(){return this._message}set message(m){this._message=m,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(m){this._title=m,this.proxy.$setTitle(this.viewId,m,this._description)}get description(){return this._description}set description(m){this._description=m,this.proxy.$setTitle(this.viewId,this._title,m)}setExpanded(m,D){const f=this.getExtensionElement(m);f&&(D?this._onDidExpandElement.fire(Object.freeze({element:f})):this._onDidCollapseElement.fire(Object.freeze({element:f})))}setSelection(m){(0,i.equals)(this._selectedHandles,m)||(this._selectedHandles=m,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(m){m!==this._visible&&(this._visible=m,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(m,D){var f;if(!!this.dataProvider.resolveTreeItem){const u=this.elements.get(m);if(u){const p=this.nodes.get(u);if(p){const t=(f=await this.dataProvider.resolveTreeItem(p.extensionItem,u,D))!==null&&f!==void 0?f:p.extensionItem;return p.item.tooltip=this.getTooltip(t.tooltip),p.item.command=this.getCommand(p.disposableStore,t.command),p.item}}}}resolveUnknownParentChain(m){return this.resolveParent(m).then(D=>D?this.resolveUnknownParentChain(D).then(f=>this.resolveTreeNode(D,f[f.length-1]).then(u=>(f.push(u),f))):Promise.resolve([]))}resolveParent(m){const D=this.nodes.get(m);return D?Promise.resolve(D.parent?this.elements.get(D.parent.item.handle):void 0):(0,C.asPromise)(()=>this.dataProvider.getParent(m))}resolveTreeNode(m,D){const f=this.nodes.get(m);return f?Promise.resolve(f):(0,C.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(u=>this.createHandle(m,u,D,!0)).then(u=>this.getChildren(D?D.item.handle:void 0).then(()=>{const p=this.getExtensionElement(u);if(p){const t=this.nodes.get(p);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(m){if(m){let D;if(typeof m=="string"){const f=this.getExtensionElement(m);D=f?this.nodes.get(f):void 0}else D=m;return D&&D.children||null}return this.roots}async fetchChildrenNodes(m){this.clearChildren(m);const D=new c.CancellationTokenSource(this._refreshCancellationSource.token);try{const f=m?this.nodes.get(m):void 0,u=await this.dataProvider.getChildren(m);if(D.token.isCancellationRequested)return[];const p=await Promise.all((0,i.coalesce)(u||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!D.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,f):null}));return D.token.isCancellationRequested?[]:(0,i.coalesce)(p)}finally{D.dispose()}}refresh(m){if(m.some(f=>!f))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new c.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const f=this.getHandlesToRefresh(m);if(f.length)return this.refreshHandles(f)}return Promise.resolve(void 0)}getHandlesToRefresh(m){const D=new Set,f=m.map(p=>this.nodes.get(p));for(const p of f)if(p&&!D.has(p.item.handle)){let t=p;for(;t&&t.parent&&f.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&D.add(p.item.handle)}const u=[];return D.forEach(p=>{const t=this.elements.get(p);if(t){const n=this.nodes.get(t);n&&(!n.parent||!D.has(n.parent.item.handle))&&u.push(p)}}),u}refreshHandles(m){const D={};return Promise.all(m.map(f=>this.refreshNode(f).then(u=>{u&&(D[f]=u.item)}))).then(()=>Object.keys(D).length?this.proxy.$refresh(this.viewId,D):void 0)}refreshNode(m){const D=this.getExtensionElement(m);if(D){const f=this.nodes.get(D);if(f)return this.clearChildren(D),(0,C.asPromise)(()=>this.dataProvider.getTreeItem(D)).then(u=>{if(u){const p=this.createTreeNode(D,u,f.parent);return this.updateNodeCache(D,p,f,f.parent),f.dispose(),p}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(m,D,f){const u=this.createTreeNode(m,D,f);if(D.id&&this.elements.has(u.item.handle))throw new Error((0,w.localize)(6,null,D.id));return this.addNodeToCache(m,u),this.addNodeToParentCache(u,f),u}getTooltip(m){return S.MarkdownString.isMarkdownString(m)?P.MarkdownString.from(m):m}getCommand(m,D){return D?this.commands.toInternal(D,m):void 0}createTreeNode(m,D,f){const u=new y.DisposableStore,p=this.createHandle(m,D,f),t=this.getLightIconPath(D);return{item:{handle:p,parentHandle:f?f.item.handle:void 0,label:d(D.label,this.extension),description:D.description,resourceUri:D.resourceUri,tooltip:this.getTooltip(D.tooltip),command:this.getCommand(u,D.command),contextValue:D.contextValue,icon:t,iconDark:this.getDarkIconPath(D)||t,themeIcon:this.getThemeIcon(D),collapsibleState:(0,k.isUndefinedOrNull)(D.collapsibleState)?S.TreeItemCollapsibleState.None:D.collapsibleState,accessibilityInformation:D.accessibilityInformation},extensionItem:D,parent:f,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(m){return m.iconPath instanceof S.ThemeIcon?m.iconPath:void 0}createHandle(m,{id:D,label:f,resourceUri:u},p,t){if(D)return`${l.ID_HANDLE_PREFIX}/${D}`;const n=d(f,this.extension),s=p?p.item.handle:l.LABEL_HANDLE_PREFIX;let r=n?n.label:u?(0,I.basename)(u):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const a=this.nodes.has(m)?this.nodes.get(m).item.handle:void 0,h=this.getChildrenNodes(p)||[];let b,_=0;do{if(b=`${s}/${_}:${r}`,t||!this.elements.has(b)||a===b)break;_++}while(_<=h.length);return b}getLightIconPath(m){if(m.iconPath&&!(m.iconPath instanceof S.ThemeIcon))return typeof m.iconPath=="string"||A.URI.isUri(m.iconPath)?this.getIconPath(m.iconPath):this.getIconPath(m.iconPath.light)}getDarkIconPath(m){if(m.iconPath&&!(m.iconPath instanceof S.ThemeIcon)&&m.iconPath.dark)return this.getIconPath(m.iconPath.dark)}getIconPath(m){return A.URI.isUri(m)?m:A.URI.file(m)}addNodeToCache(m,D){this.elements.set(D.item.handle,m),this.nodes.set(m,D)}updateNodeCache(m,D,f,u){this.elements.delete(D.item.handle),this.nodes.delete(m),D.item.handle!==f.item.handle&&this.elements.delete(f.item.handle),this.addNodeToCache(m,D);const p=this.getChildrenNodes(u)||[],t=p.filter(n=>n.item.handle===f.item.handle)[0];t&&p.splice(p.indexOf(t),1,D)}addNodeToParentCache(m,D){D?(D.children||(D.children=[]),D.children.push(m)):(this.roots||(this.roots=[]),this.roots.push(m))}clearChildren(m){if(m){const D=this.nodes.get(m);if(D){if(D.children)for(const f of D.children){const u=this.elements.get(f.item.handle);u&&this.clear(u)}D.children=void 0}}else this.clearAll()}clear(m){const D=this.nodes.get(m);if(D){if(D.children)for(const f of D.children){const u=this.elements.get(f.item.handle);u&&this.clear(u)}this.nodes.delete(m),this.elements.delete(D.item.handle),D.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(m=>m.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}l.LABEL_HANDLE_PREFIX="0",l.ID_HANDLE_PREFIX="1"}),define(be[183],_e([0,1,15,11,20,10,69,9,7,96]),function(Q,e,w,I,A,T,y,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class i{constructor(){this.testIdsToInternal=new Map}getTestById(g,m){if(m!==void 0){const D=this.testIdsToInternal.get(m),f=D==null?void 0:D.get(g);if(f)return[D,f]}return(0,w.mapFind)(this.testIdsToInternal.values(),D=>{const f=D.get(g);return f&&[D,f]})}createForHierarchy(g=()=>{}){return new o(this.createIdMap(c++),g)}createIdMap(g){const m=new d(g);return this.testIdsToInternal.set(m.id,m),{object:m,dispose:()=>this.testIdsToInternal.delete(m.id)}}}e.OwnedTestCollection=i;var P;(function(l){l[l.Disconnected=0]="Disconnected",l[l.IsChild=1]="IsChild",l[l.IsParent=2]="IsParent",l[l.IsSame=3]="IsSame"})(P=e.TestPosition||(e.TestPosition={}));let c=0;class d{constructor(g){this.id=g,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(g){if(this.map.has(g.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${g.item.extId}`);this.map.set(g.item.extId,g),g.parent||this._roots.add(g)}has(g){return this.map.has(g)}delete(g){const m=this.map.get(g);return m?(this.map.delete(g),this._roots.delete(m),!0):!1}get(g){return this.map.get(g)}comparePositions(g,m){const D=typeof g=="string"?this.map.get(g):g,f=typeof m=="string"?this.map.get(m):m;if(!D||!f)return 0;if(D===f)return 3;for(let u=this.map.get(f.parent);u;u=this.map.get(u.parent))if(u===D)return 1;for(let u=this.map.get(D.parent);u;u=this.map.get(u.parent))if(u===f)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=d;class o{constructor(g,m){this.testIdToInternal=g,this.publishDiff=m,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new I.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(g,m){this.addItem(g,m,null)}getTestByReference(g){return this.testItemToInternal.get(g)}collectDiff(){const g=this.diff;return this.diff=[],g}pushDiff(g){const m=this.diff[this.diff.length-1];if(m&&g[0]===1){if(m[0]===1&&m[1].extId===g[1].extId){(0,k.applyTestItemUpdate)(m[1],g[1]);return}if(m[0]===0&&m[1].item.extId===g[1].extId){(0,k.applyTestItemUpdate)(m[1],g[1]);return}}this.diff.push(g),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(g,m){var D;const f=this.testIdToInternal.object.get(g);if(!!f){if((f.expandLevels===void 0||m>f.expandLevels)&&(f.expandLevels=m),f.expand===1){const u=this.refreshChildren(f);return u.isSettled?this.expandChildren(f,m-1):u.p.then(()=>this.expandChildren(f,m-1))}else if(f.expand===3)return((D=f.initialExpand)===null||D===void 0?void 0:D.isSettled)===!1?f.initialExpand.p.then(()=>this.expandChildren(f,m-1)):this.expandChildren(f,m-1)}}dispose(){var g;for(const m of this.testItemToInternal.values())(g=m.discoverCts)===null||g===void 0||g.dispose(!0),(0,y.getPrivateApiFor)(m.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(g,m){const D=g==null?void 0:g.actual.id;switch(m[0]){case 2:this.pushDiff([4,D]);break;case 1:this.removeItem(g);break;case 0:this.addItem(m[1],g.src.controller,g);break;case 3:const[f,u,p]=m;switch(u){case"status":this.updateExpandability(g);break;case"range":this.pushDiff([1,{extId:D,item:{range:C.Range.from(p)}}]);break;default:this.pushDiff([1,{extId:D,item:{[u]:p}}]);break}break;default:(0,T.assertNever)(m[0])}}addItem(g,m,D){if(!(g instanceof S.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${g.id} did not`);if(this.testItemToInternal.has(g))throw new Error(`Attempted to add a single TestItem ${g.id} multiple times to the tree`);if(this.testIdToInternal.object.has(g.id))throw new Error(`Attempted to insert a duplicate test item ID ${g.id}`);const f=D?D.item.extId:null,u=g.resolveHandler?1:0,p=D==null?void 0:D.expandLevels,t={controller:m,tree:this.testIdToInternal.object.id},n={actual:g,parent:f,item:C.TestItem.from(g),expandLevels:p?p-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(g,n),this.pushDiff([0,{parent:f,src:t,expand:u,item:n.item}]);const s=(0,y.getPrivateApiFor)(g);s.parent=D==null?void 0:D.actual,s.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const r of s.children.values())this.testItemToInternal.has(r)||this.addItem(r,m,n)}updateExpandability(g){var m;let D;g.actual.resolveHandler?g.actual.status===S.TestItemStatus.Pending?D=g.discoverCts?2:1:((m=g.initialExpand)===null||m===void 0||m.complete(),D=3):D=0,D!==g.expand&&(g.expand=D,this.pushDiff([1,{extId:g.actual.id,expand:D}]),D===1&&g.expandLevels!==void 0&&this.refreshChildren(g))}expandChildren(g,m){if(!(m<0)){const D=[...g.actual.children.values()].map(f=>this.expand(f.id,m)).filter(I.isThenable);if(D.length)return Promise.all(D).then(()=>{})}}refreshChildren(g){if(g.discoverCts&&g.discoverCts.dispose(!0),!g.actual.resolveHandler){const m=new I.DeferredPromise;return m.complete(),m}return g.expand=2,g.discoverCts=new A.CancellationTokenSource,this.pushExpandStateUpdate(g),g.initialExpand=new I.DeferredPromise,g.actual.resolveHandler(g.discoverCts.token),g.initialExpand}pushExpandStateUpdate(g){this.pushDiff([1,{extId:g.actual.id,expand:g.expand}])}removeItem(g){var m;this.pushDiff([2,g.actual.id]);const D=[g];for(;D.length;){const f=D.pop();if(!!f){(m=f.discoverCts)===null||m===void 0||m.dispose(!0),this.testIdToInternal.object.delete(f.item.extId),this.testItemToInternal.delete(f.actual);for(const u of f.actual.children.values())D.push(this.testIdToInternal.object.get(u.id))}}}flushDiff(){const g=this.collectDiff();g.length&&this.publishDiff(g)}}e.SingleUseTestCollection=o}),define(be[184],_e([0,1,26,3,13]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=T;class y{constructor(i){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(w.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(w.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let P of i.activationEvents)P==="onUri"&&(P=`onUri:${w.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(P)||this._activationMap.set(P,[]),this._activationMap.get(P).push(i)}}keepOnly(i){const P=new Set;i.forEach(c=>P.add(w.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>P.has(w.ExtensionIdentifier.toKey(c.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,P){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const c=y._findLoopingExtensions(this._extensionDescriptions);if(P=P.concat(c.map(d=>d.identifier)),P.length>0){const d=new Set;P.forEach(o=>d.add(w.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>!d.has(w.ExtensionIdentifier.toKey(o.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(c)}static _findLoopingExtensions(i){const P=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(g){this._nodesSet.has(g)||(this._nodesSet.add(g),this._nodesArr.push(g))}addArc(g,m){this.addNode(g),this.addNode(m),this._arcs.has(g)?this._arcs.get(g).push(m):this._arcs.set(g,[m])}getArcs(g){return this._arcs.has(g)?this._arcs.get(g):[]}hasOnlyGoodArcs(g,m){const D=P.getArcs(g);for(let f=0;f<D.length;f++)if(!m.has(D[f]))return!1;return!0}getNodes(){return this._nodesArr}};let c=new Map;for(let g of i){const m=w.ExtensionIdentifier.toKey(g.identifier);if(c.set(m,g),g.extensionDependencies)for(let D of g.extensionDependencies){const f=w.ExtensionIdentifier.toKey(D);P.addArc(m,f)}}let d=new Set;P.getNodes().filter(g=>P.getArcs(g).length===0).forEach(g=>d.add(g));let o=P.getNodes().filter(g=>!d.has(g)),l;do{l=!1;for(let g=0;g<o.length;g++){const m=o[g];P.hasOnlyGoodArcs(m,d)&&(o.splice(g,1),g--,d.add(m),l=!0)}}while(l);return o.map(g=>c.get(g))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(w.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const P=this._activationMap.get(i);return P?P.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const P=this._extensionsMap.get(w.ExtensionIdentifier.toKey(i));return P||void 0}}e.ExtensionDescriptionRegistry=y;var C;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(C||(C={}));function S(k,i){const P=k.isBuiltin?0:k.isUnderDevelopment?2:1,c=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(P!==c)return P-c;const d=A.posix.basename(k.extensionLocation.path),o=A.posix.basename(i.extensionLocation.path);return d<o?-1:d>o?1:0}}),define(be[185],_e([0,1,23]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var I;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function T(C){const S=w.VSBuffer.alloc(1);switch(C){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=T;function y(C,S){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=y}),define(be[33],_e([0,1,3,2,4,26,151]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,A.createDecorator)("extensionService");class C{constructor(D){this.dependency=D}}e.MissingDependencyError=C;var S;(function(m){m[m.LocalProcess=0]="LocalProcess",m[m.LocalWebWorker=1]="LocalWebWorker",m[m.Remote=2]="Remote"})(S=e.ExtensionHostKind||(e.ExtensionHostKind={}));class k{constructor(D,f,u,p){this.codeLoadingTime=D,this.activateCallTime=f,this.activateResolvedTime=u,this.activationReason=p}}e.ActivationTimes=k;class i{constructor(D,f){this.description=D,this.value=f}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var P;(function(m){m[m.Normal=0]="Normal",m[m.Immediate=1]="Immediate"})(P=e.ActivationKind||(e.ActivationKind={}));function c(m){m.enableProposedApi||d(m)}e.checkProposedApiEnabled=c;function d(m){throw new Error(`[${m.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${m.identifier.value}`)}e.throwProposedApiError=d;function o(m){return{type:m.isBuiltin?0:1,isBuiltin:m.isBuiltin||m.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(m.publisher,m.name),uuid:m.uuid},manifest:m,location:m.extensionLocation}}e.toExtension=o;function l(m){return Object.assign(Object.assign({identifier:new T.ExtensionIdentifier(m.identifier.id),isBuiltin:m.type===0,isUserBuiltin:m.type===1&&m.isBuiltin,isUnderDevelopment:!1,extensionLocation:m.location},m.manifest),{uuid:m.identifier.uuid})}e.toExtensionDescription=l;class g{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None}activateByEvent(D){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(D){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(D){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(D){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(D,f){}_activateById(D,f){return Promise.resolve()}_onWillActivateExtension(D){}_onDidActivateExtension(D,f,u,p,t){}_onExtensionRuntimeError(D,f){}_onExtensionHostExit(D){}}e.NullExtensionService=g}),define(be[186],_e([0,1,132,26,33,19]),function(Q,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class C{constructor(l,g,m,D){this.startup=l,this.codeLoadingTime=g,this.activateCallTime=m,this.activateResolvedTime=D}}e.ExtensionActivationTimes=C,C.NONE=new C(!1,-1,-1,-1);class S{constructor(l){this._startup=l,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(l,g){return l===-1||g===-1?-1:g-l}build(){return new C(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class k{constructor(l,g,m,D,f,u){this.activationFailed=l,this.activationFailedError=g,this.activationTimes=m,this.module=D,this.exports=f,this.subscriptions=u}}e.ActivatedExtension=k;class i extends k{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=i;class P extends k{constructor(){super(!1,null,C.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=P;class c extends k{constructor(l){super(!0,l,C.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=c;let d=class{constructor(l,g,m,D,f){this._logService=f,this._registry=l,this._resolvedExtensionsSet=new Set,g.forEach(u=>this._resolvedExtensionsSet.add(I.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,m.forEach(u=>this._hostExtensionsMap.set(I.ExtensionIdentifier.toKey(u),u)),this._host=D,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(l){const g=I.ExtensionIdentifier.toKey(l);return this._activatedExtensions.has(g)}getActivatedExtension(l){const g=I.ExtensionIdentifier.toKey(l),m=this._activatedExtensions.get(g);if(!m)throw new Error("Extension `"+l.value+"` is not known or not activated");return m}activateByEvent(l,g){if(this._alreadyActivatedEvents[l])return y;const m=this._registry.getExtensionDescriptionsForActivationEvent(l);return this._activateExtensions(m.map(D=>({id:D.identifier,reason:{startup:g,extensionId:D.identifier,activationEvent:l}}))).then(()=>{this._alreadyActivatedEvents[l]=!0})}activateById(l,g){const m=this._registry.getExtensionDescription(l);if(!m)throw new Error("Extension `"+l+"` is not known");return this._activateExtensions([{id:m.identifier,reason:g}])}_handleActivateRequest(l,g,m){if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(l.id))){g[I.ExtensionIdentifier.toKey(l.id)]=l;return}const D=this._registry.getExtensionDescription(l.id);if(!D){this._host.onExtensionActivationError(l.id,new A.MissingDependencyError(l.id.value));const p=new Error(`Unknown dependency '${l.id.value}'`);this._activatedExtensions.set(I.ExtensionIdentifier.toKey(l.id),new c(p));return}const f=typeof D.extensionDependencies=="undefined"?[]:D.extensionDependencies;let u=!0;for(let p=0,t=f.length;p<t;p++){const n=f[p];if(!this._resolvedExtensionsSet.has(I.ExtensionIdentifier.toKey(n))){const s=this._activatedExtensions.get(I.ExtensionIdentifier.toKey(n));if(!(s&&!s.activationFailed)){if(s&&s.activationFailed){this._host.onExtensionActivationError(D.identifier,w.localize(0,null,D.displayName||D.identifier.value,n));const h=new Error(`Dependency ${n} failed to activate`);h.detail=s.activationFailedError,this._activatedExtensions.set(I.ExtensionIdentifier.toKey(D.identifier),new c(h));return}if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(n))){u=!1,g[I.ExtensionIdentifier.toKey(n)]={id:this._hostExtensionsMap.get(I.ExtensionIdentifier.toKey(n)),reason:l.reason};continue}const r=this._registry.getExtensionDescription(n);if(r){u=!1,g[I.ExtensionIdentifier.toKey(n)]={id:r.identifier,reason:l.reason};continue}this._host.onExtensionActivationError(D.identifier,new A.MissingDependencyError(n));const a=new Error(`Unknown dependency '${n}'`);this._activatedExtensions.set(I.ExtensionIdentifier.toKey(D.identifier),new c(a));return}}}u?g[I.ExtensionIdentifier.toKey(D.identifier)]=l:m.push(l)}_activateExtensions(l){if(l.length===0||(l=l.filter(f=>!this._activatedExtensions.has(I.ExtensionIdentifier.toKey(f.id))),l.length===0))return Promise.resolve(void 0);const g=Object.create(null),m=[];for(let f=0,u=l.length;f<u;f++)this._handleActivateRequest(l[f],g,m);for(let f=0,u=m.length;f<u;f++){const p=I.ExtensionIdentifier.toKey(m[f].id);g[p]&&delete g[p]}const D=Object.keys(g).map(f=>g[f]);return m.length===0?Promise.all(D.map(f=>this._activateExtension(f.id,f.reason))).then(f=>{}):this._activateExtensions(D).then(f=>this._activateExtensions(m))}_activateExtension(l,g){const m=I.ExtensionIdentifier.toKey(l);if(this._activatedExtensions.has(m))return Promise.resolve(void 0);const D=this._activatingExtensions.get(m);if(D)return D;const f=this._host.actualActivateExtension(l,g).then(void 0,u=>(this._host.onExtensionActivationError(l,w.localize(1,null,l.value,u.message)),this._logService.error(`Activating extension ${l.value} failed due to an error:`),this._logService.error(u),new c(u))).then(u=>{this._activatedExtensions.set(m,u),this._activatingExtensions.delete(m)});return this._activatingExtensions.set(m,f),f}};d=Ve([qe(4,T.ILogService)],d),e.ExtensionsActivator=d}),define(be[187],_e([0,1,12]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class I{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,y)=>{this._actualOk=T,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,w.onUnexpectedError)(T))}then(T,y){return this._ensureActual().then(T,y)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=I}),define(be[98],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class w{constructor(S,k){this.isMain=S,this.sid=k,this.nid=++w.count}}e.ProxyIdentifier=w,w.count=0;const I=[];function A(C){const S=new w(!0,C);return I[S.nid]=S,S}e.createMainContextProxyIdentifier=A;function T(C){const S=new w(!1,C);return I[S.nid]=S,S}e.createExtHostContextProxyIdentifier=T;function y(C){return I[C].sid}e.getStringIdentifierForProxy=y}),define(be[5],_e([0,1,2,98,57]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var y;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(u){u[u.Markdown=1]="Markdown",u[u.Code=2]="Code"})(k=e.CellKind||(e.CellKind={}));var i;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(i=e.CellOutputKind||(e.CellOutputKind={}));var P;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(P=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var c;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(c=e.CandidatePortSource||(e.CandidatePortSource={}));var d;(function(u){u.name="$ident";function p(n,s){return Object.defineProperty(n,u.name,{value:s,enumerable:!0}),n}u.mixin=p;function t(n){return n[u.name]}u.of=t})(d=e.ObjectIdentifier||(e.ObjectIdentifier={}));class o{static mixin(p){return p._id=o._n++,p}}e.IdObject=o,o._n=0;var l;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n",u.label2="o"})(l=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(m=e.WorkspaceEditType||(e.WorkspaceEditType={}));function D(u){if(u&&u.edits)for(const p of u.edits)typeof p.resource=="object"?p.resource=w.URI.revive(p.resource):(p.newUri=w.URI.revive(p.newUri),p.oldUri=w.URI.revive(p.oldUri)),p.metadata&&p.metadata.iconPath&&(p.metadata=(0,A.revive)(p.metadata));return u}e.reviveWorkspaceEditDto=D;var f;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,I.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,I.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,I.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,I.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,I.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,I.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[74],_e([0,1,5,3,4]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(C){this._onDidChangePassword=new I.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(w.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,S){return this._proxy.$getPassword(C,S)}store(C,S,k){return this._proxy.$setPassword(C,S,k)}delete(C,S){return this._proxy.$deletePassword(C,S)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,A.createDecorator)("IExtHostSecretState")}),define(be[75],_e([0,1,4,19,5,14]),function(Q,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,w.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(S,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(A.MainContext.MainThreadTelemetry)}report(S,k,i){const P=this.getUsageKey(S,k);this._reportedUsages.has(P)||(this._reportedUsages.add(P),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:S}))}getUsageKey(S,k){return`${S}-${k.identifier.value}`}};y=Ve([qe(0,T.IExtHostRpcService),qe(1,I.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(C,S,k){}})}),define(be[188],_e([0,1,3,5,7,26]),function(Q,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new w.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new w.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(I.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(S,k,i,P={}){const c=T.ExtensionIdentifier.toKey(S.identifier),d=this._inFlightRequests.get(c)||[],o=i.sort().join(" ");let l=d.find(g=>g.scopes===o);if(l)return l.result;{const g=this._getSession(S,c,k,i,P);l={scopes:o,result:g},d.push(l),this._inFlightRequests.set(c,d);try{await g}finally{const m=d.findIndex(D=>D.scopes===o);m>-1&&(d.splice(m),this._inFlightRequests.set(c,d))}return g}}async _getSession(S,k,i,P,c={}){await this._proxy.$ensureProvider(i);const d=S.displayName||S.name;return this._proxy.$getSession(i,P,k,d,c)}async removeSession(S,k){const i=this._authenticationProviders.get(S);return i?i.provider.removeSession(k):this._proxy.$removeSession(S,k)}registerAuthenticationProvider(S,k,i,P){var c;if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:k,provider:i,options:P!=null?P:{supportsMultipleAccounts:!1}}),this._providers.find(o=>o.id===S)||this._providers.push({id:S,label:k});const d=i.onDidChangeSessions(o=>{var l,g,m;this._proxy.$sendDidChangeSessions(S,{added:(l=o.added)!==null&&l!==void 0?l:[],changed:(g=o.changed)!==null&&g!==void 0?g:[],removed:(m=o.removed)!==null&&m!==void 0?m:[]})});return this._proxy.$registerAuthenticationProvider(S,k,(c=P==null?void 0:P.supportsMultipleAccounts)!==null&&c!==void 0?c:!1),new A.Disposable(()=>{d.dispose(),this._authenticationProviders.delete(S);const o=this._providers.findIndex(l=>l.id===S);o>-1&&this._providers.splice(o),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,k){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,k){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,k){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,k){return this._onDidChangeSessions.fire({provider:{id:S,label:k}}),Promise.resolve()}$onDidChangeAuthenticationProviders(S,k){return S.forEach(i=>{this._providers.some(P=>P.id===i.id)||this._providers.push(i)}),k.forEach(i=>{const P=this._providers.findIndex(c=>c.id===i.id);P>-1&&this._providers.splice(P)}),this._onDidChangeAuthenticationProviders.fire({added:S,removed:k}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(be[189],_e([0,1,5,14,9]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(C,S){this._extHostDocumentsAndEditors=S,this._proxy=C.getProxy(w.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const S=A.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};T=Ve([qe(0,I.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(be[190],_e([0,1,5]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class I{constructor(T){const y=T.getProxy(w.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(C){return y.$writeText(C)}})}}e.ExtHostClipboard=I}),define(be[76],_e([0,1,10,7,9,24,5,15,19,57,32,38,2,6,4,14]),function(Q,e,w,I,A,T,y,C,S,k,i,P,c,d,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let g=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadCommands),this._logService=n,this.converter=new m(this,s=>{const r=this._apiCommands.get(s);return(r==null?void 0:r.result)===f.Void?r:void 0},n),this._argumentProcessors=[{processArgument(s){return(0,k.revive)(s)}},{processArgument(s){return(0,T.cloneAndChange)(s,function(r){if(i.Range.isIRange(r))return A.Range.to(r);if(P.Position.isIPosition(r))return A.Position.to(r);if(i.Range.isIRange(r.range)&&c.URI.isUri(r.uri))return A.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...s)=>{const r=t.args.map((h,b)=>{if(!h.validate(s[b]))throw new Error(`Invalid argument '${h.name}' when running '${t.id}', received: ${s[b]}`);return h.convert(s[b])}),a=await this.executeCommand(t.internalId,...r);return t.result.convert(a,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new I.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,s,r,a){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:s,thisArg:r,description:a}),t&&this._proxy.$registerCommand(n),new I.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,s){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const r=(0,T.cloneAndChange)(n,function(a){if(a instanceof I.Position)return A.Position.from(a);if(a instanceof I.Range)return A.Range.from(a);if(a instanceof I.Location)return A.location.from(a);if(!Array.isArray(a))return a});try{const a=await this._proxy.$executeCommand(t,r,s);return(0,k.revive)(a)}catch(a){if(a instanceof Error&&a.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw a}}}async _executeContributedCommand(t,n){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:r,thisArg:a,description:h}=s;if(h)for(let b=0;b<h.args.length;b++)try{(0,w.validateConstraint)(n[b],h.args[b].constraint)}catch(_){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${h.args[b].name}' - ${h.args[b].description}`)}try{return await r.apply(a,n)}catch(b){if(t===this.converter.delegatingCommandId){const _=this.converter.getActualCommand(...n);_&&(t=_.command)}throw this._logService.error(b,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(s=>this._argumentProcessors.reduce((r,a)=>a.processArgument(r),s)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(s=>s[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,s]of this._commands){let{description:r}=s;r&&(t[n]=r)}return Promise.resolve(t)}};g=Ve([qe(0,l.IExtHostRpcService),qe(1,S.ILogService)],g),e.ExtHostCommands=g,e.IExtHostCommands=(0,o.createDecorator)("IExtHostCommands");class m{constructor(t,n,s){this._commands=t,this._lookupApiCommand=n,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const r=this._lookupApiCommand(t.command);if(r)s.id=r.internalId,s.arguments=r.args.map((a,h)=>a.convert(t.arguments&&t.arguments[h]));else if((0,C.isNonEmptyArray)(t.arguments)){const a=++this._cachIdPool;this._cache.set(a,t),n.add((0,d.toDisposable)(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),s.$ident=a,s.id=this.delegatingCommandId,s.arguments=[a],this._logService.trace("CommandsConverter#CREATE",t.command,a)}return s}}fromInternal(t){const n=y.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=m;class D{constructor(t,n,s,r){this.name=t,this.description=n,this.validate=s,this.convert=r}optional(){return new D(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new D(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=D,D.Uri=new D("uri","Uri of a text document",p=>c.URI.isUri(p),p=>p),D.Position=new D("position","A position in a text document",p=>I.Position.isPosition(p),A.Position.from),D.Range=new D("range","A range in a text document",p=>I.Range.isRange(p),A.Range.from),D.Selection=new D("selection","A selection in a text document",p=>I.Selection.isSelection(p),A.Selection.from),D.Number=new D("number","",p=>typeof p=="number",p=>p),D.String=new D("string","",p=>typeof p=="string",p=>p),D.CallHierarchyItem=new D("item","A call hierarchy item",p=>p instanceof I.CallHierarchyItem,A.CallHierarchyItem.to);class f{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=f,f.Void=new f("no result",p=>p);class u{constructor(t,n,s,r,a){this.id=t,this.internalId=n,this.description=s,this.args=r,this.result=a}}e.ApiCommand=u}),define(be[191],_e([0,1,6,9,7,62,76,169,15,87]),function(Q,e,w,I,A,T,y,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const i=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",c(I.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(o,l)=>{if(!(0,S.isFalsyOrEmpty)(o)){class g extends A.SymbolInformation{static to(D){const f=new g(D.name,I.SymbolKind.to(D.kind),D.containerName||"",new A.Location(l[0],I.Range.to(D.range)));return f.detail=D.detail,f.range=f.location.range,f.selectionRange=I.Range.to(D.selectionRange),f.children=D.children?D.children.map(g.to):[],f}}return o.map(g.to)}})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",c(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",c(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",o=>typeof o=="string",o=>o),new y.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",c(I.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",c(I.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",c(I.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",o=>Array.isArray(o)&&o.every(l=>A.Position.isPosition(l)),o=>o.map(I.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",o=>o.map(l=>{let g;for(const m of l.reverse())g=new A.SelectionRange(I.Range.to(m),g);return g}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",o=>{const l=[];if(Array.isArray(o))for(let g of o)l.push(...g[1].map(I.WorkspaceSymbol.to));return l})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(I.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(I.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(I.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",o=>{if(!!o){if(o.rejectReason)throw new Error(o.rejectReason);return I.WorkspaceEdit.to(o)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",o=>o.map(I.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new A.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!!o){const l=(0,k.decodeSemanticTokensDto)(o);if(l.type==="full")return new A.SemanticTokens(l.data,void 0)}})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new A.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!!o){const l=(0,k.decodeSemanticTokensDto)(o);if(l.type==="full")return new A.SemanticTokens(l.data,void 0)}})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(o,l,g)=>{if(!o)return new A.CompletionList([]);const m=o.suggestions.map(D=>I.CompletionItem.to(D,g));return new A.CompletionList(m,o.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",o=>{if(o)return I.SignatureHelp.to(o)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(o,l,g)=>c(m=>new A.CodeLens(I.Range.to(m.range),m.command&&g.fromInternal(m.command)))(o))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",o=>A.Range.isRange(o),o=>A.Selection.isSelection(o)?I.Selection.from(o):I.Range.from(o)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(o,l,g)=>c(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return g.fromInternal(m.command)}else{const D=new A.CodeAction(m.title,m.kind?new A.CodeActionKind(m.kind):void 0);return m.edit&&(D.edit=I.WorkspaceEdit.to(m.edit)),m.command&&(D.command=g.fromInternal(m.command)),D.isPreferred=m.isPreferred,D}})(o))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",o=>o?o.map(l=>new A.ColorInformation(I.Range.to(l.range),I.Color.to(l.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",o=>o instanceof A.Color,I.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",o=>!0,o=>({uri:o.uri,range:I.Range.from(o.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",o=>o?o.map(I.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineHint objects",o=>o.map(I.InlineHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",c(o=>({viewType:o.viewType,displayName:o.displayName,options:{transientOutputs:o.options.transientOutputs,transientCellMetadata:o.options.transientCellMetadata,transientDocumentMetadata:o.options.transientDocumentMetadata},filenamePattern:o.filenamePattern.map(l=>I.NotebookExclusiveDocumentPattern.to(l))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",o=>o.map(I.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[o,void 0]:[I.ViewColumn.from(o.viewColumn),I.TextEditorOpenOptions.from(o)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[o,void 0]:[I.ViewColumn.from(o.viewColumn),I.TextEditorOpenOptions.from(o)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="object",o=>o&&[I.ViewColumn.from(o.viewColumn),I.TextEditorOpenOptions.from(o)]).optional()],y.ApiCommandResult.Void)];class P{constructor(l){this._disposables=new w.DisposableStore,this._commands=l}static register(l){return i.forEach(l.registerApiCommand,l),new P(l).registerCommands()}registerCommands(){const l=g=>(...m)=>g(this._commands,...m);this._register(C.RemoveFromRecentlyOpenedAPICommand.ID,l(C.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:g=>typeof g=="string"}]}),this._register(C.OpenIssueReporter.ID,l(C.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:g=>typeof g=="string"||typeof g=="object"&&typeof g.extensionId=="string"}]})}_register(l,g,m){const D=this._commands.registerCommand(!1,l,g,this,m);this._disposables.add(D)}}e.ExtHostApiCommands=P;function c(o){return l=>{if(Array.isArray(l))return l.map(o)}}function d(o){if(!!Array.isArray(o)){const l=[];for(const g of o)T.isLocationLink(g)?l.push(I.DefinitionLink.to(g)):l.push(I.location.to(g));return l}}}),define(be[192],_e([0,1,11,52,3,6,2,62,26,9,7,5]),function(Q,e,w,I,A,T,y,C,S,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class c{constructor(u,p,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=u.getProxy(P.MainContext.MainThreadComments),p.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const s=this._commentControllers.get(n.handle);return s||n}else if(n&&n.$mid===7){const s=this._commentControllers.get(n.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.commentThreadHandle);return r||n}else if(n&&n.$mid===8){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);return r?{thread:r,text:n.text}:n}else if(n&&n.$mid===9){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let a=n.commentUniqueId,h=r.getCommentByUniqueId(a);return h||n}else if(n&&n.$mid===10){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let a=n.text,h=n.commentUniqueId,b=r.getCommentByUniqueId(h);return b?(b.body=a,b):n}return n}})}createCommentController(u,p,t){const n=c.handlePool++,s=new o(u,n,this._proxy,p,t);this._commentControllers.set(s.handle,s);const r=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(u.identifier))||[];return r.push(s),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(u.identifier),r),s}$createCommentThreadTemplate(u,p,t){const n=this._commentControllers.get(u);!n||n.$createCommentThreadTemplate(p,t)}async $updateCommentThreadTemplate(u,p,t){const n=this._commentControllers.get(u);!n||n.$updateCommentThreadTemplate(p,t)}$deleteCommentThread(u,p){const t=this._commentControllers.get(u);t&&t.$deleteCommentThread(p)}$provideCommentingRanges(u,p,t){const n=this._commentControllers.get(u);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(y.URI.revive(p));return(0,w.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(s,t)).then(r=>r?r.map(a=>k.Range.from(a)):void 0)}$toggleReaction(u,p,t,n,s){const r=this._commentControllers.get(u);return!r||!r.reactionHandler?Promise.resolve(void 0):(0,w.asPromise)(()=>{const a=r.getCommentThread(p);if(a){const h=a.getCommentByUniqueId(n.uniqueIdInThread);if(r!==void 0&&h&&r.reactionHandler)return r.reactionHandler(h,m(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=c,c.handlePool=0;class d{constructor(u,p,t,n,s,r,a){this._proxy=u,this._commentController=p,this._id=t,this._uri=n,this._range=s,this._comments=r,this.handle=d._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new A.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${p.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,k.Range.from(this._range),a),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=r}set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){u.isEqual(this._range)||(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const u=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),p={};u("range")&&(p.range=k.Range.from(this._range)),u("label")&&(p.label=this.label),u("contextValue")&&(p.contextValue=this.contextValue),u("comments")&&(p.comments=this._comments.map(t=>l(this,this._commentController,t,this._commentsMap))),u("collapsibleState")&&(p.collapseState=D(this._collapseState)),u("canReply")&&(p.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,p)}}getCommentByUniqueId(u){for(let p of this._commentsMap){let t=p[0],n=p[1];if(u===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}d._handlePool=0,Ve([(0,I.debounce)(100)],d.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=d;class o{constructor(u,p,t,n,s){this._extension=u,this._handle=p,this._proxy=t,this._id=n,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(u,p,t,n){if(typeof u=="string"){const s=new d(this._proxy,this,u,p,t,n,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new d(this._proxy,this,void 0,u,p,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(u,p){const t=new d(this._proxy,this,void 0,y.URI.revive(u),k.Range.to(p),[],this._extension.identifier);return t.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(u,p){let t=this._threads.get(u);t&&(t.range=k.Range.to(p))}$deleteCommentThread(u){let p=this._threads.get(u);p&&p.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function l(f,u,p,t){let n=t.get(p);n||(n=++f.commentHandle,t.set(p,n));const s=p.author&&p.author.iconPath?p.author.iconPath.toString():void 0;return{mode:p.mode,contextValue:p.contextValue,uniqueIdInThread:n,body:k.MarkdownString.from(p.body),userName:p.author.name,userIconPath:s,label:p.label,commentReactions:p.reactions?p.reactions.map(r=>g(r)):void 0}}function g(f){return{label:f.label,iconPath:f.iconPath?k.pathOrURIToURI(f.iconPath):void 0,count:f.count,hasReacted:f.authorHasReacted}}function m(f){return{label:f.label||"",count:f.count||0,iconPath:f.iconPath?y.URI.revive(f.iconPath):"",authorHasReacted:f.hasReacted||!1}}function D(f){if(f!==void 0)switch(f){case i.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}}),define(be[99],_e([0,1,2,5,7,4,14,19,15,8,13]),function(Q,e,w,I,A,T,y,C,S,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let P=class pn{constructor(d,o){this._logService=o,this._provider=new Map,this._proxy=d.getProxy(I.MainContext.MainThreadDecorations)}registerFileDecorationProvider(d,o){const l=pn._handlePool++;this._provider.set(l,{provider:d,extensionId:o}),this._proxy.$registerDecorationProvider(l,o.value);const g=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(m=>{if(!m){this._proxy.$onDidChange(l,null);return}let D=(0,S.asArray)(m);if(D.length<=pn._maxEventSize){this._proxy.$onDidChange(l,D);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.value,D.length);const f=D.map(t=>({uri:t,rank:(0,k.count)(t.path,"/")})),u=(0,S.groupBy)(f,(t,n)=>t.rank-n.rank||(0,k.compare)(t.uri.path,n.uri.path));let p=[];e:for(let t of u){let n;for(let s of t){let r=(0,i.dirname)(s.uri.path);if(n!==r&&(n=r,p.push(s.uri)>=pn._maxEventSize))break e}}this._proxy.$onDidChange(l,p)});return new A.Disposable(()=>{g==null||g.dispose(),this._proxy.$unregisterDecorationProvider(l),this._provider.delete(l)})}async $provideDecorations(d,o,l){if(!this._provider.has(d))return Object.create(null);const g=Object.create(null),{provider:m,extensionId:D}=this._provider.get(d);return await Promise.all(o.map(async f=>{try{const{uri:u,id:p}=f,t=await Promise.resolve(m.provideFileDecoration(w.URI.revive(u),l));if(!t)return;try{A.FileDecoration.validate(t),g[p]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${D.value}': ${n}`)}}catch(u){this._logService.error(u)}})),g}};P._handlePool=0,P._maxEventSize=250,P=Ve([qe(0,y.IExtHostRpcService),qe(1,C.ILogService)],P),e.ExtHostDecorations=P,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")}),define(be[193],_e([0,1,131,90,2,5,7,9,3,19,22]),function(Q,e,w,I,A,T,y,C,S,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class P{constructor(o,l,g,m,D){this._name=o,this._owner=l,this._maxDiagnosticsPerFile=g,this._proxy=m,this._onDidChangeDiagnostics=D,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(o,l){if(!o){this.clear();return}this._checkDisposed();let g=[];if(A.URI.isUri(o)){if(!l){this.delete(o);return}this._data.set(o,l.slice()),g=[o]}else if(Array.isArray(o)){g=[];let D;o=[...o].sort(P._compareIndexedTuplesByUri);for(const f of o){const[u,p]=f;if((!D||u.toString()!==D.toString())&&(D&&this._data.get(D).length===0&&this._data.delete(D),D=u,g.push(u),this._data.set(u,[])),p){const t=this._data.get(u);t&&t.push(...p)}else{const t=this._data.get(u);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(g),!!this._proxy){const m=[];for(let D of g){let f=[];const u=this._data.get(D);if(u)if(u.length>this._maxDiagnosticsPerFile){f=[];const p=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of u)if(n.severity===p[t]&&f.push(C.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;f.push({severity:I.MarkerSeverity.Info,message:(0,w.localize)(0,null,u.length-this._maxDiagnosticsPerFile),startLineNumber:f[f.length-1].startLineNumber,startColumn:f[f.length-1].startColumn,endLineNumber:f[f.length-1].endLineNumber,endColumn:f[f.length-1].endColumn})}else f=u.map(p=>C.Diagnostic.from(p));m.push([D,f])}this._proxy.$changeMany(this._owner,m)}}delete(o){this._checkDisposed(),this._onDidChangeDiagnostics.fire([o]),this._data.delete(o),this._proxy&&this._proxy.$changeMany(this._owner,[[o,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(o,l){this._checkDisposed();for(let g of this._data.keys())o.apply(l,[g,this.get(g),this])}get(o){this._checkDisposed();const l=this._data.get(o);return Array.isArray(l)?Object.freeze(l.slice(0)):[]}has(o){return this._checkDisposed(),Array.isArray(this._data.get(o))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(o,l){return o[0].toString()<l[0].toString()?-1:o[0].toString()>l[0].toString()?1:0}}e.DiagnosticCollection=P;let c=class Wt{constructor(o,l){this._logService=l,this._collections=new Map,this._onDidChangeDiagnostics=new S.Emitter,this.onDidChangeDiagnostics=S.Event.map(S.Event.debounce(this._onDidChangeDiagnostics.event,Wt._debouncer,50),Wt._mapper),this._proxy=o.getProxy(T.MainContext.MainThreadDiagnostics)}static _debouncer(o,l){return o?o.concat(l):l}static _mapper(o){const l=[],g=new Set;for(const m of o)typeof m=="string"?g.has(m)||(g.add(m),l.push(A.URI.parse(m))):g.has(m.toString())||(g.add(m.toString()),l.push(m));return Object.freeze(l),{uris:l}}createDiagnosticCollection(o,l){const{_collections:g,_proxy:m,_onDidChangeDiagnostics:D,_logService:f}=this,u=new class{$changeMany(n,s){m.$changeMany(n,s),f.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,n,s.length===0?"CLEARING":s)}$clear(n){m.$clear(n),f.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,n)}dispose(){m.dispose()}};let p;if(!l)l="_generated_diagnostic_collection_name_#"+Wt._idPool++,p=l;else if(!g.has(l))p=l;else{this._logService.warn(`DiagnosticCollection with name '${l}' does already exist.`);do p=l+Wt._idPool++;while(g.has(p))}return new class extends P{constructor(){super(l,p,Wt._maxDiagnosticsPerFile,u,D);g.set(p,this)}dispose(){super.dispose(),g.delete(p)}}}getDiagnostics(o){if(o)return this._getDiagnostics(o);{const l=new Map,g=[];for(const m of this._collections.values())m.forEach((D,f)=>{let u=l.get(D.toString());typeof u=="undefined"&&(u=g.length,l.set(D.toString(),u),g.push([D,[]])),g[u][1]=g[u][1].concat(...f)});return g}}_getDiagnostics(o){let l=[];for(let g of this._collections.values())g.has(o)&&(l=l.concat(g.get(o)));return l}$acceptMarkersChange(o){if(!this._mirrorCollection){const l="_generated_mirror",g=new P(l,l,Wt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(l,g),this._mirrorCollection=g}for(const[l,g]of o)this._mirrorCollection.set(A.URI.revive(l),g.map(C.Diagnostic.to))}};c._idPool=0,c._maxDiagnosticsPerFile=1e3,c=Ve([qe(1,k.ILogService)],c),e.ExtHostDiagnostics=c}),define(be[194],_e([0,1,2,5]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class A{constructor(y){this._proxy=y.getProxy(I.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(C=>C?C.map(S=>w.URI.revive(S)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(C=>C?w.URI.revive(C):void 0)}}e.ExtHostDialogs=A}),define(be[195],_e([0,1,12,2,7,5,18,20,8]),function(Q,e,w,I,A,T,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(P,c,d){this._documentsAndEditors=c,this._logService=d,this._documentContentProviders=new Map,this._proxy=P.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,c){if(Object.keys(y.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const d=k._handlePool++;this._documentContentProviders.set(d,c),this._proxy.$registerTextContentProvider(d,P);let o;return typeof c.onDidChange=="function"&&(o=c.onDidChange(l=>{if(l.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${l.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(l)&&this.$provideTextDocumentContent(d,l).then(g=>{if(!(!g&&typeof g!="string")){const m=this._documentsAndEditors.getDocument(l);if(!!m){const D=(0,S.splitLines)(g);if(!m.equalLines(D))return this._proxy.$onVirtualDocumentChange(l,g)}}},w.onUnexpectedError)})),new A.Disposable(()=>{this._documentContentProviders.delete(d)&&this._proxy.$unregisterTextContentProvider(d),o&&(o.dispose(),o=void 0)})}$provideTextDocumentContent(P,c){const d=this._documentContentProviders.get(P);return d?Promise.resolve(d.provideTextDocumentContent(I.URI.revive(c),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(be[196],_e([0,1,3,6,2,5,95,9,10,24]),function(Q,e,w,I,A,T,y,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class i{constructor(c,d){this._onDidAddDocument=new w.Emitter,this._onDidRemoveDocument=new w.Emitter,this._onDidChangeDocument=new w.Emitter,this._onDidSaveDocument=new w.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new I.DisposableStore,this._documentLoader=new Map,this._proxy=c.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=d,this._documentsAndEditors.onDidRemoveDocuments(o=>{for(const l of o)this._onDidRemoveDocument.fire(l.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(o=>{for(const l of o)this._onDidAddDocument.fire(l.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(c){if(!!c){const d=this._documentsAndEditors.getDocument(c);if(d)return d}}getDocument(c){const d=this.getDocumentData(c);if(!(d==null?void 0:d.document))throw new Error(`Unable to retrieve document from URI '${c}'`);return d.document}ensureDocumentData(c){const d=this._documentsAndEditors.getDocument(c);if(d)return Promise.resolve(d);let o=this._documentLoader.get(c.toString());return o||(o=this._proxy.$tryOpenDocument(c).then(l=>{this._documentLoader.delete(c.toString());const g=A.URI.revive(l);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(g))},l=>(this._documentLoader.delete(c.toString()),Promise.reject(l))),this._documentLoader.set(c.toString(),o)),o}createDocumentData(c){return this._proxy.$tryCreateDocument(c).then(d=>A.URI.revive(d))}$acceptModelModeChanged(c,d){const o=A.URI.revive(c),l=this._documentsAndEditors.getDocument(o);if(!l)throw new Error("unknown document");this._onDidRemoveDocument.fire(l.document),l._acceptLanguageId(d),this._onDidAddDocument.fire(l.document)}$acceptModelSaved(c){const d=A.URI.revive(c),o=this._documentsAndEditors.getDocument(d);if(!o)throw new Error("unknown document");this.$acceptDirtyStateChanged(c,!1),this._onDidSaveDocument.fire(o.document)}$acceptDirtyStateChanged(c,d){const o=A.URI.revive(c),l=this._documentsAndEditors.getDocument(o);if(!l)throw new Error("unknown document");l._acceptIsDirty(d),this._onDidChangeDocument.fire({document:l.document,contentChanges:[]})}$acceptModelChanged(c,d,o){const l=A.URI.revive(c),g=this._documentsAndEditors.getDocument(l);if(!g)throw new Error("unknown document");g._acceptIsDirty(o),g.onEvents(d),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:g.document,contentChanges:d.changes.map(m=>({range:C.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text}))}))}setWordDefinitionFor(c,d){(0,y.setWordDefinitionFor)(c,d)}}e.ExtHostDocuments=i}),define(be[39],_e([0,1,42,3,6,2,4,5,95,14,97,9,19,22,18,43,108]),function(Q,e,w,I,A,T,y,C,S,k,i,P,c,d,o,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class m{constructor(u){this.value=u,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let D=class{constructor(u,p){this._extHostRpc=u,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new d.ResourceMap,this._onDidAddDocuments=new I.Emitter,this._onDidRemoveDocuments=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const p=[],t=[],n=[];if(u.removedDocuments)for(const s of u.removedDocuments){const r=T.URI.revive(s),a=this._documents.get(r);(a==null?void 0:a.unref())&&(this._documents.delete(r),p.push(a.value))}if(u.addedDocuments)for(const s of u.addedDocuments){const r=T.URI.revive(s.uri);let a=this._documents.get(r);if(a&&r.scheme!==o.Schemas.vscodeNotebookCell)throw new Error(`document '${r} already exists!'`);a||(a=new m(new S.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),r,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(r,a),t.push(a.value)),a.ref()}if(u.removedEditors)for(const s of u.removedEditors){const r=this._editors.get(s);this._editors.delete(s),r&&n.push(r)}if(u.addedEditors)for(const s of u.addedEditors){const r=T.URI.revive(s.documentUri);w.ok(this._documents.has(r),`document '${r}' does not exist`),w.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const a=this._documents.get(r).value,h=new i.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new g.Lazy(()=>a.document),s.selections.map(P.Selection.to),s.options,s.visibleRanges.map(b=>P.Range.to(b)),typeof s.editorPosition=="number"?P.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,h)}u.newActiveEditor!==void 0&&(w.ok(u.newActiveEditor===null||this._editors.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this._activeEditorId=u.newActiveEditor),(0,A.dispose)(p),(0,A.dispose)(n),u.removedDocuments&&this._onDidRemoveDocuments.fire(p),u.addedDocuments&&this._onDidAddDocuments.fire(t),(u.removedEditors||u.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),u.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(u){var p;return(p=this._documents.get(u))===null||p===void 0?void 0:p.value}allDocuments(){return l.Iterable.map(this._documents.values(),u=>u.value)}getEditor(u){return this._editors.get(u)}activeEditor(u){if(!!this._activeEditorId){const p=this._editors.get(this._activeEditorId);return u?p:p==null?void 0:p.value}}allEditors(){return[...this._editors.values()]}};D=Ve([qe(0,k.IExtHostRpcService),qe(1,c.ILogService)],D),e.ExtHostDocumentsAndEditors=D,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[197],_e([0,1,2,5,6,7,9,118,8,23]),function(Q,e,w,I,A,T,y,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(d){this._stateMachine=void 0,this._schemes.push(d)}delete(d){const o=this._schemes.indexOf(d);o>=0&&(this._schemes.splice(o,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const d=this._schemes.sort(),o=[];let l,g,m=14,D=14;for(const f of d){let u=l?(0,S.commonPrefixLength)(l,f):0;for(u===0?g=1:g=D;u<f.length;u++)u+1===f.length?(m=D,D=9):D+=1,o.push([g,f.toUpperCase().charCodeAt(u),D]),o.push([g,f.toLowerCase().charCodeAt(u),D]),g=D;l=f,D=m}o.push([9,58,10]),o.push([10,47,12]),this._stateMachine=new C.StateMachine(o)}}provideDocumentLinks(d){this._initStateMachine();const o=[],l=C.LinkComputer.computeLinks({getLineContent(g){return d.lineAt(g-1).text},getLineCount(){return d.lineCount}},this._stateMachine);for(const g of l){const m=y.DocumentLink.to(g);m.target&&o.push(m)}return o}}class P{constructor(d,o){this._extHostLanguageFeatures=o,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=d.getProxy(I.MainContext.MainThreadFileSystem)}dispose(){var d;(d=this._linkProviderRegistration)===null||d===void 0||d.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(d,o,l,g={}){if(this._registeredSchemes.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const m=this._handlePool++;this._linkProvider.add(o),this._registeredSchemes.add(o),this._fsProvider.set(m,l);let D=2;g.isCaseSensitive&&(D+=1024),g.isReadonly&&(D+=2048),typeof l.copy=="function"&&(D+=8),typeof l.open=="function"&&typeof l.close=="function"&&typeof l.read=="function"&&typeof l.write=="function"&&(D+=4),this._proxy.$registerFileSystemProvider(m,o,D).catch(u=>{console.error(`FAILED to register filesystem provider of ${d.value}-extension for the scheme ${o}`),console.error(u)});const f=l.onDidChangeFile(u=>{const p=[];for(const t of u){let{uri:n,type:s}=t;if(n.scheme===o){let r;switch(s){case T.FileChangeType.Changed:r=0;break;case T.FileChangeType.Created:r=1;break;case T.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}p.push({resource:n,type:r})}}this._proxy.$onFileSystemChange(m,p)});return(0,A.toDisposable)(()=>{f.dispose(),this._linkProvider.delete(o),this._registeredSchemes.delete(o),this._fsProvider.delete(m),this._proxy.$unregisterProvider(m)})}static _asIStat(d){const{type:o,ctime:l,mtime:g,size:m}=d;return{type:o,ctime:l,mtime:g,size:m}}$stat(d,o){return Promise.resolve(this._getFsProvider(d).stat(w.URI.revive(o))).then(P._asIStat)}$readdir(d,o){return Promise.resolve(this._getFsProvider(d).readDirectory(w.URI.revive(o)))}$readFile(d,o){return Promise.resolve(this._getFsProvider(d).readFile(w.URI.revive(o))).then(l=>k.VSBuffer.wrap(l))}$writeFile(d,o,l,g){return Promise.resolve(this._getFsProvider(d).writeFile(w.URI.revive(o),l.buffer,g))}$delete(d,o,l){return Promise.resolve(this._getFsProvider(d).delete(w.URI.revive(o),l))}$rename(d,o,l,g){return Promise.resolve(this._getFsProvider(d).rename(w.URI.revive(o),w.URI.revive(l),g))}$copy(d,o,l,g){const m=this._getFsProvider(d);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(w.URI.revive(o),w.URI.revive(l),g))}$mkdir(d,o){return Promise.resolve(this._getFsProvider(d).createDirectory(w.URI.revive(o)))}$watch(d,o,l,g){const m=this._getFsProvider(d).watch(w.URI.revive(l),g);this._watches.set(o,m)}$unwatch(d,o){const l=this._watches.get(o);l&&(l.dispose(),this._watches.delete(o))}$open(d,o,l){const g=this._getFsProvider(d);if(!g.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(g.open(w.URI.revive(o),l))}$close(d,o){const l=this._getFsProvider(d);if(!l.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(l.close(o))}$read(d,o,l,g){const m=this._getFsProvider(d);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const D=k.VSBuffer.alloc(g);return Promise.resolve(m.read(o,l,D.buffer,0,g)).then(f=>D.slice(0,f))}$write(d,o,l,g){const m=this._getFsProvider(d);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(o,l,g.buffer,0,g.byteLength))}_getFsProvider(d){const o=this._fsProvider.get(d);if(!o){const l=new Error;throw l.name="ENOPRO",l.message="no provider",l}return o}}e.ExtHostFileSystem=P}),define(be[77],_e([0,1,5,64,7,23,4,14,49]),function(Q,e,w,I,A,T,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Lt{constructor(P,c){const d=P.getProxy(w.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(o){return d.$stat(o).catch(Lt._handleError)},readDirectory(o){return d.$readdir(o).catch(Lt._handleError)},createDirectory(o){return d.$mkdir(o).catch(Lt._handleError)},async readFile(o){return d.$readFile(o).then(l=>l.buffer).catch(Lt._handleError)},writeFile(o,l){return d.$writeFile(o,T.VSBuffer.wrap(l)).catch(Lt._handleError)},delete(o,l){return d.$delete(o,Object.assign({recursive:!1,useTrash:!1},l)).catch(Lt._handleError)},rename(o,l,g){return d.$rename(o,l,Object.assign({overwrite:!1},g)).catch(Lt._handleError)},copy(o,l,g){return d.$copy(o,l,Object.assign({overwrite:!1},g)).catch(Lt._handleError)},isWritableFileSystem(o){const l=c.getCapabilities(o);if(typeof l=="number")return!(l&2048)}})}static _handleError(P){if(!(P instanceof Error))throw new A.FileSystemError(String(P));if(P.name==="ENOPRO")throw A.FileSystemError.Unavailable(P.message);switch(P.name){case I.FileSystemProviderErrorCode.FileExists:throw A.FileSystemError.FileExists(P.message);case I.FileSystemProviderErrorCode.FileNotFound:throw A.FileSystemError.FileNotFound(P.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw A.FileSystemError.FileNotADirectory(P.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw A.FileSystemError.FileIsADirectory(P.message);case I.FileSystemProviderErrorCode.NoPermissions:throw A.FileSystemError.NoPermissions(P.message);case I.FileSystemProviderErrorCode.Unavailable:throw A.FileSystemError.Unavailable(P.message);default:throw new A.FileSystemError(P.message,P.name)}}};k=Ve([qe(0,C.IExtHostRpcService),qe(1,S.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(be[198],_e([0,1,6,5]),function(Q,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class A{constructor(y){this._handlePool=0,this._proxy=y.getProxy(I.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,y),(0,w.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=A}),define(be[199],_e([0,1,2,24,9,7,11,5,8,32,15,10,115,6,87,54,68,55,12]),function(Q,e,w,I,A,T,y,C,S,k,i,P,c,d,o,l,g,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class f{constructor(B,K){this._documents=B,this._provider=K}provideDocumentSymbols(B,K){const ie=this._documents.getDocument(B);return(0,y.asPromise)(()=>this._provider.provideDocumentSymbols(ie,K)).then(le=>{if(!(0,i.isFalsyOrEmpty)(le))return le[0]instanceof T.DocumentSymbol?le.map(A.DocumentSymbol.from):f._asDocumentSymbolTree(le)})}static _asDocumentSymbolTree(B){var K;B=B.slice(0).sort((fe,Se)=>{let Ne=fe.location.range.start.compareTo(Se.location.range.start);return Ne===0&&(Ne=Se.location.range.end.compareTo(fe.location.range.end)),Ne});const ie=[],le=[];for(const fe of B){const Se={name:fe.name||"!!MISSING: name!!",kind:A.SymbolKind.from(fe.kind),tags:((K=fe.tags)===null||K===void 0?void 0:K.map(A.SymbolTag.from))||[],detail:"",containerName:fe.containerName,range:A.Range.from(fe.location.range),selectionRange:A.Range.from(fe.location.range),children:[]};for(;;){if(le.length===0){le.push(Se),ie.push(Se);break}const Ne=le[le.length-1];if(k.Range.containsRange(Ne.range,Se.range)&&!k.Range.equalsRange(Ne.range,Se.range)){Ne.children&&Ne.children.push(Se),le.push(Se);break}le.pop()}}return ie}}class u{constructor(B,K,ie){this._documents=B,this._commands=K,this._provider=ie,this._cache=new g.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(B,K){const ie=this._documents.getDocument(B),le=await this._provider.provideCodeLenses(ie,K);if(!(!le||K.isCancellationRequested)){const fe=this._cache.add(le),Se=new d.DisposableStore;this._disposables.set(fe,Se);const Ne={cacheId:fe,lenses:[]};for(let ge=0;ge<le.length;ge++)Ne.lenses.push({cacheId:[fe,ge],range:A.Range.from(le[ge].range),command:this._commands.toInternal(le[ge].command,Se)});return Ne}}async resolveCodeLens(B,K){var ie;const le=B.cacheId&&this._cache.get(...B.cacheId);if(!!le){let fe;if(typeof this._provider.resolveCodeLens!="function"||le.isResolved?fe=le:fe=await this._provider.resolveCodeLens(le,K),fe||(fe=le),!K.isCancellationRequested){const Se=B.cacheId&&this._disposables.get(B.cacheId[0]);if(!!Se)return B.command=this._commands.toInternal((ie=fe.command)!==null&&ie!==void 0?ie:u._badCmd,Se),B}}}releaseCodeLenses(B){var K;(K=this._disposables.get(B))===null||K===void 0||K.dispose(),this._disposables.delete(B),this._cache.delete(B)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function p(Ue){return Array.isArray(Ue)?Ue.map(A.DefinitionLink.from):Ue?[A.DefinitionLink.from(Ue)]:[]}class t{constructor(B,K){this._documents=B,this._provider=K}provideDefinition(B,K,ie){const le=this._documents.getDocument(B),fe=A.Position.to(K);return(0,y.asPromise)(()=>this._provider.provideDefinition(le,fe,ie)).then(p)}}class n{constructor(B,K){this._documents=B,this._provider=K}provideDeclaration(B,K,ie){const le=this._documents.getDocument(B),fe=A.Position.to(K);return(0,y.asPromise)(()=>this._provider.provideDeclaration(le,fe,ie)).then(p)}}class s{constructor(B,K){this._documents=B,this._provider=K}provideImplementation(B,K,ie){const le=this._documents.getDocument(B),fe=A.Position.to(K);return(0,y.asPromise)(()=>this._provider.provideImplementation(le,fe,ie)).then(p)}}class r{constructor(B,K){this._documents=B,this._provider=K}provideTypeDefinition(B,K,ie){const le=this._documents.getDocument(B),fe=A.Position.to(K);return(0,y.asPromise)(()=>this._provider.provideTypeDefinition(le,fe,ie)).then(p)}}class a{constructor(B,K){this._documents=B,this._provider=K}provideHover(B,K,ie){const le=this._documents.getDocument(B),fe=A.Position.to(K);return(0,y.asPromise)(()=>this._provider.provideHover(le,fe,ie)).then(Se=>{if(!(!Se||(0,i.isFalsyOrEmpty)(Se.contents)))return Se.range||(Se.range=le.getWordRangeAtPosition(fe)),Se.range||(Se.range=new T.Range(fe,fe)),A.Hover.from(Se)})}}class h{constructor(B,K){this._documents=B,this._provider=K}provideEvaluatableExpression(B,K,ie){const le=this._documents.getDocument(B),fe=A.Position.to(K);return(0,y.asPromise)(()=>this._provider.provideEvaluatableExpression(le,fe,ie)).then(Se=>{if(Se)return A.EvaluatableExpression.from(Se)})}}class b{constructor(B,K){this._documents=B,this._provider=K}provideInlineValues(B,K,ie,le){const fe=this._documents.getDocument(B);return(0,y.asPromise)(()=>this._provider.provideInlineValues(fe,A.Range.to(K),A.InlineValueContext.to(ie),le)).then(Se=>{if(Array.isArray(Se))return Se.map(Ne=>A.InlineValue.from(Ne))})}}class _{constructor(B,K){this._documents=B,this._provider=K}provideDocumentHighlights(B,K,ie){const le=this._documents.getDocument(B),fe=A.Position.to(K);return(0,y.asPromise)(()=>this._provider.provideDocumentHighlights(le,fe,ie)).then(Se=>{if(Array.isArray(Se))return Se.map(A.DocumentHighlight.from)})}}class v{constructor(B,K){this._documents=B,this._provider=K}provideLinkedEditingRanges(B,K,ie){const le=this._documents.getDocument(B),fe=A.Position.to(K);return(0,y.asPromise)(()=>this._provider.provideLinkedEditingRanges(le,fe,ie)).then(Se=>{if(Se&&Array.isArray(Se.ranges))return{ranges:(0,i.coalesce)(Se.ranges.map(A.Range.from)),wordPattern:Se.wordPattern}})}}class E{constructor(B,K){this._documents=B,this._provider=K}provideReferences(B,K,ie,le){const fe=this._documents.getDocument(B),Se=A.Position.to(K);return(0,y.asPromise)(()=>this._provider.provideReferences(fe,Se,ie,le)).then(Ne=>{if(Array.isArray(Ne))return Ne.map(A.location.from)})}}class F{constructor(B,K,ie,le,fe,Se,Ne){this._documents=B,this._commands=K,this._diagnostics=ie,this._provider=le,this._logService=fe,this._extension=Se,this._apiDeprecation=Ne,this._cache=new g.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(B,K,ie,le){const fe=this._documents.getDocument(B),Se=c.Selection.isISelection(K)?A.Selection.to(K):A.Range.to(K),Ne=[];for(const Ce of this._diagnostics.getDiagnostics(B))if(Se.intersection(Ce.range)&&Ne.push(Ce)>F._maxCodeActionsPerFile)break;const ge={diagnostics:Ne,only:ie.only?new T.CodeActionKind(ie.only):void 0,triggerKind:A.CodeActionTriggerKind.to(ie.trigger)};return(0,y.asPromise)(()=>this._provider.provideCodeActions(fe,Se,ge,le)).then(Ce=>{var Ae;if(!(!(0,i.isNonEmptyArray)(Ce)||le.isCancellationRequested)){const We=this._cache.add(Ce),Ee=new d.DisposableStore;this._disposables.set(We,Ee);const je=[];for(let H=0;H<Ce.length;H++){const te=Ce[H];!te||(F._isCommand(te)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),je.push({_isSynthetic:!0,title:te.title,command:this._commands.toInternal(te,Ee)})):(ge.only&&(te.kind?ge.only.contains(te.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action is of kind '${te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),je.push({cacheId:[We,H],title:te.title,command:te.command&&this._commands.toInternal(te.command,Ee),diagnostics:te.diagnostics&&te.diagnostics.map(A.Diagnostic.from),edit:te.edit&&A.WorkspaceEdit.from(te.edit),kind:te.kind&&te.kind.value,isPreferred:te.isPreferred,disabled:(Ae=te.disabled)===null||Ae===void 0?void 0:Ae.reason})))}return{cacheId:We,actions:je}}})}async resolveCodeAction(B,K){var ie;const[le,fe]=B,Se=this._cache.get(le,fe);if(!(!Se||F._isCommand(Se))&&!!this._provider.resolveCodeAction){const Ne=(ie=await this._provider.resolveCodeAction(Se,K))!==null&&ie!==void 0?ie:Se;return(Ne==null?void 0:Ne.edit)?A.WorkspaceEdit.from(Ne.edit):void 0}}releaseCodeActions(B){var K;(K=this._disposables.get(B))===null||K===void 0||K.dispose(),this._disposables.delete(B),this._cache.delete(B)}static _isCommand(B){return typeof B.command=="string"&&typeof B.title=="string"}}F._maxCodeActionsPerFile=1e3;class U{constructor(B,K){this._documents=B,this._provider=K}provideDocumentFormattingEdits(B,K,ie){const le=this._documents.getDocument(B);return(0,y.asPromise)(()=>this._provider.provideDocumentFormattingEdits(le,K,ie)).then(fe=>{if(Array.isArray(fe))return fe.map(A.TextEdit.from)})}}class J{constructor(B,K){this._documents=B,this._provider=K}provideDocumentRangeFormattingEdits(B,K,ie,le){const fe=this._documents.getDocument(B),Se=A.Range.to(K);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(fe,Se,ie,le)).then(Ne=>{if(Array.isArray(Ne))return Ne.map(A.TextEdit.from)})}}class me{constructor(B,K){this._documents=B,this._provider=K,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(B,K,ie,le,fe){const Se=this._documents.getDocument(B),Ne=A.Position.to(K);return(0,y.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(Se,Ne,ie,le,fe)).then(ge=>{if(Array.isArray(ge))return ge.map(A.TextEdit.from)})}}class q{constructor(B,K){this._provider=B,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(B,K){const ie=C.IdObject.mixin({symbols:[]});return(0,y.asPromise)(()=>this._provider.provideWorkspaceSymbols(B,K)).then(le=>{if((0,i.isNonEmptyArray)(le)){for(const fe of le)if(!!fe){if(!fe.name){this._logService.warn("INVALID SymbolInformation, lacks name",fe);continue}const Se=C.IdObject.mixin(A.WorkspaceSymbol.from(fe));this._symbolCache.set(Se._id,fe),ie.symbols.push(Se)}}}).then(()=>(ie.symbols.length>0&&this._resultCache.set(ie._id,[ie.symbols[0]._id,ie.symbols[ie.symbols.length-1]._id]),ie))}async resolveWorkspaceSymbol(B,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return B;const ie=this._symbolCache.get(B._id);if(ie){const le=await(0,y.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ie,K));return le&&(0,I.mixin)(B,A.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(B){const K=this._resultCache.get(B);if(K){for(let[ie,le]=K;ie<=le;ie++)this._symbolCache.delete(ie);this._resultCache.delete(B)}}}class z{constructor(B,K,ie){this._documents=B,this._provider=K,this._logService=ie}static supportsResolving(B){return typeof B.prepareRename=="function"}provideRenameEdits(B,K,ie,le){const fe=this._documents.getDocument(B),Se=A.Position.to(K);return(0,y.asPromise)(()=>this._provider.provideRenameEdits(fe,Se,ie,le)).then(Ne=>{if(!!Ne)return A.WorkspaceEdit.from(Ne)},Ne=>{const ge=z._asMessage(Ne);return ge?{rejectReason:ge,edits:void 0}:Promise.reject(Ne)})}resolveRenameLocation(B,K,ie){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(B),fe=A.Position.to(K);return(0,y.asPromise)(()=>this._provider.prepareRename(le,fe,ie)).then(Se=>{let Ne,ge;if(T.Range.isRange(Se)?(Ne=Se,ge=le.getText(Se)):(0,P.isObject)(Se)&&(Ne=Se.range,ge=Se.placeholder),!!Ne){if(Ne.start.line>fe.line||Ne.end.line<fe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:A.Range.from(Ne),text:ge}}},Se=>{const Ne=z._asMessage(Se);return Ne?{rejectReason:Ne,range:void 0,text:void 0}:Promise.reject(Se)})}static _asMessage(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class ee{constructor(B,K){this.resultId=B,this.tokens=K}}class ${constructor(B,K){this._documents=B,this._provider=K,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(B,K,ie){const le=this._documents.getDocument(B),fe=K!==0?this._previousResults.get(K):null;return(0,y.asPromise)(()=>fe&&typeof fe.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(le,fe.resultId,ie):this._provider.provideDocumentSemanticTokens(le,ie)).then(Se=>(fe&&this._previousResults.delete(K),Se?(Se=$._fixProvidedSemanticTokens(Se),this._send($._convertToEdits(fe,Se),Se)):null))}async releaseDocumentSemanticColoring(B){this._previousResults.delete(B)}static _fixProvidedSemanticTokens(B){return $._isSemanticTokens(B)?$._isCorrectSemanticTokens(B)?B:new T.SemanticTokens(new Uint32Array(B.data),B.resultId):$._isSemanticTokensEdits(B)?$._isCorrectSemanticTokensEdits(B)?B:new T.SemanticTokensEdits(B.edits.map(K=>new T.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),B.resultId):B}static _isSemanticTokens(B){return B&&!!B.data}static _isCorrectSemanticTokens(B){return B.data instanceof Uint32Array}static _isSemanticTokensEdits(B){return B&&Array.isArray(B.edits)}static _isCorrectSemanticTokensEdits(B){for(const K of B.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(B,K){if(!$._isSemanticTokens(K)||!B||!B.tokens)return K;const ie=B.tokens,le=ie.length,fe=K.data,Se=fe.length;let Ne=0;const ge=Math.min(le,Se);for(;Ne<ge&&ie[Ne]===fe[Ne];)Ne++;if(Ne===le&&Ne===Se)return new T.SemanticTokensEdits([],K.resultId);let Ce=0;const Ae=ge-Ne;for(;Ce<Ae&&ie[le-Ce-1]===fe[Se-Ce-1];)Ce++;return new T.SemanticTokensEdits([{start:Ne,deleteCount:le-Ne-Ce,data:fe.subarray(Ne,Se-Ce)}],K.resultId)}_send(B,K){if($._isSemanticTokens(B)){const ie=this._nextResultId++;return this._previousResults.set(ie,new ee(B.resultId,B.data)),(0,o.encodeSemanticTokensDto)({id:ie,type:"full",data:B.data})}if($._isSemanticTokensEdits(B)){const ie=this._nextResultId++;return $._isSemanticTokens(K)?this._previousResults.set(ie,new ee(K.resultId,K.data)):this._previousResults.set(ie,new ee(B.resultId)),(0,o.encodeSemanticTokensDto)({id:ie,type:"delta",deltas:(B.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=$;class R{constructor(B,K){this._documents=B,this._provider=K}provideDocumentRangeSemanticTokens(B,K,ie){const le=this._documents.getDocument(B);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(le,A.Range.to(K),ie)).then(fe=>fe?this._send(fe):null)}_send(B){return(0,o.encodeSemanticTokensDto)({id:0,type:"full",data:B.data})}}e.DocumentRangeSemanticTokensAdapter=R;class M{constructor(B,K,ie,le,fe){this._documents=B,this._commands=K,this._provider=ie,this._apiDeprecation=le,this._extension=fe,this._cache=new g.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}async provideCompletionItems(B,K,ie,le){const fe=this._documents.getDocument(B),Se=A.Position.to(K),Ne=fe.getWordRangeAtPosition(Se)||new T.Range(Se,Se),ge=Ne.with({end:Se}),Ce=new m.StopWatch(!0),Ae=await(0,y.asPromise)(()=>this._provider.provideCompletionItems(fe,Se,le,A.CompletionContext.to(ie)));if(!!Ae&&!le.isCancellationRequested){const We=Array.isArray(Ae)?new T.CompletionList(Ae):Ae,Ee=M.supportsResolving(this._provider)?this._cache.add(We.items):this._cache.add([]),je=new d.DisposableStore;this._disposables.set(Ee,je);const H=[],te={x:Ee,b:H,a:{replace:A.Range.from(Ne),insert:A.Range.from(ge)},c:We.isIncomplete||void 0,d:Ce.elapsed()};for(let ve=0;ve<We.items.length;ve++){const Le=We.items[ve],He=this._convertCompletionItem(Le,[Ee,ve],ge,Ne);H.push(He)}return te}}async resolveCompletionItem(B,K){if(typeof this._provider.resolveCompletionItem=="function"){const ie=this._cache.get(...B);if(!!ie){const le=await(0,y.asPromise)(()=>this._provider.resolveCompletionItem(ie,K));if(!!le)return this._convertCompletionItem(le,B)}}}releaseCompletionItems(B){var K;(K=this._disposables.get(B))===null||K===void 0||K.dispose(),this._disposables.delete(B),this._cache.delete(B)}_convertCompletionItem(B,K,ie,le){var fe;const Se=this._disposables.get(K[0]);if(!Se)throw Error("DisposableStore is missing...");const Ne={x:K,a:(fe=B.label)!==null&&fe!==void 0?fe:"",o:B.label2,b:B.kind!==void 0?A.CompletionItemKind.from(B.kind):void 0,n:B.tags&&B.tags.map(A.CompletionItemTag.from),c:B.detail,d:typeof B.documentation=="undefined"?void 0:A.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters,l:B.additionalTextEdits&&B.additionalTextEdits.map(A.TextEdit.from),m:this._commands.toInternal(B.command,Se)};B.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ne.h=B.textEdit.newText):typeof B.insertText=="string"?Ne.h=B.insertText:B.insertText instanceof T.SnippetString&&(Ne.h=B.insertText.value,Ne.i|=4);let ge;return B.textEdit?ge=B.textEdit.range:B.range&&(ge=B.range),T.Range.isRange(ge)?Ne.j=A.Range.from(ge):ge&&(!(ie==null?void 0:ie.isEqual(ge.inserting))||!(le==null?void 0:le.isEqual(ge.replacing)))&&(Ne.j={insert:A.Range.from(ge.inserting),replace:A.Range.from(ge.replacing)}),Ne}}class x{constructor(B,K){this._documents=B,this._provider=K,this._cache=new g.Cache("SignatureHelp")}provideSignatureHelp(B,K,ie,le){const fe=this._documents.getDocument(B),Se=A.Position.to(K),Ne=this.reviveContext(ie);return(0,y.asPromise)(()=>this._provider.provideSignatureHelp(fe,Se,le,Ne)).then(ge=>{if(ge){const Ce=this._cache.add([ge]);return Object.assign(Object.assign({},A.SignatureHelp.from(ge)),{id:Ce})}})}reviveContext(B){let K;if(B.activeSignatureHelp){const ie=A.SignatureHelp.to(B.activeSignatureHelp),le=this._cache.get(B.activeSignatureHelp.id,0);le?(K=le,K.activeSignature=ie.activeSignature,K.activeParameter=ie.activeParameter):K=ie}return Object.assign(Object.assign({},B),{activeSignatureHelp:K})}releaseSignatureHelp(B){this._cache.delete(B)}}class O{constructor(B,K){this._documents=B,this._provider=K}provideInlineHints(B,K,ie){const le=this._documents.getDocument(B);return(0,y.asPromise)(()=>this._provider.provideInlineHints(le,A.Range.to(K),ie)).then(fe=>fe?{hints:fe.map(A.InlineHint.from)}:void 0)}}class G{constructor(B,K){this._documents=B,this._provider=K,this._cache=new g.Cache("DocumentLink")}provideLinks(B,K){const ie=this._documents.getDocument(B);return(0,y.asPromise)(()=>this._provider.provideDocumentLinks(ie,K)).then(le=>{if(!(!Array.isArray(le)||le.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.map(A.DocumentLink.from)};{const fe=this._cache.add(le),Se={links:[],id:fe};for(let Ne=0;Ne<le.length;Ne++){const ge=A.DocumentLink.from(le[Ne]);ge.cacheId=[fe,Ne],Se.links.push(ge)}return Se}}})}resolveLink(B,K){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ie=this._cache.get(...B);return ie?(0,y.asPromise)(()=>this._provider.resolveDocumentLink(ie,K)).then(le=>le&&A.DocumentLink.from(le)||void 0):Promise.resolve(void 0)}releaseLinks(B){this._cache.delete(B)}}class Y{constructor(B,K){this._documents=B,this._provider=K}provideColors(B,K){const ie=this._documents.getDocument(B);return(0,y.asPromise)(()=>this._provider.provideDocumentColors(ie,K)).then(le=>Array.isArray(le)?le.map(Se=>({color:A.Color.from(Se.color),range:A.Range.from(Se.range)})):[])}provideColorPresentations(B,K,ie){const le=this._documents.getDocument(B),fe=A.Range.to(K.range),Se=A.Color.to(K.color);return(0,y.asPromise)(()=>this._provider.provideColorPresentations(Se,{document:le,range:fe},ie)).then(Ne=>{if(!!Array.isArray(Ne))return Ne.map(A.ColorPresentation.from)})}}class ne{constructor(B,K){this._documents=B,this._provider=K}provideFoldingRanges(B,K,ie){const le=this._documents.getDocument(B);return(0,y.asPromise)(()=>this._provider.provideFoldingRanges(le,K,ie)).then(fe=>{if(!!Array.isArray(fe))return fe.map(A.FoldingRange.from)})}}class pe{constructor(B,K,ie){this._documents=B,this._provider=K,this._logService=ie}provideSelectionRanges(B,K,ie){const le=this._documents.getDocument(B),fe=K.map(A.Position.to);return(0,y.asPromise)(()=>this._provider.provideSelectionRanges(le,fe,ie)).then(Se=>{if(!(0,i.isNonEmptyArray)(Se))return[];if(Se.length!==fe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ne=[];for(let ge=0;ge<fe.length;ge++){const Ce=[];Ne.push(Ce);let Ae=fe[ge],We=Se[ge];for(;;){if(!We.range.contains(Ae))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(A.SelectionRange.from(We)),!We.parent)break;Ae=We.range,We=We.parent}}return Ne})}}class Ie{constructor(B,K){this._documents=B,this._provider=K,this._idPool=new l.IdGenerator(""),this._cache=new Map}async prepareSession(B,K,ie){const le=this._documents.getDocument(B),fe=A.Position.to(K),Se=await this._provider.prepareCallHierarchy(le,fe,ie);if(!!Se){const Ne=this._idPool.nextId();return this._cache.set(Ne,new Map),Array.isArray(Se)?Se.map(ge=>this._cacheAndConvertItem(Ne,ge)):[this._cacheAndConvertItem(Ne,Se)]}}async provideCallsTo(B,K,ie){const le=this._itemFromCache(B,K);if(!le)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyIncomingCalls(le,ie);if(!!fe)return fe.map(Se=>({from:this._cacheAndConvertItem(B,Se.from),fromRanges:Se.fromRanges.map(Ne=>A.Range.from(Ne))}))}async provideCallsFrom(B,K,ie){const le=this._itemFromCache(B,K);if(!le)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyOutgoingCalls(le,ie);if(!!fe)return fe.map(Se=>({to:this._cacheAndConvertItem(B,Se.to),fromRanges:Se.fromRanges.map(Ne=>A.Range.from(Ne))}))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,K){var ie;const le=this._cache.get(B),fe={_sessionId:B,_itemId:le.size.toString(36),name:K.name,detail:K.detail,kind:A.SymbolKind.from(K.kind),uri:K.uri,range:A.Range.from(K.range),selectionRange:A.Range.from(K.selectionRange),tags:(ie=K.tags)===null||ie===void 0?void 0:ie.map(A.SymbolTag.from)};return le.set(fe._itemId,K),fe}_itemFromCache(B,K){const ie=this._cache.get(B);return ie==null?void 0:ie.get(K)}}class Oe{constructor(B,K){this.adapter=B,this.extension=K}}class Te{constructor(B,K,ie,le,fe,Se,Ne){this._adapter=new Map,this._uriTransformer=K,this._proxy=B.getProxy(C.MainContext.MainThreadLanguageFeatures),this._documents=ie,this._commands=le,this._diagnostics=fe,this._logService=Se,this._apiDeprecation=Ne}_transformDocumentSelector(B){return(0,i.coalesce)((0,i.asArray)(B).map(K=>this._doTransformDocumentSelector(K)))}_doTransformDocumentSelector(B){if(typeof B=="string")return{$serialized:!0,language:B};if(B)return{$serialized:!0,language:B.language,scheme:this._transformScheme(B.scheme),pattern:typeof B.pattern=="undefined"?void 0:A.GlobPattern.from(B.pattern),exclusive:B.exclusive}}_transformScheme(B){return this._uriTransformer&&typeof B=="string"?this._uriTransformer.transformOutgoingScheme(B):B}_createDisposable(B){return new T.Disposable(()=>{this._adapter.delete(B),this._proxy.$unregister(B)})}_nextHandle(){return Te._handlePool++}_withAdapter(B,K,ie,le,fe=!1){const Se=this._adapter.get(B);if(!Se)return Promise.resolve(le);if(Se.adapter instanceof K){let Ne;Se.extension&&(Ne=Date.now(),this._logService.trace(`[${Se.extension.identifier.value}] INVOKE provider '${K.name}'`));const ge=ie(Se.adapter,Se.extension),Ce=Se.extension;return Ce&&Promise.resolve(ge).then(()=>this._logService.trace(`[${Ce.identifier.value}] provider DONE after ${Date.now()-Ne}ms`),Ae=>{fe&&Ae instanceof D.CancellationError||(this._logService.error(`[${Ce.identifier.value}] provider FAILED`),this._logService.error(Ae))}),ge}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(B,K){const ie=this._nextHandle();return this._adapter.set(ie,new Oe(B,K)),ie}static _extLabel(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,K,ie,le){const fe=this._addNewAdapter(new f(this._documents,ie),B),Se=le&&le.label||Te._extLabel(B);return this._proxy.$registerDocumentSymbolProvider(fe,this._transformDocumentSelector(K),Se),this._createDisposable(fe)}$provideDocumentSymbols(B,K,ie){return this._withAdapter(B,f,le=>le.provideDocumentSymbols(w.URI.revive(K),ie),void 0)}registerCodeLensProvider(B,K,ie){const le=this._nextHandle(),fe=typeof ie.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new Oe(new u(this._documents,this._commands.converter,ie),B)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(K),fe);let Se=this._createDisposable(le);if(fe!==void 0){const Ne=ie.onDidChangeCodeLenses(ge=>this._proxy.$emitCodeLensEvent(fe));Se=T.Disposable.from(Se,Ne)}return Se}$provideCodeLenses(B,K,ie){return this._withAdapter(B,u,le=>le.provideCodeLenses(w.URI.revive(K),ie),void 0)}$resolveCodeLens(B,K,ie){return this._withAdapter(B,u,le=>le.resolveCodeLens(K,ie),void 0)}$releaseCodeLenses(B,K){this._withAdapter(B,u,ie=>Promise.resolve(ie.releaseCodeLenses(K)),void 0)}registerDefinitionProvider(B,K,ie){const le=this._addNewAdapter(new t(this._documents,ie),B);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideDefinition(B,K,ie,le){return this._withAdapter(B,t,fe=>fe.provideDefinition(w.URI.revive(K),ie,le),[])}registerDeclarationProvider(B,K,ie){const le=this._addNewAdapter(new n(this._documents,ie),B);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideDeclaration(B,K,ie,le){return this._withAdapter(B,n,fe=>fe.provideDeclaration(w.URI.revive(K),ie,le),[])}registerImplementationProvider(B,K,ie){const le=this._addNewAdapter(new s(this._documents,ie),B);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideImplementation(B,K,ie,le){return this._withAdapter(B,s,fe=>fe.provideImplementation(w.URI.revive(K),ie,le),[])}registerTypeDefinitionProvider(B,K,ie){const le=this._addNewAdapter(new r(this._documents,ie),B);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideTypeDefinition(B,K,ie,le){return this._withAdapter(B,r,fe=>fe.provideTypeDefinition(w.URI.revive(K),ie,le),[])}registerHoverProvider(B,K,ie,le){const fe=this._addNewAdapter(new a(this._documents,ie),B);return this._proxy.$registerHoverProvider(fe,this._transformDocumentSelector(K)),this._createDisposable(fe)}$provideHover(B,K,ie,le){return this._withAdapter(B,a,fe=>fe.provideHover(w.URI.revive(K),ie,le),void 0)}registerEvaluatableExpressionProvider(B,K,ie,le){const fe=this._addNewAdapter(new h(this._documents,ie),B);return this._proxy.$registerEvaluatableExpressionProvider(fe,this._transformDocumentSelector(K)),this._createDisposable(fe)}$provideEvaluatableExpression(B,K,ie,le){return this._withAdapter(B,h,fe=>fe.provideEvaluatableExpression(w.URI.revive(K),ie,le),void 0)}registerInlineValuesProvider(B,K,ie,le){const fe=typeof ie.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Se=this._addNewAdapter(new b(this._documents,ie),B);this._proxy.$registerInlineValuesProvider(Se,this._transformDocumentSelector(K),fe);let Ne=this._createDisposable(Se);if(fe!==void 0){const ge=ie.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(fe));Ne=T.Disposable.from(Ne,ge)}return Ne}$provideInlineValues(B,K,ie,le,fe){return this._withAdapter(B,b,Se=>Se.provideInlineValues(w.URI.revive(K),ie,le,fe),void 0)}registerDocumentHighlightProvider(B,K,ie){const le=this._addNewAdapter(new _(this._documents,ie),B);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideDocumentHighlights(B,K,ie,le){return this._withAdapter(B,_,fe=>fe.provideDocumentHighlights(w.URI.revive(K),ie,le),void 0)}registerLinkedEditingRangeProvider(B,K,ie){const le=this._addNewAdapter(new v(this._documents,ie),B);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideLinkedEditingRanges(B,K,ie,le){return this._withAdapter(B,v,async fe=>{const Se=await fe.provideLinkedEditingRanges(w.URI.revive(K),ie,le);if(Se)return{ranges:Se.ranges,wordPattern:Se.wordPattern?Te._serializeRegExp(Se.wordPattern):void 0}},void 0)}registerReferenceProvider(B,K,ie){const le=this._addNewAdapter(new E(this._documents,ie),B);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideReferences(B,K,ie,le,fe){return this._withAdapter(B,E,Se=>Se.provideReferences(w.URI.revive(K),ie,le,fe),void 0)}registerCodeActionProvider(B,K,ie,le){var fe,Se;const Ne=new d.DisposableStore,ge=this._addNewAdapter(new F(this._documents,this._commands.converter,this._diagnostics,ie,this._logService,B,this._apiDeprecation),B);return this._proxy.$registerQuickFixSupport(ge,this._transformDocumentSelector(K),{providedKinds:(fe=le==null?void 0:le.providedCodeActionKinds)===null||fe===void 0?void 0:fe.map(Ce=>Ce.value),documentation:(Se=le==null?void 0:le.documentation)===null||Se===void 0?void 0:Se.map(Ce=>({kind:Ce.kind.value,command:this._commands.converter.toInternal(Ce.command,Ne)}))},Te._extLabel(B),Boolean(ie.resolveCodeAction)),Ne.add(this._createDisposable(ge)),Ne}$provideCodeActions(B,K,ie,le,fe){return this._withAdapter(B,F,Se=>Se.provideCodeActions(w.URI.revive(K),ie,le,fe),void 0)}$resolveCodeAction(B,K,ie){return this._withAdapter(B,F,le=>le.resolveCodeAction(K,ie),void 0)}$releaseCodeActions(B,K){this._withAdapter(B,F,ie=>Promise.resolve(ie.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider(B,K,ie){const le=this._addNewAdapter(new U(this._documents,ie),B);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(K),B.identifier,B.displayName||B.name),this._createDisposable(le)}$provideDocumentFormattingEdits(B,K,ie,le){return this._withAdapter(B,U,fe=>fe.provideDocumentFormattingEdits(w.URI.revive(K),ie,le),void 0)}registerDocumentRangeFormattingEditProvider(B,K,ie){const le=this._addNewAdapter(new J(this._documents,ie),B);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(K),B.identifier,B.displayName||B.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(B,K,ie,le,fe){return this._withAdapter(B,J,Se=>Se.provideDocumentRangeFormattingEdits(w.URI.revive(K),ie,le,fe),void 0)}registerOnTypeFormattingEditProvider(B,K,ie,le){const fe=this._addNewAdapter(new me(this._documents,ie),B);return this._proxy.$registerOnTypeFormattingSupport(fe,this._transformDocumentSelector(K),le,B.identifier),this._createDisposable(fe)}$provideOnTypeFormattingEdits(B,K,ie,le,fe,Se){return this._withAdapter(B,me,Ne=>Ne.provideOnTypeFormattingEdits(w.URI.revive(K),ie,le,fe,Se),void 0)}registerWorkspaceSymbolProvider(B,K){const ie=this._addNewAdapter(new q(K,this._logService),B);return this._proxy.$registerNavigateTypeSupport(ie),this._createDisposable(ie)}$provideWorkspaceSymbols(B,K,ie){return this._withAdapter(B,q,le=>le.provideWorkspaceSymbols(K,ie),{symbols:[]})}$resolveWorkspaceSymbol(B,K,ie){return this._withAdapter(B,q,le=>le.resolveWorkspaceSymbol(K,ie),void 0)}$releaseWorkspaceSymbols(B,K){this._withAdapter(B,q,ie=>ie.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider(B,K,ie){const le=this._addNewAdapter(new z(this._documents,ie,this._logService),B);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(K),z.supportsResolving(ie)),this._createDisposable(le)}$provideRenameEdits(B,K,ie,le,fe){return this._withAdapter(B,z,Se=>Se.provideRenameEdits(w.URI.revive(K),ie,le,fe),void 0)}$resolveRenameLocation(B,K,ie,le){return this._withAdapter(B,z,fe=>fe.resolveRenameLocation(w.URI.revive(K),ie,le),void 0)}registerDocumentSemanticTokensProvider(B,K,ie,le){const fe=this._nextHandle(),Se=typeof ie.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(fe,new Oe(new $(this._documents,ie),B)),this._proxy.$registerDocumentSemanticTokensProvider(fe,this._transformDocumentSelector(K),le,Se);let Ne=this._createDisposable(fe);if(Se){const ge=ie.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(Se));Ne=T.Disposable.from(Ne,ge)}return Ne}$provideDocumentSemanticTokens(B,K,ie,le){return this._withAdapter(B,$,fe=>fe.provideDocumentSemanticTokens(w.URI.revive(K),ie,le),null,!0)}$releaseDocumentSemanticTokens(B,K){this._withAdapter(B,$,ie=>ie.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider(B,K,ie,le){const fe=this._addNewAdapter(new R(this._documents,ie),B);return this._proxy.$registerDocumentRangeSemanticTokensProvider(fe,this._transformDocumentSelector(K),le),this._createDisposable(fe)}$provideDocumentRangeSemanticTokens(B,K,ie,le){return this._withAdapter(B,R,fe=>fe.provideDocumentRangeSemanticTokens(w.URI.revive(K),ie,le),null,!0)}registerCompletionItemProvider(B,K,ie,le){const fe=this._addNewAdapter(new M(this._documents,this._commands.converter,ie,this._apiDeprecation,B),B);return this._proxy.$registerSuggestSupport(fe,this._transformDocumentSelector(K),le,M.supportsResolving(ie),`${B.identifier.value}(${le.join("")})`),this._createDisposable(fe)}$provideCompletionItems(B,K,ie,le,fe){return this._withAdapter(B,M,Se=>Se.provideCompletionItems(w.URI.revive(K),ie,le,fe),void 0)}$resolveCompletionItem(B,K,ie){return this._withAdapter(B,M,le=>le.resolveCompletionItem(K,ie),void 0)}$releaseCompletionItems(B,K){this._withAdapter(B,M,ie=>ie.releaseCompletionItems(K),void 0)}registerSignatureHelpProvider(B,K,ie,le){const fe=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,Se=this._addNewAdapter(new x(this._documents,ie),B);return this._proxy.$registerSignatureHelpProvider(Se,this._transformDocumentSelector(K),fe),this._createDisposable(Se)}$provideSignatureHelp(B,K,ie,le,fe){return this._withAdapter(B,x,Se=>Se.provideSignatureHelp(w.URI.revive(K),ie,le,fe),void 0)}$releaseSignatureHelp(B,K){this._withAdapter(B,x,ie=>ie.releaseSignatureHelp(K),void 0)}registerInlineHintsProvider(B,K,ie){const le=typeof ie.onDidChangeInlineHints=="function"?this._nextHandle():void 0,fe=this._addNewAdapter(new O(this._documents,ie),B);this._proxy.$registerInlineHintsProvider(fe,this._transformDocumentSelector(K),le);let Se=this._createDisposable(fe);if(le!==void 0){const Ne=ie.onDidChangeInlineHints(ge=>this._proxy.$emitInlineHintsEvent(le));Se=T.Disposable.from(Se,Ne)}return Se}$provideInlineHints(B,K,ie,le){return this._withAdapter(B,O,fe=>fe.provideInlineHints(w.URI.revive(K),ie,le),void 0)}registerDocumentLinkProvider(B,K,ie){const le=this._addNewAdapter(new G(this._documents,ie),B);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(K),typeof ie.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(B,K,ie){return this._withAdapter(B,G,le=>le.provideLinks(w.URI.revive(K),ie),void 0)}$resolveDocumentLink(B,K,ie){return this._withAdapter(B,G,le=>le.resolveLink(K,ie),void 0)}$releaseDocumentLinks(B,K){this._withAdapter(B,G,ie=>ie.releaseLinks(K),void 0)}registerColorProvider(B,K,ie){const le=this._addNewAdapter(new Y(this._documents,ie),B);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideDocumentColors(B,K,ie){return this._withAdapter(B,Y,le=>le.provideColors(w.URI.revive(K),ie),[])}$provideColorPresentations(B,K,ie,le){return this._withAdapter(B,Y,fe=>fe.provideColorPresentations(w.URI.revive(K),ie,le),void 0)}registerFoldingRangeProvider(B,K,ie){const le=this._nextHandle(),fe=typeof ie.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new Oe(new ne(this._documents,ie),B)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(K),fe);let Se=this._createDisposable(le);if(fe!==void 0){const Ne=ie.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(fe));Se=T.Disposable.from(Se,Ne)}return Se}$provideFoldingRanges(B,K,ie,le){return this._withAdapter(B,ne,fe=>fe.provideFoldingRanges(w.URI.revive(K),ie,le),void 0)}registerSelectionRangeProvider(B,K,ie){const le=this._addNewAdapter(new pe(this._documents,ie,this._logService),B);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$provideSelectionRanges(B,K,ie,le){return this._withAdapter(B,pe,fe=>fe.provideSelectionRanges(w.URI.revive(K),ie,le),[])}registerCallHierarchyProvider(B,K,ie){const le=this._addNewAdapter(new Ie(this._documents,ie),B);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(K)),this._createDisposable(le)}$prepareCallHierarchy(B,K,ie,le){return this._withAdapter(B,Ie,fe=>Promise.resolve(fe.prepareSession(w.URI.revive(K),ie,le)),void 0)}$provideCallHierarchyIncomingCalls(B,K,ie,le){return this._withAdapter(B,Ie,fe=>fe.provideCallsTo(K,ie,le),void 0)}$provideCallHierarchyOutgoingCalls(B,K,ie,le){return this._withAdapter(B,Ie,fe=>fe.provideCallsFrom(K,ie,le),void 0)}$releaseCallHierarchy(B,K){this._withAdapter(B,Ie,ie=>Promise.resolve(ie.releaseSession(K)),void 0)}static _serializeRegExp(B){return{pattern:B.source,flags:(0,S.regExpFlags)(B)}}static _serializeIndentationRule(B){return{decreaseIndentPattern:Te._serializeRegExp(B.decreaseIndentPattern),increaseIndentPattern:Te._serializeRegExp(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?Te._serializeRegExp(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?Te._serializeRegExp(B.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(B){return{beforeText:Te._serializeRegExp(B.beforeText),afterText:B.afterText?Te._serializeRegExp(B.afterText):void 0,previousLineText:B.previousLineText?Te._serializeRegExp(B.previousLineText):void 0,action:B.action}}static _serializeOnEnterRules(B){return B.map(Te._serializeOnEnterRule)}setLanguageConfiguration(B,K,ie){let{wordPattern:le}=ie;if(le&&(0,S.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(K,le):this._documents.setWordDefinitionFor(K,void 0),ie.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),ie.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const fe=this._nextHandle(),Se={comments:ie.comments,brackets:ie.brackets,wordPattern:ie.wordPattern?Te._serializeRegExp(ie.wordPattern):void 0,indentationRules:ie.indentationRules?Te._serializeIndentationRule(ie.indentationRules):void 0,onEnterRules:ie.onEnterRules?Te._serializeOnEnterRules(ie.onEnterRules):void 0,__electricCharacterSupport:ie.__electricCharacterSupport,__characterPairSupport:ie.__characterPairSupport};return this._proxy.$setLanguageConfiguration(fe,K,Se),this._createDisposable(fe)}$setWordDefinitions(B){for(const K of B)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=Te,Te._handlePool=0}),define(be[200],_e([0,1,5,9,7]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class T{constructor(C,S){this._proxy=C.getProxy(w.MainContext.MainThreadLanguages),this._documents=S}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(C,S){await this._proxy.$changeLanguage(C,S);const k=this._documents.getDocumentData(C);if(!k)throw new Error(`document '${C.toString}' NOT found`);return k.document}async tokenAtPosition(C,S){var k;const i=C.version,P=I.Position.from(S),c=await this._proxy.$tokensAtPosition(C.uri,P),d={type:A.StandardTokenType.Other,range:(k=C.getWordRangeAtPosition(S))!==null&&k!==void 0?k:new A.Range(S.line,S.character,S.line,S.character)};if(!c)return d;const o={range:I.Range.to(c.range),type:I.TokenType.to(c.type)};return!o.range.contains(S)||i!==C.version?d:o}}e.ExtHostLanguages=T}),define(be[201],_e([0,1,5,19,33]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(C){return C&&C.title}let y=class{constructor(S,k){this._logService=k,this._proxy=S.getProxy(w.MainContext.MainThreadMessageService)}showMessage(S,k,i,P,c){const d={extension:S};let o;typeof P=="string"||T(P)?o=[P,...c]:(d.modal=P&&P.modal,d.useCustom=P&&P.useCustom,o=c),d.useCustom&&(0,A.checkProposedApiEnabled)(S);const l=[];for(let g=0;g<o.length;g++){const m=o[g];if(typeof m=="string")l.push({title:m,handle:g,isCloseAffordance:!1});else if(typeof m=="object"){let{title:D,isCloseAffordance:f}=m;l.push({title:D,isCloseAffordance:!!f,handle:g})}else this._logService.warn("Invalid message item:",m)}return this._proxy.$showMessage(k,i,d,l).then(g=>{if(typeof g=="number")return o[g]})}};y=Ve([qe(1,I.ILogService)],y),e.ExtHostMessageService=y}),define(be[202],_e([0,1,20,3,6,2,5,9,7,73,22,179,180,54,10,23,56,68,8]),function(Q,e,w,I,A,T,y,C,S,k,i,P,c,d,o,l,g,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class f{constructor(s,r){const a=f._Keys.nextId();s.$registerNotebookEditorDecorationType(a,C.NotebookDecorationRenderOptions.from(r)),this.value={key:a,dispose(){s.$removeNotebookEditorDecorationType(a)}}}}e.NotebookEditorDecorationType=f,f._Keys=new d.IdGenerator("NotebookEditorDecorationType");class u{constructor(s,r,a,h,b,_){this._textDocumentsAndEditors=a,this._textDocuments=h,this.logService=b,this._extensionStoragePaths=_,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new i.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new I.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new I.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new I.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new I.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new I.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new I.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new I.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new I.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new I.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new I.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new I.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new I.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new i.ResourceMap,this._statusBarCache=new m.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=s.getProxy(y.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(y.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(y.MainContext.MainThreadNotebookEditors),this._commandsConverter=r.converter,r.registerArgumentProcessor({processArgument:v=>{var E;if(v&&v.$mid===12){const F=(E=v.notebookEditor)===null||E===void 0?void 0:E.notebookUri,U=v.cell.handle,J=this._documents.get(F),me=J==null?void 0:J.getCell(U);if(me)return me.apiCell}return v}})}get activeNotebookEditor(){var s;return(s=this._activeNotebookEditor)===null||s===void 0?void 0:s.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}getEditorById(s){return this._editors.get(s)}getIdByEditor(s){for(const[r,a]of this._editors)if(a.apiEditor===s)return r}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(s){return this._documents.get(s)}_getNotebookDocument(s){const r=this._documents.get(s);if(!r)throw new Error(`NO notebook document for '${s}'`);return r}_getProviderData(s){const r=this._notebookContentProviders.get(s);if(!r)throw new Error(`NO provider for '${s}'`);return r}registerNotebookContentProvider(s,r,a,h){var b,_,v;if((0,D.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(r))throw new Error(`Notebook provider for '${r}' already registered`);this._notebookContentProviders.set(r,{extension:s,provider:a});let E;a.onDidChangeNotebookContentOptions&&(E=a.onDidChangeNotebookContentOptions(()=>{const J=C.NotebookDocumentContentOptions.from(a.options);this._notebookProxy.$updateNotebookProviderOptions(r,J)}));const F=(b=h==null?void 0:h.viewOptions)===null||b===void 0?void 0:b.filenamePattern.map(J=>C.NotebookExclusiveDocumentPattern.from(J)).filter(J=>J!==void 0);((_=h==null?void 0:h.viewOptions)===null||_===void 0?void 0:_.filenamePattern)&&!F&&console.warn(`Notebook content provider view options file name pattern is invalid ${(v=h==null?void 0:h.viewOptions)===null||v===void 0?void 0:v.filenamePattern}`);const U=C.NotebookDocumentContentOptions.from(h);return this._notebookProxy.$registerNotebookProvider({id:s.identifier,location:s.extensionLocation,description:s.description},r,{transientOutputs:U.transientOutputs,transientCellMetadata:U.transientCellMetadata,transientDocumentMetadata:U.transientDocumentMetadata,viewOptions:(h==null?void 0:h.viewOptions)&&F?{displayName:h.viewOptions.displayName,filenamePattern:F,exclusive:h.viewOptions.exclusive||!1}:void 0}),new S.Disposable(()=>{E==null||E.dispose(),this._notebookContentProviders.delete(r),this._notebookProxy.$unregisterNotebookProvider(r)})}registerNotebookCellStatusBarItemProvider(s,r,a){const h=u._notebookStatusBarItemProviderHandlePool++,b=typeof a.onDidChangeCellStatusBarItems=="function"?u._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(h,a),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(h,b,r);let _;return b!==void 0&&(_=a.onDidChangeCellStatusBarItems(v=>this._notebookProxy.$emitCellStatusBarEvent(b))),new S.Disposable(()=>{this._notebookStatusBarItemProviders.delete(h),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(h,b),_&&_.dispose()})}createNotebookEditorDecorationType(s){return new f(this._notebookEditorsProxy,s).value}async openNotebookDocument(s){const r=this._documents.get(s);if(r)return r.apiNotebook;const a=await this._notebookDocumentsProxy.$tryOpenDocument(s),h=this._documents.get(T.URI.revive(a));return(0,o.assertIsDefined)(h==null?void 0:h.apiNotebook)}async showNotebookDocument(s,r){var a;T.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let h;typeof r=="object"?h={position:C.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus,selections:r.selections&&r.selections.map(C.NotebookRange.from),pinned:typeof r.preview=="boolean"?!r.preview:void 0}:h={preserveFocus:!1};const b=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.viewType,h),_=b&&((a=this._editors.get(b))===null||a===void 0?void 0:a.apiEditor);if(_)return _;throw b?new Error(`Could NOT open editor for "${s.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.toString()}".`)}async $provideNotebookCellStatusBarItems(s,r,a,h){var b;const _=this._notebookStatusBarItemProviders.get(s),v=T.URI.revive(r),E=this._documents.get(v);if(!(!E||!_)){const F=E.getCellFromIndex(a);if(!!F){const U=await _.provideCellStatusBarItems(F.apiCell,h);if(!!U){const J=new A.DisposableStore,me=this._statusBarCache.add([J]),q=(b=U&&U.map(z=>C.NotebookStatusBarItem.from(z,this._commandsConverter,J)))!==null&&b!==void 0?b:void 0;return{cacheId:me,items:q}}}}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,r,a,h){if((0,D.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");const b=this._handlePool++;this._notebookSerializer.set(b,a);const _=C.NotebookDocumentContentOptions.from(h);return this._notebookProxy.$registerNotebookSerializer(b,{id:s.identifier,location:s.extensionLocation,description:s.description},r,_),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(b)})}async $dataToNotebook(s,r,a){const h=this._notebookSerializer.get(s);if(!h)throw new Error("NO serializer found");const b=await h.deserializeNotebook(r.buffer,a);return{metadata:C.NotebookDocumentMetadata.from(b.metadata),cells:b.cells.map(C.NotebookCellData.from)}}async $notebookToData(s,r,a){const h=this._notebookSerializer.get(s);if(!h)throw new Error("NO serializer found");const b=await h.serializeNotebook({metadata:C.NotebookDocumentMetadata.to(r.metadata),cells:r.cells.map(C.NotebookCellData.to)},a);return l.VSBuffer.wrap(b)}cancelOneNotebookCellExecution(s){const r=this._activeExecutions.get(s.uri);r==null||r.cancel()}async $openNotebook(s,r,a,h,b){const{provider:_}=this._getProviderData(s),v=await _.openNotebook(T.URI.revive(r),{backupId:a,untitledDocumentData:h==null?void 0:h.buffer},b);return{metadata:C.NotebookDocumentMetadata.from(v.metadata),cells:v.cells.map(C.NotebookCellData.from)}}async $saveNotebook(s,r,a){const h=this._getNotebookDocument(T.URI.revive(r)),{provider:b}=this._getProviderData(s);return await b.saveNotebook(h.apiNotebook,a),!0}async $saveNotebookAs(s,r,a,h){const b=this._getNotebookDocument(T.URI.revive(r)),{provider:_}=this._getProviderData(s);return await _.saveNotebookAs(T.URI.revive(a),b.apiNotebook,h),!0}async $backupNotebook(s,r,a){var h;const b=this._getNotebookDocument(T.URI.revive(r)),_=this._getProviderData(s),v=(h=this._extensionStoragePaths.workspaceValue(_.extension))!==null&&h!==void 0?h:this._extensionStoragePaths.globalValue(_.extension),E=String((0,g.hash)([b.uri.toString(),this._backupIdPool++])),F=T.URI.joinPath(v,E),U=await _.provider.backupNotebook(b.apiNotebook,{destination:F},a);return b.updateBackup(U),U.id}$acceptModelChanged(s,r,a){this._getNotebookDocument(T.URI.revive(s)).acceptModelChanged(r,a)}$acceptDirtyStateChanged(s,r){const a=this._getNotebookDocument(T.URI.revive(s));a.acceptModelChanged({rawEvents:[],versionId:a.apiNotebook.version},r)}$acceptModelSaved(s){const r=this._getNotebookDocument(T.URI.revive(s));this._onDidSaveNotebookDocument.fire(r.apiNotebook)}$acceptEditorPropertiesChanged(s,r){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",s,r);const a=this._editors.get(s);if(!a)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);r.visibleRanges&&a._acceptVisibleRanges(r.visibleRanges.ranges.map(C.NotebookRange.to)),r.selections&&a._acceptSelections(r.selections.selections.map(C.NotebookRange.to)),r.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:a.apiEditor,visibleRanges:a.apiEditor.visibleRanges}),r.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:a.apiEditor,selections:a.apiEditor.selections}))}$acceptEditorViewColumns(s){for(const r in s){const a=this._editors.get(r);if(!a)throw new Error(`unknown text editor: ${r}. known editors: ${[...this._editors.keys()]} `);a._acceptViewColumn(C.ViewColumn.to(s[r]))}}$acceptDocumentPropertiesChanged(s,r){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",s.path,r);const a=this._getNotebookDocument(T.URI.revive(s));a.acceptDocumentPropertiesChanged(r),r.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:a.apiNotebook})}_createExtHostEditor(s,r,a){if(this._editors.has(r))throw new Error(`editor with id ALREADY EXSIST: ${r}`);const h=new c.ExtHostNotebookEditor(r,this._notebookEditorsProxy,s,a.visibleRanges.map(C.NotebookRange.to),a.selections.map(C.NotebookRange.to),typeof a.viewColumn=="number"?C.ViewColumn.to(a.viewColumn):void 0);this._editors.set(r,h)}$acceptDocumentAndEditorsDelta(s){var r,a,h;if(s.removedDocuments)for(const _ of s.removedDocuments){const v=T.URI.revive(_),E=this._documents.get(v);E&&(E.dispose(),this._documents.delete(v),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:E.apiNotebook.getCells().map(F=>F.document.uri)}),this._onDidCloseNotebookDocument.fire(E.apiNotebook));for(const F of this._editors.values())F.notebookData.uri.toString()===v.toString()&&this._editors.delete(F.id)}if(s.addedDocuments){const _=[];for(const v of s.addedDocuments){const E=T.URI.revive(v.uri),F=v.viewType;if(this._documents.has(E))throw new Error(`adding EXISTING notebook ${E} `);const U=this,J=new P.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(me){U._onDidChangeNotebookCells.fire(me)},emitCellOutputsChange(me){U._onDidChangeCellOutputs.fire(me)},emitCellMetadataChange(me){U._onDidChangeCellMetadata.fire(me)},emitCellExecutionStateChange(me){U._onDidChangeCellExecutionState.fire(me)}},F,v.metadata?C.NotebookDocumentMetadata.to(v.metadata):new S.NotebookDocumentMetadata,E);J.acceptModelChanged({versionId:v.versionId,rawEvents:[{kind:k.NotebookCellsChangeType.Initialize,changes:[[0,0,v.cells]]}]},!1),_.push(...v.cells.map(me=>P.ExtHostCell.asModelAddData(J.apiNotebook,me))),(r=this._documents.get(E))===null||r===void 0||r.dispose(),this._documents.set(E,J),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:_}),this._onDidOpenNotebookDocument.fire(J.apiNotebook)}}if(s.addedEditors)for(const _ of s.addedEditors){if(this._editors.has(_.id))return;const v=T.URI.revive(_.documentUri),E=this._documents.get(v);E&&this._createExtHostEditor(E,_.id,_)}const b=[];if(s.removedEditors)for(const _ of s.removedEditors){const v=this._editors.get(_);v&&(this._editors.delete(_),((a=this._activeNotebookEditor)===null||a===void 0?void 0:a.id)===v.id&&(this._activeNotebookEditor=void 0),b.push(v))}if(s.visibleEditors){this._visibleNotebookEditors=s.visibleEditors.map(v=>this._editors.get(v)).filter(v=>!!v);const _=new Set;this._visibleNotebookEditors.forEach(v=>_.add(v.id));for(const v of this._editors.values()){const E=_.has(v.id);v._acceptVisibility(E)}this._visibleNotebookEditors=[...this._editors.values()].map(v=>v).filter(v=>v.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.newActiveEditor===null?this._activeNotebookEditor=void 0:s.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(s.newActiveEditor)),s.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((h=this._activeNotebookEditor)===null||h===void 0?void 0:h.apiEditor)}createNotebookCellExecution(s,r,a){const h=this.lookupNotebookDocument(s);if(!h)throw new Error(`Invalid uri: ${s} `);const b=h.getCellFromIndex(r);if(!b)throw new Error(`Invalid cell index: ${s}, ${r} `);if(this._activeExecutions.has(b.uri))throw new Error(`duplicate execution for ${b.uri}`);const _=new t(s,h,b,this._notebookDocumentsProxy);this._activeExecutions.set(b.uri,_);const v=_.onDidChangeState(()=>{_.state===p.Resolved&&(_.dispose(),v.dispose(),this._activeExecutions.delete(b.uri))});return _.asApiObject()}}e.ExtHostNotebookController=u,u._notebookStatusBarItemProviderHandlePool=0;var p;(function(n){n[n.Init=0]="Init",n[n.Started=1]="Started",n[n.Resolved=2]="Resolved"})(p||(p={}));class t extends A.Disposable{constructor(s,r,a,h){super();this._uri=s,this._document=r,this._cell=a,this._proxy=h,this._onDidChangeState=new I.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=p.Init,this._tokenSource=this._register(new w.CancellationTokenSource),this._executionOrder=a.internalMetadata.executionOrder,this.mixinMetadata({runState:S.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEdits(s){return this._proxy.$applyEdits(this._uri,s,!1)}verifyStateForOutput(){if(this._state===p.Init)throw new Error("Must call start before modifying cell output");if(this._state===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(s){const r=[{editType:11,handle:this._cell.handle,metadata:s}];this.applyEdits(r)}cellIndexToHandle(s){const r=typeof s=="number"?this._document.getCellFromIndex(s):this._cell;if(!!r)return r.handle}asApiObject(){const s=this;return Object.freeze({get document(){return s._document.apiNotebook},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(r){s._executionOrder=r,s.mixinMetadata({executionOrder:r})},start(r){var a;if(s._state===p.Resolved||s._state===p.Started)throw new Error("Cannot call start again");s._state=p.Started,s._onDidChangeState.fire(),s.mixinMetadata({runState:S.NotebookCellExecutionState.Executing,runStartTime:(a=r==null?void 0:r.startTime)!==null&&a!==void 0?a:null})},end(r){var a,h;if(s._state===p.Resolved)throw new Error("Cannot call resolve twice");s._state=p.Resolved,s._onDidChangeState.fire(),s.mixinMetadata({runState:S.NotebookCellExecutionState.Idle,lastRunSuccess:(a=r==null?void 0:r.success)!==null&&a!==void 0?a:null,runEndTime:(h=r==null?void 0:r.endTime)!==null&&h!==void 0?h:null})},clearOutput(r){return s.verifyStateForOutput(),this.replaceOutput([],r)},async appendOutput(r,a){s.verifyStateForOutput();const h=s.cellIndexToHandle(a);if(typeof h=="number")return r=Array.isArray(r)?r:[r],s.applyEdits([{editType:2,handle:h,append:!0,outputs:r.map(C.NotebookCellOutput.from)}])},async replaceOutput(r,a){s.verifyStateForOutput();const h=s.cellIndexToHandle(a);if(typeof h=="number")return r=Array.isArray(r)?r:[r],s.applyEdits([{editType:2,handle:h,outputs:r.map(C.NotebookCellOutput.from)}])},async appendOutputItems(r,a){return s.verifyStateForOutput(),r=Array.isArray(r)?r:[r],s.applyEdits([{editType:10,append:!0,items:r.map(C.NotebookCellOutputItem.from),outputId:a}])},async replaceOutputItems(r,a){return s.verifyStateForOutput(),r=Array.isArray(r)?r:[r],s.applyEdits([{editType:10,items:r.map(C.NotebookCellOutputItem.from),outputId:a}])},token:s._tokenSource.token})}}}),define(be[203],_e([0,1,3,6,5,2,9,72]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class S{constructor(i,P,c){this._initData=P,this._extHostNotebook=c,this._kernelData=new Map,this._handlePool=0,this._proxy=i.getProxy(A.MainContext.MainThreadNotebookKernels)}createNotebookController(i,P,c,d,o,l){for(let _ of this._kernelData.values())if(_.controller.id===P)throw new Error(`notebook controller with id '${P}' ALREADY exist`);const g=this._handlePool++,m=this,D=()=>console.warn(`NO execute handler from notebook controller '${n.id}' of extension: '${i.identifier}'`);let f=!1;const u=new I.DisposableStore,p=new w.Emitter,t=new w.Emitter,n={id:P,selector:c,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:d||i.identifier.value,preloads:l?l.map(y.NotebookKernelPreload.from):[]};let s=o!=null?o:D,r;this._proxy.$addKernel(g,n).catch(_=>{console.log(_),f=!0});let a=0;const h=()=>{if(!f){const _=++a;Promise.resolve().then(()=>{_===a&&this._proxy.$updateKernel(g,n)})}},b={get id(){return n.id},get selector(){return n.selector},onDidChangeNotebookAssociation:p.event,get label(){return n.label},set label(_){var v;n.label=(v=_!=null?_:i.displayName)!==null&&v!==void 0?v:i.name,h()},get detail(){var _;return(_=n.detail)!==null&&_!==void 0?_:""},set detail(_){n.detail=_,h()},get description(){var _;return(_=n.description)!==null&&_!==void 0?_:""},set description(_){n.description=_,h()},get isPreferred(){var _;return(_=n.isPreferred)!==null&&_!==void 0?_:!1},set isPreferred(_){n.isPreferred=_,h()},get supportedLanguages(){var _;return(_=n.supportedLanguages)!==null&&_!==void 0?_:[]},set supportedLanguages(_){n.supportedLanguages=_,h()},get hasExecutionOrder(){var _;return(_=n.hasExecutionOrder)!==null&&_!==void 0?_:!1},set hasExecutionOrder(_){n.hasExecutionOrder=_,h()},get preloads(){return n.preloads?n.preloads.map(y.NotebookKernelPreload.to):[]},get executeHandler(){return s},set executeHandler(_){s=_!=null?_:D},get interruptHandler(){return r},set interruptHandler(_){r=_,n.supportsInterrupt=Boolean(_),h()},createNotebookCellExecutionTask(_){if(f)throw new Error("notebook controller is DISPOSED");return m._extHostNotebook.createNotebookCellExecution(_.notebook.uri,_.index,n.id)},dispose:()=>{f||(f=!0,this._kernelData.delete(g),u.dispose(),p.dispose(),t.dispose(),this._proxy.$removeKernel(g))},onDidReceiveMessage:t.event,postMessage(_,v){return m._proxy.$postMessage(g,v&&m._extHostNotebook.getIdByEditor(v),_)},asWebviewUri(_){return(0,C.asWebviewUri)(m._initData.environment,String(g),_)}};return this._kernelData.set(g,{extensionId:i.identifier,controller:b,onDidChangeSelection:p,onDidReceiveMessage:t}),b}$acceptSelection(i,P,c){const d=this._kernelData.get(i);d&&d.onDidChangeSelection.fire({selected:c,notebook:this._extHostNotebook.lookupNotebookDocument(T.URI.revive(P)).apiNotebook})}async $executeCells(i,P,c){const d=this._kernelData.get(i);if(!!d){const o=this._extHostNotebook.lookupNotebookDocument(T.URI.revive(P));if(!o)throw new Error("MISSING notebook");const l=[];for(let g of c){const m=o.getCell(g);m&&l.push(m.apiCell)}try{await d.controller.executeHandler.call(d.controller,l,d.controller)}catch(g){console.error(g)}}}async $cancelCells(i,P,c){const d=this._kernelData.get(i);if(!!d){const o=this._extHostNotebook.lookupNotebookDocument(T.URI.revive(P));if(!o)throw new Error("MISSING notebook");d.controller.interruptHandler&&await d.controller.interruptHandler.call(d.controller);for(let l of c){const g=o.getCell(l);g&&this._extHostNotebook.cancelOneNotebookCellExecution(g)}}}$acceptRendererMessage(i,P,c){const d=this._kernelData.get(i);if(!!d){const o=this._extHostNotebook.getEditorById(P);if(!o)throw new Error(`send message for UNKNOWN editor: ${P}`);d.onDidReceiveMessage.fire(Object.freeze({editor:o.apiEditor,message:c}))}}}e.ExtHostNotebookKernels=S}),define(be[100],_e([0,1,5,3,6,23,4,14]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class S extends A.Disposable{constructor(o,l,g,m){super();this._onDidAppend=this._register(new I.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=o,this._proxy=m,this._id=m.$register(this.name,l,g),this._disposed=!1,this._offset=0}get name(){return this._name}append(o){this.validate(),this._offset+=o?T.VSBuffer.fromString(o).byteLength:0}update(){this._id.then(o=>this._proxy.$update(o))}appendLine(o){this.validate(),this.append(o+`
`)}clear(){this.validate();const o=this._offset;this._id.then(l=>this._proxy.$clear(l,o))}show(o,l){this.validate(),this._id.then(g=>this._proxy.$reveal(g,!!(typeof o=="boolean"?o:l)))}hide(){this.validate(),this._id.then(o=>this._proxy.$close(o))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(o=>this._proxy.$dispose(o)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=S;class k extends S{constructor(o,l){super(o,!1,void 0,l)}append(o){super.append(o),this._id.then(l=>this._proxy.$append(l,o)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class i extends S{constructor(o,l,g){super(o,!0,l,g)}append(o){throw new Error("Not supported")}}class P{constructor(o,l){this.name=o,this._channel=l}append(o){this._channel.then(l=>l.append(o))}appendLine(o){this._channel.then(l=>l.appendLine(o))}clear(){this._channel.then(o=>o.clear())}show(o,l){this._channel.then(g=>g.show(o,l))}hide(){this._channel.then(o=>o.hide())}dispose(){this._channel.then(o=>o.dispose())}}e.LazyOutputChannel=P;let c=class{constructor(o){this._proxy=o.getProxy(w.MainContext.MainThreadOutputService)}$setVisibleChannel(o){}createOutputChannel(o){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");return new k(o,this._proxy)}createOutputChannelFromLogFile(o,l){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");if(!l)throw new Error("illegal argument `file`. must not be falsy");return new i(o,l,this._proxy)}};c=Ve([qe(0,C.IExtHostRpcService)],c),e.ExtHostOutputService=c,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(be[204],_e([0,1,11,20,3,6,5,2,7,12,15,47]),function(Q,e,w,I,A,T,y,C,S,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function c(d,o,l){const g=d.getProxy(y.MainContext.MainThreadQuickOpen);class m{constructor(r,a){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=a}showQuickPick(r,a,h,b=I.CancellationToken.None){this._onDidSelectItem=void 0;const _=Promise.resolve(r),v=++this._instances,E=g.$show(v,{title:h==null?void 0:h.title,placeHolder:h==null?void 0:h.placeHolder,matchOnDescription:h==null?void 0:h.matchOnDescription,matchOnDetail:h==null?void 0:h.matchOnDetail,ignoreFocusLost:h==null?void 0:h.ignoreFocusOut,canPickMany:h==null?void 0:h.canPickMany},b),F={},U=E.then(()=>F);return Promise.race([U,_]).then(J=>{if(J!==F)return _.then(me=>{const q=[];for(let z=0;z<me.length;z++){const ee=me[z];let $,R,M,x,O;typeof ee=="string"?$=ee:($=ee.label,R=ee.description,M=ee.detail,x=ee.picked,O=ee.alwaysShow),q.push({label:$,description:R,handle:z,detail:M,picked:x,alwaysShow:O})}return h&&typeof h.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{h.onDidSelectItem(me[z])}),g.$setItems(v,q),E.then(z=>{if(typeof z=="number")return me[z];if(Array.isArray(z))return z.map(ee=>me[ee])})})}).then(void 0,J=>{if(!(0,k.isPromiseCanceledError)(J))return g.$setError(v,J),Promise.reject(J)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,a=I.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,g.$input(r,typeof this._validateInput=="function",a).then(void 0,h=>{if(!(0,k.isPromiseCanceledError)(h))return Promise.reject(h)})}$validateInput(r){return this._validateInput?(0,w.asPromise)(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,a=I.CancellationToken.None){const h=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!!h){const b=await this._workspace.getWorkspaceFolders2();if(!!b)return b.find(_=>_.uri.toString()===h.uri.toString())}}createQuickPick(r,a){const h=new t(r,a,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}createInputBox(r){const a=new n(r,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(r,a){const h=this._sessions.get(r);h&&h._fireDidChangeValue(a)}$onDidAccept(r){const a=this._sessions.get(r);a&&a._fireDidAccept()}$onDidChangeActive(r,a){const h=this._sessions.get(r);h instanceof t&&h._fireDidChangeActive(a)}$onDidChangeSelection(r,a){const h=this._sessions.get(r);h instanceof t&&h._fireDidChangeSelection(a)}$onDidTriggerButton(r,a){const h=this._sessions.get(r);h&&h._fireDidTriggerButton(a)}$onDidHide(r){const a=this._sessions.get(r);a&&a._fireDidHide()}}class D{constructor(r,a){this._extensionId=r,this._onDidDispose=a,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new A.Emitter,this._onDidChangeValueEmitter=new A.Emitter,this._onDidTriggerButtonEmitter=new A.Emitter,this._onDidHideEmitter=new A.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((a,h)=>{const b=a===S.QuickInputButtons.Back?-1:h;this._handlesToButtons.set(b,a)}),this.update({buttons:r.map((a,h)=>({iconPath:f(a.iconPath),tooltip:a.tooltip,handle:a===S.QuickInputButtons.Back?-1:h}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const a=this._handlesToButtons.get(r);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),g.$dispose(this._id))}update(r){if(!this._disposed){for(const a of Object.keys(r)){const h=r[a];this._pendingUpdate[a]=h===void 0?null:h}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){g.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}D._nextId=1;function f(s){if(s instanceof S.ThemeIcon)return{id:s.id};const r=p(s),a=u(s);return{dark:typeof r=="string"?C.URI.file(r):r,light:typeof a=="string"?C.URI.file(a):a}}function u(s){return typeof s=="object"&&"light"in s?s.light:s}function p(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends D{constructor(r,a,h){super(r,h);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new A.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new A.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((a,h)=>{this._handlesToItems.set(h,a),this._itemsToHandles.set(a,h)}),this.update({items:r.map((a,h)=>({label:a.label,description:a.description,handle:h,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(r){const a=(0,i.coalesce)(r.map(h=>this._handlesToItems.get(h)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(r){const a=(0,i.coalesce)(r.map(h=>this._handlesToItems.get(h)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}}class n extends D{constructor(r,a){super(r,a);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?P.default.Error:P.default.Ignore})}}return new m(o,l)}e.createExtHostQuickOpen=c}),define(be[205],_e([0,1,2,3,52,6,11,5,15,112,19,26,33]),function(Q,e,w,I,A,T,y,C,S,k,i,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function d(r){if(r)return typeof r.iconPath=="string"?w.URI.file(r.iconPath):r.iconPath}function o(r,a){if(!r.iconPath&&!a.iconPath)return 0;if(r.iconPath){if(!a.iconPath)return 1}else return-1;const h=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath,b=typeof a.iconPath=="string"?a.iconPath:a.iconPath.fsPath;return(0,k.comparePaths)(h,b)}function l(r,a){let h=0;if(r.strikeThrough!==a.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==a.faded)return r.faded?1:-1;if(r.tooltip!==a.tooltip)return(r.tooltip||"").localeCompare(a.tooltip||"");if(h=o(r,a),h!==0)return h;if(r.light&&a.light)h=o(r.light,a.light);else{if(r.light)return 1;if(a.light)return-1}if(h!==0)return h;if(r.dark&&a.dark)h=o(r.dark,a.dark);else{if(r.dark)return 1;if(a.dark)return-1}return h}function g(r,a){if(r.command!==a.command)return r.command<a.command?-1:1;if(r.title!==a.title)return r.title<a.title?-1:1;if(r.tooltip!==a.tooltip){if(r.tooltip!==void 0&&a.tooltip!==void 0)return r.tooltip<a.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(a.tooltip!==void 0)return-1}if(r.arguments===a.arguments)return 0;if(r.arguments)if(a.arguments){if(r.arguments.length!==a.arguments.length)return r.arguments.length-a.arguments.length}else return 1;else return-1;for(let h=0;h<r.arguments.length;h++){const b=r.arguments[h],_=a.arguments[h];if(b!==_)return b<_?-1:1}return 0}function m(r,a){let h=(0,k.comparePaths)(r.resourceUri.fsPath,a.resourceUri.fsPath,!0);if(h!==0)return h;if(r.command&&a.command)h=g(r.command,a.command);else{if(r.command)return 1;if(a.command)return-1}if(h!==0)return h;if(r.decorations&&a.decorations)h=l(r.decorations,a.decorations);else{if(r.decorations)return 1;if(a.decorations)return-1}return h}function D(r,a){for(let h=0;h<r.length;h++)if(r[h]!==a[h])return!1;return!0}function f(r,a){return r.command===a.command&&r.title===a.title&&r.tooltip===a.tooltip&&(r.arguments&&a.arguments?D(r.arguments,a.arguments):r.arguments===a.arguments)}function u(r,a){return(0,S.equals)(r,a,f)}class p{constructor(a,h,b){this._extension=a,this._proxy=h,this._sourceControlHandle=b,this._value="",this._onDidChange=new I.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(a){this._proxy.$setInputBoxValue(this._sourceControlHandle,a),this.updateValue(a)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(a){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,a),this._placeholder=a}get validateInput(){return(0,c.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(a){if((0,c.checkProposedApiEnabled)(this._extension),a&&typeof a!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=a,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!a)}get visible(){return this._visible}set visible(a){a=!!a,this._visible!==a&&(this._visible=a,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,a))}focus(){(0,c.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(a,h){(0,c.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,a,h)}$onInputBoxValueChange(a){this.updateValue(a)}updateValue(a){this._value=a,this._onDidChange.fire(a)}}e.ExtHostSCMInputBox=p;class t{constructor(a,h,b,_,v){this._proxy=a,this._commands=h,this._sourceControlHandle=b,this._id=_,this._label=v,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new I.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new I.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(a){this._label=a,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,a)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(a){this._hideWhenEmpty=a,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(a){this._resourceStates=[...a],this._onDidUpdateResourceStates.fire()}getResourceState(a){return this._resourceStatesMap.get(a)}$executeResourceCommand(a,h){const b=this._resourceStatesCommandsMap.get(a);return b?(0,y.asPromise)(()=>this._commands.executeCommand(b.command,...b.arguments||[],h)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var a;const h=[...this._resourceStates].sort(m),_=(0,S.sortedDiff)(this._resourceSnapshot,h,m).map(F=>{const U=F.toInsert.map(J=>{const me=this._resourceHandlePool++;this._resourceStatesMap.set(me,J);const q=J.resourceUri,z=d(J.decorations),ee=J.decorations&&d(J.decorations.light)||z,$=J.decorations&&d(J.decorations.dark)||z,R=[];let M;if(J.command)if(J.command.command==="vscode.open"||J.command.command==="vscode.diff"){const pe=new T.DisposableStore;M=this._commands.converter.toInternal(J.command,pe),this._resourceStatesDisposablesMap.set(me,pe)}else this._resourceStatesCommandsMap.set(me,J.command);ee&&R.push(ee),$&&$.toString()!==(ee==null?void 0:ee.toString())&&R.push($);const x=J.decorations&&J.decorations.tooltip||"",O=J.decorations&&!!J.decorations.strikeThrough,G=J.decorations&&!!J.decorations.faded,Y=J.contextValue||"";return{rawResource:[me,q,R,x,O,G,Y,M],handle:me}});return{start:F.start,deleteCount:F.deleteCount,toInsert:U}}),v=_.map(({start:F,deleteCount:U,toInsert:J})=>[F,U,J.map(me=>me.rawResource)]),E=_.reverse();for(const{start:F,deleteCount:U,toInsert:J}of E){const me=J.map(z=>z.handle),q=this._handlesSnapshot.splice(F,U,...me);for(const z of q)this._resourceStatesMap.delete(z),this._resourceStatesCommandsMap.delete(z),(a=this._resourceStatesDisposablesMap.get(z))===null||a===void 0||a.dispose(),this._resourceStatesDisposablesMap.delete(z)}return this._resourceSnapshot=h,v}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(a,h,b,_,v,E){this._proxy=h,this._commands=b,this._id=_,this._label=v,this._rootUri=E,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new I.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new p(a,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,_,v,E)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(a){this._count!==a&&(this._count=a,this._proxy.$updateSourceControl(this.handle,{count:a}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(a){this._quickDiffProvider=a,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!a})}get commitTemplate(){return this._commitTemplate}set commitTemplate(a){a!==this._commitTemplate&&(this._commitTemplate=a,this._proxy.$updateSourceControl(this.handle,{commitTemplate:a}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(a){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=a;const h=this._commands.converter.toInternal(a,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:h})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(a){if(!(this._statusBarCommands&&a&&u(this._statusBarCommands,a))){this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=a;const h=(a||[]).map(b=>this._commands.converter.toInternal(b,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:h})}}get selected(){return this._selected}createResourceGroup(a,h){const b=new t(this._proxy,this._commands,this.handle,a,h),_=I.Event.once(b.onDidDispose)(()=>this.createdResourceGroups.delete(b));return this.createdResourceGroups.set(b,_),this.eventuallyAddResourceGroups(),b}eventuallyAddResourceGroups(){const a=[],h=[];for(const[b,_]of this.createdResourceGroups){_.dispose();const v=b.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(b),this.eventuallyUpdateResourceStates()});I.Event.once(b.onDidDispose)(()=>{this.updatedResourceGroups.delete(b),v.dispose(),this._groups.delete(b.handle),this._proxy.$unregisterGroup(this.handle,b.handle)}),a.push([b.handle,b.id,b.label,b.features]);const E=b._takeResourceStateSnapshot();E.length>0&&h.push([b.handle,E]),this._groups.set(b.handle,b)}this._proxy.$registerGroups(this.handle,a,h),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const a=[];this.updatedResourceGroups.forEach(h=>{const b=h._takeResourceStateSnapshot();b.length!==0&&a.push([h.handle,b])}),a.length>0&&this._proxy.$spliceResourceStates(this.handle,a),this.updatedResourceGroups.clear()}getResourceGroup(a){return this._groups.get(a)}setSelectionState(a){this._selected=a,this._onDidChangeSelection.fire(a)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(a=>a.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,Ve([(0,A.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),Ve([(0,A.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let s=class An{constructor(a,h,b){this._commands=h,this.logService=b,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new I.Emitter,this._proxy=a.getProxy(C.MainContext.MainThreadSCM),this._telemetry=a.getProxy(C.MainContext.MainThreadTelemetry),h.registerArgumentProcessor({processArgument:_=>{if(_&&_.$mid===3){const v=this._sourceControls.get(_.sourceControlHandle);if(!v)return _;const E=v.getResourceGroup(_.groupHandle);return E?E.getResourceState(_.handle):_}else if(_&&_.$mid===4){const v=this._sourceControls.get(_.sourceControlHandle);return v?v.getResourceGroup(_.groupHandle):_}else if(_&&_.$mid===5){const v=this._sourceControls.get(_.handle);return v||_}return _}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(a,h,b,_){this.logService.trace("ExtHostSCM#createSourceControl",a.identifier.value,h,b,_),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:a.identifier.value});const v=An._handlePool++,E=new n(a,this._proxy,this._commands,h,b,_);this._sourceControls.set(v,E);const F=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(a.identifier))||[];return F.push(E),this._sourceControlsByExtension.set(P.ExtensionIdentifier.toKey(a.identifier),F),E}getLastInputBox(a){this.logService.trace("ExtHostSCM#getLastInputBox",a.identifier.value);const h=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(a.identifier)),b=h&&h[h.length-1];return b&&b.inputBox}$provideOriginalResource(a,h,b){const _=w.URI.revive(h);this.logService.trace("ExtHostSCM#$provideOriginalResource",a,_.toString());const v=this._sourceControls.get(a);return!v||!v.quickDiffProvider||!v.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>v.quickDiffProvider.provideOriginalResource(_,b)).then(E=>E||null)}$onInputBoxValueChange(a,h){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",a);const b=this._sourceControls.get(a);return b&&b.inputBox.$onInputBoxValueChange(h),Promise.resolve(void 0)}$executeResourceCommand(a,h,b,_){this.logService.trace("ExtHostSCM#$executeResourceCommand",a,h,b);const v=this._sourceControls.get(a);if(!v)return Promise.resolve(void 0);const E=v.getResourceGroup(h);return E?E.$executeResourceCommand(b,_):Promise.resolve(void 0)}$validateInput(a,h,b){this.logService.trace("ExtHostSCM#$validateInput",a);const _=this._sourceControls.get(a);return!_||!_.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>_.inputBox.validateInput(h,b)).then(v=>v?Promise.resolve([v.message,v.type]):Promise.resolve(void 0))}$setSelectedSourceControl(a){var h,b;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",a),a!==void 0&&((h=this._sourceControls.get(a))===null||h===void 0||h.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((b=this._sourceControls.get(this._selectedSourceControlHandle))===null||b===void 0||b.setSelectionState(!1)),this._selectedSourceControlHandle=a,Promise.resolve(void 0)}};s._handlePool=0,s=Ve([qe(2,i.ILogService)],s),e.ExtHostSCM=s});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Q):I?I.value:e.get(Q)};define(be[206],_e([0,1,7,5,135,6]),function(Q,e,w,I,A,T){"use strict";var y,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class S{constructor(c,d,o,l,g=w.StatusBarAlignment.Left,m,D){y.set(this,void 0),C.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,tt(this,y,c,"f"),tt(this,C,d,"f"),this._id=S.ID_GEN++,this._statusId=o,this._statusName=l,this._alignment=g,this._priority=m,this._accessibilityInformation=D}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var c;return(c=this._command)===null||c===void 0?void 0:c.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(c){this._text=c,this.update()}set tooltip(c){this._tooltip=c,this.update()}set color(c){this._color=c,this.update()}set backgroundColor(c){c&&!S.ALLOWED_BACKGROUND_COLORS.has(c.id)&&(c=void 0),this._backgroundColor=c,this.update()}set command(c){var d;((d=this._command)===null||d===void 0?void 0:d.fromApi)!==c&&(this._internalCommandRegistration.clear(),typeof c=="string"?this._command={fromApi:c,internal:Me(this,C,"f").toInternal({title:"",command:c},this._internalCommandRegistration)}:c?this._command={fromApi:c,internal:Me(this,C,"f").toInternal(c,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(c){this._accessibilityInformation=c,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Me(this,y,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var c;this._timeoutHandle=void 0;let d=this._color;this._backgroundColor&&(d=S.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Me(this,y,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(c=this._command)===null||c===void 0?void 0:c.internal,d,this._backgroundColor,this._alignment===w.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=S,y=new WeakMap,C=new WeakMap,S.ID_GEN=0,S.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new w.ThemeColor("statusBarItem.errorForeground")]]);class k{constructor(c){this._messages=[],this._item=c.createStatusBarEntry("status.extensionMessage",(0,A.localize)(0,null),w.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(c){const d={message:c};return this._messages.unshift(d),this._update(),new w.Disposable(()=>{const o=this._messages.indexOf(d);o>=0&&(this._messages.splice(o,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(c,d){this._proxy=c.getProxy(I.MainContext.MainThreadStatusBar),this._commands=d,this._statusMessage=new k(this)}createStatusBarEntry(c,d,o,l,g){return new S(this._proxy,this._commands,c,d,o,l,g)}setStatusBarMessage(c,d){const o=this._statusMessage.setMessage(c);let l;return typeof d=="number"?l=setTimeout(()=>o.dispose(),d):typeof d!="undefined"&&d.then(()=>o.dispose(),()=>o.dispose()),new w.Disposable(()=>{o.dispose(),clearTimeout(l)})}}e.ExtHostStatusBar=i}),define(be[78],_e([0,1,5,3,4]),function(Q,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(C){this._onDidChangeStorage=new I.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(w.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,S){this._proxy.$registerExtensionStorageKeysToSync(C,S)}getValue(C,S,k){return this._proxy.$getValue(C,S).then(i=>i||k)}setValue(C,S,k){return this._proxy.$setValue(C,S,k)}$acceptValue(C,S,k){this._onDidChangeStorage.fire({shared:C,key:S,value:k})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,A.createDecorator)("IExtHostStorage")}),define(be[79],_e([0,1,4,27,19,77,2]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,w.createDecorator)("IExtensionStoragePaths");let C=class{constructor(k,i,P){var c;this._logService=i,this._extHostFileSystem=P,this._workspace=(c=k.workspace)!==null&&c!==void 0?c:void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(d=>this._value=d)}async _getOrCreateWorkspaceStoragePath(){var k;if(!this._workspace)return Promise.resolve(void 0);const i=this._workspace.id,P=y.URI.joinPath(this._environment.workspaceStorageHome,i);try{return await this._extHostFileSystem.value.stat(P),this._logService.trace("[ExtHostStorage] storage dir already exists",P),P}catch(c){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",P),await this._extHostFileSystem.value.createDirectory(P),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(k=y.URI.revive(this._workspace.configuration))===null||k===void 0?void 0:k.toString(),name:this._workspace.name},void 0,2))),P}catch(c){this._logService.error("[ExtHostStorage]",c);return}}workspaceValue(k){if(this._value)return y.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return y.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}};C=Ve([qe(0,I.IExtHostInitDataService),qe(1,A.ILogService),qe(2,T.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(be[40],_e([0,1,3,5,4,2,14,6,7,136,12,173,20,31,156]),function(Q,e,w,I,A,T,y,C,S,k,i,P,c,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,A.createDecorator)("IExtHostTerminalService");class l{constructor(t,n,s,r){this._proxy=t,this._id=n,this._creationOptions=s,this._name=r,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(h=>this._pidPromiseComplete=h);const a=this;this.value={get name(){return a._name||""},get processId(){return a._pidPromise},get creationOptions(){return a._creationOptions},get exitStatus(){return a._exitStatus},sendText(h,b=!0){a._checkDisposed(),a._proxy.$sendText(a._id,h,b)},show(h){a._checkDisposed(),a._proxy.$show(a._id,h)},hide(){a._checkDisposed(),a._proxy.$hide(a._id)},dispose(){a._disposed||(a._disposed=!0,a._proxy.$dispose(a._id))},get dimensions(){if(!(a._cols===void 0||a._rows===void 0))return{columns:a._cols,rows:a._rows}}}}async create(t,n,s,r,a,h,b,_,v,E,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:s,env:r,icon:a,initialText:h,waitOnExit:b,strictEnv:_,hideFromUser:v,isFeatureTerminal:E,isExtensionOwnedTerminal:F})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=l;class g{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new w.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new w.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new w.Emitter,this._onProcessTitleChanged=new w.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new w.Emitter,this._onProcessShellTypeChanged=new w.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=g;let m=1,D=class extends C.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new w.Emitter,this._onDidOpenTerminal=new w.Emitter,this._onDidChangeActiveTerminal=new w.Emitter,this._onDidChangeTerminalDimensions=new w.Emitter,this._proxy=n.getProxy(I.MainContext.MainThreadTerminalService),this._bufferer=new o.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new w.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[s,r]of this._terminalProcesses)r.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const n=new l(this._proxy,(0,d.generateUuid)(),t,t.name),s=new g(t.pty);return n.createExtensionTerminal().then(r=>{const a=this._setupExtHostProcessListeners(r,s);this._terminalProcessDisposables[r]=a}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const r=new g(n),a=this._setupExtHostProcessListeners(t,r);this._terminalProcessDisposables[t]=a}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const s=this._getTerminalById(t);s&&(this._activeTerminal=s,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const s=this._getTerminalById(t);s&&this._onDidWriteTerminalData.fire({terminal:s.value,data:n})}async $acceptTerminalDimensions(t,n,s){const r=this._getTerminalById(t);r&&r.setDimensions(n,s)&&this._onDidChangeTerminalDimensions.fire({terminal:r.value,dimensions:r.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,s){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(n,s)}async $acceptTerminalTitleChange(t,n){const s=this._getTerminalById(t);s&&(s.name=n)}async $acceptTerminalClosed(t,n){const s=this._getTerminalObjectIndexById(this._terminals,t);if(s!==null){const r=this._terminals.splice(s,1)[0];r.setExitCode(n),this._onDidCloseTerminal.fire(r.value)}}$acceptTerminalOpened(t,n,s,r){if(n){const b=this._getTerminalObjectIndexById(this._terminals,n);if(b!==null){this._terminals[b]._id=t,this._onDidOpenTerminal.fire(this.terminals[b]),this._terminals[b].isOpen=!0;return}}const a={name:r.name,shellPath:r.executable,shellArgs:r.args,cwd:typeof r.cwd=="string"?r.cwd:T.URI.revive(r.cwd),env:r.env,hideFromUser:r.hideFromUser},h=new l(this._proxy,t,a,s);this._terminals.push(h),this._onDidOpenTerminal.fire(h.value),h.isOpen=!0}async $acceptTerminalProcessId(t,n){const s=this._getTerminalById(t);s&&s._setProcessId(n)}async $startExtensionTerminal(t,n){const s=this._getTerminalById(t);if(!s)return{message:(0,k.localize)(0,null,t)};s.isOpen||await new Promise(a=>{const h=this.onDidOpenTerminal(async b=>{b===s.value&&(h.dispose(),a())})});const r=this._terminalProcesses.get(t);r?r.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const s=new C.DisposableStore;s.add(n.onProcessReady(a=>this._proxy.$sendProcessReady(t,a.pid,a.cwd))),s.add(n.onProcessTitleChanged(a=>this._proxy.$sendProcessTitle(t,a))),this._bufferer.startBuffering(t,n.onProcessData),s.add(n.onProcessExit(a=>this._onProcessExit(t,a))),n.onProcessOverrideDimensions&&s.add(n.onProcessOverrideDimensions(a=>this._proxy.$sendOverrideDimensions(t,a))),this._terminalProcesses.set(t,n);const r=this._extensionTerminalAwaitingStart[t];return r&&n instanceof g&&(n.startSendingEvents(r.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),s}$acceptProcessAckDataEvent(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.input(n)}$acceptProcessResize(t,n,s){var r;try{(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(n,s)}catch(a){if(a.code!=="EPIPE"&&a.code!=="ERR_IPC_CHANNEL_CLOSED")throw a}}$acceptProcessShutdown(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(s=>this._proxy.$sendProcessInitialCwd(t,s))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(s=>this._proxy.$sendProcessCwd(t,s))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const s=this._getTerminalById(t);if(!s)return[];this._terminalLinkCache.delete(t);const r=this._terminalLinkCancellationSource.get(t);r&&r.dispose(!0);const a=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,a);const h=[],b={terminal:s.value,line:n},_=[];for(const F of this._linkProviders)_.push(new Promise(async U=>{a.token.onCancellationRequested(()=>U({provider:F,links:[]}));const J=await F.provideTerminalLinks(b,a.token)||[];a.token.isCancellationRequested||U({provider:F,links:J})}));const v=await Promise.all(_);if(a.token.isCancellationRequested)return[];const E=new Map;for(const F of v)F&&F.links.length>0&&h.push(...F.links.map(U=>{const J={id:m++,startIndex:U.startIndex,length:U.length,label:U.tooltip};return E.set(J.id,{provider:F.provider,link:U}),J}));return this._terminalLinkCache.set(t,E),h}$activateLink(t,n){var s;const r=(s=this._terminalLinkCache.get(t))===null||s===void 0?void 0:s.get(n);!r||r.provider.handleTerminalLink(r.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const s=this._terminalProcessDisposables[t];s&&(s.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const s=this._getTerminalObjectIndexById(t,n);return s!==null?t[s]:null}_getTerminalObjectIndexById(t,n){let s=null;return t.some((r,a)=>r._id===n?(s=a,!0):!1),s}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new f,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const s=(0,P.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,s.length===0?void 0:s)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const s=n[0],r=new f(n[1]);this._setEnvironmentVariableCollection(s,r)})}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};D=Ve([qe(1,y.IExtHostRpcService)],D),e.BaseExtHostTerminalService=D;class f{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new w.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:S.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:S.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const s=this.map.get(t);(!s||s.value!==n.value||s.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((s,r)=>t.call(n,r,s,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=f;let u=class extends D{constructor(t){super(!1,t)}createTerminal(t,n,s){throw new i.NotSupportedError}createTerminalFromOptions(t){throw new i.NotSupportedError}getDefaultShell(t,n){throw new i.NotSupportedError}getDefaultShellArgs(t,n){throw new i.NotSupportedError}$getAvailableProfiles(t){throw new i.NotSupportedError}async $getDefaultShellAndArgs(t){throw new i.NotSupportedError}};u=Ve([qe(0,y.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u}),define(be[207],_e([0,1,3,15,5,97,9,7]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(i,P){this._extHostDocumentsAndEditors=P,this._onDidChangeTextEditorSelection=new w.Emitter,this._onDidChangeTextEditorOptions=new w.Emitter,this._onDidChangeTextEditorVisibleRanges=new w.Emitter,this._onDidChangeTextEditorViewColumn=new w.Emitter,this._onDidChangeActiveTextEditor=new w.Emitter,this._onDidChangeVisibleTextEditors=new w.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(A.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(c=>this._onDidChangeVisibleTextEditors.fire(c)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(c=>this._onDidChangeActiveTextEditor.fire(c))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const P=this._extHostDocumentsAndEditors.allEditors();return i?P:P.map(c=>c.value)}async showTextDocument(i,P,c){let d;typeof P=="number"?d={position:y.ViewColumn.from(P),preserveFocus:c}:typeof P=="object"?d={position:y.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?y.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:d={preserveFocus:!1};const o=await this._proxy.$tryShowTextDocument(i.uri,d),l=o&&this._extHostDocumentsAndEditors.getEditor(o);if(l)return l.value;throw o?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i){return new T.TextEditorDecorationType(this._proxy,i).value}$acceptEditorPropertiesChanged(i,P){const c=this._extHostDocumentsAndEditors.getEditor(i);if(!c)throw new Error("unknown text editor");if(P.options&&c._acceptOptions(P.options),P.selections){const d=P.selections.selections.map(y.Selection.to);c._acceptSelections(d)}if(P.visibleRanges){const d=I.coalesce(P.visibleRanges.map(y.Range.to));c._acceptVisibleRanges(d)}if(P.options&&this._onDidChangeTextEditorOptions.fire({textEditor:c.value,options:Object.assign(Object.assign({},P.options),{lineNumbers:y.TextEditorLineNumbersStyle.to(P.options.lineNumbers)})}),P.selections){const d=C.TextEditorSelectionChangeKind.fromValue(P.selections.source),o=P.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:c.value,selections:o,kind:d})}if(P.visibleRanges){const d=I.coalesce(P.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:c.value,visibleRanges:d})}}$acceptEditorPositionData(i){for(const P in i){const c=this._extHostDocumentsAndEditors.getEditor(P);if(!c)throw new Error("Unknown text editor");const d=y.ViewColumn.to(i[P]);c.value.viewColumn!==d&&(c._acceptViewColumn(d),this._onDidChangeTextEditorViewColumn.fire({textEditor:c.value,viewColumn:d}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=S});var Ht=this&&this.__rest||function(Q,e){var w={};for(var I in Q)Object.prototype.hasOwnProperty.call(Q,I)&&e.indexOf(I)<0&&(w[I]=Q[I]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,I=Object.getOwnPropertySymbols(Q);A<I.length;A++)e.indexOf(I[A])<0&&Object.prototype.propertyIsEnumerable.call(Q,I[A])&&(w[I[A]]=Q[I[A]]);return w};define(be[208],_e([0,1,2,4,5,6,7]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,I.createDecorator)("IExtHostTimeline");class C{constructor(i,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(A.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:c=>{var d,o;if(c&&c.$mid===11){const l=c.uri===void 0?void 0:w.URI.revive(c.uri);return(o=(d=this._itemsBySourceAndUriMap.get(c.source))===null||d===void 0?void 0:d.get(S(l)))===null||o===void 0?void 0:o.get(c.handle)}return c}})}async $getTimeline(i,P,c,d,o){const l=this._providers.get(i);return l==null?void 0:l.provideTimeline(w.URI.revive(P),c,d,o)}registerTimelineProvider(i,P,c,d){const o=new T.DisposableStore,l=this.convertTimelineItem(P.id,d,o).bind(this);let g;P.onDidChange&&(g=P.onDidChange(D=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},D),{id:P.id})),this));const m=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},P),{scheme:i,onDidChange:void 0,async provideTimeline(D,f,u,p){var t;(p==null?void 0:p.resetCache)&&(o.clear(),(t=m.get(P.id))===null||t===void 0||t.clear());const n=await P.provideTimeline(D,f,u);if(n!=null){const s=l(D,p);return Object.assign(Object.assign({},n),{source:P.id,items:n.items.map(s)})}},dispose(){var D;for(const f of m.values())(D=f.get(P.id))===null||D===void 0||D.clear();g==null||g.dispose(),o.dispose()}}))}convertTimelineItem(i,P,c){return(d,o)=>{let l;if(o==null?void 0:o.cacheResults){let g=this._itemsBySourceAndUriMap.get(i);g===void 0&&(g=new Map,this._itemsBySourceAndUriMap.set(i,g));const m=S(d);l=g.get(m),l===void 0&&(l=new Map,g.set(m,l))}return g=>{var m,D;const{iconPath:f}=g,u=Ht(g,["iconPath"]),p=`${i}|${(m=g.id)!==null&&m!==void 0?m:g.timestamp}`;l==null||l.set(p,g);let t,n,s;return g.iconPath&&(f instanceof y.ThemeIcon?s={id:f.id}:w.URI.isUri(f)?(t=f,n=f):{light:t,dark:n}=f),Object.assign(Object.assign({},u),{id:(D=u.id)!==null&&D!==void 0?D:void 0,handle:p,source:i,command:g.command?P.toInternal(g.command,c):void 0,icon:t,iconDark:n,themeIcon:s,accessibilityInformation:g.accessibilityInformation})}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,T.toDisposable)(()=>{var c;for(const d of this._itemsBySourceAndUriMap.values())(c=d.get(i.id))===null||c===void 0||c.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=C;function S(k){return k==null?void 0:k.toString()}}),define(be[209],_e([0,1,6,18,2,5]),function(Q,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(S){this._openers=new Map,this._proxy=S.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,k,i,P){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const c=P.schemes.find(d=>!y.supportedSchemes.has(d));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,i),this._proxy.$registerUriOpener(k,P.schemes,S,P.label),(0,w.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(S,k,i){const P=this._openers.get(S);if(!P)throw new Error(`Unknown opener with id: ${S}`);const c=A.URI.revive(k);return P.canOpenExternalUri(c,i)}async $openUri(S,k,i){const P=this._openers.get(S);if(!P)throw new Error(`Unknown opener id: '${S}'`);return P.openExternalUri(A.URI.revive(k.resolvedUri),{sourceUri:A.URI.revive(k.sourceUri)},i)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([I.Schemas.http,I.Schemas.https])}),define(be[210],_e([0,1,5,2,6,12,26]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(w.MainContext.MainThreadUrls)}registerUriHandler(k,i){if(this.handles.has(y.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const P=C.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(k)),this.handlers.set(P,i),this._proxy.$registerUriHandler(P,k),(0,A.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(k)),this.handlers.delete(P),this._proxy.$unregisterUriHandler(P)})}$handleExternalUri(k,i){const P=this.handlers.get(k);if(!P)return Promise.resolve(void 0);try{P.handleUri(I.URI.revive(i))}catch(c){(0,T.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(k){return I.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=C,C.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Q):I?I.value:e.get(Q)};define(be[50],_e([0,1,23,3,2,145,166,72,5]),function(Q,e,w,I,A,T,y,C,S){"use strict";var k,i,P,c,d,o,l,g,m,D,f,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.serializeMessage=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class p{constructor(v,E,F,U,J,me,q){k.set(this,void 0),i.set(this,void 0),P.set(this,void 0),c.set(this,void 0),d.set(this,void 0),o.set(this,void 0),l.set(this,""),g.set(this,void 0),m.set(this,!1),D.set(this,!1),f.set(this,!1),this._onMessageEmitter=new I.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new I.Emitter),this._onDidDispose=Me(this,u,"f").event,tt(this,k,v,"f"),tt(this,i,E,"f"),tt(this,g,F,"f"),tt(this,c,U,"f"),tt(this,d,J,"f"),tt(this,o,me,"f"),tt(this,f,t(me),"f"),tt(this,P,q,"f")}dispose(){tt(this,m,!0,"f"),Me(this,u,"f").fire(),Me(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(v){return tt(this,D,!0,"f"),(0,C.asWebviewUri)(Me(this,c,"f"),Me(this,k,"f"),v)}get cspSource(){return Me(this,c,"f").webviewCspSource.replace("{{uuid}}",Me(this,k,"f"))}get html(){return this.assertNotDisposed(),Me(this,l,"f")}set html(v){this.assertNotDisposed(),Me(this,l,"f")!==v&&(tt(this,l,v,"f"),!Me(this,D,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(v)&&(tt(this,D,!0,"f"),Me(this,P,"f").report("Webview vscode-resource: uris",Me(this,o,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Me(this,i,"f").$setHtml(Me(this,k,"f"),v))}get options(){return this.assertNotDisposed(),Me(this,g,"f")}set options(v){this.assertNotDisposed(),Me(this,i,"f").$setOptions(Me(this,k,"f"),a(Me(this,o,"f"),Me(this,d,"f"),v)),tt(this,g,v,"f")}async postMessage(v){if(Me(this,m,"f"))return!1;const E=n(v,{serializeBuffersForPostMessage:Me(this,f,"f")});return Me(this,i,"f").$postMessage(Me(this,k,"f"),E.message,...E.buffers)}assertNotDisposed(){if(Me(this,m,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=p,k=new WeakMap,i=new WeakMap,P=new WeakMap,c=new WeakMap,d=new WeakMap,o=new WeakMap,l=new WeakMap,g=new WeakMap,m=new WeakMap,D=new WeakMap,f=new WeakMap,u=new WeakMap;function t(_){if(!_.enableProposedApi)return!1;try{const v=(0,T.normalizeVersion)((0,T.parseVersion)(_.engines.vscode));return!!v&&v.majorBase>=1&&v.minorBase>=56}catch(v){return!1}}e.shouldSerializeBuffersForPostMessage=t;function n(_,v){if(v.serializeBuffersForPostMessage){const E=[],F=(J,me)=>{if(me&&me instanceof ArrayBuffer){let q=E.findIndex(z=>z.original===me);if(q===-1){const z=new Uint8Array(me),ee=w.VSBuffer.wrap(z);q=E.length,E.push({original:me,vsBuffer:ee})}return{$$vscode_array_buffer_reference$$:!0,index:q}}return me};return{message:JSON.stringify(_,F),buffers:E.map(J=>J.vsBuffer)}}else return{message:JSON.stringify(_),buffers:[]}}e.serializeMessage=n;class s{constructor(v,E,F,U,J){this.initData=E,this.workspace=F,this._logService=U,this._deprecationService=J,this._webviews=new Map,this._webviewProxy=v.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(v,E,...F){const U=this.getWebview(v);if(U){const{message:J}=(0,y.deserializeWebviewMessage)(E,F);U._onMessageEmitter.fire(J)}}$onMissingCsp(v,E){this._logService.warn(`${E} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(v,E,F){const U=new p(v,this._webviewProxy,h(E),this.initData,this.workspace,F,this._deprecationService);return this._webviews.set(v,U),U._onDidDispose(()=>{this._webviews.delete(v)}),U}deleteWebview(v){this._webviews.delete(v)}getWebview(v){return this._webviews.get(v)}}e.ExtHostWebviews=s;function r(_){return{id:_.identifier,location:_.extensionLocation}}e.toExtensionData=r;function a(_,v,E){return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,portMapping:E.portMapping,localResourceRoots:E.localResourceRoots||b(_,v)}}e.serializeWebviewOptions=a;function h(_){var v;return{enableCommandUris:_.enableCommandUris,enableScripts:_.enableScripts,portMapping:_.portMapping,localResourceRoots:(v=_.localResourceRoots)===null||v===void 0?void 0:v.map(E=>A.URI.from(E))}}e.reviveOptions=h;function b(_,v){return[...((v==null?void 0:v.getWorkspaceFolders())||[]).map(E=>E.uri),_.extensionLocation]}}),define(be[211],_e([0,1,20,56,6,18,25,2,9,50,68,5,7]),function(Q,e,w,I,A,T,y,C,S,k,i,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class d{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=u(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class o{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,s){const r=this.key(t,n.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const a=new d(n,s);return this._documents.set(r,a),a}delete(t,n){const s=this.key(t,n.uri);this._documents.delete(s)}key(t,n){return`${t}@@@${n}`}}var l;(function(p){p[p.Text=0]="Text",p[p.Custom=1]="Custom"})(l||(l={}));class g{constructor(){this._providers=new Map}addTextProvider(t,n,s){return this.add(0,t,n,s)}addCustomProvider(t,n,s){return this.add(1,t,n,s)}get(t){return this._providers.get(t)}add(t,n,s,r){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:s,provider:r}),new c.Disposable(()=>this._providers.delete(n))}}class m{constructor(t,n,s,r,a){this._extHostDocuments=n,this._extensionStoragePaths=s,this._extHostWebview=r,this._extHostWebviewPanels=a,this._editorProviders=new g,this._documents=new o,this._proxy=t.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,s,r){const a=new A.DisposableStore;return D(s)?(a.add(this._editorProviders.addTextProvider(n,t,s)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(t),n,r.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(t))):(a.add(this._editorProviders.addCustomProvider(n,t,s)),this.supportEditing(s)&&a.add(s.onDidChangeCustomDocument(h=>{const b=this.getCustomDocumentEntry(n,h.document.uri);if(f(h)){const _=b.addEdit(h);this._proxy.$onDidEdit(h.document.uri,n,_,h.label)}else this._proxy.$onContentChange(h.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(t),n,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(t))),c.Disposable.from(a,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,s,r,a){var h;const b=this._editorProviders.get(n);if(!b)throw new Error(`No provider found for '${n}'`);if(b.type!==1)throw new Error(`Invalid provide type for '${n}'`);const _=C.URI.revive(t),v=await b.provider.openCustomDocument(_,{backupId:s,untitledDocumentData:r==null?void 0:r.buffer},a);let E;return this.supportEditing(b.provider)&&this._extensionStoragePaths&&(E=(h=this._extensionStoragePaths.workspaceValue(b.extension))!==null&&h!==void 0?h:this._extensionStoragePaths.globalValue(b.extension)),this._documents.add(n,v,E),{editable:this.supportEditing(b.provider)}}async $disposeCustomDocument(t,n){const s=this._editorProviders.get(n);if(!s)throw new Error(`No provider found for '${n}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${n}'`);const r=C.URI.revive(t),{document:a}=this.getCustomDocumentEntry(n,r);this._documents.delete(n,a),a.dispose()}async $resolveWebviewEditor(t,n,s,r,a,h){const b=this._editorProviders.get(s);if(!b)throw new Error(`No provider found for '${s}'`);const _=S.ViewColumn.to(a),v=this._extHostWebview.createNewWebview(n,r.webviewOptions,b.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(n,s,r.title,_,r.panelOptions,v),F=C.URI.revive(t);switch(b.type){case 1:{const{document:U}=this.getCustomDocumentEntry(s,F);return b.provider.resolveCustomEditor(U,E,h)}case 0:{const U=this._extHostDocuments.getDocument(F);return b.provider.resolveCustomTextEditor(U,E,h)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,s){this.getCustomDocumentEntry(n,t).disposeEdits(s)}async $onMoveCustomEditor(t,n,s){const r=this._editorProviders.get(s);if(!r)throw new Error(`No provider found for '${s}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const a=this._extHostWebviewPanels.getWebviewPanel(t);if(!a)throw new Error("No webview found");const h=C.URI.revive(n),b=this._extHostDocuments.getDocument(h);await r.provider.moveCustomTextEditor(b,a,w.CancellationToken.None)}async $undo(t,n,s,r){return this.getCustomDocumentEntry(n,t).undo(s,r)}async $redo(t,n,s,r){return this.getCustomDocumentEntry(n,t).redo(s,r)}async $revert(t,n,s){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(r.document,s),r.disposeBackup()}async $onSave(t,n,s){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(r.document,s),r.disposeBackup()}async $onSaveAs(t,n,s,r){const a=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(a.document,C.URI.revive(s),r)}async $backup(t,n,s){const r=this.getCustomDocumentEntry(n,t),h=await this.getCustomEditorProvider(n).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},s);return r.updateBackup(h),h.id}getCustomDocumentEntry(t,n){const s=this._documents.get(t,C.URI.revive(n));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const n=this._editorProviders.get(t),s=n==null?void 0:n.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=m;function D(p){return typeof p.resolveCustomTextEditor=="function"}function f(p){return typeof p.undo=="function"&&typeof p.redo=="function"}function u(p){const t=p.scheme===T.Schemas.file||p.scheme===T.Schemas.untitled?p.fsPath:p.toString();return(0,I.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Q):I?I.value:e.get(Q)};define(be[212],_e([0,1,3,6,2,31,9,50,5,7]),function(Q,e,w,I,A,T,y,C,S,k){"use strict";var i,P,c,d,o,l,g,m,D,f,u,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends I.Disposable{constructor(h,b,_,v,E,F,U){super();i.set(this,void 0),P.set(this,void 0),c.set(this,void 0),d.set(this,void 0),o.set(this,void 0),l.set(this,void 0),g.set(this,void 0),m.set(this,void 0),D.set(this,!0),f.set(this,!0),u.set(this,!1),p.set(this,this._register(new w.Emitter)),this.onDidDispose=Me(this,p,"f").event,t.set(this,this._register(new w.Emitter)),this.onDidChangeViewState=Me(this,t,"f").event,tt(this,i,h,"f"),tt(this,P,b,"f"),tt(this,c,_,"f"),tt(this,o,F,"f"),tt(this,m,E,"f"),tt(this,l,v,"f"),tt(this,d,U,"f")}dispose(){Me(this,u,"f")||(tt(this,u,!0,"f"),Me(this,p,"f").fire(),Me(this,P,"f").$disposeWebview(Me(this,i,"f")),Me(this,d,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Me(this,d,"f")}get viewType(){return this.assertNotDisposed(),Me(this,c,"f")}get title(){return this.assertNotDisposed(),Me(this,l,"f")}set title(h){this.assertNotDisposed(),Me(this,l,"f")!==h&&(tt(this,l,h,"f"),Me(this,P,"f").$setTitle(Me(this,i,"f"),h))}get iconPath(){return this.assertNotDisposed(),Me(this,g,"f")}set iconPath(h){this.assertNotDisposed(),Me(this,g,"f")!==h&&(tt(this,g,h,"f"),Me(this,P,"f").$setIconPath(Me(this,i,"f"),A.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return Me(this,o,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Me(this,m,"f")=="number"&&Me(this,m,"f")<0))return Me(this,m,"f")}get active(){return this.assertNotDisposed(),Me(this,f,"f")}get visible(){return this.assertNotDisposed(),Me(this,D,"f")}_updateViewState(h){Me(this,u,"f")||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(tt(this,f,h.active,"f"),tt(this,D,h.visible,"f"),tt(this,m,h.viewColumn,"f"),Me(this,t,"f").fire({webviewPanel:this}))}reveal(h,b){this.assertNotDisposed(),Me(this,P,"f").$reveal(Me(this,i,"f"),{viewColumn:h?y.ViewColumn.from(h):void 0,preserveFocus:!!b})}assertNotDisposed(){if(Me(this,u,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,P=new WeakMap,c=new WeakMap,d=new WeakMap,o=new WeakMap,l=new WeakMap,g=new WeakMap,m=new WeakMap,D=new WeakMap,f=new WeakMap,u=new WeakMap,p=new WeakMap,t=new WeakMap;class s{constructor(h,b,_){this.webviews=b,this.workspace=_,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=h.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(h,b,_,v,E={}){const F=typeof v=="object"?v.viewColumn:v,U={viewColumn:y.ViewColumn.from(F),preserveFocus:typeof v=="object"&&!!v.preserveFocus},J=(0,C.shouldSerializeBuffersForPostMessage)(h),me=s.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(h),me,b,{title:_,panelOptions:r(E),webviewOptions:(0,C.serializeWebviewOptions)(h,this.workspace,E),serializeBuffersForPostMessage:J},U);const q=this.webviews.createNewWebview(me,E,h);return this.createNewWebviewPanel(me,b,_,F,E,q)}$onDidChangeWebviewPanelViewStates(h){const b=Object.keys(h);b.sort((_,v)=>{const E=h[_],F=h[v];return E.active?1:F.active?-1:+E.visible-+F.visible});for(const _ of b){const v=this.getWebviewPanel(_);if(!!v){const E=h[_];v._updateViewState({active:E.active,visible:E.visible,viewColumn:y.ViewColumn.to(E.position)})}}}async $onDidDisposeWebviewPanel(h){const b=this.getWebviewPanel(h);b==null||b.dispose(),this._webviewPanels.delete(h),this.webviews.deleteWebview(h)}registerWebviewPanelSerializer(h,b,_){if(this._serializers.has(b))throw new Error(`Serializer for '${b}' already registered`);return this._serializers.set(b,{serializer:_,extension:h}),this._proxy.$registerSerializer(b,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(h)}),new k.Disposable(()=>{this._serializers.delete(b),this._proxy.$unregisterSerializer(b)})}async $deserializeWebviewPanel(h,b,_,v){const E=this._serializers.get(b);if(!E)throw new Error(`No serializer found for '${b}'`);const{serializer:F,extension:U}=E,J=this.webviews.createNewWebview(h,_.webviewOptions,U),me=this.createNewWebviewPanel(h,b,_.title,v,_.panelOptions,J);await F.deserializeWebviewPanel(me,_.state)}createNewWebviewPanel(h,b,_,v,E,F){const U=new n(h,this._proxy,b,_,v,E,F);return this._webviewPanels.set(h,U),U}getWebviewPanel(h){return this._webviewPanels.get(h)}}e.ExtHostWebviewPanels=s;function r(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Q):I?I.value:e.get(Q)};define(be[213],_e([0,1,3,6,50,5,7]),function(Q,e,w,I,A,T,y){"use strict";var C,S,k,i,P,c,d,o,l,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends I.Disposable{constructor(u,p,t,n,s,r){super();C.set(this,void 0),S.set(this,void 0),k.set(this,void 0),i.set(this,void 0),P.set(this,!1),c.set(this,void 0),d.set(this,void 0),o.set(this,void 0),l.set(this,this._register(new w.Emitter)),this.onDidChangeVisibility=Me(this,l,"f").event,g.set(this,this._register(new w.Emitter)),this.onDidDispose=Me(this,g,"f").event,tt(this,k,t,"f"),tt(this,d,n,"f"),tt(this,C,u,"f"),tt(this,S,p,"f"),tt(this,i,s,"f"),tt(this,c,r,"f")}dispose(){Me(this,P,"f")||(tt(this,P,!0,"f"),Me(this,g,"f").fire(),Me(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Me(this,d,"f")}set title(u){this.assertNotDisposed(),Me(this,d,"f")!==u&&(tt(this,d,u,"f"),Me(this,S,"f").$setWebviewViewTitle(Me(this,C,"f"),u))}get description(){return this.assertNotDisposed(),Me(this,o,"f")}set description(u){this.assertNotDisposed(),Me(this,o,"f")!==u&&(tt(this,o,u,"f"),Me(this,S,"f").$setWebviewViewDescription(Me(this,C,"f"),u))}get visible(){return Me(this,c,"f")}get webview(){return Me(this,i,"f")}get viewType(){return Me(this,k,"f")}_setVisible(u){u===Me(this,c,"f")||Me(this,P,"f")||(tt(this,c,u,"f"),Me(this,l,"f").fire())}show(u){this.assertNotDisposed(),Me(this,S,"f").$show(Me(this,C,"f"),!!u)}assertNotDisposed(){if(Me(this,P,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,S=new WeakMap,k=new WeakMap,i=new WeakMap,P=new WeakMap,c=new WeakMap,d=new WeakMap,o=new WeakMap,l=new WeakMap,g=new WeakMap;class D{constructor(u,p){this._extHostWebview=p,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=u.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(u,p,t,n){if(this._viewProviders.has(p))throw new Error(`View provider for '${p}' already registered`);return this._viewProviders.set(p,{provider:t,extension:u}),this._proxy.$registerWebviewViewProvider((0,A.toExtensionData)(u),p,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(p),this._proxy.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(u,p,t,n,s){const r=this._viewProviders.get(p);if(!r)throw new Error(`No view provider found for '${p}'`);const{provider:a,extension:h}=r,b=this._extHostWebview.createNewWebview(u,{},h),_=new m(u,this._proxy,p,t,b,!0);this._webviewViews.set(u,_),await a.resolveWebviewView(_,{state:n},s)}async $onDidChangeWebviewViewVisibility(u,p){this.getWebviewView(u)._setVisible(p)}async $disposeWebviewView(u){const p=this.getWebviewView(u);this._webviewViews.delete(u),p.dispose(),this._extHostWebview.deleteWebview(u)}getWebviewView(u){const p=this._webviewViews.get(u);if(!p)throw new Error("No webview found");return p}}e.ExtHostWebviewViews=D}),define(be[101],_e([0,1,3,5,2,18,8,4,14]),function(Q,e,w,I,A,T,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Tn{constructor(P){this._onDidChangeWindowState=new w.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Tn.InitialState,this._proxy=P.getProxy(I.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(c=>this.$onDidChangeWindowFocus(c))}get state(){return this._state}$onDidChangeWindowFocus(P){P!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:P}),this._onDidChangeWindowState.fire(this._state))}openUri(P,c){let d;if(typeof P=="string"){d=P;try{P=A.URI.parse(P)}catch(o){return Promise.reject(`Invalid uri - '${P}'`)}}return(0,y.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this._proxy.$openUri(P,d,c)}async asExternalUri(P,c){if((0,y.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([T.Schemas.http,T.Schemas.https]).has(P.scheme))return Promise.reject(`Invalid scheme '${P.scheme}'`);const d=await this._proxy.$asExternalUri(P,c);return A.URI.from(d)}};k.InitialState={focused:!0},k=Ve([qe(0,S.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(be[214],_e([0,1,19,5,27,14]),function(Q,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let y=class extends w.AbstractLogger{constructor(S,k){super();this._proxy=S.getProxy(I.MainContext.MainThreadLog),this._logFile=k.logFile.toJSON(),this.setLevel(k.logLevel)}$setLevel(S){this.setLevel(S)}trace(S,...k){this.getLevel()<=w.LogLevel.Trace&&this._proxy.$log(this._logFile,w.LogLevel.Trace,Array.from(arguments))}debug(S,...k){this.getLevel()<=w.LogLevel.Debug&&this._proxy.$log(this._logFile,w.LogLevel.Debug,Array.from(arguments))}info(S,...k){this.getLevel()<=w.LogLevel.Info&&this._proxy.$log(this._logFile,w.LogLevel.Info,Array.from(arguments))}warn(S,...k){this.getLevel()<=w.LogLevel.Warning&&this._proxy.$log(this._logFile,w.LogLevel.Warning,Array.from(arguments))}error(S,...k){this.getLevel()<=w.LogLevel.Error&&this._proxy.$log(this._logFile,w.LogLevel.Error,Array.from(arguments))}critical(S,...k){this.getLevel()<=w.LogLevel.Critical&&this._proxy.$log(this._logFile,w.LogLevel.Critical,Array.from(arguments))}flush(){}};y=Ve([qe(0,T.IExtHostRpcService),qe(1,A.IExtHostInitDataService)],y),e.ExtHostLogService=y}),define(be[215],_e([0,1,11,20,12,3,6,113,187,98,23]),function(Q,e,w,I,A,T,y,C,S,k,i){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function c(r,a){try{return JSON.stringify(r,a)}catch(h){return"null"}}function d(r,a){return JSON.stringify(r,a)}function o(r){return r?(a,h)=>h&&h.$mid===1?r.transformOutgoing(h):h:null}var l;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const m=()=>{},D=Symbol.for("rpcProtocol"),f=Symbol.for("rpcProxy");class u extends y.Disposable{constructor(a,h=null,b=null){super();this[P]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=a,this._logger=h,this._uriTransformer=b,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let _=0,v=k.ProxyIdentifier.count;_<v;_++)this._locals[_]=null,this._proxies[_]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new w.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(_=>this._receiveOneMessage(_))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(a=>{this._pendingRPCReplies[a].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(a){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(a){this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(a){this._responsiveState!==a&&(this._responsiveState=a,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(a){return this._uriTransformer?(0,C.transformIncomingURIs)(a,this._uriTransformer):a}getProxy(a){const{nid:h,sid:b}=a;return this._proxies[h]||(this._proxies[h]=this._createProxy(h,b)),this._proxies[h]}_createProxy(a,h){let b={get:(_,v)=>(typeof v=="string"&&!_[v]&&v.charCodeAt(0)===36&&(_[v]=(...E)=>this._remoteCall(a,v,E)),v===f?h:_[v])};return new Proxy(Object.create(null),b)}set(a,h){return this._locals[a.nid]=h,h}assertRegistered(a){for(let h=0,b=a.length;h<b;h++){const _=a[h];if(!this._locals[_.nid])throw new Error(`Missing actor ${_.sid} (isMain: ${_.isMain})`)}}_receiveOneMessage(a){if(!this._isDisposed){const h=a.byteLength,b=p.read(a,0),_=b.readUInt8(),v=b.readUInt32();switch(_){case 1:case 2:{let{rpcId:E,method:F,args:U}=t.deserializeRequestJSONArgs(b);this._uriTransformer&&(U=(0,C.transformIncomingURIs)(U,this._uriTransformer)),this._receiveRequest(h,v,E,F,U,_===2);break}case 3:case 4:{let{rpcId:E,method:F,args:U}=t.deserializeRequestMixedArgs(b);this._uriTransformer&&(U=(0,C.transformIncomingURIs)(U,this._uriTransformer)),this._receiveRequest(h,v,E,F,U,_===4);break}case 5:{this._logger&&this._logger.logIncoming(h,v,0,"ack"),this._onDidReceiveAcknowledge(v);break}case 6:{this._receiveCancel(h,v);break}case 7:{this._receiveReply(h,v,void 0);break}case 9:{let E=t.deserializeReplyOKJSON(b);this._uriTransformer&&(E=(0,C.transformIncomingURIs)(E,this._uriTransformer)),this._receiveReply(h,v,E);break}case 8:{let E=t.deserializeReplyOKVSBuffer(b);this._receiveReply(h,v,E);break}case 10:{let E=t.deserializeReplyErrError(b);this._uriTransformer&&(E=(0,C.transformIncomingURIs)(E,this._uriTransformer)),this._receiveReplyErr(h,v,E);break}case 11:{this._receiveReplyErr(h,v,void 0);break}default:console.error("received unexpected message"),console.error(a)}}}_receiveRequest(a,h,b,_,v,E){this._logger&&this._logger.logIncoming(a,h,1,`receiveRequest ${(0,k.getStringIdentifierForProxy)(b)}.${_}(`,v);const F=String(h);let U,J;if(E){const q=new I.CancellationTokenSource;v.push(q.token),U=this._invokeHandler(b,_,v),J=()=>q.cancel()}else U=this._invokeHandler(b,_,v),J=m;this._cancelInvokedHandlers[F]=J;const me=t.serializeAcknowledged(h);this._logger&&this._logger.logOutgoing(me.byteLength,h,1,"ack"),this._protocol.send(me),U.then(q=>{delete this._cancelInvokedHandlers[F];const z=t.serializeReplyOK(h,q,this._uriReplacer);this._logger&&this._logger.logOutgoing(z.byteLength,h,1,"reply:",q),this._protocol.send(z)},q=>{delete this._cancelInvokedHandlers[F];const z=t.serializeReplyErr(h,q);this._logger&&this._logger.logOutgoing(z.byteLength,h,1,"replyErr:",q),this._protocol.send(z)})}_receiveCancel(a,h){this._logger&&this._logger.logIncoming(a,h,1,"receiveCancel");const b=String(h);this._cancelInvokedHandlers[b]&&this._cancelInvokedHandlers[b]()}_receiveReply(a,h,b){this._logger&&this._logger.logIncoming(a,h,0,"receiveReply:",b);const _=String(h);if(!!this._pendingRPCReplies.hasOwnProperty(_)){const v=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_],v.resolveOk(b)}}_receiveReplyErr(a,h,b){this._logger&&this._logger.logIncoming(a,h,0,"receiveReplyErr:",b);const _=String(h);if(!!this._pendingRPCReplies.hasOwnProperty(_)){const v=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_];let E;b&&(b.$isError?(E=new Error,E.name=b.name,E.message=b.message,E.stack=b.stack):E=b),v.resolveErr(E)}}_invokeHandler(a,h,b){try{return Promise.resolve(this._doInvokeHandler(a,h,b))}catch(_){return Promise.reject(_)}}_doInvokeHandler(a,h,b){const _=this._locals[a];if(!_)throw new Error("Unknown actor "+(0,k.getStringIdentifierForProxy)(a));let v=_[h];if(typeof v!="function")throw new Error("Unknown method "+h+" on actor "+(0,k.getStringIdentifierForProxy)(a));return v.apply(_,b)}_remoteCall(a,h,b){if(this._isDisposed)return Promise.reject(A.canceled());let _=null;if(b.length>0&&I.CancellationToken.isCancellationToken(b[b.length-1])&&(_=b.pop()),_&&_.isCancellationRequested)return Promise.reject(A.canceled());const v=t.serializeRequestArguments(b,this._uriReplacer),E=++this._lastMessageId,F=String(E),U=new S.LazyPromise;_&&_.onCancellationRequested(()=>{const me=t.serializeCancel(E);this._logger&&this._logger.logOutgoing(me.byteLength,E,0,"cancel"),this._protocol.send(t.serializeCancel(E))}),this._pendingRPCReplies[F]=U,this._onWillSendRequest(E);const J=t.serializeRequest(E,a,h,v,!!_);return this._logger&&this._logger.logOutgoing(J.byteLength,E,0,`request: ${(0,k.getStringIdentifierForProxy)(a)}.${h}(`,b),this._protocol.send(J),U}}e.RPCProtocol=u,P=D,u.UNRESPONSIVE_TIME=3*1e3;class p{constructor(a,h){this._buff=a,this._offset=h}static alloc(a,h,b){let _=new p(i.VSBuffer.alloc(b+1+4),0);return _.writeUInt8(a),_.writeUInt32(h),_}static read(a,h){return new p(a,h)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(a){this._buff.writeUInt8(a,this._offset),this._offset+=1}readUInt8(){const a=this._buff.readUInt8(this._offset);return this._offset+=1,a}writeUInt32(a){this._buff.writeUInt32BE(a,this._offset),this._offset+=4}readUInt32(){const a=this._buff.readUInt32BE(this._offset);return this._offset+=4,a}static sizeShortString(a){return 1+a.byteLength}writeShortString(a){this._buff.writeUInt8(a.byteLength,this._offset),this._offset+=1,this._buff.set(a,this._offset),this._offset+=a.byteLength}readShortString(){const a=this._buff.readUInt8(this._offset);this._offset+=1;const b=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,b}static sizeLongString(a){return 4+a.byteLength}writeLongString(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readLongString(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const b=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,b}writeBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}static sizeVSBuffer(a){return 4+a.byteLength}writeVSBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readVSBuffer(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const h=this._buff.slice(this._offset,this._offset+a);return this._offset+=a,h}static sizeMixedArray(a,h){let b=0;b+=1;for(let _=0,v=a.length;_<v;_++){const E=a[_],F=h[_];switch(b+=1,F){case 1:b+=this.sizeLongString(E);break;case 2:b+=this.sizeVSBuffer(E);break;case 3:break}}return b}writeMixedArray(a,h){this._buff.writeUInt8(a.length,this._offset),this._offset+=1;for(let b=0,_=a.length;b<_;b++){const v=a[b];switch(h[b]){case 1:this.writeUInt8(1),this.writeLongString(v);break;case 2:this.writeUInt8(2),this.writeVSBuffer(v);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const a=this._buff.readUInt8(this._offset);this._offset+=1;let h=new Array(a);for(let b=0;b<a;b++)switch(this.readUInt8()){case 1:h[b]=this.readLongString();break;case 2:h[b]=this.readVSBuffer();break;case 3:h[b]=void 0;break}return h}}class t{static _arrayContainsBufferOrUndefined(a){for(let h=0,b=a.length;h<b;h++)if(a[h]instanceof i.VSBuffer||typeof a[h]=="undefined")return!0;return!1}static serializeRequestArguments(a,h){if(this._arrayContainsBufferOrUndefined(a)){let b=[],_=[];for(let v=0,E=a.length;v<E;v++){const F=a[v];F instanceof i.VSBuffer?(b[v]=F,_[v]=2):typeof F=="undefined"?(b[v]=i.VSBuffer.alloc(0),_[v]=3):(b[v]=i.VSBuffer.fromString(d(F,h)),_[v]=1)}return{type:"mixed",args:b,argsType:_}}return{type:"simple",args:d(a,h)}}static serializeRequest(a,h,b,_,v){return _.type==="mixed"?this._requestMixedArgs(a,h,b,_.args,_.argsType,v):this._requestJSONArgs(a,h,b,_.args,v)}static _requestJSONArgs(a,h,b,_,v){const E=i.VSBuffer.fromString(b),F=i.VSBuffer.fromString(_);let U=0;U+=p.sizeUInt8(),U+=p.sizeShortString(E),U+=p.sizeLongString(F);let J=p.alloc(v?2:1,a,U);return J.writeUInt8(h),J.writeShortString(E),J.writeLongString(F),J.buffer}static deserializeRequestJSONArgs(a){const h=a.readUInt8(),b=a.readShortString(),_=a.readLongString();return{rpcId:h,method:b,args:JSON.parse(_)}}static _requestMixedArgs(a,h,b,_,v,E){const F=i.VSBuffer.fromString(b);let U=0;U+=p.sizeUInt8(),U+=p.sizeShortString(F),U+=p.sizeMixedArray(_,v);let J=p.alloc(E?4:3,a,U);return J.writeUInt8(h),J.writeShortString(F),J.writeMixedArray(_,v),J.buffer}static deserializeRequestMixedArgs(a){const h=a.readUInt8(),b=a.readShortString(),_=a.readMixedArray(),v=new Array(_.length);for(let E=0,F=_.length;E<F;E++){const U=_[E];typeof U=="string"?v[E]=JSON.parse(U):v[E]=U}return{rpcId:h,method:b,args:v}}static serializeAcknowledged(a){return p.alloc(5,a,0).buffer}static serializeCancel(a){return p.alloc(6,a,0).buffer}static serializeReplyOK(a,h,b){return typeof h=="undefined"?this._serializeReplyOKEmpty(a):h instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(a,h):this._serializeReplyOKJSON(a,c(h,b))}static _serializeReplyOKEmpty(a){return p.alloc(7,a,0).buffer}static _serializeReplyOKVSBuffer(a,h){let b=0;b+=p.sizeVSBuffer(h);let _=p.alloc(8,a,b);return _.writeVSBuffer(h),_.buffer}static deserializeReplyOKVSBuffer(a){return a.readVSBuffer()}static _serializeReplyOKJSON(a,h){const b=i.VSBuffer.fromString(h);let _=0;_+=p.sizeLongString(b);let v=p.alloc(9,a,_);return v.writeLongString(b),v.buffer}static deserializeReplyOKJSON(a){const h=a.readLongString();return JSON.parse(h)}static serializeReplyErr(a,h){return h?this._serializeReplyErrEror(a,h):this._serializeReplyErrEmpty(a)}static _serializeReplyErrEror(a,h){const b=i.VSBuffer.fromString(c(A.transformErrorForSerialization(h),null));let _=0;_+=p.sizeLongString(b);let v=p.alloc(10,a,_);return v.writeLongString(b),v.buffer}static deserializeReplyErrError(a){const h=a.readLongString();return JSON.parse(h)}static _serializeReplyErrEmpty(a){return p.alloc(11,a,0).buffer}}var n;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var s;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(s||(s={}))}),define(be[216],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const w=function(T){const y=C=>{self.removeEventListener("message",y);const S=C.data;Object.defineProperties(self,{postMessage:{value(k,i){S.postMessage(k,i)}},onmessage:{get(){return S.onmessage},set(k){S.onmessage=k}}}),S.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",y)}.toString();class I extends EventTarget{constructor(T,y,C){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${w})('${y}'))`,k=new Blob([S],{type:"application/javascript"}),i=URL.createObjectURL(k),P=new MessageChannel,c=i,d={type:"_newWorker",id:c,port:P.port2,url:i,options:C};T(d,[P.port2]),this.postMessage=P.port1.postMessage.bind(P.port1),this.terminate=()=>{const o={type:"_terminateWorker",id:c};P.port1.postMessage(o),URL.revokeObjectURL(i),P.port1.close(),P.port2.close()},Object.defineProperties(this,{onmessage:{get(){return P.port1.onmessage},set(o){P.port1.onmessage=o}},onmessageerror:{get(){return P.port1.onmessageerror},set(o){P.port1.onmessageerror=o}}}),P.port1.addEventListener("messageerror",o=>{const l=new MessageEvent("messageerror",{data:o.data});this.dispatchEvent(l)}),P.port1.addEventListener("message",o=>{const l=new MessageEvent("message",{data:o.data});this.dispatchEvent(l)}),P.port1.start()}}e.NestedWorker=I}),define(be[217],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,w.createDecorator)("remoteAgentService")}),define(be[218],_e([0,1,18,13,21,2,4,217]),function(Q,e,w,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let S=class{constructor(i,P){this.localUserHome=i,this.remoteAgentService=P,this.resolveOS=(async()=>{const c=await this.remoteAgentService.getEnvironment();return(c==null?void 0:c.os)||A.OS})(),this.resolveUserHome=(async()=>{const c=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(c==null?void 0:c.userHome)||i})()}async userHome(i){return(i==null?void 0:i.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(i=>i===1?I.win32:I.posix)}async fileURI(i){let P="";if(await this.resolveOS===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const d=i.indexOf("/",2);d===-1?(P=i.substring(2),i="/"):(P=i.substring(2,d),i=i.substring(d)||"/")}return T.URI.from({scheme:w.Schemas.file,authority:P,path:i,query:"",fragment:""})}};S=Ve([qe(1,C.IRemoteAgentService)],S),e.AbstractPathService=S}),define(be[102],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class w{constructor(y,C){this.line=y,this.character=C}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,C){return new w(0,0)}with(y){return new w(0,0)}}e.Position=w;class I{constructor(y,C,S,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(y,C),this.end=new w(S,k)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new I(0,0,0,0)}with(y){return new I(0,0,0,0)}}e.Range=I;var A;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(A=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[41],_e([0,1,15,28,24,37,8,4,13,12,102]),function(Q,e,w,I,A,T,y,C,S,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const P="\u27EA ",c=" characters skipped \u27EB",d=(P.length+c.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var o;(function(R){R[R.file=0]="file",R[R.text=1]="text"})(o=e.SearchProviderType||(e.SearchProviderType={}));var l;(function(R){R[R.File=1]="File",R[R.Text=2]="Text"})(l=e.QueryType||(e.QueryType={}));function g(R){return!!R.preview}e.resultIsMatch=g;function m(R){return!!R.resource}e.isFileMatch=m;function D(R){return!!R.message}e.isProgressMessage=D;var f;(function(R){R[R.Normal=0]="Normal",R[R.NewSearchStarted=1]="NewSearchStarted"})(f=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class u{constructor(M){this.resource=M,this.results=[]}}e.FileMatch=u;class p{constructor(M,x,O){this.ranges=x;const G=Array.isArray(x)?x:[x];if(O&&O.matchLines===1&&t(G)){M=(0,y.getNLines)(M,O.matchLines);let Y="",ne=0,pe=0;const Ie=Math.floor(O.charsPerLine/5),Oe=[];for(const Te of G){const Ue=Math.max(Te.startColumn-Ie,0),B=Te.startColumn+O.charsPerLine;if(Ue>pe+Ie+d){const K=P+(Ue-pe)+c;Y+=K+M.slice(Ue,B),ne+=Ue-(pe+K.length)}else Y+=M.slice(pe,B);Oe.push(new s(0,Te.startColumn-ne,Te.endColumn-ne)),pe=B}this.preview={text:Y,matches:Array.isArray(this.ranges)?Oe:Oe[0]}}else{const Y=Array.isArray(x)?x[0].startLineNumber:x.startLineNumber;this.preview={text:M,matches:(0,w.mapArrayOrNot)(x,ne=>new n(ne.startLineNumber-Y,ne.startColumn,ne.endLineNumber-Y,ne.endColumn))}}}}e.TextSearchMatch=p;function t(R){const M=R[0].startLineNumber;for(const x of R)if(x.startLineNumber!==M||x.endLineNumber!==M)return!1;return!0}class n{constructor(M,x,O,G){this.startLineNumber=M,this.startColumn=x,this.endLineNumber=O,this.endColumn=G}}e.SearchRange=n;class s extends n{constructor(M,x,O){super(M,x,M,O)}}e.OneLineRange=s;var r;(function(R){R.Default="default",R.FileNames="fileNames",R.Type="type",R.Modified="modified",R.CountDescending="countDescending",R.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function a(R,M=!0){const x=R&&R.files&&R.files.exclude,O=M&&R&&R.search&&R.search.exclude;if(!(!x&&!O)){if(!x||!O)return x||O;let G=Object.create(null);return G=A.mixin(G,A.deepClone(x)),G=A.mixin(G,A.deepClone(O),!0),G}}e.getExcludes=a;function h(R,M){return R.excludePattern&&I.match(R.excludePattern,M)?!1:R.includePattern||R.usingSearchPaths?R.includePattern&&I.match(R.includePattern,M)?!0:R.usingSearchPaths?!!R.folderQueries&&R.folderQueries.some(x=>{const O=x.folder.fsPath;if(T.isEqualOrParent(M,O)){const G=S.relative(O,M);return!x.includePattern||!!I.match(x.includePattern,G)}else return!1}):!1:!0}e.pathIncludedInQuery=h;var b;(function(R){R[R.unknownEncoding=1]="unknownEncoding",R[R.regexParseError=2]="regexParseError",R[R.globParseError=3]="globParseError",R[R.invalidLiteral=4]="invalidLiteral",R[R.rgProcessError=5]="rgProcessError",R[R.other=6]="other",R[R.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class _ extends Error{constructor(M,x){super(M);this.code=x}}e.SearchError=_;function v(R){const M=R.message;if((0,k.isPromiseCanceledError)(R))return new _(M,b.canceled);try{const x=JSON.parse(M);return new _(x.message,x.code)}catch(x){return new _(M,b.other)}}e.deserializeSearchError=v;function E(R){const M={message:R.message,code:R.code};return new Error(JSON.stringify(M))}e.serializeSearchError=E;function F(R){return R.type==="error"?!0:R.type==="success"}e.isSerializedSearchComplete=F;function U(R){return R.type==="success"}e.isSerializedSearchSuccess=U;function J(R){return!!R.path}e.isSerializedFileMatch=J;function me(R,M){const x=R.searchPath?R.searchPath:R.relativePath;return(0,y.fuzzyContains)(x,M)}e.isFilePatternMatch=me;class q{constructor(M){this.path=M,this.results=[]}addMatch(M){this.results.push(M)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=q;function z(R,M){const x=Object.assign(Object.assign({},R||{}),M||{});return Object.keys(x).filter(O=>{const G=x[O];return typeof G=="boolean"&&G})}e.resolvePatternsForProvider=z;class ee{constructor(M,x){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},M.excludePattern||{}),x.excludePattern||{}),this._parsedExcludeExpression=I.parse(this._excludeExpression);let O=M.includePattern;x.includePattern&&(O?O=Object.assign(Object.assign({},O),x.includePattern):O=x.includePattern),O&&(this._parsedIncludeExpression=I.parse(O))}includedInQuerySync(M,x,O){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(M,x,O)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(M,x,O))}includedInQuery(M,x,O){return Promise.resolve(this._parsedExcludeExpression(M,x,O)).then(Y=>!!Y).then(Y=>Y?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(M,x,O)).then(ne=>!!ne):Promise.resolve(!0)).then(Y=>Y)}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=ee;function $(R){for(const M in R)if(typeof R[M]!="boolean")return!0;return!1}}),define(be[30],_e([0,1,15,11,20,3,22,18,81,25,8,10,2,138,4,19,153,48,49,27,14,7,41,5]),function(Q,e,w,I,A,T,y,C,S,k,i,P,c,d,o,l,g,m,D,f,u,p,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(F,U,J){return new k.ExtUri(me=>b(me,J)).isEqual(F,U)}function r(F,U,J){return s(F.uri,U.uri,J)?0:(0,i.compare)(F.uri.toString(),U.uri.toString())}function a(F,U,J){return F.index!==U.index?F.index<U.index?-1:1:s(F.uri,U.uri,J)?(0,i.compare)(F.name,U.name):(0,i.compare)(F.uri.toString(),U.uri.toString())}function h(F,U,J,me){const q=F.slice(0).sort((ee,$)=>J(ee,$,me)),z=U.slice(0).sort((ee,$)=>J(ee,$,me));return(0,w.delta)(q,z,(ee,$)=>J(ee,$,me))}function b(F,U){const J=U.getCapabilities(F.scheme);return!(J&&J&1024)}class _ extends m.Workspace{constructor(U,J,me,q,z,ee){super(U,me.map($=>new m.WorkspaceFolder($)),q,ee);this._name=J,this._isUntitled=z,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris(ee),me.forEach($=>{this._workspaceFolders.push($),this._structure.set($.uri,$)})}static toExtHostWorkspace(U,J,me,q){if(!U)return{workspace:null,added:[],removed:[]};const{id:z,name:ee,folders:$,configuration:R,isUntitled:M}=U,x=[],O=J;J?$.forEach((pe,Ie)=>{const Oe=c.URI.revive(pe.uri),Te=_._findFolder(me||J,Oe,q);Te?(Te.name=pe.name,Te.index=pe.index,x.push(Te)):x.push({uri:Oe,name:pe.name,index:Ie})}):x.push(...$.map(({uri:pe,name:Ie,index:Oe})=>({uri:c.URI.revive(pe),name:Ie,index:Oe}))),x.sort((pe,Ie)=>pe.index<Ie.index?-1:1);const G=new _(z,ee,x,R?c.URI.revive(R):null,!!M,pe=>b(pe,q)),{added:Y,removed:ne}=h(O?O.workspaceFolders:[],G.workspaceFolders,r,q);return{workspace:G,added:Y,removed:ne}}static _findFolder(U,J,me){for(let q=0;q<U.folders.length;q++){const z=U.workspaceFolders[q];if(s(z.uri,J,me))return z}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(U,J){return J&&this._structure.get(U)&&(U=(0,k.dirname)(U)),this._structure.findSubstr(U)}resolveWorkspaceFolder(U){return this._structure.get(U)}}let v=class{constructor(U,J,me,q){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=q,this._extHostFileSystemInfo=me,this._requestIdProvider=new S.Counter,this._barrier=new I.Barrier,this._proxy=U.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=U.getProxy(n.MainContext.MainThreadMessageService);const z=J.workspace;this._confirmedWorkspace=z?new _(z.id,z.name,[],z.configuration?c.URI.revive(z.configuration):null,!!z.isUntitled,ee=>b(ee,me)):void 0}$initializeWorkspace(U,J){this._trusted=J,this.$acceptWorkspaceData(U),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:C.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(U,J,me,...q){const z=[];if(Array.isArray(q)&&q.forEach(x=>{c.URI.isUri(x.uri)&&!z.some(O=>s(O.uri,x.uri,this._extHostFileSystemInfo))&&z.push({uri:x.uri,name:x.name||(0,k.basenameOrAuthority)(x.uri)})}),this._unconfirmedWorkspace||[J,me].some(x=>typeof x!="number"||x<0)||me===0&&z.length===0)return!1;const ee=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(J+me>ee.length)return!1;const $=ee.slice(0);$.splice(J,me,...z.map(x=>({uri:x.uri,name:x.name||(0,k.basenameOrAuthority)(x.uri),index:void 0})));for(let x=0;x<$.length;x++){const O=$[x];if($.some((G,Y)=>Y!==x&&s(O.uri,G.uri,this._extHostFileSystemInfo)))return!1}$.forEach((x,O)=>x.index=O);const{added:R,removed:M}=h(ee,$,a,this._extHostFileSystemInfo);if(R.length===0&&M.length===0)return!1;if(this._proxy){const x=U.displayName||U.name;this._proxy.$updateWorkspaceFolders(x,J,me,z).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(g.Severity.Error,(0,d.localize)(0,null,x,O.toString()),{extension:U},[])})}return this.trySetWorkspaceFolders($),!0}getWorkspaceFolder(U,J){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(U,J)}async getWorkspaceFolder2(U,J){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(U,J)}async resolveWorkspaceFolder(U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(U)}getPath(){if(!!this._actualWorkspace){const{folders:U}=this._actualWorkspace;if(U.length!==0)return U[0].uri.fsPath}}getRelativePath(U,J){let me,q="";if(typeof U=="string"?(me=c.URI.file(U),q=U):typeof U!="undefined"&&(me=U,q=U.fsPath),!me)return q;const z=this.getWorkspaceFolder(me,!0);if(!z)return q;typeof J=="undefined"&&this._actualWorkspace&&(J=this._actualWorkspace.folders.length>1);let ee=(0,k.relativePath)(z.uri,me);return J&&z.name&&(ee=`${z.name}/${ee}`),ee}trySetWorkspaceFolders(U){this._actualWorkspace&&(this._unconfirmedWorkspace=_.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:U,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(U){const{workspace:J,added:me,removed:q}=_.toExtHostWorkspace(U,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=J||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:me,removed:q}))}findFiles(U,J,me,q,z=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${q.value}, entryPoint: findFiles`);let ee;if(J===null?ee=!1:J&&(typeof J=="string"?ee=J:ee=J.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:$,folder:R}=E(U);return this._proxy.$startFileSearch((0,P.withUndefinedAsNull)($),(0,P.withUndefinedAsNull)(R),(0,P.withUndefinedAsNull)(ee),(0,P.withUndefinedAsNull)(me),z).then(M=>Array.isArray(M)?M.map(x=>c.URI.revive(x)):[])}async findTextInFiles(U,J,me,q,z=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${q.value}, entryPoint: findTextInFiles`);const ee=this._requestIdProvider.getNext(),$=typeof J.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:J.previewOptions,{includePattern:R,folder:M}=E(J.include),x=typeof J.exclude=="string"?J.exclude:J.exclude?J.exclude.pattern:void 0,O={ignoreSymlinks:typeof J.followSymlinks=="boolean"?!J.followSymlinks:void 0,disregardIgnoreFiles:typeof J.useIgnoreFiles=="boolean"?!J.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof J.useGlobalIgnoreFiles=="boolean"?!J.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof J.useDefaultExcludes=="boolean"?!J.useDefaultExcludes:!0,fileEncoding:J.encoding,maxResults:J.maxResults,previewOptions:$,afterContext:J.afterContext,beforeContext:J.beforeContext,includePattern:R,excludePattern:x},G=!1;if(this._activeSearchCallbacks[ee]=Y=>{if(!G){const ne=c.URI.revive(Y.resource);Y.results.forEach(pe=>{(0,t.resultIsMatch)(pe)?me({uri:ne,preview:{text:pe.preview.text,matches:(0,w.mapArrayOrNot)(pe.preview.matches,Ie=>new p.Range(Ie.startLineNumber,Ie.startColumn,Ie.endLineNumber,Ie.endColumn))},ranges:(0,w.mapArrayOrNot)(pe.ranges,Ie=>new p.Range(Ie.startLineNumber,Ie.startColumn,Ie.endLineNumber,Ie.endColumn))}):me({uri:ne,text:pe.text,lineNumber:pe.lineNumber})})}},z.isCancellationRequested)return{};try{const Y=await this._proxy.$startTextSearch(U,(0,P.withUndefinedAsNull)(M),O,ee,z);return delete this._activeSearchCallbacks[ee],Y||{}}catch(Y){throw delete this._activeSearchCallbacks[ee],Y}}$handleTextSearchResult(U,J){this._activeSearchCallbacks[J]&&this._activeSearchCallbacks[J](U)}saveAll(U){return this._proxy.$saveAll(U)}resolveProxy(U){return this._proxy.$resolveProxy(U)}get trusted(){return this._trusted}requestWorkspaceTrust(U){const J=this._proxy.$requestWorkspaceTrust(U);return(U==null?void 0:U.modal)?J:Promise.resolve(this._trusted)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};v=Ve([qe(0,u.IExtHostRpcService),qe(1,f.IExtHostInitDataService),qe(2,D.IExtHostFileSystemInfo),qe(3,l.ILogService)],v),e.ExtHostWorkspace=v,e.IExtHostWorkspace=(0,o.createDecorator)("IExtHostWorkspace");function E(F){let U,J;return F&&(typeof F=="string"?U=F:(U=F.pattern,J=F.baseFolder||c.URI.file(F.base))),{includePattern:U,folder:J}}}),define(be[34],_e([0,1,24,3,30,5,7,155,66,10,11,4,14,19,2]),function(Q,e,w,I,A,T,y,C,S,k,i,P,c,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function l(n,s){if(s){const r=s.split(".");let a=n;for(let h=0;a&&h<r.length;h++)a=a[r[h]];return a}}function g(n){return n instanceof o.URI}function m(n){return n&&n.uri instanceof o.URI&&n.languageId&&typeof n.languageId=="string"}function D(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function f(n){return n&&n.uri instanceof o.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function u(n){if(g(n))return{resource:n};if(m(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(D(n))return{overrideIdentifier:n.languageId};if(f(n))return{resource:n.uri};if(n===null)return{resource:null}}let p=class{constructor(s,r,a){this._proxy=s.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=a,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,r){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(s,r))}};p=Ve([qe(0,c.IExtHostRpcService),qe(1,A.IExtHostWorkspace),qe(2,d.ILogService)],p),e.ExtHostConfiguration=p;class t{constructor(s,r,a,h){this._onDidChangeConfiguration=new I.Emitter,this._proxy=s,this._logService=h,this._extHostWorkspace=r,this._configuration=C.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,r){const a={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,a))}getConfiguration(s,r,a){const h=u(r)||{},b=this._toReadonlyValue(s?l(this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,h,a==null?void 0:a.identifier);function _(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const v={has(E){return typeof l(b,E)!="undefined"},get:(E,F)=>{this._validateConfigurationAccess(s?`${s}.${E}`:E,h,a==null?void 0:a.identifier);let U=l(b,E);if(typeof U=="undefined")U=F;else{let J;const me=(q,z)=>{let ee;const $=()=>{J=J||(0,w.deepClone)(b),ee=ee||l(J,z)};return(0,k.isObject)(q)?new Proxy(q,{get:(R,M)=>{if(typeof M=="string"&&M.toLowerCase()==="tojson")return $(),()=>ee;if(J)return ee=ee||l(J,z),ee[M];const x=R[M];return typeof M=="string"?me(x,`${z}.${M}`):x},set:(R,M,x)=>($(),ee&&(ee[M]=x),!0),deleteProperty:(R,M)=>($(),ee&&delete ee[M],!0),defineProperty:(R,M,x)=>($(),ee&&Object.defineProperty(ee,M,x),!0)}):q};U=me(U,E)}return U},update:(E,F,U,J)=>{E=s?`${s}.${E}`:E;const me=_(U);return F!==void 0?this._proxy.$updateConfigurationOption(me,E,F,h,J):this._proxy.$removeConfigurationOption(me,E,h,J)},inspect:E=>{var F,U,J,me,q,z,ee,$;E=s?`${s}.${E}`:E;const R=(0,w.deepClone)(this._configuration.inspect(E,h,this._extHostWorkspace.workspace));if(R)return{key:E,defaultValue:(F=R.default)===null||F===void 0?void 0:F.value,globalValue:(U=R.user)===null||U===void 0?void 0:U.value,workspaceValue:(J=R.workspace)===null||J===void 0?void 0:J.value,workspaceFolderValue:(me=R.workspaceFolder)===null||me===void 0?void 0:me.value,defaultLanguageValue:(q=R.default)===null||q===void 0?void 0:q.override,globalLanguageValue:(z=R.user)===null||z===void 0?void 0:z.override,workspaceLanguageValue:(ee=R.workspace)===null||ee===void 0?void 0:ee.override,workspaceFolderLanguageValue:($=R.workspaceFolder)===null||$===void 0?void 0:$.override,languageIds:R.overrideIdentifiers}}};return typeof b=="object"&&(0,w.mixin)(v,b,!1),Object.freeze(v)}_toReadonlyValue(s){const r=a=>(0,k.isObject)(a)?new Proxy(a,{get:(h,b)=>r(h[b]),set:(h,b,_)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(h,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(h,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return r(s)}_validateConfigurationAccess(s,r,a){const h=S.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),b=a?`[${a.value}] `:"";if(h===4){typeof(r==null?void 0:r.resource)=="undefined"&&this._logService.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){(r==null?void 0:r.resource)&&this._logService.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,r){const a=new C.ConfigurationChangeEvent(s,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(h,b)=>a.affectsConfiguration(h,u(b))})}_toMap(s){return s.reduce((r,a)=>(r.set(a[0],a[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Q):I?I.value:e.get(Q)};define(be[103],_e([0,1,2,11,3,5,7,30,39,34,20,40,14,27,4,18,21,19,75,172,12]),function(Q,e,w,I,A,T,y,C,S,k,i,P,c,d,o,l,g,m,D,f,u){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(q){function z($){if($!=null)return $}q.from=z;function ee($){if($!=null)return $}q.to=ee})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(q){function z($){if($!=null)return $}q.from=z;function ee($){if($!=null)return $}q.to=ee})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(q){function z($){if($!=null)return $}q.from=z;function ee($){if($!=null)return $}q.to=ee})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(q){function z(R){if(R){const M=R;return M&&!!M.process}else return!1}q.is=z;function ee(R){if(R!=null){const M={process:R.process,args:R.args};return R.options&&(M.options=s.from(R.options)),M}}q.from=ee;function $(R){if(R!=null)return new y.ProcessExecution(R.process,R.args,R.options)}q.to=$})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var a;(function(q){function z($){if($!=null)return $}q.from=z;function ee($){if($!=null)return $}q.to=ee})(a=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var h;(function(q){function z(R){if(R){const M=R;return M&&(!!M.commandLine||!!M.command)}else return!1}q.is=z;function ee(R){if(R!=null){const M={};return R.commandLine!==void 0?M.commandLine=R.commandLine:(M.command=R.command,M.args=R.args),R.options&&(M.options=a.from(R.options)),M}}q.from=ee;function $(R){if(!(R==null||R.command===void 0&&R.commandLine===void 0))return R.commandLine?new y.ShellExecution(R.commandLine,R.options):new y.ShellExecution(R.command,R.args?R.args:[],R.options)}q.to=$})(h=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var b;(function(q){function z(R){if(R){let M=R;return M&&M.customExecution==="customExecution"}else return!1}q.is=z;function ee(R){return{customExecution:"customExecution"}}q.from=ee;function $(R,M){return M.get(R)}q.to=$})(b=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var _;(function(q){function z(ee,$){let R;return ee.scope!==void 0&&typeof ee.scope!="number"?R=ee.scope.uri:ee.scope!==void 0&&typeof ee.scope=="number"&&(ee.scope===y.TaskScope.Workspace&&$&&$.workspaceFile?R=$.workspaceFile:R=f.USER_TASKS_GROUP_KEY),{id:ee._id,workspaceFolder:R}}q.from=z})(_=e.TaskHandleDTO||(e.TaskHandleDTO={}));var v;(function(q){function z(R,M){if(R==null)return[];const x=[];for(let O of R){const G=ee(O,M);G&&x.push(G)}return x}q.fromMany=z;function ee(R,M){if(R!=null){let x;R.execution instanceof y.ProcessExecution?x=r.from(R.execution):R.execution instanceof y.ShellExecution?x=h.from(R.execution):R.execution&&R.execution instanceof y.CustomExecution&&(x=b.from(R.execution));const O=t.from(R.definition);let G;if(R.scope?typeof R.scope=="number"?G=R.scope:G=R.scope.uri:G=y.TaskScope.Workspace,!(!O||!G)){const Y=R.group?R.group.id:void 0;return{_id:R._id,definition:O,name:R.name,source:{extensionId:M.identifier.value,label:R.source,scope:G},execution:x,isBackground:R.isBackground,group:Y,presentationOptions:n.from(R.presentationOptions),problemMatchers:R.problemMatchers,hasDefinedMatchers:R.hasDefinedMatchers,runOptions:R.runOptions?R.runOptions:{reevaluateOnRerun:!0},detail:R.detail}}}}q.from=ee;async function $(R,M,x){if(R!=null){let O;r.is(R.execution)?O=r.to(R.execution):h.is(R.execution)?O=h.to(R.execution):b.is(R.execution)&&(O=b.to(R._id,x));const G=t.to(R.definition);let Y;if(R.source&&(R.source.scope!==void 0?typeof R.source.scope=="number"?Y=R.source.scope:Y=await M.resolveWorkspaceFolder(w.URI.revive(R.source.scope)):Y=y.TaskScope.Workspace),!(!G||!Y)){const ne=new y.Task(G,Y,R.name,R.source.label,O,R.problemMatchers);return R.isBackground!==void 0&&(ne.isBackground=R.isBackground),R.group!==void 0&&(ne.group=y.TaskGroup.from(R.group)),R.presentationOptions&&(ne.presentationOptions=n.to(R.presentationOptions)),R._id&&(ne._id=R._id),R.detail&&(ne.detail=R.detail),ne}}}q.to=$})(v=e.TaskDTO||(e.TaskDTO={}));var E;(function(q){function z($){return $}q.from=z;function ee($){if(!!$)return Object.assign(Object.create(null),$)}q.to=ee})(E=e.TaskFilterDTO||(e.TaskFilterDTO={}));class F{constructor(z,ee,$){this._id=ee,this._task=$,p.set(this,void 0),tt(this,p,z,"f")}get task(){return this._task}terminate(){Me(this,p,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}p=new WeakMap;var U;(function(q){function z(ee){return{id:ee._id,task:void 0}}q.from=z})(U=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let J=class{constructor(z,ee,$,R,M,x,O,G){this._onDidExecuteTask=new A.Emitter,this._onDidTerminateTask=new A.Emitter,this._onDidTaskProcessStarted=new A.Emitter,this._onDidTaskProcessEnded=new A.Emitter,this._proxy=z.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=R,this._configurationService=M,this._terminalService=x,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=O,this._deprecationService=G,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,ee,$){if(!$)return new y.Disposable(()=>{});const R=this.nextHandle();return this._handlers.set(R,{type:ee,provider:$,extension:z}),this._proxy.$registerTaskProvider(R,ee),new y.Disposable(()=>{this._handlers.delete(R),this._proxy.$unregisterTaskProvider(R)})}registerTaskSystem(z,ee){this._proxy.$registerTaskSystem(z,ee)}fetchTasks(z){return this._proxy.$fetchTasks(E.from(z)).then(async ee=>{const $=[];for(let R of ee){const M=await v.to(R,this._workspaceProvider,this._providedCustomExecutions2);M&&$.push(M)}return $})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(ee=>z.push(ee)),z}terminateTask(z){if(!(z instanceof F))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,ee,$){const R=this._providedCustomExecutions2.get(z.id);if(R){if(this._activeCustomExecutions2.get(z.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(z.id,R),this._terminalService.attachPtyToTerminal(ee,await R.callback($))}this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const ee=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:ee})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const ee=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:ee,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const ee=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:ee,exitCode:z.exitCode})}$provideTasks(z,ee){const $=this._handlers.get(z);if(!$)return Promise.reject(new Error("no handler found"));const R=[],M=(0,I.asPromise)(()=>$.provider.provideTasks(i.CancellationToken.None)).then(x=>this.provideTasksInternal(ee,R,$,x));return new Promise(x=>{M.then(O=>{Promise.all(R).then(()=>{x(O)})})})}async $resolveTask(z,ee){const $=this._handlers.get(z);if(!$)return Promise.reject(new Error("no handler found"));if(ee.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${ee.definition.type}] cannot be resolved by provider of type [${$.type}].`);const R=await v.to(ee,this._workspaceProvider,this._providedCustomExecutions2);if(!R)throw new Error("Unexpected: Task cannot be resolved.");const M=await $.provider.resolveTask(R,i.CancellationToken.None);if(!!M){this.checkDeprecation(M,$);const x=v.from(M,$.extension);if(!x)throw new Error("Unexpected: Task cannot be resolved.");if(M.definition!==R.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return b.is(x.execution)&&await this.addCustomExecution(x,M,!0),await this.resolveTaskInternal(x)}}nextHandle(){return this._handleCounter++}async addCustomExecution(z,ee,$){const R=await this._proxy.$createTaskId(z);!$&&!this._providedCustomExecutions2.has(R)&&this._notProvidedCustomExecutions.add(R),this._providedCustomExecutions2.set(R,ee.execution)}async getTaskExecution(z,ee){if(typeof z=="string"){const M=this._taskExecutionPromises.get(z);if(!M)throw new Error("Unexpected: The specified task is missing an execution");return M}let $=this._taskExecutionPromises.get(z.id);if($)return $;const R=new Promise(async(M,x)=>{const O=ee||await v.to(z.task,this._workspaceProvider,this._providedCustomExecutions2);O?M(new F(this,z.id,O)):x("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(z.id,R),R.then(M=>(this._taskExecutions.set(z.id,M),M),M=>Promise.reject(M))}checkDeprecation(z,ee){z._deprecated&&this._deprecationService.report("Task.constructor",ee.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let $=this._notProvidedCustomExecutions.values(),R=$.next();for(;!R.done;)!this._activeCustomExecutions2.has(R.value)&&this._lastStartedTask!==R.value&&(this._providedCustomExecutions2.delete(R.value),this._notProvidedCustomExecutions.delete(R.value)),R=$.next()}};J=Ve([qe(0,c.IExtHostRpcService),qe(1,d.IExtHostInitDataService),qe(2,C.IExtHostWorkspace),qe(3,S.IExtHostDocumentsAndEditors),qe(4,k.IExtHostConfiguration),qe(5,P.IExtHostTerminalService),qe(6,m.ILogService),qe(7,D.IExtHostApiDeprecationService)],J),e.ExtHostTaskBase=J;let me=class extends J{constructor(z,ee,$,R,M,x,O,G){super(z,ee,$,R,M,x,O,G);this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:g.PlatformToString(0)})}async executeTask(z,ee){if(!ee.execution)throw new Error("Tasks to execute must include an execution");const $=v.from(ee,z);if($===void 0)throw new Error("Task is not valid");if(b.is($.execution))await this.addCustomExecution($,ee,!1);else throw new u.NotSupportedError;const R=await this.getTaskExecution(await this._proxy.$getTaskExecution($),ee);return this._proxy.$executeTask($).catch(M=>{throw new Error(M)}),R}provideTasksInternal(z,ee,$,R){const M=[];if(R)for(let x of R){this.checkDeprecation(x,$),(!x.definition||!z[x.definition.type])&&this._logService.warn(`The task [${x.source}, ${x.name}] uses an undefined task type. The task will be ignored in the future.`);const O=v.from(x,$.extension);O&&b.is(O.execution)?(M.push(O),ee.push(this.addCustomExecution(O,x,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:M,extension:$.extension}}async resolveTaskInternal(z){if(b.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,ee){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(z,ee,$){}};me=Ve([qe(0,c.IExtHostRpcService),qe(1,d.IExtHostInitDataService),qe(2,C.IExtHostWorkspace),qe(3,S.IExtHostDocumentsAndEditors),qe(4,k.IExtHostConfiguration),qe(5,P.IExtHostTerminalService),qe(6,m.ILogService),qe(7,D.IExtHostApiDeprecationService)],me),e.WorkerExtHostTask=me,e.IExtHostTask=(0,o.createDecorator)("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Q):I?I.value:e.get(Q)},Ht=this&&this.__rest||function(Q,e){var w={};for(var I in Q)Object.prototype.hasOwnProperty.call(Q,I)&&e.indexOf(I)<0&&(w[I]=Q[I]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,I=Object.getOwnPropertySymbols(Q);A<I.length;A++)e.indexOf(I[A])<0&&Object.prototype.propertyIsEnumerable.call(Q,I[A])&&(w[I[A]]=Q[I[A]]);return w};define(be[219],_e([0,1,15,11,23,20,3,53,43,6,24,10,2,31,5,39,14,69,9,7,30,183,96]),function(Q,e,w,I,A,T,y,C,S,k,i,P,c,d,o,l,g,m,D,f,u,p,t){"use strict";var n,s,r,a;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const h=($,R)=>`${$}:${R.toString()}`;let b=class{constructor(R,M,x){this.documents=M,this.workspace=x,this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.ownedTests=new p.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(o.MainContext.MainThreadTesting),this.runQueue=new _(this.proxy),this.workspaceObservers=new z(this.proxy),this.textDocumentObservers=new ee(this.proxy,M)}registerTestController(R,M){const x=(0,d.generateUuid)();this.controllers.set(x,{instance:M,extensionId:R}),this.proxy.$registerTestController(x);const O=[...this.testControllers.keys()];return setTimeout(()=>{var G;for(const Y of O)(G=this.testControllers.get(Y))===null||G===void 0||G.subscribeFn(x,M)},0),new f.Disposable(()=>{this.controllers.delete(x),this.proxy.$unregisterTestController(x)})}createTextDocumentTestObserver(R){return this.textDocumentObservers.checkout(R.uri)}createWorkspaceTestObserver(R){return this.workspaceObservers.checkout(R.uri)}async runTests(R,M=T.CancellationToken.None){const x=O=>O.map(this.getInternalTestForReference,this).filter(P.isDefined).map(G=>({src:G.src,testId:G.item.extId}));await this.proxy.$runTests({exclude:R.exclude?x(R.exclude).map(O=>O.testId):void 0,tests:x(R.tests),debug:R.debug},M)}createTestRunTask(R,M,x,O=!0){return this.runQueue.createTestRunTask(R,M,x,O)}$publishTestResults(R){this.results=Object.freeze(R.map(M=>(0,i.deepFreeze)(D.TestResults.to(M))).concat(this.results).sort((M,x)=>x.completedAt-M.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(R,M){const x=c.URI.revive(M),O=h(R,x);if(!this.testControllers.has(O)){const G=new T.CancellationTokenSource;let Y;if(R===1){let Oe=this.documents.getDocument(x);if(!Oe){const Te=new k.DisposableStore;Oe=await new Promise(Ue=>{Te.add((0,I.disposableTimeout)(()=>Ue(void 0),5e3)),Te.add(this.documents.onDidAddDocuments(B=>{const K=B.find(ie=>ie.document.uri.toString()===x.toString());K&&Ue(K)}))}).finally(()=>Te.dispose())}if(Oe){const Te=await this.workspace.getWorkspaceFolder2(x,!1);Y=Ue=>Ue.createDocumentTestRoot?Ue.createDocumentTestRoot(Oe.document,G.token):(0,e.createDefaultDocumentTestRoot)(Ue,Oe.document,Te,G.token)}}else{const Oe=await this.workspace.getWorkspaceFolder2(x,!1);Oe&&(Y=Te=>Te.createWorkspaceTestRoot(Oe,G.token))}if(!!Y){const ne=async(Oe,Te)=>{try{const Ue=await Y(Te);Ue&&Ie.addRoot(Ue,Oe)}catch(Ue){console.error(Ue)}},pe=new k.DisposableStore,Ie=pe.add(this.ownedTests.createForHierarchy(Oe=>this.proxy.$publishDiff(R,M,Oe)));pe.add((0,k.toDisposable)(()=>G.dispose(!0)));for(const[Oe,Te]of this.controllers)ne(Oe,Te.instance);Ie.pushDiff([3,-1]),this.testControllers.set(O,{store:pe,collection:Ie,subscribeFn:ne})}}}async $expandTest(R,M){const x=(0,w.mapFind)(this.testControllers.values(),O=>O.collection.treeId===R.src.tree?O:void 0);await(x==null?void 0:x.collection.expand(R.testId,M<0?Infinity:M)),this.flushCollectionDiffs()}$unsubscribeFromTests(R,M){var x;const O=c.URI.revive(M),G=h(R,O);(x=this.testControllers.get(G))===null||x===void 0||x.store.dispose(),this.testControllers.delete(G)}$acceptDiff(R,M,x){R===1?this.textDocumentObservers.acceptDiff(c.URI.revive(M),x):this.workspaceObservers.acceptDiff(c.URI.revive(M),x)}async $runTestsForProvider(R,M){const x=this.controllers.get(R.tests[0].src.controller);if(!!x){const O=R.tests.map(({testId:ne,src:pe})=>this.ownedTests.getTestById(ne,pe==null?void 0:pe.tree)).filter(P.isDefined).map(([ne,pe])=>pe),G=R.excludeExtIds.map(ne=>this.ownedTests.getTestById(ne)).filter(P.isDefined).filter(([ne,pe])=>O.some(Ie=>ne.comparePositions(Ie,pe)===1));if(!!O.length){const Y={tests:O.map(ne=>U.unwrap(ne.actual)),exclude:G.map(([,ne])=>U.unwrap(ne.actual)),debug:R.debug};await this.runQueue.enqueueRun({dto:v.fromInternal(R),token:M,extensionId:x.extensionId,req:Y,doRun:()=>x.instance.runTests(Y,M)})}}}$lookupTest(R){const M=this.ownedTests.getTestById(R.testId);if(!M)return Promise.resolve(void 0);const x=M[1],{actual:O,discoverCts:G,expandLevels:Y}=x,ne=Ht(x,["actual","discoverCts","expandLevels"]);return Promise.resolve(ne)}flushCollectionDiffs(){for(const{collection:R}of this.testControllers.values())R.flushDiff()}getInternalTestForReference(R){var M,x;return(x=(M=this.workspaceObservers.getMirroredTestDataByReference(R))!==null&&M!==void 0?M:(0,w.mapFind)(this.testControllers.values(),O=>O.collection.getTestByReference(R)))!==null&&x!==void 0?x:this.textDocumentObservers.getMirroredTestDataByReference(R)}};b=Ve([qe(0,g.IExtHostRpcService),qe(1,l.IExtHostDocumentsAndEditors),qe(2,u.IExtHostWorkspace)],b),e.ExtHostTesting=b;class _{constructor(R){this.proxy=R,this.state=new Map}enqueueRun(R){let M=this.state.get(R.extensionId);M||(M={queue:[],current:void 0},this.state.set(R.extensionId,M));const x=new I.DeferredPromise,O=()=>{const G=[],Y=new Set;M.current={publicReq:R.req,factory:ne=>{const pe=new E(ne,R.dto,Y,this.proxy);return G.push(pe),R.token.onCancellationRequested(()=>pe.end()),pe}},this.invokeRunner(R.extensionId,R.dto.id,R.doRun,G).finally(()=>x.complete())};return M.queue.push(O),M.queue.length===1&&O(),x.p}createTestRunTask(R,M,x,O){var G,Y;const ne=this.state.get(R);if((ne==null?void 0:ne.current.publicReq)===M)return ne.current.factory(x);const pe=v.fromPublic(M),Ie=new E(x,pe,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:M.debug,exclude:(Y=(G=M.exclude)===null||G===void 0?void 0:G.map(Oe=>Oe.id))!==null&&Y!==void 0?Y:[],id:pe.id,tests:M.tests.map(Oe=>Oe.id),persist:O}),Ie.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(pe.id)),Ie}invokeRunner(R,M,x,O){try{const G=x();return(0,I.isThenable)(G)?G.then(()=>this.handleInvokeResult(R,M,O,void 0)).catch(Y=>this.handleInvokeResult(R,M,O,Y)):this.handleInvokeResult(R,M,O,void 0)}catch(G){return this.handleInvokeResult(R,M,O,G)}}async handleInvokeResult(R,M,x,O){const G=this.state.get(R);!G||(G.queue.shift(),G.queue.length>0?G.queue[0]():this.state.delete(R),await Promise.all(x.map(Y=>Y.onEnd.wait())))}}class v{constructor(R,M,x){this.id=R,this.include=M,this.exclude=x}static fromPublic(R){var M,x;return new v((0,d.generateUuid)(),new Set(R.tests.map(O=>O.id)),new Set((x=(M=R.exclude)===null||M===void 0?void 0:M.map(O=>O.id))!==null&&x!==void 0?x:S.Iterable.empty()))}static fromInternal(R){return new v(R.runId,new Set(R.tests.map(M=>M.testId)),new Set(R.excludeExtIds))}isIncluded(R){for(let M=R;M;M=M.parent){if(this.include.has(M.id))return!0;if(this.exclude.has(M.id))return!1}return!0}}class E{constructor(R,M,x,O){this.name=R,n.set(this,void 0),s.set(this,void 0),r.set(this,(0,d.generateUuid)()),a.set(this,void 0),this.onEnd=new I.Barrier,tt(this,n,O,"f"),tt(this,s,M,"f"),tt(this,a,x,"f"),O.$startedTestRunTask(M.id,{id:Me(this,r,"f"),name:R,running:!0})}setState(R,M,x){Me(this,s,"f").isIncluded(R)&&(this.ensureTestIsKnown(R),Me(this,n,"f").$updateTestStateInRun(Me(this,s,"f").id,Me(this,r,"f"),R.id,M,x))}appendMessage(R,M){Me(this,s,"f").isIncluded(R)&&(this.ensureTestIsKnown(R),Me(this,n,"f").$appendTestMessageInRun(Me(this,s,"f").id,Me(this,r,"f"),R.id,D.TestMessage.from(M)))}appendOutput(R){Me(this,n,"f").$appendOutputToRun(Me(this,s,"f").id,Me(this,r,"f"),A.VSBuffer.fromString(R))}end(){Me(this,n,"f").$finishedTestRunTask(Me(this,s,"f").id,Me(this,r,"f")),this.onEnd.open()}ensureTestIsKnown(R){const M=Me(this,a,"f");if(!M.has(R.id)){const x=[];for(;x.unshift(D.TestItem.from(R)),!(M.has(R.id)||(M.add(R.id),!R.parent));)R=R.parent;Me(this,n,"f").$addTestsToRun(Me(this,s,"f").id,x)}}}n=new WeakMap,s=new WeakMap,r=new WeakMap,a=new WeakMap;const F=async($,R,M,x)=>{if(!!M){const O=await $.createWorkspaceTestRoot(M,x);if(!!O){x.onCancellationRequested(()=>{U.removeFilter(R)});const G=U.getWrapperForTestItem(O,R);return G.refreshMatch(),G}}};e.createDefaultDocumentTestRoot=F;class U extends f.TestItemImpl{constructor(R,M,x){super(R.id,R.label,R.uri,void 0);if(this.actual=R,this.filterDocument=M,this.actualParent=x,!(R instanceof f.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${R.id} did not`);this.debuggable=R.debuggable,this.runnable=R.runnable,this.description=R.description,this.error=R.error,this.status=R.status,this.range=R.range,this.resolveHandler=R.resolveHandler;const O=(0,m.getPrivateApiFor)(this);(0,m.getPrivateApiFor)(R).bus.event(Y=>{switch(Y[0]){case 3:this[Y[1]]=Y[2];break;case 0:const ne=U.getWrapperForTestItem(Y[1],this.filterDocument,this);(0,m.getPrivateApiFor)(ne).parent=R,ne.refreshMatch();break;default:O.bus.fire(Y)}})}static removeFilter(R){this.wrapperMap.delete(R)}static getWrapperForTestItem(R,M,x){let O=this.wrapperMap.get(M);if(O==null?void 0:O.has(R))return O.get(R);O||(O=new WeakMap,this.wrapperMap.set(M,O));const G=new U(R,M,x);return O.set(R,G),G}static unwrap(R){return R instanceof U?R.actual:R}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var R;const M=this._cachedMatchesFilter;for(const O of this.actual.children.values()){const G=U.getWrapperForTestItem(O,this.filterDocument,this);G.hasNodeMatchingFilter?this.children.has(G.id)||this.addChild(G):G.dispose()}const x=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=x,x!==M&&((R=this.actualParent)===null||R===void 0||R.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,m.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,m.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=U,U.wrapperMap=new WeakMap;class J extends t.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,D.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:M,removed:x}=this;return{get added(){return[...R].map(O=>O.revived)},get updated(){return[...M].map(O=>O.revived)},get removed(){return[...x].map(O=>O.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class me extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(R){let M=[];for(const x of R){const O=this.items.get(x);O&&M.push(O.revived)}return M}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,M){return Object.assign(Object.assign({},R),{revived:D.TestItem.toPlain(R.item),depth:M?M.depth+1:0,children:new Set})}createChangeCollector(){return new J(this.changeEmitter)}}e.MirroredTestCollection=me;class q{constructor(){this.resources=new Map}checkout(R){var M,x;const O=R.toString(),G=(M=this.resources.get(O))!==null&&M!==void 0?M:this.createObserverData(R);return(x=G.pendingDeletion)===null||x===void 0||x.dispose(),G.observers++,{onDidChangeTest:G.tests.onDidChangeTests,onDidDiscoverInitialTests:new y.Emitter().event,get tests(){return G.tests.rootTestItems},dispose:(0,C.once)(()=>{--G.observers||(G.pendingDeletion=this.eventuallyDispose(R))})}}getMirroredTestDataByReference(R){for(const{tests:M}of this.resources.values()){const x=M.getMirroredTestDataByReference(R);if(x)return x}}eventuallyDispose(R){return(0,I.disposableTimeout)(()=>this.unlisten(R),10*1e3)}createObserverData(R){const M=new me,x=this.listen(R,G=>M.apply(G)),O={observers:0,tests:M,listener:x};return this.resources.set(R.toString(),O),O}unlisten(R){var M;const x=R.toString(),O=this.resources.get(x);O&&(O.observers=-1,(M=O.pendingDeletion)===null||M===void 0||M.dispose(),O.listener.dispose(),this.resources.delete(x))}}class z extends q{constructor(R){super();this.proxy=R,this.diffListeners=new Map}acceptDiff(R,M){var x;(x=this.diffListeners.get(R.toString()))===null||x===void 0||x(M)}listen(R,M){this.proxy.$subscribeToDiffs(0,R);const x=R.toString();return this.diffListeners.set(x,M),new f.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,R),this.diffListeners.delete(x)})}}class ee extends q{constructor(R,M){super();this.proxy=R,this.documents=M,this.diffListeners=new Map}acceptDiff(R,M){var x;(x=this.diffListeners.get(R.toString()))===null||x===void 0||x(M)}listen(R,M){if(!this.documents.getDocument(R))return new f.Disposable(()=>{});const O=R.toString();return this.diffListeners.set(O,M),this.proxy.$subscribeToDiffs(1,R),new f.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,R),this.diffListeners.delete(O)})}}}),define(be[220],_e([0,1,15,51,28,58,22,18,13,25,8,10,2,116,141,92,48,175,218,41]),function(Q,e,w,I,A,T,y,C,S,k,i,P,c,d,o,l,g,m,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(_,v,E,F){this.configurationService=_,this.workspaceContextService=v,this.editorGroupsService=E,this.pathService=F}text(_,v,E={}){_=this.getContentPattern(_,E);const F=this.configurationService.getValue(),U=v&&v.some(me=>!this.configurationService.getValue({resource:me}).search.useRipgrep),J=this.commonQuery(v==null?void 0:v.map(g.toWorkspaceFolder),E);return Object.assign(Object.assign({},J),{type:2,contentPattern:_,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:F.search.usePCRE2||U||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles})}getContentPattern(_,v){const E=this.configurationService.getValue();_.isRegExp&&(_.pattern=_.pattern.replace(/\r?\n/g,"\\n"));const F=Object.assign(Object.assign({},_),{wordSeparators:E.editor.wordSeparators});return this.isCaseSensitive(_,v)&&(F.isCaseSensitive=!0),this.isMultiline(_)&&(F.isMultiline=!0),F}file(_,v={}){const E=this.commonQuery(_,v);return Object.assign(Object.assign({},E),{type:1,filePattern:v.filePattern?v.filePattern.trim():v.filePattern,exists:v.exists,sortByScore:v.sortByScore,cacheKey:v.cacheKey})}handleIncludeExclude(_,v){return _?(_=Array.isArray(_)?_.map(r):r(_),v?this.parseSearchPaths(_):{pattern:t(...Array.isArray(_)?_:[_])}):{}}commonQuery(_=[],v={}){const E=this.handleIncludeExclude(v.includePattern,v.expandPatterns),F=this.handleIncludeExclude(v.excludePattern,v.expandPatterns),U=_.length>1,J=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map(z=>this.getFolderQueryForSearchPath(z,v,F)):_.map(z=>this.getFolderQueryForRoot(z,v,F,U))).filter(z=>!!z),me={_reason:v._reason,folderQueries:J,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:v.extraFileResources,excludePattern:F.pattern,includePattern:E.pattern,onlyOpenEditors:v.onlyOpenEditors,maxResults:v.maxResults};if(v.onlyOpenEditors){const ee=w.coalesce(w.flatten(this.editorGroupsService.groups.map(R=>R.editors.map(M=>M.resource)))).filter(R=>(0,f.pathIncludedInQuery)(me,R.fsPath)),$=this.commonQueryFromFileList(ee);return Object.assign(Object.assign({},me),$)}const q=v.extraFileResources&&v.extraFileResources.filter(z=>(0,f.pathIncludedInQuery)(me,z.fsPath));return me.extraFileResources=q&&q.length?q:void 0,me}commonQueryFromFileList(_){const v=[],E=new y.ResourceMap,F={};let U=!1;return _.forEach(J=>{var me,q;if(J.scheme!==C.Schemas.walkThrough)if((0,k.isAbsolutePath)(J)){const ee=(q=(me=this.workspaceContextService.getWorkspaceFolder(J))===null||me===void 0?void 0:me.uri)!==null&&q!==void 0?q:J.with({path:S.dirname(J.fsPath)});let $=E.get(ee);$||(U=!0,$={folder:ee,includePattern:{}},v.push($),E.set(ee,$));const R=S.relative(ee.fsPath,J.fsPath);(0,P.assertIsDefined)($.includePattern)[R.replace(/\\/g,"/")]=!0}else J.fsPath&&(U=!0,F[J.fsPath]=!0)}),{folderQueries:v,includePattern:F,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}isCaseSensitive(_,v){if(v.isSmartCase){if(_.isRegExp){if(i.containsUppercaseCharacter(_.pattern,!0))return!0}else if(i.containsUppercaseCharacter(_.pattern))return!0}return!!_.isCaseSensitive}isMultiline(_){return _.isMultiline||_.isRegExp&&(0,d.isMultilineRegexSource)(_.pattern)||_.pattern.indexOf(`
`)>=0?!0:!!_.isMultiline}parseSearchPaths(_){const v=$=>S.isAbsolute($)||/^\.\.?([\/\\]|$)/.test($),F=(Array.isArray(_)?_:n(_)).map($=>{const R=this.pathService.resolvedUserHome;return R?(0,T.untildify)($,R.scheme===C.Schemas.file?R.fsPath:R.path):$}),U=I.groupBy(F,$=>v($)?"searchPaths":"exprSegments"),J=(U.exprSegments||[]).map($=>i.rtrim($,"/")).map($=>i.rtrim($,"\\")).map($=>($[0]==="."&&($="*"+$),s($))),me={},q=this.expandSearchPathPatterns(U.searchPaths||[]);q&&q.length&&(me.searchPaths=q);const z=w.flatten(J),ee=t(...z);return ee&&(me.pattern=ee),me}getExcludesForFolder(_,v){return v.disregardExcludeSettings?void 0:(0,f.getExcludes)(_,!v.disregardSearchExcludeSettings)}expandSearchPathPatterns(_){if(!_||!_.length)return[];const v=w.flatten(_.map(F=>{let{pathPortion:U,globPortion:J}=p(F);J&&(J=a(J));const me=this.expandOneSearchPath(U);return w.flatten(me.map(q=>this.resolveOneSearchPathPattern(q,J)))})),E=new Map;return v.forEach(F=>{const U=F.searchPath.toString(),J=E.get(U);J?F.pattern&&(J.pattern=J.pattern||{},J.pattern[F.pattern]=!0):E.set(U,{searchPath:F.searchPath,pattern:F.pattern?t(F.pattern):void 0})}),Array.from(E.values())}expandOneSearchPath(_){if(S.isAbsolute(_)){const v=this.workspaceContextService.getWorkspace().folders;return v[0]&&v[0].uri.scheme!==C.Schemas.file?[{searchPath:v[0].uri.with({path:_})}]:[{searchPath:c.URI.file(S.normalize(_))}]}if(this.workspaceContextService.getWorkbenchState()===2){const v=this.workspaceContextService.getWorkspace().folders[0].uri;if(_=r(_),_.startsWith("../")||_===".."){const F=S.posix.resolve(v.path,_);return[{searchPath:v.with({path:F})}]}const E=a(_);return[{searchPath:v,pattern:E}]}else{if(_==="./"||_===".\\")return[];{const v=_.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(v){const E=v[1],F=this.workspaceContextService.getWorkspace().folders.filter(U=>U.name===E);if(F.length)return F.map(U=>{const J=v[2];return{searchPath:U.uri,pattern:J&&a(J)}});{const U=o.localize(0,null,E);throw new Error(U)}}}}return[]}resolveOneSearchPathPattern(_,v){const E=_.pattern&&v?`${_.pattern}/${v}`:_.pattern||v,F=[{searchPath:_.searchPath,pattern:E}];return E&&!E.endsWith("**")&&F.push({searchPath:_.searchPath,pattern:E+"/**"}),F}getFolderQueryForSearchPath(_,v,E){const F=this.getFolderQueryForRoot((0,g.toWorkspaceFolder)(_.searchPath),v,E,!1);return F?Object.assign(Object.assign({},F),{includePattern:_.pattern}):null}getFolderQueryForRoot(_,v,E,F){let U;const J=c.URI.isUri(_)?_:_.uri;if(E.searchPaths){const $=E.searchPaths.filter(R=>(0,k.isEqual)(R.searchPath,J))[0];if($&&!$.pattern)return null;$&&(U=$.pattern)}const me=this.configurationService.getValue({resource:J}),q=this.getExcludesForFolder(me,v),z=Object.assign(Object.assign({},q||{}),U||{}),ee=c.URI.isUri(_)?(0,k.basename)(_):_.name;return{folder:J,folderName:F?ee:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:me.files&&me.files.encoding,disregardIgnoreFiles:typeof v.disregardIgnoreFiles=="boolean"?v.disregardIgnoreFiles:!me.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof v.disregardGlobalIgnoreFiles=="boolean"?v.disregardGlobalIgnoreFiles:!me.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof v.ignoreSymlinks=="boolean"?v.ignoreSymlinks:!me.search.followSymlinks}}};u=Ve([qe(0,l.IConfigurationService),qe(1,g.IWorkspaceContextService),qe(2,m.IEditorGroupsService),qe(3,D.IPathService)],u),e.QueryBuilder=u;function p(b){const _=b.match(/[\*\{\}\(\)\[\]\?]/);if(_){const v=_.index,E=b.substr(0,v).match(/[/|\\][^/\\]*$/);if(E){let F=b.substr(0,E.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:b.substr((E.index||0)+1)}}}return{pathPortion:b}}function t(...b){return b.length?b.reduce((_,v)=>(_[v]=!0,_),Object.create(null)):void 0}function n(b){return A.splitGlobAware(b,",").map(_=>_.trim()).filter(_=>!!_.length)}function s(b){return[`**/${b}/**`,`**/${b}`].map(v=>v.replace(/\*\*\/\*\*/g,"**"))}function r(b){return b.replace(/\\/g,"/")}function a(b){return r(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(b,_){b=w.distinct(b,F=>F.toString());const v=[],E=_.getWorkspace();return b&&b.forEach(F=>{let U;if(_.getWorkbenchState()===2)U=(0,k.relativePath)(E.folders[0].uri,F),U&&U!=="."&&(U="./"+U);else{const J=_.getWorkspaceFolder(F);if(J){const me=J.name;if(E.folders.filter(z=>z.name===me).length===1){const z=(0,k.relativePath)(J.uri,F);z===""?U=`./${J.name}`:U=`./${J.name}/${z}`}else U=F.fsPath}}U&&v.push(U)}),v}e.resolveResourcesForSearchIncludes=h}),define(be[221],_e([0,1,25,2,20,12,4,220,41,48]),function(Q,e,w,I,A,T,y,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function P(l,g){const m=g.activationEvents;if(!m)return Promise.resolve(void 0);const D=[],f=[];for(const r of m)if(/^workspaceContains:/.test(r)){const a=r.substr("workspaceContains:".length);a.indexOf("*")>=0||a.indexOf("?")>=0||l.forceUsingSearch?f.push(a):D.push(a)}if(D.length===0&&f.length===0)return Promise.resolve(void 0);let u;const p=new Promise((r,a)=>{u=r}),t=r=>u({activationEvent:r}),n=Promise.all(D.map(r=>c(l,r,t))).then(()=>{}),s=d(l,g.identifier,f,t);return Promise.all([n,s]).then(()=>{u(void 0)}),p}e.checkActivateWorkspaceContainsExtension=P;async function c(l,g,m){for(const D of l.folders)if(await l.exists(w.joinPath(I.URI.revive(D),g))){m(`workspaceContains:${g}`);return}}async function d(l,g,m,D){if(m.length===0)return Promise.resolve(void 0);const f=new A.CancellationTokenSource,u=l.checkExists(l.folders,m,f.token),p=setTimeout(async()=>{f.cancel(),D(`workspaceContainsTimeout:${m.join(",")}`)},i);let t=!1;try{t=await u}catch(n){T.isPromiseCanceledError(n)||T.onUnexpectedError(n)}f.dispose(),clearTimeout(p),t&&D(`workspaceContains:${m.join(",")}`)}function o(l,g,m,D){const f=l.get(y.IInstantiationService),u=l.get(S.ISearchService),t=f.createInstance(C.QueryBuilder).file(g.map(n=>(0,k.toWorkspaceFolder)(I.URI.revive(n))),{_reason:"checkExists",includePattern:m,exists:!0});return u.fileSearch(t,D).then(n=>!!n.limitHit,n=>T.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=o});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Q):I?I.value:e.get(Q)};define(be[35],_e([0,1,133,13,80,25,11,6,22,2,19,5,34,186,78,30,33,184,12,26,18,23,162,7,67,4,27,79,14,65,70,40,3,221,74,163]),function(Q,e,w,I,A,T,y,C,S,k,i,P,c,d,o,l,g,m,D,f,u,p,t,n,s,r,a,h,b,_,v,E,F,U,J,me){"use strict";var q,z,ee;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let $=class Rn extends C.Disposable{constructor(O,G,Y,ne,pe,Ie,Oe,Te,Ue,B){super();this._onDidChangeRemoteConnectionData=this._register(new F.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=G,this._extHostContext=Y,this._initData=Oe,this._extHostWorkspace=ne,this._extHostConfiguration=pe,this._logService=Ie,this._extHostTunnelService=Ue,this._extHostTerminalService=B,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new m.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new o.ExtHostStorage(this._extHostContext),this._secretState=new J.ExtHostSecretState(this._extHostContext),this._storagePath=Te,this._instaService=O.createChild(new _.ServiceCollection([o.IExtHostStorage,this._storage],[J.IExtHostSecretState,this._secretState]));const K=new Set;this._initData.hostExtensions.forEach(ie=>K.add(f.ExtensionIdentifier.toKey(ie))),this._activator=new d.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ie,le)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ie,le)},actualActivateExtension:async(ie,le)=>{if(K.has(f.ExtensionIdentifier.toKey(ie)))return await this._mainThreadExtensionsProxy.$activateExtension(ie,le),new d.HostExtension;const fe=this._registry.getExtensionDescription(ie);return this._activateExtension(fe,le)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),A.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){D.onUnexpectedError(O)}}async deactivateAll(){let O=[];try{O=this._registry.getAllExtensionDescriptions().map(pe=>pe.identifier).filter(pe=>this.isActivated(pe)).map(pe=>this._deactivate(pe))}catch(G){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,G){return this._activator.activateByEvent(O,G)}_activateById(O,G){return this._activator.activateById(O,G)}activateByIdWithErrors(O,G){return this._activateById(O,G).then(()=>{const Y=this._activator.getActivatedExtension(O);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const O=S.TernarySearchTree.forPaths(),G=this._registry.getAllExtensionDescriptions().map(Y=>{if(!!this._getEntryPoint(Y))return this._hostUtils.realpath(Y.extensionLocation.fsPath).then(ne=>O.set(k.URI.file(ne).fsPath,Y))});this._extensionPathIndex=Promise.all(G).then(()=>O)}return this._extensionPathIndex}_deactivate(O){let G=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return G;const Y=this._activator.getActivatedExtension(O);if(!Y)return G;try{typeof Y.module.deactivate=="function"&&(G=Promise.resolve(Y.module.deactivate()).then(void 0,ne=>Promise.resolve(void 0)))}catch(ne){}try{(0,C.dispose)(Y.subscriptions)}catch(ne){}return G}async _activateExtension(O,G){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,G).then(Y=>{const ne=Y.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,ne.codeLoadingTime,ne.activateCallTime,ne.activateResolvedTime,G),this._logExtensionActivationTimes(O,G,"success",ne),Y},Y=>{throw this._logExtensionActivationTimes(O,G,"failure"),Y})}_logExtensionActivationTimes(O,G,Y,ne){const pe=R(O,G);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},pe),ne||{}),{outcome:Y}))}_doActivateExtension(O,G){const Y=R(O,G);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Y);const ne=this._getEntryPoint(O);if(!ne)return Promise.resolve(new d.EmptyExtension(d.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value} ${JSON.stringify(G)}`),this._logService.flush();const pe=new d.ExtensionActivationTimesBuilder(G.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,T.joinPath)(O.extensionLocation,ne),pe),this._loadExtensionContext(O)]).then(Ie=>(A.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),Rn._callActivate(this._logService,O.identifier,Ie[0],Ie[1],pe))).then(Ie=>(A.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),Ie))}_loadExtensionContext(O){const G=new t.ExtensionGlobalMemento(O,this._storage),Y=new t.ExtensionMemento(O.identifier.value,!1,this._storage),ne=new me.ExtensionSecrets(O,this._secretState),pe=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,Ie=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([G.whenReady,Y.whenReady,this._storagePath.whenReady]).then(()=>{const Oe=this;let Te;return Object.freeze({globalState:G,workspaceState:Y,secrets:ne,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Ue){return I.join(O.extensionLocation.fsPath,Ue)},get storagePath(){var Ue;return(Ue=Oe._storagePath.workspaceValue(O))===null||Ue===void 0?void 0:Ue.fsPath},get globalStoragePath(){return Oe._storagePath.globalValue(O).fsPath},get logPath(){return I.join(Oe._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return k.URI.joinPath(Oe._initData.logsLocation,O.identifier.value)},get storageUri(){return Oe._storagePath.workspaceValue(O)},get globalStorageUri(){return Oe._storagePath.globalValue(O)},get extensionMode(){return pe},get extension(){return Te===void 0&&(Te=new M(Oe,O.identifier,O,Ie)),Te},get extensionRuntime(){return(0,g.checkProposedApiEnabled)(O),Oe.extensionRuntime},get environmentVariableCollection(){return Oe._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,G,Y,ne,pe){return Y=Y||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,G,Y,ne,pe).then(Ie=>new d.ActivatedExtension(!1,null,pe.build(),Y,Ie,ne.subscriptions))}static _callActivateOptional(O,G,Y,ne,pe){if(typeof Y.activate=="function")try{pe.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${G.value}`);const Ie=typeof global=="object"?global:self,Oe=Y.activate.apply(Ie,[ne]);return pe.activateCallStop(),pe.activateResolveStart(),Promise.resolve(Oe).then(Te=>(pe.activateResolveStop(),Te))}catch(Ie){return Promise.reject(Ie)}else return Promise.resolve(Y)}_activateOneStartupFinished(O,G){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:G}).then(void 0,Y=>{this._logService.error(Y)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(A.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const G of O.activationEvents)G==="onStartupFinished"&&this._activateOneStartupFinished(O,G)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,pe=>{this._logService.error(pe)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(pe=>this._handleWorkspaceContainsEagerExtensions(pe.added)));const G=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Y=this._handleWorkspaceContainsEagerExtensions(G),ne=Promise.all([O,Y]).then(()=>{});return Promise.race([ne,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ne}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(G=>this._handleWorkspaceContainsEagerExtension(O,G))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,G){if(!this.isActivated(G.identifier)){const Y=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ne={folders:O.map(Ie=>Ie.uri),forceUsingSearch:Y,exists:Ie=>this._hostUtils.exists(Ie.fsPath),checkExists:(Ie,Oe,Te)=>this._mainThreadWorkspaceProxy.$checkExists(Ie,Oe,Te)},pe=await(0,U.checkActivateWorkspaceContainsExtension)(ne,G);if(!!pe)return this._activateById(G.identifier,{startup:!0,extensionId:G.identifier,activationEvent:pe.activationEvent}).then(void 0,Ie=>this._logService.error(Ie))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:G}=this._initData.environment;if(!O||!G||G.scheme!==u.Schemas.file)throw new Error(w.localize(0,null));const Y=(0,T.originalFSPath)(G),ne=await this._loadCommonJSModule(null,G,new d.ExtensionActivationTimesBuilder(!1));if(!ne||typeof ne.run!="function")throw new Error(w.localize(1,null,Y));return new Promise((pe,Ie)=>{const Oe=(Ue,B)=>{Ue?Ie(Ue):pe(typeof B=="number"&&B>0?1:0)},Te=ne.run(Y,Oe);Te&&Te.then&&Te.then(()=>{pe(0)}).catch(Ue=>{Ie(Ue.toString())})})}async $extensionTestsExit(O){this._logService.info(`extension host terminating: test runner requested exit with code ${O}`),this._logService.info(`exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(O,G){return this._resolvers[O]=G,(0,C.toDisposable)(()=>{delete this._resolvers[O]})}async $resolveAuthority(O,G){const Y=O.indexOf("+");if(Y===-1)throw new Error("Not an authority that can be resolved!");const ne=O.substr(0,Y);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ne}`,!1);const pe=this._resolvers[ne];if(!pe)return{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ne}.`,detail:void 0}};try{A.mark(`code/extHost/willResolveAuthority/${ne}`);const Ie=await pe.resolve(O,{resolveAttempt:G});A.mark(`code/extHost/didResolveAuthorityOK/${ne}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(pe));const Oe={authority:O,host:Ie.host,port:Ie.port,connectionToken:Ie.connectionToken},Te={extensionHostEnv:Ie.extensionHostEnv,trust:Ie.trust};return{type:"ok",value:{authority:Oe,options:Te,tunnelInformation:{environmentTunnels:Ie.environmentTunnels}}}}catch(Ie){if(A.mark(`code/extHost/didResolveAuthorityError/${ne}`),Ie instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:Ie._code,message:Ie._message,detail:Ie._detail}};throw Ie}}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,G){return G===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(Y=>this._activateByEvent(O,!1))}async $activate(O,G){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,G),!0):!1}async $deltaExtensions(O,G){O.forEach(ne=>ne.extensionLocation=k.URI.revive(ne.extensionLocation));const Y=await this.getExtensionPathIndex();return await Promise.all(G.map(async ne=>{const pe=this._registry.getExtensionDescription(ne);if(!!pe){const Ie=await this._hostUtils.realpath(pe.extensionLocation.fsPath);Y.delete(k.URI.file(Ie).fsPath)}})),await Promise.all(O.map(async ne=>{const pe=await this._hostUtils.realpath(ne.extensionLocation.fsPath);Y.set(k.URI.file(pe).fsPath,ne)})),this._registry.deltaExtensions(O,G),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let G=p.VSBuffer.alloc(O),Y=Math.random()%256;for(let ne=0;ne<O;ne++)G.writeUInt8(Y,ne);return G}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};$=Ve([qe(0,r.IInstantiationService),qe(1,e.IHostUtils),qe(2,b.IExtHostRpcService),qe(3,l.IExtHostWorkspace),qe(4,c.IExtHostConfiguration),qe(5,i.ILogService),qe(6,a.IExtHostInitDataService),qe(7,h.IExtensionStoragePaths),qe(8,v.IExtHostTunnelService),qe(9,E.IExtHostTerminalService)],$),e.AbstractExtHostExtensionService=$;function R(x,O){return{id:x.identifier.value,name:x.name,extensionVersion:x.version,publisherDisplayName:x.publisher,activationEvents:x.activationEvents?x.activationEvents.join(","):null,isBuiltin:x.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class M{constructor(O,G,Y,ne){q.set(this,void 0),z.set(this,void 0),ee.set(this,void 0),tt(this,q,O,"f"),tt(this,z,G,"f"),tt(this,ee,Y.identifier,"f"),this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=I.normalize((0,T.originalFSPath)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=ne}get isActive(){return Me(this,q,"f").isActivated(Me(this,ee,"f"))}get exports(){if(this.packageJSON.api!=="none")return Me(this,q,"f").getExtensionExports(Me(this,ee,"f"))}activate(){return Me(this,q,"f").activateByIdWithErrors(Me(this,ee,"f"),{startup:!1,extensionId:Me(this,z,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=M,q=new WeakMap,z=new WeakMap,ee=new WeakMap}),define(be[104],_e([0,1,13,2,3,11,5,7,170,30,35,39,174,34,171,14,4,10,46]),function(Q,e,w,I,A,T,y,C,S,k,i,P,c,d,o,l,g,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,g.createDecorator)("IExtHostDebugService");let f=class{constructor(h,b,_,v,E){this._workspaceService=b,this._extensionService=_,this._editorsService=v,this._configurationService=E,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new A.Emitter,this._onDidTerminateDebugSession=new A.Emitter,this._onDidChangeActiveDebugSession=new A.Emitter,this._onDidReceiveDebugSessionCustomEvent=new A.Emitter,this._debugServiceProxy=h.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new A.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new p(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(F=>{F.onDidChange(U=>{this.registerAllDebugTypes(F)}),this.registerAllDebugTypes(F)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(h,b){const _=h;if(typeof _.sourceReference=="number"&&_.sourceReference>0){let v=`debug:${encodeURIComponent(_.path||"")}`,E="?";return b&&(v+=`${E}session=${encodeURIComponent(b.id)}`,E="&"),v+=`${E}ref=${_.sourceReference}`,I.URI.parse(v)}else{if(_.path)return I.URI.file(_.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(h){const b=[];for(const _ of h.getAllExtensionDescriptions())if(_.contributes){const v=_.contributes.debuggers;if(v&&v.length>0)for(const E of v)(0,o.isDebuggerMainContribution)(E)&&b.push(E.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const h=[];return this._breakpoints.forEach(b=>h.push(b)),h}addBreakpoints(h){this.startBreakpoints();const b=h.filter(E=>{const F=E.id;return this._breakpoints.has(F)?!1:(this._breakpoints.set(F,E),!0)});this.fireBreakpointChanges(b,[],[]);const _=[],v=new Map;for(const E of b)if(E instanceof C.SourceBreakpoint){let F=v.get(E.location.uri.toString());F||(F={type:"sourceMulti",uri:E.location.uri,lines:[]},v.set(E.location.uri.toString(),F),_.push(F)),F.lines.push({id:E.id,enabled:E.enabled,condition:E.condition,hitCondition:E.hitCondition,logMessage:E.logMessage,line:E.location.range.start.line,character:E.location.range.start.character})}else E instanceof C.FunctionBreakpoint&&_.push({type:"function",id:E.id,enabled:E.enabled,hitCondition:E.hitCondition,logMessage:E.logMessage,condition:E.condition,functionName:E.functionName});return this._debugServiceProxy.$registerBreakpoints(_)}removeBreakpoints(h){this.startBreakpoints();const b=h.filter(F=>this._breakpoints.delete(F.id));this.fireBreakpointChanges([],b,[]);const _=b.filter(F=>F instanceof C.SourceBreakpoint).map(F=>F.id),v=b.filter(F=>F instanceof C.FunctionBreakpoint).map(F=>F.id),E=b.filter(F=>F instanceof C.DataBreakpoint).map(F=>F.id);return this._debugServiceProxy.$unregisterBreakpoints(_,v,E)}startDebugging(h,b,_){return this._debugServiceProxy.$startDebugging(h?h.uri:void 0,b,{parentSessionID:_.parentSession?_.parentSession.id:void 0,repl:_.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:_.noDebug,compact:_.compact})}stopDebugging(h){return this._debugServiceProxy.$stopDebugging(h?h.id:void 0)}registerDebugConfigurationProvider(h,b,_){if(!b)return new C.Disposable(()=>{});const v=this._configProviderHandleCounter++;return this._configProviders.push({type:h,handle:v,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(h,_,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,v),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(E=>E.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(h,b,_){if(!_)return new C.Disposable(()=>{});if(!this.definesDebugType(h,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:v,factory:_}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,v),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(E=>E.factory!==_),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(h,b){if(!b)return new C.Disposable(()=>{});const _=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:h,handle:_,factory:b}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(v=>v.factory!==b)})}async $runInTerminal(h,b){return Promise.resolve(void 0)}async $substituteVariables(h,b){if(!this._variableResolver){const[E,F]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(E||[],this._editorsService,F)}let _;const v=await this.getFolder(h);return v&&(_={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(_,b)}createDebugAdapter(h,b){if(h.type==="implementation")return new s(h.implementation)}createSignService(){}async $startDASession(h,b){const _=this,v=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(v.type),v).then(E=>{if(!E)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const F=this.convertToDto(E),U=this.createDebugAdapter(F,v);if(!U)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const J=U;return this._debugAdapters.set(h,J),this.getDebugAdapterTrackers(v).then(me=>(me&&this._debugAdaptersTrackers.set(h,me),J.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const z=q,ee={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(z.arguments.value);ee.body={signature:$},J.sendResponse(ee)}else throw new Error("no signer")}catch($){ee.success=!1,ee.message=$.message,J.sendResponse(ee)}}else me&&me.onDidSendMessage&&me.onDidSendMessage(q),q=(0,o.convertToVSCPaths)(q,!0),_._debugServiceProxy.$acceptDAMessage(h,q)}),J.onError(q=>{me&&me.onError&&me.onError(q),this._debugServiceProxy.$acceptDAError(h,q.name,q.message,q.stack)}),J.onExit(q=>{me&&me.onExit&&me.onExit((0,m.withNullAsUndefined)(q),void 0),this._debugServiceProxy.$acceptDAExit(h,(0,m.withNullAsUndefined)(q),void 0)}),me&&me.onWillStartSession&&me.onWillStartSession(),J.startSession()))})}$sendDAMessage(h,b){b=(0,o.convertToDAPaths)(b,!1);const _=this._debugAdaptersTrackers.get(h);_&&_.onWillReceiveMessage&&_.onWillReceiveMessage(b);const v=this._debugAdapters.get(h);v&&v.sendMessage(b)}$stopDASession(h){const b=this._debugAdaptersTrackers.get(h);this._debugAdaptersTrackers.delete(h),b&&b.onWillStopSession&&b.onWillStopSession();const _=this._debugAdapters.get(h);return this._debugAdapters.delete(h),_?_.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(h){const b=[],_=[],v=[];if(h.added)for(const E of h.added){const F=E.id;if(F&&!this._breakpoints.has(F)){let U;if(E.type==="function")U=new C.FunctionBreakpoint(E.functionName,E.enabled,E.condition,E.hitCondition,E.logMessage);else if(E.type==="data")U=new C.DataBreakpoint(E.label,E.dataId,E.canPersist,E.enabled,E.hitCondition,E.condition,E.logMessage);else{const J=I.URI.revive(E.uri);U=new C.SourceBreakpoint(new C.Location(J,new C.Position(E.line,E.character)),E.enabled,E.condition,E.hitCondition,E.logMessage)}U._id=F,this._breakpoints.set(F,U),b.push(U)}}if(h.removed)for(const E of h.removed){const F=this._breakpoints.get(E);F&&(this._breakpoints.delete(E),_.push(F))}if(h.changed){for(const E of h.changed)if(E.id){const F=this._breakpoints.get(E.id);if(F){if(F instanceof C.FunctionBreakpoint&&E.type==="function"){const U=F;U.enabled=E.enabled,U.condition=E.condition,U.hitCondition=E.hitCondition,U.logMessage=E.logMessage,U.functionName=E.functionName}else if(F instanceof C.SourceBreakpoint&&E.type==="source"){const U=F;U.enabled=E.enabled,U.condition=E.condition,U.hitCondition=E.hitCondition,U.logMessage=E.logMessage,U.location=new C.Location(I.URI.revive(E.uri),new C.Position(E.line,E.character))}v.push(F)}}}this.fireBreakpointChanges(b,_,v)}$provideDebugConfigurations(h,b,_){return(0,T.asPromise)(async()=>{const v=this.getConfigProviderByHandle(h);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const E=await this.getFolder(b);return v.provideDebugConfigurations(E,_)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(h,b,_,v){return(0,T.asPromise)(async()=>{const E=this.getConfigProviderByHandle(h);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.getFolder(b);return E.resolveDebugConfiguration(F,_,v)})}$resolveDebugConfigurationWithSubstitutedVariables(h,b,_,v){return(0,T.asPromise)(async()=>{const E=this.getConfigProviderByHandle(h);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.getFolder(b);return E.resolveDebugConfigurationWithSubstitutedVariables(F,_,v)})}async $provideDebugAdapter(h,b){const _=this.getAdapterDescriptorFactoryByHandle(h);if(!_)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.getSession(b);return this.getAdapterDescriptor(_,v).then(E=>{if(!E)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.convertToDto(E)})}async $acceptDebugSessionStarted(h){const b=await this.getSession(h);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(h){const b=await this.getSession(h);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(h){this._activeDebugSession=h?await this.getSession(h):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(h,b){const _=await this.getSession(h);_&&_._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(h,b){const v={session:await this.getSession(h),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(v)}convertToDto(h){if(h instanceof C.DebugAdapterExecutable)return{type:"executable",command:h.command,args:h.args,options:h.options};if(h instanceof C.DebugAdapterServer)return{type:"server",port:h.port,host:h.host};if(h instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:h.path};if(h instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:h.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(h){const b=this._adapterFactories.filter(_=>_.type===h);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(h){const b=this._adapterFactories.filter(_=>_.handle===h);if(b.length>0)return b[0].factory}getConfigProviderByHandle(h){const b=this._configProviders.filter(_=>_.handle===h);if(b.length>0)return b[0].provider}definesDebugType(h,b){if(h.contributes){const _=h.contributes.debuggers;if(_&&_.length>0){for(const v of _)if(v.label&&v.type&&v.type===b)return!0}}return!1}getDebugAdapterTrackers(h){const _=h.configuration.type,v=this._trackerFactories.filter(E=>E.type===_||E.type==="*").map(E=>(0,T.asPromise)(()=>E.factory.createDebugAdapterTracker(h)).then(F=>F,F=>null));return Promise.race([Promise.all(v).then(E=>{const F=E.filter(U=>!!U);if(F.length>0)return new n(F)}),new Promise((E,F)=>{const U=setTimeout(()=>{clearTimeout(U),F(new Error("timeout"))},1e3)})]).catch(E=>{})}async getAdapterDescriptor(h,b){const _=b.configuration.debugServer;if(typeof _=="number")return Promise.resolve(new C.DebugAdapterServer(_));if(h){const E=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>h.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,E))).then(F=>{if(F)return F})}const v=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,v))}daExecutableFromPackage(h,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(h,b,_){(h.length>0||b.length>0||_.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:h,removed:b,changed:_}))}async getSession(h){if(h)if(typeof h=="string"){const b=this._debugSessions.get(h);if(b)return b}else{let b=this._debugSessions.get(h.id);if(!b){const _=await this.getFolder(h.folderUri);b=new u(this._debugServiceProxy,h.id,h.type,h.name,_,h.configuration),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(h){if(h){const b=I.URI.revive(h);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};f=Ve([qe(0,l.IExtHostRpcService),qe(1,k.IExtHostWorkspace),qe(2,i.IExtHostExtensionService),qe(3,P.IExtHostDocumentsAndEditors),qe(4,d.IExtHostConfiguration)],f),e.ExtHostDebugServiceBase=f;class u{constructor(h,b,_,v,E,F){this._debugServiceProxy=h,this._id=b,this._type=_,this._name=v,this._workspaceFolder=E,this._configuration=F}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(h){this._name=h,this._debugServiceProxy.$setDebugSessionName(this._id,h)}_acceptNameChanged(h){this._name=h}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(h,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,h,b)}getDebugProtocolBreakpoint(h){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,h.id)}}e.ExtHostDebugSession=u;class p{constructor(h){this.value=Object.freeze({append(b){h.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=p;class t extends c.AbstractVariableResolverService{constructor(h,b,_,v){super({getFolderUri:E=>{const F=h.filter(U=>U.name===E);if(F&&F.length>0)return F[0].uri},getWorkspaceFolderCount:()=>h.length,getConfigurationValue:(E,F)=>_.getConfiguration(void 0,E).get(F),getAppRoot:()=>D.cwd(),getExecPath:()=>D.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(b){const E=b.activeEditor();if(E)return w.normalize(E.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(b&&v){const E=b.activeEditor();if(E){const F=v.getWorkspaceFolder(E.document.uri);if(F)return w.normalize(F.uri.fsPath)}}},getSelectedText:()=>{if(b){const E=b.activeEditor();if(E&&!E.selection.isEmpty)return E.document.getText(E.selection)}},getLineNumber:()=>{if(b){const E=b.activeEditor();if(E)return String(E.selection.end.line+1)}}},void 0,D.env)}}e.ExtHostVariableResolverService=t;class n{constructor(h){this.trackers=h}onWillStartSession(){this.trackers.forEach(h=>h.onWillStartSession?h.onWillStartSession():void 0)}onWillReceiveMessage(h){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(h):void 0)}onDidSendMessage(h){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(h):void 0)}onWillStopSession(){this.trackers.forEach(h=>h.onWillStopSession?h.onWillStopSession():void 0)}onError(h){this.trackers.forEach(b=>b.onError?b.onError(h):void 0)}onExit(h,b){this.trackers.forEach(_=>_.onExit?_.onExit(h,b):void 0)}}class s extends S.AbstractDebugAdapter{constructor(h){super();this.implementation=h,h.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(h){this.implementation.handleMessage(h)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends f{constructor(h,b,_,v,E){super(h,b,_,v,E)}createVariableResolver(h,b,_){return new t(h,b,_)}};r=Ve([qe(0,l.IExtHostRpcService),qe(1,k.IExtHostWorkspace),qe(2,i.IExtHostExtensionService),qe(3,P.IExtHostDocumentsAndEditors),qe(4,d.IExtHostConfiguration)],r),e.WorkerExtHostDebugService=r}),define(be[222],_e([0,1,80,2,5,34,33,26,14,27,4,35,46,19]),function(Q,e,w,I,A,T,y,C,S,k,i,P,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let o=class{constructor(f,u,p,t,n,s,r){this._apiFactory=f,this._extensionRegistry=u,this._instaService=p,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=s,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),w.mark("code/extHost/willWaitForConfig");const f=await this._extHostConfiguration.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const u=await this._extHostExtensionService.getExtensionPathIndex();this.register(new l(this._apiFactory,u,this._extensionRegistry,f,this._logService)),this.register(this._instaService.createInstance(g)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(m,u,this._initData.environment.appUriScheme))}register(f){if(Array.isArray(f.nodeModuleName))for(let u of f.nodeModuleName)this._factories.set(u,f);else this._factories.set(f.nodeModuleName,f);typeof f.alternativeModuleName=="function"&&this._alternatives.push(u=>f.alternativeModuleName(u))}};o=Ve([qe(2,i.IInstantiationService),qe(3,T.IExtHostConfiguration),qe(4,P.IExtHostExtensionService),qe(5,k.IExtHostInitDataService),qe(6,d.ILogService)],o),e.RequireInterceptor=o;class l{constructor(f,u,p,t,n){this._apiFactory=f,this._extensionPaths=u,this._extensionRegistry=p,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(f,u){const p=this._extensionPaths.findSubstr(u.fsPath);if(p){let t=this._extApiImpl.get(C.ExtensionIdentifier.toKey(p.identifier));return t||(t=this._apiFactory(p,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(p.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,s)=>t+=`	${s} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${u.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let g=class{constructor(f,u){this.nodeModuleName="keytar";const{environment:p}=u,t=f.getProxy(A.MainContext.MainThreadKeytar);if(p.appRoot){let n=p.appRoot.fsPath;c.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,s)=>t.$getPassword(n,s),setPassword:(n,s,r)=>t.$setPassword(n,s,r),deletePassword:(n,s)=>t.$deletePassword(n,s),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(f,u){return this._impl}alternativeModuleName(f){const u=f.length;if(!(u<=7||!this.alternativeNames)){const p=u-7;if((f.charAt(p)==="/"||f.charAt(p)==="\\")&&f.endsWith("keytar")&&(f=f.replace(/\\/g,"/"),this.alternativeNames.has(f)))return"keytar"}}};g=Ve([qe(0,S.IExtHostRpcService),qe(1,k.IExtHostInitDataService)],g);let m=class{constructor(f,u,p){this._extensionPaths=f,this._appUriScheme=u,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=p.getProxy(A.MainContext.MainThreadTelemetry);const t=p.getProxy(A.MainContext.MainThreadWindow);this._impl=(n,s)=>{const r=I.URI.parse(n);return s?this.callOriginal(n,s):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,n,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,n,{}):this.callOriginal(n,s)}}load(f,u,p){const t=this._extensionPaths.findSubstr(u.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=p(f),this._impl}callOriginal(f,u){return this.sendNoForwardTelemetry(),this._original(f,u)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};m=Ve([qe(2,S.IExtHostRpcService)],m)}),define(be[223],_e([0,1,11,12,80,6,2,5,215,19,61,65,27,152,14,71,35,40]),function(Q,e,w,I,A,T,y,C,S,k,i,P,c,d,o,l,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class D{constructor(u,p,t,n){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const s=new S.RPCProtocol(u,null,n);p=D._transform(p,s);const r=new P.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());r.set(c.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},p)),r.set(o.IExtHostRpcService,new o.ExtHostRpcService(s)),r.set(l.IURITransformerService,new l.URITransformerService(n)),r.set(g.IHostUtils,t);const a=new d.InstantiationService(r,!0),h=a.invokeFunction(E=>E.get(m.IExtHostTerminalService));this._disposables.add(h),this._logService=a.invokeFunction(E=>E.get(k.ILogService)),A.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",p),this._extensionService=a.invokeFunction(E=>E.get(g.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const b=new WeakMap;this._extensionService.getExtensionPathIndex().then(E=>{Error.prepareStackTrace=(F,U)=>{let J="",me,q;for(const z of U)J+=`
	at ${z.toString()}`,q=z.getFileName(),!me&&q&&(me=E.findSubstr(q));return b.set(F,me),`${F.name||"Error"}: ${F.message||""}${J}`}});const _=s.getProxy(C.MainContext.MainThreadExtensionService),v=s.getProxy(C.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(E=>{const F=I.transformErrorForSerialization(E),U=b.get(E);U?_.$onExtensionRuntimeError(U.identifier,F):v.$onUnexpectedError(F)})}terminate(u){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${u}`),this._logService.flush(),this._disposables.dispose(),I.setUnexpectedErrorHandler(t=>{});const p=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,w.timeout)(4e3),p]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(u,p){u.extensions.forEach(n=>n.extensionLocation=y.URI.revive(p.transformIncomingURIs(n.extensionLocation))),u.environment.appRoot=y.URI.revive(p.transformIncomingURIs(u.environment.appRoot));const t=u.environment.extensionDevelopmentLocationURI;return t&&(u.environment.extensionDevelopmentLocationURI=t.map(n=>y.URI.revive(p.transformIncomingURIs(n)))),u.environment.extensionTestsLocationURI=y.URI.revive(p.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=y.URI.revive(p.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=y.URI.revive(p.transformIncomingURIs(u.environment.workspaceStorageHome)),u.logsLocation=y.URI.revive(p.transformIncomingURIs(u.logsLocation)),u.logFile=y.URI.revive(p.transformIncomingURIs(u.logFile)),u.workspace=p.transformIncomingURIs(u.workspace),u}}e.ExtensionHostMain=D}),define(be[224],_e([0,1,13,20,60,28,25,55,41]),function(Q,e,w,I,A,T,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(c,d,o){this.config=c,this.provider=d,this.sessionToken=o,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&T.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&T.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const d=this.config.folderQueries||[];return new Promise((o,l)=>{const g=m=>{this.resultCount++,c(m)};if(this.isCanceled)return o({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(m=>{const D=m.toString(),f=w.basename(D);this.globalExcludePattern&&this.globalExcludePattern(D,f)||this.matchFile(g,{base:m,basename:f})}),Promise.all(d.map(m=>this.searchInFolder(m,g))).then(m=>{o({limitHit:this.isLimitHit,stats:m[0]||void 0})},m=>{l(new Error((0,A.toErrorMessage)(m)))})})}async searchInFolder(c,d){const o=new I.CancellationTokenSource,l=this.getSearchOptionsForFolder(c),g=this.initDirectoryTree(),m=new S.QueryGlobTester(this.config,c),D=!m.hasSiblingExcludeClauses();let f;try{this.activeCancellationTokens.add(o),f=C.StopWatch.create();const u=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},l,o.token),p=f.elapsed(),t=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(u&&u.forEach(n=>{const s=w.posix.relative(c.folder.path,n.path);if(D){const r=w.basename(n.path);this.matchFile(d,{base:c.folder,relativePath:s,basename:r});return}this.addDirectoryEntries(g,c.folder,s,d)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(g,m,d),{providerTime:p,postProcessTime:t.elapsed()})}finally{o.dispose(),this.activeCancellationTokens.delete(o)}}getSearchOptionsForFolder(c){const d=(0,S.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),o=(0,S.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:o,includes:d,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},d,o,l){if(o===this.filePattern){const m=w.basename(this.filePattern);this.matchFile(l,{base:d,relativePath:this.filePattern,basename:m})}function g(m){const D=w.basename(m),f=w.dirname(m);let u=c[f];u||(u=c[f]=[],g(f)),u.push({base:d,relativePath:m,basename:D})}g(o)}matchDirectoryTree({rootEntries:c,pathToEntries:d},o,l){const g=this,m=this.filePattern;function D(f){const u=T.hasSiblingFn(()=>f.map(p=>p.basename));for(let p=0,t=f.length;p<t;p++){const n=f[p],{relativePath:s,basename:r}=n;if(!!o.includedInQuerySync(s,r,m!==r?u:void 0)){const a=d[s];if(a)D(a);else{if(s===m)continue;g.matchFile(l,n)}if(g.isLimitHit)break}}}D(c)}matchFile(c,d){(!this.includePattern||d.relativePath&&this.includePattern(d.relativePath,d.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(d))}}class i{constructor(){this.sessions=new Map}fileSearch(c,d,o,l){const g=this.getSessionTokenSource(c.cacheKey),m=new k(c,d,g&&g.token);let D=0;const f=u=>{D+=u.length,o(u.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(m,i.BATCH_SIZE,f,l).then(u=>({limitHit:u.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:D,detailStats:u.stats}}))}clearCache(c){const d=this.getSessionTokenSource(c);d&&d.cancel()}getSessionTokenSource(c){if(!!c)return this.sessions.has(c)||this.sessions.set(c,new I.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:y.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,d,o,l){l.onCancellationRequested(()=>{c.cancel()});const g=D=>{D&&(m.push(D),d>0&&m.length>=d&&(o(m),m=[]))};let m=[];return c.search(g).then(D=>(m.length&&o(m),D),D=>(m.length&&o(m),Promise.reject(D)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(be[225],_e([0,1,13,15,20,60,25,28,2,41,18,10]),function(Q,e,w,I,A,T,y,C,S,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class c{constructor(f,u,p){this.query=f,this.provider=u,this.fileUtils=p,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(f,u){const p=this.query.folderQueries||[],t=new A.CancellationTokenSource;return u.onCancellationRequested(()=>t.cancel()),new Promise((n,s)=>{this.collector=new o(f);let r=!1;const a=(h,b)=>{if(!r&&!this.isLimitHit){const _=this.resultSize(h);g(h)&&typeof this.query.maxResults=="number"&&this.resultCount+_>this.query.maxResults&&(this.isLimitHit=!0,r=!0,t.cancel(),h=this.trimResultToSize(h,this.query.maxResults-this.resultCount));const v=this.resultSize(h);this.resultCount+=v,(v>0||!g(h))&&this.collector.add(h,b)}};Promise.all(p.map((h,b)=>this.searchInFolder(h,_=>a(_,b),t.token))).then(h=>{t.dispose(),this.collector.flush();const b=h.some(_=>!!_&&!!_.limitHit);n({limitHit:this.isLimitHit||b,messages:(0,I.flatten)(h.map(_=>(_==null?void 0:_.message)?(0,P.isArray)(_.message)?_.message:[_.message]:[])),stats:{type:"textSearchProvider"}})},h=>{t.dispose();const b=(0,T.toErrorMessage)(h);s(new Error(b))})})}resultSize(f){return g(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}trimResultToSize(f,u){const p=Array.isArray(f.ranges)?f.ranges:[f.ranges],t=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:p.slice(0,u),preview:{matches:t.slice(0,u),text:f.preview.text},uri:f.uri}}async searchInFolder(f,u,p){const t=new k.QueryGlobTester(this.query,f),n=[],s={report:h=>{if(!!this.validateProviderResult(h)){const b=f.folder.scheme===i.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(h.uri))):void 0,_=y.relativePath(f.folder,h.uri);_&&n.push(t.includedInQuery(_,w.basename(_),b).then(v=>{v&&u(h)}))}}},r=this.getSearchOptionsForFolder(f),a=await this.provider.provideTextSearchResults(d(this.query.contentPattern),r,s,p);return await Promise.all(n),a}validateProviderResult(f){if(g(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(f){const u=(0,k.resolvePatternsForProvider)(this.query.includePattern,f.includePattern),p=(0,k.resolvePatternsForProvider)(this.query.excludePattern,f.excludePattern),t={folder:S.URI.from(f.folder),excludes:p,includes:u,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.fileUtils.toCanonicalName(f.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=c;function d(D){return{isCaseSensitive:D.isCaseSensitive||!1,isRegExp:D.isRegExp||!1,isWordMatch:D.isWordMatch||!1,isMultiline:D.isMultiline||!1,pattern:D.pattern}}class o{constructor(f){this._onResult=f,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new m(512,u=>this.sendItems(u))}add(f,u){this._currentFileMatch&&(this._currentFolderIdx!==u||!y.isEqual(this._currentUri,f.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=u,this._currentFileMatch={resource:f.uri,results:[]}),this._currentFileMatch.results.push(l(f))}pushToCollector(){const f=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,f)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(f){this._onResult(f)}}e.TextSearchResultsCollector=o;function l(D){return g(D)?{preview:{matches:(0,I.mapArrayOrNot)(D.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:D.preview.text},ranges:(0,I.mapArrayOrNot)(D.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:D.text,lineNumber:D.lineNumber}}function g(D){return!!D.preview}e.extensionResultIsMatch=g;class m{constructor(f,u){this.maxBatchSize=f,this.cb=u,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(f,u){!f||this.addItemToBatch(f,u)}addItems(f,u){!f||this.addItemsToBatch(f,u)}addItemToBatch(f,u){this.batch.push(f),this.batchSize+=u,this.onUpdate()}addItemsToBatch(f,u){this.batch=this.batch.concat(f),this.batchSize+=u,this.onUpdate()}onUpdate(){this.totalNumberCompleted<m.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},m.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=m,m.TIMEOUT=4e3,m.START_BATCH_AFTER_COUNT=50}),define(be[105],_e([0,1,6,5,4,224,14,71,19,2,225]),function(Q,e,w,I,A,T,y,C,S,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,A.createDecorator)("IExtHostSearch");let P=class{constructor(l,g,m){this.extHostRpc=l,this._uriTransformer=g,this._logService=m,this._proxy=this.extHostRpc.getProxy(I.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(l){return this._uriTransformer.transformOutgoingScheme(l)}registerTextSearchProvider(l,g){if(this._textSearchUsedSchemes.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this._textSearchUsedSchemes.add(l);const m=this._handlePool++;return this._textSearchProvider.set(m,g),this._proxy.$registerTextSearchProvider(m,this._transformScheme(l)),(0,w.toDisposable)(()=>{this._textSearchUsedSchemes.delete(l),this._textSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}registerFileSearchProvider(l,g){if(this._fileSearchUsedSchemes.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this._fileSearchUsedSchemes.add(l);const m=this._handlePool++;return this._fileSearchProvider.set(m,g),this._proxy.$registerFileSearchProvider(m,this._transformScheme(l)),(0,w.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(l),this._fileSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}$provideFileSearchResults(l,g,m,D){const f=c(m),u=this._fileSearchProvider.get(l);if(u)return this._fileSearchManager.fileSearch(f,u,p=>{this._proxy.$handleFileMatch(l,g,p.map(t=>t.resource))},D);throw new Error("unknown provider: "+l)}$clearCache(l){return this._fileSearchManager.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,g,m,D){const f=this._textSearchProvider.get(l);if(!f||!f.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const u=c(m);return this.createTextSearchManager(u,f).search(t=>this._proxy.$handleTextMatch(l,g,t),D)}createTextSearchManager(l,g){return new i.TextSearchManager(l,g,{readdir:m=>Promise.resolve([]),toCanonicalName:m=>m})}};P=Ve([qe(0,y.IExtHostRpcService),qe(1,C.IURITransformerService),qe(2,S.ILogService)],P),e.ExtHostSearch=P;function c(o){return Object.assign(Object.assign({},o),{folderQueries:o.folderQueries&&o.folderQueries.map(d),extraFileResources:o.extraFileResources&&o.extraFileResources.map(l=>k.URI.revive(l))})}e.reviveQuery=c;function d(o){return Object.assign(Object.assign({},o),{folder:k.URI.revive(o.folder)})}}),define(be[226],_e([0,1,130,20,12,3,47,2,123,85,117,59,64,5,191,190,76,192,34,193,194,195,177,196,39,35,197,178,199,200,201,100,181,204,205,206,78,40,207,182,9,7,210,50,101,30,33,51,167,198,93,99,103,104,105,19,71,14,27,202,165,70,75,188,208,164,79,77,213,211,212,189,49,219,209,74,161,94,203,67,102]),function(Q,e,w,I,A,T,y,C,S,k,i,P,c,d,o,l,g,m,D,f,u,p,t,n,s,r,a,h,b,_,v,E,F,U,J,me,q,z,ee,$,R,M,x,O,G,Y,ne,pe,Ie,Oe,Te,Ue,B,K,ie,le,fe,Se,Ne,ge,Ce,Ae,We,Ee,je,H,te,ve,Le,He,xe,Xe,W,re,ce,V,Z,ae,he,ye,ze){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function $e(Be){const Ge=Be.get(Ne.IExtHostInitDataService),nt=Be.get(W.IExtHostFileSystemInfo),dt=Be.get(ve.IExtHostConsumerFileSystem),it=Be.get(r.IExtHostExtensionService),Ye=Be.get(Y.IExtHostWorkspace),mt=Be.get(ae.IExtHostTelemetry),wt=Be.get(D.IExtHostConfiguration),we=Be.get(fe.IURITransformerService),de=Be.get(Se.IExtHostRpcService),oe=Be.get(q.IExtHostStorage),j=Be.get(te.IExtensionStoragePaths),Re=Be.get(le.ILogService),Pe=Be.get(Ae.IExtHostTunnelService),Qe=Be.get(We.IExtHostApiDeprecationService),Ze=Be.get(G.IExtHostWindow),ut=Be.get(V.IExtHostSecretState);de.set(d.ExtHostContext.ExtHostFileSystemInfo,nt),de.set(d.ExtHostContext.ExtHostLogService,Re),de.set(d.ExtHostContext.ExtHostWorkspace,Ye),de.set(d.ExtHostContext.ExtHostConfiguration,wt),de.set(d.ExtHostContext.ExtHostExtensionService,it),de.set(d.ExtHostContext.ExtHostStorage,oe),de.set(d.ExtHostContext.ExtHostTunnelService,Pe),de.set(d.ExtHostContext.ExtHostWindow,Ze),de.set(d.ExtHostContext.ExtHostSecretState,ut),de.set(d.ExtHostContext.ExtHostTelemetry,mt);const ht=de.set(d.ExtHostContext.ExtHostDecorations,Be.get(Ue.IExtHostDecorations)),Je=de.set(d.ExtHostContext.ExtHostDocumentsAndEditors,Be.get(s.IExtHostDocumentsAndEditors)),ot=de.set(d.ExtHostContext.ExtHostCommands,Be.get(g.IExtHostCommands)),ft=de.set(d.ExtHostContext.ExtHostTerminalService,Be.get(z.IExtHostTerminalService)),at=de.set(d.ExtHostContext.ExtHostDebugService,Be.get(K.IExtHostDebugService)),_t=de.set(d.ExtHostContext.ExtHostSearch,Be.get(ie.IExtHostSearch)),vt=de.set(d.ExtHostContext.ExtHostTask,Be.get(B.IExtHostTask)),Dt=de.set(d.ExtHostContext.ExtHostOutputService,Be.get(E.IExtHostOutputService)),It=de.set(d.ExtHostContext.ExtHostEditorTabs,new Z.ExtHostEditorTabs),Pt=de.set(d.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(de)),bt=de.set(d.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(de,Je)),Gt=de.set(d.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(de,Je,Re)),Qt=de.set(d.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Re,bt,de.getProxy(d.MainContext.MainThreadBulkEdits))),gt=de.set(d.ExtHostContext.ExtHostNotebook,new ge.ExtHostNotebookController(de,ot,Je,bt,Re,j)),Jt=de.set(d.ExtHostContext.ExtHostNotebookKernels,new he.ExtHostNotebookKernels(de,Ge,gt)),yt=de.set(d.ExtHostContext.ExtHostEditors,new ee.ExtHostEditors(de,Je)),zt=de.set(d.ExtHostContext.ExtHostTreeViews,new $.ExtHostTreeViews(de.getProxy(d.MainContext.MainThreadTreeViews),ot,Re)),Yt=de.set(d.ExtHostContext.ExtHostEditorInsets,new Ie.ExtHostEditorInsets(de.getProxy(d.MainContext.MainThreadEditorInsets),yt,Ge.environment)),Vt=de.set(d.ExtHostContext.ExtHostDiagnostics,new f.ExtHostDiagnostics(de,Re)),lt=de.set(d.ExtHostContext.ExtHostLanguageFeatures,new b.ExtHostLanguageFeatures(de,we,bt,ot,Vt,Re,Qe)),Xt=de.set(d.ExtHostContext.ExtHostFileSystem,new a.ExtHostFileSystem(de,lt)),At=de.set(d.ExtHostContext.ExtHostFileSystemEventService,new h.ExtHostFileSystemEventService(de,Re,Je)),Ut=de.set(d.ExtHostContext.ExtHostQuickOpen,(0,U.createExtHostQuickOpen)(de,Ye,ot)),dn=de.set(d.ExtHostContext.ExtHostSCM,new J.ExtHostSCM(de,ot,Re)),vn=de.set(d.ExtHostContext.ExtHostComments,new m.ExtHostComments(de,ot,bt)),hn=de.set(d.ExtHostContext.ExtHostProgress,new F.ExtHostProgress(de.getProxy(d.MainContext.MainThreadProgress))),Zt=de.set(d.ExtHostContext.ExtHosLabelService,new Oe.ExtHostLabelService(de)),jt=de.set(d.ExtHostContext.ExtHostTheming,new Ce.ExtHostTheming(de)),Mt=de.set(d.ExtHostContext.ExtHostAuthentication,new Ee.ExtHostAuthentication(de)),wn=de.set(d.ExtHostContext.ExtHostTimeline,new je.ExtHostTimeline(de,ot)),en=de.set(d.ExtHostContext.ExtHostWebviews,new O.ExtHostWebviews(de,Ge.environment,Ye,Re,Qe)),tn=de.set(d.ExtHostContext.ExtHostWebviewPanels,new xe.ExtHostWebviewPanels(de,en,Ye)),qt=de.set(d.ExtHostContext.ExtHostCustomEditors,new He.ExtHostCustomEditors(de,bt,j,en,tn)),bn=de.set(d.ExtHostContext.ExtHostWebviewViews,new Le.ExtHostWebviewViews(de,en)),Tt=de.set(d.ExtHostContext.ExtHostTesting,new re.ExtHostTesting(de,Je,Ye)),nn=de.set(d.ExtHostContext.ExtHostUriOpeners,new ce.ExtHostUriOpeners(de)),_n=(0,pe.values)(d.ExtHostContext);de.assertRegistered(_n);const Bt=new Xe.ExtHostBulkEdits(de,Je),rn=new l.ExtHostClipboard(de),Ot=new v.ExtHostMessageService(de,Re),Rt=new u.ExtHostDialogs(de),fn=new me.ExtHostStatusBar(de,ot.converter),xt=new _.ExtHostLanguages(de,bt);return o.ExtHostApiCommands.register(ot),function(Fe,sn,on){const pt=function(){let X=!Fe.isUnderDevelopment;function ue(ke){X||(Re.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function ke(rt){if(Array.isArray(rt))rt.forEach(ke);else if(typeof rt=="string")ue(rt);else{const N=rt;typeof N.scheme=="undefined"&&ue(rt),!Fe.enableProposedApi&&typeof N.exclusive=="boolean"&&(0,ne.throwProposedApiError)(Fe)}return rt}}(),En={getSession(X,ue,ke){return Mt.getSession(Fe,X,ue,ke)},get onDidChangeSessions(){return Mt.onDidChangeSessions},registerAuthenticationProvider(X,ue,ke,rt){return Mt.registerAuthenticationProvider(X,ue,ke,rt)},get onDidChangeAuthenticationProviders(){return(0,ne.checkProposedApiEnabled)(Fe),Mt.onDidChangeAuthenticationProviders},get providers(){return(0,ne.checkProposedApiEnabled)(Fe),Mt.providers},logout(X,ue){return(0,ne.checkProposedApiEnabled)(Fe),Mt.removeSession(X,ue)}},yn={registerCommand(X,ue,ke){return ot.registerCommand(!0,X,ue,ke)},registerTextEditorCommand(X,ue,ke){return ot.registerCommand(!0,X,(...rt)=>{const N=yt.getActiveTextEditor();if(!N){Re.warn("Cannot execute "+X+" because there is no active text editor.");return}return N.edit(L=>{ue.apply(ke,[N,L,...rt])}).then(L=>{L||Re.warn("Edits from command "+X+" were not applied.")},L=>{Re.warn("An error occurred while running command "+X,L)})})},registerDiffInformationCommand:(X,ue,ke)=>((0,ne.checkProposedApiEnabled)(Fe),ot.registerCommand(!0,X,async(...rt)=>{const N=Je.activeEditor(!0);if(!N){Re.warn("Cannot execute "+X+" because there is no active text editor.");return}const L=await yt.getDiffInformation(N.id);ue.apply(ke,[L,...rt])})),executeCommand(X,...ue){return ot.executeCommand(X,...ue)},getCommands(X=!1){return ot.getCommands(X)}},Kt={get machineId(){return Ge.telemetryInfo.machineId},get sessionId(){return Ge.telemetryInfo.sessionId},get language(){return Ge.environment.appLanguage},get appName(){return Ge.environment.appName},get appRoot(){var X,ue;return(ue=(X=Ge.environment.appRoot)===null||X===void 0?void 0:X.fsPath)!==null&&ue!==void 0?ue:""},get uriScheme(){return Ge.environment.appUriScheme},get clipboard(){return rn.value},get shell(){return ft.getDefaultShell(!1,on)},get isTelemetryEnabled(){return mt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return mt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(Ge.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,ue){return Ze.openUri(X,{allowTunneling:!!Ge.remote.authority,allowContributedOpeners:ue==null?void 0:ue.allowContributedOpeners})},asExternalUri(X){return X.scheme===Ge.environment.appUriScheme?Pt.createAppUri(X):Ze.asExternalUri(X,{allowTunneling:!!Ge.remote.authority})},get remoteName(){return(0,Te.getRemoteName)(Ge.remote.authority)},get uiKind(){return Ge.uiKind}};Ge.environment.extensionTestsLocationURI||Object.freeze(Kt);const mn=Ge.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,Sn={registerTestController(X){return(0,ne.checkProposedApiEnabled)(Fe),Tt.registerTestController(Fe.identifier.value,X)},createDocumentTestObserver(X){return(0,ne.checkProposedApiEnabled)(Fe),Tt.createTextDocumentTestObserver(X)},createWorkspaceTestObserver(X){return(0,ne.checkProposedApiEnabled)(Fe),Tt.createWorkspaceTestObserver(X)},runTests(X){return(0,ne.checkProposedApiEnabled)(Fe),Tt.runTests(X)},createTestItem(X,ue){return new M.TestItemImpl(X.id,X.label,X.uri,ue)},createTestRunTask(X,ue,ke){return(0,ne.checkProposedApiEnabled)(Fe),Tt.createTestRunTask(Fe.identifier.value,X,ue,ke)},get onDidChangeTestResults(){return(0,ne.checkProposedApiEnabled)(Fe),Tt.onResultsChanged},get testResults(){return(0,ne.checkProposedApiEnabled)(Fe),Tt.results}},Dn={getExtension(X){const ue=sn.getExtensionDescription(X);if(ue)return new r.Extension(it,Fe.identifier,ue,mn)},get all(){return sn.getAllExtensionDescriptions().map(X=>new r.Extension(it,Fe.identifier,X,mn))},get onDidChange(){return sn.onDidChange}},Cn={createDiagnosticCollection(X){return Vt.createDiagnosticCollection(Fe.identifier,X)},get onDidChangeDiagnostics(){return Vt.onDidChangeDiagnostics},getDiagnostics:X=>Vt.getDiagnostics(X),getLanguages(){return xt.getLanguages()},setTextDocumentLanguage(X,ue){return xt.changeLanguage(X.uri,ue)},match(X,ue){return(0,P.score)(R.LanguageSelector.from(X),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(X,ue,ke){return lt.registerCodeActionProvider(Fe,pt(X),ue,ke)},registerCodeLensProvider(X,ue){return lt.registerCodeLensProvider(Fe,pt(X),ue)},registerDefinitionProvider(X,ue){return lt.registerDefinitionProvider(Fe,pt(X),ue)},registerDeclarationProvider(X,ue){return lt.registerDeclarationProvider(Fe,pt(X),ue)},registerImplementationProvider(X,ue){return lt.registerImplementationProvider(Fe,pt(X),ue)},registerTypeDefinitionProvider(X,ue){return lt.registerTypeDefinitionProvider(Fe,pt(X),ue)},registerHoverProvider(X,ue){return lt.registerHoverProvider(Fe,pt(X),ue,Fe.identifier)},registerEvaluatableExpressionProvider(X,ue){return lt.registerEvaluatableExpressionProvider(Fe,pt(X),ue,Fe.identifier)},registerInlineValuesProvider(X,ue){return lt.registerInlineValuesProvider(Fe,pt(X),ue,Fe.identifier)},registerDocumentHighlightProvider(X,ue){return lt.registerDocumentHighlightProvider(Fe,pt(X),ue)},registerLinkedEditingRangeProvider(X,ue){return lt.registerLinkedEditingRangeProvider(Fe,pt(X),ue)},registerReferenceProvider(X,ue){return lt.registerReferenceProvider(Fe,pt(X),ue)},registerRenameProvider(X,ue){return lt.registerRenameProvider(Fe,pt(X),ue)},registerDocumentSymbolProvider(X,ue,ke){return lt.registerDocumentSymbolProvider(Fe,pt(X),ue,ke)},registerWorkspaceSymbolProvider(X){return lt.registerWorkspaceSymbolProvider(Fe,X)},registerDocumentFormattingEditProvider(X,ue){return lt.registerDocumentFormattingEditProvider(Fe,pt(X),ue)},registerDocumentRangeFormattingEditProvider(X,ue){return lt.registerDocumentRangeFormattingEditProvider(Fe,pt(X),ue)},registerOnTypeFormattingEditProvider(X,ue,ke,...rt){return lt.registerOnTypeFormattingEditProvider(Fe,pt(X),ue,[ke].concat(rt))},registerDocumentSemanticTokensProvider(X,ue,ke){return lt.registerDocumentSemanticTokensProvider(Fe,pt(X),ue,ke)},registerDocumentRangeSemanticTokensProvider(X,ue,ke){return lt.registerDocumentRangeSemanticTokensProvider(Fe,pt(X),ue,ke)},registerSignatureHelpProvider(X,ue,ke,...rt){return typeof ke=="object"?lt.registerSignatureHelpProvider(Fe,pt(X),ue,ke):lt.registerSignatureHelpProvider(Fe,pt(X),ue,typeof ke=="undefined"?[]:[ke,...rt])},registerCompletionItemProvider(X,ue,...ke){return lt.registerCompletionItemProvider(Fe,pt(X),ue,ke)},registerDocumentLinkProvider(X,ue){return lt.registerDocumentLinkProvider(Fe,pt(X),ue)},registerColorProvider(X,ue){return lt.registerColorProvider(Fe,pt(X),ue)},registerFoldingRangeProvider(X,ue){return lt.registerFoldingRangeProvider(Fe,pt(X),ue)},registerSelectionRangeProvider(X,ue){return lt.registerSelectionRangeProvider(Fe,X,ue)},registerCallHierarchyProvider(X,ue){return lt.registerCallHierarchyProvider(Fe,X,ue)},setLanguageConfiguration:(X,ue)=>lt.setLanguageConfiguration(Fe,X,ue),getTokenInformationAtPosition(X,ue){return(0,ne.checkProposedApiEnabled)(Fe),xt.tokenAtPosition(X,ue)},registerInlineHintsProvider(X,ue){return(0,ne.checkProposedApiEnabled)(Fe),lt.registerInlineHintsProvider(Fe,X,ue)}},kn={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(X,ue,ke){const rt=await(C.URI.isUri(X)?Promise.resolve(an.openTextDocument(X)):Promise.resolve(X));return yt.showTextDocument(rt,ue,ke)},createTextEditorDecorationType(X){return yt.createTextEditorDecorationType(X)},onDidChangeActiveTextEditor(X,ue,ke){return yt.onDidChangeActiveTextEditor(X,ue,ke)},onDidChangeVisibleTextEditors(X,ue,ke){return yt.onDidChangeVisibleTextEditors(X,ue,ke)},onDidChangeTextEditorSelection(X,ue,ke){return yt.onDidChangeTextEditorSelection(X,ue,ke)},onDidChangeTextEditorOptions(X,ue,ke){return yt.onDidChangeTextEditorOptions(X,ue,ke)},onDidChangeTextEditorVisibleRanges(X,ue,ke){return yt.onDidChangeTextEditorVisibleRanges(X,ue,ke)},onDidChangeTextEditorViewColumn(X,ue,ke){return yt.onDidChangeTextEditorViewColumn(X,ue,ke)},onDidCloseTerminal(X,ue,ke){return ft.onDidCloseTerminal(X,ue,ke)},onDidOpenTerminal(X,ue,ke){return ft.onDidOpenTerminal(X,ue,ke)},onDidChangeActiveTerminal(X,ue,ke){return ft.onDidChangeActiveTerminal(X,ue,ke)},onDidChangeTerminalDimensions(X,ue,ke){return(0,ne.checkProposedApiEnabled)(Fe),ft.onDidChangeTerminalDimensions(X,ue,ke)},onDidWriteTerminalData(X,ue,ke){return(0,ne.checkProposedApiEnabled)(Fe),ft.onDidWriteTerminalData(X,ue,ke)},get state(){return Ze.state},onDidChangeWindowState(X,ue,ke){return Ze.onDidChangeWindowState(X,ue,ke)},showInformationMessage(X,...ue){return Ot.showMessage(Fe,y.default.Info,X,ue[0],ue.slice(1))},showWarningMessage(X,...ue){return Ot.showMessage(Fe,y.default.Warning,X,ue[0],ue.slice(1))},showErrorMessage(X,...ue){return Ot.showMessage(Fe,y.default.Error,X,ue[0],ue.slice(1))},showQuickPick(X,ue,ke){return Ut.showQuickPick(X,!!Fe.enableProposedApi,ue,ke)},showWorkspaceFolderPick(X){return Ut.showWorkspaceFolderPick(X)},showInputBox(X,ue){return Ut.showInput(X,ue)},showOpenDialog(X){return Rt.showOpenDialog(X)},showSaveDialog(X){return Rt.showSaveDialog(X)},createStatusBarItem(X,ue){let ke,rt,N,L;return X&&typeof X!="number"?(ke=X.id,rt=X.name,N=X.alignment,ue=X.priority,L=X.accessibilityInformation):(ke=Fe.identifier.value,rt=w.localize(0,null,Fe.displayName||Fe.name),N=X),fn.createStatusBarEntry(ke,rt,N,ue,L)},setStatusBarMessage(X,ue){return fn.setStatusBarMessage(X,ue)},withScmProgress(X){return Qe.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),hn.withProgress(Fe,{location:M.ProgressLocation.SourceControl},(ue,ke)=>X({report(rt){}}))},withProgress(X,ue){return hn.withProgress(Fe,X,ue)},createOutputChannel(X){return Dt.createOutputChannel(X)},createWebviewPanel(X,ue,ke,rt){return tn.createWebviewPanel(Fe,X,ue,ke,rt)},createWebviewTextEditorInset(X,ue,ke,rt){return(0,ne.checkProposedApiEnabled)(Fe),Yt.createWebviewEditorInset(X,ue,ke,rt,Fe)},createTerminal(X,ue,ke){return typeof X=="object"?"pty"in X?ft.createExtensionTerminal(X):(X.message&&(0,ne.checkProposedApiEnabled)(Fe),X.icon&&(0,ne.checkProposedApiEnabled)(Fe),ft.createTerminalFromOptions(X)):ft.createTerminal(X,ue,ke)},registerTerminalLinkProvider(X){return ft.registerLinkProvider(X)},registerTreeDataProvider(X,ue){return zt.registerTreeDataProvider(X,ue,Fe)},createTreeView(X,ue){return zt.createTreeView(X,ue,Fe)},registerWebviewPanelSerializer:(X,ue)=>tn.registerWebviewPanelSerializer(Fe,X,ue),registerCustomEditorProvider:(X,ue,ke={})=>qt.registerCustomEditorProvider(Fe,X,ue,ke),registerFileDecorationProvider(X){return ht.registerFileDecorationProvider(X,Fe.identifier)},registerUriHandler(X){return Pt.registerUriHandler(Fe.identifier,X)},createQuickPick(){return Ut.createQuickPick(Fe.identifier,!!Fe.enableProposedApi)},createInputBox(){return Ut.createInputBox(Fe.identifier)},get activeColorTheme(){return jt.activeColorTheme},onDidChangeActiveColorTheme(X,ue,ke){return jt.onDidChangeActiveColorTheme(X,ue,ke)},registerWebviewViewProvider(X,ue,ke){return bn.registerWebviewViewProvider(Fe,X,ue,ke==null?void 0:ke.webviewOptions)},get activeNotebookEditor(){return(0,ne.checkProposedApiEnabled)(Fe),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,ue,ke){return(0,ne.checkProposedApiEnabled)(Fe),gt.onDidChangeActiveNotebookEditor(X,ue,ke)},get visibleNotebookEditors(){return(0,ne.checkProposedApiEnabled)(Fe),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ne.checkProposedApiEnabled)(Fe),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,ue,ke){return(0,ne.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookEditorSelection(X,ue,ke)},onDidChangeNotebookEditorVisibleRanges(X,ue,ke){return(0,ne.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookEditorVisibleRanges(X,ue,ke)},showNotebookDocument(X,ue){return(0,ne.checkProposedApiEnabled)(Fe),gt.showNotebookDocument(X,ue)},registerExternalUriOpener(X,ue,ke){return(0,ne.checkProposedApiEnabled)(Fe),nn.registerExternalUriOpener(Fe.identifier,X,ue,ke)},get openEditors(){return(0,ne.checkProposedApiEnabled)(Fe),It.tabs},get onDidChangeOpenEditors(){return(0,ne.checkProposedApiEnabled)(Fe),It.onDidChangeTabs}},an={get rootPath(){return Qe.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ye.getPath()},set rootPath(X){throw A.readonly()},getWorkspaceFolder(X){return Ye.getWorkspaceFolder(X)},get workspaceFolders(){return Ye.getWorkspaceFolders()},get name(){return Ye.name},set name(X){throw A.readonly()},get workspaceFile(){return Ye.workspaceFile},set workspaceFile(X){throw A.readonly()},updateWorkspaceFolders:(X,ue,...ke)=>Ye.updateWorkspaceFolders(Fe,X,ue||0,...ke),onDidChangeWorkspaceFolders:function(X,ue,ke){return Ye.onDidChangeWorkspace(X,ue,ke)},asRelativePath:(X,ue)=>Ye.getRelativePath(X,ue),findFiles:(X,ue,ke,rt)=>Ye.findFiles(R.GlobPattern.from(X),R.GlobPattern.from(ue),ke,Fe.identifier,rt),findTextInFiles:(X,ue,ke,rt)=>{let N,L;return typeof ue=="object"?(N=ue,L=ke):(N={},L=ue,rt=ke),Ye.findTextInFiles(X,N||{},L,Fe.identifier,rt)},saveAll:X=>Ye.saveAll(X),applyEdit(X){return Bt.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,ue,ke,rt)=>At.createFileSystemWatcher(R.GlobPattern.from(X),ue,ke,rt),get textDocuments(){return bt.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw A.readonly()},openTextDocument(X){let ue;const ke=X;if(typeof X=="string")ue=Promise.resolve(C.URI.file(X));else if(C.URI.isUri(X))ue=Promise.resolve(X);else if(!ke||typeof ke=="object")ue=bt.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(rt=>bt.ensureDocumentData(rt).then(N=>N.document))},onDidOpenTextDocument:(X,ue,ke)=>bt.onDidAddDocument(X,ue,ke),onDidCloseTextDocument:(X,ue,ke)=>bt.onDidRemoveDocument(X,ue,ke),onDidChangeTextDocument:(X,ue,ke)=>bt.onDidChangeDocument(X,ue,ke),onDidSaveTextDocument:(X,ue,ke)=>bt.onDidSaveDocument(X,ue,ke),onWillSaveTextDocument:(X,ue,ke)=>Qt.getOnWillSaveTextDocumentEvent(Fe)(X,ue,ke),onDidChangeConfiguration:(X,ue,ke)=>on.onDidChangeConfiguration(X,ue,ke),getConfiguration(X,ue){return ue=arguments.length===1?void 0:ue,on.getConfiguration(X,ue,Fe)},registerTextDocumentContentProvider(X,ue){return Gt.registerTextDocumentContentProvider(X,ue)},registerTaskProvider:(X,ue)=>(Qe.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Fe,X,ue)),registerFileSystemProvider(X,ue,ke){return Xt.registerFileSystemProvider(Fe.identifier,X,ue,ke)},get fs(){return dt.value},registerFileSearchProvider:(X,ue)=>((0,ne.checkProposedApiEnabled)(Fe),_t.registerFileSearchProvider(X,ue)),registerTextSearchProvider:(X,ue)=>((0,ne.checkProposedApiEnabled)(Fe),_t.registerTextSearchProvider(X,ue)),registerRemoteAuthorityResolver:(X,ue)=>((0,ne.checkProposedApiEnabled)(Fe),it.registerRemoteAuthorityResolver(X,ue)),registerResourceLabelFormatter:X=>((0,ne.checkProposedApiEnabled)(Fe),Zt.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,ue,ke)=>At.onDidCreateFile(X,ue,ke),onDidDeleteFiles:(X,ue,ke)=>At.onDidDeleteFile(X,ue,ke),onDidRenameFiles:(X,ue,ke)=>At.onDidRenameFile(X,ue,ke),onWillCreateFiles:(X,ue,ke)=>At.getOnWillCreateFileEvent(Fe)(X,ue,ke),onWillDeleteFiles:(X,ue,ke)=>At.getOnWillDeleteFileEvent(Fe)(X,ue,ke),onWillRenameFiles:(X,ue,ke)=>At.getOnWillRenameFileEvent(Fe)(X,ue,ke),openTunnel:X=>((0,ne.checkProposedApiEnabled)(Fe),Pe.openTunnel(Fe,X).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,ne.checkProposedApiEnabled)(Fe),Pe.getTunnels()},onDidChangeTunnels:(X,ue,ke)=>((0,ne.checkProposedApiEnabled)(Fe),Pe.onDidChangeTunnels(X,ue,ke)),registerPortAttributesProvider:(X,ue)=>((0,ne.checkProposedApiEnabled)(Fe),Pe.registerPortsAttributesProvider(X,ue)),registerTimelineProvider:(X,ue)=>((0,ne.checkProposedApiEnabled)(Fe),wn.registerTimelineProvider(X,ue,Fe.identifier,ot.converter)),get isTrusted(){return Ye.trusted},requestWorkspaceTrust:X=>((0,ne.checkProposedApiEnabled)(Fe),Ye.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,ue,ke)=>Ye.onDidGrantWorkspaceTrust(X,ue,ke)},gn={get inputBox(){return Qe.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),dn.getLastInputBox(Fe)},createSourceControl(X,ue,ke){return dn.createSourceControl(Fe,X,ue,ke)}},Nt={createCommentController(X,ue){return vn.createCommentController(Fe,X,ue)}},$t={get activeDebugSession(){return at.activeDebugSession},get activeDebugConsole(){return at.activeDebugConsole},get breakpoints(){return at.breakpoints},onDidStartDebugSession(X,ue,ke){return at.onDidStartDebugSession(X,ue,ke)},onDidTerminateDebugSession(X,ue,ke){return at.onDidTerminateDebugSession(X,ue,ke)},onDidChangeActiveDebugSession(X,ue,ke){return at.onDidChangeActiveDebugSession(X,ue,ke)},onDidReceiveDebugSessionCustomEvent(X,ue,ke){return at.onDidReceiveDebugSessionCustomEvent(X,ue,ke)},onDidChangeBreakpoints(X,ue,ke){return at.onDidChangeBreakpoints(X,ue,ke)},registerDebugConfigurationProvider(X,ue,ke){return at.registerDebugConfigurationProvider(X,ue,ke||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,ue){return at.registerDebugAdapterDescriptorFactory(Fe,X,ue)},registerDebugAdapterTrackerFactory(X,ue){return at.registerDebugAdapterTrackerFactory(X,ue)},startDebugging(X,ue,ke){return!ke||typeof ke=="object"&&"configuration"in ke?at.startDebugging(X,ue,{parentSession:ke}):at.startDebugging(X,ue,ke||{})},stopDebugging(X){return at.stopDebugging(X)},addBreakpoints(X){return at.addBreakpoints(X)},removeBreakpoints(X){return at.removeBreakpoints(X)},asDebugSourceUri(X,ue){return at.asDebugSourceUri(X,ue)}},In={registerTaskProvider:(X,ue)=>vt.registerTaskProvider(Fe,X,ue),fetchTasks:X=>vt.fetchTasks(X),executeTask:X=>vt.executeTask(Fe,X),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(X,ue,ke)=>vt.onDidStartTask(X,ue,ke),onDidEndTask:(X,ue,ke)=>vt.onDidEndTask(X,ue,ke),onDidStartTaskProcess:(X,ue,ke)=>vt.onDidStartTaskProcess(X,ue,ke),onDidEndTaskProcess:(X,ue,ke)=>vt.onDidEndTaskProcess(X,ue,ke)},ln={openNotebookDocument:X=>((0,ne.checkProposedApiEnabled)(Fe),gt.openNotebookDocument(X)),get onDidOpenNotebookDocument(){return(0,ne.checkProposedApiEnabled)(Fe),gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,ne.checkProposedApiEnabled)(Fe),gt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,ne.checkProposedApiEnabled)(Fe),gt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,ne.checkProposedApiEnabled)(Fe),gt.notebookDocuments.map(X=>X.apiNotebook)},registerNotebookSerializer(X,ue,ke){return(0,ne.checkProposedApiEnabled)(Fe),gt.registerNotebookSerializer(Fe,X,ue,ke)},registerNotebookContentProvider:(X,ue,ke)=>((0,ne.checkProposedApiEnabled)(Fe),gt.registerNotebookContentProvider(Fe,X,ue,ke)),registerNotebookCellStatusBarItemProvider:(X,ue)=>((0,ne.checkProposedApiEnabled)(Fe),gt.registerNotebookCellStatusBarItemProvider(Fe,X,ue)),createNotebookEditorDecorationType(X){return(0,ne.checkProposedApiEnabled)(Fe),gt.createNotebookEditorDecorationType(X)},onDidChangeNotebookDocumentMetadata(X,ue,ke){return(0,ne.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookDocumentMetadata(X,ue,ke)},onDidChangeNotebookCells(X,ue,ke){return(0,ne.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookCells(X,ue,ke)},onDidChangeCellExecutionState(X,ue,ke){return(0,ne.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookCellExecutionState(X,ue,ke)},onDidChangeCellOutputs(X,ue,ke){return(0,ne.checkProposedApiEnabled)(Fe),gt.onDidChangeCellOutputs(X,ue,ke)},onDidChangeCellMetadata(X,ue,ke){return(0,ne.checkProposedApiEnabled)(Fe),gt.onDidChangeCellMetadata(X,ue,ke)},createConcatTextDocument(X,ue){return(0,ne.checkProposedApiEnabled)(Fe),new H.ExtHostNotebookConcatDocument(gt,bt,X,ue)},createNotebookCellExecutionTask(X,ue,ke){return(0,ne.checkProposedApiEnabled)(Fe),gt.createNotebookCellExecution(X,ue,ke)},createNotebookController(X,ue,ke,rt,N){return(0,ne.checkProposedApiEnabled)(Fe),Jt.createNotebookController(Fe,X,ue,ke,rt,N)}};return{version:Ge.version,authentication:En,commands:yn,comments:Nt,debug:$t,env:Kt,extensions:Dn,languages:Cn,notebook:ln,scm:gn,tasks:In,test:Sn,window:kn,workspace:an,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:I.CancellationTokenSource,CandidatePortSource:d.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,EventEmitter:T.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:c.FileType,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,Hover:M.Hover,IndentAction:i.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:k.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:S.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,UIKind:d.UIKind,Uri:C.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlineHint:M.InlineHint,InlineHintKind:M.InlineHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,RemoteTrustOption:ye.RemoteTrustOption,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookRange:M.NotebookRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookDocumentMetadata:M.NotebookDocumentMetadata,NotebookCellMetadata:M.NotebookCellMetadata,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,NotebookCellStatusBarItem:M.NotebookCellStatusBarItem,LinkedEditingRanges:M.LinkedEditingRanges,TestItemStatus:M.TestItemStatus,TestResultState:M.TestResultState,TestMessage:M.TestMessage,TextSearchCompleteMessageType:ze.TextSearchCompleteMessageType,TestMessageSeverity:M.TestMessageSeverity,WorkspaceTrustState:M.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=$e}),define(be[227],_e([0,1,61,100,30,99,34,76,39,40,103,104,105,79,78,70,75,101,77,49,74,94]),function(Q,e,w,I,A,T,y,C,S,k,i,P,c,d,o,l,g,m,D,f,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.registerSingleton)(d.IExtensionStoragePaths,d.ExtensionStoragePaths),(0,w.registerSingleton)(g.IExtHostApiDeprecationService,g.ExtHostApiDeprecationService),(0,w.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,w.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,w.registerSingleton)(D.IExtHostConsumerFileSystem,D.ExtHostConsumerFileSystem),(0,w.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService),(0,w.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,w.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,w.registerSingleton)(f.IExtHostFileSystemInfo,f.ExtHostFileSystemInfo),(0,w.registerSingleton)(I.IExtHostOutputService,I.ExtHostOutputService),(0,w.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch),(0,w.registerSingleton)(o.IExtHostStorage,o.ExtHostStorage),(0,w.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,w.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,w.registerSingleton)(l.IExtHostTunnelService,l.ExtHostTunnelService),(0,w.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow),(0,w.registerSingleton)(A.IExtHostWorkspace,A.ExtHostWorkspace),(0,w.registerSingleton)(u.IExtHostSecretState,u.ExtHostSecretState),(0,w.registerSingleton)(p.IExtHostTelemetry,p.ExtHostTelemetry)}),define(be[228],_e([0,1,226,35,222,7,11,5]),function(Q,e,w,I,A,T,y,C){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var k;(function(o){var l;const g=(l=self.trustedTypes)===null||l===void 0?void 0:l.createPolicy("TrustedFunctionWorkaround",{createScript:(D,...f)=>{f.forEach(n=>{var s;if(!((s=self.trustedTypes)===null||s===void 0?void 0:s.isScript(n)))throw new Error("TrustedScripts only, please")});const u=f.slice(0,-1).join(","),p=f.pop().toString();return`(function anonymous(${u}) {
${p}
})`}});function m(...D){return g?self.eval(g.createScript("",...D)):new Function(...D)}o.create=m})(k||(k={}));class i extends A.RequireInterceptor{_installInterceptor(){}getModule(l,g){for(let m of this._alternatives){let D=m(l);if(D){l=D;break}}if(this._factories.has(l))return this._factories.get(l).load(l,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends I.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const l=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);d(l,this._initData.environment.isExtensionDevelopmentDebug);const g=this._instaService.invokeFunction(w.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(i,g,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(l){return l.browser}async _loadCommonJSModule(l,g,m){var D,f,u,p,t,n,s,r;g=g.with({path:c(g.path,".js")}),l&&performance.mark(`code/extHost/willFetchExtensionCode/${l.value}`);const a=await fetch(g.toString(!0));if(l&&performance.mark(`code/extHost/didFetchExtensionCode/${l.value}`),a.status!==200)throw new Error(a.statusText);const h=await a.text(),b=`${g.toString(!0)}#vscode-extension`,_=`${h}
//# sourceURL=${b}`;let v;try{v=k.create((f=(D=P._ttpExtensionScripts)===null||D===void 0?void 0:D.createScript("module"))!==null&&f!==void 0?f:"module",(p=(u=P._ttpExtensionScripts)===null||u===void 0?void 0:u.createScript("exports"))!==null&&p!==void 0?p:"exports",(n=(t=P._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&n!==void 0?n:"require",(r=(s=P._ttpExtensionScripts)===null||s===void 0?void 0:s.createScript(_))!==null&&r!==void 0?r:_)}catch(J){throw l?console.error(`Loading code for extension ${l.value} failed: ${J.message}`):console.error(`Loading code failed: ${J.message}`),console.error(`${g.toString(!0)}${typeof J.line=="number"?` line ${J.line}`:""}${typeof J.column=="number"?` column ${J.column}`:""}`),console.error(J),J}const E={},F={exports:E},U=J=>{const me=this._fakeModules.getModule(J,g);if(me===void 0)throw new Error(`Cannot load module '${J}'`);return me};try{return m.codeLoadingStart(),l&&performance.mark(`code/extHost/willLoadExtensionCode/${l.value}`),v(F,E,U),F.exports!==E?F.exports:E}finally{l&&performance.mark(`code/extHost/didLoadExtensionCode/${l.value}`),m.codeLoadingStop()}}async $setRemoteEnvironment(l){throw new Error("Not supported")}async _waitForDebuggerAttachment(l=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const g=Date.now()+l;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,y.timeout)(10)}}}e.ExtHostExtensionService=P,P._ttpExtensionScripts=(S=self.trustedTypes)===null||S===void 0?void 0:S.createPolicy("ExtensionScripts",{createScript:o=>o});function c(o,l){return o.endsWith(l)?o:o+l}function d(o,l){g("info","log"),g("log","log"),g("warn","warn"),g("error","error");function g(f,u){const p=console[f];console[f]=function(){o.$logExtensionHostMessage({type:"__$console",severity:u,arguments:D(arguments)}),l&&p.apply(console,arguments)}}const m=1e5;function D(f){const u=[],p=[];if(f.length)for(let t=0;t<f.length;t++){if(typeof f[t]=="undefined")f[t]="undefined";else if(f[t]instanceof Error){const n=f[t];n.stack?f[t]=n.stack:f[t]=n.toString()}p.push(f[t])}try{const t=JSON.stringify(p,function(n,s){if(s&&typeof s=="object"){if(u.indexOf(s)!==-1)return"[Circular]";u.push(s)}return s});return t.length>m?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(be[229],_e([0,1,61,19,35,228,214]),function(Q,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.registerSingleton)(A.IExtHostExtensionService,T.ExtHostExtensionService),(0,w.registerSingleton)(I.ILogService,y.ExtHostLogService)}),define(be[231],_e([0,1,23,3,185,223,216,13,80,227,229]),function(Q,e,w,I,A,T,y,C,S){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0});const i=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const P=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const g=(k=self.trustedTypes)===null||k===void 0?void 0:k.createPolicy("extensionHostWorker",{createScriptURL:D=>D}),m=self.Worker;Worker=function(D,f){const u=`importScripts('${D}');`;f=f||{},f.name=f.name||C.basename(D.toString());const p=new Blob([u],{type:"application/javascript"}),t=URL.createObjectURL(p);return new m(g?g.createScriptURL(t):t,f)}}else self.Worker=class extends y.NestedWorker{constructor(g,m){super(P,g,Object.assign({name:C.basename(g.toString())},m))}};const c=new class{exit(g){i()}async exists(g){return!0}async realpath(g){return g}};class d{constructor(){const m=new MessageChannel,D=new I.Emitter;let f=!1;P(m.port2,[m.port2]),m.port1.onmessage=u=>{const{data:p}=u;if(!(p instanceof ArrayBuffer)){console.warn("UNKNOWN data received",p);return}const t=w.VSBuffer.wrap(new Uint8Array(p,0,p.byteLength));if((0,A.isMessageOfType)(t,2)){f=!0,l("received terminate message from renderer");return}D.fire(t)},this.protocol={onMessage:D.event,send:u=>{if(!f){const p=u.buffer.buffer.slice(u.buffer.byteOffset,u.buffer.byteOffset+u.buffer.byteLength);m.port1.postMessage(p,[p])}}}}}function o(g){return new Promise(m=>{const D=g.onMessage(f=>{D.dispose();const u=JSON.parse(f.toString());g.send((0,A.createMessageOfType)(0)),m({protocol:g,initData:u})});g.send((0,A.createMessageOfType)(1))})}let l=g=>i();(function(){const m=new d;S.mark("code/extHost/willConnectToRenderer"),o(m.protocol).then(D=>{S.mark("code/extHost/didWaitForInitData");const f=new T.ExtensionHostMain(D.protocol,D.initData,c,null);l=u=>f.terminate(u)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7ce1499d9541ba2acf66cd30a9054bd7818a8f80/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
